!-----------------------------------------------------------------------
!               CIF general routines
!-----------------------------------------------------------------------
      subroutine LeggiCIFinMem(ifSPG, ifRefl, nats, celltemp, iprint,
     *                         b_or_u, nSymmCard, wave, ier)
      USE General
      USE Symmetry
      USE CIF
!
!-----legge le informazioni strutturali dal file *.cmf prodotto dal CSDS 
!-----(Cambridge Structural Database System) by Roxi
!-----legge le informazioni strutturali dal file *.cif 
!
      implicit none
      integer :: kshif(3), b_or_u, nchar, lenp, lend, n, kkkk
      integer :: leggi, nats, ifLoop, ishif, nLoop, ifSPG, ier
      integer :: jop, jopen, itype, iform, nSymmCard, Lung, i, ifRefl
      integer :: iprint, j, k, L, found, nnsym, ifIscra
      real    :: celltemp(13), cif_val , wave, a, ValoreCIF
      character line*160, dire*160, Label*16
      character cif_comment, cif_, lineo*160, lineSav*160
      logical :: insym
!
      ifIscra = 0
      ifRefl = 0
      iprint = 0     ! iprint = 1  for test only
*     iprint = 1     ! iprint = 1  for test only
!
      do i=1, allowed_cifkey
         l_cifkey(i) = Lung(cifkey(i))
      enddo
!
      insym = .FALSE.
      nSymmCard = 0
      ReflFileName = 'tmp_cif_refl_file.hkl'
      ReflFileForm = '(3i4,2f12.4,f7.2)'
      itype = 0
      iform = 1
      jop = jopen(jfile, ReflFileName, itype, iform, ier)
      if (ier < 0) return
!
      ifSPG = InfoOK(2)
      cif_comment = '#'
      cif_ = '_'
      nLoop  = 0
      ifLoop = 0
      ifCartesian = 0
      n_aniso = 0
      b_or_u = 2
      kshif(:) = 0
      ishif   = 0
      celltemp(:) = 0.0
      celltemp(1:6) = cell(1:6)
      ifRhombAx = 0
      cif_serial(:) = 0
      cif_number(:) = 0
      wave = 0.71073
*     Species(:) = ' '
*     nk = 0
      nats = 0
!
      itype = 1
      iform = 2
      jop = jopen(jgrap, '  ', itype, iform, ier)
      if (jop < 0) then
          ier = -1
          return
      endif
!
      leggi = 1
      ier = 0
      do while (ier == 0)
         if (leggi == 1) then
             read(jhost,'(a)',end=200) line
             if (iprint > 0) write(0,*) line
             if (line(1:7) == '#===END') then
                 kkkk = 1
             endif
             call StandardCifKey(line, nchar)
             lineSav = line
         else
             line = lineSav
             leggi = 1
             nchar = 1
         endif
         call lcase(line)
         if (nchar <= 0) cycle
         if (line(1:1) == cif_comment) cycle
         if (line(1:4) == 'data') cycle
         if (line(1:1) == ';') cycle
         if (line(1:5) == 'loop_') then
             ifLoop = 1
             nLoop  = 0
             LoopType  = 0
             insym = .FALSE.
         else
             call cutst(line,lenp,dire,lend)
             if (ifLoop == 0) then
                 if (dire(1:1) == cif_) then
                     insym = .FALSE.
                 endif
!
!-- symmetry
!
                 if (insym) then
                     if (ifSPG == 0) then
                         nSymmCard = nSymmCard + 1
                         if (nSymmCard == 1) then
                             allocate(SymmCard(1:192), stat = ier)
                         endif
                         call shift(lineSav, L)
                         k = index(lineSav," ")
                         a = ValoreCIF(lineSav(1:k-1))
                         nnsym = nint(a)
                         if (nnsym == nSymmCard) then
                             lineSav(1:k-1) = ' '
                         endif
                         k = index(lineSav,"'")
                         if (k > 0) then
                             lineSav(1:k-1) = ' '
                             call shift(lineSav, L)
                             k = index(lineSav(2:),"'")
                             lineSav(k+2:) = ' '
                         endif
                         call StrippaApice(lineSav, ier)
                         SymmCard(nSymmCard) = lineSav(1:80)
                     endif
!
!-- Cell Parameters
!
                 elseif (dire(1:lend).eq.'_cell_length_a') then
                     call StrippaESD(line, cif_val, ier)
                     celltemp(1) = cif_val
                 elseif (dire(1:lend).eq.'_cell_length_b') then
                     call StrippaESD(line, cif_val, ier)
                     celltemp(2) = cif_val
                 elseif (dire(1:lend).eq.'_cell_length_c') then
                     call StrippaESD(line, cif_val, ier)
                     celltemp(3) = cif_val
                 elseif (dire(1:lend).eq.'_cell_angle_alpha') then
                     call StrippaESD(line, cif_val, ier)
                     celltemp(4) = cif_val
                 elseif (dire(1:lend).eq.'_cell_angle_beta') then
                     call StrippaESD(line, cif_val, ier)
                     celltemp(5) = cif_val
                 elseif (dire(1:lend).eq.'_cell_angle_gamma') then
                     call StrippaESD(line, cif_val, ier)
                     celltemp(6) = cif_val
!
!-- Space Group Symbol
!
                 elseif (dire(1:lend).eq.
     *                            '_symmetry_space_group_name_h-m' .or.
     *                   dire(1:lend).eq.
     *                            '_symmetry.space_group_name_h-m' .or.
     *                   dire(1:lend).eq.
     *                            '_space_group_name_h-m_alt') then
                     call StrippaApice(line, ier)
                     call shift(line, n)
                     if (ier == 0) then
                         if (line(1:1)==' ' .or. line(1:1)=='?') then
**** gianluca 21/04/2015     ifSPG = 0
!ORI!                    else
                         elseif (InfoOK(2) == 0) then  ! because of Space Scan
                             call StandardSPG(line,ier)
                             if (ier /= 0) then
                                 Msg = 
     *                           'Wrong Space Group Symbol in CIF file:'
     *                           // line(1:Lung(line))
                                 call MsgWinErr('ERROR', Msg,
     *                                          ERR_WINDOW, n)
                                 ifSPG = 0
                                 ier = 0
                             else
                                 ifSPG = 1
                             endif
                         endif
                      endif
!
!-- Wave length
!
                 elseif (dire(1:lend).eq.
     *                            '_diffrn_radiation_wavelength') then
                     call StrippaESD(line, cif_val, ier)
                     wave = cif_val
                 endif    !!!
             else
!
!-- manage loop directive
!--      Loop = 1 reading of CIF keys
!--           = 2 reading of CIF values
!--      LoopType = 0 not useful Loop  
!--      LoopType = 1 Loop on coordinates 
!--      LoopType = 2 Loop on reflections 
!--      LoopType = 4 Loop on symmetry equivalet positions
!
                 if (dire(1:5) == 'loop_') then
                     leggi = 0
                     ifLoop = 0
                     LoopType = 0
                     insym = .FALSE.
                 else
                     if (ifLoop == 1) then
                         if (dire(1:1) == cif_) then
                             call GetLoopKey(dire, nLoop)
                             if (LoopType == 1) then
                                 nats = 0
                                 if (n_aniso > 0) then
                                     ifIscra = 1
                                     rewind jgrap
                                     itype = 1
                                     iform = 2
                                     jop = jopen(iscra, '  ',
     *                                     itype, iform, ier)
                                     do j=1, n_aniso
                                        read(jgrap) Label, cif_bij(1:6)
                                        write(iscra) Label, cif_bij(1:6)
                                     enddo
                                 endif
*                                nk = 0
                                 cif_serial(:) = 0
                                 cif_number(:) = 0
                                 rewind jgrap
                             endif
                             if (LoopType == 4) then
                                 nSymmCard = 0
                                 ifLoop = 0
                                 insym = .TRUE.
                             endif
                         else
                             ifLoop = 2
                             if (LoopType > 0) then
                                 call GetLoopVal(lineSav, nLoop,
     *                                           ifRefl, iprint, 
     *                                           nats, b_or_u, ier)
                                 if (ier < 0) return
                             endif
                         endif
                     else
                         if (dire(1:1) == cif_) then
                             leggi = 0
                             ifLoop = 0
                             LoopType = 0
                         else
                             if (LoopType > 0) then
                                 call GetLoopVal(lineSav, nLoop, ifRefl,
     *                                        iprint, nats, b_or_u, ier)
                                 if (ier < 0) return
                             endif
                         endif
                     endif
                 endif                 
             endif
!
CCCC
         endif
      enddo
 200  continue
!
      if (ifSPG == 0 .and. nSymmCard > 0) then
          nsym = nSymmCard
          call ManageSymmCards(ier)
          call FromSymmCardsToSpaceGroupSymbol(found)
          if (found == 1) then
              call CreaSymmetryInfo(ier)
          endif
      endif
!
      if (ifIscra == 1) then
          rewind iscra
          do j=1, n_aniso
             read(iscra) Label, cif_bij(1:6)
             write(jgrap) Label, cif_bij(1:6)
          enddo
          close(iscra)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetLoopKey(line, nLoop)
      USE CIF
      character*(*) line
!
      j = 9999
      k0 = Lung(line)
      do i=1, allowed_cifkey
         if (line(1:k0) == cifkey(i)(1:l_cifkey(i))) then
             j = i
             nLoop = nLoop + 1
             punt_cifkey(nLoop) = j
         endif
      enddo
      if (LoopType == 0) then
          do i=1, max_cif_loops
             if (j <= limiti_cif(i)) then
                 LoopType = i
                 exit
             endif
          enddo
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetLoopVal(line, nLoop, ifRefl,
     *                      iprint, nats, b_or_u, ier)
      USE General
*     USE Molcom
      USE CIF
!
      character*(*) line
      character tipo*2, buffer*40, aval*40, Label*16, specie*4
      character site_refinement_flags*10
      real xyz_cif(3), site_symmetry_mult
      integer hkl(3), b_or_u
!
      phase = 0.0
      if (iprint > 0) then
          write(6,'(a)') line(1:lung(line))
      endif
      Buffer1 = line
      call shift(Buffer1, L)
      if (Buffer1(1:1) == '?') then
          return
      endif
      Label = ' '
      Label(1:2) = 'XX'
      biso = 3
      occ  = 1
      iz = 0
      iso_ani = 2   !  = 1 se aniso, = 2 se iso
      do i=1, nLoop
         call cutst(line,lenp,buffer,lend)
         j = punt_cifkey(i)
         tipo = sir_cifval(j)
         if (val_cifkey(j) == 'a') then
             aval = buffer
             if (iprint > 0) then
                 write(6,10) i,tipo,cifkey(j),aval
             endif
         else
             call StrippaESD(buffer, fval, ier)
             if (iprint > 0) then
                 write(6,20) i,tipo,cifkey(j),fval
             endif
         endif
         if (LoopType == 1) then

             select case (tipo)

             case ('xf')
                  xyz_cif(1) = fval

             case ('yf')
                  xyz_cif(2) = fval

             case ('zf')
                  xyz_cif(3) = fval

             case ('xc')
                  xyz_cif(1) = fval
                  ifCartesian = 1

             case ('yc')
                  xyz_cif(2) = fval
                  ifCartesian = 1

             case ('zc')
                  xyz_cif(3) = fval
                  ifCartesian = 1

             case ('ia')
                  call lcase(aval)
                  if (aval(1:4) == 'uiso') then
                      iso_ani = 2
                  else
                      iso_ani = 1
                  endif
                  
             case ('ad')
                  call lcase(aval)
                  if (aval(1:4) == 'uani') then
                      b_or_u = 2
                      iso_ani = 1
                  elseif (aval(1:3) == 'uij') then
                      b_or_u = 2
                      iso_ani = 1
                  elseif (aval(1:4) == 'bani') then
                      b_or_u = 1
                      iso_ani = 1
                  endif
                  
             case ('bi')
                  biso = fval

             case ('ui')
                  biso = fval * 8.0 * pi *pi

             case ('oc')
                  occ = fval

             case ('la')
                  Label = aval

             case ('sy')
                  call StringToSpecie(Label,buffer, aval, specie, iz, 1,
     *                                isn_cif)

             end select
         elseif (LoopType == 2) then

             select case (tipo)

             case ('al')
                  Label = aval

             case ('u1')
                  cif_bij(1) = fval

             case ('u2')
                  cif_bij(2) = fval

             case ('u3')
                  cif_bij(3) = fval

             case ('u4')
                  cif_bij(4) = fval

             case ('u5')
                  cif_bij(5) = fval

             case ('u6')
                  cif_bij(6) = fval

              case ('b1')
                  cif_bij(1) = fval

             case ('b2')
                  cif_bij(2) = fval

             case ('b3')
                  cif_bij(3) = fval

             case ('b4')
                  cif_bij(4) = fval

             case ('b5')
                  cif_bij(5) = fval

             case ('b6')
                  cif_bij(6) = fval

             case ('sm')
                  site_symmetry_mult = fval

             case ('rf')
                  site_refinement_flags = aval

            end select

         elseif (LoopType == 3) then

             select case (tipo)

             case ('ih')
                  hkl(1) = nint(fval)

             case ('ik')
                  hkl(2) = nint(fval)

             case ('il')
                  hkl(3) = nint(fval)

             case ('ob')
                  effe = fval
                  ifo2 = 1

             case ('c1')
                  effe2 = fval

             case ('s1')
                  sigma = fval

             case ('o2')
                  effe = sqrt(fval)
                  ifo2 = 2

             case ('c2')
                  effe2 = sqrt(fval)

             case ('s2')
                  sigma = sqrt(fval)

             case ('ph')
                  phase = fval

            end select

         endif
!
!-- i valori del loop non sono tutti in un solo record
!
         if (lenp < 0 .and. i < nLoop) then
             read(jhost,'(a)',end=200) line
             if (iprint > 0) write(0,*) line
             call lcase(line)
             call shift(line, L)
*            call cutst(line,lenp,buffer,lend)
             if (L < 1) then
                 ier = -1
                 return
             endif
         endif
      enddo
!
      if (LoopType == 1) then
          if (iz == 0) then
              call StringToSpecie(Label, buffer, aval, specie, iz, 0,
     *                            isn_cif)
          endif
     
          if (iz > 0) then
              cif_number(iz) = cif_number(iz) + occ
          endif
          nats = nats + 1
          if (iprint > 0) then
              write(6,30) nats, Label, specie, xyz_cif, occ,biso,isn_cif
          endif
          write(jgrap) Label,specie,xyz_cif,occ,iso_ani,biso,isn_cif
      elseif (LoopType == 2) then
          n_aniso = n_aniso + 1
          if (iprint > 0) then
              write(6,40) n_aniso, Label, cif_bij(1:6)
          endif
          write(jgrap) Label, cif_bij(1:6)
      elseif (LoopType == 3) then
          ifRefl = 1
          if (iprint > 0) then
              write(6, ReflFileForm) hkl(1:3), effe, sigma
          endif
          write(jfile, ReflFileForm) hkl(1:3), effe, sigma, phase
      endif
!
      return
  200 continue
      ier = -1
      return
!
   10 format(i3,1h),2x,a1,2x,a40,a40)
   20 format(i3,1h),2x,a1,2x,a40,f10.3)      
   30 format(i3,1h],2x,a16,2x,a4,2x,5f10.3,i5)      
   40 format(i3,1h],2x,a16,2x,6f10.3)      
      end
!-----------------------------------------------------------------------
      subroutine StringToSpecie(Lab, buffer, aval, specie, iz, ifSpecie,
     *                          isn_cif)
      USE General
      USE CIF
      USE elements
!
      character*(*) buffer, aval, Lab, specie
      integer :: pxen 
!
       
      if (ifSpecie == 0) then
          pxen = pxen_from_label(Lab)
          aval = specie_from_pxen(pxen)
      else
          if (aval(1:2) /= 'Q ' .and. aval(1:2) /= 'q ') then
              pxen = pxen_from_label(aval)
              aval = specie_from_pxen(pxen)
          endif
      endif
!
      call lcase(aval)
      if (aval(1:2) /= 'q ') then
          if (nk == 0) then
              nk = nk + 1
              Species(nk) = aval(1:4)
              cif_serial(nk) = cif_serial(nk) + 1
              isn_cif = cif_serial(nk)
              iz = 1
          else
              j = 0
              do k=1, nk
                 if (aval(1:4) == Species(k)) then
                     j = k
                 endif
              enddo
              if (j == 0) then
                  nk = nk + 1
                  Species(nk) = aval(1:4)
                  cif_serial(nk) = cif_serial(nk) + 1
                  isn_cif = cif_serial(nk)
                  iz = nk
              else
                  iz = j
                  cif_serial(iz) = cif_serial(iz) + 1
                  isn_cif = cif_serial(iz)
              endif
          endif 
      else 
          iz = -1
      endif 
      specie = aval(1:4)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine StrippaESD(line, cif_val, ier)
      character*(*) line
!
      k0 = Lung(line)
      if (k0 > 0) then
          k1 = index(line, '(')
          k2 = index(line, ')')
          if (k2 > k1) then
             line(k1:k2) = ' '
          endif
          k1 = index(line, ' ')
          if (k1 > 0) then
              line(k1:) = ' '
          endif
          cif_val = ValoreCIF(line)
      else
          cif_val = 0.0
          ier = -1
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine StrippaApice(line, ier)
      character*(*) line
      character Apice(2)
!
      Apice(1) = char(39)   !  apice
      Apice(2) = char(34)   !  doppio apice
      k0 = Lung(line)
      if (k0 > 0) then
          do i=1, k0
             if (line(i:i) == Apice(1) .or. line(i:i) == Apice(2)) then
                 line(i:i) = ' '
             endif
          enddo
          call shift(line, L)
      else
          ier = -1
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine StandardCifKey(String, nchar)
      character*(*) String
!
!-- Substitute "." with "_" in CIF keyword
!
      call shift(String,nchar)
      if (String(1:1) == '_') then
          ls = index(String(1:nchar), ' ')
          if (ls == 0) ls = nchar
          k = 9999
          do while (k > 1)
             k = index(String(2:ls), '.') + 1
             if (k > 0) then
                 String(k:k) = '_'
             endif
          enddo
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine FillCifKey()
      USE Cif
!
      cifkey( 1) = '_ccdc_atom_site_atom_id_number          '
      cifkey( 2) = '_ccdc_atom_site_symmetry                '
      cifkey( 3) = '_atom_site_id                           '
      cifkey( 4) = '_atom_site_group_pdb                    '
      cifkey( 5) = '_atom_site_label                        '
      cifkey( 6) = '_atom_site_label_seq_id                 '
      cifkey( 7) = '_atom_site_label_atom_id                '
      cifkey( 8) = '_atom_site_label_comp_id                '
      cifkey( 9) = '_atom_site_label_asym_id                '
      cifkey(10) = '_atom_site_label_alt_id                 '
      cifkey(11) = '_atom_site_type_symbol                  '
      cifkey(12) = '_atom_site_auth_seq_id                  '
      cifkey(13) = '_atom_site_fract_x                      '
      cifkey(14) = '_atom_site_fract_y                      '
      cifkey(15) = '_atom_site_fract_z                      '
      cifkey(16) = '_atom_site_cartn_x                      '
      cifkey(17) = '_atom_site_cartn_y                      '
      cifkey(18) = '_atom_site_cartn_z                      '
      cifkey(19) = '_atom_site_thermal_displace_type        '
      cifkey(20) = '_atom_site_u_iso_or_equiv               '
      cifkey(21) = '_atom_site_b_iso_or_equiv               '
      cifkey(22) = '_atom_site_occupancy                    '
      cifkey(23) = '_atom_site_adp_type                     '
      cifkey(24) = '_atom_site_symmetry_multiplicity        '
      cifkey(25) = '_atom_site_calc_flag                    '
      cifkey(26) = '_atom_site_refinement_flags             '
      cifkey(27) = '_atom_site_disorder_assembly            '
      cifkey(28) = '_atom_site_disorder_group               '
      cifkey(29) = '_ccdc_atom_site_base                    '
      cifkey(30) = '_atom_site_aniso_label                  '
      cifkey(31) = '_atom_site_aniso_type_symbol            '
      cifkey(32) = '_atom_site_aniso_u_11                   '
      cifkey(33) = '_atom_site_aniso_u_22                   '
      cifkey(34) = '_atom_site_aniso_u_33                   '
      cifkey(35) = '_atom_site_aniso_u_23                   '
      cifkey(36) = '_atom_site_aniso_u_13                   '
      cifkey(37) = '_atom_site_aniso_u_12                   '
      cifkey(38) = '_atom_site_aniso_b_11                   '
      cifkey(39) = '_atom_site_aniso_b_22                   '
      cifkey(40) = '_atom_site_aniso_b_33                   '
      cifkey(41) = '_atom_site_aniso_b_23                   '
      cifkey(42) = '_atom_site_aniso_b_13                   '
      cifkey(43) = '_atom_site_aniso_b_12                   '
      cifkey(44) = '_atom_site_wyckoff_symbol               '
      cifkey(45) = '_atom_site_attached_hydrogens           '
      cifkey(45) = '                                        '
      cifkey(46) = '_refln_index_h                          '
      cifkey(47) = '_refln_index_k                          '
      cifkey(48) = '_refln_index_l                          '
      cifkey(49) = '_refln_f_squared_meas                   '
      cifkey(50) = '_refln_f_squared_calc                   '
      cifkey(51) = '_refln_f_squared_sigma                  '
      cifkey(52) = '_refln_f_meas                           '
      cifkey(53) = '_refln_f_calc                           '
      cifkey(54) = '_refln_f_sigma                          '
      cifkey(55) = '_refln_phase_calc                       '
      cifkey(56) = '                                        '
      cifkey(57) = '                                        '
      cifkey(58) = '_symmetry_equiv_pos_as_xyz              '
      cifkey(59) = '_symmetry_equiv_pos_site_id             '
      cifkey(60) = '                                        '
!
      return
      end
!-----------------------------------------------------------------------
      subroutine WriteSimpleCif(nome, nats, nz, div, n, xyzs, bfac, 
     *                          aLab, u, bari)
      USE General, only  : jrel, Inte, Species, cell, PiccoFour, no
      USE Symmetry, only : nsym, icent, nSpaceG
!
      implicit none
      integer    :: jop, jopen, itype, iform, ier2, i, k, nats, jlig
      integer    :: div, divide, n, nz(nats)
      real       :: xyzs(n,nats), bfac(nats), u, U_th_fact, occ
      real       :: Pi, ottoPi2, nbar, bari(3)
      character (len=*)  :: nome
      character (len=16) :: aLab(nats), Label
!
      Pi = 3.14
      ottoPi2 = 8.0 * Pi * Pi
      bari(:) = 0.0
      nbar    = 0.0
      if (no(1) == 1) then
          jlig = 2
      else
          jlig = 1
      endif
!
      itype = 0
      iform = 1
      jop = jopen(jrel,nome,itype,iform,ier2)
      write(jrel,'(a,/)') '# Temporary CIF file'
      write(jrel,10) cell(1:6)
      write(Inte,'(16a1)') (nSpaceG(i),i=1,16)
      call ucase(Inte)
      write(jrel,20) Inte(1:16)
      write(jrel,30)
!
      if (iabs(nz(1)) >= div) then
          divide = div
      else
          divide = 1
      endif
      do i=1, nats
         if (u < 0.0) then
             U_th_fact = - u
         else
             U_th_fact = bfac(i) / ottoPi2
         endif
         k = iabs(nz(i)) / divide
         if (k == 0) cycle
         if (n == 5) then
             occ = xyzs(5,i)
         else
             occ = 1.0
         endif
         if (k == PiccoFour) then
             k = jlig
             Label = 'Peak'
             Label(5:) = aLab(i)(1:4)
         else
             Label = aLab(i)
         endif
         bari(1:3) = bari(1:3) + xyzs(1:3,i)
         nbar = nbar + 1
         write(jrel,40) Label, xyzs(1:3,i), occ, U_th_fact,
     *                  Species(k), nint( occ * nsym*(icent+1))
      enddo
      write(jrel,'(/,a)') '# End Temporary CIF file'
      close (jrel)
      bari(1:3) = bari(1:3) / nbar
!
      return
   10 format('_cell_length_a                                ',f7.3,/,
     *       '_cell_length_b                                ',f7.3,/,
     *       '_cell_length_c                                ',f7.3,/,
     *       '_cell_angle_alpha                             ',f7.3,/,
     *       '_cell_angle_beta                              ',f7.3,/,
     *       '_cell_angle_gamma                             ',f7.3)
   20 format('_symmetry_space_group_name_H-M                ',"'",a,"'")
   30 format('loop_',/,
     *       '_atom_site_label',/,
     *       '_atom_site_fract_x',/,
     *       '_atom_site_fract_y',/,
     *       '_atom_site_fract_z',/,
     *       '_atom_site_occupancy',/,
     *       '_atom_site_U_iso_or_equiv',/,
     *       '_atom_site_thermal_displace_type',/,
     *       '_atom_site_type_symbol',/,
     *       '_atom_site_symmetry_multiplicity',/)
   40 format(a,5f9.4,' uiso ',a,i5)
      end
!-----------------------------------------------------------------------
      subroutine ManageSymmCards(ier)
      USE General
      USE Symmetry
!
      implicit none
      integer :: i, j, k, l, ls, Lung, lxyz(3), cifra, ier
      real    :: a1, a2, ValoreCIF
      character (len=20) :: linee(3)
      character (len=3)  :: xyz
!
*     do i=1, nsym
*        call ManageSymmCard(SymmCard(i)) ! , Rmatrix, Tmatrix)
*     enddo
      kmat(1:192,1:3,1:3) = 0
      tmat(1:192,1:3) = 0.0
      xyz = 'xyz'
!
!-- Unit matrix
!
      do i=1, 3
         kmat(1,i,i) = 1
      enddo
!
      if (nsym > 1) then
          do i=1, nsym
             if (iprin > 0) then
                 l = Lung(SymmCard(i))
                 write(0,'(i3,")",2x,a)') i, SymmCard(i)(1:l)
             endif
             call NoBlanks(SymmCard(i), ls)
             k = index(SymmCard(i),',')
             linee(1) = SymmCard(i)(1:k-1)
!
             SymmCard(i)(1:k) = ' '
             call shift(SymmCard(i), ls)
             k = index(SymmCard(i),',')
             linee(2) = SymmCard(i)(1:k-1)
!
             SymmCard(i)(1:k) = ' '
             call shift(SymmCard(i), ls)
             linee(3) = SymmCard(i)(1:ls)
             do j=1, 3
                lxyz(j) = Lung(linee(j))
                call lcase(linee(j))
             enddo
             do j=1, 3
                ls = 1
*               do while (ls > 0)
                    do l=1, 3
                       ls = index(linee(j), xyz(l:l))
                       if (ls > 0) then
                           if (ls == 1) then
                               cifra = 1
                               linee(j)(ls:ls) = ' '
                           else
                               if (linee(j)(ls-1:ls-1) == '+') then
                                   cifra = 1
                                   linee(j)(ls-1:ls) = '  '
                               elseif (linee(j)(ls-1:ls-1) == '-') then
                                   cifra = -1
                                   linee(j)(ls-1:ls) = '  '
                               else
                                   ier = -1
                                   return
                               endif
                           endif
                           kmat(i,j,l) = cifra
                       endif
                       call shift(linee(j), lxyz(j))
                    enddo
*               enddo
                if (lxyz(j) > 0) then
                    k = index(linee(j), '/')
                    if (k > 0) then
                        a1 = ValoreCIF(linee(j)(1:k-1))
                        a2 = ValoreCIF(linee(j)(k+1:))
                        a1 = a1 / a2
                    else
                        a1 = ValoreCIF(linee(j))
                    endif
                    tmat(i,j) = a1
                endif
             enddo
!
             if (iprin > 0) then
                 do j=1, 3
                    write(0,'(3i4,4x,f8.3)') kmat(i,j,1:3), tmat(i,j)
                 enddo
                 write(0,*) ' '
             endif
!
          enddo
      else
         if (iprin > 0) then
             do j=1, 3
                write(0,'(3i4,4x,f8.3)') kmat(1,j,1:3), tmat(1,j)
             enddo
             write(0,*) ' '
         endif
      endif
!
!-- Check if only SYMM cards have been supplied
!
*     if (latt == 0) then
*         call ManageLattIcent(ier)
*     endif
!gl!  call musym()
!
      if (latt == 0) then
          latt = 1
          icent = 0
      else
          call musym
      endif
      if (abs(pts) < 0.5) then
          pts  = 1
          latt = 1
          icent = 0
      endif
      nsymTot = nsym * (icent + 1) * pts
      totop = nsymTot
      call MakeSymmOperators
      InfoOK(2) = 2
      deallocate(SymmCard, stat = ier)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ManageSymmCard(input) ! , Rmatrix, Tmatrix)
      USE General
      USE Symmetry
!
      implicit none
      integer :: i, j, k, l, ls, Lung, lxyz(3), cifra, ier, Rmatrix(3,3)
      real    :: a1, a2, ValoreCIF, Tmatrix(3)
      character (len=*) :: input
      character (len=80) :: stringa
      character (len=20) :: linee(3)
      character (len=3)  :: xyz
!
      stringa = input
      xyz = 'xyz'
      Rmatrix(:,:) = 0
      Tmatrix(:)   = 0
!
      call NoBlanks(stringa, ls)
      k = index(stringa,',')
      linee(1) = stringa(1:k-1)
!
      stringa(1:k) = ' '
      call shift(stringa, ls)
      k = index(stringa,',')
      linee(2) = stringa(1:k-1)
!
      stringa(1:k) = ' '
      call shift(stringa, ls)
      linee(3) = stringa(1:ls)
      do j=1, 3
         lxyz(j) = Lung(linee(j))
         call lcase(linee(j))
      enddo
      do j=1, 3
         ls = 1
         do l=1, 3
            ls = index(linee(j), xyz(l:l))
            if (ls > 0) then
                if (ls == 1) then
                    cifra = 1
                    linee(j)(ls:ls) = ' '
                else
                    if (linee(j)(ls-1:ls-1) == '+') then
                        cifra = 1
                        linee(j)(ls-1:ls) = '  '
                    elseif (linee(j)(ls-1:ls-1) == '-') then
                        cifra = -1
                        linee(j)(ls-1:ls) = '  '
                    else
                        ier = -1
                        return
                    endif
                endif
                Rmatrix(j,l) = cifra
            endif
            call shift(linee(j), lxyz(j))
         enddo
         if (lxyz(j) > 0) then
             k = index(linee(j), '/')
             if (k > 0) then
                 a1 = ValoreCIF(linee(j)(1:k-1))
                 a2 = ValoreCIF(linee(j)(k+1:))
                 a1 = a1 / a2
             else
                 a1 = ValoreCIF(linee(j))
             endif
             Tmatrix(j) = a1
         endif
      enddo
      write(6,*) 'Stringa ', input
      do i=1, 3
         write(6,'(3i4,f8.2)') Rmatrix(i,1:3), Tmatrix(i)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ManageLattIcent(ier)
      USE General
      USE Symmetry
!
      implicit none
      integer :: i, j, k, l, ls, Lung, ncent, delete(192), sommaR, ier
      integer :: kt, WL(3)
      real    :: sommaT, trasla0(3), trasla(3), tra, unterzo, dueterzi
!
!-- Look for inversion center
!
      icent = 0
      delete(:) = 0
      ncent = 0
      do i=1, nsym-1
         if (delete(i) == 1) cycle
         do j=i+1, nsym
            if (delete(j) == 1) cycle
            sommaR = 0
            do k=1, 3
               do l=1, 3
                  sommaR = sommaR + iabs(kmat(j,k,l) + kmat(i,k,l))
               enddo
            enddo
            sommaT = 0.0
            do k=1,3
               sommaT = sommaT + abs( abs(tmat(j,k)) - abs(tmat(i,k)))
            enddo
            if (sommaR == 0 .and.  sommaT < 0.1) then
                delete(j) = 1
                ncent = ncent + 1
            endif
         enddo
      enddo
      if (ncent > 0) then
          if (ncent == nsym / 2) then
              icent = 1
              call ComprimiMatrici(delete)
          else
              ier = -1
              return
          endif
      endif
!
!-- Look for 1/2 lattice translations
!
      WL(:) = 0
      trasla0(:) = 0.5
      do kt=1, 3
         trasla(:) = trasla0(:)
         trasla(kt) = 0.0
         ncent = 0
         do i=1, nsym-1
            if (delete(i) == 1) cycle
            do j=i+1, nsym
               if (delete(j) == 1) cycle
               sommaR = 0
               do k=1, 3
                  do l=1, 3
                     sommaR = sommaR + iabs(kmat(j,k,l) - kmat(i,k,l))
                  enddo
               enddo
               if (sommaR /= 0) cycle
               sommaT = 0.0
               do k=1,3
                  tra = abs(tmat(i,k) + trasla(k))
                  sommaT = sommaT + abs( abs(tmat(j,k)) - tra)
               enddo
               if (sommaT < 0.1) then
                   delete(j) = 1
                   WL(kt) = WL(kt) + 1
               endif
            enddo
         enddo
      enddo
      do i=1, 3
         k = WL(i)
         if (k > 0) then
             k = nsym / k
             k = k / 2
             WL(i) = k
         endif
      enddo
      latt = 1                                                       ! P
      if (sum(WL(:)) > 0) then
          call ComprimiMatrici(delete)
          if (WL(1) == 0 .and. WL(2) == 1 .and. WL(3) == 1) then
              latt = 2                                               ! A
          elseif (WL(1) == 1 .and. WL(2) == 0 .and. WL(3) == 1) then
              latt = 3                                               ! B
          elseif (WL(1) == 1 .and. WL(2) == 1 .and. WL(3) == 0) then
              latt = 4                                               ! C
          elseif (WL(1) == 1 .and. WL(2) == 1 .and. WL(3) == 1) then
              latt = 5                                               ! I
          elseif (WL(1) == 2 .and. WL(2) == 2 .and. WL(3) == 2) then
              latt = 6                                               ! F
*         elseif (WL(1) == 2 .and. WL(2) == 2 .and. WL(3) == 2) then
*             latt = 7                                               ! R
          endif
      endif
!
!-- Look for R lattice translations
!
      unterzo  = 1.0 / 3.0
      dueterzi = 2.0 / 3.0
      WL(:) = 0
      trasla0(:) = 0.5
      do kt=1, 2
         if (kt == 1) then
             trasla(1:3) = (/ dueterzi, unterzo, unterzo /)
         else
             trasla(1:3) = (/ unterzo, dueterzi, dueterzi /)
         endif
         ncent = 0
         do i=1, nsym-1
            if (delete(i) == 1) cycle
            do j=i+1, nsym
               if (delete(j) == 1) cycle
               sommaR = 0
               do k=1, 3
                  do l=1, 3
                     sommaR = sommaR + iabs(kmat(j,k,l) - kmat(i,k,l))
                  enddo
               enddo
               if (sommaR /= 0) cycle
               sommaT = 0.0
               do k=1,3
                  tra = abs(tmat(i,k) + trasla(k))
                  sommaT = sommaT + abs( abs(tmat(j,k)) - tra)
               enddo
               if (sommaT < 0.1) then
                   delete(j) = 1
                   WL(kt) = WL(kt) + 1
               endif
            enddo
         enddo
      enddo
      do i=1, 2
         k = WL(i)
         if (k > 0) then
             k = nsym / k
             k = k / 2
             WL(i) = k
         endif
      enddo
      if (sum(WL(1:2)) > 0) then
          call ComprimiMatrici(delete)
          latt = 7                                               ! R
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ComprimiMatrici(delete)
      USE Symmetry
!
      implicit none
      integer :: i, j, k, l, ls, Lung, ncent, delete(192), sommaR
!
      k = 0
      do i=1, nsym
         if (delete(i) == 0) then
             k = k + 1
             kmat(k,:,:) = kmat(i,:,:)
             tmat(k,:)   = tmat(i,:)
         endif
      enddo
!
      nsym = k
      delete(:) = 0
!
      return
      end
!-----------------------------------------------------------------------
!               PDB general routines
!-----------------------------------------------------------------------
      subroutine LeggiPDBinMem(ifAll, ifHOH, ifHET, ifBack,ifCutResidui,
     *                         celltemp, nats, nSpec, nSecondary, ier)
c**Protein Data Bank program format**
!
!--        ifAll = 1  all informations in PDB file are stored in binary file
!                = 0  only atoms coordinates are stored
!--        ifHOH = 0  HOH atoms are skipped
!                = 1  HOH atoms are imported
!--        ifHET = 0  HETATM  hetero atoms are skipped
!                = 1  HETATM  hetero atoms are imported
!--       ifBack = 0  all residues atoms selected
!                = 1  only backbone atoms (i.e. N, Ca, C, O, CB)
!-- inMemoryOnly = 1  coordinates will be not written in binary file
!                = 0  coordinates will be stored in binary file
!
      USE Molcom, only : rm, rmi
      USE General
      USE Deprecato
      USE Symmetry
      USE Groups
      USE Dialogo
!
      dimension jav(4),add(13),jxcon(11)
!
      integer :: KompareString, nResidui, HET
      real celltemp(13), aniso(6), x1(3), x2(3)
      character (len=16) LabelS
      character (len=6) atom
      character (len=4) tipoAtm, nomeAtomo, Segment, specieAtomo, tipoRe
      character (len=1) Alternate, Catena, insertion, extraCatena
      character (len=3) tipoResd, extraResid
      character (len=2) ElementSymbol, Charge, a2
      integer serial, resSeq
      dimension xtemp(80)
!
      dimension nt(16)
      character*16 vetch,ntchar
      dimension nter(20)
      dimension xmatr(3,3),xmtrix(26,3,3),vectx(26,3)
      character*80 iformat
      character*26 alfabeto
      character*21 ident1,ident2
      character*4 dire
      dimension xwave(2)
      integer kshif(3), ResiduoNegativo
!mr   integer nSecondary, Secondary(100,5)
      integer nSecondary, Secondary(1000,5)
      character*4 iwave(2),ibackbone(5)
      character*5 iwatch
      character*3 ihohch,residch,iresiduo(30),jbbch
      character*80 CardBuffer
      character*16 SpgString
      logical AtomReady
c
c--pdb directives
      dimension ispec(20),ncs(20)
      character*4 ishe(16)
      character*1 jblank
      data alfabeto/'abcdefghijklmnopqrstuvwxyz'/
c--------------------12345678901234567890123456
      data nshe/16/
      data xwave/0.71069,1.54178/
      data ishe  /'rema','titl','crys','orig','scal',
     2            'ter ','atom','heta','cone','anis',
     3            'mtri','mode','endm','heli','shee',
     4            'end '/
      data iwatch/'woxth'/
      data ihohch/'hoh'/
      data iwave /'mo  ','cu  '/
      data ibackbone/' n  ',' ca ',' c  ',' o  ',' cb '/
      data iresiduo/'ala','arg','val','tyr','trp',
     2              'thr','ser','pro','phe','met',
     3              'lys','leu','ile','his','gly',
     4              'glu','gln','cys','asp','asn',
     5              'mse',' da',' dc',' dg',' dt',
     6              '  a','  c','  g','  t','  u'/ 
      data ntchar/'p 1'/
!
      nResidui = 30
      extraResid = ' '
      AtomReady = .false.
      ResiduoNegativo = 0
      kshif(:) = 0
      ishif   = 0
      nSecondary = 0
!
      read(ntchar,'(16a1)') nt
      read(iwatch,'(5a1)')iwater,iox,ixx,ixt,jhidr
      read(ihohch,'(a3)') ihoh
!--
!
      kchain = ichar('a')
      nfl=1
      itype = 1
      iform = 2
      jop = jopen(jgrap,'  ',itype,iform,ier)
      if (jop < 0) then
          ier = -1
          return
      endif
!
      celltemp(:) = 0.0
!
!     if (ifCutResidui == 1) then
!         AminoName( 1) = 'ALA';   AminoName( 2) = 'ARG'
!         AminoName( 3) = 'ASN';   AminoName( 4) = 'ASP'
!         AminoName( 5) = 'CYS';   AminoName( 6) = 'GLN'
!         AminoName( 7) = 'GLU';   AminoName( 8) = 'GLY'
!         AminoName( 9) = 'HIS';   AminoName(10) = 'ILE'
!         AminoName(11) = 'LEU';   AminoName(12) = 'LYS'
!         AminoName(13) = 'MET';   AminoName(14) = 'MSE'
!         AminoName(15) = 'PHE';   AminoName(16) = 'PRO'
!         AminoName(17) = 'SER';   AminoName(18) = 'THR'
!         AminoName(19) = 'TRP';   AminoName(20) = 'TYR'
!         AminoName(21) = 'VAL'
          nResid = 21
!     endif
!
      nChains = 0
**!
**!-- if Skeleton already computed store information in list 30
**!
**      if (ifSkeleton > 0) then
**          nSkel  = nats
**          do i=1,nSkel
**             xyztot(1:3,i) = xyzs(1:3,i)
**          enddo
**          k = 1
**          nSkelLeg = iconn(1)
**          do i=1,nSkelLeg
**             LE1(1:3,i) = iconn(k+1:k+3)
**             k = k + 3
**           enddo
**           iconn(1) = 0
**      else
**          nSkel  = 0
**      endif
      nSpec = 0
      nSpecie = 0
      nResTot=0
      nResCur=0
      kResNum=0
      ier=0
      nbo=0
      nterx=0
      imtrix=0
      idev=0
!mr
      if (WhichWave == -1) then
          WhichWave = 1
          wavel = xwave(WhichWave)
      endif
!mr
      if (ifRemo == 0) then
          iscale = 0
      else
          iscale = 1
          xmatr(:,:) = rmi(:,:)
      endif
      if (InfoOK(3).eq.0) then
          nk = 0
      endif
!
!--read the cards
!
      do while(ier == 0)
         call LeggiCardImage(ifUguale, ifEOF, ier)
         if (ifEOF < 0 .or. ier < 0) exit
         call lcase(cardImage)
!
         call cutst(cardImage,lenp,direttiva,lend)
         call lcase(direttiva)
         if (lend <= 0) cycle                   ! blank card
         n=KompareString(direttiva,ishe,nshe,0)
         if (n <= 0) then
             n = 1000
         endif
!
         select case (n)
!
            case (1)   ! 'remark' card
!
            case (2)   ! 'compnd' card
               if (ifRemo == 0) then
!gl!               read(cardDiret(5:),'(20a4)') itle
                   Titolo = cardDiret(5:84)
               endif
!
            case (3)   ! 'cryst1' card
               if (InfoOK(2) == 0) then
                   SpgString = cardDiret(56:66)
                   call lcase(SpgString)
                   read(SpgString,'(16a1)') nSpaceG
                   call CreaSymmetryInfo(ier)
               endif
*              call insym(ishif,kshif,ier)
               cardDiret(56:) = ' '
               cardImage = cardDiret(7:)
               iopt = 6
               call getnum(cardImage,xtemp,itemp,iv,iopt)
               if (iopt < 0) then
                   ier = -1
                   exit
               else
                   celltemp(1:6) = xtemp(1:6)
               endif
               if (ifRemo == 1 .and. ifAll == 1) then
                   call Orto(celltemp(1:6))
               endif
               if (ifAll == 1) then     !  DA VERIFICARE ???
                   iscale = 1
               endif
*              if (InfoOK(1) == 0) then
*                  InfoOK(1) = 1
*              endif
!
            case (4)   ! 'orig' card
!
            case (5)   ! 'scale' card
               iscale = 1
               read(cardDiret,1018)(xmatr(1,j),j=1,3)
               read(jhost,1018)(xmatr(2,j),j=1,3)
               read(jhost,1018)(xmatr(3,j),j=1,3)
!
            case (6)   ! 'ter  ' card
!
            case (7,8)   ! 'atom' or 'hetatm' card
               if (AtomReady) then
                   write(jgrap) xyzsS1, xyzsS2, xyzsS3, xyzsS4, xyzsS5,
     *                          nzS, 
     *                          bfacS6,
     *                          nomeAtomo,  ! tipo atomo (C, CA, etc.)
     *                          Alternate,  ! blank/A/B..
     *                          tipoRe,     ! tipo residuo
     *                          Catena,     ! catena
     *                          resSeq,     ! num. sequ. del residuo
     *                          insertion,  ! code for insertion of residues
     *                          LabelS,     ! label
     *                          aniso,      ! componenti anisotrope
     *                          HET,        ! 0/1 (ATOM/HETATM)
     *                          specieAtomo ! specie atomica
                   AtomReady = .false.
               endif
               aniso(:) = 0.0
               if (n == 8) then
                   iheta = 1
               else
                   iheta = 0
               endif
               if (ifHET == 0) then
                   if (iheta == 1) cycle
               endif
*              if (InfoOK(1) == 0) then
                   if (celltemp(1) < 0.01) then
                       celltemp(1: 3) = 1.0
                       celltemp(4: 6) = 90.0
                       celltemp(7:13) = 0.0
                       do i=1,3
                          do j=1,3
                             xmatr(i,j)=0.0
                             if (i.eq.j) xmatr(i,j)=1.0
                          enddo
                       enddo
                       iscale=1
*                      InfoOK(1) = 1
                   endif
*              else
*                  celltemp(1: 6) = cell(1:6)
*                  celltemp(7:13) = 0.0
*              endif
               if (iscale == 0 .or. ifRemo > 0) then !aggiunto da Rocco 12/5/09
                   iscale = 1
                   xmatr(:,:) = rmi(:,:)
               endif
*              read(cardImage,1019) ostorem55,jav(1),jav(2),jav(3),
*    *                              jav(4),jb 2  ,jbb,jc,jd,je,
*    *                              (xtemp(i),i=1,5),jf,jg,jl
               cardImage = cardDiret
               call lcase(cardImage)
               read(cardImage,1119) atom, serial, tipoAtm, Alternate,
     *                              tipoResd, Catena, resSeq,
     *                              insertion, xtemp(1:5), 
     *                              Segment, ElementSymbol, Charge
 1119 format(a6,i5,1x,a4,a1,a3,1x,a1,i4,a1,3x,3f8.3,2f6.2,6x,a4,2a2)
               a2 = ElementSymbol
               call lcase(a2)
               if (a2 == 'un') then     ! Mercury
                   ElementSymbol = '  '
                   Charge = '  '
               endif
               if (atom(1:3) == 'ato') then
                   HET = 0
                else
                   HET = 1
                endif
               x1(1:3) = xtemp(1:3)
!
               if (xtemp(4) < 0.001) then   ! gianluca 25/09/2015
                   xtemp(4) = 1.0
               endif
!
               occ = xtemp(4)
      ident1 = cardDiret(7:27)
      nomeAtomo = tipoAtm
      call shift(nomeAtomo,lenp)
!
!Record Format 
!COLUMNS        DATA TYPE       FIELD         DEFINITION
!---------------------------------------------------------------------------------
! 1 -  6        Record name     "ATOM  "
! 7 - 11        Integer         serial        Atom serial number.
!13 - 16        Atom            name          Atom name.
!17             Character       altLoc        Alternate location indicator.
!18 - 20        Residue name    resName       Residue name.
!22             Character       chainID       Chain identifier.
!23 - 26        Integer         resSeq        Residue sequence number.
!27             AChar           iCode         Code for insertion of residues.
!31 - 38        Real(8.3)       x             Orthogonal coordinates for X in
!                                             Angstroms.
!39 - 46        Real(8.3)       y             Orthogonal coordinates for Y in
!                                             Angstroms.
!47 - 54        Real(8.3)       z             Orthogonal coordinates for Z in
!                                             Angstroms.
!55 - 60        Real(6.2)       occupancy     Occupancy.
!61 - 66        Real(6.2)       tempFactor    Temperature factor.
!73 - 76        LString(4)      segID         Segment identifier, left-justified.
!77 - 78        LString(2)      element       Element symbol, right-justified.
!79 - 80        LString(2)      charge        Charge on the atom.
!
!         1         2         3         4         5         6         7         8
!12345678901234567890123456789012345678901234567890123456789012345678901234567890
!ATOM    145  N   VAL A  25      32.433  16.336  57.540  1.00 11.92      A1   N
!ATOM    146  CA  VAL A  25      31.132  16.439  58.160  1.00 11.85      A1   C
!ATOM    147  C   VAL A  25      30.447  15.105  58.363  1.00 12.34      A1   C
!ATOM    148  O   VAL A  25      29.520  15.059  59.174  1.00 15.65      A1   O
!ATOM    149  CB AVAL A  25      30.385  17.437  57.230  0.28 13.88      A1   C
!ATOM    150  CB BVAL A  25      30.166  17.399  57.373  0.72 15.41      A1   C
!ATOM    151  CG1AVAL A  25      28.870  17.401  57.336  0.28 12.64      A1   C
!ATOM    152  CG1BVAL A  25      30.805  18.788  57.449  0.72 15.11      A1   C
!ATOM    153  CG2AVAL A  25      30.835  18.826  57.661  0.28 13.58      A1   C
!ATOM    154  CG2BVAL A  25      29.909  16.996  55.922  0.72 13.25      A1   C
!ddddddnnnnn aaaacrrr annnni   111111112222222233333333444444555555      iiiieecc
!0    00   1 1  111 2 22  22   3      33      44      55    66    6      7  77778 
!1----67---1 3--678-0 23--67   1------89------67------45----01----6      3--67890
!a6    i5    a4  aa3  ai4  a   f8.3    f8.3    f8.3    f6.2  f6.2        a4  a a
c
c--jav(1) 1x,a1  h number (1,2 o 3)
c--jav(2)    a1  chemical symbol (h,c,o,n,s,p)
c--jav(3)    a1  remoteness indicator (alfa, beta,.. etc.)
c--jav(4)    a1  branch designator (1,2,...etc
c--jb        a1  alternate location indicator (A,B)
c--jbb       a3  residue name (ALA,ILE,..etc.)
c--jc     1x,a1  chain identifier (A per alfa chain,....)
c--jd        i4  residue seq. no.
c--je        a1  code for insertion of residues (A,B,...etc)
c--xtemp   3x,3f8.3,2f6.2,1x    (x,y,z,occ,b)
c--jf     6x,a4  segID
c--jg        a2  element
c--jl        a2  charge 
!
!--controllo se e' un atome sconosciuto UNX/UNK o un dummy atom DUM
               cardImage = cardDiret
*              if (iheta == 1) then
*                  if (ElementSymbol == '  ') then
                       if ((tipoResd == 'unx' .or.
     *                     tipoResd == 'unk') .and. SaltaUNK) cycle
                       if (tipoAtm(1:3) == 'unx' .or.
     *                     tipoAtm(1:3) == 'unk') cycle
!
               if (tipoResd == 'dum' .or. 
     *             tipoAtm(1:3) == 'dum') cycle
*                  endif
*              endif
!
!--controllo se e' un atomo sconosciuto UNX/UNK
!
*?*            if (iheta == 0) then
*?*                if (ElementSymbol == '  ') then
*?*                    if (tipoResd == 'unx' .or. 
*?*  *                     tipoResd == 'unk') cycle
*?*                    if (tipoAtm(1:3) == 'unx' .or. 
*?*  *                     tipoAtm(1:3) == 'unk') cycle
*?*                endif
*?*            endif
!
!--controllo se e' un atomo di un residuo / acido nucleico
!
               kresid = kRes(tipoResd, ElementSymbol) 


               if (kresid > 0) then    !! prova per MES
                   HET = 0
                   iheta = 0
               endif
  


!!             kresid = 0 
!!             do n=1, nResidui
!!                if (tipoResd == iresiduo(n)) then
!!                    kresid = n
!!                    exit
!!                endif
!!             enddo
               if (kresid /= 0) then
                   ifProtein = 1
               endif
!
!--controllo se devo prendere solo backbone      
!
               iOK = 0
               if (ifBack == 1) then
                   if (iheta == 0) then
                       if (kresid /= 0) then
                           do n=1, 5
                              if (ibackbone(n) == tipoAtm) then
                                  iOK = 1
                                  exit
                              endif
                           enddo
                       endif
                       if (iOK == 0) cycle
                   endif
               endif
!
!--controllo se devo prendere solo una parte dei residui
!
               if (ifCutResidui == 1) then
                   tipoRe = tipoResd
                   call ucase(tipoRe)
                   ifResid = 0
                   do i=1, nResid
                      if (tipoRe(1:3) == AminoName3(i)) then
                          ifResid = 1
                          exit
                      endif
                   enddo
                   if (ifResid == 1) then
                       if (resSeq < MinResiduo .or. 
     *                     resSeq > MaxResiduo) cycle
                   endif
               endif
!
!--conto i residui
!
               if (kresid /= 0) then
                   if (nResCur /= kresid) then
                        nResTot = nResTot + 1
                        kResNum = resSeq
                        nResCur = kresid
                   else
                        if (kResNum /= resSeq) then
                           nResTot = nResTot+1
                           kResNum = resSeq
                        endif
                   endif 
               endif    
!
               iOK = 0
               if (Catena == ' ') then
                   iOK = 1
                   do i=1,nResidui
                      if (tipoResd == iresiduo(i)) then
                          iOK = 0
                          Catena = 'a'
                          exit
                      endif
                   enddo
               else
                   iOK = 1
               endif
               if (Catena == ' ') then
                   if (tipoResd == 'hoh') then
                       Catena = 'w'
                   endif
               endif
               if (Catena == ' ') then
                   if (nChains == 0) then
                       Catena = 'a'
                       extraResid = tipoResd    ! gl 12/04/2010
                       extraCatena = Catena     ! gl 12/04/2010
                   else
                       if (tipoResd == extraResid) then
                           Catena = extraCatena
                       else
                           k = cChains(nChains) + 1
                           Catena = char(k)
                           extraCatena = Catena
                           extraResid = tipoResd
                       endif
                   endif
               endif
!
!-- check on chains
!
               if (Catena /= ' ') then  !  .and. kresid /= 0) then
                   kchain = ichar(Catena)
                   if (nChains == 0) then
                       nChains = 1
                       cChains(nChains) = kchain
                   else
                       iOK = 0
                       do i=1, nChains
                          if (kchain == cChains(i)) then
                              iOK = 1
                              exit
                          endif
                       enddo
                       if (iOK == 0) then
                           nChains = nChains + 1
                           cChains(nChains) = kchain
                       endif
                   endif
               endif
!
               Catena = char(kchain)
               call ucase(Alternate)
               call ucase(Catena)
!
*gl*           call MoltMatVec(xmatr, x1, x2)
               x2(1:3) = x1(1:3)  ! gianluca 24/05/2011
!
!--define the stomic species  (old format iold=1, new format iold=0)
               iold = 1
               if (ElementSymbol /= '  ') then
!
!--controllo che possa essere una specie chimica giustificata a destra
!
                   if (ElementSymbol(2:2) /= ' ') then
                       ifnum = isADigit(ElementSymbol(2:2))
                       if (ifnum == 0) iold = 0
                   endif
               endif
               if (tipoAtm(2:2) == 'w') tipoAtm(2:2) = 'o'
               if (iold == 1) then
                   k = 1
                   if (tipoAtm(1:1) /= ' ') then
                       k = isADigit(tipoAtm(1:1))
                   endif
                   if (k == 0) then
                       if (tipoAtm(2:2) /= ' ') then
                           k = isADigit(tipoAtm(2:2))
*gl??*                     if (k == 1) k = 0
                       endif
*gl??*                 if (k == 1) then
                       if (k == 0) then
                           CardBuffer = tipoAtm(1:2)
                       else
                           CardBuffer = tipoAtm(1:1)
                       endif
                   else
                       CardBuffer = tipoAtm(2:3)
                       if (CardBuffer(1:3) /= tipoResd) then
                           CardBuffer = tipoAtm(2:2)
                       endif
                   endif
               else
                   tipoAtm = ElementSymbol
                   cardBuffer = tipoAtm
               endif
               call shift(tipoAtm,lenp)
               call shift(CardBuffer,lenp)
               specieAtomo = CardBuffer(1:4)
               if (ifHOH == 0) then
                   if (specieAtomo(1:2) == 'h ') cycle
                   if (specieAtomo(1:2) == 'o ' .and.
     *                 tipoResd == 'hoh') cycle
               endif
!
!--definisco nome atomo      
!
               CardBuffer = nomeAtomo
               lenp = Lung(CardBuffer)
!
               ircode = 0
               if (Alternate /= ' ') then
                   ircode = 1
                   CardBuffer(lenp+1:) = '/' // Alternate
                   lenp = Lung(CardBuffer)
               endif
!
               if (tipoResd /= '   ') then
                   ircode = 1  
                   CardBuffer(lenp+1:) = '_' // tipoResd
                   lenp = Lung(CardBuffer)
               endif 
!
               if (resSeq > 0) then
                   ircode = 1  
                   write(CardBuffer(lenp+1:lenp+5),'("_",i4)') resSeq
                   call NoBlanks(CardBuffer, lenp)
               endif
               CardBuffer(lenp+1:lenp+2) = '_' // Catena
               call NoBlanks(CardBuffer, lenp)
!
               if (ircode == 1) then
                   LabelS = CardBuffer(1:16)   ! Chiedere a Riccardo cosa succede
               else
                   LabelS = CardBuffer(1:16)   ! se ircode = 0
               endif
!
               call ucase(LabelS)
               nats = nats + 1
!
               iOK = 0
               if (nSpec == 0) then
                   nSpec = nSpec + 1
                   vSpecie(nSpec) = specieAtomo
                   nSpecie(nSpec) = occ
                   izz = 1
               else
                   do j=1,nSpec
                      if (vSpecie(j) == specieAtomo) then
                          iOK = 1
                          nSpecie(j) = nSpecie(j) + occ
                          izz = j
                      endif
                   enddo
                   if (iOK == 0) then
                       nSpec = nSpec + 1
                       vSpecie(nSpec) = specieAtomo
                       nSpecie(nSpec) = occ
                       izz = nSpec
                   endif
               endif
!
               xyzsS1 = x2(1)
               xyzsS2 = x2(2)
               xyzsS3 = x2(3)
               xyzsS4 = 100
               xyzsS5 = occ
               bfacS6 = xtemp(5)
               nzS    = izz
*gl*           if (kresid > 0) then
                   tipoRe = tipoResd ! iresiduo(kresid)
*gl*           else
*gl*               tipoRe = ' '
*gl*           endif
!
               AtomReady = .true.
!
               if (resSeq <= 0) then
                   ResiduoNegativo = 1
               endif
!
            case (9)   ! 'conect' card
!
            case (10)  ! 'anisou' cards
               ident2 = cardDiret(7:27)
               if (ident1 /= ident2) cycle
*gl*           cardImage = cardDiret(27:70)
               cardImage = cardDiret(29:70)
!old!          iopt = 6
!old!          call getnum(cardImage,xtemp,itemp,iv,iopt)
! new gianluca 20 ott 2014
               read(cardImage,'(6i7)', err=1) itemp(1:6)
               xtemp(1:6) = itemp(1:6)
    1          if (ier /= 0) then
! new end
                   ier = -1
                   exit
               else
!
!                        (1)(2)(3)(4)(5)(6)
!  la sequenza in pdb  : 11 22 33 12 13 23
!  la sequenza in sir  : 11 12 13 22 23 33
!
*                  aniso(1) = xtemp(1) * 0.0001*UijToBij_11
*                  aniso(4) = xtemp(2) * 0.0001*UijToBij_22
*                  aniso(6) = xtemp(3) * 0.0001*UijToBij_33
*                  aniso(2) = xtemp(4) * 0.0001*UijToBij_12
*                  aniso(3) = xtemp(5) * 0.0001*UijToBij_13
*                  aniso(5) = xtemp(6) * 0.0001*UijToBij_23
                   aniso(1) = xtemp(1)
                   aniso(2) = xtemp(2)
                   aniso(3) = xtemp(3)
                   aniso(4) = xtemp(4)
                   aniso(5) = xtemp(5)
                   aniso(6) = xtemp(6)
               endif
!
            case (11)  ! 'mtrix(n)' cards
               imtrix=imtrix+1
****           write(iformat,1017)(image(i),i=1,80)
*              read(iformat,'(7x,i3,45x,i5)') indi1,indi2
*              read(iformat,1118)indi3,(xmtrix(indi1,1,j),j=1,3),
*    2          vectx(indi1,1),indi4
               read(cardDiret,'(7x,i3,45x,i5)') indi1,indi2
               read(cardDiret,1118)indi3,(xmtrix(indi1,1,j),j=1,3),
     2          vectx(indi1,1),indi4
               read(jhost,1118)indi3,(xmtrix(indi1,2,j),j=1,3),
     2          vectx(indi1,2),indi4
               read(jhost,1118)indi3,(xmtrix(indi1,3,j),j=1,3),
     2          vectx(indi1,3),indi4
               if(indi2.eq.1) imtrix=imtrix-1 
!
            case (12)  ! 'mode   ' card
!
            case (13)  ! 'endm  ' card
!
            case (14)  ! 'helix ' card
               read(cardDiret,1120) SpgString(1:1),i, SpgString(2:2),j
               nSecondary = nSecondary + 1
               nc = ichar('H')
               Secondary(nSecondary,1) = nc  ! "H" = helix, "E" = sheet
               Secondary(nSecondary,2) = i   ! initial residue number
               nc = ichar(SpgString(1:1))
               Secondary(nSecondary,3) = nc  ! initial residue chain
               Secondary(nSecondary,4) = j   ! final residue number
               nc = ichar(SpgString(2:2))
               Secondary(nSecondary,5) = nc  ! final residue chain
!
            case (15)  ! 'sheet ' card
               read(cardDiret,1130) SpgString(1:1),i, SpgString(2:2),j
               nSecondary = nSecondary + 1
               nc = ichar('E')
               Secondary(nSecondary,1) = nc  ! "H" = helix, "E" = sheet
               Secondary(nSecondary,2) = i   ! initial residue number
               nc = ichar(SpgString(1:1))
               Secondary(nSecondary,3) = nc  ! initial residue chain
               Secondary(nSecondary,4) = j   ! final residue number
               nc = ichar(SpgString(2:2))
               Secondary(nSecondary,5) = nc  ! final residue chain
!
!
            case (16)  ! 'end   ' card
               exit
!
         end select
!
      enddo
!
      if (AtomReady) then
          write(jgrap) xyzsS1, xyzsS2, xyzsS3, xyzsS4, xyzsS5,
     *                 nzS, 
     *                 bfacS6,
     *                 nomeAtomo,  ! tipo atomo
     *                 Alternate,  ! blank/A/B..
     *                 tipoRe,     ! tipo residuo
     *                 Catena,     ! catena
     *                 resSeq,     ! num. sequ. del residuo
     *                 insertion,  ! code for insertion of residues
     *                 LabelS,     ! label
     *                 aniso,      ! componenti anisotrope
     *                 HET,        ! 0/1 (ATOM/HETATM)
     *                 specieAtomo ! specie atomica
          AtomReady = .false.
      endif
!
      if (nSecondary > 0) then
          do i=1, nSecondary
             write(jgrap) Secondary(i,:)
          enddo
      endif
      if (ier < 0) then
          Msg = 'Problems reading PDB file.' // char(10) //
     *          'Line: ' //  cardDiret(1:Lung(cardDiret))
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, n)
      endif
!
*gl*  write(lo,2010) nats
*gl*  write(lo,2011) nResTot
*gl*  write(lo,2012) nChains, char(cChains(1:nChains))
!
      return
 1017 format(80a1)
 1018 format(10x,3f10.6)
 1019 format(6x,f5.0,1x,4a1,a1,a3,1x,a1,i4,a1,3x,3f8.3,2f6.2,6x,a4,2a2)
 1081 format(28x,6f7.0)
 1118 format(7x,i3,3f10.6,5x,f10.6,i5)
 1120 format(19x,a1,i5,6x,a1,i5)
 1130 format(21x,a1,i4,6x,a1,i4)
*gl* 2010 format(/,' - ',i6,' atom(s) stored')
*gl* 2011 format(  ' - ',i6,' residues')
*gl* 2012 format(  ' - ',i6,' chain(s): ',10(a,2x))
*gl* 2013 format(' -  Atoms in unit cell:')
*gl* 2014 format(6x,a4,i9)
      end
!-----------------------------------------------------------------------
      integer function KompareString (itestch, iargch, narg, iesatto) ! ex kcompch
!
!--standard comparision routine
!
!  itestch  charater vector holding the word(s) to be compared
!  iargch   character vector holding the words against which the
!           comparision is to be made
!  narg     number of standard character words to compare against
!  iesatto  = 0 leng 1o vettore puo' essere piu' grande
!             1 leng vettori devono identici
!
!-- on return KompareString holds the position of the find or else 0
!
!--
      character(*) itestch, iargch(narg)
!
      call shift(itestch,len1)
      if (len1 > 0) then
          do l=1,narg
             call shift(iargch(l),len2)
             if (len2 > 0) then
                 if (iesatto == 1) then
                     if (len1 /= len2) cycle
                 endif
                 if (len1 >= len2) then
                     if (itestch(1:len2) == iargch(l)(1:len2)) then
                         KompareString = l
                         return
                     endif
                 endif
             endif
          enddo
      endif
!
      KompareString = 0
!
      return
      end
!-----------------------------------------------------------------------
      subroutine StrippaDollaro
      USE General
!
      implicit none
      integer dollaro
!
      dollaro = 1
      do while (dollaro > 0)
         dollaro = index(cardImage, '$')
         if (dollaro > 0) then
             cardImage(dollaro:dollaro) = ' '
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      integer function LeggiNfloat(cardDiret, a, n)  ! ex jredf
c--read n floating point number
c
c--jredfnew is set as follows on return :
c
c  -1  hash function found or spurious character found
c   0  all the numbers read correctly
c   1  not all the number have been read
c
c--
      implicit none
      integer :: n, iopt, ivet(40), iv
      real    :: a(n), vet(40)
      character (len=*) cardDiret
!
      iopt = n
      a(1:n) = 0.0
      call getnum(cardDiret, vet, ivet, iv, iopt)
      if (iopt /= -1) then
          if (iv < n) then
              a(1:iv) = vet(1:iv)
              LeggiNfloat = 1
          else
              a(1:n) = vet(1:n)
              LeggiNfloat = 0
          endif
      else
          LeggiNfloat = -1
      endif
!
      return
      end
!-----------------------------------------------------------------------
!               SHELX general routines
!-----------------------------------------------------------------------
      subroutine LeggiShelxinMem(ifRefl, celltemp, nSymmCard, lattTemp, 
     *                           icentTemp, nats, wave, ier)
!
!--read file in **shelx program format**
!
      USE General
      USE Deprecato
      USE Symmetry
!
      integer :: KompareString, ifSfac, ivet(40)
      real    :: vet(40), xtemp(80), celltemp(13), FreeVar(1000)
      real    :: atomo(11), xwave(2)
      character (len= 1) :: charX
      character (len=16) :: LabelS
!
      common /shelx/ anomal(2,20),janomal(20),scfact(14,20),jscfact(20),
     *               nscfact(20), fnum(50), Csfac, Asfac
!
!--shelx directives
!
      character*4 ishe(81)
      data nshe/81/,xwave/0.71073,1.54178/
      data ishe/'titl', 'cell', 'zerr', 'latt', 'symm',
     2          'sfac', 'unit', 'fvar', 'affi', 'devi',
     4          'hkl ', 'wght', 'exti', 'omit', 'merg',
     5          'l.s.', 'fmed', 'plan', 'exyz', 'eadp',
     7          'sump', 'rem ', 'list', 'fmap', 'hklf',
     8          'mole', 'afix', 'dfix', 'bond', 'bloc',
     1          'anis', 'size', 'conf', 'eqiv', 'htab',
     2          'acta', 'dang', 'isor', 'resi', 'part',
     4          'disp', 'end ', 'bind', 'free', 'slim',
     6          'temp', 'wpdb', 'grid', 'hfix', 'rtab',
     7          'mpla', 'sadi', 'same', 'flat', 'chiv',
     9          'bump', 'conn', 'swat', 'delu', 'simu',
     *          'damp', 'defs', 'spec', 'shel', 'time',
     1          'more', 'laue', 'twin', 'basf', 'move',
     2          'cgls', 'frag', 'fend', 'tref', 'find',
     3          'weed', 'skip', 'ntpr', 'mfun', 'test',
     4          'plop'/
      data charX/'='/
!
      allocate(SymmCard(1:192), stat = ier)
!
      ifSfac = 0
      itype = 1
      iform = 2
      jop = jopen(jgrap,'  ',itype,iform,ier)
      if (jop < 0) then
          ier = -1
          return
      endif
!
      FreeVar(:) = 0.0
      iHKLF = 4
      ifRefl = 0
      nSymmCard = 1
      SymmCard(nSymmCard) = 'x,y,z'
      nats = 0
      Csfac=0.0
      Asfac=0.0
      idiffr=0
      WhichWave=1
      wave=xwave(WhichWave)
      nvar=0
      idev=0
      Bprevious=-1.0
      nk = 0
!
!--read the cards
!
      do while(ier == 0)
         call LeggiCardImageShift(ifUguale, ifEOF, ier)
         if (ifEOF < 0 .or. ier < 0) exit
         call lcase(cardImage)
!
         call cutst(cardImage,lenp,direttiva,lend)
         call lcase(direttiva)
         if (lend <= 0) cycle                   ! blank card
         n=KompareString(direttiva,ishe,nshe,0)
         if (n <= 0) then
             n = 1000
         endif
!
         select case (n)
!
            case (1)  !  'titl' directive
               if (ifFromShelx == 1) then
                   write(lo,10) cardDiret(1:Lung(cardDiret))
               endif
               Titolo = cardDiret(5:84)
!
            case (2)  !  'cell' directive
               if (ifFromShelx == 1) then
                   write(lo,10) cardDiret(1:Lung(cardDiret))
               endif
               iopt = 7
               call getnum(cardImage,xtemp,itemp,iv,iopt)
               if (iopt < 0) then
                   ier = -1
               else
                   wave= xtemp(1)
                   celltemp(1:6) = xtemp(2:7)
*                  if (InfoOK(1) == 0) then
*                      InfoOK(1) = 1
*                  endif
               endif
!
            case (3)  !  'zerr' directive
               if (ifFromShelx == 1) then
                   write(lo,10) cardDiret(1:Lung(cardDiret))
               endif
               iopt = 7
               call getnum(cardImage,xtemp,itemp,iv,iopt)
               if (iopt < 0) then
                   ier = -1
               else
                   celltemp(7:12) = xtemp(2:7)
                   celltemp(13) = 0.0
               endif
!
            case (4)  !  'latt' directive
               if (ifFromShelx == 1) then
                   write(lo,10) cardDiret(1:Lung(cardDiret))
               endif
               iopt = 1
               call getnum(cardImage,xtemp,itemp,iv,iopt)
               if (iopt < 0) then
                   ier = -1
               else
                   lattX = itemp(1)
                   if (lattX > 0) then
                       icentTemp = 1
                   else
                       icentTemp = 0
                       lattX = iabs(lattX)
                   endif
                   if (lattX == 1) then      ! primitive
                       lattTemp = 1
                   elseif (lattX == 2) then  ! I lattice
                       lattTemp = 5
                   elseif (lattX == 3) then  ! R lattice
                       lattTemp = 7
                   elseif (lattX == 4) then  ! F lattice
                       lattTemp = 6
                   elseif (lattX == 5) then  ! A lattice
                       lattTemp = 2
                   elseif (lattX == 6) then  ! B lattice
                       lattTemp = 3
                   elseif (lattX == 7) then  ! C lattice
                       lattTemp = 4
                   endif
               endif
!
            case (5)  !  'symm' directive 
               if (ifFromShelx == 1) then
                   write(lo,10) cardDiret(1:Lung(cardDiret))
               endif
               nSymmCard = nSymmCard + 1
               SymmCard(nSymmCard) = cardImage(1:80)
!
            case (6)  !  'sfac' directive! CONSIDERARE IL CASO DI SFAC NUMERICO e '='
               if (ifFromShelx == 1) then
                   write(lo,10) cardDiret(1:Lung(cardDiret))
               endif
               call StrippaDollaro
               if (ifUguale == 1) then
                   call PasteCardImage(ier)
               endif
               if (ier < 0) exit
               do i=1, 18
                  call cutst(cardImage,lenp,direttiva,lend)
                  nk = nk + 1
                  Species(nk) = direttiva(1:4)
                  if (lenp <= 0) then
                      exit
                  else
                      if (isADigit(cardImage(1:1)) == 0) then
                          cycle
                      else
                          iopt = 0
                          call getnum(cardImage,xtemp,itemp,iv,iopt)
                          if (iopt < 0) then
                              ier = -1
                          else
                              scfact(1:14, nk) = xtemp(1:14)
                              Csfac = Csfac + abs(scfact(9, nk))
                              Asfac = Asfac + abs(scfact(1, nk))
                              exit
                          endif
                      endif
                  endif
               enddo
!
            case (7)  !  'unit' directive
               if (ifFromShelx == 1) then
                   write(lo,10) cardDiret(1:Lung(cardDiret))
               endif
               IunitOK=1
               iopt = 0
               call getnum(cardImage,xtemp,itemp,iv,iopt)
               if (iopt < 0) then
                   ier = -1
               else
                   fnum(1:iv) = xtemp(1:iv)
               endif
!
            case (8)  !  'fvar' directive
               iopt = 0
               call getnum(cardImage,xtemp,itemp,iv,iopt)
               if (iopt < 0) then
                   ier = -1
               else
                   nvar = iv
                   FreeVar(1:nvar) = xtemp(1:nvar)
               endif
!
            case (9)  !  'affi' directive
!
            case (10)  ! 'devi' directive
!
            case (11)  ! 'hkl ' directive
               if (ifFromShelx == 1) then
                   write(lo,10) cardDiret(1:Lung(cardDiret))
               endif
               iopt = 1
               call getnum(cardImage, xtemp, itemp, iv, iopt)
               if (iopt < 0) then
                   ier = -1
               else
                   iHKLF = itemp(1)
                   call LeggiRiflessiShelx(ifRefl, iHKLF)
                   if (iHKLF /= 3 .and. iHKLF /= 4) then
                       write(Msg,2111) iHKLF
                       ier = -1
                   endif
               endif
!
            case (12)  ! 'wght' directive
!
            case (13)  ! 'exti' directive
!
            case (14)  ! 'omit' directive
!
            case (15)  ! 'merg' directive
!
            case (16)  ! 'l.s.' directive
!
            case (17)  ! 'fmed' directive
!
            case (18)  ! 'plan' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (19)  ! 'exyz' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (20)  ! 'eadp' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (21)  ! 'sump' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (22)  ! 'rem ' directive
!
            case (23)  ! 'list' directive
!
            case (24)  ! 'fmap' directive
!
            case (25)  ! 'hklf' directive
               if (ifFromShelx == 1) then
                   write(lo,10) cardDiret(1:Lung(cardDiret))
               endif
               iopt = 1
               call getnum(cardDiret, vet, ivet, iv, iopt)
               if (iopt < 0) then
                   ier = -1
               else
                   iHKLF = itemp(1)
                   call LeggiRiflessiShelx(ifRefl, iHKLF)
                   if (iHKLF /= 3 .and. iHKLF /= 4) then
                       write(Msg,2111) iHKLF
                       ier = -1
                   endif
               endif
!
            case (26)  ! 'mole' directive
!
            case (27)  ! 'afix' directive
!
            case (28)  ! 'dfix' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (29)  ! 'bond' directive
!
            case (30)  ! 'bloc' directive
!
            case (31)  ! 'anis' directive
!
            case (32)  ! 'size' directive
!
            case (33)  ! 'conf' directive
!
            case (34)  ! 'eqiv' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (35)  ! 'htab' directive
!
            case (36)  ! 'acta' directive
!
            case (37)  ! 'dang' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (38)  ! 'isor' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (39)  ! 'resi' directive
!
            case (40)  ! 'part' directive
!
            case (41)  ! 'disp' directive
!
            case (42)  ! 'end ' directive
               exit
!
            case (43)  ! 'bind' directive
!
            case (44)  ! 'free' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (45)  ! 'slim' directive
!
            case (46)  ! 'temp' directive
!
            case (47)  ! 'wpdb' directive
!
            case (48)  ! 'grid' directive
!
            case (49)  ! 'hfix' directive
!
            case (50)  ! 'rtab' directive
!
            case (51)  ! 'mpla' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (52)  ! 'sadi' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (53)  ! 'same' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (54)  ! 'flat' directive
!
            case (55)  ! 'chiv' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (56)  ! 'bump' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (57)  ! 'conn' directive
!
            case (58)  ! 'swat' directive
!
            case (59)  ! 'delu' directive
!
            case (60)  ! 'simu' directive
               if (ifUguale == 1)  then
                   call SkipCardImage(charX,ier)
               endif
!
            case (61)  ! 'damp' directive
!
            case (62)  ! 'defs' directive
!
            case (63)  ! 'spec' directive
!
            case (64)  ! 'shel' directive
!
            case (65)  ! 'time' directive
!
            case (66)  ! 'more' directive
!
            case (67)  ! 'laue' directive
!
            case (68)  ! 'twin' directive
!
            case (69)  ! 'basf' directive
!
            case (70)  ! 'move' directive
!
            case (71)  ! 'cgls' directive
!
            case (72)  ! 'frag' directive
!
            case (73)  ! 'fend' directive
!
            case (74)  ! 'tref' directive
!
            case (75,76,77,78,79,80,81)  ! 
!
            case (1000)  ! read the atomic parameters
!
               atomo(:) = 0.0
               call cutst(cardDiret,lenp,direttiva,lend)
               LabelS = direttiva
               if (ifUguale == 1) then
                   call PasteCardImage(ier)
                   if (ier < 0) exit
               endif
*gl*           call cutst(cardDiret,lenp,direttiva,lend)
*gl*           LabelS = direttiva
               iopt = 0
               call getnum(cardImage,xtemp,itemp,iv,iopt)
               if (iopt < 0) then
                   ier = -1
               else
                   nzS = itemp(1)
*                  atomo(1:11) = xtemp(2:12)
                   if (iv <= 3) then
                       atomo(1:3) = xtemp(2:4)
                       atomo(4) = 1.0
                       atomo(5) = 3.0
                   else
                       if (iv == 12) then
                           atomo(1:11) = xtemp(2:12)
                       else
                           atomo(1:5) = xtemp(2:6)
                       endif
                       do i=1, 11
                          a = atomo(i)
                          if (a > 9.99) then
                              ia = a
                              m = ia / 10
                              ia = m * 10
                              p = a - ia
                              if (m == 1) then
                                  atomo(i) = a - 10.0
                              else
                                  if (abs(p) < 5.0) then
                                      atomo(i) = p * FreeVar(m)
                                  endif
                              endif
                          endif
                       enddo

                       do i=11,6,-1
                          atomo(i) = atomo(i-1)
                       enddo
                       if (atomo(7) > 0.0) then
                           atomo(5) = 0.0
                       else
                           atomo(5) = atomo(5) * 8.0 * pi * pi
                           atomo(6:11) = 0.0
                       endif
                   endif
                   nats = nats + 1
                   write(jgrap) nzS, Labels, atomo(1:11), Species(nzS)
               endif
!
         end select
!
      enddo
!
      if (InfoOK(3) == 0 .and. QualePGM /= 5) then
          if (ifSfac == 1) then
              if (Csfac < 0.0001) neutro = 2  ! elettroni
              if (Asfac < 0.0001) neutro = 1  ! neutroni
          endif
          nw(1:nk) = nint(fnum(1:nk))
*         vSpecie(:) = Species(:)
*         k = WhichProps
*         call CreaAtmPropInfo(k, ier)
*         vSpecie(:) = Species(:)
*         call GetFromAtmStruct
      endif
      if (ier < 0) then
          Msg = 'Problems reading Shelx file.' // char(10) //
     *          'Line: ' //  cardDiret(1:Lung(cardDiret))
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, n)
      endif
      if (iHKLF.eq.3) then
          ifo2 = 1
      else
          ifo2 = 2
      endif
!
      return
   10 format(7x,a)
 2111 format(' Warning! card: HKLF n, n must equal 3 o 4, not',i5)
      end
!-----------------------------------------------------------------------
      subroutine LeggiCardImageShift(ifUguale, ifEOF, ier)
      USE General
!
      implicit none
      integer ifUguale, k, ifEOF, ier, ll
!
      ifEOF = 0
      read(jhost, '(a)', end=100, err=200) cardImage
      call filtra(cardImage)
      call shift(cardImage,ll)
      cardDiret = cardImage
!
!--check the '=' character
!  ifUguale = 1  character '=' is in the string
!             0  character '=' is NOT in the string
      ifUguale = 0
      k = index(cardImage, '=')
      if (k > 0) ifUguale = 1
!
      return
!
  100 ifEOF = -1
      return
!
  200 ier = -1
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiCardImage(ifUguale, ifEOF, ier)
      USE General
!
      implicit none
      integer ifUguale, k, ifEOF, ier
!
      ifEOF = 0
      read(jhost, '(a)', end=100, err=200) cardImage
      call filtra(cardImage)
      cardDiret = cardImage
!
!--check the '=' character
!  ifUguale = 1  character '=' is in the string
!             0  character '=' is NOT in the string
      ifUguale = 0
      k = index(cardImage, '=')
      if (k > 0) ifUguale = 1
!
      return
!
  100 ifEOF = -1
      return
!
  200 ier = -1
      return
      end
!-----------------------------------------------------------------------
      subroutine SkipCardImage(charX,ier)
      USE General
!
      implicit none
      integer ifUguale, ier
      character*(*) charX
!
      ifUguale = 1
      do while (ifUguale > 0)
         read(jhost, '(a)', err=100, end=100) cardImage
         call lcase(cardImage)
         ifUguale = index(cardImage, charX)
      enddo
!
      return
!
  100 ier = -1
      return
      end
!-----------------------------------------------------------------------
      subroutine SkipCardImageNO(charX,ier)
      USE General
!
      implicit none
      integer ifUguale, ier
      character*(*) charX
!
      ifUguale = 0
      do while (ifUguale == 0)
         read(jhost, '(a)', err=100, end=100) cardImage
         call lcase(cardImage)
         ifUguale = index(cardImage, charX)
      enddo
!
      return
!
  100 ier = -1
      return
      end
!-----------------------------------------------------------------------
      subroutine PasteCardImage(ier)
      USE General
!
      implicit none
      integer ifUguale, ifEOF, ier, L1, L2, Lung
!
      call lcase(cardImage)
      call OneBlankOnly(cardImage)
      L1 = Lung(cardImage)
      direttiva = cardImage(1:L1-1)
      call LeggiCardImage(ifUguale, ifEOF, ier)
      if (ifEOF < 0 .or. ier < 0) then
          ier = -1
          return
      endif
      call OneBlankOnly(cardImage)
      L2 = Lung(cardImage)
      cardDiret = cardImage
      cardImage = direttiva(1:L1) // ' ' // cardDiret(1:L2)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiRiflessiShelx(ifRefl, iHKLF)
      USE General
!
      if (iHKLF < 0) then
          iHKLF = -iHKLF
          if (iHKLF == 3 .or. iHKLF == 4 .and. InfoOK(6) == 0) then
              ReflFileName = 'tmp_shelx_refl_file.hkl'
              ReflFileForm = '(3i4,2f12.4,f7.2)'
              itype = 0
              iform = 1
              jop = jopen(iscra, ReflFileName, itype, iform, ier)
              do
                 read(jhost,'(3i4,2f8.2)',end=10) kh,kk,kl,fob,sfob
                 if (kh == 0 .and. kk == 0 .and. kl == 0) exit
                 write(iscra,'(3i4,2f8.2)') kh,kk,kl,fob,sfob
              enddo
   10         continue
              close(iscra)
              ifRefl = 1
          endif
      endif
!
      return
      end

!-----------------------------------------------------------------------
      integer function kRes(name, ElementSymbol)
!
      implicit none
      character *(*)  name, ElementSymbol
      integer kResiduo
!
      kRes = kResiduo(name // char(0), ElementSymbol // char(0))
      return
      end
