#include <utils.h>
#include <fftw3.h>
#include <gtkmrcomune.h>
#include <gtkdefs.h>

extern "C" _args *args;
extern _Dialogo *dialogo;

static float c_factor = 257.f;
static int redmax   = 255;
static int greenmax = 255;
static int bluemax  = 255; 
static int    *finestra;
static int    puntatore;
static unsigned char   *fbuffer;

GdkColor *get_colorgdk(int new_color);
std::string main_dir();

int initGraphics();
char stringbar[MAX_LEN];
GdkPoint stella[11] = {{7,1},{9,6},{13,6},{9,9},{12,14},{7,12},{2,14},{5,9},{1,6},{5,6},{7,7}};

_drawarea    *DrawingArea = NULL;
GtkWidget    *MainWindow;

extern "C" WindoMess windomess_;
WindoMess *winmess = &windomess_;

PangoFontDescription *fontdescP, *fontdescN, *fontdescU, *fontnew;
int ifProportional = 0;
int ifHidden = 0;
int mainloop = 0;
int jscreen = 0;
gboolean single_it = TRUE;
gchar *Specie[NUMSPECIES];
gchar *Sigle[NUMSPECIES];
int   nw[NUMSPECIES];
int   no[NUMSPECIES];
int nSpec = 0;

int Ascent,Descent, larSaveP, larSaveN, altSaveP, altSaveN;
extern "C" int kridisegna_(int *w, int *h, int *i);

int MainLoop(_drawarea *DrawingArea, int flag);
GtkWidget* open_window (int WINDWID, int WINDHEI, const char *title, _drawarea *da);
void CloseWindow(int *jscreen, int mainloop, _drawarea *da, int col);
void PrimoParametro(char *string);
void SecondoParametro(char *string);

//    Gestione vettori e matrici allocabili dinamicamente 

int         nElemVett;
_matrice    ipixLab;
_matrice    ipix;
stringa     *It;
int         *ifLabelsVis;
int         *nzTot;
int         *SinglePlotStyle;
int         *iSite;

int gMatrice(_matrice Matrice, int i, int j)
{
     return (Matrice.values[i+j*Matrice.nrighe]);
}

void pMatrice(_matrice Matrice, int i, int j, int val)
{
     Matrice.values[i+j*Matrice.nrighe] = val;
}
    
#ifdef __cplusplus
extern "C" {
#endif

#if 0
void sfftw_executec_(fftwf_plan *p)
{
     fftwf_execute(*p);
}

fftwf_plan sfftw_plan_dft_c2r_3dc_(int *n1, int *n2, int *n3, fftwf_complex *xmapC, float *xmap, int *f)
{
     return fftwf_plan_dft_c2r_3d(*n3, *n2, *n1, xmapC,xmap, *f);
}

fftwf_plan sfftw_plan_dft_r2c_3dc_(int *n1, int *n2, int *n3, float *xmap, fftwf_complex *xmapC, int *f)
{
     return fftwf_plan_dft_r2c_3d(*n3, *n2, *n1, xmap,xmapC, *f);
}

void sfftw_destroy_planc_(fftwf_plan *p)
{
     fftwf_destroy_plan(*p);
}

fftwf_plan sfftw_plan_dft_r2c_1dc_(int *n1, float *vInp, fftwf_complex *vOut, int *f)
{
     return fftwf_plan_dft_r2c_1d(*n1, vInp, vOut, *f);
}
#endif

void put_vett_int_(int localvet[], int *indice, int *nelems)
{
    int ind = *indice;
    nElemVett = *nelems;
    switch(ind)
    {
    case 1:
         ifLabelsVis = localvet;
         break;
    case 2:
         SinglePlotStyle = localvet;
         break;
    case 3:
         nzTot = localvet;
         break;
    case 4:
         iSite = localvet;
         break;
    default:
        break;
    }
}

void put_matrice_(int localvet[], int *indice, int *righe, int *colonne)
{
    int ind = *indice;
    switch(ind)
    {
    case 1:
         ipix.nrighe = *righe;
         ipix.ncolonne = *colonne;
         ipix.values = localvet;
        break;
    case 2:
         ipixLab.nrighe = *righe;
         ipixLab.ncolonne = *colonne;
         ipixLab.values = localvet;
        break;
    }

}
void put_vett_str_ (stringa localstr[], int *)
{
	It = localstr;
}

#ifdef __cplusplus
}
#endif

typedef struct {
                  gpointer  reg;
                  char      *lab;
               } _InfoReg;

gpointer getCurrentContext()
{
     if(!DrawingArea)
        return NULL;
     return g_object_get_data(G_OBJECT(
             gtk_widget_get_toplevel(DrawingArea->widget)), "currentContext");
}

gpointer getCurrentPix()
{
     if(!DrawingArea)
        return NULL;
     return g_object_get_data(G_OBJECT(
             gtk_widget_get_toplevel(DrawingArea->widget)), "currentPixmap");
}

gpointer getCurrentWindow()
{
     if(!DrawingArea)
        return NULL;
     return  (GObject *) g_object_get_data(G_OBJECT(
             gtk_widget_get_toplevel(DrawingArea->widget)), "currentWindow");
}

gboolean ManageExpose (GtkWidget *widget, gpointer obj, gpointer )
{
    gpointer pix = get_object(widget, "offscreen");

#ifdef IN_GTK3
    cairo_surface_t *image = (cairo_surface_t *)pix;
    cairo_set_source_surface ((cairo_t *) obj, image, 0, 0);
    cairo_paint ((cairo_t *) obj);
#else
    gpointer context = get_object(widget, "context");
    GdkEventExpose *event = ( GdkEventExpose * ) obj;
    if(event->count > 1)
       return TRUE;
    draw_drawable(gtk_widget_get_window(widget),
                  context,
                  pix,
                  event->area.x, event->area.y,
                  0, 0,
                  event->area.width, event->area.height);
#endif
  return FALSE;
}

float *FromIndexToCol(int new_color)
{
     GdkColor *gdkcolor = get_colorgdk(new_color);
     float *col = g_new0(float, 4);
     col[0] = (float) gdkcolor->red   / 65535.f;
     col[1] = (float) gdkcolor->green / 65535.f;
     col[2] = (float) gdkcolor->blue  / 65535.f;
     col[3] = 1.f;
     g_free(gdkcolor);
     return col;
}

static gpointer barra(int x1, int y1, int w, int h, int iColor)
{
     GdkRectangle rect;
     gpointer region;
     gpointer outPix = getCurrentPix();
     gpointer context = getCurrentContext();

     rect.x      = x1;
     rect.y      = y1;
     rect.width  = w;
     rect.height = h;

     setta_foreground( iColor, context);
     draw_rectangle2(outPix, context, TRUE, x1, y1, w, h, FromIndexToCol(iColor));
     region = region_rectangle(&rect);
     return region;
}

extern "C" int c_saveas_(char *filt)
{
using namespace gtkext;
     if(!jscreen)
        return 0;
     GtkWidget *w = gtk_widget_get_toplevel(DrawingArea->widget);
     std::string filter = "*.";
     filter.append(g_strstrip(filt));
     FilselItem local_item = saveas(w, filter.c_str(), dialogo->FileNameMod);
     if(local_item.exitCode > 0)
     {
       std::string file = local_item.cwd;
       file.append(str_cut(local_item.fileinp, "."));
       file.append(".");
       file.append(filt);
       CopiaStringa(dialogo->FileNameMod, 256, file.c_str());
       return 1;
     }
     return 0;
}

void PrintScreen(GtkWidget *, gpointer )
{
using namespace gtkext;
     GtkWidget *w = gtk_widget_get_toplevel(DrawingArea->widget);
     GdkPixbuf *dest=NULL, *pixb;
     GError *error = NULL;
     gtkext::FilselItem local_item;

     std::string curdir = getPWD();
     local_item = saveas(w, "*.png", NULL);
     dir_set_current(curdir.c_str());
     if(local_item.exitCode > 0)
     {
       std::string pngfile = local_item.cwd;
       std::string fn = local_item.fileinp;
       std::vector<std::string> exts;
       exts.push_back("png");
       int k = find_extension_in_list(fn, exts);
       if(k == -1)
          return;
       pngfile.append(fn);
       os_and_gc *rt = g_new0(os_and_gc, 1);
       rt->os = getCurrentPix();
       rt->gc = getCurrentWindow();
       pixb = (GdkPixbuf *)pixbuf_get_from_struct (rt);
//

       if(pixb != NULL)
       {
          if(local_item.ifAlpha)
          {
            if(dialogo->jBackGround)

               dest = gdk_pixbuf_add_alpha(pixb, TRUE, 255, 255, 255);
            else
               dest = gdk_pixbuf_add_alpha(pixb, TRUE, 0, 0, 0);
          }
          else
               dest = gdk_pixbuf_copy(pixb);
          g_object_unref(G_OBJECT(pixb));
       }
       if(dest != NULL)
         gdk_pixbuf_save (dest, toUTF8(pngfile.c_str()), "png", &error, NULL);
     }
}

void string_to_vector (char *string, char* vecstr[])
{
   if(strlen(string) > 0)
   {
       GList *lista = fill_list(string, "@");
       if(lista)
       {
          int nsc = (int) g_list_length(lista);
          int i;
          for(i=0; i<nsc; i++)
          {
              char *pstr = (char *)g_list_nth_data(lista, i);
              int l1 = (int) strlen(g_strstrip(pstr));
              size_t sz = l1 + 1;
              vecstr[i] = g_new0(char, sz);
              CopiaStringa(vecstr[i], sz, g_strstrip(pstr));
              g_free(pstr);
          }
          g_list_free(lista);
       }
    }
}

void dashed_line (int ix1, int iy1, int ix2, int iy2)
{
      double tratto, x1, y1, x2, y2, dist, dx, dy, 
          xm, alfa, seno, coseno;
      int i, j, xrb, yrb, tratti;
      gpointer outPix = getCurrentPix();
      gpointer context = getCurrentContext();

      tratto = 6.0;
      x1 = (double) ix1;
      x2 = (double) ix2;
      y1 = (double) iy1;
      y2 = (double) iy2;
      dx = x2 - x1;
      dy = y2 - y1;

      dist = sqrt(dx*dx + dy*dy); 
      if(dist > 0.1) 
      {
         alfa = atan2(y2-y1, x2-x1);
         coseno = cos(alfa);
         seno = sin(alfa);

	  tratti = (int) (dist / tratto);
         xm = 0;
         for(i=0; i<tratti; i+=2)
         {
             for(j=1; j<=(int)(tratto/2.); j++)
             {
                 xrb = (int) (x1 + xm * coseno);
                 yrb = (int) (y1 + xm * seno);
                 draw_point( outPix, context, xrb, yrb );
                 xm++;
             }
             xm += 1.5*tratto;
         } 
      }
}

void dashed_rectangle (int ix, int iy, int w, int h)
{
     int x, y;
     gpointer outWindow = getCurrentWindow();
//     gpointer context = getCurrentContext();
//F25     gpointer context = get_context(outWindow);
     gpointer context;
#if (GTK_MAJOR_VERSION > 2) && (GTK_MINOR_VERSION >= 22)
       GdkRectangle rect;
       rect.width= gdk_window_get_width (GDK_WINDOW(outWindow));
       rect.height = gdk_window_get_height (GDK_WINDOW(outWindow));
       gdk_window_get_position (GDK_WINDOW(outWindow), &rect.x, &rect.y);
       cairo_region_t *reg = (cairo_region_t *)region_rectangle(&rect);
       GdkDrawingContext *dc = gdk_window_begin_draw_frame
           (GDK_WINDOW(outWindow), reg);
       cairo_t *tgc = gdk_drawing_context_get_cairo_context(dc);
       context = (gpointer)tgc;
#elif defined(USE_CAIRO)
       cairo_t *cr;
       cr =  gdk_cairo_create((GdkWindow *)outWindow);
       cairo_set_line_width(cr, 1.0);
       context = (gpointer) cr;
#else
       context = (gpointer)gdk_gc_new((GdkDrawable *)outWindow);
#endif


     for(x=ix; x<ix+w; x+=10)
     {
         draw_line( outWindow, context, x, iy, x+3, iy);
         draw_line( outWindow, context, x, iy+h-1, x+3, iy+h-1);
     }

     for(y=iy; y<iy+h; y+=10)
     {
         draw_line( outWindow, context, ix, y, ix, y+3);
         draw_line( outWindow, context, ix+w-1, y, ix+w-1, y+3);
     }
}

void dashed_circle (int ix, int iy, int ir)
{
     int x, x2, y, r2;
     gpointer outPix = getCurrentPix();
     gpointer context = getCurrentContext();

     r2 = ir*ir;
     for(x=0; x<=ir; x+=5)
     {
         x2 = x * x;
         y = (int)( sqrt((double)(r2 - x2)) + 0.5);
         draw_point( outPix, context, ix-x, iy+y );
         draw_point( outPix, context, ix+x, iy+y );
         draw_point( outPix, context, ix-x, iy-y );
         draw_point( outPix, context, ix+x, iy-y );
     }
     for(y=0; y<=ir; y+=5)
     {
         x2 = y * y;
         x = (int)( sqrt((double)(r2 - x2)) + 0.5);
         draw_point( outPix, context, ix+x, iy-y );
         draw_point( outPix, context, ix+x, iy+y );
         draw_point( outPix, context, ix-x, iy-y );
         draw_point( outPix, context, ix-x, iy+y );
     }

}

/*
void disegna_pixmap(GtkWidget *widget, gpointer winout, gpointer context,
                          gpointer mypixmap, int xb, int yb)
{
      int wi, he, xdest, ydest;

      drawable_get_size(mypixmap, &wi, &he);
      xdest = xb - wi / 2;
      ydest = yb - he / 2;
      draw_drawable(winout, context, mypixmap, xdest, ydest);
}
*/

void draw_stella(int dx, int dy, int ic, gpointer context, gpointer outPix)
{
      int i;
      GdkPoint pstella[10];

      dx -= stella[10].x;
      dy -= stella[10].y;
      
      for(i=0; i<10; i++)
      {
          pstella[i].x = stella[i].x+dx;
          pstella[i].y = stella[i].y+dy;
      }
      GdkColor *gdkcolor = get_colorgdk(DrawingArea->backGround);
      set_foreground( context, gdkcolor);
      draw_polygon( outPix, context, TRUE, pstella, 10 );
      setta_foreground( ic, context);
      draw_polygon( outPix, context, FALSE, pstella, 10 );
      g_free(gdkcolor);
}

void print_mess(const char *riga)
{
    GtkWidget *statusbar = lookup_widget(MainWindow, "statusbar");
    CopiaStringa(stringbar,sizeof(stringbar), riga);

    gtk_statusbar_pop(GTK_STATUSBAR(statusbar), 1);
    (void) gtk_statusbar_push(GTK_STATUSBAR(statusbar), 1,toUTF8(riga));
}

gpointer linea_spessa (int x1, int y1, int x2, int y2, 
                 int spessore, gpointer context, GdkWindow *win, int iColor)
{
     GdkPoint xy[4];
     double m, m2, dx1, dy1;
     gpointer region = region_new();

     setta_foreground( iColor, context);
     if(MRabs(x2-x1) < 1.)
     {
        dx1 = spessore ;
        dy1 = 0;
     }
     else if(MRabs(y2 - y1) < 1.)
     {
        dx1 = 0;
        dy1 = spessore ;
     }
     else
     {
        m  = (x2 - x1) / (y2 - y1);
        m2 =  m * m + 1;
        dx1 =  spessore / sqrt(m2);
        dy1 =  - m * dx1 ;
     }
     xy[0].x = (int)(x1 - dx1);
     xy[1].x = (int)(x1 + dx1);
     xy[2].x = (int)(x2 + dx1);
     xy[3].x = (int)(x2 - dx1);
     xy[0].y = (int)(y1 - dy1);
     xy[1].y = (int)(y1 + dy1);
     xy[2].y = (int)(y2 + dy1);
     xy[3].y = (int)(y2 - dy1);
     draw_polygon( win, context, FALSE, xy, 4 );
//     gdk_region_union(region, gdk_region_polygon(xy, 4, GDK_EVEN_ODD_RULE));
     return region;
}

gpointer linea_shaded (int x1, int y1, int x2, int y2, 
                 double spessore, gpointer gc, GdkWindow *win, int iColor, GdkColor Colori[])
{
     GdkPoint xy[4];
     double m, m2, dx1, dy1;
     int i;
     gpointer region = region_new();
     guint16 red   = (guint16)(((double)Colori[iColor].red + 1.)/257.);
     guint16 green = (guint16)(((double)Colori[iColor].green + 1.)/257.);
     guint16 blue  = (guint16)(((double)Colori[iColor].blue + 1.)/257.);

      if(MRabs(y2-y1) != 0)
      {
         m  = (x2 - x1) / (y2 - y1);
         m2 =  m * m + 1;
      }
      for(i=(int)spessore; i>0;i--)
      {
          if(MRabs(x2-x1) == 0)
          {
             dx1 = i ;
             dy1 = 0;
          }
          else if(MRabs(y2-y1) == 0)
          {
             dx1 = 0;
             dy1 = i ;
          }
          else
          {
             dx1 =  i / sqrt(m2);
             dy1 =  - m * dx1 ;
          }
          xy[0].x = (int)(x1 - dx1);
          xy[1].x = (int)(x1 + dx1);
          xy[2].x = (int)(x2 + dx1);
          xy[3].x = (int)(x2 - dx1);
          xy[0].y = (int)(y1 - dy1);
          xy[1].y = (int)(y1 + dy1);
          xy[2].y = (int)(y2 + dy1);
          xy[3].y = (int)(y2 - dy1);
          float coef =  (float) ((spessore-i) / spessore);
          guint16 r1 =  (guint16) (65535 * MRblend(red,   255, coef, 0.9f)) /255;
          guint16 g1 =  (guint16) (65535 * MRblend(green, 255, coef, 0.9f)) /255;
          guint16 b1 =  (guint16) (65535 * MRblend(blue,  255, coef, 0.9f)) /255;
          GdkColor c1 = {0, r1, g1, b1};
          set_foreground(gc, &c1);
          draw_polygon( win, gc, TRUE, xy, 4 );
//          gdk_region_union(region, gdk_region_polygon(xy, 4, GDK_EVEN_ODD_RULE));
      }
     return region;
}

gpointer draw_bonds (int x1, int y1, int x2, int y2, double DLeg, 
                       gpointer gc, GdkWindow *win, int iColor, GdkColor Colori[])
{
     gpointer region = region_new();

     if(DLeg < 4.)
     {
//         gdk_region_union(region, linea_spessa (x1, y1, x2, y2, 1, gc, win, iColor));
         region = linea_spessa (x1, y1, x2, y2, 1, gc, win, iColor);
         return region;
     }
//     gdk_region_union(region, linea_shaded (x1, y1, x2, y2, DLeg,  gc, win, iColor, Colori));
     region = linea_shaded (x1, y1, x2, y2, DLeg,  gc, win, iColor, Colori);

     return region;
}

static int blend_rods(int fg, int bg, double fgfactor, double flim) 
{
    if(fgfactor <= flim)
       return (int) ((double)fg * (0.3 + 0.7*fgfactor / flim));
    return (int) ((double)fg * 0.95 + 
         0.05 * ((double)fg + (double)(bg - fg) * flim/fgfactor));

}

void palla_per_rods(int x, int y, int raggio, int iFC, int qAt)
{
      int g, gy;
      int j, i0, i, j2, i2, ix1, iy1,raggio2, oldquota;
      double distm, arg,rad, coef, qAtm, quota, quota0, flim;

      raggio2 = raggio*raggio;
      if (raggio < 1)
          raggio = 1;
      rad = (double) raggio;

      GdkColor *col = get_colorgdk(iFC);

      guint16 red   = (guint16)(((double)col->red   + 1.)/c_factor);
      guint16 green = (guint16)(((double)col->green + 1.)/c_factor);
      guint16 blue  = (guint16)(((double)col->blue  + 1.)/c_factor);
      g_free(col);
      flim = 0.99;

      distm = rad;
      
      if(distm < 0.5)
         distm = 1.;
       
       qAtm = (double)qAt;

       for(j = raggio; --j >= -raggio;)
       {
          j2 = j * j;
          i0 = (int)( sqrt((double)(raggio2 - j2)) + 0.5);
          ix1 = j + x + 1;
          g = ix1*DrawingArea->kscrx;
          for(i = -i0; i <= i0; i++)
          {
              i2 = i * i;
              iy1 = i + y + 1;

              if((ix1 >=0) && (ix1 < DrawingArea->kscrx) && (iy1 >=0) && (iy1 < DrawingArea->kscry))
              {
                  arg = (double) (raggio2 - i2 - j2);
                  if(arg > 0)
                  {
                     quota0 = sqrt(arg);
                     quota = qAtm +  sqrt(quota0);
                     gy = g + iy1;
                     oldquota = finestra[gy];
                     if((int)quota >= oldquota)
                     {
                        coef  = quota0/distm;
                        if(coef > 1)
                           coef = 1.;
                        finestra[gy] = (int)quota;
                        puntatore = STRIDE*ix1 + iy1*DrawingArea->kscrx*STRIDE;

                        fbuffer[puntatore]   = (unsigned char)
                          blend_rods((int)red,   redmax,   coef, flim);
                        fbuffer[puntatore+1] = (unsigned char)
                          blend_rods((int)green, greenmax, coef, flim);
                        fbuffer[puntatore+2] = (unsigned char)
                          blend_rods((int)blue,  bluemax,  coef, flim);
                     }
                  }
              }
          }
       }
}

void draw_rods (int ix1, int iy1, int ix2, int iy2, int ic1, int ic2, int diam,
                int iz1, int iz2, int nle1, int nle2)
{
      double pensize, x1, y1, x2, y2, dist, alfa, seno, coseno, step, 
          coef, dx2, xm, ym, pensize2, dist2, xrb, yrb, flim, emme,
          red, green, blue, distm, quota0, iniz, ifin;
      int dum, ico, xb, yb, z1, z2, oldquota, quota, qAtm, esci;


      esci = 0;
      pensize = (double) diam / 2 ;
      flim = 0.99;
      if(pensize < 1)
         pensize = 1;
      pensize2 = pensize*pensize;

      if(iz1 <= iz2)
      {
         x1 = (double) ix1;
         x2 = (double) ix2;
         y1 = (double) iy1;
         y2 = (double) iy2;
         z1 = iz1;
         z2 = iz2;
      }
      else
      {
         x1 = (double) ix2;
         x2 = (double) ix1;
         y1 = (double) iy2;
         y2 = (double) iy1;
         dum = ic1;
         ic1 = ic2;
         ic2 = dum;
         z2 = iz1;
         z1 = iz2;
         dum = nle1;
         nle1 = nle2;
         nle2 = dum;
      }

      dist = sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)); 

      iniz = -pensize;
      ifin = dist+pensize;

      if((nle2 < 2) && (dist < (pensize/2.)))
      {
         palla_per_rods((int)x2, (int)y2, diam/2, ic2, z2);
         esci = 1;
         if(x1 < x2)
            ifin = pensize;
         else
            iniz = dist-pensize;
      }

      if(!esci)
      {
         if(dist != 0)
            emme = (double)(z2-z1) / dist;
         else
            emme = 0;

         alfa = atan2(y2-y1, x2-x1);
         coseno = cos(alfa);
         seno = sin(alfa);
         step = 0.5;
         distm = pensize;

         for(xm=iniz; xm<=ifin; xm+=step)
         {
             xrb = x1 + xm * coseno;
             yrb = y1 + xm * seno;
             if(xm < 0)
                dist2 = pensize2 - xm*xm;
             else if(xm > dist)
                dist2 = pensize2 - (xm-dist)*(xm-dist);
             else 
                dist2 = pensize2;
             dx2 = pensize - sqrt(dist2);

             if(xm < dist/2)
                ico = ic1;
             else
                ico = ic2;

             GdkColor *col = get_colorgdk(ico);
          
             if(z1 != z2)
             {
                if((xm > 0) && (xm < dist))
                    qAtm = z1 + (int)(xm*emme);
                else if(xm <= 0)
                    qAtm = z1;
                else
                    qAtm = z2;
             }
             else
                qAtm = z1;

            for(ym=-pensize+dx2; ym<=pensize-dx2; ym+=step)
            {
                xb = (int)(xrb - ym*seno);
                yb = (int)(yrb + ym*coseno);
                if((xb >=0) && (xb < DrawingArea->kscrx) && (yb >=0) && (yb < DrawingArea->kscry))
                {
                    quota0 = sqrt(MRabs(dist2 - ym*ym));
  
                    quota = qAtm + (int) quota0;

                    oldquota = finestra[xb*DrawingArea->kscry+yb];
                    if(quota > oldquota)
                    {
                       coef  = quota0/distm;
                       if(coef > 1)
                          coef = 1.;
                       red   = ((double)col->red+1)/c_factor   ;
                       green = ((double)col->green+1)/c_factor ;
                       blue  = ((double)col->blue  +1)/c_factor;

                       finestra[xb*DrawingArea->kscry+yb] = quota;
                       puntatore = STRIDE*xb + STRIDE*yb*DrawingArea->kscrx;
                       fbuffer[puntatore]   = (unsigned char)
                             blend_rods((int)red,   redmax,   coef, flim);
                       fbuffer[puntatore+1] = (unsigned char)
                             blend_rods((int)green, greenmax, coef, flim);
                       fbuffer[puntatore+2] = (unsigned char)
                             blend_rods((int)blue,  bluemax,  coef, flim);
                    }
                 }
             }
             g_free(col);
         }
    }
}

void draw_dash (int ix1, int iy1, int ix2, int iy2, int ic1)
{
      double tratto, x1, y1, x2, y2, dist, dx, dy, xm, alfa, 
             flim, red, green, blue, coef, seno, coseno;
      int i, j, xrb, yrb, oldquota, tratti;
      GdkColor *cc = get_colorgdk(ic1);

      coef = 1.0;
      flim = 0.0;
      red   = ((double)cc->red  +1)/c_factor   ;
      green = ((double)cc->green+1)/c_factor ;
      blue  = ((double)cc->blue +1)/c_factor;
      tratto = 10.0;
      x1 = (double) ix1;
      x2 = (double) ix2;
      y1 = (double) iy1;
      y2 = (double) iy2;
      dx = x2 - x1;
      dy = y2 - y1;

      dist = sqrt(dx*dx + dy*dy); 
      if(dist > 0.1) 
      {
         alfa = atan2(y2-y1, x2-x1);
         coseno = cos(alfa);
         seno = sin(alfa);

	  tratti = (int) (dist / tratto);
         xm = 0;
         for(i=0; i<tratti; i+=2)
         {
             for(j=1; j<=(int)(tratto/2.); j++)
             {
                 xrb = (int) (0.5 + x1 + xm * coseno);
                 yrb = (int) (0.5 + y1 + xm * seno);
                 oldquota = finestra[xrb*DrawingArea->kscry+yrb];
                 if(oldquota == -1)
                 {

                   puntatore = STRIDE*xrb + STRIDE*yrb*DrawingArea->kscrx;
                   fbuffer[puntatore]   = (unsigned char)
                       MRblend((int)red,   redmax,   coef, flim);
                   fbuffer[puntatore+1] = (unsigned char)
                       MRblend((int)green, greenmax, coef, flim);
                   fbuffer[puntatore+2] = (unsigned char)
                       MRblend((int)blue,  bluemax,  coef, flim);

                 }
                 xm++;
             }
             xm += 1.5*tratto;
         } 
      }
}

void palla_per_vandervaals(int x, int y, int raggio, int iFC, 
                           int ixlux, int iylux, int qAt)
{
      int g, gy;
      int j, i0, i, j2, i2, ix1, iy1,raggio2, quota, oldquota;
      double dpunto, distm, arg,rad, coef, xlux, ylux, flim;

      raggio2 = raggio*raggio;
      rad = (double) raggio;
      xlux =  - (double)ixlux * rad / 100.;
      ylux = - (double)iylux * rad / 100.;  //tiene conto del sist. di rif. GDK
      distm = rad + sqrt(xlux*xlux+ylux*ylux);
      if(distm < 0.5)
         distm = 1.;

      GdkColor *col = get_colorgdk(iFC);

      
      flim = MRmax(1-10./distm, 0.75);

      guint16 red   = (guint16)(((double)col->red   + 1.)/c_factor);
      guint16 green = (guint16)(((double)col->green + 1.)/c_factor);
      guint16 blue  = (guint16)(((double)col->blue  + 1.)/c_factor);

       for(j = raggio; --j >= -raggio;)
       {
          j2 = j * j;
          i0 = (int)( sqrt((double)(raggio2 - j2)) + 0.5);
          j2 = (j - (int)xlux) * (j - (int)xlux);
          ix1 = j + x + 1;
          g = ix1*DrawingArea->kscry;
          for(i = -i0; i < i0; i++)
          {
              i2 = (i - (int)ylux) * (i - (int)ylux);
              dpunto = sqrt((double)(j2+i2));
              iy1 = i + y + 1;

              if((ix1 >=0) && (ix1 < DrawingArea->kscrx) && (iy1 >=0) && (iy1 < DrawingArea->kscry))
              {
                  arg = (double) (raggio2 - i*i - j*j);
                  if(arg > 0)
                  {
                     quota = qAt + (int) sqrt(arg);
                     gy = g + iy1;
                     oldquota = finestra[gy];
                     if(quota >= oldquota)
                     {
                        coef = 1-dpunto/distm;
                        finestra[gy] = quota;
                        puntatore = STRIDE*ix1 + iy1*DrawingArea->kscrx*STRIDE;

                        fbuffer[puntatore]   = (unsigned char)
                          MRblend(red,   redmax,   coef, flim);
                        fbuffer[puntatore+1] = (unsigned char)
                          MRblend(green, greenmax, coef, flim);
                        fbuffer[puntatore+2] = (unsigned char)
                          MRblend(blue,  bluemax,  coef, flim);
                     }
                  }
              }
          }
       }
}

extern "C" int gtkintf_(int xv[],int yv[], int *z, int *action, int *col , int *col1 , char *string)
{
  int iz, xlx, yly, start_xlx, start_yly, dx, dy, i, xb, yb, np, asc, ncil;
  float  pensize;
  double x1, y1, x2, y2, dx1, dy1, m, m2, d, sz;
  static GtkWidget *drawingarea;
  GdkPoint *points;
//  GdkPixmap *mypixmap;
  gpointer  mypixmap;
  GdkVisual *visual;
  gpointer outPix = getCurrentPix();
  gpointer outWindow = getCurrentWindow();
  gpointer context = getCurrentContext();
  GtkAllocation allocation = {0, 0, 1, 1};
  GdkColor *colore;
  if((*action >1) && (*action <999) && (context == NULL))
     return -1;

  iz = *z;
  switch(*action)
  {
  case 0:
       CloseWindow(&jscreen, mainloop, DrawingArea, *col);
       break;

  case 1:
       iz = initGraphics();
       if(iz)
       {
          *z = -1;
          return -1;
       }
       dialogo->color_BLACK        = colorBLACK;
       dialogo->color_BRIGHTWHITE  = colorBRIGHTWHITE;
       dialogo->color_WHITE        = colorWHITE;
       dialogo->color_GRAY         = colorGRAY;
       dialogo->color_BLUE         = colorBLUE;
       dialogo->color_GREEN        = colorGREEN;
       dialogo->color_CYAN         = colorCYAN;
       dialogo->color_RED          = colorRED;
       dialogo->color_MAGENTA      = colorMAGENTA;
       dialogo->color_BROWN        = colorBROWN;
       dialogo->color_LIGHTBLUE    = colorLIGHTBLUE;
       dialogo->color_LIGHTGREEN   = colorLIGHTGREEN;
       dialogo->color_LIGHTCYAN    = colorLIGHTCYAN;
       dialogo->color_LIGHTRED     = colorLIGHTRED;
       dialogo->color_LIGHTMAGENTA = colorLIGHTMAGENTA;
       dialogo->color_YELLOW       = colorYELLOW;
       dialogo->color_GHOST        = GHOST;
       dialogo->color_BONDS        = BONDS;
       dialogo->color_LABS         = LABS;
       dialogo->color_CELL         = CELLC;
       dialogo->color_RESTR        = RESTR;
       dialogo->NN_OBJS            = N_OBJS-1;
       dialogo->NToAdd             = N_OBJS+NUM_COLORS;
//       dialogo->jBackGround        = 1;
       dialogo->viewerOpened = FALSE;
       jscreen = 1;
       ifHidden = yv[1];
// FC25
       {
       GdkRectangle rect;
#if (GTK_MAJOR_VERSION > 2) && (GTK_MINOR_VERSION >= 22)
       GdkMonitor *mon = gdk_display_get_primary_monitor(gdk_display_get_default());
       gdk_monitor_get_geometry(mon, &rect);
#else
       GdkScreen *sc = gdk_screen_get_default();
       gdk_screen_get_monitor_geometry(sc, 0, &rect);
#endif
       int ww = rect.width;
       int hh = rect.height;
       if(xv[0] > (ww- 50))
          xv[0] = ww - 50;
       if(yv[0] > (hh - 50))
          yv[0] = hh - 50;

#if 0
// mr 090309
       if(xv[0] > (gdk_screen_width() - 50))
          xv[0] = gdk_screen_width() - 50;
       if(yv[0] > (gdk_screen_height() - 50))
          yv[0] = gdk_screen_height() - 50;
// end mr 090309
#endif
      }
//END FC25

//FC25 visual = gdk_visual_get_system();
       visual = gdk_screen_get_system_visual(gdk_screen_get_default());

       DrawingArea = g_new0(_drawarea, 1);
       if(strlen(string))
          MainWindow = open_window(xv[0],yv[0], string, DrawingArea);
       else 
          MainWindow = open_window(xv[0],yv[0], " ", DrawingArea);
       if(ifHidden)
          gtk_widget_hide (MainWindow);
       get_metrics(fontdescP, &larSaveP, &altSaveP);
       get_metrics(fontdescN, &larSaveN, &altSaveN);

       drawingarea = DrawingArea->widget;
       g_object_set_data(G_OBJECT(MainWindow), "currentWindow", DrawingArea->outWindow);
       if(drawingarea != NULL)
          gtk_widget_get_allocation(drawingarea, &allocation);

       xv[0]  = (int) allocation.width;  // larghezza area grafica 
       yv[0]  = (int) allocation.height; // altezza area grafica 
       xv[1]  =  larSaveP;                            // larghezza font 
       yv[1]  =  altSaveP;                            // altezza font 
       xv[2]  =  0;                                   // Ascent font  NOT USED  
       yv[2]  =  0;                                   // Descent font  NOT USED 
       xv[3]  =  2;                                   // Valore BackingStore 
       xv[4]  = xv[0];                                // Max larghezza area grafica 
       yv[4]  = yv[0];                                // Max altezza area grafica 
#if (GTK_MAJOR_VERSION == 2) && (GTK_MINOR_VERSION < 22)
       yv[5] = gdk_visual_get_bits_per_rgb(visual);
#else
       gdk_visual_get_blue_pixel_details(visual, NULL, NULL, &yv[5]);
#endif
       xv[6] = dialogo->ifLabels;
       xv[7] = dialogo->iPlotType;
       yv[7] = dialogo->jBackGround;

       ifProportional  = 1;
       break;

  case 2:                                //  draw point at x, y  
      xlx = xv[0];
      yly = yv[0];
      setta_foreground( *col, context);
      draw_point( outPix, context, xlx, yly );
      break;

  case 3:                                //  draw from x1, y1 to x2, y2 
      start_xlx = xv[0];
      start_yly = yv[0];
      xlx       = xv[1];
      yly       = yv[1];
      dx  = start_xlx - xlx;
      dy  = start_yly - yly;
      setta_foreground( *col, context);
      if (dx == 0 && dy == 0)
          draw_point( outPix, context,
                        xlx, yly );
       else
          draw_line( outPix, context,
                        xlx, yly, start_xlx, start_yly);
      break;

  case 4:         // draw from x1, y1 to x2, y2, color=*col, pensize=*col1, filled = *z
      pensize = (float) *col1 / 2;
      setta_foreground( *col, context);
      x1 = (double) xv[0];
      x2 = (double) xv[1];
      y1 = (double) yv[0];
      y2 = (double) yv[1];

      if(MRabs(x2-x1) < 1.)
      {
         dx1 = pensize ;
         dy1 = 0;
      }
      else if(MRabs(y2 - y1) < 1.)
      {
         dx1 = 0;
         dy1 = pensize ;
      }
      else
      {
         m  = (x2 - x1) / (y2 - y1);
         m2 =  m * m + 1;
         dx1 =  pensize / sqrt(m2);
         dy1 =  - m * pensize /  sqrt(m2) ;
      }
      points = g_new0(GdkPoint, 4);
      points[0].x = (int)(x1 - dx1);
      points[1].x = (int)(x1 + dx1);
      points[2].x = (int)(x2 + dx1);
      points[3].x = (int)(x2 - dx1);
      points[0].y = (int)(y1 - dy1);
      points[1].y = (int)(y1 + dy1);
      points[2].y = (int)(y2 + dy1);
      points[3].y = (int)(y2 - dy1);
      draw_polygon( outPix, context, iz, points, 4 );
      g_free(points);
      break;

  case 5:                    // Draw dash line from x1, y1 to x2, y2 
      start_xlx = xv[0];
      start_yly = yv[0];
      xlx       = xv[1];
      yly       = yv[1];
      dx  = start_xlx - xlx;
      dy  = start_yly - yly;
      setta_foreground( *col, context);
      if (dx == 0 && dy == 0)
          draw_point( outPix, context, xlx, yly );
      else
          dashed_line(start_xlx, start_yly, xlx, yly);
      break;

  case 6: 
      {
      pensize = (float) *z / 2 + 1;
      colore = get_colorgdk(*col);
      int red   = colore->red;
      int green = colore->green;
      int blue  = colore->blue;

      x1 = (double) xv[0];
      x2 = (double) xv[1];
      y1 = (double) yv[0];
      y2 = (double) yv[1];
      m = 1;
      m2 = 1;
      if(MRabs(yv[1]-yv[0]) != 0)
      {
         m  = (x2 - x1) / (y2 - y1);
         m2 =  m * m + 1;
      }
      for(i=(int)pensize; i>0;i--)
      {
          if(MRabs(xv[1]-xv[0]) == 0)
          {
             dx1 = i ;
             dy1 = 0;
          }
          else if(MRabs(yv[1] - yv[0]) == 0)
          {
             dx1 = 0;
             dy1 = i ;
          }
          else
          {
             dx1 =  i / sqrt(m2);
             dy1 =  - m * i /  sqrt(m2) ;
          }
          points = g_new0(GdkPoint, 4);
          points[0].x = (int)(x1 - dx1);
          points[1].x = (int)(x1 + dx1);
          points[2].x = (int)(x2 + dx1);
          points[3].x = (int)(x2 - dx1);
          points[0].y = (int)(y1 - dy1);
          points[1].y = (int)(y1 + dy1);
          points[2].y = (int)(y2 + dy1);
          points[3].y = (int)(y2 - dy1);
          float coef =  (float) (pensize-i) / pensize;
//          int r1 =  (int) (65535 * MRblend(red,   255, coef, 0.9f)) /255;
//          int g1 =  (int) (65535 * MRblend(green, 255, coef, 0.9f)) /255;
//          int b1 =  (int) (65535 * MRblend(blue,  255, coef, 0.9f)) /255;
          guint16 r1 =  (guint16) MRblend(red,   65535, coef, 0.9f);
          guint16 g1 =  (guint16) MRblend(green, 65535, coef, 0.9f);
          guint16 b1 =  (guint16) MRblend(blue,  65535, coef, 0.9f);
          GdkColor c1 = {0, r1, g1, b1};
          set_foreground ( context, &c1);
          draw_polygon( outPix, context, TRUE, points, 4 );
          g_free(points);
      }
      }
      break;

  case 7:            // clear screen 
      drawingarea = DrawingArea->widget;
      if(drawingarea != NULL)
         gtk_widget_get_allocation(drawingarea, &allocation);
      setta_foreground( *col, context);
      draw_rectangle (outPix, context, TRUE, 0,0,
                         (int)allocation.width,
                         (int)allocation.height);
      break;

  case 8:        // set foreground color to col  
      setta_foreground( *col, context);
      break;

  case 9:         //  draw string (z chars) in position x,y  
      yb = yv[0];
      xb = xv[0];
      fontnew  = pango_font_description_copy(fontdescP);
      sz = (double) pango_font_description_get_size(fontnew);
      switch (*z)
      {
      case 1:                // size small 
           pango_font_description_set_size (fontnew, (int) (0.66*sz));
           break;
      case 3:                // size big 
           pango_font_description_set_size (fontnew, (int) (1.5*sz));
           break;
      }

      colore = get_colorgdk(*col);
      if ( xb > 0 )
      {
         xb = xb + 50;
         draw_string(outPix, fontnew, context, xb, yb, string, colore, NULL);
      }
      else
      {
         xb = - xb + 50;
         draw_string(outPix, fontnew, context, xb, yb, string, colore, NULL);
         np=8;
         xb = xb - 30      ;
         asc = Ascent / 3;
         yb = yb - asc;
         points = g_new0(GdkPoint, 8);
         points[0].x = xb;
         points[0].y = yb+asc;
         points[1].x = xb+8;
         points[1].y = yb+asc;
         points[2].x = xb+8;
         points[2].y = yb+2*asc;
         points[3].x = xb+15;
         points[3].y = yb;
         points[4].x = xb+8;
         points[4].y = yb-2*asc;
         points[5].x = xb+8;
         points[5].y = yb-asc;
         points[6].x = xb;
         points[6].y = yb-asc;
         points[7].x = xb;
         points[7].y = yb+asc;
         draw_polygon( outPix, context, TRUE, points, np );
         g_free(points);
      }
      pango_font_description_free (fontnew);

      break;

  case 10:        // draw circle center in  x,y ,radius = z  
      yb = yv[0];
      xb = xv[0];
      iz = *z;
      setta_foreground( *col, context);
      draw_circle( outPix, context, FALSE, xb, yb, iz);
      break;

  case 11:        // fill circle center in  x,y ,radius = z  
      yb = yv[0];
      xb = xv[0];
      setta_foreground( *col1, context);
      draw_circle( outPix, context, TRUE, xb, yb, iz);
      if ( *col != *col1 )
      {
           setta_foreground( *col, context);
           draw_circle( outPix, context, FALSE, xb, yb, iz);
      }
      break;

  case 12:              // Draw dash circle, center in  x1, y1, radius = z 
      yb = yv[0];
      xb = xv[0];
      iz = *z;
      setta_foreground( *col, context);
      set_dash_style(context);
      draw_circle( outPix, context, FALSE, xb, yb, iz);
      reset_style(context);
      break;

  case 13:              // Draw dash arc, center in  x1, y1, radius = z 
      yb = yv[0];
      xb = xv[0];
      iz = *z;
      setta_foreground( *col, context);
      set_dash_style(context);
      draw_arc( outPix, context, FALSE,
                     xb, yb, iz, xv[1], yv[1] );
      reset_style(context);
      break;

  case 14:        // draw z-points polygon using color col  
      setta_foreground( *col, context);
      points = g_new0(GdkPoint, iz);
      for (np=0;np<*z;np++)
      {
         points[np].x = xv[np];
         points[np].y = yv[np];
      }
      draw_polygon( outPix, context, FALSE, points, iz );
      g_free(points);
      break;

  case 15:        // fill z-points polygon using color col  
      setta_foreground( *col, context);
      points = g_new0(GdkPoint, iz);
      for (np=0;np<*z;np++)
      {
         points[np].x = xv[np];
         points[np].y = yv[np];
      }
      draw_polygon( outPix, context, TRUE, points, iz );
      draw_polygon (outPix, context, FALSE, points, iz);
      g_free(points);
      break;

   case 16:                     // Connect iz points using color icol 
      setta_foreground( *col, context);
      points = g_new0(GdkPoint, iz);
      for (np=0;np<*z;np++)
      {
         points[np].x = xv[np];
         points[np].y = yv[np];
      }
      draw_lines( outPix, context, points, *z);
      g_free(points);
      break;

  case 17:        // Draw rectangle with col filled with col1 
      xb = xv[0];
      yb = yv[0];
      xlx = xv[1] - xv[0];
      yly = yv[1] - yv[0];
      if ( *col1  >= 0 )
      {
         setta_foreground( *col1, context);
         draw_rectangle(outPix, context, TRUE, xb+1, yb+1, xlx-1, yly-1 );
      }
      setta_foreground( *col, context);
      draw_rectangle(outPix, context, FALSE, xb, yb, xlx, yly );
      break;

  case 18:          // Store atomic species in static array
      if(*col1 == 0)
      {
          nSpec =  *col;
          string_to_vector (string, Specie);
      }
      else
      {
          for(i=0; i<nSpec; i++)
          {
              nw[i] = xv[i];
              no[i] = yv[i];
          }
          for(i=nSpec; i<NUMSPECIES; i++)
          {
              nw[i] = 0;
              no[i] = 0;
          }
          string_to_vector (string, Sigle);
      }    
      break;

  case 19:        // Draw a pixmap (string) centered in xb,yb 
      xb = xv[0];
      yb = yv[0];
//      mypixmap = mr_load_pixmap(drawingarea, string);
//      disegna_pixmap(drawingarea, outPix, context, mypixmap, xb, yb);
      mypixmap = create_initial_pix(string);
      if(mypixmap != NULL)
         disegna_pix(outPix, context, mypixmap, xb, yb);

      break;

  case 20:        // draw elliptic arc center in  x,y  
      yb = yv[0];
      xb = xv[0];
      setta_foreground( *col, context);
      draw_ell( outPix, context, FALSE,
                     xb, yb, xv[1], yv[1], xv[2], yv[2] );
      break;

  case 21:        // fill elliptic arc center in  x,y  
      yb = yv[0];
      xb = xv[0];
      setta_foreground( *col1, context);
      draw_ell( outPix, context, TRUE, xb, yb, xv[1], yv[1], xv[2], yv[2] );
      if ( *col != *col1 )
      {
          setta_foreground( *col, context);
          draw_ell( outPix, context, TRUE, xb, yb, xv[1], yv[1], xv[2], yv[2] );
      }
      break;

  case 22:              // Draw dash elliptic arc center in  x,y  
      yb = yv[0];
      xb = xv[0];
      setta_foreground( *col, context);
      set_dash_style(context);
      draw_ell( outPix, context, FALSE,
                     xb, yb, xv[1], yv[1], xv[2], yv[2] );
      reset_style(context);
      break;

  case 23:              // Fill arc, center in  x1, y1, radius = z 
      yb = yv[0];
      xb = xv[0];
      iz = *z;
      setta_foreground( *col, context);
      draw_arc( outPix, context, TRUE,
                     xb, yb, iz, xv[1], yv[1] );
      break;

  case 25:                 // Draw small spheres from x1, y1 to x2, y2 
      start_xlx = xv[0];
      start_yly = yv[0];
      xlx       = xv[1];
      yly       = yv[1];
      dx  = start_xlx - xlx;
      dy  = start_yly - yly;
      d = sqrt((double)(dx*dx) + (double)(dy*dy));
      setta_foreground( *col, context);
      if(d == 0)
      {
         draw_point( outPix, context, xlx, yly );
         return 0;
      }
      ncil = (int) (d / 12.);
      if(ncil == 0)
      {
         draw_circle( outPix, context, TRUE, xlx, yly, 6);
         return 0;
      }
      dx /= ncil;
      dy /= ncil;
      for(i=0; i<ncil; i++)
      {
         draw_circle( outPix, context, TRUE,
                     xlx, yly, 6);
         xlx += dx;
         yly += dy;
      }
      break;

  case 29:         //  draw vertical string (z chars) in position x,y  
                   //  xv[1] = -1 bottom aligned
                   //  xv[1] =  0 centre aligned
                   //  xv[1] =  1 top aligned
      yb = yv[0];
      xb = xv[0];
      fontnew  = pango_font_description_copy(fontdescP);
      sz = (double) pango_font_description_get_size(fontnew);
      switch (*z)
      {
      case 1:                // size small 
           pango_font_description_set_size (fontnew, (int) (0.66*sz));
           break;
      case 3:                // size big 
           pango_font_description_set_size (fontnew, (int) (1.5*sz));
           break;
      }

      colore = get_colorgdk(*col);
      if ( xb > 0 )
      {
         draw_Vstring(outPix, fontnew, context, xb, yb, string,
               colore, xv[1]);
      }
      pango_font_description_free (fontnew);
      break;

  case 30:
      if(*z == 1)
      {
         finestra = g_new0(int, DrawingArea->kscrx*DrawingArea->kscry);
         for(xb=0; xb<DrawingArea->kscrx*DrawingArea->kscry; xb++)
             finestra[xb] = -1;
         fbuffer = g_new0(guchar, STRIDE*DrawingArea->kscrx*DrawingArea->kscry+1); 
         for(xb=0; xb<STRIDE*DrawingArea->kscrx*DrawingArea->kscry; xb++)
             fbuffer[xb] = (unsigned char)(255*DrawingArea->backGround);
         puntatore = 0;
      }
      else
      {
         gpointer bb = draw_rgb_image (outPix, context, 0, 0, DrawingArea->kscrx, 
                         DrawingArea->kscry, fbuffer, STRIDE);
         g_free(finestra);
         g_free(bb);
         puntatore = 0;
      }
      break;

  case 31:
      if((xv[2] != 0) && (yv[2] != 0))
         palla_per_vandervaals(xv[0], yv[0], xv[1], *col, xv[2],  yv[2], yv[1]);
      else
         palla_per_rods(xv[0], yv[0], xv[1], *col,  yv[1]);
      break;

  case 32:
      if(*z >= 0)
         draw_rods (xv[0], yv[0], xv[1], yv[1], *col, *col1, *z, 
                    xv[2], xv[3], xv[5], xv[6]);
      else
         draw_dash (xv[0], yv[0], xv[1], yv[1], *col);
      break;
  case 33:        // Draw cross center in x,y with col, size = z 
      yb = yv[0];
      xb = xv[0];
      iz = *z;
      setta_foreground( *col, context);
      draw_line(outPix, context, xb-iz, yb, xb+iz, yb);
      draw_line(outPix, context, xb, yb-iz, xb, yb+iz);
      break;

  case 34:        // Draw cross center in x,y with col, size = z 
      yb = yv[0];
      xb = xv[0];
      iz = *z;
      setta_foreground( *col, context);
      draw_line(outPix, context, xb-iz, yb-iz, xb+iz, yb+iz);
      draw_line(outPix, context, xb-iz, yb+iz, xb+iz, yb-iz);
      break;

  case 40:                         //  draw star at x1, y1  
      dx = xv[0];
      dy = yv[0];
      draw_stella(dx, dy, *col, context, outPix);
      break;

   case 44:                     // change font 
      if ( *z  == 1 )
       {
           ifProportional  = 1;
           xv[0] = larSaveP ;
           yv[0] = altSaveP ;
       }
       else
       {
           ifProportional  = 0;
           xv[0] = larSaveN ;
           yv[0] = altSaveN ;
       }
       break;

   case 50:                    // Draw bar with hint using color icol 
      {
      gpointer region = barra(xv[0], yv[0], xv[1], yv[1], *col);
      int nreg = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(outWindow), "nreg"));
      nreg++;
      g_object_set_data(G_OBJECT(outWindow), "nreg", GINT_TO_POINTER(nreg));
      char nome[20];
      _InfoReg *InfoRegs = g_new0(_InfoReg , 1);
      ScriviStringa(nome, sizeof(nome), "reg%d", nreg - 1);
      InfoRegs->reg = region;
      int sz = (int) strlen(string) + 1;
      InfoRegs->lab = g_new0(char, sz);
      CopiaStringa(InfoRegs->lab, sz, string);
      g_object_set_data(G_OBJECT(outWindow), nome, InfoRegs);
      }
      break;

   case 70:
      i = xv[0];
      if ( ifProportional  == 1 )
           fontnew  = pango_font_description_copy(fontdescP);
      else
           fontnew  = pango_font_description_copy(fontdescN);
      sz = (double) pango_font_description_get_size(fontnew); 
      switch (i)
      {
      case 1:                // size small 
           pango_font_description_set_size (fontnew, (int) (0.66*sz));
           break;
      case 3:                // size big 
           pango_font_description_set_size (fontnew, (int) (1.5*sz));
           break;
      }
      xv[0] = gtkext::text_width(fontnew, string);
      pango_font_description_free (fontnew);
      break;

  case 80:                                // rings a bell  //Not used
      break;

  case 81:
      gtk_window_set_title (GTK_WINDOW(gtk_widget_get_toplevel(DrawingArea->widget)),
                   toUTF8(string));
      break;

   case 85:                     // enable/disable  single iteration

      if ( *z  == 0 )
            single_it = FALSE;
      else
            single_it = TRUE;
      break;

  case 86:
 
      while(gtk_events_pending())
         (void) gtk_main_iteration();
      break;


  case 90:         //  draw string (z chars) in position x,y  
      fontnew  = pango_font_description_copy(fontdescP);
      sz = (double) pango_font_description_get_size(fontnew);
      switch (*z)
      {
      case 1:                // size small 
           pango_font_description_set_size (fontnew, (int) (0.66*sz));
           break;
      case 3:                // size big 
           pango_font_description_set_size (fontnew, (int) (1.5*sz));
           break;
      }

      yb = yv[0]-altSaveP;
      xb = xv[0];
      colore = get_colorgdk(*col);
      draw_string(outPix, fontnew, context, xb, yb, string, colore, NULL);
      pango_font_description_free (fontnew);
      g_free(colore);

      break;


  case 999:
      if(!mainloop)
      {
         mainloop = 1;
         *z = MainLoop(DrawingArea, *col);
         mainloop = 0;
      }
      break;

  case 2000:                                   // first parameter 
      PrimoParametro(string);
      break;

  case 3000:                                   // second parameter 
      SecondoParametro(string);
      break;

  default:
      (void) printf("caso non gestito %d \n", *action);
     
  }
  return 0;
}

extern "C" void cflush_(void)
{
       if(!jscreen)
          return;
       //gpointer outPix = getCurrentPix();
       gpointer outWindow = getCurrentWindow();
       //gpointer context   = getCurrentContext();
       //flush_os(outPix, outWindow, context);
       gdk_window_invalidate_rect ((GdkWindow *)outWindow, NULL, FALSE);
}
     

extern "C" void crea_png_(char *pngfile)
{
    if(!jscreen)
       return;
    os_and_gc *rt = g_new0(os_and_gc, 1);
    
    rt->os = getCurrentPix();
    rt->gc = getCurrentWindow();
    save_pixbuf_from_mem(rt, pngfile);
    g_free(rt);
}

char *filtraperc(const gchar *msg)
{
    std::string str = msg;

    std::string::size_type pos = str.find_first_of('%');
    while (pos != std::string::npos)
    {
          str.insert(pos+1, "%");
          pos = str.find_first_of('%',pos+2);
    }
      return DuplicaStringa(str.c_str());
}

int cMsgWinErr(const char *cmsg, int type, int tempo, int def_answer)
{
   char *messaggio, *msgtot;
   int answer;

   size_t sz = strlen(cmsg) + 1;
   msgtot          = g_new0(char, sz);
   CopiaStringa(msgtot, sz, cmsg);
   sz = strlen(msgtot) + 50;
       
   messaggio = g_new0(char, sz);
   formatta_msg(messaggio, sz, msgtot, 40);
   g_free(msgtot);
   answer = 0;

   if((type < 0)  || !jscreen)
   {
        if(gtk_init_check(NULL, NULL))
        {
           GtkWidget *dialog = gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  "%s", messaggio);
           gtk_dialog_run (GTK_DIALOG (dialog));
           gtk_widget_destroy (dialog);
        }
        answer = 1;
   }
   else
   switch(type)
   {
   case SEVERE_ERR_WINDOW:
   case ERR_WINDOW:
        answer = MessageDialog(NULL, tempo, def_answer, MainWindow, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, filtraperc(messaggio));
        break;

   case WARN_WINDOW:
        answer = MessageDialog(NULL, tempo, def_answer, MainWindow, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK, filtraperc(messaggio));
        break;

   default:
   case INFO_WINDOW:
        answer = MessageDialog(NULL, tempo, def_answer, MainWindow, GTK_MESSAGE_INFO, GTK_BUTTONS_OK, filtraperc(messaggio));
        break;

   case QUEST_WINDOW:
   case QUEST_WINDOW_R:
        answer = MessageDialog(NULL, tempo, def_answer, MainWindow, GTK_MESSAGE_QUESTION, GTK_BUTTONS_OK_CANCEL, filtraperc(messaggio));
        if(answer == GTK_RESPONSE_OK)
           answer = 1;
        else
           answer = 2;
        break;

   case QUEST_WINDOW_YES_NO:
   case QUEST_WINDOW_NO_YES:
        answer = MessageDialog(NULL, tempo, def_answer, MainWindow, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO, filtraperc(messaggio));
        if(answer == GTK_RESPONSE_YES)
           answer = 1;
        else
           answer = 2;
        break;

   }
   g_free(messaggio);
   return answer;
}

extern "C" void msgwinerrc_ (char *, char *msg, int *tipo, int *exitC)
{   
    *exitC = cMsgWinErr(msg, *tipo);
}

extern "C" void get_mess_codes_(void)
{
     GetMessCodes(winmess);
}
extern "C" void msgwinc_ (char *inte, char *msg, int *, int *exitC)
{
    int ctempo;

    if(jscreen)
    {
       char *msgf = filtraperc(msg);
       ctempo = *exitC;

       MessageDialog(inte, ctempo, 0, MainWindow, GTK_MESSAGE_INFO, GTK_BUTTONS_CLOSE, msgf);
    }
}

extern "C" void msgwinc2_ (char *msg, int *tipo, int *def_r, int *exitC)
{
    int ctempo = *exitC;

    *exitC = cMsgWinErr(msg, *tipo, ctempo, *def_r);
}

extern "C" int c_barradistato_(int *, int *action, int *x , int *y , char *string)
{
  int xb, yb;
  float percentage;
  GtkWidget *progressbar;

  if(!jscreen)
     return 0;
  if(single_it)
     while(gtk_events_pending())
         (void) gtk_main_iteration();
  switch(*action)
  {
  case 1:        // Manage Progress Bar 
      xb = *x;
      yb = *y;
      percentage = (float) xb / (float) yb ;
      if(percentage >1.0) percentage = 1.0;
      if(percentage <0.0) percentage = 0.0;
      progressbar = lookup_widget(MainWindow, "progressbar");
//    g_print("x %d y %d\n", *x, *y);
      gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progressbar), percentage);   
//      gtk_widget_draw(progressbar, NULL);
      break;

  case 2:        // Show Progress Bar 
      progressbar = lookup_widget(MainWindow, "progressbar");
      gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progressbar), 0.0f);   
      gtk_widget_show(progressbar);
//      gtk_widget_draw(progressbar, NULL);
      break;

  case 3:        // Hide Progress Bar 
      progressbar = lookup_widget(MainWindow, "progressbar");
      gtk_widget_hide(progressbar);
      break;

  case 4:       // Message in the status bar 
      print_mess(string);
      break;

  }
  return 0;
}

typedef char card[780];

int get_options(card param, std::vector<std::string> &opt)
{
      int nopts = 0;
      bool start_opt = false;
      bool start_quote = false;
      int quote = 34;
      std::string arg;

      for(int j=0; j<(int)strlen(param); j++)
      {
          if((param[j] == '-') && !start_opt && !start_quote)
          {
             start_opt = true;
             if(!arg.empty())
             {
                opt.push_back(arg);
                nopts++;
             }
             arg.assign("-");
          }
          else if(param[j] == quote)
          {
             start_quote = !start_quote;
             start_opt = false;
          }
          else
          {
             arg.append(1,param[j]);
             start_opt = false;
          }
      }
      opt.push_back(arg);
      nopts++;
      return nopts;
}

extern "C" void startjav_(card *params, int *np)
{
      std::string msg;
      std::vector<std::string> args;
      std::vector<std::string> opt;
      std::string exe;
      if(!jscreen)
         return;
#ifdef _WIN32
#ifdef _DEBUG
      exe.assign(main_dir() + G_DIR_SEPARATOR_S + "jav_d");
#else
      exe.assign(main_dir() + G_DIR_SEPARATOR_S + "jav");
#endif
#else
      exe.assign(main_dir() + G_DIR_SEPARATOR_S + "jav");
#endif
      std::string file1;
      int nparam = *np;
      
      for(int i=0; i<nparam; i++)
      {
          if(!str_white(params[i]))
          {
             if(strstr(params[i], "-"))           // options
             {
                int nopts = get_options(params[i], opt);
                for(int j=0; j<nopts; j++)
                   args.push_back(opt[j]);
             }
             else                                 // Files
             {
                 if(!g_path_is_absolute(params[i]))
                 {
                    file1.assign(g_get_current_dir());
                    file1.append(G_DIR_SEPARATOR_S);
                    file1.append(params[i]);
                 }
                 else
                    file1.assign(params[i]);
                 args.push_back(toUTF8(file1.c_str()));
             }
          }
      }
      int result = run_command(exe, args, msg);
      if((result == -1) && !str_white(msg.c_str()))
        gtkext::dlg_errmsg(GTK_WINDOW(MainWindow), msg);
}

void setta_foreground(int new_color, gpointer context)
{
     GdkColor *gdkcolor = get_colorgdk(new_color);
     set_foreground(context, gdkcolor);
     g_free(gdkcolor);
}
 
extern "C" void c_getrgb_(int *indice, float rgb[3])
{
  GdkColor *gdkcolor = get_colorgdk(*indice);
  float *c = ToColor3f(gdkcolor);
  memcpy(rgb, c, 3*sizeof(float));
  g_free(c);
  g_free(gdkcolor);
}

extern "C" void profileplot_(int *nlim1, int *nlim2, int *iColor, int kpix[], int kpiy[])
{
   int npoints,np;
   if(!jscreen)
      return;
   gpointer outPix = getCurrentPix();
   gpointer context = getCurrentContext();

   npoints = -1;
//121210   points = g_new0(GdkPoint, (*nlim2 - *nlim1 + 2)*sizeof(GdkPoint));
   GdkPoint *points = g_new0(GdkPoint, (*nlim2 - *nlim1 + 2));
   for (np=*nlim1-1;np<*nlim2;np++)
   {
         npoints++;
         points[npoints].x = kpix[np];
         points[npoints].y = kpiy[np];
   }

   npoints++;
   setta_foreground(*iColor, context);
   draw_lines( outPix, context, points, npoints);
   g_free(points);
}

#ifdef _WIN32
#if WINVER >= 0x0602
#include <Processthreadsapi.h>
#endif
extern "C" void lanciash_(char *shell_script)
{
   if(jscreen)
   {
      PROCESS_INFORMATION procInfo = {0};
      STARTUPINFO startupInfo = {0};
      SECURITY_ATTRIBUTES saAttr = {0};
      HANDLE hStdIn  = GetStdHandle(STD_INPUT_HANDLE);
      HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
      HANDLE hStdErr = GetStdHandle(STD_ERROR_HANDLE);
      std::string commandline;

      dir_set_current(g_path_get_dirname(shell_script));
      ChangeMode(shell_script, tXt);
      saAttr.nLength = sizeof(saAttr);
      saAttr.bInheritHandle = TRUE;
      saAttr.lpSecurityDescriptor = NULL;

      startupInfo.cb = sizeof(startupInfo);
      startupInfo.dwFlags = STARTF_USESTDHANDLES |  STARTF_USESHOWWINDOW;
      startupInfo.hStdInput = hStdIn;
      startupInfo.hStdOutput = hStdOut;
      startupInfo.hStdError = hStdErr;
      startupInfo.wShowWindow = SW_HIDE;
      commandline.assign ("cmd.exe /c \"");
      commandline.append(g_path_get_basename(shell_script));
      commandline.append("\"");

      wchar_t cmd[256];
      size_t l;
      mbstowcs_s(&l,cmd, commandline.c_str(),256);
      LPWSTR p = cmd;

      BOOL rc = CreateProcess(NULL, p, NULL, &saAttr, FALSE, 0, NULL, NULL,
          &startupInfo, &procInfo);
      if(!rc)
      {
            g_warning( "CreateProcess failed (%d).\n", GetLastError());
         return;
      }
      WaitForSingleObject( procInfo.hProcess, INFINITE );
      CloseHandle( procInfo.hProcess );
      CloseHandle( procInfo.hThread );
      return;
   }
   GError *error=NULL;
   dir_set_current(g_path_get_dirname(shell_script));
   ChangeMode(shell_script, tXt);
   std::string commandline;
   commandline.assign(g_path_get_basename(shell_script));
   g_spawn_command_line_sync(commandline.c_str(), NULL, NULL, NULL, &error);
   if(error)
      g_warning ("Error spawning file: %s", error->message);
}
#else
extern "C" void lanciash_(char *shell_script)
{
      GError *error=NULL;
      dir_set_current(g_path_get_dirname(shell_script));
      ChangeMode(shell_script, tXt);
      std::string commandline;
      commandline.assign("./");
      commandline.append(g_path_get_basename(shell_script));
      g_spawn_command_line_sync(commandline.c_str(), NULL, NULL, NULL, &error);
      if(error)
         g_warning ("Error spawning file: %s", error->message);
}
#endif
