c----------------------------------------------------------
      subroutine readhist
   
      USE General
      USE Param
      character*4 car
      common/maphistograms/ vresl(50),vrmin(50),vrmax(50),vrave(50),
     +                   vrstd(50),hdata(200,50),nresl,nhist

      do 5 i=1,50
         vresl(i)=0.0
         vrmin(i)=0.0
         vrmax(i)=0.0
         vrave(i)=0.0
         vrstd(i)=0.0
         do 2 j=1,200
            hdata(j,i)=0.0
 2       continue
 5    continue

      open(60, file=histlib, status='old')

 10   format(a4,2i4)
 20   format(a4,18f7.2)
 30   format(a4,18f7.3)
 40   format(18f7.0)

      read(60,10) car,nresl,nhist
      read(60,20) car,(vresl(i),i=1,nresl)
      read(60,20) car,(vrmin(i),i=1,nresl)
      read(60,20) car,(vrmax(i),i=1,nresl)
      read(60,20) car,(vrave(i),i=1,nresl)
      read(60,20) car,(vrstd(i),i=1,nresl)
      read(60,10) car, ndum1,ndum2

      do 50 i=1,nhist
         read(60,40) (hdata(i,j),j=1,nresl)
 50   continue

      close(60)

      return
      end
c------------------------------------------------------------------------------
      subroutine HM_Flex(x,x1)

      USE General
      USE PhaseModule
      USE Param
      real x(*),x1(*)

      common/maphistograms/ vresl(50),vrmin(50),vrmax(50),vrave(50),
     +                   vrstd(50),hdata(200,50),nresl,nhist
      common/dada/ncol,ndim1,ndim2
      real hobs(200),hcal(200),hmod(200)
      real cobs(200),ccal(200),rtran(200)

      res1=0.5/sqrt(rhomax)
      rh=0.0
      srh=0.0
      srh2=0.0
 
      do 10 i=1,nhist
         hobs(i)=0.0
         hmod(i)=0.0
 10   continue

      do 20 ires=1,nresl
         if (vresl(ires).lt.res1) goto 30
 20   continue

 30   if (ires.eq.1) then
         ires=2
         dj=0.0
      elseif (ires.eq.nresl+1) then
         ires=nresl
         dj=1.0
      else
         dj=(res1-vresl(ires-1))/(vresl(ires)-vresl(ires-1))
      endif

*---- histograms interpolation

      do 40 i=1,nhist
         rcal=(i-0.5)*(vrmax(ires)-vrmin(ires))/
     +                real(nhist-1)+vrmin(ires)
         hcal(i)=(1.0-dj)*hdata(i,ires-1) + dj*hdata(i,ires)
         rh=rh+hcal(i)
         srh=srh+hcal(i)*rcal
         srh2=srh2+hcal(i)*rcal**2
 40   continue      

      rave=srh/rh
      rstd=sqrt(srh2*rh - srh**2)/rh
      rmax=vrmax(ires)
      rmin=vrmin(ires)
      dhr=(rmax-rmin)/real(nhist-1)

*---- Obs. Map histogram ----*
      call histprot(x,x1,nhist,hobs,rtot,dr,rmmin,srm1,sr2m1)
      rmav1=srm1/rtot
      rmstd1=sqrt(sr2m1*rtot - srm1**2)/rtot
      rmav1=rmav1/volume
      rmstd1=rmstd1/volume

      do 50 i=1,nhist
         hobs(i)=hobs(i)/rtot
         hcal(i)=hcal(i)/rh
 50   continue

      cobs(1)=0.0
      ccal(1)=0.0
      cobs(nhist)=1.0
      ccal(nhist)=1.0
      do 60 i=2,nhist-1
         cobs(i)=cobs(i-1)+hobs(i-1)
         ccal(i)=ccal(i-1)+hcal(i-1)
 60   continue

      dr=dr/volume
      rmmin=rmmin/volume
      do 90 i=1,nhist
         robs=(i-1)*dr+rmmin
         do 70 j=2,nhist-1
            if (ccal(j).ge.cobs(i)) goto 80
 70      continue
 80      rcal=(j-2+(cobs(i)-ccal(j-1))/amax1(ccal(j)-ccal(j-1),1.0e-6))
     +        *dhr+rmin
         rtran(i)=rcal*volume
 90   continue

*---- modificare la mappa
      dr=dr*volume
      rmmin=rmmin*volume
      dhr1=dhr*volume
      rmin2=rmin*volume
      call histtran(x,x1,nhist,rtran,dr,rmmin,hmod,rmin2,dhr1,
     +              rhm,srm,sr2m)
      rmav=srm/rhm
      rmstd=sqrt(sr2m*rhm - srm**2)/rhm
      rmav=rmav/volume
      rmstd=rmstd/volume
      do 100 i=1,nhist
       hmod(i)=hmod(i)/rtot
 100  continue
*--
      if (knw == 1 .and. kverboCow == 1) then
          write (lo,850)
          write (lo,860)vresl(ires-1),vresl(ires),1.0-dj,dj
          write (lo,870)rmav1,rmstd1,rave,rstd,rmav,rmstd
          if (kverbo==4) then
            write (lo,880)
          endif
      endif
 850  format (/'  Map Histogram Matching:')
 860  format ('  Histograms chosen: resolution =',2f5.2,' A'
     +       /'                        weights =',2f5.2)
 870  format ('  <rho_obs>,std     ',2f7.3,/
     *       ,'  <rho_calc>,std    ',2f7.3,/
     *       ,'  <rho_mod> ,std    ',2f7.3)
 880  format (/,5x,'RHO',6x,'P(Counts)',6x,'RHO',11x,'P(Counts)',/,
     +        13x,'(Observed)', 12x,'(Calculated) (Transformed)')
      dr=dr/volume
      rmmin=rmmin/volume
      if (kverbo==4) then
       do 900 i=1,nhist,nhist/10
         r1=(i-1)*dr +rmmin
         r =(i-1)*dhr+rmin
         write (lo,890)r1,hobs(i),r,hcal(i),hmod(i)
 890   format (1x,f9.3,2x,f10.6,3x,f9.3,2(2x,f10.6))
 900   continue
      endif
c
      return
      end

c ----------------------------------------------------------------------
c
      subroutine histprot(x,x1,nhist,hobs,rtot,dr,rmmin,sr,sr2)

      USE Mappa
      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))

      real hobs(200)

      nx=np(1)
      ny=np(2)
      nz=np(3)

      nt=0
      sr=0.0
      sr2=0.0
      rmmax=-1.0e10
      rmmin= 1.0e10


      do 150 ky=1,ny
        do 100 kz=1,nz
            do 50 kx=1,nx
               xx=x(kx,ky,kz)
               ixx1=nint(x1(kx,ky,kz))
               if (ixx1.eq.100) then
                  nt=nt+1
                  sr=sr+xx
                  sr2=sr2+xx**2
                  rmmax=amax1(rmmax,xx)
                  rmmin=amin1(rmmin,xx)
               endif
 50         continue
 100     continue

 150  continue

      dr=(rmmax-rmmin)/real(nhist-1)
      rtot=real(nt)


      do 350 ky=1,ny
        do 200 kz=1,nz
            do 70 kx=1,nx
               xx=x(kx,ky,kz)
               ixx1=nint(x1(kx,ky,kz))
               if (ixx1.eq.100) then
                 ih=int((xx-rmmin)/dr)+1
                 hobs(ih)=hobs(ih)+1.0
               endif
 70         continue
 200     continue

 350  continue

 
      return
      end
c
c ----------------------------------------------------------------------
c
      subroutine histtran(x,x1,nhist,rtran,dr,rmmin,hmod,rmin,
     +                    dhr,rhm,srm,sr2m)

      USE Mappa
      real rtran(200),hmod(200)
      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))

 
      nx=np(1)
      ny=np(2)
      nz=np(3)

      rhm=0.0
      srm=0.0
      sr2m=0.0

      do 150 ky=1,ny
        do 100 kz=1,nz
            do 50 kx=1,nx
               xx=x(kx,ky,kz)
               ixx1=nint(x1(kx,ky,kz))
               if (ixx1.eq.100) then
                  robs=xx
                  rh=(robs-rmmin)/dr+1.0
                  ih=int(rh)
                  dh=rh-real(ih)
                  ih=max(min(ih,nhist-1),1)
                  rcal=rtran(ih)+dh*(rtran(ih+1)-rtran(ih))
                  x(kx,ky,kz)=rcal
                  ihm=(rcal-rmin)/dhr+1
                  if (ihm.le.0) ihm=1
                  hmod(ihm)=hmod(ihm)+1.0
                  rhm=rhm+1
                  srm=srm+rcal
                  sr2m=sr2m+rcal**2
               endif
 50         continue
 100     continue
 150  continue


      return
      end
