#include <MarchingCubes.h>

namespace GLextmr {
   class Mappa {
   public:
      Mappa(int ind, bool if_surface=false);
      void Save(std::ofstream &f);
      bool Restore(std::ifstream &f);
      void Save(FILE *fp);
      bool Restore(FILE *fp);
      size_t truesize();
      void run_mc(GLWindow *gl, int limx, int limy, int limz);
      void CalcolaC();
      void freeMap();
      void RunMC(GLWindow *gl, int k);
      void DrawMap(GLWindow *gl);
      void DrawCube(GLWindow *gl);
      void FromRadTorad(GLWindow *gl);
      void fromTrianglesToVertices(GLdouble *vertices, GLdouble *normals);
      double SigmaMappa();
      double minimum;
      double maximum;
      double mean;
      bool ifVis;
      vet3 vn[8];          // vertici cubo spigolo 2*R e centro xyzC
      vet3 vf[8];          // vertici cubo spigolo 2*R e centro xyzC
      vet3 vmN[8];
      vet3 vnN;
      float mat_emission[4];
      float shininess;
      float color_mappa[4];
      myreal  iso;
      int   size_x;
      int   size_y;
      int   size_z;
      int   size_m;
      int   size_M;
      int   cx;
      int   cy;
      int   cz;
      int   radius_x;
      int   radius_y;
      int   radius_z;
      int   wireframe;
      myreal  sigma;
      float xmin[3];
      float xmax[3];
      myreal  sigmaMax;
      int   nsym;
      float resm;
      int nrefl;
      int   ifDifference;
      bool created;
      bool isSurface;
      bool multicolor;
      float radius;
      float step;
      char *name;
      myreal  *mappa;
      int     *color;
      MarchingCubes *mc ;
   };
     void on_sigma(GtkWidget *button, gpointer data);
     void centre_settings(GtkWidget *window, GtkWidget *dlg, GtkWidget *vboxx,
                          bool block_h = false);
     void set_values_for_centre(GtkWidget *father, GtkWidget *window);
     void map_settings(GtkWidget *window, GtkWidget *dlg, GtkWidget *vbox,
                          bool block_h = false);
     void update_maps(GtkWidget *father, GtkWidget *window);
     void set_values_for_map(int i, GtkWidget *father, GtkWidget *window);
     void PrintMapInfo(gpointer,  gpointer data);
}
extern "C" float getxmap_(int *i, int *j, int *k);
