#include <utils.h>
#include <csymlib.h>
#include <cstring>
#include <cerrno>

static int ktest1;
static float  fvalues[13];
static int intervalli[] = {1, 3, 16, 75, 143, 195};

static const char *cell_data[] = {"a:", "b:", "c:", "alpha:", "beta:", "gamma:",
                         "err_a:", "err_b:", "err_c:", "err_alpha:",
                         "err_beta:", "err_gamma:", "Volume:"};

static const char *famiglia[] = {"Triclinic", "Monoclinic", "Orthorombic",
                           "Tetragonal", "Hexagonal", "Cubic"};

 static const char *CrystSystem[] = {"Automatic", "Triclinic", "Monoclinic a", "Monoclinic b", "Monoclinic c", "Orthorombic", "Tetragonal", "Hexagonal", "Cubic ", "Rhombohedric"};

extern "C" void  newproject_symm_ (int *ier, char *inpfile,
                               int cellconditions[], size_t l1);

GtkWidget *i_Spg_Cell (GtkWidget *notebook, GtkWidget *dlg,
                       GCallback cb_func, const char *filspg)
{
  GtkWidget *vbox;
  GtkWidget *hbox;
  GtkWidget *vbox1;
  GtkWidget *hbox2;
  GtkWidget *label;
  GtkWidget *table1;
  GtkWidget *combo;
  GtkWidget *frame;
  GtkWidget *entry;
  GtkWidget *button;
  GtkWidget *frame_spg;
  int i, j, kl, k, ke;
  int Silent = 1;
  bool ifNewProject = false;

  if(GTK_IS_DIALOG(notebook))
     vbox = gtk_dialog_get_content_area(GTK_DIALOG(notebook));
  else
  {
     vbox = vbox_new (FALSE, 4);
     g_object_set_data (G_OBJECT (dlg), "vbox", vbox);
     gtk_widget_show (vbox);
     gtk_container_add (GTK_CONTAINER (notebook), vbox);
     Silent = 0;
     ifNewProject = true;
  }

  frame = NEW_FRAME("Symmetry", true);
  gtk_widget_show(frame);
  gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 10);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 2);
  set_mandatory(gtk_frame_get_label_widget(GTK_FRAME(frame)));

  vbox1 = vbox_new (FALSE, 4);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), vbox1);
  g_object_set_data (G_OBJECT (dlg), "spaceg_box", vbox1);

  if(ifNewProject)
  {
  GSList *group = NULL;
  frame_spg = NEW_FRAME("");
  label = RADIO_BUTTON_WITH_LABEL(group, "Enter Space Group symbol (or number)",
           NULL);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (label));
  gtk_frame_set_label_widget(GTK_FRAME(frame_spg), label);
  g_object_set_data (G_OBJECT (dlg), "radio_space", label);
  gtk_widget_show (label);
  gtk_widget_show (frame_spg);
  gtk_box_pack_start (GTK_BOX (vbox1), frame_spg, FALSE, FALSE, 0);
  g_signal_connect(G_OBJECT(label), "toggled", G_CALLBACK(on_cb_attiva),
          get_widget(frame_spg, "align"));
  
  GtkWidget *frame_search = NEW_FRAME("");
  label = RADIO_BUTTON_WITH_LABEL(group, "Search for Space Group", NULL);
  gtk_frame_set_label_widget(GTK_FRAME(frame_search), label);
  gtk_widget_show (frame_search);
  gtk_widget_show (label);
  g_object_set_data (G_OBJECT (dlg), "radio_search", label);
  gtk_box_pack_start (GTK_BOX (vbox1), frame_search, FALSE, FALSE, 0);
  g_signal_connect(G_OBJECT(label), "toggled", G_CALLBACK(on_cb_attiva),
          get_widget(frame_search, "align"));
  gtk_widget_set_sensitive(get_widget(frame_search, "align"), FALSE);
  hbox = vbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  add_to_frame(frame_search, hbox);
  hbox2 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (hbox), hbox2, FALSE, FALSE, 0);
  GSList *group1 = NULL;
  label = RADIO_BUTTON_WITH_LABEL(group1, "Select from list", NULL);
  group1 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (label));
  gtk_widget_show (label);
  g_object_set_data (G_OBJECT (dlg), "radio_find", label);
  gtk_box_pack_start (GTK_BOX (hbox2), label, FALSE, FALSE, 0);
  GtkWidget *lab1 = LABEL_NEW("Crystal Family: ", MyBLUE);
  gtk_widget_show (lab1);
  int n = (int) (sizeof(CrystSystem)/ sizeof(CrystSystem[0]));
  GtkWidget *combo = create_combo(NULL, CrystSystem, n, 1, NULL, NULL);
  g_object_set_data(G_OBJECT (dlg), "crystfam", combo);
  gtk_widget_show (combo);
  gtk_box_pack_end( GTK_BOX(hbox2), get_widget(combo, "parent"), FALSE,
          FALSE, 0);
  gtk_box_pack_end( GTK_BOX(hbox2), lab1, FALSE, FALSE, 4);
  set_width_chars (GTK_ENTRY(get_widget(combo,"entry")), 16);

  label = RADIO_BUTTON_WITH_LABEL(group1, "Scan all possible Space Groups",
       NULL);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
  g_object_set_data (G_OBJECT (dlg), "radio_scan", label);
  g_signal_connect(G_OBJECT(label), "toggled", G_CALLBACK(on_cb_disattiva), combo);
  }
  else
  {
  hbox = hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 4);
  g_object_set_data (G_OBJECT (dlg), "spaceg_hbox", hbox);

//  label = LABEL_NEW("Select Space Group:", MyRED);
  label = LABEL_NEW("Space Group:", MyRED);
  gtk_widget_show (label);
  gtk_box_pack_start( GTK_BOX(hbox), label, FALSE, FALSE, 0);
  g_object_set_data (G_OBJECT (dlg), "radio_space", label);

  hbox2 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (hbox), hbox2, TRUE, TRUE, 0);
  }

  combo = spgr_widget(filspg, Silent);
  entry = get_widget(combo, "entry");
  set_width_chars (GTK_ENTRY(entry), 16); 
  g_object_set_data (G_OBJECT (dlg), "space_group", combo);
  g_object_set_data (G_OBJECT (dlg), "entry_spg", entry);

  if(ifNewProject)
  {
#ifdef IN_GTK3
     GtkWidget *a = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, 0, 0);
#else
     GtkWidget *a = gtk_alignment_new(0,0.5, 0, 0);
#endif
     gtk_widget_show(a);
     add_to_frame(frame_spg, a);
     gtk_container_add(GTK_CONTAINER(a), combo);
  }
  else
    gtk_box_pack_start( GTK_BOX(hbox2), combo, FALSE, FALSE, 4);

  button = myimage_button ("_Accept", "apply.png");
  g_object_set_data (G_OBJECT (dlg), "accept0", button);
  g_signal_connect(G_OBJECT(button), "clicked",
                     cb_func, GINT_TO_POINTER(0));
  gtk_box_pack_end( GTK_BOX(vbox1), button, FALSE, FALSE, 0);
  gtk_widget_show(button);

  frame = NEW_FRAME("Cell parameters ", true);
  g_object_set_data (G_OBJECT (dlg), "cell_param", frame);
  gtk_widget_show(frame);
  gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 10);
//  gtk_container_set_border_width (GTK_CONTAINER (frame), 2);
  gtk_widget_set_sensitive(frame, FALSE);

  table1 = table_new (7, 6, FALSE);
  gtk_widget_show (table1);
  table_set_row_spacings (table1, 4);
  table_set_col_spacings (table1, 4);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), table1);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 4);

  label = gtk_label_new("");
  g_object_set_data (G_OBJECT (dlg), "CellPar", label);
  gtk_widget_show (label);
  set_alignment(label, 0, 0.5);
  table_attach( table1, label, 0, 5, 0, 1, TRUE);

  label = LABEL_BOLD("Errors on cell parameters and on volume:", MyBLUE, 1.05f);
  gtk_widget_show (label);
  set_alignment(label, 0, 0.5);
  table_attach( table1, label, 0, 5, 3, 4, TRUE);

  label = LABEL_NEW("Volume:", MyBLUE);
  gtk_widget_show (label);
  set_alignment(label, 1.0, 0.5);
  table_attach (table1, label, 0, 1, 6, 7, TRUE);

  entry = gtk_entry_new ();
  g_object_set_data (G_OBJECT (dlg), "Volume:", entry);
  gtk_widget_show (entry);
  set_width_chars (GTK_ENTRY(entry), 8); 
  table_attach(table1, entry, 1, 2, 6, 7);
  g_signal_connect (G_OBJECT(entry), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);

  for(k = 0; k<4; k++)
  {
      i = k + (k > 1);
      for(j = 0; j<6; j++)
      {
           kl = (k % 2)*3 + j/2;
           ke = kl + 6*(k/2);
           if((j % 2) == 0)                     /* label */
           {
               if(k < 2)
                  label = LABEL_NEW (cell_data[kl], MyRED);
               else
                  label = LABEL_NEW (cell_data[kl], MyBLUE);
               gtk_widget_show (label);
               table_attach(table1, label, j, j+1, i+1, i+2, TRUE);
               set_alignment(label, 1.0, 0.5);
               if(k < 2)
                  set_mandatory(label);
           }
           else                                 /* entry */
           {
               entry = gtk_entry_new ();
               g_object_set_data (G_OBJECT (dlg), 
                   cell_data[ke], entry);
               gtk_widget_show (entry);
               set_width_chars (GTK_ENTRY(entry), 8); 
               table_attach(table1, entry, j, j+1, i+1, i+2);
               g_signal_connect (G_OBJECT(entry), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);
           }
      }
  }           
  return vbox;
}

int CheckSpace(GtkWidget *dialog, int spgnum, float symop_r[3], int ktest)
{
     char *string0 = g_new0(char, 80);
     GtkWidget *entry;
     int i, il1, il2, il3, ifnum;
/*
     if(ifClear)
     {
         entry = get_widget(dialog, "CellPar");
         set_label_text(entry, " ", "red", 1.05f);
         for(i = 0; i<13; i++)
         {
            entry = get_widget(dialog, cell_data[i]);
            gtk_entry_set_text(GTK_ENTRY(entry), "  ");
         }
     }
*/
     for (i=5; i>=0; i--)
     {
        if(spgnum >= intervalli[i])
           break;
     }
     ifnum = i;
#if 1
     for(i = 0; i<13; i++)
     {
         entry = get_widget(dialog, cell_data[i]);
         if(!gtk_editable_get_editable(GTK_EDITABLE(entry)))
            gtk_entry_set_text(GTK_ENTRY(entry), "  ");
     }
#endif
     switch(ifnum)
     {
     case 0:                 //Triclinic
           for(i = 0; i<13; i++)
           {
              entry = get_widget(dialog, cell_data[i]);
              if(ktest == 0)
                 gtk_entry_set_text(GTK_ENTRY(entry), "  ");
              gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
           }
           break;
     case 1:                 //Monoclinic
           if(symop_r[0] == symop_r[1])
           {
              il1 = 0;
              il2 = 1;
              il3 = 2;
           }
           else if(symop_r[0] == symop_r[2])
           {
              il1 = 0;
              il2 = 2;
              il3 = 1;
           }
           else if(symop_r[1] == symop_r[2])
           {
              il1 = 1;
              il2 = 2;
              il3 = 0;
           }
           for(i = 0; i<6; i++)
           {
              entry = get_widget(dialog, cell_data[i]);
              if((i == 3+il1) || (i == 3+il2))
              {
//14102014       if(ktest != 1)
                    gtk_entry_set_text(GTK_ENTRY(entry), "90");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
                 entry = get_widget(dialog, cell_data[i+6]);
//14102014       if(ktest != 1)
                    gtk_entry_set_text(GTK_ENTRY(entry), "0");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
              }
              else
              {
                 if(ktest == 0)
                    gtk_entry_set_text(GTK_ENTRY(entry), "  ");
                  gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
                  entry = get_widget(dialog, cell_data[i+6]);
                 if(ktest == 0)
                    gtk_entry_set_text(GTK_ENTRY(entry), "  ");
                  gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
              }
           }
          break;
     case 2:                 //Orthorombic
           for(i = 0; i<6; i++)
           {
              entry = get_widget(dialog, cell_data[i]);
              if((i >= 3) && (i <= 5))
              {
//14102014       if(ktest != 1)
                    gtk_entry_set_text(GTK_ENTRY(entry), "90");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
                 entry = get_widget(dialog, cell_data[i+6]);
//14102014       if(ktest != 1)
                    gtk_entry_set_text(GTK_ENTRY(entry), "0");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
              }
              else
              {
                 if(ktest == 0)
                    gtk_entry_set_text(GTK_ENTRY(entry), "  ");
                  gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
                 entry = get_widget(dialog, cell_data[i+6]);
                 if(ktest == 0)
                    gtk_entry_set_text(GTK_ENTRY(entry), "  ");
                  gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
              }
           }
           break;
     case 3:                 //Tetragonal
           for(i = 0; i<6; i++)
           {
              entry = get_widget(dialog, cell_data[i]);
              if((i >= 3) && (i <= 5))
              {
//14102014       if(ktest != 1)
                    gtk_entry_set_text(GTK_ENTRY(entry), "90");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
                 entry = get_widget(dialog, cell_data[i+6]);
//14102014       if(ktest != 1)
                    gtk_entry_set_text(GTK_ENTRY(entry), "0");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
              }
              else if(i == 1)
              {
                    gtk_entry_set_text(GTK_ENTRY(entry), " = a");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
                 entry = get_widget(dialog, cell_data[i+6]);
                    gtk_entry_set_text(GTK_ENTRY(entry), " = a");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
              }
              else
              {
                 if(ktest == 0)
                    gtk_entry_set_text(GTK_ENTRY(entry), "  ");
                  gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
                 entry = get_widget(dialog, cell_data[i+6]);
                 if(ktest == 0)
                    gtk_entry_set_text(GTK_ENTRY(entry), "  ");
                  gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
              }
           }
           break;
     case 4:                 //Hexagonal
           for(i = 0; i<6; i++)
           {
              entry = get_widget(dialog, cell_data[i]);
              if((i == 3) || (i == 4))
              {
//14102014       if(ktest != 1)
                    gtk_entry_set_text(GTK_ENTRY(entry), "90");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
                 entry = get_widget(dialog, cell_data[i+6]);
//14102014       if(ktest != 1)
                    gtk_entry_set_text(GTK_ENTRY(entry), "0");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
              }
              else if(i == 5)
              {
//14102014       if(ktest != 1)
                    gtk_entry_set_text(GTK_ENTRY(entry), "120");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
                 entry = get_widget(dialog, cell_data[i+6]);
//14102014       if(ktest != 1)
                    gtk_entry_set_text(GTK_ENTRY(entry), "0");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
              }
              else if(i == 1)
              {
                    gtk_entry_set_text(GTK_ENTRY(entry), " = a");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
                 entry = get_widget(dialog, cell_data[i+6]);
                    gtk_entry_set_text(GTK_ENTRY(entry), " = a");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
              }
              else
              {
                 if(ktest == 0)
                    gtk_entry_set_text(GTK_ENTRY(entry), "  ");
                  gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
                 entry = get_widget(dialog, cell_data[i+6]);
                 if(ktest == 0)
                    gtk_entry_set_text(GTK_ENTRY(entry), "  ");
                  gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
              }
           }
           break;
     case 5:                 //Cubic
           for(i = 0; i<6; i++)
           {
              entry = get_widget(dialog, cell_data[i]);
              if((i >= 3) && (i <= 5))
              {
//14102014       if(ktest != 1)
                    gtk_entry_set_text(GTK_ENTRY(entry), "90");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
                 entry = get_widget(dialog, cell_data[i+6]);
//14102014       if(ktest != 1)
                    gtk_entry_set_text(GTK_ENTRY(entry), "0");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
              }
              else if((i == 1) || (i == 2))
              {
                    gtk_entry_set_text(GTK_ENTRY(entry), " = a");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
                 entry = get_widget(dialog, cell_data[i+6]);
                    gtk_entry_set_text(GTK_ENTRY(entry), " = a");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), FALSE);
              }
              else
              {
                 if(ktest == 0)
                    gtk_entry_set_text(GTK_ENTRY(entry), "  ");
                 gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
                 entry = get_widget(dialog, cell_data[i+6]);
                 if(ktest == 0)
                    gtk_entry_set_text(GTK_ENTRY(entry), "  ");
                  gtk_editable_set_editable(GTK_EDITABLE(entry), TRUE);
              }
           }
           break;
     }
     if(ifnum == 1)                  // Monoclinic
        ScriviStringa(string0, 80, "Crystal family: %s, Spacegroup number: %d, unique axis %c",
            famiglia[ifnum], spgnum, cell_data[il3][0]);
     else
        ScriviStringa(string0, 80, "Crystal family: %s, Spacegroup number: %d", 
            famiglia[ifnum], spgnum);
     entry = get_widget(dialog, "CellPar");
     set_label_text(entry, string0, "red", 1.05f);
     return 0;
}

void CheckSpg (GtkWidget *button, gpointer data)
{
     int cellconditions[14];
     GtkWidget *dlg = gtk_widget_get_toplevel(button);
     GtkWidget *entry = get_widget(dlg, "entry_spg");
     char  *string0, stringf[17];
     size_t sz0 = 30, sz1 = 16;
     string0 = g_new0(char, sz0);
     int i, ier = 0;

     ScriviStringa(string0, sz0, "%s", combo_get_text(entry));
     if(strlen(string0) <= 0)
        return;
     int ifSilent = 0;
     float symop_r[3];
     int spgnum = GetSpgNum(get_spg(g_strstrip(string0), ifSilent), symop_r);
     if(spgnum == -1)
        return;
     for (i=5; i>=0; i--)
     {
        if(spgnum >= intervalli[i])
           break;
     }
     if(i < 0)
        return;

     ScriviStringa(stringf, sizeof(stringf), "%16.16s", string0);
     newproject_symm_(&ier, stringf, cellconditions, sz1);

     if(ier)
        return;
     ier = CheckSpace(dlg, spgnum, symop_r, ktest1);

     entry = get_widget(dlg, "cell_param");
     gtk_widget_set_sensitive(entry, !ier);
     entry = get_widget(dlg, "ok_button");
     gtk_widget_set_sensitive(entry, !ier);
}

int check_cell(GtkWidget *dlg)
{
     GtkWidget *entry = get_widget(dlg, "entry_spg");
     char  *string0;
     float numero;
     size_t sz0 = 30;
     string0 = g_new0(char, sz0);
     int i, ier = 0;

     for(i=0; i<13; i++)
     {
         entry = get_widget(dlg, cell_data[i]);
         ScriviStringa(string0, sz0, "%s",
               gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
         errno = 0;
         if(i < 6)
         {
                if(strlen(g_strstrip(string0)) == 0)
                {
                    MessageDialog(dlg, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE,
                          "You must specify a value for %s", cell_data[i]);
                    return -5;
                }
                if((strcmp(string0, "= a") == 0) && (ktest1 == 2))
                   numero = fvalues[0];
                else
                   numero = (float) atof(string0);
                if(errno != 0)
                   return -errno;
                if(ktest1 == 2)
                   fvalues[i] = numero;
         }
     }
     return ier;
}

void disattiva_frame(GtkEditable *widget, GtkWidget *frame)
{
   gtk_widget_set_sensitive(frame, FALSE);
}

void GetSpgAndCell(float abcvet[], int *ier, int *ktest, const char *filspg)
{
    GtkWidget *dialog, *vbox, *button, *entry, *button2;
    int i;

    if(abcvet[0] >= 0)
    {
       *ktest = 2;
       for(i=0; i<13; i++)
           fvalues[i] = abcvet[i];
    }
    else
       *ktest = 0;
    ktest1 = *ktest;
    *ier = 0;
    dialog = gtk_dialog_new();
    gtk_window_set_title(GTK_WINDOW(dialog), "Missing data");
    vbox = i_Spg_Cell(dialog, dialog, G_CALLBACK(CheckSpg), filspg);
//13102014
    g_signal_connect(G_OBJECT(get_widget(dialog, "entry_spg")), "changed",
        G_CALLBACK (disattiva_frame), get_widget(dialog, "cell_param"));
// end 13102014

    button = OK_button();
    gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button, GTK_RESPONSE_OK);
    g_object_set_data(G_OBJECT(dialog), "ok_button", button);
    button2 = CANCEL_button();
    gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button2, GTK_RESPONSE_CANCEL);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
        GTK_BUTTONBOX_SPREAD);
    if(ktest1 == 2)
    {
       gtk_widget_set_sensitive(button, FALSE);
       vbox = get_widget(dialog, "cell_param");
       gtk_widget_set_sensitive(vbox, TRUE);

       for(i=0; i<13; i++)
       {
           entry = get_widget(dialog, cell_data[i]);
           gtk_entry_set_text(GTK_ENTRY(entry), g_strdup_printf("%7.4f",
                    abcvet[i]));
       }
    }
    gtk_widget_show_all(dialog);
    bool loop = true;
    while (loop)
    {
       int result = gtk_dialog_run(GTK_DIALOG(dialog));
       gtk_widget_hide(dialog);
       switch(result)
       {
       case GTK_RESPONSE_OK:
            loop = (check_cell(dialog) != 0);
            if(!loop)
            {
               for(i=0; i<6; i++)
               {
                   entry = get_widget(dialog, cell_data[i]);
                   const char *val = gtk_entry_get_text(GTK_ENTRY(entry));
//13102014         abcvet[i] = (float) atof(val);
//13102014
                   if(strstr(val, "="))
                      abcvet[i] = abcvet[0];
                   else
                      abcvet[i] = (float) atof(val);
//end 13102014
               }
            }
            break;
       case GTK_RESPONSE_DELETE_EVENT:
       case GTK_RESPONSE_CANCEL:
            *ier = -1;
            loop = false;
            break;
       }
    }
    gtk_widget_destroy(dialog);
}

