*---------------------------------------------------------------------*
*----       SKELETON  PROCEDURE IN THREE DIMENSIONS               ----*
*----                    Bones Procedure                          ----*
*----                    Javier & Dritan (1996-1997)              ----*
*---                     Dritan 2007                              ----*
*---------------------------------------------------------------------*

      subroutine skeleton_greer(xmapSK)

      USE General
      USE Riflessi
      USE Mappa, only: np
      USE Param
      USE MappaAutre
      USE Skeleton

      character*200 strFile
      real xmapSK(0:np(1)-1,0:np(2)-1,0:np(3)-1)


c     strFile = StructureName(1:Lung(StructureName)) //'_sk0.map'
c     call CCP4MAPOUT(0,xmapSK,np,strFile)

c     strFile = StructureName(1:Lung(StructureName)) //'_sk0.map'
c     call CCP4MAPIN(np,strFile)
c     xmapSK = xmapAutre
c     stop

      nnx=np(1)
      nny=np(2)
      nnz=np(3)
      nmap=nnx*nny*nnz
      call prepeqv

      call AllocaSkeleton(1)

      if (iBonesIn == 1) then
      ! leggere il file bones di mapman / preparare MASK
        jRBones = 100
        call ReadBonesFile(jRBones)
      endif

      maskSK = xmapSK ! serve per la mappa inziale (da normalizzare anche per preparare un mask)

*---- Density max and min, rhoave,rhostd
      denmin=1.0e25
      denmax=-1.0e25
      call maxminG(0,nnx,nny,nnz,denmin,denmax,rhoave,rhostd,maskSK)
c     write(lo,*) ' Nr. points:',nmap
c     write(lo,*) ' min,max:',denmin/volume,denmax/volume
      write(lo,*) ' Normalise map (<rho> =0.0 sigma = 1.0)'
      write(lo,*) ' subst:',rhoave/volume
      write(lo,*) ' divide:',rhostd/volume

      ! normalize mappa : rhoave = 0.0 e rhostd = 1.0
      do ix = 0, nnx - 1
        do iy = 0, nny - 1
          do iz = 0, nnz - 1
            maskSK(ix,iy,iz) = maskSK(ix,iy,iz) - rhoave
            maskSK(ix,iy,iz) = maskSK(ix,iy,iz) / (rhostd/volume)
          enddo
        enddo
      enddo
      denmin=1.0e25
      denmax=-1.0e25
      call maxminG(0,nnx,nny,nnz,denmin,denmax,rhoave,rhostd,maskSK)
c     write(lo,*) ' min,max:',denmin/volume,denmax/volume
c     write(lo,*) ' <rho>:',rhoave/volume
c     write(lo,*) ' sigma:',rhostd/volume

c     sogMadSk     --> soglia mappa                     (default 1.5)
c     sogLevSK     --> soglia "level" mappa             (default 1.0)
c     nSparePoints --> nr. dei spare points             (default 0)
c     lungSK       --> lunghezza minima per i frammenti (default 5)



*---- Greer Procedure ----*
      call greer(nnx,nny,nnz,denmax,denmin,rhoave,rhostd,maskSK)

*---- Connections ----*
      call chain_skel(nnx,nny,nnz,npcn,nccn)

      if(ifDEDM==0) then
        nspazio=npcn
      else
        nspazio=npcn*10
      endif
      IF (.NOT. ALLOCATED(xyzBones))
     *   allocate (xyzBones(4,nspazio) , stat = ierr)
      nBonesPoint = 0 

      do  i=1,npcn
         if(ifDEDM==0) then
           ! solo main points
           if (levlis(i).eq.main) then
              nBonesPoint = nBonesPoint + 1 
              xyzBones(1:3,nBonesPoint) = pntlis(i,1:3)  ! in coor. ortonormali
              xyzBones(4,nBonesPoint)   = levlis(i)      ! tipo
           endif
         else
           ! solo main and side points
           if (levlis(i).eq.main.or.levlis(i).eq.side) then
              nBonesPoint = nBonesPoint + 1 
              xyzBones(1:3,nBonesPoint) = pntlis(i,1:3)  ! in coor. ortonormali
              xyzBones(4,nBonesPoint)   = levlis(i)      ! tipo
           endif
         endif
      enddo

      write(6,*) 'Nr. BonesPoint', nBonesPoint,npcn
      if(ifDEDM>0) return

      ! scrivere la "bones mask" da xyzBones
      maskSK(:,:,:) = 0.0
      radSphere = -1.0 ! il segno negativo per coord. ortonormali
      ! neqv = 1 
      call Atoms2Mask(radSphere,nBonesPoint,1,xyzBones,maskSK)

      strFile=StructureName(1:Lung(StructureName))//'_mask_sk.map'
      call CCP4MAPOUT(0,maskSK,np,strFile)

      maskSK(:,:,:) = 0.0
      radSphere = -1.0 ! il segno negativo per coord. ortonormali
      call Atoms2Mask_new(0,radSphere,nBonesPoint,xyzBones,maskSK)

      strFile=StructureName(1:Lung(StructureName))//'_mask_sk_new.map'
      call CCP4MAPOUT(0,maskSK,np,strFile)

*---- Output PDB format
      call pdbout(npcn,nccn)


c     stop
      return
      end
*--------------------------------------------------------------------*
      subroutine greer(nnx,nny,nnz,denmax1,denmin1,rhoave,rhostd,xmapSK)

      USE General
      USE Riflessi
      USE Param
      USE Mappa, only: np
      USE Skeleton

      real xmapSK(1:np(1),1:np(2),1:np(3))

      integer indx(3,3,3)
      logical flag

      parameter (level=10)
      
*---- Initial values ----*
      nmap=nnx*nny*nnz 
      base=rhoave+sogMapSK*rhostd
      den_int=sogLevSK*rhostd

*---- Calculating Levels in the Fourier map----*
      maxival=0
      ns = 0
      do ky = 1, nny
        do kz = 1, nnz
          do kx = 1, nnx
           ind1 = kz + nnz*( (kx-1) + (ky-1)*nnx )
           rden = xmapSK(kx,ky,kz)
           ival=(rden-base)/den_int + 1
           if (ival.le.0) ival=0
           maxival=max(maxival,ival)
           ndenSK(ind1)=ival
           ns = ns + 1
          enddo
        enddo
      enddo

      maxival=min(maxival,level)

      write(lo,15) denmax1/volume,denmin1/volume,rhoave/volume,
     +             rhostd/volume,base/volume,den_int/volume,
     +             maxival
 15   format('Maximum density ............ ',f8.3,/,
     +       'Minimum density ............ ',f8.3,/,
     +       'Average density ............ ',f8.3,/,
     +       'Standar deviation .......... ',f8.3,/,
     +       'Base density ............... ',f8.3,/,
     +       'Level increment ............ ',f8.3,/,
     +       'Number of levels ........... ',I8,/)

      ntot=0
      do 20 ns=1,nmap
         il=mod(ns-1,nnz)+1
         ih=mod((ns-1)/nnz,nnx)+1
         ik=mod((ns-1)/(nnz*nnx),nny)+1
         if (ih.eq.1 .or. ih.eq.nnx) ndenSK(ns)=0
         if (ik.eq.1 .or. ik.eq.nny) ndenSK(ns)=0
         if (il.eq.1 .or. il.eq.nnz) ndenSK(ns)=0
         if (ndenSK(ns).gt.0) ntot=ntot+1
 20   continue
      write(lo,25) ntot
 25   format('Points .gt. level=0 :',i8)


*---- Skeleton Process ----*
      nxm1=nnx-1
      nym1=nny-1
      nzm1=nnz-1

      do 500 nlevel=1,level+1
         do 250 i=2,nxm1
            do 200 j=2,nym1
               do 150 k=2,nzm1
                  ind=k + nnz*( (i-1) + (j-1)*nnx )
                  if (ndenSK(ind).le.0) ndenSK(ind)=0
                  if (nlevel.eq.level+1) then
                     if (ndenSK(ind).eq.0) goto 150
                  else

*---- 1.- The grid point is in R set ----*
                     if (ndenSK(ind).ne.nlevel) goto 150
                  endif

*---- 2.- No HOLE is created by removing this point ----*
                  flag=.false.

                  ih11=i
                  ik11=j
                  il11=k-1

                  ih12=i
                  ik12=j
                  il12=k+1

                  ih13=i
                  ik13=j-1
                  il13=k

                  ih14=i
                  ik14=j+1
                  il14=k

                  ind11=il11 + nnz*( (ih11-1) + (ik11-1)*nnx )
                  ind12=il12 + nnz*( (ih12-1) + (ik12-1)*nnx )
                  ind13=il13 + nnz*( (ih13-1) + (ik13-1)*nnx )
                  ind14=il14 + nnz*( (ih14-1) + (ik14-1)*nnx )

                  if (ndenSK(ind11).eq.0) flag=.true.
                  if (ndenSK(ind12).eq.0) flag=.true.
                  if (ndenSK(ind13).eq.0) flag=.true.
                  if (ndenSK(ind14).eq.0) flag=.true.
                  if (.not. flag) goto 150

                  flag=.false.
                  ih21=i-1
                  ik21=j
                  il21=k

                  ih22=i+1
                  ik22=j
                  il22=k

                  ih23=i
                  ik23=j
                  il23=k-1

                  ih24=i
                  ik24=j
                  il24=k+1
         
                  ind21=il21 + nnz*( (ih21-1) + (ik21-1)*nnx )
                  ind22=il22 + nnz*( (ih22-1) + (ik22-1)*nnx )
                  ind23=il23 + nnz*( (ih23-1) + (ik23-1)*nnx )
                  ind24=il24 + nnz*( (ih24-1) + (ik24-1)*nnx )

                  if (ndenSK(ind21).eq.0) flag=.true.
                  if (ndenSK(ind22).eq.0) flag=.true.
                  if (ndenSK(ind23).eq.0) flag=.true.
                  if (ndenSK(ind24).eq.0) flag=.true.
                  if (.not. flag) goto 150

                  flag=.false.
                  ih31=i-1
                  ik31=j
                  il31=k

                  ih32=i+1
                  ik32=j
                  il32=k

                  ih33=i
                  ik33=j-1
                  il33=k

                  ih34=i
                  ik34=j+1
                  il34=k
         
                  ind31=il31 + nnz*( (ih31-1) + (ik31-1)*nnx )
                  ind32=il32 + nnz*( (ih32-1) + (ik32-1)*nnx )
                  ind33=il33 + nnz*( (ih33-1) + (ik33-1)*nnx )
                  ind34=il34 + nnz*( (ih34-1) + (ik34-1)*nnx )

                  if (ndenSK(ind31).eq.0) flag=.true.
                  if (ndenSK(ind32).eq.0) flag=.true.
                  if (ndenSK(ind33).eq.0) flag=.true.
                  if (ndenSK(ind34).eq.0) flag=.true.
                  if (.not. flag) goto 150

*----  3.- The point cannot be a tip or single point in the skeleton ----*
                  ict=0
                  nx1=i-1
                  nx2=i+1
                  ny1=j-1
                  ny2=j+1
                  nz1=k-1
                  nz2=k+1
                  do 30 jx=nx1,nx2
                  do 30 jy=ny1,ny2
                  do 30 jz=nz1,nz2
                     ind1=jz + nnz*( (jx-1) + (jy-1)*nnx )
                     if (ndenSK(ind1).gt.0) ict=ict+1
 30               continue

*----  If it is a tip (ict.le.2) ----*
                  if (ict.le.2) goto 150

*----  4.- Removing the central grid point disconnect the neighbors in I ----*
                  do 40 n1=1,3
                  do 40 n2=1,3
                  do 40 n3=1,3
                     indx(n1,n2,n3)=0
 40               continue
                  do 50 ix=nx1,nx2
                  do 50 iy=ny1,ny2
                  do 50 iz=nz1,nz2
                     if (ix.eq.i .and. iy.eq.j .and. iz.eq.k) goto 50
                     ind1=iz + nnz*( (ix-1) + (iy-1)*nnx )
                     if (ndenSK(ind1).gt.0) goto 60
 50               continue
                  goto 150

*---- mark nearest neighboors to first point ----*
 60               call naydx(ix,iy,iz,nnx,nny,nnz,nx3,nx4,
     +                       ny3,ny4,nz3,nz4)

                  do 70 jx=nx3,nx4
                  do 70 jy=ny3,ny4
                  do 70 jz=nz3,nz4
                     if (jx.eq.i .and. jy.eq.j .and. jz.eq.k)
     +                  goto 70
                     ind2=jz + nnz*( (jx-1) + (jy-1)*nnx )
                     if (ndenSK(ind2).gt.0) then
                        call markit(jx,jy,jz,i,j,k,indx,ict)
                     endif 
 70               continue

*---- Go over INDX, check if marked, if it is mark it's neighboors. ICT is only
*---- update if a new mark is made. If a pass has no new marks then we have
*---- finished.
 80               ict=0
                  do 100 ix=nx1,nx2
                  do 100 iy=ny1,ny2
                  do 100 iz=nz1,nz2
                     if (indx(ix-nx1+1,iy-ny1+1,iz-nz1+1).ne.0) then
                        call naydx(ix,iy,iz,nnx,nny,nnz,nx3,nx4,
     +                             ny3,ny4,nz3,nz4)

                        do 90 jx=nx3,nx4
                        do 90 jy=ny3,ny4
                        do 90 jz=nz3,nz4
                           if (jx.eq.i .and. jy.eq.j .and. jz.eq.k)
     +                        goto 90
                           ind2=jz + nnz*( (jx-1) + (jy-1)*nnx )
                           if (ndenSK(ind2).gt.0) then
                              call markit(jx,jy,jz,i,j,k,indx,ict)
                           endif 
 90                     continue
                     endif
 100              continue
                  if (ict.gt.0) goto 80

*---- No new neighbours. All marked, now see if any data points not in INDX.
                  do 110 ix=nx1,nx2
                  do 110 iy=ny1,ny2
                  do 110 iz=nz1,nz2
                     if (ix.eq.i .and. iy.eq.j .and. iz.eq.k) goto 110
                     ind1=iz + nnz*( (ix-1) + (iy-1)*nnx )
                     if (ndenSK(ind1).le.0) goto 110

                     lx=ix-nx1+1
                     ly=iy-ny1+1
                     lz=iz-nz1+1
                     if (indx(lx,ly,lz).eq.1) goto 110

*---- if we through, then the point is neede to coserve connectivity
                     goto 150
 110              continue

*---- All satisfied, so tranfer it to subset R
                  ndenSK(ind)=-ndenSK(ind)

 150           continue
 200        continue
 250     continue
*---- End of this pass, so transfer subset R to Subset N
         do 400 i=2,nxm1
            do 350 j=2,nym1
               do 300 k=2,nzm1
                  ind=k + nnz*( (i-1) + (j-1)*nnx )
                  if (ndenSK(ind).lt.0) ndenSK(ind)=0
 300           continue
 350        continue
 400     continue

 500  continue

      ntot=0
      do 510 ns=1,nmap
         il=mod(ns-1,nnz)+1
         ih=mod((ns-1)/nnz,nnx)+1
         ik=mod((ns-1)/(nnz*nnx),nny)+1
         if (ih.eq.1 .or. ih.eq.nnx) ndenSK(ns)=0
         if (ik.eq.1 .or. ik.eq.nny) ndenSK(ns)=0
         if (il.eq.1 .or. il.eq.nnz) ndenSK(ns)=0
         if (ndenSK(ns).gt.0) ntot=ntot+1
 510  continue
      write(lo,515) ntot
 515  format('Points in Skeleton Map:',i8)

      return
      end

*-----------------------------------------------------------------------*
*----                   UTILITY FOR PDB FORMAT                       ---*
*-----------------------------------------------------------------------*
      subroutine pdbout(npcn,nccn)
      USE General
      USE Skeleton


      Buffer1 = StructureName(1:Lung(StructureName)) //'_skeleton.pdb'
      write(lo,*) ' Write skeleton in pdb format: ',
     *            Buffer1(1:Lung(Buffer1))
      jop=jopen(1,Buffer1,0,1,ier)

      if (jop.lt.0) then
         write(lo,910)
         stop
      endif


      write (1,110)cell(1:6)
      write (1,120)((qt(i,j),j=1,4),i=1,3)
      
      do 10 i=1,npcn
         if (levlis(i).eq.main) then
            write (1,5)i,pntlis(i,1),pntlis(i,2),pntlis(i,3),levlis(i)
         endif
 10   continue
      do 20 i=1,nccn-1
         md1=mod(newcon(i),2)
         md2=mod(newcon(i+1),2)
         ind1=int( (newcon(i)-md1) / 2)
         ind2=int( (newcon(i+1)-md2) / 2)
         if (levlis(ind1).eq.main .and. levlis(ind2).eq.main) then 
            write(1,15) ind1,ind2
 15         format('CONNECT',2i7)
         endif
 20   continue

 110  format ('CRYST1',3f9.3,3f7.2,' P 1    ')
 120  format ('SCALE1    ',3f10.6,f15.6/
     +        'SCALE2    ',3f10.6,f15.6/
     +        'SCALE3    ',3f10.6,f15.6)

 5       format ('ATOM',i7,'  C   SKL     1    ',3f8.3,'  1.00 20.00',
     *           i8)
910   format(/,'Open error in PDB file')
 
      return
      end
*-------------------------------------------------------------------*
      subroutine markit(ix,iy,iz,i,j,k,indx,ict)
      integer indx(3,3,3)

      i1=ix-i+2
      i2=iy-j+2
      i3=iz-k+2

      if (i1.le.0) return
      if (i1.gt.3) return
      if (i2.le.0) return
      if (i2.gt.3) return
      if (i3.le.0) return
      if (i3.gt.3) return
      
      if (indx(i1,i2,i3).gt.0) return
      indx(i1,i2,i3)=1
      ict=ict+1

      return
      end
*-----------------------------------------------------------*
      subroutine chain_skel(nnx,nny,nnz,npcn,nccn)
      USE General
      USE Skeleton

      integer pcount,bcount,ccount,fcount,ccountMax
      integer lev

*---- Initial values ----*
      nmap=nnx*nny*nnz

      nbran=0
      pcount=0
      bcount=0
      ccount=0
      ccountMax=0
      fcount=0
      lno=1

      do 10 i=1,maxfrg
         nfrg(i)=0
 10   continue

      maxx=nnx-1
      maxy=nny-1
      maxz=nnz-1

      do 500 i=2,maxx
         do 450 j=2,maxy
            do 400 k=2,maxz
               ix=i
               iy=j
               iz=k
               ind=iz + nnz*( (ix-1) + (iy-1)*nnx )
               if (ndenSK(ind).eq.0) goto 400

*---- Point in the bones found. Store it in the point list ----*
               pcount=pcount+1
               if (pcount.gt.maxp) then
                  print*,'Error:**** 1 ****'
                  stop
               endif
               index=pcount
               ival=ndenSK(ind)
               ndenSK(ind)=0
               call points(index,ix,iy,iz,ival,nnx,nny,nnz)
               iblng=0

*---- And store a "move to" in the connectivity list ----*
               ccount=ccount+1
               if (ccount.gt.maxc) then 
                  print*,'Error:**** 2 ****'
                  stop
               endif
               conlis(lno,ccount)=index*2

*---- Scan the neighboors ----*
 20            nflg=0
               lev=0
               ix1=ix-1
               ix2=ix+1
               iy1=iy-1
               iy2=iy+1
               iz1=iz-1
               iz2=iz+1

               do 32 jx=ix1,ix2
                  do 31 jy=iy1,iy2
                     do 30 jz=iz1,iz2
                        if (jz.lt.1 .or. jz.gt.nnz) goto 30
                        if (jy.lt.1 .or. jy.gt.nny) goto 31
                        if (jx.lt.1 .or. jx.gt.nnx) goto 32
                        ind1=jz + nnz*( (jx-1) + (jy-1)*nnx )
                        if (ndenSK(ind1).ne.0) then

*---- Found a neighboor ----*
                           nflg=nflg+1
                           if (ndenSK(ind1).gt.lev) then
                              lev=ndenSK(ind1)
                              lx=jx
                              ly=jy
                              lz=jz
                           endif
                           if (nflg.eq.2) then
                        
*---- A second neighboor i.e. it's a branchpoint store in branch list ----*
                              bcount=bcount+1
                              if (bcount.gt.maxb) then
                                 print*,'Error:**** 3 ****'
                                 stop
                              endif
                              nbran=nbran+1
                              brnlis(bcount,1)=index
                              brnlis(bcount,2)=ix
                              brnlis(bcount,3)=iy
                              brnlis(bcount,4)=iz
                              brnlis(bcount,5)=1
                              brnlis(bcount,6)=iblng
                           endif
                        endif
 30                  continue
 31               continue
 32            continue

*---- Continue the chain ----*
 40            if (nflg.ne.0) then
                  ix=lx
                  iy=ly
                  iz=lz
                  pcount=pcount+1
                  if (pcount.gt.maxp) then
                     print*,'Error:**** 4 ****'
                     stop
                  endif
                  index=pcount
                  ind=iz + nnz*( (ix-1) + (iy-1)*nnx )
                  ival=ndenSK(ind)
                  ndenSK(ind)=0
                  call points(index,ix,iy,iz,ival,nnx,nny,nnz)

*---- Store a "line to" in connectivity list ----*
                  ccount=ccount+1
                  if (ccount.gt.maxc) then
                     print*,'Error:**** 5 ****'
                     stop
                  endif
                  conlis(lno,ccount)=index*2+1
                  iblng=iblng+1
                  goto 20
   
               else

*---- Tip is reached. Go back to the lastest branchpoint ----*
 50               if (bcount.eq.0) goto 70
                  index=brnlis(bcount,1)
                  ix=brnlis(bcount,2)
                  iy=brnlis(bcount,3)
                  iz=brnlis(bcount,4)
                  iblng=brnlis(bcount,6)

*---- Check if there is still a neigbour ----*
                  ix1=ix-1
                  ix2=ix+1
                  iy1=iy-1
                  iy2=iy+1
                  iz1=iz-1
                  iz2=iz+1
                  do 62 jx=ix1,ix2
                     do 61 jy=iy1,iy2
                        do 60 jz=iz1,iz2
                           if (jz.lt.1 .or. jz.gt.nnz) goto 60
                           if (jy.lt.1 .or. jy.gt.nny) goto 61
                           if (jx.lt.1 .or. jx.gt.nnx) goto 62
                           ind1=jz + nnz*( (jx-1) + (jy-1)*nnx )
                           if (ndenSK(ind1).ne.0) then
                              lx=jx
                              ly=jy
                              lz=jz
                              brnlis(bcount,5)=brnlis(bcount,5)+1
                              nflg=1

*---- Store a "move to" in list ----*
                              ccount=ccount+1
                              if (ccount.gt.maxc) then
                                 print*,'Error:**** 6 ****'
                                 stop
                              endif
                              conlis(lno,ccount)=index*2
                              goto 40
                           endif
 60                     continue
 61                  continue
 62               continue

*---- No more branches at this point ----*
                  call branch(lno,ccount,bcount,fcount)
                  goto 50
               endif

*---- Finished a whole chain. Transfer it to the final list ----*
 70            if (ccount.ge.1) then
                  fcount=fcount+1
                  if (fcount.gt.maxc) then
                     print*,'Error:**** 7 ****'
                     stop
                  endif
                  lim1=1
                  call movlis(lno,finlis,fcount,lim1,ccount,even)
                  if (fcount.gt.maxc) then
                     print*,'Error:**** 8 ****'
                     stop
                  endif
                  do 80 nn=1,maxfrg-1
                     if (ccount.le.frgsz(nn)) then
                        nfrg(nn)=nfrg(nn)+1
                        goto 90
                     endif
 80               continue 
 90              if (ccount.gt.frgsz(maxfrg))nfrg(maxfrg)=nfrg(maxfrg)+1
                 ccountMax = max(ccountMax,ccount)
                 ccount=0
               endif
 400        continue
 450     continue
 500  continue

*---- The Connectivity is now defined ----*

*---- All points are given the level "unknown" ----*
      do 510 n=1,pcount
         levlis(n)=unkn
 510  continue 

*---- Insert extra points ----*
      ipext=0
      iext=0
      iext=nSparePoints
      inlow=pcount+1
      pcount=pcount+ipext
      if (pcount.gt.maxp) then
         pcount=maxp
         iext=maxp-pcount+1
      endif
      do 530 n=inlow,pcount
         do 520 jj=1,3
            pntlis(n,jj)=1500.0
 520     continue
         levlis(n)=unus
 530  continue

*---- Print information ----*
      write(lo,600) pcount,iext,fcount,nbran
 600  format(//,'No. of Points in the Bones :',i8,
     +          ' (Including Spare Points)',
     +        /,'No. of Spare Points        :',i8,
     +        /,'No. of Connections         :',i8,
     +        /,'No. of Branch Points       :',i8)

      TotFrg = sum(nfrg(1:maxfrg))
      do 610 n=1,maxfrg-1
         write(lo,620) frgsz(n),nfrg(n),100.*(nfrg(n)/TotFrg)
 610  continue
      write(lo,625) frgsz(maxfrg),nfrg(maxfrg),
     *       100.*(nfrg(maxfrg)/TotFrg)
      write(lo,630) ccountMax

      do i = 1, maxfrg
       write(1,'(i5,i8,f6.2)') frgsz(i),nfrg(i),100.*(nfrg(i)/TotFrg)
      enddo

 620  format(' No. of Fragments size .le.',i5,' :',i8,2x,f6.2)
 625  format(' No. of Fragments size .gt.',i5,' :',i8,2x,f6.2)
 630  format(' Maximum Fragment size     ',5x,' :',i8)

      npcn=pcount
      nccn=fcount
      call envsav(npcn,nccn,finlis)
      call mainlv(npcn,nccn)

      return
      end
*----------------------------------------------------------------------*
      subroutine points(index,ix,iy,iz,ival,nnx,nny,nnz)
      USE General
      USE Skeleton

      dimension x1(3)


      ix1 = ix - 1
      iy1 = iy - 1
      iz1 = iz - 1

      dx=1.0/real(nnx)
      dy=1.0/real(nny)
      dz=1.0/real(nnz)

      u=real(ix1)*dx
      v=real(iy1)*dy
      w=real(iz1)*dz

      call frac2orth(u,v,w,x,y,z)

      pntlis(index,1)=x
      pntlis(index,2)=y
      pntlis(index,3)=z
      levlis(index)=ival

      return
      end
*---------------------------------------------------------------------*
      subroutine branch(lno,ccount,bcount,fcount)
      USE General, only : lo
      USE Skeleton
     
      integer ccount,bcount,fcount
      integer ipoint(6)

*---- Index of the branchpoint ----*
      in=brnlis(bcount,1)

*---- No. of branches at this point ----*
      nbrn=brnlis(bcount,5)

*---- Distance to the beginning of the chain ----*
      bln=brnlis(bcount,6)

      in=in*2
      in1=in+1
      icc=ccount+1
      inb=0
      lng=0
      max1=0
      max2=0
      lsto=1
      if (lno.eq.1) lsto=2
      lsfrom=lno
      if (nbrn.le.1) then
         bcount=bcount-1
         return
      endif

*---- Find the two longest branches and their lenght ----*
 10   icc=icc-1
      if (icc.lt.0) then
         write(lo,15) icc
 15      format('Error:**** Branch - Search (ICC= ',i8,')')
         stop
      endif
      icon=conlis(lno,icc)
      if (icon.ne.in .and. icon.ne.in1) then
         lng=lng+1
         goto 10
      endif

*---- Found a Branchpoint ----*
      inb=inb+1
      if (lng.gt.max1) then
         if (max1.ne.0) then
            if (max2.ne.0) then
               lim1=mi2
               lim2=mi2+max2
               call squeze(lsfrom,finlis,fcount,ccount,lim1,lim2)
               if (fcount.gt.maxc) then
                  print*,'Error:****** BR1 *********'
                  stop
               endif
               brnlis(bcount,5)=brnlis(bcount,5)-1
               if (lim2.eq.1) then
                  mi1=mi1-(max2+1)
               endif
            endif
            max2=max1
            mi2=mi1
         endif
         max1=lng
         mi1=icc
      else
         if (lng.ge.max2) then
            if (max2.ne.0) then
               lim1=mi2
               lim2=mi2+max2
               call squeze(lsfrom,finlis,fcount,ccount,lim1,lim2)
               if (fcount.gt.maxc) then
                  print*,'Error:****** BR2 *********'
                  stop
               endif
               brnlis(bcount,5)=brnlis(bcount,5)-1
               if (lim2.eq.1) then
                  mi1=mi1-(lng+1)
               endif
            endif
            max2=lng
            mi2=icc
         else
            lim1=icc
            lim2=icc+lng
            call squeze(lsfrom,finlis,fcount,ccount,lim1,lim2)
            if (fcount.gt.maxc) then
               print*,'Error:****** BR3********'
               stop
            endif
            brnlis(bcount,5)=brnlis(bcount,5)-1
            if (lim2.eq.1) then
               mi1=mi1-(lng+1)
               mi2=mi2-(lng+1)
            endif
         endif
      endif

      lng=0

      if (inb.ne.nbrn) goto 10

*---- Choose between the two branches at this point and the connection
*---- from the starting point

*---- The shortest of the two branches didn't make it transfer it to 
*---- the final list
      if (bln.ge.max2) then
         lim1=mi2
         lim2= mi2+max2
         call squeze(lsfrom,finlis,fcount,ccount,lim1,lim2)
         if (fcount.gt.maxc) then
            print*,'Error:****** BR4********'
            stop
         endif
         bcount=bcount-1
         return
      else

*---- This is a special case: the starting point happens to be the first
*---- branchpoint as well. So we have to invert one of the chains and
*---- connect the other to it.

         if (bln.eq.0) then
            ibeg=1
            lim1=mi2
            lim2=mi2+max2

            call invlis(lsfrom,lsto,ibeg,lim1,lim2,even)

*---- The last element in the new list is overwritten by the first
*---- element from the longest chain

            lim1=mi1
            lim2=mi1+max1
            call movlis(lsfrom,lsto,ibeg,lim1,lim2,odd)
            bcount=bcount-1
            ccount=ibeg
            if (ccount.gt.maxc) then       
               print*,'Error:****** BR5********'
               stop
            endif
            lno=lsto
            return
         else

*---- The connection from starting point is shortest at the moment.
*---- Invert the tree structure to investigate it further.

            ibeg=1
            lim1=mi1
            lim2=mi1+max1
            call invlis(lsfrom,lsto,ibeg,lim1,lim2,even)

            lim1=mi2
            lim2=mi2+max2
            call movlis(lsfrom,lsto,ibeg,lim1,lim2,odd)

            ibeg=ibeg+1
            lim1=1
            lim2=mi1
            if (mi1.gt.mi2) lim2=mi2
            call invlis(lsfrom,lsto,ibeg,lim1,lim2,even)
         endif

         ccount=ibeg
         if (ccount.gt.maxc) then
            print*,'Error:****** BR6********'
            stop
         endif
         lno=lsto

*---- And invert the branch list as well ----*

         j=1
         k=bcount
         lng=max1+brnlis(k,6)

 30      do 40 n=1,6
            ipoint(n)=brnlis(k-j+1,n)
 40      continue
         do 50 n=1,5
            brnlis(k-j+1,n)=brnlis(j,n)
 50      continue
         brnlis(k-j+1,6)=lng-brnlis(j,n)
         do 60 n=1,5
            brnlis(j,n)=ipoint(n)
 60      continue
         brnlis(j,6)=lng-ipoint(6)
         j=j+1
         if (j.lt.k-j+1) goto 30
         if (j.eq.k-j+1) then
            brnlis(j,6)=lng-brnlis(j,6)
         endif
         return
      endif

      end
*---------------------------------------------------------------------*
      subroutine movlis(lsfrom,lsto,ibeg,lim1,lim2,md2)

      USE Skeleton

      m2=mod(conlis(lsfrom,lim1),2)
      conlis(lsto,ibeg)=conlis(lsfrom,lim1)+md2-m2
 10   if (lim1.eq.lim2) goto 100
      ibeg=ibeg+1
      lim1=lim1+1
      conlis(lsto,ibeg)=conlis(lsfrom,lim1)
      goto 10
 
 100  return
      end
*---------------------------------------------------------------------*
      subroutine squeze(lsfrom,lsto,fcount,ccount,lim1,lim2)

      USE Skeleton

      integer lsfrom,lsto,fcount,ccount,lim1,lim2,lim,ccn

      lim=lim1
      ccn=ccount
      md2=even
      lng=lim2-lim1+1
      fcount=fcount+1

      call movlis(lsfrom,lsto,fcount,lim1,lim2,md2)
      if (lim2.lt.ccn) then
         lim1=lim
         lim2=lim2+1
         if (conlis(lsfrom,lim1).eq.conlis(lsfrom,lim2)+1) md2=odd
         call movlis(lsfrom,lsfrom,lim1,lim2,ccn,md2)
         lim2=1
      else
         lim2=0
      endif
      ccount=ccount-lng
   
      return
      end
*---------------------------------------------------------------------*
      subroutine invlis(lsfrom,lsto,ibeg,lim1,lim2,md2)

      USE Skeleton

      iend=lim2-lim1+ibeg+1
      jend=iend
      m2=mod(conlis(lsfrom,lim2),2)
      conlis(lsto,ibeg)=conlis(lsfrom,lim2)-m2+md2

 10   if (lim1.eq.lim2) return
      ibeg=ibeg+1
      lim2=lim2-1
      m2=mod(conlis(lsfrom,lim2),2)
      if (m2.eq.1) then
         conlis(lsto,ibeg)=conlis(lsfrom,lim2)
         goto 10
      else
         icon=conlis(lsfrom,lim2)
         conlis(lsto,ibeg)=icon+1

         if (lim1.eq.lim2) return

 20      lim2=lim2-1
         iend=iend-1
         m2=mod(conlis(lsfrom,lim2),2)
         if (m2.eq.1) then
            if (icon.eq.conlis(lsfrom,lim2)-m2) goto 50
         endif
         conlis(lsto,iend)=conlis(lsfrom,lim2)
         if  (lim1.ne.lim2) goto 20
         goto 55

 50      iend=iend+1
 55      ibeg=ibeg+1
         if (iend.ne.jend) then
            conlis(lsto,ibeg)=conlis(lsto,iend)
            goto 50
         else
            conlis(lsto,ibeg)=conlis(lsfrom,lim2)-m2
            if (lim1.ne.lim2) then
               goto 10
            else
               ibeg=ibeg-1
               brnlis(1,5)=brnlis(1,5)-1
               return
            endif
         endif
      endif

      return
      end
*---------------------------------------------------------*
      subroutine naydx(ix,iy,iz,nnx,nny,nnz,nx1,nx2,ny1,ny2,
     +                 nz1,nz2)

      nx1=ix-1
      nx2=ix+1
      if (nx1.lt.1) nx1=1
      if (nx2.gt.nnx) nx2=nnx

      ny1=iy-1
      ny2=iy+1
      if (ny1.lt.1) ny1=1
      if (ny2.gt.nny) ny2=nny

      nz1=iz-1
      nz2=iz+1
      if (nz1.lt.1) nz1=1
      if (nz2.gt.nnz) nz2=nnz

      return
      end
*-----------------------------------------------------------------*
      subroutine envsav(i1,i2,i3)
      USE General
      USE Skeleton

      npnc=i1
      nccn=i2
      do 10 n=1,nccn
         newcon(n)=conlis(i3,n)
 10   continue

      return
      end
*-----------------------------------------------------------------*
      subroutine mainlv(pcount,ccount)
      USE General
      USE Skeleton


      integer pcount,bcount,ccount,fcount
      integer lev
      logical change


      nmain = 0
      nside = 0

*---- Calculating the length to define skeleton as main chain ----*
      if (lungSK.eq.0) then
        do 10 n=maxfrg,2,-1
           if (nfrg(n).eq.0) goto 10
           mlng=frgsz(n-1)
           goto 20
 10     continue
      else
         mlng=lungSK
      endif

 20   if (mlng.eq.1) then
         write(lo,25)
 25      format('Sorry, Not Enough connectivity found')
         stop
      endif

*---- Points are assigned level according to the lenght of the chain ----*
      change = .true.
      i = 0

  100 i = i+1
      icon = newcon(i)
      md2 = mod(icon,2)
      if(md2.eq.even)then
         if(change)then
            inew = i
            lng = 0
            change = .false.
         else
            i = inew
            nlev = side
            change = .true.
            md2 = even
            call newlev(i,md2,nlev,nmain,nside)
         endif
      else
         if(change)then
            call newlev(i,md2,nlev,nmain,nside)
         else
            lng = lng+1
            if(lng.ge.mlng)then
               nlev = main
               i = inew
               change = .true.
               md2 = even
               call newlev(i,md2,nlev,nmain,nside)
            endif
         endif
      endif
      if(i.lt.ccount)goto 100

      if(i.eq.ccount)then
         if(.not.change)then
            nlev = side
            i = inew
            change = .true.
            md2 = even
            call newlev(i,md2,nlev,nmain,nside)
         endif
      endif

      write(lo,1000) mlng,nmain,nside
 1000 format(//,20x,' minimum mainchain lenght     :',i8
     &,       /,20x,' no. of mainchain connections :',i8
     &,       /,20x,' no. of sidechain connections :',i8)
      end
*------------------------------------------------------------------*
      subroutine newlev(i,md2,nlev,nmain,nside)
      USE General
      USE Skeleton

      icon = newcon(i)
      inx = nint((icon-md2)/2.0)
      if(levlis(inx).lt.nlev) levlis(inx) = nlev
      if(nlev.eq.side)nside = nside+1
      if(nlev.eq.main)nmain = nmain+1
      return
      end

!------------------------------
      subroutine ReadBonesFile(jRBones)
      USE General
      USE Symmetry
      USE Mappa, only: np
      USE Skeleton

      dimension x1(3), x0(3),i1(35)
      character*200 strFile
      
      nBonesPoint = 100000 
       IF (.NOT. ALLOCATED(xyzBones))
     *   allocate (xyzBones(4,nBonesPoint) , stat = ierr)

      iaSk = 0
      iaSk1 = 0
      ibones = 1
      open(ibones,file=BonesFileName,status='old',err=9000)
      write(lo,*)' Read bones file:',
     *          BonesFileName(1:Lung(BonesFileName))

 10   read (ibones,'(a)',end = 100)Buffer1

      if (Buffer1(1:14).eq.'SKEL_ATOM_XYZ') then
         read(ibones,'(a)')Buffer1
         iconSk = 1
      endif
      if (Buffer1(1:14).eq.'SKEL_ATOM_BONE') then
         read(ibones,'(a)')Buffer1
         iconSk = 2
      endif
c     if (Buffer1(1:16).eq.'SKEL_CONNECTIVITY') goto 40
 20   continue

      if (iconSk ==1) goto 30
      if (iconSk ==2) goto 40
c     if (iconSk ==3) goto 50
      goto 10

 30   read(Buffer1,'(3f10.3)') x0(1:3)
      iaSk = iaSk + 1
c     call orth2frac(x0(1),x0(2),x0(3),x1(1),x1(2),x1(3))
c     xyzBones(1:3,iaSk) = x1(1:3)
      xyzBones(1:3,iaSk) = x0(1:3)
      goto 10

 40   continue 

!     leggere il tipo di bones: 
!     1-> left overs; 2->side chain; 3->main chain, 4->spare parts

      if (iaSk1 + 35 < iaSk) then
        iaSk2 = 35
      else
        iaSk2 = iaSk - iaSk1
      endif

      read(Buffer1,'(35i2)') i1(1:iaSk2)
      do i = 1, iaSk2
        iaSk1 = iaSk1 +1
        ii= i1(i)
        xyzBones(4,iaSk1) = ii
      enddo
      goto 10

c50   read(Buffer1,'(35i2)') i1(1:35)
c     do i = 1, 35
c       iaSk1 = iaSk1 +1
c       ii= i1(i)
c       xyzSk(4,iaSk1) = ii
c     enddo


9000  stop
100   close (ibones)

      write(lo,*)'Tot:', iaSk
      write(lo,*)'Main-chain  (3):',count(xyzBones(4,1:iaSk) == 3)
      write(lo,*)'Side-chain  (2):',count(xyzBones(4,1:iaSk) == 2)
      write(lo,*)'Left-overs  (1):',count(xyzBones(4,1:iaSk) == 1)
      write(lo,*)'Spare-parts (4):',count(xyzBones(4,1:iaSk) == 4)
      
      nBonesPoint = iaSk 

      maskSK(:,:,:) = 0.0
      radSphere = -jRBones/100.
      call Atoms2Mask(radSphere,nBonesPoint,1,xyzBones,maskSK)

      strFile=StructureName(1:Lung(StructureName))//'_mask_file.map'
      call CCP4MAPOUT(0,maskSK,np,strFile)

      return
      end
!------------------------------
