#include <utils.h>
#include <string.h>
#include "ilm_callbacks.h"

static GdkColor colorWhite = White;
static mr_action_entry menu_entries[] = {

{0, 1, "File", "_File", "File Operations", NULL, NULL, NULL, -2, 1, 0}, 
{1, 1, "Open", "_Open", "Load input (.ilm) file", "fileopen32", G_CALLBACK(on_OpenBtn_clicked), NULL, -2, 1, 0}, 
{1, 1, "Recent Projects", "_Recent Projects", "Load recent", NULL, NULL, NULL, -2, 1, 0}, 
{2, 1, "recent1", "recent1", "Load recent", NULL, G_CALLBACK (on_recent_activate), NULL, -2, 1, 0}, 
{2, 1, "recent2", "recent2", "Load recent", NULL, G_CALLBACK (on_recent_activate), NULL, -2, 1, 0}, 
{2, 1, "recent3", "recent3", "Load recent", NULL, G_CALLBACK (on_recent_activate), NULL, -2, 1, 0}, 
{2, 1, "recent4", "recent4", "Load recent", NULL, G_CALLBACK (on_recent_activate), NULL, -2, 1, 0}, 
{2, 1, "recent5", "recent5", "Load recent", NULL, G_CALLBACK (on_recent_activate), NULL, -2, 1, 0}, 
{1, 4},
{1, 1, "Quit", "_Exit", "Exit", "quit32", G_CALLBACK(on_QuitBtn_clicked), NULL, -2, 1, 0}, 
{0, 1, "Examples", "_Examples", "Load examples", NULL, NULL, NULL, -2, 1, 0}, 
{1, 1, "example1", "example1", "Load example", NULL, G_CALLBACK (on_recent_activate), NULL, -2, 1, 0}, 
{1, 1, "example2", "example2", "Load example", NULL, G_CALLBACK (on_recent_activate), NULL, -2, 1, 0}, 
{1, 1, "example3", "example3", "Load example", NULL, G_CALLBACK (on_recent_activate), NULL, -2, 1, 0}, 
{1, 1, "example4", "example4", "Load example", NULL, G_CALLBACK (on_recent_activate), NULL, -2, 1, 0}, 
{1, 1, "example5", "example5", "Load example", NULL, G_CALLBACK (on_recent_activate), NULL, -2, 1, 0}, 
{1, 1, "example6", "example6", "Load example", NULL, G_CALLBACK (on_recent_activate), NULL, -2, 1, 0}, 
{1, 1, "example7", "example7", "Load example", NULL, G_CALLBACK (on_recent_activate), NULL, -2, 1, 0}, 
{1, 1, "example8", "example8", "Load example", NULL, G_CALLBACK (on_recent_activate), NULL, -2, 1, 0}, 
{0, 1, "New Project", "_New Project", "Start a new project", NULL, NULL, NULL, -2, 1, 0}, 
{1, 1, "Ab Initio", "_Ab Initio", "Start a new ab initio project", "abinitio", G_CALLBACK(on_SirBtn_clicked), NULL, -2, 1, 0}, 
{1, 1, "Mad/Sad", "Mad/_Sad", "Start a new Mad/Sad project", "madsad", G_CALLBACK(on_MadBtn_clicked), NULL, -2, 1, 0}, 
{1, 1, "Mir/Sir", "_Mir/Sir", "Start a new Mir/Sir project", "mirsir", G_CALLBACK(on_MirBtn_clicked), NULL, -2, 1, 0}, 
{1, 1, "Miras/Siras", "M_iras/Siras", "Start a new Miras/Siras project", "mirassiras", G_CALLBACK(on_MrsBtn_clicked), NULL, -2, 1, 0}, 
{1, 1, "REMO", "ReMo", "Start a new molecular replacement project", "remo", G_CALLBACK(on_MolRepBtn_clicked), NULL, -2, 1, 0}, 
{1, 1, "EDM", "Edm", "Start a new electron density modification project", "edm", G_CALLBACK(on_EdmBtn_clicked), NULL, -2, 1, 0}, 
{1, 1, "dea", "dea", "Start a new Dedm - Edm - Automatic model building project", "dea", G_CALLBACK(on_DeaBtn_clicked), NULL, -2, 1, 0}, 
{0, 1, "HelpM", "_Help", "Help", NULL, NULL, NULL, -2, 1, 0}, 
{1, 1, "Check for Updates", "Check for _Updates", "Check for updates", "checkforupdate", G_CALLBACK(ilmCheckForUpdates), NULL, -2, 1, 0}, 
{1, 1, "Content", "_Content", "Help on Content", "bigcontent", G_CALLBACK(on_HelpBtn_clicked), NULL, -2, 1, 0}, 
{1, 1, "AboutM", "_About", "About ILMILIONE", "help", G_CALLBACK(on_AboutBtn_clicked), NULL, -2, 1, 0}
};

static mr_action_entry tb_entries[] = {
 
{0, 1, "Exit", "Exit", "Exit", "quit32", G_CALLBACK(on_QuitBtn_clicked), NULL, -2, 1, 0}, 
{0, 1, "Load", "Load", "Load input (.ilm) file", "fileopen32", G_CALLBACK(on_OpenBtn_clicked), NULL, -2, 1, 0}, 
{0, 4},
{0, 1, "Settings", "Settings", "Settings", "bigsettings", G_CALLBACK(on_SettingsBtn_clicked), NULL, -2, 1, 0}, 
{0, 4},
{0, 1, "Sir", "Sir", "New ab initio project", "abinitio", G_CALLBACK(on_SirBtn_clicked), NULL, -2, 1, 0}, 
{0, 1, "MadSad", "MadSad", "New MAD/SAD project", "madsad", G_CALLBACK(on_MadBtn_clicked), NULL, -2, 1, 0}, 
{0, 1, "MirSir", "MirSir", "New MIR/SIR project", "mirsir", G_CALLBACK(on_MirBtn_clicked), NULL, -2, 1, 0}, 
{0, 1, "MirasSiras", "MirasSiras", "New MIRAS/SIRAS project", "mirassiras", G_CALLBACK(on_MrsBtn_clicked), NULL, -2, 1, 0}, 
{0, 1, "ReMo", "ReMo", "New Molecular Replacement project", "remo", G_CALLBACK(on_MolRepBtn_clicked), NULL, -2, 1, 0}, 
{0, 1, "Edm", "Edm", "New Electron Density Modification / FreeLunch project", "edm", G_CALLBACK(on_EdmBtn_clicked), NULL, -2, 1, 0}, 
{0, 1, "DEA", "DEA", "Dedm - Edm - Automatic model building", "dea", G_CALLBACK(on_DeaBtn_clicked), NULL, -2, 1, 0}, 
{0, 4},
{0, 1, "About", "About", "About ILMILIONE", "bigabout", G_CALLBACK(on_AboutBtn_clicked), NULL, -2, 1, 0}, 
{0, 1, "Help", "Help", "Help on-line", "bigcontent", G_CALLBACK(on_HelpBtn_clicked), NULL, -2, 1, 0}
};
 

static guint n_menu_entries = G_N_ELEMENTS (menu_entries);
static guint n_tb_entries = G_N_ELEMENTS (tb_entries);

#ifdef USE_ACTIONS
//static const gchar *ui_info =
static const gchar *menu_info =
"<ui>"
"  <menubar name='MenuBar'>"
"    <menu action='File'>"
"      <menuitem action='Open'/>"
"      <menu action='Recent Projects'>"
"        <menuitem action='recent1'/>"
"        <menuitem action='recent2'/>"
"        <menuitem action='recent3'/>"
"        <menuitem action='recent4'/>"
"        <menuitem action='recent5'/>"
"      </menu>"
"      <menuitem action='Exit'/>"
"    </menu>"
"    <menu action='Examples'>"
"    <menuitem action='example1'/>"
"    <menuitem action='example2'/>"
"    <menuitem action='example3'/>"
"    <menuitem action='example4'/>"
"    <menuitem action='example5'/>"
"    <menuitem action='example6'/>"
"    <menuitem action='example7'/>"
"    <menuitem action='example8'/>"
"    </menu>"
"    <menu action='New Project'>"
"    <menuitem action='Ab Initio'/>"
"    <menuitem action='Mad/Sad'/>"
"    <menuitem action='Mir/Sir'/>"
"    <menuitem action='Miras/Siras'/>"
"    <menuitem action='ReMo'/>"
"    <menuitem action='Edm'/>"
"    <menuitem action='dea'/>"
"    </menu>"
"    <menu action='HelpM'>"
"    <menuitem action='Check for Updates'/>"
"    <menuitem action='Content'/>"
"    <menuitem action='About'/>"
"    </menu>"
"   </menubar>"
"</ui>";
static const gchar *tb_info =
"<ui>"
"  <toolbar name='ToolBar'>"
"    <toolitem action='Exit'/>"
"    <toolitem action='Open'/>"
//"    <separator/>"
"    <toolitem action='Settings'/>"
"    <toolitem action='Ab Initio'/>"
"    <toolitem action='Mad/Sad'/>"
"    <toolitem action='Mir/Sir'/>"
"    <toolitem action='Miras/Siras'/>"
"    <toolitem action='ReMo'/>"
"    <toolitem action='Edm'/>"
"    <toolitem action='dea'/>"
"    <separator/>"
"    <toolitem action='About'/>"
"    <toolitem action='Content'/>"
"   </toolbar>"
"</ui>";

#endif

void do_menu_and_toolbar(GtkWidget *table, GtkWidget *window,
          const char *fontname, int w, int h)
{
     GtkWidget *menubar, *toolbar;

#ifdef USE_ACTIONS
     GtkActionGroup *group = CreateActionGroup(window, n_menu_entries, menu_entries, "MenuBar");
     group = CreateActionGroup(window, n_tb_entries, tb_entries, "Toolbar");
     GtkUIManager *merge = gtk_ui_manager_new ();
     gtk_ui_manager_insert_action_group (merge, group, -1);
     gtk_window_add_accel_group (GTK_WINDOW (window),
                                  gtk_ui_manager_get_accel_group (merge));
     g_object_set_data_full (G_OBJECT (window), "ui-manager", merge,
                              g_object_unref);
     menubar = CreateMenubar(window, menu_info, merge, group);
     toolbar = CreateToolbar(window, tb_info, merge, group);
     GtkIconSize myIconSize = gtk_icon_size_register("myIconSize", 32, 32);
#if (GTK_MAJOR_VERSION >= 3) || (GTK_MINOR_VERSION > 10)
     gtk_toolbar_set_icon_size(GTK_TOOLBAR(toolbar), myIconSize);
#endif
//     widget_modify_bg(toolbar, GTK_STATE_NORMAL, &colorWhite);
     gtk_toolbar_set_show_arrow(GTK_TOOLBAR(toolbar), FALSE);
#else
     menubar = CreateMenubar(window, menu_entries, n_menu_entries, w, h);
     toolbar = CreateToolbar (window, 0, tb_entries, n_tb_entries);
#endif
     widget_modify_bg(toolbar, GTK_STATE_NORMAL, &colorWhite);

     if(menubar)
     {
#ifndef MAC_INTEGRATION
     table_attach (table, menubar, 0, 1, 0, 1, TRUE);
     gtk_widget_show (menubar);
#endif
     SetMainMenu(menubar, true);
     }
     if(toolbar)
     {
     table_attach (table, toolbar, 0, 1, 1, 2, TRUE);
     gtk_widget_show (toolbar);
     }
}
