#ifdef HAVE_CONFIG_H
#  include <config.h>
#else
#  include <config_any.h>
#endif

#include "cutils.h"
#include "libcomune.h"
#include <cstring>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <cctype>
#include <cstdarg>

#ifdef _WIN32
#include <windows.h>
#include <direct.h>
#else
#include <sys/types.h>
#include <unistd.h>
#endif
#include <sys/stat.h>

#include <sir_application.h>

void GetMessCodes(WindoMess *winmess)
{
     winmess->F_INFO_WINDOW         = INFO_WINDOW;
     winmess->F_QUEST_WINDOW        = QUEST_WINDOW;
     winmess->F_QUEST_WINDOW_R      = QUEST_WINDOW_R;
     winmess->F_QUEST_WINDOW_YES_NO = QUEST_WINDOW_YES_NO;
     winmess->F_QUEST_WINDOW_NO_YES = QUEST_WINDOW_NO_YES;
     winmess->F_WARN_WINDOW         = WARN_WINDOW;
     winmess->F_ERR_WINDOW          = ERR_WINDOW;
     winmess->F_SEVERE_ERR_WINDOW   = SEVERE_ERR_WINDOW;
}

int dir_set_current(const gchar *dir)
{
    if(dir == NULL)
       return -1;
#ifdef _WIN32                        // locale support
    return _chdir(fromUTF8(dir).c_str());
#else 
    return chdir(dir);
#endif
}

int MsgWinErr_nogtk(const char *cmsg, int type)
{
    size_t sz1 = strlen(cmsg)+50;
    char *messaggio = (char *) malloc(sz1*sizeof(char));
    size_t sz = strlen(cmsg)+120;
    char *msg = (char *)malloc(sz * sizeof(char));
    formatta_msg(messaggio, sz1, cmsg, 40);
    type = -type;
    if(type == SEVERE_ERR_WINDOW)
       ScriviStringa(msg, sz, "%s\nProgram will be terminated.", messaggio);
    else
       ScriviStringa(msg, sz, "%s\n", messaggio);
#ifdef _WIN32
   {
       (void) AllocConsole();
       char c;
       ScriviStringa(msg, sz, "%s\nPress <Enter> to continue\n", messaggio);
       DWORD nchar;
       HANDLE inp = GetStdHandle(STD_INPUT_HANDLE);
       HANDLE out = GetStdHandle(STD_OUTPUT_HANDLE);
       WriteConsole(out, msg, (DWORD) strlen(msg), &nchar, NULL);
       ReadConsole (inp, &c, 1, &nchar, NULL);
       FreeConsole();
   }
#else
    printf("%s\n", msg);
#endif
    if(type >= SEVERE_ERR_WINDOW)
        exit(-1);
    else
        return 0;
}

