*-----------------------------------------------------------------------*
*----               Envelope  Subroutines                           ----*
*-----------------------------------------------------------------------*
      subroutine Long_Env_New(numbDyn,jpatt)
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE Param
      USE PhaseModule
!
      if (ifExpanded > 0) then ! occhio
         ihmx=ihmxSav
         rhomax = maxval(rhov(1:nrefl))
      endif
      Renve = RenveDyn
c----
      if (jpatt == 0) then
          call envelope(numbDyn,npunti)
      else
          call envelope_Patt(numbDyn,npunti)
      endif
c
      if (ifExpanded > 0) then ! occhio
         ihmx=ihmxExt
         rhomax = maxval(rhov(1:nrefltot))
      endif
c

c----
      return
      end
*-----------------------------------------------------------------------*
*----               Envelope  Subroutine                            ----*
*-----------------------------------------------------------------------*
      subroutine envelope(numb,npts)
      USE General
      USE Riflessi
      Use Mappa
      USE Param
      USE PhaseModule
!
      v_p_sav = v_p
c     if (Iterazione >= nIterazioni/2 .and. mod(Iterazione,2) == 1) then
c         v_p = v_p * 0.8 !1.2
c         write(6,*)  'Iterazione, v_p = ',Iterazione, v_p_sav, v_p
c     endif
*---- change  V_P
*---- change F000
      f000_old=f000
      f000=volume*(0.32*(1.0-v_p)+0.43*v_p)
!     write(6,*)'volume,v_p,f000,np',volume,v_p,f000,np
*---- change F000

      do i=1,numb
         fcoef(i) = fovet(i) * wt(i)
      enddo
      jpatt = 0
!g    call MakeMap(fcoef, iphaz, numb, jpatt, xmap,
      call MakeMap(fcoef, iphaz, numb, jpatt, xenve,
     *                     FORTHenv,BACKenv)

*     if (knw == 1) then
*         write(lo,*)'      *        ENVELOPE SECTION        *'
*     endif
!
!-- sposto la mappa per l'envelope su xenve
!
!g    xenve(0:np(1)-1,0:np(2)-1,0:np(3)-1) = 
!g   *                   xmap(0:np(1)-1,0:np(2)-1,0:np(3)-1)
c
      if (kverbo.gt.0) then
      write(lo,*)
      write(lo,*)'      **********************************'
      write(lo,*)'      *        ENVELOPE SECTION        *'
      write(lo,*)'      **********************************'
      endif
c
*---- jflag=0 Non modifica la densita'  ----*
*---- jflag=1 Modifica la densita': troncare a " den_p " + parte negativa ----*
*---- jflag=2 Modifica la densita': troncare la parte negativa--*
*---- jflag=3 Modifica la densita': troncare a " den_s "  ----*
*---- jflag=4 Modifica la densita': troncare la parte < SOGmin e > SOGmax ----*
*---- jflag=5 Modifica la densita': modifca la parte relativa all'envelope ----* 
c
      jflag = 4
      sog = 0.0
      jrel1 = 0
      call changemap_env(xenve,xenve,sog,jflag,jrel1)

*---- Make the envelop map  (envelope molecolare) ----*
      call newenv()

      npts=v_p*(np(1)*np(2)*np(3))
      call envhistOld(xenve,npts)

*---- Make the envelop Mask ----*
      call envmaskOld(xenve,den_p,npunti,jpatt)


      if (kverbo.gt.0) then
          write(lo,1000)Renve,v_p*100.0,0.5/sqrt(rhomax),f000/volume,
     +             den_p/volume,npunti
      endif

 1000 format (/,'   Radius (A) ................ ',f6.2,/,
     +          '   Volume (%) ................ ',f6.2,/,
     +          '   Resolution (A) ............ ',f6.2,/,
     +          '   F000 ...................... ',f8.4,/,
     +          '   Mask Level ................ ',f7.3,/,
     +          '   Envelope grid point ....... ',i8,/)

 1111 format (/,'   ---------  ENVELOPE  ------ ',/,
     +          '   Radius (A) ................ ',f6.2,/,
     +          '   Mask Level ................ ',f7.3,/,
     +          '   Envelope grid point ....... ',i8,/)


*---- change F000
      f000=f000_old
*---- change  V_P
      v_p = v_p_sav
*---- change  V_P
      return
      end
*-----------------------------------------------------------------------*
*----           Envelope for Patterson  Subroutine                  ----*
*-----------------------------------------------------------------------*
      subroutine envelope_Patt_Fo(numb,npts)
      USE General
      USE Riflessi
      Use Mappa
      USE Param
      USE PhaseModule
!
*---- change F000
      f000_old=f000
      f000=volume*(0.32*(1.0-v_p)+0.43*v_p)
!     write(6,*)'volume,v_p,f000,np',volume,v_p,f000,np
*---- change F000
      nptmap = np(1) * np(2) * np(3)

      do i=1,numb
         fcoef(i) = fovet(i) * fovet(i) * wt(i)
      enddo
      jpatt = 1
      call MakeMap(fcoef, iphaz, numb, jpatt, xmap,
     *                     FORTHenv,BACKenv)
!
!-- sposto la mappa per l'envelope su xenve
!
      xenve(0:np(1)-1,0:np(2)-1,0:np(3)-1) = 
     *                   xmap(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      call maxmin_dedi(np(1),np(2),np(3),xenve)
!     call Write_CCP4_Map(xenve, 11)
c
      if (kverbo.gt.0) then
      write(lo,*)
      write(lo,*)'      **********************************'
      write(lo,*)'      *  PATT. ENVELOPE SECTION        *'
      write(lo,*)'      **********************************'
      endif
c
*---- jflag=0 Non modifica la densita'  ----*
*---- jflag=1 Modifica la densita': troncare a " den_p " + parte negativa ----*
*---- jflag=2 Modifica la densita': troncare la parte negativa--*
*---- jflag=3 Modifica la densita': troncare a " den_s "  ----*
*---- jflag=4 Modifica la densita': troncare la parte < SOGmin e > SOGmax ----*
*---- jflag=5 Modifica la densita': modifca la parte relativa all'envelope ----* 
c
!     jflag = 1
!     den_p =  3.0 * stden
      jflag = 2
      sog = 0.0
      jrel1 = 0
      call changemap_env(xenve,xenve,sog,jflag,jrel1)
!     call maxmin_dedi(np(1),np(2),np(3),xenve)
!     call Write_CCP4_Map(xenve, 22)

*---- Make the envelop map  (envelope molecolare) ----*
      call newenv()
      call maxmin_dedi(np(1),np(2),np(3),xenve)
      call Write_CCP4_Map(xenve, 33)

      npts=v_p*(np(1)*np(2)*np(3))
      call envhistOld(xenve,npts)

*---- Make the envelop Mask ----*
!     call envmask(xenve,den_p,npunti,jpatt)
!     call maxmin_dedi(np(1),np(2),np(3),xenve)
!     call Write_CCP4_Map(xenve, 44)


!     if (kverbo.gt.0) then
          write(lo,1000)Renve,v_p*100.0,0.5/sqrt(rhomax),f000/volume,
     +             den_p/volume,nptmap,npts
!    +             den_p/volume,nptmap,npts,npunti
!     endif

 1000 format (/,'   Radius (A) ................ ',f6.2,/,
     +          '   Volume (%) ................ ',f6.2,/,
     +          '   Resolution (A) ............ ',f6.2,/,
     +          '   F000 ...................... ',f8.4,/,
     +          '   Mask Level ................ ',f7.3,/,
     +          '   Map      grid points ...... ',i8,/,
     +          '   Proteins grid points ...... ',i8,/)
!    +          '   Envelope grid points ...... ',i8,/)

 1111 format (/,'   ---------  ENVELOPE  ------ ',/,
     +          '   Radius (A) ................ ',f6.2,/,
     +          '   Mask Level ................ ',f7.3,/,
     +          '   Envelope grid points ...... ',i8,/)


*---- change F000
      f000=f000_old

      return
      end
*-----------------------------------------------------------------------*
*----           Envelope for Patterson  Subroutine                  ----*
*-----------------------------------------------------------------------*
      subroutine envelope_Patt(numb,npts)
      USE General
      USE Riflessi
      Use Mappa
      USE Param
      USE PhaseModule
!
      nptmap = np(1) * np(2) * np(3)

!
!-- sposto la mappa per l'envelope su xenve
!
      xenve(0:np(1)-1,0:np(2)-1,0:np(3)-1) = 
     *                   xmap(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      call maxmin_dedi(np(1),np(2),np(3),xenve)
!     call Write_CCP4_Map(xenve, 11)
c
      if (kverbo.gt.0) then
      write(lo,*)
      write(lo,*)'      **********************************'
      write(lo,*)'      *  PATT. ENVELOPE SECTION        *'
      write(lo,*)'      **********************************'
      endif
c
*---- jflag=0 Non modifica la densita'  ----*
*---- jflag=1 Modifica la densita': troncare a " den_p " + parte negativa ----*
*---- jflag=2 Modifica la densita': troncare la parte negativa--*
*---- jflag=3 Modifica la densita': troncare a " den_s "  ----*
*---- jflag=4 Modifica la densita': troncare la parte < SOGmin e > SOGmax ----*
*---- jflag=5 Modifica la densita': modifca la parte relativa all'envelope ----* 
c
!     jflag = 1
!     den_p =  3.0 * stden
      jflag = 2
!     jflag = 4
      sog = 0.0
      jrel1 = 0
      call changemap_env(xenve,xenve,sog,jflag,jrel1)
!     call maxmin_dedi(np(1),np(2),np(3),xenve)
!     call Write_CCP4_Map(xenve, 22)

*---- Make the envelop map  (envelope molecolare) ----*
      call newenv()
      call maxmin_dedi(np(1),np(2),np(3),xenve)
      call Write_CCP4_Map(xenve, 33)

      npts=v_p*(np(1)*np(2)*np(3))
!     if (kverbo.gt.0) then
          write(lo,1000)Renve,v_p*100.0,0.5/sqrt(rhomax),
     +             nptmap,npts
!     endif

 1000 format (/,'   Radius (A) ................ ',f6.2,/,
     +          '   Volume (%) ................ ',f6.2,/,
     +          '   Resolution (A) ............ ',f6.2,/,
     +          '   Map      grid points ...... ',i8,/,
     +          '   Proteins grid points ...... ',i8,/)


      return
      end
*-----------------------------------------------------------*
      function g_sold(r,sinl,pi)
      dimension pp(6)
       

      s=2.0*sinl
      u=2.0*pi*s
      x=r*u

      if (x.le.0.01) then
         g_sold=1.0
      else
!        y=3.0 * ( sin(x) - x*cos(x) )/ (x**3)
!        z=3.0 * ( 2.0*x*sin(x) - (x**2 -2.0)*cos(x) - 2.0)/(x**4)
!        g_sold=4.0*(y - z)
       y = (sin(x)-cos(x)*x)*3.0/x**3
       z = ((x**2*3.0-6.0)*sin(x)-(x**3-6.0*x)*cos(x))*3.0/x**5
       g_sold = 2.5*(y - z)
      endif

      return
      end

*---------------------------------------------------------*
      subroutine envmaskOld(x,den,npunti,jpatt)
      USE General
      USE Symmetry
      USE Mappa, only : np
      USE PhaseModule
!
      real x(1:np(1),1:np(2),1:np(3))


!     write(6,*) 'ENVMASK - DEN', den

      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      npunti=0

      if (jpatt == 0) then
          if (ksize.gt.4.or.no(nk).ge.20) then
              sogenv = 50.0
              if ( LowRes.eq.0 ) sogenv = 0.0
          else
              sogenv = -100.0
          endif
      else
          sogenv = 0.0
      endif



!     write(6,*) 'SOGENV = ',sogenv

      do iz=1,nnz
         do iy=1,nny
            do ix=1,nnx
               xx=x(ix,iy,iz)
               if (xx.gt.den) then
                   x(ix,iy,iz) = 100.0
!                  x(ix,iy,iz) = 200.0    ! per il flipping
                   npunti=npunti+1
               else
                   x(ix,iy,iz) = sogenv
               endif
            enddo
         enddo
      enddo    

      return
      end
*---------------------------------------------------*
*----          Subroutine flatmap           --------*
*---------------------------------------------------*
      subroutine flatmapOld(x,x1,icont,Xflip)
      real x(*),x1(*)
*---- Statistics with envelop + our map ----*

c     call st_env_map(x,x1)

*---- Modify the density  FLATMAP ----*
       call aggmaskOld(x,x1,icont,Xflip)

      return
      end
*--------------------------------------------------------------------*
      subroutine st_env_map(x,x1)
      USE General
      USE Mappa, only : np
      USE Param
!
      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))
!
!     call scrper(' Statistic: Mask + Map',0,0)
!
      nnx=np(1)
      nny=np(2)
      nnz=np(3)
      npunti=nnx*nny*nnz

*------
      depr=0.0
      rmsp=0.0
      npp=0
      npn=0
      repp=0.0
      repn=0.0
      deso=0.0
      rmss=0.0
      nsp=0
      nsn=0
      resp=0.0
      resn=0.0

      do 150 iz=1,nnz
        do 100 iy=1,nny
            do 50 ix=1,nnx
               xx=x(ix,iy,iz)
               xx1=x1(ix,iy,iz)/100.0
               if (xx1.eq.1.0) then
                  if (xx.gt.0.0) then
                     npp=npp+1
                  else
                     npn=npn+1
                  endif
                  depr=depr + xx
                  rmsp=rmsp + xx*xx
               else
                  if (xx.ne.0.0) then
                     if (xx.gt.0.0) nsp=nsp+1
                     if (xx.lt.0.0) nsn=nsn+1
                     deso=deso +xx
                     rmss=rmss + xx*xx
                  endif
               endif

  50        continue
 100    continue
 150  continue
      
*-----
      if ( (npp+npn) .gt. 0) then
         depr=depr/float(npp+npn)
         rmsp= (rmsp/float(npp+npn)) - depr*depr
         rmsp= sqrt(rmsp)
         repp=float(npp)/float(npp+npn) * 100.0
         repn=float(npn)/float(npp+npn) * 100.0
      endif

      if ( (nsp+nsn) .gt. 0) then
         deso=deso/float(nsp+nsn)
         rmss= (rmss/float(nsp+nsn)) - deso*deso
         rmss= sqrt(rmss)
         resp=float(nsp)/float(nsp+nsn) * 100.0
         resn=float(nsn)/float(nsp+nsn) * 100.0
      endif

*---- Impresion de valores ----*
      write(lo,90)
      write(lo,105)
      write(lo,110) npp,repp,nsp,resp
      write(lo,120) npn,repn,nsn,resn
      write(lo,130) depr/volume,deso/volume
      write(lo,140) rmsp/volume,rmss/volume

  90  format(//,15x,'***---- Statistic Fourier Map - Envelope ----***')
 105  format(/,5x,'**---- ( Protein Zone ) -**',15x,
     *            '**---- ( Solvent Zone ) --**',/)
 110  format(5x,'N. points (+):',i8,3x,'(',f5.1,'%)',9x,
     *          'N. points (+):',i8,3x,'(',f5.1,'%)')
 120  format(5x,'N. points (-):',i8,3x,'(',f5.1,'%)',9x,
     *          'N. points (-):',i8,3x,'(',f5.1,'%)')
 130  format(5x,'Average density:',f8.3,18x,'Average density:',f8.3)
 140  format(5x,'R.M.S.  density:',f8.3,18x,'R.M.S.  density:',f8.3)

      return
      end
*-------------------------------------------------------*
      subroutine aggmaskOld(x,x1,icont,Xflip1)
      USE General
      USE Symmetry
      USE Mappa, only : np
      USE Param
      USE PhaseModule
!
      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))

      adjden=0.0
      attun=1.0

      solden=0.0
      if (icont.eq.2) solden = 0.32*volume
      nnx=np(1)
      nny=np(2)
      nnz=np(3)
      npunti=nnx*nny*nnz

      npt1=0
      npt2=0
      nptF=0
      nptw05=0
      nptw07=0
      do 150 iz=1,nnz
        do 100 iy=1,nny
            do 50 ix=1,nnx
               xx=x(ix,iy,iz)
               kxx1=nint(x1(ix,iy,iz)) / 100
               if (kxx1.eq.1) then
                  npt1=npt1+1
               elseif (kxx1.eq.2) then
                  npt2=npt2+1
                  x(ix,iy,iz)=0
                  if (Xflip1.ne.0.0) then
                     xxnew=deso + Xflip1*(xx-deso)
                     if (xxnew.lt.0.0) x(ix,iy,iz) = nint(xxnew)
                     nptF=nptF+1
                  endif
               else
                  if (kxx1.eq.0) nptw05=nptw05+1
                  if (icont.eq.1) then
                     x(ix,iy,iz)=nint(xx*0.50)
                     if(ResEff>sogResEff.and.ksize>4) then
                         x(ix,iy,iz)=-nint(xx)
                     endif
                  endif
               endif
 50         continue
 100     continue
 150  continue

      if (kverbo.gt.0) then
          write(lo,500)
          if (npt1.gt.0) write(lo,1000) npt1,(npt1/float(npunti))*100.0
          if (nptw05.gt.0) write(lo,1500) nptw05,
     *                 (nptw05/float(npunti))*100.0
      endif

  500 format(20x,/,'  ----- MASK ----- ')
 1000 format(6x,'W.eq.1.0 =',i10,2x,'( ',f6.2,'% )')
 1500 format(6x,'W.eq.0.5 =',i10,2x,'( ',f6.2,'% )',/)
c1600 format(6x,'W.gt.0.5 =',i10,2x,'( ',f6.2,'% )')
c2000 format(6x,'W.eq.0.0 =',i10,2x,'( ',f6.2,'% )',/)

      return
      end
*--------------------------------------------------------------------*
      function errefunc(i,j,a1,b1,b2)

      x=b1 * float(i)
      y=b2 * float(j)

      d2=x**2 + y**2 + 2.0 * x * y * a1

      errefunc=0.0
      if (d2.gt.0.0) errefunc=sqrt(d2)

      return
      end

c------------------------------------------------------------------
      subroutine envhistOld(x,npts)
      USE General
      USE Symmetry
      USE Mappa, only : np
      USE Param
!
      real x(1:np(1),1:np(2),1:np(3))
!
      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      denmin=1.0e25
      denmax=-1.0e25
      call maxminE(nnx,nny,nnz,x)

      nrange=500
      rang=(denmax - denmin)/nrange
      npunti=0
      do 10 i=1,nrange+1
         hisp(i)=0.0
         hisp1(i)=0.0
         range(i)=denmin + rang*(i-1)
 10   continue

      do 150 kz=1,nnz
         do 100 ky=1,nny
           do 50 kx=1,nnx
               xx=x(kx,ky,kz)
               n=int((xx-denmin)/rang) + 1
               if (n.gt.nrange) n=nrange
               if (n.le.1) n=1
               hisp(n)=hisp(n)+1.0

 50         continue
 100     continue
 150  continue

      jflag=1
      npts1=npts
      call findsogE(den_p,npts1,jflag)
      npts1=nint(npunti*v_p)
      call findsogE(den_s,npts1,jflag)

      return
      end
c------------------------------------------------------------------
      subroutine findsogE(sogden,npts,jflag)
      USE General
      USE Param
!
      rang=(denmax - denmin)/nrange
      if (jflag.gt.0) then
         ires=0
         do 10 i=nrange+1,2,-1
            if (jflag.eq.1) ires=ires+hisp(i-1)
            if (jflag.eq.2) ires=ires+hisp1(i-1)
            if (ires.ge.npts) then
               sogden=denmin + (rang*(i-2) + rang/2)
               goto 20
            endif
 10      continue
 20      continue
c---------------
      else
         ires=0
         res=0.0
         do 30 i=nrange+1,2,-1
            res=range(i-1)
            if (jflag.eq.-1) ires=ires + hisp(i-1)
            if (jflag.eq.-2) ires=ires + hisp1(i-1)
            if (res.le.sogden) then
               npts=ires
               goto 40
            endif
 30      continue
 40      continue
      endif
!     write(6,*) 'SOGDEN',sogden,npts,denmax,denmin,nrange
      return
      end

*----------------------------------------------------------------------------*
      subroutine maxminE(nnx,nny,nnz,x)
      USE General
      USE Param
!
      real x(1:nnx,1:nny,1:nnz)
!
      denmin =  1.0e25
      denmax = -1.0e25
      avden  =  0.0
      stden  =  0.0
      do iz = 1, nnz
       do iy = 1, nny
        do ix = 1, nnx
           xx=x(ix,iy,iz)
           denmax=amax1(denmax,xx)
           denmin=amin1(denmin,xx)
           avden=avden + xx
           stden=stden + xx * xx
        enddo
       enddo
      enddo

      avden=avden/float(nnx*nny*nnz)
      stden=stden/float(nnx*nny*nnz) - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif

      return
      end
*---------------------------------------------------*
      subroutine newenv()
      USE General
      USE Symmetry
      USE Mappa
      USE Param
! 
      integer lmod,hs,h

      integer,allocatable::hkl(:)
      real, allocatable::refle(:,:)

      complex fm, sf, phasec
      logical hemiFFTW
      
      external lmod, hemiFFTW

      ncol = 2
c     ndim1 = numestref()  ! per hkl e refle 
      res  = 0.5/sqrt(rhomax)
      ndim1 = (4.0*Pi*volume)/(3.0*res**3)

      allocate (hkl(ndim1), stat=ier)
      if (ier.ne.0) print *, 'allocate HKL in newenve error'

      allocate (refle(ncol,ndim1), stat=ier)
      if (ier.ne.0) print *, 'allocate REFLE in newenve error'

      n1 = np(1)
      n2 = np(2)
      n3 = np(3)
      n0 = np(1) / 2 + 1
*---- Scale ----*
      scfft=1.0/real(n1 * n2 * n3)

!!gpu call sfftw_execute(BACKenv)
      call sfftw_executer2c(n1,n2,n3,BACKenv,xenve,xmapC)

*---- All hkl for wang ----*

c     ip5=256*(262144+512+1)
      ntt=0

      nh=2*ihmx(1)+1
      nkk=n2
      nl=ihmx(3)+1
      hs=-ihmx(1)

      m=0
      kmin=-ihmx(2)
      h=hs-1
      mk=ihmx(2) - kmin +1
 
      do ih=1,nh
         h=h+1
         k=kmin-1
         do ik=1,mk
            k=k+1
            l=-1
            do il=1,nl
               l=l+1

*---           Eliminando (-h,-k,0) ---*
*---           Eliminando (-h, k,0) ---*
*---           Eliminando ( 0,-k,0) ---*

               if ( h.lt.0 .and. l.eq.0 ) cycle
               if ( h.eq.0 .and. k.lt.0 .and. l.eq.0 ) cycle   
               if ( h.eq.0 .and. k.eq.0 .and. l.eq.0 ) cycle   

               sinl=rhof(pp,h,k,l)
               s=sinl*sinl
               if (s.gt.rhomax) cycle   
c

               sf=cmplx(0.0,0.0)
               if (hemiFFTW(h,k,l)) then
                  iu = lmod(h, n0)
                  iv = lmod(k, n2)
                  iw = lmod(l, n3)
                  sf = conjg(xmapC(iu,iv,iw)) 
               else
                  iu = lmod(-h, n0)
                  iv = lmod(-k, n2)
                  iw = lmod(-l, n3)
                  sf =       xmapC(iu,iv,iw)  
               endif
               wwt=g_sold(Renve,sinl,pi)
               sf=sf*scfft*wwt

               ntt=ntt+1
               iih=h
               iik=k
               iil=l
               call pack2002(ihj,iih,iik,iil)
               hkl(ntt)=ihj
c              hkl(ntt)=ip5+(262144*h+512*k+l)
               refle(1,ntt)=real(sf)
               refle(2,ntt)=aimag(sf)
            enddo
         enddo
      enddo
!
      xmapC(:,:,:) = cmplx(0.0,0.0)
!
      do i=1,ntt
         ihj=hkl(i)
c        h=ihj/262144-256
c        l=ihj-262144*(h+256)
c        k=l/512-256
c        l=l-512*(k+256)-256
         call unpack2002(ihj,h,k,l)

         fm = cmplx(refle(1,i), refle(2,i))

         if (h.ge.0) then
            ih = lmod(h, n0)
            ik = lmod(k, n2)
            il = lmod(l, n3)
            xmapC(ih,ik,il) = conjg(fm)
         endif

         if (-h.ge.0) then
            ih = lmod(-h, n0)
            ik = lmod(-k, n2)
            il = lmod(-l, n3)
            xmapC(ih,ik,il) = fm
         endif

      enddo

      xmapC(0,0,0) = cmplx(f000, 0.0)
!!gpu call sfftw_execute(FORTHenv)
      call sfftw_executec2r(n1,n2,n3,FORTHenv,xmapC,xenve)

      deallocate (hkl, stat=ier)
      deallocate (refle, stat=ier)

      return
      end
*------------------------------------------------------------------*
      subroutine changemap_env (x,x1,sog,jflag,jrel1)
      USE General
      USE Mappa, only : np
      USE Param
! 
      common/puntic/npu1,npu2,npu3,npu4

      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))
 
c- metodo di Wang - jflag = 4
      SOGmin=0.32*volume
      SOGmax=2.0*volume
c- metodo di Wang
      nnx=np(1)
      nny=np(2)
      nnz=np(3)
      n_p=0

      do k=1,nnz
         do j=1,nny
            do i=1,nnx
               xx=x(i,j,k)
               if (jrel1.gt.0) xx1=x1(i,j,k)/100.0
               if (sog.gt.0.0.and.x(i,j,k).gt.sog) then
                    x(i,j,k)=sog
                    npu1=npu1+1
               endif

               if (jflag.eq.1) then
*----------------
                  if (xx.lt.den_p.or.xx.le.0.0) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                     if (jrel1.gt.0) then
                         if (xx1.eq.1.0) then
                             npu2=npu2+1
                         elseif (xx1.eq.0.5) then
                             npu3=npu3+1
                         else
                             npu4=npu4+1
                         endif
                     endif
                  endif
*----------------
               elseif (jflag.eq.2) then
                  if ( xx.le.0.0 ) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                     if (jrel1.gt.0) then
                         if (xx1.gt.0.0.and.xx1.lt.2.0) then
                             if (xx1.eq.1.0) then
                                npu2=npu2+1
                             elseif (xx1.eq.0.5) then
                                npu3=npu3+1
                             else
                                npu4=npu4+1
                             endif 
                         endif
                     endif
                  endif
*----------------
               elseif (jflag.eq.3) then
                  if ( xx.lt.den_s ) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                  endif
*----------------
               elseif (jflag.eq.4) then
                  if ( xx.lt.SOGmin ) then
                     x(i,j,k)=SOGmin
                  elseif ( xx.gt.SOGmax ) then
                     x(i,j,k)=SOGmax
                     n_p=n_p+1
                  endif
*----------------
               elseif (jflag.eq.5) then
                  if (xx1.eq.1.0) then
                     if (xx.lt.den_p) then
                        x(i,j,k)=0.0
                        n_s=n_s+1
                     else
                        n_p=n_p+1
                        npu2=npu2+1
                     endif
                  else
                     if (xx.lt.den_s) then
                         x(i,j,k)=0.0
                         n_s=n_s+1
                     else
                        n_p=n_p+1
                        npu3=npu3+1
                     endif
                  endif
*----------------
               else
                  n_p=n_p+1
               endif
            enddo
         enddo
      enddo

      return
      end
c---------------------------------------------------------------------------
      integer function numestref ()
      USE General
      USE Symmetry

      integer hmax,hmin,kmax,kmin,lmax,lmin
      
      
      rmax=sqrt(0.5/rhomax)
      hmax=int(cell(1)/rmax)
      kmax=int(cell(2)/rmax)
      lmax=int(cell(3)/rmax)

      hmin=-hmax
      kmin=-kmax
      lmin=-lmax

      num=0
 
      do 300 il=lmin,lmax
         do 200 ik=kmin,kmax
            do 100 ih=hmin,hmax

*---           Eliminando (-h,-k,0) ---*
*---           Eliminando (-h, k,0) ---*
*---           Eliminando ( 0,-k,0) ---*

               if ( ih.lt.0 .and. il.eq.0 ) goto 100
               if ( ih.eq.0 .and. ik.lt.0 .and. il.eq.0 ) goto 100
               if ( ih.eq.0 .and. ik.eq.0 .and. il.eq.0 ) goto 100

               s=rhof(pp,ih,ik,il)**2
               if (s.gt.rhomax) goto 100

               num=num+1

100         continue
200      continue
300   continue

      numestref=num

      return
      end
!-----------------------------------------------------------------------
      function CalcolaRaggioEnve(jpatt)
      USE General
      USE Riflessi
      USE Param
      USE PhaseModule

!
      if (ifExpanded > 0) then ! occhio
         ihmx(:) = ihmxSav(:)
         rhomax = maxval(rhov(1:nrefl))
      endif

      rmax=0.5/sqrt(rhomax)

      numresVal = numres(rmax)    !!! si deve ricalcolare dedi 7/6/17

      rnrflc=100 + numresVal
      wangrd=2.0
      iwp=2
      sw0=sum(wt(1:nrefl))
      sw=sum(wt(1:nrefl)**iwp)
      CalcolaRaggioEnve = wangrd*(rnrflc/sw)**0.33*rmax
!     write(6,*) 'Enve: sw0',numresVal,rnrflc,sw0,sw,CalcolaRaggioEnve

      if (jpatt == 0) then
         if(ksize>4.and.LowRes==0.and.no(nk)<=20.and.v_p<0.59) then
              CalcolaRaggioEnve = wangrd*(numbLSQ/sw)**0.33*rmax
         endif
      endif

      if (ksize > 3) then
!         CalcolaRaggioEnve = amin1(10.0, CalcolaRaggioEnve)
          if(FinalFom<0.8) then!liberato2009
             CalcolaRaggioEnve = amin1(10.0, CalcolaRaggioEnve)
          else
             CalcolaRaggioEnve = amin1(10.0, CalcolaRaggioEnve)+1.0
          endif
!            CalcolaRaggioEnve = amin1(8.0, CalcolaRaggioEnve)
      else
          r2max = rmax * 2
          CalcolaRaggioEnve = amin1(r2max, CalcolaRaggioEnve)
      endif
         

      if (ifExpanded > 0) then ! occhio
         ihmx(:) = ihmxExt(:)
         rhomax = maxval(rhov(1:nrefltot))
      endif
!
      return
      end
!-----------------------------------------------------------------------
c     subroutine rhostats(map,solmsk,np)
c     USE General
c     USE Param
c
c     integer np(3)
c     integer nhistLoc
c     real rhomi,rhoma,pmin,pmax
c     parameter (nhistLoc=100,rhomi=-5.0,rhoma=20.0,pmin=-0.9,pmax=2.4)
c     integer hist(nhistLoc,-10:10)
c     integer i,j,k,l,n,ih,imin,imax,nr(-10:10)
c     real s(-10:10),s2(-10:10),rmax(-10:10),rmin(-10:10),rho
c     real map(np(1),np(2),np(3))
c     real solmsk(np(1),np(2),np(3))

c     nww=np(3)
c     nv=np(2)
c     nu=np(1)

c     do i=-10,10
c        nr(i)=0
c        s(i)=0.0
c        s2(i)=0.0
c        rmin(i)= 1000.0
c        rmax(i)=-1000.0
c        do j=1,nhistLoc
c           hist(j,i)=0
c        enddo
c     enddo

c     do k=1,nww
c        do j=1,nv
c           do i=1,nu
c               rho=map(i,j,k)/volume
c               ih=int(nhistLoc*(rho-rhomi)/(rhoma-rhomi))
c               ih=max(min(ih,nhistLoc),1)
c               ksolv = nint(solmsk(i,j,k))
c               l = ksolv / 100
c               nr(l)=nr(l)+1
c               s(l)=s(l)+rho
c               s2(l)=s2(l)+rho**2
c               rmax(l)=max(rmax(l),rho)
c               rmin(l)=min(rmin(l),rho)
c               hist(ih,l)=hist(ih,l)+1
c           enddo
c        enddo
c     enddo

c     n=nu*nv*nww
c     write (lo,200)
c     write (lo,201)'Protein',(100.0*nr(1))/n,rmin(1),rmax(1),
c    +  s(1)/nr(1),sqrt(max(s2(1)*nr(1)-s(1)**2,0.0))/nr(1)
c     write (lo,201)'Solvent',(100.0*nr(0))/n,rmin(0),rmax(0),
c    +  s(0)/nr(0),sqrt(max(s2(0)*nr(0)-s(0)**2,0.0))/nr(0)
c     if (nr(-1).ne.0) write (lo,201)'Unknown',(100.0*nr(-1))/n,
c    +  rmin(-1),rmax(-1),s(-1)/nr(-1),
c    +  sqrt(max(s2(-1)*nr(-1)-s(-1)**2,0.0))/nr(-1)
c200  format(/9x,'% of cell   Min Rho   Max Rho   Mean Rho   Std.Dev.')
c201  format(1x,a7,': ',f8.1,'  ',f8.3,'  ',f8.3,'   ',f8.3,'   ',f8.3)
c     imin=int(nhistLoc*(pmin-rhomi)/(rhoma-rhomi))
c     imax=int(nhistLoc*(pmax-rhomi)/(rhoma-rhomi))
c     write (lo,205)
c205  format (/' Density       Number of counts:   Number of counts:'
c    +        /' Range:        (Protein)           (Solvent)')
c     do 220 i=imin,imax
c     rho=(i+0.5)*(rhoma-rhomi)/nhistLoc+rhomi
c     write (lo,210)rho,hist(i,1),hist(i,0)
c210  format(1x,f8.3,8x,i10,10x,i10)
c220  continue

c     write (lo,*)

c     return
c     end
!-----------------------------------------------------------------------
