#include "mrconfig.h"
#include <gtkmrcomune.h>
#include "aliasx.h"
#include <sstream>

extern _Dialogo *dialogo;

//extern stringa     *It;
extern GtkWidget *finestre[6];

static int *selezione;
char **Atomi;         //[30000];
static _StyleType FrameStyle = {true, 1, NULL, GTK_SHADOW_ETCHED_IN, 2, 2, 10, 2};

/*****************************************************************/
/*        G e o m e t r i c   C a l c u l a t i o n s            */
/*****************************************************************/

#define MAX_SELECTED 2
int selected_items[MAX_SELECTED];
int num_selections = 0;
InfoGeo infogeo;
static GtkWidget *old_exp = NULL;
static GtkWidget *geocalc_dlg = NULL;
static GtkWidget *mainwin;
float fort_coef[16];
float fort_err[16];
int geoAction;

static TreeItem all[] =     { {"Select by List", NULL},
                              {"Select by Mouse Click", NULL},
                              {"Select by Polygon", NULL},
                               {NULL}
                             };
static TreeItem allm1[] =    { {"Select by List", NULL},
                              {"Select by Mouse Click", NULL},
                               {NULL}
                             };
static TreeItem deletes[] =  { {"Delete planes", NULL},
                               {"Delete lines", NULL},
                               {"Delete baricentra", NULL},
                               {"Delete all items", NULL},
                               {NULL}
                             };
                
static TreeItem tnames[] = { {"Mean quadratic plane (P)", all},
                             {"Mean quadratic line (L)", all},
                             {"Barycentre (B)", all},
                             {"Group of atoms (G)", all},
                             {"Single atom (S)", allm1},
                             {"Delete items", deletes},
                             {NULL}
                       };

extern "C" void beccaatomi_(char *at, int *n, int idum);

static void ok_lista(GtkButton *button, gpointer data)
{
    int i, numSelected;
    const gchar *nome;
    void manage_ok_geom(int from);
    char *string = (char *) data;
    GtkWidget *lista = get_widget(gtk_widget_get_toplevel(GTK_WIDGET(button)),
                             string);

    get_selected_rownums(lista, selezione);

    numSelected = 0;
    nome = gtk_widget_get_name(GTK_WIDGET(button));
    gtk_widget_set_sensitive(geocalc_dlg, TRUE);
    close_dlg(button, GINT_TO_POINTER(1));
    if(strstr(nome, "ok") != NULL)
    {
       for(i=0;i < dialogo->NatMol; i++)
       {
          if(selezione[i])
             dialogo->kptrc[numSelected++] = i+1;
       }
       for(i=numSelected; i<1000; i++)
           dialogo->kptrc[numSelected++] = 0;
       manage_ok_geom(2);
    }
}

void c_recupera_info(InfoGeo *info)
{
     Cancella("tmp.tmp");
     info->nplanes = 0;
     info->nlines = 0;
     info->nbaric = 0;
     info->ngroups = 0;
     info->nsingle = 0;
     prepara_calcoli_();
}

int c_finish_define(int action, float coef[], float ferr[])
{
     int ier;

     finish_define_(&action, coef, ferr, &ier);
     return ier;
}

void details (GtkWidget *button, gpointer data)
{
  gtkext::text_window (GTK_WINDOW(gtk_widget_get_toplevel(button)), "tmp.tmp", "*.txt", 
             gtkext::IFSAVEAS+gtkext::IFREADONLY, "Results on geometric calculations");
}

static void sel_element(GtkTreeSelection *selec, gpointer data)
{
    GtkTreeView *treeview;
    GtkTreePath *path;
    GList *rowsel = NULL;
    int i, nsel, hnd;

    treeview = gtk_tree_selection_get_tree_view(selec);
    hnd = get_int(GTK_WIDGET(treeview), "hnd");
    rowsel = get_selections(GTK_WIDGET(treeview));
    if(rowsel)
       nsel = g_list_length(rowsel);
    else
       nsel = 0;
    if(nsel == 1)
       gtk_widget_show(get_widget(geocalc_dlg, "distance_s"));
    else
       gtk_widget_hide(get_widget(geocalc_dlg, "distance_s"));
    for(i=0; i<nsel; i++)
    {
        path = (GtkTreePath *)g_list_nth_data (rowsel, i);
        if(i < MAX_SELECTED)
           selected_items[i] = 
             atoi(gtk_tree_path_to_string(path));
        else
        {
           g_signal_handler_block(G_OBJECT(selec), hnd);
//           g_signal_handlers_block_by_func(G_OBJECT(selec), 
//                   G_CALLBACK(sel_element), data);
           unselect_row(GTK_WIDGET(treeview), i);
           g_signal_handler_unblock(G_OBJECT(selec), hnd);
//           g_signal_handlers_unblock_by_func(G_OBJECT(selec), 
//                   G_CALLBACK(sel_element), data);
        }
    }
}

void update_results(GtkWidget *widget, const char *strResults)
{
    GtkWidget *label;
    GtkTextIter start, end;

    label = lookup_widget(widget, "results");
    GtkTextBuffer *textb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(label));
    gtk_text_buffer_get_bounds (textb, &start, &end);
/*
    gtk_text_buffer_delete (textb, &start, &end);
    gtk_text_buffer_get_start_iter (textb, &start);
*/
    gtk_text_buffer_get_end_iter (textb, &start);
    if(strstr(strResults, "WARNING"))
       gtk_text_buffer_insert_with_tags_by_name(textb, &start, strResults,
                                   (int) strlen(strResults), "reference_line", "big", NULL);
    else
       gtk_text_buffer_insert_with_tags_by_name(textb, &start, strResults,
                                   (int) strlen(strResults), MONOSPACE_FONT, NULL);
    gtk_text_buffer_insert(textb, &start, "\n",  1);
//    gtk_text_buffer_insert(textb, &start, "\n\n\n\n",  4);
    gtk_text_buffer_get_bounds (textb, &start, &end);
/*
    GtkTextChildAnchor *anchor = gtk_text_buffer_create_child_anchor (textb, &end);
    GtkWidget *button = myimage_button(" _Details", "details.png");
    gtk_text_view_add_child_at_anchor (GTK_TEXT_VIEW(label), button, anchor);
   (void) g_signal_connect (G_OBJECT (button), "clicked", 
         G_CALLBACK(details), NULL);
    gtk_widget_show_all(button);
*/
}

void clear_results(GtkWidget *widget)
{
    GtkWidget *label;
    GtkTextIter start, end;

    label = lookup_widget(widget, "results");
    GtkTextBuffer *textb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(label));
    gtk_text_buffer_get_bounds (textb, &start, &end);
    gtk_text_buffer_delete(textb, &start, &end);
}

void update_label_info(GtkWidget *widget)
{
    GtkWidget *label;
    char *riga;

    label = lookup_widget(widget, "defined_items");
    riga = g_strdup_printf(
              "\n%d Quadratic planes\n%d Quadratic lines\n%d Barycentres\n%d Groups of atoms\n%d Single atoms\n",  
              infogeo.nplanes, infogeo.nlines, infogeo.nbaric, 
              infogeo.ngroups, infogeo.nsingle);
    gtk_label_set_text(GTK_LABEL(label), riga);
}

void manage_ok_geom(int from)
{
    GtkWidget *list;
    int ier;

    if(old_exp)
       gtk_tree_view_collapse_all ((GtkTreeView *) old_exp); 
    switch(geoAction)
    {
    case 1:                  /* Mean Quadratic plane */
         fort_coef[0] = (float) (infogeo.nplanes + 1);
         break;
    case 2:                  /* Quadratic line */
         fort_coef[0] = (float) (infogeo.nlines + 1);
         break;
    case 3:                  /* Baricentrum */
         fort_coef[0] = (float) (infogeo.nbaric + 1);
         break;
    case 4:                  /* Groups of atoms */
         fort_coef[0] = (float) (infogeo.ngroups + 1);
         break;
    case 5:                  /* Single atoms */
         fort_coef[0] = (float) (infogeo.nsingle + 1);
         break;
    default:
         break;
    }
    ier = c_finish_define(geoAction, fort_coef, fort_err);
    if(!ier)
    {
       std::stringstream str;
       char *riga;
       list = lookup_widget(geocalc_dlg, "lista_items");
       switch(geoAction)
       {
       case 1:                  /* Mean Quadratic plane */
            str.clear();
            str << "P " <<  (infogeo.nplanes+1) << " " <<  fort_coef[0] << " " << fort_err[0]
                << " " << fort_coef[1] << " " << fort_err[1] << " " << fort_coef[2] << " " << fort_err[2] 
                << " " <<  fort_coef[3] << " " << fort_err[3];
            ScriviStringa(infogeo.Planes[infogeo.nplanes], 
                    sizeof(stringa120), "%s", str.str().c_str());
            riga = infogeo.Planes[infogeo.nplanes];
            add_line_to_list(list, (gpointer) riga);
            infogeo.nplanes++;
            break;
       case 2:                  /* Quadratic line */
            str.clear();
            str << "L " <<  (infogeo.nlines+1) << " " <<  fort_coef[0] << " " << fort_err[0]
                << " " << fort_coef[1] << " " << fort_err[1] << " " << fort_coef[2] << " " << fort_err[2] 
                << " " <<  fort_coef[3] << " " << fort_err[3] << " " << fort_coef[4] << " " << fort_err[4] 
                << " " <<  fort_coef[5] << " " << fort_err[5];
            ScriviStringa(infogeo.Lines[infogeo.nlines],
                    sizeof(stringa120), "%s", str.str().c_str());
            riga = infogeo.Lines[infogeo.nlines];
            add_line_to_list(list, (gpointer) riga);
            infogeo.nlines++;
            break;
       case 3:                  /* Baricentrum  */
            str.clear();
            str << "B " <<  (infogeo.nbaric+1) << " " <<  fort_coef[0] << " " << fort_err[0]
                << " " << fort_coef[1] << " " << fort_err[1] << " " << fort_coef[2] << " " << fort_err[2];
            ScriviStringa(infogeo.Baric[infogeo.nbaric],
                    sizeof(stringa120), "%s", str.str().c_str());
            riga = infogeo.Baric[infogeo.nbaric];
            add_line_to_list(list, (gpointer) riga);
            infogeo.nbaric++;
            break;
       case 4:                  /* Group of atoms  */
            str.clear();
            str << "G " <<  (infogeo.ngroups+1) << " " <<  (int) fort_coef[0]
                << " atoms in the group";
            ScriviStringa(infogeo.Groups[infogeo.ngroups],
                    sizeof(stringa120), "%s", str.str().c_str());
            riga = infogeo.Groups[infogeo.ngroups];
            add_line_to_list(list, (gpointer) riga);
            infogeo.ngroups++;
            break;
       case 5:                  /* Single atoms  */
            str.clear();
            str << "S " <<  (infogeo.nsingle+1) << " " <<  Atomi[(int) fort_coef[0]-1];
//            str << "S " <<  (infogeo.nsingle+1) << " " <<  It[(int) fort_coef[0]-1];
            ScriviStringa(infogeo.Single[infogeo.nsingle],
                    sizeof(stringa120), "%s", str.str().c_str());
            riga = infogeo.Single[infogeo.nsingle];
            add_line_to_list(list, (gpointer) riga);
            infogeo.nsingle++;
            break;
       default:
            break;
       }
       update_label_info(list);
    }
}

void dist_ang (GtkButton *button, gpointer data)
{
    GtkWidget *list;
    GtkAdjustment *adj;
    stringa120 vriga;
    float fval[20];
    int i, ier, ni;
    GtkTreeModel *model;
    GtkTreeIter iter;
    gchar *strpath;
    GtkTreePath *path;
    GList *rowsel = NULL;
    char *riga;
    std::stringstream ResultStr;

    geoAction = GPOINTER_TO_INT(data);
    switch(geoAction)
    {
    case 11:                            //Distance
         ResultStr << "Distance between ";
         break;
    case 12:                            //Angle
         ResultStr << "Angle between ";
         break;
    case 14:                            //Torsion Angle
         ResultStr << "Torsion Angle among atoms of ";
         break;
    case 13:                            //Normal Plane
         ResultStr << "Normal plane to ";
         break;
    }
    list = lookup_widget(GTK_WIDGET(button), "lista_items");
    rowsel = get_selections(list);
    if(rowsel)
       num_selections = g_list_length(rowsel);
    else
       num_selections = 0;
    if(!num_selections)
    {
       (void) MessageDialog(gtk_widget_get_toplevel(GTK_WIDGET(button)), GTK_MESSAGE_ERROR,
             GTK_BUTTONS_CLOSE, "You must select one or two items!");
       return;
    }
    for(i=0; i<num_selections; i++)
    {
        path = (GtkTreePath *)g_list_nth_data (rowsel, i);
        if(i < MAX_SELECTED)
           selected_items[i] = 
             atoi(gtk_tree_path_to_string(path));
    }

    for(i=0; i<16; i++)
    {
        fort_coef[i] = 0;
        fort_err[i] = 0;
    }
    if(num_selections == 1)
    {
       adj = GTK_ADJUSTMENT(get_object(gtk_widget_get_toplevel(GTK_WIDGET(button)), "hscale"));
       fort_coef[15] = (float) gtk_adjustment_get_value(GTK_ADJUSTMENT(adj));
    }
//    if(num_selections == 2)
    {
       model = gtk_tree_view_get_model (GTK_TREE_VIEW(list));
       for(ni=0; ni<num_selections; ni++)
       {
           strpath = g_new0(char, 5);
           ScriviStringa(strpath, 5, "%d", selected_items[ni]);
           path = gtk_tree_path_new_from_string(strpath);
           g_free(strpath);
           gtk_tree_model_get_iter (model, &iter, path);
           gtk_tree_model_get (model, &iter, 0, &riga, -1);

           ScriviStringa(vriga, sizeof(vriga), "%s", riga);
           ResultStr <<  (char *)get_nth_field(vriga, " ", 1, 's') 
                     <<  (char *)get_nth_field(vriga, " ", 2, 's') << " ";
           switch(vriga[0])
           {
           case 'P':
                fort_coef[ni*8] = 1;
                break;
           case 'L':
                fort_coef[ni*8] = 2;
                break;
           case 'B':
                fort_coef[ni*8] = 3;
                break;
           case 'G':
                fort_coef[ni*8] = 4;
                break;
           case 'S':
                fort_coef[ni*8] = 5;
                break;
           }
           (void) g_strdelimit(vriga, "()", ' ');
           get_float_tokens(vriga, " ", 14, fval);
           fort_coef[1+8*ni] = fval[1];           // serial
           for(i=1; i<=6; i++)
           {
               fort_coef[i+1+8*ni] = fval[i*2];
               fort_err[i-1+6*ni] = fval[i*2+1];
           }
       }

       ier = c_finish_define(geoAction, fort_coef, fort_err);
       unselect_all(GTK_TREE_VIEW(list));

       if(!ier)
       {
          switch(geoAction)
          {
          case 11:                            //Distance
               ResultStr << " is: " << dialogo->SmallIt[0];
               break;
          case 12:                            //Angle
               ResultStr << " is: " << dialogo->SmallIt[0] << " degrees";
               break;
          case 14:                            //Torsion Angle
               ResultStr << " is: " << dialogo->SmallIt[0] << " degrees";
               break;
          case 13:                           //Perpendicular Plane
               std::stringstream str;
               str << "P " <<  (infogeo.nplanes+1) << " " <<  fort_coef[0] << " " << fort_err[0]
                   << " " << fort_coef[1] << " " << fort_err[1] << " " << fort_coef[2] << " " << fort_err[2] 
                   << " " <<  fort_coef[3] << " " << fort_err[3];
               ScriviStringa(infogeo.Planes[infogeo.nplanes], 
                    sizeof(stringa120), "%s", str.str().c_str());
               riga = infogeo.Planes[infogeo.nplanes];
               add_line_to_list(list, (gpointer) riga);
               infogeo.nplanes++;
               update_label_info(list);
               ResultStr << " is:\n" << fort_coef[0] << "x + "
                         << fort_coef[1] << "y + "
                         << fort_coef[2] << "z = " <<fort_coef[3];
               break;
          }
          update_results(list, ResultStr.str().c_str());
       }
       else
          update_results(list, "WARNING: Operation not allowed!");
    }

}

static void select_from_tree(GtkTreeSelection *selec, GtkWidget *dlg)
{
    GtkTreeModel *model;
    GtkTreeIter iter;
    GtkTreePath *path;
    GtkTreeView *treeview;
    char *linea;
    int iAction;

    treeview = gtk_tree_selection_get_tree_view(selec);
    old_exp = GTK_WIDGET(treeview);
    if(gtk_tree_selection_get_selected (selec, &model, &iter))
    {
       linea = DuplicaStringa(get_selected_row_path(GTK_WIDGET(treeview)));
       path = gtk_tree_path_new_from_string(linea);
       if(gtk_tree_view_expand_row (treeview, path, 0)) //ramo principale
          return;
       else
       {
          int nodi[3], selMode, i, tipo;
          if(!strstr(linea,":"))
             return;
          get_int_tokens(linea, ":", 2, nodi);
          iAction = nodi[0];
          for(i=0; i<dialogo->NatMol; i++)
              selezione[i] = 0;

          geoAction = iAction+1;
          selMode = nodi[1];
          if(geoAction < 5)
             tipo = 1;
          else
          {
             tipo = 0;
             selMode += 10;
          }

          if(iAction < 5)
          {
             if((selMode % 10) == 0)
                 mostra_lista("Select Atoms", "Atoms", Atomi, 
                         dialogo->NatMol, tipo,G_CALLBACK(ok_lista));
             else
                 mostra_tbg1lsq(mainwin, selMode+1, 3);
          }
       }
    }
}

void end_geocalc(GtkButton *button, gpointer data)
{
    close_dlg(button, data);
    for (int i=0; i<dialogo->NatMol; i++)
         g_free(Atomi[i]);
    g_free(Atomi);
    g_free(selezione);
}

void help_geocalc(GtkButton *button, gpointer data)
{
//    open_htm("help_geomcalc.htm");
    open_htm("Info.html#geometry","");
}

GtkWidget* create_geocalc (void)
{
  GtkWidget *dialog1;
  GObject *adj;
  GtkWidget *vbox1;
  GtkWidget *frame, *hscale;
  GtkWidget *label, *align;
  GtkWidget *list;
  GtkWidget *table;
  GtkWidget *button;
  int hnd;

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1), "Geometric calculations");
  gtk_container_set_border_width(GTK_CONTAINER(dialog1), 2);
//  gtk_widget_set_size_request(dialog1, 450, 350);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG (dialog1));

  table = table_new(4, 2, FALSE);
  table_set_row_spacings(table, 4); 
  table_set_col_spacings(table, 4); 
#ifdef IN_GTK3
  gtk_widget_set_hexpand(table, TRUE);
  gtk_widget_set_vexpand(table, TRUE);
  g_object_set(G_OBJECT(table), "valign", GTK_ALIGN_CENTER, NULL);
  g_object_set(G_OBJECT(table), "halign", GTK_ALIGN_CENTER, NULL);
  gtk_box_pack_start (GTK_BOX (vbox1), table, FALSE, FALSE, 4);
#else
  label = gtk_alignment_new(0.5f, 0.5f, 0.2f, 0.2f);
  gtk_box_pack_start (GTK_BOX (vbox1), label, FALSE, FALSE, 4);
  gtk_container_add(GTK_CONTAINER(label), table);
#endif

  frame = NEW_FRAME ("Define item", &FrameStyle);
  table_attach(table, frame, 0, 1, 0, 1, TRUE);

  align = get_widget(frame, "align");
  do_tree_store(align, tnames, G_CALLBACK(select_from_tree), dialog1);

  frame = NEW_FRAME ("Set limit on distance(s)", &FrameStyle);
  table_attach(table, frame, 0, 2, 2, 3, TRUE); 
  g_object_set_data (G_OBJECT (dialog1), "distance_s", frame);
  adj = adj_new (1.40f, 0.80f, 3.0f, 0.01f, 0.1f);
  hscale = hscale_new (GTK_ADJUSTMENT (adj));
  g_object_set_data (G_OBJECT (dialog1), "hscale", adj);
  gtk_scale_set_value_pos (GTK_SCALE (hscale), GTK_POS_BOTTOM);
  gtk_scale_set_digits (GTK_SCALE (hscale), 3);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), hscale);


  frame = NEW_FRAME ("List of items", &FrameStyle);
  table_attach(table, frame, 0, 1, 1, 2, TRUE);

  list = create_selection(dialog1, get_widget(frame, "align"),NULL,"lista_items");
  set_selection_mode(list, GTK_SELECTION_MULTIPLE);
  hnd = g_signal_connect(G_OBJECT(gtk_tree_view_get_selection (GTK_TREE_VIEW (list))),
        "changed", G_CALLBACK(sel_element), NULL);
  g_object_set_data(G_OBJECT(list), "hnd", GINT_TO_POINTER(hnd));

  frame = NEW_FRAME ("Defined items", &FrameStyle);
  table_attach(table, frame, 1, 2, 0, 1, TRUE);

  align = get_widget(frame, "align");
    
  label = LABEL_NEW ("\n\n\n", NULL);
  g_object_set_data (G_OBJECT (dialog1), "defined_items", label);
  gtk_container_add(GTK_CONTAINER(align), label);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
  set_alignment(label, 0, 0.5);

  frame = NEW_FRAME ("Results", &FrameStyle);
  gtk_box_pack_end(GTK_BOX(vbox1), frame, TRUE, TRUE, 4);
  label = scrolled_text(get_widget(frame, "align"));
  g_object_set_data (G_OBJECT (dialog1), "results", label);

  frame = NEW_FRAME ("Select item(s) to compute:", &FrameStyle);
  table_attach(table, frame, 1, 2, 1, 2, TRUE); 

  label = get_widget(frame, "align");
  table = table_new(2, 2, TRUE);
  table_set_row_spacings(table, 10); 
  table_set_col_spacings(table, 4); 
  gtk_container_add(GTK_CONTAINER(label), table);

  GtkSizeGroup *szgroup = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
  GtkSizeGroup *szgroup1 = gtk_size_group_new(GTK_SIZE_GROUP_VERTICAL);
  button = myimage_button(" _Distance", "dist_butt.png");
  gtk_size_group_add_widget(szgroup, button);
  gtk_size_group_add_widget(szgroup1, button);
  table_attach(table, button, 0, 1, 0, 1);
  (void) g_signal_connect (G_OBJECT (button), "clicked", 
         G_CALLBACK(dist_ang), GINT_TO_POINTER(11));
  set_tip (button, "Distance between two items or among the atoms of one item");
  button = myimage_button(" _Angle", "angles.png");
  gtk_size_group_add_widget(szgroup, button);
  gtk_size_group_add_widget(szgroup1, button);
  table_attach(table, button, 1, 2, 0, 1);
  (void) g_signal_connect (G_OBJECT (button), "clicked", 
         G_CALLBACK(dist_ang), GINT_TO_POINTER(12));
  set_tip (button, "Angle between two items or among the atoms of one item");
  button = myimage_button ("  _Tors.Angle", "tangles.png");
  gtk_size_group_add_widget(szgroup, button);
  gtk_size_group_add_widget(szgroup1, button);
  table_attach(table, button, 0, 1, 1, 2);
  (void) g_signal_connect (G_OBJECT (button), "clicked", 
         G_CALLBACK(dist_ang), GINT_TO_POINTER(14));
  set_tip (button, "Torsion angle among the atoms of one item");
  button = myimage_button ("  _Perp.Plane", "pplane_butt.png");
  gtk_size_group_add_widget(szgroup, button);
  gtk_size_group_add_widget(szgroup1, button);
  table_attach(table, button, 1, 2, 1, 2);
  (void) g_signal_connect (G_OBJECT (button), "clicked", 
         G_CALLBACK(dist_ang), GINT_TO_POINTER(13));
  set_tip (button, "Plane perpendicular to a line and through an atom");

  button = HELP_button();
  gtk_dialog_add_action_widget(GTK_DIALOG (dialog1), button, 1);
  (void) g_signal_connect (G_OBJECT (button), "clicked", 
         G_CALLBACK(help_geocalc), NULL);

  button = myimage_button(" _Details", "details.png");
  gtk_dialog_add_action_widget(GTK_DIALOG (dialog1), button, 2);
  (void) g_signal_connect (G_OBJECT (button), "clicked", 
         G_CALLBACK(details), NULL);
  gtk_widget_grab_focus (button);

  button = myimage_button("  _Close", "cancel.png");
  gtk_dialog_add_action_widget(GTK_DIALOG (dialog1), button, 3);
  (void) g_signal_connect (G_OBJECT (button), "clicked", 
         G_CALLBACK(end_geocalc), GINT_TO_POINTER(1));

  (void) g_signal_connect_swapped(G_OBJECT(dialog1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
   (void) g_signal_connect (G_OBJECT (dialog1), "delete_event",
                      G_CALLBACK(true_cb), NULL);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(button)), GTK_BUTTONBOX_SPREAD);

  return dialog1;
}

void open_geocalc(gpointer, gpointer data)
{
   int i;
   char *riga;
   GtkWidget *label;

   mainwin = finestre[0];
   if(geocalc_dlg == NULL)
      geocalc_dlg = create_geocalc();
   g_object_set_data(G_OBJECT(mainwin), "win_dlg", geocalc_dlg);

   c_recupera_info(&infogeo);
   update_label_info(geocalc_dlg);
   clear_results(geocalc_dlg);
   selezione = g_new0(int, dialogo->NatMol);
   Atomi = g_new0(char *, dialogo->NatMol);
   for(i=0; i<dialogo->NatMol; i++)
   {
      selezione[i] = 0;
//      size_t sz = strlen(It[i])+1;
      int  sz = 17;
      Atomi[i] = g_new0(char, sz);
      beccaatomi_(Atomi[i], &i, sz);
   }
   label = lookup_widget(geocalc_dlg, "lista_items");
   clear_list(label);
   for(i=0; i<infogeo.nplanes; i++)
   {
       riga = infogeo.Planes[i];
       add_line_to_list(label, (gpointer) riga);
   }
   for(i=0; i<infogeo.nlines; i++)
   {
       riga = infogeo.Lines[i];
       add_line_to_list(label, (gpointer) riga);
   }
   for(i=0; i<infogeo.nbaric; i++)
   {
       riga = infogeo.Baric[i];
       add_line_to_list(label, (gpointer) riga);
   }
   for(i=0; i<infogeo.ngroups; i++)
   {
       riga = infogeo.Groups[i];
       add_line_to_list(label, (gpointer) riga);
   }
   for(i=0; i<infogeo.nsingle; i++)
   {
       riga = infogeo.Single[i];
       add_line_to_list(label, (gpointer) riga);
   }

   gtk_widget_show_all(geocalc_dlg);
   label = lookup_widget(geocalc_dlg, "distance_s");
   gtk_widget_hide(label);
   finestra_modale_aperta2(geocalc_dlg);
}
