!-----------------------------------------------------------------------
!     Mir / MirAs related routines
!-----------------------------------------------------------------------
      subroutine SigHEstimate(jcondition)
c     jcondition=1 --> num. of heavy atoms estimate
c     jcondition=2 --> |Fh|,sigFh estimates
      
      USE General
      USE Symmetry
      USE Riflessi
      USE Grafici
      USE Molcom
      USE MadModule
!
      common/bterMIR/btnat,btder
      dimension i1(3),xx(200),yy(200),SumDelta2(201),nrDelta2(201)
      dimension sig(200),ia(1),a(1),alphaMat(1,1),covar(1,1)
      dimension sumFpRes(20),nrFpRes(20)
      character HAtom*4,tirang1*80

      dimension sigHmed(100),sigDmed(100),sigPmed(100)
      dimension errorSigma(100), NumError(100),RES(100)
      dimension deMed(100),ehMed(100),ehEst1(100),ehEst2(100)
      dimension ehEst3(100),dif3Med(100)
      dimension sumFheavy(100),dif0Med(100),dif1Med(100),dif2Med(100)

      real, allocatable ::sigHeavy(:),sigEhEst(:),FheavyCalc(:)
      real, allocatable ::Delta2(:),sigEhEstn(:)
      real, allocatable ::FheavyEst0(:),FheavyEst2(:),FheavyEst3(:)
      external PdeltaFit



      ! worko --> FH calc.
    
      ! fovet -- > FH
      ! sigmav -- > sig(FH)

      allocate(sigHeavy(nrefl),sigEhEst(nrefl),FheavyCalc(nrefl),
     *        Delta2(nrefl),FheavyEst0(nrefl),FheavyEst2(nrefl),
     *        FheavyEst3(nrefl),sigEhEstn(nrefl),stat=ierr)

      FheavyCalc(:)=0.0
      sigHeavy(:)=0.0
      sigEhEst(:)=0.0
      sigEhEstn(:)=0.0
      Delta2(:)=0.0
      FheavyEst0(:)=0.0
      FheavyEst2(:)=0.0
      FheavyEst3(:)=0.0

      ider=kfpfs(WhichDeriv)
      MaxShelReso=12
      sumFpRes(:)=0.0
      nrFpRes(:)=0
      rhomax=maxval(rhov(1:nrefl))
      rhomin=minval(rhov(1:nrefl))
    
      select case (jcondition)
      case (1)
      write(lo,*) '******************************************'
      write(lo,*) '*      <sigH>  Estimate                   *'
      write(lo,*) '******************************************'

      do 100 i=1, nrefl
       lh=khl(1,i)
       lk=khl(2,i)
       ll=khl(3,i)
       rho2=rhov(i)
       fo=fNativ(i)
       NumReso =
     +   INT((rho2-rhomin)*MaxShelReso/ (rhomax-rhomin)) + 1
       IF (NumReso.GT.MaxShelReso) NumReso = MaxShelReso
       IF (NumReso.LT.1) NumReso = 1
       sumFpRes(NumReso) = sumFpRes(NumReso) + fo**2
       nrFpRes(NumReso) = nrFpRes(NumReSo) + 1

 100  continue

      do j=1,MaxShelReso
        if (nrFpRes(j).gt.0.0) then
         sumFpRes(j)= sumFpRes(j)/float(nrFpRes(j))
        else
         sumFpRes(j)=0.0
        endif
      enddo

      MaxBin=150
      sumfo=sum(fNativ(:),mask=fDeriv(:,WhichDeriv)>0.0) 
      sumfd=sum(fDeriv(:,WhichDeriv),mask=fDeriv(:,WhichDeriv) >0.0)


      scaleFoFd=sumfo/sumfd

      nrDelta2Tot=0
      Delta2Max=0.0
      Delta2Min=99999.0
      SumDelta2(:)=0.0
      nrDelta2(:)=0
      Delta2(:)=-9999.

      sogDe2=1.5

      rhomaxD=0.0
      rhominD=999.0
      nrefDeri=0
      do 200 i=1,nrefl
         if (fDeriv(i,WhichDeriv) < 0.0) goto 200
         nrefDeri=nrefDeri+1
         lh=khl(1,i)
         lk=khl(2,i)
         ll=khl(3,i)
         i1(1)=lh
         i1(2)=lk
         i1(3)=ll
         rho2=rhov(i)
         if (rho2 > rhomaxD) rhomaxD=rho2
         if (rho2 < rhominD) rhominD=rho2

         call cmult2002(i1,eps,multVal)

         NumReso =
     +    INT((rho2-rhomin)*MaxShelReso/ (rhomax-rhomin)) + 1
         IF (NumReso.GT.MaxShelReso) NumReso = MaxShelReso
         IF (NumReso.LT.1) NumReso = 1
         sigNa1=sumFpRes(NumReso)
         fnative=fNativ(i)
         fderivative=fDeriv(i,WhichDeriv)*scaleFoFd

         De2=abs(fderivative**2-fnative**2)/sigNa1
         if (de2.le.sogDe2) then
          Delta2(i)=de2
          Delta2Max=max(Delta2Max,de2)
          Delta2Min=min(Delta2Min,de2)
         else
            Delta2(i)=-9999.0
         endif
 200  continue

      de2Max=0.0
      de2Min=9999.
      do 300 i=1,nrefl
        de2=Delta2(i)
        if (de2.lt.0.) goto 300
        de2Max=Delta2Max
        de2Min=Delta2Min
        NumBin =
     +     INT((de2-de2Min)*MaxBin/ (de2Max-de2Min)) + 1
           IF (NumBin.GT.MaxBin) NumBin = MaxBin
           IF (NumBin.LT.1) NumBin = 1
        SumDelta2(NumBin)=SumDelta2(NumBin)+de2
        nrDelta2(NumBin)=nrDelta2(NumBin)+1
        nrDelta2Tot=nrDelta2Tot+1
 300  continue

        varbin=(Delta2Max - Delta2Min)/float(MaxBin)
        yy(1)=nrDelta2(1)/(varbin*nrDelta2Tot)
        xx(1)=0.0
        sig(1)=0.001*yy(1)
        do 500 i=2,MaxBin
          yy(i)=nrDelta2(i)/(varbin*nrDelta2Tot)
          xx(i)=xx(i-1) + varbin
          sig(i)=0.001*yy(i)
          if (nrDelta2(i).eq.0) then
            MaxBinFinal=i-1
            goto 550
          endif
 500    continue

        MaxBinFinal= MaxBin
 550    continue

         MA=1
         mfit=MA
         ia(1)=1
         a(1)=yy(1)
         NPT=MaxBinFinal

        write(lo,'(1x,t5,a,f8.4,i6)') 'A initial=',a(1),MaxBinFinal
        do iter=1,2
        alamda=-1.0
        call mrqmin(xx,yy,sig,NPT,a,ia,ma,covar,alphaMat,
     *       MA,chisq,PdeltaFit,alamda)
        k=1
        itst=0
 1      write(lo,'(/1x,t5,a,i2,t18,a,f12.1,t43,a,e9.2)') 
     *   'Iteration #',k,' Chi-squared: ',chisq,' ALAMDA: ',alamda
        write(lo,'(1x,t5,a,f8.4)') 'A estimate=',a(1)
        goto 1000
        k=k+1
        ochisq=chisq
        call mrqmin(xx,yy,sig,NPT,a,ia,ma,covar,alphaMat,
     *       MA,chisq,PdeltaFit,alamda)
        if (chisq.gt.ochisq) then
          itst=0
        else if (abs(ochisq-chisq).lt.0.1) then
          itst=itst+1
        endif
        if (itst.lt.4) then
          goto 1
        endif

        alamda=0.0
        call mrqmin(xx,yy,sig,NPT,a,ia,ma,covar,alphaMat,
     *       MA,chisq,PdeltaFit,alamda)
        write(lo,*) 'Uncertainties:'
        write(lo,'(1x,f8.4/)')sqrt(covar(1,1))
        enddo

 1000   continue

        s2=0.0
        s3=0.0

        resmaxD=0.5/sqrt(rhomaxD)
        resminD=0.5/sqrt(rhominD)
        pesosigHP=(resmaxD-resminD)/(resmaxD+resminD)
        pesosigHP=pesosigHP**2
        pesosigHP=min(1.0,pesosigHP)

        sigHP=pesosigHP/(a(1)**2-1.0)
        sigmaP=0.0
        do i=1,nk-nDataSets
          sigmaP=sigmaP+float(nw(i))*no(i)*no(i)
        enddo
        sigH=sigHP*sigmaP
        sumZh2=no(ider)**2
        numHeavy=nint(sigH/(0.5*sumZh2*nsym*pts))
        numHeavy=max(1,numHeavy)
        anat=numHeavy
        aa=numHeavy*nsym*pts
        nw(ider) = int(aa)
        occHeavy=sqrt(sigH/(aa*sumZh2))
        occHeavy=min(1.0,occHeavy)

        s2=sigH
        s3=s2*no(ider)
        s3s2=s3/sqrt(s2**3)
        aa=s3s2*s3s2*pts
        s3s2=aa*sqrt(1.0/aa)
        write(HAtom,'(a4)') nalf(ider)
        call lcase(HAtom)
        call ucase(HAtom(1:1))
        write(lo,371) HAtom,sigHP,sigH,s3s2,numHeavy,occHeavy
        s3s2d(WhichDeriv) = s3s2

  371  format(/,18x,'Derivative:',2x,a4,/,
     + 18x,'*********************',/,
     + 18x,'sigH/sigP =',f7.3,/,
     + 18x,'sigH =',f10.3,/,
     + 18x,'s3s2 =',f7.3,/,
     + 18x,'n. atom in u.a  =',i5,/,
     + 18x,'<occ>  =',f5.2)

      write(Msg ,"('Est. number of heavy atoms in a.u: ',i4,2x,
     *             'with <OCC>: ',f5.2)") numHeavy, occHeavy
      write(Msg,372) HAtom, numHeavy, occHeavy
  372 format('Nr. of ',a4,'Atoms (estimated):',i4,2x,'(',f5.2,')')
      call TestoGR(Msg, -1, 2, 1)

      case (2)
      write(lo,*) '******************************************'
      write(lo,*) '*                 |Fh| Estimate           *'
      write(lo,*) '******************************************'
      ! la stima di  Fh & sig(Fh))

      MaxShelReso = 8
c     print*,count(worko(:) > 0.0)
c     print*,sum(worko(:))


      nrefc=count(fDeriv(1:nrefl,Whichderiv) > 0.0)
      MaxShelReso=30
      Nstat=floor(nrefc/float(MaxShelReso))
      MaxShelReso=8.0*alog10(0.05*float(max0(nrefc,100))+0.5)
c     print*,MaxShelReso

      sigHmed(:)=0.0
      sigPmed(:)=0.0
      sigDmed(:)=0.0
      errorSigma(:) =  0.0
      ehMed(:) =  0.0
      deMed(:) =  0.0
      ehEst2(:) =  0.0
      ehEst3(:) =  0.0
      dif0Med(:) =  0.0
      dif2Med(:) =  0.0
      dif3Med(:) =  0.0
      sumFheavy(:) =  0.0
      NumError(:) =  0
      FheavyEst0(:)=0.0
      FheavyEst2(:)=0.0
      FheavyEst3(:)=0.0
      sigEhEst(:)=0.0
      sigEhEstn(:)=0.0
      wt(:)=0.0

c     write(6,*)ider,numHeavy,occHeavy,bt
c     print*,nk,ider

      socc2=nsym*numHeavy*occHeavy**2
      sumFheavyEst0=0.0
      sumFheavyEst1=0.0
      sumFheavyC=0.0


      do 1100 i=1,nrefl
         if (fDeriv(i,WhichDeriv) < 0.0) goto 1100
         i1(1)=khl(1,i)
         i1(2)=khl(2,i)
         i1(3)=khl(3,i)
         call cmult2002(i1,eps,multVal)
         rho2=rhov(i)

         sigNa1=0.0
         sigH1=0.0
         sigD1=0.0
         do ink=1,nk
            fz=cl(ink)
            do ii=1,4
              fz=fz+al(ii,ink)*exp(-bs(ii,ink)*rho2)
            enddo
            if (ink==ider) then
             fz2=socc2*fz**2
             sigH1=fz2*exp(-2.0*btder*rho2)
            else
             fz2=nw(ink)*nsym*pts*fz**2
             sigNa1=sigNa1+fz2*exp(-2.0*btnat*rho2)
            endif
         enddo

         sigNa1=eps*pts*sigNa1
         sigH1 =eps*pts*sigH1

         sigD1=sigNa1+sigH1
c        sigD1 =eps*pts*sigD1



c        sigH1=0.0
c        fz=cl(ider)
c        do ii=1,4
c         fz=fz+al(ii,ider)*exp(-bs(ii,ider)*rho2)
c        enddo
c        fz2=socc2*fz**2
c        sigH1=fz2*exp(-2.0*bt*rho2)
c        sigH1=eps*pts*sigH1

         sigHeavy(i)=sigH1

         NumReso =
     +    INT((rho2-rhominD)*MaxShelReso/ (rhomaxD-rhominD)) + 1
         IF (NumReso.GT.MaxShelReso) NumReso = MaxShelReso
         IF (NumReso.LT.1) NumReso = 1
         sigf1=sNativ(i)             ! sigFp
         sigf2=sDeriv(i,WhichDeriv)  ! sigFd
         sigdelta=sigf1**2 + sigf2**2
         sigdelta=sigdelta/sigH1
         errorSigma(NumReso)=errorSigma(NumReso)+sigdelta
         sigHmed(NumReso)=sigHmed(NumReso)+sigH1
         sigDmed(NumReso)=sigDmed(NumReso)+sigD1
         sigPmed(NumReso)=sigPmed(NumReso)+sigNa1
         de=(fNativ(i)-fDeriv(i,WhichDeriv))**2
         de=de/sigH1
         deMed(NumReso)=deMed(NumReso)+de
         FheavyEst0(i)=sqrt(de)
         sumFheavyEst0=sumFheavyEst0+FheavyEst0(i)
         if (knw==1 ) then
           ehMed(NumReso)=ehMed(NumReso)+worko(i)**2 ! calc. per la strutt. vera
           sumFheavyC=sumFheavyC+worko(i)
           sumFheavy(NumReso)=sumFheavy(NumReso)+worko(i)**2
           FheavyCalc(i)=worko(i)
         endif
         sigEhEst(i)=(1.0-pi/4.0)*(sigdelta/(1.+sigdelta))
         if (sigEhEst(i) > 0.0) sigEhEst(i)=sqrt(sigEhEst(i))

         NumError(NumReso) =  NumError(NumReso)+1
 1100 continue


      sumNum=0
      sumerrorSigma=0.0
      sumSigHMed=0.0
      sumeHMed=0.0
      sumdeMed=0.0
      sumEhEst1=0.0
      do 1020 j=1,MaxShelReso
         sumNum=sumNum+NumError(j)
         sumerrorSigma=sumerrorSigma+errorSigma(j)
         sumSigHMed=sumSigHMed+sigHmed(j)
         sumeHMed=sumeHMed+ehMed(j)
         sumdeMed=sumdeMed+deMed(j)
         if (NumError(j).gt.0.0) then
          errorSigma(j)=errorSigma(j)/NumError(j)
          sigHmed(j)=sigHmed(j)/NumError(j)
          sigPmed(j)=sigPmed(j)/NumError(j)
          sigDmed(j)=sigDmed(j)/NumError(j)
          deMed(j)=deMed(j)/NumError(j)
          if (knw==1) ehMed(j)=ehMed(j)/NumError(j)
         endif
 1020   continue

      sumFheavyEst2=0.0
      sumFheavyEst3=0.0
      dluzmin=9999.0
      dluzmax=0.0
      do 1030 i=1,nrefl
         if (fDeriv(i,WhichDeriv) < 0.0) then
            fHeavy(i,WhichDeriv)=-1.0
            sHeavy(i,WhichDeriv)=0.0
            goto 1030
         endif
         i1(1)=khl(1,i)
         i1(2)=khl(2,i)
         i1(3)=khl(3,i)
         rho2=rhov(i)
         NumReso =
     +    INT((rho2-rhominD)*MaxShelReso/ (rhomaxD-rhominD)) + 1
         IF (NumReso.GT.MaxShelReso) NumReso = MaxShelReso
         IF (NumReso.LT.1) NumReso = 1
         de=(fDeriv(i,WhichDeriv)-fNativ(i))**2
         de=de/sigHeavy(i)
         errSig=100.0*errorSigma(NumReso)
         aa=(de+errSig)/(1.+errSig)
         ehEst2(NumReso)=ehEst2(NumReso)+aa
         FheavyEst2(i)=sqrt(aa)
         sumFheavyEst2=sumFheavyEst2+FheavyEst2(i)

         fhe=FheavyEst2(i)*sqrt(sigHeavy(i))
         sigfhe=sigEhEst(i)*sqrt(sigHeavy(i))

         ! nuova formula ...
c        if (Dluz(i) <=0.0)print*,i,fDeriv(i,WhichDeriv),fNativ(i)
         dluzmin=min(Dluz(i),dluzmin)
         dluzmax=max(Dluz(i),dluzmax)
c        Dluz(i)=max(1.0, Dluz(i))
c        Dluz(i)=min(0.9, Dluz(i))
         Dluz(i)=1.0
         sigHD=sigHmed(NumReso)/sigDmed(NumReso)
         wvar(i)=max(0.9, wvar(i))    ! sigmaA
         aa=1. - wvar(i)**2
         bb=1. - sigHD - wvar(i)**2
         rL11=aa/bb

         aa=(sigDmed(NumReso) -(Dluz(i)**2)*sigPmed(NumReso))
         aa1=sigHmed(NumReso)/aa
         rrp=fNativ(i)
         rrd=fDeriv(i,WhichDeriv)
         cc=(rrd -Dluz(i) * rrp)**2
         rrh=1.0 + aa1*(cc/aa -1.0)

c        rrh=(1.0 + aa1) + (cc / aa -1.0)

         if (rrh < 0.0) then
           rrh=0.0
         else
           wt(i)=1.0
           rrh=sqrt(rrh)
         endif
         ehEst3(NumReso)=ehEst3(NumReso)+rrh
         FheavyEst3(i)=sqrt(rrh)
         sumFheavyEst3=sumFheavyEst3+FheavyEst3(i)
         sigEhEstn(i)=(1.0-pi/4.0)*(1/rL11)
         if (sigEhEstn(i) > 0.0) then
           sigEhEstn(i)=sqrt(sigEhEstn(i))
         else
           sigEhEstn(i)=0.0
         endif

         fhe=FheavyEst3(i)*sqrt(sigHeavy(i))
         sigfhe=sigEhEstn(i)*sqrt(sigHeavy(i))


c        fhe=FheavyCalc(i)*sqrt(sigHeavy(i))
c        sigfhe=sigEhEstn(i)*sqrt(sigHeavy(i))


         ! valori finali per Fh e sigFh
         fHeavy(i,WhichDeriv)=fhe
         sHeavy(i,WhichDeriv)=sigfhe
c        !----

 1030  continue
c     print*,dluzmin,dluzmax

      if (knw==1) then
c      write(6,*)sumFheavyC
c      write(6,*)sumFheavyEst0
c      write(6,*)sumFheavyEst2
c      write(6,*)sumFheavyEst3
       sc0=sumFheavyEst0/sumFheavyC
       sc2=sumFheavyEst2/sumFheavyC
       sc3=sumFheavyEst3/sumFheavyC
       
       write(lo,*)'Scale0=',sc0
       write(lo,*)'Scale2=',sc2
       write(lo,*)'Scale3=',sc3
       sumdif0=0.0
       sumdif2=0.0
       sumdif3=0.0
       sumFheavyEst0=0.0
       sumFheavyEst2=0.0
       sumFheavyEst3=0.0

       do 1035 i=1,nrefl
         rho2=rhov(i)
         NumReso =
     +    INT((rho2-rhominD)*MaxShelReso/ (rhomaxD-rhominD)) + 1
         IF (NumReso.GT.MaxShelReso) NumReso = MaxShelReso
         IF (NumReso.LT.1) NumReso = 1
         sumFheavyEst0=sumFheavyEst0+FheavyEst0(i)/sc0
         sumFheavyEst2=sumFheavyEst2+FheavyEst2(i)/sc2
         sumFheavyEst3=sumFheavyEst3+FheavyEst3(i)/sc3
          dif0=abs(FheavyCalc(i)-FheavyEst0(i)/sc0)
          sumdif0=sumdif0+dif0
          dif2=abs(FheavyCalc(i)-FheavyEst2(i)/sc2)
          sumdif2=sumdif2+dif2
          dif3=abs(FheavyCalc(i)-FheavyEst3(i)/sc3)
          sumdif3=sumdif3+dif3
          dif0Med(NumReso)=dif0Med(NumReso)+dif0
          dif2Med(NumReso)=dif2Med(NumReso)+dif2
          dif3Med(NumReso)=dif3Med(NumReso)+dif3
 1035  continue

       write(lo,*)'R0=',sumdif0/sumFheavyC
       write(lo,*)'R2=',sumdif2/sumFheavyC
       write(lo,*)'R3=',sumdif3/sumFheavyC
      endif

      sumEhEst2=0.0
      sumEhEst3=0.0
      do 1040 j=1,MaxShelReso
        sumEhEst2=sumEhEst2+ehEst2(j)
        sumEhEst3=sumEhEst3+ehEst3(j)
        if (NumError(j).gt.0.0) then
         ehEst2(j)=ehEst2(j)/NumError(j)
         ehEst3(j)=ehEst3(j)/NumError(j)
         if (knw==1) then
          dif0Med(j)=dif0Med(j)/sumFheavy(j)
          dif2Med(j)=dif2Med(j)/sumFheavy(j)
          dif3Med(j)=dif3Med(j)/sumFheavy(j)
         endif
        endif
 1040  continue

c     U = (rhomaxD-rhominD)/REAL(MaxShelReso)
c     do i=1,MaxShelReso-1
c      RES(i) = 0.5/ sqrt(REAL(i)*U+rhominD)
c     enddo
c     RES(MaxShelReso) = 0.5/ sqrt(rhomaxD)

c     if (knw==1) then
c     WRITE (lo,2000)nalf(ider),
c    +    (RES(j),J=1,MaxShelReso),RES(MaxShelReso),
c    +    (NumError(j),j=1,MaxShelReso),int(sumNum),
c    +    (100.*errorSigma(j),j=1,MaxShelReso),
c    *    100.*sumerrorSigma/sumNum,
c    +    (deMed(j),j=1,MaxShelReso),sumdeMed/sumNum,
c    +    (ehMed(j),j=1,MaxShelReso),sumeHMed/sumNum,
c    +    (ehEst2(j),j=1,MaxShelReso),sumEhEst2/sumNum,
c    +    (dif2Med(j),j=1,MaxShelReso),sumdif2/sumFheavyC,
c    +    (dif0Med(j),j=1,MaxShelReso),sumdif0/sumFheavyC
c2000     format (/2X,'Derivative',1x,a2,71x,'TOTAL',
c    +            /2x,'______________',69x,'______',
c    +            /2X,'Res (A)      ',2X,8f8.2,2h |,f8.2,
c    +            /2x,'Nr. of refl. ',2x,8i8,2h |,i8,
c    +            /2x,'<|sig|2>     ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<|de|2>      ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<|eH|2>      ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<|eHest|2>   ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<R>          ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<Rde>        ',2x,8f8.2,2h |,f8.2/)

c     else

c     WRITE (lo,3000)nalf(ider),
c    +    (RES(j),J=1,MaxShelReso),RES(MaxShelReso),
c    +    (NumError(j),j=1,MaxShelReso),int(sumNum),
c    +    (errorSigma(j),j=1,MaxShelReso),sumerrorSigma/sumNum,
c    +    (deMed(j),j=1,MaxShelReso),sumdeMed/sumNum,
c    +    (ehEst2(j),j=1,MaxShelReso),sumEhEst2/sumNum 
c3000     format (/2X,'Derivative',1x,a2,71x,'TOTAL',
c    +            /2x,'______________',69x,'______',
c    +            /2X,'Res (A)      ',2X,8f8.2,2h |,f8.2,
c    +            /2x,'Nr. of refl. ',2x,8i8,2h |,i8,
c    +            /2x,'<|sig|2>     ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<|de|2>      ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<|eHest|2>   ',2x,8f8.2,2h |,f8.2/)

c     endif


      if (knw ==1) then
        FheavyEst2(:)=FheavyEst2(:)/sc2
        tirang1='|Eh|old'
        call GetStatRfac(tirang1,FheavyEst2,FheavyCalc,FheavyEst2,
     *             nrefl,1,wt,30,0.0)

        do i=1, nrefl
         if (sigEhEst(i) > 0.0) then
           wvar(i)=FheavyEst2(i)/sigEhEst(i)
         else
           wvar(i)=0.0
         endif
        enddo
        tirang1='(|Eh|/sigEh)old'
        call GetStatRfac(tirang1,wvar,FheavyCalc,FheavyEst2,
     *             nrefl,1,wt,30,0.0)


        tirang1='|Eh|new'
        FheavyEst3(:)=FheavyEst3(:)/sc3
        call GetStatRfac(tirang1,FheavyEst3,FheavyCalc,FheavyEst3,
     *             nrefl,1,wt,30,0.0)
        do i=1, nrefl
         if (sigEhEstn(i) > 0.0) then
           wvar(i)=FheavyEst3(i)/sigEhEstn(i)
         else
           wvar(i)=0.0
         endif
        enddo

        tirang1='(|Eh|/sigEh)new'
        call GetStatRfac(tirang1,wvar,FheavyCalc,FheavyEst3,
     *             nrefl,1,wt,30,0.0)
      endif


      end select

      deallocate(sigHeavy,sigEhEst,sigEhEstn,FheavyCalc,
     *           Delta2,stat=ierr)
      deallocate(FheavyEst0,FheavyEst2,FheavyEst3,stat=ierr)

c     write(lo,*) '******************************************'
c     write(lo,*) '*           END                           *'
c     write(lo,*) '******************************************'

      return
      end
c-----------------------------------------------------------
      SUBROUTINE mrqmin(x,y,sig,ndata,a,ia,ma,covar,alpha,nca,chisq,
     *                  funcs,alamda)
      INTEGER ma,nca,ndata,ia(ma),MMAX
      EXTERNAL funcs
      REAL alamda,chisq,a(ma),alpha(nca,nca),covar(nca,nca),
     *sig(ndata),x(ndata),y(ndata)
      PARAMETER (MMAX=20)
CU    USES covsrt,gaussj,mrqcof
      INTEGER j,k,l,mfit
      REAL ochisq,atry(MMAX),beta(MMAX),da(MMAX)
      SAVE ochisq,atry,beta,da,mfit
      if(alamda.lt.0.)then
        mfit=0
        do 11 j=1,ma
          if (ia(j).ne.0) mfit=mfit+1
11      continue
        alamda=0.001
        call mrqcof(x,y,sig,ndata,a,ia,ma,alpha,beta,nca,chisq,funcs)
        ochisq=chisq
        do 12 j=1,ma
          atry(j)=a(j)
12      continue
      endif
      do 14 j=1,mfit
        do 13 k=1,mfit
          covar(j,k)=alpha(j,k)
13      continue
        covar(j,j)=alpha(j,j)*(1.+alamda)
        da(j)=beta(j)
14    continue
      call gaussj(covar,mfit,nca,da,1,1)
      if(alamda.eq.0.)then
        call covsrt(covar,nca,ma,ia,mfit)
        call covsrt(alpha,nca,ma,ia,mfit)
        return
      endif
      j=0
      do 15 l=1,ma
        if(ia(l).ne.0) then
          j=j+1
          atry(l)=a(l)+da(j)
        endif
15    continue
      call mrqcof(x,y,sig,ndata,atry,ia,ma,covar,da,nca,chisq,funcs)
      if(chisq.lt.ochisq)then
        alamda=0.1*alamda
        ochisq=chisq
        do 17 j=1,mfit
          do 16 k=1,mfit
            alpha(j,k)=covar(j,k)
16        continue
          beta(j)=da(j)
17      continue
        do 18 l=1,ma
          a(l)=atry(l)
18      continue
      else
        alamda=10.*alamda
        chisq=ochisq
      endif
      return
      END
*---------------------------------------
      SUBROUTINE covsrt(covar,npc,ma,ia,mfit)
      INTEGER ma,mfit,npc,ia(ma)
      REAL covar(npc,npc)
      INTEGER i,j,k
      REAL swap
      do 12 i=mfit+1,ma
        do 11 j=1,i
          covar(i,j)=0.
          covar(j,i)=0.
11      continue
12    continue
      k=mfit
      do 15 j=ma,1,-1
        if(ia(j).ne.0)then
          do 13 i=1,ma
            swap=covar(i,k)
            covar(i,k)=covar(i,j)
            covar(i,j)=swap
13        continue
          do 14 i=1,ma
            swap=covar(k,i)
            covar(k,i)=covar(j,i)
            covar(j,i)=swap
14        continue
          k=k-1
        endif
15    continue
      return
      END
*----------------------------------------
      SUBROUTINE mrqcof(x,y,sig,ndata,a,ia,ma,alpha,beta,nalp,chisq,
     *funcs)
      INTEGER ma,nalp,ndata,ia(ma),MMAX
      REAL chisq,a(ma),alpha(nalp,nalp),beta(ma),sig(ndata),x(ndata),
     *y(ndata)
      EXTERNAL funcs
      PARAMETER (MMAX=20)
      INTEGER mfit,i,j,k,l,m
      REAL dy,sig2i,wt,ymod,dyda(MMAX)
      mfit=0
      do 11 j=1,ma
        if (ia(j).ne.0) mfit=mfit+1
11    continue
      do 13 j=1,mfit
        do 12 k=1,j
          alpha(j,k)=0.
12      continue
        beta(j)=0.
13    continue
      chisq=0.
      do 16 i=1,ndata
        call funcs(x(i),a,ymod,dyda,ma)
        sig2i=1./(sig(i)*sig(i))
        dy=y(i)-ymod
        j=0
        do 15 l=1,ma
          if(ia(l).ne.0) then
            j=j+1
            wt=dyda(l)*sig2i
            k=0
            do 14 m=1,l
              if(ia(m).ne.0) then
                k=k+1
                alpha(j,k)=alpha(j,k)+wt*dyda(m)
              endif
14          continue
            beta(j)=beta(j)+dy*wt
          endif
15      continue
        chisq=chisq+dy*dy*sig2i
16    continue
      do 18 j=2,mfit
        do 17 k=1,j-1
          alpha(k,j)=alpha(j,k)
17      continue
18    continue
      return
      END
*-------------------------------------------
      SUBROUTINE gaussj(a,n,np,b,m,mp)
      INTEGER m,mp,n,np,NMAX
      REAL a(np,np),b(np,mp)
      PARAMETER (NMAX=50)
      INTEGER i,icol,irow,j,k,l,ll,indxc(NMAX),indxr(NMAX),ipiv(NMAX)
      REAL big,dum,pivinv
      do 11 j=1,n
        ipiv(j)=0
11    continue
      do 22 i=1,n
        big=0.
        do 13 j=1,n
          if(ipiv(j).ne.1)then
            do 12 k=1,n
              if (ipiv(k).eq.0) then
                if (abs(a(j,k)).ge.big)then
                  big=abs(a(j,k))
                  irow=j
                  icol=k
                endif
              else if (ipiv(k).gt.1) then
                call cpause ('singular matrix in gaussj')
              endif
12          continue
          endif
13      continue
        ipiv(icol)=ipiv(icol)+1
        if (irow.ne.icol) then
          do 14 l=1,n
            dum=a(irow,l)
            a(irow,l)=a(icol,l)
            a(icol,l)=dum
14        continue
          do 15 l=1,m
            dum=b(irow,l)
            b(irow,l)=b(icol,l)
            b(icol,l)=dum
15        continue
        endif
        indxr(i)=irow
        indxc(i)=icol
        if (a(icol,icol).eq.0.) call cpause('singular matrix in gaussj')
        pivinv=1./a(icol,icol)
        a(icol,icol)=1.
        do 16 l=1,n
          a(icol,l)=a(icol,l)*pivinv
16      continue
        do 17 l=1,m
          b(icol,l)=b(icol,l)*pivinv
17      continue
        do 21 ll=1,n
          if(ll.ne.icol)then
            dum=a(ll,icol)
            a(ll,icol)=0.
            do 18 l=1,n
              a(ll,l)=a(ll,l)-a(icol,l)*dum
18          continue
            do 19 l=1,m
              b(ll,l)=b(ll,l)-b(icol,l)*dum
19          continue
          endif
21      continue
22    continue
      do 24 l=n,1,-1
        if(indxr(l).ne.indxc(l))then
          do 23 k=1,n
            dum=a(k,indxr(l))
            a(k,indxr(l))=a(k,indxc(l))
            a(k,indxc(l))=dum
23        continue
        endif
24    continue
      return
      END

* ---------------------------------------------   
      subroutine PdeltaFit(x,a,y,dyda,na)

      dimension a(na),dyda(na)

      
      y=a(na)*exp(-a(na)*x)
      dyda(na)=(1.-a(na)*x) * exp(-a(na)*x)
c     write(6,*)x,a,y,dyda,na
      return
      end
!-----------------------------------------------------------------------
      subroutine NormalMir(ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Molcom
      USE Grafici
      USE Param
      USE MadModule
      USE PhaseModule
!
      common/bterMIR/btnat,btder
c
      character  nomefile*255, filem*80, WilsonString*10, stringa*2 
      dimension f_derv(5), sigma_derv(5)
 
c

      rhomax=maxval(rhov(1:nrefl))
      rhomin=minval(rhov(1:nrefl))
      scnat=1.0
      btnat=0.0
      zero1 = 0.0
      zero2 = 0.0
      izero = 0
      call norm2000_MIR(scnat,btnat,zero1,zero2,izero,ier)
      write(lo,*) 'Native:',nrefl,scnat,btnat
      ! nativa
      fNativ(1:nrefl) = fNativ(1:nrefl) * sqrt(scnat)
      sNativ(1:nrefl) = sNativ(1:nrefl) * sqrt(scnat)

      Msg = "<big><b>Data Section:</b></big>"
      call TestoGR(Msg, color_RED, 2, 1)
      Msg = 'The heavy atom content is statistically estimated:'
      Msg = 'Derivative data used:'
      k = Lung(Msg) + 2
      do ider = 1, nDataSets
         id = kfpfs(ider)
         write(stringa,'(a2)') nalf(id)
         call lcase(stringa)
         call ucase(stringa(1:1))
         k1 = 2
         if (stringa(2:2) == ' ') k1 = 1
         Msg(k:k+k1) = stringa(1:k1) // ','
         if (ider == nDataSets) then
             Msg(k+k1:k+k1) = ' '
         else
             k = k + k1 + 2
         endif
      enddo 
      call TestoGR(Msg, -1, 2, 1)

      nreflSav = nrefl
      nkSav = nk
      s3s2d(:) = 0
           
      do ider = 1, nDataSets
         call GetFromAtmStruct
         WhichDeriv=ider
         call SigHEstimate(1)

         id = kfpfs(ider)
         nwMir(id) = nw(id)
         scder=1.0
         btder=0.0
         fNativ(1:nrefl) = fNativ(1:nrefl) / sqrt(scnat)
         sNativ(1:nrefl) = sNativ(1:nrefl) / sqrt(scnat)
         call norm2000_MIR(scnat,btnat,scder,btder,WhichDeriv,ier)
         write(lo,*) 'Derivative:',scder,btder

         fDeriv(1:nrefl,WhichDeriv) = fDeriv(1:nrefl,WhichDeriv) * 
     *                             sqrt(scder)
         sDeriv(1:nrefl,WhichDeriv) = sDeriv(1:nrefl,WhichDeriv) * 
     *                             sqrt(scder)

         fNativ(1:nrefl) = fNativ(1:nrefl) * sqrt(scnat)
         sNativ(1:nrefl) = sNativ(1:nrefl) * sqrt(scnat)

!

         if (knw.gt.0) then
             call SFCalc_mir()
         endif
!
         bt=btder
         call sigmaAheavy(WhichDeriv,0)
         call SigHEstimate(2)

!
!-- starts E calcultation
!
         k = 0
         do i=1, nrefl
                k = k + 1
                fovet(k) = fHeavy(i,WhichDeriv)
                sigmav(k) = sHeavy(i,WhichDeriv)
                iwork1(i) = k
         enddo
         nrefl = k
!
!-- in unit cell content only the heavy atom
!
         do i=1, nk
            if (kAnom(WhichDeriv) == nalf(i)) then
                no(1) = no(i)
                nw(1) = nw(i)
                cl(1) = cl(i)
                al(1:4,1) = al(1:4,i)
                bs(1:4,1) = bs(1:4,i)
                exit
            endif
         enddo
         nk = 1
         ifCreate = 0
         evet(:)=-1.0
         ifMercedes = 0
         call norm2000(ifMercedes, ier) 
         if (ier < 0) return
         eHeavy(:,WhichDeriv) = evet(:)
         btMir(WhichDeriv) = bt
         scMir(WhichDeriv) = sc
         nstrMir(WhichDeriv) = nstr
         nzroMir(WhichDeriv) = nzro
         fosogMir(WhichDeriv) = fosog
      enddo  ! end loop derivati
      Msg='The structure factor moduli of the heavy atoms (HASF)' //
     *    ' are estimated.'

      call TestoGR(Msg, -1, 2, 1)

      Msg=' '
      
!
      do i=1,nrefl
         iwork2(i) = i
         fovet(i) = fNativ(i)
         sigmav(i) = sNativ(i)
      enddo

      do ider = 1, nDataSets
         id = kfpfs(ider)
         nw(id) = nwMir(id)
      enddo
      nk = nkSav
      call AggiornaProperties(ier)

      write(lo,9022)
     *    (nomeat(i),Species(i),nw(i),no(i),zeff(i),i=1,nk)
 9022 format(/,12x,'Atom',6x,'Symbol',3x,'Number in cell',3x,
     *             'Atomic number',3x,'Z-eff.',/,
     *              (10x,a12,2x,a4,i13,i16,f14.3))
!
      call AggiornaRiflessiNew()
!
      if (knw==1) then
        do ider=1,nDataSets
          WhichDeriv=ider
          call SFCalc_mir()
          nkoti=count(eHeavy(:,ider)> 0.0)
          skoti=sum(eHeavy(:,ider),mask=eHeavy(:,ider)> 0.0)
          write(6,*)ider,nkoti,skoti/float(nkoti)
          skotiv=sum(worko(:),mask=eHeavy(:,ider)> 0.0)
          sckoti=skotiv/skoti
          write(6,*)sckoti
          skotidif=sum(abs((worko(:)-sckoti*eHeavy(:,ider))),
     *             mask=eHeavy(:,ider)> 0.0)
          write(6,*)skotidif/skotiv
        enddo
      endif
!
      call PutMad
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SFCalc_mir()
      USE General
      USE Symmetry
      USE Riflessi
      USE Molcom
      USE MadModule
      USE PhaseModule
!
! ----
!      structure factor calculation
! ----

      integer i1(3)
      character nomeFile*256
      dimension ffnk(18), cb(3)

      character cisp*2
      character *80 line, dire
      dimension vet(40),ivet(40)
      dimension xo(11),xn(11),keyx(10)
!--

      nH =  kfpfs(WhichDeriv)
      write(cisp,'(a2)') nalf(nH)
      call shift(cisp,nchar)

      k = index(fname(1), '.')
      k1=index(fname(1)(1:k),'_task')
      if (k1==0) k1 = k
      nomeFile = fname(1)(1:k1-1)//'.coor'

      write(lo,*)'FH from fragment: ',nomeFile
      write(lo,'(a2)') nalf(nH)
      itype=2
      iform=1
      jop=jopen(44,nomeFile,itype,iform,ierr)
      if (jop.lt.0) then
         return
      end if
!--
*     iAction = -1
*     nats = 500 * totop
*     call AllocaAtomi(iAction)
      natss = 0
!--
      j = 0
      do
         read(44,'(a)',end = 20) line
         call shift(line, nchar)
         if (line(1:1) /= '>' .and. line(1:1) /= '!' ) then
             call cutst(line,lenp,dire,lend)
             call lcase(dire)
             read(dire(1:2),'(a2)') cisp
             call lcase(cisp)
             read(cisp,'(a2)') isp
             if (isp.eq.nalf(nH)) then
                 j = j + 1
                 nzMM(j) = nH
             else 
                 goto 10
             end if
             iopt=0
             call getnum(line,vet,ivet,iv,iopt)
             if (iopt .ne. -1) then
                do i=1,iv
                   xyzMM(i,j)= vet(i)
                enddo
             endif
             if (iv == 3) then
                 xyzMM(4,j) = bt
                 xyzMM(5,j) = 1.0
             end if
             if (iv == 4) then
                 xyzMM(5,j) = 1.0
             end if
             bfacMM(j) = xyzMM(4,j)
         endif
  10  continue
      end do
   20 close(44)
      
      natss = j

      sumfor = 0.
      sumfc = 0.
!
c     nnn = nats
c     do na=1,nats
c        do n=2,nsym
c           do i = 1, 3
c              cb(i) = 0
c              do j = 1, 3
c                 cb(i) = cb(i) + kmat(n, i, j) * xyzs(j, na)
c              end do
c              cb(i) = cb(i) + tmat(n, i)
c           end do
c           nnn = nnn + 1
c           xyzs(1, nnn) = cb(1)
c           xyzs(2, nnn) = cb(2)
c           xyzs(3, nnn) = cb(3)
c           xyzs(4, nnn) = xyzs(4, na)
c           xyzs(5, nnn) = xyzs(5, na)
c           nz(nnn) = nz(na)
c           bfac(nnn) = bfac(na)
c        end do
c     end do
c     nats = nnn

      nnn=natss
      itype = 0
      do i=1,nnn
         xo(1)=xyzMM(1,i)
         xo(2)=xyzMM(2,i)
         xo(3)=xyzMM(3,i)
         iser=i
         iactn=1
         khead=0
         ksp=kspecb(newvet,xo,xn,keyx,itype,iser,khead,iactn)
         if (ksp < 0) xyzMM(5, i) = 1.0/float(keyx(10))
      enddo


      do i=1,nrefl
         i1(1)=khl(1,i)
         i1(2)=khl(2,i)
         i1(3)=khl(3,i)

         call cmult2002(i1,eps,multt)
!
!-- compute H*R and H*T
!
         do j=1,nsym
            tt=1000.0
            do l=1,3
               tt=tt+float(i1(l))*tmat(j,l)
               hkle(l,j)=0

               do k=1,3
                  hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)
               enddo

            enddo
            hkle(4,j)=tt
         enddo
     
         rho=rhov(i)
         
         act=0.0
         bct=0.0
         
c        do jj=1,nAnom
            nkA = nkAnom(WhichDeriv)
            ffnk(nkA) = cl(nkA)
            do ii=1,4
               ffnk(nkA) = ffnk(nkA) + al(ii,nkA) * exp(-bs(ii,nkA)*rho)
            end do
c        end do

         sfj = 0.
         do jj=1,natss
            if (nzMM(jj).ne.0) then
                arg=-bfacMM(jj)*rho
                effe=pts*ffnk(nzMM(jj))*exp(arg)
                tfocc=effe*xyzMM(5,jj)
                sfj = sfj + tfocc
!
                att=0.0
                btt=0.0
                do  j=1,nsym
                   arg=amod(hkle(1,j)*xyzMM(1,jj)
     *                     +hkle(2,j)*xyzMM(2,jj)
     *                     +hkle(3,j)*xyzMM(3,jj)
     *                     +hkle(4,j),1.0)
                   iarg=int(360.0*arg+0.5)+1
                   if (iarg.eq.361) iarg=1
                   att=att+cost(iarg)
                   btt=btt+sint(iarg)
                enddo
                if (icent.eq.0) then
                    contc=att
                    conts=btt
                else
                    contc=2.0*att
                    conts=0.0
                endif
!
                contc=contc*tfocc
                conts=conts*tfocc
                act=act+contc
                bct=bct+conts
            endif
         enddo

         sfj = sfj*sqrt(eps*nsym)

         args=act*act+bct*bct
         if (args.gt.0.000001) then
             fc=sqrt(args)
             faze=rtod*atan2(bct,act)+360.0
         else
             fc=0.0
             faze=0.0
         endif

         ipub(i) = mod(int(faze+0.5), 360)
         worko(i) = fc/sfj
         if (ipub(i).eq.0) then
            ipub(i) = 360
         end if

c        write(1,*)i1,fc,fc/sfj,ipub(i)
c        print*,i1,fc,fc/sfj,ipub(i)
      enddo
!
***   iAction = 2
***   call AllocaAtomi(iAction)
!
      return
      end 
!-----------------------------------------------------------------------
      subroutine norm2000_MIR(scp,btp,scdx,btdx,jposition,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Molcom
      USE MadModule
!
      common /misurato/ misu

c--
      character name*80, tmpChar*10
c     sapi
      common /rsc/ ibgr,mg,mig(8),scl,bts(9),scs(9),ip(8,3,5)
!g    common /atd/ gisd(560),giwd(560)
c     wilson plot parameters
!     common /c/ flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,del,ks
*gl*  common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
c
      dimension ivat(3),i1(3)
      dimension na(18)
c
      write(lo,*) '**********************************************'
      write(lo,*) '*  Normalization Procedure Native/Derivative  '
      write(lo,*) '**********************************************'

      ksubr = 1
c
c ---
      do i=1,nk
         na(i) = nw(i)
      enddo
      do i=1,560
         gis(i) = 0.0
         gisd(i) = 0.0
      enddo


      do i=1,560
         t      = 0.01 * float(i-1)
         tt     = t * t
         giw(i) = 0.0
         giwd(i) = 0.0
         iniz=0
         do j=1,nk-nDataSets
             iniz=iniz+1
             fz = cl(j)
             do jj=1,4
                bst = bs(jj,j) * tt
                if (bst.le.60.) then
                    fz = fz + al(jj,j) * exp(-bst)
                endif
             enddo
             gis(i) = gis(i) + fz * fz * float(na(j))
             fnw    = float(nw(j))
             giw(i) = giw(i) + fz * fz * fnw
         enddo
         if (jposition > 0) then
          gisd(i)=gis(i)
          giwd(i)=giw(i)
          do j=iniz+1,nk
             fz = cl(j)
             do jj=1,4
               bst = bs(jj,j) * tt
               if (bst.le.60.) then
                  fz = fz + al(jj,j) * exp(-bst)
                endif
              enddo
              if (kAnom(jposition) == nalf(j)) then
                gisd(i) = gisd(i) + fz * fz * float(na(j))*occHeavy**2
                fnw    = float(nw(j))*occHeavy**2
                giwd(i) = giw(i) + fz * fz * fnw
              endif
          enddo
         endif
      enddo

      do i=1,nrefl
         i1(1) = khl(1,i)
         i1(2) = khl(2,i)
         i1(3) = khl(3,i)
         fo    = fNativ(i)  ! Fnative
         sig   = sNativ(i)  ! sig(Fp)

         if (jposition > 0) then
           fd    = fDeriv(i,jposition)  ! Fderivative
           sigd  = sDeriv(i,jposition)    ! sig(Fd)
         else
           fd    = 0.0
           sigd  = 0.0
         endif

         rho   = rhov(i)   
c-- compute epsilon and multiplicity by generating equivalent
c-- reflexions
c-- epsylon = number of times same reflexion appears in list
c-- multiplicity = number different reflexions in list
c-- in triclinic space groups eps = 1.0 and mult = 1
         call cmult2002(i1,eps,multVal)
         ff0=fo*fo/pts
         fff=ff0

          ff0d=fd*fd/pts
          fffd=ff0d
c-- ig variable is not used
         ig=1
c-- pack symmetry functions for later use
c-- look up scattering factor tables
         mult(i) = multVal

         epsv(i) = eps     !pgMAD
         sinth=100.0*sqrt(rho)
         ind=max0(2,int(sinth+1.5))
*        write(0,*) i,i1,rho, sinth,ind
         frac=sinth-float(ind-1)
         bf=0.5*(giw(ind+1)-giw(ind-1))
         af=bf+giw(ind-1)-giw(ind)
         form=af*frac*frac+bf*frac+giw(ind)
         denor=form*eps
*        write(lo,*) i,i1,rho, sinth,ind,bf,af,form,denor
c-- 'wilson' structure factor or e'(p)
         work2(i)=fff/denor
c-- 'debye' structure factor or e'
         work1(i)=ff0/denor

         if (jposition > 0) then
         bf=0.5*(giwd(ind+1)-giwd(ind-1))
         af=bf+giwd(ind-1)-giwd(ind)
         form=af*frac*frac+bf*frac+giwd(ind)
         denor=form*eps

c-- 'wilson' structure factor or e'(p)
         fcvetp(i)=fffd/denor
c-- 'debye' structure factor or e'
         fcvetv(i)=ff0d/denor
         endif
      enddo

c--- Wilson Plot : Nativa
      nbWils=8.0*alog10(0.05*float(max0(nrefl,100))+0.5)
c     maximum of 30 points on wilson plot
      if (nbWils.gt.29) then
          nbWils = 29
      endif
      if (nrefl.le.0) then
          write(lo,448)
          ier=-1
          go to 1000
      endif
  448 format(/,' *** error *** no reflections supplied')
      if (iprin.gt.0) write(lo,442) nbWils
  442 format(' number of points on wilson plot =',i3)

      call scrper(' Computing Wilson plot',0,-1)
c-- obtain sums for wilson plot and fit least squares straight line
c
      if (jposition > 0) then
        xsc=scp
        xbt=btp
        call sum2000_MIR(jposition,xsc,xbt,ier)
        scdx=xsc/sc
        btdx=xbt-bt
      else
        call sum2000_MIR(0,0.0,0.0,ier)
        scp=sc
        btp=bt
      endif

 1000 continue
      return
      end

c-----------------------------------------------------------------------
c     least squares plot, including summation over nbWils ranges of rho
      subroutine sum2000_MIR(jnorm,xsc,xbt,ier)
      USE General
      USE Symmetry
      USE Riflessi
c
!     common /c/ flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,del,ks
      common/shell/zme(2,30),enr,ewmin(30),zmed(2,30),enrd,ewmind(30)
c
      dimension sw(30),sd(30),sr(30),nsum(30),si(30),nsum1(30)
      dimension swd(30),sdd(30),srd(30),sid(30)
      dimension sip(30),nsump(30)
c
c     if (iprin.gt.0) write(lo,40)
c  40 format(///,20x,18hleast squares plot//6h range,6x,
c    1 18hrho=(sinth/lam)**2,6x,6hnumber,6x,8hmean rho,7x,6hmean i,
c    2 7x,23hmean exp(-2*b*rho)*E**2,3x,5hdebye,7x,6hwilson)
c
c     set initial values

      if0=0
      ppp=0.0
      q=0.0
      r=0.0
      s=0.0
      t=0.0
      number=0
      if (jnorm.gt.0) then
        add=(rhomaxd-rhomind)/float(nbWils)
        start=-add
        end=add
        rr=float(nbWils)/(rhomaxd-rhomind)
      else
        add=(rhomax-rhomin)/float(nbWils)
        start=-add
        end=add
        rr=float(nbWils)/(rhomax-rhomin)
      endif

      do i=1,30
         sw(i)=0.0
         sd(i)=0.0
         sr(i)=0.0
         si(i)=0.0
         nsum(i)=0
         nsum1(i)=0
         ewmin(i)=99.9

         nsump(i)=0
         sip(i)=0.0

         swd(i)=0.0
         sdd(i)=0.0
         srd(i)=0.0
         sid(i)=0.0
         ewmind(i)=99.9

      enddo

      do 100 i=1,nrefl
         fo=fNativ(i)
         rho=rhov(i)
         ed=work1(i)
         ew=work2(i)

         if (jnorm > 0) then
           fd=fDeriv(i,jnorm)
           edd=fcvetv(i)
           ewd=fcvetp(i)
         endif

         if (jnorm > 0.and.fd < 0.0) then
           n=min0(int(1.0+rr*(rho-rhomin)),nbWils)
           multt = mult(i)
           eps = epsv(i)
           tmul=float(multt)
           nsump(n)=nsump(n)+1
           sip(n)=sip(n)+tmul*fo*fo/(eps*pts)
           goto 100
         endif


c-- n stores range of rho
         n=min0(int(1.0+rr*(rho-rhomin)),nbWils)
         multt = mult(i)
         eps = epsv(i)
         tmul=float(multt)
c-- weighted sums
c-- number of reflexions
         nsum(n)=nsum(n)+multt
         nsum1(n)=nsum(n)+1
c-- wilson
         sw(n)=sw(n)+ew*tmul
         if (ew.lt.ewmin(n)) then
             ewmin(n) = ew
         endif
c-- debye
         edi=ed
         if (edi.lt.0.) edi=0.
         sd(n)=sd(n)+edi*tmul
c-- rho
         sr(n)=sr(n)+rho*tmul
c-- intensity
         fo2=fo*fo
         if (fo2.lt.0.) fo2 = 0.
         si(n)=si(n)+tmul*fo2/(eps*pts)

         if (jnorm > 0) then
c-- wilson
           swd(n)=swd(n)+ewd*tmul
           if (ewd.lt.ewmind(n)) then
               ewmind(n) = ewd
           endif
c-- debye
           edid=edd
           if (edid.lt.0.) edid=0.
           sdd(n)=sdd(n)+edid*tmul
c-- intensity
           fd2=fd*fd
           if (fd2.lt.0.) fd2 = 0.
           sid(n)=sid(n)+tmul*fd2/(eps*pts)

         endif

 100  continue

      do i=1,nbWils
         if (nsum(i) > 0) then
             nbW = i
         else
             exit
         endif
      enddo
      if (nbW < nbWils) then
          write(lo,*) 
          write(lo,*) 
     *    '     *********************************************'
          write(lo,*) 
     *    '     ** Some problems in Wilson-plot procedure. **'
          write(lo,*) 
     *    '     **   If program fails, check reflections.  **'
          write(lo,*) 
     *    '     *********************************************'
          write(lo,*) 
          Msg = 'Some problems in Wilson-plot procedure.'
     *          // char(10) // 'If program fails, check reflections'
          call OpenWarning(Msg)
      endif
      nbWils = nbW
      iflag = 0
      do while (iflag.eq.0.and.nbWils.gt.0)
         if (nsum(nbWils).eq.0.or.
     *         sw(nbWils).lt.0.000001.or.
     *         sd(nbWils).lt.0.000001) then
             nbWils = nbWils - 1
         else
             iflag = 1
         endif
      enddo
      if (nbWils.le.1) then
          write(Msg,301)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier=-1
          return
      endif
      nnpn = 0
      do 300 i=1,nbWils
c-new 19/04/93
         if (nsum(i).eq.0.or.sw(i).lt.0.000001.or.
     *         sd(i).lt.0.000001) then
c-new 28/06/2002
             if (nnpn.eq.0) then
                goto 300
             end if
c-
             write(Msg,301)
             call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
             ier=-1
             return
         endif
         nnpn = 1
c-- smooth curve by adding adjacent ranges
         number=number+nsum(i)
         nsum(i)=nsum(i)+nsum(i+1)
         nsum1(i)=nsum1(i)+nsum1(i+1)
         ! native
         sw(i)=sw(i)+sw(i+1)
         sd(i)=sd(i)+sd(i+1)
         sr(i)=sr(i)+sr(i+1)
         si(i)=si(i)+si(i+1)
         ! derivative
         if (jnorm > 0) then
          swd(i)=swd(i)+swd(i+1)
          sdd(i)=sdd(i)+sdd(i+1)
          srd(i)=srd(i)+srd(i+1)
          sid(i)=sid(i)+sid(i+1)
          sip(i)=sip(i)+sip(i+1)
          nsump(i)=nsump(i)+nsump(i+1)
         endif

c-- calculate weighted averages and logs
         peso=float(nsum(i))
         div=1.0/amax1(1.0,peso)
         esqav=sd(i)*div
         if (jnorm > 0) then
           esqavd=sdd(i)*div
           esqav=esqav/esqavd
         endif
         flgd(i)=alog(esqav)
         avi=si(i)*div
         avr(i)=sr(i)*div
         if (jnorm > 0) then
          divp=1.0/amax1(1.0,float(nsump(i)))
          avip=sip(i)*divp
          avid=sid(i)*div
          avi=avi/avid
          aad=swd(i)*div
          aa=sw(i)*div
          aa=aa/aad
         endif

         if (jnorm > 0) then
           flgw(i)=alog(aa)
         else
           flgw(i)=alog(sw(i)*div)
         endif
         start=start+add
         
         if (jnorm > 0) then
           end=amin1(end+add,rhomaxd)
         else
           end=amin1(end+add,rhomax)
         endif
         if (nsum(i).eq.0) then
             flgd(i)=-20
             flgw(i)=-20
         endif
         if (iprin.gt.0) then
             if (if0.eq.0) then
                 if0=1
                 write(lo,40)
             endif
             write(lo,280) i,start,end,nsum(i),avr(i),avi,
     *                     esqav,flgd(i),flgw(i)
         endif
c-- coefficients of normal equations
         ppp=ppp+peso*avr(i)*avr(i)
         q=q+peso*avr(i)
         r=r+peso*avr(i)*flgd(i)
         s=s+peso*flgd(i)
         t=t+peso
  300 continue
   40 format(///,20x,'least squares plot',//,' range',6x,
     1 'rho=(sinth/lam)**2',6x,'number',6x,'mean rho',7x,'mean i',
     2 7x,'mean exp(-2*b*rho)*E**2',3x,'debye',7x,'wilson')
  280 format(' ',i3,f15.4,'  -',f8.4,i11,f14.4,f14.1,f23.4,f15.4,f13.4)
  301 format('Wilson-plot procedure in error. Check reflections')
      if (iprin.gt.0) write(lo,320) ppp,q,r,q,t,s
  320 format('normal equations',/,' ',e11.3,' * slope +',e11.3,
     1 ' * intercept =',e11.3)
c-- least squares
      div=ppp*t-q*q
      slope=(r*t-q*s)/div
      flgk=(ppp*s-q*r)/div
      sc=exp(-flgk)
      bt=-0.5*slope
      if (iprin.gt.0) write(lo,340) slope,flgk,bt,sc
  340 format(/,'slope =',f8.4,4x,'intercept =',f8.4,4x,
     1 'temperature factor (b) =',f8.4,4x,'scale =',f8.4/
     2 51x,'f(absolute)**2 = scale*f(observed)**2')
c
      if (jnorm.gt.0.and.bt.gt.0) then
          write(lo,*)' Btd < Btp'
          write(lo,"('Btd =',f10.3)")  xbt-bt
          write(lo,"('Scd =',f10.3)") xsc/sc
          bt=0.0
          slope=0.0
          flgk1=r/q
          flgk2=s/t
          flgk=(flgk1+flgk2)/2.0
          sc=exp(-flgk)
      endif

      return
      end
*----------------------------*
*---- Calcola le distanze----*
*----------------------------*
      function dista(x1,x2,cellx)
      USE General

      real x1(3),x2(3),cellx(6),delta(3)


      do 10 i=1,3
        if (x1(i).lt.0.0) x1(i)=x1(i)-int(x1(i))+1.0
        if (x1(i).gt.1.0) x1(i)=x1(i)-int(x1(i))
        if (x2(i).lt.0.0) x2(i)=x2(i)-int(x2(i))+1.0
        if (x2(i).gt.1.0) x2(i)=x2(i)-int(x2(i))
        de1= abs(x1(i)-x2(i))
        de= min(abs(de1-1.0),de1)
        delta(i)= de*cellx(i)
 10   continue

      cosa=cos(cellx(4)*dtor)
      cosb=cos(cellx(5)*dtor)
      cosg=cos(cellx(6)*dtor)
      dist2=delta(1)**2 + delta(2)**2 + delta(3)**2 +
     &      2.0*delta(1)*delta(2)*cosg + 2.0*delta(1)*delta(3)*cosb +
     &      2.0*delta(2)*delta(3)*cosa

      dista=sqrt( dist2 )

      return
      end

c----------------------------
      subroutine prepeqv
      USE General
      USE Symmetry

      common /misc/ ttt(3,3), dxmax(3), ishift(3,19)
      common /cent/ tl(3,4),fs(3,3,24),mlat

c-- halve y-axis by c.of.s. or lattice type if possible
      ihalf=0
      if (icent.eq.1) ihalf=-1
      if (ihalf.ne.0) goto 888
      goto (888,886,888,886,886,886,888), latt
  886 ihalf = 1
  888 call centre (1,1)
c-- expand to full space group symmetry
c-- put centring translations in tl(i,j)
      go to (940,890,890,890,890,910,920),latt
  890 call centre(2,latt)
      go to 940
  910 call centre(2,2)
      call centre(3,3)
      call centre(4,4)
      go to 940
  920 call centre(2,6)
      call centre(3,7)
  940 do 1000 i=1,nsym
      do 970 j=1,3
      do 950 k=1,3
      fs(k,j,i)=0.0
  950 continue
      do 960 k=1,2
      m=iabs(ismat(k,j,i))
      if (m.gt.0) fs(m,j,i)=float(isign(1,ismat(k,j,i)))
  960 continue
  970 continue
      if (i.eq.1.or.ihalf.ne.0) goto 1000
c-- halve y-axis by symmetry op. if possible
      do 980 j=1,3
      if (iabs(ismat(1,j,i)).ne.j.or.ismat(2,j,i).ne.0) goto 1000
  980 continue
      if (ismat(1,2,i).eq.(-2).and.abs(tsmat(2,i)).lt.1e-6) ihalf= -1
      if (ismat(1,2,i).eq.2.and.abs(tsmat(2,i)-0.5).lt.1e-6) ihalf=1
 1000 continue
      nsymTot=nsym*(icent+1)*mlat
      return
      end
!---------------------------------------------------
      subroutine sigmaAheavy(kheavy,iprint)

      USE General
      USE Symmetry
      USE Riflessi

      character *200 strTime
      real,     allocatable   :: RES(:),midpts(:),Eobs(:),Emodi(:)
      real,     allocatable   :: ee(:),sigEobs(:),sigEdobs(:)
      integer,  allocatable   :: RES_TAG(:)
      real,     allocatable   :: Eo2Shell(:),Ec2Shell(:),Eo2Ec2Shell(:)
      real,     allocatable   :: SIGnShell(:),SIGpShell(:),SIGqShell(:)
      real,     allocatable   :: EpsShell(:),scEo2Shell(:),scEc2Shell(:)
      real,     allocatable   :: SIGMAAShell(:),eeShell(:),
     *                           SIGMAAShell_l(:),xfit(:),yfit(:)
      real,     allocatable   :: DluzShell(:),sig(:),
     *                           DluzShell_l(:),numbShell(:)
      real,     allocatable   :: shellTAB(:,:),sumDiffShell(:),
     *                           sumFoShell(:),rfacShell(:)
      real*8,     allocatable   :: r(:),drds(:)
   


      if (iprint==1) then
        write(lo,*)'================================='
        write(lo,*)'=  sigmaAheavy  routine          ',kheavy,iprint
        write(lo,*)'================================='
      endif

      ! sort riflessi x il FOD
      work1(:)=fDeriv(:,kheavy)
      do i=1,nrefl
        iorde(i)=i
      enddo
      call sortall3(-1,work1,1,nrefl,iorde)
      nrefc=count(work1(1:nrefl) > 0.0)

      allocate (RES(nrefc),RES_TAG(nrefc),Eobs(nrefc),Emodi(nrefc), 
     *         sigEobs(nrefc),sigEdobs(nrefc),ee(nrefc), stat=ierr)

      do i=1,nrefc
       ii=iorde(i)
       RES(i)=sqrt(rhov(ii))
      enddo

      Nbin=30
      Nstat=floor(nrefc/float(Nbin))
      Nbin=8.0*alog10(0.05*float(max0(nrefc,100))+0.5)

      allocate (Eo2Shell(Nbin),Ec2Shell(Nbin),Eo2Ec2Shell(Nbin),
     *         SIGnShell(Nbin),SIGpShell(Nbin),SIGqShell(Nbin),
     *         EpsShell(Nbin),scEo2Shell(Nbin),scEc2Shell(Nbin),
     *         eeShell(Nbin),midpts(Nbin),SIGMAAShell(Nbin),
     *         SIGMAAShell_l(Nbin),xfit(Nbin),yfit(Nbin),
     *         DluzShell(Nbin),DluzShell_l(Nbin),
     *         sig(Nbin),shellTAB(Nbin,2),numbShell(Nbin),
     *         sumDiffShell(Nbin),
     *         sumFoShell(Nbin),rfacShell(Nbin),
     *         r(Nbin),drds(Nbin), 
     *         stat=ierr)

      shellTAB(:,:)=0.0
      midpts(:)=0.0
      RES_TAG(:)=0
      call shells(shellTAB,midpts,RES_TAG,RES,nrefc,Nbin,1) 

      Eobs(:)=0.0
      Emodi(:)=0.0
      SigmaaVal(:)=0.0
      Eo2Shell(:)=0.0
      Ec2Shell(:)=0.0
      Eo2Ec2Shell(:)=0.0
      SIGqShell(:)=0.0
      eeShell(:)=0.0
      scEo2Shell(:)=1.0
      scEc2Shell(:)=1.0
      SIGMAAShell(:)=0.0
      SIGMAAShell_l(:)=0.0
      DluzShell(:)=0.0
      DluzShell_l(:)=0.0
      sumDiffShell(:)=0.0
      rfacShell(:)=0.0
      sumFoShell(:)=0.0

      ! calc sihP, sigQ & sigN for any shell

      if (iprint==1) then
       write(lo,*)'Nr riflessi obs:',nrefc
       write(lo,*)'Nr riflessi con Fc >0:',count(work1(1:nrefc) > 0.0)
      endif

      sumFo=0.0
      sumFc=0.0
      do i=1,nrefc
       ii=iorde(i)
       sumFo=sumFo+fNativ(ii)*fDeriv(ii,kheavy)
       sumFc=sumFc+fDeriv(ii,kheavy)**2
      enddo

      scaleFoFc=sumFo/sumFc

      if (iprint==1) then
        write(lo,*)'scale(Fo,Fc):',scaleFoFc
      endif

      sumFo=0.0
      do i=1,nrefc
       ii=iorde(i)
       sumFo=sumFo+fNativ(ii)
      enddo

      SIGnShell(:)=0.0
      SIGpShell(:)=0.0
      numbShell(:)=0.0

      sumDiff=0.0
      do i=1,nrefc
         ic=iorde(i)
         ii=RES_TAG(i)
         eps=epsv(ic)*pts
         wref=2.0
         if (mkang(ic) > 1) wref=1.0
         numbShell(ii)=numbShell(ii) + wref
         SIGnShell(ii)=SIGnShell(ii) + wref*((fNativ(ic)**2)/eps)
         SIGpShell(ii)=SIGpShell(ii) + 
     *                 wref*((fDeriv(ic,kheavy)**2)/eps)
         sumDiffShell(ii)=sumDiffShell(ii)  +
     *           abs(fNativ(ic) - scaleFoFc *fDeriv(ic,kheavy))
         sumFoShell(ii)=sumFoShell(ii) + fNativ(ic)
         sumDiff=sumDiff +abs(fNativ(ic)-
     *           scaleFoFc *fDeriv(ic,kheavy))
      enddo

      do i=1,Nbin
        SIGpShell(i)=SIGpShell(i)/numbShell(i)
        SIGnShell(i)=SIGnShell(i)/numbShell(i)
      enddo

      !------------------------------
      do i=1,nrefc
         ic=iorde(i)
         ii=RES_TAG(i)
         eps=epsv(ic)*pts
         Eobs(i)=fNativ(ic)/(sqrt(eps*SIGnShell(ii)))
         Emodi(i)=fDeriv(ic,kheavy)/(sqrt(eps*SIGpShell(ii)))
         if (Emodi(i) < 0.0) then
           call cstop(' ')
         endif
      enddo

      sumEo=sum(Eobs(1:nrefc))
      sumEc=sum(Emodi(1:nrefc))
      scaleEoEc=sumEo/sumEc
   
      if (iprint==1) then
        write(lo,*)'scale(Eo,Ec):',scaleEoEc
      endif

      sumDiffShell(:)=0.0
      sumFoShell(:)=0.0
      sumDiff=0.0
      do i=1,nrefc
        ii=RES_TAG(i)
        sumDiffShell(ii)=sumDiffShell(ii)  + 
     *          abs(Eobs(i) - scaleEoEc *Emodi(i))
        sumFoShell(ii)=sumFoShell(ii) + Eobs(i)
        sumDiff=sumDiff  + abs(Eobs(i) - scaleEoEc *Emodi(i))
      enddo

      do i=1, Nbin
        if (sumFoShell(i) > 0.0 ) then
         rfacShell(i)=sumDiffShell(i)/sumFoShell(i)
        endif
      enddo

      if (iprint==1) then
        write(lo,*)' <sigN>',sum(SIGnShell(:))/float(Nbin)
        write(lo,*)' <sigP>',sum(SIGpShell(:))/float(Nbin)
        write(lo,*)' <sigP>/<sigN>',sum(SIGpShell(:))/sum(SIGnShell(:))
      endif

      ! calc Eo, Ec
      do i=1,nrefc
       ic=iorde(i)
       ii=RES_TAG(i)
       eps=epsv(ic)*pts
       Eobs(i)=fNativ(ic)/(sqrt(eps*SIGnShell(ii)))
       Emodi(i)=fDeriv(ic,kheavy)/(sqrt(eps*SIGpShell(ii)))
       sigEobs(i)=sNativ(ic)/(sqrt(eps*SIGnShell(ii)))
       sigEdobs(i)=sDeriv(ic,kheavy)/(sqrt(eps*SIGnShell(ii)))
       ee(i)=(1.0 + 1.0*sigEobs(i)**2) * (1.0 + 1.0*sigEdobs(i)**2)
       eeShell(ii)= eeShell(ii)+ee(i)
       Eo2Shell(ii)= Eo2Shell(ii)+Eobs(i)**2
       Ec2Shell(ii)= Ec2Shell(ii)+Emodi(i)**2
       Eo2Ec2Shell(ii)=Eo2Ec2Shell(ii) + ((Eobs(i)**2)*(Emodi(i)**2))
      enddo

      if (iprint==1) then
        write(lo,*)'<Eo>',sum(Eobs(:))/float(nrefc)
        write(lo,*)'<Ec>',sum(Emodi(:))/float(nrefc)
        write(lo,*)'<sigE>',sum(sigEobs(:))/float(nrefc)
      endif

      ! calc <Eo2>, <Ec2> <Eo2Ec2> for any shell
      do i=1, Nbin
        numbShell1=count(RES_TAG(:) == i)
        Eo2Shell(i)=Eo2Shell(i)/float(numbShell1)
        Ec2Shell(i)=Ec2Shell(i)/float(numbShell1)
        Eo2Ec2Shell(i)=Eo2Ec2Shell(i)/float(numbShell1)
        eeShell(i)=eeShell(i)/float(numbShell1)
      enddo

      if (iprint==1) then
        write(lo,*)'<e>o',sum(eeShell(:))/float(Nbin)
        write(lo,*)'<Eo2>o',sum(Eo2Shell(:))/float(Nbin)
        write(lo,*)'<Ec2>o',sum(Ec2Shell(:))/float(Nbin)
        write(lo,*)'<Eo2Ec2>o',sum(Eo2Ec2Shell(:))/float(Nbin)
        write(lo,*)'R(Eo,Ec)',sumDiff/sumEo
      endif

      !scale <Eo2> , <Ec2>, <Eo2Ec2> and calc <sigmaA> for any shell
      do i=1,Nbin
        scEo2Shell(i)=Eo2Shell(i)/1.0
        scEc2Shell(i)=Ec2Shell(i)/1.0
        Eo2Shell(i)=Eo2Shell(i)/scEo2Shell(i)
        Ec2Shell(i)=Ec2Shell(i)/scEc2Shell(i)
        Eo2Ec2Shell(i)=Eo2Ec2Shell(i)/(scEo2Shell(i)*scEc2Shell(i))
      enddo

      if ((sum(Eo2Ec2Shell(:))/float(Nbin)) < 1.1) eeShell(1:Nbin)=1.0
      do ii=1,Nbin
       do i=1,Nbin
        dif=Eo2Ec2Shell(i) - eeShell(i)
        if (dif < 0.01) then
          if (i == Nbin) then
            Eo2Ec2Shell(i)=Eo2Ec2Shell(i-1)
          elseif (i == 1) then
            Eo2Ec2Shell(i)=Eo2Ec2Shell(i+1)
          else
            Eo2Ec2Shell(i)=0.5*(Eo2Ec2Shell(i-1) + 
     *              Eo2Ec2Shell(i+1))
          endif
        endif
       enddo
      enddo

      do i=1,Nbin
       if (Eo2Ec2Shell(i) > eeShell(i)) then
         SIGMAAShell(i)=sqrt((Eo2Ec2Shell(i)-eeShell(i)))
       else
         if (Eo2Ec2Shell(i) > 1.0) then
            SIGMAAShell(i)=sqrt((Eo2Ec2Shell(i)-1.0))
         else
           SIGMAAShell(i)=0.0
         endif
        endif
        SIGMAAShell(i)=max(0.05,SIGMAAShell(i))
      enddo

      rSumSigmaa=sum(abs(SIGMAAShell(1:Nbin)))

      if (rSumSigmaa < 0.0001) then
       write(lo,*) ' !!!!! errore sum(sigmaA)=0 '
       call cstop(' ')
      endif


      ! sigmaa refinement (max =10 cycle)
c        do 100 iref=1,10
c         r(:)=0.0d0
c         drds(:)=0.0d0
c         do i=1,nrefc
c          ic=iorde(i)
c          ii=RES_TAG(i)
c          en=Eobs(i)
c          ep=Emodi(i)
c          if (en > 0.0.and.ep > 0.0) then
c          x=2.0*en*ep*SIGMAAShell(ii)/(eeShell(ii)-SIGMAAShell(ii)**2)
c          dxds=2.0*en*ep*(eeShell(ii)+SIGMAAShell(ii)**2)/
c    *         (eeShell(ii)-SIGMAAShell(ii)**2)**2
c          if (itype(ic)==1) then
c           rm=bes(x)
c           rm=sim(x)
c           rmbyx=0.5
c           if (x.gt.0.001) rmbyx=rm/x
c           r(ii)=r(ii)+2.0d0*dble(SIGMAAShell(ii)-rm*en*ep)
c           drds(ii)=drds(ii)+
c    +        2.0d0*dble(1.0-en*ep*(1.0-rmbyx-rm**2)*dxds)
c          else
c           rm=tanh(0.5*x)
c           r(ii)=r(ii)+dble(SIGMAAShell(ii)-rm*en*ep)
c           drds(ii)=drds(ii)+dble(1.0-en*ep*0.5*(1.0-rm**2)*dxds)
c          endif
c          endif
c        enddo
c      ! update sigmaA
c        dsmax=0.0
c        do i=1,Nbin
c           numbShell1=count(RES_TAG(:) == i)
c           if (numbShell1.gt.0) then
c             ds=real(r(i)/drds(i))
c             SIGMAAShell(i)=SIGMAAShell(i)-ds
c             SIGMAAShell(i)=min(SIGMAAShell(i),0.999)
c             dsmax=max(abs(ds),dsmax)
c           endif
c          enddo
c       if (dsmax.lt.0.0001) goto 102
c100    continue
c102    continue
c       if (iprint==1) then
c         write(lo,*)'sigmaA cycles:',iref
c       endif


      ! linear fit per sigmaA
      mwt=0
      sig(:)=0.0

      nInit=1
      do i=1,Nbin
        if (midpts(i) > 0.9) then
         nInit=i
         exit
        endif
      enddo

c     print*,'nInit=',nInit
      
      nEnd=1
      NPT=Nbin - nInit + 1 - nEnd
      xfit(1:NPT)=midpts(nInit:Nbin-1)
      yfit(1:NPT)=SIGMAAShell(nInit:Nbin-1)

      call fit(xfit,yfit,NPT,sig,mwt,a,b,siga,sigb,chi2,q)

      if (iprint==1) then
      write(lo,*)'sigmaA linear fitting:'
      write(lo,'(1x,t5,a,f9.6,t24,a,f9.6)') 'A = ',a,'Uncertainty: ',
     *       siga
      write(lo,'(1x,t5,a,f9.6,t24,a,f9.6)') 'B = ',b,'Uncertainty: ',
     *       sigb
      write(lo,'(1x,t5,a,4x,f10.6)') 'Chi-squared: ',chi2
      write(lo,'(1x,t5,a,f10.6)') 'Goodness-of-fit: ',q
      endif

      do i=1,Nbin
        ! per non usare linear fitting
        SIGMAAShell_l(i)=SIGMAAShell(i)
        SIGMAAShell_l(i)=min(1.0,SIGMAAShell_l(i)) 
        if (a > 0.0 ) then
          DluzShell_l(i)=SIGMAAShell_l(i)/sqrt(a)
          DluzShell_l(i)=min(1.0,DluzShell_l(i))
        else
         DluzShell_l(i)=DluzShell(i)
        endif
        sigNsigP=sqrt(SIGnShell(i)/SIGpShell(i))
        sigNsigP=max(1.0,sigNsigP)
        DluzShell(i)=SIGMAAShell_l(i)*sigNsigP
        DluzShell(i)=min(1.0,DluzShell(i))
        DluzShell(i)=max(0.0,DluzShell(i))
      enddo


      if (iprint==1) then
        write(lo,*)'<e>n',sum(eeShell(:))/float(Nbin)
        write(lo,*)'<Eo2>n',sum(Eo2Shell(:))/float(Nbin)
        write(lo,*)'<Ec2>n',sum(Ec2Shell(:))/float(Nbin)
        write(lo,*)'<Eo2Ec2>n',sum(Eo2Ec2Shell(:))/float(Nbin)
      endif

      sigAmed=sum(SIGMAAShell(:))/float(Nbin)

      if (iprint==1) then
        write(lo,"(1x,'Shell',1x,'res',2x,'sint/l',3x,'NREF',
     *            2x,'<Eo2Ec2>',
     *            1x,'R(Eo,Ec)',
     *            1x,'sigmaA',1x,
     *            5x,'D')")
        do i=1,Nbin
          numbShell1=count(RES_TAG(:) == i)
           write(lo,1000)i,0.5/midpts(i),midpts(i),
     *                numbShell1,
     *                Eo2Ec2Shell(i),
     *                rfacShell(i),
     *                SIGMAAShell(i),
     *                DluzShell(i)
      
 1000 format(2x,i2,1x,f6.2,1x,f6.3,2x,i5,4(2x,f7.4))
        enddo
        write(lo,"(2x,116('_'))")
        write(lo,"(20x,i5,4(2x,f7.4),11(' ',f6.3))")
     *             nrefc,
     *             sum(Eo2Ec2Shell(:))/float(Nbin),
     *             sumDiff/sumEo,
     *             sum(SIGMAAShell(:))/float(Nbin),
     *             sum(DluzShell(:))/float(Nbin)

      endif

      do i=1,nrefc
        ic=iorde(i)
        ii=RES_TAG(i)
        SigmaaVal(ic)=SIGMAAShell(ii)
        Dluz(ic)=DluzShell(ii)
      enddo

      deallocate (Eo2Shell,Ec2Shell,Eo2Ec2Shell,
     *          SIGnShell,SIGpShell,SIGqShell,
     *          EpsShell,scEo2Shell,scEc2Shell,
     *          eeShell,midpts,SIGMAAShell,
     *          SIGMAAShell_l,xfit,yfit,
     *          DluzShell,DluzShell_l,
     *          sig,shellTAB,numbShell,
     *          sumDiffShell,
     *          sumFoShell,rfacShell,
     *          r,drds,
     *          stat=ierr)

      return
      end
