#include "mrconfig.h"
#include <gtkmrcomune.h>
#include "callbacks.h"
#include "aliasx.h"
extern GtkWidget *finestre[6];
extern int nSpec;
extern gchar *Specie[NUMSPECIES];
extern int  *SinglePlotStyle;
extern int  *nzTot;

extern _Dialogo *dialogo;

namespace main_app {
       extern Application TheApp;
                   }

void c_aggiornadisegno(void);

static int PlotStyle = 3;
static int gSelMode = 4;
static GtkWidget *cplotstyle_dlg = NULL;
static int selezione[NUMSPECIES];
static int curPs, RadType;
static float probability;
static const char *selections[] = {"Select by Species", "Select by Mouse",
                             "Select by Polygon", "All"}; 
static const char *plotstyles[] = {"Wires", "Rods", "Simple", "Sticks & Balls", 
                              "Bubbles", "Shading", "Van der Waals", 
                              "Ellipsoids"};
static const int nPlotStyles = G_N_ELEMENTS(plotstyles);

static _StyleType FrameStyle = {true, 1, NULL, GTK_SHADOW_ETCHED_IN, 6, 6, 20, 6};

void manage_ok_ps(int from)
{
}


static void sel_element(GtkTreeSelection *selec, gpointer data)
{
    GtkTreeView *treeview;
    GtkTreePath *path;
    GList *rowsel = NULL;
    int i, num_selections;

    treeview = gtk_tree_selection_get_tree_view(selec);
    rowsel = get_selections(GTK_WIDGET(treeview));
    if(rowsel)
       num_selections = g_list_length(rowsel);
    else
       num_selections = 0;
    for(i=0; i<NUMSPECIES; i++)
        selezione[i] = 0;
    for(i=0; i<num_selections; i++)
    {
        path = (GtkTreePath *)g_list_nth_data (rowsel, i);
        selezione[atoi(gtk_tree_path_to_string(path))] = 1;
    }
}

void get_prob(GtkAdjustment *adj, gpointer user_data)
{
    probability = (float) gtk_adjustment_get_value(adj);
}

void change_rad_type(GtkToggleButton *button, gpointer data)
{
    if(gtk_toggle_button_get_active(button))
       RadType = GPOINTER_TO_INT(data);
}

int newPlotStyle()
{
   int i, count[10], result;

   for(i=0; i<10; i++)
       count[i] = 0;
   for(i=0; i<dialogo->NatMol; i++)
       count[SinglePlotStyle[i]-1]++;
   result = 1;
   for(i=1; i<10; i++)
       if(count[i] > count[result-1])
          result = i+1;
   return result;
}

void close_cpsdlg(GtkButton *button, gpointer data)
{
    int i, ifOk, ifClose;

    ifOk = (GPOINTER_TO_INT(data)) % 10;
    ifClose = !(GPOINTER_TO_INT(data) / 10);

    if(ifOk)
    {
       dialogo->nRadType = RadType;
       if(dialogo->ProbF != probability)
          aggiorna_prob_(&probability);
       switch(gSelMode)
       {
       default:
            break;
       case 1:
            for(i=0; i<dialogo->NatMol; i++)
            {
                if(selezione[nzTot[i]-1])
                   SinglePlotStyle[i] = curPs;
            }
            dialogo->iPlotType = newPlotStyle();
            break;
       case 2:
       case 3:
            i = 0;
            while(dialogo->kptrc[i] != 0)
            {
                SinglePlotStyle[dialogo->kptrc[i]-1] = curPs;
                i++;
            }
            dialogo->iPlotType = newPlotStyle();
            break;
       case 4:
               for(i=0; i<dialogo->NatMol; i++)
                   SinglePlotStyle[i] = curPs;
            dialogo->iPlotType = curPs;
       }
       main_app::TheApp.UpdatePS(dialogo->iPlotType);
       c_aggiornadisegno();
    }
    if(ifClose)
       close_dlg(button, GINT_TO_POINTER(1));
}

static void selection_mode_changed (GtkWidget *combo, int newSel)
{

    GtkWidget *frame_list, *fpro, *frad;

    gSelMode = newSel + 1;
    if(!gSelMode)
       return;

    fpro = get_widget(cplotstyle_dlg, "fProbability");
    frad = get_widget(cplotstyle_dlg, "fRadius");
    gtk_widget_set_sensitive(fpro, FALSE);
    gtk_widget_set_sensitive(frad, FALSE);
    frame_list = get_widget(cplotstyle_dlg, "frame_list");
    if(gSelMode == 1)                   /* Select by Species */
       gtk_widget_set_sensitive(frame_list, TRUE);
    else                 
    {
       gtk_widget_set_sensitive(frame_list, FALSE);
       frame_list = get_widget(cplotstyle_dlg, "lista_specie");
       unselect_all(GTK_TREE_VIEW(frame_list));
       for(int i=0; i<NUMSPECIES; i++)
           selezione[i] = 0;
       if((gSelMode != 4) && gSelMode)
           mostra_tbg1lsq(finestre[0], gSelMode, 4);
    }
    if((curPs >= dialogo->STICKS_N_BALLS) && (curPs <= dialogo->SHADING) &&
         (gSelMode == 4))
        gtk_widget_set_sensitive(frad, TRUE);
    if((curPs == dialogo->ELLIPSOIDS) && (gSelMode == 4))
        gtk_widget_set_sensitive(fpro, TRUE);
}

static void ps_changed (GtkWidget *combo,  int newStyle)
{
    GtkWidget *preview, *pict, *optmenu, *fpro, *frad;

    curPs = newStyle + 1;
    if(!curPs)
       return;
    fpro = get_widget(cplotstyle_dlg, "fProbability");
    frad = get_widget(cplotstyle_dlg, "fRadius");
    gtk_widget_set_sensitive(fpro, FALSE);
    gtk_widget_set_sensitive(frad, FALSE);

    preview = get_widget(cplotstyle_dlg, "preview");
    pict = gtk_bin_get_child(GTK_BIN(preview));
    gtk_container_remove(GTK_CONTAINER(preview), pict);

    optmenu = get_widget(cplotstyle_dlg, "plotstyles");
    pict = get_widget(optmenu, g_strdup_printf("item%d", curPs));
    gtk_container_add(GTK_CONTAINER(preview), pict);
    gtk_widget_show(pict);

    if((curPs == dialogo->RODS) || (curPs == dialogo->VAN_DER_WAALS))
    { 
        optmenu = get_widget(cplotstyle_dlg, "selections");
        combo_set_val(optmenu, 4);
        gtk_widget_set_sensitive(optmenu, FALSE);
        gSelMode = 4;
    }
    else
    { 
        optmenu = get_widget(cplotstyle_dlg, "selections");
        gtk_widget_set_sensitive(optmenu, TRUE);
    }
    if((curPs >= dialogo->STICKS_N_BALLS) && (curPs <= dialogo->SHADING) &&
         (gSelMode == 4))
        gtk_widget_set_sensitive(frad, TRUE);
    if((curPs == dialogo->ELLIPSOIDS) && (gSelMode == 4))
        gtk_widget_set_sensitive(fpro, TRUE);

}

void change_plot_style(void)
{
   GtkWidget *dialog, *vbox, *frame, *button, *icon, *table, *list, *hscale;
   GObject *adj;
   GSList *group = NULL;
   GtkTreeSelection *select;
   char nome[8];
   int i;

   dialog = gtk_dialog_new();
   cplotstyle_dlg = dialog;
   gtk_window_set_title (GTK_WINDOW (dialog), "Define Plot Style");
   gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_MOUSE);
   gtk_container_set_border_width(GTK_CONTAINER(dialog), 6);
   
   vbox = gtk_dialog_get_content_area(GTK_DIALOG(dialog));

   table = table_new(2, 2, TRUE);
   gtk_box_pack_start(GTK_BOX(vbox), table, TRUE, TRUE, 0);

   vbox = vbox_new(FALSE, 0);
   table_attach(table, vbox, 0, 1, 0, 1, TRUE);

   frame = NEW_FRAME("Select atoms", &FrameStyle);
   gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 0);

   button = MRcombo_new(selections, selection_mode_changed, 3, 4);
   gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), button);
   g_object_set_data(G_OBJECT(dialog), "selections", button);
   
   frame = NEW_FRAME("Select Plot Style", &FrameStyle);
   gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 10);
   button = MRcombo_new(plotstyles, ps_changed, dialogo->iPlotType - 1, 
                nPlotStyles);
   gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), button);
   g_object_set_data(G_OBJECT(dialog), "plotstyles", button);

   frame = NEW_FRAME("Preview", &FrameStyle);
   table_attach(table, frame, 0, 1, 1, 2, TRUE);
   g_object_set_data(G_OBJECT(dialog), "preview", get_widget(frame, "align"));
   
   for (i=1; i<=nPlotStyles; i++)
   {
        ScriviStringa(nome, sizeof(nome), "ps%d", i);
        icon = create_image(g_strdup_printf("%s.png", nome));
        g_object_ref(icon);
        ScriviStringa(nome, sizeof(nome), "item%d", i);
        g_object_set_data(G_OBJECT(button), nome, icon);
        if(i == 1)
           gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), icon);
   }

   frame = NEW_FRAME("Species", &FrameStyle);
   table_attach(table, frame, 1, 2, 0, 1, TRUE);
   g_object_set_data(G_OBJECT(dialog), "frame_list", frame);
   list = create_selection (dialog, get_widget(frame, "align"), NULL, "lista_specie");

   select = gtk_tree_view_get_selection (GTK_TREE_VIEW (list));
   gtk_tree_selection_set_mode (select, GTK_SELECTION_MULTIPLE);
   g_signal_connect (G_OBJECT (select), "changed",
                  G_CALLBACK (sel_element),
                  NULL);
   populate_list(GTK_TREE_VIEW(list), Specie, nSpec, 1);

   vbox = vbox_new(FALSE, 0);
   table_attach(table, vbox, 1, 2, 1, 2, TRUE);

   frame = NEW_FRAME("Probability", &FrameStyle);
   g_object_set_data(G_OBJECT (dialog), "fProbability", frame);
   gtk_box_pack_end(GTK_BOX(vbox), frame, FALSE, FALSE, 0);

   adj = adj_new (0, 0, 1, 0.05f, 0.1f);
   hscale = hscale_new (GTK_ADJUSTMENT (adj));
   g_object_set_data(G_OBJECT (dialog), "hscale", adj);
   gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), hscale);
   gtk_scale_set_value_pos (GTK_SCALE (hscale), GTK_POS_BOTTOM);
   gtk_scale_set_digits (GTK_SCALE (hscale), 2);
   (void) g_signal_connect (G_OBJECT(
               gtk_range_get_adjustment((GtkRange *)hscale)),
               "value_changed", G_CALLBACK (get_prob), NULL);

   frame = NEW_FRAME("Radius proportional to:", &FrameStyle);
   g_object_set_data(G_OBJECT (dialog), "fRadius", frame);
   gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 0);

   vbox = vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), vbox);

   button = RADIO_BUTTON_WITH_LABEL(group, "Covalent Radius", LABELCOLOR);
   group = gtk_radio_button_get_group (GTK_RADIO_BUTTON(button));
   gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 2);
   (void) g_signal_connect(G_OBJECT(button), "toggled",
          G_CALLBACK(change_rad_type), GINT_TO_POINTER(1));
   g_object_set_data(G_OBJECT (dialog), "r1", button);

   button = RADIO_BUTTON_WITH_LABEL(group, "Peak Height", LABELCOLOR);
   group = gtk_radio_button_get_group (GTK_RADIO_BUTTON(button));
   gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 2);
   (void) g_signal_connect(G_OBJECT(button), "toggled",
          G_CALLBACK(change_rad_type), GINT_TO_POINTER(2));
   g_object_set_data(G_OBJECT (dialog), "r2", button);

   button = RADIO_BUTTON_WITH_LABEL(group, "Thermal Factor", LABELCOLOR);
   group = gtk_radio_button_get_group (GTK_RADIO_BUTTON(button));
   gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 2);
   (void) g_signal_connect(G_OBJECT(button), "toggled",
          G_CALLBACK(change_rad_type), GINT_TO_POINTER(3));
   g_object_set_data(G_OBJECT (dialog), "r3", button);

   button = myimage_button("   _OK", "ok.png");
   gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button, 1);
   (void) g_signal_connect (G_OBJECT (button), "clicked",
                      G_CALLBACK(close_cpsdlg), GINT_TO_POINTER(1));

   button = myimage_button ("_Accept", "apply.png");
   gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button, 2);
   (void) g_signal_connect (G_OBJECT (button), "clicked",
                      G_CALLBACK(close_cpsdlg), GINT_TO_POINTER(11));

   button = myimage_button("  _Cancel", "cancel.png");
   gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button, 3);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
           GTK_BUTTONBOX_SPREAD);
   (void) g_signal_connect (G_OBJECT (button), "clicked",
                      G_CALLBACK(close_cpsdlg), GINT_TO_POINTER(0));
   (void) g_signal_connect_swapped(G_OBJECT(dialog), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
  (void) g_signal_connect (G_OBJECT (dialog), "delete_event",
                      G_CALLBACK(true_cb), NULL);

}

void open_cplotstyle_dlg(GtkWidget *item, gpointer data)
{
   GtkWidget *button, *preview, *pict;
   GObject *adj;
   int i;
   char nome[8];

   PlotStyle = dialogo->iPlotType;
   RadType = dialogo->nRadType;
   probability = dialogo->ProbF;
   gSelMode = 4;
   if(cplotstyle_dlg == NULL)
      change_plot_style();

   adj = G_OBJECT(get_object(cplotstyle_dlg, "hscale"));
   gtk_adjustment_set_value(GTK_ADJUSTMENT(adj) , dialogo->ProbF);

   ScriviStringa(nome, sizeof(nome), "r%d", dialogo->nRadType);
   button = get_widget(cplotstyle_dlg, nome);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);

   button = get_widget(cplotstyle_dlg, "selections");
   combo_set_val (button, 4);

   button = get_widget(cplotstyle_dlg, "plotstyles");
   combo_set_val (button, dialogo->iPlotType);
   curPs = dialogo->iPlotType;
   ScriviStringa(nome, sizeof(nome), "item%d", curPs);
   preview = get_widget(cplotstyle_dlg, "preview");
   pict = gtk_bin_get_child(GTK_BIN(preview));
   gtk_container_remove(GTK_CONTAINER(preview), pict);

   pict = get_widget(button, nome);
   gtk_container_add(GTK_CONTAINER(preview), pict);
   gtk_widget_show(pict);

   button = get_widget(cplotstyle_dlg, "lista_specie");
   populate_list(GTK_TREE_VIEW(button), Specie, nSpec, 1);
   for(i=0; i<NUMSPECIES; i++)
       selezione[i] = 0;

   button = get_widget(cplotstyle_dlg, "frame_list");
   gtk_widget_set_sensitive(button, FALSE);
   gtk_window_set_transient_for(GTK_WINDOW(cplotstyle_dlg), GTK_WINDOW(finestre[0]));
   gtk_widget_show_all(cplotstyle_dlg);

   gdk_window_raise(gtk_widget_get_window(cplotstyle_dlg));
   finestra_modale_aperta2(cplotstyle_dlg);
   g_object_set_data(G_OBJECT(finestre[0]), "win_dlg", cplotstyle_dlg);

}

void c_buildskeleton (GtkWidget *item,  gpointer data)
{
    int quale, azione;
    GtkWidget *pixmapwid, *button = get_widget(item, "button");
    char num[8];

    azione = GPOINTER_TO_INT(data); 
    if (azione == 1)
    {
        quale = get_int(button, "quale");
        ScriviStringa(num, sizeof(num), "icon%d", quale);
        pixmapwid = get_widget(button, num);
        gtk_widget_hide(pixmapwid);
        quale++;
        quale %= 2;
        ScriviStringa(num, sizeof(num), "icon%d", quale);
        pixmapwid = get_widget(button, num);
        gtk_widget_show(pixmapwid);
        g_object_set_data(G_OBJECT(button), "quale", GINT_TO_POINTER(quale));
    }
    leggiskeleton_(&azione);
}
