#include "mrconfig.h"
#include "aliasx.h"
#include <gtkmrcomune.h>

namespace main_app {
       extern Application TheApp;
                   }

static int statoglob[20];
static int statoiniziale[20];
/*
 0         Apply symmentry
 1         Fit to Window
 2         Draw Ghosts
 3         Draw Restraints
 4         Draw Hydrogens
 5         Draw HBonds
 6         Perspective
 7         ViewDist*10
 8         nCell along a
 9         nCell along b
10         nCell along c
11         perc a *100
12         perc b *100
13         perc c *100
14         1
15         1
16         1
17         int(DeADef(1)*100)
18         int(DeADef(2)*100)
19         int(DeADef(3)*100)
*/
static GtkWidget *opt_dlg = NULL;
static const char *checks[] = {//"Draw Cell Edges",
                         "Apply Symmetry",
                         "Fit to Window",
                         "Draw Ghosts",
                         "Draw Restraints",
                         "Draw Hydrogens",
                         "Draw Hyd. Bonds",
                         "Perspective"
                        };
static const char *labels[] = {"along a",
                         "along b",
                         "along c",
                         "Perc. of a",
                         "Perc. of b",
                         "Perc. of c"
                        };

extern GtkWidget *finestre[6];
extern GdkCursor *default_cursor, *wait_cursor;
extern stringa     *It;
extern PangoFontDescription *fontdescN, *fontdescP;

extern _Dialogo *dialogo;

void aggiornatasto2(const char *nome, gboolean stato);

void c_plot_opt (int *iact, int statoiniziale[])
{

    fortran_al_lavoro();
    plot_opt_(iact,statoiniziale);
    fine_lavoro();
    aggiornatasto2("SymmOn", statoiniziale[0]);
}

void c_set_prosp (int dist, int ifProsp)
{
       void c_aggiornadisegno();

       dialogo->ViewDist = (float)dist * 0.1f;
       if (ifProsp == 0)
          dialogo->ViewDist = 2.e7;
       c_aggiornadisegno();
}


void get_viewdist (GtkAdjustment *adj, gpointer data)
{
    int viewdist;
    double viewdistance;

    viewdistance = gtk_adjustment_get_value(adj) ;
    viewdist = (int) viewdistance * 10;
    statoglob[7] = viewdist;
}

void on_spin_changed (GtkWidget *spin, gpointer data)
{
    int i;

    i = GPOINTER_TO_INT(data);
    statoglob[8+i] = spin_button_get_value_as_int(spin);

}

void on_ok_clicked  (GtkButton *button, gpointer data)
{
    static int int2 = 2;

    close_dlg(button, GINT_TO_POINTER(1));
    c_plot_opt (&int2,statoglob);
}

void on_okp_clicked  (GtkButton *button, gpointer data)
{
    int dist, ifProsp;

    dist = statoglob[7];
    ifProsp = statoglob[6];
    close_dlg(button, GINT_TO_POINTER(1));
    c_set_prosp (dist, ifProsp);
}

void on_default_clicked (GtkButton *button, gpointer data)
{
    static int int1 = 1;

    close_dlg(button, GINT_TO_POINTER(1));
    c_plot_opt (&int1,statoglob);
}

void on_options_check_toggled (GtkToggleButton *togglebutton, gpointer data)
{
   int val;
   float viewdistance;
   GtkAdjustment *adj;
   GtkWidget *dlg, *frame, *scale;

   val = GPOINTER_TO_INT(data);
   dlg = gtk_widget_get_toplevel(GTK_WIDGET(togglebutton));
   frame = get_widget(dlg, "framesymm");
   scale = get_widget(dlg, "hscale");
   statoglob[val] = gtk_toggle_button_get_active(togglebutton);
   if(val == 6)
   {
      if (statoglob[val] == 0)
      {
         adj = GTK_ADJUSTMENT(get_object(dlg, "hscale_view"));
         viewdistance = (float) (2000.0f);  
         gtk_adjustment_set_value (adj,viewdistance);
         statoglob[val+1] = 20000000;
      }
      gtk_widget_set_sensitive(scale, statoglob[val]);
  }
  else if(val == 0)
      gtk_widget_set_sensitive(frame, statoglob[val]);
}

void set_opt(GtkWidget *dlg, int input_val[])
{
    int i;
    GtkWidget *frame;
    GtkToggleButton *checkb;
    GtkAdjustment *adj;
    float viewdistance;

    for(i=0;i<7; i++)
    {
        checkb = GTK_TOGGLE_BUTTON(get_widget(dlg, checks[i]));
        gtk_toggle_button_set_active(checkb, input_val[i]);
    }
    viewdistance = (float) ((input_val[7])/10.0f);  
    adj = GTK_ADJUSTMENT(get_object(dlg, "hscale_view"));
    gtk_adjustment_set_value(adj, viewdistance);

    frame = get_widget(dlg, "hscale");
    gtk_widget_set_sensitive(GTK_WIDGET(frame), input_val[6]);

    for(i=0;i<6;i++)
    {
        adj = GTK_ADJUSTMENT(get_object(dlg, labels[i]));
        gtk_adjustment_set_value(adj, (float)input_val[8+i]);
    }
    frame = get_widget(dlg, "framesymm");
    gtk_widget_set_sensitive(frame, input_val[1]);
}

GtkWidget* create_options_dialog (GCallback cb)
{
  GtkWidget *options_dlg;
  GtkWidget *frame;
  GtkWidget *button;
  GtkWidget *vbox;
  GtkWidget *hbox;
  GtkWidget *opts_check;
  GtkWidget *hscale_view;
  GtkWidget *label;
  GtkWidget *spin;
  GtkWidget *table;
  GtkWidget *align;
  GObject *adj;
  int i, j;

  options_dlg = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (options_dlg), "Drawing Options");
  gtk_window_set_position (GTK_WINDOW (options_dlg), GTK_WIN_POS_MOUSE);
  vbox = gtk_dialog_get_content_area(GTK_DIALOG(options_dlg));
  gtk_container_set_border_width (GTK_CONTAINER (options_dlg), 8);

  frame = gtk_frame_new (NULL);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

  table = table_new(3, 2, TRUE);
  gtk_container_add (GTK_CONTAINER (frame), table);
  gtk_container_set_border_width (GTK_CONTAINER (table), 4);

  for (i=0;i<6;i++)
  {
      j = i/2;
      opts_check = CHECK_BUTTON_WITH_LABEL (checks[i], LABELCOLOR);
      g_object_set_data (G_OBJECT (options_dlg), checks[i],
           opts_check);
      table_attach(table,opts_check,i%2,(i%2)+1,j,j+1, TRUE);
      (void) g_signal_connect (G_OBJECT (opts_check), "toggled",
                 G_CALLBACK (on_options_check_toggled),
                 GINT_TO_POINTER(i));
  }

  frame = FRAME_BOLD("View Distance", FRAMECOLOR, 1.2f);
  gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 6);
  gtk_widget_show(frame);

  hbox = hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame), hbox);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 4);
  gtk_widget_show(hbox);

  opts_check = CHECK_BUTTON_WITH_LABEL (checks[6], LABELCOLOR);
  g_object_set_data(G_OBJECT (options_dlg), checks[6], opts_check);
  gtk_box_pack_start (GTK_BOX (hbox), opts_check, FALSE, FALSE, 0);
  (void) g_signal_connect (G_OBJECT (opts_check), "toggled",
                      G_CALLBACK (on_options_check_toggled),
                      GINT_TO_POINTER(6));
  gtk_widget_show(opts_check);

  adj = adj_new (10, 10, 200, 0, 10);
  (void) g_signal_connect(adj,"value_changed", 
           G_CALLBACK(get_viewdist), NULL);
  g_object_set_data(G_OBJECT (options_dlg), "hscale_view", adj);

  hscale_view = hscale_new (GTK_ADJUSTMENT (adj));
  g_object_set_data(G_OBJECT (options_dlg), "hscale", 
                 hscale_view);
  gtk_widget_show (hscale_view);
  gtk_box_pack_start (GTK_BOX (hbox), hscale_view, TRUE,TRUE, 0);
  gtk_widget_show(hscale_view);

  frame = gtk_frame_new (NULL);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
  g_object_set_data (G_OBJECT (options_dlg), "framesymm", 
                 frame);

  table = table_new(5, 4, FALSE);
  gtk_container_add (GTK_CONTAINER (frame), table);
  gtk_container_set_border_width (GTK_CONTAINER (table), 4);
  table_set_row_spacings(table, 8);
  table_set_col_spacings(table, 8);

  label = LABEL_BOLD("Number of cells:", LABELCOLOR, 1.2f);
  table_attach(table, label, 0, 2, 0, 1);
  set_alignment(label, 0.f, 0.5f);

  label = LABEL_BOLD("Shell around the cells:", LABELCOLOR, 1.2f);
  table_attach (table, label, 2, 4, 0, 1);
  set_alignment(label, 0.f, 0.5f);

  for(i=0;i<6;i++)
  {
      j = 2*(i/3);
      label = LABEL_NEW(labels[i], LABELCOLOR);
      set_alignment(label, 0.f, 0.5f);
      table_attach (table, label,j,j+1,(i%3)+1,(i%3)+2);
      if(j == 0)                          /* number of cells */
         adj = adj_new (1, 1, 3, 1, 1);
      else                                /* shell around the cells */
         adj = adj_new (1, 0, 50, 1, 2);
      spin = spin_button_new (GTK_ADJUSTMENT(adj), 1, 0);
      g_object_set_data(G_OBJECT (options_dlg), labels[i], adj);
      (void) g_signal_connect (G_OBJECT (spin), "value-changed",
                      G_CALLBACK (on_spin_changed), GINT_TO_POINTER(i));
      table_attach(table,spin,j+1,j+2,(i%3)+1,(i%3)+2);
  }

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_CENTER,GTK_ALIGN_CENTER,0,0);
#else
  align = gtk_alignment_new(0.5f,0.5f,0.f,0.f);
#endif
  table_attach(table, align, 0, 4, 4, 5);

  button = myimage_button("  _Reset", "reset.png");
  gtk_container_add(GTK_CONTAINER(align), button);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
             G_CALLBACK (on_default_clicked), NULL);

  button = myimage_button("   _OK", "ok.png");
  gtk_dialog_add_action_widget (GTK_DIALOG(options_dlg), button, 1);
  (void) g_signal_connect (G_OBJECT (button), "clicked",
                      G_CALLBACK (cb), NULL);
  g_object_set_data (G_OBJECT (options_dlg), "b1", 
                 button);

  button = myimage_button("  _Cancel", "cancel.png");
  gtk_dialog_add_action_widget (GTK_DIALOG(options_dlg), button, 2);
  (void) g_signal_connect (G_OBJECT (button), "clicked",
                      G_CALLBACK (close_dlg), GINT_TO_POINTER(1));
  g_object_set_data (G_OBJECT (options_dlg), "b2", 
                 button);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
        GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect_swapped(G_OBJECT(options_dlg), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
  (void) g_signal_connect (G_OBJECT (options_dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return options_dlg;
}

void open_optdlg(GtkWidget *item, gpointer data)
{
     int i;
     int iact = 1;
     GtkWidget *frame;

     c_plot_opt(&iact,statoiniziale);
     for (i=0; i<20; i++)
         statoglob[i] = statoiniziale[i];
     if(opt_dlg == NULL)
        opt_dlg = create_options_dialog(G_CALLBACK(on_ok_clicked));
     set_opt(opt_dlg, statoiniziale);
     gtk_window_set_transient_for(GTK_WINDOW(opt_dlg), GTK_WINDOW(finestre[0]));
     gtk_widget_show_all(opt_dlg);
     frame = get_widget(opt_dlg, "framesymm");
     gtk_widget_set_sensitive(frame, statoiniziale[0]);
     gdk_window_raise(gtk_widget_get_window(opt_dlg));
     finestra_modale_aperta2(opt_dlg);
}

/***********************************************************/
/*           C H A R A C T E R    S I Z E                  */
/***********************************************************/

void  check_menu_item(GtkWidget *item, gboolean stato)
{
   int hnd = get_int(item, "hnd");
   g_signal_handler_block(G_OBJECT(item), hnd);
   gtk_check_menu_item_set_active((GtkCheckMenuItem *)item, stato);
   g_signal_handler_unblock(G_OBJECT(item), hnd);
}

#ifdef __WIN3232
void set_char_size(GtkWidget *wi, gpointer data)
{
     GtkWidget *menubar, *item;
     int isize = GPOINTER_TO_INT(data);

     menubar = get_widget(finestre[0], menubarname);
     pango_font_description_set_size (fontdescN, isize*PANGO_SCALE);
     main_app::TheApp.SetFont('N', pango_font_description_to_string(fontdescN));
     set_font('N');
     pango_font_description_set_size (fontdescP, isize*PANGO_SCALE);
     main_app::TheApp.SetFont('P', pango_font_description_to_string(fontdescP));
     set_font('P');

     switch(isize)
     {
     case 8:
          item = get_widget(menubar, "Small");
          check_menu_item(item, TRUE);
          item = get_widget(menubar, "Medium");
          check_menu_item(item, FALSE);
          item = get_widget(menubar, "Large");
          check_menu_item(item, FALSE);
          break;
     case 10:
          item = get_widget(menubar, "Small");
          check_menu_item(item, FALSE);
          item = get_widget(menubar, "Medium");
          check_menu_item(item, TRUE);
          item = get_widget(menubar, "Large");
          check_menu_item(item, FALSE);
          break;
     default:
          item = get_widget(menubar, "Small");
          check_menu_item(item, FALSE);
          item = get_widget(menubar, "Medium");
          check_menu_item(item, FALSE);
          item = get_widget(menubar, "Large");
          check_menu_item(item, TRUE);
          break;
     }
}
#endif
/***********************************************************/
/*           N E W    B R O W S E R                        */
/***********************************************************/

GtkWidget *select_browser_dlg = NULL;

void change_browser(GtkButton *button, gpointer data)
{
    GtkWidget *entry;

    entry = lookup_widget(GTK_WIDGET(button), "entry");
    main_app::TheApp.UpdateIB(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
}

GtkWidget *create_selectbrowser(void)
{
   GtkWidget *dialog, *vbox, *label, *entry, *button;

   dialog = gtk_dialog_new();

   gtk_window_set_title(GTK_WINDOW(dialog), 
               "Internet Browser");
   gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);

   vbox = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
   gtk_container_set_border_width(GTK_CONTAINER(dialog), 12);

   label = label_boxed_medium("Change the default name\nfor the Internet Browser"); 
   gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 10);

   entry = ENTRY_NEW();
   g_object_set_data (G_OBJECT (dialog), "entry", entry);
   gtk_box_pack_start(GTK_BOX(vbox), entry, FALSE, FALSE, 10);

   button = myimage_button("   _OK", "ok.png");
   (void) g_signal_connect(G_OBJECT (button), "clicked",
                       G_CALLBACK (change_browser), NULL);
   (void) g_signal_connect_after (G_OBJECT (button), "clicked",
                       G_CALLBACK (close_dlg), GINT_TO_POINTER(1));
   gtk_dialog_add_action_widget(GTK_DIALOG (dialog), button, 1); 

   button = myimage_button("  _Cancel", "cancel.png");
   (void) g_signal_connect (G_OBJECT (button), "clicked",
                       G_CALLBACK (close_dlg), GINT_TO_POINTER(1));
   gtk_dialog_add_action_widget(GTK_DIALOG (dialog), button, 2); 
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);

   (void) g_signal_connect_swapped(G_OBJECT(dialog), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
  (void) g_signal_connect (G_OBJECT (dialog), "delete_event",
                      G_CALLBACK(true_cb), NULL);
   return dialog;
}

void open_scelta_browser(GtkWidget *item, gpointer data)
{
    GtkWidget *entry;

    if(select_browser_dlg == NULL)
       select_browser_dlg = create_selectbrowser();
    entry = lookup_widget(select_browser_dlg, "entry");
    gtk_entry_set_text(GTK_ENTRY(entry), main_app::TheApp.InternetBrowser().c_str());
    gtk_widget_show_all(select_browser_dlg);
    gdk_window_raise(gtk_widget_get_window(select_browser_dlg));
    finestra_modale_aperta2(select_browser_dlg);
}

/***********************************************************************/

/*                            A L I E N                                */

/***********************************************************************/
static GtkWidget *alien_dlg = NULL;
void to_open_file(GtkButton *button, gpointer data);

void change_alien(GtkButton *button, gpointer data)
{
    GtkWidget *entry;

    entry = lookup_widget(GTK_WIDGET(button), "ib");
    main_app::TheApp.UpdateIB( gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
    entry = lookup_widget(GTK_WIDGET(button), "povray");
    main_app::TheApp.UpdatePovray( gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
}

GtkWidget *create_alien_dlg()
{
   GtkWidget *dialog, *vbox, *label, *entry, *button;

   dialog = gtk_dialog_new();

   gtk_window_set_title(GTK_WINDOW(dialog), 
               "Alien Programs");
   gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
   gtk_widget_set_size_request(dialog, 400, 300);

   vbox = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
   gtk_container_set_border_width(GTK_CONTAINER(dialog), 12);

   label = label_boxed_medium(g_strdup_printf("Install alien programs in %s",
           MR_PACKAGE)); 
   gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 10);

#ifdef _WIN32
   entry = entry_for_fileselection("PovRay (pvengine.exe)", "povray.png", 
        G_CALLBACK(to_open_file), GINT_TO_POINTER(12), 0, 1, LABELCOLOR);
#else
   entry = entry_for_fileselection("PovRay", "povray.png", 
        G_CALLBACK(to_open_file), GINT_TO_POINTER(12), 0, 1, LABELCOLOR);
#endif
   gtk_box_pack_start(GTK_BOX(vbox), entry, FALSE, FALSE, 10);
   g_object_set_data(G_OBJECT(dialog), "povray", get_widget(entry, "entry"));

   entry = entry_for_fileselection("Internet Browser", "browser.png", 
        G_CALLBACK(to_open_file), GINT_TO_POINTER(11), 0, 1, LABELCOLOR);
   gtk_box_pack_start(GTK_BOX(vbox), entry, FALSE, FALSE, 10);
   g_object_set_data(G_OBJECT(dialog), "ib", get_widget(entry, "entry"));

   button = myimage_button("   _OK", "ok.png");
   (void) g_signal_connect(G_OBJECT (button), "clicked",
                       G_CALLBACK (change_alien), NULL);
   (void) g_signal_connect_after (G_OBJECT (button), "clicked",
                       G_CALLBACK (close_dlg), GINT_TO_POINTER(1));
   gtk_dialog_add_action_widget(GTK_DIALOG (dialog), button, 1); 

   button = myimage_button("  _Cancel", "cancel.png");
   (void) g_signal_connect (G_OBJECT (button), "clicked",
                       G_CALLBACK (close_dlg), GINT_TO_POINTER(1));
   gtk_dialog_add_action_widget(GTK_DIALOG (dialog), button, 2); 

   (void) g_signal_connect_swapped(G_OBJECT(dialog), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
  (void) g_signal_connect (G_OBJECT (dialog), "delete_event",
                      G_CALLBACK(true_cb), NULL);
   return dialog;
}


void open_alien(GtkWidget *item, gpointer data)
{
    GtkWidget *entry;

    if(alien_dlg == NULL)
       alien_dlg = create_alien_dlg();
    g_object_set_data(G_OBJECT(finestre[0]), "alien_dlg", alien_dlg);
    entry = lookup_widget(alien_dlg, "povray");
    gtk_entry_set_text(GTK_ENTRY(entry), main_app::TheApp.PovrayP().c_str());
    entry = lookup_widget(alien_dlg, "ib");
    gtk_entry_set_text(GTK_ENTRY(entry), main_app::TheApp.InternetBrowser().c_str());
    gtk_window_set_transient_for(GTK_WINDOW(alien_dlg), GTK_WINDOW(finestre[0]));
    gtk_widget_show_all(alien_dlg);
    gdk_window_raise(gtk_widget_get_window(alien_dlg));
    finestra_modale_aperta2(alien_dlg);
}

/***********************************************************************/

/*                            B U I L D                                */

/***********************************************************************/
namespace GLextmr 
{
      char *getStringSymm(int *koper, int nops);
}

GtkWidget *build_dlg = NULL;

int symop, nc[3], nsym, nce;
int sel_line = -1;

void c_autobuild(GtkWidget *item, gpointer data)
{
   GtkWidget *statusbar, *drawingarea;

   statusbar = lookup_widget(finestre[0], statusbarname);
   drawingarea = lookup_widget(finestre[0], drawingareaname);
   print_mess("Computing... please wait");
   set_smiley(3);
   gdk_window_set_cursor(gtk_widget_get_window(drawingarea),wait_cursor);
   autobuild_();
   aggiornatasto2("SymmOn", dialogo->ifCont);
   gtk_statusbar_pop(GTK_STATUSBAR(statusbar), 1);
   set_smiley(1);
   gdk_window_set_cursor(gtk_widget_get_window(drawingarea),default_cursor);
}

void c_resetbuild(GtkWidget *item, gpointer data)
{
   resetbuild_();
   aggiornatasto2("SymmOn", dialogo->ifCont);
}


void  c_finish_aided_build(int kplt)
{
   finish_aided_build_(&kplt);
   aggiornatasto2("SymmOn", dialogo->ifCont);
}

static void sel_to_undo (GtkTreeSelection *selec, gpointer data)
{
    GtkTreeModel *model;
    GtkTreeIter iter;
    GtkTreeView *treeview;
    gboolean is_selection;
    GtkWidget *button;
    int row;

    treeview = gtk_tree_selection_get_tree_view(selec);
    button = lookup_widget(GTK_WIDGET(treeview), "undo");
    is_selection = gtk_tree_selection_get_selected (selec, &model, &iter);
    gtk_widget_set_sensitive(button, is_selection);

    if(is_selection)
    {
       row = row_selected(selec);
       sel_line = row+1;
    }
}

void aggiorna_condizioni(GtkWidget *button, int flag)
{
   GtkWidget *widget;
   GtkWidget *list;
   char *symop_txt, *riga;

   list = lookup_widget (button, "appcond");
   if(flag > 0)
   {
      widget = lookup_widget (button, "combosymop");
      symop_txt = g_strdup_printf("%s", 
       combo_get_text (get_widget(widget, "entry")));
      riga = g_strdup_printf("%s   %d, %d, %d", symop_txt,
               nc[0], nc[1], nc[2]);
      add_line_to_list(list, (gpointer) riga);
   }
   else if(flag < 0)
     remove_selection(list);
   else
      clear_list(list);
}
void end_build (GtkButton *button, gpointer data)
{
  int ifOkay, kplt;
  
  ifOkay = GPOINTER_TO_INT(data);

  if(ifOkay > 0)
  {
      kplt = symop * 1000 +
             ( nc[0] + 5 ) * 100 +
             ( nc[1] + 5 ) *  10 +
             ( nc[2] + 5 );

     c_finish_aided_build(kplt);
  }
  else if(ifOkay < 0)
  {
     kplt = -sel_line;
     c_finish_aided_build(kplt);
  }
  else
     c_resetbuild(NULL, NULL);
  aggiorna_condizioni (GTK_WIDGET(button), ifOkay);
}

void get_combotxt (GtkWidget *combo, gpointer data)
{
  GtkWidget *widget;
  char *symop_txt;

  symop_txt = g_strdup(combo_get_text (combo));
  widget = lookup_widget (GTK_WIDGET(combo), "symopl");
  if(symop_txt)
    label_boxed_set_text(widget, symop_txt);
}

void nc_changed (GtkWidget *spin, gpointer data)
{
    int i;
    GtkWidget *widget;
    char sp[5];

    for (i=0; i<3; i++)
    {
         ScriviStringa(sp, sizeof(sp), "sp%d", i);
         widget = lookup_widget(GTK_WIDGET(spin), sp);
         nc[i] = spin_button_get_value_as_int(widget); 
    }
    widget = lookup_widget(GTK_WIDGET(spin), "ncelll");
    label_boxed_set_text(widget, g_strdup_printf("%d, %d, %d", nc[0], nc[1],
                         nc[2]));
}
GtkWidget* create_build_dlg (void)
{
  GtkWidget *dialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *hbox;
  GtkWidget *list;
  GtkWidget *frame;
  GtkWidget *align;
  GtkWidget *label;
  GtkWidget *symopw;
  GtkWidget *hseparator;
  GtkWidget *table1;
  GtkWidget *symop_t;
  GtkWidget *ncell_t;
  GtkWidget *spin;
  GtkWidget *pix;
  GtkWidget *button;
  GtkTreeSelection *selec;

  dialog = gtk_dialog_new ();
  gtk_container_set_border_width (GTK_CONTAINER (dialog), 10);
  gtk_window_set_title (GTK_WINDOW (dialog), "Aided Build");

  dialog_vbox1 = gtk_dialog_get_content_area(GTK_DIALOG (dialog));
  gtk_container_set_border_width (GTK_CONTAINER (dialog_vbox1), 1);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_CENTER,GTK_ALIGN_FILL,0,1);
#else
  align = gtk_alignment_new(0.5,0.5,0.,1.);
#endif
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), align, TRUE, TRUE, 0);

  table1 = table_new (9, 6, FALSE);
  gtk_container_add (GTK_CONTAINER(align), table1);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 3);
  table_set_row_spacings (table1, 4);
  table_set_col_spacings (table1, 8);

  label = LABEL_NEW ("Symmetry operators", LABELCOLOR);
  set_alignment(label, 0, 0.5);
  table_attach_exp (table1, label, 0, 3, 0, 1);

  symopw = create_combo (NULL, NULL, 0, 0, &symop, NULL, false);
  g_object_set_data (G_OBJECT (dialog), "combosymop", symopw);
  (void) g_signal_connect(G_OBJECT(get_widget(symopw,"entry")), "changed",
               G_CALLBACK(get_combotxt), NULL);
//  gtk_editable_set_editable(GTK_EDITABLE(get_widget(symopw, "entry")), FALSE);
  table_attach (table1, get_widget(symopw, "parent"), 3, 6, 0, 1);

  hseparator = hseparator_new ();
  table_attach (table1, hseparator, 0, 6, 1, 2);

  label = LABEL_NEW("Number of cells:", LABELCOLOR);
  table_attach_exp (table1, label, 0, 6, 2, 3);
  set_alignment(label, 0, 0.5);

  label = LABEL_NEW("along a", LABELCOLOR);
  table_attach (table1, label, 0, 1, 3, 4);
  set_alignment(label, 0, 0.5);

  label = LABEL_NEW("along b", LABELCOLOR);
  table_attach (table1, label, 2, 3, 3, 4);
  set_alignment(label, 0, 0.5);

  label = LABEL_NEW("along c", LABELCOLOR);
  table_attach (table1, label, 4, 5, 3, 4);
  set_alignment(label, 0, 0.5);

  hseparator = hseparator_new ();
  table_attach (table1, hseparator, 0, 6, 4, 5);
  
  label = LABEL_NEW("Condition to apply", LABELCOLOR);
  table_attach_exp (table1, label, 0, 6, 5, 6);
  set_alignment(label, 0, 0.5);

  symop_t = label_boxed ("                    ");
  g_object_set_data (G_OBJECT (dialog), "symopl", symop_t);
  table_attach (table1, symop_t, 0, 2, 6, 7);

  pix = create_image("plus.png");
  g_object_set_data (G_OBJECT (dialog), "1+", pix);
  table_attach (table1, pix, 2, 5, 6, 7);

  ncell_t = label_boxed ("          ");
  g_object_set_data (G_OBJECT (dialog), "ncelll", ncell_t);
  table_attach (table1, ncell_t, 5, 6, 6, 7);
  
  frame = FRAME_NEW("Conditions applied", FRAMECOLOR);
  table_attach (table1, frame, 0, 6, 7, 9, TRUE);

  hbox = hbox_new(FALSE, 6);
  gtk_container_add(GTK_CONTAINER(frame), hbox);
  gtk_container_set_border_width(GTK_CONTAINER(hbox), 6);
  list = create_selection(dialog, hbox, NULL, "appcond");
  set_selection_mode(list, GTK_SELECTION_SINGLE);
  selec = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  (void) g_signal_connect(G_OBJECT(selec), "changed", 
                      G_CALLBACK(sel_to_undo), NULL);
  gtk_widget_set_size_request(get_widget(list, "scrollwin"), -1, 80);
  
#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_CENTER,GTK_ALIGN_CENTER,0,0);
#else
  align = gtk_alignment_new(0.5f,0.5f,0.f,0.f);
#endif
  gtk_box_pack_end(GTK_BOX(hbox), align, FALSE, FALSE, 0);
  button = myimage_button("  _Undo", "undo.png");
  gtk_container_add(GTK_CONTAINER(align), button);
  g_object_set_data(G_OBJECT(dialog), "undo", button);
  (void) g_signal_connect(G_OBJECT(button), "clicked", 
              G_CALLBACK(end_build), GINT_TO_POINTER(-1));


  spin = spin_button_new (GTK_ADJUSTMENT (
             adj_new (0, -3, 3, 1, 1)), 1, 0);
  g_object_set_data (G_OBJECT (dialog), "sp0", spin);
  table_attach (table1, spin, 1, 2, 3, 4);
  spin_button_set_numeric (spin, TRUE);
  (void) g_signal_connect (G_OBJECT (spin), "value-changed",
                      G_CALLBACK (nc_changed), GINT_TO_POINTER(1));

  spin = spin_button_new (GTK_ADJUSTMENT (
             adj_new (0, -3, 3, 1, 1)), 1, 0);
  g_object_set_data (G_OBJECT (dialog), "sp1", spin);
  table_attach (table1, spin, 3, 4, 3, 4);
  spin_button_set_numeric (spin, TRUE);
  (void) g_signal_connect (G_OBJECT (spin), "value-changed",
                      G_CALLBACK (nc_changed), GINT_TO_POINTER(2));

  spin = spin_button_new (GTK_ADJUSTMENT (
             adj_new (0, -3, 3, 1, 1)), 1, 0);
  g_object_set_data (G_OBJECT (dialog), "sp2", spin);
  table_attach (table1, spin, 5, 6, 3, 4);
  spin_button_set_numeric (spin, TRUE);
  (void) g_signal_connect (G_OBJECT (spin), "value-changed",
                      G_CALLBACK (nc_changed), GINT_TO_POINTER(3));

  button = myimage_button ("_Accept", "apply.png");
  gtk_dialog_add_action_widget(GTK_DIALOG (dialog), button, 1); 
  (void) g_signal_connect (G_OBJECT (button), "clicked",
                      G_CALLBACK (end_build), GINT_TO_POINTER(1));

  button = myimage_button("  _Reset", "reset.png");
  gtk_dialog_add_action_widget(GTK_DIALOG (dialog), button, 2); 
  (void) g_signal_connect (G_OBJECT (button), "clicked",
                      G_CALLBACK (end_build), GINT_TO_POINTER(0));

  button = myimage_button("  _Cancel", "cancel.png");
  gtk_dialog_add_action_widget(GTK_DIALOG (dialog), button, 3); 
  (void) g_signal_connect (G_OBJECT (button), "clicked",
                      G_CALLBACK (close_dlg), GINT_TO_POINTER(1));

  (void) g_signal_connect_swapped(G_OBJECT(dialog), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
  (void) g_signal_connect (G_OBJECT (dialog), "delete_event",
                      G_CALLBACK(true_cb), NULL);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);

  return dialog;
}

void aided_build (GtkWidget*item, gpointer data)
{
using namespace GLextmr;
  GtkWidget *widg, *combos, *spin;
  GList *combo_items = NULL;
  int i, tutto, j;
  char sp[5];

  if(build_dlg == NULL)
     build_dlg = create_build_dlg();

  gtk_window_set_transient_for(GTK_WINDOW(build_dlg), GTK_WINDOW(finestre[0]));
  gtk_widget_show_all(build_dlg);
  init_aided_build_(&nsym);

  combos = lookup_widget(build_dlg, "combosymop");
  widg   = lookup_widget(GTK_WIDGET(build_dlg), "appcond");
  clear_list(widg);

  for(i=1; i<=nsym;i++)
      combo_items = g_list_append (combo_items, getStringSymm(&i, nsym));
  set_popdown_strings (combos, combo_items);
  g_list_free (combo_items);

  for (i=0; i<3; i++)
  {
       ScriviStringa(sp, sizeof(sp), "sp%d", i);
       spin = lookup_widget(GTK_WIDGET(build_dlg), sp);
       spin_button_set_value(spin, (float) nc[i]); 
#ifdef USE_VALUE_CHANGED
       gtk_adjustment_value_changed (spin_button_get_adjustment(spin));
#endif
  }

  widg = lookup_widget(GTK_WIDGET(build_dlg), "undo");
  gtk_widget_set_sensitive(widg, FALSE);

  combo_set_val(combos, 1);
  if(dialogo->nAided > 0)
  {
     for(i=0; i<dialogo->nAided; i++)
     {
         tutto = dialogo->jAided[i];
         nc[2] = (tutto % 10) - 5;
         tutto /= 10;
         nc[1] = (tutto % 10) - 5;
         tutto /= 10;
         nc[0] = (tutto % 10) - 5;
         tutto /= 10;
         symop = tutto % 10;
         combo_set_val(combos, symop);
         for (j=0; j<3; j++)
         {
              ScriviStringa(sp, sizeof(sp), "sp%d", j);
              spin = lookup_widget(GTK_WIDGET(build_dlg), sp);
              spin_button_set_value(spin, (float) nc[j]); 
         }
         aggiorna_condizioni (build_dlg, 1);
     }
  }
  finestra_modale_aperta2(build_dlg);
}
