!-------------------------------------------------------
      MODULE DemiFlunch

        integer                :: ninto, jCodeDFL,nDemiH,nDemiK,nDemiL
        integer                :: npOrig(3)
        integer, allocatable   ::itypeSI(:)
        real, allocatable      ::fvaria(:)
        real, allocatable      ::variance(:)
        real, allocatable      ::sigma(:,:)
        integer, allocatable   ::jcodr(:)
        real, allocatable      ::nrinto(:)
        integer, allocatable   ::iequip(:,:)
        real, allocatable      ::shifti(:,:)

      End MODULE DemiFlunch
!-------------------------------------------------------
      subroutine AllocaDemiFlunch(iAction)
      USE General
      USE DemiFlunch
      dimension ierv(100)

      ierv(:) = 0

!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      if (iAction == 1) then
      IF (.NOT. ALLOCATED(fvaria))
     *     ALLOCATE (fvaria(1:nreflDim) ,stat = ierv( 1))
      IF (.NOT. ALLOCATED(itypeSI))
     *     ALLOCATE (itypeSI(1:nreflDim) ,stat = ierv( 2))
      IF (.NOT. ALLOCATED(variance))
     *     ALLOCATE (variance(1:nreflDim) ,stat = ierv( 3))
      IF (.NOT. ALLOCATED(sigma))
     *     ALLOCATE (sigma(1:nreflDim,2) ,stat = ierv( 4))
      IF (.NOT. ALLOCATED(jcodr))
     *     ALLOCATE (jcodr(1:nreflDim) ,stat = ierv( 5))
      IF (.NOT. ALLOCATED(nrinto))
     *     ALLOCATE (nrinto(1:nreflDim) ,stat = ierv( 6))
      IF (.NOT. ALLOCATED(iequip))
     *     ALLOCATE (iequip(1:nreflDim,3) ,stat = ierv( 7))
      IF (.NOT. ALLOCATED(shifti))
     *     ALLOCATE (shifti(1:nreflDim,3) ,stat = ierv( 7))


      else
      endif


      return
      end
!-------------------------------------------------------
      subroutine DemiFlunchMain

      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
c     USE Envelope
      Use MapTest
      USE IsrCom

      USE Grafici
      USE Param
      USE DemiFlunch

      character*200,namefile
      dimension ww(3),ifa(3),ffc(3),ffcv(3),var(3),rnn(3)
      real celltemp(13)

      integer lhx(3),ier

      complex fh,fm,phasec


      real i1(3),i2(3),shi1(4),f(9)   ! f(9) aggiunto da gianluca 17/11/2011
      real rho2
    
      write(6,*) ' Procedura HI <---> SI'
      write(6,*) ' *********************'
      dmaxSi = 0.0
      dmaxHi = 0.0
c     radius = 8.0
      radius = 0.0
 
      jCodeDFL = 1
      nDemiH = 2
      nDemiK = 1
      nDemiL = 1

c     jCodeDFL = 3
c     nDemiH = 2
c     nDemiK = 2
c     nDemiL = 2

      a=cell(1)
      b=cell(2)
      c=cell(3)
      alph=dtor*cell(4)
      beta=dtor*cell(5)
      gamm=dtor*cell(6)

      cstar(1)=b*c*sin(alph)/volume
      cstar(2)=a*c*sin(beta)/volume
      cstar(3)=a*b*sin(gamm)/volume
      domin=sin(beta)*sin(gamm)
      cstar(4)=(cos(beta)*cos(gamm)-cos(alph))/domin
      domin=sin(alph)*sin(gamm)
      cstar(5)=(cos(alph)*cos(gamm)-cos(beta))/domin
      domin=sin(alph)*sin(beta)
      cstar(6)=(cos(alph)*cos(beta)-cos(gamm))/domin


      dmax1=0.5/sqrt(rhomax)

      ihma=nDemiH*nint(1.0/(cstar(1)*dmax1))
      ikma=nDemiK*nint(1.0/(cstar(2)*dmax1))
      ilma=nDemiL*nint(1.0/(cstar(3)*dmax1))


      ifat1=(2*ilma+1)*(2*ikma+1)
      ifat2=(2*ilma+1)
      ifatx=ihma*ifat1+ikma*ifat2+ilma

      call AllocaISR(2)
      allocate (isr(ifatx), stat=ier)
      if (ier.ne.0) print *, 'allocate ISR error'

      isr(:)=0

      ! contare il nr. max. dei riflessi da generare come ppp, pdd, ppd
      rp1max=float(ihma/nDemiH)
      rp2max=float(ikma/nDemiK)
      rp3max=float(ilma/nDemiL)
      dmaxHi = dmax1
      nreflDim = nrefl * neqv
      rp1 = rp1max + 0.5
      rp2 = rp2max + 0.5
      rp3 = rp3max + 0.5
      nrp123 = nint(2.0*rp1max/0.5)

c     do  rp1=rp1max,-rp1max,-0.5
c       do  rp2=rp2max,-rp2max,-0.5
c         do  rp3=rp3max,-rp3max,-0.5
      do  ip1=1,nrp123
        rp1 = rp1 - 0.5
        do  ip2=1,nrp123
          rp2 = rp2 - 0.5
          do  ip3=1,nrp123

            rp3 = rp3 - 0.5
           
            rho1=rhofreal(pp,rp1,rp2,rp3)
            if (rho1.gt.0)then
               dd=0.5/rho1
               if (dd.lt.dmaxHi) cycle
            endif
            jcode1=jDemiRef(rp1,rp2,rp3)
            if (jcode1 /= jcodeDFL) cycle ! solo i riflessi ppd,pdp,dpp

            ih=int(rp1*ndemiH)
            ik=int(rp2*ndemiK)
            il=int(rp3*ndemiL)

            indr=ih*ifat1+ik*ifat2+il
            indrr=iabs(indr)
            if (indrr.eq.0.or.indrr.gt.ifatx) cycle
            if (indrr.gt.0.and.isr(indrr).gt.0) cycle
             nreflDim = nreflDim + 1
             isr(indrr) = 1
          enddo
        enddo
      enddo

      isr(:) = 0

      call AllocaRiflessi(2)
      call AllocaRiflessi(1)
      InfoOK(7) = 0 
      call LeggiRiflessiSP
      InfoOK(7) = 1 
      call AllocaDemiFlunch(1)
      smax=rhomax*4.0

      if (knw > 0) then
         call esamin(khl,mkang,ipub,iphaz,nrefl,1,wtt1,wt,
     *             errm1,errmw1,nref1,shi1)
      endif

      nrefsi=0
      nrefhi=0
      nrefhsi=0
      nreftot=0
      ipos = 0
      ipos2=nrefl
      dmaxSi1=999.0
      lhx(1)=0
      lhx(2)=0
      lhx(3)=0

      iy=67543
      ix=iy

      do 100 i=1,nrefl
         ih = khl(1,i)
         ik = khl(2,i)
         il = khl(3,i)

         if (knw > 0) then
           iphaz(i)=shi1(4)*iphaz(i)-360.*(ih*shi1(1)+ik*shi1(2)+
     *             il*shi1(3))
           iphaz(i)=mod(iphaz(i)+3600,360)
           if (iphaz(i).le.0) iphaz(i)=360+iphaz(i)
           iphad(i) = iphaz(i)
         endif

         if (ih.gt.lhx(1)) lhx(1)=ih
         if (ik.gt.lhx(2)) lhx(2)=ik
         if (il.gt.lhx(3)) lhx(3)=il
         i1(1)=float(ih)
         i1(2)=float(ik)
         i1(3)=float(il)
         fc=fovet(i)
         en1=evet(i)
         fase1=ipub(i)*dtor
         fase2=iphaz(i)*dtor
         ap1=fc*cos(fase1)
         bp1=fc*sin(fase1)
         ap2=fc*cos(fase2)
         bp2=fc*sin(fase2)

         do 700 jj=1,neqv
            do 540 ii=1,3
  540       i2(ii)=0
            do 560 ii=1,3
               do 550 kk=1,2
                  m=iabs(ismat(kk,ii,jj))
                  if(m.ne.0) i2(m)=i2(m)+i1(ii)*isign(1,ismat(kk,ii,jj))
  550          continue
  560       continue

         fh=cmplx(ap1,bp1)
         fm=fh*phasec(-twopi*(i1(1)*tsmat(1,jj) +
     +                       i1(2)*tsmat(2,jj) +
     +                       i1(3)*tsmat(3,jj)) )
         ifasec1=nint(phaseof(fm)*rtod)
         ifasec1=mod(ifasec1+3600,360)
         if (ifasec1.le.0) ifasec1=360+ifasec1

         fh=cmplx(ap2,bp2)
         fm=fh*phasec(-twopi*(i1(1)*tsmat(1,jj) +
     +                       i1(2)*tsmat(2,jj) +
     +                       i1(3)*tsmat(3,jj)) )
         ifasec2=nint(phaseof(fm)*rtod)

         ifasec2=mod(ifasec2+3600,360)
         if (ifasec2.le.0) ifasec2=360+ifasec2

         if (i2(1).lt.0.0) then
           do ir=1,3
           i2(ir)=-i2(ir)
           enddo
           ifasec1=-ifasec1
           if (ifasec1.le.0) ifasec1=360+ifasec1
           ifasec2=-ifasec2
           if (ifasec2.le.0) ifasec2=360+ifasec2
         endif

         ih=nDemiH*i2(1)
         ik=nDemiK*i2(2)
         il=nDemiL*i2(3)

         indr=ih*ifat1+ik*ifat2+il
         indrr=iabs(indr)
         if (indrr.gt.0.and.isr(indrr).gt.0) goto 700

         ishift=ifasec2-iphaz(i) 
         ishift=mod(ishift+3600,360)
         if (ishift.le.0) ishift=360+ishift

c        if (mkang(i) /= 1) then
c          write(2,'(i5,1x,i2,2x,3i5,3i5)') i,jj,int(i2(1:3)),
c    *      iphaz(i),ifasec2,ishift
c        endif
         nrefsi=nrefsi+1
         ipos=i
         if (jj.gt.1) then
            ipos2=ipos2+1
            ipos=ipos2
         endif
         isr(indrr)=ipos

         rho2=rhov(i)
         dd=0.5/sqrt(rho2)
         if (dd.lt.dmaxSi1) dmaxSi1=dd


         khl(1,ipos) = ih
         khl(2,ipos) = ik
         khl(3,ipos) = il
         rhov(ipos)=rho2
         dreso(ipos)=0.5/sqrt(rho2)
         fovet(ipos)=fc
         fovet_mod(ipos)=fovet(i)
         evet(ipos)=en1           ! F normalizzato (Wilson)
         ipub(ipos)=ifasec1
         iphaz(ipos)=ifasec2
         wt(ipos)=wt(i)
         iphad(ipos)=ifasec2
         wtd(ipos)=wt(i)
         inobs(ipos)=1
         itypeSI(ipos)=mkang(i)
         mkang(ipos)=mkang(i)
         iequip(ipos,1)=i
         iequip(ipos,2)=jj
         iequip(ipos,3)=ishift
         if (jj.gt.1) itypeSI(ipos)=-mkang(i)
         jcodr(ipos)=0  ! interi (ppp)

         call fjcalc(i2,rho2,f)
         call sigcalc(f,f,rho2,rho2,sig1,sig2,sig11)

CC       evet(ipos)=fc/sqrt(sig2) ! E pseu-normalizzato (senza epsilon)
         sigma(ipos,1)=sig1
         sigma(ipos,2)=sig2
 700  continue
 100  continue

      rp1max=float(ihma/nDemiH)
      rp2max=float(ikma/nDemiK)
      rp3max=float(ilma/nDemiL)
      nrefsioss=nrefsi
      dmaxSioss=dmaxSi1

*---- generiamo i SI (interi non-osservati))
      if (dmaxSi.le.0.0) goto 170
      nnobs=0
*
* COMMENTATE DA GIANLUCA 03/03/2008
*
*     do 150 rp1=rp1max,-rp1max,-1.0
*       do 150 rp2=rp2max,-rp2max,-1.0
*         do 150 rp3=rp3max,-rp3max,-1.0
*           rho1=rhofreal(pp,rp1,rp2,rp3)
*           rho2=rho1**2
*           if (rho1.gt.0)then
*              dd=0.5/rho1
*              if (dd.lt.dmaxSi.or.dd.ge.dmaxSioss) goto 150
*           endif
*           ih=int(rp1*nDemiH)
*           ik=int(rp2*nDemiK)
*           il=int(rp3*nDemiL)

*           indr=ih*ifat1+ik*ifat2+il
*           indrr=iabs(indr)
*           if (indrr.eq.0.or.indrr.gt.ifatx) goto 150
*           if (indrr.gt.0.and.isr(indrr).gt.0) goto 150
*           kh=int(rp1)
*           kk=int(rp2)
*           kl=int(rp3)
*           call geneq(1,kh,kk,kl,idelt,jcode,isgnn,id1,rho22,ireje)

*           nrefsi=nrefsi+1
*           nnobs=nnobs+1
*           if (dd.lt.dmaxSi1) dmaxSi1=dd
*           if (ih/nDemiH.gt.lhx(1)) lhx(1)=ih/nDemiH
*           if (ik/nDemiK.gt.lhx(2)) lhx(2)=ik/nDemiK
*           if (il/nDemiL.gt.lhx(3)) lhx(3)=il/nDemiL

*           isr(indrr)=nrefsi

*           i1(1)=rp1
*           i1(2)=rp2
*           i1(3)=rp3

*           call fjcalc(i1,rho2,f)

*           call sigcalc(f,f,rho2,rho2,sig1,sig2,sig11)

*           iorde(nrefsi)=nrefsi
*           inobs(nrefsi)=1
*           rhov(nrefsi)=rho2
*           dreso(nrefsi)=0.5/sqrt(rho2)
*           ipub(nrefsi)=0
*           iphaz(nrefsi)=0
*           wt(nrefsi)=0.0
*           fovet(nrefsi)=0.0
*           fcvet(nrefsi)=0.0
*           mkang(nrefsi)=ityp
*----------
**          iequip(nrefsi)=i
*----------
*           itypeSI(nrefsi)=ityp*isgnn
*           sigma(nrefsi,1)=sig1
*           sigma(nrefsi,2)=sig2
*           khl(1,nrefsi) = ih
*           khl(2,nrefsi) = ik
*           khl(3,nrefsi) = il
*           jcodr(nrefsi)=0      ! jcode

* 150 continue

  170 continue

      r1max=0.0
      r2max=0.0
      r3max=0.0
*---- generiamo i HI (semi-interi) fino a res. osservato
      dmaxHi = dmaxSioss
      nreftot=nrefsi
      ic=0
*
* COMMENTATE DA GIANLUCA 03/03/2008
*
*     do 200 rp1=rp1max,-rp1max,-0.5
*       do 200 rp2=rp2max,-rp2max,-0.5
*         do 200 rp3=rp3max,-rp3max,-0.5

*           if (rp1.eq.0.0.and.rp2.eq.0.0.and.rp3.eq.0.0) goto 200

*           rho1=rhofreal(pp,rp1,rp2,rp3)
*           rho2=rho1**2
*           if (rho1.gt.0)then
*              dd=0.5/rho1
*              if (dd.lt.dmaxHi) goto 200
*           endif

*           jcode1=jDemiRef(rp1,rp2,rp3)
*           if (jcode1 /= jcodeDFL) goto 200

*           ih=int(rp1*nDemiH)
*           ik=int(rp2*nDemiK)
*           il=int(rp3*nDemiL)

*           indr=ih*ifat1+ik*ifat2+il
*           indrr=iabs(indr)
*           if (indrr.eq.0.or.indrr.gt.ifatx) goto 200
*           if (indrr.gt.0.and.isr(indrr).gt.0) goto 200

*           nrefhi=nrefhi+1
*           nreftot=nreftot+1
*           isr(indrr)=nreftot

*           i1(1)=rp1
*           i1(2)=rp2
*           i1(3)=rp3

*           jcodr(nreftot)=jcode1
*           iorde(nreftot)=nreftot
*           inobs(nreftot)=0
*           rhov(nreftot)=rho2
*           dreso(nreftot)=0.5/sqrt(rho2)
*           iphaz(nreftot)=0
*           ipub(nreftot)=0
*           iphad(nreftot)=0
*           wt(nreftot)=0.0
*           fovet(nreftot)=0.0
*           fcvet(nreftot)=0.0

*           khl(1,nreftot) = ih
*           khl(2,nreftot) = ik
*           khl(3,nreftot) = il
*           mkang(nreftot)=1

*           call fjcalc(i1,rho2,f)
*           call sigcalc(f,f,rho2,rho2,sig1,sig2,sig11)

*           sigma(nreftot,1)=sig1
*           sigma(nreftot,2)=sig2

* 200 continue


      is1=0
      is2=0
      ninto=0
      if (radius.le.0.0) goto 600

      radius=amax1(dmaxHi,radius)
      rp1m=float(nint(1.0/(cstar(1)*radius)))
      rp2m=float(nint(1.0/(cstar(2)*radius)))
      rp3m=float(nint(1.0/(cstar(3)*radius)))
      radius1=1.0/radius

      rp1 = rp1m + 0.5
      rp2 = rp2m + 0.5
      rp3 = rp3m + 0.5
      nrp123 = nint(2.0*rp1/0.5)

c     do 500 rp1=rp1m,-rp1m,-0.5
c       do 500 rp2=rp2m,-rp2m,-0.5
c         do 500 rp3=rp3m,-rp3m,-0.5

      do 500 ip1=1,nrp123
        rp1 = rp1 - 0.5
        do 500 ip2=1,nrp123
          rp2 = rp2 - 0.5
          do 500 ip3=1,nrp123
            rp2 = rp2 - 0.5

            if (rp1.eq.0.0.and.rp2.eq.0.0.and.rp3.eq.0.0) goto 500

            rho1=rhofreal(pp,rp1,rp2,rp3)
            ss=2.0*rho1
            if (ss.gt.radius1) goto 500
            jcode=jsemi(rp1,rp2,rp3)
            if (jcode.eq.0) goto 500
            if (jcode.eq.1) is1=is1+1
            if (jcode.eq.2) is2=is2+1

c           jcode1=jDemiRef(rp1,rp2,rp3)
c           if (jcode1.eq.0) then
c               is2=is2+1
c           elseif(jcode1.eq.3) then
c               is1=is1+1
c           else
c             goto 500
c           endif
            ninto=ninto+1
            shifti(ninto,1)=rp1
            shifti(ninto,2)=rp2
            shifti(ninto,3)=rp3

 500  continue

 600  continue

      call esamin(khl,mkang,ipub,iphaz,nrefl,1,wtt1,wt,
     *             erm1,ermw1,nref1,shi1)

      namefile=StructureName(1:Lung(StructureName))//'_hi.hkl'
      nreflTot = nreftot
      ihmxExt(1) = ihma
      ihmxExt(2) = ikma
      ihmxExt(3) = ilma
      work1(:) = 0.0
      work2(:) = 0.0
      jcodeDFL_save = jcodeDFL
      jcodeDFL = 0
      call ReadFileAscii(namefile,ier)
      do i = 1, nrefsi
          wtt1(i) = 1.0
c         iphaz(i) = ipub(i)
          iphad(i) = iphaz(i)
          ipub(i) = work1(i)
          fmod(i) = work2(i)
          sig2=sigma(i,2)
          emod(i)=fmod(i)/sqrt(sig2)
      enddo
      jcodeDFL = jcodeDFL_save
      work1(:) = 0.0
      work2(:) = 0.0
      call ReadFileAscii(namefile,ier)
      do i = nrefsi + 1, nreftot
          wtt1(i) = 1.0
          ipub(i) = work1(i)
          fmod(i) = work2(i)
          sig2=sigma(i,2)
          emod(i)=fmod(i)/sqrt(sig2)
      enddo

      jcodeSI=-1
      if (lhx(2).lt.lhx(1)) then
         jcodeSI=-2
         if (lhx(3).lt.lhx(2)) jcodeSI=-3
      else
         if (lhx(3).lt.lhx(1)) jcodeSI=-3
      endif
     

      write(lo,3000) nrefsioss,nnobs,(real(lhx(j)),j=1,3),jcodeSI,
     *               dmaxSioss,dmaxSi1,
     *               nrefhi-nrefhsi,nrefhsi,rp1max,rp2max,rp3max,dmaxHi,
     *               radius,ninto,is1,is2
 3000 format (//,1x,'NrefSI     :' ,i5,2x,1h(i5,' Nobs ',1h),/
     *        1x,'Max Indices:',3f4.0,1x,i3,/
     *        1x,'Res(A)     :',f6.2,1x,1h(,f6.2,' Nobs ',1h)/
     *        1x,'NrefHI     :',i5,/
     *        1x,'NrefMIX    :',i5,/
     *        1x,'Max Indices:',3f4.0,/
     *        1x,'Res(A)     :',f6.2,
     *        1x,'dsphere(A) :',f6.2,/,
     *        1x,'Reflexions in the sphere:',i5,/
     *        1x,'                      SI:',i5,/
     *        1x,'                      HI:',i5)


      dsog=dmaxSioss

      if (radius < 0.01) goto 800
      ap0=0.0
      z=0.0
      z2=0.0
      do j=1,nk
       if (no(j).gt.1)then
         ap0=ap0+float(nw(j)*no(j))
         z=z+float(nw(j)*no(j))
         z2=z2+float(nw(j)*no(j)**2)
       endif
      enddo
      write(lo,*)'F000=',ap0
      zneqv=z/sqrt(z2)
      write(lo,*)'Neqv=',zneqv,1.0/s3s2
      do i=nrefsi+1,nreftot
        jcode1=jcodr(i)
        ih=khl(1,i)
        ik=khl(2,i)
        il=khl(3,i)
        i1(1)=ih/float(nDemiH)
        i1(2)=ik/float(nDemiK)
        i1(3)=il/float(nDemiL)
        wt(i)=0.0    ! reset il peso a zero per i riflesso da fasare
        if (jcode1.gt.0) then
          call HiSiEstimateNorm(jcode1,i,i1,soge,sogem,
     +                        dsog,zneqv,1,nrefsi) ! ,isr)
        endif

      enddo
      call stathisi(3,nrefsi+1,nreflTot)
      stop

  800 continue

!------------------------------------
      igrid = 0
      resm = 0.5/sqrt(rhomax)
      factr=resm/3.0
      write(6,*) ' Change Grid',factr
      call CalcGrid
      npOrig(1:3) = np(1:3)

      call SaveLists123
      neqv = nsym
      ! nuova cella
      cell(1) = cell(1) * nDemiH
      cell(2) = cell(2) * nDemiK
      cell(3) = cell(3) * nDemiL
*gl*  call frm01(cell)        !!gl
      celltemp(:) = 0
      celltemp(1:6) = cell(1:6)
      call CreaCellInfo(celltemp)
*gl*  call xfl01              !!gl
      ! nuova volume della cella
      a1=cos(cell(4)*pi/180.0)
      a2=cos(cell(5)*pi/180.0)
      a3=cos(cell(6)*pi/180.0)
      arg=1.0-a1*a1
     1       -a2*a2
     2       -a3*a3
     3       +a1*a2*a3*2.0
       volume=cell(1)*cell(2)*cell(3)*sqrt(arg)
!-----------------
c     call esamin(khl,mkang,ipub,iphaz,nrefsi,1,wtt1,wt,
c    *             erm1,ermw1,nref1,shi1)
c     stop
!-----------------

c     neqv_old=neqv
c     nsym_old=nsym
c     nsym=1
c     neqv=1


      nrefl_old=nrefl
      nrefl=nreftot

      wt(nrefsi+1:nreflTot) = 0.0

      np(1) = np(1) * nDemiH
      np(2) = np(2) * nDemiK
      np(3) = np(3) * nDemiL

      if (knw > 0) call AllocaMapTest(2)
      call AllocaMappa(2)
      call AllocaEnve(2)
      call AllocaMappa(1)
      call AllocaEnve(1)
      if (knw > 0) call AllocaMapTest(1)

      if (knw > 0) then
       call MakeMap(fovet,ipub,nrefsi,0,xmapT,
     *                   FORTH,BACK)  ! True map
       call DistruggiPiani(FORTH,BACK)
      endif


      iphaz(1:nrefsi) = ipub(1:nrefsi)
      wt(1:nrefsi) = 1.0

c     wt(nrefsi+1:nreflTot) = 1.0
c     iphaz(nrefsi+1:nreflTot) = ipub(nrefsi+1:nreflTot)
c     fovet(nrefsi+1:nreflTot) = fmod(nrefsi+1:nreflTot)

      fcoef(1:nreflTot) = fovet(1:nreflTot)*wt(1:nreflTot)
      call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK)
      if (knw > 0) then
        call mapcorr0(xmap,xmapT,0,corr,ier)
        write(6,*) 'CC_init = ',corr
      endif
      percHI = 0.10

      ncycleDFL = 10
      do icyDFL = 1, ncycleDFL

      write(6,*) 'CYCLE',icyDFL,ncycleDFL
      write(6,*) 'SI reflections:',count(fcoef(1:nrefsi) > 0.0) 
      write(6,*) 'HI reflections:',count(fcoef(nrefsi+1:nreflTot) > 0.0)
      
      call MakeMap(fcoef,iphaz,nreflTot,0,xmap,
     *                   FORTH,BACK)
      
      namefile=StructureName(1:Lung(StructureName))//'_SI_1.map'
      call CCP4MAPOUT(0,xmap,np,namefile)


      ! envelope

      ihism = 0
c     iflat = 2  ! test pr solv = 0.32
c     iflat = 0  ! test pr solv = 0.0
      iflat = 1  ! den solv * 0.5
      rhomax=maxval(rhov(1:nrefl))

      wangmd=131.0
      wangrd=-2.0
      iwp=int(wangmd/100) + 1
      sw=sum(wt(1:nrefl)**iwp)
      rmax=0.5/sqrt(rhomax)
      rnrflc=100 + numres(rmax)
      Renve=abs(wangrd)*(rnrflc/sw)**0.33*rmax

      smax=rhomax*4.0
      call envelopeMask(0,smax,v_p,xenve)

c     xmap(npOrig(1):np(1)-1,npOrig(2):np(2)-1,npOrig(3):np(3)-1) = 0.0

      nx1 = npOrig(1)
      nx2 = np(1)
      if (nx1 == nx2) nx1 = 0

      ny1 = npOrig(2)
      ny2 = np(2)
      if (ny1 == ny2) ny1 = 0

      nz1 = npOrig(3)
      nz2 = np(3)
      if (nz1 == nz2) nz1 = 0

      do iz = nz1 , nz2 - 1
        do iy = ny1, ny2 - 1
          do ix = nx1, nx2 - 1
c           xmap(ix,iy,iz) = 0.0      
            xmap(ix,iy,iz) = - xmap(ix,iy,iz)
            xenve(ix,iy,iz) = 0.0      
          enddo
        enddo
      enddo

      namefile=StructureName(1:Lung(StructureName))//'_SI_0.map'
      call CCP4MAPOUT(0,xmap,np,namefile)

****  call flatmap(xmap,xenve,iflat,0.0,0,ier)  ! Gianluca 01/10/2013 ??
      call flatmap(xmap,xenve,iflat,0.0)

      percMap = 0.1 * v_p
      npts1=np(1)*np(2)*np(3)*percMap
      call denhist(1,xmap,xenve,0,npts1)
      call ChangeAndInvMap(xmap,xenve,0,0.0,1,ier)

!     calc pesi + combi
      x = icyDFL
      x1 = 1
      x2 = ncycleDFL
      y1 = 0.80
      y2 = 0.20

      call varlinear(x,x1,x2,y,y1,y2)

      coefOld = y
      coefNew = 1 - y
      write(6,*) 'Combinazione:',coefOld,coefNew


      call sigmaA(2,fovet,sigmav,fovet,mkang,rhov,epsv,fcvet,
     *            ipub,iphaz,wt,iphad,wtd,
     *            wvar,wt,Dluz,e1,e2,
     *            nreflDim,nrefsi,nrefsi,
     *            0,coefOld,coefNew,1)

      call sigmaA(4,fovet,sigmav,fovet,mkang,rhov,epsv,fcvet,
     *            ipub,iphaz,wt,iphad,wtd,
     *            wvar,work1,Dluz,e1,e2,
     *            nreflDim,nrefsi,nreflTot,
     *            0,1.0,1.0,1)

      ii = 0
      do i = nrefsi+1, nreflTot
      ii = i - nrefsi
       SimW =  2.0 * e1(i) * e1(i)
       wt(i) = sim(SimW)
       evet(i) = e1(i)
      enddo
      if (knw > 0) then
        fcoef(1:nrefsi) = fovet(1:nrefsi) * wt(1:nrefsi)
        call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK)
        call mapcorr0(xmap,xmapT,0,corr,ier)
        write(6,*) 'CC_end = ',corr
      endif
      call stathisi(0,1,nrefsi)
c     call mergeequiv(nrefl_old,nrefsi)
c     call stathisi(0,1,nrefsi)
      call stathisi(jcodeDFL,nrefsi+1,nreflTot)
      stop
      
      percHI = percHI + 0.10
      percHI = min(1.0, percHI)
c     call SceltaRef(-1,nreflTot,evet,wt,nreflTot,nrefsi+1,0.20,0)
      fcoef(1:nrefsi) = fovet(1:nrefsi)*wt(1:nrefsi)
      fcoef(nrefsi+1:nreflTot) = fcvet(nrefsi+1:nreflTot)*
     *                           wt(nrefsi+1:nreflTot)
      enddo

      stop
c     if (neqv_old.gt.1) then
c       call mergeequiv(nrefl_old,nrefsi)
c       write(6,*)'Dopo Merge Equivalents'
c       call stathisi(0,1,nrefsi)
c     endif

      return
      end  
  
*-------------------------------------------------------------------------
      subroutine sigcalc(f1,f2,rho2_1,rho2_2,sig1,sig2,sig11)

      USE General

      dimension f1(9),f2(9)

      sig1=0.0
      sig2=0.0
      sig11=0.0

      do 100 j=1,nk
        arg=-bt*rho2_1
        f11=f1(j)*exp(arg)

        sig1=sig1+nw(j)*f11
        sig2=sig2+nw(j)*f11*f11

        arg=-bt*rho2_2
        f22=f2(j)*exp(arg)
        sig11=sig11+nw(j)*f11*f22
 100  continue

      return
      end
*----------------------------------------------------------
      subroutine fjcalc (i1,rho2,f)

      USE General

      real i1(3),f(9)


      sig2=0.0

      do 50 ij=1,nk
        f(ij)=cl(ij)
        do 50 ii=1,4
          f(ij)=f(ij)+al(ii,ij)*exp(-bs(ii,ij)*rho2)
  50    continue

       return
       end
*---------------------------------------------------------------
      integer function jDemiRef(rp1,rp2,rp3)

      ip=abs(int(rp1))
      a1=abs(rp1)-float(ip)
      ip=abs(int(rp2))
      a2=abs(rp2)-float(ip)
      ip=abs(int(rp3))
      a3=abs(rp3)-float(ip)
      jDemiRef = 0
      if (a1 > 0.0.and.a2 > 0.0.and.a3 > 0.0) then
       jDemiRef = 3  ! ddd
      elseif (a1 > 0.0.and.a2 > 0.0) then
       jDemiRef = 2  ! ddp
      elseif (a1 > 0.0.and.a3 > 0.0) then
       jDemiRef = -2  ! dpd
      elseif (a2 > 0.0.and.a3 > 0.0) then
       jDemiRef = -2  ! pdd
      elseif (a1 > 0.0) then
       jDemiRef = 1  ! dpp
      elseif (a2 > 0.0) then
       jDemiRef = -1  ! pdp
      elseif (a3 > 0.0) then
       jDemiRef = -1  ! ppd
      endif

      return
      end

*---------------------------------------------------------------
      function jsemi(rp1,rp2,rp3)

      ip=abs(int(rp1))
      a1=abs(rp1)-float(ip)
      ip=abs(int(rp2))
      a2=abs(rp2)-float(ip)
      ip=abs(int(rp3))
      a3=abs(rp3)-float(ip)
      if (a1 > 0.0.and.a2>0.0.and.a3 > 0.0) then
              jcode=1    ! riflesso  ddd
      elseif (rp1.eq.0.0.and.a2.eq.0.5.and.a3.eq.0.5) then
              jcode=-1   ! riflesso seminintero
      elseif (a1.eq.0.5.and.rp2.eq.0.0.and.a3.eq.0.5) then
              jcode=-2   ! riflesso seminintero
      elseif (a1.eq.0.5.and.a2.eq.0.5.and.rp3.eq.0.0) then
              jcode=-3   ! riflesso seminintero
      elseif (rp1.eq.0.0.and.rp2.eq.0.0.and.a3.eq.0.5) then
              jcode=1   ! riflesso seminintero
      elseif (rp1.eq.0.0.and.a2.eq.0.5.and.rp3.eq.0.0) then
              jcode=1   ! riflesso seminintero
      elseif (a1.eq.0.5.and.rp2.eq.0.0.and.rp3.eq.0.0) then
              jcode=1   ! riflesso seminintero
      elseif (a1.eq.0.0.and.a2.eq.0.5.and.a3.eq.0.5) then
              jcode=-1
c     elseif (a1.eq.0.0.and.a2.eq.0.0.and.a3.eq.0.5) then
c             jcode=-12
c     elseif (a1.eq.0.0.and.a2.eq.0.5.and.a3.eq.0.0) then
c             jcode=-13
      elseif (a1.eq.0.5.and.a2.eq.0.0.and.a3.eq.0.5) then
              jcode=-2
c     elseif (a1.eq.0.5.and.a2.eq.0.0.and.a3.eq.0.0) then
c             jcode=-23
      elseif (a1.eq.0.5.and.a2.eq.0.5.and.a3.eq.0.0) then
              jcode=-3
      elseif (a1.eq.0.0.and.a2.eq.0.0.and.a3.eq.0.0) then
              jcode=2   ! riflesso intero
      else
              jcode=0 
      endif

      jsemi=jcode

      return
      end

*--------------------------------
      function rhofreal(p,rh,rk,rl)
      dimension p(6)

c
      rho2=p(1)*rh*rh+p(2)*rk*rk
     1 +p(3)*rl*rl+p(4)*rh*rk
     2 +p(5)*rh*rl+p(6)*rk*rl
      rhofreal=sqrt(rho2)
      return
      end
*-----------------------------------
      function rhofreal_2d(p,rh,rk)
      dimension p(6)

c
      rho2=p(1)*rh*rh+p(2)*rk*rk
     1 +p(4)*rh*rk
      rhofreal_2d=sqrt(rho2)
      return
      end
*-------------------------------------------
      subroutine stathisi(jcod,Ninit,Nend)

      USE General
      USE Symmetry
      USE Riflessi
      USE DemiFlunch

      character tirang*80
       
      dimension shi1(4),shi(4)
c     dimension ecalc(200000),wtt2(200000)
c     dimension shi1(4),shi(4),wtt3(200000),wtt4(200000),eoss(200000)


      if (Nend.lt.Ninit) return
      write(6,*) ' Statistica per jcode', jcod
      shi1(1)=0.0
      shi1(2)=0.0
      shi1(3)=0.0
      shi1(4)=1.0

      shi(1)=0.0
      shi(2)=0.0
      shi(3)=0.0
      shi(4)=1.0
      work1(:) = 0.0

      do i = Ninit, Nend
          jcode1=jcodr(i)
         if (jcod.eq.jcode1)  then
           work1(i) = wt(i)
         endif
      enddo

      call esamin(khl,mkang,ipub,iphaz,Nend,Ninit,wtt1,work1,
     *             erm1,ermw1,nref1,shi1)
c     return
c     write(lo,*) nref1,erm1,ermw1
c     write(lo,*) shi1

      numb=0
      sumfo=0.0
      sumfc=0.0
      sumdiff=0.0
      sumrnn=0.0
      sumw=0.0
      sumerr=0.0
      sumerrw=0.0
      work1(:) = 0.0
      work2(:) = 0.0
      e1(:) = 0.0
      e2(:) = 0.0
      do 10 i=Ninit,Nend
c         wtt2(i)=0.0
c         wtt3(i)=0.0
c         wtt4(i)=0.0
          jcode=jcodr(i)

          if (jcod.ne.jcode) goto 10

c         if (jcod==0.and.mkang(i) /= 1) then
c          write(3,'(i5,2x,3i5,4i5)') i,
c    *     khl(1:3,i),iphaz(i),iequip(1:3,2)
c        endif
        
          if (jcod.eq.0.and.mkang(i).lt.0) goto 10

          work1(i)=nrinto(i)
          sumrnn=sumrnn+work1(i)
          fo=fmod(i)  ! modulo vero
          fc=fcvet(i) ! modulo stimato
          sig2=sqrt(sigma(i,2))
          e1(i)=fcvet(i)/sig2
          e2(i)=fmod(i)/sig2
          segni1(i)=0.0
          ph1=real(ipub(i))
          ph2=real(iphaz(i))

          nh1 = khl(1,i)
          nk1 = khl(2,i)
          nl1 = khl(3,i)

          ph2=shi1(4)*ph2-360.*(nh1*shi1(1)+nk1*shi1(2)+
     *              nl1*shi1(3))
          ph2=amod(ph2+3600.,360.)
          if (ph2.le.0.0) ph2=360.+ph2

          err=abs(ph1-ph2)
          err=amod(err+3600.,360.)
          if (err.gt.180.)err=360.-err

          if (wt(i).le.0.0.or.wtt1(i).le.0.0) goto 10

          numb=numb+1
          sumfo=sumfo+fo
          sumfc=sumfc+fc
          sumdiff=sumdiff+abs(fo-fc)
          sumerr=sumerr+err
          sumerrw=sumerrw+err*wt(i)
          sumw=sumw+wt(i)

c         if (wtd(i).gt.0.0) then
c            wtt2(i)=wt(i)
c         else
c            if (inobs(i).eq.0) then
c              wtt3(i)=wt(i)
c         if (jcod.eq.2)write(1,'(7f8.2)')nh1/2.0,nk1/2.0,nl1/2.0,
c    *                 fo,ph1,fc,ph2
c            else
c              wtt4(i)=wt(i)
c         if (jcod.eq.2)write(1,'(7f8.2)')nh1/2.0,nk1/2.0,nl1/2.0,
c    *                  fo,ph1,fc,ph2
c            endif
c         endif

 10   continue

      if (numb.le.0) return
      scfcfo=sumfc/sumfo
      if (jcod.gt.0) write(6,*)' HI-reflections'
      if (jcod.eq.0) write(6,*)' SI-reflections'
      if (jcod.lt.0) write(6,*)' HSI-reflections',jcod
      write(lo,*)' ---------------------'
      write(lo,*)' Nr. of phased reflections:',numb
      write(lo,*)' Scale (Fc,Fo)=',scfcfo
      write(lo,*)' <Wt>=',sumw/real(numb)
      write(lo,*)' Rtot=',sumdiff/sumfo
      write(lo,*)' Error=',sumerr/real(numb),sumerrw/sumw,numb
      write(lo,*)' Origin:',shi1

      sumfo=0.0
      sumfc=0.0
      do 20 i=ninit,nend
       if (wt(i).le.0.0) goto 20
       fcvet(i)=fcvet(i)/scfcfo
       e1(i)=e1(i)/scfcfo
       sumfo=sumfo+fovet_mod(i)
       sumfc=sumfc+fcvet(i)
 20   continue

c     if (sumrnn.gt.0.0) then
c      tirang='Ninto'
c      call GetStatRfac(tirang,work1,fmod,fcvet,nend,ninit,wt,-20,0.0)
c      call ParamDistribution(tirang,1,work1,khl,nend,ninit,ipub,
c    *                       iphaz,shi1,wtt2,segni1,20,0.0)
c     endif

c     tirang='Fc/sig'
c     call GetStatRfac(tirang,fvaria,fmod,fcvet,nend,ninit,wt,-20,0.0)
c     call ParamDistribution(tirang,1,fvaria,khl,nend,ninit,ipub,
c    *                       iphaz,shi1,wt,segni1,20,0.0)

      tirang='Fc'
      call GetStatRfac(tirang,fcvet,fmod,fcvet,nend,ninit,wt,-20,0.0)
      call ParamDistribution(tirang,1,fcvet,khl,nend,ninit,ipub,
     *                       iphaz,shi1,wt,segni1,20,0.0)

      tirang='E'
      call GetStatRfac(tirang,evet,emod,evet,nend,ninit,wt,-20,0.0)
      call ParamDistribution(tirang,1,evet,khl,nend,ninit,ipub,
     *                       iphaz,shi1,wt,segni1,20,0.0)

      tirang='RES'
      call GetStatRfac(tirang,dreso,fmod,fcvet,nend,ninit,wt,-20,0.0)
      call ParamDistribution(tirang,1,dreso,khl,nend,ninit,ipub,
     *                       iphaz,shi1,wt,segni1,20,0.0)

      tirang='wt'
      call GetStatRfac(tirang,wt,fmod,fcvet,nend,ninit,wt,-20,0.0)
      call ParamDistribution(tirang,2,wt,khl,nend,ninit,ipub,
     *                       iphaz,shi1,wt,segni1,20,0.0)

      return
      end
*-------------------------------------------
      subroutine mergeequiv(nrefa,nreftot)

      USE General
      USE Symmetry
      USE Riflessi
      USE DemiFlunch

      character tirang*80
      complex fh,fm,phasec
      dimension i1(3),i2(3),shi1(4),iposref(24)



      sumnum=0.0
      sumden=0.0
      sumgi=0.0

      ieqv=0
      ncod1=1

       ic=0
       do 20 i=nrefa+1,nreftot 

        ic=ic+1

        ih = khl(1,i)
        ik = khl(2,i)
        il = khl(3,i)

        i1(1)=ih/nDemiH
        i1(2)=ik/nDemiK
        i1(3)=il/nDemiL

        ncod2=iequip(i,1)
        if (ieqv.eq.0) ncod1=ncod2

        jj=iequip(i,2)
        fc=fcvet(i)
        fase1=iphaz(i)*dtor
        ap1=fc*cos(fase1)
        bp1=fc*sin(fase1)

        if (ncod2.eq.ncod1) then

         do 40 ii=1,3
   40      i2(ii)=0
         do 60 ii=1,3
           do 50 kk=1,2
             m=iabs(ismat(kk,ii,jj))
             if(m.ne.0) i2(m)=i2(m)+i1(ii)*isign(-1,ismat(kk,ii,jj))
   50      continue
   60    continue

         fh=cmplx(ap1,bp1)
         fm=fh*phasec(-twopi*(-i1(1)*tsmat(1,jj) -
     +                       i1(2)*tsmat(2,jj) -
     +                       i1(3)*tsmat(3,jj)) )
         ifasec1=nint(phaseof(fm)*rtod)
         if (i2(1).lt.0.0) ifasec1=-ifasec1

         ifasec1=iphaz(i)-iequip(i,3)

         ifasec1=mod(ifasec1+3600,360)
         if (ifasec1.le.0) ifasec1=360+ifasec1

         gi=wt(i)
         phi=ifasec1*dtor

         sumnum=sumnum+ gi*fc*sin(phi)
         sumden=sumden+ gi*fc*cos(phi)
         sumgi=sumgi+ gi
         ieqv=ieqv+1
         iposref(ieqv)=i

         goto 20

        else
          if (ieqv.le.0) then
             sumnum=0.0
             sumden=0.0
             sumgi=0.0
             ieqv=0
             goto 20
          endif
          gi=wt(ncod1)
          phi=iphaz(ncod1)*dtor
          sumnum=sumnum+ gi*fcvet(ncod1)*sin(phi)
          sumden=sumden+ gi*fcvet(ncod1)*cos(phi)
          sumgi=sumgi+ wt(ncod1)

          ang=atan2(sumnum,sumden)*rtod
          ip=ang+sign(0.5,ang)
          ip=mod(ip+3600,360)
          if (ip.eq.0) ip=360
          iphaz(ncod1)=ip
          g=sqrt(sumnum**2+sumden**2)
          fcvet(ncod1)=g/sumgi
          wt(ncod1)=sumgi/real(ieqv)

          do j=1,ieqv
            j1=iposref(j)
            iphaz(j1)=iphaz(ncod1) + iequip(j1,3)
            wt(j1)=wt(ncod1)
            fcvet(j1)=fcvet(ncod1)
          enddo

          ieqv=0
          sumnum=0.0
          sumden=0.0
          sumgi=0.0
          goto 20
        endif

 20   continue


      return
      end
*----------------------------------------------------*
*--- (CPR1n) - (CPR4n) semplified normalized formulas  ----*
*----------------------------------------------------*
      subroutine HiSiEstimateNorm(jcodp,nref1,i1,soge,sogem,
     +                            dsog,zneqv,Ninit,Nend) ! ,isr)

      USE General
      USE Symmetry
      USE Riflessi
      USE DemiFlunch
      real i1(3),i2(3),i3(3)

c     include 'fourpa.fh'
c     include 'sihidata.fh'
c     dimension isr(*)
c     character*2 nalf
c     common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c     common/rc/p(6),cx(9),nreftot,nrefc,nb,rhomax,mm,en,mz,er,th,rhomin
c     common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
c    *          ,s3s2p,s3s2d
c     common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,ff(9),nalf(8)
c     common/ureq/ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
c     common /tran/ scale,mh(3),level,it4,xlim(3)
c     common/trig/sint(450),pi,twopi,dtor,rtod
c     common/sphere/ninto,fall(81000,9),shifti(50000,3)
c     common/indmax/ifat1,ifat2,ifatx

      real mp1,mp2,mp1w,mp2w,vara,varb

      sig2p=sigma(nref1,2)

c     if (jcodp.eq.1) then
c       fop=fmod(nref1)
c     else
c       fop=fovet(nref1)
c     endif
c     ee=evet(nref1)
c     faseV=ipub(nref1)
c     apn=ee*cos(faseV*dtor)
c     bpn=ee*sin(faseV*dtor)


      rho2p=rhov(nref1)
      dis=0.5/sqrt(rho2p)

      ps=i1(1)+i1(2)+i1(3)
      sp=0.0
      sp2=0.0
      if (jcodp.eq.1) then
        pro1=i1(1)*i1(2)*i1(3)
        if (pro1.eq.0.0) return
        sp2=1.0/((pi**6)*(pro1*pro1))
        sp=-1.0/(pro1*pi**3)
      endif

      ntot=0

      sum2=0.0
      sum1=0.0
      sum2w=0.0
      sum1w=0.0
      sum11=0.0
      sum22=0.0
      sumw=0.0
 
      do 100 i=Ninit,Nend
          jcodq=jcodr(i)
          if (jcodp.eq.0.and.jcodq.ne.1) goto 100 
c         if (jcodp.eq.0.and.jcodq.lt.1) goto 100 

          if (wt(i).le.0.001) goto 100

c         ihkl=jhkl(i)
c         call unpack(ihkl,ih,ik,il)
          ih = khl(1,i)
          ik = khl(2,i)
          il = khl(3,i)

          i2(1)=real(ih/1.0)
          i2(2)=real(ik/2.0)
          i2(3)=real(il/1.0)

          rho2q=rhov(i)
          sig2q=sigma(i,2)

          disq=0.5/sqrt(rho2q)
c         if (jcodq.eq.1.and.disq.ge.dsog) goto 100

          if (jcodq.eq.1) then
            eeq=fcvet(i)/sqrt(sig2q) ! il modulo stimato del ddd
          else
            eeq=fovet(i)/sqrt(sig2q) ! il modulo osservato di ppp
          endif
          ! quando la stima e fatto con E
          eeq=evet(i)
          if (eeq.lt.soge) goto 100
          faseq=iphaz(i)
          aqn=eeq*cos(faseq*dtor)
          bqn=eeq*sin(faseq*dtor)
          w=wt(i)

          qs=i2(1)+i2(2)+i2(3)

          arg1=(i1(1)+i2(1))*(i1(2)+i2(2))*(i1(3)+i2(3))
          if (arg1.eq.0.0) goto 100
          is1=int(2.0*(ps+qs)-2.0)
          sppq=(-1.0**is1)/(arg1*pi**3)

          arg1=(i2(1)-i1(1))*(i2(2)-i1(2))*(i2(3)-i1(3))
          if (arg1.eq.0.0) goto 100
          is1=int(2.0*(qs-ps)-2.0)
          sqmp=(-1.0**is1)/(arg1*pi**3)

          arg1=(i1(1)-i2(1))*(i1(2)-i2(2))*(i1(3)-i2(3))
          if (arg1.eq.0.0) goto 100
          is1=int(2.0*(ps-qs)-2.0)
          spmq=(-1.0**is1)/(arg1*pi**3)

          ntot=ntot+1

          sq=0.0
          sq2=0.0

          if (jcodq.eq.1) then
            pro2=i2(1)*i2(2)*i2(3)
            if (pro2.eq.0.0) goto 100
            sq2=1.0/((pi**6)*(pro2*pro2))
            sq=-1.0/(pro2*pi**3)
          endif

          sum1q=(sppq+sqmp)*(bqn-zneqv*sq)/(1.0-2.0*sq2)
          sum2q=(sppq+spmq)*aqn
          sum11q=(sppq+sqmp)**2/(1.0-2.0*sq2)
          sum22q=(sppq+spmq)**2

c         if (abs(sum1q).lt.soge.or.abs(sum2q).lt.soge) goto 100

          sum1=sum1+sum1q
          sum2=sum2+sum2q
          sum1w=sum1w+sum1q*w
          sum2w=sum2w+sum2q*w
          sum11=sum11+sum11q
          sum22=sum22+sum22q

          sumw=sumw+w

 100  continue

      if (ntot.lt.5) return
      mp1=sum1
      mp2=zneqv*sp+sum2

c     mp1w=sum1w/sumw
c     mp2w=zneqv*sp+sum2w/sumw

      vara=0.5-0.5*sum11
      varb=0.5*(1.0-2.0*sp2)-0.5*sum22
           
      eec1=sqrt(mp1**2 + mp2**2)
      fase1=atan2(mp2,mp1)
c     fase1=atan2(mp2w,mp1w)
      fase1=nint(fase1*rtod)
      fase1=mod(fase1+3600.,360.)
      if (fase1.le.0.0) fase1=360.-fase1
       
      ! solo nela caso dei interi
      ityp1=mkang(nref1)
      if (jcodp.eq.0.and.ityp1.ne.1) then
         fase=fase1
         fase1= favi(ityp1,fase1)
      endif

c     var=sqrt(vara**2 + varb**2)
      var=vara + varb

CCC   peso=0.5*sqrt(eec1/var)
      peso=bes(2.0*eec1)
      peso=amin1(1.0,peso)
CCC   if (jcodp.eq.2.and.dis.lt.dsog) peso=0.0
CCC   if (dis.ge.dsog) peso=0.0

c     if (jcodp.eq.1.or.inobs(nref1).eq.1) then
c        fovet(nref1)=eec1*sqrt(sig2p)
c        evet(nref1)=eec1
c     endif

      ! per tutti i tipi di riflesso fcvet = f stimato
      !                              ecvet = e stimato

      fcvet(nref1)=eec1*sqrt(sig2p)
      ecvet(nref1)=eec1
      iphaz(nref1)=fase1
      wt(nref1)=peso
      fvaria(nref1)=eec1/sqrt(var)
      variance(nref1)=var
      nrinto(nref1)=0.0

c     write(3,1000)i1,jcodp,ntot,dis,apn,mp1,vara,bpn,mp2,varb,
c     write(3,1000)i1,jcodp,ntot,dis
c     write(3,1000)i1,jcodp,ntot,dis,apn,mp1,sum11,bpn,mp2,sum22,
c    *              eec1,fase1,ee,faseV,eem

 1000 format (3(f8.2),1x,i1,1x,i4,20(f9.2))
 3000 return
      end

