c-- flex code for Solvent Flattening                      Release 97.01
      subroutine edmflex(ier)

c
c     *************************** FLEX97 ********************************
c          solvent flattening procedure   -    April  1997
c
c     *************************** FLEX97 ********************************

      USE General
      USE Symmetry
      USE IsrCom
      USE Grafici
      USE Mappa
      Use MapTest
      Use Riflessi
      USE PhaseModule
      USE Param
      USE CowMod, only: ncol, ndim1, ndim2

      character*200,strLog,namefile
      character *200 strTime
*     common/dada/ncol,ndim1,ndim2
      common/twomap/bwil,icoeff
      common /conue/ shi(4),ishi,shi1(4)
c     common/soglie/sogres,sogw,sogres2,soge
      integer sizes(5),itipo(5)


c
      jrest = 0
      call RoutineHeader('EDM ','05.12')
c
c     write(lo,20)

c  20 format(1h ,78('+'),//,
c    *       19x,'***  EDM Section    ***',/)


      write(ktml,'(//," <b><u>EDM Section</b></u>",/)')


c
c     preliminary section        define all necessary program parameters
c
c
      erreo=999999.9
      erre =1.0
      krecy=0
      cut_res = 0.0
      call dirflex(ilow,cut_res,ier)
      if (ier.lt.0) return
*----
      if (ifEDM == 0.and.iabs(ifFreeLunch) > 0) ihism = 1

      call AllocaISR(1)

      if (InfoOK(7)==0) then
        call LeggiRiflessiSP
        call CalcGrid
        call calcscale
      endif
      ! controllare se sono messi a 0 i valori di fove_mod (p.es nel
      ! caso SIR/MIR (con i tripletti)
      if (count(fovet_mod(1:nrefl) > 0) < 100) then
        call calcscale
      endif

      call inptf_flex

c     ! Calculate real space metric : notazione CCP4
c     call calcmetric
c     !

      if (knw == 1.or.ifPDBt > 0) then
          call AllocaTestStuff(1)
      endif


      nx=np(1)
      ny=np(2)
      nz=np(3)

      ncol=2
      rhomaxT=maxval(rhov(1:nreflTot))
      smax=rhomaxT*4.0
      ndim1 = numestref(smax)
      ndim1=ndim1*2
      !write(6,*)ndim1
      ndim2=nx*ny*(nz+2)
      !write(6,*)ndim2

      call AllocaMappa(1)
c     call AllocaEnve(1)

      FORTH=0
      FORTHini=0
      FORTHenv=0
      BACK=0
      BACKini=0
      BACKenv=0
      WhichFFTMethod=1

      call prepdata(ilow,ier)
      call readhist

      if (ifPDBt > 0) knw = 1


      if (knw > 0) then
        call AllocaMapTest(1)
        if (ifPDBt > 0) then
          fcoef(1:nrefl)=fmod(1:nrefl)
        else
          fcoef(1:nrefl)=fovet(1:nrefl)
        endif
        call MakeMap(fcoef,ipub,nrefl,0,xmapT,
     *                   FORTH,BACK)  ! True map
        call DistruggiPiani(FORTH,BACK)
      endif

      if (nrefExt > 0 ) then
         ! test quando facc. edm partendo dai dati extra.
c        inobs(nrefExt+1:nrefl) = 1
         ifExtra = - 1
         nrefExt = nrefl - nrefExt
c        namefile='ttg_refmac.hkl'
c        call ReadFileAscii(namefile)
c        ipub(:)=work1(:)
c        fmod(:)=work2(:)
         wtt1(:)=1.0
         ! peso medio interni
         pesMedInt=sum(wt(1:nrefl-nrefExt))
         pesMedInt=pesMedInt/count(wt(1:nrefl-nrefExt) > 0.0)
         write(6,*) '<m_int>=',pesMedInt
         ! peso medio extra
         pesMedExt=sum(wt(nrefl-nrefExt+1:nrefl))
         pesMedExt=pesMedExt/count(wt(nrefl-nrefExt+1:nrefl) > 0.0)
         write(6,*) '<m_ext>=',pesMedExt
         scPesi=pesMedInt*0.5
         if (scPesi < pesMedExt ) then
         scPesi=scPesi/pesMedExt
         write(6,*) 'sc<m_ext>=',scPesi
         wt(nrefl-nrefExt+1:nrefl)=wt(nrefl-nrefExt+1:nrefl)*scPesi
         pesMedExt=sum(wt(nrefl-nrefExt+1:nrefl))
         pesMedExt=pesMedExt/count(wt(nrefl-nrefExt+1:nrefl) > 0.0)
         write(6,*) '<m_ext>=',pesMedExt
         endif
c        call MakeMap(khl,fmod,ipub,nrefl,0,xmapT,
c    *                   FORTH,BACK)  ! True map
c        call DistruggiPiani(FORTH,BACK)
      endif
      
      if (nrsetMin > 0 .and. nrsetMax > 0) then
       do nnumset=nrsetMin, nrsetMax
          numset = nnumset
         call getsetflex
         if (knw ==1) then
             call statres
             erore0 = erore
             erorepes0 = erorepes
         endif
         if (abs(ifEDM) > 0) then
           call flexmain
           if (knw ==1) then
               call statres
           endif
           call MemSetflex
           if (knw ==1) then
               write(lo,10) nnumset, erore0, erore
           endif
           fcvet(1:nrefl) = fovet(1:nrefl)*wt(1:nrefl)
           emod(1:nrefl) = evet(1:nrefl)*wt(1:nrefl)
           call WRITEMTZ(2,17,0)
           strTime='EDM'
           call CPUTIMEtot(strTime)
         endif
!
         if (numbGen > 0.and.iabs(ifFreeLunch) > 0) then
             if (nLinesGRsaveBox(2) > 0) 
     *        nLinesGRsaveBox(2) = nLinesGRsaveBox(2)  + 2
             call FreeLunch()
             call WRITEMTZ(3,0,0)
             strTime='FreeLunch'
             call CPUTIMEtot(strTime)
c            call WRITEMTZ(4,0,0)
         endif
!
       enddo
      else
         ! case quando partiamo dalle fasi della lista7 (p.ex file mtz)
         write(6,*) 'Sog:',sogw,soge,sogres,sogres2
         do i=1,nrefl
          if (wt(i).le.sogw) wt(i)=0.0
          if (evet(i).lt.soge) wt(i)=0.0
          dres=0.5/sqrt(rhov(i))
          if (dres < sogres) wt(i)=0.0
          if (dres > sogres2) wt(i)=0.0
c        iphaz(i) = (ipub(i) + 0.7*iphaz(i)) /2.0
c        iphaz(i) = mod(iphaz(i) + 3600, 360)
         enddo
         if (knw.gt.0) then
          if (nrefExt > 0 ) then
             call esamin(khl,mkang,ipub,iphaz,nrefExt,1,wtt1,wt,
     *             errm1,errmw1,nref1,shi1)
             call esamin(khl,mkang,ipub,iphaz,nrefl,nrefExt+1,wtt1,wt,
     *             errm1,errmw1,nref1,shi1)
          endif
          call esamin(khl,mkang,ipub,iphaz,nrefl,1,wtt1,wt,
     *             errm1,errmw1,nref1,shi1)
          do i=1,nrefl
           nh1=khl(1,i)
           nk1=khl(2,i)
           nl1=khl(3,i)
           iphaz(i)=shi1(4)*iphaz(i)-360.*(nh1*shi1(1)+nk1*shi1(2)+
     *             nl1*shi1(3))
           iphaz(i)=mod(iphaz(i)+3600,360)
           if (iphaz(i).le.0) iphaz(i)=360+iphaz(i)
          enddo
          call statres
         endif
         ! starting set (per la combinazione) 

         iphad(:)=iphaz(:)
         wtd(:)=wt(:)
         ! ciclo precedente
         iphi2_in(:)=iphaz(:)
         wtt_in(:)=wt(:)

         iphi2_o(:)=iphaz(:)
         wtt_o(:)=wt(:)
         if (neutro>0.and.numbGen > 0.and.iabs(ifFreeLunch) > 0) then
            call FreeLunch_neutro()
            call WRITEMTZ(3,0,0)
            strTime='n-FreeLunch'
            call CPUTIMEtot(strTime)
         else
c        if (ifDemiFL > 0) call DemiFlunchMain
         if (abs(ifEDM) > 0) then
           call flexmain
           fcvet(1:nrefl) = fovet(1:nrefl)*wt(1:nrefl)
           emod(1:nrefl) = evet(1:nrefl)*wt(1:nrefl)
           call WRITEMTZ(2,0,0)
           strTime='EDM'
           call CPUTIMEtot(strTime)
           if (numbGen > 0.and.iabs(ifFreeLunch) > 0) then
             if (nLinesGRsaveBox(2) > 0) 
     *        nLinesGRsaveBox(2) = nLinesGRsaveBox(2)  + 2
              call FreeLunch()
              call WRITEMTZ(3,0,0)
              strTime='FreeLunch'
              call CPUTIMEtot(strTime)
           endif
         else
           if (numbGen > 0.and.iabs(ifFreeLunch) > 0) then
           ! controllo "set riflessi fasati prima di FL"
           nrefPhased = count(wt(1:nrefl) > 0.0)
           percPhased = float(nrefPhased)/float(nrefl)
           if (percPhased < 0.75) then
             write(lo,*)
             write(lo,*)
             write(lo,*)' SIRprot runs only with option FREELUNCH'
             write(lo,*)' % of phased reflections in the data:',
     *                   percPhased*100.
             write(lo,*)' SIRprot will perfom before a default',
     *               ' EDM Procedure',
     *               ' to complete data'
             write(lo,*)
             write(lo,*)
            ! facciamo prima flex
             call flexmain
             if (nLinesGRsaveBox(2) > 0) 
     *        nLinesGRsaveBox(2) = nLinesGRsaveBox(2)  + 2
           endif
           call FreeLunch()
           call WRITEMTZ(3,0,0)
           strTime='FreeLunch'
           call CPUTIMEtot(strTime)
           endif
         endif
         endif  ! x n-FreeLunch
      endif


      call AllocaMappa(2)
      call AllocaEnve(2)
      if (ifcorr.eq.1) then
         call AllocaMapTest(2)
      endif

      call AllocaISR(2)


c     strTime='EDM'
c     call CPUTIMEtot(strTime)
!
      return
   10 format(/,'EDM/FLEX Set ',i2,'  MPE iniz, fin',2f8.2)
      end
c-----------------------------------------------------------------------
      subroutine inptf_flex
c--
c-- input subroutine
c--
      USE General
      USE Symmetry
      USE Mappa 
      USE PhaseModule
      USE Param

      character*80 mapname
      common /kuse/ kuser1,nsize,kuser3
      common /tran/ scale,mh(3),level,it4,xlim(3)
c---
      common /misc/ t(3,3),dxmax(3),ishift(3,19)
      common /dd/ a2,b2,c2,ab,ac,bc,bterm,wscale
      common/twomap/bwil,icoeff
      common/four2/mapname,iftrue
      dimension abc(3),ang(3)
c
*gl*  call xfl01              !!gl
!     if (jpatt.eq.0) then
*gl*     call yfl02           !!gl
*gl*     call musym()         !!gl
!     endif
!     neqv = nsym
      call xspinb
*---------------------------------------------------*
      a1=cos(cell(4)*pi/180.0)
      a2=cos(cell(5)*pi/180.0)
      a3=cos(cell(6)*pi/180.0)
      arg=1.0-a1*a1
     1       -a2*a2
     2       -a3*a3
     3       +a1*a2*a3*2.0
       volume=cell(1)*cell(2)*cell(3)*sqrt(arg)

!
       dm0 = 0.85   ! limite adatto per una Mappa Fourier 
       dxmax(1)=dm0*cell(2)*cell(3)*sin(dtor*cell(4))/volume
       dxmax(2)=dm0*cell(3)*cell(1)*sin(dtor*cell(5))/volume
       dxmax(3)=dm0*cell(1)*cell(2)*sin(dtor*cell(6))/volume
       dm=dm0*dm0

!
       f000=0.0
       v_m=0.0
*--------------------------------------
       den=0.0
       do i=1,nk
         f000=f000+float(nw(i)*no(i))
         den=den+float(nw(i)*nw(i)*no(i))
         if (no(i).gt.1) then
            v_m=v_m+14.0*float(nw(i))
         endif
       enddo
       if (icoeff.eq.8) f000=f000/sqrt(den)
*---- Matthews' number 
          v_m=volume/v_m
*---- Percent of Protein
*-----  protein density=1.23 (from CCP4 1.34)
c         v_p=1.23/v_m
          v_p=1.34/v_m
c         if (jderi.eq.0) v_p=1.0
          if (vp0_init.gt.0.0) v_p=vp0_init
          if (ihism.gt.0) f000=volume*(0.32*(1.0-v_p)+0.43*v_p)
          if (isfhm.gt.0) f000=volume*(0.32*(1.0-v_p)+0.43*v_p)
!  modificato
          if (ifFreeLunch ==0 ) f000=volume*(0.32*(1.0-v_p)+0.43*v_p)
*---------------------------------------------------*
*gl*     call xfl06
         call LoadReflInfo
         
      do 20 i=1,3
         abc(i)=cell(i)
         ang(i)=cell(i+3)*pi/180.0
         mh(i)=ihmx(i)
   20 continue
      a2=abc(1)*abc(1)
      b2=abc(2)*abc(2)
      c2=abc(3)*abc(3)
      ab=2.0*abc(1)*abc(2)*cos(ang(3))
      ac=2.0*abc(1)*abc(3)*cos(ang(2))
      bc=2.0*abc(2)*abc(3)*cos(ang(1))
      bterm=bt
      wscale=sc
!     if ((jpatt.eq.4.or.kheavy.gt.0).and.natHeavy.gt.0) nat=natHeavy
      anat=float(nat)/(pts*float((icent+1)*nsym))
      natm=int(anat+0.5)
      if (npc.gt.0) natm=npc
c
      if (icent == 1) then
          nsym2 = 2 * nsym
      else
          nsym2 = neqv
      endif
!
      return
      end
c--------------------------------------------------------------------
      subroutine dirflex(ilow,cut_res,ier)

      USE General
      USE Symmetry
      USE Mappa
      USE PhaseModule
      USE Param
      USE Skeleton
      USE CowMod, only: ncol, ndim1, ndim2

      character*80 name,nameout,nameold,mapname
      character*200 line,dire,diret,filet
      character buff*2,Numdigit*13
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /cifre/ Numdigit
      common /tran/ scale,mh(3),level,it4,xlim(3)
      common /misc/ t(3,3),dxmax(3),ishift(3,19)
      common/inpcl/ntype,ttype(10,5),nprojx,nbond,dmaxi,radnew(8)
      common/twomap/bwil,icoeff
      common/inptfile/iold,nameout,nameold
      common/conue/shi(4),ishi,shi1(4)
      common/super1/nmaMa1,iexte,fdri(3,100),percref(100),percc1(100),
     *              ncycl1(100)
      common/super2/ncycl2(100),percc2(100),nmaMa2
      common/super3/ncycl3(100),percc3(100),nmaMa3
      common/super4/ncycl4(100),percc4(100),nmaMa4
      common/four2/mapname,iftrue
c     common/soglie/sogres,sogw,sogres2,soge
      common/omitmap/iomit,iy,nxomit(3,3)
*     common/dada/ncol,ndim1,ndim2
      common /sphere/radius
      common /origins/nox,noy,noz

      dimension vet(40),ivet(40)
      dimension ltype(10,5)
      equivalence (ltype(1,1),ttype(1,1))
c-- set default values
c
      ifPDBheavy = 0

      if (iphase ==0) then
        nrsetMin=1
        nrsetMax=1
      else
        nrsetMin=0
        nrsetMax=0
      endif
      ! for Rfree real
      frpr=4.0
      frsr=4.0
      frpx=-1.0e6
      frsx=-1.0e6
      realfree=1.0e6

      iflat=2  ! 0 --> sol=0.0; 1--> sol=den*0.5; 2--> solvent=0.32


      ifDemiFL = 0 
      ifFreeLunch=0  ! free Lunch 1 --> procedura vecchia 2 -- > la nuova
      rGenStep(:) = 0.0
      macroFL = 2
      irescut = 0
      sogRhoMaxMap = 100.0
      sogSigmaMap = 1.0
 
      if2fofc=0
      ifreweight=0
      ifextref=0  !0--> default (decide il pgm) 1 --> all  2--> resolution 3--> weights 4--> Fc  5--> Fo 6--> Epp
      jgamma=0
      jgamma=1

      radius=0.0
      isfhm=0
      jsigmaa=0
      jsigmaa=1

      ishi=0
      shi(1:3)=0.0
      shi1(1:3)=0.0

      shi(4:4)=1.0
      shi1(4:4)=1.0

      mapname=' '
      igrid=1
      ndim1=0
      ndim2=0
      ncol=0
      iomit=0
      iy=67543
      irefc=0

      cut_res=7.5


      ilow=0
!     jpatt=0
      nameout =' '
      ipart = 0
      ifDEDM = 0
      nivoltaD = 0
      idritanD = 0
      ialte  =0
      Xflip=0.0
      solc=0.0
      iold=0
      v_p=0.0
      pv_p=-0.10
      icoeff=0
      icomb=1
*------parametri per super 1
c     percTest=1.0
      percTest=0.7
      nmaMa1=5
      percc1(1)=0.2* percTest
c     percc1(1)=0.15* percTest
      ncycl1(1)=20
      ! per il super ciclo new
      percc1(2)=percc1(1)
      ncycl1(2)=5
      do i=3,100
        ncycl1(i)=5
c       percc1(i)=percc1(i-1)+0.05*percTest
        percc1(i)=percc1(i-1)+0.05
        if (percc1(i).gt.1.0) percc1(i)=1.0
      enddo
      iexte=1
      pr=1.0/float(ncycl1(1)-1)
      percref(1)=pr
      percref(ncycl1(1))=1.0
      do i=2,ncycl1(1)-1
         percref(i)=percref(i-1)+pr
      enddo
*-----End parametri per super 1
*----- parametri per super 2
       percTest=1.0
       nmaMa2=3
       percc2(1)=0.20* percTest
       percc2(2)=0.35* percTest
       percc2(3)=0.50* percTest

       ncycl2(1)=5
       ncycl2(2)=5
       ncycl2(3)=10

*-----End parametri per super 2

*----- parametri per super 3
       percTest=1.0
       nmaMa3=1
       percc3(1)=0.50* percTest
       ncycl3(1)=5
*-----End parametri per super 3

      fdri(1,:)=0.70
      fdri(2,:)=0.40
      fdri(3,:)=0.05

c     fdri(1,:)=0.90
c     fdri(2,:)=0.60
c     fdri(3,:)=0.05

c     sogDE=0.1
c     sogsigFlex=0.7
*----- parametri per super 4 (new)
      nmaMa4=2
      nmaMa4=1
      percc4(1)=1.0
c     ncycl4(1)=20
      ncycl4(1)=50

      percc4(2)=0.15
c     percc4(2)=0.5
      ncycl4(2)=20
*-----End parametri per super 4

      sogDEflex1=0.0
      sogsigFlex=0.0

      iftrue=0
      th=1.0
      jnobs=0
      nobfac=1
      ilistFlex=0
      soge2=100.0
      sogrho=0.0
      elimas=2.5
      irecom = 0
      ! skeleton-Greer
      iBonesIn = 0 ! file bones from mapman
      iskelet = 0
      sogMapSK = 1.5
      sogLevSK = 0.5
      lungSK = 5
      nSparePoints = 0
      !
      invf = 0
      ienve = 1
      nenve = 3
      Renve = 8.0
      stepE = -2.0

      bwil = 0.0
      isuper1=1
      jspini = -1
      do 10 i=1,nk
   10 radnew(i)=-1.0
      fobmin=-1.0
      tsigma=-1.0
      nsec=1
      dmaxi=0.0
      jpfile=0
      ntype=0
      do 20 i=1,5
      do 20 j=1,10
   20 ttype(j,i)=0
      jmpsie= 0
      iprin = 0
      ibl   = 0
      nproj = 0
      nbond = 1
      npc   = 0
      nojoin= 0
      it4   = 0
      level = 100
      xlim(1)=1.0
      xlim(2)=1.0
      xlim(3)=1.0
      ks    = 1

      isuperNew=1

      ifree  = 0   ! 0/1 --> non/calcolare rfree (nel caso ifEDM =1, ifree= 0 xche si usa ifreem, invece ifEDM =-1, ifree=1)
      ifreem = 1   ! 0/1 --> non/calcolare rfree mask
      ihism  = 1   ! 0/1 --> non/usare HM
      ifEDM  = 1   ! -1/0/1 --> -1 procedura FLEX, 0 nessun EDM, 1 procedura nuova
      ifExtra =0   ! 0/1 --> non/usare i riflessi extrapolated
                   ! -1 nel caso che abbiamo gia e' riflessi da FreeLunch (x usare div. nel sigmaA)
      
      ifconv=1  ! criterio di convergenza : 0-> nessuna; 1-> freemask 2->R-free 3->Rsir

      vp0_init=0.0

      sogres=0.0
      sogres2=200.0
      soge=0.0
c     soge=0.2
      sogw=0.0
      numset= 0
      nrstMin= 0
      nrstMax= 0
      elimhe=0.0
c     factr= 1.0/3.0
      factr= 3.0/4.0
      ifcorr = 1

      nox=2
      noy=256
      noz=2
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 8000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
      if (dire(1:4).eq.'true') then
          iftrue=1
          go to 100
          end if
      if (dire(1:4).eq.'corr') then
          ifcorr=1
          mapname=line
          go to 100
          end if
      if (dire(1:4).eq.'noco') then
          ifcorr=0
          go to 100
          end if
      if (dire(1:4).eq.'layy') then
          nsec=1
          go to 100
          endif
      if (dire(1:4).eq.'layx') then
          nsec=2
          go to 100
          endif
      if (dire(1:4).eq.'layz') then
          nsec=3
          go to 100
          endif
      if (dire(1:4).eq.'frag') then
c         kfrag=kform
          kfrag=jhost
          read(line,'(a)') FichierIn
          istat=2
          iform=1
          if (jopen(kfrag,FichierIn,istat,iform,ier).ne.0) go to 9100
          k=index(FichierIn,'.',.TRUE.)
          Inte = FichierIn(k+1:)
          call lcase(Inte)
          if (Inte(1:3) == 'pdb') then
              ifPDBheavy = 1
              PDBfile = FichierIn
              lPDB = Lung(PDBfile)
          else
              ifPDBheavy = 0
          endif

          go to 100
          endif
      if (dire(1:4).eq.'bone') then
          read(line,'(a)') filet
          istat=2
          iform=1
          if (jopen(1,filet,istat,iform,ier).ne.0) go to 9100
          close(1)
          BonesFileName = filet
          iBonesIn = 1
          go to 100
          endif
c     if (dire(1:4).eq.'pdb') then
          ! ora la lettura PDB  + calc sf e' nel DATA
c         read(line,'(a)') filet
c         ifPDBt = 1
c         PDBfile = filet
c         lPDB = Lung(PDBfile)
c         istat=2
c         iform=1
c         kfrag=jhost
c         print*,filet,kfrag
c         if (jopen(kfrag,filet,istat,iform,ier).ne.0) go to 9100
c         go to 100
c         endif
c-- directives with numeric parameters
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 9000
      if (dire(1:4).eq.'fdif') then
          if2fofc=1
          if (iv ==1 ) if2fofc=ivet(1)
          go to 100
          end if
      if (dire(1:4).eq.'rewe') then
          ifreweight=1
          if (iv > 0) ifreweight = ivet(1)
          go to 100
          end if
      if (dire(1:4).eq.'refe') then
          ifextref=ivet(1)
          go to 100
          end if
      if (dire(1:4).eq.'sigm') then
          if (iv > 0) then
           jsigmaa=ivet(1)
          else
           jsigmaa=2
          endif
          go to 100
          end if
      if (dire(1:4).eq.'sphe') then
          radius=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'flat') then
          if (iv.ne.1) goto 9000
          iflat=ivet(1)
          goto 100
      endif
      if (dire(1:4).eq.'list' ) then
          if (iv.eq.0) go to 9000
          ilistFlex=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'rfre') then
         ifree=1
         if (iv > 0) ifree=ivet(1)
         goto 100
      endif
      if (dire(1:4).eq.'mfre') then
         ifreem=1
         if (iv > 0) ifreem=ivet(1)
         goto 100
      endif
      if (dire(1:4).eq.'coef') then
          if (iv.le.0) goto 9000
          icoeff=ivet(1)
          goto 100
      endif
      if (dire(1:4).eq.'alte') then
          ialte=1
          goto 100
      endif
      if (dire(1:4).eq.'bwil') then
          if (iv.le.0) goto 9000
          bwil=vet(1)
          goto 100
      endif
      if (dire(1:4).eq.'supo') then
          isuperNew=0
          ifree=1
          iflat = 1
          goto 100
      endif
      if (dire(1:4).eq.'supn') then
        isuperNew=1
        nmaMa4=0
        do iv1=1,iv
          ncycl4(iv1)=ivet(iv1)
          nmaMa4=nmaMa4+1
        enddo
        if (nmaMa4 <=1 ) nmaMa4=1
        goto 100
      endif
      if (dire(1:4).eq.'sup1') then
          if (iv.le.0) goto 9000
             do i=1,iv
              percc1(i)=vet(i)
             enddo
          nmaMa1=iv
          goto 100
      endif
      if (dire(1:4).eq.'sup2') then
          if (iv.le.0) goto 9000
c         if (iv.ne.nmaMa2) goto 9000
          do i=1,iv
          percc2(i)=vet(i)
          enddo
          nmaMa2=iv
          goto 100
      endif
      if (dire(1:4).eq.'sup3') then
          if (iv.le.0) goto 9000
c         if (iv.ne.nmaMa3) goto 9000
          do i=1,iv
          percc3(i)=vet(i)
          enddo
          nmaMa3=iv
          goto 100
      endif
      if (dire(1:4).eq.'prim') then
          if (iv.le.0) goto 9000
          isuper1=ivet(1)
          goto 100
      endif
      if (dire(1:4).eq.'nobs') then
          jnobs=ivet(iv)
          goto 100
      endif
      if (dire(1:5).eq.'rhoma') then
          if (iv.gt.1) go to 8000
          th=vet(1)
          if (th.lt.0.0.or.th.gt.1.0) go to 8000
          go to 100
          endif
      if (dire(1:4).eq.'rapr') then
          if (iv.le.0) goto 9000
          randp=vet(1)
          if (iv.eq.2) ifrec=ivet(2)
          goto 100
      endif
      if (dire(1:4).eq.'wcom') then
          if (iv.ne.1) goto 9000
          icomb=ivet(1)
          go to 100
          end if
      if (dire(1:4).eq.'comb') then
          if (iv.lt.3) goto 9000
          ivm=iv/3
          if (ivm.le.0) ivm=1
           ii=-2
           do i=1,ivm
           ii=ii+3
           fdri(1,i)=vet(ii)
           fdri(2,i)=vet(ii+1)
           fdri(3,i)=vet(ii+2)
          enddo
          ncma1=ivm
          go to 100
          end if
      if (dire(1:4).eq.'noex') then
          iexte=0
          go to 100
          end if
      if (dire(1:4).eq.'cycl') then
          if (iv.ne.1) goto 9000
          ncycl1(1)=ivet(1)
          go to 100
          end if
      if (dire(1:4).eq.'exte') then
          iexte=2
          if (iv.ge.2) then
            do i=2,iv
             percref(i-1)=vet(i)
            enddo
            ncycl1(1)=iv-1
          elseif (iv.eq.1) then
             ncycl1(1)=ivet(1)
          end if
          go to 100
          end if
      if (dire(1:4).eq.'enve') then
          ienve=2
          if (iv.ge.1) Renve=vet(1)
          if (iv.ge.2) nenve=ivet(2)
          if (iv.ge.3) then
              pv_p=vet(3)
              if (pv_p.gt.1.0) pv_p=pv_p/100.0
          endif
          if (iv.ge.4) stepE=vet(4)
          go to 100
          end if
      if (dire(1:4).eq.'solv') then
          vp0_init=vet(1)
          if (vp0_init.gt.1.0) vp0_init=vp0_init/100.0
          vp0_init=1.-vp0_init
          go to 100
          end if
      if (dire(1:4).eq.'flip') then
          if (iv.ne.1) goto 9000
          Xflip=vet(1)
          go to 100
          end if
      if (dire(1:4).eq.'solc') then
          if (iv.ne.1) goto 9000
          solc=vet(1)
          go to 100
          end if
      if (dire(1:4).eq.'skel') then
          iskelet=1
          if (iv.gt.0) then
            if (iv.ne.4) goto 9000
            sogMapSK=vet(1)
            sogLevSK = vet(2)
            nSparePoints = ivet(3)
            lungSK = ivet(4)
          endif
          go to 100
          end if
      if (dire(1:6).eq.'dfreel') then
         ifDemiFL = 1
         go to 100
         end if
      if (dire(1:5).eq.'freel') then
          ihism = 1
          ifFreeLunch = 2
          sogw = 0.01
          if (iv > 0) then
            irescut = ivet(1)
            if (iv > 1) then
             ifFreeLunch = ivet(2)
             if (iv > 2) then
              percExtreIn = vet(3)
              macroFL = ivet(4)
              do i=5,iv
                rGenStep(i-4) = vet(i)
              enddo
             endif
            endif
          endif
          go to 100
          end if
c     if (dire(1:4).eq.'solv') then
c         isfhm=20
c         if (iv.gt.0) isfhm=ivet(1)
c         go to 100
c         end if
      if (dire(1:4).eq.'conv') then
          ifconv=1
          if (iv > 0) ifconv=ivet(1)
          select case (ifconv)
          case (-1) ! default  (usa Real-Rfree)
           ifreem = 1
           ifree = 0
           ifconv = 1
          case (0)  ! senza crit. di conv (si ferma solo con dphi)
           ifreem = 1 ! si calc. realRfree, ma non si usa
           ifree  = 0 ! non si calc. Rfree
          case (1)  ! come il default (usa Real-Rfree)
           ifreem = 1
           ifree = 0  ! non si calc.Rfree (solo Rtot)
          case (2)  !Rfree  (non si calc. real-Rfree)
           ifreem = 0
           ifree = 1
          case (3) ! con dPHI equivalente come senza criterio di convergenza
           ifreem = 1
           ifconv = 0 
          end select
          ! nel caso FLEX old
          if (ifEDM < 0) then
             ifconv = 0
             ifree  = 1
             ifreem = 0
          endif
          go to 100
          end if
      if (dire(1:2).eq.'dm') then
          select case (iv)
           case (0)
            ifEDM=0
           case (1)
             ifEDM=ivet(1)
           case (2)
             ifEDM=ivet(1)
             ihism=ivet(2)
           case (3)
             ifEDM=ivet(1)
             ihism=ivet(2)
             ifExtra=ivet(3)
           case (4)
             ifEDM=ivet(1)
             ihism=ivet(2)
             ifExtra=ivet(3)
             ! per il momento ivet(4) = 0  (si puo usare per skeleton)
          end select 
          go to 100
          end if
      if (dire(1:4).eq.'hist') then
c         ihism=1
          if (iv.gt.0) ihism=ivet(1)
          go to 100
          end if
      if (dire(1:4).eq.'invf') then
          invf=1
          go to 100
          end if
      if (dire(1:4).eq.'omit') then
          iomit=ivet(1)
          go to 100
          end if
      if (dire(1:4).eq.'part') then
          if (iv > 0) then
           ifDEDM=ivet(1)
           if (iv > 1) then
              nivoltaD = ivet(2)
              if (iv > 2) idritanD = ivet(3)
           endif
          else
           ifDEDM=1
          endif 
c           ifDEDM=0  ! occhio
          go to 100
          end if
      if (dire(1:4).eq.'nobf') then
          nobfac=0
          go to 100
          endif
      if (dire(1:4).eq.'shif') then
          if (iv.ne.4) goto 9000
          ishi = 1
          do i=1,4
          shi1(i) = vet(i)
          enddo
          go to 100
          endif
      if (dire(1:4).eq.'rmin') then
          if (iv.eq.0) goto 9000
          sogres=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'rmax') then
          if (iv.eq.0) goto 9000
          sogres2=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'sogw') then
          if (iv.eq.0) goto 9000
          sogw=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'soge') then
          if (iv.eq.0) goto 9000
          soge=vet(1)
          go to 100
          endif
      if (dire(1:5).eq.'sogde') then
          if (iv.eq.0) goto 9000
          sogDEflex1=vet(1)
          go to 100
          endif
      if (dire(1:5).eq.'sogsi') then
          if (iv.eq.0) goto 9000
          sogsigFlex=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'sog2') then
          if (iv.eq.0) goto 9000
          soge2=vet(1)
          go to 100
          endif
c     if (dire(1:5).eq.'sogrh') then
c         if (iv.eq.0) goto 9000
c         sogrho=vet(1)
c         go to 100
c         endif
      ! sog RHOmax (MAP) per il cut (freelunch secondo macro)
      if (dire(1:5).eq.'sogrh') then
          if (iv.eq.0) goto 9000
          sogRhoMaxMap = vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'sogm') then
          if (iv.eq.0) goto 9000
          sogSigmaMap = vet(1)
          go to 100
          endif

      if (dire(1:5).eq.'elimh') then
          elimhe=2.5
          if (iv.eq.1) elimhe=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'lowe') then
          ilow=1
          if (iv.eq.1) cut_res=vet(1)
          go to 100
          endif
      if (dire(1:5).eq.'elima') then
          if (iv.eq.0) goto 9000
          elima=vet(1)
          go to 100
          endif
      if (dire(1:2).eq.'ls') then
          if (iv.ne.1) go to 9000
          lsx=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'prin') then
          if (iv.ne.1) go to 9000
          iprin = ivet(1)
          go to 100
          endif
c     if (dire(1:4).eq.'dmax') then
c         if (iv.ne.1) go to 9000
c         dmaxi=vet(1)
c         go to 100
c         endif
      if (dire(1:4).eq.'gamm') then
          jgamma=1
          if (iv > 0) then
c           gammav=vet(1)
            jgamma=ivet(1)
          endif
          go to 100
          endif
      if (dire(1:4).eq.'proj') then
          if (iv.ne.1) go to 9000
          nproj=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'noin') then
          if (iv.ne.0) go to 9000
          nojoin=1
          go to 100
          endif
      if (dire(1:4).eq.'leve') then
          if (iv.ne.1) go to 9000
          level=ivet(1)
          go to 100
          endif
c     if (dire(1:4).eq.'auto') then
c         igrid=1
c         go to 100
c         endif
      if (dire(1:4).eq.'grid') then
          if (iv.gt.1) go to 9000
          if (iv.eq.1) then
           factr=vet(1)
           igrid=0
          else
           igrid=1
          endif
          go to 100
          endif
      if (dire(1:4).eq.'limi') then
          if (iv.ne.3) go to 9000
          do 7500 i=1,3
 7500     xlim(i)=amin1(vet(i),1.0)
          go to 100
          endif
      if (dire(1:3).eq.'map' ) then
          if (iv.ne.0) go to 9000
          it4=lo
          go to 100
          endif
      if (dire(1:3).eq.'set' ) then
          if (iv.eq.0) then
            nrsetMin=1
            nrsetMax=1
          else
            nrsetMin=ivet(1)
            nrsetMax=nrsetMin
            if (iv.eq.2) then
                nrsetMax=ivet(2)
            endif
          endif
          go to 100
      endif
      if (dire(1:3).eq.'tan' ) then
         if (iv.ne.0) go to 9000
         numset=1001
         go to 100
      endif
      if (dire(1:3).eq.'kno' ) then
         if (iv.ne.0) go to 9000
         numset=1000
         go to 100
      endif
       if (dire(1:4).eq.'nori')  then
          if (iv.ne.3) go to 8000
          nox=ivet(1)
          noy=ivet(2)
          noz=ivet(3)
          go to 100
          endif

      ier=-1
      return
 8000 continue

      if (iexte.eq.2.and.ncycl1(1).gt.5) then
        pr=1.0/float(ncycl1(1)-1)
        percref(1)=pr
        percref(ncycl1(1))=1.0
        do i=2,ncycl1(1)-1
           percref(i)=percref(i-1)+pr
        enddo
        iexte=1
      endif
      if (isuper1.eq.2) then
       nmaMa2=1
       percc2(1)=0.20
       ncycl2(1)=10
      endif

      if (knw.eq.0) ifcorr=0
      if (tsigma.gt.0.0.and.ksigma.eq.0) then
                                           write(lo,8005)
                                           tsigma=-1.0
                                         endif
 8005 format(' *** warning ***  no suitable sigma(F) in data',/,
     *       '                  SIGMA directive ignored')
      nprojj=nproj
      if (ntype.gt.0) then
                        do 8020 i=1,ntype
                        write(buff,'(a2)') ttype(i,1)
                        read (buff,'(a2)') iitype
                        do 8010 j=1,nk
                           if (iitype.ne.nalf(j)) go to 8010
                           go to 8020
 8010                   continue
                        write(lo,8030) ttype(i,1)
                        go to 9000
 8020                   continue
                      endif
 8030 format(' Element ',a2,' not present in the declared content')
      return
 9000 continue
      ier=-1
      return
 9100 continue
      ier=-1
      return
      end
*-----------------------------------------------------------------
      subroutine prepdata(ilow,ier)

      USE General
      USE Symmetry
      USE Riflessi

      USE IsrCom
      USE Grafici
      USE Mappa
      USE Molcom
      USE PhaseModule
      USE Param

      common /tran/ scale,mh(3),level,it4,xlim(3)

      character space*16
      character*80 nameout,nameold,mapname
      character*200,strLog
      character*80,strHead(3)

c
      nexp=0
      ratio = -1.0
      corr=0.0
      corre=0.0
      nref1=0
      errm1=0.0
      errmw1=0.0
      errm12=0.0
      errinv=0.0
      errinvp=0.0
      Rtot=0.0
      nref12=0

      if (kscreen > 0) then
        HistoOK(1)=0
c       if (iphase > 0) HistoOK(2) = 0
        if (HistoOK(2) > 0) then
          call ManageGraph(0,0) 
        endif
        if (inBoxGr(2) > 0) then
          inBoxGr(2:)=0
          nLinesGR=nLinesGRsaveBox(2)
        endif
!gl     write(strLog,'(18h<b>EDM SECTION</b>)')
!gl     call TestoGR(strLog, -1, 2, 2)
        write(strLog,'("<big><b>EDM Section</b></big>")')
        call TestoGR(strLog, color_RED, 2, 2)
c       if (numset > 0) then  
c         write(strLog,'(21hTrials to be improved: ,i3)')numset
c         call TestoGR(strLog, -1, 2, 2)
c       endif
        call zflush
        call DoSingleIteration()
      endif

      if (ifromExt==0)  then
            write(strLog,'("Trials to be improved",
     *                  " by FLEX : ",i3)')numset

            if (numset > 0) then
             write(strLog,'("EDM SECTION")')

             strHead(1)='TRIAL'
             strHead(2)=''

             select case (ianom)
             case (3)
             strHead(3)='CFOM\dSIR\u vs. TRIALS after Phasing Procedure'
             case (6)
             strHead(3)='CFOM\dMAD\u vs. TRIALS after Phasing Procedure'
             strHead(3)='CFOM\dMAD\u vs. TRIALS after Phasing Procedure'
             case (9)
             strHead(3)='CFOM\dMAS\u vs. TRIALS after Phasing Procedure'
             end select
             ncfom=count(cfomPhase(1:nsetTotal)> 0.0)
             if (nsetTotal > 0.and.ncfom > 0) then
c            call PlotCFOM(strHead,xtrialPhase,cfomPhase,1,100,
c    *                     nsetTotal,1,0,0,0)
             endif
            endif
          !-----------------------------

      endif
c     LabTrials=0

      write(space,'(16a1)') (nSpaceG(i),i=1,16)
      call ucase(space(1:1))

      ! write info on the graph window
        write(strLog,901) space
        write(strLog,902) cell(1:6)
        if (kscreen > 0) call TestoGR(strLog, -1, 2, 2)
        write(strLog,903)np
        if (kscreen > 0) call TestoGR(strLog, -1, 2, 2)
        write(strLog,908) factr
        if (kscreen > 0) call TestoGR(strLog, -1, 2, 2)
        write(strLog,905) 1.-v_p
        if (kscreen > 0) call TestoGR(strLog, -1, 2, 2)
        write(strLog,906) nrefl
c       if (kscreen > 0) call TestoGR(strLog, -1, 2, 2)
        write(strLog,907) nnobs
c       if (kscreen > 0) call TestoGR(strLog, -1, 2, 2)
        nLinesGRsaveBox(2)=nLinesGR

        call zflush
        call DoSingleIteration()

  901 format('Space Group: ',a16)
  902 format('Unit cell parameters: ' ,3f8.3,2x,3f8.3)
  903 format('Number of grid points along X, Y, Z: ',3i4)
  904 format('Grid spacing (in angstrom) approximately: ',f6.3)
  905 format('Solvent Fraction: ',f7.3)
  906 format('Number of independent reflections input: ',i6)
  907 format('Number of unobserved reflections: ',i6)
  908 format('Grid spacing approximately: ',f6.3,
     *       ' <span lang="A">A</span>')

      !---


      write(lo,900)
      write(lo,910) space
      write(lo,920)
      write(lo,930) cell(1:6)
      write(lo,920)
      write(lo,940) np
      write(lo,920)
      write(lo,950) mh
      write(lo,920)
      write(lo,960) nrefl
      write(lo,920)

  900 format( 2x,'+',74('-'),'+')
  910 format( 2x,'I','  Space group symbol',26x,a16,12x,'I')
  920 format( 2x,'I',74x,'I')
  930 format( 2x,'I','  Unit cell parameters                      ',
     *                 3f8.3,'      I',/,
     *        2x,'I','                                            ',
     *                 3f8.3,'      I')
  940 format( 2x,'I','  Number of grid points along X, Y, Z        ',
     *                 i7,2i8,6x,'I')
  950 format( 2x,'I','  Maximum h, k, l value                      ',
     *                 i7,2i8,6x,'I')
  960 format( 2x,'I','  Number of independent reflections input',
     *                 13x,i6,14x,'I')
C 970 format( 2x,'I','  Number of reflections in one hemisphere',
C    *                 13x,i6,14x,'I')
  980 format( 2x,'I','  Grid spacing (in angstrom) approximately   ',
     *                  9x,f6.3,14x,'I')
  995 format( 2x,'I','  F000                                       ',
     *                  9x,f6.3,14x,'I')
  996 format( 2x,'I','  Volume                                ',
     *                    f20.3,14x,'I')
  997 format( 2x,'I','  %protein                                   ',
     *                  9x,f7.3,13x,'I')
  998 format( 2x,'I','  Phased reflections                         ',
     *                  10x,i6,13x,'I',/,
     *        2x,'I','  Error (W-Error)                            ',
     *                  f6.3,2x,1h(,f6.3,1h),13x,'I')
  999 format( 2x,'I','  Origin                                     ',
     *                  4(f5.2,2x),1x,'I')
  281 format(///)


*-----------------------------------------
      scale=1.0
      write(lo,980) factr
      write(lo,900)
      write(lo,995) f000/volume
      write(lo,920)
      write(lo,996) volume
      write(lo,920)
      write(lo,997) V_p*100.0
      write(lo,900)
c     write(lo,998) nref1,errm1,errmw1
      write(lo,920)
c     write(lo,999) shi1
      write(lo,900)

c     call getheavy(ier)

*-----
      call OpenFiles
*-----
      return
      end
c--------------------------------------------------------------------------
      subroutine MapDirect(jrelM,jrelS,namef)
      USE General
      USE Mappa
      dimension nstore(250)
      character*80 namef
c
      write(6,*)' File --> Direct'
      rewind jrelM
      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      itype=0
      iform=2
      nlenM = nnx * nlenBin / knwr
      kop=kopen(jrelS ,namef,nlenM,itype,ier)
      if (kop.lt.0) go to 9000
c
      irec = 0
      do 800 ky = 1, nny
         do 700 kz = 1, nnz
            read(jrelM)   ( nstore(i), i = 1 , nnx )
            irec = irec + 1
            write(jrelS,rec=irec) ( nstore(i), i = 1 , nnx )
  700       continue
  800 continue

      return
c
 9000 continue
      ier=1111
      return
      end
c--------------------------------------------------------------------------
      subroutine OpenFiles

      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      character*80 mapname
      character*80 line,namem,namef,nameout,nameold
      common/inptfile/iold,nameout,nameold
      common/four2/mapname,iftrue
c
c     write(6,*)'   ****  Open Files *****'

      nlenM = np(1)*nlenBin/knwr
c     print*,nlenBin,knwr,nlenM

      line=path(2)
      ii = lung ( line )
      namem=fname(6)
      k = index ( namem, '.',.TRUE. )

*---- direct access files
      itype=0
      namef = namem(1:k) // 'enve'
      kop=kopen(jrelE,namef,nlenM,itype,ier)
      if (kop.lt.0) goto 9000

      if (knw.gt.0) then
        itype=0
        namef=namem
        ii = lung ( mapname )
        if (ii.gt.1) namef=mapname
        kop=kopen(jrelT,namef,nlenM,itype,ier)
        if (kop.lt.0) goto 9000

        namef = namem(1:k) // 'enveT'
        itype=0
        kop=kopen(jrelET,namef,nlenM,itype,ier)
        if (kop.lt.0) goto 9000
      else
        jrelT=0
        jrelET=0
      endif

      namef = namem(1:k) // 'dumm'
      itype=0
      kop=kopen(jrelSK,namef,nlenM,itype,ier)
      if (kop.lt.0) goto 9000

      return

 9000 continue
      write(lo,9010) ier
      ier=-1
      return
 9010 format(' *** error *** open error on sequential files , code ='
     *,i5)
      end

*---------------------------------------------------------------------
      subroutine prepeqv

      USE General
      USE Symmetry
      common /cent/ tl(3,4),fs(3,3,24),mlat

c     halve y-axis by c.of.s. or lattice type if possible
      ihalf=0
      if (icent.eq.1) ihalf=-1
      if (ihalf.ne.0) goto 888
      goto (888,886,888,886,886,886,888), latt
  886 ihalf = 1
  888 call centre (1,1)
c     expand to full space group symmetry
c     put centring translations in tl(i,j)
      go to (940,890,890,890,890,910,920),latt
  890 call centre(2,latt)
      go to 940
  910 call centre(2,2)
      call centre(3,3)
      call centre(4,4)
      go to 940
  920 call centre(2,6)
      call centre(3,7)
c 940 do 1000 i=1,neqv
  940 do 1000 i=1,nsym
      do 970 j=1,3
      do 950 k=1,3
      fs(k,j,i)=0.0
  950 continue
      do 960 k=1,2
      m=iabs(ismat(k,j,i))
      if(m.gt.0) fs(m,j,i)=float(isign(1,ismat(k,j,i)))
  960 continue
  970 continue
      if (i.eq.1.or.ihalf.ne.0) goto 1000
c     halve y-axis by symmetry op. if possible
      do 980 j=1,3
      if (iabs(ismat(1,j,i)).ne.j.or.ismat(2,j,i).ne.0) goto 1000
  980 continue
      if(ismat(1,2,i).eq.(-2).and.abs(tsmat(2,i)).lt.1e-6) ihalf= -1
      if(ismat(1,2,i).eq.2.and.abs(tsmat(2,i)-0.5).lt.1e-6) ihalf=1
 1000 continue
c     nsym=neqv*(icent+1)*mlat
      nsymTot=nsym*(icent+1)*mlat

      return
      end
c--------------------------------------------------------------------------
      subroutine getheavy(ier)


      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
      character*2 dire, diret,spa
      character*80 line
      dimension  vet(40), ivet(40)

*gl*  call srlin (13,lsn,lixx,ljxx,lkxx,llxx)
      lixx = InfoOK(13)
c     if(lixx.gt.0.and.jderi.gt.0) call mod03(201)
      if(lixx.gt.0.and.jderi.gt.0) call mod03
      call prepeqv

      if ( jpfile.le.0) then
!        call srlin (15,lsn,lfw,llw,lpb,ll)
!        if (lfw.gt.0) then
         if (InfoOK(15) == 1) then
*gl*        call sfl15(interp)  !!gl
            call PutGetXyzs(2, interp)
            numset = numbrun
            goto 30
         else
            return
         endif
      endif 
      nats=1
 50   read(jpfile,'(a)',end=26) line
      call lcase (line)
      call shift(line,lenp)
      call cutst(line,lens,dire,lend)
      spa=dire(1:2)
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if(iopt.lt.0) write(6,*) 'error iopt'
      xyzs(1,nats)=vet(1)
      xyzs(2,nats)=vet(2)
      xyzs(3,nats)=vet(3)
      xyzs(4,nats)=vet(4)
      xyzs(5,nats)=vet(5)
      bfac(nats)=vet(4)
      do 15 j=1,nk
        write(diret,'(a2)')nalf(j)
        if(spa.eq.diret) nz(nats)=100+j
  15  continue
      nats=nats+1
      goto 50

  26  nats=nats-1
      numbrun = numset
*gl*  call frm15(interp)  !!gl
      call PutGetXyzs(1, interp)

  30  continue
      write(lo,'(//)')
      write(lo,100)
      do 40 i=1,nats
c        itp=iabs(nz(i)/100)
         itp=iabs(nz(i))
         if (itp.le.0) goto 40
         itp=nalfd(itp)
         write(lo,200) itp,i,xyzs(5,i),bfac(i),(xyzs(j,i),j=1,3)
 40   continue
      write(lo,'(//)')
 100  format(23x,'Heavy atoms positions',/,25x,
     *       'Occ',7x,'Bfac',7x,'x',9x,'y',9x,'z')
 200  format(4x,'Atom ',a2,i4,5x,5f10.4)

c     if (jderi.gt.0)call mod03(1)
      if (jderi.gt.0)call mod03

      return
      end
*---------------------------------------------------*
      integer function numestref (smax)
 
      USE General
      USE Symmetry

      integer hmax,hmin,kmax,kmin,lmax,lmin
      
      
      rmax=sqrt(1.0/smax)
      hmax=int(cell(1)/rmax)
      kmax=int(cell(2)/rmax)
      lmax=int(cell(3)/rmax)

      hmin=-hmax
      kmin=-kmax
      lmin=-lmax

      num=0
 
      do 300 ih=hmin,hmax
         do 200 ik=kmin,kmax
            do 100 il=lmin,lmax

*---           Eliminando (-h,-k,0) ---*
*---           Eliminando (-h, k,0) ---*
*---           Eliminando ( 0,-k,0) ---*

               if ( ih.lt.0 .and. il.eq.0 ) goto 100
               if ( ih.eq.0 .and. ik.lt.0 .and. il.eq.0 ) goto 100
               if ( ih.eq.0 .and. ik.eq.0 .and. il.eq.0 ) goto 100

               s=4.0*rhof(pp,ih,ik,il)**2
               if (s.gt.smax) goto 100

               num=num+1

100         continue
200      continue
300   continue

      numestref=num

      return
      end
*----------------------------------------------------------*
      subroutine getsetflex

      USE General
      USE Symmetry
      USE Grafici
      USE Riflessi
      USE Molcom
      USE PhaseModule
      USE Param

      character*200,strLog
      common /conue/ shi(4),ishi,shi1(4)
      common /misc/ t(3,3),dxmax(3),ishift(3,19)
**    dimension cfom(2250),ipos(302)
c     common/soglie/sogres,sogw,sogres2,soge
c
c     examine sets of phases in order of combined figure of merit unless
c     set is specified by the user
c
c     print*,'SogRes=',sogres,sogres2
c     print*,'SogWt=',sogw
c     print*,'Soge=',soge
c     print*,'Soge2=',soge2
c     print*,'list=',ilistFlex
c     print*,'numset=',numset
      wt(:)=0.0
      iphaz(:)=0

      if (ilistFlex==0) ilistFlex=16
      if (ilistFlex.gt.0) then
*gl*     call srlin (ilistFlex,lsn,lfw,llw,lpb,ll16)
         lfw = InfoOK(ilistFlex)
         if (lfw.lt.0) then
             write(lo,140) ilistFlex
             ier=-1
             return
          endif
      else
*gl*     call srlin (17,lsn,lfw,llw,lpb,ll16)
         lfw = InfoOK(17)
         if (lfw.gt.0) then
           ilistFlex=17
           numb=nrefl
         else
           ilistFlex=16
*gl*       call srlin (16,lsn,lfw,llw,lpb,ll16)
           lfw = InfoOK(16)
           if (lfw.lt.0) then
              write(lo,140) ilistFlex
              ier=-1
              return
           endif
         endif
      endif
      if (ilistFlex.eq.17) then
*gl*      call sfl17()
          call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                         nsetFinalPhases)
      else
*gl*      call ysfl16(cfom,ipos,nset)
          call LoadInitialPhases(cfom, ipos, nset)
      endif
      xtrialPhase(1:nset)=ipos(1:nset)
      cfomPhase(1:nset)=cfom(1:nset)
      nsetTotal=nset
  140 format(/,' *** error ***  no sets of phases available for list',
     * i4)
      if (numset.ge.1000) numset=nset-(numset-1000)
      if (numset.gt.0.and.numset.le.nset) goto 170
      if (numset.gt.0.and.numset.gt.nset) then
          write(lo,150) numset,nset
          ier=-1
          return
      endif
  150 format(/,' *** error ***  set ',i3,' has been required',/,
     *         '                but only ',i3,' sets are available')
      npos = 1
      do 160 j=1,nset
        if (cfom(j) .gt. cfom(npos)) npos = j
  160 continue
c     mark selected set
      cfom(npos) = cfom(npos)-100.0
      if (ilistFlex.eq.17) then
*gl*      call sup17(nsetm)
          call UpdateFinalPhases(FomsFineDSR, iposFineDSR, nsetm)
      elseif (ilistFlex.eq.16.or.ilistFlex.eq.0) then
*gl*      call ysup16(cfom,ipos,nset)
          call UpdateInitialPhases(cfom, ipos, nset)
      end if
c   select set
  170 if (numset.gt.0) then
          noset=numset
          nono=ipos(numset)
      else
          noset=npos
          nono=ipos(npos)
      endif
      numset = noset
      if (ilistFlex.eq.17) then
*gl*     call snr17o(nono,fom,wt,iphaz)
         call GetFinalPhases(nono, fom, wt, iphaz)
      elseif (ilistFlex.eq.16.or.ilistFlex.eq.0) then
*gl*    call snr16(nono,fom,wt,iphaz)
        call PutGetInitialPhases(2, nono, fom, wt, iphaz)
      end if

      do 200 ii = 1 , nrefl

         dres=0.5/sqrt(rhov(ii))
         if (dres < sogres) wt(ii)=0.0
         if (dres > sogres2) wt(ii)=0.0

c        if (dres > sogres2) then
c           iphaz(ii)=ipub(ii)
c           wt(ii)=wt(ii)*1.8
c           wt(ii)=min(1.0,wt(ii))
c        endif
c        if (dres < sogres) iphaz(ii)=ipub(ii)

         if (wt(ii).lt.sogw) wt(ii)=0.0
         if (evet(ii).lt.soge) wt(ii)=0.0
         if (evet(ii).ge.soge2) wt(ii)=0.0

c       if (knw > 0.and. wt(ii) > 0) then
c         aa=cos((iphaz(ii)-ipub(ii))*dtor)
c         aa=max(0.01,aa)
c         aa=min(1.0,aa)
c         wt(ii)=aa
c       endif
        if (inobs(ii).gt.0) goto 200

 200  continue

 1000 format(3i4,10f9.2)

      select case (ianom)

      case (3)

      write(ktml,'(" -->"," Trial=",i3," CFOM<sub>MIR</sub>=",f8.2,/)')
     *                    nint(fom(10)),fom(6)
        if (ifPDB == 0) then
            write(strLog,'("<b>Current Trial=",i3,
     *           " CFOM<sub>MIR</sub>=",f6.2,"</b>")')
     *                    nint(fom(10)),fom(6)
        else
            write(strLog,'("<b>Substructure from ",a,"</b> ")')
     *            PDBfile(1:lPDB)
        endif

      case (6)

      write(ktml,'(" -->"," Trial=",i3," CFOM<sub>MAD</sub>=",f8.2,/)')
     *                    nint(fom(10)),fom(6)
        if (ifPDB == 0) then
            write(strLog,'("<b>Current Trial=",i3,
     *           " CFOM<sub>MAD</sub>=",f6.2,"</b>")')
     *                    nint(fom(10)),fom(6)
        else
            write(strLog,'("<b>Substructure from ",a,"</b> ")')
     *            PDBfile(1:lPDB)
        endif

      case (9)

      write(ktml,'(" -->"," Trial=",i3,
     *             " CFOM<sub>MIRAS</sub>=",f8.2,/)')
     *             nint(fom(10)),fom(6)
        if (ifPDB == 0) then
            write(strLog,'("<b>Current Trial=",i3,
     *           " CFOM<sub>MAS</sub>=",f6.2,"</b>")')
     *                    nint(fom(10)),fom(6)
        else
            write(strLog,'("<b>Substructure from ",a,"</b> ")')
     *            PDBfile(1:lPDB)
        endif

      end select

c     if (kscreen > 0) then
c       if (inBoxGr(3) >0) then
c         nLinesGR=nLinesGRsaveBox(3)
c       else
c         nLinesGRsaveBox(3)=nLinesGR
c       endif
c     
c       call TestoGR(strLog, color_LIGHTRED, 2, 3)
c     endif


      if (knw.gt.0) then
         call esamin(khl,mkang,ipub,iphaz,nrefl,1,wtt1,wt,
     *             errm1,errmw1,nref1,shi1)
         do i=1,nrefl
           nh1=khl(1,i)
           nk1=khl(2,i)
           nl1=khl(3,i)
           iphaz(i)=shi1(4)*iphaz(i)-360.*(nh1*shi1(1)+nk1*shi1(2)+
     *             nl1*shi1(3))
           iphaz(i)=mod(iphaz(i)+3600,360)
           if (iphaz(i).le.0) iphaz(i)=360+iphaz(i)
         enddo
c        call statres
      endif
      ! starting set (per la combinazione) 
      iphad(:)=iphaz(:)
      wtd(:)=wt(:)
      ! ciclo precedente
      iphi2_in(:)=iphaz(:)
      wtt_in(:)=wt(:)

      iphi2_o(:)=iphaz(:)
      wtt_o(:)=wt(:)

      call toflush()

**    call flush(ktml)

      return
      end

*----------------------------------------------------------*
      subroutine MemSetflex

      USE General
      USE Symmetry
      USE Riflessi
      Use Mappa
      Use MapTest
      USE PhaseModule
      USE Param

      common /conue/ shi(4),ishi,shi1(4)
      common /misc/ t(3,3),dxmax(3),ishift(3,19)

**    dimension cfom(500),ipos(500)
      dimension fom17(11)

c--- memorizare in lista 17

c     write(lo,*)'Memorize SET'

      errm1=0.0
      errmw1=0.0
      if (knw.gt.0) then
       call esamin(khl,mkang,ipub,iphaz,nrefl,1,
     *             wtt1,wt,errm1,errmw1,nref1,shi1)
        if (ifcorr.eq.1) then
          fcoef(:)=wt(:)*fovet(:)
          call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK)
          call mapcorr(xmap,xmapT,corr)
        endif
      endif

c     print*,'list=',ilistFlex

      if (ilistFlex==0.or.ilistFlex==16) then
*gl*    call srlin (16,lsn,lfw,llw,lpb,ll)
        lfw = InfoOK(16)
        if (lfw <=0) then
           nsetm=1
           cfom(1)=1.0
           ipos(1)=1
           nSetsMaxFineDSR = nsetm
*gl*       call nfrm17()
*gl*       call sup17(nsetm)
           call ManageFinalPhases(1, nreflDim, nsem)
           call UpdateFinalPhases(FomsFineDSR, iposFineDSR, nsetm)
*gl*       call sfl17()
           call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                          nsetFinalPhases)
           numset=1.0
        else
*gl*      call ysfl16(cfom,ipos,nsetm)
          call LoadInitialPhases(cfom, ipos, nsetm)
*gl*      call srlin (17,lsn,lfw,llw,lpb,ll)
          lfw = InfoOK(17)
          if (lfw <= 0) then
            nsetm17=(nrsetMax - nrsetMin) + 1
            nSetsMaxFineDSR = nsetm17
*gl*        call nfrm17()
            call ManageFinalPhases(1, nreflDim, nsetm17)
*gl*        call sfl17()
            call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                           nsetFinalPhases)
*gl*        call sup17(nsetm17)
            call UpdateFinalPhases(FomsFineDSR, iposFineDSR, nsetm17)
          endif
          ! la lista17 ora e' usato solo per il flex
c         call sfl17()
c         nsetm17=nSetsFineDSR
c         iposFineDSR(numset)=ipos(numset)
c         call ysup17(nsetm17)
          nsetm17=(nrsetMax - nrsetMin) + 1
          nsetm17=1
          nSetsMaxFineDSR = nsetm17
*gl*      call nfrm17()
          call ManageFinalPhases(1, nreflDim, nsetm17)
*gl*      call sfl17()
          call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                         nsetFinalPhases)

!-!
!-! PEZZA Gianluca 14 marzo 2017
!-!
          numset = 1
!-!

          iposFineDSR(numset)=numset
*gl*      call sup17(nsetm17)
          call UpdateFinalPhases(FomsFineDSR, iposFineDSR, nsetm17)
        endif
      else
*gl*    call sfl17()
        call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                       nsetFinalPhases)
      endif

      nono=iposFineDSR(numset)
      
      !fom(5) --> CFOM 
      fom(5)=cfom_FLEX
      if (knw > 0) then
        fom(7)=errm1
        fom(8)=errmw1
        fom(9)=corr
      endif


      if (nono > 0) then
*gl*      call snw17o(nono,fom,wt,iphaz)
          call PutFinalPhases(nono, fom, wt, iphaz)
      endif

      return
      end
