!-----------------------------------------------------------------------
!--routine da GEOM.f
!-----------------------------------------------------------------------
code for zmatr_new
      subroutine zmatr_new(ier)
c--calcola coordinate locali dai valori espressi nella z-matrix
c
      USE General
      USE ZMatrix
c
      dimension xortol(3,500) 
      dimension amat(9,9),dmat(9),INDX(9),v(3,3)
      dimension aa(3,3),w(3),bb(3,3),ww(3,3),www(3)
      dimension x11(3),x1(3),x2(3),rr(3,3)
      double precision sintheta, costheta,sinphi,cosphi,sinpsi,cospsi
      double precision rrd(3,3)
c
c--nzm e' il numero di atomi nella sequenza descritta dalla Z-matrix
c--Esempio:
c-- i  iloc(i)   nloc(1,i)  xloc(1,i)  nloc(2,i)  xloc(2,i) nloc(3,i)  xloc(3,i)
c-- 1    3         0         0           0          0.0       0         0.0
c-- 2    2         3         1.54        0          0.0       0         0.0
c-- 3    5         2         1.5         3         120.0      0         0.0
c-- 4    8         5         1.52        2         122.0      3        210.0
c-- in questo caso nzm=4
c-- nzm,iloc,nloc,xloc devono essere note                          
c--xortol e xortolocal sono le coordinate ortonormali locali 
c--calcolate a partire dalle precedenti
c--xortol e' la coordinata locale dell'i-esimo atomo nella sequenza Z-matrix
c--xortolocal e' la coordinata locale dell' atomo nella mappa, corrispondente
c--all'i-esimo atomo nella sequenza Z-matrix
c--xor e' l'origine del sistema di riferimento, ossia la posizione
c--del penultimo atomo nella sequenza della Z-matrix nel sistema cristallino
c
      ier=0
      itest=0
      do i=1,nzm
	  iesz(i)=0
      enddo
c--coordinate dell'atomo 1 origine
	k=1
	k1=iloc(k)
      xortol(1,k)=0.0
      xortol(2,k)=0.0
      xortol(3,k)=0.0
      xortolocal(1,k1)=xortol(1,k)
      xortolocal(2,k1)=xortol(2,k)
      xortolocal(3,k1)=xortol(3,k)
      iesz(k1)=1
c--coordinate degli atomi seguenti da 2-->nzm
      do icard=2,nzm
	  i=iloc(icard)
	  j=nloc(1,icard)
        k=nloc(2,icard)
	  l=nloc(3,icard)
        r=xloc(1,icard)
	  theta=xloc(2,icard)
        phi=xloc(3,icard)
c        write(lo,'(4i5,3f10.3)')i,j,k,l,r,theta,phi
	  select case (icard)
	    case(2) 
	      call coordinate_ij   ( xortol, i, j,       r,        "x" )
          case(3)
            call coordinate_ijk  ( xortol, i, j, k,    r, theta, "y" )
          case default
	      call coordinate_ijkl ( xortol, i, j, k, l, r, theta, phi )
        end select
      enddo
      do ja=1,nzm
c        write(lo,60)ja, (xortol(n,ja),n=1,3)
   60   format(i5,3f10.5)
        xortolocal(1:3,ja)=xortol(1:3,ja)
      enddo
      if(itest.eq.1) then
        write(lo,*)' coordinate da Z-matrix attuali'
        do ja=1,nzm
          write(lo,60)ja, (xortolocal(n,ja),n=1,3)
        enddo      
      endif
      return
      end
!
code for zmatr_follow
      subroutine zmatr_follow(nordZ,ier)
c--calcola coordinate locali dai valori espressi nella z-matrix
c--(chiamata da fullrotamers in commonfiles.f)
      USE General
      USE ZMatrix
c
      dimension xortol(3,500) 
      dimension amat(9,9),dmat(9),INDX(9),v(3,3)
      dimension aa(3,3),w(3),bb(3,3),ww(3,3),www(3)
      dimension x11(3),x1(3),x2(3),rr(3,3)
      double precision sintheta, costheta,sinphi,cosphi,sinpsi,cospsi
      double precision rrd(3,3)
c
      ier=0
c--coordinate definite precedentemente fino all'atomo nordZ-1
      do ja=1,nordZ-1
        xortol(1:3,ja)=xortolocal(1:3,ja)
      enddo
c--coordinate degli atomi seguenti da nzm,nfin
      do icard=nordZ,nzm
	i=iloc(icard)
	j=nloc(1,icard)
      k=nloc(2,icard)
	l=nloc(3,icard)
      r=xloc(1,icard)
	theta=xloc(2,icard)
      phi=xloc(3,icard)
	call coordinate_ijkl ( xortol, i, j, k, l, r, theta, phi )
      enddo
      do ja=nordZ,nzm
        xortolocal(1:3,ja)=xortol(1:3,ja)
      enddo
      return
      end
!      
c--------------------------------------------------------------
code for coordinate_ij
      subroutine coordinate_ij (coordinates, i, j,       r,      option)
!-----------------------------------------------------------------
! subroutine coordinate_ij ( coordinates, i, j, r, option )
!-----------------------------------------------------------------
      dimension coordinates(3,500),direction(3)
	character*1  option
!
	do m=1,3
      coordinates(m,i)=0.0
	direction(m) =0.0
	enddo
! . Branch on the option.
      select case ( option )
c        case ( "r" ) ; direction = normalize ( random_vector ( 3 ) )
        case ( "x" ) ; direction(1) =  1.0 
        case ( "y" ) ; direction(2) =  1.0 
        case ( "z" ) ; direction(3) =  1.0 
        case default ; return
      end select
! . Calculate the coordinates of i.
      coordinates(1:3,i) = coordinates(1:3,j) + r * direction
      end subroutine coordinate_ij
c
code for coordinate_ijk  
      subroutine coordinate_ijk(coordinates, i, j, k,    r,theta,option)
!----------------------------------------------------------------------------
! subroutine coordinate_ijk ( coordinates, i, j, k, r, theta, option )
!----------------------------------------------------------------------------
      dimension coordinates(3,500),drlk(3),dra(3), drkj(3)
	character*1  option
!
! . Parameter declarations.
      pi     = 4.0 * atan(1.0)
      rtod   = 180.0 / pi
      dtor   = 1.0 / rtod
      to_radians = dtor
      small = 1.0e-9 
	do m=1,3
      coordinates(m,i)=0.0
	drlk(m) =0.0
	enddo
! . Branch on the option.
      select case ( option )
!        case ( "r" ) ; drlk    = normalize ( random_vector ( 3 ) )
        case ( "x" ) ; drlk(1) =  1.0 
        case ( "y" ) ; drlk(2) =  1.0 
        case ( "z" ) ; drlk(3) =  1.0 
        case default ; return
      end select
! . Calculate some trigonometric functions.
      cost = cos ( to_radians * theta )
      sint = sin ( to_radians * theta )
! . Calculate the jk displacement vector.
      drkj = coordinates(1:3,k) - coordinates(1:3,j)
! . Calculate the length of drkj.
      rkj = sqrt ( dot_product ( drkj, drkj ) )
! . Check that j and k are not too close.
      if ( rkj > small ) then
! . normalize drkj.
      drkj = drkj / rkj
! . Calculate the cross product of drlk and drkj.
      call cross_product ( drlk, drkj, dra )
! . Calculate the length of dra.
      ra = sqrt ( dot_product ( dra, dra ) )
! . Check the length of dra.
      if ( ra > small ) then
! . Normalize dra.
         dra = dra / ra
! . Calculate the cross product of drkj and dra (put in drlk).
         call cross_product ( drkj, dra, drlk )
! . Calculate the coordinate displacements (spherical polars).
         wa = r * cost
         wb = r * sint
! . Calculate the coordinates of i.
         coordinates(1:3,i) = coordinates(1:3,j) + wa*drkj + wb*drlk
      end if
      end if
      end subroutine coordinate_ijk
c
code for coordinate_ijkl
      subroutine coordinate_ijkl (coordinates, i, j, k, l, r, theta,phi)
!-----------------------------------------------------------------------------
! subroutine coordinate_ijkl ( coordinates, i, j, k, l, r, theta, phi )
!-----------------------------------------------------------------------------
      dimension coordinates(3,500),drlk(3),dra(3), drkj(3)
!
! . Parameter declarations.
      pi     = 4.0 * atan(1.0)
      rtod   = 180.0 / pi
      dtor   = 1.0 / rtod
      to_radians = dtor
      small = 1.0e-9
! . Initialize the coordinates for i.
	do m=1,3
        coordinates(m,i)=0.0
	  drlk(m) =0.0
	enddo
! . Check j, k and l.
!   IF ( ( j <= 0 ) .or. ( j > n ) .or. ( any ( coordinates(1:3,j) == undefined ) ) .or. &
!        ( k <= 0 ) .or. ( k > n ) .or. ( any ( coordinates(1:3,k) == undefined ) ) .or. &
!        ( l <= 0 ) .or. ( l > n ) .or. ( any ( coordinates(1:3,l) == undefined ) ) ) return
! . Calculate some trigonometric functions.
      cosp = cos ( to_radians * phi   )
      sinp = sin ( to_radians * phi   )
      cost = cos ( to_radians * theta )
      sint = sin ( to_radians * theta )
! . Calculate some displacement vectors.
      drkj = coordinates(1:3,k) - coordinates(1:3,j)
      drlk = coordinates(1:3,l) - coordinates(1:3,k)
! . Calculate the length of drkj.
      rkj = sqrt ( dot_product ( drkj, drkj ) )
! . Check that J and K are not too close.
      if ( rkj > small ) then
! . Normalize drkj.
      drkj = drkj / rkj
! . Calculate the cross product of drlk and drkj.
      call cross_product ( drlk, drkj,dra  )
! . Calculate the length of dra.
      ra = sqrt ( dot_product ( dra, dra ) )
! . Check the length of dra.
      if ( ra > small ) then
! . Normalize dra.
         dra = dra / ra
! . Calculate the cross product of drkj and ra (put in drlk).
      call cross_product ( drkj, dra, drlk )
! . Calculate the coordinate displacements (spherical polars).
         wa = r * cost
         wb = r * sint * cosp
         wc = r * sint * sinp
! . Calculate the coordinates of i.
         coordinates(1:3,i) = coordinates(1:3,j) + wa * drkj 
     2	   + wb * drlk + wc * dra
      end if
      end if
      end subroutine coordinate_ijkl
!------------------------------
      subroutine cross_product ( a, b, c )
!------------------------------
      dimension a(3),b(3),c(3)
! . Function declarations.
!      real ( kind = dp ), dimension(1:3) :: cross_product

! . Array arguments.
!      real , dimension(1:3), intent(in) :: a, b, c
! . Calculate the cross product a x b.
      c(1) = a(2) * b(3) - a(3) * b(2)
      c(2) = a(3) * b(1) - a(1) * b(3)
      c(3) = a(1) * b(2) - a(2) * b(1)
      end subroutine cross_product
!-----------------------------------------------------------------------
code for m1m3
      subroutine m1m3 (udm,tdm)
      dimension udm(9), tdm(3,3)
      do i = 1,3
         do j= 1,3
            k = (i-1)*3+j
            tdm(i,j) = udm(k)
         enddo
      enddo
      return
      end
c
code for m3m1
      subroutine m3m1(tdm,udm)
      dimension tdm(3,3),udm(9)
      do i=1,3
      do j=1,3
      k = (i-1)*3+j
      udm(k) = tdm(i,j)
      enddo
      enddo
      return
      end
c
code for newfr
      subroutine newfr(vr,gd,grr,ox,oy,tm)
c--genera il nuovo sistema di riferimento
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension gd(3,3),grr(3,3),ox(3),oy(3),e1(3),e2(3),e3(3),
     *tm(3,3),wr(3),e2r(3),w(3)
c--
      call normer(ox,gd,e1)
      call prodv(vr,gd,grr,ox,oy,wr,w)
      call normer(w,gd,e3)
      call prodv(vr,gd,grr,e3,e1,e2r,e2)
      do 5 j=1,3
      tm(1,j)=e1(j)
      tm(2,j)=e2(j)
      tm(3,j)=e3(j)
    5 continue
      return
      end
!-----------------------------------------------------------------------
code for normer
      subroutine normer(vt,am,vtn)
c**normalizzazione di un vettore
      dimension vt(3),am(3,3),vtn(3)
c
      vtvt=0.0
      do i=1,3
      do j=1,3
      vtvt=vtvt+vt(i)*vt(j)*am(i,j)
      enddo
      enddo
      if(vtvt.le.0.0) then
      do i=1,3
      vtn(i)=0.0
      enddo
      return
      endif
      cost=sqrt(vtvt)
      do i=1,3
      vtn(i)=vt(i)/cost
      enddo
      return
      end
!-----------------------------------------------------------------------
code for prodv
      subroutine prodv(dt,am,ar,v1,v2,vr3,v3)
c**calcola il prodotto vettoriale
      dimension v1(3),v2(3),v3(3),am(3,3),ar(3,3),vr3(3)
c
      do i=1,3
      call seq(i,j,k)
      vr3(i)=(v1(j)*v2(k)-v1(k)*v2(j))/dt
      enddo
      call vrgv(vr3,ar,v3)
      return
      end
c
code for vrgv
      subroutine vrgv(ve,c,vu)
c**moltiplicazione di una matrice 3x3 ed un vettore a 3
c  componenti
      dimension ve(3),c(3,3),vu(3)
c
      do i=1,3
      vu(i)=0.0
      do j=1,3
      vu(i)=vu(i)+c(i,j)*ve(j)
      enddo
      enddo
      return
      end
c
code for seq
      subroutine seq(i,j,k)
c--
      j=mod(i,3)+1
      k=mod(i+1,3)+1
      end
c
code for orcor
      subroutine orcor(xo,yo,zo,c,xn,yn,zn)
c**fornisce le coordinate atomiche ortogonalizzate
      dimension c(3,3)
c
      xn=c(1,1)*xo+c(1,2)*yo+c(1,3)*zo
      yn=c(2,1)*xo+c(2,2)*yo+c(2,3)*zo
      zn=c(3,1)*xo+c(3,2)*yo+c(3,3)*zo
      return
      end
!-----------------------------------------------------------------------
      subroutine moltm(b, d, w)
        dimension b(3,3), d(3,3), w(3,3)
c
c ---  matrix * matrix
c
      do 30 i = 1 , 3
         do 20 j = 1 , 3
            dum = 0
            do 10 k = 1 , 3
               dum = dum + b(i, k) * d(k, j)
   10       continue
            w(i, j) = dum
   20    continue
   30 continue
c
      return
      end
!-----------------------------------------------------------------------
      subroutine moltv(b, d, w)
        dimension b(3,3), d(3), w(3)
c
c ---  matrix * matrix
c
      do 30 i = 1 , 3
            dum = 0
            do 10 k = 1 , 3
               dum = dum + b(i, k) * d(k)
   10       continue
            w(i) = dum
   30 continue
c
      return
      end
!-----------------------------------------------------------------------
code for OrtoGru
      subroutine OrtoGru(ncard,ResMatIn,ResMatOut,loo,lx,ly,NRdim)
c-- ortogonalization
c  t_ortho(3,3) matrice di trasformazione da spazio cristalino a
c               spazio di riferimento ortonormale monometrico del modello
c  t_cryst(3,3) matrice di trasformazione da spazio di riferimento
c              ortonormale monometrico del modello a spazio cristallino
c
      USE General
      USE BigStore
      USE Liste
      USE Plotter
      USE ZMatrix
!
      dimension ResMatIn(3,NRdim),ResMatOut(3,NRdim)
c--
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workb/hhh(3),ux(3),uy(3),uz(3),ncom,nstep,icomb(12)
      dimension ox(3),oy(3),tmt(3,3),tb(3,3),d(3,3)
      dimension x1(3),xr(3),x0(3)
c--
      itest=0
      pis4=4*twopis
c inizio shift coordinate atomiche
      x0(1:3)=ResMatIn(1:3,loo)
      do ja=1,ncard
         ResMatOut(1:3,ja)=ResMatIn(1:3,ja)-x0(1:3)
      enddo
c inizio setting asse x ed asse y
      ox(1:3)=ResMatOut(1:3,lx)
      oy(1:3)=ResMatOut(1:3,ly)
      call newfr(vr,gdd,grr,ox,oy,tm)
      do i=1,3
        do j=1,3
          tinv(i,j)=tm(i,j)
          d(i,j)=0.0
        enddo
      enddo
      call trasp(tm,t_cryst)
      ndim=3
      m=0
      call matin(tinv,ndim,d,m,det)
      call trasp(tinv,t_ortho)
c inizio trasformazione delle coordinate atomiche
      do ja=1,ncard
        x1(1:3)=ResMatOut(1:3,ja)
        call orcor(x1(1),x1(2),x1(3),t_ortho,xr(1),xr(2),xr(3))
c che vengono ricopiate sulla vecchia
        ResMatOut(1:3,ja)=xr(1:3)
      enddo
      return
      end
!-----------------------------------------------------------------------
