#include <utils.h>
#include "gtkmrnew.h"
#include "gtkmrcomune.h"
#include <gtkdefs.h>
#ifdef _WIN32
#include <windows.h>
#endif

extern char *lck_file;
extern int jscreen;
extern _Dialogo *dialogo;
extern "C" void exitsirprot_(int *ier, int *iCode);

extern "C" int kridisegna_(int *w, int *h, int *i);

gboolean delete_cb (GtkWidget *widget, GdkEvent *event, gpointer data)
{
    _drawarea *DrawingArea = (_drawarea *) data;
    GtkWidget *button = get_widget(DrawingArea->widget, "stop_button");
    if(gtk_widget_get_visible(button))
       gtk_button_clicked(GTK_BUTTON(button));
    else
       gtk_button_clicked(GTK_BUTTON(get_widget(DrawingArea->widget, "close_button")));
    return TRUE;
}

static gboolean on_configure_event (GtkWidget *widget, GdkEventConfigure *event,
                                        gpointer user_data)
{
    int w,h,i;

    gpointer pixmap;
    gpointer context;
    _drawarea *da = (_drawarea *)(get_object(widget, "struct"));
    os_and_gc *rt;

    GtkAllocation allocation;
    gtk_widget_get_allocation(widget, &allocation);
    w = (int)allocation.width;
    h = (int)allocation.height;
    if((MRabs(w - da->wPrevious)<= 2) && (MRabs(h - da->hPrevious) <= 2))
    {
        g_signal_stop_emission_by_name(G_OBJECT(widget), "configure_event");
        return TRUE;
    }

    if (get_object(widget, "context") != NULL)
        context = get_object(widget, "context");
    else
        context = NULL;
                                                                                
    if (get_object(widget, "offscreen") != NULL)
        pixmap = get_object(widget, "offscreen");
    else
        pixmap = NULL;
                                                                                
    destroy_os_and_gc(pixmap, context);
    rt = get_os_and_gc(widget);
    pixmap = rt->os;
    context = rt->gc;
    g_object_set_data(G_OBJECT(widget), "context", context);
    g_object_set_data( G_OBJECT(widget), "offscreen", pixmap);
    g_free(rt);
    da->outPix = pixmap;
    da->context = context;
    da->wPrevious = w;
    da->hPrevious = h;
    g_object_set_data(G_OBJECT(gtk_widget_get_toplevel(widget)), "currentPixmap", pixmap);
    g_object_set_data(G_OBJECT(gtk_widget_get_toplevel(widget)), "currentContext", context);
    g_object_set_data(G_OBJECT(gtk_widget_get_toplevel(widget)), "currentWindow", gtk_widget_get_window(widget));

/*  Clear window */

    if(context)
    {
    setta_foreground(da->backGround, context);
    draw_rectangle (pixmap, context, TRUE, 0, 0, w, h);

     if(da->primavolta)
        da->primavolta = FALSE;
     else
     {
        i = 1;
        kridisegna_(&w, &h, &i);
     }
     }
     return TRUE;
}

int MainLoop(_drawarea *DrawingArea, int flag)
{
         
         gtk_widget_hide( get_widget(DrawingArea->widget, "stop_button") );
         if (dialogo->ilMilione  < 2)
         {
             gtk_widget_hide( get_widget(DrawingArea->widget, "finish_button") );
             gtk_widget_hide( get_widget(DrawingArea->widget, "next_button") );
             gtk_widget_show( get_widget(DrawingArea->widget, "close_button") );
         }
         else
         {
             gtk_widget_show( get_widget(DrawingArea->widget, "finish_button") );
             gtk_widget_show( get_widget(DrawingArea->widget, "next_button") );
             gtk_widget_hide( get_widget(DrawingArea->widget, "close_button") );
         }

         gtk_main ();
         return 0;
}
     
void cExitSirprot(GtkButton *button, gpointer data)
{
    int iCode = GPOINTER_TO_INT(data);
    int ier = 0;
    FILE *fp;
    char *file1 = g_new0(char, MaxLenFilename);

    ScriviStringa(file1, MaxLenFilename, "%s",lck_file);
    fp = fOpen(file1, "w");
    if(dialogo->SirProtError == -1)
       fprintf(fp, "-1 0\n");
    else
       fprintf(fp, "%d 1\n", iCode);
    fclose(fp);
    if(iCode != -1)
    {
       gtk_main_quit();
       exit(0);
    }
     if(gtkext::dlg_yesno(NULL, "Do you want to interrupt running task?"))
       exitsirprot_(&ier, &iCode);
}
 
GtkWidget* open_window (int WINDWID, int WINDHEI, const char *title, _drawarea *DrawingArea)
{
  GtkWidget *main_window;
  GtkWidget *drawingarea;
  GtkWidget *vbox, *hbox, *button;

  main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  g_object_set_data (G_OBJECT (main_window), "mainwin", main_window);
  gtk_window_set_title (GTK_WINDOW (main_window), title);
  gtk_window_set_default_size(GTK_WINDOW (main_window), WINDWID, WINDHEI);

  vbox = vbox_new(FALSE, 0);
  gtk_container_add (GTK_CONTAINER (main_window), vbox);
  g_object_set_data (G_OBJECT (main_window), "vbox", 
              vbox);
  gtk_widget_show (vbox);

  drawingarea = gtk_drawing_area_new ();
  g_object_set_data (G_OBJECT (main_window), "drawarea", 
              drawingarea);
  gtk_box_pack_start (GTK_BOX (vbox), drawingarea, TRUE, TRUE, 0);
  g_object_set_data(G_OBJECT(drawingarea), "offscreen", NULL);
//mr090309  gtk_widget_set_size_request(drawingarea, WINDWID, WINDHEI); 
  gtk_widget_show (drawingarea);

  hbox = hseparator_new();
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
  gtk_widget_show(hbox);

  hbox = hbutton_box_new();
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 4);
  gtk_widget_show(hbox);
  gtk_button_box_set_layout (GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_END);
  gtk_box_set_spacing (GTK_BOX(hbox), 10);

//  button = gtk_button_new_from_stock ("gtk-stop");
  button = myimage_button ("_Stop", "stop.png");
  g_object_set_data( G_OBJECT(drawingarea), "stop_button", button);
  gtk_container_add(GTK_CONTAINER(hbox), button);
  gtk_widget_show(button);
  (void) g_signal_connect (G_OBJECT (button), "clicked",
              G_CALLBACK (cExitSirprot), GINT_TO_POINTER(-1));
//  button = gtk_button_new_from_stock ("gtk-close");
  button = myimage_button ("C_lose", "close.png");
  g_object_set_data( G_OBJECT(drawingarea), "close_button", button);
  gtk_container_add(GTK_CONTAINER(hbox), button);
  gtk_widget_hide(button);
  (void) g_signal_connect (G_OBJECT (button), "clicked",
              G_CALLBACK (cExitSirprot), GINT_TO_POINTER(0));
//  button = gtk_button_new_from_stock ("gtk-go-forward");
  button = myimage_button ("_Forward", "forward.png");
  g_object_set_data( G_OBJECT(drawingarea), "next_button", button);
  gtk_container_add(GTK_CONTAINER(hbox), button);
  gtk_widget_hide(button);
  (void) g_signal_connect (G_OBJECT (button), "clicked",
              G_CALLBACK (cExitSirprot), GINT_TO_POINTER(1));
//  button = gtk_button_new_from_stock ("gtk-cancel");
  button = myimage_button ("_Cancel", "cancel.png");
  g_object_set_data( G_OBJECT(drawingarea), "finish_button", button);
  gtk_container_add(GTK_CONTAINER(hbox), button);
  gtk_widget_hide(button);
  (void) g_signal_connect (G_OBJECT (button), "clicked",
              G_CALLBACK (cExitSirprot), GINT_TO_POINTER(2));

  (void) g_signal_connect (G_OBJECT (drawingarea), "configure_event",
                      G_CALLBACK (on_configure_event), NULL);

  (void) g_signal_connect (G_OBJECT (drawingarea), DRAW_EVENT,
                      G_CALLBACK (ManageExpose),
                      NULL);
  DrawingArea->widget = drawingarea;
  DrawingArea->wPrevious = 0;
  DrawingArea->hPrevious = 0;
  DrawingArea->backGround = dialogo->jBackGround;
  DrawingArea->primavolta = TRUE;
  DrawingArea->kscrx = WINDWID;
  DrawingArea->kscry = WINDHEI;
  g_object_set_data(G_OBJECT(drawingarea), "struct", DrawingArea);

  set_icon(main_window, program_ico);
  (void) g_signal_connect (G_OBJECT (main_window), "delete_event",
                      G_CALLBACK(delete_cb), (gpointer) DrawingArea);
  gtk_widget_show (main_window);
  DrawingArea->outWindow = gtk_widget_get_window(drawingarea);
  DrawingArea->outPix =  get_object(drawingarea, "offscreen");
  DrawingArea->context = get_object(drawingarea, "context");

  return main_window;
}

void CloseWindow(int *jscreen, int mainloop, _drawarea *da, int col)
{
   if(*jscreen)
   {
      *jscreen = 0;
      gtk_widget_destroy(gtk_widget_get_toplevel(da->widget));
   }
}

void PrimoParametro(char *string)
{
}

void SecondoParametro(char *string)
{
}

#if 0
#ifdef _WIN32
#if WINVER >= 0x0602
#include <Processthreadsapi.h>
#endif

extern "C" void lanciash_(char *shell_script)
{
   if(jscreen)
   {
      PROCESS_INFORMATION procInfo = {0};
      STARTUPINFO startupInfo = {0};
      SECURITY_ATTRIBUTES saAttr = {0};
      HANDLE hStdIn  = GetStdHandle(STD_INPUT_HANDLE);
      HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
      HANDLE hStdErr = GetStdHandle(STD_ERROR_HANDLE);
      std::string commandline;

      dir_set_current(g_path_get_dirname(shell_script));
      ChangeMode(shell_script, tXt);
      saAttr.nLength = sizeof(saAttr);
      saAttr.bInheritHandle = TRUE;
      saAttr.lpSecurityDescriptor = NULL;

      startupInfo.cb = sizeof(startupInfo);
      startupInfo.dwFlags = STARTF_USESTDHANDLES |  STARTF_USESHOWWINDOW;
      startupInfo.hStdInput = hStdIn;
      startupInfo.hStdOutput = hStdOut;
      startupInfo.hStdError = hStdErr;
      startupInfo.wShowWindow = SW_HIDE;
      commandline.assign ("cmd.exe /c \"");
      commandline.append(g_path_get_basename(shell_script));
      commandline.append("\"");

      wchar_t cmd[256];
      size_t l;
      mbstowcs_s(&l,cmd, commandline.c_str(),256);
      LPWSTR p = cmd;

      BOOL rc = CreateProcess(NULL, p, NULL, &saAttr, FALSE, 0, NULL, NULL,
          &startupInfo, &procInfo);
      if(!rc)
      {
         MessageDialog(NULL, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
            g_strdup_printf( "CreateProcess failed (%d).\n", GetLastError()));
         return;
      }
      WaitForSingleObject( procInfo.hProcess, INFINITE );
      CloseHandle( procInfo.hProcess );
      CloseHandle( procInfo.hThread );
      return;
   }
 
   GError *error=NULL;
   dir_set_current(g_path_get_dirname(shell_script));
   ChangeMode(shell_script, tXt);
   std::string commandline;
   commandline.assign(g_path_get_basename(shell_script));
   g_spawn_command_line_sync(commandline.c_str(), NULL, NULL, NULL, &error);
   if(error)
      g_warning ("Error spawning file: %s", error->message);
}
#else
extern "C" void lanciash_(char *shell_script)
{
      GError *error=NULL;
      dir_set_current(g_path_get_dirname(shell_script));
      ChangeMode(shell_script, tXt);
      std::string commandline;
#ifdef _WIN32
      commandline.assign(g_path_get_basename(shell_script));
#else
      commandline.assign("./");
      commandline.append(g_path_get_basename(shell_script));
#endif
      g_spawn_command_line_sync(commandline.c_str(), NULL, NULL, NULL, &error);
      if(error)
         g_warning ("Error spawning file: %s", error->message);
}
#endif

extern "C" void lanciash_nowait_(char *shell_script)
{
      GError *error=NULL;
      dir_set_current(g_path_get_dirname(shell_script));
      ChangeMode(shell_script, tXt);
      std::string commandline;
#ifdef _WIN32
      commandline.assign(g_path_get_basename(shell_script));
#else
      commandline.assign("./");
      commandline.append(g_path_get_basename(shell_script));
#endif

//180514      g_spawn_command_line_async(shell_script, &error);
      g_spawn_command_line_async(commandline.c_str(), &error);
      if(error)
         g_warning ("Error spawning file: %s", error->message);
}

extern "C" void makeexec_(char *shell_script)
{
      ChangeMode(shell_script, tXt);
}
#endif

