      subroutine PlotLSQCycle(strHead,xplot,yplot,npunti,xgrid,ngrid)

      USE General
      USE Grafici
      USE Molcom

      character ::strHead(3)*80
      real      ::xplot(npunti)
      real      ::yplot(npunti)
      common/OldPlot/xmax_old,ymin_old,ymax_old

       xmax=float(npunti) +1.0
        
       if (npunti==1) then
         ymin=0.0
         ymax=100.0
         ymin_old=0.0
         ymax_old=100.0
         xmax_old=xmax
       else
         ymin=nint(minval(yplot(1:npunti)))
         ymax=nint(maxval(yplot(1:npunti)))
         if (ymin > 0.0) then
           ymin=nint(ymin -0.05*ymin)
           ymin=max(ymin,0.0)
           if (ymin < 15.0) ymin=5.0
           if (ymin < 5.0) ymin=0.0
         else
           ymin=nint(ymin -0.05*ymin)
         endif
         ymax=nint(ymax +0.05*ymax)
       endif

       xmax_old=xmax
       ymin_old=ymin
       ymax_old=ymax


       rxmax=float((npunti+1)/10)
       if (rxmax < 1.) rxmax=1.0


       if (kscreen > 0) then
        HistoOK(1)=1
        StringGR(1,1) = 'Cycle'
        StringGR(1,2) = ''
        LegendGR(1) = 'LSQ Refinement: R% vs cycle number'
        xpoints(1:npunti,1)=xplot(1:npunti)
        ypoints(1:npunti,1)=yplot(1:npunti)
        colorGR(1:npunti,1)=color_LIGHTRED
        lPlots(1)=npunti

c       MinMaxGR(1,1) = minval(xpoints(1:npunti,1))
c       MinMaxGR(2,1) = maxval(xpoints(1:npunti,1))

c       MinMaxGR(3,1) = minval(ypoints(1:npunti,1))
c       MinMaxGR(4,1) = maxval(ypoints(1:npunti,1))

        MinMaxGR(1,1) = 0.0
        MinMaxGR(2,1) = xmax

        MinMaxGR(3,1) = ymin
        MinMaxGR(4,1) = ymax
        QualeTic(1) = CheckTic(xmax, 1)
        if (ngrid > 0) then
         xpoints(ngrid,1)=xgrid
         ypoints(ngrid,1)=ymax
         colorGR(ngrid,1)= -1       ! linea verticale
        endif

        if (npunti > 1) then
          call ManageGraph(1,0)
          call zflush
          call DoSingleIteration()
        endif
       endif

      return
      end
c------------------------------------
       subroutine PlotCFOM(strHead,xplotI,yplotI,ndim1,ndim2,
     *                    npunti,nplots,iposMax,nCurrentSet,iMIR)


      USE General
       USE Grafici
       USE Molcom
     
       character ::strHead(3)*80
       real      ::xplotI(ndim1,ndim2)
       real      ::yplotI(ndim1,ndim2)
       real, allocatable ::xplot(:,:)
       real, allocatable ::yplot(:,:)
       real maxx

       if (npunti==0.or.nplots==0) return
       if (ndim1==0.or.ndim2==0) return

       allocate(xplot(ndim1,ndim2),yplot(ndim1,ndim2), stat=ierr)

c      print*,'Plot CFOM'
       xplot(:,:)=xplotI(:,:)
       yplot(:,:)=yplotI(:,:)

 10    continue

       xmin=nint(minval(xplot(1:1,1:npunti)))
       xmax=nint(maxval(xplot(1:1,1:npunti)))

       if (nCurrentSet==0) then
c        ymin=nint(minval(yplot(1:nplots,1:npunti)))
c        ymax=nint(maxval(yplot(1:nplots,1:npunti)))
         ymin=nint(minval(yplot(1:2,1:npunti)))
         ymax=nint(maxval(yplot(1:2,1:npunti)))
       else
        if (nplots==2) then
         ymin1=nint(minval(yplot(1:1,1:npunti)))
         ymax1=nint(maxval(yplot(1:1,1:npunti)))
         ymin2=yplot(2,nCurrentSet)
         ymax2=yplot(2,nCurrentSet)
         ymin=min(ymin1,ymin2)
         ymax=max(ymax1,ymax2)
        else
         ymin1=nint(minval(yplot(1:1,1:npunti)))
         ymax1=nint(maxval(yplot(1:1,1:npunti)))
         ymin2=minval(yplot(1:1,1:npunti))
         ymax2=maxval(yplot(1:1,1:npunti))
         ymin=min(ymin1,ymin2)
         ymax=max(ymax1,ymax2)
        endif
       endif


       ! questa per la Grafica, non per pgplot
c      if (ymax <= 1.0) then
c        yplot(:,1:npunti)=yplot(:,1:npunti)*10.
c        goto 10
c      endif

c      print*,'PLOTCFOM'
c      print*,npunti
c      print*,iposMax
c      print*,nCurrentSet
c      print*,nplots
c      print*,iMIR
c      print*,xmin,xmax
c      print*,ymin,ymax
c      print*,'PLOTCFOM'

     
       if (ymin > 0.0) then
         ymin=nint(ymin -0.05*ymin)
         ymin=max(ymin,0.0)-1.0
       else
         ymin=nint(ymin -0.05*ymin)
       endif
       ymax=nint(ymax +0.10*ymax)+1.0

c      print*,xmin,xmax
c      print*,ymin,ymax

       rxMax=1.0
       nxMax=0
       ryMax=float(nint((ymax-ymin)/6.0))
       nyMax=6

       if (kscreen > 0) then
          HistoOK(2)=1
          StringGR(2,1) = 'Trial'
          StringGR(2,2) = ''
          LegendGR(2) = strHead(3)

          lPlots(2) = lPlots(2) + 1

           if (iabs(iposMax) > 0 .and. lPlots(2) > 1) then 
               if (iMIR==0) then
                 jposMax = iabs(iposMax) * 2
                 if (iposMax > 0) jposMax = jposMax - 1
               else
                  jposMax = iposMax
               endif
           else
               if (iMIR==0) then
                  jposMax = 0
               else
                  jposMax = iposMax
               endif
           endif

           do i=1, npunti
              xpoints(lPlots(2),2)=i
              ypoints(lPlots(2),2)= yplot(nplots,i)
           enddo
           if (iMIR==0.or.iMIR==2) then
               do i=1, lPlots(2)
                  if (mod(i,2) == 0) then
                      colorGR(i,2)=color_GREEN
                  else
                      colorGR(i,2)=color_RED
                  endif
               enddo
           else
               colorGR(1:lPlots(2),2)=color_GREEN
           endif
           if (jposMax > 0) then
               colorGR(jposMax ,2) = colorGR(jposMax ,2) + 1000
           endif
           minx = 0.0
           maxx = npunti + 1

           ymin = minval(ypoints(1:lPlots(2),2))
           ymax = maxval(ypoints(1:lPlots(2),2))

           if (ymin > 0.0) then
            ymin=nint(ymin -0.05*ymin)
            ymin=max(ymin,0.0)-1.0
           else
            ymin=nint(ymin -0.05*ymin)
           endif
           ymax=nint(ymax +0.10*ymax)+1.0

           miny = ymin
           maxy = ymax
           
           MinMaxGR(1,2) = minx
           MinMaxGR(2,2) = maxx
           MinMaxGR(3,2) = miny
           MinMaxGR(4,2) = maxy
           QualeTic(2) = CheckTic(maxx, 2)
           call ManageGraph(2,0)
           call zflush
           call DoSingleIteration()
       endif

       deallocate(xplot,yplot, stat=ierr)
       return
       end
c----------------------------------
      subroutine PlotFlexCycle(xplot,yplot,ndim1,npunti,
     *           nplot,xgrid,ngrid,iend)

      USE Grafici
      USE Molcom

      character ::strHead(3)*80
      real      ::xplot(ndim1,npunti)
      real      ::yplot(ndim1,npunti)
      real      ::xgrid(ngrid)



      xmax=float(npunti) + 1.0
      if (npunti==1) then
       ymin=0.0
       ymax=maxval(yplot(1:nplot,1:npunti))
       ymax=nint(ymax +0.10*ymax) 
      else
       ymin=nint(minval(yplot(1:nplot,1:npunti)))
       ymax=nint(maxval(yplot(1:nplot,1:npunti)))
       ymax=nint(ymax +0.05*ymax) + 1.0
       if (ymin > 1.0) then
         ymin=nint(ymin -0.05*ymin)
         ymin=max(ymin,0.0) - 1.0
       else
         ymin=nint(ymin -0.05*ymin)
         ymin=0.0
       endif
      endif

c     if (iend==1.and.nplot==2) then
c        ymin=0.0
c        ymax=1.0
c     endif


      rxmax=float((npunti+1)/10)
      if (rxmax < 1.) rxmax=1.0
!      if (kscreen > 0.and.nplot==1) then
       if (kscreen > 0) then
         HistoOK(1)=1
         tipoGraficiGR(1) = 1
         LegendGR(1) = 'RealRfree% vs cycle number'
         LegendGR(1) = ''
         StringGR(1,1) = 'Cycle'
         StringGR(1,2) = ''
         ii=0
         do iplot=1,nplot
          do i=1,npunti
           ii=ii+1
           xpoints(ii,1)=xplot(1,i)
           ypoints(ii,1)=yplot(iplot,i)
           if (iplot==1) then
              colorGR(ii,1)=color_LIGHTRED
           elseif (iplot==2) then
              colorGR(ii,1)=color_LIGHTGREEN
           else
              colorGR(ii,1)=color_LIGHTBLUE
           endif
          enddo
         enddo
        lPlots(1)=ii
c       print*,ii
c       print*,xpoints(1:ii,1)
c       print*,ypoints(1:ii,1)
c       stop

        MinMaxGR(1,1) = 0.0
        MinMaxGR(2,1) = xmax

        MinMaxGR(3,1) = ymin
        MinMaxGR(4,1) = ymax
        QualeTic(1) = CheckTic(xmax, 1)

c       if (ngrid > 0) then
c        xpoints(ngrid,1)=xgrid
c        ypoints(ngrid,1)=ymax
c        colorGR(ngrid,1)= -1       ! linea verticale
c       endif

        if (ii > 1) then
          call ManageGraph(1,0)
          call zflush
          call DoSingleIteration()
        endif
       endif

      return
      end
c--------------------------------------------------------------------------
      subroutine PlotFlexInfo
      
      USE Grafici
      USE Molcom
      USE StrLogModule

      if (kscreen <=0) return
c     print*,inBoxGr(2),nLinesGR,nLinesGRsaveBox(2)
      if (inBoxGr(2) >0) then
        if (nLinesGRsaveBox(2) > 0) then
          nLinesGR=nLinesGRsaveBox(2)
        else
          nLinesGRsaveBox(2)=nLinesGR
        endif
      else
        nLinesGRsaveBox(2)=nLinesGR
      endif
      

      ! superCycle
      if (Lung(strLogS) > 0) then
        call OneBlankOnly(strLogS)
        call TestoGR(strLogS, color_GREEN, 2, 2)
      endif

      ! MacroCycle
      call OneBlankOnly(strLogMa)
      call TestoGR(strLogMa, color_GREEN, 2, 2)
      ! MicroCycle
      call OneBlankOnly(strLogMi)
      call TestoGR(strLogMi, color_GREEN, 2, 2)


      return
      end
c-------------------------------------
      subroutine PrePlotFlexCycle(ifconv,ifree,xplot,yplot,npunti,
     *                            xgrid,ngrid,iend)

      USE General

      character ::strHead(3)*80
      real      ::xplot(3,npunti)
      real      ::yplot(3,npunti)
      real      ::xgrid(ngrid)

      strHead(3)=''
      strHead(1)='Cycle'     


      select case (ifconv)
      case (0)
        strHead(2)='(%)RR\dfree\u'
      case (1)
        strHead(2)='(%)RR\dfree\u'
      case (2)
        strHead(2)='(%)R\dfree\u'
      case (3)
        strHead(2)='(%)FOM\Flex\u'
      end select
      
!     call PlotFlexCycle(strHead,xplot,yplot,3,npunti,1,
      call PlotFlexCycle(        xplot,yplot,3,npunti,1,
     *                   xgrid,ngrid,iend)


      if (ifree.eq.1.and.ifconv/=2) then
       strHead(2)='(%)R\dfree\u'
      else
       strHead(2)='(%)R\dtot\u'
      endif
!     call PlotFlexCycle(strHead,xplot,yplot,3,npunti,3,
      call PlotFlexCycle(        xplot,yplot,3,npunti,3,
     *                   xgrid,ngrid,iend)

      return
      end

c--------------------------------------------------------------------------
      subroutine PlotFreeLunchInfo
      
      USE Grafici
      USE Molcom
      USE StrLogModule

      if (kscreen <=0) return
c     print*,inBoxGr(2),nLinesGR,nLinesGRsaveBox(2)
      if (inBoxGr(3) >0) then
        if (nLinesGRsaveBox(3) > 0) then
          nLinesGR=nLinesGRsaveBox(3)
        else
          nLinesGRsaveBox(3)=nLinesGR
        endif
      else
        nLinesGRsaveBox(3)=nLinesGR
      endif
      
      
      ! MacroCycle
      call OneBlankOnly(strLogMa)
      call TestoGR(strLogMa, color_GREEN, 2, 3)
      ! MicroCycle
      call OneBlankOnly(strLogMi)
      call TestoGR(strLogMi, color_GREEN, 2, 3)


      return
      end
c--------------------------------------------------------------------------
      subroutine PlotCurrentCycleInfo(nstrings,strBoxTitle)

      USE Grafici
      USE Molcom
      USE PhaseModule
      USE Param
      USE StrLogModule

      character (len=200)    :: strBoxTitle

      if (kscreen <=0) return

      if (inBoxGr(4) >0) then
        nLinesGR=nLinesGRsaveBox(4)
      else
        nLinesGRsaveBox(4)=nLinesGR
      endif

c     strTemp='<b>EDM Parameters for the current Cycle:</b>'
!gl   call TestoGR(strBoxTitle, -1, 2, 4)
      call TestoGR(strBoxTitle, color_RED, 2, 4)
      call TestoGR('&', -1, 1, 4)

      do i=1,nstrings
       if (Lung(strInfo(i)) > 0 ) then
        iColor = strInfoC(i)
c       call TestoGR(strInfo(i), -1, 1, 4)
        call TestoGR(strInfo(i), iColor, 1, 4)
       endif
      enddo


      call zflush
      call DoSingleIteration()


      return
      end
!----------------------
      subroutine BackupGrafico(iAction,igrafB)
      Use Grafici


      if (iAction == 1) then
        npunti =lPlots(igrafB)
        StringGR(3,1)=StringGR(igrafB,1)
        StringGR(3,2)= StringGR(igrafB,2)
        LegendGR(3)= LegendGR(igrafB) 
        xpoints(1:npunti,3)= xpoints(1:npunti,igrafB)
        ypoints(1:npunti,3)= ypoints(1:npunti,igrafB)
        colorGR(1:npunti,3)= colorGR(1:npunti,igrafB)
        lPlots(3)= npunti
        MinMaxGR(1,3)= MinMaxGR(1,igrafB)
        MinMaxGR(2,3)= MinMaxGR(2,igrafB)
        MinMaxGR(3,3)= MinMaxGR(4,igrafB)
      else
        npunti =lPlots(3)
        StringGR(igrafB,1)=StringGR(3,1)
        StringGR(igrafB,2)= StringGR(3,2)
        LegendGR(igrafB)= LegendGR(3) 
        xpoints(1:npunti,igrafB)= xpoints(1:npunti,3)
        ypoints(1:npunti,igrafB)= ypoints(1:npunti,3)
        colorGR(1:npunti,igrafB)= colorGR(1:npunti,3)
        lPlots(igrafB)= npunti
        MinMaxGR(1,igrafB)= MinMaxGR(1,3)
        MinMaxGR(2,igrafB)= MinMaxGR(2,3)
        MinMaxGR(3,igrafB)= MinMaxGR(4,3)
      endif

      return
      end
