!-----------------------------------------------------------------------
      ! sigmaA routine
      ! Dritan : 28/06/2005
c--------------------------------------
      ! input:
      ! jsigma=1  <E2Ec2>
      ! jsigma=2  R(E2Ec2)
      ! jsigma=3  <E2-Ec2>
      ! jsigma=4  nel caso di FreeLunch (jsigma = -4)
      ! jsigma=5,6  nel caso di Fourier differenza
      ! jsigma< 0  Ec instead of Fc
      ! Fo ,sigFo,--> observed data
      ! rho --> (sinT/l)^2
      ! eps
      ! Fop2 & iphi2 wtt --> calculated data  (wtt can be also 1.0)
      ! iphi --> true phase
      ! iphi2o &  wto --> observed phase/weigth for combination (icombPh=1)
      ! nrefl1 --> number of reflection (observed)
      ! nrefSi --> number of reflection (incluse non-observed)
      ! ndim --> dimension for all the arrays
      ! output:
      ! wvar , m(pesMod) and D (Dluz)
      !
      subroutine sigmaA(jflag,fop1,sigfo,eobs1,itype,rho,epsv,fop2,
     *    iphi1,iphi2,wtt,iphi2o,wto,
     *    wvar,pesMod,Dluz,Eop,Ecp,
     *    ndim,nrefl1,nrefSi,icombPh,rf1,rf2,iprint)


      USE General
      USE Symmetry
c

      dimension fop1(ndim),sigfo(ndim),eobs1(ndim),fop2(ndim),
     *          rho(ndim),epsv(ndim),itype(ndim),wtt(ndim)
      dimension iphi1(ndim),iphi2(ndim),iphi2o(ndim)
      dimension Dluz(ndim),wvar(ndim),Eop(ndim),Ecp(ndim)
      dimension pesMod(ndim),wto(ndim)
c     real sim,atanh,siminv


      character *200 strTime
      real,     allocatable   :: RES(:),midpts(:),Eobs(:),Emodi(:)
      real,     allocatable   :: ee(:),sigEobs(:),wtnew(:)
      integer,  allocatable   :: RES_TAG(:),iphinew(:)
      real,     allocatable   :: Eo2Shell(:),Ec2Shell(:),Eo2Ec2Shell(:)
      real,     allocatable   :: Eo4Shell(:),Ec4Shell(:)
      real,     allocatable   :: SIGnShell(:),SIGpShell(:),SIGqShell(:)
      real,     allocatable   :: EpsShell(:),scEo2Shell(:),scEc2Shell(:)
      real,     allocatable   :: SIGMAAShell(:),SIGMAAShellsave(:),
     *                           SIGMAAeShell(:),SIGMAAccShell(:),
     *                           SIGMAAShell_l(:),
     *                           xfit(:),yfit(:),eeShell(:)
      real,     allocatable   :: cosErrShell(:),FacGSIMShell(:),
     *                           cosErrEShell(:),
     *                           cosErroShell(:),cosErrcShell(:),
     *                           cosErr12Shell(:)
      integer,  allocatable   :: nWtnShell(:),nWtoShell(:),
     *                           nWtcShell(:),nWt12Shell(:)
      real,     allocatable   :: wtnewShell(:),DluzShell(:),sig(:),
     *                           DluzShell_l(:),numbShell(:)
      real,     allocatable   :: shellTAB(:,:),wttShell(:),
     *                           sumDiffShell(:),sumFoShell(:),
     *                           rfacShell(:),
     *                           gsimShell(:),wtoShell(:),wtcShell(:)
      real,     allocatable   :: EomEcShell(:),SIGMAAnShell(:)
      real*8,     allocatable   :: r(:),drds(:)
   
      allocate(RES(nrefSi),RES_TAG(nrefSi),Eobs(nrefSi),Emodi(nrefSi),
     *         ee(nrefSi),sigEobs(nrefSi),wtnew(nrefSi),iphinew(nrefSi),
     *         stat=ierr)

      ! x dritan
      kmad=0
      !

c     iprint=1
      jsigmaa=iabs(jflag)

      if (iprint==1) then
        write(lo,*)'================================='
        write(lo,*)'=  sigmaA  routine',jflag,icombPh
        write(lo,*)'================================='
      endif

      sigAmed=0.0
      pesMod(:)=0.0
      Dluz(:)=0.0
      wvar(:)=0.0

      Eobs(:)=0.0
      Emodi(:)=0.0
      ee(:)=0.0
      sigEobs(:)=0.0
      wtnew(:)=0.0
      iphinew(:)=0

      RES(1:nrefSi)=sqrt(rho(1:nrefSi))

      Nbin=30
      Nstat=floor(nrefl1/float(Nbin))
      Nbin=8.0*alog10(0.05*float(max0(nrefl1,100))+0.5)
c

      allocate (Eo2Shell(Nbin),Ec2Shell(Nbin),Eo2Ec2Shell(Nbin),
     *         Eo4Shell(Nbin),Ec4Shell(Nbin),
     *         SIGnShell(Nbin),SIGpShell(Nbin),SIGqShell(Nbin),
     *         EpsShell(Nbin),scEo2Shell(Nbin),scEc2Shell(Nbin),
     *         eeShell(Nbin),midpts(Nbin),SIGMAAShell(Nbin),
     *         SIGMAAShellsave(Nbin),SIGMAAccShell(Nbin),
     *         SIGMAAShell_l(Nbin),xfit(Nbin),yfit(Nbin),
     *         cosErrShell(Nbin),FacGSIMShell(Nbin),
     *         wtnewShell(Nbin),DluzShell(Nbin),DluzShell_l(Nbin),
     *         sig(Nbin),shellTAB(Nbin,2),numbShell(Nbin),
     *         wttShell(Nbin),wtoShell(Nbin),sumDiffShell(Nbin),
     *         sumFoShell(Nbin),rfacShell(Nbin),
     *         cosErrEShell(Nbin),cosErroShell(Nbin),
     *         cosErr12Shell(Nbin),cosErrcShell(Nbin),
     *         nWtnShell(Nbin),nWtoShell(Nbin),
     *         nWtcShell(Nbin),nWt12Shell(Nbin),
     *         gsimShell(Nbin),
     *         SIGMAAeShell(Nbin),wtcShell(Nbin), 
     *         EomEcShell(Nbin), SIGMAAnShell(Nbin),
     *         r(Nbin),drds(Nbin), 
     *         stat=ierr)
c
c

      shellTAB(:,:)=0.0
      midpts(:)=0.0
      RES_TAG(:)=0
      call shells(shellTAB,midpts,RES_TAG,RES,nrefl1,Nbin,1) 

      Eo2Shell(:)=0.0
      Ec2Shell(:)=0.0
      Eo4Shell(:)=0.0
      Ec4Shell(:)=0.0
      Eo2Ec2Shell(:)=0.0
      SIGqShell(:)=0.0
      eeShell(:)=0.0
      scEo2Shell(:)=1.0
      scEc2Shell(:)=1.0
      SIGMAAShell(:)=0.0
      SIGMAAccShell(:)=0.0
      SIGMAAShellsave(:)=0.0
      SIGMAAeShell(:)=0.0
      SIGMAAnShell(:)=0.0
      SIGMAAShell_l(:)=0.0
      DluzShell(:)=0.0
      DluzShell_l(:)=0.0
      cosErrShell(:)=0.0
      cosErroShell(:)=0.0
      cosErr12Shell(:)=0.0
      cosErrcShell(:)=0.0
      cosErrEShell(:)=0.0
      FacGSIMShell(:)=0.0
      nWtnShell(:) = 0
      nWtoShell(:) = 0
      nWtcShell(:) = 0
      nWt12Shell(:) = 0
      wtnewShell(:)=0.0
      wttShell(:)=0.0
      wtoShell(:)=0.0
      wtcShell(:)=0.0
      sumDiffShell(:)=0.0
      rfacShell(:)=0.0
      sumFoShell(:)=0.0
      gsimShell(:)=0.0
      EomEcShell(:)=0.0

      ! calc sihP, sigQ & sigN for any shell

      if (iprint==1) then
       write(lo,*)'Nr riflessi obs:',nrefl1
       write(lo,*)'Nr riflessi nobs:',nrefSi - nrefl1
       write(lo,*)'Nr riflessi con Fc >0:',count(fop2(1:nrefSi) > 0.0)
       if (jflag > 0) then
        write(lo,*)'Nr riflessi con Fo >0:',count(fop1(1:nrefl1) > 0.0)
       else
        write(lo,*)'Nr riflessi con Eo >0:',count(eobs1(1:nrefSi) > 0.0)
       endif
       write(lo,*)'Nr riflessi con wt >0:',count(wtt(1:nrefSi) > 0.0)
      endif
      if (jflag > 0) then
c       sumFo=sum(fop1(1:nrefl1))
        sumFo=sum(fop1(1:nrefl1)*fop2(1:nrefSi))
        sumFc=sum(fop2(1:nrefSi)**2)
      else
        sumFo=sum(eobs1(1:nrefl1))
c       sumFo=sum(eobs1(1:nrefl1)*fop2(1:nrefSi))
        sumFc=sum(fop2(1:nrefSi))
      endif
c
      if (kmad == 0) then
            scaleFoFc=sumFo/sumFc
      else
            scaleFoFc = 1.0
      endif

      if (iprint==1) then
        if (jflag > 0) then
          write(lo,*)'scale(Fo,Fc):',scaleFoFc
        else
          write(lo,*)'scale(Eo,Ec):',scaleFoFc
        endif
      endif
      if (jflag > 0) then
        sumFo=sum(fop1(1:nrefl1))
      else
        sumFo=sum(eobs1(1:nrefl1))
      endif
c
c--regolo dumpPartial
c
      dumpPartial = 1.0
      if(jflag==5) then
        rhomax_obs=maxval(rho(1:nrefl1))
        resol=0.5/sqrt(rhomax_obs)
        if(resol>1.2) then
          if(ivolta==1) then
            if(sigmaold<0.50) then
              dumpPartial = 1.1
              if(sigmaold<0.45) dumpPartial = 1.2
            endif
          elseif(ivolta>=2) then
            if(sigmaold<0.50) then
              dumpPartial = 1.1
              if(sigmaold<0.45) dumpPartial = 1.3
            endif
          endif
!--caso di molti atomi dummy nel modello arp/warp (1xyg)
          if(abs(ifDEDM)>=2) then 
            if(sigPsigNOld>2.0) then 
              dumpPartial=1.3 
            endif
          endif
          if(iprint==1) then
            write(lo,*) 'dumpPartial A',dumpPartial,jflag,ivolta
          endif
        endif
      endif
c
      if (abs(ifDEDM) > 0) then
        if(sigPsigNOld<0.70) then
          dumpPartial = 1.1
          if(sigPsigNOld<0.60)  dumpPartial = 1.2
          if(sigPsigNOld<0.40)  dumpPartial = 1.3
        endif
        if(ivolta/=0.and.ivolta==nivolta.and.idritanD==0) 
     *          dumpPartial=dumpPartial+0.2 
c    *          dumpPartial=dumpPartial+0.3 
        if(iprint==1) then
          write(lo,*) 'dumpPartial B',dumpPartial,jflag,ivolta
        endif
      endif
c
      SIGnShell(:)=0.0
      SIGpShell(:)=0.0
      numbShell(:)=0.0

      sumDiff=0.0
      do i=1,nrefl1
         ii=RES_TAG(i)
         eps=epsv(i)*pts
         wref=2.0
         if (itype(i) > 1) wref=1.0
         numbShell(ii)=numbShell(ii) + wref
         SIGnShell(ii)=SIGnShell(ii) + wref*((fop1(i)**2)/eps)
         if (jflag > 0) then
           SIGpShell(ii)=SIGpShell(ii) + 
     *          wref*((dumpPartial*fop2(i)**2)/eps)
           sumDiffShell(ii)=sumDiffShell(ii)  +
     *           abs(fop1(i) - scaleFoFc *fop2(i))
           sumFoShell(ii)=sumFoShell(ii) + fop1(i)
           sumDiff=sumDiff  + abs(fop1(i) - scaleFoFc *fop2(i))
         else
           sumDiffShell(ii)=sumDiffShell(ii)  +
     *           abs(eobs1(i) - scaleFoFc *fop2(i))
           sumFoShell(ii)=sumFoShell(ii) + eobs1(i)
           sumDiff=sumDiff  + abs(eobs1(i) - scaleFoFc *fop2(i))
         endif

      enddo

      do i=1,Nbin
        SIGpShell(i)=SIGpShell(i)/numbShell(i)
        SIGnShell(i)=SIGnShell(i)/numbShell(i)
      enddo

      !------------------------------
      do i=1,nrefl1
         ii=RES_TAG(i)
         eps=epsv(i)*pts
         if (jflag > 0) then
           Eobs(i)=fop1(i)/(sqrt(eps*SIGnShell(ii)))
           Emodi(i)=fop2(i)/(sqrt(eps*SIGpShell(ii)))
         else
           Eobs(i)=eobs1(i)
           Emodi(i)=fop2(i)
         endif
      enddo

      sumEo=sum(Eobs(1:nrefl1))
      sumEc=sum(Emodi(1:nrefl1))
      scaleEoEc=sumEo/sumEc
   
      if (iprint==1) then
        write(lo,*)'scale(Eo,Ec):',scaleEoEc
      endif

      sumDiffShell(:)=0.0
      sumFoShell(:)=0.0
      sumDiff=0.0
      do i=1,nrefl1
         ii=RES_TAG(i)
         sumDiffShell(ii)=sumDiffShell(ii)  + 
     *           abs(Eobs(i) - scaleEoEc *Emodi(i))
         sumFoShell(ii)=sumFoShell(ii) + Eobs(i)
         sumDiff=sumDiff  + abs(Eobs(i) - scaleEoEc *Emodi(i))
       enddo

       p1=-3.1334
       p2=0.9472
       p3=0.79443

       p1res=-0.12
       p2res=1.54
 
       do i=1, Nbin
        if (sumFoShell(i) > 0.0 ) then
         rfac=sumDiffShell(i)/sumFoShell(i)
         resLimit=0.5/midpts(i)
         resCorrection=1.0
         if (resLimit > 7.0) then
           resCorrection=0.7
         elseif (resLimit < 4.5) then
           resCorrection=1.0
         else
           resCorrection=p1res*resLimit + p2res
         endif
         rfac=rfac*resCorrection
         rfac=min(0.75,rfac)
c        rfac=min(0.55,rfac)
         rfacShell(i)=rfac

c        cosErrEShell(i)=p1*(rfac**2) + p2*rfac + p3 ! originale
         cosErrEShell(i)=1-rfac**2
c        cosErrEShell(i)=wtt(i) ! occhio
         cosErrEShell(i)=max(0.01,cosErrEShell(i))
c        write(6,*) 'ufi',rfac,cosErrEShell(i),rtod*acos(cosErrEShell(i))
        endif
       enddo

      sigPsigN=sum(SIGpShell(:))/sum(SIGnShell(:))
      if (iprint==1) then
        write(lo,*)' <sigN>',sum(SIGnShell(:))/float(Nbin)
        write(lo,*)' <sigP>',sum(SIGpShell(:))/float(Nbin)
        write(lo,*)' <sigP>/<sigN>',sigPsigN
      endif

      ! calc Eo, Ec
      do i=1,nrefl1
       ii=RES_TAG(i)
       eps=epsv(i)*pts
       if (wtt(i) > 0) then
         diffERR=(iphi2(i)-iphi1(i)) * dtor
         diffERR=cos(diffERR)
         cosErrShell(ii)=cosErrShell(ii) + diffERR
       endif
       if (jflag > 0) then
         Eobs(i)=fop1(i)/(sqrt(eps*SIGnShell(ii)))
         Emodi(i)=fop2(i)/(sqrt(eps*SIGpShell(ii)))
       else
         Eobs(i)=eobs1(i)
         Emodi(i)=fop2(i)
       endif
       if (kmad == 0) then
         sigEobs(i)=sigfo(i)/(sqrt(eps*SIGnShell(ii)))
       else
         sigEobs(i)=sigfo(i)  !   per MAD i sigma sono sigma(E)
       endif
       ee(i)=1.0 + sigEobs(i)
       if (jsigmaa == 4) ee(i)=1.0 + (sigEobs(i))**2
       ee(i) = min(ee(i), 1.15)
       eeShell(ii)= eeShell(ii)+ee(i)
       Eo2Shell(ii)= Eo2Shell(ii)+Eobs(i)**2
       Ec2Shell(ii)= Ec2Shell(ii)+Emodi(i)**2
       Eo4Shell(ii)= Eo4Shell(ii)+Eobs(i)**4
       Ec4Shell(ii)= Ec4Shell(ii)+Emodi(i)**4
       Eo2Ec2Shell(ii)=Eo2Ec2Shell(ii) + ((Eobs(i)**2)*(Emodi(i)**2))
       EomEcShell(ii)=EomEcShell(ii) + (Eobs(i)-Emodi(i))**2
      enddo

      if (iprint==1) then
        write(lo,*)'<Eo>',sum(Eobs(:))/float(nrefl1)
        write(lo,*)'<Ec>',sum(Emodi(:))/float(nrefl1)
        write(lo,*)'<sigE>',sum(sigEobs(:))/float(nrefl1)
      endif

      ! calc <Eo2>, <Ec2> <Eo2Ec2> for any shell
      do i=1, Nbin
        numbShell1=count(RES_TAG(:) == i)
        Eo2Shell(i)=Eo2Shell(i)/float(numbShell1)
        Ec2Shell(i)=Ec2Shell(i)/float(numbShell1)
        Eo4Shell(i)=Eo4Shell(i)/float(numbShell1)
        Ec4Shell(i)=Ec4Shell(i)/float(numbShell1)
        Eo2Ec2Shell(i)=Eo2Ec2Shell(i)/float(numbShell1)
        eeShell(i)=eeShell(i)/float(numbShell1)
        cosErrShell(i)=cosErrShell(i)/float(numbShell1)
        EomEcShell(i)=EomEcShell(i)/float(numbShell1)
      enddo

      if (iprint==1) then
        write(lo,*)'<e>o',sum(eeShell(:))/float(Nbin)
        write(lo,*)'<Eo2>o',sum(Eo2Shell(:))/float(Nbin)
        write(lo,*)'<Ec2>o',sum(Ec2Shell(:))/float(Nbin)
        write(lo,*)'<(Eo-Ec)2>',sum(EomEcShell(:))/float(Nbin)
        write(lo,*)'<Eo2Ec2>o',sum(Eo2Ec2Shell(:))/float(Nbin)
c       write(lo,*)'<cos(phi-pub>)',sum(cosErrShell(:))/float(Nbin)
        write(lo,*)'<dphi>',rtod*acos(sum(cosErrShell(:))/float(Nbin))
        write(lo,*)'R(Eo,Ec)',sumDiff/sumEo
      endif

      !scale <Eo2> , <Ec2>, <Eo2Ec2> and calc <sigmaA> for any shell
      scalaEE = 1.0
      if (jsigmaa == 4) scalaEE = eeShell(1)
      do i=1,Nbin
        eeShell(i)=eeShell(i)/scalaEE
        scEo2Shell(i)=Eo2Shell(i)/1.0
        scEc2Shell(i)=Ec2Shell(i)/1.0
        Eo2Shell(i)=Eo2Shell(i)/scEo2Shell(i)
        Ec2Shell(i)=Ec2Shell(i)/scEc2Shell(i)
        Eo2Ec2Shell(i)=Eo2Ec2Shell(i)/(scEo2Shell(i)*scEc2Shell(i))
        Eo4Shell(i)=Eo4Shell(i)/scEo2Shell(i)**2
        Ec4Shell(i)=Ec4Shell(i)/scEc2Shell(i)**2
      enddo

       ! gsim for any shell
      do i=1,nrefl1
        ii=RES_TAG(i)
        ee1=Eobs(i)/sqrt(scEo2Shell(ii))
        ee2=Emodi(i)/sqrt(scEc2Shell(ii))
        gsimShell(ii)=gsimShell(ii) + 2.*ee1*ee2
        aa=12.*sqrt(ee(i))/pi**2
        bb=4.-(pi*sqrt(ee(i)))
        SIGMAAn=aa*(bb -2.*EomEcShell(ii))
        if (SIGMAAn > 0.0) then
          SIGMAAnShell(ii)=SIGMAAnShell(ii) + sqrt(SIGMAAn)
        else
          SIGMAAnShell(ii)=0.0
        endif
      enddo

       do i=1,Nbin
          numbShell1=count(RES_TAG(:) == i)
          SIGMAAnShell(i)=SIGMAAnShell(i)/float(numbShell1)
       enddo

       rSumSigmaan=sum(abs(SIGMAAnShell(1:Nbin)))

       if (rSumSigmaan > 0.0 ) then
         do ii=1,Nbin
          do i=1,Nbin
           if (SIGMAAnShell(i) < 0.0001) then
             if (i == Nbin) then
               SIGMAAnShell(i)=SIGMAAnShell(i-1)
             elseif (i == 1) then
               SIGMAAnShell(i)=SIGMAAnShell(i+1)
             else
               SIGMAAnShell(i)=0.5*(SIGMAAnShell(i-1) + 
     *              SIGMAAnShell(i+1))
             endif
           endif
          enddo
         enddo
        endif

      do i=1,Nbin
         numbShell1=count(RES_TAG(:) == i)
         gsimShell(i)=gsimShell(i)/float(numbShell1)
         gsimE=besinv(cosErrEShell(i))
         gsimE1=gsimShell(i)
         gg=gsimE1/gsimE
         det=gg**2 + 4.*eeShell(i)
         if (det > 0) then
          siga1=(-gg + sqrt(det))/2.0
          siga2=(-gg - sqrt(det))/2.0
          SIGMAAeShell(i)=siga1
         endif
      enddo
      rSumSigmaae=sum(abs(SIGMAAeShell(1:Nbin)))

      if (jsigmaa /=4) then
c      if ((sum(Eo2Ec2Shell(:))/float(Nbin)) < 1.1) eeShell(1:Nbin)=1.0
       if ((sum(Eo2Ec2Shell(:))/float(Nbin)) < 1.4) eeShell(1:Nbin)=1.0 ! occhio
       do ii=1,Nbin
        do i=1,Nbin
         dif=Eo2Ec2Shell(i) - eeShell(i)
         if (dif < 0.01) then
           if (i == Nbin) then
             Eo2Ec2Shell(i)=Eo2Ec2Shell(i-1)
           elseif (i == 1) then
             Eo2Ec2Shell(i)=Eo2Ec2Shell(i+1)
           else
             Eo2Ec2Shell(i)=0.5*(Eo2Ec2Shell(i-1) + 
     *              Eo2Ec2Shell(i+1))
           endif
         endif
        enddo
       enddo
      endif

      do i=1,Nbin
       if (Eo2Ec2Shell(i) > eeShell(i)) then
         SIGMAAShell(i)=sqrt((Eo2Ec2Shell(i)-eeShell(i)))
       else
         if (Eo2Ec2Shell(i) > 1.0) then
            SIGMAAShell(i)=sqrt((Eo2Ec2Shell(i)-1.0))
         else
           SIGMAAShell(i)=0.0
         endif
       endif
       SIGMAAShell(i)=max(0.05,SIGMAAShell(i))
c      write(6,*) 'uffa',i,Eo2Ec2Shell(i),eeShell(i),SIGMAAShell(i)
      enddo

      ! calcolo sigmaA dalla correlazione
      do i=1,Nbin
         numbShell1=count(RES_TAG(:) == i)
         sxy = Eo2Ec2Shell(i)*numbShell1
         sx = Eo2Shell(i)*numbShell1
         sy = Ec2Shell(i)*numbShell1
         sx2 = Eo4Shell(i)*numbShell1
         sy2 = Ec4Shell(i)*numbShell1
         
         sumnum = numbShell1*sxy-sx*sy
         if (sumnum > 0) then
           sumden = sqrt((numbShell1*sx2-sx**2)*(numbShell1*sy2-sy**2))
           SIGMAAccShell(i) = sqrt(sumnum/sumden)
         else
           if (iprint > 0) 
     *         write(lo,*)' CC(Eo2,Ec2) < 0.0 ==> sigmaA = 0.05'
           SIGMAAccShell(i) = 0.05
         endif
      enddo
      if (jsigmaa==1.and.ifDEDM==0) then
        if (sum(Eo2Ec2Shell(1:Nbin))/float(Nbin) < 1.2) then
         SIGMAAShell(1:Nbin) = SIGMAAccShell(1:Nbin)
         write(lo,*)' Cambiato con sigmaCC'
       endif
      endif
      !

      select case (jsigmaa)
      case (1)
       jsigmaaT=1
      case (2)
       if (rSumSigmaae > 0.0) then
         SIGMAAShell(1:Nbin)=SIGMAAeShell(1:Nbin)
         jsigmaaT=2
       else
         jsigmaaT=1
       endif
      case (3)
       if (rSumSigmaan > 0.0) then
         SIGMAAShell(1:Nbin)=SIGMAAnShell(1:Nbin)
         jsigmaaT=3
       else
         jsigmaaT=1
       endif
      case (4)
       jsigmaaT=4
      case (5)
       jsigmaaT=5
      case (6)
       jsigmaaT=6
      end select

      if (jsigmaa/=jsigmaaT) then
         write(lo,*) 'Cambiato da',jsigmaa,' a ',jsigmaaT
      endif

      jsigmaa=jsigmaaT
      
      rSumSigmaa=sum(abs(SIGMAAShell(1:Nbin)))
      averSig=rSumSigmaa/float(Nbin)

      dmin=0.5/sqrt(rhomax)
c     if(dmin<1.2) averSig=0.0
      if(iprint==1) write(lo,*) 'averSig',averSig

      if (rSumSigmaa < 0.0001) then
       write(lo,*) ' !!!!! errore sum(sigmaA)=0 '
       call cstop(' ')
      endif



      SIGMAAShellsave(1:Nbin) = SIGMAAShell(1:Nbin)


      if(jsigmaa.ne.6) then
      ! sigmaa refinement (max =10 cycle)
      irefCondition = 0
      if (jsigmaa==1.or.
     &         (jsigmaa==5.and.(averSig>0.9.or.
     &   sigPsigN>(1.2/dumpPartial).or.idritan==1))) then 
         SIGMAAShell_l(1:Nbin) = SIGMAAShell(1:Nbin)
         wttShell(:)= 0.0
         do 200 ilimit=1,3
          if(jsigmaa==1) then
            thres=0.001*(ilimit)
           else
            thres=0.1*(ilimit)
           endif
           if(iprint==1) then
             write(lo,*) 'threshold',ilimit,thres
           endif
           do 100 iref=1,10
            if (iprint > 0) write(lo,*)' Cycle:',iref
            r(:)=0.0d0
            drds(:)=0.0d0
            do i=1,nrefl1
             ii=RES_TAG(i)
             en=Eobs(i)
             ep=Emodi(i)
             if (en > 0.0.and.ep > 0.0) then
            x=2.0*en*ep*SIGMAAShell(ii)/(eeShell(ii)-SIGMAAShell(ii)**2)
             dxds=2.0*en*ep*(eeShell(ii)+SIGMAAShell(ii)**2)/
     *           (eeShell(ii)-SIGMAAShell(ii)**2)**2
             if (itype(i)==1) then
              rm=sim(x)
              rmbyx=0.5
              if (x.gt.0.001) rmbyx=rm/x
              r(ii)=r(ii)+2.0d0*dble(SIGMAAShell(ii)-rm*en*ep)
              drds(ii)=drds(ii)+
     +          2.0d0*dble(1.0-en*ep*(1.0-rmbyx-rm**2)*dxds)
             else
              rm=tanh(0.5*x)
              wttShell(ii)=wttShell(ii) + rm
              r(ii)=r(ii)+dble(SIGMAAShell(ii)-rm*en*ep)
              drds(ii)=drds(ii)+dble(1.0-en*ep*0.5*(1.0-rm**2)*dxds)
             endif
           endif
         enddo
       ! update sigmaA
         dsmax=0.0
         do i=1,Nbin
            numbShell1=count(RES_TAG(:) == i)
            if (numbShell1.gt.0) then
              ds=real(r(i)/drds(i))
              SIGMAAShell(i)=SIGMAAShell(i)-ds
              SIGMAAShell(i)=min(SIGMAAShell(i),0.999)
              if (iprint > 0) then
                write(lo,'(2x,i2,1x,f6.2,1x,f6.3,2x,i5,4(2x,f7.4))')
     *                 i,0.5/midpts(i),midpts(i),numbShell1,
     *                 SIGMAAShell_l(i),ds,SIGMAAShell(i),
     *                 wttShell(i)/numbShell1
              endif
              SIGMAAShell_l(i)=SIGMAAShell(i)
              dsmax=max(abs(ds),dsmax)
            endif
           enddo
           if (dsmax.lt.thres) then 
              irefCondition = 1
              goto 102
           endif
 100    continue
 200    continue
 102    continue

        if (iprint==1) then
          write(lo,*)'sigmaA cycles:',iref,irefCondition
        endif
        if (irefCondition == 0) then 
          do i=1,Nbin
            SIGMAAShell(i) = SIGMAAShellsave(i)
          enddo
        endif
      endif
      endif
      if(jsigmaa==5) jsigmaa=1
c
      do i=1,Nbin
        SIGMAAShell(i)=min(SIGMAAShell(i),0.999) ! occhio
        SIGMAAShell(i)=max(SIGMAAShell(i),0.05)
      enddo

      ! linear fit per sigmaA

      mwt=0
      sig(:)=0.0
      nInit=1
      do i=1,Nbin
        if (midpts(i) > 0.9) then
         nInit=i
         exit
        endif
      enddo

c     print*,'nInit=',nInit

      nEnd=1
      NPT=Nbin - nInit + 1 - nEnd
      xfit(1:NPT)=midpts(nInit:Nbin-1)
      yfit(1:NPT)=SIGMAAShell(nInit:Nbin-1)

      call fit(xfit,yfit,NPT,sig,mwt,a,b,siga,sigb,chi2,q)

      if (iprint==1) then
      write(lo,*)'sigmaA linear fitting:'
      write(lo,'(1x,t5,a,f9.6,t24,a,f9.6)') 'A = ',a,'Uncertainty: ',
     *       siga
      write(lo,'(1x,t5,a,f9.6,t24,a,f9.6)') 'B = ',b,'Uncertainty: ',
     *       sigb
      write(lo,'(1x,t5,a,4x,f10.6)') 'Chi-squared: ',chi2
      write(lo,'(1x,t5,a,f10.6)') 'Goodness-of-fit: ',q
      endif

      do i=1,Nbin
c       SIGMAAShell_l(i)=b*midpts(i) + a
        ! per non usare linear fitting
        SIGMAAShell_l(i)=SIGMAAShell(i)
        SIGMAAShell_l(i)=min(1.0,SIGMAAShell_l(i)) 
        SIGMAAShell_l(i)=SIGMAAShell(i)

        FacGSIMShell(i)=SIGMAAShell_l(i)
     *                  /(eeShell(i) -SIGMAAShell_l(i)**2)

        if (a > 0.0 ) then
          DluzShell_l(i)=SIGMAAShell_l(i)/sqrt(a)
          DluzShell_l(i)=min(1.0,DluzShell_l(i))
        else
         DluzShell_l(i)=DluzShell(i)
        endif

        if (jflag > 0) then
          sigNsigP=sqrt(SIGnShell(i)/SIGpShell(i))
          sigNsigP=max(1.0,sigNsigP)
          DluzShell(i)=SIGMAAShell_l(i)*sigNsigP
          DluzShell(i)=min(1.0,DluzShell(i))
          DluzShell(i)=max(0.0,DluzShell(i))
        endif
        DluzShell_l(i)=max(0.0,DluzShell_l(i))
      enddo


      if (iprint==1) then
        write(lo,*)'<e>n',sum(eeShell(:))/float(Nbin)
        write(lo,*)'<Eo2>n',sum(Eo2Shell(:))/float(Nbin)
        write(lo,*)'<Ec2>n',sum(Ec2Shell(:))/float(Nbin)
        write(lo,*)'<Eo2Ec2>n',sum(Eo2Ec2Shell(:))/float(Nbin)
      endif

      sigAmed=sum(SIGMAAShell(:))/float(Nbin)

      ! calc. new weight (modified sim weight using sigmaA)
      sumErr12=0.0
      sumErro=0.0
      sumwto=0.0

      sumErrn=0.0
      sumwtn=0.0

      sumErrc=0.0
      sumwtc=0.0

      sumErrnc=0.0
      sumwtnc=0.0

      sumErren=0.0
      sumwten=0.0

      nwto=0
      nwte=0
      nwtn=0
      nwten=0
      nwtc=0
      nwtnc=0
      cosErrShell(:) = 0.0
c
c--limito i pesi quando faccio la DEDM
c  vale quando faccio la DM di Dritan
c
      rff1=rf1
      rff2=rf2
      if(icombPh==1.and.abs(ifDEDM)>0) then 
        rff2=1.0 
        rff1=0.5 
        rff1=min(rff1,sigPsigNOld)
      endif
c
      do i=1,nrefl1
        ii=RES_TAG(i)

        if (wto(i) > 0) nWtoShell(ii) =  nWtoShell(ii) + 1

        wref=2.0
        if (itype(i) > 1) wref=1.0
        ee1=Eobs(i)
        ee2=Emodi(i)
        gmod=wref*ee1*ee2*FacGSIMShell(ii)
        gmod=max(0.0,gmod)
        if (itype(i)==1) then
c        wtnew(i)=bes(gmod) 
         wtnew(i)=sim(gmod)
        else
         wtnew(i)=tanh(0.5*gmod)
        endif

        wtnew(i)=min(1.0,wtnew(i))
        ! errore fase nuova
        if (wtnew(i) > 0.0) then
         nWtnShell(ii) =  nWtnShell(ii) + 1
         diffERR=(iphi2(i)-iphi1(i)) * dtor
         diffERR=cos(diffERR)
         cosErrShell(ii)=cosErrShell(ii) + diffERR
         if (wto(i) > 0.0) then
          sumErrn=sumErrn + acos(diffERR)*rtod
          sumwtn=sumwtn+wtnew(i)
          nwtn=nwtn+1
         else
          sumErren=sumErren + acos(diffERR)*rtod
          sumwten=sumwten+wtnew(i)
          nwten=nwten+1
         endif
        endif

        wtnewShell(ii)=wtnewShell(ii) + wtnew(i)
        wttShell(ii)=wttShell(ii) + wtt(i)
        wtoShell(ii)=wtoShell(ii) + wto(i)

        gold=0.0
        if (wto(i) > 0) then
          fomo=wto(i)
          ! com con wt/fasi iniziali obs
          if (itype(i)/=1) then
            gold=atanhILM(fomo)
          else
            gold=siminv(fomo)
          endif
        endif
       csum=rff2*gmod*cos(iphi2(i)*dtor) + rff1*gold*cos(iphi2o(i)*dtor)
       ssum=rff2*gmod*sin(iphi2(i)*dtor) + rff1*gold*sin(iphi2o(i)*dtor)
c      csum=rf2*gmod*cos(iphi2(i)*dtor) + rf1*gold*cos(iphi2o(i)*dtor)
c      ssum=rf2*gmod*sin(iphi2(i)*dtor) + rf1*gold*sin(iphi2o(i)*dtor)
        args=csum**2 + ssum**2
        if (args > 0.0 ) then
          fase=atan2(ssum,csum)*rtod
          fase=mod(fase+3600.,360.)
          if (itype(i) > 1) fase = favi(itype(i),fase)
          peso=sqrt(csum**2 + ssum**2)
          if (icombPh==1) then
            iphinew(i)=nint(fase)
            if (itype(i)==1) then
c             pesMod(i)=bes(peso)
              pesMod(i)=sim(peso)
            else
              pesMod(i)=tanh(peso)
            endif
          else
           ! senza combinazione
           iphinew(i)=iphi2(i)
           pesMod(i)=wtnew(i)
          endif
        else
          iphinew(i)=0
          pesMod(i)=0.0
        endif
        wtcShell(ii)=wtcShell(ii) + pesMod(i)
        ! errore fasi obs
        if (wto(i) > 0.0) then
         diffERR=(iphi2o(i)-iphi1(i)) * dtor
         diffERR=cos(diffERR)
         cosErroShell(ii)=cosErroShell(ii) + diffERR
         sumErro=sumErro + acos(diffERR)*rtod
         sumwto=sumwto+wto(i)
         nwto=nwto+1
         if (pesMod(i) > 0) then
           nWt12Shell(ii) =  nWt12Shell(ii) + 1
           diffERR=(iphi2o(i)-iphi2(i)) * dtor
           diffERR=cos(diffERR)
           cosErr12Shell(ii)=cosErr12Shell(ii) + diffERR
           sumErr12=sumErr12 + acos(diffERR)*rtod
         endif
        endif
        ! errore fasi comb
        if (pesMod(i) > 0.0) then
         nWtcShell(ii) =  nWtcShell(ii) + 1
         diffERR=(iphinew(i)-iphi1(i)) * dtor
         diffERR=cos(diffERR)
         cosErrcShell(ii)=cosErrcShell(ii) + diffERR
         if (wto(i) > 0.0) then
          sumErrc=sumErrc + acos(diffERR)*rtod
          sumwtc=sumwtc+pesMod(i)
          nwtc=nwtc+1
         else
          sumErrnc=sumErrnc + acos(diffERR)*rtod
          sumwtnc=sumwtnc+pesMod(i)
          nwtnc=nwtnc+1
         endif
        endif
c       endif
c
c--calcolo il peso per la fourier differenza
c
       var=(ee1**2) * (1.0 -wtnew(i)**2) ! versione best con e
c      var = var + ee2**2 * (1.0 - Dluz(i) **2)
       var=var+sigEobs(i)**2 ! versione best con e
c      var=(fop1(i)**2) * (1.0 -wtnew(i)**2) ! versione con f
c      var=var+sigfo(i)**2 ! versione con f
       if (var > 0.0) then
        wvar(i)=(var)**0.3 ! versione best con e
c       wvar(i)=1.0/sqrt(var)  ! versione con f o con e + Dritan
       else
        wvar(i)=0.0
       endif

c       if (SIGMAAShell(ii) > 0.0) then
c         wvar(i)=wvar(i)*sqrt(SIGMAAShell(ii))
c       endif
c         Dluz(i)=DluzShell(ii)
          Dluz(i)=DluzShell_l(ii) ! linea da cambiare occhio

c         gmod=2.*pesMod(i)*ee1*(2.*pesMod(i)*ee1-Dluz(i)*ee2)
c         gmod=2.*pesMod(i)*ee1-Dluz(i)*ee2
c         ! calc. coef. per fourier di differenza
c         ee1=Eobs(i)/sqrt(scEo2Shell(ii))
c         ee2=Emodi(i)/sqrt(scEc2Shell(ii))
c         aa = pesMod(i) * ee1 - SIGMAAShell(ii) * ee2
c         ! solo per test
c         eobs1(i) = aa
c         eobs1(i) = ee2
c         sigfo(i) = ee1
c         wvar(i) = SIGMAAShell(ii)

      enddo

      do i=1, Nbin
        numbShell1=count(RES_TAG(:) == i)
        if (numbShell1 > 0) then
          wtnewShell(i)=wtnewShell(i)/float(numbShell1)
          wttShell(i)=wttShell(i)/float(numbShell1)
          wtoShell(i)=wtoShell(i)/float(numbShell1)
          wtcShell(i)=wtcShell(i)/float(numbShell1)
        endif
        if (nWtoShell(i) > 0) 
     *    cosErroShell(i)=cosErroShell(i)/float(nWtoShell(i))
        if (nWtnShell(i) > 0) 
     *        cosErrShell(i)=cosErrShell(i)/float(nWtnShell(i))
        if (nWt12Shell(i) > 0) 
     *        cosErr12Shell(i)=cosErr12Shell(i)/float(nWt12Shell(i))
        if (nWtcShell(i) > 0) 
     *      cosErrcShell(i)=cosErrcShell(i)/float(nWtcShell(i))
      enddo

      if (iprint==1) then
        write(lo,*)'<wvar>',sum(wvar(:))/count(wvar(:) > 0.0)
        write(lo,'(1x,5hShell,1x,3hres,2x,6hsint/l,3x,4hNREF,
     *            2x,8h<Eo2Ec2>,
     *            1x,8hR(Eo,Ec),
     *            1x,8h <Eo-Ec>,
     *            1x,6hsigmaA,1x,
     *            3x,3hm_o,2x,7hcosERRo,
     *            3x,3hm  ,2x,7hcosERR ,
     *            1x,3hm_c,2x,7hcosERRc,
     *            3x,3hD  ,3x,7hD_l    )')
        do i=1,Nbin
          numbShell1=count(RES_TAG(:) == i)
c         write(51,*)midpts(i),Eo2Ec2Shell(i),eeShell(i),
c    *             sumDiffShell(i)/sumFoShell(i)
c         write(52,*)midpts(i),SIGMAAShell(i),eeShell(i),
c    *        cosErrShell(i),DluzShell(i),DluzShell_l(i),
c    *        wtnewShell(i),SIGMAAShell_l(i),wttShell(i),
c    *        cosErrEShell(i)
           write(lo,1000)i,0.5/midpts(i),midpts(i),
     *                numbShell1,
     *                Eo2Ec2Shell(i),
     *                rfacShell(i),
     *                EomEcShell(i),
c    *                SIGMAAccShell(i),
     *                SIGMAAShell(i),
     *                wtoShell(i),cosErroShell(i),
     *                wtnewShell(i),cosErrShell(i),
     *                wtcShell(i),cosErrcShell(i),
     *                DluzShell(i),DluzShell_l(i),
     *                eeShell(i)
c    *                acos(cosErr12Shell(i))*rtod
      
 1000 format(2x,i2,1x,f6.2,1x,f6.3,2x,i5,4(2x,f7.4),8(' ',f6.3),2x,f6.2)
        enddo

        nwto1=count(wto(1:nrefl1)>0.0)
        if (nwto1 > 0.0) then
           wtomed=sum(wto(1:nrefl1))/float(nwto1)
        else
           wtomed=0.0
        endif
        nwtn1=count(wtnew(1:nrefl1)>0.0)
        if (nwtn1 > 0.0) then
           wtnmed=sum(wtnew(1:nrefl1))/float(nwtn1)
        else
           wtnmed=0.0
        endif
        nwtc1=count(pesMod(1:nrefl1)>0.0)
        if (nwtc1 > 0.0) then
           wtcmed=sum(pesMod(1:nrefl1))/float(nwtc1)
        else
           wtcmed=0.0
        endif

        write(lo,'(2x,116(1h_))')
        write(lo,'(19x,i6,4(2x,f7.4),8f7.3,2(2x,f6.2))')
     *             nrefl1,
     *             sum(Eo2Ec2Shell(:))/float(Nbin),
     *             sumDiff/sumEo,
     *             sum(EomEcShell(:))/float(Nbin),
     *             sum(SIGMAAShell(:))/float(Nbin),
     *             wtomed,
     *             sum(cosErroShell(:))/float(Nbin),    
     *             wtnmed,
     *             sum(cosErrShell(:))/float(Nbin),    
     *             wtcmed,
     *             sum(cosErrcShell(:))/float(Nbin),
     *             sum(DluzShell(:))/float(Nbin),
     *             sum(DluzShell_l(:))/float(Nbin),
     *             acos(sum(cosErr12Shell(:))/float(Nbin))*rtod,
     *             sumErr12/float(nwto)
        if (nwto > 0) then
          write(lo,*)'  Combination with Initial Phases'
          write(lo,'(2x,8hBefore: ,2x,5hNref=,i6,2x,7h<dphi>=,
     *          f6.2,2x,4h<m>=,f6.3,f6.3)')
     *          nwto,sumErro/float(nwto),sumwto/float(nwto),rff1
        endif
        if (nwtn > 0) then
           write(lo,'(2x,8hAfter:  ,2x,5hNref=,i6,2x,7h<dphi>=,
     *           f6.2,2x,4h<m>=,f6.3,f6.3)')
     *           nwtn,sumErrn/float(nwtn),sumwtn/float(nwtn),rff2
        endif
        if (nwtc > 0) then
            write(lo,'(2x,8hCombine:,2x,5hNref=,i6,2x,7h<dphi>=,
     *          f6.2,2x,4h<m>=,f6.3)')
     *          nwtc,sumErrc/float(nwtc),sumwtc/float(nwtc)
        endif

        if (nwten > 0) then
          write(lo,*)'  Non Combine reflections'
          write(lo,'(10x,5hNref=,i6,2x,7h<dphi>=,f6.2,2x,4h<m>=,f6.3)')
     *               nwten,sumErren/float(nwten),sumwten/float(nwten)
        endif

      if (iprint > 0) then
          write(lo,*)'-----------------------------'
          write(lo,*)'sigmaA calc from:'
          if (jflag > 0) then
            write(lo,*)'|F|'
          else
            write(lo,*)'|E|'
          endif
          select case (jsigmaa)
             case (1)
               write(lo,*)'<Eo2Ec2>'
             case (2)
               write(lo,*)'R(EoEc)'
             case (3)
               write(lo,*)'<Eo-Ec>'
          end select
          write(lo,*) 'nrefl',nrefl1
          write(lo,*) '<sigmaA>',sum(SIGMAAShell(:))/float(Nbin)
          write(lo,*) '<m>',sum(pesMod(1:nrefl1))/
     *                 count(pesMod(1:nrefl1)>0.0),
     *                 count(pesMod(1:nrefl1)>0.0)
          write(lo,*) '<cosPHI>',sum(cosErrcShell(:))/float(Nbin)
          write(lo,*) '<dPHI>',rtod*acos(sum(cosErrcShell(:))/
     *                 float(Nbin))
          write(lo,*) '<D>',sum(DluzShell(:))/float(Nbin)
          write(lo,*) '<D>',sum(DluzShell_l(:))/float(Nbin)
          write(lo,*)'-----------------------------'
       endif
      endif
      if(ivolta==0) sigmaold=sum(SIGMAAShell(:))/float(Nbin)

      ! calc. pesi per i riflessi nonosservati
      if (jflag > 0) then
        SIGpMed=eps*sum(SIGpShell(:))/float(Nbin)
      else
        SIGpMed=1.0
      endif
      if (jsigmaa == 4) then
        ! da Rocco
c
c  uso la retta dei minimi quadrati
c
        sumx=0.0
        sumy=0.0
        sumxx=0.0
        sumxy=0.0
        do ii=1,NBin
         x=midpts(ii)
         y=min(SIGMAAShell(ii),0.80)
         sumx=sumx+x
         sumy=sumy+y
         sumxx=sumxx+x*x
         sumxy=sumxy+x*y
        enddo
        delta=Nbin*sumxx-sumx*sumx
        bbterm=(Nbin*sumxy-sumx*sumy)/delta
        aaterm=(sumy*sumxx-sumx*sumxy)/delta
c
        sogsigma=0.80
        sigmaven=sum(SIGMAAShell(:))/float(Nbin)
c
        do i=nrefl1+1,nrefSi
         iu=i-nrefl1
c
c--estrapolo i valori di sigma nel range non misurato
c
         x=sqrt(rho(i))
         sigmaext=aaterm+bbterm*x
! controllo per evitare esalazioni
         sigmaext=min(sigmaext,sogsigma)
         fact=1.0-sigmaext**2
         pesMod(iu) = sqrt(3.0*(Pi/4.0)*fact)
         exxo = sqrt(1.0+sigmaext**2*(fop2(i)**2-SIGpMed))
         if (jflag < 0) then
           fop2(i)=exxo
         else
           Eop(i) = fop2(i)/sqrt(SIGpMed) ! Eesterno
           Ecp(i) = exxo                  ! Eestrapolato
         endif
        enddo
      else
        ! da Dritan
       SIGpMed=sum(SIGpShell(:))/float(Nbin)
       scunobsMed=sum(scEc2Shell(:))/float(Nbin)
       pesmedObs=sum(pesMod(1:nrefl1))/count(pesMod(1:nrefl1) > 0.0)
       pesmedExt1=sum(wto(nrefl1+1:nrefSi))/
     *    count(wto(nrefl1+1:nrefSi) > 0.0)
c     print*,pesmedExt1
       sumcosdiffERRo=0.0
       sumdiffERRo=0.0
       sumcosdiffERR=0.0
       sumdiffERR=0.0
       sumcosdiffERRn=0.0
       sumdiffERRn=0.0
       do i=nrefl1+1,nrefSi

        if (wto(i) > 0.0) then
          diffERR=(iphi2o(i)-iphi1(i)) * dtor
          diffERR=cos(diffERR)
          sumcosdiffERRo=sumcosdiffERRo + diffERR
          diffERR=acos(diffERR)*rtod
          sumdiffERRo=sumdiffERRo + diffERR
        endif

        wref=2.0
        if (itype(i) > 1) wref=1.0
        rx=sqrt(rho(i))
        if (rx > midpts(Nbin)) then
          sigPunobs=SIGpShell(Nbin)
c         sigPunobs=SIGpMed
          scunobs= 1./sqrt(scEc2Shell(Nbin))
        else
          sigPunobs=SIGpMed
          scunobs= 1./sqrt(scunobsMed)
        endif
c       Emodi(i)=fop2(i)/(sqrt(epsv(i)*sigPunobs))
c       Emodi(i)=scunobs*fop2(i)/sqrt(epsv(i)*SIGpMed)
        Emodi(i)=scaleFoFc*fop2(i)/sqrt(epsv(i)*SIGpMed)
        sigmaAunobs=b*sqrt(rho(i)) + a
        sigmaAunobs=min(sigmaAunobs,0.80)
        FacGSIMunobs=sigmaAunobs/1.0 - sigmaAunobs**2
        fact=1.0-sigmaAunobs**2
c       exxo = 0.5*sqrt(pi*fact+(2.0*sigmaAunobs*Emodi(i))**2)
        exxo = 1.0+sigmaAunobs**2*(Emodi(i)**2-1.0)
        var_exxo=sqrt(3.0*(pi/4.0)*fact)
        if (exxo > 0.0) then
         Emodi(i)=sqrt(exxo)
c        gmod=wref*Emodi(i)**2*FacGSIMunobs
c        gmod=2.0*Emodi(i)*Emodi(i)*FacGSIMunobs
         gmod=wref*Emodi(i)
c        gmod=Emodi(i)
         if (itype(i)==1) then
c          wtnew(i)=bes(gmod)
           wtnew(i)=0.5*sim(gmod)
          else
           wtnew(i)=0.5*tanh(0.5*gmod)
          endif
          wtnew(i)=min(1.0,wtnew(i))
          wtnew(i)=max(0.0,wtnew(i))
c         wtt(i)=wtnew(i)
c         Ecp(i)=Emodi(i)
        else
          Emodi(i)=0.0
          wtnew(i)=0.0
c         wtt(i)=0.0
c         Ecp(i)=0.0
        endif
      ! comb. 
        if (wtnew(i) > 0.0) then
          diffERR=(iphi2(i)-iphi1(i)) * dtor
          diffERR=cos(diffERR)
          sumcosdiffERR=sumcosdiffERR + diffERR
          diffERR=acos(diffERR)*rtod
          sumdiffERR=sumdiffERR + diffERR
        endif
       gnew = 0.0
       gold = 0.0
       if (wto(i) > 0.0) then
          gold=besinv(wto(i))
       endif
       if (wtnew(i) > 0.0) then
c         gnew=gold
          gnew=besinv(wtnew(i))
       endif
       csum=0.5*gnew*cos(iphi2(i)*dtor) + 1.5*gold*cos(iphi2o(i)*dtor)
       ssum=0.5*gnew*sin(iphi2(i)*dtor) + 1.5*gold*sin(iphi2o(i)*dtor)
       args=csum**2 + ssum**2
       if (args > 0.0 ) then
          ! comb. moduli
           fop1(i)=(fop1(i) + fop2(i)) * 0.5
          !
          fase=atan2(ssum,csum)*rtod
          fase=mod(fase+3600.,360.)
          if (itype(i) > 1) fase = favi(itype(i),fase)
          peso=sqrt(csum**2 + ssum**2)
c         if (icombPh==1) then
            iphinew(i)=nint(fase)
            if (itype(i)==1) then
c             pesMod(i)=bes(peso)
              pesMod(i)=sim(peso)
            else
              pesMod(i)=tanh(peso)
            endif
          else
           ! senza combinazione
           iphinew(i)=iphi2(i)
           pesMod(i)=wtnew(i)
c         endif
       endif
        diffERR=(iphinew(i)-iphi1(i)) * dtor
        diffERR=cos(diffERR)
        sumcosdiffERRn=sumcosdiffERRn + diffERR
        diffERR=acos(diffERR)*rtod
        sumdiffERRn=sumdiffERRn + diffERR

      enddo
      if (nrefSi > nrefl1) then
         pesmedNobs=sum(pesMod(nrefl1+1:nrefSi))/
     *           count(pesMod(nrefl1+1:nrefSi) > 0.0)
         scPeso=pesmedNobs/pesmedObs

         write(lo,*)'unobs refl.'
         write(lo,*)'nrefl:',nrefSi-nrefl1
         write(lo,*)'<Ec>',sum(Emodi(nrefl1+1:nrefSi))/
     *           count(Emodi(nrefl1+1:nrefSi)>0.0)
         write(lo,*)'<wt>unobs',pesmedNobs,scPeso
         ! per il momneto non gli metto in scala
c        pesMod(nrefl1+1:nrefSi)=pesMod(nrefl1+1:nrefSi)/scPeso
         pesmedNobs=sum(pesMod(nrefl1+1:nrefSi))/
     *           count(pesMod(nrefl1+1:nrefSi) > 0.0)
         write(lo,*)'<wt>unobs',pesmedNobs
         sumdiffERRo=sumdiffERRo/count(wto(nrefl1+1:nrefSi) > 0.0)
         sumdiffERR=sumdiffERR/count(wtnew(nrefl1+1:nrefSi) > 0.0)
         sumdiffERRn=sumdiffERRn/count(pesMod(nrefl1+1:nrefSi) > 0.0)
!        write(lo,*)'<cosPHI>',sumcosdiffERR,sumcosdiffERRn
         write(lo,*)'<dphi>',sumdiffERRo,sumdiffERR,sumdiffERRn
      !
       endif
      endif
     !

      if (jsigmaa /= 4) then
       wtt(1:nrefSi) = pesMod(1:nrefSi)
       iphi2(1:nrefSi) = iphinew(1:nrefSi) 
       ! Ep Epp (x sirProt)
       Eop(1:nrefSi)=Eobs(1:nrefSi)
       Ecp(1:nrefSi)=Emodi(1:nrefSi)
      endif

      if (iabs(jflag) > 4) then
      ! Test per Fq 
      do i=1,nrefl1
        ii=RES_TAG(i)
        Eop(i) = Eobs(i)/sqrt(scEo2Shell(ii))
        Ecp(i) = Emodi(i)/sqrt(scEc2Shell(ii))
        if(jsigmaa==6) then
           wtt(i)=Dluz(i)
        endif
        Dluz(i)=0.8*SIGMAAShell(ii)
      enddo
      endif

      !

      if (iprint==1) then
        write(lo,*)'================================='
        write(lo,*)'=       end sigmaA              ='
        write(lo,*)'================================='
      endif

      deallocate(RES,RES_TAG,Eobs,Emodi,ee,sigEobs,wtnew,stat=ierr)
      deallocate (Eo2Shell,Ec2Shell,Eo4Shell,Ec4Shell,Eo2Ec2Shell,
     *          SIGnShell,SIGpShell,SIGqShell,
     *          EpsShell,scEo2Shell,scEc2Shell,
     *          eeShell,midpts,SIGMAAShell,SIGMAAShellsave,
     *          SIGMAAccShell,SIGMAAShell_l,xfit,yfit,
     *          cosErrShell,FacGSIMShell,
     *          wtnewShell,DluzShell,DluzShell_l,
     *          sig,shellTAB,numbShell,
     *          wttShell,wtoShell,sumDiffShell,
     *          sumFoShell,rfacShell,
     *          cosErrEShell,cosErroShell,cosErr12Shell,cosErrcShell,
     *          gsimShell,
     *          SIGMAAeShell,EomEcShell,SIGMAAnShell,wtcShell, 
     *          r,drds,
     *          stat=ierr)
      return
      end
      !------------------------------------------------------
      subroutine shells (SH,midpts,ITAG,res,Nt,Nbin,jshell)
      dimension SH(Nbin,2),ITAG(Nt),res(Nt),nsum(Nbin+1),sumr(Nbin+1)
      real midpts(Nbin),midpts_back(Nbin)
      real,     allocatable   :: res_sort(:)
      integer,  allocatable   :: IX_sort(:),IX_aux(:)

      allocate(res_sort(Nt),IX_sort(Nt),IX_aux(Nt),stat=ierr)

      SH(:,:)     = 0.0
      midpts(:)   = 0.0
      ITAG(:)     = 0
      nsum(:)     = 0.0
      sumr(:)     = 0.0
      res_sort(:) = 0.0
      IX_sort(:)  = 0
      IX_aux(:)   = 0

      nb=Nbin
      Ndata=floor(Nt/float(nb))
c     print*,Nt,nb,Ndata

      go to (1000,2000),jshell

 1000 continue

      rmin=minval(res(1:Nt))
      rmin=rmin**2
      rmax=maxval(res(1:Nt))
      rmax=rmax**2

c     print*,nb,rmin,rmax,0.5/sqrt(rmin),0.5/sqrt(rmax)

      add=(rmax-rmin)/float(nb)
      rr=float(nb)/(rmax-rmin)
      start=rmin-add
      ends=rmin+add

      do i=1,Nt
       rho=res(i)**2
       n=min0(int(1.0+rr*(rho-rmin)),nb)
       ITAG(i)= n
       nsum(n)=nsum(n) + 1
       sumr(n)=sumr(n) + rho
      enddo

      do i=1,nb
       nsum(i)=nsum(i)+nsum(i+1)
       sumr(i)=sumr(i)+sumr(i+1)
       start=start+add
       ends=amin1(ends+add,rmax)
       SH(i,1)=sqrt(start)
       SH(i,2)=sqrt(ends)
       wr=float(nsum(i))
       div=1.0/amax1(1.0,wr)
       midpts(i)=sumr(i)*div
c      write(6,'(1h ,i3,f8.4,3h  -,f8.4,2x,f8.4,i6)')i,start,ends,
c    *        midpts(i),nsum(i)
      enddo
      midpts(nb)=rmax
      midpts_back(1:nb)=midpts(1:nb)
      nb1=nb
      ii=2
      do i=2,nb-1
       if (nsum(i).le.0) then
        ii=i - (nb-nb1)
        midpts_back(1:ii-1)=midpts_back(1:ii-1)
        midpts_back(ii:nb1-1)=midpts_back(ii+1:nb1)
        nb1=nb1-1
       endif
      enddo

      nb=nb1
      midpts(1:nb)=midpts_back(1:nb)
      Nbin=nb

      do i=1,Nt
        IX_sort(i)=i
        res_sort(i)=res(i)**2
      enddo
      call sortall3(1,res_sort,1,Nt,IX_sort)

      ITAG(:)= 0
      n=1
      do i=1,Nt
 20     sog=midpts(n)
        if (n > nb) sog=rmax
        if (res_sort(i) <= midpts(n)) then
         ITAG(IX_sort(i))= n
        else
         n=n+1
         goto 20
        endif
      enddo

c     nn=0
c     do i=1, nb
c       numbShell=count(ITAG(:) == i)
c       nn=nn + numbShell
c       print*,i,numbShell,nn
c     enddo

      midpts(1:nb)=sqrt(midpts(1:nb))

      goto 5000

 2000 continue

      do i=1,Nt
        IX_sort(i)=i
        res_sort(i)=res(i)
      enddo

      call sortall3(1,res_sort,1,Nt,IX_sort)

      do i=1,Nbin-1
         rmin=10000.0
         rmax=-10000.0
         j=0
         do ii=1+(i-1)*Ndata,i*Ndata
           j=j+1
c          print*,i,IX_sort(ii)
c          ITAG(IX_sort(ii),1)= IX_sort(ii)
           ITAG(IX_sort(ii))= i
           rmax=max(rmax,res(IX_sort(ii)))
           rmin=min(rmin,res(IX_sort(ii)))
         enddo
         SH(i,1)=rmin
         SH(i,2)=rmax
       enddo

      rmin=10000.0
      rmax=-10000.0
      j=0
      do ii=1+(Nbin-1)*Ndata,Nt
           j=j+1
c          ITAG(IX_sort(ii),1)= IX_sort(ii)
           ITAG(IX_sort(ii))= Nbin
           rmax=max(rmax,res(IX_sort(ii)))
           rmin=min(rmin,res(IX_sort(ii)))
      enddo
      SH(Nbin,1)=rmin
      SH(Nbin,2)=rmax

      midpts(1:Nbin)=0.5*(SH(1:Nbin,1) + SH(1:Nbin,2))

 5000  continue

       deallocate(res_sort,IX_sort,IX_aux,stat=ierr)

       return
       end
      !------------------------------------------------------
      subroutine sigmaAheavy(kheavy,iprint)

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR

      character *200 strTime
      real,     allocatable   :: RES(:),midpts(:),Eobs(:),Emodi(:)
      real,     allocatable   :: ee(:),sigEobs(:),sigEdobs(:)
      integer,  allocatable   :: RES_TAG(:)
      real,     allocatable   :: Eo2Shell(:),Ec2Shell(:),Eo2Ec2Shell(:)
      real,     allocatable   :: SIGnShell(:),SIGpShell(:),SIGqShell(:)
      real,     allocatable   :: EpsShell(:),scEo2Shell(:),scEc2Shell(:)
      real,     allocatable   :: SIGMAAShell(:),eeShell(:),
     *                           SIGMAAShell_l(:),xfit(:),yfit(:)
      real,     allocatable   :: DluzShell(:),sig(:),
     *                           DluzShell_l(:),numbShell(:)
      real,     allocatable   :: shellTAB(:,:),sumDiffShell(:),
     *                           sumFoShell(:),rfacShell(:)
      real*8,     allocatable   :: r(:),drds(:)
   

c     iprint=1
      if (iprint==1) then
        write(lo,*)'================================='
c       write(lo,*)'=  sigmaAheavy  routine          ',kheavy,iprint
        write(lo,*)'=  sigmaA Heavy  Routine         '
        write(lo,*)'================================='
      endif

      ! sort riflessi x il FOD
      work1(:)=fod(kheavy,:)
      do i=1,nrefl
        iorde(i)=i
      enddo
      call sortall3(-1,work1,1,nrefl,iorde)
      nrefc=count(work1(1:nrefl) > 0.0)

      allocate (RES(nrefc),RES_TAG(nrefc),Eobs(nrefc),Emodi(nrefc), 
     *         sigEobs(nrefc),sigEdobs(nrefc),ee(nrefc), stat=ierr)

      do i=1,nrefc
       ii=iorde(i)
       RES(i)=sqrt(rhov(ii))
      enddo

      Nbin=30
      Nstat=floor(nrefc/float(Nbin))
      Nbin=8.0*alog10(0.05*float(max0(nrefc,100))+0.5)

      allocate (Eo2Shell(Nbin),Ec2Shell(Nbin),Eo2Ec2Shell(Nbin),
     *         SIGnShell(Nbin),SIGpShell(Nbin),SIGqShell(Nbin),
     *         EpsShell(Nbin),scEo2Shell(Nbin),scEc2Shell(Nbin),
     *         eeShell(Nbin),midpts(Nbin),SIGMAAShell(Nbin),
     *         SIGMAAShell_l(Nbin),xfit(Nbin),yfit(Nbin),
     *         DluzShell(Nbin),DluzShell_l(Nbin),
     *         sig(Nbin),shellTAB(Nbin,2),numbShell(Nbin),
     *         sumDiffShell(Nbin),
     *         sumFoShell(Nbin),rfacShell(Nbin),
     *         r(Nbin),drds(Nbin), 
     *         stat=ierr)

      shellTAB(:,:)=0.0
      midpts(:)=0.0
      RES_TAG(:)=0
      call shells(shellTAB,midpts,RES_TAG,RES,nrefc,Nbin,1) 

      Eobs(:)=0.0
      Emodi(:)=0.0
      SigmaaVal(:)=0.0
      Eo2Shell(:)=0.0
      Ec2Shell(:)=0.0
      Eo2Ec2Shell(:)=0.0
      SIGqShell(:)=0.0
      eeShell(:)=0.0
      scEo2Shell(:)=1.0
      scEc2Shell(:)=1.0
      SIGMAAShell(:)=0.0
      SIGMAAShell_l(:)=0.0
      DluzShell(:)=0.0
      DluzShell_l(:)=0.0
      sumDiffShell(:)=0.0
      rfacShell(:)=0.0
      sumFoShell(:)=0.0

      ! calc sihP, sigQ & sigN for any shell

      if (iprint==1) then
       write(lo,*)'Nr riflessi obs:',nrefc
       write(lo,*)'Nr riflessi con Fc >0:',count(work1(1:nrefc) > 0.0)
c      write(lo,*)'Nr riflessi con Fo >0:',count(fovet(1:nrefc) > 0.0)
      endif

      sumFo=0.0
      sumFc=0.0
      do i=1,nrefc
       ii=iorde(i)
       sumFo=sumFo+fovet(ii)*fod(kheavy,ii)
       sumFc=sumFc+fod(kheavy,ii)**2
      enddo

      scaleFoFc=sumFo/sumFc

      if (iprint==1) then
        write(lo,*)'scale(Fo,Fc):',scaleFoFc
      endif

      sumFo=0.0
      do i=1,nrefc
       ii=iorde(i)
       sumFo=sumFo+fovet(ii)
      enddo

      SIGnShell(:)=0.0
      SIGpShell(:)=0.0
      numbShell(:)=0.0

      sumDiff=0.0
      do i=1,nrefc
         ic=iorde(i)
         ii=RES_TAG(i)
         eps=epsv(ic)*pts
         wref=2.0
         if (mkang(ic) > 1) wref=1.0
         numbShell(ii)=numbShell(ii) + wref
         SIGnShell(ii)=SIGnShell(ii) + wref*((fovet(ic)**2)/eps)
         SIGpShell(ii)=SIGpShell(ii) + wref*((fod(kheavy,ic)**2)/eps)
         sumDiffShell(ii)=sumDiffShell(ii)  +
     *           abs(fovet(ic) - scaleFoFc *fod(kheavy,ic))
         sumFoShell(ii)=sumFoShell(ii) + fovet(ic)
         sumDiff=sumDiff  + abs(fovet(ic) - scaleFoFc *fod(kheavy,ic))
      enddo

      do i=1,Nbin
        SIGpShell(i)=SIGpShell(i)/numbShell(i)
        SIGnShell(i)=SIGnShell(i)/numbShell(i)
      enddo

      !------------------------------
      do i=1,nrefc
         ic=iorde(i)
         ii=RES_TAG(i)
         eps=epsv(ic)*pts
         Eobs(i)=fovet(ic)/(sqrt(eps*SIGnShell(ii)))
         Emodi(i)=fod(kheavy,ic)/(sqrt(eps*SIGpShell(ii)))
         if (Emodi(i) < 0.0) then
           call cstop(' ')
         endif
      enddo

      sumEo=sum(Eobs(1:nrefc))
      sumEc=sum(Emodi(1:nrefc))
      scaleEoEc=sumEo/sumEc
   
      if (iprint==1) then
        write(lo,*)'scale(Eo,Ec):',scaleEoEc
      endif

      sumDiffShell(:)=0.0
      sumFoShell(:)=0.0
      sumDiff=0.0
      do i=1,nrefc
        ii=RES_TAG(i)
        sumDiffShell(ii)=sumDiffShell(ii)  + 
     *          abs(Eobs(i) - scaleEoEc *Emodi(i))
        sumFoShell(ii)=sumFoShell(ii) + Eobs(i)
        sumDiff=sumDiff  + abs(Eobs(i) - scaleEoEc *Emodi(i))
      enddo

      do i=1, Nbin
        if (sumFoShell(i) > 0.0 ) then
         rfacShell(i)=sumDiffShell(i)/sumFoShell(i)
        endif
      enddo

      if (iprint==1) then
        write(lo,*)' <sigN>',sum(SIGnShell(:))/float(Nbin)
        write(lo,*)' <sigP>',sum(SIGpShell(:))/float(Nbin)
        write(lo,*)' <sigP>/<sigN>',sum(SIGpShell(:))/sum(SIGnShell(:))
      endif

      ! calc Eo, Ec
      do i=1,nrefc
       ic=iorde(i)
       ii=RES_TAG(i)
       eps=epsv(ic)*pts
       Eobs(i)=fovet(ic)/(sqrt(eps*SIGnShell(ii)))
       Emodi(i)=fod(kheavy,ic)/(sqrt(eps*SIGpShell(ii)))
       sigEobs(i)=sigmav(ic)/(sqrt(eps*SIGnShell(ii)))
       sigEdobs(i)=sigfd(kheavy,ic)/(sqrt(eps*SIGnShell(ii)))  ! rispetto a sigP o sigD
       ee(i)=(1.0 + 1.0*sigEobs(i)**2) * (1.0 + 1.0*sigEdobs(i)**2)
       eeShell(ii)= eeShell(ii)+ee(i)
       Eo2Shell(ii)= Eo2Shell(ii)+Eobs(i)**2
       Ec2Shell(ii)= Ec2Shell(ii)+Emodi(i)**2
       Eo2Ec2Shell(ii)=Eo2Ec2Shell(ii) + ((Eobs(i)**2)*(Emodi(i)**2))
      enddo

      if (iprint==1) then
        write(lo,*)'<Eo>',sum(Eobs(:))/float(nrefc)
        write(lo,*)'<Ec>',sum(Emodi(:))/float(nrefc)
        write(lo,*)'<sigE>',sum(sigEobs(:))/float(nrefc)
      endif

      ! calc <Eo2>, <Ec2> <Eo2Ec2> for any shell
      do i=1, Nbin
        numbShell1=count(RES_TAG(:) == i)
        Eo2Shell(i)=Eo2Shell(i)/float(numbShell1)
        Ec2Shell(i)=Ec2Shell(i)/float(numbShell1)
        Eo2Ec2Shell(i)=Eo2Ec2Shell(i)/float(numbShell1)
        eeShell(i)=eeShell(i)/float(numbShell1)
      enddo

      if (iprint==1) then
        write(lo,*)'<e>o',sum(eeShell(:))/float(Nbin)
        write(lo,*)'<Eo2>o',sum(Eo2Shell(:))/float(Nbin)
        write(lo,*)'<Ec2>o',sum(Ec2Shell(:))/float(Nbin)
        write(lo,*)'<Eo2Ec2>o',sum(Eo2Ec2Shell(:))/float(Nbin)
        write(lo,*)'R(Eo,Ec)',sumDiff/sumEo
      endif

      !scale <Eo2> , <Ec2>, <Eo2Ec2> and calc <sigmaA> for any shell
      do i=1,Nbin
        scEo2Shell(i)=Eo2Shell(i)/1.0
        scEc2Shell(i)=Ec2Shell(i)/1.0
        Eo2Shell(i)=Eo2Shell(i)/scEo2Shell(i)
        Ec2Shell(i)=Ec2Shell(i)/scEc2Shell(i)
        Eo2Ec2Shell(i)=Eo2Ec2Shell(i)/(scEo2Shell(i)*scEc2Shell(i))
      enddo

      if ((sum(Eo2Ec2Shell(:))/float(Nbin)) < 1.1) eeShell(1:Nbin)=1.0
      do ii=1,Nbin
       do i=1,Nbin
        dif=Eo2Ec2Shell(i) - eeShell(i)
        if (dif < 0.01) then
          if (i == Nbin) then
            Eo2Ec2Shell(i)=Eo2Ec2Shell(i-1)
          elseif (i == 1) then
            Eo2Ec2Shell(i)=Eo2Ec2Shell(i+1)
          else
            Eo2Ec2Shell(i)=0.5*(Eo2Ec2Shell(i-1) + 
     *              Eo2Ec2Shell(i+1))
          endif
        endif
       enddo
      enddo

      do i=1,Nbin
       if (Eo2Ec2Shell(i) > eeShell(i)) then
         SIGMAAShell(i)=sqrt((Eo2Ec2Shell(i)-eeShell(i)))
       else
         if (Eo2Ec2Shell(i) > 1.0) then
            SIGMAAShell(i)=sqrt((Eo2Ec2Shell(i)-1.0))
         else
           SIGMAAShell(i)=0.0
         endif
        endif
        SIGMAAShell(i)=max(0.05,SIGMAAShell(i))
      enddo

      rSumSigmaa=sum(abs(SIGMAAShell(1:Nbin)))

      if (rSumSigmaa < 0.0001) then
       write(lo,*) ' !!!!! errore sum(sigmaA)=0 '
       call cstop(' ')
      endif


      ! sigmaa refinement (max =10 cycle)
c        do 100 iref=1,10
c         r(:)=0.0d0
c         drds(:)=0.0d0
c         do i=1,nrefc
c          ic=iorde(i)
c          ii=RES_TAG(i)
c          en=Eobs(i)
c          ep=Emodi(i)
c          if (en > 0.0.and.ep > 0.0) then
c          x=2.0*en*ep*SIGMAAShell(ii)/(eeShell(ii)-SIGMAAShell(ii)**2)
c          dxds=2.0*en*ep*(eeShell(ii)+SIGMAAShell(ii)**2)/
c    *         (eeShell(ii)-SIGMAAShell(ii)**2)**2
c          if (itype(ic)==1) then
c           rm=bes(x)
c           rm=sim(x)
c           rmbyx=0.5
c           if (x.gt.0.001) rmbyx=rm/x
c           r(ii)=r(ii)+2.0d0*dble(SIGMAAShell(ii)-rm*en*ep)
c           drds(ii)=drds(ii)+
c    +        2.0d0*dble(1.0-en*ep*(1.0-rmbyx-rm**2)*dxds)
c          else
c           rm=tanh(0.5*x)
c           r(ii)=r(ii)+dble(SIGMAAShell(ii)-rm*en*ep)
c           drds(ii)=drds(ii)+dble(1.0-en*ep*0.5*(1.0-rm**2)*dxds)
c          endif
c          endif
c        enddo
c      ! update sigmaA
c        dsmax=0.0
c        do i=1,Nbin
c           numbShell1=count(RES_TAG(:) == i)
c           if (numbShell1.gt.0) then
c             ds=real(r(i)/drds(i))
c             SIGMAAShell(i)=SIGMAAShell(i)-ds
c             SIGMAAShell(i)=min(SIGMAAShell(i),0.999)
c             dsmax=max(abs(ds),dsmax)
c           endif
c          enddo
c       if (dsmax.lt.0.0001) goto 102
c100    continue
c102    continue
c       if (iprint==1) then
c         write(lo,*)'sigmaA cycles:',iref
c       endif

      ! linear fit per sigmaA
      mwt=0
      sig(:)=0.0

      nInit=1
      do i=1,Nbin
        if (midpts(i) > 0.9) then
         nInit=i
         exit
        endif
      enddo

c     print*,'nInit=',nInit
      
      nEnd=1
      NPT=Nbin - nInit + 1 - nEnd
      xfit(1:NPT)=midpts(nInit:Nbin-1)
      yfit(1:NPT)=SIGMAAShell(nInit:Nbin-1)

      call fit(xfit,yfit,NPT,sig,mwt,a,b,siga,sigb,chi2,q)

      if (iprint==1) then
      write(lo,*)'sigmaA linear fitting:'
      write(lo,'(1x,t5,a,f9.6,t24,a,f9.6)') 'A = ',a,'Uncertainty: ',
     *       siga
      write(lo,'(1x,t5,a,f9.6,t24,a,f9.6)') 'B = ',b,'Uncertainty: ',
     *       sigb
      write(lo,'(1x,t5,a,4x,f10.6)') 'Chi-squared: ',chi2
      write(lo,'(1x,t5,a,f10.6)') 'Goodness-of-fit: ',q
      endif

      do i=1,Nbin
        ! per non usare linear fitting
        SIGMAAShell_l(i)=SIGMAAShell(i)
        SIGMAAShell_l(i)=min(1.0,SIGMAAShell_l(i)) 
        if (a > 0.0 ) then
          DluzShell_l(i)=SIGMAAShell_l(i)/sqrt(a)
          DluzShell_l(i)=min(1.0,DluzShell_l(i))
        else
         DluzShell_l(i)=DluzShell(i)
        endif
        sigNsigP=sqrt(SIGnShell(i)/SIGpShell(i))
        sigNsigP=max(1.0,sigNsigP)
        DluzShell(i)=SIGMAAShell_l(i)*sigNsigP
        DluzShell(i)=min(1.0,DluzShell(i))
        DluzShell(i)=max(0.0,DluzShell(i))
      enddo


      if (iprint==1) then
        write(lo,*)'<e>n',sum(eeShell(:))/float(Nbin)
        write(lo,*)'<Eo2>n',sum(Eo2Shell(:))/float(Nbin)
        write(lo,*)'<Ec2>n',sum(Ec2Shell(:))/float(Nbin)
        write(lo,*)'<Eo2Ec2>n',sum(Eo2Ec2Shell(:))/float(Nbin)
      endif

      sigAmed=sum(SIGMAAShell(:))/float(Nbin)

      if (iprint==1) then
        write(lo,'(1x,"Shell",1x,"res",2x,"sint/l",3x,"NREF",
     *            2x,"<Eo2Ec2>",
     *            1x,"R(Eo,Ec)",
     *            1x,"sigmaA",1x,
     *            5x,"D")')
        do i=1,Nbin
          numbShell1=count(RES_TAG(:) == i)
           write(lo,1000)i,0.5/midpts(i),midpts(i),
     *                numbShell1,
     *                Eo2Ec2Shell(i),
     *                rfacShell(i),
     *                SIGMAAShell(i),
     *                DluzShell(i)
      
 1000 format(2x,i2,1x,f6.2,1x,f6.3,2x,i5,4(2x,f7.4))
        enddo
        write(lo,'(2x,116(1h_))')
        write(lo,'(20x,i5,4(2x,f7.4),11f7.3)')
     *             nrefc,
     *             sum(Eo2Ec2Shell(:))/float(Nbin),
     *             sumDiff/sumEo,
     *             sum(SIGMAAShell(:))/float(Nbin),
     *             sum(DluzShell(:))/float(Nbin)

      endif

      do i=1,nrefc
        ic=iorde(i)
        ii=RES_TAG(i)
        SigmaaVal(ic)=SIGMAAShell(ii)
        Dluz(ic)=DluzShell(ii)
      enddo

      deallocate (RES,RES_TAG,Eobs,Emodi, 
     *         sigEobs,sigEdobs,ee, stat=ierr)

      deallocate (Eo2Shell,Ec2Shell,Eo2Ec2Shell,
     *          SIGnShell,SIGpShell,SIGqShell,
     *          EpsShell,scEo2Shell,scEc2Shell,
     *          eeShell,midpts,SIGMAAShell,
     *          SIGMAAShell_l,xfit,yfit,
     *          DluzShell,DluzShell_l,
     *          sig,shellTAB,numbShell,
     *          sumDiffShell,
     *          sumFoShell,rfacShell,
     *          r,drds,
     *          stat=ierr)

      return
      end
