! ----------------------------------------------------------------------
c-- sir code for SIRPROT                         Release 91.00
c     program sirprot
      subroutine sirprotMain
      USE General
      USE BigStore
      USE Grafici
      USE Atomi
      USE Molcom
      USE TempMat
      USE RemoModule
      USE PhaseModule
      USE Dialogo
      USE TestModel
!
      character (len=256)  :: strLog
      character (len=780)  :: line
      character (len=80)   :: str,file
!     character fname(15)*80,ext(15)*4,path(2)*80
c-- file names and extensions
!     common/dotdat/ fname,ext,path
c-- direct access file related commons
      common/xdisu/ncdfu ,ndfle,irecx
      common /xfile/ ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common /xfili/ lfirst,nwblo,lindex(600)
      common /xchar/ id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/xbufd/link(1600)
c---
!g    common/exepathc/exepath
!g    character*256 exepath,fnameGifView
      character*256 fnameGifView
      character*19 charx
      data charx/'() ,*#0123456789+-.'/

      integer iz, i
!
      call fGetPWD(WorkingDirectory,lstring,ier)
!
      numbModels = 1          ! gl  30/10/10
      WhichModel = 1          ! gl  30/10/10
      MonomerInModel(:) = 1   ! gl  30/10/10
!
      newLista6 = 0
      ifNewFileBin = 0
!
      read(charx,'(19a1)')id,ie,ib,icc,ia,ih,numb,iplus, inus,ipoint
      distCoord = 0.6    ! distanza per la to_coord
      ifExamin = 1
      ifMadEnv = 1
      ModelToCompare = 0
      IcodeFo4 = 0
      l4s = 0
      QualePgm = SIRPROTPGM
      link(:) = 0
      ifRemo = 0
      ifCutResidui = 0
      MinResiduo   = 0
      MaxResiduo   = 0
      numbWL = 0
      MaxNk = 18
      bfacMR = -1
      nMolMR = 1
      kmad = 2
      neutro = 0
      kverbo = 0
      isOverFlag = 0
      MaxAtoms = 500
      ifSkeleton = 0
      ifViewer = .false.
      ifTwin  = 0
      ifCalcF = 0
      ProgName = 'SirProt'
      lProgName = Lung(ProgName)
      ifat512  = 512
      ifat512a = ( 2 * ifat512 + 1 ) * ( 2 * ifat512 + 1 )
      ifat512b = ( 2 * ifat512 + 1 )
      t1=0.0
      ttot=0.0
      pi=4.0*atan(1.0)
      twopi=2.0*pi
      rtod=180.0/pi
      dtor=1.0/rtod
      twopis = 2.0 * pi * pi
      rtd=180.0/pi
      dtr=1.0/rtd

c-----open windows
c     kscreen=1
c     kscreen=0
c     call scr0()
      
c ---
      call GetMessagesCode
      call CheckRecordLength
      ifW95 = nfGetEnv()
      if (ifW95 == 0) then
          slash = char(47)
      else
          slash = char(92)
      endif
      jcpuP = 0
!mr040606      call CPUTime0(ProgName)

      call BeccaSt(fnameGifView,ier)

      if (ier.lt.0) then
          Msg = 'Null or wrong input file name'
          call MsgWinErr('Error', Msg, ERR_WINDOW, k)
          ier = -2
          go to 1000
      endif      

      call CPUTime0(ProgName)

c     j=Lung(exepath)
      j=len_trim(exepath)
      path(1)=exepath(1:j)
      
      ifDrawGR = .true.

c     set flag for caos environment
      jcaos=0
      ncdfu=jdir
c     set flag for direct execution
      iexec=-1
c
c-- set up the default names for work files
c

C CCP4 initialisations
!mrgl      call ccpfyp
C MTZ-specific initialisations
      call mtzini

      do 10 i=1,5
      file=fname(i)(1:30)//ext(i)
      call NoBlanks(file,lfile)
   10 continue

c     file=fname(9)(1:30)//ext(9)
c     call NoBlanks(file,lfile)


      ! solo per determinare le dimensione della finestra grafica (cpn PGPLOT)
c     CALL PGPLOT_WINDOW
c
c-- define the number of reflections per block in scratch file
c--   nrpb = (number of words in block) / 6
c
      nrpb=knwr/6
c     npoints = 100
c     if (kscreen > 0) call ManageGraph(-1, npoints)
  50  call spoolr(jcaos,line,newf,iexec,jfour,ier)

      ! definire il nome della strutture (uso: grafica, diversi files di output)
      k = index(fname(1), '.bin')
      kk = k
      k1 = index(fname(1)(1:k),'_task')
      if (k1 > 0) kk = k1
      k1 = index(fname(1)(1:k),'_edm')
      if (k1 > 0) kk = k1
      k1 = index(fname(1)(1:k),'_flunch')
      if (k1 > 0) kk = k1

      StructureName = fname(1)(1:kk-1)
      !

      if (kscreen > 0) then
          call scr0
c         call CreaPng(fname(9))
          inBoxGR(:) = 0
          nLinesGR   = 0
          call FillCaratteriSpeciali()
          npoints = 100
          call ManageGraph(-1, npoints)
          call AllocaGrafici(1,500,0)
      endif

      if (ier.lt.0) go to 1000
      ier = 0
!
      lflValue = 1550000
      iAct = 1
      call AllocaBigStore(iAct)
      call InitBuild
!
      if (.not. allocated(mat)) then
          allocate (mat(1:3,1:50000) ,stat = ierr)
      endif
!
!-- check if a model has to be loaded
!
*     call AllocaAtomi(1)
*     call CheckModelToLoad(ier)
*     call AllocaAtomi(2)
*     if (ier < 0) return
!
      call sircom(newf,iexec,ier)
!
 1000 call ExitSirprot(ier, 0)
!
      return
      end
c-----------------------------------------------------------------------
      subroutine InitBuild
!
      USE BuildStuff
!
      nats = 400
      nats600 =1+600*nats
      nats20=20*nats
      jdimbuild=1000   !dimension dei vettori di clust
      nfl=1
      lfl=nats600
      lflValue=nats600
      llfl=nats600-nats*25
      lfl=nats600-nats*25
      call AllocaBuildStuff(1)
!
      return
      end
c-----------------------------------------------------------------------
      subroutine spoolr(jcaos,line,newf,iexec,jfour,ier)
      USE General
      USE Molcom
      USE PhaseModule
!
      character line*(*),releas*5,com4*4
      character beg,commen,allcom(80)*14,dire*80,defa*7
      character Numdigit*13
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /xfile/ ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common /xfili/ lfirst,nwblo,lindex(600)
      character*8 itldef
!     character fname(15)*80,ext(15)*4,path(2)*80
!     common/dotdat/ fname,ext,path
      common /cifre/ Numdigit
      common /charas/ beg,commen,allcom
      dimension vet(40),ivet(40)
      data itldef /' sirPROT'/

c
      ilMilione = 0
      if (iexec.lt.0) then
c     set up sin/cos table
          do i=1,450
             sint(i)=sin(dtor*float(i-1))
          enddo
          allcom(15)(1:1)=beg
          do i=1,19,2
             read(itldef,'(2a4)') itle(i),itle(i+1)
          enddo
          jfour=0
      endif
      ifHidden = 0
      irefl=0
      kcont=0
      ier=0
      init=0
      nallc=80
      ipcom=0
      icomo=2
      ipdir=0
      nerr=0
      do 120 i=1,maxcom
      do 120 j=1,2
  120 icomq(i,j)=0
      ifli=0
      if (jcaos.eq.1) ifli=1
c
c-- read cards
c
  130 format(a)
      if (iexec.gt.0) write(lo,135) beg,beg,beg
  135 format(//,' Please enter commands and directives ( ',a1,a1,' to go
     *, ',a1,'end to stop )')
  140 if (ifli.eq.0) read(ln,130,end=2000) line
      call filtra(line)
      cardImage = line
!
      k = index(line,'!')
      if (k /= 0) then
          line(k:) = ' '
      endif

      ifli=0
      call shift(line,nchar)
      if (nchar.le.0.or.line(1:1).eq.commen) go to 140
c
c-- if first character is equal to '%' it is a command or a comment
c
      if (line(1:1).eq.beg) then
c
c-- check if the command is an "exec" one
c
            if (line(2:2).eq.beg) then
                                    iexec=iexec+1
c                                   return
                                    go to 165
                                  endif
CCCCCCCCCif (line(2:2).ne.blank) then
c
c-- verify if the command is allowed
c
         icom=0
         com4=line(2:5)
         call lcase(com4)
         do i=1,nallc
c           write(6,*) i,nallc,com4,allcom(i)
            if (com4.eq.allcom(i)(1:4)) then
                icom=i
                exit
            endif
         enddo
         jcom=0
c
c-- if %PATTERSON next command must be %END
c
         if (icomo.eq.16) icom=7
c
         if (icom.eq.0) then
             go to 3000
         else
             if (icom.eq.18) then
c--       the command is  %automatic
                 jcom=1
                 ifAutomatic = 1
             endif
             if (icom.eq.19) then
c--       the command is  %hidden
                 call cutst(line,lenp,dire,lend)
                 iopt=0
                 call getnum(line,vet,ivet,iv,iopt)
                 if (iv.eq.2) then
                     kscrx=max0(kscrx,ivet(1))
                     kscry=max0(kscry,ivet(2))
                 endif
                 jcom=1
                 kscreen=1
                 ifHidden = 1
                 ifAutomatic = 1
             endif
             if (icom.eq.26) then
c--       the command is  %window
c
                 call cutst(line,lenp,dire,lend)
                 iopt=0
                 call getnum(line,vet,ivet,iv,iopt)
                 if (iv.eq.2) then
                     kscrx=max0(kscrx,ivet(1))
                     kscry=max0(kscry,ivet(2))
                 endif
                 jcom=1
                 kscreen=1
             endif

             if (icom.eq.25) then
c
c--       the command is  %nowindow
c
                 jcom=1
                 kscreen=0
             endif
             
             if (icom.eq.27) then
c--       the command is  %ilmilione
                 jcom = 1
                 call cutst(line, lenp, dire, lend)
                 iopt = 0
                 call getnum(line, vet, ivet, iv, iopt)
                 ilMilione = ivet(1)
             endif
             if (icom.eq.8) then
c
c--       the command is  %continue
c
                 jcom=1
                 icomo=icomo+1
                 if (icomo.eq.2) icomo=3
                 if (icomo.eq.24) icomo=1
                 do 160 ii=icomo,7
                    if (ii.eq.2) go to 160
                    ipcom=ipcom+1
                    if (ipcom.gt.maxcom) go to 6000
                    icomq(ipcom,1)=ii
  160            continue
             endif
             if (icom.eq.9) then
c
c--       the command is  %job
c
                 jcom=1
                 call cutst(line,lenp,dire,lend)
                 read(line,'(20a4)') itle
             endif
             if (icom.eq.23) then
c--       the command is  %structure
c
                 jcom=1
                 call cutst(line,lenp,dire,lend)
                 if (lenp.le.0) go to 1000
                 call cutst(line,lenp,dire,lend)
                 fname(1)=dire(1:lend)//ext(1)
                 fname(2)=dire(1:lend)//ext(2)
                 fname(3)=dire(1:lend)//ext(3)
                 fname(4)=dire(1:lend)//ext(4)
                 fname(5)=dire(1:lend)//ext(5)
                 fname(6)=dire(1:lend)//ext(6)
c                fname(9)=dire(1:lend)//ext(9)
             endif

             if (icom.eq.13) then
c
c--       the command is %initialize
c
                 jcom=1
                 init=1
             endif
             if (icom.eq.41) then    ! %coordinates
                 jcom = 1
                 call cutst(cardImage, lenp, dire, lend)
                 call cutst(cardImage, lenp, dire, lend)
                 FraFilePath = dire(1:lend)
                 ifLoadHydrogen = 1
                 if (lenp > 2) then
                     call lcase(cardImage)
                     if (cardImage(1:3) == 'noh') then
                         ifLoadHydrogen = 0
                     else
                         go to 3000
                     endif
                 endif
             endif
             if (jcom.eq.0) then
                 ipcom=ipcom+1
                 if (ipcom.gt.200) go to 6000
                 icomq(ipcom,1)=icom
                 icomo=icom
             endif
         endif
      else
c
c-- it is a directive
c
         if (ipcom.eq.0) go to 4000
         ipdir=ipdir+1
         if (ipdir.gt.100) go to 5000
         card(ipdir)=line
         com4=line(1:4)
         call lcase(com4)
         icomq(ipcom,2)=icomq(ipcom,2)+1
c        if (com4.eq.'true'.or.com4.eq.'corr') then
c                              call cutst(line,lenp,dire,lend)
c                              if (lenp.gt.0) fname(6)=line
c                              endif
         if (com4.eq.'scha'.or.
     *       com4.eq.'mold'.or.
     *       com4.eq.'molp') then
             call cutst(line,lenp,dire,lend)
             if (lenp.gt.0) fname(4)=line
         endif
         if (com4.eq.'refl') then
             call cutst(line,lenp,dire,lend)
             irefl=1
             com4=line(1:4)
             call lcase(com4)
             if (com4.eq.'foll') then
                 jfile=ln
c                hklf=' '
c                hklf(1:20) ='card reader         '
                 ReflFileName(1:20) ='card reader         '
             else
c                hklf=line
                 ReflFileName = dire(1:lend)
             endif
         endif
         if (com4 == 'mtz ') then
             ReflFileName = ' '
             call cutst(line, lenp, dire, lend)
             call cutst(line, lenp, dire, lend)
             irefl = 2
             ReflFileName = dire(1:lend)
         endif
         if (com4.eq.'cont') kcont=1
      endif
      if (icom.ne.7.and.icom.ne.8) go to 140
      if (nerr.ne.0) go to 9000
  165 if (iexec.gt.0) return
      iexec=iexec+1
      if (jcaos.eq.0) then
c-- initialize history array
      if (kenvir.eq.0) then
                         do 170 i=1,99
  170                    kstory(i)=0
                       endif
c-- set up internal structures
*gl*  call star9
c     print*,'kuku',fname(1)
      itipe=0
      if (kopen(jdir,fname(1),nlenBin,itipe,ierr).ge.0) go to 200
      write(lo,190) ierr,fname(1)
  190 format(' error ',i5,'  opening file ',a)
      ier=-1
      return
  200 continue
*gl*  call xdwn(lfirst,lindex,10)
      newf=0
      if (init.eq.1) lindex(8)=ifile+1
      if (lindex(8).ne.ifile) then
*gl*                            call setfi
                                newf=1
                              endif
*gl*  call xlc
*gl*  call xcsae
                         endif
c--
      write(lo,215) itle
  215 format(1h ,78('*'),/," " ,20a4,//)
      call wrhead
      write(lo,220)
  220 format(' Used commands & directives:',/)
      jj=0
      do i=1,ipcom
         line = blank
         j=icomq(i,1)
         if (j.eq.5) jfour=1
         if (j.eq.6) jfour=2
         if (j.eq.11) jfour=2
         write(line(1:26),'(11x,a1,a14)') beg,allcom(j)
         if (icomq(i,2).eq.0) then
             defa='default'
             if (icomq(i,1).eq.7) defa='       '
             write(line(28:34),'(a7)') defa
             write(lo,'(/,a)') line(1:Lung(line))
         else
             do j=1,icomq(i,2)
                jj=jj+1
                if (j.eq.1) then
                    write(line(28:),'(a)') card(jj)(1:780-28)
                    write(lo,'(/,a)') line(1:Lung(line))
                else
                    write(line,'(27x,a)') card(jj)(1:780-27)
                    write(lo,'(a)') line(1:Lung(line))
                endif
             enddo
         endif
      enddo
      call CheckPath(ier)
      if (ier.lt.0) return
      write(lo,290) ln,fname(14)(1:Lung(fname(14))),
     *              lo,fname(15)(1:Lung(fname(15))),
     *              jdir,fname( 1)(1:Lung(fname( 1))),
     *              jrel,fname(13)(1:Lung(fname(13)))
c     if (irefl.ne.0) write(lo,300) jfile,hklf
      if (irefl == 1) then
          write(lo,300) jfile,ReflFileName(1:Lung(ReflFileName))
      elseif (irefl == 2) then
          write(lo,301) jfile,ReflFileName(1:Lung(ReflFileName))
      endif
      if (kcont.eq.1)  then
          itype=2
          iform=1
          jop=jopen(kform,ffile,itype,iform,ierr)
          if (jop.lt.0) then
              write(lo,270) ierr,ffile
              ier=-1
          else
              read(kform,280,iostat=ierr,err=7000) releas
              write(lo,310) kform,ffile,releas
              close (kform)
          endif
      endif
  270 format(' *** error ***  open error, code =',i5,' file is ',a)
  280 format(a5)
  290 format(//,   ' Files used in SIRprot:',//,
     *     '  Channel                                  Name',/,
     1            i6,'    instruction input file           ',a,/,
     2            i6,'    output file                      ',a,/,
     3            i6,'    direct access structure file     ',a,/,
     2            i6,'    files information                ',a)

  300 format(     i6,'    reflection input file            ',a)
  301 format(     i6,'    reflections from MTZ file        ',a)
  310 format(     i6,'    scattering factors file          ',a,
     1     /, 6x,    '    ( Release : ',a5,' )')
      write(lo,'(//)')
      if (newf.eq.1) then
                       write(lo,330)
                     else
                       write(lo,340)
*gl*                   call summar
                     endif
  330 format(6x,'direct access structure file has been initialized'//)
  340 format(6x,'direct access structure file actually contains:'/)
      return
 1000 continue
!      write(6,*)icom
      write(Msg,1010)
1010  format(' No structure name specified ')
      go to 9000
 2000 continue
      write(Msg,2010)
 2010 format(' no   %end or %continue   command specified')
      go to 9000
 3000 continue
      write(Msg,3010) line(1:nchar)
 3010 format(' error in command ',a)
      go to 9000
 4000 write(Msg,4100) line(1:nchar)
 4100 format(' no command specified for directive ',a)
      go to 9000
 5000 write(Msg,5100)
 5100 format(' more than 100 directives used',
     *       ' check for missing  %end or %continue')
      go to 9000
 6000 write(Msg,6100) maxcom
 6100 format(' more than ',i5,' commands used',
     *       ' check input file or submit two jobs ')
      go to 9000
 7000 nrec=1
      write(Msg,7100) ierr,nrec,ffile(1:Lung(ffile))
 7100 format(' error ',i5,' reading record no. ',i3,' in file ',a)
 9000 ier=-1
      call MsgWinErr('Error', Msg, ERR_WINDOW, k)
!    
      return
      end
c-----------------------------------------------------------------------
      subroutine sircom(newf,iexec,ier)
c-- main subroutine to handle sir commands
      USE General
      USE PhaseModule
!
      character beg,commen,allcom(80)*14
      common /charas/ beg,commen,allcom
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /xlimi/ idummy(6),nfls
c

c
      ier=0
      ipdir =0
      icomat=0
   80 if (ier.lt.0) return
      nfls=1
      nfl=1
      npcnor=0
      icomat=icomat+1
      j=icomq(icomat,1)
      if (j.ne.0) then
      jj=kstory(20)+1
      kstory(20)=jj
      jj=jj+20
      if (jj.le.99) kstory(jj)=j
      go to (100,200,300,400,500,600,700,800,900,1000,
     *       1100,1150,1200,1300,1400,1500,1600,1700,1800,
     *       1900,2000,2100,2200,2300,2400,2500),j
c-- normal     routine
  100 continue
c     call normal(ier)
      go to 80
c-- seminvariants routine
  200 continue
c     call seminv(ier)
      go to 80
c-- invariants routine
  300 continue
      call invar(ier)
      go to 80
c-- phase   routine
  400 continue
      call contan(ier)
      go to 80
c-- fourier routine
  500 continue
c     call fourie(fname(3),ier)
      go to 80
c-- end command
  600 continue
      !call export(ier)
      go to 80
c-- end command
  700 continue
      call AllocaRFreeVett(2, n)
      go to 1500
c-- continue  routine
  800 continue
      ier=-1
      go to 80
c-- job command
  900 continue
      ier=-1
      go to 3000
c-- file command
 1000 continue
      call PhasingProcedure(ier)
      go to 80
c--   dummy command
 1100 continue
      call edmflex(ier)
      go to 80
 1150 continue
c     call pattinv(ier)
      go to 80
c-- initialize
 1200 continue
      ier=-1
      go to 3000
c-- restart   command
 1300 continue
      !call restar(ier)
      go to 80
c-- history command
 1400 continue
      call befor
      go to 80
 1600 continue
c     call patter(ier)
      go to 80
 1700 continue
      ier=-1
      go to 3000
 1800 continue
      ier=-1
      go to 3000
 1900 continue
      ier=-1
      go to 3000
 2000 continue
      ier=-1
      go to 3000
 2100 continue
      ier=-1
      go to 3000
 2200 continue
      ier=-1
      go to 3000
c-- data       routine
 2300 continue
      call datasir(newf,ier)
      go to 80
c-- nowindow  comand
 2400 continue
      ier=-1
      go to 3000
c-- window  comand
 2500 continue
      ier=-1
      go to 3000
c-- exec command
 1500 iexec=-1
          endif
      return
 3000 write(lo,3100) j,allcom(j)
 3100 format(' wrong command code = ',i5,' for ',a14,' command')
      return
 7000 write(lo,7010) ier,jhost
 7010 format(' *** error ***  open error, code =',i5,' file is ',a)
      ier=-1
      return
      end
c-----------------------------------------------------------------------
      subroutine befor
      USE General
!
      character cff,beg,commen,allcom(80)*14
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /charas/ beg,commen,allcom
c
      call RoutineHeader('History of the Structure','05.12')
c
      ifin=kstory(20)-1
      kstory(20)=ifin
      if (ifin.le.0) then
                      write(lo,300)
                     else
                      write(lo,400)
                      do 200 i=1,ifin
                      j=i+20
                      jj=kstory(j)
                      write(lo,500) allcom(jj)
  200                 continue
                     endif
  300 format(/,10x,' The structure has no story',/)
  400 format(/,10x,' List of commands issued in the past',/)
  500 format(11x,a1,a14)
      return
      end
!-----------------------------------------------------------------------
      subroutine RoutineHeader(routine, versionPgm)
      USE General
      USE Molcom
!
      character*(*) routine, versionPgm
!
      write(lo,10)
      write(Inte,20) ProgName(1:lProgName), routine(1:Lung(routine))
      write(Inte(65:),30) versionPgm(1:Lung(versionPgm))
      write(lo,'(a)') Inte(1:Lung(Inte))
      write(lo,40) itle
      call toflush()
!
      return
!
   10 format(///,' ',78('+'),/)
   20 format(' ',a,' : ',a,' routine')
   30 format('Release  ',a)
   40 format(/,' ',20a4,/,' ',78('+'),//)
!
      end
!-----------------------------------------------------------------------
      subroutine histor(nfield,ivalue,ier)
      USE General
!
c-- this subroutine is used to get the story of different
c-- attemps solving the actual structure
c
c     nfield = 1   information about pseudotranslational symmetry
c                  ( ivalue=0 if absent, ivalue= n if it exists with
c                    a percentage value of n , ivalue = -n if used )
c            = 2   information about partial procedure
c                  ( ivalue=1 if used , ivalue=0 otherwise )
c            = 3   number of symbols used
c            = 4   information about the use of seminvariants
c                  ( ivalue=1 if used , ivalue=0 otherwise )
c            = 5   information about the use of mess
c                  ( ivalue=1 if used , ivalue=0 otherwise )
c            = 6 - 16   not used
c
      character*40 filen
c
              if (kenvir.eq.0) then
c-- standard sir91 environment
                                 kstory(nfield)=ivalue
         else if (kenvir.eq.1) then
c-- enraf-nonius environment
c-- update the 170-th record (16 words lenght)
c-- in the master file for enraf-nonius implementation
c-- the record is red into kstory array, updated and rewritten
                                 namel=9
                                 filen(1:namel)='struc.nme'
                                 nrec=170
                                 jnon=30
                                 itipe=0
                                 nonius=16
         if (kopen(jnon,filen(1:namel),nonius,itipe,ierr).ge.0) then
            read (jnon,rec=nrec,err=100,iostat=ierr) (kstory(i),i=1,16)
                                    kstory(nfield)=ivalue
            write(jnon,rec=nrec,err=120,iostat=ierr) (kstory(i),i=1,16)
                                    close(jnon)
                                  else
                                    ier=-1
                                    write(lo,90) ierr,filen(1:namel)
                                  endif
         else if (kenvir.eq.2) then
                                 kstory(nfield)=ivalue
                               endif
      return
   90 format(' error ',i5,'  opening file ',a)
  100 ier=-1
      write(lo,110) ierr,nrec,filen(1:namel)
  110 format(' error ',i5,' reading record no. ',i3,' in file ',a)
      return
  120 ier=-1
      write(lo,130) ierr,nrec,filen(1:namel)
  130 format(' error ',i5,' writing record no. ',i3,' in file ',a)
      return
      end
c--------------------------------------------------------------------
      subroutine unpak3(index,kod1,kod2,ifaz)
      isave=index/32
      ifaz=index-isave*32 -1
      kod1=isave/4096
      kod2=isave-4096*kod1-2048
      kod1=kod1-2048
      return
      end
c--------------------------------------------------------------------
      subroutine unpak3b(index,kod1,kod2,ifaz)
      isave=index/32
      ifaz=index-isave*32 -1
      kod1=isave/8192
      kod2=isave-8192*kod1-4096
      kod1=kod1-4096
      return
      end
c-----------------------------------------------------
      subroutine unpack (index,ih,kk,il)
      ih = index/262144
      is = index - 262144*ih
      kk = is/512-256
      il = is-512*(kk+256)-256
      return
      end
c ----------------------------------------------------------------------

      function rmodH(i1)
      USE General

      dimension i1(3)

      d2=(cstar(1)*i1(1))**2+(cstar(2)*i1(2))**2+(cstar(3)*i1(3))**2 +
     +     2.0*cstar(1)*i1(1)*cstar(2)*i1(2)*cstar(6) +
     +     2.0*cstar(1)*i1(1)*cstar(3)*i1(3)*cstar(5) +
     +     2.0*cstar(2)*i1(2)*cstar(3)*i1(3)*cstar(4)

      rmodH=sqrt(d2)
c     rho=rhof(pp,i1(1),i1(2),i1(3))
c     rmodh2=rho/0.5

      return
      end
*---------------------------
      function angH1H2(i1,i2)
      USE General

      dimension i1(3),i2(3)

c     rh1=rmodH(i1)
c     rh2=rmodH(i2)

      rh1=2.0*rhof(pp,i1(1),i1(2),i1(3))
      rh2=2.0*rhof(pp,i2(1),i2(2),i2(3))

      prodS=rh1*rh2
      a2=cstar(1)**2
      b2=cstar(2)**2
      c2=cstar(3)**2

      prodV=a2*i1(1)*i2(1)+b2*i1(2)*i2(2)+c2*i1(3)*i2(3) +
     +     (i1(1)*i2(2)+i2(1)*i1(2))*cstar(1)*cstar(2)*cstar(6) +
     +     (i1(1)*i2(3)+i2(1)*i1(3))*cstar(1)*cstar(3)*cstar(5) +
     +     (i1(2)*i2(3)+i2(2)*i1(3))*cstar(2)*cstar(3)*cstar(3)

      angcos=prodV/prods
      if (angcos.gt.1.0) angcos=1.0
      if (angcos.lt.-1.0) angcos=-1.0
      angH1H2=acos(angcos)

      return
      end
c-----------------------------------------
      subroutine sortz(lind,numb,iblk,jump)
!
      USE BuildModule
      USE BuildStuff
!--sort the data in store
!
!  lind  addres in store
!  numb  number of block of data to be sorted
!  iblk  block lenght of the data (i.e. number of items per block)
!  jump  < 0 sort in decreasing order
!  jump  > 0 sort in increasing order
!  iabs(jump-1) = relative addres of the key of sort
!
      USE BigStore
!
      if (numb.le.1) then
          return
      endif
      jsig=1
      if (jump.lt.0) then
          jump = iabs(jump)
          jsig = -1
      endif
      jump = jump - 1
      ja = 2
      kVai = 1
      do while (kVai.eq.1)
         jb = numb / ja
         if (jb.le.0) then 
             jb = 1
         endif
         jc = numb - jb
 2040    continue
         jd = 0
         m  = lind
         do i=1,jc
            mk = m + jb * iblk
            if ((store(m+jump)-store(mk+jump))*jsig.gt.0) then
                mm = m
                mmk = mk
                do je=1,iblk
                   f          = store(mm)
                   store(mm)  = store(mmk)
                   store(mmk) = f
                   mm  = mm + 1
                   mmk = mmk + 1
                enddo
                jd = 1
            endif
            m = m + iblk
         enddo
         if (jd.gt.0) then
             go to 2040
         endif
         if (jb.gt.1) then
             ja = ja * 2
         else
             kVai = 0
         endif
      enddo
c
      return
      end
c-----------------------------------------
cDritan come sortz ma il vettore e' assegnato dinamicamente
code for sortz_mem
      subroutine sortz_mem(store,lind,numb,iblk,jump)
c--sort the data in store
c
c  lind  addres in store
c  numb  number of block of data to be sorted
c  iblk  block lenght of the data (i.e. number of items per block)
c  jump  < 0 sort in decreasing order
c  jump  > 0 sort in increasing order
c  iabs(jump) = relative addres of the key of sort
c
      dimension store(*)
c
      jsig=1
      if (jump.lt.0) then
                       jump=iabs(jump)
                       jsig=-1
                     endif
      if (numb.eq.1) return
      jump=jump-1
      ja=2
2010  continue
      jb=numb/ja
      if(jb) 2020,2020,2030
2020  continue
      jb=1
2030  continue
      jc=numb-jb
2040  continue
      jd=0
      m=lind
      do 2070 i=1,jc
      mk=m+jb*iblk
      if ((store(m+jump)-store(mk+jump))*jsig) 2060,2060,2050
 2050 continue
      mm=m
      mmk=mk
      do 2055 je=1,iblk
      f=store(mm)
      store(mm)=store(mmk)
      store(mmk)=f
      mm=mm+1
      mmk=mmk+1
 2055 continue
      jd=1
 2060 continue
      m=m+iblk
 2070 continue
      if (jd) 2080,2080,2040
 2080 continue
      if (jb-1) 2100,2100,2090
 2090 continue
      ja=ja*2
      go to 2010
 2100 continue
      return
      end
c-----------------------------------------------------
      subroutine stst
c--print the test (centro)
      USE General
      USE Symmetry
!
      common/tst/nt,ar(26),nn(11,26,3),ppv(11,26,3)
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common /pseud/ emmePS,patom,qatom,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef
      dimension pa(11,26,3),vmjn(4)
c
      write(lo,1000)
 1000 format(1h0,' number of relations(nr),number of correct rel.',
     2'(nc) and percentage(%) of correct relationship ')
      write(lo,1001)
 1001 format(///)
      write(lo,1010)
 1010 format(14x,'rel.posit.',20x,'rel.negat.',//,
     2 1x,5h arg.,2(9x,3hnr.,4x,3hnc.,4x,1h%,2x),/)
      do 1030 l=1,2
      do 1020 i=1,nt
      if (nn(1,i,l).gt.0) then
                            fn=float(nn(1,i,l))
                            pa(1,i,l)=ppv(1,i,l)*100.0/fn
                          else
                            pa(1,i,l)=0.0
                          endif
 1020 continue
 1030 continue
      do 1050 i=1,nt
      if (nn(1,i,1).eq.0.and.nn(1,i,2).eq.0) go to 1050
      write(lo,1040)ar(i),(nn(1,i,l),ppv(1,i,l),pa(1,i,l),l=1,2)
 1040 format(f5.1,2(5x,i7,2f7.1))
 1050 continue
      return
      end
c--------------------------------------------------
      subroutine nstst
c--print the test (non-centro)
c
      USE General
      USE Symmetry
!
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common /pseud/ emmePS,patom,qatom,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
c
      write(lo,1000)
1000  format(' number of relationships(nr), percentages(%) of correct si
     *gns',/,' average errors in relationships')
      write(lo,1001)
 1001 format(///)
      en=float(mjn(1,1))/10.0
      write(lo,1010)
 1010 format(20x, 'positive rel.',25x,'negative rel.')
      write(lo,1020)
 1020 format(3x,2hg ,1x,2(8x,'nr.    %     <|phi|>         '),//)
      do 1100 j=1,3
      do 1090 i=1,ns
      if(nb(1,i,j)) 1090,1090,1030
 1030 continue
      fn=1.0/float(nb(1,i,j))
      fnb(1,i,j)=fnb(1,i,j)*fn*100.0
      bcm(1,i,j)=bcm(1,i,j)*fn
 1090 continue
 1100 continue
      do 1110 i=1,ns
*     do 1105 j=1,2
*     if (nb(1,i,j).gt.0) then
*                   arg=rtod*atan2( acm(1,i,j) , bcm(1,i,j))
*                   arg=rtod*atan( acm(1,i,j) / bcm(1,i,j))
*                   arg=amod(arg+3600.0,360.0)
*                   if (arg.gt.180.0) arg=360-arg
*                   bcm(1,i,j)=arg
*                 endif
*1105 continue
      write(lo,1120) br(i),(nb(1,i,j),fnb(1,i,j),bcm(1,i,j),j=1,2)
 1120 format(f5.1,3(5x,i7,f7.1,f9.3,9x))
 1110 continue
      return
      end
c------------------------------------------------------
      subroutine nctet(aa,cc,ang,j)
c--test for the correct coincidence (non-centro)
c
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
c
      if (aa.lt.0.0) then
                       kk=2
                     else
                       kk=1
                     endif
      bb=abs(aa)
      do 1100 i=1,ns
      ii=i
      if(br(i)-bb) 1020,1020,1200
1020  continue
       nb(j,ii,kk)= nb(j,ii,kk)+1
      bcm(j,ii,kk)=bcm(j,ii,kk)+ang
      a=aa*cc
      if(a) 1100,1030,1030
1030  continue
      fnb(j,ii,kk)=fnb(j,ii,kk)+1.0
1100  continue
1200  continue
      return
      end
c------------------------------------------------------
cadd dritan
      subroutine nctetgatt(aa,cc,ang,j)
c--test for Gatt
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
c
      if (aa.lt.0.0) then
                       kk=2
                     else
                       kk=1
                     endif
      bb=abs(aa)
      do 1100 i=1,ns
      ii=i
      if(br(i)-bb) 1020,1020,1200
1020  continue
       nb(j,ii,kk)= nb(j,ii,kk)+1
      bcm(j,ii,kk)=bcm(j,ii,kk)+ang
      a=abs(aa)*cc
      if(a) 1100,1030,1030
1030  continue
      fnb(j,ii,kk)=fnb(j,ii,kk)+1.0
1100  continue
1200  continue
      return
      end
cend add dritan
c--------------------------------------------------------
      subroutine nclrt
c--prepare the test buffer (non-centro)
c
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)

      ns=15
      br(1)=0.0
      br(2)=0.2
      br(3)=br(2)+0.2
      do 1100 i=4,7
      br(i)=br(i-1)+0.4
1100  continue
      do 1110 i=8,11
      br(i)=br(i-1)+0.6
1110  continue
      br(12)=5.5
      br(13)=6.5
      br(14)=9.0
      br(15)=15.0

      do 1140 k=1,11
      do 1140 j=1,3
      do 1150 i=1,ns
      nb (k,i,j)=0
      fnb(k,i,j)=0.0
      bcm(k,i,j)=0.0
      acm(k,i,j)=0.0
1150  continue
1140  continue
      return
      end
c--------------------------------------------------------
      subroutine nclrtgatt
c--prepare the test buffer: per la statistica di Gatt
c
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)

      ns=15
      br(1)=0.0
      do 1100 i=2,7
      br(i)=br(i-1)+0.4
1100  continue
      do 1110 i=8,11
      br(i)=br(i-1)+0.6
1110  continue
      br(12)=5.5
      br(13)=6.5
      br(14)=9.0
      br(15)=15.0

      do 1140 k=1,11
      do 1140 j=1,3
      do 1150 i=1,ns
      nb (k,i,j)=0
      fnb(k,i,j)=0.0
      bcm(k,i,j)=0.0
      acm(k,i,j)=0.0
1150  continue
1140  continue
      return
      end
c-----------------------------------------------------
      subroutine clrt
c--prepare the test buffer (centro)
      common/tst/nt,ar(26),nn(11,26,3),ppv(11,26,3)
      ar( 1)=.0
      ar( 2)=.2
      ar( 3)=.4
      ar( 4)=.6
      ar( 5)=.8
      ar( 6)=1.
      ar( 7)=1.2
      ar( 8)=1.4
      ar( 9)=1.6
      ar(10)=2.
      ar(11)=2.4
      ar(12)=2.8
      ar(13)=3.2
      ar(14)=3.4
      ar(15)=3.8
      ar(16)=4.2
      ar(17)=4.6
      ar(18)=5.0
      ar(19)=5.5
      ar(20)=6.0
      ar(21)=6.5
      ar(22)=7.
      ar(23)=7.5
      ar(24)=8.0
      ar(25)=8.5
      ar(26)=9.0
      nt=26
      do 100 k=1,11
      do 100 l=1,3
      do 200 i=1,nt
      nn(k,i,l)=0
      ppv(k,i,l)=0
 200  continue
 100  continue
      return
      end
c----------------------------------------------------------
      subroutine sctst(aa,cc,j)
c--test for the correct coincidence (centro)
      common/tst/nt,ar(26),nn(11,26,3),ppv(11,26,3)
c
      if(aa.lt.0) then
                    k=2
                  else
                    k=1
                  endif
      bb=abs(aa)
      do 1100 i=1,nt
      if(ar(i)-bb)1020,1020,1200
 1020 continue
      nn(j,i,k)=nn(j,i,k)+1
      if(cc)1100,1030,1030
 1030 continue
      ppv(j,i,k)=ppv(j,i,k)+1.0
 1100 continue
 1200 continue
      return
      end
c----------------------------------------------------------------------
      subroutine nclrtd
c--prepare the test buffer (non-centro) differential
c
      common /nctstd/ nsd,brd(15),nbd(11,15,3),fnbd(11,15,3),
     *                bcmd(11,15,3),acmd(11,15,3)

      nsd=8
      brd(1)=0.0
      brd(2)=0.2
      brd(3)=0.4
      brd(4)=0.8
      brd(5)=1.2
      brd(6)=1.6
      brd(7)=2.0
      brd(8)=15.0

      do 1140 k=1,11
      do 1140 j=1,3
      do 1150 i=1,nsd
      nbd (k,i,j)=0
      fnbd(k,i,j)=0.0
      bcmd(k,i,j)=0.0
      acmd(k,i,j)=0.0
1150  continue
1140  continue
      return
      end
c----------------------------------------------------------------------
      subroutine nctetd(aa,cc,ang,j)
c--test for the correct coincidence (non-centro)
c
      common /nctstd/ nsd,brd(15),nbd(11,15,3),fnbd(11,15,3),
     *       bcmd(11,15,3),acmd(11,15,3)
c
      if (aa.lt.0.0) then
                       kk=2
                     else
                       kk=1
                     endif
      bb=abs(aa)
      do 1100 i=1,nsd-1
      ii=i
      if(brd(i)-bb) 1020,1020,1200
1020  continue
      if(brd(i+1)-bb) 1100,1100,1025
1025  continue
       nbd(j,ii,kk)= nbd(j,ii,kk)+1
      bcmd(j,ii,kk)=bcmd(j,ii,kk)+ang
      a=aa*cc
      if(a) 1100,1030,1030
1030  continue
      fnbd(j,ii,kk)=fnbd(j,ii,kk)+1.0
1100  continue
1200  continue
      return
      end
c----------------------------------------------------------------------
      subroutine nststd
c--print the test (non-centro) - differential
c
      USE General
      USE Symmetry
!
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common /pseud/ emmePS,patom,qatom,lpseud(4,3)
     1         ,scale,jmme,prod,prod2,mjn(5,11),njn,coef
      common /nctstd/ nsd,brd(15),nbd(11,15,3),fnbd(11,15,3),
     *       bcmd(11,15,3),acmd(11,15,3)
c
      write(lo,1000)
1000  format(' number of relationships(nr), percentages(%) of correct si
     *gns',/,' average errors in relationships')
      write(lo,1001)
 1001 format(///)
      en=float(mjn(1,1))/10.0
      write(lo,1010)
 1010 format(23x, 'positive rel.',25x,'negative rel.')
      write(lo,1020)
 1020 format(6x,2hg ,1x,2(11x,'nr.    %     <|phi|>         '),//)
      do 1100 j=1,3
      do 1090 i=1,nsd
      if(nbd(1,i,j)) 1090,1090,1030
 1030 continue
      fnd=1.0/float(nbd(1,i,j))
      fnbd(1,i,j)=fnbd(1,i,j)*fnd*100.0
      bcmd(1,i,j)=bcmd(1,i,j)*fnd
 1090 continue
 1100 continue
      do 1110 i=1,nsd-1
      write(lo,1120) brd(i),brd(i+1),(nbd(1,i,j),
     *               fnbd(1,i,j),bcmd(1,i,j),j=1,2)
 1120 format(f5.1,' -',f5.1,3(5x,i7,f7.1,f9.3,9x))
 1110 continue
      return
      end
!----------------------------------------------------------------------
      subroutine wrhead
      USE General
      USE Grafici
      USE Molcom
      USE Html
!
      character str*80
      character strLog*200,sname*80
      character*40 stringa
!
      cardGR(:) = ' '
!
!-- write the Header
!
c     write(ktml,100)
      stringa = '     Mad/Sad procedure'
      ls = Lung(stringa)

      k=index(fname(1),'.bin') -1
      call sirdate(Inte,icod)
      str=Inte
      k1=index(fname(1)(1:k),'_task') -1
      k1=max(1,k1)
      k2=index(fname(1)(1:k),'_edm') -1
      k2=max(1,k2)

      if (k1 == 1.and.k2 == 1) then
            k1 = k
      elseif (k1 == 1) then
            k1 = k2
      endif 
      
      if (icod.eq.0) then
        HTMLdate = ' '
        Msg = ProgName(1:lProgName) // ' starts on:   '//fname(1)(1:k1)
        write(data_ora,'(30x,a)') Msg
        headersGR(1) = ' '
      else
        HTMLdate = 'Date: ' // Inte(1:icod)
        Msg = Inte(1:icod) // '  ' //
     *       ProgName(1:lProgName) // ' starts on:   '//fname(1)(1:k1)
        write(data_ora,'(a)') Msg(1:256)
        headersGR(1) = Inte(1:icod)
      endif

      HTMLname = 'Structure name: ' // fname(1)(1:k1)
!
      headersGR(2) = ' '
!
      if (icod.eq.0) then
          messh=' SIRprot runs on:   '//fname(1)(1:k1)
          write(strLog,25)fname(1)(1:k1)
      else
          messh=str(1:icod)//' SIRprot runs on:   '//fname(1)(1:k1)
          write(strLog,35)fname(1)(1:k1),str(1:icod)
      endif
 
      write(lo,10) messh


   10 format(1h ,a,//)
   20 format(/,' Structure name: ',a)
   25 format(' Structure name: ',a)
   30 format(/,' Date: ',a,/,' Structure name: ',a)
   35 format(' Structure name: ',a,'         --   ',a,'--' )
  100 format('<p align="left"><font size="3" style="font-family: ',
     *       'times new roman,times,serif;" color="#FF0000"><b>')
!
      return
      end

!-----------------------------------------------------------------------
      subroutine CheckPath(ier)
      USE General
      USE Molcom
      USE spginfom                  !!mr
!
!
!-- add path to data files and check if they exist
!
! ---
      integer ex1, ex2, ex3, ex4, ex5, ex6, ex7, ex8, ex9, ex11
!
      if (ifDebug == 0) then
*         call manage_console(1)
      endif
      ier = 0
!
!-- add extensions to the package name 
!
      cardImage   = ffile
      ffile  = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = sirtx
      sirtx  = ProgName(1:lProgName) //  cardImage(1:Lung(cardImage))
      cardImage   = iasun
      iasun  = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = ciffle
      ciffle = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = psfle
      psfle  = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = rotfle
      rotfle = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = grufle
      grufle = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = extgroup
      extgroup = 'Sir' //  cardImage(1:Lung(cardImage))
!
!-- add path to data files
!-- exepath path to "sir2002.exe directory" //  "sirdir"
!                    directory where read-only files are stored
!-- cfgpath path to .cfg & .pal files
!                    directory where read/write files are stored
!
      i1 = Lung ( exepath )
      j1 = Lung(sirtx)
      j2 = Lung(ffile)
      j3 = Lung(iasun)
      j4 = Lung(ciffle)
      j5 = Lung(psfle)
      j6 = Lung(grufle)
      j7 = Lung(extgroup)
      j8 = Lung(syminfo)
      j9 = Lung(histlib)
      j10 = Lung(rotfle)
      j11 = Lung(hetero)
!
      if (i1.gt.0) then
          cardImage=' '
          cardImage(1:i1)=exepath
          cardImage(i1+1:i1+j1)=sirtx
          sirtx=cardImage
!
          cardImage=' '
          k = index(exepath, 'sirprotdir',BACK=.true.)
          if (k > 0) then
              exepath(k:) = 'files' // slash
              i2 = Lung(exepath)
          else
              i2 = i1
          endif

!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j2)=ffile
          ffile=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j3)=iasun
          iasun=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j4)=ciffle
          ciffle=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j5)=psfle
          psfle=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j6)=grufle
          grufle=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j10)=rotfle
          rotfle=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j7)=extgroup
          extgroup=cardImage
!
**        cardImage=' '
**        k = index(exepath, 'sirdir',BACK=.true.)
**        if (k > 0) then
**            exepath(k:) = 'files' // slash
**            i2 = Lung(exepath)
**        else
**            i2 = i1
**        endif

!mr          k = index(exepath, 'ilmilione',BACK=.true.)
!mr          if (k > 0) then
!mr              exepath(k:) = 'ilmilione' // slash // 'files' // slash
!mr              i2 = Lung(exepath)
!mr          else
!mr              i2 = i1
!mr          endif
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j8)=syminfo
          syminfo=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j9)=histlib
          histlib=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j11)=hetero
          hetero=cardImage
!
      endif
      j1 = j1 + i1
      j2 = j2 + i2
      j3 = j3 + i2
      j4 = j4 + i2
      j5 = j5 + i2
!v1.1 j6 = j6 + i2
      j7 = j7 + i2
      j8 = j8 + i2
      j9 = j9 + i2
      j10=j10 + j2
      j11=j11 + j2
!
!-- check if files exist
!
      itipo=2
      iform=1
      jop=jopen(kform,sirtx,itipo,iform,ierr)
      if (jop.lt.0) then
          ex1 = 0
        else
          ex1 = 1
          close(kform)
      endif
!
      jop=jopen(kform,ffile,itipo,iform,ierr)
      if (jop.lt.0) then
          ex2 = 0
        else
          ex2 = 1
          close(kform)
      endif
!
      jop=jopen(kform,iasun,itipo,iform,ierr)
      if (jop.lt.0) then
          ex3 = 0
        else
          ex3 = 1
          close (kform)
      endif
!
      jop=jopen(kform,ciffle,itipo,iform,ierr)
      if (jop.lt.0) then
          ex4 = 0
        else
          ex4 = 1
          close (kform)
      endif
!
      jop=jopen(kform,psfle,itipo,iform,ierr)
      if (jop.lt.0) then
          ex5 = 0
        else
          ex5 = 1
          close (kform)
      endif
!
      jop=jopen(kform,grufle,itipo,iform,ierr)
      if (jop.lt.0) then
          ex6 = 0
      else
          ex6 = 1
          close (kform)
      endif
!
      jop=jopen(kform,rotfle,itipo,iform,ierr)
      if (jop.lt.0) then
          ex10 = 0
      else
          ex10 = 1
          close (kform)
      endif
!
      jop=jopen(kform,extgroup,itipo,iform,ierr)
      if (jop.lt.0) then
          ex7 = 0
      else
          ex7 = 1
          close (kform)
      endif
!
      jop=jopen(kform,syminfo,itipo,iform,ierr)
      if (jop.lt.0) then
          ex8 = 0
      else
          ex8 = 1
          call spg_set_symmetry_file(syminfo)      !!mr
          close (kform)
      endif
!
      jop=jopen(kform,histlib,itipo,iform,ierr)
      if (jop.lt.0) then
          ex9 = 0
      else
          ex9 = 1
          close (kform)
      endif
!
      jop=jopen(kform,hetero,itipo,iform,ierr)
      if (jop.lt.0) then
          ex11 = 0
      else
          ex11 = 1
          close (kform)
      endif
!
      Missing = 0
      if (ex1.ne.1) then
          write(Msg,70) sirtx(1:j1)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -2
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') sirtx(1:j1)
      endif
      if (ex2.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') ffile(1:j2)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) ffile(1:j2)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
            else
              write(lo,80) ffile(1:j2)
          endif
      endif
      if (ex3.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') iasun(1:j3)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) iasun(1:j3)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
            else
              write(lo,80) iasun(1:j3)
          endif
      endif
      if (ex4.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') ciffle(1:j4)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) ciffle(1:j4)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
            else
              write(lo,80) ciffle(1:j4)
          endif
      endif
      if (ex5.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') psfle(1:j5)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) psfle(1:j5)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
            else
              write(lo,80) psfle(1:j5)
          endif
      endif
      if (ex6.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') grufle(1:j6)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) grufle(1:j6)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
            else
              write(lo,80) grufle(1:j6)
          endif
      endif
      if (ex10.ne.1) then
          if (Missing == 0) then
              write(*,10)
              Missing = 1
          endif
          write(*,'(a)') rotfle(1:j10)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) rotfle(1:j10)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
            else
              write(lo,80) rotfle(1:j10)
          endif
      endif
      if (ex7.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') extgroup(1:j7)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) extgroup(1:j7)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
            else
              write(lo,80) extgroup(1:j7)
          endif
      endif
      if (ex8.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') syminfo(1:j8)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) syminfo(1:j8)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
            else
              write(lo,80) syminfo(1:j8)
          endif
      endif
      if (ex9.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') histlib(1:j9)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) histlib(1:j9)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
            else
              write(lo,80) histlib(1:j9)
          endif
      endif
      if (ex11.ne.1) then
          if (Missing == 0) then
              write(*,10)
              Missing = 1
          endif
          write(*,'(a)') hetero(1:j11)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) hetero(1:j11)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
            else
              write(lo,80) hetero(1:j11)
          endif
      endif
      if (Missing > 0) then
         ifBreak = 0
*        call LockFile(-1, 0, ifBreak)
      endif
!
      if (ier == 0 .and. ifDebug == 0) then
*         call manage_console(2)
      endif

   10 format(//,' ***** ERROR *****',/,' Missing files:')
   70 format(' File ',a,' does not exist.')
   80 format(//,' *** WARNING ***  File ',a,' does not exist.')
!
      return
      end
c-----------------------------------------------------------------------
      subroutine checkpathOld(ier)
      USE General
      USE Molcom
!
c
c-- add path to data files and check if they exist
c
!     character fname(15)*80,ext(15)*4,path(2)*80
!     common/dotdat/ fname,ext,path
c ---
      character line*256
      integer ex1, ex2, ex3, ex4, ex5, ex6
c
      ier = 0
c
c-- add path to data files ( form.dat xsir92.txt SirPal.pal struct.map)
c
      line=path(2)
      i = lung ( line )
      if (i.gt.0) fname(6)=line(1:i)//fname(6)
c---
      i = lung ( path(1) )
      j1=lung(ffile)
      j2=lung(sirtx)
      j3=lung(iasun)
      j4=lung(grufle)
      j5=lung(syminfo)
      j6=lung(histlib)
      if (i.gt.0) then
!
          line=' '
          k = index(path(1), 'ilmilione', BACK=.true.)
          if (k > 0) then
              path(1)(k:) = 'ilmilione' // slash // 'files' // slash
              i2 = Lung(path(1))
          else
              i2 = i
          endif
          line=' '
          line(1:i2)=path(1)
          line(i2+1:i2+j1)=ffile
          ffile=line
!
          line=' '
          line(1:i2)=path(1)
          line(i2+1:i2+j3)=iasun
          iasun=line
!
          line=' '
          line(1:i2)=path(1)
          line(i2+1:i2+j4)=grufle
          grufle=line
!
          line=' '
          line(1:i2)=path(1)
          line(i2+1:i2+j5)=syminfo
          syminfo=line
!
          line=' '
          line(1:i2)=path(1)
          line(i2+1:i2+j6)=histlib
          histlib=line
      endif
      j1 = j1 + i2
      j2 = j2 + i2
      j3 = j3 + i2
      j4 = j4 + i2
      j5 = j5 + i2
      j6 = j6 + i2
!
!-- check if files exist
!
      itype=2
      iform=1
      jop=jopen(kform,ffile,itype,iform,ierr)
      if (jop.lt.0) then
          ex1 = 0
        else
          ex1 = 1
          close(kform)
      endif
!
      jop=jopen(kform,iasun,itype,iform,ierr)
      if (jop.lt.0) then
          ex3 = 0
        else
          ex3 = 1
          close(kform)
      endif
!
      jop=jopen(kform,grufle,itype,iform,ierr)
      if (jop.lt.0) then
          ex4 = 0
        else
          ex4 = 1
          close(kform)
      endif
!
      jop=jopen(kform,syminfo,itype,iform,ierr)
      if (jop.lt.0) then
          ex5 = 0
      else
          ex5 = 1
          close (kform)
      endif
!
      jop=jopen(kform,histlib,itype,iform,ierr)
      if (jop.lt.0) then
          ex6 = 0
      else
          ex6 = 1
          close (kform)
      endif
!
      Missing = 0
      if (ex1.ne.1) then
          write(Msg,70) ffile(1:j1)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -2
          if (Missing == 0) then
              write(*,10)
              Missing = 1
          endif
          write(*,'(a)') ffile(1:j1)
      endif
      if (ex3.ne.1) then
          write(Msg,70) iasun(1:j3)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -2
          if (Missing == 0) then
              write(*,10)
              Missing = 1
          endif
          write(*,'(a)') iasun(1:j3)
      endif
      if (ex4.ne.1) then
          write(Msg,70) grufle(1:j4)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -2
          if (Missing == 0) then
              write(*,10)
              Missing = 1
          endif
          write(*,'(a)') grufle(1:j4)
      endif
      if (ex5.ne.1) then
          if (Missing == 0) then
              write(*,10)
              Missing = 1
          endif
          write(*,'(a)') syminfo(1:j5)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) syminfo(1:j5)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
            else
              write(lo,80) syminfo(1:j5)
          endif
      endif
      if (ex6.ne.1) then
          if (Missing == 0) then
              write(*,10)
              Missing = 1
          endif
          write(*,'(a)') histlib(1:j6)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) histlib(1:j6)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
            else
              write(lo,80) histlib(1:j6)
          endif
      endif
      if (Missing > 0) then
c         pause
          call cstop('Missig files')
      endif
!
   10 format(//,' ***** ERROR *****',/,' Missing files:')
   70 format(' File ',a,' does not exist.')
   80 format(//,' *** WARNING ***  File ',a,' does not exist.')
      end
c-----------------------------------------------------------------------
      block data sirblk
      USE PhaseModule
!

      character beg,commen,allcom(80)*14
      common /charas/ beg,commen,allcom
      character Numdigit*13
      common /cifre/ Numdigit
      common/xcardch/CardImageX,idch(6)
      character CardImageX*80,idch*1
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common/bigcom/ maxstr,maxpsi
      common /restw/ dfr(3,500),qvr(3,500),kblock(500)
      common /conue/ shi(4),ishi,shi1(4)
      common /origins/nox,noy,noz
      common /xunit/ ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      data idch/' ',',','(',')','+','-'/
      data nox,noy,noz / 2,256,2/
      data shi  / 0.0, 0.0, 0.0, 1.0/
      data shi1 / 0.0, 0.0, 0.0, 1.0/
      data ishi / 0/
c
      data Numdigit/'0123456789.-+'/
      data beg,commen /'%','>'/
      data maxcom/200/
      data allcom/'normal        ','seminvariants ','invariants    ', !  3
     *            'phase         ','fourier       ','export        ', !  6
     *            'end           ','continue      ','job           ', !  9
     *            'extend        ','edm           ','invp          ', ! 12
     *            'initialize    ','restart       ','history       ', ! 15
     *            '%             ','patterson     ','automatic     ', ! 18
     *            'hidden        ','use           ','return        ', ! 21
     *            'path          ','structure     ','data          ', ! 24
     *            'nowindow      ','window        ','ilmilione     ', ! 27
     *            '              ','              ','              ', ! 30
     *            '              ','              ','              ', ! 33
     *            '              ','              ','              ', ! 36
     *            '              ','              ','              ', ! 39
     *            '              ','coordinates   ','              ', ! 42
     *            '              ','              ','              ', ! 45
     *            '              ',34*' '/
c
      data kblock/500*0/
c--   maxstr = maximum number of strong reflections
c--   maxpsi = maximum number of weak reflections
      data maxstr,maxpsi /2000,1000/
!
!-- ex depends
!
c     jout  =  0  peaks coordinates in shelx-92 format
c           =  1  peaks coordinates in crystals format
!
      data ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
     *    /   5,   6,   7,  62,   1,     0,     0/
!
      end

!-----------------------------------------------------------------------
      subroutine CreaIsOver()
      USE General
      USE Molcom
!
!
      if (isOverFlag == 0) then
          if (ianom == 0) then
              Msg = 'EDM procedure is over'
          elseif (ianom == 3) then
              Msg = 'MIR/SIR PHASING procedure is over'
          elseif (ianom == 6) then
              Msg = 'MAD/SAD PHASING procedure is over'
          elseif (ianom == 9) then
              Msg = 'MIRAS/SIRAS PHASING procedure is over'
          endif
      else
          if (ianom == 0) then
              Msg = 'EDM procedure has been stopped by user'
          elseif (ianom == 3) then
              Msg = 'MIR/SIR PHASING procedure has been stopped by user'
          elseif (ianom == 6) then
              Msg = 'MAD/SAD PHASING procedure has been stopped by user'
          elseif (ianom == 9) then
              Msg = 
     *          'MIRAS/SIRAS PHASING procedure has been stopped by user'
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine InitGrafici(npoints, iFirstTime)
      USE General
      USE Grafici
      USE Molcom
!
!-- initialize histogram area
!
      kLarg = kscrx
      kAlt  = kscry
      stepGR = 1.5 * FntPixHeight / float(kAlt)
      tot3 = (1.0 - 2 * stepGR) / 3.0
!
      xHisto(1,:) = 0.5
      xHisto(2,:) = 1.0
!
      yHisto(1,2) = 0.0 + stepGR
      yHisto(2,2) = yHisto(1,2) + tot3
!
      yHisto(1,3) = yHisto(2,2)
      yHisto(2,3) = yHisto(1,3) + tot3
!
      yHisto(1,1) = yHisto(2,3)
      yHisto(2,1) = 1.0 - stepGR
!
      xHistF(:,:) = xHisto(:,:)
      yHistF(:,:) = yHisto(:,:)
      xHisto(1,:) = xHisto(1,:) + 0.05
      xHisto(2,:) = xHisto(2,:) - stepGR ! 0.10
      yHisto(1,:) = yHisto(1,:) + 1.75 * stepGR ! 0.10
      yHisto(2,:) = yHisto(2,:) - 1.75 * stepGR ! 0.05
!
      if (iFirstTime == 1) then
          if (npoints > 0) then
              nPointsGR = npoints
          endif
          tipoGraficiGR(1) = 4
          StringGR(1,1) = 'Cycle'
          StringGR(1,2) = 'R%'
          LegendGR(1) = 'R% vs cycle number'

          tipoGraficiGR(2) = 3
          StringGR(2,1) = 'Trials'
          StringGR(2,2) = 'CFOM'
          LegendGR(2) = 'CFOM vs trials'

!
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine RotazTot
!
      return
      end
! ----------------------------------------------------------------------
      subroutine Get_1_2(jj, ier)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine mod03
      USE General
c
c-- modify the common containing atomic species informations 
c
      implicit none
      integer :: iflg, ind, ind1, ii, i
!
!-- check to see if derivative atom has been added
!
      iflg = 0
      ind = mod(knorm, 100)
      if (no(nk) == nod(ind)) iflg = 1
!
!-- reset list 3 if knorm eq 1
!
      if (knorm == 1 .and. iflg == 1) then
          do i=8,1,-1
             if (no(i) /= 0) then
                 ind1 = i
                 exit
             endif
         enddo
         if (ind1 == nk) then
             nk=nk-1
             nat=nat-no(nk+1)
         else
             do ii=1,4
                al(ii,1)=al(ii,ind1)
                bs(ii,1)=bs(ii,ind1)
             enddo
             cl(1)=cl(ind1)
             nw(1)=nw(ind1)
             no(1)=no(ind1)
             ff(1)=ff(ind1)
             nalf(1)=nalf(ind1)
             nk=ind1-1
             nat=0
             do i=1,nk
                nat=nat+nw(i)
             enddo
         endif
      endif
c
c       check if isomorph or anom differences are used
c
      if (knorm/100 >= 2 .and. (iflg == 0 .or. nk /= 1)) then
          do ii=1,4
             if (iflg == 0) then
                 al(ii,nk+1)=al(ii,1)
                 bs(ii,nk+1)=bs(ii,1)
             else
                 al(ii,nk)=al(ii,1)
                 bs(ii,nk)=bs(ii,1)
             endif
             al(ii,1)=ald(ii,ind)
             bs(ii,1)=bsd(ii,ind)
          enddo
          if (iflg == 0) then
              cl(nk+1)=cl(1)
              nw(nk+1)=nw(1)
              no(nk+1)=no(1)
              ff(nk+1)=ff(1)
              nalf(nk+1)=nalf(1)
          else
              cl(nk)=cl(1)
              nw(nk)=nw(1)
              no(nk)=no(1)
              ff(nk)=ff(1)
              nalf(nk)=nalf(1)
          endif
c         cl(1)=cld(ind)+ffirst(ind)
          cl(1)=cld(ind)
          nw(1)=nwd(ind)
          no(1)=nod(ind)
          nk=1
          nat=nwd(ind)
          ff(1)=fd
          nalf(1)=nalfd(ind)
      else
          if (knorm/100 == 1) then
              if (iflg == 1 .and. nk == 1) then
                  do ii=1,4
                     al(ii,1)=al(ii,ind1)
                     bs(ii,1)=bs(ii,ind1)
                  enddo
                  cl(1)=cl(ind1)
                  nw(1)=nw(ind1)
                  no(1)=no(ind1)
                  ff(1)=ff(ind1)
                  nalf(1)=nalf(ind1)
                  nk=ind1-1
              endif
              if (iflg == 0 .or. nk == 1) then
                  nk=nk+1
                  nat=nat+nwd(ind)
                  ff(nk)=fd
                  do ii=1,4
                     al(ii,nk)=ald(ii,ind)
                     bs(ii,nk)=bsd(ii,ind)
                  enddo
c                 cl(nk)=cld(ind)+ffirst(ind)
                  cl(nk)=cld(ind)
                  nw(nk)=nwd(ind)
                  no(nk)=nod(ind)
                  nalf(nk)=nalfd(ind)
              endif
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
*gl*  subroutine snr07(vett)
*gl*  dimension vett(*)
!
*gl*  ii = kldnr(in,vett)
!
*gl*  return
*gl*  end
! ----------------------------------------------------------------------
      subroutine PutGetDerivInfo(iAction)
      USE General
      USE Properties
!
!-- Manage derivates scattering factors
!
      implicit none
      integer :: iAction, i, j, ier, puntatore(18), WP, ipos, WPs
!
      WPs = WhichProps
      WP = 2
      if (iAction ==1 ) then
          nk = nkd
          do i=1, nkd
             write(Species(i),'(a4)') nalfd(i)
             nalf(i) = nalfd(i)
             nw(i) = nwd(i)
             do j=1,5
                AtmProperties(WP)%ffirst(i,j) = ffirst(i,j)
                AtmProperties(WP)%fsecon(i,j) = fsecon(i,j)
             enddo
          enddo
          AtmProperties(WP)%nkd = nkd
          AtmProperties(WP)%nwd(1:nkd) = nwd(1:nkd)
          AtmProperties(WP)%nalfd(1:nkd) = nalfd(1:nkd)
          ier = 0
          call LeggiXEN(WP, puntatore, ier)
      else
          nkd = AtmProperties(WP)%nkd
          nwd(1:nkd) = AtmProperties(WP)%nwd(1:nkd)
          natd = 0
          do i=1, nkd
             ipos = i
             nod(ipos)    = AtmProperties(WP)%z(i)
             nalfd(ipos)  = AtmProperties(WP)%nalfd(i)
             nanomv(ipos) = AtmProperties(WP)%nanomv(i)
             nod(ipos)    = AtmProperties(WP)%z(i)
             if (nod(ipos).gt.1) natd=natd+nwd(ipos)
             cld(ipos)    = AtmProperties(WP)%c(i)
             do j=1,4
                ald(j,ipos) = AtmProperties(WP)%a(j,i)
                bsd(j,ipos) = AtmProperties(WP)%b(j,i)
             enddo
             do j=1,5
                ffirst(ipos,j) = AtmProperties(WP)%ffirst(ipos,j)
                fsecon(ipos,j) = AtmProperties(WP)%fsecon(ipos,j)
             enddo
          enddo
      endif
      WhichProps = WPs
      call GetFromAtmStruct
!
      return
      end
! ----------------------------------------------------------------------
code for yfl33
      subroutine yfl33
c--form absolute list 33
c
c  l3  location of the information for the first form factor
c  n3  number of form factors
c
c--
      USE General
      USE BigStore
      USE Liste
!
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c--

      call PutGetDerivInfo(2)
      return

      sys03=1.0
      call srdls(33,ly,nfl,lz)
      l3g=nfl
      n3    = store(l3g+5)
      l3    = store(l3g+6) +l3g
      md3   = store(l3g+7)

      l=lz-1
      li=0 ! dritan
      call xsac(33,ly,li,l)
      nkd=n3
      m3=l3
      natd=0
      do i=1,n3
         ipos=nint(store(m3+26))
         nalfd(ipos)=kshuttle(m3)
         nanomv(ipos)=kshuttle(m3+1)
         nwd(ipos)= store(m3+12)
         nod(ipos)= store(m3+13)
         cld(ipos)=store(m3+2)
         if (nod(ipos).gt.1) natd=natd+nwd(ipos)
         m3i=m3+3
         do j=1,4
            ald(j,ipos)=store(m3i )
            bsd(j,ipos)=store(m3i+1)
            m3i=m3i+2
         enddo
         idr1=0
         do idr=1,5
           ffirst(ipos,idr)=store(m3+14+idr1)
           fsecon(ipos,idr)=store(m3+14+idr1+1)
           idr1=idr1+2
         enddo
         m3=m3+md3
      enddo
!
      return
      end
c
code for yfrm33
      subroutine yfrm33(ier)
c--form list 33, form factors for derivatives
c
      USE General
      USE BigStore
      USE Liste
!
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/workc/fnum(200)
      dimension dta(2,8,8)
*CAOS dimension anomal(2,20),janomal(20)
      dimension ibuf(40),ipresi(8),ileft(8)
      character*16 vetch
c--
c     do i=1,nkd
c     write(6,'(2x,a2)') nalfd(i)
c     enddo

      call PutGetDerivInfo(1)
      return

      idiffr = 1
      idiffr = neutro
      len = 12
      jan = -1
      ierr=0
      iwac=1
      itype=2
      iform=1
      if(jopen(kform,ffile,itype,iform,ierr)) 9200,1013,1013
1013  continue
      ja=20
      n3=nkd
      do 1000 i=1,nkd
      fnum(i)=nwd (i)
1000  continue
      n3a=n3
c--form list 33
      nfl=1
      kn = 33
      call xcln(kn,store(nfl))
      store(nfl+4)=1.0
c     md3=18
      md3=27
      store(nfl+5)=float(n3)
      store(nfl+6)=12.0
      store(nfl+7)=md3
      store(nfl+8)=iwac
      lz=nfl+len
c
c--read the title on the file
      nta=nt
      nt=80
      rewind kform
      do i=1,40
         ibuf(i)=ib
      enddo
      read(kform,'(a120)',iostat=ierr,err=9100) buffer_ctrl_M
      call filtra(buffer_ctrl_M)
      read(buffer_ctrl_M,2006,iostat=ier,err=9100)(ibuf(i),i=1,40)
2006  format(40a2)
c--read number of records per atomic specie
      if (jrcrd(kform).eq.-1) then
          write(Msg,9110) ffile
          call MsgWinErr('ERROR', Msg, SEVERE_ERR_WINDOW, nExitCode)
          ier=-1
          return
      endif
      ncard=jredi()
      if(ncard.ge.iwac+3)goto 2010
      write(Msg,9110) ffile
      call MsgWinErr('ERROR', Msg, SEVERE_ERR_WINDOW, nExitCode)
      goto 9300
c--read the contents for each atomic specie
2010  continue
      if(jrcrd(kform).eq.-1) go to 9000
      jrca_result = jrca(ibuf,n,vetch)
c     write(6,*) 'dopo jrca ',vetch
      if(jrca_result) 9100,2030,9100
2030  continue
      if(ibuf(1).eq.ih)goto 2100
      ix=kcomp(1,ibuf,nalfd,n3,1)
      if(ix) 2100,2100,2040
2040  continue
      nc=1
      n3a=n3a-1
      do i=1,md3
      store(lz+i-1)=0.0
      enddo
!gl!  kgian= jst03(lz,fnum(ix),ncard,iwac,idiffr,kform)
      kgian= jst03(lz,fnum(ix),ncard,     idiffr,kform)
      if (kgian) 9100,2050,3100
2050  continue
***   lz=lz-md3    ????
      store(lz+1)=xshuttle(nanomv(ix))
      idr1=0
      do idr=1,5
       store(lz+14+idr1)=ffirst(ix,idr)
       store(lz+14+idr1+1)=fsecon(ix,idr)
       idr1=idr1+2
      enddo
      store(lz+26)=ix
      lz=lz+md3
      if(n3a) 3000,3000,2010
2100  continue
      do 2150 i=1,ncard-1
      if(jrcrd(kform).eq.-1) return
2150  continue
      go to 2010
c--close the 'form.dat' file
3000  continue
      close(kform,iostat=ier,err=9100)
      n=lz-nfl
      call xfrml(33,store,n)
3100  continue
      nt=nta
      return
 9000 continue
      write(Msg,9010) char(10)
 9010 format('Atom type not expected', a ,
     *       'check content directive ')
      call MsgWinErr('ERROR', Msg, SEVERE_ERR_WINDOW, nExitCode)
      ier=-1
      return
9100  continue
      if (ierr.eq.0) then 
          write(Msg,9110) ffile
      else
          write(Msg,9120) ierr,ffile
      endif
      call MsgWinErr('ERROR', Msg, SEVERE_ERR_WINDOW, nExitCode)
 9110 format(' *** error ***  possible file corrupted. file is ',a)
 9120 format(' *** error ***  read error, code =',i5,' file is ',a)
      go to 9300
9200  continue
      write(Msg,9210) ffile
      call MsgWinErr('ERROR', Msg, SEVERE_ERR_WINDOW, nExitCode)
9210  format(' *** error ***  file not found, file is ',a)
9300  ier=-1
      return
      end
!-----------------------------------------------------------------------
      subroutine pre_list05(iAction)
!
      USE General
      USE Atomi
      USE Molcom
      USE BigStore
      USE Liste
      USE RemoModule
      USE PhaseModule
!
      if (iAction == 1) then
          nkSav = nk
          nalfSav(:) = nalf(:)
          vSpecie(:) = Species(:)
          nk = nkd
          do i=1, 5
             nalf(i) = nalfd(i)
             write(Species(i),'(a4)') nalf(i)
          enddo
          nzsav(:) = nz(:)
          do i=1,nats
             itp=iabs(nz(i))
             if (itp > 100)  itp=mod(itp,100)
             nz(i)=itp * 10000
             serial(i) = i
             bfac(i) = xyzs(4,i)
             bij(:,i) = 0.0
             iCol(i) = 1
             SinglePlotType(i) = 1
             xyLab(:,i) = 0
             nOpEq(i) = 1
             iEqui(i) = i
          enddo
      else
          nk = nkSav
          nalf(1:5) = nalfSav(1:5)
          Species(:) = vSpecie(:)
          nz(:) = nzsav(:)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiGroups()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiPDB(ifAll, ifHOH, ifHET, ifBack, inMemoryOnly,ier)
!
      USE General
      implicit none
      integer :: ifAll, ifHOH, ifHET, ifBack, inMemoryOnly, ier
      integer :: nkSav, noSav(18), nwSav(18)
!
      nkSav = nk
      noSav(:) = no(:)
      nwSav(:) = nw(:)
      call ManagePDBSir(ifAll, ifHOH, ifHET, ifBack, inMemoryOnly, ier)
      nk = nkSav
      no(:) = noSav(:)
      nw(:) = nwSav(:)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RestoreCellContent(ier)            !!gl
      USE General            !!gl
!
      WhichProps = 1
      call CreaAtmPropInfo(WhichProps, ier)
      call GetFromAtmStruct
*gl*  call yfrm03(wave,ier)            !!gl
*gl*  if (neutro /= 0) then            !!gl
*gl*      call upd03NeutronsElectrons            !!gl
*gl*  endif            !!gl
*gl*  call yfl03            !!gl
!
      return            !!gl
      end            !!gl
!-----------------------------------------------------------------------
      subroutine mrwinnew3 (nlim1,nlim2,iColor,kpix,kpiy)
      integer nlim1, nlim2, iColor, kpix(*), kpiy(*)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine matin(a,n,b,m,determ)
c--subroutine matin
c--matrix inversion with accompanying solution of linear equations
c
      dimension ipivot(160),a(3,3),b(3,3),index(160,2),pivot(160)
      equivalence (irow,jrow), (icolum,jcolum), (amax, t, swap)
c
c     initialization
c
      determ=1.0
      do j=1,n
        ipivot(j)=0
      enddo
      do i=1,n
c
c     search for pivot element
c
        amax=0.0
   45   do 105 j=1,n
   50     if (ipivot(j).eq.1) goto 105 !60, 105, 60
   60     do 100 k=1,n
   70       if (ipivot(k).eq.1) goto 100 ! 80, 100, 740
            if (ipivot(k).gt.1) return 
   80       if (abs(amax).ge.abs(a(j,k))) goto 100 !85, 100, 100
   85       irow=j
   90       icolum=k
   95       amax=a(j,k)
  100     continue
  105   continue
  110   ipivot(icolum)=ipivot(icolum)+1
c
c     interchange rows to put pivot element on diagonal
c
  130   if (irow.eq.icolum)goto 260 ! 140, 260, 140
  140   determ=-determ
  150   do l=1,n
          swap=a(irow,l)
          a(irow,l)=a(icolum,l)
          a(icolum,l)=swap
        enddo
  205   if(m.le.0) goto 260 ! 260, 260, 210
  210   do l=1, m
          swap=b(irow,l)
          b(irow,l)=b(icolum,l)
          b(icolum,l)=swap
        enddo
  260   index(i,1)=irow
  270   index(i,2)=icolum
  310   pivot(i)=a(icolum,icolum)
  320   determ=determ*pivot(i)
c
c     divide pivot row by pivot element
c
  330   a(icolum,icolum)=1.0
  340   do l=1,n
          a(icolum,l)=a(icolum,l)/pivot(i)
        enddo
  355   if(m.gt.0) then  ! 380, 380, 360
  360     do l=1,m
            b(icolum,l)=b(icolum,l)/pivot(i)
          enddo
        endif
c        
c     reduce non-pivot rows
c        
  380   do l1=1,n
          if(l1.ne.icolum) then 
            t=a(l1,icolum)
            a(l1,icolum)=0.0
            do l=1,n
               a(l1,l)=a(l1,l)-a(icolum,l)*t
            enddo
            if(m.gt.0)then 
              do l=1,m
                b(l1,l)=b(l1,l)-b(icolum,l)*t
              enddo
            endif
          endif
        enddo
      enddo
c
c     interchange columns
c
  600 do i=1,n
        l=n+1-i
        if (index(l,1).ne.index(l,2))then 
           jrow=index(l,1)
           jcolum=index(l,2)
           do k=1,n
             swap=a(k,jrow)
             a(k,jrow)=a(k,jcolum)
             a(k,jcolum)=swap
           enddo
        endif
      enddo
      return
      end
!-----------------------------------------------------------------------
      integer function kkshuttle(inStore)
      USE BigStore
      real   valore, input
      integer output
      equivalence (input, output)
!
      valore = store(inStore)
      input = valore
      kkshuttle = output
!
      return
      end
!-----------------------------------------------------------------------
      subroutine xfrm36
!
      return
      end
!-----------------------------------------------------------------------
code for sortya
      subroutine sortya(ibuffer,lind,numb,minc,jump)
c--general sorting routine
c
c  ibuffer : array to be used
c--lind :first address in the list
c--numb :number of elements in the list
c--minc :number of words per element
c--jump :function of the relative address(jaddress) of the variable
c  to be sort   (0.ge.jaddress.le.minc)
c  jump>0 increasing sorting ( jaddress=jump )
c  jump<0 decreasing sorting ( jaddress=iabs(jump)-1 )
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension  ibuffer(*)
c
      if(numb.eq.1)return
      jsign=1
      if(jump.lt.0)then ! go to 2000
      jump=iabs(jump)-1
      jsign=-1
      endif
c2000  continue
      ja=2
 2010 continue
      jb=numb/ja
      if(jb.le.0) jb=1 ! 2020,2020,2030
c 2020 continue
c      jb=1
c 2030 continue
      jc=numb-jb
 2040 continue
      jd=0
      m =lind
      do i=1,jc
      mk =m +jb*minc
      if ((ibuffer(m +jump)-ibuffer(mk +jump))*jsign > 0) then
          mm=m
          mmk=mk
          do je=1,minc
             jf=ibuffer(mm)
             ibuffer(mm)=ibuffer(mmk)
             ibuffer(mmk)=jf
             mm=mm+1
             mmk=mmk+1
          enddo
          jd=1
      endif
 2060 continue
      m =m +minc
      enddo
      if(jd.gt.0)goto 2040 ! 2080,2080,2040
 2080 continue
      if(jb.gt.1) then ! 2100,2100,2090
c 2090 continue
        ja=ja*2
        go to 2010
      endif
c 2100 continue
      return
      end
!-----------------------------------------------------------------------
      function kcomp(nw,itest,iarg,narg,nsarg)
c--standard comparision routine
c
c  nw     number of separate words to be compared
c  itest  vector holding the word(s) to be compared
c  iarg   vector holding the words against which the comparision is to
c         be made
c  narg   number of standard words to compare against
c  nsarg  the step beteen successive comparision words
c
c-- on return kcomp holds the position of the find or else -1
c--
      dimension itest(nw),iarg(narg*nsarg)
      kcomp=-1
      i=1
      j=1
1000  continue
      if(narg.lt.i)then 
        return
      endif 
      k=1
      l=j
1040  continue
*     write(ncwu,2011) itest(k),iarg(l)
*2011 format('kcomp:',' itest(k)',a2,'iarg(l)',a2)
      if(itest(k).ne.iarg(l)) goto 1080 
      if(nw.gt.k) goto 1070 
 1060  continue
      kcomp=i
      return
1070  continue
      k=k+1
      l=l+1
      go to 1040
1080  continue
      i=i+1
      j=j+nsarg
      go to 1000
      end
!-----------------------------------------------------------------------
      subroutine RiAllocaBigStore
      USE General, only: lo
      USE BigStore
      real,    allocatable :: storeTmp(:)
!
      allocate (storeTmp(1:lflValue), stat = ierr)
      if (ierr /= 0) then
          write(lo,*) 'RiAllocaBigStore Allocation error'
          call cstop(' ')
      endif
!
      lflValueSav = lflValue
      storeTmp(1:lflValueSav) = store(1:lflValueSav)
      call AllocaBigStore(2)
      lflValue = lflValue * 1.5
      call AllocaBigStore(1)
      store(1:lflValueSav) = storeTmp(1:lflValueSav)
      store(lflValueSav+1:) = 0.0
!
      deallocate (storeTmp, stat = ierr)
      if (ierr /= 0) then
          write(*,*) 'RiAllocaBigStore DeAllocation Error'
          call cstop(' ')
      endif
!
      return
      end
!-----------------------------------------------------------------------
!-- da geom2010.f del sir (utilizzate in build)
!-----------------------------------------------------------------------
!code for xpqmMNQD
      subroutine xpqmMNQD(ier)
!--main routine for l.s. plane calculation
!
      USE GENERAL
      USE Geometry
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workc/ggwc(9),grwc(9),x1(6),x2(6),x3(6),x4(6),x5(6),
     1     x6(6),eval(3),eve(3,3),ever(3,3),
     2     ainer(3,3),vv(3),vr(3),
     3     caa(3,3),xb(3),varxb(3,3),
     4     ggbis(3,3),grbis(3,3),varian(4),l28,m28,md28,n28,icomc(63)
!
      ier=0
!---- set normal equations matrix for the best plane
      call xneqpgMNQD(ainer,xb,idev,varxb)
      if(istat2.gt.0) then
         write(lo,1020) ((ainer(i,j),j=1,3),i=1,3)
 1020    format(15x,'normal equat. matrix',/,3(10x,3f15.5,/))
      endif
!--search for the eigenvalues and eigenvectors
      call eign3(xgg, xgr,ainer,eval,eve,ever,ier)
      if(ier.ne.0)return
      do i=1,3
         vv(1:3)=eve(i,1:3)
         call mv(xgg9,vv,vr)
         ever(i,1:3)=vr(1:3)
      enddo
      istat2=0
      if(istat2.gt.0) then
         write(lo,1070) (i,eval(i),(eve(i,j),j=1,3)
     1    ,                (ever(i,j),j=1,3),i=1,3)
1070     format(/,'eigenvalue',5x,'real eigenvectors'
     3        ,5x,'dual eigenvectors',/,5x,i5,2x,7f9.4)
         cin32=eval(3)/eval(2)
         cin31=eval(3)/eval(1)
         cin21=eval(2)/eval(1)
         write(lo,1080) cin32,cin31,cin21
 1080    format (/,5x,'indici di confidenza ',/,5x,3(f8.2,2x),/)
      endif
      istat2=0
      return
      end
!
!code for xneqpgMNQD
      subroutine xneqpgMNQD(tmab,bard ,ivar,gamba)
!--
      USE GENERAL
      USE Atomi
!
      dimension tmab(3,3),barr(3),bard(3),xd(3),xr(3)
      dimension gamba(3,3)
!--
      bard(:) = 0.0
      barr(:) = 0.0
      tmab(:,:) = 0.0
      gamba(:,:) = 0.0
      do n= 1,nats25
         bard(1:3) = bard(1:3)+xyzs25(1:3,n)
      enddo
      bard(1:3)=bard(1:3)/nats25
      call mv (xgg9,bard,barr)
      if(ivar.gt.0) call xvarbMNQD(gamba)
      do n=1,nats25
         xyzs25(1:3,n)=xyzs25(1:3,n)-bard(1:3)
      enddo
      do n= 1,nats25
         xd(1:3)=xyzs25(1:3,n)
         call mv(xgg9,xd,xr)
!         call ospr(xr,xd,xx)
         do k=1,3
            do l=1,3
               tmab(k,l) =tmab(k,l)+xd(k)*xr(l)
            enddo
         enddo
      enddo
      return
      end
!
!code for xvarbMNQD
      subroutine xvarbMNQD(var)
!--
      USE Atomi
      dimension var(3,3)
!--
      var(:,:) = 0.0
      do n=1,nats25
         var(1,1) = var(1,1)+xyzs25_dev(1,n)*xyzs25_dev(1,n)
         var(2,2) = var(2,2)+xyzs25_dev(2,n)*xyzs25_dev(2,n)
         var(3,3) = var(3,3)+xyzs25_dev(3,n)*xyzs25_dev(3,n)
      enddo
      var(1,1) = var(1,1)/nats25
      var(2,2) = var(2,2)/nats25
      var(3,3) = var(3,3)/nats25
      return
      end
!
!-----------------------------------------------------------------------
code for eign3
      subroutine eign3(g,gr,tm,eival,eivec,reivec,ier)                              
      USE General, only: pi,lo
      dimension g(3,3),gr(3,3),tm(3,3),eival(3),eivec(3,3)                      
      dimension reivec(3,3)                                                     
      dimension tx(3,3)                                                  
      double precision a,atrem,b,bimez,discr,p,q,r,tmdp(3,3)                              
!g    pi=3.14159                                                                
c     eigenvalues and eigenvectors of                                           
c     a 3x3 matrix in the mixed-indices                                         
c     representation                                                            
c     first index in contravariant position                                     
c     second index in covariant position                                        
c     referred to unitary axes                                                  
c                                                                               
c     set up the coefficients of secular equation                               
c     y**3+p*y**2+q*y+r=0                                                       
c     which is then reduced in the form                                         
c                                                                               
c     x**3+a*x+b=0                                                              
c     with y=x-p/3                                                              
c          a=1/3(3q-p**2)                                                       
c          b=1/27(2p**3-9p*q+27r)                                               
c                         
      ier=0
c       
      tmdp(:,:)=tm(:,:)                                                     
      p=tmdp(1,1)+tmdp(2,2)+tmdp(3,3)                                                 
      q=tmdp(1,1)*tmdp(2,2)-tmdp(1,2)*tmdp(2,1)                                         
     1 +tmdp(1,1)*tmdp(3,3)-tmdp(1,3)*tmdp(3,1)                                         
     2 +tmdp(2,2)*tmdp(3,3)-tmdp(2,3)*tmdp(3,2)                                         
      r=tmdp(1,1)*tmdp(2,2)*tmdp(3,3)                                                 
     1 +tmdp(1,2)*tmdp(2,3)*tmdp(3,1)                                                 
     2 +tmdp(2,1)*tmdp(3,2)*tmdp(1,3)                                                 
     3 -tmdp(3,1)*tmdp(2,2)*tmdp(1,3)                                                 
     4 -tmdp(3,2)*tmdp(2,3)*tmdp(1,1)                                                 
     5 -tmdp(2,1)*tmdp(1,2)*tmdp(3,3)                                                 
      p=-p                                                                      
      r = -r                                                                    
      a=(3.*q-p**2)/3.                                                          
      b=(2.*p**3-9.*p*q+27.*r)/27.                                              
      bimez=b/2.                                                                
      atrem=-a**3/27.                                                           
      discr=bimez**2-atrem                                                      
c---                                                                            
c     iwu = 7                                                                   
c     write(iwu,102) p,q,r,a,b,bimez,atrem,discr                                
      if(discr) 100,100,900                                                     
  100 continue                                                                  
      csfi=-bimez/dsqrt(atrem)                                                  
      if (csfi.gt.1)   csfi =1.0
      if (csfi.lt.-1.) csfi =-1.
      fi=acos(csfi)
      fistre=fi/3.                                                              
      csfi1=cos(fistre)                                                         
      csfi2=cos(fistre+2.*pi/3.)                                                
      csfi3=cos(fistre+4.*pi/3.)                                                
      a3sq=dsqrt(-a/3.)                                                         
c---                                                                            
c     write(iwu,102) p,q,r,a,b,bimez,atrem,discr                                
c     write(iwu,101) csfi,fi,fistre,csfi1,csfi2,csfi3,a3sq                      
c 102 format (5x,d15.8)                                                         
c 101 format(5x,f15.8)                                                          
      root1=2.*csfi1*a3sq                                                       
      root2=2.*csfi2*a3sq                                                       
      root3=2.*csfi3*a3sq                                                       
      root1=root1-p/3.                                                          
      root2=root2-p/3.                                                          
      root3=root3-p/3.                                                          
c---                                                                            
c     write(iwu,'(a,3e14.4)') 'roots:',root1,root2,root3                                          
      eival(1)=amin1(root1,root2,root3)                                         
      eival(3)=amax1(root1,root2,root3)                                         
      eival(2)=root1+root2+root3-eival(1)-eival(3)                              
      do 200 i=1,3                                                              
      tx(1,1)=tm(1,1)-eival(i)                                                  
      tx(2,2)=tm(2,2)-eival(i)                                                  
      tx(3,3)=tm(3,3)-eival(i)                                                  
      do 210 j=1,3                                                              
      eivec(i,j)=0.0                                                            
  210 continue                                                                  
      go to (201,202,203) ,i                                                    
  201 continue                                                                  
      eivec(1,1)=tx(2,2)*tx(3,3)-tm(2,3)*tm(3,2)                                
      eivec(1,2)=tm(3,1)*tm(2,3)-tm(2,1)*tx(3,3)                                
      eivec(1,3)=tm(2,1)*tm(3,2)-tm(3,1)*tx(2,2)                                
      go to 204                                                                 
  202 continue                                                                  
      eivec(2,1)=tm(1,3)*tm(3,2)-tm(1,2)*tx(3,3)                                
      eivec(2,2)=tx(1,1)*tx(3,3)-tm(1,3)*tm(3,1)                                
      eivec(2,3)=tm(1,2)*tm(3,1)-tm(3,2)*tx(1,1)                                
      go to 204                                                                 
  203 continue                                                                  
      eivec(3,1)=tm(1,2)*tm(2,3)-tm(1,3)*tx(2,2)                                
      eivec(3,2)=tm(2,1)*tm(1,3)-tm(2,3)*tx(1,1)                                
      eivec(3,3)=tx(1,1)*tx(2,2)-tm(1,2)*tm(2,1)                                
  204 continue                                                                  
      fll=0.0                                                                   
      do 250 j=1,3                                                              
      do 250 k=1,3                                                              
c-----                                                                          
c----- g(i,j) is not an unitary metric                                          
c-----                                                                          
      fll =  g(j,k)*eivec(i,k)*eivec(i,j)                                       
     1    +fll                                                                  
  250 continue                                                                  
      fll=sqrt(fll)                                                             
c                                                                               
c     contravariant components                                                  
c     of eigenvectors                                                           
c                                                                               
      eivec(i,1)=eivec(i,1)/fll                                                 
      eivec(i,2)=eivec(i,2)/fll                                                 
      eivec(i,3)=eivec(i,3)/fll                                                 
  200 continue                                                                  
c----                                                                           
c     write(iwu,1)                                                              
c   1 format (/)                                                                
c     write(iwu,103) ((eivec(i,j),j=1,3),i=1,3)                                 
  103 format(5x,3f10.5)                                                         
c----                                                                           
c                                                                               
c     covariant components                                                      
c     of eigenvectors                                                           
c                                                                               
      do 300 i=1,3                                                              
      do 310 j=1,3                                                              
      reivec(i,j) = 0.0                                                         
      do 310 k=1,3                                                              
      reivec(i,j) = reivec(i,j)+g(j,k)*eivec(i,k)                               
  310 continue                                                                  
      flr = 0.0                                                                 
      do 350 j=1,3                                                              
      do 350 k=1,3                                                              
      flr = gr(j,k)*reivec(i,j)*reivec(i,k)+flr                                 
  350 continue                                                                  
      flr = sqrt(flr)                                                           
      reivec(i,1) = reivec(i,1)/flr                                             
      reivec(i,2) = reivec(i,2)/flr                                             
      reivec(i,3) = reivec(i,3)/flr                                             
  300 continue                                                                  
c----                                                                           
c     write(iwu,1)                                                              
c     write(iwu,103) ((reivec(i,j),j=1,3),i=1,3)                                
c----                                                                           
      return                                                                
  900 continue 
      ier=-1                                                                 
c     write(lo,10) discr                                                      
c   10 format  (10x,d15.8 )                                                      
      return                                                                    
      end                                                                       
!-----------------------------------------------------------------------
code for mv
      subroutine mv(g,a,b)
c--matrix * vector multiplicatio
c
      dimension g(*)
      dimension a(*),b(*)
      idm =3
      do 10 i=1,idm
      j=(i-1)*idm
      b(i)=0.0
      do 20 l=1,idm
      b(i)=b(i)+g(j+l)*a(l)
   20 continue
   10 continue
      return
      end
!-----------------------------------------------------------------------
