#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include "ilm.h"
#include <sstream>

//#include "util.h"

//  enum Pages { MTZ, CONT, RUN};
GdkColor colorWhite = White;
GdkColor colorBlue = Blue;
GdkColor colorYellow = Yellow;

static _StyleType FrameStyle = {true, 1, NULL, GTK_SHADOW_ETCHED_IN, 3, 3, 10, 3};
static _StyleType FrameStyle1 = {true, 1, NULL, GTK_SHADOW_NONE, 3, 3, 10, 3};
static _StyleType FrameStyle2 = {false, 1, NULL, GTK_SHADOW_ETCHED_IN, 2, 2, 5, 2};


#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    g_object_ref (G_OBJECT(widget)), (GDestroyNotify) g_object_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

static mr_action_entry pmenu_entries[] = {

{0, 1, "IlmMenuFile", "File", "File Operations", NULL, NULL, NULL, -2, 1, 0},
{1, 1, "IlmMenuFileSave", "Save", "Save project file (.ilm)", "filesave", G_CALLBACK(on_save_activate), NULL, -2, 1, 0}, 
#ifndef NDEBUG
{1, 1, "IlmMenuFileSaveAscii", "Save Ascii", "Save project file as ascii (.ailm)", "filesave", G_CALLBACK(on_saveascii_activate), NULL, -2, 1, 0}, 
#endif
{1, 1, "IlmMenuFileSaveAs", "Save As", "Save project file as", "filesaveas", G_CALLBACK(on_save_as_activate), NULL, -2, 1, 0}, 
{1, 4},
{1, 1, "IlmMenuFileQuit", "Quit", "Exit project", "quit", G_CALLBACK(on_Quit), NULL, -2, 1, 0}, 
{0, 1, "IlmMenuActions", "Actions", "Actions", NULL, NULL, NULL, -2, 1, 0},
{1, 1, "IlmMenuActionsApply", "Apply", "Apply", "apply", G_CALLBACK(on_apply_activate), NULL, -2, 1, 0}, 
{1, 1, "IlmMenuActionsSetDefaults", "Set Defaults", "Set default valuess", NULL, G_CALLBACK(on_setdefaults_activate), NULL, -2, 1, 0}, 
{1, 4},
{1, 1, "IlmMenuActionsQuit", "Quit", "Exit project", "quit", G_CALLBACK(on_Quit), NULL, -2, 1, 0}, 
{0, 1, "IlmMenuProject", "Project Files", "Project files", NULL, NULL, NULL, -2, 1, 0},
{1, 1, "INPUT", "INPUT", "Input files", NULL, NULL, NULL, -2, 1, 0},
{1, 1, "IlmMenuInTask0", "Task0 Instructions", "Task0 Instructions", NULL, G_CALLBACK(on_IlmMenuInTask_activate), NULL, 0, 1, 0},
{1, 1, "IlmMenuInTask1", "Task1 Instructions", "Task1 Instructions", NULL, G_CALLBACK(on_IlmMenuInTask_activate), NULL, 1, 1, 0},
{1, 1, "IlmMenuInTask2", "Task2 Instructions", "Task2 Instructions", NULL, G_CALLBACK(on_IlmMenuInTask_activate), NULL, 2, 1, 0},
{1, 1, "IlmMenuInTask", "Task Instructions", "Task Instructions", NULL, G_CALLBACK(on_IlmMenuInTask_activate), NULL, -3, 1, 0},
{1, 4},
{1, 1, "OUTPUT", "OUTPUT", "Output files", NULL, NULL, NULL, -2, 1, 0},
{1, 1, "IlmMenuOutHtml", "HTML Summary", "HTML Summary", NULL, G_CALLBACK(on_IlmMenuOutHtml_activate), NULL, -1, 1, 0},
{1, 1, "IlmMenuOutInfo", "Files Info", "Files Info", NULL, G_CALLBACK(on_IlmMenuOutInfo_activate), NULL, -1, 1, 0},
{1, 1, "IlmMenuOutMtz", "MTZ File", "MTZ File", NULL, NULL, NULL, -1, 1, 0},
{2, 1, "IlmMenuOutMtz_text", "View Text", "View as text", NULL, G_CALLBACK(on_IlmMenuABIOutMtz_activate), NULL, -2, 1, 0},
{2, 1, "IlmMenuOutMtz_model", "View Map", "View as map", NULL, G_CALLBACK(on_IlmMenuABIOutMtz_model_activate), NULL, -2, 1, 0},
{1, 1, "IlmMenuOutPhase", "MTZ File Before EDM", "MTZ File Before EDM", NULL, NULL, NULL, -1, 1, 0},
{2, 1, "IlmMenuOutPhase_text", "View Text", "View as text", NULL, G_CALLBACK(on_IlmMenuOutPhase_activate), NULL, -2, 1, 0},
{2, 1, "IlmMenuOutPhase_model", "View Map", "View as map", NULL, G_CALLBACK(on_IlmMenuOutPhase_model_activate), NULL, -2, 1, 0},
{1, 1, "IlmMenuOutEdm", "MTZ After EDM", "MTZ After EDM", NULL, NULL, NULL, -1, 1, 0},
{2, 1, "IlmMenuOutEdm_text", "View Text", "View as text", NULL, G_CALLBACK(on_IlmMenuOutEdm_activate), NULL, 0, 1, 0},
{2, 1, "IlmMenuOutEdm_model", "View Map", "View as map", NULL, G_CALLBACK(on_IlmMenuOutEdm_model_activate), NULL, 0, 1, 0},
{1, 1, "IlmMenuOutEdm1", "MTZ After FreeLunch", "MTZ After FreeLunch", NULL, NULL, NULL, -1, 1, 0},
{2, 1, "IlmMenuOutEdm1_text", "View Text", "View as text", NULL, G_CALLBACK(on_IlmMenuOutEdm_activate), NULL, 1, 1, 0},
{2, 1, "IlmMenuOutEdm1_model", "View Map", "View as map", NULL, G_CALLBACK(on_IlmMenuOutEdm_model_activate), NULL, 1, 1, 0},
{1, 1, "IlmMenuOutMap1", "MAP After EDM", "MAP After EDM", NULL, G_CALLBACK(on_IlmMenuOutMap_activate), NULL, 0, 1, 0},
{1, 1, "IlmMenuOutMap2", "MAP After FreeLunch", "MAP After FreeLunch", NULL, G_CALLBACK(on_IlmMenuOutMap_activate), NULL, 1, 1, 0},
{1, 1, "IlmMenuOutFull", "Full Text", "Full text", NULL, G_CALLBACK(on_IlmMenuOutFull_activate), NULL, -3, 1, 0},
{1, 1, "IlmMenuOutFull0", "Full Text", "Full text", NULL, G_CALLBACK(on_IlmMenuOutFull_activate), NULL, 0, 1, 0},
{1, 1, "IlmMenuOutFull1", "Full Text", "Full text", NULL, G_CALLBACK(on_IlmMenuOutFull_activate), NULL, 1, 1, 0},
{1, 1, "IlmMenuOutFull2", "Full Text", "Full text", NULL, G_CALLBACK(on_IlmMenuOutFull_activate), NULL, 2, 1, 0},
{1, 4},
{1, 1, "IlmMenuOutPdb", "PDB Files", "PDB files", NULL, NULL, NULL, -2, 1, 0},
{2, 1, "IlmMenuOutPdb_text", "View Text", "View as text", NULL, G_CALLBACK(on_IlmMenuOutPdb_text_activate), NULL, -2, 1, 0},
{2, 1, "IlmMenuOutPdb_model", "View Model", "View as model", NULL, G_CALLBACK(on_IlmMenuOutPdb_model_activate), NULL, -2, 1, 0},
{0, 1, "IlmMenuHelp", "Help", "Help", NULL, NULL, NULL, -2, 1, 0}, 
{1, 1, "IlmMenuContent", "Content", "Help on Content", "bigcontent", G_CALLBACK(on_HelpBtn_clicked), NULL, -2, 1, 0}, 
{1, 1, "IlmMenuAbout", "About", "About ILMILIONE", "help", G_CALLBACK(on_AboutBtn_clicked), NULL, -2, 1, 0}
};
static guint n_pmenu_entries = G_N_ELEMENTS (pmenu_entries);

void do_menu_and_toolbar(GtkWidget *table, GtkWidget *Wnd,
         const char *fontname, int w, int h);

typedef struct {
                 GtkWidget *frame;
                 GtkWidget *PDBentry;
                 GtkWidget *nMonomers;
                 GtkWidget *hetero;
                 GtkWidget *PDBradio;
                 GtkWidget *Wilsonradio;
                 GtkWidget *p20radio;
                 GtkWidget *seqradio;
                 GtkWidget *rmsradio;
                 GtkWidget *entry;
                 GtkWidget *polycheck;
                 GtkWidget *cutmodel;
                 GtkWidget *fromres;
                 GtkWidget *tores;
                 GtkWidget *rotfix;
                 GtkWidget *rot1;
                 GtkWidget *rot2;
                 GtkWidget *rot3;
                 GtkWidget *transfix;
                 GtkWidget *trans1;
                 GtkWidget *trans2;
                 GtkWidget *trans3;
                 GtkWidget *edm;
                 GtkWidget *edmspin;
               } MRmodel;

typedef struct {
                 GtkWidget *manres;
                 GtkWidget *autores;
                 GtkWidget *minres;
                 GtkWidget *maxres;
                 GtkWidget *mantres;
                 GtkWidget *autotres;
                 GtkWidget *rot;
                 GtkWidget *rotlocal;
                 GtkWidget *trans;
                 GtkWidget *translocal;
               } MRtask;

_MyMTZ *page_mtz(GtkWidget *fbox1, bool ifPhases, char *filename)
{
  _MyMTZ *mymtz = g_new0(_MyMTZ, 1);
  GtkSizeGroup *szgroup1 = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
  GtkWidget *hbox2, *align, *vbox4, *vbox3, *frame;
  GtkWidget *hboxmtz2;
  GtkWidget *hboxmtz3;
  GtkWidget *hboxmtz4;
  GtkWidget *vboxmtz4;
  GtkWidget *labelmtz2;
  GtkWidget *labelmtz2b;
  GtkWidget *labelmtz3;
  GtkWidget *labelmtz4;
  GtkWidget *framemtz1;
  GtkWidget *framemtz2;
  static const char *titles[] = {"Label", "Type"};
  int sizes[] = {130, 70};

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START,GTK_ALIGN_START,0,1);
#else
  align = gtk_alignment_new(0,0,0,1);
#endif
  gtk_box_pack_start (GTK_BOX (fbox1), align, FALSE, FALSE, 0);
  gtk_widget_show(align);
  GtkWidget *fbox = vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(align), fbox);
  gtk_widget_show(fbox);
  std::string filespg = Ilm::TheApp.PkgDataDir() + "files"  + G_DIR_SEPARATOR_S + "Sir.spg";

  mymtz->mtzfile = filename;
  mymtz->entry = entry_for_filesel(NULL, "MTZ file:",
                                        "IlmIlmMtzFileEntry", 1, 1);
  set_tip (mymtz->entry, "MTZ file");
  set_width_chars (GTK_ENTRY (mymtz->entry), 60);
  mymtz->browse = get_widget (mymtz->entry, "browse");
  set_tip (mymtz->browse, "Select MTZ file");
  mymtz->view = get_widget (mymtz->entry, "preview");
  hbox2 = get_widget(mymtz->entry, "box");
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 4);
  gtk_box_pack_start (GTK_BOX (fbox), hbox2, FALSE, FALSE, 0);
  gtk_size_group_add_widget(szgroup1, get_widget(mymtz->entry, "label"));
  gtk_editable_set_editable (GTK_EDITABLE (mymtz->entry), FALSE);

  mymtz->title = entry_for_filesel(NULL, "Title:", "IlmMtzTitleEntry", 0, 0);
  hbox2 = get_widget(mymtz->title, "box");
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 4);
  gtk_box_pack_start (GTK_BOX (fbox), hbox2, FALSE, FALSE, 0);
  gtk_widget_show (mymtz->title);
  gtk_editable_set_editable (GTK_EDITABLE (mymtz->title), FALSE);
  set_width_chars (GTK_ENTRY (mymtz->title), 60);
  gtk_size_group_add_widget(szgroup1, get_widget(mymtz->title, "label"));

  hboxmtz2 = hbox_new (FALSE, 0);
  gtk_widget_show (hboxmtz2);
  gtk_box_pack_start (GTK_BOX (fbox), hboxmtz2, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hboxmtz2), 4);

  labelmtz2 = LABEL_NEW ("Change Space Group:", MyBLUE);
  gtk_widget_show (labelmtz2);
  gtk_box_pack_start (GTK_BOX (hboxmtz2), labelmtz2, FALSE, FALSE, 0);

  int ifSilent = 0;
  mymtz->spg = spgr_widget((char *)filespg.c_str(), ifSilent);
  gtk_widget_show (mymtz->spg);
  gtk_box_pack_start (GTK_BOX (hboxmtz2), mymtz->spg, FALSE, FALSE, 4);
  gtk_widget_set_size_request(mymtz->spg, 120, -1);

  mymtz->find = CHECK_BUTTON_WITH_LABEL("Check Space Group", MyBLUE);
  gtk_widget_show (mymtz->find);
  gtk_box_pack_start (GTK_BOX (hboxmtz2), mymtz->find, FALSE, FALSE, 25);
  g_signal_connect(G_OBJECT(mymtz->find), "toggled", G_CALLBACK(on_cb_disattiva), mymtz->spg);
  
  mymtz->cell = gtk_entry_new ();
  gtk_widget_show (mymtz->cell);
  gtk_box_pack_end (GTK_BOX (hboxmtz2), mymtz->cell, FALSE, FALSE, 0);
  gtk_editable_set_editable (GTK_EDITABLE (mymtz->cell), FALSE);
  gtk_widget_set_size_request(mymtz->cell, 250, -1);

  labelmtz2b = LABEL_NEW ("Cell Parameters:", MyBLUE);
  gtk_widget_show (labelmtz2b);
  gtk_box_pack_end (GTK_BOX (hboxmtz2), labelmtz2b, FALSE, FALSE, 4);

  framemtz1 = NEW_FRAME("mtz colums", &FrameStyle);
  gtk_widget_show (framemtz1);
  gtk_box_pack_end (GTK_BOX (fbox), framemtz1, TRUE, TRUE, 10);
  mymtz->hint = gtk_frame_get_label_widget (GTK_FRAME (framemtz1));

  hbox2 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_container_add (GTK_CONTAINER (get_widget(framemtz1, "align")), hbox2);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 4);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START,GTK_ALIGN_START,0,1);
#else
  align = gtk_alignment_new(0,0,0,1);
#endif
  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (hbox2), align, FALSE, FALSE, 0);

  vbox4 = vbox_new (FALSE, 4);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (align), vbox4);
  gtk_container_set_border_width (GTK_CONTAINER (vbox4), 4);

  hboxmtz4 = hbox_new (FALSE, 4);
  gtk_widget_show (hboxmtz4);
  gtk_box_pack_start (GTK_BOX (vbox4), hboxmtz4, TRUE, TRUE, 0);

  vboxmtz4 = vbox_new (FALSE, 4);
  gtk_widget_show (vboxmtz4);
  gtk_box_pack_start (GTK_BOX (hboxmtz4), vboxmtz4, TRUE, TRUE, 0);

  align = NEW_FRAME("Selected columns:", &FrameStyle2);
  gtk_box_pack_start (GTK_BOX (vboxmtz4), align, TRUE, TRUE, 0);
  gtk_widget_show (align);

  framemtz2 = gtk_scrolled_window_new( NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (framemtz2),
                                  GTK_POLICY_NEVER, 
                                  GTK_POLICY_AUTOMATIC);
  gtk_widget_set_size_request(framemtz2, -1, 60);
  gtk_widget_show (framemtz2);
  gtk_container_add (GTK_CONTAINER (get_widget(align, "align")), framemtz2);

  mymtz->columns = gtk_text_view_new ();
  gtk_widget_show (mymtz->columns);
  gtk_container_add(GTK_CONTAINER(framemtz2), mymtz->columns);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (mymtz->columns), FALSE);
  gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW (mymtz->columns), GTK_WRAP_WORD);
  gtk_text_view_set_right_margin (GTK_TEXT_VIEW (mymtz->columns), 4);
  gtk_text_view_set_left_margin (GTK_TEXT_VIEW (mymtz->columns), 4);
  //gtk_widget_set_size_request(mymtz->columns, 120, 60);

  align = NEW_FRAME("Columns: ",  &FrameStyle2);
  gtk_widget_show (align);
  gtk_box_pack_end (GTK_BOX (vbox4), align, TRUE, TRUE, 0);

  hboxmtz3 = table_new(2, 4, FALSE);
  table_set_col_spacings(hboxmtz3, 4);

//  hboxmtz3 = hbox_new (FALSE, 0);
  gtk_widget_show (hboxmtz3);
  gtk_container_add (GTK_CONTAINER (get_widget(align, "align")), hboxmtz3);
//  gtk_container_set_border_width (GTK_CONTAINER (hboxmtz3), 4);

  if(ifPhases)
     labelmtz4 = gtk_label_new ("value/phase:");
  else
     labelmtz4 = gtk_label_new ("value:");
  gtk_widget_show (labelmtz4);
//  gtk_box_pack_start (GTK_BOX (hboxmtz3), labelmtz4, FALSE, FALSE, 4);
  table_attach(hboxmtz3, labelmtz4, 0, 1, 0, 1);

  mymtz->vcombo = new_combo ();
  gtk_widget_set_size_request(mymtz->vcombo, 150, -1);
  gtk_widget_show (mymtz->vcombo);
//  gtk_box_pack_start (GTK_BOX (hboxmtz3), mymtz->vcombo, FALSE, FALSE, 4);
  table_attach(hboxmtz3, mymtz->vcombo, 0, 1, 1, 2);
//  gtk_editable_set_editable (GTK_EDITABLE (get_widget (mymtz->vcombo,"entry")), FALSE);

  if(ifPhases)
     labelmtz3 = gtk_label_new ("    esd/weight:");
  else
     labelmtz3 = gtk_label_new ("    esd:");
  gtk_widget_show (labelmtz3);
//  gtk_box_pack_start (GTK_BOX (hboxmtz3), labelmtz3, FALSE, FALSE, 8);
  table_attach(hboxmtz3, labelmtz3, 1, 2, 0, 1);

  mymtz->esdcombo = new_combo ();
  gtk_widget_set_size_request(mymtz->esdcombo, 150, -1);
  gtk_widget_show (mymtz->esdcombo);
//  gtk_box_pack_start (GTK_BOX (hboxmtz3), mymtz->esdcombo, FALSE, FALSE, 4);
  table_attach(hboxmtz3, mymtz->esdcombo, 1, 2, 1, 2);
//  gtk_editable_set_editable (GTK_EDITABLE (get_widget (mymtz->esdcombo,"entry")), FALSE);

  mymtz->add = gtk_button_new_with_mnemonic ("Add pair");
  gtk_widget_show (mymtz->add);
  table_attach(hboxmtz3, mymtz->add, 2, 3, 1, 2);
  mymtz->del = gtk_button_new_with_mnemonic ("Clear columns");
  gtk_widget_show (mymtz->del);
  table_attach(hboxmtz3, mymtz->del, 3, 4, 1, 2);

  frame = NEW_FRAME("Available columns: ", &FrameStyle2);
  gtk_widget_show (frame);
  gtk_box_pack_end (GTK_BOX (hbox2), frame, FALSE, FALSE, 8);

  vbox3 = vbox_new (FALSE, 0);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER(get_widget(frame, "align")), vbox3);
  gtk_container_set_border_width (GTK_CONTAINER (vbox3), 6);

  mymtz->allcols = new_selection(frame, vbox3, "vbox3", 
                               2, titles, sizes);
  gtk_container_set_border_width (GTK_CONTAINER (get_widget(mymtz->allcols, "frame")), 0);

  gtk_widget_show (mymtz->allcols);

  mymtz->addcol = gtk_button_new_with_mnemonic ("Add");
  gtk_widget_show (mymtz->addcol);
  gtk_box_pack_start (GTK_BOX (vbox3), mymtz->addcol, FALSE, FALSE, 0);

  g_signal_connect ((gpointer) mymtz->browse, "clicked",
                    G_CALLBACK (on_IlmMtzBrowseBtn_clicked),
                    mymtz);
  g_signal_connect ((gpointer) mymtz->view, "clicked",
                    G_CALLBACK (on_Ilm_mtz_view_clicked),
                    mymtz->entry);
  g_signal_connect ((gpointer) mymtz->add, "clicked",
                    G_CALLBACK (on_IlmMtzAddPairBtn_clicked),
                    mymtz);
  g_signal_connect ((gpointer) mymtz->del, "clicked",
                    G_CALLBACK (on_IlmMtzClearBtn_clicked),
                    mymtz);
  g_signal_connect ((gpointer) mymtz->addcol, "clicked",
                    G_CALLBACK (on_IlmMtzAddC_clicked),
                    mymtz);


  return mymtz;
}
void create_task_info(GtkWidget *father, GtkWidget *parent_box)
{
  GtkWidget *label;
  GtkWidget *spin;
  GtkWidget *radio;
  GtkWidget *align;
  GSList *group = NULL;

  MRtask *model = g_new0(MRtask, 1);
#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START,GTK_ALIGN_START,0,1);
#else
  align = gtk_alignment_new(0,0,0,1);
#endif
  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (parent_box), align, FALSE, FALSE, 0);
#ifndef CANNOT_PAD_ALIGN
#ifdef IN_GTK3
  set_margins(align, 0, 0, 0, 20);
#else
  gtk_alignment_set_padding(GTK_ALIGNMENT(align), 0, 0, 0, 20);
#endif
#endif

  GtkWidget *table = table_new(2, 7, FALSE);
  gtk_widget_show (table);
  gtk_container_add (GTK_CONTAINER (align), table);
  table_set_row_spacings(table, 10);
  table_set_col_spacings(table, 10);
  label = LABEL_BOLD ("Resolution range    ", MyBLUE, 1.1f);
  gtk_widget_show (label);
  table_attach_all(table, label, 0, 1, 0, 1);
  group = NULL;
  radio = RADIO_BUTTON_WITH_LABEL (NULL, "Automatic", MyBLUE);
  gtk_widget_show (radio);
  table_attach (table, radio, 1, 2, 0, 1);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->autores = radio;
  gtk_widget_set_name (radio, "IlmTasksMRaRes");
  GLADE_HOOKUP_OBJECT (father, radio, "IlmTasksMRaRes");
  radio = RADIO_BUTTON_WITH_LABEL (NULL, "Manual", MyBLUE);
  gtk_widget_show (radio);
  table_attach (table, radio, 2, 3, 0, 1);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->manres = radio;
  gtk_widget_set_name (radio, "IlmTasksMRmRes");
  GLADE_HOOKUP_OBJECT (father, radio, "IlmTasksMRmRes");
  spin = SPIN_WITH_LABEL("Min:    ", MyBLUE, 0, 100., 1., 0.1, 2);
  gtk_widget_show_all (spin);
  table_attach (table, spin, 3, 4, 0, 1);
  gtk_widget_set_sensitive(spin, FALSE);
  model->minres = spin;
  g_signal_connect(G_OBJECT(model->manres), "toggled", G_CALLBACK(on_cb_attiva), spin);
  g_signal_connect ((gpointer) get_widget(spin, "spin"), "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  gtk_widget_set_name (get_widget(spin, "spin"), "IlmTasksMRResMinSpin");
  set_width_chars (GTK_ENTRY (get_widget(spin, "spin")), 5);
  GLADE_HOOKUP_OBJECT (father, get_widget(spin, "spin"), "IlmTasksMRResMinSpin");
  spin = SPIN_WITH_LABEL("Max:    ", MyBLUE, 0, 100., 1., 0.1, 2);
  gtk_widget_show_all (spin);
  table_attach (table, spin, 4, 5, 0, 1);
  gtk_widget_set_sensitive(spin, FALSE);
  model->maxres = spin;
  g_signal_connect(G_OBJECT(model->manres), "toggled", G_CALLBACK(on_cb_attiva), spin);
  g_signal_connect ((gpointer) get_widget(spin, "spin"), "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  gtk_widget_set_name (get_widget(spin, "spin"), "IlmTasksMRResMaxSpin");
  set_width_chars (GTK_ENTRY (get_widget(spin, "spin")), 5);
  GLADE_HOOKUP_OBJECT (father, get_widget(spin, "spin"), "IlmTasksMRResMaxSpin");
  label = LABEL_BOLD ("Threshold selection ", MyBLUE, 1.1f);
  gtk_widget_show (label);
  table_attach_all(table, label, 0, 1, 1, 2);
  group = NULL;
  radio = RADIO_BUTTON_WITH_LABEL (NULL, "Automatic", MyBLUE);
  gtk_widget_show (radio);
  table_attach (table, radio, 1, 2, 1, 2);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->autotres = radio;
  gtk_widget_set_name (radio, "IlmTasksMRTSAuto");
  GLADE_HOOKUP_OBJECT (father, radio, "IlmTasksMRTSAuto");

  radio = RADIO_BUTTON_WITH_LABEL (NULL, "Manual", MyBLUE);
  gtk_widget_show (radio);
  table_attach (table, radio, 2, 3, 1, 2);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->mantres = radio;
  gtk_widget_set_name (radio, "IlmTasksMRTSMan");
  GLADE_HOOKUP_OBJECT (father, radio, "IlmTasksMRTSMan");
  spin = SPIN_WITH_LABEL("Rot.:  ", MyBLUE, 0, 1, 0., 0.1, 2);
  gtk_widget_show_all (spin);
  table_attach (table, spin, 3, 4, 1, 2);
  g_signal_connect ((gpointer) get_widget(spin, "spin"), "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  model->rot = spin;
  gtk_widget_set_sensitive(spin, FALSE);
  g_signal_connect(G_OBJECT(model->mantres), "toggled", G_CALLBACK(on_cb_attiva), spin);
  gtk_widget_set_name (get_widget(spin, "spin"), "IlmTasksMRTSRotSpin");
  set_width_chars (GTK_ENTRY (get_widget(spin, "spin")), 5);
  GLADE_HOOKUP_OBJECT (father, get_widget(spin, "spin"), "IlmTasksMRTSRotSpin");
  spin = SPIN_WITH_LABEL("Opt.:  ", MyBLUE, 0, 1, 0., 0.1, 2);
  gtk_widget_show_all (spin);
  table_attach (table, spin, 4, 5, 1, 2);
  g_signal_connect ((gpointer) get_widget(spin, "spin"), "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  model->rotlocal = spin;
  gtk_widget_set_sensitive(spin, FALSE);
  g_signal_connect(G_OBJECT(model->mantres), "toggled", G_CALLBACK(on_cb_attiva), spin);
  gtk_widget_set_name (get_widget(spin, "spin"), "IlmTasksMRTSRotLocSpin");
  set_width_chars (GTK_ENTRY (get_widget(spin, "spin")), 5);
  GLADE_HOOKUP_OBJECT (father, get_widget(spin, "spin"), "IlmTasksMRTSRotLocSpin");
  spin = SPIN_WITH_LABEL("Trans.: ", MyBLUE, 0, 1, 0., 0.1, 2);
  gtk_widget_show_all (spin);
  table_attach (table, spin, 5, 6, 1, 2);
  g_signal_connect ((gpointer) get_widget(spin, "spin"), "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  model->trans = spin;
  gtk_widget_set_sensitive(spin, FALSE);
  g_signal_connect(G_OBJECT(model->mantres), "toggled", G_CALLBACK(on_cb_attiva), spin);
  gtk_widget_set_name (get_widget(spin, "spin"), "IlmTasksMRTSTraSpin");
  set_width_chars (GTK_ENTRY (get_widget(spin, "spin")), 5);
  GLADE_HOOKUP_OBJECT (father, get_widget(spin, "spin"), "IlmTasksMRTSTraSpin");

  spin = SPIN_WITH_LABEL("Opt.:  ", MyBLUE, 0, 1, 0., 0.1, 2);
  gtk_widget_show_all (spin);
  table_attach (table, spin, 6, 7, 1, 2);
  g_signal_connect ((gpointer) get_widget(spin, "spin"), "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  model->translocal = spin;
  gtk_widget_set_sensitive(spin, FALSE);
  g_signal_connect(G_OBJECT(model->mantres), "toggled", G_CALLBACK(on_cb_attiva), spin);
  gtk_widget_set_name (get_widget(spin, "spin"), "IlmTasksMRTSTraLocSpin");
  set_width_chars (GTK_ENTRY (get_widget(spin, "spin")), 5);
  GLADE_HOOKUP_OBJECT (father, get_widget(spin, "spin"), "IlmTasksMRTSTraLocSpin");

//END NEW
}

MRmodel *model_info(GtkWidget *father, int n)
{
  GtkWidget *frame;
  GtkWidget *vbox;
  GtkWidget *hbox;
  GtkWidget *entry;
  GtkWidget *BrowseBtn;
  GtkWidget *ViewBtn;
  GtkWidget *ModifyBtn;
  GtkWidget *table_remo;
  GtkWidget *label;
  GtkWidget *spin;
  GtkWidget *check;
  GtkWidget *radio;
  GtkWidget *align;
  GtkWidget *hbox1;
  GSList *group = NULL;
  GObject *adj;
  GtkSizeGroup *szgroup;

  MRmodel *model = g_new0(MRmodel, 1);

  frame = FRAME_BOLD(g_strdup_printf("Model n. %d", n+1), MyRED, 1.2f);
//  frame = NEW_FRAME(g_strdup_printf("Model n. %d", n+1));
  gtk_widget_set_name (frame, g_strdup_printf("IlmTasksMRModel%d",n));
  gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_NONE);
//  gtk_container_set_border_width (GTK_CONTAINER (frame), 8);
  GLADE_HOOKUP_OBJECT (father, frame, g_strdup_printf("IlmTasksMRModel%d",n));
  model->frame = frame;

  vbox = vbox_new (FALSE, 8);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (frame), vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 8);

#ifdef IN_GTK3
  GtkWidget *a = new_alignment(GTK_ALIGN_START,GTK_ALIGN_CENTER,0,1);
#else
  GtkWidget *a = gtk_alignment_new(0,0.5,0,1);
#endif

  gtk_box_pack_start (GTK_BOX (vbox), a, FALSE, FALSE, 10);
  gtk_widget_show (a);

  entry = entry_for_filesel(a, "Model PDB file: ", 
                                 "PDBfilename", 1, 1, 1);
  gtk_widget_set_name (entry, g_strdup_printf("IlmTasksMRFileEntry%d", n));
  set_width_chars (GTK_ENTRY (entry), 60);
  BrowseBtn = get_widget(entry, "browse");
  ViewBtn = get_widget(entry, "preview");
  ModifyBtn = get_widget(entry, "modify");
  model->PDBentry = entry;
  GLADE_HOOKUP_OBJECT (father, entry, g_strdup_printf("IlmTasksMRFileEntry%d", n));
  g_signal_connect ((gpointer) BrowseBtn, "clicked",
                    G_CALLBACK (on_IlmTasksMRBrowseBtn_clicked),
                    GINT_TO_POINTER(n));
  g_signal_connect ((gpointer) ViewBtn, "clicked",
                    G_CALLBACK (on_Ilm_text_view_clicked),
                    entry);
  g_signal_connect ((gpointer) ModifyBtn, "clicked",
                    G_CALLBACK (on_Ilm_pdb_modify_clicked),
                    GINT_TO_POINTER(n));
  if(Ilm::TheApp.Executables()[Ilm::IExePDBViewer].find("jav") == std::string::npos)
     gtk_widget_set_sensitive(ModifyBtn, FALSE);
  else
     gtk_widget_set_sensitive(ModifyBtn, TRUE);

  table_remo = table_new(2, 2, FALSE);      //TRUE);
  gtk_widget_show (table_remo);
  gtk_box_pack_start (GTK_BOX (vbox), table_remo, FALSE, FALSE, 20);
  table_set_col_spacings(table_remo, 50);

  spin = SPIN_WITH_LABEL ("Number of monomers to search: ",NULL, 1, 100000, 1, 1, 0);
  gtk_widget_show_all (spin);
  model->nMonomers = get_widget(spin, "spin");
  set_width_chars (GTK_ENTRY (get_widget(spin, "spin")), 5);
  g_signal_connect ((gpointer) get_widget(spin, "spin"), "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  gtk_widget_set_name (get_widget(spin, "spin"),
         g_strdup_printf("IlmTasksMRNmolSpin%d", n));
  GLADE_HOOKUP_OBJECT (father, get_widget(spin, "spin"),
         g_strdup_printf("IlmTasksMRNmolSpin%d", n));
  table_attach(table_remo, spin, 0, 1, 0, 1, TRUE);

  check = CHECK_BUTTON_WITH_LABEL ("Use heteroatoms",NULL);
  gtk_widget_show (check);
  table_attach(table_remo, check, 0, 1, 1, 2, TRUE);
  model->hetero = check;
  gtk_widget_set_name (check, g_strdup_printf("IlmTasksMRHeteroCheck%d", n));
  GLADE_HOOKUP_OBJECT (father, check, g_strdup_printf("IlmTasksMRHeteroCheck%d", n));

  label = NEW_FRAME ("Thermal Factor: ", &FrameStyle);
  gtk_widget_show (label);
  table_attach(table_remo, label, 1, 2, 0, 2, TRUE);

  hbox = vbox_new (FALSE, 2);
  gtk_widget_show (hbox);
  gtk_container_add(GTK_CONTAINER(get_widget(label, "align")), hbox);

  radio = RADIO_BUTTON_WITH_LABEL (NULL, "PDB", MyBLUE);
  gtk_widget_show (radio);
  gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->PDBradio = radio;
  gtk_widget_set_name (radio, g_strdup_printf("IlmTasksMRPdbRadio%d", n));
  GLADE_HOOKUP_OBJECT (father, radio, g_strdup_printf("IlmTasksMRPdbRadio%d", n));

  radio = RADIO_BUTTON_WITH_LABEL (NULL, "Proportional to Wilson", MyBLUE);
  gtk_widget_show (radio);
  gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->Wilsonradio = radio;
  gtk_widget_set_name (radio, g_strdup_printf("IlmTasksMRWilsonRadio%d", n));
  GLADE_HOOKUP_OBJECT (father, radio, g_strdup_printf("IlmTasksMRWilsonRadio%d", n));

  radio = RADIO_BUTTON_WITH_LABEL (NULL, "20", MyBLUE);
  gtk_widget_show (radio);
  gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->p20radio = radio;
  gtk_widget_set_name (radio, g_strdup_printf("IlmTasksMR20Radio%d", n));
  GLADE_HOOKUP_OBJECT (father, radio, g_strdup_printf("IlmTasksMR20Radio%d", n));

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START,GTK_ALIGN_START,0,1);
#else
  align = gtk_alignment_new(0,0,0,1);
#endif
  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (vbox), align, FALSE, FALSE, 0);
#ifndef CANNOT_PAD_ALIGN
#ifdef IN_GTK3
  set_margins(align, 0, 0, 0, 20);
#else
  gtk_alignment_set_padding(GTK_ALIGNMENT(align), 0, 0, 0, 20);
#endif
#endif

  label = FRAME_NEW ("Similarity of the PDB model to the target structure", MyBLUE);
  gtk_widget_show (label);
  gtk_container_add (GTK_CONTAINER (align), label);

  hbox = hbox_new (FALSE, 6);
  gtk_widget_show (hbox);
  gtk_container_add (GTK_CONTAINER(label) , hbox);
  gtk_container_set_border_width (GTK_CONTAINER(hbox) , 6);

  radio = LABEL_NEW ("Sequence identity", MyBLUE);
  gtk_widget_show (radio);
  gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);

/* 190509
  group = NULL;
  radio = RADIO_BUTTON_WITH_LABEL (NULL, "sequence identity", MyBLUE);
  gtk_widget_show (radio);
  gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->seqradio = radio;
  gtk_widget_set_name (radio, g_strdup_printf("IlmTasksMRSeqRadio%d", n));
  GLADE_HOOKUP_OBJECT (father, radio, g_strdup_printf("IlmTasksMRSeqRadio%d", n));

  radio = RADIO_BUTTON_WITH_LABEL (NULL, "rms differerence", MyBLUE);
  gtk_widget_show (radio);
  gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 30);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (radio), group);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  model->rmsradio = radio;
  gtk_widget_set_name (radio, g_strdup_printf("IlmTasksMRrmsRadio%d", n));
  GLADE_HOOKUP_OBJECT (father, radio, g_strdup_printf("IlmTasksMRrmsRadio%d", n));
end 190509 */

  spin = SPIN_WITH_LABEL (" ",MyBLUE, 0, 1, .1, .1, 4);
  gtk_widget_show_all (spin);
  gtk_box_pack_start (GTK_BOX (hbox), spin, FALSE, TRUE, 100);
  g_signal_connect ((gpointer) get_widget(spin, "spin"), "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);

  model->entry = spin;
  gtk_widget_set_name (get_widget(spin,"spin" ), g_strdup_printf("IlmTasksMRvalue%d", n));
  GLADE_HOOKUP_OBJECT (father, get_widget( spin,"spin" ), g_strdup_printf("IlmTasksMRvalue%d", n));

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START,GTK_ALIGN_START,0,1);
#else
  align = gtk_alignment_new(0,0,0,1);
#endif
  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (vbox), align, FALSE, FALSE, 0);
#ifndef CANNOT_PAD_ALIGN
#ifdef IN_GTK3
  set_margins(align, 0, 0, 0, 20);
#else
  gtk_alignment_set_padding(GTK_ALIGNMENT(align), 0, 0, 0, 20);
#endif
#endif

  label = FRAME_NEW ("Modify model", MyBLUE);
  gtk_widget_show (label);
  gtk_container_add (GTK_CONTAINER (align), label);

  hbox = hbox_new (FALSE, 6);
  gtk_widget_show (hbox);
  gtk_container_add (GTK_CONTAINER(label) , hbox);
  gtk_container_set_border_width (GTK_CONTAINER(hbox) , 6);

  check = CHECK_BUTTON_WITH_LABEL ("Polyalanine model", MyBLUE);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 10);
  model->polycheck = check;
  gtk_widget_set_name (check, g_strdup_printf("IlmTasksMRPolyalaCheck%d", n));
  GLADE_HOOKUP_OBJECT (father, check, g_strdup_printf("IlmTasksMRPolyalaCheck%d", n));

  hbox1 = hbox_new (FALSE, 6);
  gtk_widget_show (hbox1);
  gtk_box_pack_end (GTK_BOX (hbox), hbox1, FALSE, FALSE, 10);

  check = CHECK_BUTTON_WITH_LABEL ("Cut model:", MyBLUE);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (hbox1), check, FALSE, FALSE, 0);
  model->cutmodel = check;
  gtk_widget_set_name (check, g_strdup_printf("IlmTasksMRCutCheck%d", n));
  GLADE_HOOKUP_OBJECT (father, check, g_strdup_printf("IlmTasksMRCutCheck%d", n));

  spin = SPIN_WITH_LABEL ("use residues from ",MyBLUE, 1, 3000, 1, 1, 0);
  gtk_widget_show_all (spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, FALSE, TRUE, 0);
  gtk_widget_set_sensitive(spin, FALSE);
  g_signal_connect ((gpointer) check, "toggled",
                    G_CALLBACK (on_cb_attiva), spin);
  g_signal_connect ((gpointer) get_widget(spin, "spin"), "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  model->fromres = spin;
  gtk_widget_set_name (get_widget(spin,"spin" ), g_strdup_printf("IlmTasksMRn1Spin%d", n));
  GLADE_HOOKUP_OBJECT (father, get_widget( spin,"spin" ), g_strdup_printf("IlmTasksMRn1Spin%d", n));

  spin = SPIN_WITH_LABEL ("to ",MyBLUE, 1, 3000, 1, 1, 0);
  gtk_widget_show_all (spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, FALSE, TRUE, 0);
  gtk_widget_set_sensitive(spin, FALSE);
  g_signal_connect ((gpointer) check, "toggled",
                    G_CALLBACK (on_cb_attiva), spin);
  g_signal_connect ((gpointer) get_widget(spin, "spin"), "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  model->tores = spin;
  gtk_widget_set_name (get_widget(spin,"spin" ), g_strdup_printf("IlmTasksMRn2Spin%d", n));
  GLADE_HOOKUP_OBJECT (father, get_widget( spin,"spin" ), g_strdup_printf("IlmTasksMRn2Spin%d", n));

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START,GTK_ALIGN_START,1,1);
#else
  align = gtk_alignment_new(0,0,1,1);
#endif

  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (vbox), align, FALSE, FALSE, 0);
#ifndef CANNOT_PAD_ALIGN
#ifdef IN_GTK3
  set_margins(align, 0, 0, 0, 20);
#else
  gtk_alignment_set_padding(GTK_ALIGNMENT(align), 0, 0, 0, 20);
#endif
#endif

  label = FRAME_NEW ("Rotation: ", MyBLUE);
  gtk_widget_show (label);
  gtk_container_add (GTK_CONTAINER (align), label);

  hbox = hbox_new (FALSE, 6);
  gtk_widget_show (hbox);
  gtk_container_add (GTK_CONTAINER(label) , hbox);
  gtk_container_set_border_width (GTK_CONTAINER(hbox) , 6);

  check = CHECK_BUTTON_WITH_LABEL ("Fixed", MyBLUE);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 0);
  model->rotfix = check;
  gtk_widget_set_name (check, g_strdup_printf("IlmTasksMRRotCheck%d", n));
  GLADE_HOOKUP_OBJECT (father, check, g_strdup_printf("IlmTasksMRRotCheck%d", n));

  hbox1 = hbox_new (FALSE, 8);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (hbox), hbox1, FALSE, TRUE, 30);
  gtk_widget_set_sensitive (hbox1, FALSE);
  g_signal_connect ((gpointer) check, "toggled",
                    G_CALLBACK (on_cb_attiva), hbox1);

  label = LABEL_NEW("Eulerian angles (degrees)", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox1), label, TRUE, TRUE, 0);

  szgroup = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);

  adj = adj_new (0, 0, 360, 1, 10);
  spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 0);
  gtk_widget_show (spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, TRUE, TRUE, 10);
  gtk_size_group_add_widget(szgroup, spin);
  g_signal_connect ((gpointer) spin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  model->rot1 = spin;
  gtk_widget_set_name (spin, g_strdup_printf("IlmTasksMRRot1Spin%d", n));
  GLADE_HOOKUP_OBJECT (father, spin, g_strdup_printf("IlmTasksMRRot1Spin%d", n));

  adj = adj_new (0, 0, 360, 1, 10);
  spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 0);
  gtk_widget_show (spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, TRUE, TRUE, 10);
  gtk_size_group_add_widget(szgroup, spin);
  g_signal_connect ((gpointer) spin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  model->rot2 = spin;
  gtk_widget_set_name (spin, g_strdup_printf("IlmTasksMRRot2Spin%d", n));
  GLADE_HOOKUP_OBJECT (father, spin, g_strdup_printf("IlmTasksMRRot2Spin%d", n));
 
  adj = adj_new (0, 0, 360, 1, 10);
  spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 0);
  gtk_widget_show (spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, TRUE, TRUE, 10);
  gtk_size_group_add_widget(szgroup, spin);
  g_signal_connect ((gpointer) spin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  model->rot3 = spin;
  gtk_widget_set_name (spin, g_strdup_printf("IlmTasksMRRot3Spin%d", n));
  GLADE_HOOKUP_OBJECT (father, spin, g_strdup_printf("IlmTasksMRRot3Spin%d", n));

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START,GTK_ALIGN_START,1,1);
#else
  align = gtk_alignment_new(0,0,1,1);
#endif

//  gtk_widget_show (align);             //da commentare
  gtk_box_pack_start (GTK_BOX (vbox), align, FALSE, FALSE, 0);
#ifndef CANNOT_PAD_ALIGN
#ifdef IN_GTK3
  set_margins(align, 0, 0, 0, 20);
#else
  gtk_alignment_set_padding(GTK_ALIGNMENT(align), 0, 0, 0, 20);
#endif
#endif

  label = FRAME_NEW ("Translation: ", MyBLUE);
  gtk_widget_show (label);
  gtk_container_add (GTK_CONTAINER (align), label);

  hbox = hbox_new (FALSE, 6);
  gtk_widget_show (hbox);
  gtk_container_add (GTK_CONTAINER(label), hbox);
  gtk_container_set_border_width (GTK_CONTAINER(hbox), 6);

  check = CHECK_BUTTON_WITH_LABEL ("Fixed", MyBLUE);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 0);
  model->transfix = check;
  gtk_widget_set_name (check, g_strdup_printf("IlmTasksMRTransCheck%d", n));
  GLADE_HOOKUP_OBJECT (father, check, g_strdup_printf("IlmTasksMRTransCheck%d", n));

  hbox1 = hbox_new (FALSE, 8);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (hbox), hbox1, TRUE, TRUE, 30);
  gtk_widget_set_sensitive (hbox1, FALSE);
  g_signal_connect ((gpointer) check, "toggled",
                    G_CALLBACK (on_cb_attiva), hbox1);

  label = LABEL_NEW("Fractional coordinates   ", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox1), label, TRUE, TRUE, 0);

  adj = adj_new (0, 0, 1, 0.1, 0.1);
  spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 3);
  gtk_widget_show (spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, FALSE, TRUE, 10);
  gtk_size_group_add_widget(szgroup, spin);
  g_signal_connect ((gpointer) spin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  model->trans1 = spin;
  gtk_widget_set_name (spin, g_strdup_printf("IlmTasksMRTrans1Spin%d", n));
  GLADE_HOOKUP_OBJECT (father, spin, g_strdup_printf("IlmTasksMRTrans1Spin%d", n));

  adj = adj_new (0, 0, 1, 0.1, 0.1);
  spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 3);
  gtk_widget_show (spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, FALSE, TRUE, 10);
  gtk_size_group_add_widget(szgroup, spin);
  g_signal_connect ((gpointer) spin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  model->trans2 = spin;
  gtk_widget_set_name (spin, g_strdup_printf("IlmTasksMRTrans2Spin%d", n));
  GLADE_HOOKUP_OBJECT (father, spin, g_strdup_printf("IlmTasksMRTrans2Spin%d", n));

  adj = adj_new (0, 0, 1, 0.1, 0.1);
  spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 3);
  gtk_widget_show (spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, FALSE, TRUE, 10);
  gtk_size_group_add_widget(szgroup, spin);
  g_signal_connect ((gpointer) spin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  model->trans3 = spin;
  gtk_widget_set_name (spin, g_strdup_printf("IlmTasksMRTrans3Spin%d", n));
  GLADE_HOOKUP_OBJECT (father, spin, g_strdup_printf("IlmTasksMRTrans3Spin%d", n));

  hbox = hbox_new (FALSE, 8);
//  gtk_widget_show (hbox);              // da commentare
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);

  check =  CHECK_BUTTON_WITH_LABEL ("EDM", MyBLUE);
  gtk_widget_show (check);
  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 0);
  model->edm = check;
  gtk_widget_set_name (check, g_strdup_printf("IlmTasksMREdmCheck%d", n));
  GLADE_HOOKUP_OBJECT (father, check, g_strdup_printf("IlmTasksMREdmCheck%d", n));

  hbox1 = hbox_new (FALSE, 8);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (hbox), hbox1, TRUE, TRUE, 30);
  gtk_widget_set_sensitive (hbox1, FALSE);
  g_signal_connect ((gpointer) check, "toggled",
                    G_CALLBACK (on_cb_attiva), hbox1);

  label = LABEL_NEW ("Extend resolution up to", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox1), label, FALSE, FALSE, 0);

  adj = adj_new (1, 0, 10, 1, 10);
  spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 0);
  gtk_widget_show (spin);
  gtk_box_pack_start (GTK_BOX (hbox1), spin, FALSE, TRUE, 0);
  g_signal_connect ((gpointer) spin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  model->edmspin = spin;
  gtk_widget_set_name (spin, g_strdup_printf("IlmTasksMREdmSpin%d", n));
  GLADE_HOOKUP_OBJECT (father, spin, g_strdup_printf("IlmTasksMREdmSpin%d", n));

  return model;
}

void createMenus(GtkWidget *father, GtkWidget *parentBox, int type_p)
{
using namespace Ilm;
  GtkWidget *IlmMenu = CreateMenubar(father, pmenu_entries, n_pmenu_entries,
                       16, 16, false);
  gtk_widget_set_name (IlmMenu, "IlmMenu");
  gtk_widget_show_all (IlmMenu);

  obj_hide(get_object(father, "IlmMenuOutMap1"));
  obj_hide(get_object(father, "IlmMenuOutMap2"));
  if(type_p > ABI)                     // Tutti tranne DEA
     obj_hide(get_object(father, "IlmMenuProject"));

  switch (type_p)
  {
  case EDM:
     obj_hide(get_object(father, "IlmMenuInTask0"));
     obj_hide(get_object(father, "IlmMenuInTask1"));
     obj_hide(get_object(father, "IlmMenuInTask2"));
     obj_hide(get_object(father, "IlmMenuOutMtz"));
     obj_hide(get_object(father, "IlmMenuOutPhase"));
     obj_hide(get_object(father, "IlmMenuOutFull0"));
     obj_hide(get_object(father, "IlmMenuOutFull1"));
     obj_hide(get_object(father, "IlmMenuOutFull2"));
     break;
  case MRS:
  case MIR:
  case MAD:
     obj_hide(get_object(father, "IlmMenuOutMtz"));
     obj_hide(get_object(father, "IlmMenuOutFull"));
     obj_hide(get_object(father, "IlmMenuInTask"));
     break;
  case ABI:
  case MOLREP:
     obj_hide(get_object(father, "IlmMenuInTask0"));
     obj_hide(get_object(father, "IlmMenuInTask1"));
     obj_hide(get_object(father, "IlmMenuInTask2"));
     obj_hide(get_object(father, "IlmMenuOutFull0"));
     obj_hide(get_object(father, "IlmMenuOutFull1"));
     obj_hide(get_object(father, "IlmMenuOutFull2"));
     obj_hide(get_object(father, "IlmMenuOutPhase"));
     obj_hide(get_object(father, "IlmMenuOutEdm"));
     obj_hide(get_object(father, "IlmMenuOutEdm1"));
     break;
  }

  gtk_box_pack_start (GTK_BOX (parentBox), IlmMenu, FALSE, FALSE, 0);
  GLADE_HOOKUP_OBJECT (father, IlmMenu, "IlmMenu");
}

GtkWidget *frameEDM(GtkWidget *fatherWindow)
{
  GtkWidget *IlmTasksEdmVBox;
  GtkWidget *IlmTasksEdmTable;
  GtkWidget *IlmTasksEdmFrame;
  GtkWidget *IlmTasksEdmCheck;
  GtkWidget *IlmTasksEdmSFCheck;
  GtkWidget *IlmTasksEdmHistCheck;
  GtkWidget *IlmTasksEdmSolvF;
  GtkWidget *label;
  GtkWidget *IlmTasksEdmConvCombo;
  GtkWidget *IlmTasksEdmExtCombo;
  GtkWidget *IlmTasksEdmFlexCheck;
  static const char *conve[] = {"Automatic", "None", "Real R-Free", "R-Free", "dPHI"};
  static const char *exte[] = {"Automatic", "All", "Resolution", "Weight", "F-calculated", "F-observed", "E-par"};

  if(Ilm::PTheProject->eType == Ilm::EDM)
     IlmTasksEdmCheck = CHECK_BUTTON_BOLD ("EDM", MyBLUE, 1.1f);
   else
     IlmTasksEdmCheck = CHECK_BUTTON_BOLD ("EDM on bestTrial", MyBLUE, 1.1f);
  gtk_widget_set_name (IlmTasksEdmCheck, "IlmTasksEdmCheck");
  gtk_widget_show (IlmTasksEdmCheck);
  set_tip (IlmTasksEdmCheck, "Electron density modification");

  IlmTasksEdmFrame = NEW_FRAME (NULL, &FrameStyle1);
  gtk_widget_set_name (IlmTasksEdmFrame, "IlmTasksEdmFrame");
  gtk_widget_show (IlmTasksEdmFrame);
  gtk_frame_set_label_widget(GTK_FRAME(IlmTasksEdmFrame), IlmTasksEdmCheck);

  IlmTasksEdmVBox = vbox_new (FALSE, 4);
  gtk_widget_set_name (IlmTasksEdmVBox, "IlmTasksEdmVBox");
  gtk_widget_show (IlmTasksEdmVBox);
  gtk_container_add (GTK_CONTAINER(get_widget(IlmTasksEdmFrame, "align")),
      IlmTasksEdmVBox);
  gtk_container_set_border_width (GTK_CONTAINER (IlmTasksEdmVBox), 8);
  gtk_widget_set_sensitive(IlmTasksEdmVBox, FALSE);

  IlmTasksEdmTable = table_new (3, 3, FALSE);
  gtk_widget_set_name (IlmTasksEdmTable, "IlmTasksEdmTable");
  gtk_widget_show (IlmTasksEdmTable);
  gtk_box_pack_start (GTK_BOX(IlmTasksEdmVBox), IlmTasksEdmTable, TRUE, TRUE, 10);
  table_set_col_spacings(IlmTasksEdmTable, 10);
  table_set_row_spacings(IlmTasksEdmTable, 10);

  IlmTasksEdmSolvF = SPIN_WITH_LABEL("Solvent Fraction", MyBLUE, 0., 1., 0., 0.01, 2);
  gtk_widget_set_name (get_widget(IlmTasksEdmSolvF, "spin"), "IlmTasksEdmSolvFValue");
  gtk_widget_set_name (IlmTasksEdmSolvF, "IlmTasksEdmSolvF");
  gtk_widget_show_all (IlmTasksEdmSolvF);
  table_attach(IlmTasksEdmTable, IlmTasksEdmSolvF, 0, 1, 0, 1, TRUE);

  GtkWidget *IlmTasksEdmSolventF = LABEL_NEW ("(Computed value: )", NULL);
  gtk_widget_set_name (IlmTasksEdmSolventF, "SolventFractionC");
  gtk_widget_show (IlmTasksEdmSolventF);
  set_alignment (IlmTasksEdmSolventF, 0., 0.5);
  table_attach(IlmTasksEdmTable, IlmTasksEdmSolventF, 1, 3, 0, 1, TRUE);

  IlmTasksEdmSFCheck = CHECK_BUTTON_WITH_LABEL ("Solvent flattening", MyBLUE);
  gtk_widget_set_name (IlmTasksEdmSFCheck, "IlmTasksEdmSFCheck");
  gtk_widget_show (IlmTasksEdmSFCheck);
  table_attach(IlmTasksEdmTable, IlmTasksEdmSFCheck, 0, 1, 1, 2, TRUE);

  IlmTasksEdmHistCheck = CHECK_BUTTON_WITH_LABEL ("Histogram matching", MyBLUE);
  gtk_widget_set_name (IlmTasksEdmHistCheck, "IlmTasksEdmHistCheck");
  gtk_widget_show (IlmTasksEdmHistCheck);
  table_attach(IlmTasksEdmTable, IlmTasksEdmHistCheck, 0, 1, 2, 3, TRUE);

  label = LABEL_NEW ("Convergence control:", MyBLUE);
  gtk_widget_show (label);
  set_alignment (label, 0., 0.5);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
  table_attach(IlmTasksEdmTable, label, 1, 2, 1, 2, TRUE);

  IlmTasksEdmConvCombo = create_combo_str ();
  gtk_widget_set_name (IlmTasksEdmConvCombo, "IlmTasksEdmConvCombo");
  gtk_widget_show (IlmTasksEdmConvCombo);
  table_attach(IlmTasksEdmTable, IlmTasksEdmConvCombo, 2, 3, 1, 2, TRUE);
  fill_combo(IlmTasksEdmConvCombo, conve, sizeof(conve)/sizeof(conve[0]), 1);
  set_width_chars (GTK_ENTRY (gtk_bin_get_child(GTK_BIN(IlmTasksEdmConvCombo))), 12);

  label = LABEL_NEW ("Extension:", MyBLUE);
  gtk_widget_show (label);
  set_alignment (label, 0., 0.5);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
  table_attach(IlmTasksEdmTable, label, 1, 2, 2, 3, TRUE);

  IlmTasksEdmExtCombo = create_combo_str ();
  gtk_widget_set_name (IlmTasksEdmExtCombo, "IlmTasksEdmExtCombo");
  gtk_widget_show (IlmTasksEdmExtCombo);
  table_attach(IlmTasksEdmTable, IlmTasksEdmExtCombo, 2, 3, 2, 3, TRUE);
  fill_combo(IlmTasksEdmExtCombo, exte, sizeof(exte)/sizeof(exte[0]), 1);
  set_width_chars (GTK_ENTRY (gtk_bin_get_child(GTK_BIN(IlmTasksEdmExtCombo))), 12);

  IlmTasksEdmFlexCheck = CHECK_BUTTON_WITH_LABEL ("Flex (Automatic EDM Procedure - Obsolete)", MyBLUE);
  gtk_widget_set_name (IlmTasksEdmFlexCheck, "IlmTasksEdmFlexCheck");
  if(Ilm::PTheProject->eType == Ilm::EDM)
     gtk_widget_show (IlmTasksEdmFlexCheck);
  else
     gtk_widget_hide (IlmTasksEdmFlexCheck);
  gtk_box_pack_start (GTK_BOX(IlmTasksEdmVBox), IlmTasksEdmFlexCheck, FALSE, FALSE, 20);

  GLADE_HOOKUP_OBJECT (fatherWindow, get_widget(IlmTasksEdmSolvF, "spin"), "IlmTasksEdmSolvFValue");
  GLADE_HOOKUP_OBJECT (fatherWindow, IlmTasksEdmCheck, "IlmTasksEdmCheck");
  GLADE_HOOKUP_OBJECT (fatherWindow, IlmTasksEdmFrame, "IlmTasksEdmFrame");
  GLADE_HOOKUP_OBJECT (fatherWindow, IlmTasksEdmVBox, "IlmTasksEdmVBox");
  GLADE_HOOKUP_OBJECT (fatherWindow, IlmTasksEdmTable, "IlmTasksEdmTable");
  GLADE_HOOKUP_OBJECT (fatherWindow, IlmTasksEdmSFCheck, "IlmTasksEdmSFCheck");
  GLADE_HOOKUP_OBJECT (fatherWindow, IlmTasksEdmHistCheck, "IlmTasksEdmHistCheck");
  GLADE_HOOKUP_OBJECT (fatherWindow, IlmTasksEdmConvCombo, "IlmTasksEdmConvCombo");
  GLADE_HOOKUP_OBJECT (fatherWindow, IlmTasksEdmExtCombo, "IlmTasksEdmExtCombo");
  GLADE_HOOKUP_OBJECT (fatherWindow, IlmTasksEdmFlexCheck, "IlmTasksEdmFlexCheck");
  GLADE_HOOKUP_OBJECT (fatherWindow, IlmTasksEdmSolventF, "SolventFractionC");

  g_signal_connect ((gpointer) IlmTasksEdmCheck, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksEdmCheck, "toggled",
                    G_CALLBACK (on_cb_attiva),
                    IlmTasksEdmVBox);
  g_signal_connect(G_OBJECT(IlmTasksEdmFlexCheck), "toggled",
                   G_CALLBACK(on_cb_disattiva), IlmTasksEdmTable);

  return IlmTasksEdmFrame;
}

GtkWidget *frameStrategy(GtkWidget *father, GtkWidget *parentBox)
{
  GtkWidget *IlmStrategyFrame;
  GtkWidget *hboxStrategy;
  GtkWidget *IlmStrategy1Radio;
  GtkWidget *IlmStrategy2Radio;
  GtkWidget *IlmStrategy3Radio;
  GtkWidget *IlmStrategySpin;
  GSList *IlmStrategyRadio_group = NULL;

  IlmStrategyFrame = FRAME_BOLD ("Strategy", MyBLUE, 1.1f);
  gtk_widget_set_name (IlmStrategyFrame, "IlmStrategyFrame");
  gtk_box_pack_start (GTK_BOX (parentBox), IlmStrategyFrame, TRUE, TRUE, 6);

  hboxStrategy = hbox_new (FALSE, 10);
  gtk_widget_set_name (hboxStrategy, "hboxStrategy");
  gtk_widget_show (hboxStrategy);
  gtk_container_add (GTK_CONTAINER(IlmStrategyFrame), hboxStrategy);
  gtk_container_set_border_width (GTK_CONTAINER(hboxStrategy), 10);

  IlmStrategy1Radio =  RADIO_BUTTON_WITH_LABEL (NULL, "Sequential", MyBLUE);
  gtk_widget_set_name (IlmStrategy1Radio, "IlmStrategy1Radio");
  gtk_widget_show (IlmStrategy1Radio);
  gtk_box_pack_start (GTK_BOX (hboxStrategy), IlmStrategy1Radio, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmStrategy1Radio), IlmStrategyRadio_group);
  IlmStrategyRadio_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (IlmStrategy1Radio));

  IlmStrategy2Radio =  RADIO_BUTTON_WITH_LABEL (NULL, "Alternate", MyBLUE);
  gtk_widget_set_name (IlmStrategy2Radio, "IlmStrategy2Radio");
  gtk_widget_show (IlmStrategy2Radio);
  gtk_box_pack_start (GTK_BOX (hboxStrategy), IlmStrategy2Radio, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmStrategy2Radio), IlmStrategyRadio_group);
  IlmStrategyRadio_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (IlmStrategy2Radio));

  IlmStrategy3Radio =  RADIO_BUTTON_WITH_LABEL (NULL, "Parallel", MyBLUE);
  gtk_widget_set_name (IlmStrategy3Radio, "IlmStrategy3Radio");
  gtk_widget_show (IlmStrategy3Radio);
  gtk_box_pack_start (GTK_BOX (hboxStrategy), IlmStrategy3Radio, FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmStrategy3Radio), IlmStrategyRadio_group);
  IlmStrategyRadio_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (IlmStrategy3Radio));

  IlmStrategySpin = SPIN_WITH_LABEL("Number of ....", MyBLUE, 2., 10., 2., 1., 0);
  gtk_widget_set_name (get_widget(IlmStrategySpin, "label"), "IlmStrategySpinLabel");
  gtk_widget_set_name (get_widget(IlmStrategySpin, "spin"), "IlmStrategySpinValue");
  gtk_widget_set_name (IlmStrategySpin, "IlmStrategySpin");
  gtk_widget_show_all (IlmStrategySpin);
  gtk_box_pack_start (GTK_BOX (hboxStrategy), IlmStrategySpin, FALSE, FALSE, 0);
  gtk_widget_set_sensitive(IlmStrategySpin, false);

  GLADE_HOOKUP_OBJECT (father, IlmStrategyFrame, "IlmStrategyFrame");
  GLADE_HOOKUP_OBJECT (father, hboxStrategy, "hboxStrategy");
  GLADE_HOOKUP_OBJECT (father, IlmStrategy1Radio, "IlmStrategy1Radio");
  GLADE_HOOKUP_OBJECT (father, IlmStrategy2Radio, "IlmStrategy2Radio");
  GLADE_HOOKUP_OBJECT (father, IlmStrategy3Radio, "IlmStrategy3Radio");
  GLADE_HOOKUP_OBJECT (father, IlmStrategySpin, "IlmStrategySpin");
  GLADE_HOOKUP_OBJECT (father, get_widget(IlmStrategySpin, "label"), "IlmStrategySpinLabel");
  GLADE_HOOKUP_OBJECT (father, get_widget(IlmStrategySpin, "spin"), "IlmStrategySpinValue");
  g_signal_connect ((gpointer) get_widget(IlmStrategySpin, "spin"), "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmStrategy1Radio, "toggled",
                    G_CALLBACK (on_IlmStrategyRadio_toggled),
                    GINT_TO_POINTER(1));
  g_signal_connect ((gpointer) IlmStrategy2Radio, "toggled",
                    G_CALLBACK (on_IlmStrategyRadio_toggled),
                    GINT_TO_POINTER(2));
  g_signal_connect ((gpointer) IlmStrategy3Radio, "toggled",
                    G_CALLBACK (on_IlmStrategyRadio_toggled),
                    GINT_TO_POINTER(3));

  return IlmStrategyFrame;
}

GtkWidget *frameMost(GtkWidget *father, GtkWidget *parentBox)
{
  GtkWidget *IlmTasksBox;
  GtkWidget *IlmTasksProFullBox;
  GtkWidget *IlmTasksProCheck;
  GtkWidget *IlmTasksProBox;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *label;
  GtkWidget *hbox2;
  GtkWidget *vbox2;
  GtkWidget *frame;
  GObject *IlmTasksProNtrialsSpin_adj;
  GtkWidget *IlmTasksProNtrialsSpin;
  GObject *IlmTasksProNstoreSpin_adj;
  GtkWidget *IlmTasksProNstoreSpin;
  GObject *IlmTasksProNuseSpin_adj;
  GtkWidget *IlmTasksProNuseSpin;
  GtkWidget *IlmTasksProNtrialsCheck;
  GtkWidget *IlmTasksMad1FullBox;
  GtkWidget *IlmTasksMad1Check;
  GtkWidget *IlmTasksMad1Box;
  GtkWidget *IlmTasksMad1WaveTable;
  GtkWidget *IlmTasksMad1AutoCheck;
  GtkWidget *IlmTasksMad1SelectWavesLbl;
  GtkWidget *IlmTasksMad1ReflBox;
  GtkWidget *label104;
  GObject *IlmTasksMad1NreflSpin_adj;
  GtkWidget *IlmTasksMad1NreflSpin;
  GtkWidget *IlmTasksMad1NreflCheck;
  GtkWidget *IlmTasksMad1MaxresSpin;
  GtkWidget *IlmTasksMad1MaxresCheck;
  GtkWidget *IlmTasksMad1PattersonCheck;
  GtkWidget *IlmTasksMad1DMCheck;
  GtkWidget *IlmTasksMad1MorePowerCheck;
  GtkWidget *IlmTasksMad1Ntrials1Spin;
  GtkWidget *IlmTasksMad1Ntrials2Spin;
  GtkWidget *IlmTasksMad1NtrialsCheck;
  GtkWidget *IlmTasksMad2FullBox;
  GtkWidget *IlmTasksMad2Check;
  GtkWidget *IlmTasksMad2Box;
  GtkWidget *IlmTasksMad2VBox;
  GtkWidget *IlmTasksFilePositionRadio;
  GtkWidget *IlmTasksBestTrialsRadio;
  GSList *IlmTasksFPRadio_group = NULL;
  GtkWidget *table;
  GtkWidget *IlmTasksMad2SelectWavesLbl;
  GtkWidget *IlmTasksMad2FileEntry;
  GtkWidget *IlmTasksMad2BrowseBtn;
  GtkWidget *IlmTasksMad2FileLbl;
  GtkWidget *IlmTasksMad2FilePreview;
  GtkWidget *IlmTasksMad2FileBox;
  GtkWidget *hboxBestTrials;
  GObject *IlmTasksMad2MinSpin_adj;
  GtkWidget *IlmTasksMad2MinSpin;
  GObject *IlmTasksMad2MaxSpin_adj;
  GtkWidget *IlmTasksMad2MaxSpin;
  GtkWidget *IlmTasksMad2MaxLabel;
  GtkWidget *IlmTasksMad2LsqCheck;
  GtkWidget *IlmTasksMad2LsqBox1;
  GtkWidget *IlmTasksMad2LsqPosCheck;
  GtkWidget *IlmTasksMad2LsqAdpCheck;
  GtkWidget *IlmTasksMad2LsqSofCheck;
  GtkWidget *IlmTasksMad2LsqF1Check;
  GtkWidget *IlmTasksMad2LsqF2Check;
  GtkWidget *IlmTasksEdmExCheck;
  GtkWidget *IlmTasksEdmExtraSpin;
  GtkWidget *IlmTasksEdmFLCheck;
  GtkWidget *IlmTasksEdmFLSpin;
  GtkWidget *IlmTasksImproveFrame;
  GtkWidget *IlmTasksEDMLabel;
  GtkWidget *hbox158b;
  GSList *IlmTasksMad1Solve_group = NULL;
  int hnd;

  GtkWidget *frameTasks = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (frameTasks);
  gtk_container_add (GTK_CONTAINER (parentBox), frameTasks);
  gtk_container_set_border_width (GTK_CONTAINER (frameTasks), 4);
#ifdef IN_GTK3
  gtk_scrolled_window_set_min_content_height (GTK_SCROLLED_WINDOW (frameTasks), 300);
#else
  gtk_widget_set_size_request(frameTasks, 20, 280);
#endif
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (frameTasks),
        GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  GtkWidget *viewport = gtk_viewport_new(NULL, NULL);
  widget_modify_bg(viewport, GTK_STATE_NORMAL, &colorWhite);
  gtk_widget_show (viewport);
  gtk_container_add (GTK_CONTAINER (frameTasks), viewport);
#ifdef IN_GTK3
  gtk_widget_set_vexpand(viewport, TRUE);
  gtk_widget_set_valign(viewport, GTK_ALIGN_START);
#endif

  IlmTasksBox = vbox_new (FALSE, 2);
  gtk_widget_set_name (IlmTasksBox, "IlmTasksBox");
  gtk_widget_show (IlmTasksBox);
  gtk_container_set_border_width (GTK_CONTAINER (IlmTasksBox), 4);
  gtk_container_add (GTK_CONTAINER (viewport), IlmTasksBox);
  GLADE_HOOKUP_OBJECT (father, IlmTasksBox, "IlmTasksBox");

// Task 0
  IlmTasksProFullBox = vbox_new (FALSE, 0);
  gtk_widget_set_name (IlmTasksProFullBox, "IlmTasksProFullBox");
  gtk_widget_show (IlmTasksProFullBox);
  gtk_box_pack_start (GTK_BOX (IlmTasksBox), IlmTasksProFullBox, TRUE, TRUE, 0);

  frame = NEW_FRAME(NULL, &FrameStyle1);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (IlmTasksProFullBox), frame, TRUE, TRUE, 0);

  IlmTasksProCheck = CHECK_BUTTON_BOLD("Task0: Find protein phases directly", MyBLUE, 1.1f);
  gtk_widget_set_name (IlmTasksProCheck, "IlmTasksProCheck");
  gtk_widget_show (IlmTasksProCheck);
  gtk_frame_set_label_widget(GTK_FRAME(frame), IlmTasksProCheck);

  IlmTasksProBox = hbox_new (FALSE, 8);
  gtk_widget_set_name (IlmTasksProBox, "IlmTasksProBox");
  gtk_widget_show (IlmTasksProBox);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), IlmTasksProBox);
  gtk_container_set_border_width (GTK_CONTAINER (IlmTasksProBox), 8);

  vbox1 = vbox_new (FALSE, 4);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (IlmTasksProBox), vbox1, TRUE, TRUE, 0);

  hbox1 = hbox_new (FALSE, 4);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  label = LABEL_NEW ("Select derivatives:  ", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox1), label, FALSE, FALSE, 0);

  for (int i=1; i<=Ilm::MAX_DERIVATIVES; i++)
  {
      std::stringstream name;
      name << "Deriv." << i;
      GtkWidget *check = CHECK_BUTTON_WITH_LABEL (name.str().c_str(), MyBLUE);
      name.str("");
      name << "IlmTasksProDeriv" << i << "Check";
      gtk_widget_set_name (check, name.str().c_str());
      GLADE_HOOKUP_OBJECT (father, check, name.str().c_str());
      gtk_widget_show (check);
      gtk_box_pack_start (GTK_BOX (hbox1), check, FALSE, FALSE, 20);
  }

  hbox1 = hbox_new (FALSE, 7);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  hbox2 = hbox_new (FALSE, 3);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);

  label = LABEL_NEW ("N. trials to generate by tangent: ", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox2), label, FALSE, FALSE, 0);

  IlmTasksProNtrialsSpin_adj = adj_new (60, 1, 500, 1, 10);
  IlmTasksProNtrialsSpin = spin_button_new (GTK_ADJUSTMENT (IlmTasksProNtrialsSpin_adj), 1, 0);
  gtk_widget_set_name (IlmTasksProNtrialsSpin, "IlmTasksProNtrialsSpin");
  gtk_widget_show (IlmTasksProNtrialsSpin);
  gtk_box_pack_start (GTK_BOX (hbox2), IlmTasksProNtrialsSpin, FALSE, TRUE, 0);

  label = LABEL_NEW ("to store:", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox2), label, FALSE, FALSE, 0);

  IlmTasksProNstoreSpin_adj = adj_new (10, 1, 500, 1, 10);
  IlmTasksProNstoreSpin = spin_button_new (GTK_ADJUSTMENT (IlmTasksProNstoreSpin_adj), 1, 0);
  gtk_widget_set_name (IlmTasksProNstoreSpin, "IlmTasksProNstoreSpin");
  gtk_widget_show (IlmTasksProNstoreSpin);
  gtk_box_pack_start (GTK_BOX (hbox2), IlmTasksProNstoreSpin, FALSE, TRUE, 0);

  label = LABEL_NEW ("to use:", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox2), label, FALSE, FALSE, 0);

  IlmTasksProNuseSpin_adj = adj_new (10, 1, 500, 1, 10);
  IlmTasksProNuseSpin = spin_button_new (GTK_ADJUSTMENT (IlmTasksProNuseSpin_adj), 1, 0);
  gtk_widget_set_name (IlmTasksProNuseSpin, "IlmTasksProNuseSpin");
  gtk_widget_show (IlmTasksProNuseSpin);
  gtk_box_pack_start (GTK_BOX (hbox2), IlmTasksProNuseSpin, FALSE, TRUE, 0);

  IlmTasksProNtrialsCheck = CHECK_BUTTON_WITH_LABEL ("default", MyBLUE);
  gtk_widget_set_name (IlmTasksProNtrialsCheck, "IlmTasksProNtrialsCheck");
  gtk_widget_show (IlmTasksProNtrialsCheck);
  gtk_box_pack_start (GTK_BOX (hbox2), IlmTasksProNtrialsCheck, FALSE, FALSE, 0);

  GLADE_HOOKUP_OBJECT (father, IlmTasksProFullBox, "IlmTasksProFullBox");
  GLADE_HOOKUP_OBJECT (father, IlmTasksProCheck, "IlmTasksProCheck");
  GLADE_HOOKUP_OBJECT (father, IlmTasksProBox, "IlmTasksProBox");
  GLADE_HOOKUP_OBJECT (father, IlmTasksProNtrialsSpin, "IlmTasksProNtrialsSpin");
  GLADE_HOOKUP_OBJECT (father, IlmTasksProNstoreSpin, "IlmTasksProNstoreSpin");
  GLADE_HOOKUP_OBJECT (father, IlmTasksProNuseSpin, "IlmTasksProNuseSpin");
  GLADE_HOOKUP_OBJECT (father, IlmTasksProNtrialsCheck, "IlmTasksProNtrialsCheck");

  g_signal_connect ((gpointer) IlmTasksProCheck, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksProNtrialsSpin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksProNstoreSpin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksProNuseSpin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksProNtrialsCheck, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);

//Task 1
  IlmTasksMad1FullBox = vbox_new (FALSE, 0);
  gtk_widget_set_name (IlmTasksMad1FullBox, "IlmTasksMad1FullBox");
  gtk_widget_show (IlmTasksMad1FullBox);
  gtk_box_pack_start (GTK_BOX (IlmTasksBox), IlmTasksMad1FullBox, TRUE, TRUE, 0);

  frame = NEW_FRAME(NULL, &FrameStyle1);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad1FullBox), frame, TRUE, TRUE, 0);

  IlmTasksMad1Check = CHECK_BUTTON_BOLD ("Task1: Find anomalous substructure", MyBLUE, 1.1f);
  gtk_widget_set_name (IlmTasksMad1Check, "IlmTasksMad1Check");
  gtk_widget_show (IlmTasksMad1Check);
  set_tip (IlmTasksMad1Check, "Check this if you want to find positions of anomalous scatterers. You may skip this step if you know them.");
  gtk_frame_set_label_widget(GTK_FRAME(frame), IlmTasksMad1Check);

  IlmTasksMad1Box = hbox_new (FALSE, 8);
  gtk_widget_set_name (IlmTasksMad1Box, "IlmTasksMad1Box");
  gtk_widget_show (IlmTasksMad1Box);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), IlmTasksMad1Box);
  gtk_container_set_border_width (GTK_CONTAINER (IlmTasksMad1Box), 8);

  vbox2 = vbox_new (FALSE, 4);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad1Box), vbox2, TRUE, TRUE, 0);

  IlmTasksMad1WaveTable = table_new (4, 3, FALSE);
  gtk_widget_set_name (IlmTasksMad1WaveTable, "IlmTasksMad1WaveTable");
  gtk_widget_show (IlmTasksMad1WaveTable);
  gtk_box_pack_start (GTK_BOX (vbox2), IlmTasksMad1WaveTable, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (IlmTasksMad1WaveTable), 4);
  table_set_col_spacings (IlmTasksMad1WaveTable, 4);

  hbox1 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  table_attach (IlmTasksMad1WaveTable, hbox1, 1, 2, 0, 1);

//  for(int i=1; i<=4; i++)
  for(int i=1; i<=Ilm::MAX_DERIVATIVES; i++)
  {
      std::stringstream nome;
      nome << "Wave " << i;
      GtkWidget *check = CHECK_BUTTON_WITH_LABEL (nome.str().c_str(), MyBLUE);
      gtk_widget_show (check);
      gtk_box_pack_start (GTK_BOX (hbox1), check, FALSE, FALSE, 20);
      nome.str("");
      nome << "IlmTasksMad1Wave" << i << "Check";
      GLADE_HOOKUP_OBJECT (father, check, nome.str().c_str());
      g_signal_connect ((gpointer) check, "toggled",
                    G_CALLBACK (on_IlmTasksMad1WaveCheck_toggled),
                    NULL);
  }
  IlmTasksMad1AutoCheck = CHECK_BUTTON_WITH_LABEL ("Auto", MyBLUE);
  gtk_widget_set_name (IlmTasksMad1AutoCheck, "IlmTasksMad1AutoCheck");
  gtk_widget_show (IlmTasksMad1AutoCheck);
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1AutoCheck, "IlmTasksMad1AutoCheck");
  table_attach (IlmTasksMad1WaveTable, IlmTasksMad1AutoCheck, 2, 3, 0, 1, TRUE);

  IlmTasksMad1SelectWavesLbl = LABEL_NEW ("Select waves:", MyBLUE);
  gtk_widget_set_name (IlmTasksMad1SelectWavesLbl, "IlmTasksMad1SelectWavesLbl");
  gtk_widget_show (IlmTasksMad1SelectWavesLbl);
  table_attach (IlmTasksMad1WaveTable, IlmTasksMad1SelectWavesLbl, 0, 1, 0, 1, TRUE);
  set_alignment (IlmTasksMad1SelectWavesLbl, 0., 0.5);

//non si vede
  IlmTasksMad1ReflBox = hbox_new (FALSE, 6);
  gtk_widget_set_name (IlmTasksMad1ReflBox, "IlmTasksMad1ReflBox");
//070309  gtk_widget_show (IlmTasksMad1ReflBox);
  gtk_box_pack_start (GTK_BOX (vbox2), IlmTasksMad1ReflBox, TRUE, FALSE, 0);

  label104 = LABEL_NEW ("Number of strong reflections for direct methods:", MyBLUE);
  gtk_widget_set_name (label104, "label104");
  gtk_widget_show (label104);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad1ReflBox), label104, FALSE, FALSE, 0);
  set_alignment (label104, 0, 0.5);

  IlmTasksMad1NreflSpin_adj = adj_new (900, 0, 1e+07, 100, 1000);
  IlmTasksMad1NreflSpin = spin_button_new (GTK_ADJUSTMENT (IlmTasksMad1NreflSpin_adj), 1, 0);
  gtk_widget_set_name (IlmTasksMad1NreflSpin, "IlmTasksMad1NreflSpin");
  gtk_widget_show (IlmTasksMad1NreflSpin);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad1ReflBox), IlmTasksMad1NreflSpin, FALSE, FALSE, 0);
  set_tip (IlmTasksMad1NreflSpin, "Number of strong reflections used in direct methods procedure");

  IlmTasksMad1NreflCheck = CHECK_BUTTON_WITH_LABEL ("Use default value", MyBLUE);
  gtk_widget_set_name (IlmTasksMad1NreflCheck, "IlmTasksMad1NreflCheck");
  gtk_widget_show (IlmTasksMad1NreflCheck);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad1ReflBox), IlmTasksMad1NreflCheck, FALSE, FALSE, 0);
//fin qui

  GtkWidget *spin = SPIN_WITH_LABEL("Max resolution: ", NULL, 0.001, 100, 0.001, 0.1, 5);
  table_attach (IlmTasksMad1WaveTable, spin, 0, 1, 1, 2, TRUE);
  gtk_widget_show_all (spin);
  IlmTasksMad1MaxresSpin = get_widget(spin, "spin");
  gtk_widget_set_name (IlmTasksMad1MaxresSpin, "IlmTasksMad1MaxresSpin");

  IlmTasksMad1MaxresCheck = CHECK_BUTTON_WITH_LABEL ("Use default value", MyBLUE);
  gtk_widget_set_name (IlmTasksMad1MaxresCheck, "IlmTasksMad1MaxresCheck");
  gtk_widget_show (IlmTasksMad1MaxresCheck);
  table_attach (IlmTasksMad1WaveTable, IlmTasksMad1MaxresCheck, 2, 3, 1, 2, TRUE);

  IlmTasksMad1PattersonCheck = RADIO_BUTTON_WITH_LABEL (NULL, "Use Patterson", MyBLUE);
  gtk_widget_set_name (IlmTasksMad1PattersonCheck, "IlmTasksMad1PattersonCheck");
  gtk_widget_show (IlmTasksMad1PattersonCheck);
  table_attach (IlmTasksMad1WaveTable, IlmTasksMad1PattersonCheck, 0, 1, 2, 3, TRUE);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmTasksMad1PattersonCheck), IlmTasksMad1Solve_group);
  IlmTasksMad1Solve_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON(IlmTasksMad1PattersonCheck));

  IlmTasksMad1DMCheck = RADIO_BUTTON_WITH_LABEL (NULL, "Use Direct Methods", MyBLUE);
  gtk_widget_set_name (IlmTasksMad1DMCheck, "IlmTasksMad1DMCheck");
  gtk_widget_show (IlmTasksMad1DMCheck);
  table_attach (IlmTasksMad1WaveTable, IlmTasksMad1DMCheck, 1, 2, 2, 3, TRUE);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmTasksMad1DMCheck), IlmTasksMad1Solve_group);
  IlmTasksMad1Solve_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON(IlmTasksMad1DMCheck));

  IlmTasksMad1MorePowerCheck = CHECK_BUTTON_WITH_LABEL ("More Power", MyBLUE);
  gtk_widget_set_name (IlmTasksMad1MorePowerCheck, "IlmTasksMad1MorePowerCheck");
  gtk_widget_show (IlmTasksMad1MorePowerCheck);
  table_attach (IlmTasksMad1WaveTable, IlmTasksMad1MorePowerCheck, 2, 3, 2, 3, TRUE);

  spin = SPIN_WITH_LABEL("N. trials  to generate : ", NULL, 1, 1000, 60, 1, 0);
  IlmTasksMad1Ntrials1Spin = get_widget(spin, "spin");
  gtk_widget_set_name (IlmTasksMad1Ntrials1Spin, "IlmTasksMad1Ntrials1Spin");
  gtk_widget_show_all (spin);
  table_attach (IlmTasksMad1WaveTable, spin, 0, 1, 3, 4, TRUE);

  spin = SPIN_WITH_LABEL(" to store: ", NULL, 1, 1000, 60, 1, 0);
  IlmTasksMad1Ntrials2Spin = get_widget(spin, "spin");
  gtk_widget_set_name (IlmTasksMad1Ntrials2Spin, "IlmTasksMad1Ntrials2Spin");
  gtk_widget_show_all (spin);
  table_attach (IlmTasksMad1WaveTable, spin, 1, 2, 3, 4, TRUE);

  IlmTasksMad1NtrialsCheck = CHECK_BUTTON_WITH_LABEL ("Use default values", MyBLUE);
  gtk_widget_set_name (IlmTasksMad1NtrialsCheck, "IlmTasksMad1NtrialsCheck");
  gtk_widget_show (IlmTasksMad1NtrialsCheck);
  table_attach (IlmTasksMad1WaveTable, IlmTasksMad1NtrialsCheck, 2, 3, 3, 4, TRUE);

  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1FullBox, "IlmTasksMad1FullBox");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1Check, "IlmTasksMad1Check");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1Box, "IlmTasksMad1Box");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1WaveTable, "IlmTasksMad1WaveTable");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1SelectWavesLbl, "IlmTasksMad1SelectWavesLbl");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1ReflBox, "IlmTasksMad1ReflBox");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1NreflSpin, "IlmTasksMad1NreflSpin");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1NreflCheck, "IlmTasksMad1NreflCheck");
//  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1ResBox, "IlmTasksMad1ResBox");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1MaxresSpin, "IlmTasksMad1MaxresSpin");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1MaxresCheck, "IlmTasksMad1MaxresCheck");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1PattersonCheck, "IlmTasksMad1PattersonCheck");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1DMCheck, "IlmTasksMad1DMCheck");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1MorePowerCheck, "IlmTasksMad1MorePowerCheck");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1Ntrials1Spin, "IlmTasksMad1Ntrials1Spin");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1Ntrials2Spin, "IlmTasksMad1Ntrials2Spin");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad1NtrialsCheck, "IlmTasksMad1NtrialsCheck");
  g_signal_connect ((gpointer) IlmTasksMad1Check, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1AutoCheck, "toggled",
                    G_CALLBACK (on_IlmTasksMad1AutoCheck_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1NreflSpin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1NreflCheck, "toggled",
                    G_CALLBACK (on_IlmTasksMad1NreflCheck_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1MaxresSpin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1MaxresCheck, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1Ntrials1Spin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1Ntrials2Spin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1NtrialsCheck, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1PattersonCheck, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);


// Task 2
  IlmTasksMad2FullBox = vbox_new (FALSE, 0);
  gtk_widget_set_name (IlmTasksMad2FullBox, "IlmTasksMad2FullBox");
  gtk_widget_show (IlmTasksMad2FullBox);
  gtk_box_pack_start (GTK_BOX (IlmTasksBox), IlmTasksMad2FullBox, TRUE, TRUE, 0);

  frame = NEW_FRAME(NULL, &FrameStyle1);
  gtk_widget_show(frame);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad2FullBox), frame, TRUE, TRUE, 0);

  IlmTasksMad2Check = CHECK_BUTTON_BOLD ("Task2: MAD Phasing", MyBLUE, 1.1f);
  gtk_widget_set_name (IlmTasksMad2Check, "IlmTasksMad2Check");
  gtk_widget_show (IlmTasksMad2Check);
  set_tip (IlmTasksMad2Check, "Perform phasing using previously determined positions of anomalous scatterers.");
  gtk_frame_set_label_widget(GTK_FRAME(frame), IlmTasksMad2Check);

  IlmTasksMad2VBox = vbox_new (FALSE, 8);
  gtk_widget_set_name (IlmTasksMad2VBox, "IlmTasksMad2VBox");
  gtk_widget_show (IlmTasksMad2VBox);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), IlmTasksMad2VBox);
  gtk_container_set_border_width (GTK_CONTAINER (IlmTasksMad2VBox), 8);

  IlmTasksMad2Box = hbox_new (FALSE, 8);
  gtk_widget_set_name (IlmTasksMad2Box, "IlmTasksMad2Box");
  gtk_widget_show (IlmTasksMad2Box);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad2VBox), IlmTasksMad2Box, TRUE, TRUE, 0);

  vbox2 = vbox_new (FALSE, 3);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad2Box), vbox2, TRUE, TRUE, 0);

  table = table_new (4, 3, FALSE);
  gtk_widget_show (table);
  gtk_box_pack_start (GTK_BOX (vbox2), table, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table), 4);
  table_set_col_spacings (table, 4);
  table_set_row_spacings (table, 10);

  hbox1 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  table_attach (table, hbox1, 1, 2, 0, 1, TRUE);
  for(int i=1; i<=Ilm::MAX_DERIVATIVES; i++)
  {
      std::stringstream nome;
      nome << "Wave " << i;
      GtkWidget *check = CHECK_BUTTON_WITH_LABEL (nome.str().c_str(), MyBLUE);
      gtk_widget_show (check);
      gtk_box_pack_start (GTK_BOX (hbox1), check, FALSE, FALSE, 20);
      nome.str("");
      nome << "IlmTasksMad2Wave" << i << "Check";
      GLADE_HOOKUP_OBJECT (father, check, nome.str().c_str());
      g_signal_connect ((gpointer) check, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  }

  IlmTasksMad2SelectWavesLbl = LABEL_NEW ("Select waves:", MyBLUE);
  gtk_widget_set_name (IlmTasksMad2SelectWavesLbl, "IlmTasksMad2SelectWavesLbl");
  gtk_widget_show (IlmTasksMad2SelectWavesLbl);
  table_attach (table, IlmTasksMad2SelectWavesLbl, 0, 1, 0, 1, TRUE);
  set_alignment (IlmTasksMad2SelectWavesLbl, 0., 0.5);

  hbox1 = hbox_new(FALSE, 6);
  gtk_widget_show(hbox1);
  table_attach (table, hbox1, 0, 3, 1, 2, TRUE);

  IlmTasksFilePositionRadio = gtk_radio_button_new(NULL);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmTasksFilePositionRadio), IlmTasksFPRadio_group);
  IlmTasksFPRadio_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (IlmTasksFilePositionRadio));
  gtk_box_pack_start (GTK_BOX (hbox1), IlmTasksFilePositionRadio, FALSE, FALSE, 0);
  gtk_widget_show(IlmTasksFilePositionRadio);

  IlmTasksMad2FileEntry = entry_for_filesel(hbox1, "Anomalous scatterers positions file: (PDB)",
                                        "IlmTasksMad2FileEntry", 1, 1);
  set_tip (IlmTasksMad2FileEntry, "The file with the coordinates of anomalous scatterers.");
  set_width_chars (GTK_ENTRY (IlmTasksMad2FileEntry), 60);
  IlmTasksMad2BrowseBtn = get_widget (IlmTasksMad2FileEntry, "browse");
  IlmTasksMad2FileLbl = get_widget (IlmTasksMad2FileEntry, "label");
  IlmTasksMad2FilePreview = get_widget (IlmTasksMad2FileEntry, "preview");
  gtk_widget_set_name (IlmTasksMad2BrowseBtn, "IlmTasksMad2BrowseBtn");
  IlmTasksMad2FileBox = get_widget (IlmTasksMad2FileEntry, "box");
  gtk_widget_set_name (IlmTasksMad2FileBox, "IlmTasksMad2FileBox");

  hbox2 = hbox_new(FALSE, 6);
  gtk_widget_show(hbox2);
  table_attach (table, hbox2, 0, 3, 2, 3, TRUE);

  IlmTasksBestTrialsRadio = gtk_radio_button_new(NULL);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmTasksBestTrialsRadio), IlmTasksFPRadio_group);
  IlmTasksFPRadio_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (IlmTasksBestTrialsRadio));
  gtk_box_pack_start (GTK_BOX (hbox2), IlmTasksBestTrialsRadio, FALSE, FALSE, 0);
  gtk_widget_show(IlmTasksBestTrialsRadio);

  hboxBestTrials = hbox_new (FALSE, 6);
  gtk_widget_set_name (hboxBestTrials, "IlmBoxBestTrials");
  gtk_widget_show (hboxBestTrials);
  gtk_box_pack_start (GTK_BOX (hbox2), hboxBestTrials, TRUE, TRUE, 0);
  gtk_widget_set_sensitive(hboxBestTrials, FALSE);

  label = LABEL_NEW ("Best trials   from:", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hboxBestTrials), label, FALSE, FALSE, 0);

  IlmTasksMad2MinSpin_adj = adj_new (2, 1, 100, 1, 10);
  IlmTasksMad2MinSpin = spin_button_new (GTK_ADJUSTMENT (IlmTasksMad2MinSpin_adj), 1, 0);
  gtk_widget_set_name (IlmTasksMad2MinSpin, "IlmTasksMad2MinSpin");
  gtk_widget_show (IlmTasksMad2MinSpin);
  gtk_box_pack_start (GTK_BOX (hboxBestTrials), IlmTasksMad2MinSpin, FALSE, TRUE, 0);

  label = LABEL_NEW ("to:", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hboxBestTrials), label, FALSE, FALSE, 0);

  IlmTasksMad2MaxSpin_adj = adj_new (7, 1, 100, 1, 10);
  IlmTasksMad2MaxSpin = spin_button_new (GTK_ADJUSTMENT (IlmTasksMad2MaxSpin_adj), 1, 0);
  gtk_widget_set_name (IlmTasksMad2MaxSpin, "IlmTasksMad2MaxSpin");
  gtk_widget_show (IlmTasksMad2MaxSpin);
  gtk_box_pack_start (GTK_BOX (hboxBestTrials), IlmTasksMad2MaxSpin, FALSE, TRUE, 0);

  IlmTasksMad2MaxLabel = gtk_label_new("");
  gtk_widget_set_name (IlmTasksMad2MaxLabel, "IlmTasksMad2MaxLabel");
  gtk_widget_show (IlmTasksMad2MaxLabel);
  gtk_box_pack_start (GTK_BOX (hboxBestTrials), IlmTasksMad2MaxLabel, FALSE, FALSE, 0);

  hbox2 = hbox_new (FALSE, 17);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 4);

  IlmTasksMad2LsqCheck = CHECK_BUTTON_WITH_LABEL ("LSQ:   parameters to refine       ", MyBLUE);
  gtk_widget_set_name (IlmTasksMad2LsqCheck, "IlmTasksMad2LsqCheck");
  gtk_widget_show (IlmTasksMad2LsqCheck);
  set_tip (IlmTasksMad2LsqCheck, "Least squares refinement");
  table_attach (table, IlmTasksMad2LsqCheck, 0, 1, 3, 4, TRUE);

  IlmTasksMad2LsqBox1 = hbox_new (FALSE, 0);
  gtk_widget_set_name (IlmTasksMad2LsqBox1, "IlmTasksMad2LsqBox1");
  gtk_widget_show (IlmTasksMad2LsqBox1);
  table_attach (table, IlmTasksMad2LsqBox1, 1, 2, 3, 4, TRUE);

  label = LABEL_NEW ("Atomic parameters: ", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad2LsqBox1), label, FALSE, FALSE, 0);
  set_alignment (label, 0., 0.5);

  IlmTasksMad2LsqPosCheck = CHECK_BUTTON_WITH_LABEL ("position", MyBLUE);
  gtk_widget_set_name (IlmTasksMad2LsqPosCheck, "IlmTasksMad2LsqPosCheck");
  gtk_widget_show (IlmTasksMad2LsqPosCheck);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad2LsqBox1), IlmTasksMad2LsqPosCheck, FALSE, FALSE, 0);
  set_tip (IlmTasksMad2LsqPosCheck, "x,y,z coordinates");

  IlmTasksMad2LsqAdpCheck = CHECK_BUTTON_WITH_LABEL ("B-factor", MyBLUE);
  gtk_widget_set_name (IlmTasksMad2LsqAdpCheck, "IlmTasksMad2LsqAdpCheck");
  gtk_widget_show (IlmTasksMad2LsqAdpCheck);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad2LsqBox1), IlmTasksMad2LsqAdpCheck, FALSE, FALSE, 0);
  set_tip (IlmTasksMad2LsqAdpCheck, "Atomic displacement parameter");

  IlmTasksMad2LsqSofCheck = CHECK_BUTTON_WITH_LABEL ("sof", MyBLUE);
  gtk_widget_set_name (IlmTasksMad2LsqSofCheck, "IlmTasksMad2LsqSofCheck");
  gtk_widget_show (IlmTasksMad2LsqSofCheck);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad2LsqBox1), IlmTasksMad2LsqSofCheck, FALSE, FALSE, 0);
  set_tip (IlmTasksMad2LsqSofCheck, "Site ocupation factor");

  label = LABEL_NEW ("Wave parameters: ", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad2LsqBox1), label, FALSE, FALSE, 30);
  set_alignment(label, 0., 0.5);
  GLADE_HOOKUP_OBJECT (father, label, "IlmTasksMad2LsqLabel");

  char nome[40];
  ScriviStringa(nome, sizeof(nome), "%sf'", special_car_greek('D'));
  IlmTasksMad2LsqF1Check = CHECK_BUTTON_WITH_LABEL (nome, MyBLUE);
  gtk_widget_set_name (IlmTasksMad2LsqF1Check, "IlmTasksMad2LsqF1Check");
  gtk_widget_show (IlmTasksMad2LsqF1Check);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad2LsqBox1), IlmTasksMad2LsqF1Check, FALSE, FALSE, 0);

  IlmTasksMad2LsqF2Check = CHECK_BUTTON_WITH_LABEL ("f''", MyBLUE);
  gtk_widget_set_name (IlmTasksMad2LsqF2Check, "IlmTasksMad2LsqF2Check");
  gtk_widget_show (IlmTasksMad2LsqF2Check);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad2LsqBox1), IlmTasksMad2LsqF2Check, FALSE, FALSE, 0);

  GtkWidget *edm_frame = frameEDM(father);
#ifdef IN_GTK3
  GtkWidget *align = new_alignment(GTK_ALIGN_START,GTK_ALIGN_START,1,0);
#else
  GtkWidget *align = gtk_alignment_new(0,0,1,0);
#endif

  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad2VBox), align, TRUE, TRUE, 0);
  gtk_container_add (GTK_CONTAINER (align), edm_frame);

// attenzione perche' la roba di sotto non viene mostrata

  GtkWidget *hbox158a = hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox158a, "hbox158a");
//  table_attach(IlmTasksTable, hbox158a, 4, 5, 0, 1, TRUE);

  IlmTasksEdmExCheck = CHECK_BUTTON_WITH_LABEL ("Extrapolate reflections", MyBLUE);
  gtk_widget_set_name (IlmTasksEdmExCheck, "IlmTasksEdmExCheck");
  gtk_widget_show (IlmTasksEdmExCheck);
  gtk_box_pack_start (GTK_BOX (hbox158a), IlmTasksEdmExCheck, TRUE, TRUE, 0);

  IlmTasksEdmExtraSpin = SPIN_WITH_LABEL2 ("up to resolution: ",MyBLUE, 0, 1, 1, 0.05, 2, 1);
  gtk_widget_set_name (get_widget(IlmTasksEdmExtraSpin, "spin"), "IlmTasksEdmExtraSpin");
  gtk_widget_show_all (IlmTasksEdmExtraSpin);
  gtk_box_pack_start (GTK_BOX (hbox158a), IlmTasksEdmExtraSpin, FALSE, TRUE, 0);
  gtk_widget_set_sensitive(IlmTasksEdmExtraSpin, FALSE);

// fin qui

  IlmTasksImproveFrame = NEW_FRAME(NULL, &FrameStyle1);
  gtk_widget_set_name (IlmTasksImproveFrame, "IlmTasksImproveFrame");
  gtk_widget_show (IlmTasksImproveFrame);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START,GTK_ALIGN_START,1,0);
#else
  align = gtk_alignment_new(0,0,1,0);
#endif

  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (IlmTasksMad2VBox), align, TRUE, TRUE, 0);
  gtk_container_add (GTK_CONTAINER (align), IlmTasksImproveFrame);

  GtkWidget *vbox158c = vbox_new (FALSE, 0);
  gtk_widget_show (vbox158c);
  gtk_container_add (GTK_CONTAINER (get_widget(IlmTasksImproveFrame, "align")), vbox158c);
  gtk_container_set_border_width (GTK_CONTAINER (vbox158c), 8);

  IlmTasksEdmFLCheck =  CHECK_BUTTON_BOLD(" Free Lunch - Improve map resolution ", MyBLUE, 1.1f);
  gtk_widget_set_name (IlmTasksEdmFLCheck, "IlmTasksEdmFLCheck");
  gtk_widget_show (IlmTasksEdmFLCheck);
  gtk_frame_set_label_widget(GTK_FRAME(IlmTasksImproveFrame), IlmTasksEdmFLCheck);

  IlmTasksEDMLabel = gtk_label_new(" ");
  gtk_widget_set_name (IlmTasksEDMLabel, "IlmTasksEDMLabel");
  gtk_widget_show(IlmTasksEDMLabel);
  gtk_box_pack_start (GTK_BOX (vbox158c), IlmTasksEDMLabel, FALSE, FALSE, 10);
  set_alignment (IlmTasksEDMLabel, 0., 0.5);

  hbox158b = hbox_new (FALSE, 4);
  gtk_widget_set_name (hbox158b, "hbox158b");
  gtk_widget_show (hbox158b);
  gtk_box_pack_start (GTK_BOX (vbox158c), hbox158b, FALSE, FALSE, 4);
//  gtk_container_set_border_width (GTK_CONTAINER (hbox158b), 8);

  IlmTasksEdmFLSpin = SPIN_WITH_LABEL2 ("Free Lunch up to resolution: ", MyBLUE, 0, 1, 1, 0.05, 2, 1);
  gtk_widget_set_name (get_widget(IlmTasksEdmFLSpin, "spin"), "IlmTasksEdmFLSpin");
  gtk_widget_show_all (IlmTasksEdmFLSpin);
  gtk_box_pack_start (GTK_BOX (hbox158b), IlmTasksEdmFLSpin, FALSE, TRUE, 2);
  gtk_widget_set_sensitive(IlmTasksEdmFLSpin, FALSE);

  frame = frameStrategy(father, IlmTasksBox);
//mr 23/05/06  gtk_widget_show (frame);

  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2FullBox, "IlmTasksMad2FullBox");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2Check, "IlmTasksMad2Check");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2VBox, "IlmTasksMad2VBox");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2Box, "IlmTasksMad2Box");
//  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2Wave1Check, "IlmTasksMad2Wave1Check");
//  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2Wave2Check, "IlmTasksMad2Wave2Check");
//  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2Wave3Check, "IlmTasksMad2Wave3Check");
//  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2Wave4Check, "IlmTasksMad2Wave4Check");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2SelectWavesLbl, "IlmTasksMad2SelectWavesLbl");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2FileEntry, "IlmTasksMad2FileEntry");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2BrowseBtn, "IlmTasksMad2BrowseBtn");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2FileLbl, "IlmTasksMad2FileLbl");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2FilePreview, "IlmTasksMad2FilePreview");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2FileBox, "IlmTasksMad2FileBox");
  GLADE_HOOKUP_OBJECT (father, IlmTasksFilePositionRadio, "IlmTasksFilePositionRadio");
  GLADE_HOOKUP_OBJECT (father, IlmTasksBestTrialsRadio, "IlmTasksBestTrialsRadio");
  GLADE_HOOKUP_OBJECT (father, hboxBestTrials, "IlmBoxBestTrials");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2MinSpin, "IlmTasksMad2MinSpin");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2MaxSpin, "IlmTasksMad2MaxSpin");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2MaxLabel, "IlmTasksMad2MaxLabel");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2LsqCheck, "IlmTasksMad2LsqCheck");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2LsqBox1, "IlmTasksMad2LsqBox1");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2LsqPosCheck, "IlmTasksMad2LsqPosCheck");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2LsqAdpCheck, "IlmTasksMad2LsqAdpCheck");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2LsqSofCheck, "IlmTasksMad2LsqSofCheck");
//  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2LsqBox2, "IlmTasksMad2LsqBox2");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2LsqF1Check, "IlmTasksMad2LsqF1Check");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMad2LsqF2Check, "IlmTasksMad2LsqF2Check");
  GLADE_HOOKUP_OBJECT (father, IlmTasksImproveFrame, "IlmTasksImproveFrame");
  GLADE_HOOKUP_OBJECT (father, IlmTasksEdmExCheck, "IlmTasksEdmExCheck");
  GLADE_HOOKUP_OBJECT (father, IlmTasksEdmFLCheck, "IlmTasksEdmFLCheck");
  GLADE_HOOKUP_OBJECT (father, IlmTasksEDMLabel, "IlmTasksEDMLabel");
  GLADE_HOOKUP_OBJECT (father, get_widget(IlmTasksEdmExtraSpin, "spin"), "IlmTasksEdmExtraSpin");
  GLADE_HOOKUP_OBJECT (father, get_widget(IlmTasksEdmExtraSpin, "check"), "IlmTasksEdmExtraDefaults");
  GLADE_HOOKUP_OBJECT (father, get_widget(IlmTasksEdmFLSpin, "spin"), "IlmTasksEdmFLSpin");
  GLADE_HOOKUP_OBJECT (father, get_widget(IlmTasksEdmFLSpin, "check"), "IlmTasksEdmFLDefaults");

  g_signal_connect ((gpointer) IlmTasksMad1Check, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1AutoCheck, "toggled",
                    G_CALLBACK (on_IlmTasksMad1AutoCheck_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1NreflSpin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1NreflCheck, "toggled",
                    G_CALLBACK (on_IlmTasksMad1NreflCheck_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1MaxresSpin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1MaxresCheck, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1Ntrials1Spin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1Ntrials2Spin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1NtrialsCheck, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad1PattersonCheck, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad2Check, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
/*
  g_signal_connect ((gpointer) IlmTasksMad2Wave1Check, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad2Wave2Check, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad2Wave3Check, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad2Wave4Check, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
*/
  g_signal_connect ((gpointer) IlmTasksMad2BrowseBtn, "clicked",
                    G_CALLBACK (on_IlmTasksMad2BrowseBtn_clicked),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksMad2FilePreview, "clicked",
                    G_CALLBACK (on_Ilm_text_view_clicked),
                    IlmTasksMad2FileEntry);
  hnd = g_signal_connect ((gpointer) IlmTasksMad2MinSpin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_object_set_data(G_OBJECT(IlmTasksMad2MinSpin), "hnd", GINT_TO_POINTER(hnd));
  hnd = g_signal_connect ((gpointer) IlmTasksMad2MaxSpin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_object_set_data(G_OBJECT(IlmTasksMad2MaxSpin), "hnd", GINT_TO_POINTER(hnd));
  g_signal_connect ((gpointer) IlmTasksMad2LsqCheck, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksEdmFLCheck, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect(G_OBJECT(IlmTasksEdmExCheck), "toggled",
                   G_CALLBACK(on_cb_attiva), IlmTasksEdmExtraSpin);
  g_signal_connect(G_OBJECT(IlmTasksEdmFLCheck), "toggled",
                   G_CALLBACK(on_cb_attiva), IlmTasksEdmFLSpin);
  g_signal_connect(G_OBJECT(IlmTasksEdmFLCheck), "toggled",
                   G_CALLBACK(on_cb_disattiva), hbox158a);
  g_signal_connect(G_OBJECT(IlmTasksEdmExCheck), "toggled",
                   G_CALLBACK(on_cb_disattiva), IlmTasksImproveFrame);
  g_signal_connect(G_OBJECT(IlmTasksFilePositionRadio), "toggled",
                   G_CALLBACK(on_cb_attiva), IlmTasksMad2FileBox);
  g_signal_connect(G_OBJECT(IlmTasksBestTrialsRadio), "toggled",
                   G_CALLBACK(on_cb_attiva), hboxBestTrials);
  g_signal_connect(G_OBJECT(IlmTasksBestTrialsRadio), "toggled",
                   G_CALLBACK(on_Check_activated), NULL);

  return frameTasks;
}

GtkWidget *frameLig(GtkWidget *father, GtkWidget *parentBox)
{
  GtkWidget *IlmContLigFrm = gtk_frame_new (NULL);
  gtk_widget_set_name (IlmContLigFrm, "IlmContLigFrm");
  gtk_widget_show (IlmContLigFrm);
  gtk_box_pack_start (GTK_BOX (parentBox), IlmContLigFrm, FALSE, FALSE, 0);

  GtkWidget *hbox1 = hbox_new (FALSE, 12);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (IlmContLigFrm), hbox1);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 8);

  for(int i=1; i<=4;i++)
  {
      GtkWidget *hbox2 = hbox_new (FALSE, 4);
      gtk_widget_show (hbox2);
      gtk_box_pack_start (GTK_BOX (hbox1), hbox2, FALSE, TRUE, 0);

      std::stringstream name;
      name << "IlmContLigSymbol" << i << "Entry";
      GtkWidget *entry = gtk_entry_new ();
      gtk_widget_set_name (entry, name.str().c_str());
      gtk_widget_show (entry);
      gtk_box_pack_start (GTK_BOX (hbox2), entry, FALSE, TRUE, 0);
//      gtk_entry_set_max_length (GTK_ENTRY (entry), 3);
      set_width_chars (GTK_ENTRY (entry), 3);
      GLADE_HOOKUP_OBJECT (father, entry, name.str().c_str());

      name.str("");
      name << "IlmContLigAmount" << i << "Spin";
      GObject *adj = adj_new (0, 0, 10000, 1, 10);
      GtkWidget *spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 0);
      gtk_widget_set_name (spin, name.str().c_str());
      gtk_widget_show (spin);
      gtk_box_pack_start (GTK_BOX (hbox2), spin, FALSE, TRUE, 0);
      GLADE_HOOKUP_OBJECT (father, spin, name.str().c_str());
  }
  return IlmContLigFrm;
}

GtkWidget *frameMir(GtkWidget *father, GtkWidget *parentBox)
{
  GtkWidget *label;
  GtkWidget *IlmContMirFrm = gtk_frame_new (NULL);
  gtk_widget_set_name (IlmContMirFrm, "IlmContMirFrm");
  gtk_widget_show (IlmContMirFrm);
  gtk_box_pack_start (GTK_BOX (parentBox), IlmContMirFrm, FALSE, FALSE, 0);

  GtkWidget *table = table_new (2, 6, FALSE);
  gtk_widget_show (table);
  gtk_container_add (GTK_CONTAINER (IlmContMirFrm), table);
  table_set_row_spacings (table, 3);
  table_set_col_spacings (table, 5);

  for(int nd=0; nd<=Ilm::MAX_DERIVATIVES; nd++)
  {
      if(nd == 0)
         label = LABEL_NEW ("Native\nElement - Amount", MyBLUE);
      else
         label = LABEL_NEW (g_strdup_printf("Deriv.%d", nd), MyBLUE);
      gtk_widget_show (label);
      table_attach (table, label, nd, nd+1, 0, 1, TRUE);
      gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_CENTER);
      set_alignment(label, 0., 0.5);

      GtkWidget *tbl = table_new (4, 2, FALSE);
      std::stringstream nometbl;
      nometbl << "IlmContMir" << nd << "Tbl"; 
      gtk_widget_show (tbl);
      gtk_widget_set_name(tbl, nometbl.str().c_str());
      table_attach (table, tbl, nd, nd+1, 1, 2, TRUE);
      table_set_row_spacings (tbl, 1);
      table_set_col_spacings (tbl, 1);
      GLADE_HOOKUP_OBJECT (father, tbl, nometbl.str().c_str());

      for(int j=1; j<=4; j++)
      {
         std::stringstream nome1, nome2;
         nome1 << "IlmContMir" << nd << "Symbol" << j << "Entry"; 
         nome2 << "IlmContMir" << nd << "Amount" << j << "Spin"; 

         GtkWidget *entry = gtk_entry_new ();
         gtk_widget_set_name (entry, nome1.str().c_str());
         gtk_widget_show (entry);
         table_attach (tbl, entry, 0, 1, j-1, j, TRUE);
         set_width_chars (GTK_ENTRY (entry), 3);
         GLADE_HOOKUP_OBJECT (father, entry, nome1.str().c_str());
         GObject *adj = adj_new (0, 0, 10000, 1, 10);
         GtkWidget *spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 0);
         gtk_widget_set_name (spin, nome2.str().c_str());
         set_width_chars(GTK_ENTRY(spin), 6);
         gtk_widget_show (spin);
         table_attach (tbl, spin, 1, 2, j-1, j, TRUE);
         GLADE_HOOKUP_OBJECT (father, spin, nome2.str().c_str());
         g_signal_connect ((gpointer) spin, "value_changed",        //new
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
      }
   } 
   label = LABEL_BOLD ("Additional elements in asymmetric unit for every derivative and native protein", MyBLUE, 1.1f);
   gtk_widget_show (label);
   gtk_frame_set_label_widget (GTK_FRAME (IlmContMirFrm), label);
   return IlmContMirFrm;
}

GtkWidget *frameMad(GtkWidget *father, GtkWidget *parentBox)
{
  GtkWidget *IlmContMadFrm = gtk_frame_new (NULL);
  gtk_widget_set_name (IlmContMadFrm, "IlmContMadFrm");
  gtk_widget_show (IlmContMadFrm);
  gtk_box_pack_start (GTK_BOX (parentBox), IlmContMadFrm, FALSE, FALSE, 0);

  GtkWidget *table = table_new (5, 7, FALSE);
  gtk_widget_show (table);
  gtk_container_add (GTK_CONTAINER (IlmContMadFrm), table);
  gtk_container_set_border_width (GTK_CONTAINER (table), 4);
  table_set_row_spacings (table, 2);
  table_set_col_spacings (table, 4);

  GtkWidget *label = LABEL_NEW ("Amount", MyBLUE);
  gtk_widget_show (label);
  table_attach (table, label, 2, 3, 0, 1, TRUE);
  set_alignment(label, 0., 0.5);

  label = LABEL_NEW ("Element", MyBLUE);
  gtk_widget_show (label);
  table_attach (table, label, 1, 2, 0, 1, TRUE);
  set_alignment(label, 0., 0.5);

  for(int i=1; i<=Ilm::MAX_ELEMENTS; i++ ) 
  {
    std::stringstream name;
    name.str("");
    name << "IlmContSymbol" << i << "Entry";
    GtkWidget *Entry = gtk_entry_new ();
    gtk_widget_set_name (Entry, name.str().c_str());
    gtk_widget_show (Entry);
    table_attach (table, Entry, 1, 2, i, i+1, TRUE);
    gtk_entry_set_max_length (GTK_ENTRY (Entry), 3);
    set_width_chars (GTK_ENTRY (Entry), 5);
    GLADE_HOOKUP_OBJECT (father, Entry, name.str().c_str());
    GObject *adj1 = adj_new (0, 0, 1e+06, 1, 10);
    GtkWidget *AmountSpin = spin_button_new (GTK_ADJUSTMENT (adj1), 1, 0);
    name.str("");
    name  << "IlmContAmount" << i << "Spin";
    gtk_widget_set_name (AmountSpin, name.str().c_str());
    set_width_chars(GTK_ENTRY(AmountSpin), 4);
    gtk_widget_show (AmountSpin);
    table_attach (table, AmountSpin, 2, 3, i, i+1, TRUE);
    GLADE_HOOKUP_OBJECT (father, AmountSpin, name.str().c_str());
    GtkWidget *Lbl = LABEL_NEW (g_strdup_printf("Deriv. %d", i), MyBLUE);
    name.str("");
    name  << "IlmContDeriv" << i << "Lbl";
    gtk_widget_set_name (Lbl, name.str().c_str());
    gtk_widget_show (Lbl);
    table_attach (table, Lbl, 0, 1, i, i+1, TRUE);
    set_alignment (Lbl, 0., 0.5);
    GLADE_HOOKUP_OBJECT (father, Lbl, name.str().c_str());


    for(int j=1; j<=Ilm::MAX_DERIVATIVES; j++ )
    {
        GtkWidget *hbox = hbox_new (FALSE, 0);
        gtk_widget_show (hbox);
        table_attach (table, hbox, 2+j, 3+j, i, i+1, TRUE);

        label = LABEL_NEW (g_strdup_printf("Wave %d:  f' and f''", j), MyBLUE);
        gtk_widget_show (label);
        table_attach (table, label, 2+j, 3+j, 0, 1, TRUE);
        set_alignment(label, 0., 0.5);

        for(int k=1; k<=2; k++ )
        {
            std::stringstream name;
            name << "IlmContE" << i << "W" << j << "F" << k << "Spin";
            GObject *adj = adj_new (0, -100, 100, 0.1, 1);
            GtkWidget *Spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 3);
            gtk_widget_set_name (Spin, name.str().c_str());
            set_width_chars(GTK_ENTRY(Spin), 6);
            gtk_widget_show (Spin);
            gtk_box_pack_start (GTK_BOX (hbox), Spin, TRUE, TRUE, 0);
            GLADE_HOOKUP_OBJECT (father, Spin, name.str().c_str());
            g_signal_connect ((gpointer) Spin, "value_changed",         //new
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
         }
    }
  }

  label = gtk_label_new ("");
  gtk_widget_show (label);
  table_attach (table, label, 0, 1, 0, 1, TRUE);
  set_alignment(label, 0., 0.5);

  label = LABEL_BOLD ("Additional elements in asymmetric unit (with anomalous dispersion coeficients if present)", MyBLUE, 1.1f);
  gtk_widget_show (label);
  gtk_frame_set_label_widget (GTK_FRAME (IlmContMadFrm), label);

  return  IlmContMadFrm;
}

GtkWidget *frameMolrep(GtkWidget *father, GtkWidget *parentBox)
{
  GtkWidget *IlmTasksMRnModels;
  GtkWidget *IlmTasksMRPseudoCheck;

  GtkWidget *frameREMO = gtk_frame_new(NULL);
  gtk_frame_set_shadow_type(GTK_FRAME(frameREMO), GTK_SHADOW_NONE);
  gtk_widget_show(frameREMO);
  gtk_container_add (GTK_CONTAINER (parentBox), frameREMO);

  GtkWidget *Vbox1 = vbox_new (FALSE, 8);
  gtk_widget_show (Vbox1);
  gtk_container_add (GTK_CONTAINER (frameREMO), Vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (Vbox1), 4);

  GtkWidget *frame = NEW_FRAME ("Molecular replacement phasing", &FrameStyle1);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (Vbox1), frame, FALSE, FALSE, 0);

  GtkWidget *vbox1 = vbox_new (FALSE, 8);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), vbox1);

  GtkWidget *hbox1 = hbox_new (FALSE, 8);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, FALSE, 0);

  IlmTasksMRnModels = SPIN_WITH_LABEL("Number of models: ", MyBLUE, 1, 20, 1, 1, 0);
  gtk_widget_set_name (get_widget(IlmTasksMRnModels, "spin"), "IlmTasksMRnModels");
  gtk_box_pack_start (GTK_BOX (hbox1), IlmTasksMRnModels, FALSE, FALSE, 0);
  gtk_widget_show_all (IlmTasksMRnModels);
  GLADE_HOOKUP_OBJECT (father, get_widget(IlmTasksMRnModels, "spin"), "IlmTasksMRnModels");

  IlmTasksMRPseudoCheck = CHECK_BUTTON_WITH_LABEL ("Use pseudotranslation information (if present)",  MyBLUE);
  gtk_widget_show (IlmTasksMRPseudoCheck);
  gtk_box_pack_start (GTK_BOX (hbox1), IlmTasksMRPseudoCheck, TRUE, TRUE, 40);
  gtk_widget_set_name (IlmTasksMRPseudoCheck, "IlmTasksMRPseudoCheck");
  GLADE_HOOKUP_OBJECT (father, IlmTasksMRPseudoCheck, "IlmTasksMRPseudoCheck");


  GtkWidget *scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 4);
  gtk_widget_set_size_request(scrolledwindow1, 20, 280);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), 
        GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  GtkWidget *viewport = gtk_viewport_new(NULL, NULL);
  widget_modify_bg(viewport, GTK_STATE_NORMAL, &colorWhite);
  gtk_widget_show (viewport);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrolledwindow1), GTK_SHADOW_ETCHED_IN);

  GtkWidget *Vbox2 = vbox_new (FALSE, 8);
  gtk_widget_show (Vbox2);
  gtk_container_add (GTK_CONTAINER (viewport), Vbox2);

  for(int i=0; i<MAX_MODELS; i++)
  {
      MRmodel *model = model_info(father, i);
      gtk_box_pack_start (GTK_BOX (Vbox2), model->frame, FALSE, FALSE, 0);
  }

  create_task_info(father, vbox1);
  g_signal_connect ((gpointer) get_widget(IlmTasksMRnModels, "spin"), "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);

  return frameREMO;
}

GtkWidget *frameAbi(GtkWidget *father, GtkWidget *parentBox)
{
  GtkWidget *framesir;
  GtkWidget *framerec;
  GtkWidget *IlmTasksABIRadio1;
  GtkWidget *IlmTasksABIRadio2;
  GtkWidget *IlmTasksABIPattersonCheck;
  GtkWidget *IlmTasksABIDMCheck;
  GObject *IlmTasksABIBlocks_adj;
  GtkWidget *IlmTasksABIBlocks;
  GtkWidget *IlmTasksABIDefaultsCheck;
  GtkWidget *IlmTaskABblocklabel[10];
  GObject *IlmTaskABItG_adj[10];
  GtkWidget *IlmTaskABItG[10];
  GObject *IlmTaskABItS_adj[10];
  GtkWidget *IlmTaskABItS[10];
  GtkWidget *IlmTasksABIImproveFrame;
  GtkWidget *IlmTasksABIExtraCheck;
  GtkWidget *IlmTasksABISolveRadio;
  GtkWidget *IlmTasksABIFLRadio;
  GtkWidget *IlmTasksABILabel;
  GSList *IlmTasksABIExtra_group = NULL;
  GSList *IlmTasksABISolve_group = NULL;
  GSList *IlmTasksABI_group = NULL;
  static const char *titles1[] = {"Trial", "FOM", "Related MTZ labels"};
  int sizes1[] = {70, 130, 250};
  char nome[40];

//  GtkWidget *frameABI = gtk_frame_new(NULL);
//  gtk_frame_set_shadow_type(GTK_FRAME(frameABI), GTK_SHADOW_NONE);
//  gtk_widget_show(frameABI);
//  gtk_box_pack_start (GTK_BOX (parentBox), frameABI, TRUE, TRUE, 0);

  GtkWidget *frameABI = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (frameABI);
  gtk_container_add (GTK_CONTAINER (parentBox), frameABI);
  gtk_container_set_border_width (GTK_CONTAINER (frameABI), 4);
  gtk_widget_set_size_request(frameABI, 20, 280);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (frameABI),
        GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  GtkWidget *viewport = gtk_viewport_new(NULL, NULL);
  widget_modify_bg(viewport, GTK_STATE_NORMAL, &colorWhite);
  gtk_widget_show (viewport);
  gtk_container_add (GTK_CONTAINER (frameABI), viewport);


  GtkWidget *vbox1 = vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (viewport), vbox1);
//  gtk_container_add (GTK_CONTAINER (frameABI), vbox1);

  GtkWidget  *frame = gtk_frame_new(NULL);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 10);

  framesir = gtk_frame_new(NULL);
  gtk_frame_set_shadow_type(GTK_FRAME(framesir), GTK_SHADOW_NONE);
  gtk_widget_show (framesir);
  gtk_container_add (GTK_CONTAINER (frame), framesir);
  GLADE_HOOKUP_OBJECT (father, framesir, "framesir");

  IlmTasksABIRadio1 = RADIO_BUTTON_BOLD ("Solving strategy", MyBLUE, 1.1f);
  gtk_widget_set_name (IlmTasksABIRadio1, "IlmTasksABIRadio1");
  gtk_widget_show (IlmTasksABIRadio1);
  gtk_frame_set_label_widget(GTK_FRAME(frame), IlmTasksABIRadio1);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmTasksABIRadio1), IlmTasksABI_group);
  IlmTasksABI_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON(IlmTasksABIRadio1));

  frame = gtk_frame_new(NULL);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, TRUE, TRUE, 10);
  gtk_widget_set_name (frame, "framerec");
  GLADE_HOOKUP_OBJECT_NO_REF (father, frame, "framerec");

  framerec = gtk_frame_new(NULL);
  gtk_frame_set_shadow_type(GTK_FRAME(framerec), GTK_SHADOW_NONE);
  gtk_widget_show (framerec);
  gtk_container_add (GTK_CONTAINER (frame), framerec);
  gtk_widget_set_sensitive (framerec, FALSE);

  IlmTasksABIRadio2 = RADIO_BUTTON_BOLD ("Recover previous trial", MyBLUE, 1.1f);
  gtk_widget_set_name (IlmTasksABIRadio2, "IlmTasksABIRadio2");
  gtk_widget_show (IlmTasksABIRadio2);
  gtk_frame_set_label_widget(GTK_FRAME(frame), IlmTasksABIRadio2);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmTasksABIRadio2), IlmTasksABI_group);
  IlmTasksABI_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON(IlmTasksABIRadio2));

  vbox1 = vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (framesir), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (framesir), 4);
  gtk_container_set_border_width (GTK_CONTAINER (framerec), 4);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 4);

  GtkWidget *hbox1 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);
  frame = FRAME_BOLD("Use", MyBLUE, 1.2f);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox1), frame, TRUE, TRUE, 2);
  GtkWidget *vbox2 = vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (frame), vbox2);
  IlmTasksABIPattersonCheck = RADIO_BUTTON_WITH_LABEL (NULL, "Patterson", MyBLUE);
  gtk_widget_set_name (IlmTasksABIPattersonCheck, "IlmTasksABIPattersonCheck");
  gtk_widget_show (IlmTasksABIPattersonCheck);
  gtk_box_pack_start (GTK_BOX (vbox2), IlmTasksABIPattersonCheck, FALSE, TRUE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmTasksABIPattersonCheck), IlmTasksABISolve_group);
  IlmTasksABISolve_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON(IlmTasksABIPattersonCheck));
  IlmTasksABIDMCheck = RADIO_BUTTON_WITH_LABEL (NULL, "Direct Methods", MyBLUE);
  gtk_widget_set_name (IlmTasksABIDMCheck, "IlmTasksABIDMCheck");
  gtk_widget_show (IlmTasksABIDMCheck);
  gtk_box_pack_start (GTK_BOX (vbox2), IlmTasksABIDMCheck, FALSE, TRUE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmTasksABIDMCheck), IlmTasksABISolve_group);
  IlmTasksABISolve_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON(IlmTasksABIDMCheck));

  frame = gtk_frame_new (NULL);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox1), frame, TRUE, TRUE, 2);

  GtkWidget *table = table_new (11, 5, FALSE);
  gtk_widget_show (table);
  gtk_container_add (GTK_CONTAINER (frame), table);
  table_set_col_spacings (table, 10);
  gtk_container_set_border_width (GTK_CONTAINER (table), 4);

  GtkWidget *label = LABEL_NEW ("Nr. of Blocks", MyBLUE);
  gtk_widget_show (label);
  table_attach_all (table, label, 0, 1, 0, 1);
  set_alignment(label, 0., 0.5);

  IlmTasksABIBlocks_adj = adj_new (1, 1, 10, 1, 10);
  IlmTasksABIBlocks = spin_button_new (GTK_ADJUSTMENT (IlmTasksABIBlocks_adj), 1, 0);
  set_width_chars (GTK_ENTRY (IlmTasksABIBlocks), 4);
  gtk_widget_set_name (IlmTasksABIBlocks, "IlmTasksABIBlocks");
  gtk_widget_show (IlmTasksABIBlocks);
  table_attach (table, IlmTasksABIBlocks, 0, 1, 1, 2);

  label = LABEL_NEW ("Block #", MyBLUE);
  gtk_widget_show (label);
  table_attach_all (table, label, 1, 2, 0, 1);
  set_alignment(label, 0., 0.5);

  IlmTasksABIDefaultsCheck = CHECK_BUTTON_WITH_LABEL ("Use default values", MyBLUE);
  gtk_widget_set_name (IlmTasksABIDefaultsCheck, "IlmTasksABIDefaultsCheck");
  gtk_widget_show (IlmTasksABIDefaultsCheck);
  table_attach (table, IlmTasksABIDefaultsCheck, 4, 5, 1, 2);

  for(int i=1; i<=10; i++)
  {
     IlmTaskABblocklabel[i-1] = LABEL_NEW (g_strdup_printf("%d", i), NULL);
     ScriviStringa(nome, sizeof(nome), "IlmTaskABblock%dlabel", i);
     gtk_widget_set_name (IlmTaskABblocklabel[i-1], nome);
//   gtk_widget_show (IlmTaskABblocklabel[i-1]);
     table_attach (table, IlmTaskABblocklabel[i-1], 1, 2, i, i+1);
     set_alignment (IlmTaskABblocklabel[i-1], 0.5, 0.5);

     IlmTaskABItG_adj[i-1] = adj_new (30, 1, 10000, 1, 10);
     IlmTaskABItG[i-1] = spin_button_new (GTK_ADJUSTMENT (IlmTaskABItG_adj[i-1]), 1, 0);
     set_width_chars (GTK_ENTRY (IlmTaskABItG[i-1]), 5);
     ScriviStringa(nome, sizeof(nome), "IlmTaskABItG%d", i);
     gtk_widget_set_name (IlmTaskABItG[i-1], nome);
//   gtk_widget_show (IlmTaskABItG[i-1]);
     table_attach (table, IlmTaskABItG[i-1], 2, 3, i, i+1);

     IlmTaskABItS_adj[i-1] = adj_new (30, 1, 300, 1, 10);
     IlmTaskABItS[i-1] = spin_button_new (GTK_ADJUSTMENT (IlmTaskABItS_adj[i-1]), 1, 0);
     set_width_chars (GTK_ENTRY (IlmTaskABItS[i-1]), 5);
     ScriviStringa(nome, sizeof(nome), "IlmTaskABItS%d", i);
     gtk_widget_set_name (IlmTaskABItS[i-1], nome);
//   gtk_widget_show (IlmTaskABItS[i-1]);
     table_attach (table, IlmTaskABItS[i-1], 3, 4, i, i+1);
  }

  label = LABEL_NEW ("Trials to generate", MyBLUE);
  gtk_widget_show (label);
  table_attach_all (table, label, 2, 3, 0, 1);
  set_alignment(label, 0., 0.5);

  label = LABEL_NEW ("Trials to store", MyBLUE);
  gtk_widget_show (label);
  table_attach_all (table, label, 3, 4, 0, 1);
  set_alignment(label, 0., 0.5);

  label = LABEL_BOLD ("Blocks/Trials", MyBLUE, 1.1f);
  gtk_widget_show (label);
  gtk_frame_set_label_widget (GTK_FRAME (frame), label);
  gtk_label_set_use_markup (GTK_LABEL (label), TRUE);

  GtkWidget *edm_frame = frameEDM(father);
//  gtk_box_pack_start (GTK_BOX (vbox1), edm_frame, TRUE, TRUE, 0);
#ifdef IN_GTK3
  GtkWidget *align = new_alignment(GTK_ALIGN_START,GTK_ALIGN_START,1,0);
#else
  GtkWidget *align = gtk_alignment_new(0,0,1,0);
#endif

  gtk_widget_show (align);
  gtk_box_pack_start (GTK_BOX (vbox1), align, TRUE, TRUE, 0);
  gtk_container_add (GTK_CONTAINER (align), edm_frame);

  IlmTasksABIExtraCheck = gtk_check_button_new_with_label ("Use extrapolated reflections");
//  IlmTasksABIExtraCheck = CHECK_BUTTON_BOLD ("Use extrapolated reflections", MyBLUE, 1.1f);
  gtk_widget_set_name (IlmTasksABIExtraCheck, "IlmTasksABIExtraCheck");
  gtk_widget_show (IlmTasksABIExtraCheck);

  IlmTasksABIImproveFrame = gtk_frame_new (NULL);
  gtk_widget_set_name (IlmTasksABIImproveFrame, "IlmTasksABIImproveFrame");
  gtk_widget_show (IlmTasksABIImproveFrame);
  gtk_box_pack_start (GTK_BOX (vbox1), IlmTasksABIImproveFrame, FALSE, FALSE, 2);
  gtk_frame_set_label_widget(GTK_FRAME(IlmTasksABIImproveFrame), IlmTasksABIExtraCheck);
  gtk_widget_set_sensitive (IlmTasksABIImproveFrame, FALSE);

  GtkWidget *vbox_extra = vbox_new (FALSE, 4);
  gtk_widget_show (vbox_extra);
  gtk_container_add (GTK_CONTAINER (IlmTasksABIImproveFrame), vbox_extra);
  gtk_container_set_border_width (GTK_CONTAINER (vbox_extra), 4);
  gtk_widget_set_sensitive (vbox_extra, FALSE);

  IlmTasksABILabel = gtk_label_new(" ");
  gtk_widget_set_name (IlmTasksABILabel, "IlmTasksABILabel");
  gtk_widget_show(IlmTasksABILabel);
  gtk_box_pack_start (GTK_BOX (vbox_extra), IlmTasksABILabel, FALSE, FALSE, 10);
  set_alignment (IlmTasksABILabel, 0., 0.5);

  GtkWidget *hbox_extra = hbox_new (FALSE, 4);
  gtk_widget_show (hbox_extra);
  gtk_box_pack_start (GTK_BOX (vbox_extra), hbox_extra, FALSE, FALSE, 10);
//  gtk_container_set_border_width (GTK_CONTAINER (hbox_extra), 8);

  IlmTasksABISolveRadio = RADIO_BUTTON_WITH_LABEL (NULL, "to solve structure and to improve the final map", MyBLUE);
  gtk_widget_set_name (IlmTasksABISolveRadio, "IlmTasksABISolveRadio");
  gtk_widget_show (IlmTasksABISolveRadio);
  gtk_box_pack_start (GTK_BOX (hbox_extra),IlmTasksABISolveRadio, FALSE, TRUE, 2);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmTasksABISolveRadio), IlmTasksABIExtra_group);
  IlmTasksABIExtra_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON(IlmTasksABISolveRadio));

  IlmTasksABIFLRadio =  RADIO_BUTTON_WITH_LABEL (NULL, "to improve the final map only", MyBLUE);
  gtk_widget_set_name (IlmTasksABIFLRadio, "IlmTasksABIFLRadio");
  gtk_widget_show (IlmTasksABIFLRadio);
  gtk_box_pack_start (GTK_BOX (hbox_extra),IlmTasksABIFLRadio, FALSE, TRUE, 2);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmTasksABIFLRadio), IlmTasksABIExtra_group);
  IlmTasksABIExtra_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON(IlmTasksABIFLRadio));

  vbox1 = vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (framerec), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 4);

  GtkWidget *hbox = hbox_new(FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox, FALSE, FALSE, 8);

  label = LABEL_NEW ("MTZ file name:   ", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
  set_alignment(label, 0., 0);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);

  GtkWidget *IlmTasksABIMtzFileLab = gtk_label_new("");
  gtk_widget_set_name (IlmTasksABIMtzFileLab, "IlmTasksABIMtzFileLab");
  gtk_widget_show (IlmTasksABIMtzFileLab);
  gtk_box_pack_start (GTK_BOX (hbox), IlmTasksABIMtzFileLab, FALSE, FALSE, 10);
  set_alignment (IlmTasksABIMtzFileLab, 0., 0.);
  gtk_label_set_justify (GTK_LABEL (IlmTasksABIMtzFileLab), GTK_JUSTIFY_LEFT);
  GLADE_HOOKUP_OBJECT (father, IlmTasksABIMtzFileLab, "IlmTasksABIMtzFileLab");

  hbox = hbox_new(FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox, FALSE, FALSE, 8);

  label = LABEL_NEW ("MTZ file content: ", MyBLUE);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
  set_alignment(label, 0., 0);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);

  GtkWidget *IlmTasksABIMtzInfoLab = gtk_label_new("");
  gtk_widget_set_name (IlmTasksABIMtzInfoLab, "IlmTasksABIMtzInfoLab");
  gtk_widget_show (IlmTasksABIMtzInfoLab);
  gtk_box_pack_start (GTK_BOX (hbox), IlmTasksABIMtzInfoLab, FALSE, FALSE, 10);
  set_alignment (IlmTasksABIMtzInfoLab, 0., 0.);
  gtk_label_set_justify (GTK_LABEL (IlmTasksABIMtzInfoLab), GTK_JUSTIFY_LEFT);
  GLADE_HOOKUP_OBJECT (father, IlmTasksABIMtzInfoLab, "IlmTasksABIMtzInfoLab");


  label = FRAME_NEW ("Available trials: ", MyBLUE);
  gtk_widget_show (label);
  gtk_frame_set_shadow_type(GTK_FRAME(label), GTK_SHADOW_NONE);
  gtk_box_pack_start (GTK_BOX (vbox1), label, TRUE, TRUE, 8);

  GtkWidget *IlmTasksABItrialsel = new_selection(father, label, "IlmTasksABItrialsel",
                               3, titles1, sizes1);
  gtk_widget_set_name (IlmTasksABItrialsel, "IlmTasksABItrialsel");
  gtk_container_set_border_width (GTK_CONTAINER (get_widget(IlmTasksABItrialsel, "frame")), 0);
  gtk_widget_show (IlmTasksABItrialsel);

  GLADE_HOOKUP_OBJECT (father, IlmTasksABIPattersonCheck, "IlmTasksABIPattersonCheck");
  GLADE_HOOKUP_OBJECT (father, IlmTasksABIDMCheck, "IlmTasksABIDMCheck");
  GLADE_HOOKUP_OBJECT (father, IlmTasksABIBlocks, "IlmTasksABIBlocks");
  GLADE_HOOKUP_OBJECT (father, IlmTasksABIDefaultsCheck, "IlmTasksABIDefaultsCheck");
  for(int i=1; i<=10; i++)
  {
     ScriviStringa(nome, sizeof(nome), "IlmTaskABblock%dlabel", i);
     GLADE_HOOKUP_OBJECT (father, IlmTaskABblocklabel[i-1], nome);
     ScriviStringa(nome, sizeof(nome), "IlmTaskABItG%d", i);
     GLADE_HOOKUP_OBJECT (father, IlmTaskABItG[i-1], nome);
     ScriviStringa(nome, sizeof(nome), "IlmTaskABItS%d", i);
     GLADE_HOOKUP_OBJECT (father, IlmTaskABItS[i-1], nome);
  }
  GLADE_HOOKUP_OBJECT (father, IlmTasksABIImproveFrame, "IlmTasksABIImproveFrame");
  GLADE_HOOKUP_OBJECT (father, IlmTasksABIExtraCheck, "IlmTasksABIExtraCheck");
  GLADE_HOOKUP_OBJECT (father, IlmTasksABISolveRadio, "IlmTasksABISolveRadio");
  GLADE_HOOKUP_OBJECT (father, IlmTasksABIFLRadio, "IlmTasksABIFLRadio");
  GLADE_HOOKUP_OBJECT (father, IlmTasksABILabel, "IlmTasksABILabel");
  GLADE_HOOKUP_OBJECT (father, IlmTasksABIRadio1, "IlmTasksABIRadio1");
  GLADE_HOOKUP_OBJECT (father, IlmTasksABIRadio2, "IlmTasksABIRadio2");

  g_signal_connect ((gpointer) IlmTasksABIPattersonCheck, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksABIBlocks, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksABIDefaultsCheck, "toggled",
                    G_CALLBACK (on_Check_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmTasksABIExtraCheck, "toggled",
                    G_CALLBACK (on_cb_attiva),
                    (gpointer) vbox_extra);

  g_signal_connect ((gpointer) IlmTasksABIRadio1, "toggled",
                    G_CALLBACK (on_cb_attiva),
                    (gpointer) framesir);
  g_signal_connect ((gpointer) IlmTasksABIRadio2, "toggled",
                    G_CALLBACK (on_cb_attiva),
                    (gpointer) framerec);

  for(int i=0; i<10; i++)
  {
      g_signal_connect ((gpointer) IlmTaskABItG[i], "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
      g_signal_connect ((gpointer) IlmTaskABItS[i], "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
 }
  return frameABI;
}

static void fill_combo_amb(GtkCellLayout *w,
                      GtkCellRenderer   *renderer,
                      GtkTreeModel      *model,
                      GtkTreeIter       *iter,
                      gpointer           data)
{
    char *line;
    gtk_tree_model_get (GTK_TREE_MODEL(data), iter, 1, &line, -1);
    if(line != NULL)
    {
       if(find_program_in_path(line))
          g_object_set(G_OBJECT(renderer), "sensitive", TRUE, NULL);
       else
          g_object_set(G_OBJECT(renderer), "sensitive", FALSE, NULL);
    }
}

GtkWidget *frameDea(GtkWidget *father, GtkWidget *parentBox)
{
  GtkWidget *IlmDeaMtzFileEntry;
  GtkWidget *IlmDeaMtzBrowseBtn;
  GtkWidget *IlmDeaMtzViewBtn;
  GtkWidget *IlmDeaMtzTitleEntry;
  GtkWidget *IlmDeaMtzSpgWidget;
  GtkWidget *IlmDeaMtzSpgEntry;
  GtkWidget *IlmDeaMtzSpgFind;
  GtkWidget *IlmDeaMtzCellEntry;
  GtkWidget *IlmDeaMtzValueCombo;
  GtkWidget *IlmDeaMtzValueEntry;
  GtkWidget *IlmDeaMtzEsdCombo;
  GtkWidget *IlmDeaMtzEsdEntry;
  GtkWidget *IlmDeaMtzColumnsEntry;
  GtkWidget *IlmDeaMtzAddBtn;
  GtkWidget *IlmDeaMtzDeleteBtn;
  GtkWidget *IlmDeaMtzAllCols;
  GtkWidget *IlmDeaMtzAddColBtn;
  GtkWidget *label_hint1;

//  GtkWidget *frameDEA = gtk_frame_new(NULL);
//  gtk_frame_set_shadow_type(GTK_FRAME(frameDEA), GTK_SHADOW_NONE);
//  gtk_widget_show(frameDEA);
//  gtk_box_pack_start (GTK_BOX (parentBox), frameDEA, TRUE, TRUE, 0);
  GtkWidget *frameDEA = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (frameDEA);
  gtk_container_add (GTK_CONTAINER (parentBox), frameDEA);
  gtk_container_set_border_width (GTK_CONTAINER (frameDEA), 4);
  gtk_widget_set_size_request(frameDEA, 20, 280);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (frameDEA),
        GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  GtkWidget *viewport = gtk_viewport_new(NULL, NULL);
  widget_modify_bg(viewport, GTK_STATE_NORMAL, &colorWhite);
  gtk_widget_show (viewport);
  gtk_container_add (GTK_CONTAINER (frameDEA), viewport);

  GtkWidget *IlmDeaBox = vbox_new (FALSE, 2);
  gtk_widget_set_name (IlmDeaBox, "IlmDeaBox");
  gtk_widget_show (IlmDeaBox);
  gtk_container_set_border_width (GTK_CONTAINER (IlmDeaBox), 4);
  gtk_container_add (GTK_CONTAINER (viewport), IlmDeaBox);
//  gtk_container_add (GTK_CONTAINER (frameDEA), IlmDeaBox);

  GtkWidget *hbox = hbox_new(FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start(GTK_BOX(IlmDeaBox), hbox, FALSE, FALSE, 4);

  GtkWidget *label = LABEL_NEW ("Select Automatic Model Building Program", MyBLUE);
  gtk_widget_show (label);
  set_alignment(label, 0., 0.5);
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 4);

#if 0
  GtkWidget *IlmTasksDeaCombo = create_combo_str ();
  gtk_widget_set_name (IlmTasksDeaCombo, "IlmTasksDeaCombo");
  gtk_widget_show (IlmTasksDeaCombo);
  gtk_box_pack_start(GTK_BOX(hbox), IlmTasksDeaCombo, FALSE, FALSE, 4);
  fill_combo(IlmTasksDeaCombo, (const char **) Ilm::ambp, sizeof(Ilm::ambp)/sizeof(Ilm::ambp[0]), 1);
  GLADE_HOOKUP_OBJECT (father, IlmTasksDeaCombo, "IlmTasksDeaCombo");
#endif

  GtkTreeStore *store = gtk_tree_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
  GtkWidget *IlmTasksDeaCombo = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
  GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
  gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(IlmTasksDeaCombo), renderer, TRUE);
  gtk_cell_layout_add_attribute(GTK_CELL_LAYOUT(IlmTasksDeaCombo), renderer, "text", 0);
  gtk_cell_layout_set_cell_data_func (GTK_CELL_LAYOUT(IlmTasksDeaCombo),
      renderer, fill_combo_amb, (gpointer)store, NULL);
  GtkTreeIter iter;
  for(int k=0; k<(int) G_N_ELEMENTS(Ilm::ambp); k++)
  {
       gtk_tree_store_append(store, &iter, NULL);
       gtk_tree_store_set(store, &iter, 0, Ilm::ambp[k],
                                        1, Ilm::amb_prg[k], -1);
  }
  gtk_widget_set_name (IlmTasksDeaCombo, "IlmTasksDeaCombo");
  gtk_widget_show (IlmTasksDeaCombo);
  gtk_box_pack_start(GTK_BOX(hbox), IlmTasksDeaCombo, FALSE, FALSE, 4);
  GLADE_HOOKUP_OBJECT (father, IlmTasksDeaCombo, "IlmTasksDeaCombo");


  GtkWidget *spin = SPIN_WITH_LABEL("Number of cycles ", MyBLUE, 1, 100, 10, 1, 0);
  gtk_widget_show_all (spin);
  gtk_box_pack_start (GTK_BOX (hbox), spin, FALSE, TRUE, 20);
  g_signal_connect ((gpointer) get_widget(spin, "spin"), "value_changed",
                    G_CALLBACK (on_Spin_value_changed), NULL);
  gtk_widget_set_name (get_widget(spin, "spin"), "IlmTasksDeaCycles");
  GLADE_HOOKUP_OBJECT (father, get_widget(spin, "spin"), "IlmTasksDeaCycles");

  GtkWidget *frame = gtk_frame_new(NULL);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (IlmDeaBox), frame, FALSE, FALSE, 0);

  GtkWidget *hbox2 = hbox_new(FALSE, 6);
  gtk_widget_show(hbox2);
  gtk_container_add (GTK_CONTAINER(frame), hbox2);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 4);

  GtkWidget *entry = entry_for_filesel(hbox2, "Model file (PDB): ",
                                 "PDBfilename", 1, 1);
  gtk_widget_set_name (entry, "IlmTasksDeaPDBModel");
  set_width_chars (GTK_ENTRY (entry), 60);
  GLADE_HOOKUP_OBJECT (father, entry, "IlmTasksDeaPDBModel");
  g_signal_connect ((gpointer)  get_widget(entry, "browse"), "clicked",
                    G_CALLBACK (on_IlmTasksDeaPDB), GINT_TO_POINTER(0));
  g_signal_connect ((gpointer) get_widget(entry, "preview"), "clicked",
                    G_CALLBACK (on_Ilm_text_view_clicked), entry);

  GSList *IlmTasksDea_group = NULL;
  GtkWidget *IlmTasksDeaModelRadio = RADIO_BUTTON_BOLD ("Model", MyBLUE, 1.1f);
  gtk_widget_set_name (IlmTasksDeaModelRadio, "IlmTasksDeaModelRadio");
  gtk_widget_show (IlmTasksDeaModelRadio);
  set_tip (IlmTasksDeaModelRadio, "Check this if you want to start from model");
  gtk_frame_set_label_widget(GTK_FRAME(frame), IlmTasksDeaModelRadio);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmTasksDeaModelRadio), IlmTasksDea_group);
  IlmTasksDea_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON(IlmTasksDeaModelRadio));
  g_signal_connect(G_OBJECT(IlmTasksDeaModelRadio), "toggled", G_CALLBACK(on_cb_attiva), hbox2);
  g_signal_connect(G_OBJECT(IlmTasksDeaModelRadio), "toggled", G_CALLBACK(on_Check_toggled), NULL);
  GLADE_HOOKUP_OBJECT (father, IlmTasksDeaModelRadio, "IlmTasksDeaModelRadio");

  frame = gtk_frame_new(NULL);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (IlmDeaBox), frame, TRUE, TRUE, 0);

  GtkWidget *hbox1 = vbox_new(FALSE, 6);
  gtk_widget_show(hbox1);
  gtk_container_add (GTK_CONTAINER(frame), hbox1);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 4);
  gtk_widget_set_sensitive(hbox1, 0);

  GtkWidget *IlmTasksDeaPhasesRadio = RADIO_BUTTON_BOLD ("Phases", MyBLUE, 1.1f);
  gtk_widget_set_name (IlmTasksDeaPhasesRadio, "IlmTasksDeaPhasesRadio");
  gtk_widget_show (IlmTasksDeaPhasesRadio);
  set_tip (IlmTasksDeaPhasesRadio, "Check this if you want to start from phases");
  gtk_frame_set_label_widget(GTK_FRAME(frame), IlmTasksDeaPhasesRadio);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmTasksDeaPhasesRadio), IlmTasksDea_group);
  IlmTasksDea_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON(IlmTasksDeaPhasesRadio));
  g_signal_connect(G_OBJECT(IlmTasksDeaPhasesRadio), "toggled", G_CALLBACK(on_cb_attiva), hbox1);
  g_signal_connect(G_OBJECT(IlmTasksDeaPhasesRadio), "toggled", G_CALLBACK(on_Check_toggled), NULL);
  GLADE_HOOKUP_OBJECT (father, IlmTasksDeaPhasesRadio, "IlmTasksDeaPhasesRadio");

  hbox = vbox_new(FALSE, 6);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(hbox1), hbox, FALSE, FALSE, 0);

  entry = entry_for_filesel(hbox, "Heavy atoms for\ndensity truncation(PDB): ",
                                 "PDBfilename", 1, 1);
  set_tip (entry, "Heavy atoms for density truncation near heavy atoms sites");
  set_width_chars (GTK_ENTRY (entry), 60);
  gtk_widget_set_name (entry, "IlmTasksDeaPDBPhases");
  GLADE_HOOKUP_OBJECT (father, entry, "IlmTasksDeaPDBPhases");
  g_signal_connect ((gpointer)  get_widget(entry, "browse"), "clicked",
                    G_CALLBACK (on_IlmTasksDeaPDB), GINT_TO_POINTER(1));
  g_signal_connect ((gpointer) get_widget(entry, "preview"), "clicked",
                    G_CALLBACK (on_Ilm_text_view_clicked), entry);

  _MyMTZ *mymtz1 = page_mtz(hbox, 1, Ilm::PTheProject->szMtzFilePh);
  mymtz1->quale = 1;

  IlmDeaMtzFileEntry = mymtz1->entry;
  IlmDeaMtzBrowseBtn = mymtz1->browse;
  IlmDeaMtzViewBtn   = mymtz1->view;
  gtk_widget_set_name (IlmDeaMtzBrowseBtn, "IlmDeaMtzBrowseBtn");
  gtk_widget_set_name (IlmDeaMtzViewBtn, "IlmDeaMtzViewBtn");
  IlmDeaMtzTitleEntry = mymtz1->title;
  gtk_widget_set_name (IlmDeaMtzTitleEntry, "IlmDeaMtzTitleEntry");
  IlmDeaMtzSpgWidget = mymtz1->spg;
  IlmDeaMtzSpgEntry = get_widget(IlmDeaMtzSpgWidget, "entry");
  gtk_widget_set_name (IlmDeaMtzSpgEntry, "IlmDeaMtzSpgEntry");
  IlmDeaMtzSpgFind = mymtz1->find;
  gtk_widget_set_name (IlmDeaMtzSpgFind, "IlmDeaMtzSpgFind");
  gtk_widget_hide (IlmDeaMtzSpgFind);
  label_hint1 = mymtz1->hint;
  gtk_widget_set_name (label_hint1, "IlmDeaMtzHint");
  IlmDeaMtzCellEntry = mymtz1->cell;
  gtk_widget_set_name (IlmDeaMtzCellEntry, "IlmDeaMtzCellEntry");
  IlmDeaMtzColumnsEntry = mymtz1->columns;
  gtk_widget_set_name (IlmDeaMtzColumnsEntry, "IlmDeaMtzColumnsEntry");
  IlmDeaMtzDeleteBtn = mymtz1->del;
  gtk_widget_set_name (IlmDeaMtzDeleteBtn, "IlmDeaMtzDeleteBtn");
  IlmDeaMtzValueCombo = mymtz1->vcombo;
  gtk_widget_set_name (IlmDeaMtzValueCombo, "IlmDeaMtzValueCombo");
  IlmDeaMtzValueEntry = get_widget (IlmDeaMtzValueCombo,"entry");
  gtk_widget_set_name (IlmDeaMtzValueEntry, "IlmDeaMtzValueEntry");
  IlmDeaMtzEsdCombo = mymtz1->esdcombo;
  gtk_widget_set_name (IlmDeaMtzEsdCombo, "IlmDeaMtzEsdCombo");
  IlmDeaMtzEsdEntry = get_widget (IlmDeaMtzEsdCombo,"entry");
  gtk_widget_set_name (IlmDeaMtzEsdEntry, "IlmDeaMtzEsdEntry");
  IlmDeaMtzAddBtn = mymtz1->add;
  gtk_widget_set_name (IlmDeaMtzAddBtn, "IlmDeaMtzAddBtn");
  IlmDeaMtzAllCols = mymtz1->allcols;
  gtk_widget_set_name (IlmDeaMtzAllCols, "IlmDeaMtzAllCols");
  IlmDeaMtzAddColBtn = mymtz1->addcol;
  gtk_widget_set_name (IlmDeaMtzAddColBtn, "IlmDeaMtzAddColBtn");


  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzFileEntry, "IlmDeaMtzFileEntry");
  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzTitleEntry, "IlmDeaMtzTitleEntry");
  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzBrowseBtn, "IlmDeaMtzBrowseBtn");
  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzSpgEntry, "IlmDeaMtzSpgEntry");
  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzSpgFind, "IlmDeaMtzSpgFind");
  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzCellEntry, "IlmDeaMtzCellEntry");
  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzValueCombo, "IlmDeaMtzValueCombo");
  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzValueEntry, "IlmDeaMtzValueEntry");
  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzEsdCombo, "IlmDeaMtzEsdCombo");
  GLADE_HOOKUP_OBJECT (father, label_hint1, "IlmDeaMtzHint");
  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzEsdEntry, "IlmDeaMtzEsdEntry");
  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzColumnsEntry, "IlmDeaMtzColumnsEntry");
  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzAddBtn, "IlmDeaMtzAddBtn");
  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzDeleteBtn, "IlmDeaMtzDeleteBtn");
  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzAllCols, "IlmDeaMtzAllCols");
  GLADE_HOOKUP_OBJECT (father, IlmDeaMtzAddColBtn, "IlmDeaMtzAddColBtn");

  return frameDEA;
}

GtkWidget*
create_IlmProjectWnd ()
{
using namespace Ilm;
  GtkWidget *IlmProjectWnd;
  GdkPixbuf *IlmProjectWnd_icon_pixbuf;
  GtkWidget *viewport;
  GtkWidget *vbox1;
  GtkWidget *IlmNotebook;
  GtkWidget *vbox2;
  GtkWidget *IlmJobEntry;
  GtkWidget *vbox3;
  GtkWidget *align;
  GtkWidget *IlmMtzFileEntry;
  GtkWidget *IlmMtzBrowseBtn;
  GtkWidget *IlmMtzViewBtn;
  GtkWidget *IlmMtzTitleEntry;
  GtkWidget *IlmMtzSpgWidget;
  GtkWidget *IlmMtzSpgEntry;
  GtkWidget *IlmMtzSpgFind;
  GtkWidget *IlmMtzCellEntry;
  GtkWidget *label_hint;
  GtkWidget *IlmMtzValueCombo;
  GtkWidget *IlmMtzValueEntry;
  GtkWidget *IlmMtzEsdCombo;
  GtkWidget *IlmMtzEsdEntry;
  GtkWidget *IlmMtzColumnsEntry;
  GtkWidget *IlmMtzAddBtn;
  GtkWidget *IlmMtzDeleteBtn;
  GtkWidget *IlmMtzAllCols;
  GtkWidget *IlmMtzAddColBtn;

  GtkWidget *vboxCont;
  GtkWidget *hboxCont;
  GtkWidget *hboxNative;
  GtkWidget *IlmContNativeCheck;
  GtkWidget *hbox28;
  GtkWidget *hbox28bis;
  GtkWidget *IlmContWavesLbl;
  GObject *IlmContWavesSpin_adj;
  GtkWidget *IlmContWavesSpin;
  GtkWidget *IlmContDerivLbl;
  GObject *IlmContDerivSpin_adj;
  GtkWidget *IlmContDerivSpin;
  GtkWidget *IlmContDerivsTbl;
  GtkWidget *label157;

  GtkWidget *hboxmu;
  GtkWidget *hboxmus;
  GtkWidget *label117;
  GtkWidget *vlabel117;
  GtkWidget *IlmContMolRadio;
  GSList *IlmContMolRadio_group = NULL;
  GSList *IlmContSource_group = NULL;
  GSList *IlmContWaveL_group = NULL;
  GObject *IlmContMolSpin_adj;
  GtkWidget *IlmContMolSpin;
  GtkWidget *IlmContResiduesRadio;
  GObject *IlmContResiduesSpin_adj;
  GtkWidget *IlmContResiduesSpin;
  GtkWidget *IlmContSeqRadio;
  GtkWidget *IlmContSeqBrowse;
  GtkWidget *frameseq;
  GtkWidget *labelseq;
  GtkWidget *IlmContSeq;
  GtkWidget *IlmContSeqFile;
  GtkWidget *IlmContNmolsSpin;
  GtkWidget *IlmContMadFrm;
  GtkWidget *IlmContMirFrm;
  GtkWidget *IlmContSourceFrm;
  GtkWidget *IlmContWaveLFrm;
  GtkWidget *IlmContWaveLEntry;
  GtkWidget *IlmContLigFrm;
  GtkWidget *label177;
  GtkWidget *scrolledwindow1;
  GtkWidget *vbox24;
  GtkWidget *radiobutton;
  int i;
  GtkWidget *IlmOkCancelBox;
  GtkWidget *IlmQuitBtn;
  GtkWidget *IlmDefaultsBtn;
  GtkWidget *IlmOkBtn;
  GtkWidget *frame17;
  GtkWidget *IlmInfoScrollWnd;
  GtkWidget *IlmInfoView;
  GtkWidget *label90;
  GtkWidget *IlmStatusBar;
  GtkAccelGroup *accel_group;
  GtkSizeGroup *sz = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
  int typeP = Ilm::PTheProject->eType;

  accel_group = gtk_accel_group_new ();

  IlmProjectWnd = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (IlmProjectWnd, "IlmProjectWnd");
  gtk_window_set_title (GTK_WINDOW (IlmProjectWnd), g_strdup_printf("IL MILIONE %3.3s", VERSION));
  IlmProjectWnd_icon_pixbuf = create_pixbuf ("mr-ilmilione");
  if (IlmProjectWnd_icon_pixbuf)
  {
      gtk_window_set_icon (GTK_WINDOW (IlmProjectWnd), IlmProjectWnd_icon_pixbuf);
      g_object_unref (G_OBJECT(IlmProjectWnd_icon_pixbuf));
  }
  widget_modify_bg(IlmProjectWnd, GTK_STATE_NORMAL, &colorWhite);

  vbox1 = vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (IlmProjectWnd), vbox1);

// M e n u'

  createMenus(IlmProjectWnd, vbox1, typeP);

//28102016 Sostituito paned con vbox
  GtkWidget *paned = vbox_new(FALSE, 0); //vpaned_new();
  gtk_widget_show (paned);
  widget_modify_bg(paned, GTK_STATE_NORMAL, &colorWhite);

  GdkRectangle rect;
#if (GTK_MAJOR_VERSION > 2) && (GTK_MINOR_VERSION >= 22)
  GdkMonitor *mon = gdk_display_get_primary_monitor(gdk_display_get_default());
  gdk_monitor_get_geometry(mon, &rect);
#else
  GdkScreen *sc = gdk_screen_get_default();
  gdk_screen_get_monitor_geometry(sc, 0, &rect);
#endif
  int hh = rect.height;

  if(hh < 1000)             //200910
  {
     scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
     gtk_widget_show (scrolledwindow1);
     gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
     gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 4);
     gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
     viewport = gtk_viewport_new(NULL, NULL);
     widget_modify_bg(viewport, GTK_STATE_NORMAL, &colorWhite);
     gtk_widget_show (viewport);
     gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport);
     gtk_container_add (GTK_CONTAINER (viewport), paned);
  }
  else
     gtk_box_pack_start (GTK_BOX (vbox1), paned, TRUE, TRUE, 0);

  vbox1 = vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_show (vbox1);
  //gtk_paned_pack1((GtkPaned *)paned, vbox1, TRUE, TRUE);
  gtk_box_pack_start((GtkBox *)paned, vbox1, TRUE, TRUE, 0);

  IlmNotebook = gtk_notebook_new ();
  gtk_widget_set_name (IlmNotebook, "IlmNotebook");
  gtk_widget_show (IlmNotebook);
  gtk_box_pack_start (GTK_BOX (vbox1), IlmNotebook, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (IlmNotebook), 4);
  widget_modify_bg(IlmNotebook, GTK_STATE_NORMAL, &colorWhite);

// M T Z   F i l e

  vbox3 = vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox3, "vbox3");
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (IlmNotebook), vbox3);

#ifdef IN_GTK3
  GtkWidget *a = new_alignment(GTK_ALIGN_START,GTK_ALIGN_CENTER,0,0);
#else
  GtkWidget *a = gtk_alignment_new(0,0,0,0);
#endif

  gtk_widget_show (a);
  IlmJobEntry = entry_for_filesel(NULL, "Job Title:", "IlmJobEntry", 0, 0);
  set_width_chars (GTK_ENTRY (IlmJobEntry), 50);
  gtk_widget_show (IlmJobEntry);
  vbox2 = get_widget(IlmJobEntry, "box");
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 4);
  gtk_container_add (GTK_CONTAINER (a), vbox2);
  gtk_box_pack_start (GTK_BOX (vbox3), a, FALSE, FALSE, 0);

  _MyMTZ *mymtz = page_mtz(vbox3, (typeP == Ilm::EDM), 
                  Ilm::PTheProject->szMtzFile);
  mymtz->quale = 0;
  IlmMtzFileEntry = mymtz->entry;
  IlmMtzBrowseBtn = mymtz->browse;
  IlmMtzViewBtn   = mymtz->view;
  gtk_widget_set_name (IlmMtzBrowseBtn, "IlmMtzBrowseBtn");
  gtk_widget_set_name (IlmMtzViewBtn, "IlmMtzViewBtn");
  IlmMtzTitleEntry = mymtz->title;
  set_width_chars (GTK_ENTRY (IlmMtzTitleEntry), 50);
  gtk_widget_set_name (IlmMtzTitleEntry, "IlmMtzTitleEntry");
  IlmMtzSpgWidget = mymtz->spg;
  IlmMtzSpgEntry = get_widget(IlmMtzSpgWidget, "entry");
  gtk_widget_set_name (IlmMtzSpgEntry, "IlmMtzSpgEntry");
  IlmMtzSpgFind = mymtz->find;
  gtk_widget_set_name (IlmMtzSpgFind, "IlmMtzSpgFind");
  IlmMtzCellEntry = mymtz->cell;
  gtk_widget_set_name (IlmMtzCellEntry, "IlmMtzCellEntry");
  label_hint = mymtz->hint;
  gtk_widget_set_name (label_hint, "IlmMtzHint");
  IlmMtzColumnsEntry = mymtz->columns;
  gtk_widget_set_name (IlmMtzColumnsEntry, "IlmMtzColumnsEntry");
  IlmMtzDeleteBtn = mymtz->del;
  gtk_widget_set_name (IlmMtzDeleteBtn, "IlmMtzDeleteBtn");
  IlmMtzValueCombo = mymtz->vcombo;
  gtk_widget_set_name (IlmMtzValueCombo, "IlmMtzValueCombo");
  IlmMtzValueEntry = get_widget (IlmMtzValueCombo, "entry");
  gtk_widget_set_name (IlmMtzValueEntry, "IlmMtzValueEntry");
  IlmMtzEsdCombo = mymtz->esdcombo;
  gtk_widget_set_name (IlmMtzEsdCombo, "IlmMtzEsdCombo");
  IlmMtzEsdEntry = get_widget(IlmMtzEsdCombo,"entry");
  gtk_widget_set_name (IlmMtzEsdEntry, "IlmMtzEsdEntry");
  IlmMtzAddBtn = mymtz->add;
  gtk_widget_set_name (IlmMtzAddBtn, "IlmMtzAddBtn");
  IlmMtzAllCols = mymtz->allcols;
  gtk_widget_set_name (IlmMtzAllCols, "IlmMtzAllCols");
  IlmMtzAddColBtn = mymtz->addcol;
  gtk_widget_set_name (IlmMtzAddColBtn, "IlmMtzAddColBtn");

  set_tab_label (GTK_NOTEBOOK (IlmNotebook), MTZ, "MTZ File");

//           C e l l    C o n t e n t

  vboxCont = vbox_new (FALSE, 4);
  gtk_widget_set_name (vboxCont, "vboxCont");
  gtk_widget_show (vboxCont);
  gtk_container_add (GTK_CONTAINER (IlmNotebook), vboxCont);
  gtk_container_set_border_width (GTK_CONTAINER (vboxCont), 4);
#ifdef IN_GTK3
  gtk_widget_set_valign(vboxCont, GTK_ALIGN_START);
#endif

  label117 = FRAME_BOLD (" Molecular unit:", MyBLUE, 1.1f);
  gtk_widget_set_name (label117, "label117");
  gtk_widget_show (label117);
  gtk_box_pack_start (GTK_BOX (vboxCont), label117,FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (label117), 8);

  vlabel117 = vbox_new(FALSE, 0);
  gtk_widget_show (vlabel117);
  gtk_container_add (GTK_CONTAINER (label117), vlabel117);

  hboxmu = table_new (3,5, FALSE);
  gtk_widget_set_name (hboxmu, "hboxmu");
  gtk_widget_show (hboxmu);
  gtk_box_pack_start (GTK_BOX (vlabel117), hboxmu, TRUE, TRUE, 0);
  table_set_row_spacings (hboxmu, 8);
  table_set_col_spacings (hboxmu, 2);

  IlmContNmolsSpin = SPIN_WITH_LABEL("Number of molecules in\n the asymmetric unit: ", MyBLUE,
                      1, 100, 1, 1, 0);
  gtk_widget_set_name (get_widget(IlmContNmolsSpin, "spin"), "IlmContNmolsSpin");
  gtk_widget_show_all (IlmContNmolsSpin);
  gtk_size_group_add_widget(sz, get_widget(IlmContNmolsSpin, "spin"));

  IlmContMolRadio = RADIO_BUTTON_WITH_LABEL (NULL, "_Molecular Weight:", MyBLUE);
  gtk_widget_set_name (IlmContMolRadio, "IlmContMolRadio");
  gtk_widget_show (IlmContMolRadio);
  set_tip (IlmContMolRadio, "Molecular weight in Daltons");
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmContMolRadio), IlmContMolRadio_group);
  IlmContMolRadio_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (IlmContMolRadio));

  IlmContMolSpin_adj = adj_new (0, 0, 1e+07, 1000, 10000);
  IlmContMolSpin = spin_button_new (GTK_ADJUSTMENT (IlmContMolSpin_adj), 1, 0);
  gtk_widget_set_name (IlmContMolSpin, "IlmContMolSpin");
  gtk_widget_show (IlmContMolSpin);
  set_tip (IlmContMolSpin, "Molecular weight in Daltons");
  gtk_size_group_add_widget(sz, IlmContMolSpin);

  IlmContResiduesRadio = RADIO_BUTTON_WITH_LABEL (NULL, "Number of _residues:", MyBLUE);
  gtk_widget_set_name (IlmContResiduesRadio, "IlmContResiduesRadio");
  gtk_widget_show (IlmContResiduesRadio);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmContResiduesRadio), IlmContMolRadio_group);
  IlmContMolRadio_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (IlmContResiduesRadio));

  IlmContResiduesSpin_adj = adj_new (0, 0, 100000, 1, 10);
  IlmContResiduesSpin = spin_button_new (GTK_ADJUSTMENT (IlmContResiduesSpin_adj), 1, 0);
  gtk_widget_set_name (IlmContResiduesSpin, "IlmContResiduesSpin");
  gtk_widget_show (IlmContResiduesSpin);
  gtk_size_group_add_widget(sz, IlmContResiduesSpin);

  IlmContSeqRadio = RADIO_BUTTON_WITH_LABEL (NULL, "    _Sequence\n(FASTA format):", MyBLUE);
  gtk_widget_set_name (IlmContSeqRadio, "IlmContSeqRadio");
  gtk_widget_show (IlmContSeqRadio);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (IlmContSeqRadio), IlmContMolRadio_group);
  IlmContMolRadio_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (IlmContSeqRadio));

  IlmContSeqFile = entry_for_filesel(NULL, "", "IlmContSeqFile", 0, 1);
  gtk_widget_set_name (IlmContSeqFile, "IlmContSeqFile");
  gtk_widget_show (IlmContSeqFile);
  gtk_editable_set_editable(GTK_EDITABLE(IlmContSeqFile), FALSE);
  set_width_chars (GTK_ENTRY (IlmContSeqFile), 50);

  IlmContSeqBrowse = get_widget(IlmContSeqFile, "browse");
  gtk_widget_set_name (IlmContSeqBrowse, "IlmContSeqBrowse");

  frameseq = gtk_frame_new(NULL);
  gtk_widget_set_name (frameseq, "IlmContSeqFrame");
  gtk_widget_show (frameseq);
  
  IlmContSeq = ScrolledText (frameseq);
  gtk_widget_set_name (IlmContSeq, "IlmContSeq");
  gtk_widget_show (IlmContSeq);
//  gtk_container_add(GTK_CONTAINER(frameseq), get_widget(IlmContSeq, "box"));

  labelseq = LABEL_NEW("or paste data in the box above", MyBLUE);
  gtk_widget_show (labelseq);

  table_attach (hboxmu, IlmContNmolsSpin, 0, 2, 0, 1);
  table_attach (hboxmu, IlmContMolRadio, 0, 1, 1, 2);
  table_attach (hboxmu, IlmContMolSpin, 1, 2, 1, 2);
  table_attach (hboxmu, IlmContResiduesRadio, 0, 1, 2, 3);
  table_attach (hboxmu, IlmContResiduesSpin, 1, 2, 2, 3);
  table_attach (hboxmu, frameseq, 2, 5, 0, 3, TRUE);

  hboxmus = table_new (1,2, FALSE);
  gtk_widget_show (hboxmus);
  gtk_box_pack_start (GTK_BOX (vlabel117), hboxmus, FALSE, FALSE, 8);
  table_set_row_spacings (hboxmus, 8);
  table_set_col_spacings (hboxmus, 2);

  GtkWidget *IlmContSeqBox = hbox_new(FALSE, 0);
  gtk_widget_show(IlmContSeqBox);
  gtk_widget_set_name(IlmContSeqBox, "IlmContSeqBox");

  table_attach (hboxmus, IlmContSeqRadio, 0, 1, 0, 1);
  table_attach (hboxmus, IlmContSeqBox, 1, 2, 0, 1);
  gtk_box_pack_start(GTK_BOX(IlmContSeqBox), get_widget(IlmContSeqFile, "box"), TRUE, TRUE, 0);
  gtk_box_pack_end(GTK_BOX(IlmContSeqBox), labelseq, FALSE, TRUE, 6);

  hboxNative = hbox_new (FALSE, 16);
  gtk_widget_set_name (hboxNative, "hboxNative");
  gtk_widget_show (hboxNative);
  gtk_box_pack_start (GTK_BOX (vboxCont), hboxNative, FALSE, TRUE, 0);

  IlmContNativeCheck = CHECK_BUTTON_WITH_LABEL ("Native data present", MyBLUE);
  gtk_widget_set_name (IlmContNativeCheck, "IlmContNativeCheck");
  gtk_widget_show (IlmContNativeCheck);
  gtk_box_pack_start (GTK_BOX (hboxNative), IlmContNativeCheck, FALSE, FALSE, 0);
  set_tip (IlmContNativeCheck, "Check this if the native protein diffraction data are present in the reflection file in addition to anomalous diffraction data");

  hbox28 = hbox_new (FALSE, 4);
  gtk_widget_set_name (hbox28, "hbox28");
  gtk_widget_show (hbox28);
  gtk_box_pack_start (GTK_BOX (hboxNative), hbox28, FALSE, TRUE, 0);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START,GTK_ALIGN_END,0,0);
#else
  align = gtk_alignment_new(0,1,0,0);
#endif

  gtk_widget_show(align);
  gtk_box_pack_start (GTK_BOX (hbox28), align, TRUE, TRUE, 0);
  hbox28bis = hbox_new(FALSE, 0);
  gtk_widget_show(hbox28bis);
  gtk_container_add(GTK_CONTAINER(align), hbox28bis);
  IlmContWavesLbl = LABEL_NEW ("Number of Waves:", MyBLUE);
  gtk_widget_set_name (IlmContWavesLbl, "IlmContWavesLbl");
  gtk_widget_show (IlmContWavesLbl);
  gtk_container_add(GTK_CONTAINER(hbox28bis), IlmContWavesLbl);

  IlmContWavesSpin_adj = adj_new (1, 0, 4, 1, 10);
  IlmContWavesSpin = spin_button_new (GTK_ADJUSTMENT (IlmContWavesSpin_adj), 1, 0);
  gtk_widget_set_name (IlmContWavesSpin, "IlmContWavesSpin");
  gtk_widget_show (IlmContWavesSpin);
  gtk_container_add(GTK_CONTAINER(hbox28bis), IlmContWavesSpin);
  set_tip (IlmContWavesSpin, "Number of wavelengths used to collect MAD/SAD data");

  align = hbox_new(FALSE, 0);
  gtk_widget_show(align);
  gtk_box_pack_start (GTK_BOX (hbox28), align, TRUE, TRUE, 0);
  IlmContDerivLbl = LABEL_NEW ("Number of Derivatives:", MyBLUE);
  gtk_widget_set_name (IlmContDerivLbl, "IlmContDerivLbl");
  gtk_widget_show (IlmContDerivLbl);
  gtk_container_add(GTK_CONTAINER(hbox28bis), IlmContDerivLbl);

  IlmContDerivSpin_adj = adj_new (1, 0, 4, 1, 1);
  IlmContDerivSpin = spin_button_new (GTK_ADJUSTMENT (IlmContDerivSpin_adj), 1, 0);
  gtk_widget_set_name (IlmContDerivSpin, "IlmContDerivSpin");
  gtk_widget_show (IlmContDerivSpin);
  gtk_container_add(GTK_CONTAINER(hbox28bis), IlmContDerivSpin);
  set_tip (IlmContDerivSpin, "Number of Derivatives");

  IlmContDerivsTbl = table_new (2, 5, FALSE);
  gtk_widget_set_name (IlmContDerivsTbl, "IlmContDerivsTbl");
  gtk_widget_show (IlmContDerivsTbl);
  gtk_box_pack_start (GTK_BOX (hbox28), IlmContDerivsTbl, FALSE, FALSE, 50);
  table_set_row_spacings (IlmContDerivsTbl, 2);
  table_set_col_spacings (IlmContDerivsTbl, 7);

  for(int nder=0; nder<=Ilm::MAX_DERIVATIVES; nder++)
  {

      if(nder == 0)
      {
         label157 = gtk_label_new ("Number of Waves:  ");
         gtk_widget_show (label157);
         table_attach (IlmContDerivsTbl, label157, nder, nder+1, 1, 2, TRUE);
         set_alignment (label157, 0., 0.5);
         label157 = gtk_label_new (" ");
      }
      else
      {
         std::stringstream nomesp;
         nomesp << "IlmContDeriv" << nder << "Spin"; 
         GObject *adj = adj_new (0, 0, 4, 1, 10);
         GtkWidget *spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 0);
         gtk_widget_set_name (spin, nomesp.str().c_str());
         gtk_widget_show (spin);
         table_attach (IlmContDerivsTbl, spin, nder, nder+1, 1, 2, TRUE);
         GLADE_HOOKUP_OBJECT (IlmProjectWnd, spin, nomesp.str().c_str());

         g_signal_connect ((gpointer) spin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);

         label157 = LABEL_NEW(g_strdup_printf("Deriv.%d", nder), MyBLUE);
         gtk_widget_show (label157);
         table_attach (IlmContDerivsTbl, label157, nder, nder+1, 0, 1, TRUE);
         set_alignment (label157, 0., 0.5);
      }
  }

  IlmContMadFrm = frameMad(IlmProjectWnd, vboxCont);

  IlmContMirFrm = frameMir(IlmProjectWnd, vboxCont);

  IlmContLigFrm = frameLig(IlmProjectWnd, vboxCont);
  if(typeP == Ilm::ABI)
     label177 = LABEL_BOLD ("Ligands - Additional elements in asymmetric unit (different from C, N, O)",
              MyBLUE, 1.1f);
  else
     label177 = LABEL_BOLD ("Ligands - Additional elements in asymmetric unit", MyBLUE, 1.1f);
  gtk_widget_show (label177);
  gtk_frame_set_label_widget (GTK_FRAME (IlmContLigFrm), label177);

  hboxCont = hbox_new(FALSE, 0);
  gtk_widget_show (hboxCont);
  gtk_box_pack_start (GTK_BOX (vboxCont), hboxCont, FALSE, FALSE, 0);

//060309 Nascosti i campi SOURCE E Wave

  IlmContSourceFrm = FRAME_BOLD ("Source", MyBLUE, 1.1f);
  gtk_widget_set_name (IlmContSourceFrm, "IlmContSourceFrm");
//060309  gtk_widget_show (IlmContSourceFrm);
  gtk_box_pack_start (GTK_BOX (hboxCont), IlmContSourceFrm, TRUE, TRUE, 4);

  IlmContWaveLFrm = FRAME_BOLD ("Wave Length", MyBLUE, 1.1f);
  gtk_widget_set_name (IlmContWaveLFrm, "IlmContWaveLFrm");
//060309  gtk_widget_show (IlmContWaveLFrm);
  gtk_box_pack_start (GTK_BOX (hboxCont), IlmContWaveLFrm, TRUE, TRUE, 4);

  vbox24 = hbox_new (FALSE, 4);
  gtk_widget_show (vbox24);
  gtk_container_add (GTK_CONTAINER (IlmContSourceFrm), vbox24);
  gtk_container_set_border_width (GTK_CONTAINER (vbox24), 4);

  for(i=0; i< (int)(sizeof(Ilm::Sources)/sizeof(Ilm::Sources[0])); i++)
  {
      radiobutton = RADIO_BUTTON_WITH_LABEL (IlmContSource_group, Ilm::Sources[i], MyBLUE);
      IlmContSource_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
      GLADE_HOOKUP_OBJECT (IlmProjectWnd, radiobutton, Ilm::Sources[i]);
      gtk_widget_show (radiobutton);
      gtk_box_pack_start (GTK_BOX (vbox24), radiobutton, TRUE, TRUE, 0);
      if(i)
         g_signal_connect (G_OBJECT(radiobutton), "toggled",
                      G_CALLBACK(on_IlmSourceRadio_toggled), IlmProjectWnd);
         
  }

  vbox24 = hbox_new (FALSE, 4);
  gtk_widget_show (vbox24);
  gtk_container_add (GTK_CONTAINER (IlmContWaveLFrm), vbox24);
  gtk_container_set_border_width (GTK_CONTAINER (vbox24), 4);

  for(i=0; i< (int)(sizeof(Ilm::Waves)/sizeof(Ilm::Waves[0])); i++)
  {
      radiobutton = RADIO_BUTTON_WITH_LABEL (IlmContWaveL_group, Ilm::Waves[i], MyBLUE);
      IlmContWaveL_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
      GLADE_HOOKUP_OBJECT (IlmProjectWnd, radiobutton, Ilm::Waves[i]);
      gtk_widget_show (radiobutton);
      gtk_box_pack_start (GTK_BOX (vbox24), radiobutton, TRUE, TRUE, 0);
      if(i == 1)
         gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton), TRUE);
  }
#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START,GTK_ALIGN_CENTER,0,0);
#else
  align = gtk_alignment_new(0,0.5,0,0);
#endif

  gtk_widget_show(align);
  gtk_box_pack_start (GTK_BOX (vbox24), align, FALSE, FALSE, 0);

  IlmContWaveLEntry = gtk_entry_new ();
  (void) g_signal_connect (G_OBJECT(radiobutton), "toggled",
                      G_CALLBACK(on_cb_attiva), IlmContWaveLEntry);
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContWaveLEntry, "IlmContWaveLEntry");
  gtk_widget_set_size_request(IlmContWaveLEntry, 70, 22);
  gtk_widget_set_sensitive(IlmContWaveLEntry, FALSE);
  gtk_widget_show (IlmContWaveLEntry);
  gtk_container_add (GTK_CONTAINER (align), IlmContWaveLEntry);
//060309 fin qui

  set_tab_label (GTK_NOTEBOOK (IlmNotebook), CONT, "Cell Content");

//                    T a s k s

  GtkWidget *IlmNotebook_box = vbox_new(FALSE, 0);
  gtk_widget_show(IlmNotebook_box);
  gtk_container_add (GTK_CONTAINER (IlmNotebook), IlmNotebook_box);

  set_tab_label (GTK_NOTEBOOK (IlmNotebook), RUN, "Tasks");

  switch(typeP)
  {
// Tasks for Mad/Sad, Mir/Sir, Miras/Siras, Edm
  case MAD:
  case MIR:
  case MRS:
  case EDM:
       frameMost(IlmProjectWnd, IlmNotebook_box);
       break;
// Tasks for Molecular Replacement
  case MOLREP:
       frameMolrep(IlmProjectWnd, IlmNotebook_box);
       break;
// Tasks for Abi
  case ABI:
       frameAbi(IlmProjectWnd, IlmNotebook_box);
       break;
// Tasks for DEA
  case DEA:
       frameDea(IlmProjectWnd, IlmNotebook_box);
       break;
  }

  IlmOkCancelBox = hbutton_box_new ();
  gtk_widget_set_name (IlmOkCancelBox, "IlmOkCancelBox");
  gtk_widget_show (IlmOkCancelBox);
  gtk_box_pack_start (GTK_BOX (vbox1), IlmOkCancelBox, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (IlmOkCancelBox), 4);

  IlmQuitBtn = myimage_button ("_Quit Project", "quit.png");
  gtk_widget_set_name (IlmQuitBtn, "IlmQuitBtn");
  gtk_widget_show (IlmQuitBtn);
  gtk_container_add (GTK_CONTAINER (IlmOkCancelBox), IlmQuitBtn);
  gtk_widget_set_can_focus (IlmQuitBtn, TRUE);

  IlmDefaultsBtn = gtk_button_new_with_mnemonic ("Set Defaults");
  gtk_widget_set_name (IlmDefaultsBtn, "IlmDefaultsBtn");
  gtk_widget_show (IlmDefaultsBtn);
  gtk_container_add (GTK_CONTAINER (IlmOkCancelBox), IlmDefaultsBtn);
  gtk_widget_set_sensitive (IlmDefaultsBtn, FALSE);
  gtk_widget_set_can_focus (IlmDefaultsBtn, TRUE);

  IlmOkBtn = myimage_button ("_Apply", "apply.png");
  gtk_widget_set_name (IlmOkBtn, "IlmOkBtn");
  gtk_widget_show (IlmOkBtn);
  gtk_container_add (GTK_CONTAINER (IlmOkCancelBox), IlmOkBtn);
  gtk_widget_set_can_focus (IlmOkBtn, TRUE);

  frame17 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame17, "frame17");
  gtk_widget_show (frame17);
  //gtk_paned_pack2((GtkPaned *)paned, frame17, TRUE, FALSE);
  gtk_box_pack_end((GtkBox *)paned, frame17, TRUE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame17), 4);

#if 0
  IlmInfoScrollWnd = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (IlmInfoScrollWnd, "IlmInfoScrollWnd");
  gtk_widget_show (IlmInfoScrollWnd);
  gtk_container_add (GTK_CONTAINER (frame17), IlmInfoScrollWnd);
  gtk_container_set_border_width (GTK_CONTAINER (IlmInfoScrollWnd), 4);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (IlmInfoScrollWnd), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_widget_set_size_request(IlmInfoScrollWnd, 100, 100);

  IlmInfoView = gtk_text_view_new ();
  gtk_widget_set_name (IlmInfoView, "IlmInfoView");
  gtk_widget_show (IlmInfoView);
  GtkTextBuffer *buf =  gtk_text_view_get_buffer (GTK_TEXT_VIEW(IlmInfoView));

  gtk_text_buffer_create_tag (buf, "big",
			      "size", 10 * PANGO_SCALE, 
			      "weight", PANGO_WEIGHT_BOLD, NULL);  
  

  gtk_container_add (GTK_CONTAINER (IlmInfoScrollWnd), IlmInfoView);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (IlmInfoView), FALSE);
  set_bg_color(IlmInfoView, colorYellow);
  //set_text_color(IlmInfoView, colorBlue);
  set_text_color(IlmInfoView, "blue");
#endif
//NEW
#if defined (IN_GTK3) && (GTK_MINOR_VERSION > 14)
  IlmInfoView = scrolled_labeltext(frame17);
#else
  IlmInfoView = scrolled_text(frame17);
#endif
  gtk_widget_set_name (IlmInfoView, "IlmInfoView");
  gtk_widget_show (IlmInfoView);
  set_bg_color(IlmInfoView, colorYellow);
  set_text_color(IlmInfoView, "blue");
  IlmInfoScrollWnd = get_widget(IlmInfoView, "scrollwin");
  gtk_widget_set_name (IlmInfoScrollWnd, "IlmInfoScrollWnd");
  gtk_widget_set_size_request(get_widget(IlmInfoView, "scrollwin"), -1, 120);

  label90 = LABEL_BOLD ("Output", MyRED, 1.2f);
  gtk_widget_set_name (label90, "label90");
  gtk_widget_show (label90);
  gtk_frame_set_label_widget (GTK_FRAME (frame17), label90);

  IlmStatusBar = gtk_statusbar_new ();
  gtk_widget_set_name (IlmStatusBar, "IlmStatusBar");
  gtk_widget_show (IlmStatusBar);
  gtk_box_pack_start (GTK_BOX (vbox1), IlmStatusBar, FALSE, TRUE, 0);

  g_signal_connect ((gpointer) IlmProjectWnd, "delete_event",
                    G_CALLBACK (on_IlmProjectWnd_delete_event),
                    NULL);
  g_signal_connect ((gpointer) IlmProjectWnd, "destroy",
                    G_CALLBACK (on_IlmProjectWnd_destroy),
                    NULL);
//  g_signal_connect ((gpointer) IlmNotebook, "switch_page",
  g_signal_connect ((gpointer) IlmNotebook, "change-current-page",
                    G_CALLBACK (on_IlmNotebook_switch_page),
                    NULL);
//  g_signal_connect_after ((gpointer) IlmNotebook, "switch_page",
  g_signal_connect_after ((gpointer) IlmNotebook, "change-current-page",
                          G_CALLBACK (on_IlmNotebook_switch_page_after),
                          NULL);
  int hnd = g_signal_connect ((gpointer) IlmContWavesSpin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_object_set_data(G_OBJECT(IlmContWavesSpin), "hnd", GINT_TO_POINTER(hnd));
  hnd = g_signal_connect ((gpointer) IlmContDerivSpin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_object_set_data(G_OBJECT(IlmContDerivSpin), "hnd", GINT_TO_POINTER(hnd));

  g_signal_connect ((gpointer) IlmContMolRadio, "toggled",
                    G_CALLBACK (on_IlmContMolRadio_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmContMolSpin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmContResiduesRadio, "toggled",
                    G_CALLBACK (on_IlmContResiduesRadio_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmContResiduesSpin, "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) get_widget(IlmContNmolsSpin, "spin"), "value_changed",
                    G_CALLBACK (on_Spin_value_changed),
                    NULL);
  g_signal_connect ((gpointer) IlmContSeqRadio, "toggled",
                    G_CALLBACK (on_IlmContSeqRadio_toggled),
                    NULL);
  g_signal_connect ((gpointer) IlmContSeqBrowse, "clicked",
                    G_CALLBACK (on_IlmContSeqBrowse_clicked),
                    NULL);
  g_signal_connect ((gpointer) IlmContSeq, "paste-clipboard",
                    G_CALLBACK (on_IlmContSeqPaste),
                    NULL);
  g_signal_connect_after ((gpointer) IlmContSeq, "paste-clipboard",
                    G_CALLBACK (on_IlmContSeqPasteAfter),
                    NULL);
  g_signal_connect ((gpointer) IlmQuitBtn, "clicked",
                    G_CALLBACK (on_Quit),
                    NULL);
  g_signal_connect ((gpointer) IlmDefaultsBtn, "clicked",
                    G_CALLBACK (on_IlmDefaults_clicked),
                    NULL);
  g_signal_connect ((gpointer) IlmOkBtn, "clicked",
                    G_CALLBACK (on_IlmOk_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (IlmProjectWnd, IlmProjectWnd, "IlmProjectWnd");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmNotebook, "IlmNotebook");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmJobEntry, "IlmJobEntry");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzFileEntry, "IlmMtzFileEntry");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzBrowseBtn, "IlmMtzBrowseBtn");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzViewBtn, "IlmMtzViewBtn");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzTitleEntry, "IlmMtzTitleEntry");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzSpgEntry, "IlmMtzSpgEntry");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzSpgFind, "IlmMtzSpgFind");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzCellEntry, "IlmMtzCellEntry");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, label_hint, "IlmMtzHint");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzValueCombo, "IlmMtzValueCombo");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzValueEntry, "IlmMtzValueEntry");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzEsdCombo, "IlmMtzEsdCombo");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzEsdEntry, "IlmMtzEsdEntry");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzColumnsEntry, "IlmMtzColumnsEntry");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzAddBtn, "IlmMtzAddBtn");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzDeleteBtn, "IlmMtzDeleteBtn");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzAllCols, "IlmMtzAllCols");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmMtzAddColBtn, "IlmMtzAddColBtn");

  GLADE_HOOKUP_OBJECT (IlmProjectWnd, hboxNative, "hboxNative");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContNativeCheck, "IlmContNativeCheck");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContWavesLbl, "IlmContWavesLbl");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContWavesSpin, "IlmContWavesSpin");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContDerivLbl, "IlmContDerivLbl");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContDerivSpin, "IlmContDerivSpin");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContDerivsTbl, "IlmContDerivsTbl");

  GLADE_HOOKUP_OBJECT (IlmProjectWnd, vboxCont, "vboxCont");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContMolRadio, "IlmContMolRadio");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContMolSpin, "IlmContMolSpin");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContResiduesRadio, "IlmContResiduesRadio");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContResiduesSpin, "IlmContResiduesSpin");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContSeqRadio, "IlmContSeqRadio");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContSeqBrowse, "IlmContSeqBrowse");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContSeq, "IlmContSeq");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContSeqFile, "IlmContSeqFile");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContSeqBox, "IlmContSeqBox");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, frameseq, "IlmContSeqFrame");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, get_widget(IlmContNmolsSpin, "spin"), "IlmContNmolsSpin");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContMadFrm, "IlmContMadFrm");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContMirFrm, "IlmContMirFrm");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContLigFrm, "IlmContLigFrm");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContSourceFrm, "IlmContSourceFrm");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmContWaveLFrm, "IlmContWaveLFrm");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmOkCancelBox, "IlmOkCancelBox");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmQuitBtn, "IlmQuitBtn");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmDefaultsBtn, "IlmDefaultsBtn");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmOkBtn, "IlmOkBtn");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmInfoScrollWnd, "IlmInfoScrollWnd");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmInfoView, "IlmInfoView");
  GLADE_HOOKUP_OBJECT (IlmProjectWnd, IlmStatusBar, "IlmStatusBar");

  gtk_window_add_accel_group (GTK_WINDOW (IlmProjectWnd), accel_group);

  return IlmProjectWnd;
}

GtkWidget*create_IlmAboutDlg (void)
{
    GtkWidget *IlmAboutDlg, *label;
    gtkext::AboutItem it;
    GdkCursor *hand_cursor;

    hand_cursor = create_my_cursor(HAND_CURSOR);

    it.text1 = g_strdup_printf(
           "<span foreground=\"blue\" size=\"xx-large\">IL MILIONE %4.4s  </span>\n" 
"%s\n%s\n"
"\nA package for global phasing.\n\n"
"By M.C. Burla, R. Caliandro, M. Camalli, \nB. Carrozzini, G.L. Cascarano, "
"L. De Caro, \nC. Giacovazzo, G.Polidori, D. Siliqi, R.Spagna.\n\n"
"Support: sirmail@ic.cnr.it", VERSION, Ilm::TheApp.DateInfo().c_str(), ArchInfo().c_str());
    it.htext1 = g_strdup_printf("http://www.ic.cnr.it/\n\n");
    it.text2  = g_strdup_printf("Graphical User Interface based on GTK libraries (V. %d.%d)",
                 GTK_MAJOR_VERSION, GTK_MINOR_VERSION);
    it.htext2 = g_strdup_printf("http://www.gtk.org");
    it.text3  = g_strdup_printf("\ncreated by M.R. Mallamo and M. Moustiakimov.\n");
    it.htext3  = NULL;
    it.text4   = NULL;
    it.htext4  = NULL;
    it.text5   = NULL;
    it.htext5  = NULL;

    it.title            = g_strdup_printf("About Il Milione");
    it.image            = g_strdup_printf("ilm_about.gif");
    it.browser          = g_strdup_printf("%s", Ilm::TheApp.Executables()[Ilm::IExeBrowser].c_str());
    IlmAboutDlg = gtkext::create_about_dialog(NULL, &it);
    
    gtk_widget_show_all (IlmAboutDlg);
    label = get_widget(IlmAboutDlg, "htext1");
    gdk_window_set_cursor (gtk_widget_get_window(label), hand_cursor);
    label = get_widget(IlmAboutDlg, "htext2");
    gdk_window_set_cursor (gtk_widget_get_window(label), hand_cursor);

    return IlmAboutDlg;
}

GtkWidget*
create_IlmSubmitDlg (void)
{
  GtkWidget *IlmSubmitDlg;
  GtkWidget *dialog_vbox2;
  GtkWidget *vbox22;
  GtkWidget *IlmSubmitInfoLbl;
  GtkWidget *cancelbutton1;
  GtkWidget *okbutton2;
  GtkWidget *button4;

  IlmSubmitDlg = gtk_dialog_new ();
  gtk_widget_set_name (IlmSubmitDlg, "IlmSubmitDlg");
  gtk_container_set_border_width (GTK_CONTAINER (IlmSubmitDlg), 4);
  gtk_window_set_title (GTK_WINDOW (IlmSubmitDlg), "Submit Job");
  gtk_window_set_type_hint (GTK_WINDOW (IlmSubmitDlg), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox2 = gtk_dialog_get_content_area(GTK_DIALOG (IlmSubmitDlg));
  gtk_widget_set_name (dialog_vbox2, "dialog_vbox2");
  gtk_widget_show (dialog_vbox2);

  vbox22 = vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox22, "vbox22");
  gtk_widget_show (vbox22);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), vbox22, TRUE, TRUE, 0);

  IlmSubmitInfoLbl = gtk_label_new ("The Project is prepared. Press Ok to submit the job.");
  gtk_widget_set_name (IlmSubmitInfoLbl, "IlmSubmitInfoLbl");
  gtk_widget_show (IlmSubmitInfoLbl);
  gtk_box_pack_start (GTK_BOX (vbox22), IlmSubmitInfoLbl, TRUE, TRUE, 0);

  cancelbutton1 = myimage_button ("_Cancel", "cancel.png");
  gtk_widget_set_name (cancelbutton1, "cancelbutton1");
  gtk_widget_show (cancelbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (IlmSubmitDlg), cancelbutton1, GTK_RESPONSE_CANCEL);
  gtk_widget_set_can_focus (cancelbutton1, TRUE);

  okbutton2 = myimage_button ("_OK", "apply.png");
  gtk_widget_set_name (okbutton2, "okbutton2");
  gtk_widget_show (okbutton2);
  gtk_dialog_add_action_widget (GTK_DIALOG (IlmSubmitDlg), okbutton2, GTK_RESPONSE_OK);
  gtk_widget_set_can_focus (okbutton2, TRUE);

  button4 = myimage_button ("Change project name", "filesaveas.png");
  gtk_widget_set_name (button4, "button4");
  gtk_widget_show (button4);
  gtk_dialog_add_action_widget (GTK_DIALOG (IlmSubmitDlg), button4, GTK_RESPONSE_REJECT);
  gtk_widget_set_can_focus (button4, TRUE);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (IlmSubmitDlg, IlmSubmitDlg, "IlmSubmitDlg");
  GLADE_HOOKUP_OBJECT_NO_REF (IlmSubmitDlg, dialog_vbox2, "dialog_vbox2");
  GLADE_HOOKUP_OBJECT (IlmSubmitDlg, vbox22, "vbox22");
  GLADE_HOOKUP_OBJECT (IlmSubmitDlg, IlmSubmitInfoLbl, "IlmSubmitInfoLbl");
  GLADE_HOOKUP_OBJECT (IlmSubmitDlg, cancelbutton1, "cancelbutton1");
  GLADE_HOOKUP_OBJECT (IlmSubmitDlg, okbutton2, "okbutton2");
  GLADE_HOOKUP_OBJECT (IlmSubmitDlg, button4, "button4");

  return IlmSubmitDlg;
}

GtkWidget* create_IlmSirEditDlg (void)
{
  GtkWidget *IlmSirEditDlg;
  GtkWidget *dialog_vbox3;
  GtkWidget *table40;
  GtkWidget *IlmSirEdit1Entry;
  GtkWidget *IlmSirEdit1Btn;
  GtkWidget *cancelbutton2;
  GtkWidget *okbutton3;
  char nome[60];
  int i;
  int typeP = Ilm::PTheProject->eType;

  IlmSirEditDlg = gtk_dialog_new ();
  gtk_widget_set_name (IlmSirEditDlg, "IlmSirEditDlg");
  gtk_window_set_title (GTK_WINDOW (IlmSirEditDlg), "Edit instruction files");
  gtk_window_set_type_hint (GTK_WINDOW (IlmSirEditDlg), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox3 = gtk_dialog_get_content_area(GTK_DIALOG (IlmSirEditDlg));
  gtk_widget_set_name (dialog_vbox3, "dialog_vbox3");
  gtk_widget_show (dialog_vbox3);

  table40 = table_new (4, 2, FALSE);
  gtk_widget_set_name (table40, "table40");
  gtk_widget_show (table40);
  gtk_box_pack_start (GTK_BOX (dialog_vbox3), table40, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table40), 6);
  table_set_row_spacings (table40, 4);
  table_set_col_spacings (table40, 4);

  for(i=0; i<3; i++)
  {
      IlmSirEdit1Entry = gtk_entry_new ();
      ScriviStringa(nome, sizeof(nome), "IlmSirEdit%dEntry", i);
      gtk_widget_set_name (IlmSirEdit1Entry, nome);
      gtk_widget_show (IlmSirEdit1Entry);
      table_attach (table40, IlmSirEdit1Entry, 0, 1, i, i+1, TRUE);
      gtk_widget_set_sensitive (IlmSirEdit1Entry, FALSE);
      gtk_editable_set_editable (GTK_EDITABLE (IlmSirEdit1Entry), FALSE);
      GLADE_HOOKUP_OBJECT (IlmSirEditDlg, IlmSirEdit1Entry, nome);
      ScriviStringa(nome, sizeof(nome), "Task%d Sir instruction file", i);
      gtk_entry_set_text (GTK_ENTRY (IlmSirEdit1Entry), nome);

      IlmSirEdit1Btn = gtk_button_new_with_mnemonic ("Edit");
      ScriviStringa(nome, sizeof(nome), "IlmSirEdit%dBtn", i);
      gtk_widget_set_name (IlmSirEdit1Btn, nome);
      gtk_widget_show (IlmSirEdit1Btn);
      table_attach (table40, IlmSirEdit1Btn, 1, 2, i, i+1, TRUE);
      g_signal_connect ((gpointer) IlmSirEdit1Btn, "clicked",
                    G_CALLBACK (on_IlmSirEditBtn_clicked),
                    GINT_TO_POINTER(i));
      GLADE_HOOKUP_OBJECT (IlmSirEditDlg, IlmSirEdit1Btn, nome);
  }

  if(typeP == Ilm::ABI)
  {
     for(i=1; i<3; i++)
     {
         ScriviStringa(nome, sizeof(nome), "IlmSirEdit%dEntry", i);
         gtk_widget_hide(get_widget(IlmSirEditDlg, nome));
         ScriviStringa(nome, sizeof(nome), "IlmSirEdit%dBtn", i);
         gtk_widget_hide(get_widget(IlmSirEditDlg, nome));
     }
     gtk_entry_set_text (GTK_ENTRY (get_widget(IlmSirEditDlg, "IlmSirEdit0Entry")), "Ab initio Sir instruction file");
  }
  else if(typeP == Ilm::MOLREP)
  {
     for(i=1; i<3; i++)
     {
         ScriviStringa(nome, sizeof(nome), "IlmSirEdit%dEntry", i);
         gtk_widget_hide(get_widget(IlmSirEditDlg, nome));
         ScriviStringa(nome, sizeof(nome), "IlmSirEdit%dBtn", i);
         gtk_widget_hide(get_widget(IlmSirEditDlg, nome));
     }
     gtk_entry_set_text (GTK_ENTRY (get_widget(IlmSirEditDlg, "IlmSirEdit0Entry")), "ReMo instruction file");
  }
  else if(typeP == Ilm::EDM)
  {
     for(i=1; i<3; i++)
     {
         ScriviStringa(nome, sizeof(nome), "IlmSirEdit%dEntry", i);
         gtk_widget_hide(get_widget(IlmSirEditDlg, nome));
         ScriviStringa(nome, sizeof(nome), "IlmSirEdit%dBtn", i);
         gtk_widget_hide(get_widget(IlmSirEditDlg, nome));
     }
     gtk_entry_set_text (GTK_ENTRY (get_widget(IlmSirEditDlg, "IlmSirEdit0Entry")), "EDM instruction file");
  }
  else if(typeP == Ilm::DEA)
  {
     for(i=1; i<3; i++)
     {
         ScriviStringa(nome, sizeof(nome), "IlmSirEdit%dEntry", i);
         gtk_widget_hide(get_widget(IlmSirEditDlg, nome));
         ScriviStringa(nome, sizeof(nome), "IlmSirEdit%dBtn", i);
         gtk_widget_hide(get_widget(IlmSirEditDlg, nome));
     }
     gtk_entry_set_text (GTK_ENTRY (get_widget(IlmSirEditDlg, "IlmSirEdit0Entry")), "Dea instruction file");
  }

  else if(typeP == Ilm::MAD)
  {
     gtk_widget_hide(get_widget(IlmSirEditDlg, "IlmSirEdit0Entry"));
     gtk_widget_hide(get_widget(IlmSirEditDlg, "IlmSirEdit0Btn"));
  }
  
  cancelbutton2 = myimage_button ("_Cancel", "cancel.png");
  gtk_widget_set_name (cancelbutton2, "cancelbutton2");
  gtk_widget_show (cancelbutton2);
  gtk_dialog_add_action_widget (GTK_DIALOG (IlmSirEditDlg), cancelbutton2, GTK_RESPONSE_CANCEL);
  gtk_widget_set_can_focus (cancelbutton2, TRUE);

  okbutton3 = myimage_button ("_OK", "apply.png");
  gtk_widget_set_name (okbutton3, "okbutton3");
  gtk_widget_show (okbutton3);
  gtk_dialog_add_action_widget (GTK_DIALOG (IlmSirEditDlg), okbutton3, GTK_RESPONSE_OK);
  gtk_widget_set_can_focus (okbutton3, TRUE);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (IlmSirEditDlg, IlmSirEditDlg, "IlmSirEditDlg");
  GLADE_HOOKUP_OBJECT_NO_REF (IlmSirEditDlg, dialog_vbox3, "dialog_vbox3");
  GLADE_HOOKUP_OBJECT (IlmSirEditDlg, table40, "table40");
  GLADE_HOOKUP_OBJECT (IlmSirEditDlg, cancelbutton2, "cancelbutton2");
  GLADE_HOOKUP_OBJECT (IlmSirEditDlg, okbutton3, "okbutton3");

  return IlmSirEditDlg;
}

GtkWidget*
create_IlmSettingsDlg (void)
{
  GtkWidget *IlmSettingsDlg;
  GtkWidget *dialog_vbox4;
  GtkWidget *table42;
  GtkWidget *cancelbutton3;
  GtkWidget *okbutton4;
  GtkSizeGroup *sz = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);


  IlmSettingsDlg = gtk_dialog_new ();
  gtk_widget_set_name (IlmSettingsDlg, "IlmSettingsDlg");
  gtk_window_set_title (GTK_WINDOW (IlmSettingsDlg), "IL MILIONE Settings");
  gtk_window_set_type_hint (GTK_WINDOW (IlmSettingsDlg), GDK_WINDOW_TYPE_HINT_DIALOG);
  gtk_window_set_default_size (GTK_WINDOW (IlmSettingsDlg), 500, 220);

  dialog_vbox4 = gtk_dialog_get_content_area(GTK_DIALOG (IlmSettingsDlg));
  gtk_widget_set_name (dialog_vbox4, "dialog_vbox4");
  gtk_widget_show (dialog_vbox4);

  table42 = table_new (3, 2, FALSE);
  gtk_widget_set_name (table42, "table42");
  gtk_widget_show (table42);
  gtk_box_pack_start (GTK_BOX (dialog_vbox4), table42, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table42), 4);
  table_set_row_spacings (table42, 4);
  table_set_col_spacings (table42, 4);

  for(int i=0; i<(int) Ilm::NExecutables ; i++)
  {
      GtkWidget *Entry = entry_for_filesel(NULL, (char *)Ilm::SZLbExecutables[i], g_strdup_printf("IlmSetEntry%d", i+1), 0, 1);
      table_attach (table42, get_widget(Entry, "box"), 
                     0, 1, i, i+1, TRUE);
      set_tip (Entry, Ilm::SZTip[i]);
      set_width_chars (GTK_ENTRY (Entry), 60);
      GtkWidget *Btn = get_widget(Entry, "browse");
      gtk_widget_set_name (Btn, g_strdup_printf("IlmSetBtn%d", i+1));
      gtk_size_group_add_widget(sz, get_widget(Entry, "label"));
      GLADE_HOOKUP_OBJECT (IlmSettingsDlg, Entry, g_strdup_printf("IlmSetEntry%d", i+1));
      GLADE_HOOKUP_OBJECT (IlmSettingsDlg, Btn, g_strdup_printf("IlmSetBtn%d", i+1));
      g_signal_connect ((gpointer) Btn, "clicked",
                    G_CALLBACK (on_IlmSetProgBtn_clicked),
                    g_strdup_printf("IlmSetEntry%d", i+1));
  }
  cancelbutton3 = myimage_button ("_Cancel", "cancel.png");
  gtk_widget_set_name (cancelbutton3, "cancelbutton3");
  gtk_widget_show (cancelbutton3);
  gtk_dialog_add_action_widget (GTK_DIALOG (IlmSettingsDlg), cancelbutton3, GTK_RESPONSE_CANCEL);
  gtk_widget_set_can_focus (cancelbutton3, TRUE);

  okbutton4 = myimage_button ("_OK", "apply.png");
  gtk_widget_set_name (okbutton4, "okbutton4");
  gtk_widget_show (okbutton4);
  gtk_dialog_add_action_widget (GTK_DIALOG (IlmSettingsDlg), okbutton4, GTK_RESPONSE_OK);
  gtk_widget_set_can_focus (okbutton4, TRUE);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (IlmSettingsDlg, IlmSettingsDlg, "IlmSettingsDlg");
  GLADE_HOOKUP_OBJECT_NO_REF (IlmSettingsDlg, dialog_vbox4, "dialog_vbox4");
  GLADE_HOOKUP_OBJECT (IlmSettingsDlg, table42, "table42");
  GLADE_HOOKUP_OBJECT (IlmSettingsDlg, cancelbutton3, "cancelbutton3");
  GLADE_HOOKUP_OBJECT (IlmSettingsDlg, okbutton4, "okbutton4");

  return IlmSettingsDlg;
}

GtkWidget* create_IlmSplashWnd (void)
{
  GtkWidget *IlmSplashWnd;
  GtkWidget *hbox102;
  GtkWidget *image9;
  GtkWidget *table;

  IlmSplashWnd = gtk_window_new (GTK_WINDOW_TOPLEVEL);
#ifndef GTK_TOOLTIP
  GtkTooltips *tooltips = gtk_tooltips_new ();
  set_win_main(IlmSplashWnd);
  g_object_set_data(G_OBJECT(IlmSplashWnd), "tt", tooltips);
#endif 
  gtk_widget_set_name (IlmSplashWnd, "IlmSplashWnd");
  gtk_window_set_title (GTK_WINDOW (IlmSplashWnd), "Il Milione");
  widget_modify_bg(IlmSplashWnd, GTK_STATE_NORMAL, &colorWhite);
  gtk_window_set_resizable (GTK_WINDOW (IlmSplashWnd), FALSE);
  set_icon(IlmSplashWnd, "mr-ilmilione");
/*
  GdkPixbuf *IlmSplashWnd_icon_pixbuf = create_pixbuf ("icona16.ico");
  if (IlmSplashWnd_icon_pixbuf)
    {
      gtk_window_set_icon (GTK_WINDOW (IlmSplashWnd), IlmSplashWnd_icon_pixbuf);
      g_object_unref (G_OBJECT(IlmSplashWnd_icon_pixbuf));
    }
*/
  table = table_new (3, 1, FALSE);
  gtk_widget_set_name (table, "table");
  gtk_widget_show (table);
  gtk_container_add (GTK_CONTAINER (IlmSplashWnd), table);
  do_menu_and_toolbar(table, IlmSplashWnd, Ilm::TheApp.strFontName.c_str(), 20, 20);

  hbox102 = hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox102, "hbox102");
  gtk_widget_show (hbox102);
  table_attach (table, hbox102, 0, 1, 2, 3, TRUE);

  //char *str = g_strdup_printf("%5.5s", VERSION);
  char *str = g_strdup_printf("%d.%2.2d", MY_MAJOR_VERSION(VERSION),
                        MY_MINOR_VERSION(VERSION));

  int w1, h1;
  PangoFontDescription *fontnew  = get_font(3, 12);
  pango_font_description_set_style (fontnew, PANGO_STYLE_OBLIQUE);
  get_metrics(fontnew, &w1, &h1);
  GdkPixbuf *pix = pix_from_file_and_text("ilm_sfondo.png", str,
             fontnew, -6*w1,  -h1, &colorBlue, IlmSplashWnd);

  image9 = gtk_image_new_from_pixbuf(pix);
  gtk_widget_set_name (image9, "image9");
  gtk_widget_show (image9);
  gtk_box_pack_start (GTK_BOX (hbox102), image9, TRUE, TRUE, 0);

  g_signal_connect ((gpointer) IlmSplashWnd, "delete_event",
                    G_CALLBACK (on_IlmSplashWnd_delete_event),
                    NULL);
  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (IlmSplashWnd, IlmSplashWnd, "IlmSplashWnd");
  GLADE_HOOKUP_OBJECT (IlmSplashWnd, hbox102, "hbox102");

  return IlmSplashWnd;
}

