!---------------------------------------------------------------------
!                  genhy.f + refana.f   (29.11.2001) + cellana     
!---------------------------------------------------------------------
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! GENHY           (versione Vettori Sir)     guignio 2009       
!          
!
!All'inizio di ogni tipo di generazione  viene chiamata HydroBase che prepara l'ambiente 
!(alloca, azzera e definisce) e chiama HybriBase  
!Gli H vengono sempre generati attraverso Hyauto , e riconosciuti da Sir da iGeomAtom(n)>0
!Codice iautoHy  :1  Automatic 
!                 0  Wizard
!                 <0 Single iabs(iautoHY)=nord      
!--------
!
! 
!I tipi di possibili ibridizzazione e il codice che gli identifica (Hybcal) sono:
! 
!         sp  (2 legami a 180)  Hybcal=1  
!         sp2 (3 legami a 120)  Hybcal=2
!         sp3 (4 legami a 108)  Hybcal=3
!
!Per N:
!         sp2 (2-3 legami a 120) Hybcal=2
!         sp3 (3-4 legami a 108) Hybcal=3
!il programma assume il numero minimo di legami (2 e 3) per ogni ibridizzazione,sara'
!l'utente a definire il no. giusto di H,nei casi in cui il no.di legami fosse 3 o 4.  
!Per l'Ossigeno  l'ibridizzazione e sempre sp3  e ci sarebbe
!          O=C   (1 legame   senza H) Hybcal=4
!          O-H   (2 legami a 108, 1H) Hybcal=4
!          OH2   (3 legami a 108, 2H) Hybcal=4
!
!--- (Tabella 1)Tipo di ibridizzazione e valori dei vettori usati
!
!   ibrid=tipo di ibridizzazzione (non usato nel prog. serve solo qui!!!)
!   maxleg= no. di legami previsto dal tipo di ibridazione (2 per sp1,3 per sp2 ,4 per sp3)
!           Per gli atomi di N( nz=7), il prog. usa i valori di maxleg non  tra 
!           parentesi per la definizione del no. di H da generare,
!           mentre usa quelli tra parentesi per controllare il no. di H dato dall'utente.
!   nlegati=numero di legami
!   nHybcal=codice ibridizzazione calcolata dalla geometria dei legami 
!   nHydcal=no. di H calcolato   (nHydcal=maxleg-nlegati)
!   ibtab(i,1)= ibridizzazione calcolata (ibtab(i,1)=nHybcal*10+nHydcal)
!   nHybut=codice ibridizzazione dato dall'utente via bottone della grafica 
!   nHydut= no.di H da generare dato dall'utente via bottone della grafica
!   ibridiz(i)= ibridizzazione data dall'utente (ibridiz(i)= nHybut*10+nHydut)
!   Vettori utili a la routine di generazione di H. (subroutine gene)
!      ibridc(i) =vettore che contiene il tipo d'ibrid. e il no. di H da generare.
!      numHgen=nz15(i)= n.hydrogeni chiesti dall'utente.Le routine generano (maxleg-nlegati) 
!                    atomi di H, di questi verranno pressi i primi numHgen.
!                               
!                
!                -nlegati-    -nHydcal-           -nHydut-              numHgen
!nz- -ibrid-maxleg-   |  |nHybcal-|-ibtab(i,1)-Hybut-|-ibridiz(i)-ibridc(i)|
!5-6   sp     2       1  |   1    1  -11      | 1    1    11     |  11     1      
!5-6   sp     2       2  |   1    0  -10      | 1    0    10     |  99     0      
!5-6   sp2    3       1  |   2    2  -22      | 2    2    22     |  22     2      
!5-6   sp2    3       2  |   2    1  -21      | 2    1    21     |  21     1      
!5-6   sp2    3       3  |   2    0  -20      | 2    0    20     |  99     0      
!5-6   sp3    4       1  |   3    3  -33      | 3    3    33     |  33     3
!5-6   sp3    4       2  |   3    2  -32      | 3    2    32     |  32     2
!5-6   sp3    4       3  |   3    1  -31      | 3    1    31     |  31     1
!5-6   sp3    4       4  |   3    0  -30      | 3    0    30     |  99     0
!                        |                    |                  |
!  7   sp2   2(3)     1  |   2    1  -21      | 2  n=1,2 21/22   |  22     n
!  7   sp2   2(3)     2  |   2    0  -20      | 2  n=0,1 20/21   | 99/21   n
!  7   sp3   3(4)     1  |   3    2  -32      | 3  n=2,3 32/33   |  33     n
!  7   sp3   3(4)     2  |   3    1  -31      | 3  n=1,2 31/32   |  32     n
!  7   sp3   3(4)     3  |   3    0  -30      | 3  n=0,1 30/31   | 99/31   n
!                        |                    |                  |
!  8   O=C    1       1  |   4    0  -40      | 4    0    40     |  99     0
!  8   O-H    2       1  |   5    1  -51      | 5    1    51     |  33     1
!  8   OH2    3       1  !   6    2  -62      | 6    2    62     |  33     2 
!  non generare          |   9    0  -99      | 9    0    99     |  99     0
!
!----
!
!      subroutine HybriBase
!calcola la ibridizzazione calcolata (ibtab(i,1)) per tutti gli atomi C,O,N e B non isolati.
!-- per tutti ibtab(i,1)=-99 non genera H (ngH)
!-- ibtab(i,1)=-(codice ibridiz.*10+no.H da generare)
!
!      subroutine Hyauto :
! Genera gli H in funzione di ibridc() e numHgen=nz15()
!1)definisce ibridc(1:nats) in funzione di:      
!         - ibridiz(1:nats)  ibridizzazione data dall'utente
!         - ibtab(1:nats,1)  ibridizzazione calcolata
!  per N e O  solo se ibridiz  e' definita ibridc=ibridiz altrimenti ibridc=99
!  per C      se ibridiz e' non definita ibridc=ibtab

!2) genera gli H  (call gene)
!      - setta i vettori Sir: (call Mcopy)
!      Serial(nn)=nnserial
!      JSingleColor(nn)=cp(1)   singlePlotType(nn)=singlePlotType(nordC)   
!      xyLab(1,nn)=0.0
!      xyLab(2,nn)=0.0
!      ibridiz(nn)=0            ibridiz. data dall'utente
!      iGeomAtom(nn)=nordC      geometric code>0/=0 generato da Genhy/non
!      nOpEq(nn)=1555             !store(mx+55)= xshuttle(10000)  
!      iEqui(nn)=nn               !store(mx+56)= xshuttle(n)         
!      nz(nn)=1*nzconst           !solo H vedere per altre specie  
!      RS(nn)=RS(nordC) 
!      nzo(nn) = numHgen     ! utile a Dritan, numero di H generati all nn-esimo atomo
!
!    - crea la lista 5 e la salva su disco   (call frm05)
!
!_______________________________________________________________________________
!
!AUTOMATIC    Genera  gli H di TUTTI i C e B e SOLO quegli di N e O definiti previamente 
!             dall'utente  attraverso wizard o single.
!
!      subroutine autohydro()
!          iauto=1
!          ionly =0
!          call HydroBase(ier)
!          if(ier.eq.0)call Hyauto(ier,iauto)
!
!_______________________________________________________________________________!
!
!WIZARD       Genera  gli H degli O e N che l'utente definisce e gli H di TUTTI i C e B.
!             Non genera quegli che l'utente define come "non generare"
!
!      subroutine init_becca_punti (iCod)               (spec2006.f)
!      if (iQualeBecca.eq.26) then        ! hydrogens wizard
!          call UpdateCommonAndList5(ier)
!          call StringiLabel()
!          call HydroBase(ierr)
!          iQualeBecca = 0
!      endif
!
! mostra la lista degli atomi, ogni volta che seleziono una riga 
!      open_singlehydro (refine_sir.cc) 
!          init_hydro  
!              geometriac   
!
!quando premo "Accept" (sul singolo elemento della lista)
!      finish_hydro  
!          ffinish_hydro   
!              opportuna  
!
!e ritorna a ciclare da open_singlehydro
!
!Quando sono arrivata all'ultimo elemento della lista oppure premo "Stop"
!
!chiede se voglio generare gli idrogeni. Qualunque sia la risposta 
!       call generaidrogeni  
!se va tutto bene e la risposta era si'
!       call hyauto 
!
!_______________________________________________________________________________
!
!SINGLE Genera  gli H dell' atomo scelto dall'utente 
!
!      subroutine init_becca_punti (iCod)
!      if (iQualeBecca.eq.25) then        ! mouse click in hydrogens
!          nTp = 6
!          call UpdateCommonAndList5(ier)
!          call StringiLabel()
!          iautoHy=0
!          call HydroBase(ierr)
!          ifHydrobase = 1
!      endif
!
!quando scelgo l'atomo
!     open_singlehydro   
!         init_hydro  
!              geometriac   
!
!quando premo "Accept"
!     finish_hydro  
!          ffinish_hydro  
!              opportuna 
!              hyauto 
!_______________________________________________________________________________________
!
!Colloquio con la grafica:
!
!      subroutine geometriac(nord,nHybcal,nHydcal,nHybut,nHydut,nlegati
!     ,legequi,nordleg,dstleg,angleg,disthydro)
!
!-- Passa alla grafica i valori  per:
!-- nHybcal,nHydcal,nHybut,nHydut :vedere Tabella 1 (linea 34)
!-- nlegati: n. atomi legati
!-- nordleg(1:4) :n.d'ordine degli atomi legati a nord
!-- se nordleg(i)<0 : iequi=1 , atomo equivalente al nordleg(i)
!-- dstleg(1:4)  :dist. di legame dei nordleg
!-- angleg(i,1:3): angoli <i - nord - i+1>.....<i - nord -nlegati>
!
!
!      subroutine opportuna(nord,nlegati,nHybut,nHydut,ierr)
!
!-- si riprende la informazione contenuta in nhyb, data dall'utente 
!     (botton accetta) e la conserva, insieme al n. di H, in ibridiz(nord)
!-- controlla il no. di H dato dall'utente
!--  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine SirHydro(ier)
      return
      end
!code for CaosHydro
      subroutine CaosHydro(ier)
      return
      end
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!code for HydroBase
      subroutine HydroBase(ier) 
!----call nleg(kelim=0) :crea la connettivita includendo i legami con gli atomi equivalenti
!----call HybriBase :analizza la ibrid. che storizza in ibridc
!
      USE General
      USE Atomi
      USE HydroStuff
      USE Molcom
      USE BuildModule
!
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      common/baco/natssym,nOalone,icis,kveriH
!
      character*8 iwatch
      data iwatch/'h o n c '/
      read(iwatch,'(4a2)')nameh,nameo,namen,namec
!--
      MaxAtomsH=MaxAtoms
      iaction=1
      call allocaHydroStuff(iaction)
!
!      write(lo,*)' inizia Hydrobase iautoHy= ',iautoHy
      ierr=0
!--control nats< 3000
      ifWarn=0
      if(nats.ge.3000)then
      ifWarn=1
      Msg=' '
      write(Msg,11)
      call MsgWinErr('Warning',Msg,WARN_WINDOW,iExitC)
      ifWarn=0
      ier=-1
11    format(' Not enough room to add H-atoms')
      return
      endif
!--set the input parameters for sir **
      nameHy=nameh     !ex ipa1
      nserialH=1.          !initial serial number for H  (ex ipa2)
      distch=0.96
      distchdefa=0.96
!--icis=-1 default per 33 staggered configuration con 1o legame
      icis=-1
      ggwd=xgg9
      grwd=xgr9
*     gdist(1:9)=ggwd(1:9)
*     gdist(10:18)=grwd(1:9)
      rvol=volume
      scale=1.0
!-- definisce il numero massimo di legami per ogni tipo di ibridiz.
      maxlegHyb(1)=2      
      maxlegHyb(2)=3      
      maxlegHyb(3)=4      
      maxlegHyb(4)=1      
      maxlegHyb(5)=2      
      maxlegHyb(6)=3      
!-- 
      kveriH=0       !kveriH>0 no. di H non generati da genhy
      do i=1,Nats
         nzt=iabs(nz(i))/nzconst
         if (nzt == 19) then    ! gianluca 21/01/2011
             nzTot(i) = 1
             nz30(i)  = 1
         else
             nztot(i)=nzt     !no.d'ord. della specie chimica dell'i-esimo atomo
             nz30(i)=no(nzt)  !no.atomico dell'i-esimo atomo
         endif
         if (nz30(i) == 1)then   !ci sono H non generati da genhy???
!     iGeomAtom(i)=1     !da togliere solo per .mdl vecchi 06nov09
!       write(lo,*)'H i,iGeomAtom(i) ',i,iGeomAtom(i)
         if(iGeomAtom(i).le.0)kveriH=kveriH+1
         endif
      enddo
!-- controlla se esiste la conn.
      nco=iconn(1)
      if(nco.le.0)then
      write(lo,*)' Missing connectivity '
      ierr=1
      return
      endif
!--decompatta ibridiz , lascia la ibridizazione in ibridiz e salva distch in chdist(i)
      ibrid = 0
      do i=1,nats
      kz=nz30(i)
        if(kz.ge.5.and.kz.le.8)then
           chdist(i)=distch
           iax=ibridiz(i)
           if(iax.gt.199999)ibridiz(i)=99
           if(ibridiz(i).gt.99)then
           iax=ibridiz(i)
           idst=iax/100
           if(idst.gt.0)chdist(i)=float(idst)/1000
           ibrid=iax-idst*100
           ibridiz(i)=ibrid
           endif
!          write(ncwu,'(a,i5,i18,f6.3,i10,f20.3)')
!     1      'hydrobase,i,ibridizcomp,chdist,ibrid ',i,iax,chdist(i),ibrid
        endif
      enddo
!--azzera flag 'atomo selezionato'
      jFlagAtom(1:Nats)=0
1111   format (6(3i4))
!--save the connectivity in jconn
      jconn(:)=iconn(:)
!--crea la connettivita includendo i legami con gli atomi equivalenti
      call nLeg
!--crea le matrice ibtab-hibtab e il vettore ibridgl
      call HybriBase
!--stampa gli atomi disordinati (geometria non buona)
      ia=0
      if(ia.ne.0)then
        if(jdisor.gt.0.and.kstamwar.eq.1)then
        Msg= '  '
        write(Msg,9020)jdisor
 9020   format(' Warning : distance too short for',i3,'  atom(s)')
          write(lo,'(a)')Msg
        ifWarm=1 
        call MsgWinErr('Warning',Msg,WARN_WINDOW,iExitC)
        ifWarm=0
        endif
       endif
      return
      end
!
!code for HybriBase
      subroutine HybriBase
!   
      USE General
      USE HydroStuff
      USE Atomi
      USE Molcom
      USE BuildModule
!
!--crea ibtab-hibtab e ibridgl 
!--ibtab(nord,1)   = code of hybridization and number of h to be generated
!--                   for the main atom (nord)(-99=no h to generate,
!--                   if carbon atom:-33,-32,-31,-21,-11 
!--                   if oxigen atom:-30 chetonic ,-31 alcoholic, -32 H2O 
!--ibtab(nord,2)   = number of bonded atoms
!--ibtab(nord,3)   = type of bonded atoms (1=b,2=c,3=n,4=o,5=x)
!--ibtab(nord,4)  = planarity of the main atom(0=planar,1=no,-1=undefined)
!--ibtab(nord,5)  = hybridization of the main atom(1=sp1,2=sp2,3=sp3,0=?)
!--ibtab(nord,6)  = hybridization of the bonded atoms
!--                   (0=x,1=csp1,2=csp2,3=csp3,2=(o=),3=(-0-))
!--ibtab(nord,7-10)  = n.order of the bonded atoms
!--hibtab(nord,1-4) = distances to the bond atoms
!--hibtab(nord,5-10)= angles between the main atom and the bond atoms
!-- ibridgl(i)=ibridiz(i)(utente), se ibridiz(i)=0 ibridgl(i)=ibtab(i,1)(calcolati)
!
      common/baco/natssym,nOalone,icis,kveriH
!
      dimension names(4),xx(3),yy(3),itype2(1)
      dimension d(4,3),d2(3),sss(3),d3(3),ileg(9)
      dimension jshort(8),jlong(8)
      character*8 jshort,jlong
      character*14 iwatch
      data iwatch/'b c n o h qh  '/
      read(iwatch,'(7a2)')names,nameh,nameqh,namebla
!
      nn = 0 
      ibridc=0
      ibridgl=0
      hibtab(:,:)=0.0
      ibtab(:,:)=0
      nshort=0
      nlong=0
      jlong(1:8)=' '
      jshort(1:8)=' '
      loop_1: do i=1,nats
        modello=0
        nlegh=0
        nord=0
        ileg=0
        d(:,:)=0.
        ibtab(i,1)=-99
        if(nz30(i).lt.5.or.nz30(i).gt.8)cycle
        legan=lconlun(2,i)
        if(lconlun(1,i).le.0.or.legan.le.0.or.legan.gt.4)cycle
        nord=i
        xx(1:3)=xyzs(1:3,nord)
        somangle=0.
        anglemed=0.
        maddlegati=7
        kz=nz30(i)
        chdist(i)=distch
        if(kz.eq.8)then    !-- O atom 
           if(legan.eq.0)then
!!!!!            call oxigen_contact(nord)  !genera gli H deli O isolati
             ibtab(nord,1)=-99
             cycle loop_1
           else if(legan.eq.1)then
             nord1=lconlun(3,nord)
             if(nord1.gt.0)then   !e' un atomo della lista
               yy(1:3)=xyzs(1:3,nord1)
               kzz=nz30(nord1)  
             else if(nord1.lt.0)then ! e' un equivalente      
               nnn=-nord1
               nordori=xyz15(5,nnn)
               kzz=nz30(nordori)
               yy(1:3)=xyz15(1:3,nnn)
             endif
             d2(1:3)=yy(1:3)-xx(1:3)
             call reddst(d2,sss)
             dis=cdist(gdist,d2,dist2)
             ibtab(nord,1)=-40  !ossigeno chetonico
             if(kzz.eq.6)then 
               ibtab(nord,1)=-51  !ossigeno alcoolico
               if(dis.lt.1.42)ibtab(nord,1)=-40 !ossigeno chetonico
             else if(kzz.gt.18)then
               ibtab(nord,1)=-62 !se legato a un "metallico" e' H2O
             endif
           else if(legan.gt.1)then
             ibtab(nord,1)=-99
             cycle loop_1
           endif
        else if(kz.eq.5.or.kz.eq.7)then    !b or n atom 
          if(kz.eq.5)then    ! boron atom:  ibridizzazione sp3
            nclass=3             
            nlegt=nclass+1
            nhy=nlegt-legan
          else if(kz.eq.7)then    ! N atom 
            nlegt=3
            nclass=3
            nhy=nlegt-legan
          endif
          ibtab(nord,1)=-(nclass*10+nhy)
        endif
!-- non genera H agli atomi disordinati
        if(jdisor.gt.0)then
          do ij=1,jdisor
            if(idisorder(ij).eq.i)then
              ibtab(nord,1)=-99
              cycle loop_1
            endif
          enddo
        endif
        ibtab(nord,2)=legan
!-- hibtab 1-4 positions (distances) 
        do  j=1,legan
          nord1=lconlun(2+j,nord)
          ileg(j)=nord1
          if(nord1.gt.0)then   !e' un atomo della lista
            yy(1:3)=xyzs(1:3,nord1)
            kzz=nz30(nord1)  
          else if(nord1.lt.0)then ! e' un equivalente      
            nnn=-nord1
            nordori=xyz15(5,nnn)
            kzz=nz30(nordori)
            yy(1:3)=xyz15(1:3,nnn)
          endif
          d2(1:3)=yy(1:3)-xx(1:3)
          call reddst(d2,sss)
          dis=cdist(gdist,d2,dist2)
          hibtab(nord,j)=dis
          d(j,1:3)=d2(1:3)
!-- 3rd position
          nn=kzz-4
          if(nn.gt.4)nn=5
          if(nn.eq.-3)then
            nn=0
            nlegh=nlegh+1
          endif
          ibtab(nord,3)=ibtab(nord,3)+nn*(10**(j-1))
!--ibtab 7-10 positions  (n.ord. dei legati)
          ibtab(nord,maddlegati)=ileg(j)
          maddlegati=maddlegati+1
        enddo
!        write(lo,*)'HybriBase i,legan,nlegh',i,legan,nlegh
!        write(lo,*)'1222,i,ibtab(i,1:10),hibtab(i,1-4) ',i,
!        1(ibtab(i,mmm),mmm=1,10),(hibtab(i,mm),mm=1,4)
1222    format(a,11i4,5x,4f10.3)
!--hibtab 5-10 position (angles)
           if(legan.gt.1)then
             somangle=0.
             anglemed=0.
             jangl=5
             do  ij=1,legan-1
               do  j=ij+1,legan
                 do k=1,3
                   d2(k)=d(ij,k)
                   d3(k)=d(j,k)
                 enddo
                 call ang(d2,d3,angle)
                 deno=hibtab(nord,ij)*hibtab(nord,j)
!                write(lo,*)' ij,j,angle,deno',ij,j,angle,deno
                 if(deno.le.1.0e-35)deno=1.0e-5
                 angle=angle/deno
                 angle1=angle
                 if(angle.gt.1.and.angle.le.1.1)angle=1.0
                 if(angle.lt.-1.and.angle.ge.-1.1)angle=-1.0
!                write(lo,*)'rtod,angle ',rtod,angle
                 angle=acos(angle)*rtod
!                write(lo,*)'angle ',angle
                 if(angle.lt.40)then
                   kx=iabs(ibtab(nord,1))
                   ibtab(nord,1)=-99
                   cycle loop_1
                 endif
                 hibtab(nord,jangl)=angle
                 somangle=somangle+angle
!                write(lo,*)'angle,somangle ',angle,somangle
                 jangl=jangl+1
               enddo
             enddo
             anglemed=somangle/(jangl-5)
!      write(lo,1281)i,(ibtab(i,j1),j1=1,3),(hibtab(i,j2),j2=1,10),
!     1(ibtab(i,j3),j3=4,6)
!      write(lo,*)'i,hibtab(i,5-10) ',i,(hibtab(i,mm),mm=5,10)
           endif
!-- planarity(14th),hybridization(15th)
           ibtab(nord,4)=-1
           if(kz.eq.6)then
!--only C atom
             dmaxcc=1.80
             if(modello.eq.1)then
               dmaxcc=0.
               do im=1,legan
                 if(hibtab(i,im+6).ge.dmaxcc)dmaxcc=hibtab(i,im+6)
               enddo
             endif
!            write(lo,*)'i,legan,dmaxcc,kz',i,legan,dmaxcc,kz
             if(legan.eq.1)call c1leg(nord,dmaxcc)
             if(legan.eq.2)call c2leg(nord,dmaxcc)
             if(legan.eq.3)call c3leg(nord,dmaxcc)
             if(legan.eq.4)call c4leg(nord)
           else if(kz.eq.7)then  
!--only N atom
             if(anglemed.ge.115)then
               ibtab(nord,4)=0     !planar
               ibtab(nord,1)=-(20+2-legan)
               if(legan.ge.2)ibtab(nord,1)=-20
             else if(anglemed.lt.115)then
               ibtab(nord,4)= 1   !tetraedrico
               ibtab(nord,1)=-(30+3-legan)
               if(legan.ge.3)ibtab(nord,1)=-30
             endif
           endif
!      write(lo,1281)i,(ibtab(i,j1),j1=1,3),(hibtab(i,j2),j2=1,10)
!     1(ibtab(i,j3),j3=4,6)
!-- crea ibridgl
      ibridgl(nord)=iabs(ibtab(nord,1))/10*10+ibridiz(nord)/10
!--
      enddo loop_1
      kpri=0
      if(kpri.eq.0)then
      write(lo,*)'HybriBase ibtab ibridc ,nz30,ibridgl'
      do j=1,nats
      kz=nz30(j)
      write(lo,'(i5,i3,3i7,/,6x,4f8.3,/6x,6f8.3,/6x,3i7,6i4,3i7)')
     1j,kz,(ibtab(j,j1),j1=1,3),(hibtab(j,j2),j2=1,10),
     1(ibtab(j,j3),j3=4,10),ibridc(j),nz30(j),ibridgl(j)
      enddo
      endif 
!      
      do j=1,nats
      kz=nz30(j)
      HydroInfo(j)%nlegati=ibtab(j,2)
      if(HydroInfo(j)%nlegati.gt.0.and.HydroInfo(j)%nlegati.lt.5)then
         HydroInfo(j)%ibcal=iabs(ibtab(j,1))
         HydroInfo(j)%nHybcal=iabs(ibtab(j,1))/10
         HydroInfo(j)%nHydcal=HydroInfo(j)%ibcal-HydroInfo(j)%nHybcal*10
         if(HydroInfo(j)%nHybcal.eq.9)HydroInfo(j)%nHydcal=0
         HydroInfo(j)%nHybut=ibridiz(j)/10
         HydroInfo(j)%nHydut=ibridiz(j)-HydroInfo(j)%nHybut*10
         if(HydroInfo(j)%nHybut.eq.9)HydroInfo(j)%nHydut=0
         HydroInfo(j)%lab=Lab(j) // char(0)
      endif
      enddo
      return
      end
!
!code for nLeg
      subroutine nLeg
!--determinate the  number of bond of each atom
!
      USE General
      USE HydroStuff
      USE Atomi
      USE BuildModule
!
      common/baco/natssym,nOalone,icis,kveriH
!
      character*4 iwatch
      data iwatch/'qhh '/
      read(iwatch,'(2a2)')nqh,nh
!
!--crea la tabella di connet. lunga, per tutti gli atomi  con passo 12
!
!      call LongCon  !sara' sostituita da: call longconnNEW(0) mercedes 03mar10
      call longconnNEW(0)
!
!--Aggiunge gli atomi legati attraverso op. di symm.
!
!      call ConecSym !sara' sostituita da: call ConecSym1New(1,1) mercedes 03mar10
      call ConecSym1New(1,1)
!
!-- non Aggiunge i "legami per contatti" agli atomi di O isolati (H2O)
!      if(nOalone.gt.0)call oxigen_contact
!--mette gli h in coda ai legami di ogni atomo   
!
      do j=1,Nats
      nhyold(j)=0  !nhyold(j)=(nord del primo H legato al j-esimo atomo)*10+no.di H
      nhyd=0
      m0=lconlun(1,j) 
      if(m0.ne.0) then
        legan=lconlun(2,j) !no. di legami
        if(legan.gt.0)then
!            write(lo,'(a,4i6,2x,a2,2x,a2)')
!     1        'j,jj,legan',j,jj,legan
          iHelim=1
          do while (iHelim.eq.1)
          iHelim=0
          jjf=legan-nhyd
            do  jj=1,jjf
            m=lconlun(2+jj,j) !m no. d'ordine degli atomi legati
              if(m.gt.0)then  !m<0 sono atomi equiv. quindi non H
                kkz=nz30(m)
                if(kkz.eq.1.and.iGeomAtom(m).gt.0)then !iGeomAtom(i)=nordC  generato da genhy
                  nhyd=nhyd+1
                  if(nhyd.eq.1)nhyold(j)=m*10   !nhyold(j)=(nord del primo H)*10+no.di H
                  if(jj.lt.legan)then
                     do kk=jj+1,legan
                     lconlun(2+kk-1,j)=lconlun(2+kk,j)
                     enddo
                  endif
                  iHelim=1   
                  lconlun(2+legan,j)=m
                  lconlun(1:12,m)=0     !elimina gli H da lconlun
                  exit
                endif
              endif
            enddo
          enddo
          nhyold(j)=nhyold(j)+nhyd
          lconlun(2,j)=legan-nhyd  
        endif
      endif
      enddo
!-- trova il  serial number iniziale per gli H (1+s.n. degli H 'non da genhy'?????) 
!-- geometric code  =0/>0, non/generato da genhy
      snmax=0
      do i=1,Nats
      kkz=nz30(i)
!23giu09      if(kkz.eq.1.and.iGeomAtom(i).eq.0)then
      if(kkz.eq.1)then
      if(snmax.lt.serial(i))snmax=serial(i)
      endif
      enddo
      nserialH=snmax+1  
!--stampa la conn. lunga
      kpri=1
      if(kpri.eq.0)then
      write(lo,*)'nLeg  connettivita lunga'
      do   j=1,Nats
      write(lo,'(i4,5x,12i7)')j,lconlun(1:12,j)
      enddo
      write(lo,*)'nLeg nhyold'
      write(lo,'(8(2i4,2x))') (ii,nhyold(ii),ii=1,Nats)
      endif
      return                     
      end
!
!code for c1leg
      subroutine c1leg(nord,dmaxcc)
      USE HydroStuff
      USE General
      USE Atomi
      USE Molcom
      USE BuildModule
!
!--atom with one bond.
!
!--ibtab(nord,2)   = number of bonded atoms
!--ibtab(nord,3)   = type of bonded atoms (1=b,2=c,3=n,4=o,5=x)
!--ibtab(nord,4)  = planarity of the main atom(0=planar,1=no,-1=undefined)
!--ibtab(nord,5)  = hybridization of the main atom(1=sp1,2=sp2,3=sp3,0=?)
!--ibtab(nord,6)  = hybridization of the bonded atoms
!--                   (0=x,1=csp1,2=csp2,3=csp3,2=(o=),3=(-0-))
!--ibtab(nord,7-10)  = n.order of the bonded atoms
!      i=nord
!     write(lo,1289)i,(ibtab(i,j1),j1=1,3),(hibtab(i,j2),j2=1,6),
!    1(ibtab(i,j3),j3=4,6)
!1289  format('c1leg',i6,3i7,4f8.3,/,6x,6f8.3,4i7)
!--warning distance too short
       nn=ibtab(nord,7)
       if(nn.lt.0)nn=xyz15(5,-nn)
       mg1=nztot(nord)
       mg2=nztot(nn)
       dmini=BondTable(1,mg1,mg2)
       dmaxi=BondTable(2,mg1,mg2)
!       if(hibtab(nord,1).lt.1.08)then
!       ibtab(nord,1)=-99
!       ibtab(nord,5)=-1
!       return
!       endif
!--warning distance too long 
!      write(lo,*)'c1leg nord,hibtab(nord,4) ',nord,hibtab(nord,4)
!       if(hibtab(nord,1).gt.dmaxcc.and.ibtab(nord,3).eq.2)then
!       ibtab(nord,1)=-99
!       ibtab(nord,5)=-2
!       return
!       endif
!-- if it is bonded to O or P,S etc. change the range
!      write(lo,*)'c1leg nord,ibtab(nord,3) ',nord,ibtab(nord,3)
!        dmini=1.45
!        dmini=1.40
!        dmaxi=1.60
!        if(ibtab(nord,3).gt.4)then
!        dmini=1.35
!        dmaxi=3.98
!        endif
!--sp3 atom
!      if((ibtab(nord,5).eq.3.or.ibtab(nord,5).eq.0).and.
!     1 (ibtab(nord,6).eq.3.or.ibtab(nord,6).eq.0.or.
!     1 (ibtab(nord,6).eq.2.and.ibtab(nord,3).ne.4)).and.
!     1 (hibtab(nord,1).gt.dmini.and.hibtab(nord,1).lt.dmaxi))then 
      jcond1=0
      jcond2=0
      if((ibtab(nord,5).eq.3.or.ibtab(nord,5).eq.0).and.
     1 (ibtab(nord,6).eq.3.or.ibtab(nord,6).eq.0))jcond1=1
       if((ibtab(nord,6).eq.2.and.ibtab(nord,3).ne.4).and.
     1 (hibtab(nord,1).gt.dmini.and.hibtab(nord,1).lt.dmaxi))jcond2=1
      if(jcond1.eq.1.or.jcond2.eq.2)then 
         if(ibtab(nord,1).le.0)ibtab(nord,1)=-33
         ibtab(nord,4)=1
                if(ibtab(nord,3).eq.2)then
                  ibtab(nord,6)=2
                  if(hibtab(nord,4).gt.1.43)ibtab(nord,6)=3
                endif
         return
      endif
!--sp2 atom bonds to a sp2 with short distance.
!      write(lo,*)'2 legan,kangl ',legan,kangl
       if((ibtab(nord,5).eq.2.or.ibtab(nord,5).eq.0).and.
     1     ibtab(nord,6).eq.2.or.
     1     hibtab(nord,1).gt.1.00.and.hibtab(nord,1).le.dmini)then
!--bonded to c atom
          if(ibtab(nord,3).eq.2)then
            if(ibtab(nord,6).le.0)ibtab(nord,6)=2
            if(ibtab(nord,1).le.0)ibtab(nord,1)=-22
            ibtab(nord,4)=0
            ibtab(nord,5)=2
          endif
!--bonded to b or n atom
          if(ibtab(nord,3).le.1.or.ibtab(nord,3).eq.3)then
            if(ibtab(nord,6).le.0)ibtab(nord,6)=3
            if(ibtab(nord,1).le.0)ibtab(nord,1)=-33
            ibtab(nord,4)=1
            ibtab(nord,5)=2
          endif
!--bonded to o atom
          if(ibtab(nord,3).eq.4)then
            if(ibtab(nord,6).le.0)ibtab(nord,6)=2
            if(ibtab(nord,1).le.0)ibtab(nord,1)=-22
            ibtab(nord,4)=1
            ibtab(nord,5)=2
          endif
      endif
!--sp1 atom.
      if((ibtab(nord,5).eq.1.or.ibtab(nord,5).eq.0).and.             
     1   ibtab(nord,6).eq.1.or.
     1   (hibtab(nord,4).le.1.23.and.ibtab(nord,3).ne.4))then
         if(ibtab(nord,6).le.0)ibtab(nord,6)=1
         if(ibtab(nord,1).le.0)ibtab(nord,1)=-11
         ibtab(nord,4)=0
         ibtab(nord,5)=1
      endif
1     format(5x,4a2,' Too short bond. Distance =  ',f6.3)
111   format(' Too short bond. Distance =  ',f6.3)
1000  continue
      return
      end
!
!code for c2leg
      subroutine c2leg(nord,dmaxcc)
      USE HydroStuff
      USE BuildModule
!
!----atom with two bonds.
      ia=0
      if(ia.ne.0)then
!--warning distance too short
        do i =1,2
          if(hibtab(nord,i).lt.1.08)then
            ibtab(nord,1)=-99
            ibtab(nord,5)=-1
            return
          endif
        enddo
!--warning distance too long 
        do i =1,2
          if(hibtab(nord,i).gt.dmaxcc.and.ibtab(nord,3).eq.22)then
            ibtab(nord,1)=-99
            ibtab(nord,5)=-2
            return
          endif
        enddo
      endif
!
!--sp1 atom. 
      kangl=0
      somangle=hibtab(nord,5)
!--
      ii=ibtab(nord,3)
      nt=2
      ityp1=ii-10*(ii/10)
      if(ityp1.eq.5)then
        ityp1=0
        nt=nt-1
      else if(ityp1.lt.5)then
        ityp1=1
      endif
      ityp2=ii/10
      if(ityp2.eq.5)then
        ityp2=0
        nt=nt-1
      else if(ityp2.lt.5)then
        ityp2=1
      endif
!      write(lo,*)' ii,ityp1,ityp2,nt ',ii,ityp1,ityp2,nt
      if(nt.le.0)return
      if(nt.gt.0)
     1 somdis=(ityp1*hibtab(nord,1)+ityp2*hibtab(nord,2))/nt
      if(hibtab(nord,5).gt.116..or.somdis.lt.1.45)kangl=1
      if((ibtab(nord,5).eq.1.or.ibtab(nord,5).eq.0).and.
     1     abs(somangle-180.).le.10.)then
!--27lug09             if(ibtab(nord,1).le.0)ibtab(nord,1)=-99
             if(ibtab(nord,1).le.0)ibtab(nord,1)=-10
           ibtab(nord,4)=0
           if(ibtab(nord,5).le.0)ibtab(nord,5)=1
      endif
!--sp2 atom. 
!      write(lo,*)'5 legan,kangl ',legan,kangl
      if((ibtab(nord,5).eq.2.or.ibtab(nord,5).eq.0).and.
     1     (ibtab(nord,6).eq.32.or.ibtab(nord,6).eq.23.or.
     2     ibtab(nord,6).eq.22).or.kangl.eq.1)then
!      write(lo,*)'1 sp2 legan,5),6),1),kangl',legan,ibtab(nord,5)
!     1 ,ibtab(nord,6),ibtab(nord,1),kangl
           if(ibtab(nord,1).le.0)ibtab(nord,1)=-21
           ibtab(nord,4)=0
           if(ibtab(nord,5).eq.0)ibtab(nord,5)=2
!      write(lo,*)'2 sp2 legan,5),6),1) ',legan,ibtab(nord,5),
!     1ibtab(nord,1),ibtab(nord,1)
      endif
!--sp3 atom. 
!      write(lo,*)'6 legan,kangl ',legan,kangl
      if((ibtab(nord,5).eq.3.or.ibtab(nord,5).eq.0).and.
     1     (ibtab(nord,6).eq.33.or.ibtab(nord,6).eq.32.or.
     2     ibtab(nord,6).eq.23.or.ibtab(nord,6).eq.22).or.
     3     kangl.eq.0)then
!      write(lo,*)'1 sp3 legan,5),6),1) ',legan,ibtab(nord,5),
!     1ibtab(nord,6),ibtab(nord,1)
           if(ibtab(nord,1).le.0)ibtab(nord,1)=-32
           ibtab(nord,4)=1
           if(ibtab(nord,5).le.0)ibtab(nord,5)=3
!      write(lo,*)'2 sp3 legan,5),6),1) ',legan,ibtab(nord,5),
!     1ibtab(nord,6),ibtab(nord,1)
      endif
      return
      end
!
!code for c3leg
      subroutine c3leg(nord,dmaxcc)
      USE HydroStuff
      USE BuildModule
!
!----atom with three bonds.
      ia=0
      if(ia.ne.0)then
!--warning distance too short
        do i =1,3
          if(hibtab(nord,i).lt.1.08)then
            ibtab(nord,1)=-99
            ibtab(nord,5)=-1
            return
          endif
        enddo
!--warning distance too long 
        do i =1,3
          if(hibtab(nord,i).gt.dmaxcc.and.ibtab(nord,3).eq.222)then
            ibtab(nord,1)=-99
            ibtab(nord,5)=-2
            return
          endif
        enddo
      endif
!
!--sp2 atom (planar).
      somangle=hibtab(nord,5)+hibtab(nord,6)+hibtab(nord,7)
      if(abs(somangle-360.).le.10.)then
!--27lug09         if(ibtab(nord,1).le.0)ibtab(nord,1)=-99
         if(ibtab(nord,1).le.0)ibtab(nord,1)=-20
         ibtab(nord,4)=0
         if(ibtab(nord,5).ne.2)ibtab(nord,5)=2
      else
!--sp3 atom (no planar).
         if(ibtab(nord,5).eq.3.or.ibtab(nord,1).le.0)then
            ibtab(nord,1)=-31
            ibtab(nord,4)=1
            if(ibtab(nord,5).le.0)ibtab(nord,5)=3
         endif
      endif
      return
      end
!
!code for c4leg
      subroutine c4leg(nord)
      USE HydroStuff
      USE BuildModule
!
!--atom with four bonds.
!--quaternary sp3 atom.
      if(ibtab(nord,5).eq.3.or.
!--27lug09     1ibtab(nord,1).le.0)ibtab(nord,1)=-99
     1ibtab(nord,1).le.0)ibtab(nord,1)=-30
      ibtab(nord,4)=1
      if(ibtab(nord,5).le.0)ibtab(nord,5)=3
      return
      end
!
!code for geometriac
      subroutine geometriac(nord,nHybcal,nHydcal,nHybut,nHydut,nlegati
     1,legequi,nordleg,dstleg,angleg,disthydro)
!
      USE General
      USE HydroStuff
      USE Atomi
      USE BuildModule
!
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      dimension nordleg(4),legequi(4),dstleg(4),angleg(4,4),yy(3),sss(3)

!-- Passa alla grafica i valori calcolati per:
!-- nHybcal : ibridizzazione calcolata 
!-- nHydcal : n. di H calcolato 
!-- nHybut = ibridiz. dall'utente  (ibridz(natom))
!-- nHydut = num. di H dall'utente (ibridz(natom))
!-- valori di nHybcal:  per C e B :1=sp1    (ibtab(i,1)=-11,-10)
!                                  2=sp2    (ibtab(i,1)=-21,-22,-20)
!                                  3=sp3    (ibtab(i,1)=-31,-32,-33,-30)
!                       per N     :2=sp2    (ibtab(i,1)=-20,-21)
!                                  3=sp3    (ibtab(i,1)=-30,-31,-32)
!                       per O     :4=chet.g.(ibtab(i,1)=-40)
!                                  5=alc.g. (ibtab(i,1)=-51)
!                                  6=w.m.   (ibtab(i,1)=-62)
!                       per tutti :9=ngH    (ibtab(i,1)=-99)
!-- nlegati: n. atomi legati
!-- nordleg(1:4) :n.d'ordine degli atomi legati a nord
!-- se nordleg(i)<0 : iequi=1 , atomo equivalente al nordleg(i)
!-- dstleg(1:4)  :dist. di legame dei nordleg
!-- angleg(i,1:3): angoli <i - nord - i+1>.....<i - nord -nlegati>
!-- disthydro  : distanza alla quale generare gli H
!
      disthydro=chdist(nord)
      kz=nz30(nord)
!      write(lo,*)'Geometriac Nord,kz,chdist(nord) ',nord,kz,chdist(nord)
      nlegati=ibtab(nord,2)
      if(nlegati.gt.0.and.nlegati.lt.5)then
         ibcal=iabs(ibtab(nord,1))
         nHybcal=iabs(ibtab(nord,1))/10
         nHydcal=ibcal-nHybcal*10
         if(nHybcal.eq.9)nHydcal=0
         nHybut=ibridiz(nord)/10
         nHydut=ibridiz(nord)-nHybut*10
         if(nHybut.eq.9)nHydut=0   
!       write(lo,*)
!     1' Geometriac Nord,kz,nHybcal,nHydcal,nHybut,nHydut '
!     1,nord,kz,nHybcal,nHydcal,nHybut,nHydut
        j00=0
        nordleg(1:4)=0
        dstleg(1:4)=0.
        legequi(1:4)=0
        angleg(:,:)=0.
        do i=1,nlegati
          nordi=ibtab(nord,6+i)
          nordleg(i)=nordi
          dstleg(i)=hibtab(nord,i)
          if(nordi.lt.0)then
          legequi(i)=1
          nn=iabs(nordi)
          nordi=xyz15(5,nn)
          nordleg(i)=nordi   !bisogna avvisare che e' un equivalente!!!!
          yy(1:3)=xyz15(1:3,nn)-xyzs(1:3,nord)
          call reddst(yy,sss)
          dstleg(i)=cdist(gdist,yy,dist2)
          endif
          if(nlegati.gt.1)then
            i00=5
            do j=1,nlegati
              if(i.lt.j)then
                angleg(i,j)=hibtab(nord,i00+j00)
                j00=j00+1
              else if(i.eq.j)then 
                angleg(i,j)=0.0
              else if(i.gt.j)then 
                angleg(i,j)=angleg(j,i)
              endif
            enddo
          endif
        enddo
!-- stampe
        kpri=0
        if(kpri.eq.1)then
        write(lo,*)
     1' Geometriac Nord,kz,nHybcal,nHydcal,nHybut,nHydut '
     1,nord,kz,nHybcal,nHydcal,nHybut,nHydut
          write(lo,'(a,4i8)')'nordleg',nordleg
          write(lo,'(a,4f8.3)')'dstleg',dstleg
          do i=1,nlegati
            write(lo,'(a,4f8.3)')'angleg',(angleg(i,j),j=1,nlegati)
          enddo
        endif
      endif
      return
      end
!
!code for opportuna     
      subroutine opportuna(nord,nlegati,nHybut,nHydut,ierr)
      USE General
      USE Atomi
      USE HydroStuff
      USE Molcom
      USE BuildModule
!
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
!
!
!-- si riprende la informazione contenuta in nHybut e nHydut (ibrid.e n.di H) data dall'utente 
!   attraverso il botton accetta e la conserva in ibridiz(nord)
!--controlla che nHydut sia .le. che il numero massimo di H compatibile con nHybut
!-- nlegati=no. di legami del atomo
!-- nHybut= ibridizzazione data dallutente
!
!-- nHybut=9 per tutte le specie implica ibridiz(nord)=99,ibridc(nord)=99,numHgen=0(0 H da gener)
!-- e setta :
!   jFlagAtom(i) flag che indica che la ibrid. e' stata accettata dal'utente  
!  (serve anche quando l'ibridizzazione accettata non prevede la generazione di H,
!   in questo caso deve accertarsi che eventuali H generati previamente vengano cancellati RS(i)<0) 
!--  
!        write(lo,'(a,4i5,f8.3)')
!     1  'opportuna nord,nlegati,nHybut,nHydut',
!     1   nord,nlegati,nHybut,nHydut
      if(nHybut.eq.9)then
        ibridiz(nord)=99
      else if(nHybut.le.6)then
        kz=nz30(nord)
!--controlla che nHydut sia compatibili con nHybut
           maxnumH=maxlegHyb(nHybut)-ibtab(nord,2)  
           if(nHydut.gt.maxnumH)then
             ierr=1
             return
           endif   
           ibridiz(nord)=nHybut*10+nHydut
        jFlagAtom(nord)=1
        chdist(nord)=distch
!        write(lo,'(a,a,4i5,f8.3)')
!     1  'opportuna',
!     1  ' nord,ibridc(nord),ibridiz(nord),jFlagAtom(nord),chdist(nord)',
!     1  nord,ibridc(nord),ibridiz(nord),jFlagAtom(nord),chdist(nord)
!
        mhy=nhyold(nord)
        nnh=mod(mhy,10)
        if(nnh.gt.0)then
          if(nHydut.ge.0.and.nHydut.ne.nnh)then
!--elimina gli h 
            norc=nord
            norh=mhy/10
            numh=nnh
!-- eliminargli da nhyold , xyzs e iconn
!          write(lo,*)' opportuna elimina gli H di norc,   numh,norh '
!     1     ,norc,numh,norh
            do j=1,numh
!            do norh=nord1,nord2
              call via_vecchioH(norc,norh)
            enddo
          endif
          iaa=0
           if(iaa.ne.0)then
             ia=iconn(1)*3+1     
             write(lo,*)' opportuna eliminati H iconn(1) ',iconn(1)
             write(lo,'(5(3i5,2x))')iconn(2:ia)
           write(lo,'(a,i6)')'i alab(i),xyzs(1:3,i),RS(i),nz(i),nhyold '
            do i=1,nats
            write(lo,'(i5,a,4f8.3,i7)')i,alab(i),xyzs(1:3,i),RS(i),nz(i)
            enddo
           endif
        endif
      endif
!
!      write(lo,*)' opportuna nord,ibridc(nord),chdist(nord)'
!     1,nord,ibridc(nord),chdist(nord) 
!      write(lo,*)' opportuna ibridc ',(ibridc(i),i=1,n5)
!     1,nord,ibridc(nord),chdist(nord) 
      return
      end
!
!code for via_vecchioH   
      subroutine via_vecchioH(norC,norH)
!
      USE General
      USE HydroStuff
      USE Atomi
      USE Molcom
      USE BuildModule
!
!      write(lo,'(a,4i5)')
!     1'via_vecchioH norc,norh,iconn(1) ',norc,norh,iconn(1) 
      iconx=3*iconn(1)-1
      iconf=3*iconn(1)+1
      ncop=0
      do i=2,iconx,3
         ncop=ncop+1
         if(iconn(i).eq.norc.and.iconn(i+1).eq.norh)then
!      write(lo,'(a,5i5)')
!     1 'via_vecH ncop,i,iconn(i:i+2) ',ncop,i,iconn(i:i+2)
           if(ncop.lt.iconn(1))then
              i0=i
              do k=i0,iconx+3
                iconn(k)=iconn(k+3) 
              enddo
           endif
           iconn(1)=iconn(1)-1
!             write(lo,*)' via_veccH dopo eliminaiconn(1) ',iconn(1)
             ia=iconn(1)*3+1     
!             write(lo,'(5(3i5,2x))')iconn(2:ia)
           exit
         endif
      enddo
!
      iconx=3*iconn(1)+1
      iconn(iconx+1:iconx+3)=0
      do k=2,iconx,3
        if(iconn(k).gt.norh)iconn(k)=iconn(k)-1
        if(iconn(k+1).gt.norh)iconn(k+1)=iconn(k+1)-1
      enddo
!             write(lo,*)' via_veccH finale iconn(1) ',iconn(1)
!             write(lo,'(5(3i5,2x))')iconn(2:iconx+3)
!-- aggiorna nhyold
      nn=nhyold(norc)/10  !nhyold(j)=(nord del primo H)*10+no.di H
      num=nhyold(norc)-nn*10
      if(nn.eq.norh)then
        if(num.eq.1)then
          nhyold(norc)=0
        endif
        if(num.gt.1)nhyold(norc)=nhyold(norc)-1
      elseif(nn.lt.norh)then
        nhyold(norc)=nhyold(norc)-1
      endif
      do k=1,nats
        if(nhyold(k).gt.0.and.k.ne.norc)then      
          nn=nhyold(k)/10  
          if(nn.gt.norh)nhyold(k)=nhyold(k)-10
        endif
      enddo
!      write(lo,*)' via_veccH dopo H finale nhyold ',nhyold(1:nats-1)
!
      nats=nats-1
!      write(lo,*)' via_veccH dopo H aggiorna nats ',nats
      if(norh.eq.nats+1)return
      do k=norh,nats
        kk=k+1
        xyzs(1:5,k)=xyzs(1:5,kk)
        bfac(k)=bfac(kk)                
        Serial(k)=Serial(kk)
        JSingleColor(k)=JSingleColor(kk) 
        singlePlotType(k)=singlePlotType(kk)  
        ibridiz(k)=ibridiz(kk)            
        iGeomAtom(k)=iGeomAtom(kk)
        nOpEq(k)=nOpEq(kk) 
        iEqui(k)=iEqui(kk)             
        nz(k)=nz(kk)
        RS(k)=RS(kk) 
        aLab(k)=aLab(kk)
        ipixLab(1,k) = ipixLab(1,kk)
        ipixLab(2,k) = ipixLab(2,kk)
      enddo
      return
      end
!---------------------------------------------------------------------
!
!code for HyAuto   
      subroutine HyAuto(ierr,iautoHy)
!--main subroutine for automatic hydrogen generation
!----call gene :genera gli H
!
      USE General
      USE HydroStuff
      USE Atomi
      USE Molcom
      USE BuildModule
!
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      common/baco/natssym,nOalone,icis,kveriH
!
      write(lo,'(a,a)')' --------------------------------------',
     1 '----------------------------------------' 
      write(lo,1031)
1031  format(/, ' Procedure for the Generation of Hydrogen Atom(s)')
!
      ibridc(1:nats)=99
      nz15(1:nats)=0
      if(iautoHy.ge.0)then   !iautoHy=0 Wizard;iautoHy=1 Auto
        ini=1
        ifin=nats   
          do nord=ini,ifin
            kz=nz30(nord)
            if(kz.le.6)jFlagAtom(nord)=1
          enddo 
      else if(iautoHy.lt.0)then   !iabs(iautoHy)=nord    Single
        nn=iabs(iautoHy) 
        ini=nn
        ifin=nn
!trova il no.d'ordine per gli H
         do nord=1,nats
            kz=nz30(nord)
            if(kz.eq.1)nserialH=max(nserialH,serial(nord)+1)
         enddo 
      endif 
      do nord=ini,ifin
         kz=nz30(nord)
         ibridc(nord)=ibridiz(nord)
         if(ibridc(nord).eq.0.and.jFlagAtom(nord).eq.1)
     1      ibridc(nord)=iabs(ibtab(nord,1))
         if(ibridc(nord).eq.99)cycle
         if(ibridc(nord).gt.0)then
           nHyb=ibridc(nord)/10
           nHyd=ibridc(nord)-nHyb*10
           if(nHyd.eq.0)then
             ibridc(nord)=99
             cycle
           endif
           nz15(nord)=nHyd   !numHgen
           maxnumH=maxlegHyb(nHyb)-ibtab(nord,2)
!-- controlla il no. di H dato dall'utente         
           if(nHyd.gt.maxnumH)then
              ierr=nord
              return
!-- redefinisce ibridc congruentemente con le routine di generazione di H         
           else if(nHyd.lt.maxnumH)then
              ibridc(nord)=nHyb*10+maxnumH
           endif
           if(ibridc(nord).gt.50)ibridc(nord)=33   !O atom 51 alcoholic,62 water
         endif
            j=nord
!            write(lo,'(a,6i6)')
!     1 'HyAuto prima gene j,kz,nz15(j),ibridc(j),ibtab(j,1),ibridiz(j) '
!     1    ,j,kz,nz15(j),ibridc(j),ibtab(j,1),ibridiz(j)
      enddo
      nohy=0
      do j=1,nats
         if(ibridc(j).gt.33.or.ibridc(j).eq.0)nohy=nohy+1
      enddo
!      write(lo,'(a,i9,10i5)')'nohy,ibridc(1:n5)',noHy
!      write(lo,'(10i5)')ibridc(1:n5)
      if(nohy.eq.nats)then
         Inte = 'Automatic Hydrogens procedure'
         Msg = 'No atoms suitable for H geometrical calculation'
         call MsgWinErr(Inte, Msg, ERR_WINDOW, nExitCode)
         return
      endif
      call gene
!--crea la connettivita' per la grafica
      Numleg=iconn(1)
      do i=1,Numleg
         ii=3*i-1
         Le(1:3,i)=iconn(ii:ii+2)
!         write(lo,'(a,4i5)')'i,Le(1:3,i)',i,Le(1:3,i)    
      enddo
!
      kpri=1
      if(kpri.eq.0)then
         write(lo,'(a)')'i,alab(i),xyzs(1:3,i),RS(i),nz(i)'
         do i=1,nats
           write(lo,'(i5,a,4f8.3,i7)')i,alab(i),xyzs(1:3,i),RS(i),nz(i)
         enddo
      do i=1,Numleg
         write(lo,'(a,4i5)')'i,Le(1:3,i)',i,Le(1:3,i)    
      enddo
      endif
      RSsav(1:nats) = RS(1:nats)   ! gianluca 22/06/2009
      leggi=0
      call tomolplo3(leggi)
      aa = MinVal(RSsav(1:nats))       ! gianluca 22/06/2009
      if (aa < 0.0) then               ! gianluca 22/06/2009
          do i=1, nats                 ! gianluca 22/06/2009
             RS(i) = RSsav(i)          ! gianluca 22/06/2009
             if (RS(i) < -19.9) then   ! gianluca 22/06/2009
                 nz(i) = 0             ! gianluca 22/06/2009
             endif                     ! gianluca 22/06/2009
          enddo                        ! gianluca 22/06/2009
      endif                            ! gianluca 22/06/2009

!-- salva il modello
      call PutModel
!
      write(lo,'(a,a)')' --------------------------------------',
     1 '----------------------------------------' 
!      write(lo,1030)
      return
      end
!
!code for gene
      subroutine gene
!--genera gli h
!
      USE General
      USE Atomi
      USE HydroStuff
      USE Molcom
      USE BuildModule                
!
!
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      common/baco/natssym,nOalone,icis,kveriH
      dimension norh(4)
      character*4 iwatch
      data iwatch/'qhh '/
      read(iwatch,'(2a2)')nqh,nameh
!
!       write(lo,*)'(Gene) ibtab ibridc,nhyold'
!      do j=1,Nats
!      write(lo,1281)j,(ibtab(j,j1),j1=1,3),(hibtab(j,j2),j2=1,10),
!     1(ibtab(j,j3),j3=4,6),(ibtab(j,j4),j4=7,10),ibridc(j),nhyold(j)
!      enddo
!1281  format(i6,3i7,/,6x,4f8.3,/,6x,6f8.3,/,6x,3i7,/,6x,6i10,2i10)
!      write(lo,*)'(Gene) iconn, iconn(1)=',iconn(1)
!      nn=iconn(1)
!      do j=2,nn,3
!      write(lo,'(i5,3i4)')j,iconn(j:j+2)
!      enddo
!
      ier=0
      iup=1
      Natsapp=Nats+1
      Natsori=Nats
      newSerial=nserialH
      modello=0
      if(nameHy.ne.nameh)modello=1
      nconh=1
      nhtot=0
      nhydt=0
!
      loop_1: do  i=1,Nats
        kz=nz30(i)
        jz=0
        if(ibridc(i).eq.0.or.iabs(ibridc(i)).gt.97)cycle
        if(lconlun(1,i).eq.0)cycle
        if(lconlun(1,i).lt.0.and.kz.ne.8)cycle
        legan=lconlun(2,i)
!        write(lo,*)' gene,i,legan,ibridc(i)',i,legan,ibridc(i)
!--    
        numHgen=nz15(i)
        nclass=ibridc(i)/10
        nhy=ibridc(i)-10*nclass
!--
        nserialHH=nserialH
        nordHold=nhyold(i)/10   !nhyold(j)=(nord del primo H)*10+no.di H
        numHold=nhyold(i)-nordHold*10
        nhydt=nhydt+numHold
        newHnord=Nats+1
        newSerial=nserialH
        if(nordHold.gt.0)newSerial=Serial(nordHold)
        isosth=0
        if(numHgen.gt.0.and.numHgen.le.numHold)then
          newHnord=nordHold
          newserial=serial(nordHold)
          isosth=1
        endif
!       write(lo,'(a,7i5)')
!     1'i,isosth,nordHold,numHold,newHnord,newserial,nserialH '
!     1    ,i,isosth,nordHold,numHold,newHnord,newserial,nserialH
!--copia l'at.principale
!        write(lo,*) 
!     1  'i,ibridiz(i),ibridc(i),numHgen ',i,ibridiz(i),ibridc(i),numHgen 
        nhyd=nhy
        xtmp(:,:)=0.
        xtmph(:,:)=0.
        nty=0
        if(kz.ge.5.and.kz.le.8)nty=1
        if(nty.le.0.and.modello.eq.0)cycle
        occu=xyzs(5,i)             
        nordC=i
        xtmp(1:3,1)=xyzs(1:3,i)    !      call copat
        xtmp(5,  1)= i  !mi porto dietro il nord dell'atomo principale 
        dhy=chdist(i)
!        write(lo,'(a,2i3,5f8.3)')
!     1  'atprin.i,nordC,xtmp ',i,nordC,xtmp(1:5,1)
        if(nclass.eq.3)then
!-- sp3   
           if(nhy.le.2)then
!-- 31 o 32
             kf=6-nhy
             do k=3,kf
               nord2=lconlun(k,i)
               if(nord2.eq.0)cycle loop_1
               nn2=iabs(nord2)
               if(RS(nn2).le.0)cycle loop_1
               if(nord2.gt.0)then
                 xtmp(1:3,k-1)=xyzs(1:3,nord2)
               else if(nord2.lt.0)then
                 nord2=-nord2
                 xtmp(1:3,k-1)=xyz15(1:3,nord2)
               endif
!              write(lo,*)'2do atomo (k) nord2 ',k,nord2
!              write(lo,'(a,i3,5f8.3)')'primi vic.,k,nord2,xtmp '
!     1        ,k-1,nord2,xtmp(1:5,k-1)
!               if(nord2.eq.0)cycle loop_1
             enddo  
             if(nhy.eq.1)call ch31
             if(nhy.eq.2)call ch32
             if(ier.eq.-1)then
                return
             endif
             if(iup.eq.1)then
               if(isosth.eq.0)then   !include i nuovi legami in iconn
                  indi=3*iconn(1)+2
                  do kkk=1,numHgen
                    iconn(indi)=nordC
                    iconn(indi+1)= newHnord-1+kkk
                    iconn(indi+2)=1
!                    write(lo,*)'mcopy indi, nhy, iconn(indi:indi+2)',
!     1              indi, nhy, iconn(indi:indi+2)
                    indi=indi+3
                  enddo
                  iconn(1)=iconn(1)+numHgen
               endif
               call mcopy(newHnord,newserial,occu)
               if(nordHold.gt.0)nSerialH=nSerialHH
             endif
!             go to 999
!            
           else if(nhy.eq.3)then
!-- 33      
               nord2=lconlun(3,i)     !secondo atomo
               if(nord2.gt.0)then
                 xtmp(1:3,2)=xyzs(1:3,nord2)
!        write(lo,'(a,i3,5f8.3)')'primo vic.,k,xtmp ',k-1,xtmp(1:5,2)
               else if(nord2.lt.0)then
                 ifWarn=1
                 write(Msg,22)aLab(i)
                 call MsgWinErr('Warning',Msg,WARN_WINDOW,iExitC)
               endif
               if(nord2.le.0)cycle loop_1
               nclass1=ibridc(nord2)/10    !nclass1=ibridc(mm2)/10
!-- terzo atomo (legato al 2do.)
               nn3=3
               legan22=lconlun(2,nord2)     
               do kk=3,2+legan22
                 nord22=lconlun(kk,nord2)     !   mm2=kshuttle(mcon22+kk)
                 if(nord22.gt.0)then
                   if(nord22.eq.i.or.RS(nord22).le.0)cycle
                   xtmp(1:3,nn3)=xyzs(1:3,nord22)
                 else if(nord22.lt.0)then
                   nord22=-nord22             !      mm5=-mm2
                   xtmp(1:3,nn3)=xyz15(1:3,nord22)
                   xtmp(5,nn3)= xyz15(5,nord22) !mi porto dietro il nord dell'atomo 
                 endif 
!                write(lo,'(a,2i3,5f8.3)')'3zo at,nn3,nord22,xtmp '
!     1          ,nn3,nord22,xtmp(1:5,nn3)
!                write(lo,*)'3zo atomo (nord2) nord22 ',nord2,nord22
                 if(nord22.eq.0)cycle loop_1  
!--controlla che il terzo non sia colineare con gli altri due
                 ii=0              
                 call controlla_lineari(ii)
                 if(ii.eq.1)then
                   cycle
                 else
                   exit
                 endif    
                 exit
               enddo
               icis1=icis
               if(icis1.eq.1) then
                 if(nclass1.eq.2) icis1=-1
               endif
               call ch33(icis1)
               if(iup.eq.1)then
                 if(isosth.eq.0)then   !include i nuovi legami in iconn
                     indi=3*iconn(1)+2
                     do kkk=1,numHgen
                       iconn(indi)=nordC
                       iconn(indi+1)= newHnord-1+kkk
                       iconn(indi+2)=1
!                       write(lo,*)'indi,numHgen, iconn(indi:indi+2)',
!     1                 indi,numHgen, iconn(indi:indi+2)
                       indi=indi+3
                     enddo
                     iconn(1)=iconn(1)+numHgen
                 endif
                 call mcopy(newHnord,newserial,occu)
                 if(nordHold.gt.0)nSerialH=nSerialHH
               endif
!             go to 999
             endif
!
        else if(nclass.eq.2)then
300       continue
!-- sp2        
!          go to(310,320)nhy
            if(nhy.eq.1)then
310         continue
!-- 21      
              do k=2,3
               nord2=lconlun(k+1,i)     !secondo atomo  mm2=kshuttle(mcon+k)
               if(nord2.gt.0)then
               xtmp(1:3,k)=xyzs(1:3,nord2)
               xtmp(5,k)=nord2
!               write(lo,*)'2do atomo (k) nord2 ',k,nord2
!       write(lo,'(a,i3,5f8.3)')'primo vic.,k,nord2,xtmp '
!     1,k,nord2,xtmp(1:5,k-1)
               else if(nord2.lt.0)then
               nord2=-nord2
               xtmp(1:3,k)=xyz15(1:3,nord2)
               xtmp(5,k)= nord2  !mi porto dietro il nord dell'atomo
               endif 
              enddo
            call ch21
               if(iup.eq.1)then
                  if(isosth.eq.0)then   !include i nuovi legami in iconn
                  indi=3*iconn(1)+2
                     do kkk=1,numHgen
                     iconn(indi)=nordC
                     iconn(indi+1)= newHnord-1+kkk
                     iconn(indi+2)=1
!                  write(lo,*)'mcopy indi,numHgen, iconn(indi:indi+2)',
!     1             indi,numHgen, iconn(indi:indi+2)
                     indi=indi+3
                     enddo
                  iconn(1)=iconn(1)+numHgen
                  endif
               call mcopy(newHnord,newserial,occu)
               if(nordHold.gt.0)nSerialH=nSerialHH
               endif
!            go to 999
320         continue
            else if(nhy.eq.2)then
!-- 22       
               nord2=lconlun(3,i)     !secondo atomo  mm2=kshuttle(mcon+k)
               if(nord2.gt.0)then
               xtmp(1:3,2)=xyzs(1:3,nord2)
               xtmp(5,2)=nord2
!       write(lo,'(a,i3,5f8.3)')'primo vic.,2,nord2,xtmp '
!     1,2,nord2,xtmp(1:5,2)
               else if(nord2.lt.0)then
              ifWarn=1
!              isto=nint(store(m5+5))
!14gen09              write(Msg,33)istore(mm5),isto
              write(Msg,22)aLab(i)
              call MsgWinErr('Warning',Msg,WARN_WINDOW,iExitC)
!              go to 9999
              cycle loop_1
              endif
!-- terzo atomo (legato al 2do.)
            legan22=lconlun(2,nord2)     
              do kk=3,3+legan22
              nn3=3
              nord22=lconlun(kk,nord2)     !   mm2=kshuttle(mcon22+kk)
                if(nord22.gt.0)then
                if(nord22.eq.i)cycle
                xtmp(1:3,nn3)=xyzs(1:3,nord22)
                xtmp(5,nn3)= nord22 !mi porto dietro il nord dell'atomo 
                else if(nord22.lt.0)then
                nord22=-nord22             !      mm5=-mm2
                xtmp(1:3,nn3)=xyz15(1:3,nord22)
                xtmp(5,nn3)= xyz15(5,nord22) !mi porto dietro il nord dell'atomo 
                endif 
!              write(lo,*)'3zo atomo (nord2) nord22 ',nord2,nord22
              if(nord22.eq.0)cycle loop_1  !     if(mm5.le.0)cycle loop_1
!--controlla che il terzo non sia colineale con gli altri due
                   ii=0              
                   call controlla_lineari(ii)
                   if(ii.eq.1)then
                   cycle
                   else
                   exit
                   endif    
              enddo
            call ch22
               if(iup.eq.1)then
                  if(isosth.eq.0)then   !include i nuovi legami in iconn
                  indi=3*iconn(1)+2
                     do kkk=1,numHgen
                     iconn(indi)=nordC
                     iconn(indi+1)= newHnord-1+kkk
                     iconn(indi+2)=1
!                  write(lo,*)'indi,numHgen, iconn(indi:indi+2)',
!     1             indi,numHgen, iconn(indi:indi+2)
                     indi=indi+3
                     enddo
                  iconn(1)=iconn(1)+numHgen
                  endif
               call mcopy(newHnord,newserial,occu)
               if(nordHold.gt.0)nSerialH=nSerialHH
               endif
!            go to 999
            cycle loop_1
            endif
!
        else if(nclass.eq.1)then
!-- sp1    
!-- 11     
          nord2=lconlun(3,i)     !secondo atomo  mm2=kshuttle(mcon+k)
          if(nord2.gt.0)then
             xtmp(1:3,2)=xyzs(1:3,nord2)
             xtmp(5,2)=nord2
!            write(lo,'(a,i3,5f8.3)')'primo vic.,2,nord2,xtmp '
!      1     ,2,nord2,xtmp(1:5,2)
          else if(nord2.lt.0)then
             ifWarn=1
             write(Msg,22)aLab(i)
             call MsgWinErr('Warning',Msg,WARN_WINDOW,iExitC)
             cycle loop_1
          endif
!-- terzo atomo (legato al 2do.)
          legan22=lconlun(2,nord2)     
          do kk=3,3+legan22
            nord22=lconlun(kk,nord2)     !   mm2=kshuttle(mcon22+kk)
            if(nord22.gt.0)then
                if(nord22.eq.i)cycle
                xtmp(1:3,nn3)=xyzs(1:3,nord22)
                xtmp(5,nn3)= nord22 !mi porto dietro il nord dell'atomo 
            else if(nord22.lt.0)then
                nord22=-nord22             !      mm5=-mm2
                xtmp(1:3,nn3)=xyz15(1:3,nord22)
                xtmp(5,nn3)= xyz15(5,nord22) !mi porto dietro il nord dell'atomo 
            endif 
!           write(lo,*)'3zo atomo (nord2) nord22 ',nord2,nord22
            if(nord22.eq.0)cycle loop_1  !     if(mm5.le.0)cycle loop_1
            exit
          enddo
          call ch11
          if(iup.eq.1)then
             if(isosth.eq.0)then   !include i nuovi legami in iconn
                indi=3*iconn(1)+2
                do kkk=1,numHgen   
                  iconn(indi)=nordC   
                  iconn(indi+1)= newHnord-1+kkk
                  iconn(indi+2)=1
!                  write(lo,*)'indi,numHgen, iconn(indi:indi+2)',
!     1             indi,numHgen, iconn(indi:indi+2)
                  indi=indi+3
                enddo
                iconn(1)=iconn(1)+numHgen
             endif
             call mcopy(newHnord,newserial,occu)
             if(nordHold.gt.0)nSerialH=nSerialHH
          endif
        endif
!999     continue
!-- control MaxAtoms
        ifWarn=0
        if(Nats.ge.MaxAtoms)then
          ifWarn=1
          Msg=' '
          write(Msg,1002)
          write(lo,1002)
          call MsgWinErr('Warning',Msg,WARN_WINDOW,iExitC)
          ifWarn=0
1002  format('Not enough room for H-atoms.',
     1  ' Probably error in cell content.Update the content'
     1 ,' and then reload the project') 
          return
        endif
!--
      enddo loop_1
1001  continue
1109  continue
1     format(a2,19f8.3)
10    format(a2,f6.1,18f9.5)
!--
9000  continue
!-- elimina il flag
!      FlagAtom(:)=0      !call sclr5
9030  continue
2     format(' Warning : Atom ',a2,i3,' program can not',
     1 ' generate ethane H atoms.',/) 
22    format(' Warning : Atom ',a8,' program can not',
     1 ' calculate H positions.') 
!22    format(' Warning : Atom ',a2,i3,' program can not',
!     1 ' generate ethane H atoms.') 
3     format(' Warninig : Atom ',a2,i3,' program can not',
     1 ' generate ethylene H atoms.',/) 
33    format(' Warning : Atom ',a2,i3,' program can not',
     1 ' generate ethylene H atoms.') 
4     format(' Warninig : Atom ',a2,i3,' program can not',
     1 ' generate acetylene H atoms.',/) 
44    format(' Warning : Atom ',a2,i3,' program can not',
     1 ' generate acetylene H atoms.') 
      return
      end
!
!code for mcopy
      subroutine mcopy(nn,nnserial,occu)
!
      USE General
      USE Atomi
      USE Molcom
      USE HydroStuff
      USE BuildModule                
!
      character*8 Labbb
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
!--nn nord del primo H
!--nnserial serial number del primo H
!--occu occupazione
!      write(lo,*)'mcopy nats,nn,nnserial ',nats,nn,nnserial
      do i=1,numHgen
      if(nn.gt.nats)nats=nn
      xyzs(1:3,nn)=xtmph(1:3,i)
      xyzs(4,nn)=-1.                  ! altezza picco
      xyzs(5,nn)=occu
      bfac(nn)=bfac(nordC)*1.3                
!
!--inserisco i default
      Serial(nn)=nnserial
!gl!  JSingleColor(nn)=cp(1)       !store(mx+48)= xshuttle(cp(1))       ! 
      JSingleColor(nn)= 1 + N_OBJS !store(mx+48)= xshuttle(cp(1))       ! 
      singlePlotType(nn)=iPlotType !store(mx+54)= 
      xyLab(1,nn)=0.0            !store(mx+52)= 0.0                    ! 
      xyLab(2,nn)=0.0            !store(mx+53)= 0.0                    ! 
      ibridiz(nn)=0              !store(mx+45)= xshuttle(0)            !
      iGeomAtom(nn)=nordC        !store(mx+51)geometric code>0 generato da Genhy
      nOpEq(nn)=1555             !store(mx+55)= xshuttle(10000)        ! 
      iEqui(nn)=nn               !store(\mx+56)= xshuttle(n)            !
      nz(nn)=1*nzconst           !solo H vedere per altre specie      !
      RS(nn)=RS(nordC) 
      nzo(nn) = numHgen     ! utile a Dritan,numero di H generati all nn-esimo atomo
!
      Labbb(1:1)='H'
      write(Labbb(2:6),'(i5)') nnserial
      call NoBlanks(Labbb,lstri)
      aLab(nn)=Labbb(1:lstri)
      fx = LenInPix(Labbb,2)
      fy = FntPixHeight
      ipixLab(1,nn) = ipix(1,nn) - fx / 2.0
      ipixLab(2,nn) = ipix(2,nn) + fy  / 4.0
!
!
      write(lo,'(a,5f8.4,i10)')
     1 aLab(nn),xyzs(1:3,nn),bfac(nn),xyzs(5,nn),Serial(nn)

!     ! stampa per Dritan  nn,nzo(nn)
!      write(lo,'(2i10)')'nn,nzo(nn)',nn,nzo(nn)

      nn=nn+1
      nnserial=nnserial+1
      enddo
      nserialH=nnserial
      return
      end
!
!code for controlla_lineari
      subroutine controlla_lineari(ii)
!
      USE GENERAL, only: lo
!
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
!
!
      dimension x1(3),x2(3),x3(3)
      dimension a(3),b(3),c(3),cr(3)
    
      x1(1:3)=xtmp(1:3,1)
      x2(1:3)=xtmp(1:3,2)
      x3(1:3)=xtmp(1:3,3)
               call vcmp(x1,x2,a)
               call vcmp(x3,x2,b)
               call vpr(ggwd,a,b,cr)
               call mv(grwd,cr,c)
               call ospr(c,cr,q)
!      write(lo,*)'controlla_lineari '
!      write(lo,'(a,3f6.3)')'x1 ',x1
!      write(lo,'(a,3f6.3)')'x2 ',x2
!      write(lo,'(a,3f6.3)')'x3 ',x3
!!      write(lo,'(a,9f8.3)')'ggwd ',ggwd
!!      write(lo,'(a,9f8.3)')'grwd ',grwd
!      write(lo,'(a,12f8.3)')'a,b,cr,q ',a(1:3),b(1:3),cr(1:3),q
               if(abs(q).lt.0.001)ii=1
               return
               end

!
!code for ch31
      subroutine ch31
!
      USE GENERAL, only: lo
!
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      dimension x1(3),x2(3),x3(3),x4(3),y1(3)
!
      character*3 ina
      data ina/'sp3'/
!----
      call hyprt(ina)
      x1(1:3)=xtmp(1:3,1)
      x2(1:3)=xtmp(1:3,2)
      x3(1:3)=xtmp(1:3,3)
      x4(1:3)=xtmp(1:3,4)
      call h31c (x1,x2,x3,x4,y1)
      xtmph(1:3,1)=y1(1:3)
!      write(lo,*)'h y1',y1
      return
      end
!
!code for h31c
      subroutine h31c(x1,x2,x3,x4,y1)
!
!     coordinates generation for a hydrogen atom
!     of a sp3 carbon atom
!
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      dimension x1(3),x2(3),x3(3),x4(3),y1(3)
      dimension x5(3),x6(3),x7(3),x8(3)
!
      call vlen(ggwd,x1,x2,d)
      pk = dhy/d
      call pur(x1,x2,pk,x5)
      call vlen (ggwd,x1,x3,d)
      pk = dhy/d
      call pur(x1,x3,pk,x6)
      call vlen(ggwd,x1,x4,d)
      pk = dhy/d
      call pur(x1,x4,pk,x7)
      x8(1) = (x5(1)+x6(1)+x7(1))/3.
      x8(2) = (x5(2)+x6(2)+x7(2))/3.
      x8(3) = (x5(3)+x6(3)+x7(3))/3.
      call vlen(ggwd,x1,x8,d)
      pk = 1.+dhy/d
      call pur(x8,x1,pk,y1)
      return
      end
!
!code for ch32
      subroutine ch32
!
      dimension x1(3),x2(3),x3(3),x4(3),y1(3),y2(3)
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
!
      character*3 ina
      data ina/'sp3'/
!----
      call hyprt(ina)
      alfg=109.5
      x1(1:3)=xtmp(1:3,1)
      x2(1:3)=xtmp(1:3,2)
      x3(1:3)=xtmp(1:3,3)
      call h32c (x1,x2,x3,y1,y2,alfg)
      xtmph(1:3,1)=y1(1:3)
      if(numHgen.eq.2)xtmph(1:3,2)=y2(1:3)
!deve copiare in xyzs      
      return
      end
!
!code for h32c
      subroutine h32c(x1,x2,x3,y1,y2,alfg)
!
!     coordinates generation for the  two hydrogen
!     of a sp3 carbon atom
!
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      dimension x1(3),x2(3),x3(3)
      dimension y1(3),y2(3)
      dimension x4(3),x5(3),pr(4),p(4),q(3),r(3)
!--
      call bis (ggwd,x1,x2,x3,x4)
      call anamp (ggwd,x1,x2,x3,gam)
      rad = 57.29578
      alfg=109.8
      alfa = alfg/rad
      csalf = cos(alfa/2.)
      csgam = cos(gam/2.)
      pk = (csgam+dhy*csalf)/csgam
      ier=0
      call pur(x4,x1,pk,x5)
      call p3p (x2,x1,x3,ggwd,grwd,pr)
      if(ier.eq.-1)return       !mercedes 27ott08
      call mv(grwd,pr,p)
      call norm(p,pr)
      do i=1,3
      q(i) = x5(i)+p(i)
      r(i) = x5(i)-p(i)
      enddo
      pk = dhy*sin(alfa/2.)
      call pur(x5,r,pk,y1)
      call pur(x5,q,pk,y2)
      return
      end
!
!code for ch33
      subroutine ch33(icis)
!
      USE general
      USE Atomi
      USE BuildModule
!
      dimension x1(3),x2(3),x3(3),x4(3),y1(3),y2(3),y3(3)
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      character*3 ina
      data ina/'sp3'/
!----
      nhyd =numHgen
      if(numHgen.eq.0)nhyd = 3
!      call hyprt(ina)
      write(lo,1000)aLab(nordC),nhyd,ina
1000  format(/,' Atom ',a8,i2,1x,
     1 'H atom(s) calculated in  ',a,' configuration ')
      alfa = 109.5
      x1(1:3)=xtmp(1:3,1)
      x2(1:3)=xtmp(1:3,2)
      x3(1:3)=xtmp(1:3,3)
      call h33c  (x1,x2,x3,y1,y2,y3,alfa,icis)
!      write(lo,'(a,3f6.3)')'y1 ',y1
!      write(lo,'(a,3f6.3)')'y2 ',y2
!      write(lo,'(a,3f6.3)')'y3 ',y3
      if(numHgen.eq.3)then
      xtmph(1:3,1)=y1(1:3)
      xtmph(1:3,2)=y2(1:3)
      xtmph(1:3,3)=y3(1:3)
      else if(numHgen.eq.1)then
      xtmph(1:3,1)=y1(1:3)
!      nhyd=1
      else if(numHgen.eq.2)then
      xtmph(1:3,1)=y1(1:3)
      xtmph(1:3,2)=y2(1:3)
!      nhyd=2
      endif
      return
      end
!
!code for h33c
      subroutine h33c(x1,x2,x3,y1,y2,y3,alfa,icis)
!     coordinates generation for the three hydrogen atoms
!     in trans conformation
!     of a sp3 carbon atom
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      dimension x1(3),x2(3),x3(3)
      dimension y1(3),y2(3),y3(3),w(3)   
!
      alfar=(180.-alfa)*2
      if(numHgen.eq.1) icis=1
      call h22c(x1,x2,x3,y1,w,alfar,icis)
!      write(lo,'(a,3f10.4)')' x1 da h22c',(x1(kk),kk=1,3)
!      write(lo,'(a,3f10.4)')' x2 da h22c',(x2(kk),kk=1,3)
!      write(lo,'(a,3f10.4)')' y1 da h22c',(y1(kk),kk=1,3)
      call h32c(x1,x2,y1,y2,y3,alfa)
!      write(lo,'(a,3f10.4)')' y1 da h32c',(y1(kk),kk=1,3)
!      write(lo,'(a,3f10.4)')' y2 da h32c',(y2(kk),kk=1,3)
!      write(lo,'(a,3f10.4)')' y3 da h32c',(y3(kk),kk=1,3)
      return
      end
!
!code for ch21
      subroutine ch21
!
      USE General
      USE BuildModule
!
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      dimension x1(3),x2(3),x3(3),y1(3)
      character*3 ina
      data ina/'sp2'/
!----
      call hyprt(ina)
      x1(1:3)=xtmp(1:3,1)
      x2(1:3)=xtmp(1:3,2)
      x3(1:3)=xtmp(1:3,3)
      call h21c (x1,x2,x3,y1)
      xtmph(1:3,1)=y1(1:3)
      return
      end
!
!code for h21c                 
      subroutine h21c (x1,x2,x3,y1)
!
!     coordinates generation for a hydrogen atom
!     of a sp2 carbon atom
!
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      dimension x1(3),x2(3),x3(3),x4(3),y1(3)
!
      call anamp (ggwd,x1,x2,x3,gam)
      csgam = cos(gam/2.)
      call bis(ggwd,x1,x2,x3,x4)
      pk = 1.+dhy/csgam
      call pur(x4,x1,pk,y1)
      return
      end
!
!code for ch22
      subroutine ch22
!
      dimension x1(3),x2(3),x3(3),y1(3),y2(3)
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      character*3 ina
      data ina/'sp2'/
!----
      call hyprt(ina)
      x1(1:3)=xtmp(1:3,1)
      x2(1:3)=xtmp(1:3,2)
      x3(1:3)=xtmp(1:3,3)
      alfa=120.
      icis=0
      call h22c (x1,x2,x3,y1,y2,alfa,icis)
      xtmph(1:3,1)=y1(1:3)
      if(numHgen.eq.2)xtmph(1:3,2)=y2(1:3)
      return
      end
!
!code for h22c
      subroutine h22c(x1,x2,x3,y1,y2,alfg,icis)
!
      USE General
!     coordinates generation for the two hydrogen atom
!     of a sp2 hydrogen atom
!
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      dimension x1(3),x2(3),x3(3),x4(3),x5(3),x6(3)
      dimension y1(3),y2(3)
      dimension a(3),b(3),c(3),ar(4),br(4),cr(3)
!--
      rad = 57.29578
      alfa = alfg/rad
      snalfa = sin(alfa/2.)
      csalfa = cos(alfa/2.)
      p = dhy*csalfa
      call vlen(ggwd,x1,x2,d)
      pk = (p+d)/d
      call pur(x2,x1,pk,x4)
      ier=0
      call p3p(x1,x2,x3,ggwd,grwd,ar)
      if(ier.eq.-1)return       !mercedes 27ott08
      if(icis.ge.0) then
      call pnr(x1,x2,x4,ggwd,grwd,br)
      call mv(grwd,ar,a)
      call mv(grwd,br,b)
      call norm (a,ar)
      call norm(b,br)
      call vpr(grwd,ar,br,c)
      call mv(ggwd,c,cr)
      call norm(c,cr)
!      write(lo,*)'%,c:',c
      else
      call mv(grwd,ar,c)
      call norm (c,ar)
!      write(lo,*)'$,c:',c
      endif
      do  i=1,3
      x5(i) = x4(i)+c(i)
      x6(i) = x4(i)-c(i)
      enddo
      pk = dhy*snalfa
      if(icis.eq.0.or.icis.eq.-1) then
      call pur(x4,x5,pk,y1)
      call pur(x4,x6,pk,y2)
      else
      call pur(x4,x6,pk,y1)
      call pur(x4,x5,pk,y2)
      endif
      return
      end
!
!code for ch11
      subroutine ch11
!
      USE General
      USE BuildModule
!
      dimension x1(3),x2(3),y1(3)
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      character*3 ina
      data ina/'sp1'/
!----
      call hyprt(ina)
      x1(1:3)=xtmp(1:3,1)
      x2(1:3)=xtmp(1:3,2)
      call h11c (x1,x2,y1)
      xtmph(1:3,1)=y1(1:3)
      return
      end
!
!code for h11c
      subroutine h11c (x1,x2,y1)
!
!     coordinates generation for a hydrogen atom
!     of a sp carbon atom
!
      dimension x1(3),x2(3),y1(3)
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
!
      call vlen(ggwd,x1,x2,d)
      pk = 1.+dhy/d
      call pur(x2,x1,pk,y1)
      return
      end
!
!code for hyprt
      subroutine hyprt(ix)
      USE Atomi
      USE General
!
!--print heading of h-routine
!
      common/genehy/ggwd(9),grwd(9),nordC,dhy,numHgen
     1,xtmp(5,10),xtmph(5,3),maxlegHyb(6) 
      character*3 ix
      write(lo,1000)aLab(nordC),numHgen,ix
1000  format(/,' Atom ',a8,i2,1x,
     1 'H atom(s) calculated in  ',a,' configuration ')
      return
      end
!
!code for oxigen_contact 
      subroutine oxigen_contact(korde)
      USE General
      USE HydroStuff
*     USE Liste
      USE Atomi
      USE BuildModule
!
!-- nella LongCon agli atomi di OSSIGENO ISOLATI, aggiunge gli atomi 
!-- a distanza di contatto (somma dei van der waals)ordinati in senso crescente
!-- della dist. di legame
!-- nleg=3 : kkz>18 (kk=Metallo ) implica interazione O-Metallo (h all'esterno)        
!-- nleg=4 : kkz<18 (kk=nonmetallo ) implica interazione ponte h con kk  (O all'esterno)        
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/baco/natssym,nOalone,icis,kveriH
      dimension vett(3,4),yx(3,200),x(3),y(3),yy(3),z(3)
     1 ,d(3),d2(3),sss(3),d0(3),orddist(12),norddist(12)
!      data nameh/2hh /
      character*2 iwatch
      data iwatch/'h '/
      read(iwatch,'(a2)')nameh
!    
!      write(lo,*)'inizia oxigen_contact  '
!      write(lo,*)'/lst05/',l5,m5,md5,n5,l5o,m5o,md5o,n5o
!     2 ,l5d,n5d,md5c
!
!      m5sym=l5sym
!      n5sym=0
!      lconfin=l5sym-1
!      e10=1.0e-10
!      call xlat(vett)
!      
      k=korde
!      m51=l5+(k-1)*md5
!      mc1=lcon2+(k-1)*12
!      leg1=kshuttle(mc1+1)
!      leg1=lconlun(2,k)
!      kz= store(m51+26) + 1
!      write(lo,*)'k,kz,radii(kz,2)',k,kz,radii(kz,2)
!      m51x=l5+(k-1)*md5+5
!           do kj=1,3
!           z(kj)=store(m51x+kj)
!           enddo
!!      write(lo,'(a,i5,3f8.3)')'k,z ',k,z
!        do kk=1,n5
!        if(kk.eq.k)cycle
!        m52=l5+(kk-1)*md5
!        mc2=lcon2+(kk-1)*12
!        leg2=kshuttle(mc2+1)
!        kkz= store(m52+26) + 1
!        write(lo,*)'kk,kkz,radii(kkz,2)',kk,kkz,radii(kkz,2)
!        dmax=radii(kz,2)+radii(kkz,2)+0.3
!        write(lo,*)'k,kk,dmax',k,kk,dmax
!            do kj=1,3
!            x(kj)=store(l5+(kk-1)*md5+kj+5)
!            enddo
!        write(lo,'(a,i5,3f8.3)')'kk,x ',kk,x
!        mm0=0
!        m2=l2
!          do i=1,n2
!          y(1)=x(1)*store(m2  )+x(2)*store(m2+1)+x(3)*store(m2+2)
!          y(2)=x(1)*store(m2+3)+x(2)*store(m2+4)+x(3)*store(m2+5)
!          y(3)=x(1)*store(m2+6)+x(2)*store(m2+7)+x(3)*store(m2+8)
!          y(1)=y(1)+store(m2+9)
!          y(2)=y(2)+store(m2+10)
!          y(3)=y(3)+store(m2+11)
!          seg=1.0
!            do ii=1,ic+1
!              do  jj=1,3
!              y(jj)=seg*y(jj)
!              enddo
!            seg=-seg
!!-- gruppi non primitivi
!              do kkk=1,n2p
!                 do  nnn=1,3
!                 yy(nnn)=y(nnn)+vett(nnn,kkk)
!                 enddo
!              mm0=mm0+1
!                     do  n=1,3
!                     yx(n,mm0)=yy(n)
!                     enddo
!                distt=0.
!               if(mm0.gt.1)then
!                  do n=1,mm0-1
!                    do jj=1,3
!                    d2(jj)=yy(jj)-yx(jj,n)
! 2011               continue
!                    if(abs(d2(jj)).le.0.5) cycle
!                    d2(jj)=d2(jj)-sign(1.0,d2(jj))
!                    go to 2011
!                    enddo
!                  distt=g(1)*d2(1)*d2(1)
!     1                 +g(5)*d2(2)*d2(2)
!     2                 +g(9)*d2(3)*d2(3)
!     3                 +g(2)*d2(1)*d2(2)*2.0
!     4                 +g(3)*d2(1)*d2(3)*2.0
!     5                 +g(6)*d2(2)*d2(3)*2.0
!        write(lo,'(a,2i5,3f8.3,2f9.3)')'mm0,n,d2,distt',mm0,n,d2,distt
!                    if(distt.lt.0.1)then
!                    mm0=mm0-1
!                    exit
!                    endif
!                  enddo
!                endif
!              if(mm0.gt.1.and.distt.lt.0.1)cycle
!
!                 do n=1,3
!                 sss(n)=0   
!                 d(n)=z(n)-yy(n)
!1011             continue
!                 d0(1:3)=d(1:3)
!                 if(abs(d(n)).le.0.5)cycle
!                 sss(n)=sign(1.0,d(n))+sss(n)
!                 d(n)=d(n)-sign(1.0,d(n))
!                 go to 1011
!                 enddo
!              distt=g(1)*d(1)*d(1)
!     1             +g(5)*d(2)*d(2)
!     2             +g(9)*d(3)*d(3)
!     3             +g(2)*d(1)*d(2)*2.0
!     4             +g(3)*d(1)*d(3)*2.0
!     5             +g(6)*d(2)*d(3)*2.0
!              if(distt.lt.0.001)cycle
!              dist0=sqrt(distt)
!        write(lo,'(a,2i5,3f8.3,2f10.3)')'k,kk,yy,dmax,dist0'
!     1,k,kk,yy,dmax,dist0
!              if(dist0.gt.dmax)cycle
!!              dmax=dist
!              neq=1
!              if(i.eq.1.and.ii.eq.1.and.kkk.eq.1)then
!              neq=0
!              endif
!              do jneq=1,3
!              if(d(jneq).ne.d0(jneq))neq=neq+1
!              enddo
!1025          continue
!              ist=kshuttle(mc1+1)
!              if(ist.le.10)then
!              store(mc1)=xshuttle(k)
!              store(mc1)=xshuttle(-k)
!              store(mc1+1)=xshuttle(ist+1)
!!              store(mc1+ist+2)=xshuttle(kk)
!                if(neq.gt.0)then
!!                store(mc1+ist+2)=xshuttle(-m5sym)
!                do nnn=1,3
!                if(abs(d(nnn)).lt.e10)d(nnn)=sign(e10,d(nnn))
!                enddo
!                  do nny=1,md5
!                  store(m5sym+nny-1)=store(l5+(kk-1)*md5+nny-1)
!                  enddo
!                    do nyy=1,3
!                    store(m5sym+5+nyy)=yy(nyy)+sss(nyy)
!                    enddo
!                  store(m5sym+17)=xshuttle(kk)
!!      write(lo,'(a,2i8,3f8.3)')'m5sym ,ist,store(m5sym+6:m5sym+8)',
!!     1m5sym ,ist,store(m5sym+6:m5sym+8)
!                endif
!--ordina
!                   if(ist.eq.0)then
!                   norddist(ist+1)=kk
!                   if(neq.gt.0)norddist(ist+1)=-m5sym
!                   orddist(ist+1)=dist0
!                   else if(ist.ge.1)then
!                     do ioi=1,ist
!                     if(dist0.ge.orddist(ioi))cycle
!                     iioo=ioi
!                       do ipi=ist,iioo,-1
!                       norddist(ipi+1)=norddist(ipi)
!                       orddist(ipi+1)=orddist(ipi)
!                       enddo
!                     norddist(iioo)=kk
!                     if(neq.gt.0)norddist(ist+1)=-m5sym
!                     orddist(iioo)=dist0
!                     exit
!                     enddo  
!                   endif
!      write(lo,'(a,12i6)')'norddist',norddist
!      write(lo,'(a,12f8.3)')'orddist',orddist
!              endif
!1028          m5sym=m5sym+md5
!                 if(m5sym.ge.lfl)then
!!                 write(lo,*)'lfl,l5sym',lfl,l5sym
!                 ifWarn=1
!                 Msg=' '
!                 write(Msg,11)
!                 call MsgWinErr('Warning',Msg,WARN_WINDOW,iExitC)
!                 ifWarn=0
!                 ier=-1
!11               format(' Not enough room to add H-atoms'
!     1                 ,' conecsym store overflow')
!                 return
!                 endif
!              n5sym=n5sym+1 
!              enddo
!            enddo
!          m2=m2+md2
!          enddo
!        enddo
!      write(lo,'(a,i6,f6.0)')'ist,store(mc1+1)',ist,store(mc1+1)  
!-- nleg=3 : kkz>18 (kk=Metallo ) implica interazione O-Metallo (h all'esterno)        
!-- nleg=4 : kkz<18 (kk=nonmetallo ) implica interazione ponte h con kk  (O all'esterno)
!      do mm=1,4        
!      store(mc1+1+mm)=xshuttle(norddist(mm))
!      enddo
!      ibtab(k,1)=-33
!      ibtab(k,2)=1
!      store(mc1+1)=xshuttle(1)
!      if(kkz.gt.18)ibtab(k,2)=4   
!      ibtab(k,3)=kkz
!      ibtab(k,7:7)=norddist(1:1)
!      hibtab(k,1:1)=orddist(1:1)
!      ibridc(k)=33
!2000  continue
!1000  continue
!
!      write(lo,*)'LongCon dopo oxigen_contact  ibridc(i)'
!      mc=lcon2
!      do i=1,n5
!      write(lo,'(i3,12i6,i4)')i,(kshuttle(mmmx),mmmx=mc,mc+11)
!     1 ,ibridc(i)
!      mc=mc+12
!      enddo
      return
      end
!
!code for cwrdi
      subroutine cwrdi (mn,nhyd)
      USE General
      USE Atomi
!
      nn = mn
      do ii=1,nhyd
      write(lo,'(a,5f8.4)')aLab(nn),xyzs(1:3,nn),bfac(nn),xyzs(5,nn)
200   format(5x,a2,10f8.3 )
      nn=nn+1
      enddo
      return
      end
!
!___________________________________________________________________________

! Le seguenti spostate da lsqfin2006.f (mr)
!-----------------------------------------------------------------------
      subroutine autohydro()
      USE General
      USE Atomi
      USE Molcom
*     USE Liste
      USE PhaseModule
      USE BuildModule
!
      common/baco/natssym,nOalone,icis,kveriH
!
!-- update common and create list 5
!
      if (InfoOK(5) == 0) then
          call UpdateCommonAndList5(ier)
          if (ier.lt.0) then
              return
          endif
      endif
      if (ifHydrogens() == 0) then
          return
      endif
      ifCarb = ifCarbons()
      if (ifCarb.eq.1) then
          call UpdateCommonAndList5(ier)
          if (ier.lt.0) then
              return
          endif
          iautoHy=1
          ionly =0
          call HydroBase(ier)
          if(ier.eq.0)call HyAuto(ier,iautoHy)
          if (ier.lt.0) then
              return
          endif
          IfScale= 1
!          leggi = 1
!          call toMolPlo3(leggi)
          call RotazTot
          call GetBonds(1)
          call Disegna(ifScale)
          call AggiornaJav()
      endif
      iaction=2
      call AllocaHydroStuff(iaction)
! --
      return
      end
!-----------------------------------------------------------------------
      function ifCarbons()
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
!
      ifCarbons = 0
      do i=1,nk
!        if (no(i).eq.6) then
         if (no(i).ge.6 .and. no(i).le.8) then
            ifCarbons = 1
         endif
      enddo
      if (ifCarbons.eq.1) then
          ifCarbons = 0
          do i=1,nats
             k = iabs(nz(i)) / nzConst
             if (k /= 0. and. k <= 18) then
                 if (no(k).ge.6 .and. no(k).le.8) then
                     ifCarbons = 1
                 endif
             endif
          enddo
          if (ifCarbons.eq.0) then
              Inte = 'Automatic hydrogens generation'
              Msg = 'No carbon/nitrogen/oxygen atoms in the model.' 
     *               // char(10)
     *               // 'It is impossible to generate hydrogens'
              call MsgWinErr(Inte, Msg, WARN_WINDOW, nExitCode)
          endif
      else
          Inte = 'Automatic hydrogens generation'
          Msg = 
     *      'No carbon/nitrogen/oxygen  atoms in the unit cell content.'
     *      // char(10)
     *      // 'It is impossible to generate hydrogens'
          call MsgWinErr(Inte, Msg, WARN_WINDOW, nExitCode)
      endif
! --
      return
! --
      end
!-----------------------------------------------------------------------
      integer function ifHydrogens()
      USE General
      USE Atomi
      USE Molcom
      implicit none
      integer i, nExitCode
!
      ifHydrogens = 0
      do i=1,nk
         if (no(i) == 1) then
            ifHydrogens = 1
         endif
      enddo
      if (ifHydrogens == 0) then
          Msg = 'No hydrogens in unit cell content.'
          call MsgWinErr( 'Hydrogens procedure', Msg,
     *                   ERR_WINDOW, nExitCode)
      endif
! --
      return
! --
      end
!-----------------------------------------------------------------------
!      subroutine ffinish_hydro (natom, nHyb, ifWizard, ier, dist_c_h)
      subroutine ffinish_hydro(natom,nHyb,nHyd,ifWizard,ier,dist_c_h)
      USE General
      USE BuildStuff
      USE HydroStuff
      USE Molcom
      USE Atomi
      USE BuildModule
!
      Integer natom    
      Integer nhyb    
      Integer ifWizard
!
      common/xoppor/nDst
!
      ier = 0
!!mrmrmr220709      distch = dist_ch
      distch = dist_c_h              !!mrmrmr220709
      if (ifWizard.eq.0) then    !single
         itype = 1
         jFlagAtom(natom)=1
!         call opportuna(natom,nDst,nHyb)
         call opportuna(natom,nDst,nHyb,nHyd,ier)
         if(ier.gt.0)return  !ier=1 wrong number of H
         if(ibridiz(natom).ne.99.and.ibridiz(natom).ne.30)then
             iautoHy=-natom
             ionly=1
             icis=-1
             ierr=0
             call HyAuto(ierr,iautoHy)
             ier = ierr
         else
!-- salva la lista 5 su disco
             call PutModel
         endif
         IfScale= 1
         call RotazTot
         call GetBonds(1)
         call Disegna(ifScale)
         call AggiornaJav()
         iaction=2
         call AllocaHydroStuff(iaction)
      else                       !wizard          
!         call opportuna(natom,nDst,nHyb)
         call opportuna(natom,nDst,nHyb,nHyd,ier)!ier=1 wrong number of H

      endif
      return
      end
!-----------------------------------------------------------------------
! Le seguenti spostate da spec2006.f (mr)
!-----------------------------------------------------------------------
      integer function init_hydro(ifWizard,natom,ms,nHyb, dist_c_h)
      USE General
      USE Atomi, only : aLab30
      USE Molcom
      USE HydroStuff
      USE BuildModule
!
      type multistringa2
         character (len = 20)  :: str1
         character (len = 800) :: str2
         integer               :: n1, n2
      end type
      type (multistringa2)     :: ms
      integer natom
      integer nHyb
      integer ifWizard
      real dist_c_h
      common/xoppor/nDst
      dimension vDist(4), jDist(5),legequi(4),angDist(4,4)
      character*16 ilab1(5)
!
      init_hydro = 0
      if (ifHydrogens() == 0) then
          init_hydro = -1
          return
      endif
      if (natom == 0) then
!mr070609          Inte = 'Hydrogens Wizard procedure'
          ms%str2 = 'No atom suitable for Hydrogen Generation'//char(0)
!mr070609          call MsgWinErr(Inte, Msg, ERR_WINDOW, nExitCode)
          init_hydro = -1         !!mr070609
          return
      endif
      ms%str1 = Lab(natom) // char(0)
      dist_c_h = distch
      lLab = 8
!
!-- chiamata alla routine di Mercedes che restituisce:
!    
!           nHybcal = ibridiz. calcolata (ibtab(natom,1))
!           nHydcal = num. di H calcolato (ibtab(natom,1))
!           nHybut = ibridiz. dall'utente  (ibridz(natom))
!           nHydut = num. di H dall'utente (ibridz(natom))
!           nDist = num. di distanze
!           legequi(1:nDist) = vettore atomi equiv. (0=posizione orig./1=equiv)
!           jDist(1:nDist) = vettore atomi coinvolti
!           vDist(1:nDist) = vettore delle distanze
!           disthydro distanza per la generaz. del H.
!           nHybcal e nHybut = 1,2,3,4,5,6 corrisponde a sp,sp2,sp3,O=C,O-H,OH2
!
      nHyb  = 0
      nDist = 0
      LabelHyd(:) = 0
      nLabelHyd = 0
!      call geometriac(natom,nDist,jDist,equiDist,vDist,nHyb,
!     1                 angDist, disthydro)
      call geometriac(natom,nHybcal,nHydcal,nHybut,nHydut,nDist,legequi
     1,jDist,vDist,angDist,disthydro)
!
      dist_c_h = disthydro
      nHyb = nHybcal
!
      if (nDist.gt.0.and.nHyb.gt.0) then
          nDst = nDist
          maxndist = 3                                          !mr
         if(nDst.eq.4)maxndist = 4                              !merc 16nov09
          jDist(nDist+1) = jDist(1)                             !mr
          nLabelHyd = nDist + 1
          j = 1
          LabelHyd(j) = natom
          do i=1, nDist
             j = j + 1
             LabelHyd(j) = jdist(i)
          enddo
          nptrc = 0
          call Disegna(0)
          Buffer1 = ' '
          j = 0
          nriga = 0
          do i=1, maxndist                                  !mr
             if (i.le.nDist) then
                 ilab1(i)=aLab30(jdist(i))
                 if(legequi(i).eq.1)then
                 call shift(ilab1(i),l)
                 l=l+1
                 if(l.gt.lLab)l=lLab
                 ilab1(i)(l:l)='*'
                 endif
!                 Buffer1(j+1:j+30) = aLab30(jdist(i))(1:lLab)
                 Buffer1(j+1:j+30) = ilab1(i)(1:lLab)
     *                            // ' - '
     *                            // aLab30(natom)(1:lLab)
     *                            // ' =        ' // char(10)
                 write(Buffer1(j+23:j+29),'(f7.4)') vDist(i)
                 j = j + 30
                 nriga = nriga + 1
             endif
          enddo
!
! per mantenere la massima lunghezza
!
!          do i=nriga, 3
          do i=nriga, 4                 !merc 16nov09
             Buffer1(j+1:j+1) = char(10)
             j = j + 1
          end do
          nriga = 0
          do i=1, maxndist                                  !mr
             if (i.le.nDist) then
                 do k = i+1, nDist
!                    Buffer1(j+1:j+40) = aLab30(jdist(i))(1:lLab)
                    Buffer1(j+1:j+40) = iLab1(i)(1:lLab)
     *                               // ' - '
     *                               // aLab30(natom)(1:lLab)
     *                               // ' - '
!     *                               // aLab30(jdist(k))(1:lLab)
     *                               // ilab1(k)(1:lLab)
     *                               // ' =       ' // char(10)
                    write(Buffer1(j+34:j+39),'(f6.2)') angdist(i, k)
                    j = j + 40
                    nriga = nriga + 1
                 end do
             endif
          enddo
!
! per mantenere la massima lunghezza
!
!          do i=nriga, 3
          do i=nriga, 6                 !merc 16nov09
             Buffer1(j+1:j+1) = char(10)
             j = j + 1
          end do
!
! per mantenere la massima larghezza
!
          do i=1,39
             Buffer1(j+i:j+i) = ' '
          end do
          j = j + 39
          Buffer1(j+1:j+1) = char(0)
          init_hydro = 0
          ms%str2 = Buffer1
      else
          init_hydro = -1
          ms%str2 = 'Impossible to generate hydrogens for '
     *            // Lab(natom) // char(0)
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine newinfo_hydro(info)
      USE General
      USE Atomi
      USE Molcom
      USE HydroStuff
      USE BuildModule
!
      TYPE(infohydro_type)    :: info(*)
!
!      write(6,*) 'MR At  nlegati ibcal  nHybcal nHydcal nHybut nHydut'
      do j = 1, NatMol
         info(j) = HydroInfo(j)
!         write(6,'(a,6i7)')  HydroInfo(j)%lab(1:Lung(HydroInfo(j)%lab)),
!     1                         HydroInfo(j)%nlegati, HydroInfo(j)%ibcal,
!     1              HydroInfo(j)%nHybcal, HydroInfo(j)%nHydcal,
!     1              HydroInfo(j)%nHybut, HydroInfo(j)%nHydut
      enddo

      return
      end
! ----------------------------------------------------------------------
      subroutine info_hydro(spdef)
      USE General
      USE Atomi
      USE Molcom
      USE HydroStuff
      USE BuildModule
!
      integer spdef(*)
!
!-- gianluca
!!      write(6,*) 'AAA     i   nHybcal nHydcal nHybut  nHydut  nlegati'
!!      do i = 1, NatMol
!!         if(nz30(i).lt.5.or.nz30(i).gt.8)cycle
!!         call geometriac(i, nHybcal,nHydcal,nHybut,nHydut,nlegati
!!     1,                  legequi,nordleg,dstleg,angleg,disthydro)
!!         write(6,'(a,6i8)') 'AAA',i,nHybcal,nHydcal,nHybut,nHydut,nlegati
      write(6,*) 'AAA     i   nlegati, ibcal, nHybcal nHydcal '
      do j = 1, NatMol
         write(6,*) j, HydroInfo(j)%nlegati, HydroInfo(j)%ibcal,
     1              HydroInfo(j)%nHybcal, HydroInfo(j)%nHydcal

      enddo
!-- gianluca
      do natom = 1, NatMol
      It(natmol) = char(0)
      spdef(natom) = 99
      if(nz30(natom).lt.5.or.nz30(natom).gt.8)cycle
         It(natom) = Lab(natom) // char(0)
!        spdef(natom) = ibridgl(natom)
         if(HydroInfo(natom)%nlegati > 0) then
            spdef(natom) = HydroInfo(natom)%ibcal
         endif
      end do
      It(NatMol+1) = char(0)
!
      return
      end
! ----------------------------------------------------------------------
!!mrmrmr220709      integer function finish_hydro (natom, nHyb, ifWizard, dist_c_h)
      integer function finish_hydro (natom, nHyb, nHyd, ifWizard, 
     1                                dist_c_h)
!
      integer natom
      integer nHyb, nHyd
      integer ifWizard
      real dist_c_h
!
!!mrmrmr220709      call ffinish_hydro (natom, nHyb, ifWizard, ier, dist_c_h)
      call ffinish_hydro (natom, nHyb, nHyd, ifWizard, ier, dist_c_h)
      finish_hydro = ier
!
      return
      end
! ----------------------------------------------------------------------
      subroutine generaidrogeni(iCode)
      USE General
      USE BuildStuff
      USE HydroStuff
      USE Atomi
      USE BuildModule
      USE Molcom
!
      integer iCode
      common/baco/natssym,nOalone,icis,kveriH
!
!               iCode = 0    --> Cancel
!               iCode = 1    --> Ok
!
      if (iCode /= 0) then
!-- 13.01.10 deve cancellare tutti gli H generati da programma
!         call eliminaH
          ionly=1
          icis=-1
          ierr=0
          iautoHy=0
          call HyAuto(ierr,iautoHy)
      endif
!
      IfScale= 1
      leggi = 1
      call toMolPlo3(leggi)
! pezza gianluca 16/04/2009 : quando scrive gli idrogeni
! in lista 5 sbaglia il valore di iequi      
      do i=1, nats
         iEqui(i) = i
      enddo
      call RotazTot
      call GetBonds(1)
      call Disegna(ifScale)
      call AggiornaJav()
!
      iaction=2
      call AllocaHydroStuff(iaction)
!
      return
      end
! ----------------------------------------------------------------------
      integer function NoForC(k)
!
      USE General
      USE Atomi
!
      implicit none
      integer i, k
!
      i = iabs(nz(k)) / nzConst
      NoForC = no(i)
!
      return
      end
!-----------------------------------------------------------------------
! Le seguenti spostate da xfin2006.f (mr)
!-----------------------------------------------------------------------
      subroutine DelHydro(iFlagd)
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
      integer iFlagd
!             iFlagd = 1 --> Delete all hydrogens
!             iFlagd = 2 --> Delete only generated hydrogens
!
      nHydro = 0
      if (no(1).eq.1) then
          do i=1,nats
             n = iabs(nz(i)) / nzConst
!             if (n.eq.1) then  !mercedes cosi' deleta anche gli H da fourier o model
             if (n.eq.1.and.iGeomAtom(i).gt.0) then
                 nHydro = nHydro + 1
             endif
          enddo
      endif
!!141110      if (nHydro > 0) then
!!141110              write(Inte,10) nHydro
!!141110              Msg = 'All hydrogens will be deleted'
!!141110              call MsgWinErr(Inte,  Msg, QUEST_WINDOW, nExitCode)
!!141110              if (nExitCode.eq.2) then
!!141110                  return
!!141110              endif
!!141110      else
      if (nHydro <= 0) then
              write(Inte,20)
              Msg = 'No hydrogens to delete'
              call MsgWinErr(Inte, Msg, WARN_WINDOW, nExitCode)
              return
      else
          write(Msg,10) nHydro
          call PrintMess(Msg)
      endif
!
      do i=1,NatMol
         k = iEqui(i)
         if (nzTot(i).eq.1.and.ifHydro.eq.1.and.iGeomAtom(k).gt.0)then
             RS(i) = -20.0
         endif
      enddo
      jrest0 = 0
      call ModCom(jrest0)
      call GetBonds(1)
      IfScale= 1
      call Disegna(ifScale)
      call AggiornaJav()
!
   10 format('Deleted ',i4,'  hydrogens')
   20 format('Deleting hydrogens')
! ---
      return
      end
! ----------------------------------------------------------------------
! ----------------------------------------------------------------------
! 
!                   REFANA
!
! ----------------------------------------------------------------------
!----------------------------------------------------------------------
!
!code for datainmerc
      subroutine datainmerc(formt,nrefp,ier,npq,icomple)
      USE General
      USE Symmetry
      USE Molcom
      USE DataModule
      USE WrReIn
!
      implicit none
      integer :: nrefp, ier, npq, icomple, nsymsav, i, ifStatistic
      character (len=80) :: formt
!
      call scrper(' Reading reflections ',0,-1)
!
      nsymsav = nsym
      nsym = 1
      do i=1,3
         ismat(1,i,1) = i
      enddo

      ifStatistic = 1
      call ReadAllRefl(formt, nrefp, ier, ifStatistic)
      npq = nrefp
      nrefl = nrefp
      rhomax = rhm
      ihmxSav(:) = ihmx(:)
      nsym = nsymsav
!
      return
      end
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!
!code for DetermLaueGr  versione new
      subroutine DetermLaueGr
!
      USE General
      USE Laue
      USE Molcom, only: jscreen
!
      character*20 symbs, lauelcl1     
      common/dummy/reslim,nxxref
      common/probLaEle/numsysEle,RintSys(9,6),ProbSys(9,7),kfin,indprobs
     1,corrfattProb(9),ProbLsav(5),nomonoclino
      common/fordata0/ nsymbo
      common/fordata/ symbs(2000,2),fmerit(2000,2),numerosy(2000,2)
     1,lauelcl1(2000,2)
      dimension nfattpext(10)
      character *18 linnea
!
!-- apre il file dei dettagli ( se in grafica)
!
      if (jscreen > 0) then
          k = index(fname(1),'.bin')
          spgtxt = fname(1)(1:k-1) // '_spg.txt'
          itype = 0
          iform = 1
          jop =jopen(jgrap, spgtxt, itype, iform, ios)
      endif
!
!-- definisce resoluzione limite per accettare i riflessi
      reslim=0.5/sqrt(rhomax)
!      if(neutro.eq.2)reslim=0.9
!      write(lo,*)'reslim ',reslim
!-- determina il sistema cristallino
      noprinta=1
      ifSalta = 0
      call LaueSys(noprinta, ifSalta)
!22ott      ProbL=1.
!-- calcola il numero massimo di riflessi nella semisfera.
      rhom = 2.0 * sqrt(rhomax)
      rad=rhom**3
      volssfer=twopi*rad/3
      hklmassno= volssfer*volume
      percssf=100.*nrefl/hklmassno
      percmin=10.
      if(neutro.ne.2)percmin=50.0
      if(percssf.gt.100.00)percssf=100.00
      write(lo,'(a)')' '
      write(lo,'(2a,f8.2)') 
     1 ' Percentage of the semisphere corrisponding'
      write(lo,'(a,f8.2)') 
     1' to the input reflections given: ',percssf
      write(lo,'(a)')' '
!
      ksubr=1
      call  LeggiRiflessi(ier,ksubr)
!
      icode=1
!
      NumsysEle=1
      kfin=1
      nume=1
      nume2=1
      ProbSys=0.
      fmersg(1:2000)=0.
      nindlacl(1:2000) = 10
!              
        if (neutro == 2) then     ! gianluca 9 ottobre 2014
            percmin = percmin / 2
        endif
        if (percssf.ge.percmin .or. neutro /= 2)then
          if (neutro /= 2) then         !Rx e neutroni
              ProbL(1:5)=0.
              ProbL(1)=1.
              if (msys.ge.4)call DetermTwin(icode)
              if (msys.gt.4.and.msys.ne.8) call DetermLaue(icode)
              call DetermRefana(icode)
          else if (neutro == 2) then    !elettroni
              if (msys.ne.8) call SystemProb(icode)
!
!--definisce  nFattPExt(msys+1) (no. di fatt nella prob del gruppo di estinzione)
!             
!---syst---+msys+1 +--nFatPExt--+--nFatPExt/nFatPExt(mono)-+
!          |       |  (a)   (b)  |  ProbSys(msys+1,7)
!          |       |             |    (a)     (b)
!  romb    |  9    |   3     2   |    3/4      2/3
!  cubico  |  8    |   5     4   |    5/4      4/3
!  esag.   |  7    |   5     4   |    5/4      4/3
!  tet_c   |  6    |   8     7   |    2        7/3
!  ortog   |  5    |   8     7   |    2        7/3
!  monoc   |  4    |   4     3   |    1         1
!  monob   |  3    |   4     3   |    1         1
!  monoa   |  2    |   4     3   |    1         1
!  tricl   |  1    |   0     0   |    0         0
!
!--a) considera il termine Problaue
!              nFattPExt(1)=0
!              nFattPExt(2:4)=4
!              nFattPExt(5:6)=8
!              nFattPExt(7:8)=5
!              nFattPExt(9)=3
!--b)non considera il termine Problaue
              nFattPExt(1)=0
              nFattPExt(2:4)=3
              nFattPExt(5:6)=7
              nFattPExt(7:8)=4
              nFattPExt(9)=2
              corrfatt=1.
!              PLaueMx=-1.
              if (knw > 0) then
                  write(lo,*)'dopo SystemProb '
                  write(lo,'(a)')'  ' 
                  write(lo,'(a)')'  ' 
               endif
!              write(lo,'(a)')
!     1        ' Ricerca della scala tra ProbLaue e ProbExt ' 
!              write(lo,'(a,a)')'  A=2**nFat,  CorrFatt=A/nFat,  ' 
!              write(lo,'(a)')'  ' 
!              write(lo,'(21x,a)')' nFat  Rint   ProbL     A    CorrFat' 
!
               if(numsysEle.eq.1)then
                 numin=1
                 kfin0=0
               else
                 ik=0
                 jok=0
                 do while (jok==0)
                   ik=ik+1
                   if(ProbSys(ik,6).le.0.0)then
                     jok=0
                     cycle
                   endif  
                   do i=1,5
                     if(probsys(ik,i).gt.0.)jok=1
                   enddo
                 enddo
               numin=ik
               kfin0=ik-1
               endif
!           write(lo,*)'numin,kfin,numsysEle',numin,kfin,numsysEle

!25apr11              do ik=1,numsysEle
!              numin=2
!              if(numsysEle.eq.1)numin=1
              do ik=numsysEle,numin,-1
                 mm=nint(ProbSys(ik,6))    !mm=msys ,ik=msys+1
                 if(mm.le.0)cycle
!
!                 y=2.0                                       
!                 aa=y**nFattPExt(mm+1)
!                 corrfatt=aa/nFattPExt(mm+1)   
!                 ProbSys(ik,7)=corrfatt
!
!02mag11                 ProbSys(ik,7)=1./(nFattPExt(mm+1)+1)  !definisco l'exponenz.
                 ProbSys(ik,7)=1./(nFattPExt(mm+1)+1)  !definisco l'exponenz.
         if (knw > 0)
     *   write(lo,'(a,i5,7f8.3)')'ik,ProbSys(ik,1:7)',ik,ProbSys(ik,1:7)
                 if(mm.eq.1)linnea=   ' Monoc. a'
                 if(mm.eq.2)linnea=   ' Monoc. b'
                 if(mm.eq.3)linnea=   ' Monoc. c'
                 if(mm.eq.4)linnea=   ' Ortor.  '
                 do i=1,5
                    ProbLsav(i)=ProbSys(ik,i)
                    if(ProbSys(ik,i).lt.0.01)cycle
                    if(mm.eq.5.and.i.eq.1)linnea=   ' Tetrag c 4/m   '
                    if(mm.eq.5.and.i.eq.2)linnea=   ' Tetrag c 4/mm m'
                    if(mm.eq.6.and.i.eq.1)linnea=   ' Esag.  c  -3   '
                    if(mm.eq.6.and.i.eq.2)linnea=   ' Esag.  c -3 1 m'
                    if(mm.eq.6.and.i.eq.3)linnea=   ' Esag.  c -3 m 1'
                    if(mm.eq.6.and.i.eq.4)linnea=   ' Esag.  c  6/m  '
                    if(mm.eq.6.and.i.eq.5)linnea=   ' Esag.  c  6/mmm'
                    if(mm.eq.7.and.i.eq.1)linnea=   ' Cubico     m-3 '
                    if(mm.eq.7.and.i.eq.2)linnea=   ' Cubico     m-3m'
!                    write(lo,'(a,2x,i5,7f8.3)')linnea,nFattPExt(mm+1),
!     1              ProbSys(ik,i),aa,corrfatt
!                    write(lo,'(a,2x,i5,7f8.3)')linnea,nFattPExt(mm+1),
!     1              Rintsys(ik,i),ProbSys(ik,i),aa,corrfatt
                 enddo 
!
         if (knw > 0)
     *           write(lo,'(a,2i5,7f8.2)')
     1        'ik,mm,(ProbSys(ik,j),j=1,7)',ik,mm,(ProbSys(ik,j),j=1,7)
              enddo

         if (knw > 0) then
              write(lo,'(a,a)')'  ' 
              write(lo,'(a,a)')'  ' 
         endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
              nonfare=0
              if(nonfare.ne.0)then
                if (knw > 0) write(lo,*)' epsilon medio '
                do i1=1,8      
                  if (knw > 0) write(lo,*)' msys= ',i1
                  do i2=1,27      
                   if (knw > 0)
     *             write(lo,'(i6,5f10.4)')i2,(epsmed(i1,ii3,i2),ii3=1,5)
                  enddo
                enddo
              endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
              write(lo,'(a)')' '
              write(lo,'(22x,a)')
     1          '  ****  Space Group Determination Section ****'
!
              if (jscreen > 0) then
                  write(jgrap,200)
              endif
!
              nume=1
              kfin=kfin0
!              numin=2
!              if(numsysEle.eq.1)then
!                 numin=1
!                 kfin=0
!              endif
!25apr11              do i =1,numsysEle
              do i =numsysEle,numin,-1
!25apr11                  kfin=i
                 kfin=kfin+1
                 if (knw > 0) 
     *               write(lo,*)'i,kfin,numsysEle',i,kfin,numsysEle
                 indprobs=i
                 msys=ProbSys(i,6)
                 if(msys.le.0)cycle
                 if (knw > 0) 
     *       write(lo,'(a,i5,7f8.3)')'i,probSys(i,1:7)',i,probSys(i,1:7)
!                 ProbL(1:5)=ProbSys(i,1:5)
!                 ProbL(1:5)=(ProbSys(i,1:5))*ProbSys(i,7)
                 ProbSys(i,1:5)=ProbSys(i,1:5)**4.0     !era 2.0
                 ProbL(1:5)=ProbSys(i,1:5)
                 ProbL(6)=ProbSys(i,7)     !mi porto l'exponenz.   
!                   
!        write(lo,'(a,2i6,8f6.2)')'i,msys,ProbSys(i,7),ProbL(6)'
!     1   ,i,msys,ProbSys(i,7),ProbL(6)
!                 write(lo,'(a,i6,8f6.2)')
!     1   'i,(ProbSys(i,j),j=1,7)',i,(ProbSys(i,j),j=1,7)
!                 write(lo,'(a,i6,6f6.2)')
!     1   'i,(Probl(j),j=1,5)',i,(Probl(j),j=1,5)
!                 Write(lo,'(a,i6,6f6.2)')
!     1   'msys ,(Probl(j),j=1,6)',msys,(Probl(j),j=1,6)
                 call DetermRefana(icode)
              enddo
          endif
        else if (percssf <= percmin .and. msys >= 4) then ! gianluca 9 ott 2014
             do jj=1,nclassLa
                 ProbL(jj)=1.
             enddo
             call DetermRefana(icode)
        endif
!        stop
      return
  200 format(22x,
     *'<big><b>  ****  Space Group Determination Section ****</b></big>'
     *,/)
      end
! ----------------------------------------------------------------------
! ----------------------------------------------------------------------
! 
!                   TWINS
!
! ----------------------------------------------------------------------
!
!code for DetermTwin 
      subroutine DetermTwin(icode)
      USE General
      USE Symmetry
      USE Riflessi
*     USE Liste
      USE Laue
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/Twinsdet/ MatTwi(10,3,3),nMatTwi
     1,ihmax,ikmax,ilmax,ihmxx(3),lasomdim
      dimension ihg(3),Matt(96,3,3)
!--
      double precision, allocatable :: xstore(:,:)
      real, allocatable :: sSphere(:,:,:)
      real, allocatable :: assoma(:)
      character*16 line,dire,linestam,linest(30)
!
!-- linea(1:nclassLa) nome dei gruppi di Laue compatibili con la cella  
      iprsr02=1
      noprinta=1
      ifSalta = 0
      call LaueSys(noprinta, ifSalta)
      do j2=1,nclassLa
         line=linea(j2)
         linestam(1:16)=line(3:16)
         linest(j2)=linestam
         enddo
!-- allocate work area for reflections (xstore)
      IF (.NOT. ALLOCATED(xstore))
     * ALLOCATE (xstore(1:26,1:nrefl), stat = ierr)
      if (ierr.ne.0) then
          write(lo,*) 'Rflct xstore Allocation error'
          stop 
      endif
      if (icode == 1) then
!-- determina gli indici massimi
          do j2=1,nclassLa
             line=linea(j2)
!            write(lo,'(/,a,i5,3x,a)')' Laue group no.',j2,line
             call cutst(line,lenp,dire,lend)
             call lcase(line)
             lenp=16
             call onebl(line,lenp,ier)
             read(line,'(16a1)') nSpaceG
             call CreaSymmetryInfo(ier)
             jj=j2
             call daList2aMatt(jj,Matt)
             ihmxx(:)=0
             ihh=ihmx(1)
             ik=ihmx(2)
             il=ihmx(3)
!            write(lo,*)'ihmx',ihmx
!            write(lo,*)'j2,n2,nordmat(j2,1:n2)',j2,n2,nordmat(j2,1:n2)
             do ll=1,nsym
                l=nordmat(j2,ll)
                ihg(1)=ihh*Matt(l,1,1)+ik*Matt(l,1,2)+il*Matt(l,1,3)
                ihg(2)=ihh*Matt(l,2,1)+ik*Matt(l,2,2)+il*Matt(l,2,3)
                ihg(3)=ihh*Matt(l,3,1)+ik*Matt(l,3,2)+il*Matt(l,3,3)
                do k=1,3
                   if (ihmxx(k).lt.iabs(ihg(k))) ihmxx(k) = iabs(ihg(k))
                 enddo
             enddo
          enddo
      else if (icode.eq.0) then
         ihmxx(:)=ihmx(:)
      endif
!      write(lo,*)'msys,ihmxx',msys,ihmxx
      ihmax= 2*ihmxx(1)+1
      ikmax= 2*ihmxx(2)+1
      ilmax= 2*ihmxx(3)+1
!      write(lo,*)'msys,ihmxx,ihmax,ikmax,ilmax,nclassLa',
!      1msys,ihmxx,ihmax,ikmax,ilmax,nclassLa
!-- allocate work  reflections s/sphere (sSphere(hmax,kmax,lmax))
      IF (.NOT. ALLOCATED(sSphere))
     *      ALLOCATE (sSphere(1:ihmax,1:ikmax,1:ilmax),stat = ierr)
      if (ierr.ne.0) then
          write(lo,*) 'sSphere Allocation error'
          stop 
      endif
      sSphere(:,:,:)=-1.
!
!--alloca assoma utile a CercaTwins
      lasomdim= 4*nrefl
      IF (.NOT. ALLOCATED(assoma))
     *ALLOCATE (assoma(1:lasomdim),stat = ierr)
      if (ierr.ne.0) then
      write(lo,*) 'assoma Allocation error'
      stop 
      endif
!
      call AnalizzaTwin(xstore,sSphere,assoma,md,icode,Matt)
!
      DEALLOCATE(assoma, stat =ierr)
      DEALLOCATE(sSphere, stat =ierr)
      DEALLOCATE(xstore, stat =ierr)
      return
      end
!
!code for AnalizzaTwin
      subroutine AnalizzaTwin(xstore,sSphere,assoma,md,icode,Matt)
      USE General
      USE Riflessi
*     USE Liste
      USE Laue
!
!
      character*15 nameMat(10)
      character*25 npospointg(10)
!
      common/dummy/reslim,nxxref
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/Twinsdet/ MatTwi(10,3,3),nMatTwi
     1,ihmax,ikmax,ilmax,ihmxx(3),lasomdim
!--
      dimension nSpaceG(16),Matt(96,3,3),kcod(16),vett(120)
!--
      double precision :: xstore(26,nrefl)
      real sSphere(ihmax,ikmax,ilmax)
      real assoma(lasomdim)
!
      character*16 line,dire,linestam,linest(30)
!-- linea(1:nclassLa) nome dei gruppi di Laue compatibili con la cella  
!
!      write(lo,*)'icode ',icode
      noprinta=1
      ifSalta = 0
      call LaueSys(noprinta, ifSalta)
      if (msys.ge.5 .and. msys.le.7) then
          write(lo,'(/,a)')
     1'  ***** Twin Symmetry Determination Section *****'
          write(lo,'(a)')' '
c
          do imer=1,nclassLa
             line=linea(imer)
             linestam(1:16)=line(3:16)
             linest(imer)=linestam
          enddo
          if (icode.eq.0) then
              call CreaSymmetryInfo(ier)
              ngspat=0
              ii= ipuac(nSpaceG,vett,lvet,ngspat)
              ngspat=iabs(ngspat)
              call cercalaueclas(ngspat,kmer,Matt)
!            write(lo,*)'ngspat,kmer ',ngspat,kmer
              line=linea(imer)
              call daList2aMatt(kmer,Matt)
!            write(lo,*)'analizzatwin msys,ngspat ',msys,ngspat
!               do l=1,nsym
!              write(lo,'(a,i5,9i3)')'l,Matt(l,1:3,1:3)',l,Matt(l,1,1:3)
!              write(lo,'(a,5x,9i3)')'l,Matt(l,1:3,1:3)',Matt(l,2,1:3)
!              write(lo,'(a,5x,9i3)')'l,Matt(l,1:3,1:3)',Matt(l,3,1:3)
!              write(lo,*)' '
!             enddo
          endif
cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!-- Perfect twinning test
          percnegle=0.0
          ifMercedes = 1
**    call norm2000(ifMercedes, ier)
          call NormLaueGr(ier)
          call PerfectTwin(xstore,md)
cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!-- Partial twinning test
!         write(lo,*)'nMatTwi ',nMatTwi
          ifMercedes = 1
**        call norm2000(ifMercedes, ier)
          call NormLaueGr(ier)
!
          call xsto6dp(xstore)
!
          write(lo,'(a)') ' Partial Merohedral Twinning Test'
          write(lo,'(a)') ' '
          i1 = 2
          i2 = nclassLa
          if (icode == 0) then
             i1 = kmer
             i2 = kmer
          endif
!
          do imerr=i1,i2
             imer=imerr
             if (icode == 1) then
                 line=linea(imer)
                 linestam=linest(imer)
!             write(lo,'(/,a,a)')
!          1   ' Simulated Laue group     ',linestam
                 call cutst(line,lenp,dire,lend)
                 call lcase(line)
                 lenp=16
                 call onebl(line,lenp,ier)
                 read(line,'(16a1)') nSpaceG
*gl*
                 call CreaSymmetryInfo(ier)
             endif
              call daList2aMatt(imer,Matt)
!              write(lo,*)'1imer,nmattwi ',imer,nmattwi
              call setMatTwins(imer,nameMat,npospointg)
!              write(lo,*)'2imer,nmattwi ',imer,nmattwi
              if (nMatTwi > 0) then
                  call PartialTwin(imer,xstore,sSphere,assoma,
*gl* *                             md,linea,nameMat,npospointg)
     *                             md,nameMat,npospointg)
              endif
          enddo
      endif
!
      return
      end
!
code for setMatTwins
      subroutine setMatTwins(nclassapp,nameMat,npospointg)
      USE General
*     USE Liste
      USE Laue
!
!
      character*15 nameMat(10)
      character*25 npospointg(10)
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/Twinsdet/ MatTwi(10,3,3),nMatTwi
     1,ihmax,ikmax,ilmax,ihmxx(3),lasomdim
!
      nMatTwi = 0
      if (msys == 5 .and. nclassapp == 2) then
!--4/mmm
          nMatTwi=1
          MatTwi(1,1,1)= 1
          MatTwi(1,1,2)= 0
          MatTwi(1,1,3)= 0
          MatTwi(1,2,1)= 0
          MatTwi(1,2,2)=-1
          MatTwi(1,2,3)= 0
          MatTwi(1,3,1)= 0
          MatTwi(1,3,2)= 0
          MatTwi(1,3,3)=-1
!
          nameMat(1)=' h, -k, -l'
          npospointg(1)=' 4, 4/m '
!
      elseif (msys == 6 .and. nclassapp == 2) then
!-- -3m1
!      nMatTwi=5
          nMatTwi=1
          MatTwi(1,1,1)= 1
          MatTwi(1,1,2)= 0
          MatTwi(1,1,3)= 0
          MatTwi(1,2,1)=-1
          MatTwi(1,2,2)=-1
          MatTwi(1,2,3)= 0
          MatTwi(1,3,1)= 0
          MatTwi(1,3,2)= 0
          MatTwi(1,3,3)=-1
!
          nameMat(1)=' h, -h-k, -l'
          npospointg(1)=' 3(-3) '
      elseif (msys == 6 .and. nclassapp == 3) then
!-- -31m
          nMatTwi=1
          l=1
!      l=2
          MatTwi(l,1,1)= 1
          MatTwi(l,1,2)= 1
          MatTwi(l,1,3)= 0
          MatTwi(l,2,1)= 0
          MatTwi(l,2,2)=-1
          MatTwi(l,2,3)= 0
          MatTwi(l,3,1)= 0
          MatTwi(l,3,2)= 0
          MatTwi(l,3,3)=-1
!
          nameMat(l)=' h+k, -k, -l'
          npospointg(l)=' 3(-3) '
      elseif (msys == 6 .and. nclassapp == 4) then
!--6/m
          nMatTwi=1
          l=1
!      l=3
          MatTwi(l,1,1)=-1
          MatTwi(l,1,2)= 0
          MatTwi(l,1,3)= 0
          MatTwi(l,2,1)= 0
          MatTwi(l,2,2)=-1
          MatTwi(l,2,3)= 0
          MatTwi(l,3,1)= 0
          MatTwi(l,3,2)= 0
          MatTwi(l,3,3)= 1
!
          nameMat(l)=' -h, -k, l'
          npospointg(l)=' 3(-3) '
      elseif (msys == 6 .and. nclassapp == 5) then
!--6/mmm 
          nMatTwi=2
          l=1
!      l=4
          MatTwi(l,1,1)= 1
          MatTwi(l,1,2)= 0
          MatTwi(l,1,3)= 0
          MatTwi(l,2,1)=-1
          MatTwi(l,2,2)=-1
          MatTwi(l,2,3)= 0
          MatTwi(l,3,1)= 0
          MatTwi(l,3,2)= 0
          MatTwi(l,3,3)=-1
!
          nameMat(l)=' h, -h-k, -l'
          npospointg(1)=' 6(6/m) '
!
!      l=1
          l=2
          MatTwi(l,1,1)=-1
          MatTwi(l,1,2)= 0
          MatTwi(l,1,3)= 0
          MatTwi(l,2,1)= 0
          MatTwi(l,2,2)=-1
          MatTwi(l,2,3)= 0
          MatTwi(l,3,1)= 0
          MatTwi(l,3,2)= 0
          MatTwi(l,3,3)= 1
!
          nameMat(l)=' -h, -k, l'
          npospointg(l)=' 321(-3m1), 312(-31m) '
!
      elseif (msys == 7 .and. nclassapp == 2) then
!-- m-3m
          nMatTwi=1
          MatTwi(1,1,1)= 0
          MatTwi(1,1,2)= 1
          MatTwi(1,1,3)= 0
          MatTwi(1,2,1)=-1
          MatTwi(1,2,2)= 0
          MatTwi(1,2,3)= 0
          MatTwi(1,3,1)= 0
          MatTwi(1,3,2)= 0
          MatTwi(1,3,3)= 1
!
          nameMat(1)=' k, -h, l'
          npospointg(1)=' 23(m-3) '
!
      endif
!
      return
      end
!
!code for PerfectTwin
      subroutine PerfectTwin(xstore,md)
      USE General
      USE Riflessi
*     USE Liste
!
!-- Perfect twinning test
!
      common/dummy/reslim,nxxref
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!--
      dimension ssommI(24),ssommI2(24),ssommF(24),ssommF2(24),
     1nrefbin(20),resol(20)
!--
      double precision :: xstore(26,nrefl)
c
      call LoadReflInfo
!-- Perfect twinning test
      percnegle=0.0
      call xsto6dp(xstore)
!-- storizza rho in (m6+5), calcola < <I**2>/<I>**2> 
      ssommIt=0.
      ssommI2t=0.
      ssommFt=0.
      do i=1,nxxref
         ihh=xstore(1,i )
         ik =xstore(2,i)
         il =xstore(3,i)
         xstore(6,i)=rhof(pp,ihh,ik,il)
         fov=xstore(4,i)
         ssommIt =ssommIt +fov**2
         ssommI2t=ssommI2t+fov**4
         ssommFt =ssommFt +fov   
      enddo
!--calcola il no. di riflessi per intervalo (circa 200) max 20 interv.
      ninterv=nxxref/200
      if (ninterv.lt.10) ninterv = 10
      if (ninterv.gt.20) ninterv = 20
      nrefint=nxxref/ninterv
      ii=nxxref-ninterv*nrefint
      nrefbin(:)=nrefint
      do i=1,ii
         nrefbin(i)=nrefbin(i)+1
      enddo
!--sortizzo per rho decrescente
!      njump=-6
      njump=5
      nxxe = nxxref
      numb=nxxe
      call sortzadp(xstore,numb,njump)
!
      ssommI=0.
      ssommI2=0.
      ssommF=0.
      nxxx=nxxref*(1-percnegle)
!      write(lo,*)'nxxe,lxxe,mdxxe,md ',nxxe,lxxe,mdxxe,md
!      write(lo,'(a,10i6)')'nrefbin ',nrefbin(1:8)
      nn1=1
      nn=0
      do n=1,ninterv
         nn=nn+nrefbin(n)
         do ii=nn1,nn
            fov=xstore(4,ii)
            ssommIt =ssommIt +fov**2
            ssommI2t=ssommI2t+fov**4
            ssommFt =ssommFt +fov   
            rho=xstore(6,ii)
            if(ii.eq.nn1)res = 0.5 / rho
            if (ii.eq.nn) resol(n) = 0.5*abs(res+0.5 / rho)
!           write(lo,*)'n,ii,rho,res,res1,resol(n)'
!           1,n,ii,rho,res,res1,resol(n)
            ssommI(n) =ssommI(n) +fov**2
            ssommI2(n)=ssommI2(n)+fov**4
            ssommF(n) =ssommF(n) +fov   
!              write(lo,'(3f4.0,7f8.3)')xstore(mxxe:mxxe+3)
         enddo
         nn1=nn+1
      enddo
!
!      write(lo,'(a,a)')' resol       nrifl.     ssommFf2',
!      1'        ssommFf       ssommIi2         rrappFf       rrappIi'
    
      write(lo,'(a)') ' Perfect Merohedral Twinning Test'
      write(lo,'(a,a)') ' Expected Values:   Perfect Twinned =1.5',
     1'   Untwinned =2.0'
           write(lo,'(a)')'   Resol.   N.refl.     <I**2>/<I>**2'
      rrapptot=0.
      do n=1,ninterv
         nriflessi=nrefbin(n)
!        if(nmiss(n,1).gt.0)then
         ssommF2(n)=ssommI(n)
         ssommFf2=ssommF2(n)/nriflessi
         ssommFf=(ssommF(n)/nriflessi)**2
         rrappFf=ssommFf/ssommFf2
!
         ssommIi2=ssommI2(n)/nriflessi
         ssommIi=(ssommI(n)/nriflessi)**2
         rrappIi=ssommIi2/ssommIi
         rrapptot=rrapptot+rrappIi
!        write(lo,'(f7.3,i10,6f15.3)')resol(n),nriflessi,
!        1ssommFf2,ssommFf,ssommIi2,rrappFf,rrappIi
         write(lo,'(f8.3,i10,f18.5)')resol(n),nriflessi,rrappIi
!        endif
      enddo
!
      ssommI2t=ssommI2t/nxxe
      ssommIt=(ssommIt/nxxe)**2
      rrappIit=ssommI2t/ssommIt
      rrapptot=rrapptot/ninterv
      write(lo,'(a,f8.5)')' < <I**2>/<I>**2 > :  ',rrapptot
      write(lo,'(a,f8.5)')'whole resol. range <I**2>/<I>**2 :',rrappIit
      write(lo,*)' '
!
      return
      end
!
!code for PartialTwin
      subroutine PartialTwin(imer,xstore,sSphere,assoma,md
     1                        ,nameMat,npospointg)
      USE General
      USE Symmetry
      USE Riflessi
*     USE Liste
      USE Laue
!
      character*15 nameMat(10)
      character*25 npospointg(10)
      dimension ndataused(6)
!
      common/dummy/reslim,nxxref
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/Twinsdet/ MatTwi(10,3,3),nMatTwi
     1,ihmax,ikmax,ilmax,ihmxx(3),lasomdim
!--
      dimension ihg(3),ih(3),indmx(50),Matt(96,3,3)
!--
      double precision :: xstore(26,nrefl)
      real  sSphere(ihmax,ikmax,ilmax)
      real  assoma(lasomdim)
!
!-- linea(1:nclassLa) nome dei gruppi di Laue compatibili con la cella  
!
      call xsto6dp(xstore)
      call daList2aMatt(imer,Matt)
      ifMercedes = 1
      call NormLaueGr(ier)
      ndataused(imer)=0
      do i=1,nxxref
         ih(1)= xstore(1,i)
         ih(2)= xstore(2,i)
         ih(3)= xstore(3,i)
         fo   = xstore(4,i)
         indmx(:)=0
         do ll=1,nsym
            l=nordmat(imer,ll)
            ihg(1)=ih(1)*Matt(l,1,1)+ih(2)*Matt(l,1,2)+ih(3)*Matt(l,1,3)
            ihg(2)=ih(1)*Matt(l,2,1)+ih(2)*Matt(l,2,2)+ih(3)*Matt(l,2,3)
            ihg(3)=ih(1)*Matt(l,3,1)+ih(2)*Matt(l,3,2)+ih(3)*Matt(l,3,3)
!
            ihh=ihg(1)
            ikk=ihg(2)
            ill=ihg(3)
            call pack2002(ind,ihh,ikk,ill)
            indmx(l)=ind
            new = 1
            if (l /= 1) then
                do jj=1,l-1
                   if (indmx(l) == indmx(jj)) new = -1
                enddo
            endif
            if (new == -1) exit
         enddo
         xstore(6,i)=new
         if (new.eq.1) ndataused(imer) = ndataused(imer) + 1
      enddo
      assoma(:)=0.
      call CercaTwins
     1     (imer,xstore,sSphere,assoma,nameMat,npospointg,
     1     ndataused,Matt)
!
      return
      end
!
!code for CercaTwins
       subroutine CercaTwins
     1(j2,xstore,sSphere,assoma,nameMat,npospointg,
     1ndataused,Matt)
      USE General
      USE Riflessi
*     USE Liste
      USE Laue
!
      character*15 nameMat(10)
      character*25 npospointg(10)
      character*16 line,linestam
      double precision :: xstore(26,nrefl)
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      real sSphere(ihmax,ikmax,ilmax)
      dimension somm(10),somm2(10),sommF(10),sommI2(10)
     1,sommI(10),ndataused(6)
      dimension nsom(10),smed(10),s2med(10),nurefl(10)
      dimension alpha1(10),alpha2(10),alp(10),npairconsid(10)
      dimension alphav(10),erro(10),Matt(96,3,3)
      common/Twinsdet/ MatTwi(10,3,3),nMatTwi
     1,ihmax,ikmax,ilmax,ihmxx(3),lasomdim
      common/dummy/reslim,nxxref
      real  assoma(lasomdim)
!
      percinput=0.05
      soglia=0.001
      nsom(:)=0
      nurefl(:)=0
      sommI(:)=0.
      sommI2(:)=0.
      sommF(:)=0.
      sommI(:)=0.
      sommI2(:)=0.
      sommF(:)=0.
!      write(lo,*)'ihmax,ikmax,ilmax,ihmxx ',ihmax,ikmax,ilmax,ihmxx
!
      do l=1,nmatTwi
!-- store la s/sfera
         sSphere(:,:,:)=-1.
         jx=-j2
         do i=1,nxxref
            ih = xstore(1,i)
            ik = xstore(2,i)
            il = xstore(3,i)
            fo = xstore(4,i)
            new= xstore(6,i)
            fo=fo*new
!           write(lo,'(i5,3i4,2f10.2)')
!      1         i  ,ih  ,ik , il,fo,sig
!           if(i.gt.18000)tfo=-1
!           if(tfo.lt.0)write(lo,'(i5,3i4,f10.2,i5)')
!      1         i  ,ih  ,ik , il,fo,new
            call storesSphere(sSphere,ih,ik,il,fo,jx,Matt)
         enddo
         jx=j2
         do i=1,nxxref
            ih = xstore(1,i)
            ik = xstore(2,i)
            il = xstore(3,i)
            fo = xstore(4,i)
            new= xstore(6,i)
            fo=fo*new
            call storesSphere(sSphere,ih,ik,il,fo,jx,Matt)
         enddo
!--
         somm(l)=0.
         somm2(l)=0.
         assoma=0.
!           write(lo,'(a,3i4)')' MatTwi(l,1,1:3) ',MatTwi(l,1,1:3)
!           write(lo,'(a,3i4)')' MatTwi(l,2,1:3) ',MatTwi(l,2,1:3)
!           write(lo,'(a,3i4)')' MatTwi(l,3,1:3) ',MatTwi(l,3,1:3)
!              write(lo,'(a,a)')
!      1        '    i    l  ih  ik  il',
!     1'  fobs  nsom(l)      assoma(nn+1:nn+4) '
         nigual=0
         nn=1
         nocon=0
         nsom(l)=0
         do i=1,nxxref
            iho= xstore(1,i)
            iko= xstore(2,i)
            ilo= xstore(3,i)
            fo=  xstore(4,i)
            new= xstore(6,i)
            fobs1=1.
            ce=cercaFo(sSphere,iho,iko,ilo,fobs1,j2,Matt)
            if (fobs1.gt.soglia) then
                fo11= fo
                fo1=fo11**2
!               write(lo,'(a,i5,3i5,2f10.2)')
!    1          ' i,iho,iko,ilo,fo11,fo1 ',i,iho,iko,ilo,fo11,fo1
!--calculate the twinnig related indices
                ih=iho*MatTwi(l,1,1)+iko*MatTwi(l,1,2)+ilo*MatTwi(l,1,3)
                ik=iho*MatTwi(l,2,1)+iko*MatTwi(l,2,2)+ilo*MatTwi(l,2,3)
                il=iho*MatTwi(l,3,1)+iko*MatTwi(l,3,2)+ilo*MatTwi(l,3,3)
                nurefl(l)=nurefl(l)+1
!               write(lo,'(a,2i5,3i5,2f10.2)')
!      1        ' l,nurefl(l),ih,ik,il ',l,nurefl(l),ih,ik,il
!
                igual=0
                if (ih.eq.iho.and.ik.eq.iko.and.il.eq.ilo) igual=1
                if (ih.eq.-iho.and.ik.eq.-iko.and.il.eq.-ilo) igual=1
                if (igual.eq.0) then
                    fobs2=-1.
                    if (cercaFo(sSphere,ih,ik,il,fobs2,j2,Matt)
     *                  .gt.soglia)then
                        fo2= fobs2**2
!                       write(lo,'(a,2i5,3i5,2f10.2)')
!      1               ' l,nurefl(l),ih,ik,il,fo2,fobs2 ',l,nurefl(l),ih,ik,il,fo2,fobs2
                        nsom(l)=nsom(l)+1
                        assoma(nn  )=abs(fo1+fo2)
                        assoma(nn+1)=abs(fo1-fo2)
                        assoma(nn+2)=fo11
                        assoma(nn+3)=fobs2
!                       write(lo,'(2i5,2(3i4,f10.2),4f10.2)')
!       1               i,nsom(l),iho,iko,ilo,fo1,ih,ik,il,fo2,
!     1                 assoma(nn:nn+3)
                        nn=nn+4 
                    endif      
                endif      
            endif      
         enddo
!-- sort (f1+f2) in ordine decrescente       
         numbb=nsom(l)
         jump=-1
         call sortz_dyn(assoma,lasomdim,1,numbb,4,jump)
         npairconsid(l)=nsom(l)-nint(percinput*nsom(l))
         nn=npairconsid(l)
!        write(lo,*)'l,nsom(l),nn ',l,nsom(l),nn
         ii=1
         do i=1,nn
!           write(lo,'(i5,4f10.2)')
!      1    i,assoma(ii:ii+3)
            a=assoma(ii+1)/assoma(ii)
            a2=a*a
            somm(l)=somm(l)+a
            somm2(l)=somm2(l)+a2
            ii=ii+4
         enddo
         nso=npairconsid(l)
         if (nso.gt.0) then
             smed(l)=somm(l)/nso
             s2med(l)=somm2(l)/nso
             alpha1(l)=0.5-smed(l)
             alp(l)=0.5*sqrt(3*s2med(l))
             alpha2(l)=0.5-alp(l)
!            write(lo,'(i9,3f10.5,i5,a15,2f10.5)')
!            1nso,smed(l),s2med(l),alp
!            1,l,nameMat(l),alpha1(l),alpha2(l)
             alphav(l)=0.5*(alpha1(l)+alpha2(l))
             erro(l)=0.5*abs(alpha1(l)-alpha2(l))
         else if (nso.eq.0)then
             smed(l)=0.
             s2med(l)=0.
             alpha1(l)=0.
             alp(l)=0.
             alpha2(l)=0.
!            write(lo,'(i9,3f10.5,i5,a15,2f10.5)')
!            1nso,smed(l),s2med(l),alp
!            1,l,nameMat(l),alpha1(l),alpha2(l)
             alphav(l)=0.
             erro(l)=0.
         endif
      enddo
!      write(lo,'(a,a)')
!      1'nsom(l)  ncons  smed     s2med'
!     1,'   alp    nameMat       alpha1  alpha2   alphav   error'
!      do l=1,nMatTwi
!      write(lo,'(2i7,3f8.5,a15,4f8.5)')
!      1nsom(l),npairconsid(l),smed(l),s2med(l),alp(l)
!      1,nameMat(l),alpha1(l),alpha2(l),alphav(l),erro(l)
!      write(lo,'(1x,a12,i5,i7,2x,a15,2f8.5,2f8.5)')line,
!      1nsom(l),npairconsid(l),nameMat(l),smed(l),s2med(l),alphav(l)
!     1,erro(l)
!      enddo
      line=linea(j2)
      do l=1,nMatTwi
         if (nsom(l).gt.0) then
!            if(nclassLa.gt.1)then
             linestam(1:16)=line(3:16)
             write(lo,'(/,a,a)')
     1                  ' Simulated Laue group      ',linestam
             write(lo,'(a,a)') ' Twin operator             ',
     *                         nameMat(l)
             write(lo,'(a,i8)')' Number of Reflection Used ',
     *                         ndataused(j2)
             write(lo,'(a,i8)')' Total Number of Pair Found',
     *                         nsom(l)
             write(lo,'(a,i8)')' Number of Pair Considered ',
     *                         npairconsid(l)
             write(lo,'(a,f9.6,a,f9.6)') ' H =',smed(l),' H**2= ',
     *                         s2med(l)
             write(lo,'(a,f8.5,a,f8.5)')
     1                  ' Twin Fraction             '
     1        ,alphav(l),' +/- ',erro(l)
             write(lo,'(a,a)') ' Possible True Laue Groups ',
     *                         npospointg(l)
!      write(lo,'(a)')' '
!      write(lo,'(2x,a10,i6,i7,i7,2x,a15,2f8.5,2f8.5)')linestam,
!      1ndataused(j2),nsom(l),npairconsid(l),nameMat(l),smed(l),s2med(l)
!     1,alphav(l),erro(l)
!      else if(nclassLa.eq.1)then
!      write(lo,'(2x,i6,i7,i7,2x,a15,2f8.5,2f8.5)')
!      1ndataused(j2),nsom(l),npairconsid(l),nameMat(l),smed(l),s2med(l)
!     1,alphav(l),erro(l)
!      endif
         endif
      enddo
      write(lo,*)' '
      if (j2.eq.nclassLa) write(lo,*)' '
!
      return
      end
!
!code for storesSphere
      subroutine storesSphere(sSphere,ih,ik,iill,fob,jj2,Matt)
      USE General
      USE Symmetry, only : nsym
*     USE Liste
      USE Laue
!
!--
      common/Twinsdet/ MatTwi(10,3,3),nMatTwi
     1,ihmax,ikmax,ilmax,ihmxx(3),lasomdim
      real sSphere(ihmax,ikmax,ilmax)
      dimension ihg(3),Matt(96,3,3)
!
      fo = fob 
      j2=jj2
      if (j2.gt.0) then
          i1=1
          i2=nsym
      else
          i1=1
          i2=1
          j2=-j2
      endif
!      write(lo,*)'jj2,j2,i1,i2',jj2,j2,i1,i2
!     do ll=i1,i2
!      l=nordmat(j2,ll)
!      if(tfo.lt.0)then
!      if(i1.ne.1)then
!      write(lo,*)'ll Matt(l)  l',ll,l
!      write(lo,*)Matt(l,1,1:3)
!      write(lo,*)Matt(l,2,1:3)
!      write(lo,*)Matt(l,3,1:3)
!      endif
!     enddo
!--calculate the transformed indices
      do ll=i1,i2
         l=nordmat(j2,ll)
         ihg(1)=ih*Matt(l,1,1)+ik*Matt(l,1,2)+iill*Matt(l,1,3)
         ihg(2)=ih*Matt(l,2,1)+ik*Matt(l,2,2)+iill*Matt(l,2,3)
         ihg(3)=ih*Matt(l,3,1)+ik*Matt(l,3,2)+iill*Matt(l,3,3)
!
         isig=1
         do j=1,2
!        do j=1,1
            ihh=isig*ihg(1)
            ikk=isig*ihg(2)
            ill=isig*ihg(3)
            iih= ihh+ihmxx(1)+1
            iik= ikk+ihmxx(2)+1
            iil= ill+ihmxx(3)+1
            if (sSphere(iih,iik,iil).lt.0) sSphere(iih,iik,iil)=fo
!
!           write(lo,'(a,6i3,f8.2,i5)')
!           1  'stsSph ihh,ikk,ill,iih,iik,iil,sSphere(iih,iik,iil),jj2',
!           1ihh,ikk,ill,iih,iik,iil,sSphere(iih,iik,iil),jj2
            isig=-1
         enddo
      enddo
!
      return
      end
!
!code for cercaFo
      function cercaFo(sSphere,ihh,ikk,iill,Fobse,j2,Matt)
      USE General
      USE Symmetry, only : nsym
*     USE Liste
      USE Laue
!
      common/conta/numtrovati,numequivv(6)
      common/Twinsdet/ MatTwi(10,3,3),nMatTwi
     1,ihmax,ikmax,ilmax,ihmxx(3),lasomdim
      real sSphere(ihmax,ikmax,ilmax)
      dimension ihg(3),Matt(96,3,3)
!
      ii=nint(Fobse)
      cercaFo=-1.
      ih= ihh+ihmxx(1)+1
      ik= ikk+ihmxx(2)+1
      il1= iill+ihmxx(3)+1
      Fobse=sSphere(ih,ik,il1)
!      write(lo,*)'cercafo ihh,ikk,ill,fobse,ih,ik,il1 '
!      1,ihh,ikk,ill,fobse,ih,ik,il1
      if (Fobse.gt.0.001) cercaFo=Fobse
      sSphere(ih,ik,il1)=-abs(sSphere(ih,ik,il1))
      if (Fobse.gt.0.001) numtrovati=numtrovati+1
!--elimina i suoi equivalenti
      if (ii.eq.-1) then
!      write(lo,*)'cercafo ihh,ikk,ill,fobs ',ihh,ikk,ill,fobs
!--calculate the transformed indices
!      do ll=1,n2
          do ll=1,1
             l=nordmat(j2,ll)
             ihg(1)=ihh*Matt(l,1,1)+ikk*Matt(l,1,2)+iill*Matt(l,1,3)
             ihg(2)=ihh*Matt(l,2,1)+ikk*Matt(l,2,2)+iill*Matt(l,2,3)
             ihg(3)=ihh*Matt(l,3,1)+ikk*Matt(l,3,2)+iill*Matt(l,3,3)
             isig=1
             do j=1,2
                ihh=isig*ihg(1)
                 ikk=isig*ihg(2)
                 ill=isig*ihg(3)
                 ih2= ihh+ihmxx(1)+1
                 ik2= ikk+ihmxx(2)+1
                 il2= ill+ihmxx(3)+1
                 sSphere(ih2,ik2,il2)=-abs(sSphere(ih2,ik2,il2))
                 isig=-1
             enddo
          enddo
      endif
!
      return
      end
! ----------------------------------------------------------------------
! 
!                   Laue
!
! ----------------------------------------------------------------------
!
!code for DetermLaue
      subroutine DetermLaue(icode)
      USE General
      USE Symmetry, only : nsym, nSpaceG  
      USE Riflessi
      USE Laue
!
!
!
!-- come funziona:
!   usa due vett fondamentali :
!   xstore (h,k,l,fo,sigfo,E1,E2,E3,E4,E5,(neqrac,epsilon,mxsup)*5,<E1>)
!     E1,E2,E3,E4,E5  5 posizioni per gli E**2 delle massimo 5(essag.) classi di Laue
!     (neqrac,epsilon,mxsup)*5 ,5 terne di (no. eqrac,epsilon,maxsupindice)
!   sSphere(2*ihmx+1,2*ikmx+1,2*ilmx+1), ihmx,ikmx,ilmx e' calcolata per tutte le classe di L.
!      do 1,nclass
!      nnn (per la prima classe )=nref
!      nnn (per le altre)=nriflessi indipendenti nella prima classe
!        do 1,nnn 
!        - legge rifl. da xstore riempie sSphere con tutti i suoi equiv. 
!        - calcola mxsuperind e lo storizza nella 3. posizione della terna corrisp
!        - conta gli equiv. e lo storizza nella 1. posizione della terna corrisp
!        enddo
!       sortizza per maxsuper. della classe (tutti gli equiv. restano di seguito)
!       Calcolo del Rint:
!       do 1,nnn
!         do 1,no. equiv. 
!          calcola le somme di diff e E**2
!          rende neg. maxsuperin
!         enddo
!       enddo
!       Calcola <E**2> (per la prima classe lo salva in xstore(25))
!       Calcola Rint
!       sortizza per max superin della 1 classe 
!       enddo
!
!        
!
      common/dummy/reslim,nxxref
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/Twinsdet/ MatTwi(10,3,3),nMatTwi
     1,ihmax,ikmax,ilmax,ihmxx(3),lasomdim
      common/rintp/fosum,diffsum,rintres(10,5,2,25)
      common/conta/numtrovati,numequivv(6)
!--
      dimension e1med(6)
      dimension ihg(3),ihmxsu(3),Matt(96,3,3)
!--
      double precision, allocatable :: xstore(:,:)
      double precision fosum,diffsum
      real, allocatable :: sSphere(:,:,:)
!
      character*16 line,dire,linestam,linest(30)
      character*16 rintc(6),probc(6)
!-- linea(1:nclassLa) nome dei gruppi di Laue compatibili con la cella  
!
!--------------------------------------------------------------
!
      iprsr02=1
      noprinta=1
      ifSalta = 0
      call LaueSys(noprinta, ifSalta)
      if (icode.eq.1) then
          do j2=1,nclassLa
             line=linea(j2)
             linestam(1:16)=line(5:11)
             linest(j2)=linestam
!            write(lo,'(a,i7,a)')'j2,linestam',j2,linestam
          enddo
      endif
      if (icode.eq.0) nclassLa=1
      write(lo,'(a)')' '
!
!-- allocate work area for reflections (xstore)
      IF (.NOT. ALLOCATED(xstore))
     *ALLOCATE (xstore(1:26,1:nrefl), stat = ierr)
      if (ierr.ne.0) then
          write(lo,*) 'Rflct xstore Allocation error'
          stop 
      endif
!
!-- determina gli indici massimi
!
      do j2=1,nclassLa
         if (icode.eq.1) then
             line=linea(j2)
!            write(lo,'(/,a,i5,3x,a)')' Laue group no.',j2,line
             call cutst(line,lenp,dire,lend)
             call lcase(line)
             lenp=16
             call onebl(line,lenp,ier)
             read(line,'(16a1)') nSpaceG
             call CreaSymmetryInfo(ier)
             call daList2aMatt(j2,Matt)
             ihmxx(:)=0
             ihh=ihmx(1)
             ik=ihmx(2)
             il=ihmx(3)
!         write(lo,*)'j2,n2,nordmat(j2,1:n2)',j2,n2,nordmat(j2,1:n2)
             do ll=1,nsym
                l=nordmat(j2,ll)
                ihg(1)=ihh*Matt(l,1,1)+ik*Matt(l,1,2)+il*Matt(l,1,3)
                ihg(2)=ihh*Matt(l,2,1)+ik*Matt(l,2,2)+il*Matt(l,2,3)
                ihg(3)=ihh*Matt(l,3,1)+ik*Matt(l,3,2)+il*Matt(l,3,3)
                do k=1,3
                   if (ihmxx(k).lt.iabs(ihg(k))) ihmxx(k)=iabs(ihg(k))
                enddo
             enddo
         elseif (icode.eq.0) then
             ihmxx(:)=ihmx(:)
         endif
         call LoadReflInfo
      enddo
!      write(lo,*)'msys,ihmxx',msys,ihmxx
      ihmax= 2*ihmxx(1)+1
      ikmax= 2*ihmxx(2)+1
      ilmax= 2*ihmxx(3)+1
!      write(lo,*)'msys,ihmxx,ihmax,ikmax,ilmax,nclassLa',
!     1msys,ihmxx,ihmax,ikmax,ilmax,nclassLa
!-- allocate work  reflections s/sphere (sSphere(hmax,kmax,lmax))
      IF (.NOT. ALLOCATED(sSphere))
     *ALLOCATE (sSphere(1:ihmax,1:ikmax,1:ilmax),stat = ierr)
      if (ierr.ne.0) then
          write(lo,*) 'sSphere Allocation error'
          stop 
      endif
      sSphere(:,:,:)=-1.
      nxxref=nrefl
      call xsto6dp(xstore) !storizza i rifl.con (res.lt.reslim) =nxxref
!      write(lo,*) ' No. reflessi accettati = ',nxxref


!-- loop:storizza gli E**2 per ogni classe di Laue,calcola gli <E>
!-- ia=1 :stampa gli E
!
      e1med(1:6)=0.
      do imer=1,nclassLa
         if (icode.eq.1) then
             line=linea(imer)
!            write(lo,'(/,a,i5,3x,a)')' Laue group no.',imer,line
             call cutst(line,lenp,dire,lend)
             call lcase(line)
             lenp=16
             call onebl(line,lenp,ier)
             read(line,'(16a1)') nSpaceG
             call CreaSymmetryInfo(ier)
         endif
         ifMercedes = 1
         call NormLaueGr(ier)
         e1me=0.
         fmed=0.
         ia=0
         do i=1,nxxref
            xstore(5+imer,i)=evet(i)**2
            e1curr=sqrt(xstore(5+imer,i))
            if (ia.ne.0) write(lo,'(3f4.0,7f8.3)')xstore(1:10,i)
            e1me=e1me+e1curr
            fmed=fmed+xstore(4,i)
         enddo
         e1med(imer)=e1me/nxxref
         fmed=fmed/nxxref
      enddo
!--------------------------------------------------------------
!-- calcola il Rint per ogni classe di Laue
!-- calcola il numero massimo di riflessi nella semisfera.
      msyslim=4
      if(neutro==2)msyslim=2
      if (msys.gt.msyslim) then
          write(lo,'(a)')' '
          write(lo,'(22x,a)')
     *         '*** Laue Class Determination ***'
          nxxx=nxxref
          numtrovati=0
!
          do imerr=1,nclassLa
             imer=imerr
             sSphere(:,:,:)=-1.
             if (icode.eq.1)then
                 line=linea(imer)
!                write(lo,'(/,a,3x,a)')' Laue group ',linest(imer)
                 call cutst(line,lenp,dire,lend)
                 call lcase(line)
                 lenp=16
                 call onebl(line,lenp,ier)
                 read(line,'(16a1)') nSpaceG
                 call CreaSymmetryInfo(ier)
             endif
             diffsum=0.0
             fosum=0.0
             call daList2aMatt(imer,Matt)
!            write(lo,'(a,i10)')
!     1      'xstore(m6:m6+9)
!     1      ,xstore(m6+10:m6+15) nxxx= ',nxxx
             do i=1,nxxx
                ihh= xstore(1,i)
                ik = xstore(2,i)
                il = xstore(3,i)
                fo = xstore(5+imer,i)
                imm=imer
                call storesSphere(sSphere,ihh,ik,il,fo,imm,Matt)
                xstore(11+3*(imer-1),i)=1
                if (imer.gt.1) xstore(11+3*(imer-1),i)=xstore(11,i)
                nord=i
                if (imer.eq.1.or.xstore(13,i).gt.0)
     1           jz= maxsuperind(xstore,sSphere,imer,nord,ihmxsu,Matt) 
             enddo
!-- sort i rifl. per superindice
             njump=-(10+3*(imer))
             call sortzadp(xstore,nxxx,njump)
!-- calcola R-int 
             if (imer.eq.1) then
                 call RintPerc(xstore,nxxx,imer,kstop)
             else
                 call RintPerc2(xstore,nxxx,imer,kstop)
             endif
!
             ia=0
             if (ia.ne.0) then
                 write(lo,*)
                 do i=1,nxxx
                    write(lo,'(i8,3f4.0,7f8.3,2f4.0,f12.0,
     1              /,3(2f4.0,f12.0,f10.2))')
     1              i,xstore(1:10,i),xstore(26,i)
                 enddo
             endif
!-- elimina i rifl. equivalenti nella classe a minore simmetria.
             jump=-13
             call sortzadp(xstore,nxxx,jump)
             if (imer.eq.1) then
                 nxx=0
                 ia=0
                 if (ia.ne.0)
     1                write(lo,*)'elimina gli equiv a piu bassa simm.'
                 do i=1,nxxx
                    if (xstore(13,i).gt.0.1) then
                        nxx=nxx+1
                        if (ia.ne.0) then
                            write(lo,'(i8,3f4.0,7f8.3,2f4.0,f12.0,
     1                      /,3(2f4.0,f12.0),f10.2)')
     1                      nxx,xstore(1:10,i),xstore(11:21,i),
     *                      xstore(26,i)
                        endif
                    endif
                 enddo
!                write(lo,*)'dopo sort nxxx,nxx',nxxx,nxx
                 nxxx=nxx
             endif
          enddo
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!
!          write(lo,*)'DetermLaue rint(1:6),ProbL(1:6)'
!     1    ,rint(1:6),ProbL(1:6)
          noProbL=0
          do jj=1,nclassLa
             if (rint(jj).ge.0) then
                 ProbL(jj)=1-0.03*rint(jj)
                 if (ProbL(jj).lt.0) ProbL(jj)=0.
!                write(lo,*)'jj,rint(jj),ProbL(jj)',jj,rint(jj),ProbL(jj)
             elseif (rint(jj).eq.-99) then
                 if(neutro.ne.2)then               !07set12
                    ProbL(1:nclassLa)=1.0          !07set12
                    noProbL=1                      !07set12
                    exit                           !07set12
                 endif                             !07set12
             endif
          enddo
!                write(lo,*)'2 rint(1:6),ProbL(1:6)',rint(1:6),ProbL(1:6)
          probmxapp=0.
          do jj=1,nclassLa
             if (jj.gt.1.and.ProbL(jj).ge.probmxapp) then
                 probmxapp=ProbL(jj)
                 nclassapp=jj
             endif
          enddo
!          write(lo,*)'probmxapp,nclassapp ',probmxapp,nclassapp
          if(noProbL.eq.0)then
             if(probmxapp.le.0)then
                 probmxapp=1.
                 nclassapp=1
                 if (neutro /= 2) then
                     ProbL(1:nclassLa)=1.
                 endif
                 write(lo,*)'Values of R-int too high! '
                 write(lo,*)'Not possible to determine the Laue Group,'
                 write(lo,*)'only the lower symmetry group',
     1                      ' will be considered'
!-- correge la prob. della classe di Laue a minore simm.
             else if (probmxapp.gt.0.and.nclassLa.gt.1) then
                 jj=nclassapp
                 rappr=ProbL(jj)/ProbL(1)
                 write(lo,*)'jj,ProbL(1),ProbL(jj),rappr',
     1                       jj,ProbL(1),ProbL(jj),rappr
                 if (rappr.gt.0.90) then
                     if (ProbL(jj).ge.0.85) ProbL(1)=0.
                     if (ProbL(jj).lt.0.85) ProbL(1)=ProbL(1)**2
                 endif
                 write(lo,*)' 2 jj,ProbL(1),ProbL(jj),rappr',
     1                          jj,ProbL(1),ProbL(jj),rappr
                 if (msys.eq.6) then
                     if (jj.eq.5) then
                         rappr=ProbL(jj)/ProbL(4)
                         if (rappr.gt.0.90) then
                             if (ProbL(jj).ge.0.85) ProbL(4)=0.
                             if (ProbL(jj).lt.0.85) ProbL(4)=ProbL(4)**2
                         endif
                         write(lo,*)' msys=6 jj=5 jj,ProbL(1:6),rappr',
     1                             jj,ProbL(1:6),rappr
                     endif
                 endif
             endif
!
!             write(lo,*)'2 probmxapp,nclassapp ',probmxapp,nclassapp
!-- stampe finali
             write(lo,*)' '
             write(lo,*)' '
             do jj=1,nclassLa
                probc(jj)='  - '
                rintc(jj)='  - '
                if(rint(jj).gt.0.)write(rintc(jj),'(f6.2)')rint(jj)
                if(ProbL(jj).gt.0.)write(probc(jj),'(f6.2)')ProbL(jj)
             enddo
             write(lo,'(18x,5(2x,a8))')
     1           linest(1:nclassLa)
             write(lo,*)' '
             write(lo,'(a14,i10,5i10)') 
     1        ' N.Rif.indep.',nindep(1:nclassLa)
             write(lo,'(a14,i10,5i10)')
     1        ' N.R.senza eq.',nrefsing(1:nclassLa)
             write(lo,'(a14,f10.2,5f10.2)')
     1        '  < E  >   ',e1med(1:nclassLa)
             write(lo,'(a14,4x,6a10,4x,3a6)')
     1        '  R-int%   ',rintc(1:nclassLa)
             write(lo,'(a14,4x,6a10,4x,3a6)')
     1        '  ProbL  ',Probc(1:nclassLa)
!
!             write(lo,*)' '
!             write(lo,'(a,a)')
!             1' distribuzione dei rif. per numero di equivalenti '
!             1,'con il R-int corrispondente'
!             write(lo,*)' '
!             write(lo,'(16x,2(1x,a10),2x,a10,2x,3(1x,a10))')
!             1linest(1:nclassLa)
!             write(lo,*)' '
!             write(lo,'(a)')'    N.equiv.    NRif.  R%    NRif.  R% '
!             nnn=nlamat(nclassLa)
!             do i=1,nnn
!                write(lo,'(i11,2x,6(i6,f6.2))')i
!                1   ,(numequiv(kk,i),requi(kk,i),kk=1,nclassLa)
!             enddo
          else if(noProbL.eq.1)then
             write(lo,'(a,a)')
     1         ' not enought data, the probability of the Laue group'
     1        ,' will not be considered  '
          endif
      elseif (percssf.le.percmin.or.msys.le.4) then
!      if(percssf.le.50..and.msys.ge.4)
!     1 write(lo,*)' Low Percentage of semisphere given '
!      if(msys.le.4)
!     1 write(lo,*)' No Merohedral Twin Law for this Crystal System '
!       write(lo,*)' No Analyse will be performed '
          do jj=1,nclassLa
             ProbL(jj)=1.
          enddo
      endif 
!
      DEALLOCATE(sSphere, stat =ierr)
      DEALLOCATE(xstore, stat =ierr)
!
      return
      end
!--------------------------------------------------------------------
!code for SystemProb
          subroutine SystemProb(icode)
      USE General
      USE Symmetry, only : nsym, nSpaceG  
      USE Riflessi
      USE Laue
!
      common/conta/numtrovati,numequivv(6)
      common/dummy/reslim,nxxref
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/Twinsdet/ MatTwi(10,3,3),nMatTwi
     1,ihmax,ikmax,ilmax,ihmxx(3),lasomdim
      common/rintp/fosum,diffsum,rintres(10,5,2,25)
      common/probLaEle/numsysEle,RintSys(9,6),ProbSys(9,7),kfin,indprobs
     1,corrfattProb(9),ProbLsav(5),nomonoclino
!--
      dimension ihg(3),ihmxsu(3),Matt(96,3,3)
      dimension h(3),hg(3),indmx(48),ihm(3)

      double precision, allocatable :: xstore(:,:)
      real, allocatable :: sSphere(:,:,:)
      double precision  f1m,fosum,diffsum
      real e1med(6),fmedio(6),expprob(6)
      real rapnequiv(9,5),rapnequivv(9,5)
      integer numequivalenti(9,5),numindep(6),msysord(12),nindepp(9,5)
      character*16 line,dire,linestam,linest(30)
      character*16 rintc(6),probc(6)
      character*20 linn(9,7),linnea
!
      RintSys=0.
      ProbSys=0.
      y=1/6.
*gl*  y=1/8.
      iprsr02=1
      noprinta=1
      ifSalta = 0
      call LaueSys(noprinta, ifSalta)
      msysgeom=msys  !sistema compatibile con la geom. della cella
      if (icode.eq.1) then
          do j2=1,nclassLa
             line=linea(j2)
             linestam(1:16)=line(5:11)
             linest(j2)=linestam
!            write(lo,'(a,i7,a)')'j2,linestam',j2,linestam
          enddo
      endif
      if (icode.eq.0) nclassLa=1
      write(lo,'(a)')' '
!
!-- allocate work area for reflections (xstore)
      IF (.NOT. ALLOCATED(xstore))
     *ALLOCATE (xstore(1:26,1:nrefl), stat = ierr)
      if (ierr.ne.0) then
          write(lo,*) 'Rflct xstore Allocation error'
          stop 
      endif
!
!-- determina gli indici massimi della classe di Laue con massima sim,.
!-- compatibile con la geometria della cella (msys dato da anasyst)
!
      do j2=1,nclassLa
         if (icode.eq.1) then
             line=linea(j2)
!            write(lo,'(/,a,i5,3x,a)')' Laue group no.',j2,line
             call cutst(line,lenp,dire,lend)
             call lcase(line)
             lenp=16
             call onebl(line,lenp,ier)
             read(line,'(16a1)') nSpaceG
             call CreaSymmetryInfo(ier)
             call daList2aMatt(j2,Matt)
             ihmxx(:)=0
             ihh=ihmx(1)
             ik=ihmx(2)
             il=ihmx(3)
!         write(lo,*)'j2,n2,nordmat(j2,1:n2)',j2,n2,nordmat(j2,1:n2)
             do ll=1,nsym
                l=nordmat(j2,ll)
                ihg(1)=ihh*Matt(l,1,1)+ik*Matt(l,1,2)+il*Matt(l,1,3)
                ihg(2)=ihh*Matt(l,2,1)+ik*Matt(l,2,2)+il*Matt(l,2,3)
                ihg(3)=ihh*Matt(l,3,1)+ik*Matt(l,3,2)+il*Matt(l,3,3)
                do k=1,3
                   if (ihmxx(k).lt.iabs(ihg(k))) ihmxx(k)=iabs(ihg(k))
                enddo
             enddo
         elseif (icode.eq.0) then
             ihmxx(:)=ihmx(:)
         endif
         call LoadReflInfo
      enddo
!      write(lo,*)'msys,ihmxx',msys,ihmxx
      ihmax= 2*ihmxx(1)+1
      ikmax= 2*ihmxx(2)+1
      ilmax= 2*ihmxx(3)+1
!      write(lo,*)'msys,ihmxx,ihmax,ikmax,ilmax,nclassLa',
!     1msys,ihmxx,ihmax,ikmax,ilmax,nclassLa
!-- allocate work  reflections s/sphere (sSphere(hmax,kmax,lmax))
      IF (.NOT. ALLOCATED(sSphere))
     *ALLOCATE (sSphere(1:ihmax,1:ikmax,1:ilmax),stat = ierr)
      if (ierr.ne.0) then
          write(lo,*) 'sSphere Allocation error'
          stop 
      endif
      sSphere(:,:,:)=-1.
      nxxref=nrefl
      call xsto6dp(xstore) !storizza i rifl.con (res.lt.reslim) =nxxref
      write(lo,'(a,i6)') ' No. of reflections  = ',nrefl
      write(lo,'(a,f6.2)') ' Resolution limit    = ',reslim
      write(lo,'(a,i6)') ' No. of accepted     = ',nxxref

!-------------------------------------------------------------------------
!-- loop:storizza gli F per le 5 possibili classi di Laue,calcola gli <F>
!-- ia=1 :stampa gli F
!
      e1med(1:6)=0.
      e1me=0.
      fmed=0.
      ia=0
      do i=1,nxxref
         xstore(6:10,i)=xstore(4,i)   !usa gli Fo
         if (ia.ne.0) write(lo,'(3f4.0,7f8.3)')xstore(1:10,i)
         fmed=fmed+xstore(4,i)
         e1me=fmed
      enddo
      e1med(1:5)=e1me/nxxref
      fmed=fmed/nxxref
!--------------------------------------------------------------
!-- Per ogni sistema compatibile geometricamente, dal triclino a msysGeom:
!-- calcola il numero massimo di riflessi nella semisfera.
!------- calcola il Rint e Prob.per ogni classe di Laue
         write(lo,'(a)')' '
         write(lo,'(22x,a)')'*** Laue Class Determination ***'
        
!-- definisce i sistemi a sim. piu bassa goemetricamenta compatibili.
!-- msysgeom=msys definito de LaueSys
!                  tric. monoa monob monoc orto tet_c tet_a tet_b esag_c cub  romb
!-- lauesys          0     1     2     3     4    5      -     -    6     7    8 (msysgeom)
!-- lauesys_completo 0     1     2     3     4    5      6     7    8     9   10 (msys)
!-- sistemi compatibile (dati da lauesys_completo) con la geom. della cella (dati da lauesys):
!--geom----+--msysgeom------+--sistemi compatibili ---+ n.di sist --+--n.Fat.Prob.(refana)-+
!          |                |      (msys)             |  (numsys)   |    
!  romb    |        8       |     0 8                 |       2     |    3/4  
!  cubica  |        7       |     0 1 2 3 4 5 6 7 9   |       9     |    5/4
!  esag.   |        6       |     0 3 8               |       3     |    5/4
!  tet_c   |        5       |     0 1 2 3 4 5         |       6     |    2
!  ortog   |        4       |     0 1 2 3 4           |       5     |    2
!  monoc   |        3       |     0 3                 |       2     |    1
!  monob   |        2       |     0 2                 |       2     |    1
!  monoa   |        1       |     0 1                 |       2     |    1
!  tricl   |        0       |     0                   |       1     |    -
!
      numsys=msysgeom+1  !numsys:no. di sistemi  compatibili
      msysord(1)=0
      if(msysgeom.le.3.or.msysgeom.eq.8)then
         numsys=2
         msysord(2)=msysgeom
!      else if(msysgeom.eq.1)then
      else if(msysgeom.eq.0)then
         numsys=1
      else if(msysgeom.eq.4.or.msysgeom.eq.5)then
         numsys=msysgeom+1
         do i=2,numsys
            msysord(i)=i-1
         enddo
      else if(msysgeom.eq.6)then
         numsys=3
         msysord(2)=3
         msysord(3)=8
      else if(msysgeom.eq.7)then
         numsys=9
         do i=2,numsys
            msysord(i)=i-1
5         enddo
         msysord(9)=9
      endif
      numsysEle=numsys
      if (knw > 0)
     *   write(lo,'(a,i5,10i3)')
     1  '  numsys,msysord(1:numsys) ',numsys,msysord(1:numsys)
!-- comincia l'analisi dei sistemi compatibili
!           write(lo,'(a,a)')'ksys,jj,RintSys(ksys,jj),nLamat(jj),y,',
!     1     'rapneq,ProbSys(ksys,jj)'
      do ksys=1,numsys
         msys=msysord(ksys)
         RintSys(ksys,6)=msys
         ProbSys(ksys,6)=msys
         nxxx=nxxref
         numtrovati=0
         call LaueSys_completo ! trova nclassLa (no. di classi del sistema)
         numequivv(1:2)=0         
         e1med(1:2)=0.
         nindep(1:2)=0          
         do imerr=1,nclassLa
             numtrovati=0
             imer=imerr
             sSphere(:,:,:)=-1.
             line=linea(imer)
!             write(lo,'(/,a,3x,a)')' Laue group ',linea(imer)
             call cutst(line,lenp,dire,lend)
             call lcase(line)
             lenp=16
             call onebl(line,lenp,ier)
             read(line,'(16a1)') nSpaceG
             call CreaSymmetryInfo(ier)
             diffsum=0.0
             fosum=0.0
             call daList2aMatt(imer,Matt)
             do i=1,nxxx
                ihh= xstore(1,i)
                ik = xstore(2,i)
                il = xstore(3,i)
                fo = xstore(5+imer,i)
                imm=imer
                call storesSphere(sSphere,ihh,ik,il,fo,imm,Matt)
                xstore(11+3*(imer-1),i)=1
                if (imer.gt.1) xstore(11+3*(imer-1),i)=xstore(11,i)
                nord=i
                if (imer.eq.1.or.xstore(13,i).gt.0)
     1           jz= maxsuperind(xstore,sSphere,imer,nord,ihmxsu,Matt) 
             enddo
!-- sort i rifl. per superindice
             njump=-(10+3*(imer))
             call sortzadp(xstore,nxxx,njump)
             ia=0
!             if(msys.eq.4)ia=1
             if (ia.ne.0) then
                 write(lo,*)' prima di eliminare'
                 do i=1,nxxx
                    write(lo,'(i6,3f4.0,2f12.3
     1              ,2(2f4.0,f16.0),f10.2)')
     1              i,xstore(1:5,i),xstore(11:16,i),xstore(26,i)
                 enddo
             endif
!--rint vs. resol
             call Rintresol(xstore,nxxx,ksys,imerr)
!-- calcola R-int 
             if (imer.eq.1) then
                 call RintPerc(xstore,nxxx,imer,kstop)
             else
                 call RintPerc2(xstore,nxxx,imer,kstop)
 
             endif
             numequivalenti(ksys,imer)=numequivv(imer)
             nindepp(ksys,imer)=nindep(imer)
             RintSys(ksys,imer)=Rint(imer)    
             linn   (ksys,imer)=linea(imer)
!             write(lo,*)'ksys,imer,RintSys(ksys,imer)',
!     1         ksys,imer,RintSys(ksys,imer)
             ia=0
             if (ia.ne.0) then
                 write(lo,*)'dopo eliminare'
                 do i=1,nxxx
                    write(lo,'(i6,3f4.0,2f8.3
     1              ,2(2f4.0,f12.0),f10.2)')
     1              i,xstore(1:5,i),xstore(11:16,i),xstore(26,i)
                 enddo
             endif
!-- elimina i rifl. equivalenti nella classe a minore simmetria.
             jump=-13
             call sortzadp(xstore,nxxx,jump)
             if (imer.eq.1) then
                 nxx=0
                 ia=0
                 if (ia.ne.0)
     1                write(lo,*)'elimina gli equiv a piu bassa simm.'
                 do i=1,nxxx
                    if (xstore(13,i).gt.0.1) then
                        nxx=nxx+1
                        if (ia.ne.0) then
                            write(lo,'(i8,3f4.0,7f8.3,2f4.0,f12.0,
     1                      /,3(2f4.0,f12.0),f10.2)')
     1                      nxx,xstore(1:10,i),xstore(11:21,i),
     *                      xstore(26,i)
                        endif
                    endif
                 enddo
!                write(lo,*)'dopo sort nxxx,nxx',nxxx,nxx
                 nxxx=nxx
             endif
         enddo
         do jj=1,nclassLa
             if (RintSys(ksys,jj).ge.0) then
                 rapnequiv(ksys,jj)=nLaMat(jj)
                 rapneq=nLaMat(jj)**y 
                 rapnequivv(ksys,jj)=rapneq         
               ProbSys(ksys,jj)=(0.85-RintSys(ksys,jj)/100)*rapneq
!22apr                 ProbSys(ksys,jj)=(0.70 -RintSys(ksys,jj)/100)*rapneq
           if (ProbSys(ksys,jj).lt.0) ProbSys(ksys,jj)=0.
!                 write(lo,'(2i3,f8.3,i4,3f8.3)')
!     1           ,ksys,jj,RintSys(ksys,jj),nLamat(jj),y
!     1           ,rapneq,ProbSys(ksys,jj)
             elseif (rint(jj).eq.-99) then
                 RintSys(ksys,jj)=99.99
                 ProbSys(ksys,jj)=0.00
             endif
         enddo
      enddo
!
!
      probmx=0.
      Rintmx=0.
      do ksys=1,numsys
         msys=msysord(ksys)
         call lauesys_completo
         do jj=1,nclassLa
             if (ProbSys(ksys,jj).ge.probmx) then
                 probmx=ProbSys(ksys,jj)
                 nclassmx=jj
                 msysmx=ksys
             endif
             if (RintSys(ksys,jj).gt.99.and.msys.eq.0) cycle
             if (RintSys(ksys,jj).ge.Rintmx) Rintmx=RintSys(ksys,jj)
         enddo
!      write(lo,'(a,2i5,5f5.2)')'ksys,msys, ProbSys(ksys,1:5)'
!     1 ,ksys,msys, (ProbSys(ksys,kk),kk=1,5)  
      enddo
!      write(lo,'(a,2i5,5f5.2)')'msysapp nclassapp Probmxapp'
!     1 ,msysapp, nclassapp, Probmxapp  
      if (probmx.le.0)then
                 probmx=1.
                 msysmx=0    !triclino
            write(lo,*)'Values of R-int too high! '
            write(lo,*)'Not possible to determine the Laue Group,'
           write(lo,*)'only the lower symmetry group will be considered'
      endif
!-- normalizza le probabilita' 
      if(probmx.gt.0.)then
        do j=1,numsys
           msys=msysord(j)
           call lauesys_completo
           do i=1,nclassLa
             ProbSys(j,i)=(ProbSys(j,i)/probmx)
           enddo
        enddo
        probmx=1.
      endif
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!-- salva la prob. dei sistemi ripristinando l'ordine corrispondente alla subr. LaueSys 
!                  tric. monoa monob monoc orto tet_c tet_a tet_b esag_c cub  romb
!-- Lauesys_completo 0     1     2     3     4    5      6     7    8     9   10 
!-- LaueSys          0     1     2     3     4    5      -     -    6     7    8 
      do i=1,numsys
         msysnew=msysord(i)
         if(msysnew.le.5)then
            ProbSys(i,6)=msysnew
         else if(msysnew.eq.6.or.msysnew.eq.7)then
            ProbSys(i,6)=-1   !refana non accetta il 4/m //a e 4/m//b
         else if(msysnew.gt.7)then
            ProbSys(i,6)=msysnew-2
         endif
!         write(lo,'(a,i6,6f6.2)')
!     1   'i,(ProbSys(i,j),j=1,6)',i,(ProbSys(i,j),j=1,6)
      enddo


!-- stampa      
      write(lo,*)' '
      if (knw > 0) write(lo,'(a,f6.3,a)')' y =1/6= ',y
     1 ,'  Rapp=no.op.sym/no.op.sym.tric'
      write(lo,'(a,11x,a)')
     1'  Group  ','N.Refl.     Rint.     Prob.'!     Ratio   Ratio**y' 
      do j=1,numsys
         msys=msysord(j)
         call lauesys_completo
         do i=1,nclassLa
         linnea=linn(j,i)(3:20)
         if(msys.eq.5.and.i.eq.1)linnea=   ' 4/m     (along c)'
         if(msys.eq.5.and.i.eq.2)linnea=   ' 4/m m m (along c)'
         if(msys.eq.6.and.i.eq.1)linnea=   ' 4/m     (along a)'
         if(msys.eq.6.and.i.eq.2)linnea=   ' 4/m m m (along a)'
         if(msys.eq.7.and.i.eq.1)linnea=   ' 4/m     (along b)'
         if(msys.eq.7.and.i.eq.2)linnea=   ' 4/m m m (along b)'
         linn(j,i)=linnea
             rintc(1)='   -- '     
           if(RintSys(j,i).lt.99.)
     1      write(rintc(1),'(f6.2)')RintSys(j,i)
           if(msys.eq.0)then
           rapnequiv(1,1)=1
           rapnequivv(1,1)=1
           endif
           write(lo,'(a20,i6,4x,a6,f10.2,2f10.3)')
     1     linn(j,i),nindepp(j,i)             !,numequivalenti(j,i)
     1      ,Rintc(1),ProbSys(j,i)
!     1     ,rapnequiv(j,i),rapnequivv(j,i)
         enddo
      enddo
      write(lo,*)' '
      write(lo,*)' '
      call AssegnaSistema(numsys, msysord, linn, ProbSys,icode,j1,i1)
!      write(lo,'(a,i5,5f5.2)')'Passano a Refana :msysEle e ProbEle(1:5)'
!     1 ,msysEle,ProbEle(1:5)     
!
!
!-- Mercedes 31ott10 mi porto il sistema scelto dall'utente (ko=1),
!-- vedere il caso in cui l'utente sceglie Automatico (ko=0)!!!
!
       ko=0
       if(j1.gt.0)ko=1
       if(ko.eq.1)then  !sistema e laue group a scelta dell'utente
          a=ProbSys(j1,i1)
          ProbSys(1,:)=ProbSys(j1,:)
          ProbSys(1,1:5)= 0.
          ProbSys(1,i1)=a
          numsysEle=1
          msys=ProbSys(j1,6)
!       write(lo,*)'j1,i1,ko,ProbSys(1,1:7) ',j1,i1,ko,ProbSys(1,1:7)    
       else if(ko.eq.0)then  !l'utente sceglie la procedura automatica
           if(Rintmx.le.16.00)then     
!           if(Rintmx.le.1.00)then
              a=ProbSys(msysmx,nclassmx)
              ProbSys(1,:)=ProbSys(msysmx,:)
              ProbSys(1,1:5)=0.0
              ProbSys(1,nclassmx)=a
              numsysEle=1
              msys=ProbSys(msysmx,6)
           else
              numsysEle=numsys
           endif
!       write(lo,*)'ko, numsysEle ',ko, numsysEle    
       endif   
!
      DEALLOCATE(sSphere, stat =ierr)
      DEALLOCATE(xstore, stat =ierr)
!
      return
      end
!  
!code for daList2aMatt
      subroutine daList2aMatt(imerr,Matt)
      USE General
      USE Symmetry
      USE Laue
!
      dimension Matt(96,3,3),nordm(8,5,48)
!-- copia su Matt le trasposte di kmat, nello stesso ordine ,usa imer=1
!-- setta msys
      imer = imerr
      if (imerr == 0) imer=1
!
      if (jsys == 1) msys = 0
      if (jsys == 2) msys = 2
      if (jsys == 3) msys = 4
      if (jsys == 4) msys = 5
      if (jsys == 5) then
          msys = 6
!--p-3
          nordm(msys,1,1) = 1
          nordm(msys,1,2) = 2
          nordm(msys,1,3) = 3
!--p-3m1
          nordm(msys,2,1) = 1
          nordm(msys,2,2) = 2
          nordm(msys,2,3) = 3
          nordm(msys,2,4) = 5
          nordm(msys,2,5) = 6
          nordm(msys,2,6) = 4
!--p-31m
          nordm(msys,3,1) = 1
          nordm(msys,3,2) = 2
          nordm(msys,3,3) = 3
          nordm(msys,3,4) = 4
          nordm(msys,3,5) = 6
          nordm(msys,3,6) = 5
!--p6/m
          nordm(msys,4,1) = 1
          nordm(msys,4,2) = 4
          nordm(msys,4,3) = 2
          nordm(msys,4,4) = 3
          nordm(msys,4,5) = 6
          nordm(msys,4,6) = 5
!--p6/mmm
          nordm(msys,5,1) = 1
          nordm(msys,5,2) = 10
          nordm(msys,5,3) = 2
          nordm(msys,5,4) = 3
          nordm(msys,5,5) = 12
          nordm(msys,5,6) = 11
          nordm(msys,5,7) = 5
          nordm(msys,5,8) = 6
          nordm(msys,5,9) = 4
          nordm(msys,5,10) = 7
          nordm(msys,5,11) = 9
          nordm(msys,5,12) = 8
      else if (jsys == 6) then
          msys = 7
      else if (jsys == 7) then
          msys = 8
      endif
!      write(lo,*)'dalist2amatt imer',imer
!      matfin(imer)=nsym
!      write(lo,'(a)')' con kmat '
      do k=1, nsym
         i = k
!!!        if(msys.eq.6)i=nordm(msys,imer,k)
         nordmat(imer,i) = i
!        write(lo,*)' dalist5amatt i',i
         do j=1,3
            Matt(i,1,j) = kmat(i,j,1)  !(store(m2+3*(j-1)  ))
            Matt(i,2,j) = kmat(i,j,2)  !(store(m2+3*(j-1)+1))
            Matt(i,3,j) = kmat(i,j,3)  !(store(m2+3*(j-1)+2))
         enddo
!       write(lo,'(3i10)')matt(i,1,1),matt(i,1,2),matt(i,1,3)
!       write(lo,'(3i10)')matt(i,2,1),matt(i,2,2),matt(i,2,3)
!       write(lo,'(3i10)')matt(i,3,1),matt(i,3,2),matt(i,3,3)
!       write(lo,*)' '
      enddo
!
      return
      end
!--------------------------------------------------------------------
!
!code for xsto6dp
      subroutine xsto6dp(xstore)
      USE General
      USE Riflessi
*     USE Liste
!
!
!      xstore(1,i)= khl(1,i)
!      xstore(2,i)= khl(2,i)
!      xstore(3,i)= khl(3,i)
!      xstore(4,i)= fovet(i)
!      xstore(5,i)= sigmav(i)
!      xstore(6,i)= evet(i)  1 classelaue
!      xstore(7,i)= evet(i)  2 classelaue
!      xstore(8,i)= evet(i)  3 classelaue solo trig o esag.
!      xstore(9,i)= evet(i)  4 classelaue solo trig o esag.
!      xstore(10,i)= evet(i) 5 classelaue solo trig o esag.
!-- 3 posizioni per ognuna delle 5 classe di Laue
!-- 
!      xstore(11,i)= 1 (pensato per contenere no. equiv. RACC.)
!      xstore(12,i)= no.di equiv. TEOR. a meno del c.s.(epsilon)
!      xstore(13,i)= maximo superindice tra gli equivalenti.
!-- 
!      xstore(26,i)= <fo> per la prima classe de Laue 

      double precision :: xstore(26,nrefl)
      common/dummy/reslim,nxxref
!      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
!      dimension vett(18),ivett(18)
!      equivalence (vett,ivett)
!
!--store the reflections in the allocatable vector xstore
      xstore=0.
      ii=0
      do i=1,nrefl
         ihh=khl(1,i)
         ihk=khl(2,i)
         ihl=khl(3,i)
         rho= rhof(pp,khl(1,i),khl(2,i),khl(3,i))
         res=0.5/(rho)
!         if(res.lt.reslim)cycle
         ii=ii+1
         xstore(: ,ii )= 0.
         xstore(1 ,ii )= khl(1,i)
         xstore(2 ,ii )= khl(2,i)
         xstore(3 ,ii )= khl(3,i)
         xstore(4 ,ii )= fovet(i)
         xstore(5 ,ii )= sigmav(i)
!        write(lo,'(a,6x,3f4.0,7f8.3)')' xstore ',xstore(1:5,ii)
      enddo
      nxxref=ii
!
      return
      end
c
!code for sortzadp
      subroutine sortzadp(xstore,numb,jump)
      USE General
*     USE Liste
!
!--general sorting routine (double precision)
!
!  xstore : array to be used
!--numb :number of elements in the list
!--jump :function of the relative address(jaddress) of the variable
!         njump=-(13+(jclass-1)*3)
!  to be sort   (0.ge.jaddress.le.minc)
!  jump>0 increasing sorting ( jaddress=jump )
!  jump<0 decreasing sorting ( jaddress=iabs(jump)-1 )
!
      double precision  xstore(26,nrefl) ,f(26)
!
      jsign=1
      if(jump.lt.0)then 
         jump=iabs(jump)-1
         jsign=-1
      endif
      if(numb.le.1)return
      ja=2
      kVai = 1
      do while (kVai.eq.1)
        jb=numb/ja
        if(jb.le.0) jb=1
        jc=numb-jb
        jd=1
        do while (jd.eq.1)
           jd=0
           do i=1,jc
              ik =i +jb
              if((xstore(1 +jump,i)-xstore(1 +jump,ik))*jsign.gt.0)then
                do je=1,26
                  f(je)= xstore(je,i)
                  xstore(je,i)= xstore(je,ik)
                  xstore(je,ik)= f(je)
                enddo
              jd=1
              endif
           enddo
        enddo
        if(jb.gt.1)then
             ja=ja*2
        else
             kVai=0
        endif
      enddo
      return
      end

!
!code for NormLaueGr
      subroutine NormLaueGr(ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Molcom
      USE MadModule
      USE PhaseModule
!
      common /misurato/ misu

!
!--
!     sapi
      common /rsc/ ibgr,mg,mig(8),scl,bts(9),scs(9),ip(8,3,5)
      common /Estat/ nst,nrw,stl(10),rsv(10),rhr(10),nhr(10),nu(25),
     *               ava(10),avc(10),avh(10),cph(25),
     *               vst(10),zt(25),ee(10)
      dimension ivat(3)
can
      dimension sigv(10,4),isigv(10,2),isigp(10,2)
can
!gianluca 20/01/2011
      s3=0
      s2=0
      if (neutro == 2 .and. zeff(1) > 0.0) then
          do i=1,nk
             ss=float(nw(i))*zeff(i)*zeff(i)
             s2=s2+ss
             s3=s3+ss*zeff(i)
          enddo
      else
          do i=1,nk
             ss=float(nw(i))*no(i)*no(i)
             s2=s2+ss
             s3=s3+ss*no(i)
          enddo
      endif
      s3s2=s3/sqrt(s2**3)
      call UpdateReflInfo
!gianluca 20/01/2011
      ifMercedes = 1
      call norm2000(ifMercedes, ier)
      return
      end
!
!code for epsMedio   
      function epsMedio(ih,ik,il,mmssys,nncla,khlclass)
      USE General
      USE Laue
!
      epsMedio=1.
      if(ih==0.and.il/=0)then
        if(ik==0)then                  !00l
        khlclass=1
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
        else if(ik==il)then            !0ll
        khlclass=11
        epsMedio=epsmed(mmssys,nncla,khlclass)
        else if(ik==-il)then           !0l-l
        khlclass=12
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
        else                           !0kl      
        khlclass=6
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
        endif
      else if(ik==0.and.ih/=0)then
        if(il==0)then                  !h00
          khlclass=3
        epsMedio=epsmed(mmssys,nncla,khlclass)
          return
        else if(ih==il)then            !h0h
          khlclass=9
        epsMedio=epsmed(mmssys,nncla,khlclass)
          return
        else if(ih==-il)then           !h0-h
          khlclass=10
        epsMedio=epsmed(mmssys,nncla,khlclass)
          return
        else                           !h0l      
          khlclass=5
        epsMedio=epsmed(mmssys,nncla,khlclass)
          return
        endif
      else if(il==0.and.ik/=0)then  
        if(ih==0)then                  !0k0
          khlclass=2
        epsMedio=epsmed(mmssys,nncla,khlclass)
          return
        else if(ih==ik)then            !hh0
          khlclass=7
        epsMedio=epsmed(mmssys,nncla,khlclass)
          return
        else if(ih==-il)then           !h-h0
          khlclass=8
        epsMedio=epsmed(mmssys,nncla,khlclass)
          return
        else if(ik==-2*ih)then         !h-2h0
          khlclass=13
        epsMedio=epsmed(mmssys,nncla,khlclass)
        else if(ih==-2*ih)then           !h-h0
          khlclass=14
        epsMedio=epsmed(mmssys,nncla,khlclass)
          return
        else                            !hk0      
          khlclass=4
        epsMedio=epsmed(mmssys,nncla,khlclass)
          return
        endif
      else if(ik== ih.and.il== ih)then  !hhh
        khlclass=15
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
      else if(ik==-ih.and.il==-ih)then  !-hhh
        khlclass=16
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
      else if(ik==-ih.and.il== ih)then  !h-hh
        khlclass=17
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
      else if(ik== ih.and.il==-ih)then  !hh-h
        khlclass=18
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
      else if(il== ik)then               !hll
        khlclass=19
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
      else if(il==-ik)then               !hl-l
        khlclass=20
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
      else if(il== ih)then               !hkh
        khlclass=21
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
      else if(il==-ih)then               !hk-h
        khlclass=22
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
      else if(ik== ih)then               !hhl
        khlclass=23
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
      else if(ik==-ih)then               !h-hl
        khlclass=24
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
      else if(ik==-2*ih)then              !h-2hl
        khlclass=25
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
      else if(ih==-2*ik)then               !2h-hl
        khlclass=26
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
      else                                 !hkl
        khlclass=27
        epsMedio=epsmed(mmssys,nncla,khlclass)
        return
      endif
      return
      end
!
!code for trovaRintresol
      function TrovaRintResol(ress)
      USE General
*     USE Liste
      USE Laue
!
      common/conta/numtrovati,numequivv(6)
      common/rintp/fosum,diffsum,rintres(10,5,2,25)
      double precision fosum,diffsum
!
      n=0
      do nn=1,25
               if (ress.gt.tabmiss(nn)) then
                  n = nn 
                  exit
               endif
      enddo
      TrovaRintResol=n
      return
      end
!
!code for Rintresol
      subroutine RintResol(xstore,nxxx,ksys,jclass)
      USE General
*     USE Liste
      USE Laue
!
      common/conta/numtrovati,numequivv(6)
      common/rintp/fosum,diffsum,rintres(10,5,2,25)
      double precision fosum,diffsum
      double precision :: xstore(26,nrefl)
      double precision xindo
      dimension foe(300)
      character*8 aa
!
!--prepara tabella rint in funzione della resol.
      tabmiss( 1) =10.0
      tabmiss( 2) = 8.0
      tabmiss( 3) = 6.0
      tabmiss( 4) = 5.0
      tabmiss( 5) = 4.0
      tabmiss( 6) = 3.0
      tabmiss( 7) = 2.5
      tabmiss( 8) = 2.0
      tabmiss( 9) = 1.8
      tabmiss(10) = 1.6
      tabmiss(11) = 1.4
      tabmiss(12) = 1.3
      tabmiss(13) = 1.2
      tabmiss(14) = 1.1
      tabmiss(15) = 1.0
      tabmiss(16) = 0.9
      tabmiss(17) = 0.8
      tabmiss(18) = 0.7
      tabmiss(19) = 0.6
      tabmiss(20) = 0.5
      tabmiss(21) = 0.4
      tabmiss(22) = 0.3
      tabmiss(23) = 0.2
      tabmiss(24) = 0.1
      tabmiss(25) = 0.001
      rintres(ksys,jclass,1,25)=0.  !n.rif.    !rintres(10,5,2,25)
      rintres(ksys,jclass,2,25)=99. !Rint    !rintres(10,5,2,25)
!      nmiss(1:25,1) = 0
      fosig(1:25,2)=0.
!
      j1=1
      mm=10+(jclass-1)*3
!
!      write(lo,*)'inizia rintresol nxxx',nxxx
1000  continue
!-- resol
      kkh=xstore(1 ,j1 )
      kkk=xstore(2 ,j1 )
      kkl=xstore(3 ,j1 )
      rhot= rhof(pp,kkh,kkk,kkl)
      resoll=0.5/rhot
      n=0
      do nn=1,25
               if (resoll.gt.tabmiss(nn)) then
                  n = nn 
                  exit
               endif
      enddo
      xindo=xstore(3+mm,j1)
      nueqq=1
      foe (nueqq)=xstore(6,j1)
      do j=j1+1,nxxx
         if (xindo.eq.xstore(3+mm,j).and.j.lt.nxxx) then
             nueqq=nueqq+1
             foe (nueqq)=xstore(6,j)
         else if (xindo.ne.xstore(3+mm,j).or.j.eq.nxxx) then
            if (nueqq.gt.1) then
               f1=0.
               do i=1,nueqq   !-- calcola <f>
                    f1=f1+foe(i)
               enddo
               f1m=f1/nueqq
!  
               do i=1,nueqq   !-- Rint vs. resol
!       fosig(n,1) = fosig(n,1) +abs(foe(i)-f1m)
       rintres(ksys,jclass,2,n)=rintres(ksys,jclass,2,n)+abs(foe(i)-f1m)
       fosig(n,2) = fosig(n,2) + f1m
                 enddo
       rintres(ksys,jclass,1,n)=rintres(ksys,jclass,1,n)+1          
!                   nmiss(n,1) = nmiss(n,1) + 1
             endif
             j1=j
             exit
         endif
      enddo
      if (j1+1.lt.nxxx.and.xstore(3+mm,j1).gt.0.1) go to 1000
!
!-- Rint vs. resol
!      write( lo,*)'rint vs.resol ksys,jclass',ksys,jclass
      do n=1,24
      aa='   --   '
        if(fosig(n,2).gt.0.)then
          b=rintres(ksys,jclass,2,n)/fosig(n,2)
          rintres(ksys,jclass,2,n)=b
!          write(aa,'(f8.3)')b
        endif     
!        if(n.eq.1)then
!          write(lo,'(a,3x,i7,a)')
!     1    '  Up to 10.0   ',nint(rintres(ksys,jclass,1,n)),aa
!        else
!          write(lo,'(f6.3,a,f6.3,3x,i7,a)')
!     1   tabmiss(n-1),' - ',tabmiss(n),nint(rintres(ksys,jclass,1,n)),aa
!        endif
      enddo
!      write(lo,*)'fine rintresol ksys,jclass',ksys,jclass
      return
      end
!
!code for RintPerc
      subroutine RintPerc(xstore,nxxx,jclass,kstop)
      USE General
*     USE Liste
      USE Laue
!
      common/conta/numtrovati,numequivv(6)
      double precision :: xstore(26,nrefl)
      double precision xindo,fosum
      dimension foe(300)
      character*8 aa
!
!
      kstop=0
      kequiteo=1
      j1=1
      mm=10+(jclass-1)*3
!
      s=0.
      fosum=0.0
      sigsum=0.0
      d=0.0
      dw=0.
      ds=0.
      nuequi=0
      perc=0.
      indep=0
      isingle=0
      deno=0.
      ncontaeq=0
!      write(lo,*)'inizia rintperc nxxx',nxxx
1000  continue
      f1=0.
      d1=0.
      s2=0.
      xindo=xstore(3+mm,j1)
      kequiteo=nint(xstore(2+mm,j1))
      deno=deno+xstore(2+mm,j1)
      iconto=0
      nueqq=0
      do j=j1+1,nxxx
         if (jclass.eq.1) then
             xstore(26,j)=xstore(6,j)
         endif
         jo=j
         iconto=iconto+1
!         write(lo,*)'j,indep ',j,indep
         if (xindo.eq.xstore(3+mm,j)) then
!--elimina gli equiv.
             if (jclass.eq.1) then
                 xstore(3+mm,j)=-abs(xstore(3+mm,j))
             endif
!--
             if (nueqq.eq.0) then
                 nueqq=nueqq+1
                 ffo=xstore(6,j1)
                 foe (nueqq)=ffo
!                write(lo,'(i6,3f4.0)')
!                1j,xstore(j ),xstore(j+1),xstore(j+2)
!                write(lo,'(3i6,f12.0,22x,3f10.3)')
!                1nueqq,nuequi,kequiteo,xindo,xstore(m6o+6),foe(nueqq)
             endif
             nueqq=nueqq+1
             ffo=xstore(6,j)
             foe (nueqq)=ffo
             xstore(1+mm,j1)=xstore(1+mm,j1)+xstore(1+mm,j)
!            write(lo,'(3i6,2f12.0,4f10.3)')
!            1nueqq,nuequi,kequiteo,xindo,xstore(j+mm+3),xstore(m6o+mm+1)
!            1,xstore(j+mm+1),foe(nueqq)
         else if (xindo.ne.xstore(3+mm,j)) then
             if (nueqq.gt.0) then
!-- calcola <f>
                 do i=1,nueqq
                    f1=f1+foe(i)
                 enddo
                 fosum=fosum+f1
                 f1m=f1/nueqq
!-- storizzo in 26,j1 il < f > dei rifl. equiv. a piu' bassa simm.
!xx
!xx
                 if (jclass.eq.1) xstore(26,j1)=f1m
!xx
!xx
!  
                 do i=1,nueqq
                    d1=d1+abs(foe(i)-f1m)
!                   write(lo,*)'i,foe(i),f1m,d1,nueqq',i,foe(i),f1m,d1,nueqq
                 enddo
                 d=d+d1
!                write(lo,*)'j,nueqq,d,fosum',j,nueqq,d,fosum
             elseif (nueqq.eq.0) then
                 isingle=isingle+1
             endif
!      write(lo,'(a,i6,3f4.0,2f8.3)')
!     1'  j, h k l E resoll,nueqq '
!     1  ,j,xstore(1:3,j1),xstore(6,j1),resoll,nueqq
             indep=indep+1
             nn=xstore(2+mm,j1)
             nuequi=nuequi+nn
             numequiv(jclass,nn)=numequiv(jclass,nn)+1
             fome(jclass,nn)=fome(jclass,nn)+f1
             diff(jclass,nn)=diff(jclass,nn)+d1
             j1=j
             exit
         endif
      enddo
      if (j1+1.lt.nxxx.and.xstore(3+mm,j1).gt.0.1) go to 1000
!
      nindep(jclass)=indep
      nrefsing(jclass)=isingle
!-- average values
      numindconeq=indep-isingle
      fosum=fosum/nuequi
      fomed (jclass)=fosum
      numequivv(jclass)=nuequi
!--r-int
!      write(lo,*)'jclass,indep,isingle ',jclass,indep,isingle
      if (nuequi.gt.0.and.indep.gt.isingle) then
          dmed=d/nuequi
          rint1=100.*dmed/fosum
!         write(lo,'(a,i4,i8,3f15.3,f8.2)')
!     1    ' jclass,nuequi,d,dmed,fosum,rint1 ',
!     1   jclass,nuequi,d,dmed,fosum,rint1 
!          write(lo,*)'rintperc1 :rint1,nuequi,dmed,fosum'
!     1    ,rint1,nuequi,dmed,fosum
          rint  (jclass)=rint1
!         write(lo,*)' jclass,rint(jclass) ',jclass,rint(jclass)
      elseif (nuequi.eq.0.or.indep.eq.isingle) then
          kstop=1
          rint (jclass)=-99.
          ProbL(jclass)=-99.
      endif
!      write(lo,*)'jclass,indep,rint(jclass) ',jclass,indep,rint(jclass)

      return
      end
!
!code for RintPerc2
      subroutine RintPerc2(xstore,nxxx,jclass,kstop)
      USE General
*     USE Liste
      USE Laue
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/rintp/fosum,diffsum,rintres(10,5,2,25)
      double precision :: xstore(26,nrefl)
      double precision xindo,fosum,diffsum
!
      kstop=0
      kequiteo=1
      numb=nxxx
      jump=-(13+(jclass-1)*3)
      call sortzadp(xstore,numb,jump)
      j1=1
      mm=10+(jclass-1)*3
!      write(lo,*)'Rintperc2,jclass,diffsum,fosum',
!     1 jclass,diffsum,fosum
!
      nuequi=0
      perc=0.
      indep=0
      isingle=0
      deno=0.
1000  continue
      xindo=xstore(3+mm,j1)
      kequiteo=nint(xstore(2+mm,j1))
!      write(lo,*)'dopo 1000 m6,m6o,xindo',m6,m6o,xindo
      iconto=0
      nueqq=0
      do j=j1+1,nxxx
         jo=j
         if (xindo.eq.xstore(3+mm,j)) then
!--elimina gli equiv.
             xstore(3+mm,j)=-abs(xstore(3+mm,j))
             xstore(1+mm,j1)=xstore(1+mm,j1)+xstore(1+mm,j)
         elseif (xindo.ne.xstore(3+mm,j)) then
             j1=j
             exit
         endif
      enddo
      if (j1+1.lt.nxxx.and.xstore(3+mm,j1).gt.0.1) go to 1000
!     write(lo,*)'rint2,diffsum,fosum',diffsum,fosum
      nindep(jclass)=0
      isingle=0
      do j=1,nxxx
!        write(lo,'(3f4.0,7f8.3,2f4.0,f12.0,
!        1             /,3(2f4.0,f12.0))')
!        1       xstore(j:j+9),xstore(j+10:j+19)
         if (xstore(3+mm,j).gt.0) nindep(jclass)=nindep(jclass)+1
         if (xstore(3+mm,j).eq.1) isingle=isingle+1
      enddo
!     write(lo,*)'nindep(jclass) ',nindep(jclass)
!     nindep(jclass)=indep
      nrefsing(jclass)=isingle
      fomed (jclass)=fosum
!     write(lo,*)'rint2,diffsum,fosum',diffsum,fosum
!--r-int
      if (fosum.gt.0) then
          rint1=100.*diffsum/fosum
          if (rint1.gt.100) rint1=100.
!         write(lo,*)'Rintperc2,rint,diffsum,fosum',rint1,diffsum,fosum
          rint(jclass)=rint1
!--ProbL
      else 
          rint(jclass)=-99.
          ProbL(jclass)=-99.
      endif
!      write(lo,*)'2 jclass,rint(jclass),ProbL(jclass) ',
!      1jclass,rint(jclass),ProbL(jclass)
!      write(lo,*)
!
      return
      end
c
!code for maxsuperind
      function maxsuperind(xstore,sSphere,j2,nord,ihm,Matt)
      USE General
*     USE Liste
      USE Laue
!
!  in  is 1 or 2 for not use or use friedel's law
!--
      common/conta/numtrovati,numequivv(6)
      common/rintp/fosum,diffsum,rintres(10,5,2,25)
      common/Twinsdet/ MatTwi(10,3,3),nMatTwi
     1,ihmax,ikmax,ilmax,ihmxx(3),lasomdim
c
      dimension h(3),hg(3),indmx(48),ihm(3),Matt(96,3,3)
      double precision :: xstore(26,nrefl)
      double precision  f1m,fosum,diffsum
      real sSphere(ihmax,ikmax,ilmax)
!--
      indmx(:)=0
      numeqteo =0
      indmax=0
      nn=0
      d1=0.
      f1=0.
      mm=10+(j2-1)*3
!--set default values for the indices and transformed indices
      h(1:3)=xstore(1:3,nord)
      n=0
      if (j2.gt.1) then
          ind=xstore(13,nord)
          f1m=xstore(26,nord)
          indmx(1)=ind
          indmax=ind
          n=1
      endif
!--pass through the different symmetry positions
      i1=matini(j2)
      i2=matfin(j2)
!     write(lo,*)'j2,i1,i2',j2,i1,i2
      numeq=(i2-i1+1)*2
      do l=i1,i2
!        if(i1.ne.1)then
!        write(lo,*)' LaMat(l)  l=',l
!        write(lo,*)LaMat(l,1,1:3)
!        write(lo,*)LaMat(l,2,1:3)
!        write(lo,*)LaMat(l,3,1:3)
!        endif
!--calculate the transformed indices
         hg(1)=h(1)*LaMat(l,1,1)+h(2)*LaMat(l,1,2)+h(3)*LaMat(l,1,3)
         hg(2)=h(1)*LaMat(l,2,1)+h(2)*LaMat(l,2,2)+h(3)*LaMat(l,2,3)
         hg(3)=h(1)*LaMat(l,3,1)+h(2)*LaMat(l,3,2)+h(3)*LaMat(l,3,3)
c
         jisig=1
         do j=1,2
            ihh=jisig*hg(1)
            ikk=jisig*hg(2)
            ill=jisig*hg(3)
            n=n+1
            call pack2002(ind,ihh,ikk,ill)
            ihh=jisig*hg(1)
            ikk=jisig*hg(2)
            ill=jisig*hg(3)
            indmx(n)=ind
            new=0
            if (n.gt.1) then
               do jj=1,n-1
                  if (indmx(n).eq.indmx(jj)) new=1
               enddo
            endif
!      if(h(1).eq.1.and.h(2).eq.0.and.h(3).eq.0)
!     1 write(lo,'(3i5,6f5.0,3i4,i20)')n,jisig,new,h,hg,ihh,ikk,ill,ind
!      write(lo,'(3i5,6f5.0,3i4,i20)')n,jisig,new,h,hg,ihh,ikk,ill,ind
            if (new.eq.0) then
                numeqteo=numeqteo+1
!-- per i gruppi di simm. superiore
                fobs=1.
                if (j2.gt.1.and.
     1              cercaFo(sSphere,ihh,ikk,ill,fobs,j2,Matt).ge.0) then
!      write(lo,'(a,3i5,6f5.0,3i4,i20,2f8.2)')
!     1'n,jisig,new,h,hg,ihh,ikk,ill,ind,fobs,f1m',
!     1n,jisig,new,h,hg,ihh,ikk,ill,ind,fobs,f1m
                    diffsum=diffsum+abs(Fobs-f1m)
                    fosum=fosum+Fobs
                    d1=d1+abs(Fobs-f1m)
                    f1=f1+Fobs
                    nn=nn+1
                    numequivv(j2)=numequivv(j2)+nn
!      write(lo,'(a,3i4,f10.2,5d10.2)')
!     1'h,k,l,fobs,fosum,f1m,diffsum,f1,d1',
!     1ihh,ikk,ill,fobs,fosum,f1m,diffsum,f1,d1
                endif
c
                if (indmx(n).gt.indmax) then
                    indmax=indmx(n)
                    ihm(1)=ihh
                    ihm(2)=ikk
                    ihm(3)=ill
                endif
            endif
!           write
!     1(lo,'(a,3f5.0,3i4,2i5,2i12)')
!     1 'h,ihh,ikk,ill,n,nteo,indmx(n),indmax ',
!     1 h,ihh-512,ikk-512,ill-512,n,numeqteo,indmx(n),indmax
!           endif
            jisig=-1
         enddo
      enddo  
      numeqteo=numeqteo/2                                                             
      mm=10+(j2-1)*3
      if (j2.gt.1) xstore(1+mm,nord)=1
      if (j2.gt.1.and.nn.gt.0) xstore(1+mm,nord)=nn
      xstore(2+mm,nord)=numeqteo
      xstore(3+mm,nord)=indmax
!      write(lo,'(a,3f5.0,2i14)')'h,indmax,numeqteo=(m6+11)'
!      1,h,indmax,numeqteo
      maxsuperind=0
2600  continue
      return
3000  continue
      maxsuperind=-1
      go to 2600
      end
!                                                             
!code for LaueSys
      subroutine LaueSys(noprinta, ifSalta) 
      USE General
      USE Laue
!
!-- set msys 
!     msys=0  tricl. 
!     msys=1  mono a
!     msys=2  mono b
!     msys=3  mono c
!     msys=4  ortor. 
!     msys=5  tetrag. 
!     msys=6  hexag. 
!     msys=7  cubic 
!     msys=8 rhombo. 
!
!      write(lo,*)'inizia lauesys'
      if (ifSalta == 0) then
          call anasyst(msys,noprinta)
      endif
!
!-- nlinea(msys+1) = no. di laue class (nclassLa)
      nlinea(1)=1
      nlinea(2)=1
      nlinea(3)=1
      nlinea(4)=1
      nlinea(5)=1
      nlinea(6)=2
      nlinea(7)=5
      nlinea(8)=2
      nlinea(9)=2
!
!-- set  possibili classe di Laue per ogni msys
!-- set  le matrice delle classe di Laue per ogni msys (le mat sono gia trasposte!!!)
      nlin=nlinea(msys+1)
      nclassLa=nlin
!

      if (msys == 0) then
          linea(1) = ' P  -1        '
          nLaMat(1) = 1
          matini(1)=1
          matfin(1)=1
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
      elseif (msys == 1) then
          linea(1) = ' P  2/m 1 1   '
          nLaMat(1) = 2
          matini(1)=1
          matfin(1)=2
!          write(lo,'(a)') linea(2)
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
!-- (x,-y,-z)
          LaMat(2,1,1)= 1;      LaMat(2,1,2)= 0;       LaMat(2,1,3)= 0
          LaMat(2,2,1)= 0;      LaMat(2,2,2)=-1;       LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;       LaMat(2,3,3)=-1
      elseif (msys == 2) then
          linea(1) = ' P  1 2/m 1   '
          nLaMat(1) = 2
          matini(1)=1
          matfin(1)=2
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
!-- (-x,y,-z)
          LaMat(2,1,1)=-1;      LaMat(2,1,2)= 0;       LaMat(2,1,3)= 0
          LaMat(2,2,1)= 0;      LaMat(2,2,2)= 1;       LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;       LaMat(2,3,3)=-1
!
      elseif (msys == 3) then
          linea(1) = ' P  1 1 2/m   '
          nLaMat(1) = 2
          matini(1)=1
          matfin(1)=2
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
!-- (-x,-y,z)
          LaMat(2,1,1)=-1;      LaMat(2,1,2)= 0;       LaMat(2,1,3)= 0
          LaMat(2,2,1)= 0;      LaMat(2,2,2)=-1;       LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;       LaMat(2,3,3)= 1
      elseif (msys.eq.4) then
          linea(1)=' P  m m m     '
          nLaMat(1)=4
          matini(1)=1
          matfin(1)=4
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
!-- (-x,-y,z)
          LaMat(2,1,1)=-1;      LaMat(2,1,2)= 0;       LaMat(2,1,3)= 0
          LaMat(2,2,1)= 0;      LaMat(2,2,2)=-1;       LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;       LaMat(2,3,3)= 1
!-- (-x,y,-z)
          LaMat(3,1,1)=-1;      LaMat(3,1,2)= 0;       LaMat(3,1,3)= 0
          LaMat(3,2,1)= 0;      LaMat(3,2,2)= 1;       LaMat(3,2,3)= 0
          LaMat(3,3,1)= 0;      LaMat(3,3,2)= 0;       LaMat(3,3,3)=-1
!-- (x,-y,-z)
          LaMat(4,1,1)= 1;      LaMat(4,1,2)= 0;       LaMat(4,1,3)= 0
          LaMat(4,2,1)= 0;      LaMat(4,2,2)=-1;       LaMat(4,2,3)= 0
          LaMat(4,3,1)= 0;      LaMat(4,3,2)= 0;       LaMat(4,3,3)=-1
!
      elseif (msys == 5) then    !4//c
          linea(1)=' P  4/m       '
          linea(2)=' P  4/m m m   '
          matini(1)=1
          matfin(1)=4
          matini(2)=5
          matfin(2)=8
          nLaMat(1)=4
          nLaMat(2)=8
!-- P4/m
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
!-- (-x,-y,z)  (2 in Tab.Int)
          LaMat(2,1,1)=-1;      LaMat(2,1,2)= 0;       LaMat(2,1,3)= 0
          LaMat(2,2,1)= 0;      LaMat(2,2,2)=-1;       LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;       LaMat(2,3,3)= 1
!-- (-y,x,z)  (3 in Tab.Int)
          LaMat(3,1,1)= 0;      LaMat(3,1,2)= 1;       LaMat(3,1,3)= 0
          LaMat(3,2,1)=-1;      LaMat(3,2,2)= 0;       LaMat(3,2,3)= 0
          LaMat(3,3,1)= 0;      LaMat(3,3,2)= 0;       LaMat(3,3,3)= 1
!-- (y,-x,z)  (4 in Tab.Int)
          LaMat(4,1,1)= 0;      LaMat(4,1,2)=-1;       LaMat(4,1,3)= 0
          LaMat(4,2,1)= 1;      LaMat(4,2,2)= 0;       LaMat(4,2,3)= 0
          LaMat(4,3,1)= 0;      LaMat(4,3,2)= 0;       LaMat(4,3,3)= 1
!-- P4/mmm
!-- (-x,y,-z)  (5 in Tab.Int)
          LaMat(5,1,1)=-1;      LaMat(5,1,2)= 0;       LaMat(5,1,3)= 0
          LaMat(5,2,1)= 0;      LaMat(5,2,2)= 1;       LaMat(5,2,3)= 0
          LaMat(5,3,1)= 0;      LaMat(5,3,2)= 0;       LaMat(5,3,3)=-1
!-- (x,-y,-z)  (6 in Tab.Int)
          LaMat(6,1,1)= 1;      LaMat(6,1,2)= 0;       LaMat(6,1,3)= 0
          LaMat(6,2,1)= 0;      LaMat(6,2,2)=-1;       LaMat(6,2,3)= 0
          LaMat(6,3,1)= 0;      LaMat(6,3,2)= 0;       LaMat(6,3,3)=-1
!-- (y,x,-z)  (7 in Tab.Int)
          LaMat(7,1,1)= 0;      LaMat(7,1,2)= 1;       LaMat(7,1,3)= 0
          LaMat(7,2,1)= 1;      LaMat(7,2,2)= 0;       LaMat(7,2,3)= 0
          LaMat(7,3,1)= 0;      LaMat(7,3,2)= 0;       LaMat(7,3,3)=-1
!-- (-y,-x,-z)  (1 in Tab.Int)
          LaMat(8,1,1)= 0;      LaMat(8,1,2)=-1;       LaMat(8,1,3)= 0
          LaMat(8,2,1)=-1;      LaMat(8,2,2)= 0;       LaMat(8,2,3)= 0
          LaMat(8,3,1)= 0;      LaMat(8,3,2)= 0;       LaMat(8,3,3)=-1
!
      elseif (msys == 6 .or. msys == 8) then
      if (msys == 6) nclassLa=5
      if (msys == 8) nclassLa=2
          linea(1)=' P  -3        '
          linea(2)=' P  -3 m 1    '
          linea(3)=' P  -3 1 m    '
          linea(4)=' P  6/m       '
          linea(5)=' P  6/m m m   '
!
          matini(1)=1
          matfin(1)=3
          matini(2)=4
          matfin(2)=6
          matini(3)=7
          matfin(3)=9
          matini(4)=10
          matfin(4)=12
          matini(5)=4
          matfin(5)=12
!
          nLaMat(1)=3
          nLaMat(2)=6
          nLaMat(3)=6
          nLaMat(4)=6
          nLaMat(5)=12
!
          do j=1,5
             nn=3
             if (j.eq.2) nn=6
             if (j.eq.5) nn=12
             do i=1,nn
                nordmat(j,i)=i
             enddo
            if (j.eq.3) then
                do i=4,6
                   nordmat(j,i)=3+i
                enddo
            elseif (j.eq.4) then
                do i=4,6
                   nordmat(j,i)=6+i
                enddo
            endif
          enddo
!
!----P6/mmm (P-3 + P-3m1 + P-31m + P6/m )
!
!----P-3
!-- (x,y,z)  (1 in Tab.Int)
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
!-- (-y,x-y,z) (2 in Tab.Int)
          LaMat(2,1,1)= 0;      LaMat(2,1,2)= 1;       LaMat(2,1,3)= 0
          LaMat(2,2,1)=-1;      LaMat(2,2,2)=-1;       LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;       LaMat(2,3,3)= 1
!-- (-x+y,-x,z) (3 in Tab.Int)
          LaMat(3,1,1)=-1;      LaMat(3,1,2)=-1;       LaMat(3,1,3)= 0
          LaMat(3,2,1)= 1;      LaMat(3,2,2)= 0;       LaMat(3,2,3)= 0
          LaMat(3,3,1)= 0;      LaMat(3,3,2)= 0;       LaMat(3,3,3)= 1
!
!---- P -3 m 1
!-- (y,x,-z) (7 in Tab.Int)
          LaMat(4,1,1)= 0;      LaMat(4,1,2)= 1;      LaMat(4,1,3)= 0
          LaMat(4,2,1)= 1;      LaMat(4,2,2)= 0;      LaMat(4,2,3)= 0
          LaMat(4,3,1)= 0;      LaMat(4,3,2)= 0;      LaMat(4,3,3)=-1
!-- (x-y,-y,-z) (8 in Tab.Int)
          LaMat(5,1,1)= 1;      LaMat(5,1,2)= 0;      LaMat(5,1,3)= 0
          LaMat(5,2,1)=-1;      LaMat(5,2,2)=-1;      LaMat(5,2,3)= 0
          LaMat(5,3,1)= 0;      LaMat(5,3,2)= 0;      LaMat(5,3,3)=-1
!-- (-x,-x+y,-z) (9 in Tab.Int)
          LaMat(6,1,1)=-1;      LaMat(6,1,2)=-1;      LaMat(6,1,3)= 0
          LaMat(6,2,1)= 0;      LaMat(6,2,2)= 1;      LaMat(6,2,3)= 0
          LaMat(6,3,1)= 0;      LaMat(6,3,2)= 0;      LaMat(6,3,3)=-1
!---- P-3 1 m
!-- (-y,-x,-z) (10 in Tab.Int)
          LaMat(7,1,1)= 0;      LaMat(7,1,2)=-1;      LaMat(7,1,3)= 0
          LaMat(7,2,1)=-1;      LaMat(7,2,2)= 0;      LaMat(7,2,3)= 0
          LaMat(7,3,1)= 0;      LaMat(7,3,2)= 0;      LaMat(7,3,3)=-1
!-- (-x+y,y,-z) (11 in Tab.Int)
          LaMat(8,1,1)=-1;      LaMat(8,1,2)= 0;      LaMat(8,1,3)= 0
          LaMat(8,2,1)= 1;      LaMat(8,2,2)= 1;      LaMat(8,2,3)= 0
          LaMat(8,3,1)= 0;      LaMat(8,3,2)= 0;      LaMat(8,3,3)=-1
!-- (x,x-y,-z) (12 in Tab.Int)
          LaMat(9,1,1)= 1;      LaMat(9,1,2)= 1;      LaMat(9,1,3)= 0
          LaMat(9,2,1)= 0;      LaMat(9,2,2)=-1;      LaMat(9,2,3)= 0
          LaMat(9,3,1)= 0;      LaMat(9,3,2)= 0;      LaMat(9,3,3)=-1
!---- P 6/m
!-- (-x,-y,z) (4 in Tab.Int)
          LaMat(10,1,1)=-1;     LaMat(10,1,2)= 0;     LaMat(10,1,3)= 0
          LaMat(10,2,1)= 0;     LaMat(10,2,2)=-1;     LaMat(10,2,3)= 0
          LaMat(10,3,1)= 0;     LaMat(10,3,2)= 0;     LaMat(10,3,3)= 1
!-- (y,-x+y,z) (5 in Tab.Int)
          LaMat(11,1,1)= 0;     LaMat(11,1,2)=-1;     LaMat(11,1,3)= 0
          LaMat(11,2,1)= 1;     LaMat(11,2,2)= 1;     LaMat(11,2,3)= 0
          LaMat(11,3,1)= 0;     LaMat(11,3,2)= 0;     LaMat(11,3,3)= 1
!-- (x-y,x,-z) (6 in Tab.Int))
          LaMat(12,1,1)= 1;     LaMat(12,1,2)= 1;     LaMat(12,1,3)= 0
          LaMat(12,2,1)=-1;     LaMat(12,2,2)= 0;     LaMat(12,2,3)= 0
          LaMat(12,3,1)= 0;     LaMat(12,3,2)= 0;     LaMat(12,3,3)= 1
!
      elseif (msys == 7) then
          nclassLa=2
          matini(1)=1
          matfin(1)=12
          matini(2)=13
          matfin(2)=24
!
          linea(1)=' P  m -3      '
          linea(2)=' P  m -3 m    '
!
          nLaMat(1)=12
          nLaMat(2)=24
!
          nmat0=12
          nmatgr=24
!---- Pm-3
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;      LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;      LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;      LaMat(1,3,3)= 1
!-- (-x,-y,z)  (2 in Tab.Int)
          LaMat(2,1,1)=-1;      LaMat(2,1,2)= 0;      LaMat(2,1,3)= 0
          LaMat(2,2,1)= 0;      LaMat(2,2,2)=-1;      LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;      LaMat(2,3,3)= 1
!-- (-x,y,-z)  (3 in Tab.Int)
          LaMat(3,1,1)=-1;      LaMat(3,1,2)= 0;      LaMat(3,1,3)= 0
          LaMat(3,2,1)= 0;      LaMat(3,2,2)= 1;      LaMat(3,2,3)= 0
          LaMat(3,3,1)= 0;      LaMat(3,3,2)= 0;      LaMat(3,3,3)=-1
!-- (x,-y,-z)  (4 in Tab.Int)
          LaMat(4,1,1)= 1;      LaMat(4,1,2)= 0;      LaMat(4,1,3)= 0
          LaMat(4,2,1)= 0;      LaMat(4,2,2)=-1;      LaMat(4,2,3)= 0
          LaMat(4,3,1)= 0;      LaMat(4,3,2)= 0;      LaMat(4,3,3)=-1
!-- (z,x,y)  (5 in Tab.Int)
          LaMat(5,1,1)= 0;      LaMat(5,1,2)= 1;      LaMat(5,1,3)= 0
          LaMat(5,2,1)= 0;      LaMat(5,2,2)= 0;      LaMat(5,2,3)= 1
          LaMat(5,3,1)= 1;      LaMat(5,3,2)= 0;      LaMat(5,3,3)= 0
!-- (z,-x,-y)  (6 in Tab.Int)
          LaMat(6,1,1)= 0;      LaMat(6,1,2)=-1;      LaMat(6,1,3)= 0
          LaMat(6,2,1)= 0;      LaMat(6,2,2)= 0;      LaMat(6,2,3)=-1
          LaMat(6,3,1)= 1;      LaMat(6,3,2)= 0;      LaMat(6,3,3)= 0
!-- (-z,-x,y)  (7 in Tab.Int)
          LaMat(7,1,1)= 0;      LaMat(7,1,2)=-1;      LaMat(7,1,3)= 0
          LaMat(7,2,1)= 0;      LaMat(7,2,2)= 0;      LaMat(7,2,3)= 1
          LaMat(7,3,1)=-1;      LaMat(7,3,2)= 0;      LaMat(7,3,3)= 0
!-- (-z,x,-y)  (8 in Tab.Int)
          LaMat(8,1,1)= 0;      LaMat(8,1,2)= 1;      LaMat(8,1,3)= 0
          LaMat(8,2,1)= 0;      LaMat(8,2,2)= 0;      LaMat(8,2,3)=-1
          LaMat(8,3,1)=-1;      LaMat(8,3,2)= 0;      LaMat(8,3,3)= 0
!-- (y,z,x)  (9 in Tab.Int)
          LaMat(9,1,1)= 0;      LaMat(9,1,2)= 0;      LaMat(9,1,3)= 1
          LaMat(9,2,1)= 1;      LaMat(9,2,2)= 0;      LaMat(9,2,3)= 0
          LaMat(9,3,1)= 0;      LaMat(9,3,2)= 1;      LaMat(9,3,3)= 0
!-- (-y,z,-x)  (10 in Tab.Int)
          LaMat(10,1,1)= 0;      LaMat(10,1,2)= 0;      LaMat(10,1,3)=-1
          LaMat(10,2,1)=-1;      LaMat(10,2,2)= 0;      LaMat(10,2,3)= 0
          LaMat(10,3,1)= 0;      LaMat(10,3,2)= 1;      LaMat(10,3,3)= 0
!-- (y,-z,-x)  (11 in Tab.Int)
          LaMat(11,1,1)= 0;      LaMat(11,1,2)= 0;      LaMat(11,1,3)=-1
          LaMat(11,2,1)= 1;      LaMat(11,2,2)= 0;      LaMat(11,2,3)= 0
          LaMat(11,3,1)= 0;      LaMat(11,3,2)=-1;      LaMat(11,3,3)= 0
!-- (-y,-z,x)  (12 in Tab.Int)
          LaMat(12,1,1)= 0;      LaMat(12,1,2)= 0;      LaMat(12,1,3)= 1
          LaMat(12,2,1)=-1;      LaMat(12,2,2)= 0;      LaMat(12,2,3)= 0
          LaMat(12,3,1)= 0;      LaMat(12,3,2)=-1;      LaMat(12,3,3)= 0
!-- P m-3m
!-- (y,x,-z)   (13 in Tab.Int)
          LaMat(13,1,1)= 0;      LaMat(13,1,2)= 1;      LaMat(13,1,3)= 0
          LaMat(13,2,1)= 1;      LaMat(13,2,2)= 0;      LaMat(13,2,3)= 0
          LaMat(13,3,1)= 0;      LaMat(13,3,2)= 0;      LaMat(13,3,3)=-1
!-- (-y,-x,-z)  (14 in Tab.;Int)
          LaMat(14,1,1)= 0;      LaMat(14,1,2)=-1;      LaMat(14,1,3)= 0
          LaMat(14,2,1)=-1;      LaMat(14,2,2)= 0;      LaMat(14,2,3)= 0
          LaMat(14,3,1)= 0;      LaMat(14,3,2)= 0;      LaMat(14,3,3)=-1
!-- (y,-x,z)  (15 in Tab.Int)
          LaMat(15,1,1)= 0;      LaMat(15,1,2)=-1;      LaMat(15,1,3)= 0
          LaMat(15,2,1)= 1;      LaMat(15,2,2)= 0;      LaMat(15,2,3)= 0
          LaMat(15,3,1)= 0;      LaMat(15,3,2)= 0;      LaMat(15,3,3)= 1
!-- (-y,x,z)  (16 in Tab.Int)
          LaMat(16,1,1)= 0;      LaMat(16,1,2)= 1;      LaMat(16,1,3)= 0
          LaMat(16,2,1)=-1;      LaMat(16,2,2)= 0;      LaMat(16,2,3)= 0
          LaMat(16,3,1)= 0;      LaMat(16,3,2)= 0;      LaMat(16,3,3)= 1
!-- (x,z,-y)  (17 in Tab.Int)
          LaMat(17,1,1)= 1;      LaMat(17,1,2)= 0;      LaMat(17,1,3)= 0
          LaMat(17,2,1)= 0;      LaMat(17,2,2)= 0;      LaMat(17,2,3)=-1
          LaMat(17,3,1)= 0;      LaMat(17,3,2)= 1;      LaMat(17,3,3)= 0
!-- (-x,z,y)  (18 in Tab.Int)
          LaMat(18,1,1)=-1;      LaMat(18,1,2)= 0;      LaMat(18,1,3)= 0
          LaMat(18,2,1)= 0;      LaMat(18,2,2)= 0;      LaMat(18,2,3)= 1
          LaMat(18,3,1)= 0;      LaMat(18,3,2)= 1;      LaMat(18,3,3)= 0
!-- (-x,-z,-y)  (19 in Tab.Int)
          LaMat(19,1,1)=-1;      LaMat(19,1,2)= 0;      LaMat(19,1,3)= 0
          LaMat(19,2,1)= 0;      LaMat(19,2,2)= 0;      LaMat(19,2,3)=-1
          LaMat(19,3,1)= 0;      LaMat(19,3,2)=-1;      LaMat(19,3,3)= 0
!-- (x,-z,y)  (20 in Tab.Int)
          LaMat(20,1,1)= 1;      LaMat(20,1,2)= 0;      LaMat(20,1,3)= 0
          LaMat(20,2,1)= 0;      LaMat(20,2,2)= 0;      LaMat(20,2,3)= 1
          LaMat(20,3,1)= 0;      LaMat(20,3,2)=-1;      LaMat(20,3,3)= 0
!-- (z,y,-x)  (21 in Tab.Int)
          LaMat(21,1,1)= 0;      LaMat(21,1,2)= 0;      LaMat(21,1,3)=-1
          LaMat(21,2,1)= 0;      LaMat(21,2,2)= 1;      LaMat(21,2,3)= 0
          LaMat(21,3,1)= 1;      LaMat(21,3,2)= 0;      LaMat(21,3,3)= 0
!-- (z,-y,x)  (22 in Tab.Int)
          LaMat(22,1,1)= 0;      LaMat(22,1,2)= 0;      LaMat(22,1,3)= 1
          LaMat(22,2,1)= 0;      LaMat(22,2,2)=-1;      LaMat(22,2,3)= 0
          LaMat(22,3,1)= 1;      LaMat(22,3,2)= 0;      LaMat(22,3,3)= 0
!-- (-z,y,x)  (23 in Tab.Int)
          LaMat(23,1,1)= 0;      LaMat(23,1,2)= 0;      LaMat(23,1,3)= 1
          LaMat(23,2,1)= 0;      LaMat(23,2,2)= 1;      LaMat(23,2,3)= 0
          LaMat(23,3,1)=-1;      LaMat(23,3,2)= 0;      LaMat(23,3,3)= 0
!-- (-z,-y,-x)  (24 in Tab.Int)
          LaMat(24,1,1)= 0;      LaMat(24,1,2)= 0;      LaMat(24,1,3)=-1
          LaMat(24,2,1)= 0;      LaMat(24,2,2)=-1;      LaMat(24,2,3)= 0
          LaMat(24,3,1)=-1;      LaMat(24,3,2)= 0;      LaMat(24,3,3)= 0
!-- da Pm-3 a Pm-3m
!      LaMat(13,1,1)= 0
!      LaMat(13,1,2)= 1
!      LaMat(13,1,3)= 0
!      LaMat(13,2,1)= 1
!      LaMat(13,2,2)= 0
!      LaMat(13,2,3)= 0
!      LaMat(13,3,1)= 0
!      LaMat(13,3,2)= 0
!      LaMat(13,3,3)=-1
      endif
!      do i=1,nclassLa
!      i1=matini(i)
!      i2=matfin(i)
!        do l=i1,i2
!        write(lo,*)' LaMat(l)  l=',l
!        write(lo,*)LaMat(l,1,1:3)
!        write(lo,*)LaMat(l,2,1:3)
!        write(lo,*)LaMat(l,3,1:3)
!        enddo
!      enddo
!
!      write(lo,*)' fine lauesys'
      return
      end
!                                                             
!                                                             
!code for LaueSys_completo
      subroutine LaueSys_completo 
      USE General
      USE Laue
      dimension nnlinea(12)
!
!-- set msys 
!     msys=0  tricl. 
!     msys=1  mono a
!     msys=2  mono b
!     msys=3  mono c
!     msys=4  ortor. 
!     msys=5  tetrag. c 
!     msys=6  tetrag. a
!     msys=7  tetrag. b
!     msys=8  hexag. 
!     msys=9  cubic 
!     msys=10 rhombo. 
!
!-- nlinea(msys+1) = no. di laue class (nclassLa)
      nnlinea(1)=1
      nnlinea(2)=1
      nnlinea(3)=1
      nnlinea(4)=1
      nnlinea(5)=1
      nnlinea(6)=2
      nnlinea(7)=2
      nnlinea(8)=2
      nnlinea(9)=5
      nnlinea(10)=2
      nnlinea(11)=2
!
!-- set  possibili classe di Laue per ogni msys
!-- set  le matrice delle classe di Laue per ogni msys (le mat sono gia trasposte!!!)
      nnlin=nnlinea(msys+1)
      nclassLa=nnlin
!

      if (msys == 0) then
          linea(1) = ' P  -1        '
          nLaMat(1) = 1
          matini(1)=1
          matfin(1)=1
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
      elseif (msys == 1) then
          linea(1) = ' P  2/m 1 1   '
          nLaMat(1) = 2
          matini(1)=1
          matfin(1)=2
!          write(lo,'(a)') linea(2)
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
!-- (x,-y,-z)
          LaMat(2,1,1)= 1;      LaMat(2,1,2)= 0;       LaMat(2,1,3)= 0
          LaMat(2,2,1)= 0;      LaMat(2,2,2)=-1;       LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;       LaMat(2,3,3)=-1
      elseif (msys == 2) then
          linea(1) = ' P  1 2/m 1   '
          nLaMat(1) = 2
          matini(1)=1
          matfin(1)=2
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
!-- (-x,y,-z)
          LaMat(2,1,1)=-1;      LaMat(2,1,2)= 0;       LaMat(2,1,3)= 0
          LaMat(2,2,1)= 0;      LaMat(2,2,2)= 1;       LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;       LaMat(2,3,3)=-1
!
      elseif (msys == 3) then
          linea(1) = ' P  1 1 2/m   '
          nLaMat(1) = 2
          matini(1)=1
          matfin(1)=2
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
!-- (-x,-y,z)
          LaMat(2,1,1)=-1;      LaMat(2,1,2)= 0;       LaMat(2,1,3)= 0
          LaMat(2,2,1)= 0;      LaMat(2,2,2)=-1;       LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;       LaMat(2,3,3)= 1
      elseif (msys.eq.4) then
          linea(1)=' P  m m m     '
          nLaMat(1)=4
          matini(1)=1
          matfin(1)=4
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
!-- (-x,-y,z)
          LaMat(2,1,1)=-1;      LaMat(2,1,2)= 0;       LaMat(2,1,3)= 0
          LaMat(2,2,1)= 0;      LaMat(2,2,2)=-1;       LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;       LaMat(2,3,3)= 1
!-- (-x,y,-z)
          LaMat(3,1,1)=-1;      LaMat(3,1,2)= 0;       LaMat(3,1,3)= 0
          LaMat(3,2,1)= 0;      LaMat(3,2,2)= 1;       LaMat(3,2,3)= 0
          LaMat(3,3,1)= 0;      LaMat(3,3,2)= 0;       LaMat(3,3,3)=-1
!-- (x,-y,-z)
          LaMat(4,1,1)= 1;      LaMat(4,1,2)= 0;       LaMat(4,1,3)= 0
          LaMat(4,2,1)= 0;      LaMat(4,2,2)=-1;       LaMat(4,2,3)= 0
          LaMat(4,3,1)= 0;      LaMat(4,3,2)= 0;       LaMat(4,3,3)=-1
!
      elseif (msys == 5) then    !4//c
          linea(1)=' P  4/m       '
          linea(2)=' P  4/m m m   '
          matini(1)=1
          matfin(1)=4
          matini(2)=5
          matfin(2)=8
          nLaMat(1)=4
          nLaMat(2)=8
!-- P4/m
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
!-- (-x,-y,z)  (2 in Tab.Int)
          LaMat(2,1,1)=-1;      LaMat(2,1,2)= 0;       LaMat(2,1,3)= 0
          LaMat(2,2,1)= 0;      LaMat(2,2,2)=-1;       LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;       LaMat(2,3,3)= 1
!-- (-y,x,z)  (3 in Tab.Int)
          LaMat(3,1,1)= 0;      LaMat(3,1,2)= 1;       LaMat(3,1,3)= 0
          LaMat(3,2,1)=-1;      LaMat(3,2,2)= 0;       LaMat(3,2,3)= 0
          LaMat(3,3,1)= 0;      LaMat(3,3,2)= 0;       LaMat(3,3,3)= 1
!-- (y,-x,z)  (4 in Tab.Int)
          LaMat(4,1,1)= 0;      LaMat(4,1,2)=-1;       LaMat(4,1,3)= 0
          LaMat(4,2,1)= 1;      LaMat(4,2,2)= 0;       LaMat(4,2,3)= 0
          LaMat(4,3,1)= 0;      LaMat(4,3,2)= 0;       LaMat(4,3,3)= 1
!-- P4/mmm
!-- (-x,y,-z)  (5 in Tab.Int)
          LaMat(5,1,1)=-1;      LaMat(5,1,2)= 0;       LaMat(5,1,3)= 0
          LaMat(5,2,1)= 0;      LaMat(5,2,2)= 1;       LaMat(5,2,3)= 0
          LaMat(5,3,1)= 0;      LaMat(5,3,2)= 0;       LaMat(5,3,3)=-1
!-- (x,-y,-z)  (6 in Tab.Int)
          LaMat(6,1,1)= 1;      LaMat(6,1,2)= 0;       LaMat(6,1,3)= 0
          LaMat(6,2,1)= 0;      LaMat(6,2,2)=-1;       LaMat(6,2,3)= 0
          LaMat(6,3,1)= 0;      LaMat(6,3,2)= 0;       LaMat(6,3,3)=-1
!-- (y,x,-z)  (7 in Tab.Int)
          LaMat(7,1,1)= 0;      LaMat(7,1,2)= 1;       LaMat(7,1,3)= 0
          LaMat(7,2,1)= 1;      LaMat(7,2,2)= 0;       LaMat(7,2,3)= 0
          LaMat(7,3,1)= 0;      LaMat(7,3,2)= 0;       LaMat(7,3,3)=-1
!-- (-y,-x,-z)  (1 in Tab.Int)
          LaMat(8,1,1)= 0;      LaMat(8,1,2)=-1;       LaMat(8,1,3)= 0
          LaMat(8,2,1)=-1;      LaMat(8,2,2)= 0;       LaMat(8,2,3)= 0
          LaMat(8,3,1)= 0;      LaMat(8,3,2)= 0;       LaMat(8,3,3)=-1
      elseif (msys == 6) then       !4//a
          linea(1)=' P  4/m       '
          linea(2)=' P  4/m m m   '
          matini(1)=1
          matfin(1)=4
          matini(2)=5
          matfin(2)=8
          nLaMat(1)=4
          nLaMat(2)=8
!-- P4/m
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
!-- (x,-y,-z)  (2 in Tab.Int)
          LaMat(2,1,1)= 1;      LaMat(2,1,2)= 0;       LaMat(2,1,3)= 0
          LaMat(2,2,1)= 0;      LaMat(2,2,2)=-1;       LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;       LaMat(2,3,3)=-1
!-- (x,-z,y)  (3 in Tab.Int)
          LaMat(3,1,1)= 1;      LaMat(3,1,2)= 0;       LaMat(3,1,3)= 0
          LaMat(3,2,1)= 0;      LaMat(3,2,2)= 0;       LaMat(3,2,3)= 1
          LaMat(3,3,1)= 0;      LaMat(3,3,2)=-1;       LaMat(3,3,3)= 0
!-- (x,z,-y)  (4 in Tab.Int)
          LaMat(4,1,1)= 1;      LaMat(4,1,2)= 0;       LaMat(4,1,3)= 0
          LaMat(4,2,1)= 0;      LaMat(4,2,2)= 0;       LaMat(4,2,3)=-1
          LaMat(4,3,1)= 0;      LaMat(4,3,2)= 1;       LaMat(4,3,3)= 0
!-- P4/mmm
!-- (-x,y,-z)  (5 in Tab.Int)
          LaMat(5,1,1)=-1;      LaMat(5,1,2)= 0;       LaMat(5,1,3)= 0
          LaMat(5,2,1)= 0;      LaMat(5,2,2)= 1;       LaMat(5,2,3)= 0
          LaMat(5,3,1)= 0;      LaMat(5,3,2)= 0;       LaMat(5,3,3)=-1
!-- (-x,-y,z)  (6 in Tab.Int)
          LaMat(6,1,1)=-1;      LaMat(6,1,2)= 0;       LaMat(6,1,3)= 0
          LaMat(6,2,1)= 0;      LaMat(6,2,2)=-1;       LaMat(6,2,3)= 0
          LaMat(6,3,1)= 0;      LaMat(6,3,2)= 0;       LaMat(6,3,3)= 1
!-- (-x,z,y)  (7 in Tab.Int)
          LaMat(7,1,1)=-1;      LaMat(7,1,2)= 0;       LaMat(7,1,3)= 0
          LaMat(7,2,1)= 0;      LaMat(7,2,2)= 0;       LaMat(7,2,3)= 1
          LaMat(7,3,1)= 0;      LaMat(7,3,2)= 1;       LaMat(7,3,3)= 0
!-- (-x,-z,-y)  (1 in Tab.Int)
          LaMat(8,1,1)=-1;      LaMat(8,1,2)= 0;       LaMat(8,1,3)= 0
          LaMat(8,2,1)= 0;      LaMat(8,2,2)= 0;       LaMat(8,2,3)=-1
          LaMat(8,3,1)= 0;      LaMat(8,3,2)=-1;       LaMat(8,3,3)= 0


      elseif (msys == 7) then    !4//b
          linea(1)=' P  4/m       '
          linea(2)=' P  4/m m m   '
          matini(1)=1
          matfin(1)=4
          matini(2)=5
          matfin(2)=8
          nLaMat(1)=4
          nLaMat(2)=8
!-- P4/m
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
!-- (-x,y,-z)  (2 in Tab.Int)
          LaMat(2,1,1)=-1;      LaMat(2,1,2)= 0;       LaMat(2,1,3)= 0
          LaMat(2,2,1)= 0;      LaMat(2,2,2)= 1;       LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;       LaMat(2,3,3)=-1
!-- (z,y,-x)  (3 in Tab.Int)
          LaMat(3,1,1)= 0;      LaMat(3,1,2)= 0;       LaMat(3,1,3)=-1
          LaMat(3,2,1)= 0;      LaMat(3,2,2)= 1;       LaMat(3,2,3)= 0
          LaMat(3,3,1)= 1;      LaMat(3,3,2)= 0;       LaMat(3,3,3)= 0 
!-- (-z,y,x)  (4 in Tab.Int)
          LaMat(4,1,1)= 0;      LaMat(4,1,2)= 0;       LaMat(4,1,3)= 1
          LaMat(4,2,1)= 0;      LaMat(4,2,2)= 1;       LaMat(4,2,3)= 0
          LaMat(4,3,1)=-1;      LaMat(4,3,2)= 0;       LaMat(4,3,3)= 0
!-- P4/mmm
!-- (x,-y,-z)  (5 in Tab.Int)
          LaMat(5,1,1)= 1;      LaMat(5,1,2)= 0;       LaMat(5,1,3)= 0
          LaMat(5,2,1)= 0;      LaMat(5,2,2)=-1;       LaMat(5,2,3)= 0
          LaMat(5,3,1)= 0;      LaMat(5,3,2)= 0;       LaMat(5,3,3)=-1
!-- (-x,-y,z)  (6 in Tab.Int)
          LaMat(6,1,1)=-1;      LaMat(6,1,2)= 0;       LaMat(6,1,3)= 0
          LaMat(6,2,1)= 0;      LaMat(6,2,2)=-1;       LaMat(6,2,3)= 0
          LaMat(6,3,1)= 0;      LaMat(6,3,2)= 0;       LaMat(6,3,3)= 1
!-- (z,-y,x)  (7 in Tab.Int)
          LaMat(7,1,1)= 0;      LaMat(7,1,2)= 0;       LaMat(7,1,3)= 1
          LaMat(7,2,1)= 0;      LaMat(7,2,2)=-1;       LaMat(7,2,3)= 0
          LaMat(7,3,1)= 1;      LaMat(7,3,2)= 0;       LaMat(7,3,3)= 0
!-- (-z,-y,-x)  (1 in Tab.Int)
          LaMat(8,1,1)= 0;      LaMat(8,1,2)= 0;       LaMat(8,1,3)=-1
          LaMat(8,2,1)= 0;      LaMat(8,2,2)=-1;       LaMat(8,2,3)= 0
          LaMat(8,3,1)=-1;      LaMat(8,3,2)= 0;       LaMat(8,3,3)= 0



!
      elseif (msys == 8 .or. msys == 10) then   !esag.,romb
      if (msys == 8) nclassLa=5
      if (msys == 10) nclassLa=2
          linea(1)=' P  -3        '
          linea(2)=' P  -3 m 1    '
          linea(3)=' P  -3 1 m    '
          linea(4)=' P  6/m       '
          linea(5)=' P  6/m m m   '
!
          matini(1)=1
          matfin(1)=3
          matini(2)=4
          matfin(2)=6
          matini(3)=7
          matfin(3)=9
          matini(4)=10
          matfin(4)=12
          matini(5)=4
          matfin(5)=12
!
          nLaMat(1)=3
          nLaMat(2)=6
          nLaMat(3)=6
          nLaMat(4)=6
          nLaMat(5)=12
!
          do j=1,5
             nn=3
             if (j.eq.2) nn=6
             if (j.eq.5) nn=12
             do i=1,nn
                nordmat(j,i)=i
             enddo
            if (j.eq.3) then
                do i=4,6
                   nordmat(j,i)=3+i
                enddo
            elseif (j.eq.4) then
                do i=4,6
                   nordmat(j,i)=6+i
                enddo
            endif
          enddo
!
!----P6/mmm (P-3 + P-3m1 + P-31m + P6/m )
!
!----P-3
!-- (x,y,z)  (1 in Tab.Int)
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;       LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;       LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;       LaMat(1,3,3)= 1
!-- (-y,x-y,z) (2 in Tab.Int)
          LaMat(2,1,1)= 0;      LaMat(2,1,2)= 1;       LaMat(2,1,3)= 0
          LaMat(2,2,1)=-1;      LaMat(2,2,2)=-1;       LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;       LaMat(2,3,3)= 1
!-- (-x+y,-x,z) (3 in Tab.Int)
          LaMat(3,1,1)=-1;      LaMat(3,1,2)=-1;       LaMat(3,1,3)= 0
          LaMat(3,2,1)= 1;      LaMat(3,2,2)= 0;       LaMat(3,2,3)= 0
          LaMat(3,3,1)= 0;      LaMat(3,3,2)= 0;       LaMat(3,3,3)= 1
!
!---- P -3 m 1
!-- (y,x,-z) (7 in Tab.Int)
          LaMat(4,1,1)= 0;      LaMat(4,1,2)= 1;      LaMat(4,1,3)= 0
          LaMat(4,2,1)= 1;      LaMat(4,2,2)= 0;      LaMat(4,2,3)= 0
          LaMat(4,3,1)= 0;      LaMat(4,3,2)= 0;      LaMat(4,3,3)=-1
!-- (x-y,-y,-z) (8 in Tab.Int)
          LaMat(5,1,1)= 1;      LaMat(5,1,2)= 0;      LaMat(5,1,3)= 0
          LaMat(5,2,1)=-1;      LaMat(5,2,2)=-1;      LaMat(5,2,3)= 0
          LaMat(5,3,1)= 0;      LaMat(5,3,2)= 0;      LaMat(5,3,3)=-1
!-- (-x,-x+y,-z) (9 in Tab.Int)
          LaMat(6,1,1)=-1;      LaMat(6,1,2)=-1;      LaMat(6,1,3)= 0
          LaMat(6,2,1)= 0;      LaMat(6,2,2)= 1;      LaMat(6,2,3)= 0
          LaMat(6,3,1)= 0;      LaMat(6,3,2)= 0;      LaMat(6,3,3)=-1
!---- P-3 1 m
!-- (-y,-x,-z) (10 in Tab.Int)
          LaMat(7,1,1)= 0;      LaMat(7,1,2)=-1;      LaMat(7,1,3)= 0
          LaMat(7,2,1)=-1;      LaMat(7,2,2)= 0;      LaMat(7,2,3)= 0
          LaMat(7,3,1)= 0;      LaMat(7,3,2)= 0;      LaMat(7,3,3)=-1
!-- (-x+y,y,-z) (11 in Tab.Int)
          LaMat(8,1,1)=-1;      LaMat(8,1,2)= 0;      LaMat(8,1,3)= 0
          LaMat(8,2,1)= 1;      LaMat(8,2,2)= 1;      LaMat(8,2,3)= 0
          LaMat(8,3,1)= 0;      LaMat(8,3,2)= 0;      LaMat(8,3,3)=-1
!-- (x,x-y,-z) (12 in Tab.Int)
          LaMat(9,1,1)= 1;      LaMat(9,1,2)= 1;      LaMat(9,1,3)= 0
          LaMat(9,2,1)= 0;      LaMat(9,2,2)=-1;      LaMat(9,2,3)= 0
          LaMat(9,3,1)= 0;      LaMat(9,3,2)= 0;      LaMat(9,3,3)=-1
!---- P 6/m
!-- (-x,-y,z) (4 in Tab.Int)
          LaMat(10,1,1)=-1;     LaMat(10,1,2)= 0;     LaMat(10,1,3)= 0
          LaMat(10,2,1)= 0;     LaMat(10,2,2)=-1;     LaMat(10,2,3)= 0
          LaMat(10,3,1)= 0;     LaMat(10,3,2)= 0;     LaMat(10,3,3)= 1
!-- (y,-x+y,z) (5 in Tab.Int)
          LaMat(11,1,1)= 0;     LaMat(11,1,2)=-1;     LaMat(11,1,3)= 0
          LaMat(11,2,1)= 1;     LaMat(11,2,2)= 1;     LaMat(11,2,3)= 0
          LaMat(11,3,1)= 0;     LaMat(11,3,2)= 0;     LaMat(11,3,3)= 1
!-- (x-y,x,-z) (6 in Tab.Int))
          LaMat(12,1,1)= 1;     LaMat(12,1,2)= 1;     LaMat(12,1,3)= 0
          LaMat(12,2,1)=-1;     LaMat(12,2,2)= 0;     LaMat(12,2,3)= 0
          LaMat(12,3,1)= 0;     LaMat(12,3,2)= 0;     LaMat(12,3,3)= 1
!
      elseif (msys == 9) then
          nclassLa=2
          matini(1)=1
          matfin(1)=12
          matini(2)=13
          matfin(2)=24
!
          linea(1)=' P  m -3      '
          linea(2)=' P  m -3 m    '
!
          nLaMat(1)=12
          nLaMat(2)=24
!
          nmat0=12
          nmatgr=24
!---- Pm-3
!-- (x,y,z)  (1 in Tab.Int)
          LaMat(1,1,1)= 1;      LaMat(1,1,2)= 0;      LaMat(1,1,3)= 0
          LaMat(1,2,1)= 0;      LaMat(1,2,2)= 1;      LaMat(1,2,3)= 0
          LaMat(1,3,1)= 0;      LaMat(1,3,2)= 0;      LaMat(1,3,3)= 1
!-- (-x,-y,z)  (2 in Tab.Int)
          LaMat(2,1,1)=-1;      LaMat(2,1,2)= 0;      LaMat(2,1,3)= 0
          LaMat(2,2,1)= 0;      LaMat(2,2,2)=-1;      LaMat(2,2,3)= 0
          LaMat(2,3,1)= 0;      LaMat(2,3,2)= 0;      LaMat(2,3,3)= 1
!-- (-x,y,-z)  (3 in Tab.Int)
          LaMat(3,1,1)=-1;      LaMat(3,1,2)= 0;      LaMat(3,1,3)= 0
          LaMat(3,2,1)= 0;      LaMat(3,2,2)= 1;      LaMat(3,2,3)= 0
          LaMat(3,3,1)= 0;      LaMat(3,3,2)= 0;      LaMat(3,3,3)=-1
!-- (x,-y,-z)  (4 in Tab.Int)
          LaMat(4,1,1)= 1;      LaMat(4,1,2)= 0;      LaMat(4,1,3)= 0
          LaMat(4,2,1)= 0;      LaMat(4,2,2)=-1;      LaMat(4,2,3)= 0
          LaMat(4,3,1)= 0;      LaMat(4,3,2)= 0;      LaMat(4,3,3)=-1
!-- (z,x,y)  (5 in Tab.Int)
          LaMat(5,1,1)= 0;      LaMat(5,1,2)= 1;      LaMat(5,1,3)= 0
          LaMat(5,2,1)= 0;      LaMat(5,2,2)= 0;      LaMat(5,2,3)= 1
          LaMat(5,3,1)= 1;      LaMat(5,3,2)= 0;      LaMat(5,3,3)= 0
!-- (z,-x,-y)  (6 in Tab.Int)
          LaMat(6,1,1)= 0;      LaMat(6,1,2)=-1;      LaMat(6,1,3)= 0
          LaMat(6,2,1)= 0;      LaMat(6,2,2)= 0;      LaMat(6,2,3)=-1
          LaMat(6,3,1)= 1;      LaMat(6,3,2)= 0;      LaMat(6,3,3)= 0
!-- (-z,-x,y)  (7 in Tab.Int)
          LaMat(7,1,1)= 0;      LaMat(7,1,2)=-1;      LaMat(7,1,3)= 0
          LaMat(7,2,1)= 0;      LaMat(7,2,2)= 0;      LaMat(7,2,3)= 1
          LaMat(7,3,1)=-1;      LaMat(7,3,2)= 0;      LaMat(7,3,3)= 0
!-- (-z,x,-y)  (8 in Tab.Int)
          LaMat(8,1,1)= 0;      LaMat(8,1,2)= 1;      LaMat(8,1,3)= 0
          LaMat(8,2,1)= 0;      LaMat(8,2,2)= 0;      LaMat(8,2,3)=-1
          LaMat(8,3,1)=-1;      LaMat(8,3,2)= 0;      LaMat(8,3,3)= 0
!-- (y,z,x)  (9 in Tab.Int)
          LaMat(9,1,1)= 0;      LaMat(9,1,2)= 0;      LaMat(9,1,3)= 1
          LaMat(9,2,1)= 1;      LaMat(9,2,2)= 0;      LaMat(9,2,3)= 0
          LaMat(9,3,1)= 0;      LaMat(9,3,2)= 1;      LaMat(9,3,3)= 0
!-- (-y,z,-x)  (10 in Tab.Int)
          LaMat(10,1,1)= 0;      LaMat(10,1,2)= 0;      LaMat(10,1,3)=-1
          LaMat(10,2,1)=-1;      LaMat(10,2,2)= 0;      LaMat(10,2,3)= 0
          LaMat(10,3,1)= 0;      LaMat(10,3,2)= 1;      LaMat(10,3,3)= 0
!-- (y,-z,-x)  (11 in Tab.Int)
          LaMat(11,1,1)= 0;      LaMat(11,1,2)= 0;      LaMat(11,1,3)=-1
          LaMat(11,2,1)= 1;      LaMat(11,2,2)= 0;      LaMat(11,2,3)= 0
          LaMat(11,3,1)= 0;      LaMat(11,3,2)=-1;      LaMat(11,3,3)= 0
!-- (-y,-z,x)  (12 in Tab.Int)
          LaMat(12,1,1)= 0;      LaMat(12,1,2)= 0;      LaMat(12,1,3)= 1
          LaMat(12,2,1)=-1;      LaMat(12,2,2)= 0;      LaMat(12,2,3)= 0
          LaMat(12,3,1)= 0;      LaMat(12,3,2)=-1;      LaMat(12,3,3)= 0
!-- P m-3m
!-- (y,x,-z)   (13 in Tab.Int)
          LaMat(13,1,1)= 0;      LaMat(13,1,2)= 1;      LaMat(13,1,3)= 0
          LaMat(13,2,1)= 1;      LaMat(13,2,2)= 0;      LaMat(13,2,3)= 0
          LaMat(13,3,1)= 0;      LaMat(13,3,2)= 0;      LaMat(13,3,3)=-1
!-- (-y,-x,-z)  (14 in Tab.;Int)
          LaMat(14,1,1)= 0;      LaMat(14,1,2)=-1;      LaMat(14,1,3)= 0
          LaMat(14,2,1)=-1;      LaMat(14,2,2)= 0;      LaMat(14,2,3)= 0
          LaMat(14,3,1)= 0;      LaMat(14,3,2)= 0;      LaMat(14,3,3)=-1
!-- (y,-x,z)  (15 in Tab.Int)
          LaMat(15,1,1)= 0;      LaMat(15,1,2)=-1;      LaMat(15,1,3)= 0
          LaMat(15,2,1)= 1;      LaMat(15,2,2)= 0;      LaMat(15,2,3)= 0
          LaMat(15,3,1)= 0;      LaMat(15,3,2)= 0;      LaMat(15,3,3)= 1
!-- (-y,x,z)  (16 in Tab.Int)
          LaMat(16,1,1)= 0;      LaMat(16,1,2)= 1;      LaMat(16,1,3)= 0
          LaMat(16,2,1)=-1;      LaMat(16,2,2)= 0;      LaMat(16,2,3)= 0
          LaMat(16,3,1)= 0;      LaMat(16,3,2)= 0;      LaMat(16,3,3)= 1
!-- (x,z,-y)  (17 in Tab.Int)
          LaMat(17,1,1)= 1;      LaMat(17,1,2)= 0;      LaMat(17,1,3)= 0
          LaMat(17,2,1)= 0;      LaMat(17,2,2)= 0;      LaMat(17,2,3)=-1
          LaMat(17,3,1)= 0;      LaMat(17,3,2)= 1;      LaMat(17,3,3)= 0
!-- (-x,z,y)  (18 in Tab.Int)
          LaMat(18,1,1)=-1;      LaMat(18,1,2)= 0;      LaMat(18,1,3)= 0
          LaMat(18,2,1)= 0;      LaMat(18,2,2)= 0;      LaMat(18,2,3)= 1
          LaMat(18,3,1)= 0;      LaMat(18,3,2)= 1;      LaMat(18,3,3)= 0
!-- (-x,-z,-y)  (19 in Tab.Int)
          LaMat(19,1,1)=-1;      LaMat(19,1,2)= 0;      LaMat(19,1,3)= 0
          LaMat(19,2,1)= 0;      LaMat(19,2,2)= 0;      LaMat(19,2,3)=-1
          LaMat(19,3,1)= 0;      LaMat(19,3,2)=-1;      LaMat(19,3,3)= 0
!-- (x,-z,y)  (20 in Tab.Int)
          LaMat(20,1,1)= 1;      LaMat(20,1,2)= 0;      LaMat(20,1,3)= 0
          LaMat(20,2,1)= 0;      LaMat(20,2,2)= 0;      LaMat(20,2,3)= 1
          LaMat(20,3,1)= 0;      LaMat(20,3,2)=-1;      LaMat(20,3,3)= 0
!-- (z,y,-x)  (21 in Tab.Int)
          LaMat(21,1,1)= 0;      LaMat(21,1,2)= 0;      LaMat(21,1,3)=-1
          LaMat(21,2,1)= 0;      LaMat(21,2,2)= 1;      LaMat(21,2,3)= 0
          LaMat(21,3,1)= 1;      LaMat(21,3,2)= 0;      LaMat(21,3,3)= 0
!-- (z,-y,x)  (22 in Tab.Int)
          LaMat(22,1,1)= 0;      LaMat(22,1,2)= 0;      LaMat(22,1,3)= 1
          LaMat(22,2,1)= 0;      LaMat(22,2,2)=-1;      LaMat(22,2,3)= 0
          LaMat(22,3,1)= 1;      LaMat(22,3,2)= 0;      LaMat(22,3,3)= 0
!-- (-z,y,x)  (23 in Tab.Int)
          LaMat(23,1,1)= 0;      LaMat(23,1,2)= 0;      LaMat(23,1,3)= 1
          LaMat(23,2,1)= 0;      LaMat(23,2,2)= 1;      LaMat(23,2,3)= 0
          LaMat(23,3,1)=-1;      LaMat(23,3,2)= 0;      LaMat(23,3,3)= 0
!-- (-z,-y,-x)  (24 in Tab.Int)
          LaMat(24,1,1)= 0;      LaMat(24,1,2)= 0;      LaMat(24,1,3)=-1
          LaMat(24,2,1)= 0;      LaMat(24,2,2)=-1;      LaMat(24,2,3)= 0
          LaMat(24,3,1)=-1;      LaMat(24,3,2)= 0;      LaMat(24,3,3)= 0
!-- da Pm-3 a Pm-3m
!      LaMat(13,1,1)= 0
!      LaMat(13,1,2)= 1
!      LaMat(13,1,3)= 0
!      LaMat(13,2,1)= 1
!      LaMat(13,2,2)= 0
!      LaMat(13,2,3)= 0
!      LaMat(13,3,1)= 0
!      LaMat(13,3,2)= 0
!      LaMat(13,3,3)=-1
      endif
!      do i=1,nclassLa
!      i1=matini(i)
!      i2=matfin(i)
!        do l=i1,i2
!        write(lo,*)' LaMat(l)  l=',l
!        write(lo,*)LaMat(l,1,1:3)
!        write(lo,*)LaMat(l,2,1:3)
!        write(lo,*)LaMat(l,3,1:3)
!        enddo
!      enddo
!
      return
      end
!
!code for anasyst
      subroutine anasyst(msys,noprinta)
      USE General
      USE Symmetry, only : ifLaue
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
!
!-- set msys 
!     msys=0  tricl. 
!     msys=1  mono a
!     msys=2  mono b
!     msys=3  mono c
!     msys=4  ortor. 
!     msys=5  tetrag. 
!     msys=6  hexag. 
!     msys=7  cubic 
!     msys=8  rhombo. 
!
      ac(1:6)=cell(1:6)
      errac(1:6)=errcell(1:6)
      iferrcell=1
      if (errcell(1).le.0.) iferrcell=0
      do i=1,6
         if (iferrcell.eq.0) errac(i)=ac(i)/1000
      enddo
!
      aax=cell(1)
      bax=cell(2)
      cax=cell(3) 
      alp=cell(4) 
      bet=cell(5) 
      gam=cell(6) 
!
      msys=0
      if (ifLaue > 0) then
          msys = ifLaue - 10
      else
!alfa=beta=gamma
          if (abs(ac(4)-ac(5)).le.0.5*(errac(4)+errac(5)).and.
!     1       abs(ac(4)-ac(6)).le.0.5*(errac(4)+errac(6)))then 
     1        abs(ac(4)-ac(6)).le.0.05) then 
!a=b=c
               if (abs(ac(1)-ac(2)).le.0.5*(errac(1)+errac(2)).and.
     1             abs(ac(1)-ac(3)).le.0.5*(errac(1)+errac(3))) then 
                   msys = 8 
!                  if(abs(ac(4)-90.).le.errac(4))        msys=7 
                   if (abs(ac(4)-90.).le.0.05) msys = 7 
!a=b
               elseif (abs(ac(1)-ac(2)).le.0.5*(errac(1)+errac(2))) then
                   msys = 5 
               else                                   
!a.ne.b.ne.c
                   msys = 4 
               endif                                    
!alfa=beta=90
          elseif (abs(ac(4)-ac(5)).le.0.5*(errac(4)+errac(5)).and.
!     1            abs(ac(4)-90.).le.errac(4))then
     1            abs(ac(4)-90.).le.0.05) then
                  msys = 3
!               if(abs(ac(6)-120.).le.errac(6))          msys=6
                  if (abs(ac(6)-120.).le.0.05) msys = 6
!alfa=gamma=90
          elseif (abs(ac(4)-ac(6)).le.0.5*(errac(4)+errac(6)).and.
!     1            abs(ac(4)-90.).le.errac(4))then
     1            abs(ac(4)-90.).le.0.05) then
                  msys = 2
!beta=gamma=90
          elseif (abs(ac(5)-ac(6)).le.0.5*(errac(5)+errac(6)).and.
     1            abs(ac(5)-90.).le.errac(5)) then
                  msys = 1
          endif
      endif
!       write(loo,*)
!     1  '                                                   ',
!     1  'Space Group Determination Routine'
      if (noprinta.eq.0) then
          write(lo,*)       
     1      '      Crystal System determination',
     1     ' by geometrical analysis of the cell:'
          if (msys.eq.0) write(lo,*)
     1    '                         TRICLINIC  '
          if (msys.eq.1) write(lo,*)
     1    '                        MONOCLINIC Unique axis a '
          if (msys.eq.2) then
              write(lo,*)
     1'                        MONOCLINIC Unique axis b '
          elseif (msys.eq.3) then
              write(lo,*)
     1'                        MONOCLINIC Unique axis c '
          elseif (msys.eq.4) then
              write(lo,*)
     1'                        ORTHORHOMBIC  '
          elseif (msys.eq.5) then
              write(lo,*)
     1'                        TETRAGONAL  '
          elseif (msys.eq.6) then
              write(lo,*)
     1'                    TRIGONAL or HEXAGONAL  '
          elseif (msys.eq.7) then
              write(lo,*)
     1'                          CUBIC'
          elseif (msys.eq.8) then
              write(lo,*)
     1'                        RHOMBOHEDRAL  '
          endif
          write(lo,*)' '
      endif
!
      return
      end
!
!code for cercalaueclas
      subroutine cercalaueclas(nsgpat,nnumclas,Matt)
      USE General
      USE Symmetry, only : nsym
*     USE Liste
      USE Laue
!
      dimension Matt(96,3,3)
c
!      write(lo,'(a)')'cercalaueclas'
      if(nsgpat.gt.0)then
      if(msys.eq.5.and.nsgpat.eq.10)nnumclas=1
      if(msys.eq.5.and.nsgpat.eq.12)nnumclas=2
      if(msys.eq.6.and.nsgpat.eq.14)nnumclas=1
      if(msys.eq.6.and.nsgpat.eq.16)nnumclas=2
      if(msys.eq.6.and.nsgpat.eq.17)nnumclas=3
      if(msys.eq.6.and.nsgpat.eq.19)nnumclas=4
      if(msys.eq.6.and.nsgpat.eq.20)nnumclas=5
      if(msys.eq.7.and.nsgpat.eq.21)nnumclas=1
      if(msys.eq.7.and.nsgpat.eq.24)nnumclas=2
      else if(nsgpat.eq.0)then
      if(msys.eq.5)then
      if(nsym.eq.4)nnumclas=1
      if(nsym.eq.8)nnumclas=2
      else if(msys.eq.6)then
         if(nsym.eq.3)then
         nnumclas=1
         else if(nsym.eq.6)then
         do  k=2,4
         imat=0
           do l=1,nnsym
!      write(lo,'(a,i5,9i3)')'l,Matt(l,1:3,1:3)',l,Matt(l,1:3,1:3)
             do j=1,nsym
             jj=nordmat(k,j)
!      write(lo,'(a,i5,9i3)')
!      1'jj,laMat(jj,1:3,1:3)',jj,laMat(jj,1:3,1:3)
             ielem=0
               do j1=1,3
                 do j2=1,3
                 if(LaMat(jj,j1,j2).eq.Matt(l,j1,j2))ielem=ielem+1
                 enddo
               enddo
!      write(lo,*)' ielem',ielem
                if(ielem.eq.9)then
                imat=imat+1
                go to 100
                endif
             enddo
100   continue
           enddo
            if(imat.eq.nsym)then
            nnumclas=k
            return
            endif
         enddo
         else if(nsym.eq.12)then
         nnumclas=5
         endif
      else if(msys.eq.7)then
      if(nsym.eq.12)nnumclas=1
      if(nsym.eq.24)nnumclas=2
      endif
      endif
      return
      end
!      
! ----------------------------------------------------------------------
! 
!                   REFANA
!
! ----------------------------------------------------------------------
!
!code for DetermRefana
      subroutine DetermRefana(icode)
      USE General
      USE Riflessi
*     USE Liste
      USE Symmetry, only : nSpaceG
      USE Laue
      USE Molcom, only: jscreen
!
      common/dummy/reslim,nxxref
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/Twinsdet/ MatTwi(10,3,3),nMatTwi
     1,ihmax,ikmax,ilmax,ihmxx(3),lasomdim
      common /Esureappl/iapplEsure
      common /pseudoappl/iapplpse(74),iappl,perctab(13,8)
      common/rintp/fosum,diffsum,rintres(10,5,2,25)
      common/probLaEle/numsysEle,RintSys(9,6),ProbSys(9,7),kfin,indprobs
     1,corrfattProb(9),ProbLsav(5),nomonoclino
!
!--
      dimension e1med(6)  
!--
      double precision, allocatable :: xstore(:,:)
      double precision dif, uno
      double precision fosum,diffsum
!
*gl*  character*16 linea,line,dire,linestam,linest(30)
      character*16 line,dire,linestam,linest(30)
!-- linea(1:nclassLa) nome dei gruppi di Laue compatibili con la cella  
!
!-- codice non applica pseudotraslazioni (iappl=0)
      iappl=0
      if(neutro.eq.2)iappl=1
      iappl_sav=iappl
      iapplEsure=1   ! iapplEsure=0/1 non/applica corr. per Esure 
!
!      write(lo,*) 'inizia determRefana  msys=',msys
      uno = 1.0
      iprsr02=1
      noprinta=1
      ifSalta = 0
      if(neutro.eq.2)ifSalta=1
      call LaueSys(noprinta, ifSalta)
      do  j2=1,nclassLa
          line=linea(j2)
          linestam(1:16)=line(3:16)
          linest(j2)=linestam
!      write(lo,'(a,2i6,2x,a)')'msys, j2,linest(j2)',msys, j2,linest(j2)
      enddo
      write(lo,'(a)')' '
!
!-- allocate work area for reflections (xstore)
      IF (.NOT. ALLOCATED(xstore))
     *ALLOCATE (xstore(1:26,1:nrefl), stat = ierr)
      if (ierr.ne.0) then
         write(lo,*) 'Rflct xstore Allocation error'
         stop 
      endif
      if(neutro.eq.2)then                                  !11mag11
        IF (.NOT. ALLOCATED(valEsure))                     !11mag11
     *  ALLOCATE (valEsure(1:13,1:8,1:nrefl), stat = ierr) !11mag11
        if (ierr.ne.0) then                                !11mag11
           write(lo,*) 'Rflct xstore Allocation error'     !11mag11
           stop                                            !11mag11
        endif                                              !11mag11
        valEsure=0.                                        !11mag11
      endif                                                !11mag11
!--  Refana
!
!-- 1giu11
      j=0
      do i=1,nclassLa
        if(ProbL(i).eq.0)j=j+1
      enddo
      if(j == nclassLa)then
        ProbL(1)=1.
        nclassLa=1
      endif
!--
!
      do  imer=1,nclassLa
      if(ProbL(imer).le.0.)cycle
!      write(lo,'(a,2i5)')'rintres, msys,imer',msys,imer
!      rintres(1,5,:,:)=rintres(msys+1,imer,:,:)
!      do i=1,25
!      write(lo,'(i5,2f8.3)')
!     1 i,rintres(1,5,1,i),rintres(1,5,2,i)
!      enddo

!      write(lo,'(i6,3x,a,f8.3)')msys,linest(j2),probl(j2)
!      pprob=probL(imer)/probL(6)
!      write(lo,'(2a,f8.3,a,f8.3)')linest(imer),' ProbLaue ',pprob,

!     1 ', corrfatt. for the number of extinction prob. factors',probL(6)
         write(lo,'(2x,a,a)')'Laue Class   : ',linest(imer)
!
         if (jscreen > 0) then
             write(jgrap,22) linest(imer)
         endif
   22 format('<big><b><span foreground="red">    Laue Class: '
     *       ,a,'</span></b></big>',/)
!
         iappl=iappl_sav
         if (knw > 0) write(lo,*)' iappl=',iappl
         if (icode.eq.1)then
           line=linea(imer)
!          write(lo,'(/,a,i5,3x,a)')' Laue group no.',imer,line
           call cutst(line,lenp,dire,lend)
           call lcase(line)
           lenp=16
           call onebl(line,lenp,ier)
           read(line,'(16a1)') nSpaceG
           call CreaSymmetryInfo(ier)
         endif
!
         call LoadReflInfo
!
         ifMercedes = 1
**        call norm2000(ifMercedes, ier)
!         if (neutro.ne.2) call NormLaueGr(ier)
         call NormLaueGr(ier)
!         reslim=0.50/sqrt(rhomax)
!         if(neutro.eq.2) reslim=0.9
         call xsto6dp(xstore)
         nxxx=nxxref
         e1me=0.
         fmed=0.
         somme2=0.
         deno=0.
         ia=0
         do i=1,nxxx
           if(neutro.ne.2)then
              ginte=xstore(4,i)**2              !fo**2
              sginte=2*xstore(4,i)*xstore(5,i)  !d(fo**2)
              if(abs(ginte).lt.0.001)sginte=10.
              dif=ginte-3*sginte
              xstore(5,i)=sign(uno, dif)
              xstore(5+imer,i)=evet(i)**2
!              write(lo,'(a,3f4.0,7f8.2,f5.0)')
!     1        ' dopo if dopo xsto6dp '
!     1        ,xstore(1:10,i),xstore(10+3*(imer-1)+1,i)
           else
!              xstore(5+imer,i)=xstore(5,i)
              xstore(5+imer,i)=evet(i)**2
              xstore(10+3*(imer-1)+1,i)=mult(i)
              somme2=somme2+xstore(5+imer,i)*mult(i)
              deno=deno+mult(i)
           endif
           if(ia.ne.0)write(lo,'(a,3f4.0,7f8.2,f5.0)')
     1      ' dopo if dopo xsto6dp '
     1      ,xstore(1:10,i),xstore(10+3*(imer-1)+1,i)
           e1me=e1me+sqrt(xstore(5+(imer),i))
           fmed=fmed+xstore(4,i)
         enddo
         e1med(imer)=e1me/nxxx
!         fmed=fmed/nxxx
         somme2=somme2/deno
!
         if (knw > 0) write(ncwu,*)' Somma Molteplicita ', deno
!
         call refana0
!
         write(ncwu,*)' '
!22ott         if(percssf.lt.percmin.or.msys.le.4)ProbL(imer)=1.
!22ott         if(msys.le.4)ProbL(imer)=1.
         ProbLa=ProbL(imer)
!         write(ncwu,*)'ProbLa,imer,nume,nume2  ',ProbLa,imer,nume,nume2
         if(probLa.gt.0)call refana(imer,xstore,nxxx)
      enddo
!
      DEALLOCATE(xstore, stat =ierr)
      if(neutro.eq.2)DEALLOCATE(valEsure, stat =ierr)   !11mag11
      return
      end
!
! versione 21.11.01
!
!code for refana0 
      subroutine refana0
      USE General
      USE Symmetry
      USE BuildModule
      USE Laue
!
!--Reflection Set Analysis (azzera gli accumulatori)
!
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/dummyinp/indipen(13,8),indipen2(13,8),nEsu(13,8)
     1,numr(13,8,2)

!--
      ij=1
      do i=1,3
         do j=1,3
           gdist(ij)=xgg(i,j)
           gdist(ij+9)=xgr(i,j)
           ij=ij+1
         enddo
      enddo
      coefsig=3
      toller=0.2
      tfo=0
      tsfo=0
      tfosfo=0
      nonacc=0
      ntota=0
      ntotai=0
      nonconsid=0
      nEsure(:,:)=0
      Esure(:,:)=0.
      nEsu(:,:)=0.
      numr(:,:,:)=0
      scond2(:,:)=scond(:,:)
      ncont(:)=0
      tab(:,:,:)=0.
      call msyss
!      write(lo,*)'refana0 msys ',msys
      return
      end
!
!code for refanain
      subroutine refanain(llh,llk,lll,fol,sfol,weig,iexpa) 
      USE General
      USE Laue
!
!--Reflection Set Analysis     (accumula i dati)
!
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      dimension ivet(3),iveteq(48,3)

      common/dummyinp/indipen(13,8),indipen2(13,8),nEsu(13,8)
     1,numr(13,8,2)
      common/numeref/iref,ress,nrifweig(13,8)
!
      if(llh.ne.0.or.llk.ne.0.or.lll.ne.0)then
         ntotai=ntotai+1
!          write(lo,'(a,3i4,2f10.3,2i5)')' h k l fo sfo ntotai,iexpa  '
!     1    ,llh,llk,lll,fol,sfol,ntotai,iexpa
         mm=1
         iveteq(1,1)=llh
         iveteq(1,2)=llk
         iveteq(1,3)=lll
!!!!!
         if(iexpa.eq.1)then
            ivet(1)=llh
            ivet(2)=llk
            ivet(3)=lll
            indipen(:,:)=0
            indipen2(:,:)=0
            call equindi(ivet,mm,iveteq)
            if(mm.eq.0)mm=1
!            write(lo,*)' h k l fo sfo mm  '
!     1      ,llh,llk,lll,fol,sfol,mm
         endif
!!!!!
         do i=1,mm
           lh=iveteq(i,1)
           lk=iveteq(i,2)
           ll=iveteq(i,3)
           fo=fol
           sfo=sfol
           weigg=weig
!   tab(i,j,1) no. of total refl. belonging to the i cond. of the j class 
!   tab(-,-,2) no. of refl. with (fo.gt.nsig*sfo) belonging to the i,j class 
!   tab(-,-,3) <fo> of this class 
!   tab(-,-,4) <sfo> of this class 
!   tab(-,-,5) =1 there are no exceptions.(l'operatore puo esistere)  
!   tab(-,-,5) =-1 l'operatore non puo' esistere  
           if(ipow.eq.0.and.sfo.gt.999..or.fo.le.-50000.)then
              nonconsid=nonconsid+1
!          write(lo,*)'refl.  h k l fo sfo nonconsid  '
!     1     ,lh,lk,ll,fo,sfo,nonconsid,ntotai,tollercentr
           else  !24mag12 if(sfo.ge.0)then
              if(sfo.gt.0.and.fo.le.0.and.fo.gt.-30.)then
                    fo=abs(0.1*sfo)
              endif
              tfo=tfo+fo
              tsfo=tsfo+sfo
              if(sfo.gt.0)tfosfo=tfosfo+fo/sfo
              soglia=coefsig*sfo
              ntota=ntota+1
 !         write(lo,'(i7,3i4,3f10.3,i10)')
 !    1    ,ntota,lh,lk,ll,fo,sfo,tfo,mm
              iacc=i
              call anaref(iacc)
           endif
         enddo
      endif
      return
      end
!
!code for refana 
      subroutine refana(imer,xstore,nxxx)
      USE General
      USE Riflessi
*     USE Liste
      USE BuildModule
      USE Laue
!
!--Reflection Set Analysis ( main )
!
      character*20 symbs, lauelcl1
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,fattover 
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/dummyyy/valmedio(13),loo
      common/fordata0/ nsymbo
      common/fordata/ symbs(2000,2),fmerit(2000,2),numerosy(2000,2)
     1,lauelcl1(2000,2)
      common/numeref/iref,ress,nrifweig(13,8)
      double precision xstore(26,nrefl)
!--
      if(neutro.ne.2)then
         do i=1,2000
            symbs(i,1)='/                    /' 
            symbs(i,2)='/                    /' 
         enddo       
      endif
!-- per expo2002
!      do 100 i=1,nref
!      ffgruppo(i)=0.0
!      ipreso(i)=0
c 100  continue
!      do 200 i=1,nref
!      if(ipreso(i).eq.1)go to 200
!      do 300 j=i,i+indovr(i)-1
!      ffgruppo(i)=ffgruppo(i)+mult(j)*clp(j)*setfob(j,4)
!      ipreso(j)=1
! 300  continue
!      do 400 j=i,i+indovr(i)-1
!      ffgruppo(j)=ffgruppo(i)
! 400  continue
! 200  continue
      tfo=0
      tsfo=0
      tfosfo=0
      nonacc=0
      ntota=0
      ntotai=0
      nonconsid=0
      do i=1,13
         ncont(i)=0
         nconteo(i)=0
         foclass(i)=0.
         wclass(i)=0.
         do j=1,8
            ntabte(i,j)=0
            ntabte2(i,j)=0
            nrifweig(i,j)=0
            tabfomax(i,j,1)=-1000.
            tabfomax(i,j,2)=1000.
            do k=1,5
               tab(i,j,k)=0.
               tab2(i,j,k)=0.
            enddo
         enddo
      enddo
      iexpa=1
!      write(lo,*)
!     1 '   i   h   k   l     E2(ori) E2(corr)    weigt   '
      do i=1,nxxx
         llh=xstore(1,i)
         llk=xstore(2,i)
         lll=xstore(3,i)
!-- in fol mette gli E
         fol=xstore(5+imer,i)
!         if(neutro.eq.2)fol=xstore(4,i)
         sfol=0.
         sfol=xstore(5,i)  !27mar08
         weig=1
         iref=i
         if(fol.lt.(10.0**(-4.0)))fol=0.0
         rho= rhof(pp,llh,llk,lll)
         ress=0.5/rho
!         ress=0.5/sqrt(rho)
!         if(res.lt.reslim)cycle
         call refanain(llh,llk,lll,fol,sfol,weig,iexpa) 
      enddo
!
      tfo=tfo/ntota
      tfosfo=tfosfo/ntota
      do i =1,13
         call anaclass(i)
      enddo
      call spacgr(imer)
      return
      end
!
!code for anaref
      subroutine anaref(iacc)
      USE General
      USE Laue

      common/numeref/iref,ress,nrifweig(13,8)

!-- analysing one reflection.
!
!-- tab content
!   tab( 1,-,-) refl. type 0  0  l
!   tab( 2,-,-) refl. type 0  k  0
!   tab( 3,-,-) refl. type h  0  0
!   tab( 4,-,-) refl. type 0  k  l
!   tab( 5,-,-) refl. type h  0  l
!   tab( 6,-,-) refl. type h  k  0
!   tab( 7,-,-) refl. type h  h  0
!   tab( 8,-,-) refl. type h  k  l
!   tab( 9,-,-) refl. type h -h  l
!   tab(10,-,-) refl. type h  h  l
!   tab(11,-,-) refl. type h  h  h
!   tab(12,-,-) refl. type h  k  h
!   tab(13,-,-) refl. type h  k  k
!
!----------    tab( 1,-,-) refl. type 0  0  l
!   tab(1,1,-) no. of refl. belonging to the class 1 cond 1 : l=2n 
!   tab(1,2,-) no. of refl. belonging to the class 1 cond 2 : l=4n 
!   tab(1,3,-) no. of refl. belonging to the class 1 cond 3 : l=3n 
!   tab(1,4,-) no. of refl. belonging to the class 1 cond 4 : l=6n 
!   tab(1,5,-) no. of refl. belonging to the class 1 cond 5 : no cond 
!   tab(1,6,-) no. of refl. belonging to the class 1 cond 6 : no cond 
!   tab(1,7,-) no. of refl. belonging to the class 1 cond 7 : no cond 
!   tab(1,8,-) no. of refl. belonging to the class 1 cond 8 : no cond 
!                                                                    
!-----------   tab( 2,-,-) refl. type 0  k  0
!   tab(2,1,-) no. of refl. belonging to the class 2 cond 1 : k=2n 
!   tab(2,2,-) no. of refl. belonging to the class 2 cond 2 : k=4n 
!   tab(2,3,-) no. of refl. belonging to the class 2 cond 3 : no cond 
!   tab(2,4,-) no. of refl. belonging to the class 2 cond 4 : no cond 
!   tab(2,5,-) no. of refl. belonging to the class 2 cond 5 : no cond 
!   tab(2,6,-) no. of refl. belonging to the class 2 cond 6 : no cond 
!   tab(2,7,-) no. of refl. belonging to the class 2 cond 7 : no cond 
!   tab(2,8,-) no. of refl. belonging to the class 2 cond 8 : no cond 
!
!-----------   tab( 3,-,-) refl. type h  0  0
!   tab(3,1,-) no. of refl. belonging to the class 4 cond 1 : h=2n 
!   tab(3,2,-) no. of refl. belonging to the class 4 cond 2 : h=4n 
!   tab(3,3,-) no. of refl. belonging to the class 4 cond 3 : no cond 
!   tab(3,4,-) no. of refl. belonging to the class 4 cond 4 : no cond 
!   tab(3,5,-) no. of refl. belonging to the class 4 cond 5 : no cond 
!   tab(3,6,-) no. of refl. belonging to the class 4 cond 6 : no cond 
!   tab(3,7,-) no. of refl. belonging to the class 4 cond 7 : no cond 
!   tab(3,8,-) no. of refl. belonging to the class 4 cond 8 : no cond 
!                                                                    
!-----------   tab( 4,-,-) refl. type 0  k  l
!   tab(4,1,-) no. of refl. belonging to the class 3 cond 1 : k=2n 
!   tab(4,2,-) no. of refl. belonging to the class 3 cond 2 : l=2n 
!   tab(4,3,-) no. of refl. belonging to the class 3 cond 3 : k=2n,l=2n 
!   tab(4,4,-) no. of refl. belonging to the class 3 cond 4 : k+l=2n 
!   tab(4,5,-) no. of refl. belonging to the class 3 cond 5 : k=2n,l=2n,k+l=4n 
!   tab(4,6,-) no. of refl. belonging to the class 3 cond 6 : no cond 
!   tab(4,7,-) no. of refl. belonging to the class 3 cond 7 : no cond 
!   tab(4,8,-) no. of refl. belonging to the class 3 cond 8 : no cond 
!                                                                    
!-----------   tab( 5,-,-) refl. type h  0  l
!   tab(5,1,-) no. of refl. belonging to the class 5 cond 1 : h=2n 
!   tab(5,2,-) no. of refl. belonging to the class 5 cond 2 : l=2n 
!   tab(5,3,-) no. of refl. belonging to the class 5 cond 3 : h=2n,l=2n 
!   tab(5,4,-) no. of refl. belonging to the class 5 cond 4 : h+l=2n 
!   tab(5,5,-) no. of refl. belonging to the class 5 cond 5 : h=2n,l=2n,h+l=4n 
!   tab(5,6,-) no. of refl. belonging to the class 5 cond 6 : no cond 
!   tab(5,7,-) no. of refl. belonging to the class 5 cond 7 : no cond 
!   tab(5,8,-) no. of refl. belonging to the class 5 cond 8 : no cond 
!                                                                    
!-----------   tab( 6,-,-) refl. type h  k  0
!   tab(6,1,-) no. of refl. belonging to the class 6 cond 1 : h=2n 
!   tab(6,2,-) no. of refl. belonging to the class 6 cond 2 : k=2n 
!   tab(6,3,-) no. of refl. belonging to the class 6 cond 3 : h=2n,k=2n 
!   tab(6,4,-) no. of refl. belonging to the class 6 cond 4 : h+k=2n 
!   tab(6,5,-) no. of refl. belonging to the class 6 cond 5 : h=2n,k=2n,h+k=4n 
!   tab(6,6,-) no. of refl. belonging to the class 6 cond 6 : no cond 
!   tab(6,7,-) no. of refl. belonging to the class 6 cond 7 : no cond 
!   tab(6,8,-) no. of refl. belonging to the class 6 cond 8 : no cond 
!                                                                    
!-----------   tab( 7,-,-) refl. type h  k  l
!   tab(7,1,-) no. of refl. belonging to the class 8 cond 1 : h+k=2n 
!   tab(7,2,-) no. of refl. belonging to the class 8 cond 2 : k+l=2n 
!   tab(7,3,-) no. of refl. belonging to the class 8 cond 3 : h+l=2n 
!   tab(7,4,-) no. of refl. belonging to the class 8 cond 4 : h+k+l=2n 
!   tab(7,5,-) no. of refl. belonging to the class 8 cond 5 : h+k=2n,h+l=2n, 
!                                                                k+l=2n    
!   tab(7,6,-) no. of refl. belonging to the class 8 cond 6 : -h+k+l=3n 
!   tab(7,7,-) no. of refl. belonging to the class 8 cond 7 : h-k+l=3n 
!   tab(7,8,-) no. of refl. belonging to the class 8 cond 8 : h-k=3n 
!
!------------  tab( 8,-,-) refl. type h  h  0
!   tab(8,1,-) no. of refl. belonging to the class 7 cond 1 : h=2n 
!   tab(8,2,-) no. of refl. belonging to the class 7 cond 2 : no cond 
!   tab(8,3,-) no. of refl. belonging to the class 7 cond 3 : no cond 
!   tab(8,4,-) no. of refl. belonging to the class 7 cond 4 : no cond 
!   tab(8,5,-) no. of refl. belonging to the class 7 cond 5 : no cond 
!   tab(8,6,-) no. of refl. belonging to the class 7 cond 6 : no cond 
!   tab(8,7,-) no. of refl. belonging to the class 7 cond 7 : no cond 
!   tab(8,8,-) no. of refl. belonging to the class 7 cond 8 : no cond 
!                                                                    
!-----------   tab( 9,-,-) refl. type h -h  l
!   tab(9,1,-) no. of refl. belonging to the class 9 cond 1 : l=2n 
!   tab(9,2,-) no. of refl. belonging to the class 9 cond 2 : h+l=3n 
!   tab(9,3,-) no. of refl. belonging to the class 9 cond 3 : l=2n,h+l=3n 
!   tab(9,4,-) no. of refl. belonging to the class 9 cond 4 : -h+l=3n 
!   tab(9,5,-) no. of refl. belonging to the class 9 cond 5 : l=2n,-h+l=3n 
!   tab(9,6,-) no. of refl. belonging to the class 9 cond 6 : no cond 
!   tab(9,7,-) no. of refl. belonging to the class 9 cond 7 : no cond 
!   tab(9,8,-) no. of refl. belonging to the class 9 cond 8 : no cond 
!                                                                    
!------------   tab(10,-,-) refl. type h  h  l
!   tab(10,1,-) no. of refl. belonging to the class 10 cond 1 : l=2n 
!   tab(10,2,-) no. of refl. belonging to the class 10 cond 2 : l=2n,2h+l=4n 
!   tab(10,3,-) no. of refl. belonging to the class 10 cond 3 : l=3n 
!   tab(10,4,-) no. of refl. belonging to the class 10 cond 4 : h+l=2n 
!   tab(10,5,-) no. of refl. belonging to the class 10 cond 5 : h=2n, l=2n 
!   tab(10,6,-) no. of refl. belonging to the class 10 cond 6 : no cond 
!   tab(10,7,-) no. of refl. belonging to the class 10 cond 7 : no cond 
!   tab(10,8,-) no. of refl. belonging to the class 10 cond 8 : no cond 
!------------   tab(11,-,-) refl. type h  h  h
!   tab(11,1,-) no. of refl. belonging to the class 11 cond 1 : h=2n 
!   tab(11,2,-) no. of refl. belonging to the class 11 cond 2 : no cond 
!   tab(11,3,-) no. of refl. belonging to the class 11 cond 3 : no cond 
!   tab(11,4,-) no. of refl. belonging to the class 11 cond 4 : no cond 
!   tab(11,5,-) no. of refl. belonging to the class 11 cond 5 : no cond 
!   tab(11,6,-) no. of refl. belonging to the class 11 cond 6 : no cond 
!   tab(11,7,-) no. of refl. belonging to the class 11 cond 7 : no cond 
!   tab(11,8,-) no. of refl. belonging to the class 11 cond 8 : no cond 
!-----------   tab(12,-,-) refl. type h k h  
!   tab(12,1,-) no. of refl. belonging to the class 10 cond 1 : k=2n 
!   tab(12,2,-) no. of refl. belonging to the class 10 cond 2 : k=2n,2h+k=4n 
!   tab(12,3,-) no. of refl. belonging to the class 10 cond 3 : k=3n 
!   tab(12,4,-) no. of refl. belonging to the class 10 cond 4 : h+k=2n 
!   tab(12,5,-) no. of refl. belonging to the class 10 cond 5 : h=2n,k=2n 
!   tab(12,6,-) no. of refl. belonging to the class 10 cond 6 : no cond 
!   tab(12,7,-) no. of refl. belonging to the class 10 cond 7 : no cond 
!   tab(12,8,-) no. of refl. belonging to the class 10 cond 8 : no cond 
!-----------   tab(13,-,-) refl. type h k k  
!   tab(13,1,-) no. of refl. belonging to the class 10 cond 1 : h=2n 
!   tab(13,2,-) no. of refl. belonging to the class 10 cond 2 : h=2n,2k+h=4n 
!   tab(13,3,-) no. of refl. belonging to the class 10 cond 3 : h=3n 
!   tab(13,4,-) no. of refl. belonging to the class 10 cond 4 : h+k=2n 
!   tab(13,5,-) no. of refl. belonging to the class 10 cond 5 : h=2n,k=2n 
!   tab(13,6,-) no. of refl. belonging to the class 10 cond 6 : no cond 
!   tab(13,7,-) no. of refl. belonging to the class 10 cond 7 : no cond 
!   tab(13,8,-) no. of refl. belonging to the class 10 cond 8 : no cond 
!
!   tab(i,j,1) no. of total refl. belonging to the i cond. of the j class 
!   tab(-,-,2) no. of refl. with (fo.gt.nsig*sfo) belonging to the i,j class 
!   tab(-,-,3) <fo> of this class 
!   tab(-,-,4) =1 there are no exceptions.(l'operatore puo esistere)  
!   tab(-,-,4) =-1 l'operatore non puo' esistere  
!   tab(-,-,5) <sfo> of this class 
!
!            
      ind1=7
      if(iacc.eq.1)then
      ncont(ind1)=ncont(ind1)+1
      foclass(ind1)=foclass(ind1)+fo*weigg
      wclass(ind1)=wclass(ind1)+weigg
      endif
      call condi(ind1)
!
      if(lh.eq.0)then
      ind1=4
        if(iacc.eq.1)then
        ncont(ind1)=ncont(ind1)+1
        foclass(ind1)=foclass(ind1)+fo*weigg
        wclass(ind1)=wclass(ind1)+weigg
        endif
      call condi(ind1)
      endif
!
          if(lk.eq.0)then
          ind1=5
            if(iacc.eq.1)then
            ncont(ind1)=ncont(ind1)+1
            foclass(ind1)=foclass(ind1)+fo*weigg
            wclass(ind1)=wclass(ind1)+weigg
            endif
          call condi(ind1)
          endif
!
      if(ll.eq.0)then
      ind1=6
        if(iacc.eq.1)then
        ncont(ind1)=ncont(ind1)+1
        foclass(ind1)=foclass(ind1)+fo*weigg
        wclass(ind1)=wclass(ind1)+weigg
        endif
      call condi(ind1)
      endif
!
          if(lh.eq.0.and.lk.eq.0)then
          ind1=1
             if(iacc.eq.1)then
             ncont(ind1)=ncont(ind1)+1
             foclass(ind1)=foclass(ind1)+fo*weigg
             wclass(ind1)=wclass(ind1)+weigg
             endif
          call condi(ind1)
          endif
!
      if(lh.eq.0.and.ll.eq.0)then
      ind1=2
        if(iacc.eq.1)then
        ncont(ind1)=ncont(ind1)+1
        foclass(ind1)=foclass(ind1)+fo*weigg
        wclass(ind1)=wclass(ind1)+weigg
        endif
      call condi(ind1)
      endif
!
            if(lk.eq.0.and.ll.eq.0)then
            ind1=3
               if(iacc.eq.1)then
               ncont(ind1)=ncont(ind1)+1
               foclass(ind1)=foclass(ind1)+fo*weigg
               wclass(ind1)=wclass(ind1)+weigg
               endif
            call condi(ind1)
            endif
!
      if(lh.eq.lk)then
      ind1=10
        if(iacc.eq.1)then
        ncont(ind1)=ncont(ind1)+1
        foclass(ind1)=foclass(ind1)+fo*weigg
        wclass(ind1)=wclass(ind1)+weigg
        endif
      call condi(ind1)
           if(ll.eq.0)then
           ind1=8
              if(iacc.eq.1)then
              ncont(ind1)=ncont(ind1)+1
              foclass(ind1)=foclass(ind1)+fo*weigg
              wclass(ind1)=wclass(ind1)+weigg
              endif
           call condi(ind1)
           endif
      endif
!
             if(lh.eq.-lk)then
             ind1=9
                      if(iacc.eq.1)then
                      ncont(ind1)=ncont(ind1)+1
                      foclass(ind1)=foclass(ind1)+fo*weigg
                      wclass(ind1)=wclass(ind1)+weigg
                      endif
             call condi(ind1)
                 if(ll.eq.0)then
                 ind1=8
                     if(iacc.eq.1)then
                     ncont(ind1)=ncont(ind1)+1
                     foclass(ind1)=foclass(ind1)+fo*weigg
                     wclass(ind1)=wclass(ind1)+weigg
                     endif
                 call condi(ind1)
                 endif
             endif
!
      if(lh.eq.ll)then
      ind1=12
         if(iacc.eq.1)then
         ncont(ind1)=ncont(ind1)+1
         foclass(ind1)=foclass(ind1)+fo*weigg
         wclass(ind1)=wclass(ind1)+weigg
         endif
      call condi(ind1)
      endif
!
            if(lk.eq.ll)then
            ind1=13
               if(iacc.eq.1)then
               ncont(ind1)=ncont(ind1)+1
               foclass(ind1)=foclass(ind1)+fo*weigg
               wclass(ind1)=wclass(ind1)+weigg
               endif
            call condi(ind1)
            endif            
      return
      end
!
!code for applipseudo
      subroutine applipseudo
      USE General
      USE Symmetry
      USE Laue
      USE PseudoStuff
!
!-- applica le condizioni della pseudo traslazione alle diverse classi di rif.
!
!      common /pseudotras/ nkk,mpseud(12,74),numps(74),perctab(13,8)
!     *                    ,perce(74),jpseud(74)
      common /pseudoappl/iapplpse(74),iappl,perctab(13,8)
      common /PseudoInfo/ PseudoVet(3), PseudoCond(12), QualePseudo
      common /pigra/ kkmer,norps_mercedes(74),percps_mercedes(74)
     1 ,epseud_mercedes(74)
      dimension nnord(74) 
!
      call PutGetPseudoInfo(2,kk)
!
      iapplpse(1:74)=0      
      iapplpse(2)=1
      iapplpse(3)=1
      iapplpse(4)=1
      iapplpse(5)=1
      iapplpse(6)=1
      iapplpse(7)=1
      iapplpse(8)=1
      iapplpse(13)=1
      iapplpse(17)=1
      iapplpse(18)=1
      iapplpse(28)=1  !!!
      iapplpse(29)=1
      iapplpse(30)=1
      iapplpse(31)=1
      iapplpse(35)=1
      iapplpse(36)=1
      iapplpse(37)=1
      iapplpse(38)=1
      iapplpse(39)=1
      iapplpse(40)=1
      iapplpse(68)=1
      iapplpse(69)=1
      iapplpse(70)=1
      iapplpse(71)=1
      iapplpse(73)=1    
      iapplpse(74)=1
!
      perctab(1:13,1:8)=1.0
      percmin=0.16

      nkk0=0
!      perc=0.16
      jappl=0
      perc=0.40
      if(kkmer.le.0)then
      iappl=jappl
      return
      endif
      do  i=1,74        !04mag  2
         nnord(i)=i     !04mag  2
      enddo             !04mag  2
      call sort3(percps_mercedes,nnord,74)  !04mag  2
      nummaxps=0    !04mag  2
      do  ii=1,kkmer
         if(neutro.eq.2.and.nummaxps.ge.2)exit  !04mag 2
         i=nnord(ii)
!--kk= n.ord in mpseud e in perce  delle pseudot.
      kk=norps_mercedes(i)
         if(kk.gt.0)then     
            if(iapplpse(kk).eq.1)then
!       if(percps_mercedes(i).gt.perc.and.epseud_mercedes(i).gt.0.00)then
        if(percps_mercedes(i).gt.perc.and.epseud_mercedes(i).gt.1.2)then  !04magg 1
                 nummaxps=nummaxps+1    !04mag  2
!      write(lo,*)
!     1'i,kk,iapplpse(kk),percps_merc(i),epseud_merc(i),nummaxps',
!     1 i,kk,iapplpse(kk),percps_mercedes(i),epseud_mercedes(i),nummaxps  
                 jappl=1
                  per=percps_mercedes(i)          !27gen11
                  n=3      
                  if(neutro.eq.2)n=2              !09mag11 orig: n=3
                   per=(1.- per)**n                !27gen11
                call setperctab(kk,per)          !27gen11
!                 exit                     !28gen11 prende solo la prima pseudot.
       endif
            endif
         endif
      enddo
!27gen11      if(perc.lt.0.16.or.nkk0.le.0)return
!
!27gen11             perc=(1.- perc)**3
!      write(lo,*)'i,kk, perce(kk),perc  ',i,kk,perce(kk),perc 
!27gen11             call setperctab(nkk0,perc)
!
!      write(lo,*)' perctab  '
!      do i=1,13
!      write(lo,'(i5,8f6.3)')i,(perctab(i,k),k=1,8)
!      enddo
      iappl=jappl
      return
      end
!
!code for setperctab
      subroutine setperctab(kk,percen)
      USE General
      USE Symmetry
      USE Laue
!      USE PseudoStuff
!
!-- setta in perctab(i,j) la percentuale de pseudot. per la j-essima 
!-- sottoclass della classe i.
!
!      common /pseudotras/ nkk,mpseud(12,74),numps(74),perctab(13,8)
!     *                    ,perce(74),jpseud(74)
      common /pseudoappl/iapplpse(74),iappl,perctab(13,8)
!
! 3)               k = 2n    
! 5)           h+k+l = 2n    
! 7)             h+l = 2n       
! 16)         h+k+2l = 3n      
! 23)              k = 4n      
! 26)            h+l = 4n      
! 28)          h+k+l = 4n      
! 33)         h+2k+l = 4n      
! 37)           k+2l = 4n         
! 38)           2h+k = 4n      
! 41)        3h+3k+l = 4n      
! 44)        h+2k+3l = 4n      
! 48)           h+3l = 4n      
! 50)          3k+2l = 6n      
! 65)   h = 2n &   k = 2n      
! 66)   h = 2n &   l = 2n      
! 67)   k = 2n &   l = 2n       
! 68)   h = 2n & k+l = 2n       
! 69)   k = 2n & h+l = 2n      
! 70)   l = 2n & h+k = 2n      
! 71) h+k = 2n & h+l = 2n      
! 72)   h = 2n &   k = 2n & l = 2n      
! 73)   h+k = 2n &   k+l = 2n & h+l = 2n      
!
      iappl=0
      kprint=0
      if(kprint.eq.1)
     1 write(lo,*)
     1'Applica le pseudot. con perc 0.>40 alle 2 classi piu forte' 
      if(kk.eq.2)then
        perctab(5,1)=perctab(5,1)*percen
        perctab(6,1)=perctab(6,1)*percen
        perctab(8,1)=perctab(8,1)*percen
        perctab(11,1)=perctab(11,1)*percen
        perctab(13,1)=perctab(13,1)*percen
        if(neutro.eq.2)perctab(3,1)=perctab(3,1)*percen  !
        iappl=1 
      else if(kk.eq.3)then     ! 3)k = 2n    
        perctab(4,1)=perctab(4,1)*percen
        perctab(6,2)=perctab(6,2)*percen
        perctab(8,1)=perctab(8,1)*percen
        perctab(11,1)=perctab(11,1)*percen
        perctab(12,1)=perctab(12,1)*percen
        if(neutro.eq.2)perctab(2,1)=perctab(2,1)*percen    !
        iappl=1 
      else if(kk.eq.4)then
        perctab(5,2)=perctab(5,2)*percen
        perctab(4,2)=perctab(4,2)*percen
        perctab(9,1)=perctab(9,1)*percen
        perctab(10,1)=perctab(10,1)*percen
        perctab(11,1)=perctab(11,1)*percen
        perctab(12,1)=perctab(12,1)*percen
        if(neutro.eq.2)perctab(1,1)=perctab(1,1)*percen  !
        iappl=1 
      else if(kk.eq.5)then     ! 5) h+k+l = 2n    
        perctab(4,4)=perctab(4,4)*percen
        perctab(5,4)=perctab(5,4)*percen
        perctab(6,4)=perctab(6,4)*percen
        perctab(7,4)=perctab(7,4)*percen
        perctab(9,1)=perctab(9,1)*percen
        perctab(10,1)=perctab(10,1)*percen
        perctab(12,1)=perctab(12,1)*percen
        perctab(13,1)=perctab(13,1)*percen
        if(neutro.eq.2)then
        perctab(1,1)=perctab(1,1)*percen
        perctab(2,1)=perctab(2,1)*percen
        perctab(3,1)=perctab(3,1)*percen
        perctab(8,1)=perctab(8,1)*percen
        endif
        iappl=1 
      else if(kk.eq.6)then
        perctab(4,1)=perctab(4,1)*percen
        perctab(5,1)=perctab(5,1)*percen
        perctab(6,4)=perctab(6,4)*percen
        perctab(7,1)=perctab(7,1)*percen
        perctab(12,1)=perctab(12,1)*percen
        iappl=1 
      else if(kk.eq.7)then    ! 7) h+l = 2n  
        perctab(4,2)=perctab(4,2)*percen
        perctab(5,4)=perctab(5,4)*percen
        perctab(6,1)=perctab(6,1)*percen
        perctab(7,3)=perctab(7,3)*percen
        perctab(8,1)=perctab(8,1)*percen
        perctab(10,4)=perctab(10,4)*percen
        if(neutro.eq.2)then
        perctab(1,1)=perctab(1,1)*percen
        perctab(2,1)=perctab(2,1)*percen
        endif
        iappl=1 
      else if(kk.eq.8)then
        perctab(4,4)=perctab(4,4)*percen
        perctab(5,2)=perctab(5,2)*percen
        perctab(6,2)=perctab(6,2)*percen
        perctab(7,2)=perctab(7,2)*percen
        perctab(8,1)=perctab(8,1)*percen
        perctab(10,4)=perctab(10,4)*percen
        iappl=1 
      else if(kk.eq.13)then
        perctab(9,2)=perctab(9,2)*percen
        iappl=1 
      else if(kk.eq.17)then
        perctab(10,3)=perctab(10,3)*percen
        perctab(7,7)=perctab(7,7)*percen
        iappl=1 
      else if(kk.eq.18)then
        perctab(10,3)=perctab(10,3)*percen
        perctab(7,6)=perctab(7,6)*percen
        iappl=1 
      else if(kk.eq.28.and.neutro.eq.2)then  ! 28) h+k+l = 4n
        perctab(1,2)=perctab(1,2)*percen
        perctab(2,2)=perctab(2,2)*percen
        perctab(3,2)=perctab(3,2)*percen
        iappl=1 
      else if(kk.eq.29.or.kk.eq.70)then
        perctab(6,4)=perctab(6,4)*percen
        iappl=1 
      else if(kk.eq.30.or.kk.eq.69)then
        perctab(5,4)=perctab(5,4)*percen
        if(neutro.eq.2)perctab(3,1)=perctab(3,1)*percen
        if(neutro.eq.2)perctab(1,1)=perctab(1,1)*percen
        iappl=1 
      else if(kk.eq.31.or.kk.eq.68)then
        perctab(4,4)=perctab(4,4)*percen
        if(neutro.eq.2)perctab(2,1)=perctab(2,1)*percen
        if(neutro.eq.2)perctab(1,1)=perctab(1,1)*percen
        iappl=1 
      else if(kk.eq.35)then
        perctab(4,1)=perctab(4,1)*percen
        if(neutro.eq.2)perctab(2,1)=perctab(2,1)*percen
        iappl=1 
      else if(kk.eq.36)then
        perctab(4,2)=perctab(4,2)*percen
        if(neutro.eq.2)perctab(1,1)=perctab(1,1)*percen
        iappl=1 
      else if(kk.eq.37)then
        perctab(5,2)=perctab(5,2)*percen
        if(neutro.eq.2)perctab(1,1)=perctab(1,1)*percen
        iappl=1 
      else if(kk.eq.38)then
        perctab(5,1)=perctab(5,1)*percen
        if(neutro.eq.2)perctab(3,1)=perctab(3,1)*percen
        iappl=1 
      else if(kk.eq.39)then
        perctab(6,1)=perctab(6,1)*percen
        if(neutro.eq.2)perctab(3,1)=perctab(3,1)*percen
        iappl=1 
      else if(kk.eq.40)then
        perctab(6,2)=perctab(6,2)*percen
        if(neutro.eq.2)perctab(2,1)=perctab(2,1)*percen
        iappl=1 
civan
      else if(kk.eq.71)then
        perctab(7,5)=perctab(7,5)*percen
        perctab(4,4)=perctab(4,4)*percen
        perctab(5,4)=perctab(5,4)*percen
        perctab(6,4)=perctab(6,4)*percen
        perctab(4,3)=perctab(4,3)*percen
        perctab(10,4)=perctab(10,4)*percen
        iappl=1 
      else if(neutro.eq.2.and.kk.eq.73)then
!     else if(neutro.eq.2.and.kk.eq.773)then
        perctab(1,1)=perctab(1,1)*percen
        perctab(2,1)=perctab(2,1)*percen
        perctab(3,1)=perctab(3,1)*percen
        perctab(4,4)=perctab(4,4)*percen
        perctab(5,4)=perctab(5,4)*percen
        perctab(6,4)=perctab(6,4)*percen
        perctab(7,5)=perctab(7,5)*percen
        perctab(10,4)=perctab(10,4)*percen
        perctab(12,4)=perctab(12,4)*percen
        perctab(13,4)=perctab(13,4)*percen
        iappl=1 
!ivan
      endif
      if(kprint.eq.1)then
       write(lo,'(a,i5,f8.3)')'kk,percen',kk,percen
       do i1=1,13
       if(i1.eq.1) write(lo,*)'     00l     l=2n    l=4n'  
       if(i1.eq.2) write(lo,*)'     0k0     k=2n    k=4n'  
       if(i1.eq.3) write(lo,*)'     h00     h=2n    h=4n'  
       if(i1.eq.4) write(lo,*)
     1 '     0kl     k=2n    l=2n, k=2nl=2n, k+l=2n,k=2nl=2nk+l=4n'  
       if(i1.eq.5) write(lo,*)
     1 '     h0l     h=2n    l=2n, h=2nl=2n, h+l=2n,h=2nl=2nh+l=4n'  
       if(i1.eq.6) write(lo,*)
     1 '     hk0     h=2n    k=2n, h=2nk=2n, h+k=2n,h=2nk=2nh+k=4n'  
       if(i1.eq.7) write(lo,*)
     1 '     hkl     h+k=2n  k+l=2n   h+l=2n h+k+l=2n  F'  
       if(i1.eq.8) write(lo,*)'     hh0     h=2n    '  
       if(i1.eq.9) write(lo,*)'     h-hl    l=2n    '  
       if(i1.eq.10) write(lo,*)'     hhl     l=2n    '  
       if(i1.eq.11) write(lo,*)'     hhh     h=2n    '  
       if(i1.eq.12) write(lo,*)'     hkh     k=2n    '  
       if(i1.eq.13) write(lo,*)'     hkk     h=2n    '  
          write(lo,'(i5,6x,8f8.3)')i1,(perctab(i1,i2),i2=1,8) 
       enddo
       endif
      return
      end     
!
!code for condi          
      subroutine condi(ind1)          
      USE General
      USE Laue
!-- applica le condizioni per ogni classe      
!
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/numeref/iref,ress,nrifweig(13,8)
!
!-- 0 0 l
      if(ind1.eq.1)then
!         write(lo,'(a,3i4,4f8.3)')' 0 0 l fo sfo ress '
!     1   ,lh,lk,ll,fo,sfo,ress
         llj=ll
         lll=mod(llj,6)  
!         write(lo,'(a,4i4,3f8.3)')'6 00l  lll',lh,lk,ll,lll
         if(lll.ne.0)then
           ind2=4
           call stortab(ind1,ind2)
         else
           ind2=4
           call stortab2(ind1,ind2)
         endif 
         lll=mod(llj,3)  
!         write(lo,'(a,4i4,3f8.3)')'3 00l  lll',lh,lk,ll,lll
         if(lll.ne.0)then
           ind2=3
           call stortab(ind1,ind2)
         else
           ind2=3
           call stortab2(ind1,ind2)
         endif 
         lll=mod(llj,4)  
!         write(lo,'(a,4i4,3f8.3)')'4 00l  lll',lh,lk,ll,lll
         if(lll.ne.0)then
            ind2=2
            call stortab(ind1,ind2)
         else
            ind2=2
            call stortab2(ind1,ind2)
!            write(lo,'(a,3i4,3f8.3)')'ne4 00l  fo',lh,lk,ll,fo
         endif 
         lll=mod(llj,2)  
!      write(lo,'(a,4i4,3f8.3)')'2 00l  lll',lh,lk,ll,lll
         if(lll.ne.0)then
           ind2=1
           call stortab(ind1,ind2)
         else
           ind2=1
           call stortab2(ind1,ind2)
         endif 
!      write(lo,'(a,4i4,2f8.3)')
!     1 ' 00l ind2,fo,sfo tab,tab2',lh,lk,ll,ind2,fo,sfo
!      write(lo,'(a,3f8.3)')
!     1  'tab(1,ind2,1-3) ',(tab(ind1,ind2,iii),iii=1,3)
!      write(lo,'(a,3f8.3)')
!     1  'tab2(1,ind2,1-3) ',(tab2(ind1,ind2,iii),iii=1,3)
      endif 
!-- 0 k 0 , h 0 0
      if(ind1.eq.2.or.ind1.eq.3)then
         if(ind1.eq.2)then
           ii=lk
!           write(lo,'(a,10x,3i4,4f8.3,i5)')' 0 k 0 f  sfo  ress'
!     1      ,lh,lk,ll,fo,sfo,ress
         endif 
         if(ind1.eq.3)then
           ii=lh
!         write(lo,'(a,20x,3i4,4f8.3,i5)')' h 0 0 fo sfo ress '
!     1    ,lh,lk,ll,fo,sfo,ress
         endif 
         lll=mod(ii,6)  
!          write(lo,'(a,4i4,3f8.3)')'6 00l  lll',lh,lk,ll,lll
         if(lll.ne.0)then
           ind2=4
           call stortab(ind1,ind2)
         else
           ind2=4
           call stortab2(ind1,ind2)
         endif 
         lll=mod(ii,3)  
!         write(lo,'(a,4i4,3f8.3)')'3 00l  lll',lh,lk,ll,lll
         if(lll.ne.0)then
           ind2=3
           call stortab(ind1,ind2)
         else
           ind2=3
           call stortab2(ind1,ind2)
         endif 
         lll=mod(ii,4)  
         if(lll.ne.0)then
           ind2=2
           call stortab(ind1,ind2)
         else
           ind2=2
           call stortab2(ind1,ind2)
         endif 
         lll=mod(ii,2)  
         if(lll.ne.0)then
           ind2=1
           call stortab(ind1,ind2)
         else
           ind2=1
           call stortab2(ind1,ind2)
         endif 
      endif 
!-- 0 k l  , h 0 l  ,  h k 0
      if(ind1.eq.4.or.ind1.eq.5.or.ind1.eq.6)then
         if(ind1.eq.4)then
!          write(lo,'(a,20x,3i4,i5)')' 0 k l  iac',lh,lk,ll,iac
           ii=lk
           jj=ll
           kk=lh
         endif
         if(ind1.eq.5)then
!          write(lo,'(a,10x,3i4,i5)')' h 0 l  iac ',lh,lk,ll,iac
           ii=lh
           jj=ll
           kk=lk
         endif
         if(ind1.eq.6)then
!           write(lo,'(a,25x,3i4,i5)')' h k 0 iac ',lh,lk,ll,iac
           ii=lh
           jj=lk
           kk=ll
         endif
!                              
         ll1=mod(ii,2)  
         ind2=1
         if(ll1.eq.0)then
           call stortab2(ind1,ind2)
         else
           call stortab(ind1,ind2)
         endif
         ll2=mod(jj,2)  
         ind2=2
         if(ll2.eq.0)then
           call stortab2(ind1,ind2)
         else
           call stortab(ind1,ind2)
         endif
!
        ind2=3
        if(ll1.eq.0.and.ll2.eq.0)then
           call stortab2(ind1,ind2)
        else
           call stortab(ind1,ind2)
        endif
!
        ll3=mod(ii+jj,4)  
        ind2=5
        if(ll1.eq.0.and.ll2.eq.0.and.ll3.eq.0)then
           call stortab2(ind1,ind2)
        else
           call stortab(ind1,ind2)
        endif
!
        ll1=mod(ii+jj,2)  
        ind2=4
        if(ll1.eq.0)then
           call stortab2(ind1,ind2)
        else
           call stortab(ind1,ind2)
        endif
      endif
!-- h h 0  ,  h h h
      if(ind1.eq.8.or.ind1.eq.11)then
         lll=mod(lh,2)  
         if(lll.ne.0)then
             ind2=1
             call stortab(ind1,ind2)
         else
             ind2=1
             call stortab2(ind1,ind2)
         endif 
      endif
!-- h k l
      if(ind1.eq.7)then
         lll=mod(lh+lk+ll,2)  
         if(lll.ne.0)then
             ind2=4
             call stortab(ind1,ind2)
         else
             ind2=4
             call stortab2(ind1,ind2)
         endif 
         lla=mod(lh+lk,2)  
         i5=0
         if(lla.ne.0)then
             ind2=1
             call stortab(ind1,ind2)
             ind2=5
             i5=1
             call stortab(ind1,ind2)
         else
             ind2=1
             call stortab2(ind1,ind2)
         endif 
         llb=mod(lk+ll,2)  
         if(llb.ne.0)then
             ind2=2
             call stortab(ind1,ind2)
             if(i5.eq.0)then
                ind2=5
                i5=1
                call stortab(ind1,ind2)
             endif 
         else
             ind2=2
             call stortab2(ind1,ind2)
         endif 
         llc=mod(lh+ll,2)  
         if(llc.ne.0)then
            ind2=3
            call stortab(ind1,ind2)
            if(i5.eq.0)then
              ind2=5
              i5=1
              call stortab(ind1,ind2)
            endif 
         else
            ind2=3
            call stortab2(ind1,ind2)
            if(lla.eq.0.and.llb.eq.0)then
              ind2=5
              call stortab2(ind1,ind2)
            endif
         endif 
         lll=mod(-lh+lk+ll,3)  
         if(lll.ne.0)then
            ind2=6
            call stortab(ind1,ind2)
         else
            ind2=6
            call stortab2(ind1,ind2)
         endif 
         lll=mod(lh-lk+ll,3)  
         if(lll.ne.0)then
            ind2=7
            call stortab(ind1,ind2)
         else
            ind2=7
            call stortab2(ind1,ind2)
         endif 
         lll=mod(lh-lk,3)  
         if(lll.ne.0)then
            ind2=8
            call stortab(ind1,ind2)
         else
            ind2=8
            call stortab2(ind1,ind2)
         endif 
      endif
!-- h -h l
      if(ind1.eq.9)then
!         write(lo,'(a,10x,3i4,3f8.3,i5)')' h -h l fo sfo rho mult'
!    1    ,lh,lk,ll,fo,sfo,weigg
         lll=mod(ll,2)  
         llx=lll
         i3=0 
         i5=0 
         if(lll.ne.0)then
            ind2=1
            call stortab(ind1,ind2)
            ind2=3
            i3=1 
            call stortab(ind1,ind2)
            ind2=5
            i5=1 
            call stortab(ind1,ind2)
         else
            ind2=1
            call stortab2(ind1,ind2)
         endif 
         lll=mod(lh+ll,3)  
         if(lll.ne.0)then
            ind2=2
            call stortab(ind1,ind2)
            if(i3.eq.0)then
              ind2=3
              i3=1 
              call stortab(ind1,ind2)
            endif 
         else
            ind2=2
            call stortab2(ind1,ind2)
            if(llx.eq.0)then
              ind2=3
              call stortab2(ind1,ind2)
            endif 
         endif 
         lll=mod(-lh+ll,3)  
         if(lll.ne.0)then
            ind2=4
            call stortab(ind1,ind2)
            if(i5.eq.0)then
              ind2=5
              i5=1 
              call stortab(ind1,ind2)
            endif 
         else
            ind2=4
            call stortab2(ind1,ind2)
            if(llx.eq.0)then
              ind2=5
              call stortab2(ind1,ind2)
            endif 
         endif 
      endif
!-- h h l or h k h or h k k
      if(ind1.eq.10.or.ind1.eq.12.or.ind1.eq.13)then
         if(ind1.eq.10)then
            ii=ll
            jj=lh
!            write(lo,'(a,10x,3i4,3f8.3,i5)')' h h l fo sfo rho mult'
!    1       ,lh,lk,ll,fo,sfo,weigg
         endif
         if(ind1.eq.12)then
           ii=lk
           jj=lh
         endif
         if(ind1.eq.13)then
           ii=lh
           jj=lk
         endif
         lll=mod(ii,2)  
         llx=mod(jj,2)  
         lly=mod(ii+jj,2)  
         llz=mod(ii+2*jj,4)  
         i2=0 
         i5=0 
         if(lll.ne.0)then
            ind2=1
            call stortab(ind1,ind2)
            ind2=5
            i5=1 
            call stortab(ind1,ind2)
            ind2=2
            i2=1 
            call stortab(ind1,ind2)
         else
            ind2=1
            call stortab2(ind1,ind2)
            if(llx.eq.0)then
                 ind2=5
                 call stortab2(ind1,ind2)
            else
                 ind2=5
!12ott05                 call stortab2(ind1,ind2)
                 call stortab(ind1,ind2)
            endif 
            if(llz.eq.0)then
                 ind2=2
                 call stortab2(ind1,ind2)
            else
                 ind2=2
!12ott05                 call stortab2(ind1,ind2)
                 call stortab(ind1,ind2)
            endif 
         endif 
         lll=mod(ii,3)  
         if(lll.ne.0)then
               ind2=3
               call stortab(ind1,ind2)
         else
               ind2=3
               call stortab2(ind1,ind2)
         endif 
         lll=mod(jj+ii,2)  
         if(lll.ne.0)then
            ind2=4
            call stortab(ind1,ind2)
         else
            ind2=4
            call stortab2(ind1,ind2)
         endif 
      endif
      return
      end
!
!code for stortab_old     !05apr11
      subroutine stortab_old(ind1,ind2)
      USE General
      USE Laue
!
      common/dummyret/tab2ret(13,8,6),tabret(13,8,6),tabnewret(13,8)
      common/dummyinp/indipen(13,8),indipen2(13,8),nEsu(13,8)
     1,numr(13,8,2)
      common/pesigeneral/eosse(3000),weigt(3000),indov(3000)
      common/numeref/iref,ress,nrifweig(13,8)
      common /Esureappl/iapplEsure
      common/rintp/fosum,diffsum,rintres(10,5,2,25)
      double precision fosum,diffsum
!   
      weigress=1.                         !14gen11
      if(iapplEsure.eq.1)then             !19feb11
        Esuremin=0.6
        if(neutro.eq.2)then               !14gen11 
           ressmin=1.0                   !14gen11
           if(ress.lt.ressmin)weigress=0.1  !14gen11
!        endif                              !14gen11
           if(fo*weigress.ge.Esuremin)then  !1mar11
           if(ind1.ne.7)then
           nind=TrovaRintResol(ress)
           b=rintres(1,5,2,nind)*100
           nm=nint(rintres(1,5,1,nind))
!           write(lo,'(2i4,a,3i4,a,f6.2,a,f6.3,a,i3,a,f5.2,a,i5)')
!     1  ,ind1,ind2,' (',lh,lk,ll,') E2=',fo,' Resol=',ress
!     1  ,' Rint(',nind,')=',b ,'%   no. di E =',nm
           endif
           endif
        endif
      else if(iapplEsure.eq.0)then        !19feb11
        Esuremin=20.0
      endif                               !19gen11
!
!      write(lo,*)'lh,lk,ll,ind1,ind2,iaccep',
!     1lh,lk,ll,ind1,ind2,iaccep
      indipen(ind1,ind2)=indipen(ind1,ind2)+1
      if(indipen(ind1,ind2).gt.1)return
!             ncont(ind1)=ncont(ind1)+1
!             foclass(ind1)=foclass(ind1)+fo
!             wclass(ind1)=wclass(ind1)+weigg
      tab(ind1,ind2,1)=tab(ind1,ind2,1)+1
      tab(ind1,ind2,2)=tab(ind1,ind2,2)+fo*weigress
      tab(ind1,ind2,3)=tab(ind1,ind2,3)+fo*weigg
      tab(ind1,ind2,4)=tab(ind1,ind2,4)+weigg
      if(tabfomax(ind1,ind2,1).lt.fo)tabfomax(ind1,ind2,1)=fo*weigress
      if(tabfomax(ind1,ind2,2).gt.fo)tabfomax(ind1,ind2,2)=fo*weigress
      tab(ind1,ind2,5)=0.0
!      if(ind1.eq.7.and.ind2.eq.4.and.msys.eq.4)
!     1write(lo,'(a,3i4,3f8.3,2i4,i6)')
!     1'stortab stor. lh,lk,ll,fo,sfo,weigress,ind1,ind2,ncont(ind1) ',
!     1lh,lk,ll,fo,sfo,weigress,ind1,ind2,ncont(ind1)
!
      if(weigress.eq.0.1)then
      nrifweig(ind1,ind2)=nrifweig(ind1,ind2)+1
!      write(lo,'(a,6i4,2f8.3,2i4,i6)')
!     1'iref,lh,lk,ll,ind1,ind2,fo,ress,nrifweig(ind1,ind2)',
!     1 iref,lh,lk,ll,ind1,ind2,fo,ress,nrifweig(ind1,ind2)
      endif    
      if(sfo.gt.0.and.weigress*fo.gt.Esuremin)then   !14gen11
          nEsure(ind1,ind2)=nEsure(ind1,ind2)+1
          Esure(ind1,ind2)=
!     *    Esure(ind1,ind2)*exp(-sqrt(eosse(iref)))
     *    Esure(ind1,ind2)+fo      !4apr2008
!          if(ind1.eq.5.and.ind2.eq.1)write(lo,'(a,3i3,2i3,i5,3f8.3)')
!      else if(weigress.le.0.11.and.fo.gt.Esuremin) then
!       if(ind1.eq.7)
!     1write(lo,'(a,a,2x,3i3,5x, 2i5,i5,3f8.3,3x,f8.3)')
!     1'h,k,l,ind1,ind2,nEsure(ind1,ind2),fo,weigress,Esure(ind1,ind2),',
!     1'resol'
!     1,lh,lk,ll,ind1,ind2,nEsure(ind1,ind2),fo,weigress,Esure(ind1,ind2)
!     1 ,ress
      endif
      return
      end
!
!code for stortab
      subroutine stortab(ind1,ind2)
      USE General
      USE Laue
      USE Riflessi
!
      common/dummyret/tab2ret(13,8,6),tabret(13,8,6),tabnewret(13,8)
      common/dummyinp/indipen(13,8),indipen2(13,8),nEsu(13,8)
     1,numr(13,8,2)
      common/pesigeneral/eosse(3000),weigt(3000),indov(3000)
      common/numeref/iref,ress,nrifweig(13,8)
      common /Esureappl/iapplEsure
      common/rintp/fosum,diffsum,rintres(10,5,2,25)
      double precision fosum,diffsum
!   
      indipen(ind1,ind2)=indipen(ind1,ind2)+1
      if(indipen(ind1,ind2).gt.1)return
      weigress=1.
      jsomm=1
      if(iapplEsure.eq.1)then             !19feb11
        Esuremin=0.6
        if(neutro.eq.2)then               !14gen11 
!           ressmin=1.0                   !14gen11
           ressmin=1.1                    !28apr11
           jsomm=mult(iref)
!11mag11           if(ress.gt.ressmin.and.fo.gt.Esuremin)then
!11mag11              nEsure(ind1,ind2)=nEsure(ind1,ind2)+jsomm
!11mag11              nEsu(ind1,ind2)=nEsu(ind1,ind2)+1
!11mag11              Esure(ind1,ind2)= Esure(ind1,ind2)+fo*jsomm      
!       if(ind1.eq.4.or.ind1.eq.5.and.ind2.eq.5)
!     1write(lo,'(a,a,2x,3i3,5x, 2i5,i5,3f8.3,3x,f8.3)')
!     1'h,k,l,ind1,ind2,nEsure(ind1,ind2),E2,Esure(ind1,ind2),',
!     1'resol',
!     1lh,lk,ll,ind1,ind2,nEsure(ind1,ind2),fo,Esure(ind1,ind2)
!     1 ,ress
!!     1write(lo,'(2x,3i3,2x,i5,2f8.3,6x,f8.3)')
!!     1lh,lk,ll,nEsure(ind1,ind2),fo ,ress
!11mag11           endif
          if(ress.gt.ressmin)valEsure(ind1,ind2,iref)=fo    !11mag11
!      write(lo,'(a,3i3,2x,i5,2i3,10x,3f8.3,3x,f8.3)')
!     1'lh,lk,ll,iref,ind1,ind2, valEsure(ind1,ind2,iref),ress ',
!     1 lh,lk,ll,iref,ind1,ind2, valEsure(ind1,ind2,iref),ress
        else
          if(sfo.gt.0.and.fo.gt.Esuremin)then   !14gen11
            nEsu(ind1,ind2)=nEsu(ind1,ind2)+1
            nEsure(ind1,ind2)=nEsure(ind1,ind2)+jsomm
            Esure(ind1,ind2)= Esure(ind1,ind2)+fo*jsomm      !4apr2008
          endif
        endif
      endif                               !19gen11
!
!      write(lo,*)'lh,lk,ll,ind1,ind2,iaccep',
!     1lh,lk,ll,ind1,ind2,iaccep
      tab(ind1,ind2,1)=tab(ind1,ind2,1)+jsomm
      tab(ind1,ind2,2)=tab(ind1,ind2,2)+fo*jsomm
      tab(ind1,ind2,3)=tab(ind1,ind2,3)+fo*jsomm*weigg
      tab(ind1,ind2,4)=tab(ind1,ind2,4)+weigg*jsomm
      if(tabfomax(ind1,ind2,1).lt.fo)tabfomax(ind1,ind2,1)=fo
      if(tabfomax(ind1,ind2,2).gt.fo)tabfomax(ind1,ind2,2)=fo
      tab(ind1,ind2,5)=0.0
!      if(ind1.eq.3.and.msys.eq.4)
!     1write(lo,'(a,3i4,3f8.3,2i4,i6)')
!     1'stortab stor. lh,lk,ll,fo,sfo,weigress,ind1,ind2,ncont(ind1) ',
!     1lh,lk,ll,fo,sfo,weigress,ind1,ind2,ncont(ind1)
!
!     1write(lo,'(a,6i4,2f8.3,2i4,i6)')
!     1'1 iref,lh,lk,ll,ind1,ind2,fo,ress,numr(ind1,ind2,1),ncont(ind1)',
!     1 iref,lh,lk,ll,ind1,ind2,fo,ress,numr(ind1,ind2,1),ncont(ind1)
      return
      end
!
!code for stortab2
      subroutine stortab2(ind1,ind2)
      USE General
      USE Laue
      USE Riflessi
!
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/dummyret/tab2ret(13,8,6),tabret(13,8,6),tabnewret(13,8)
      common/pesigeneral/eosse(3000),weigt(3000),indov(3000)
      common/dummyinp/indipen(13,8),indipen2(13,8),nEsu(13,8)
     1,numr(13,8,2)
      common/numeref/iref,ress,nrifweig(13,8)
!
      indipen2(ind1,ind2)=indipen2(ind1,ind2)+1
      if(indipen2(ind1,ind2).gt.1)return
      jsomm=1
      if(neutro.eq.2)jsomm=mult(iref)
!      write(lo,*)'lh,lk,ll,ind1,ind2,iaccep',
!     1lh,lk,ll,ind1,ind2,iaccep
!      write(lo,*)'stortab2 storizzato lh,lk,ll,ind1,ind2,ncont(ind1) ',
!     1lh,lk,ll,ind1,ind2,ncont(ind1)
      numr(ind1,ind2,2)=numr(ind1,ind2,2)+1
      tab2(ind1,ind2,1)=tab2(ind1,ind2,1)+jsomm
      tab2(ind1,ind2,2)=tab2(ind1,ind2,2)+fo*jsomm
      tab2(ind1,ind2,3)=tab2(ind1,ind2,3)+fo*weigg*jsomm
      tab2(ind1,ind2,4)=tab2(ind1,ind2,4)+weigg*jsomm
      tab2(ind1,ind2,5)=0.0
!      if(ind1.eq.2.and.msys.eq.5)
!     1write(lo,'(a,6i4,2f8.3,2i4,i6)')
!     1'2 iref,lh,lk,ll,ind1,ind2,fo,ress,numr(ind1,ind2,2),ncont(ind1)',
!     1 iref,lh,lk,ll,ind1,ind2,fo,ress,numr(ind1,ind2,2),ncont(ind1)
      return
      end
!
!code for xnoteq
      subroutine xnoteq(riga)
!--insert the character (not equal) instead =
!
      character*(*) riga
!
      k=len(riga)
      do i=1,k
      j=ichar(riga(i:i))
!      if(j.eq.61) riga(i:i)=achar(216)
      if(j.eq.61) riga(i:i)='#'
      enddo
      return
      end
!
!code for xmaius
      subroutine xmaius(riga)
!--insert the character (not equal) instead =
!
      character*(*) riga
      j=ichar(riga(1:1))
      if(j.eq.112)riga(1:1)='P'
      if(j.eq.114)riga(1:1)='R'
      if(j.eq.105)riga(1:1)='I'
      if(j.eq.102)riga(1:1)='F'
      if(j.eq.99)riga(1:1)='C'
      if(j.eq.98)riga(1:1)='B'
      if(j.eq.97)riga(1:1)='A'
      return
      end
!
!code for stampas
      subroutine stampas(imer, lout)
      USE General
      USE Laue
!
      character*18 scond1(13,8)
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,fattover 
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/dummyyy/valmedio(13),loo
      common/dummyret/tab2ret(13,8,6),tabret(13,8,6),tabnewret(13,8)
      common/refanaprint/natv,volcel,apeso,bpeso
      common/dummyinp/indipen(13,8),indipen2(13,8),nEsu(13,8)
     1,numr(13,8,2)
      common/numeref/iref,ress,nrifweig(13,8)
      character*80 apeso,bpeso
!
      dimension numcond2(13)
!--
!
!-- set la stampa completa  
!      numcond2(1)=4
!      numcond2(2)=4
!      numcond2(3)=4
!      numcond2(4)=5
!      numcond2(5)=5
!      numcond2(6)=5
!      numcond2(7)=7
!      numcond2(8)=1
!      numcond2(9)=5
!      numcond2(10)=5
!      numcond2(11)=1
!      numcond2(12)=5
!      numcond2(13)=5
!
       loo=lout
       do i=1,13
          numcond2(i)=numcond(i)
       enddo 
!
!-- stampa intestazione
!       write(lo,*)
!     1  '                                                   ',
!     1  'Space Group Determination Routine'
!       write(loo,*)
!     1  '                                                   ',
!     1  'Space Group Determination Routine'
!      write(loo,*)       
!     1  '      Crystal System determination',
!     1 ' by geometrical analysis of the cell:'
!      if(msys.eq.0)write(loo,*)
!     1'                         TRICLINIC  '
!      if(msys.eq.1)write(loo,*)
!     1'                        MONOCLINIC Unique axis a '
!      if(msys.eq.2)then
!                   write(loo,*)
!     1'                        MONOCLINIC Unique axis b '
!                   write(loo,*)
!     1'                        Laue Class:   2/m        '
!      else if(msys.eq.3)then
!                   write(loo,*)
!     1'                        MONOCLINIC Unique axis c '
!      else if(msys.eq.4)then
!      write(loo,*)
!     1'                        ORTHORHOMBIC  '
!       if(msys.eq.4.and.imer.eq.1)write(lo,*)
!     1'                        Laue Class:   2/m 2/m 2/m '
      if(msys.eq.5)then
!      write(loo,*)
!     1'                        TETRAGONAL  '
       if(imer.eq.1)write(lo,*)
     1'                        Laue Class:   4/m       '
       if(imer.eq.2)write(lo,*)
     1'                        Laue Class:   4/m m m   '
      else if(msys.eq.6)then
!      write(loo,*)
!     1'                    TRIGONAL or HEXAGONAL  '
       if(imer.eq.1)write(loo,*)
     1'                        Laue Class:   -3       '
       if(imer.eq.2)write(loo,*)
     1'                        Laue Class:   -3 m 1 '
       if(imer.eq.3)write(loo,*)
     1'                        Laue Class:   -3 1 m   '
       if(imer.eq.4)write(loo,*)
     1'                        Laue Class:   6/m       '
       if(imer.eq.5)write(loo,*)
     1'                        Laue Class:   6/m m m   '
      else if(msys.eq.7)then
!      write(loo,*)
!     1'                          CUBIC'
       if(imer.eq.1)write(loo,*)
     1'                        Laue Class:   m -3       '
       if(imer.eq.2)write(loo,*)
     1'                        Laue Class:   m -3 m   '
      else if(msys.eq.8)then
!      write(loo,*)
!     1'                        RHOMBOHEDRAL  '
       if(imer.eq.1)write(loo,*)
     1'                        Laue Class:   -3       '
       if(imer.eq.2)write(loo,*)
     1'                        Laue Class:   -3 m 1 '
      endif
       write(loo,200)
!--stampa informazione generale
*     write(lo,*)'Maximum rho accepted:',rhosog
*     write(lo,*)
*    1 'Total number of independent reflections :   ',ntotai+nonconsid
*     write(lo,*)
*    1 'Total number of reflections considered:     ',ntota
*     if(ipow.eq.1)write(lo,*)
*    1 'Total number of reflections greater than 3s:',
*    1 ntota-nonacc
*     write(lo,*)'< fo > Total :   ' ,tfo
!     if(ipow.eq.0.and.tfosfo.gt.0) write(lo,*)'< fo/sfo >Total :',tfosfo
*     write(lo,*)'Tolerance :      ',toller
!      if(ipow.eq.0.and.tfosfo.eq.0)
!     1write(lo,*)' Data set without standard deviation '
*     write(lo,1030  format(1h ,78(1h-))


!--
*     write(lo,*)' fomax per each class '
*     write(lo,*)' fomin per each class '
      if (msys.eq.0) then
          i13=7
      else
          i13=numclass(msys)
      endif
      do i=1,i13
*        write(lo,'(/,2x,a,i2,2x,a,i4)')'class n. ',i,'n.ref= ',ncont(i)
         ij=numcond2(i)
*         write(lo,'(9x,8i8)')(jj,jj=1,ij)
         do jj=1,ij
            if(tabfomax(i,jj,1).lt.0)tabfomax(i,jj,1)=0.
            if(tabfomax(i,jj,2).ge.1000.)tabfomax(i,jj,2)=0.
         enddo
*        write(lo,'(2x,a,2x,8f8.2)')
*    1   'fomax ',(tabfomax(i,jj,1),jj=1,ij)
*        write(lo,'(2x,a,2x,8f8.2)')
*    1   'fomin ',(tabfomax(i,jj,2),jj=1,ij)
         do j=1,8
           riga=scond(i,j)
           call xnoteq(riga)
           scond1(i,j)=riga
         enddo
      enddo
!      write(loo,*)'i1,( i2,nEsure Esure ) '
!      do i=1,13
!      write(loo,'(i2,8(i2,i5,f7.1))')i,(j,nEsure(i,j),Esure(i,j),j=1,ij)
!      enddo
      write(loo,200)
!
      write(loo,210)
      write(loo,200)
      write(loo,200)
      write(loo,200)
      write(loo,220)
      if (loo == lo) then
          write(loo,230) 
      else
          write(loo,240) 
      endif
      write(loo,250) 
      if (neutro.ne.2) then
          if (loo == lo) then
              write(loo,260)
          else
              write(loo,270)
          endif
      elseif (neutro.eq.2) then
          if (loo == lo) then
              write(loo,280)
          else
              write(loo,290)
          endif
      endif
!
      if(neutro.eq.2)nEsu=nEsure
      if(icomple.eq.1)i13=13
      do idum=1,i13
         i=idum
         if(idum.eq.1)i=3
         if(idum.eq.3)i=1
         ij=numcond2(i)
         focl=0.0
         wcl=0.0
         if(ncont(i).gt.0)focl=foclass(i)
         if(ncont(i).gt.0)wcl=wclass(i)/ncont(i)
         if(neutro.ne.2)then                 
            write(loo,'(2x,a,i6,2f12.3)')
     1       stab(i),ncont(i),focl,wcl
         else
            write(loo,'(2x,a,i6,f8.3)')
     1       stab(i),ncont(i),focl
         endif
         if(ncont(i).gt.0.and.focl.gt.0)then
            if(ij.gt.0)then
               ij0=numcond(i)
               do j=1,ij
                 nt=nint(tab(i,j,1))
                 if(neutro.eq.2)nt=numr(i,j,1)
                 ntg=tab(i,j,2)
! 1               format(2i3,5f7.2)
!                 write(lo,*)'i,j,nt,nt2',i,j,nt,nt2
!                 write(lo,*)'nclass,j,(tab(nclass,j,k),k=1,5)'
!                write(lo,1)i,j,(tab(i,j,k),k=1,5)
                 rapp=tab(i,j,5)
                 tabij5=-1
                 if(rapp.ge.0.and.ij0.ge.j)tabij5=1
                 ijj=tab(i,j,6)
                 if(tabij5.lt.0.)ijj=42
                 it5=nint(tabij5)
                 if(neutro.ne.2)then                 
                 write(loo,12)
     1            scond1(i,j),nt,(tab(i,j,k),k=2,5)
     1            ,tabnew(i,j),symope(ijj)
                 else
                 write(loo,'( 1x,a,i6,1x,f10.2,i10,2f10.2,a,2i6)')
     1            scond1(i,j),nt,tab(i,j,2),nEsu(i,j),Esure(i,j)
     1            ,tabnew(i,j),symope(ijj) !,nEsure(i,j),nint(tab(i,j,1))
                 endif
                 ntr=nint(tabret(i,j,1))
                 ntgr=tabret(i,j,2)
                 rapp=tabret(i,j,5)
!                write(loo,'(a,5x,i5,1x,5f7.2)')
!     1          ' single refl. ',ntr,(tabret(i,j,k),k=2,5)
!     1          ,tabnewret(i,j)
!-- gli altri...
                 nt=nint(tab2(i,j,1))
                 if(neutro.eq.2)nt=numr(i,j,2)
                 ntg=nint(tab2(i,j,2))
                 if(neutro.ne.2)then                 
                 write(loo,121)
     1           scond2(i,j),nt,(tab2(i,j,k),k=2,5)
                 else
                 write(loo,1212)
     1           scond2(i,j),nt,tab2(i,j,2) !,tab2(i,j,1)
                 endif
                 ntr2=nint(tab2ret(i,j,1))
                 ntgr=tab2ret(i,j,2)
                 rapp=tab2ret(i,j,5)
!                write(loo,'(a,5x,i5,1x,5f7.2)')
!     1          ' single refl. ',ntr2,(tab2ret(i,j,k),k=2,5)
               enddo
            endif
         endif
      enddo
      write(loo,*)'  '
      write(loo,*)'  '
10    format(18x,a,i6,i6,2f7.1,1x,a,f3.0)
12    format( 1x,a,i6,1x,5f7.2,a)
121   format( 1x,a,i6,1x,4f7.2,10x,a,f8.2)
1212  format( 1x,a,i6,1x,4f10.2,10x,a,f8.2)
122   format( 1x,a,i5,1x,4f6.2,f7.2,22x,f8.2)
120   format(16x,a,i4,1x,2f6.2,7x,a,f3.0)
  200 format(' ')
  210 format('               SYSTEMATIC ABSENCE EXCEPTIONS')
  220 format(
     *'  Note: Symbol # means not equal  ',/,
     *'      NR    means number of reflections (equivalent included)',/,
     *'      NRcl  means number of input reflections in each class')
  230 format(
     *'      [A]   means <E**2> over the class of ',
     *'reflections expected to be')
  240 format(
     *'      [A]   means &#60;E**2&#62; over the class of ',
     *'reflections expected to be')
  250 format(
     *'              systematicly absent: e.g. (0k0)',
     *' with k=2n+1 for P 1 21 1')
  260 format(
     *'      [B]   means <w*E**2>/NR',/,
     *'      [C]   means <w>=sum(w)/NR',/,
     *'      [D]   means sum(w*E**2)/sum(w)  ',/,
     *'      [E]   means [D]extincted/[D]notextincted',//,
     *'   Class ','   NRcl.   [D]cl.  [C]cl.',/,
     *' Condition ','            NR    ',
     *'[A] ','   [B] ','   [C] ','   [D] ','   [E] ',
     *' Sym. Op. ',/)
  270 format(
     *'      [B]   means &#60;w*E**2&#62;/NR',/,
     *'      [C]   means &#60;w&#62;=sum(w)/NR',/,
     *'      [D]   means sum(w*E**2)/sum(w)  ',/,
     *'      [E]   means [D]extincted/[D]notextincted',//,
     *'   Class ','   NRcl.   [D]cl.  [C]cl.',/,
     *' Condition ','            NR    ',
     *'[A] ','   [B] ','   [C] ','   [D] ','   [E] ',
     *' Sym. Op. ',/)
  280 format(
     *'      nEs   means number of reflections with Esure',/,
     *'      [B]   means <Esure**2>/nEsure',/,
     *'      [E]   means [A]extincted/[A]notextincted',//,
     *'   Class ','   NRcl. <E**2>cl.  ',/,
     *' Condition ','            NR    ',
     *'  [A]     ','   nEs    ','   [B]    ','   [E] ',
     *' Sym. Op. ',/)
  290 format(
     *'      nEs   means number of reflections with Esure',/,
     *'      [B]   means &#60;Esure**2&#62;/nEsure',/,
     *'      [E]   means [A]extincted/[A]notextincted',//
     *'   Class ','   NRcl. &#60;E**2&#62;cl.  ',/,
     *' Condition ','            NR    ',
     *'  [A]     ','   nEs    ','   [B]    ','   [E] ',
     *' Sym. Op. ',/)
!      close(loo)
      return
      end
!
!code for stampaGenh
      subroutine stampaGenh
      USE General
      USE Laue
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa
!
!-- stampa intestazione
       write(lo,*)
     1  '                  Space Group Determination Routine'
!       write(lo,*)
!     1  ' For the statistic, the reflections were expanded', 
!     1  ' by application of the point group operators ' 
      write(lo,*)       
     1  '      Crystal System determination',
     1 ' by geometrical analysis of the cell:'
      if(msys.eq.0)write(lo,*)
     1'                         TRICLINIC  '
      if(msys.eq.1)write(lo,*)
     1'                        MONOCLINIC Unique axis a '
      if(msys.eq.2)write(lo,*)
     1'                        MONOCLINIC Unique axis b '
      if(msys.eq.3)write(lo,*)
     1'                        MONOCLINIC Unique axis c '
      if(msys.eq.4)write(lo,*)
     1'                        ORTHORHOMBIC  '
      if(msys.eq.5)write(lo,*)
     1'                        TETRAGONAL  '
      if(msys.eq.6)write(lo,*)
     1'                    TRIGONAL or HEXAGONAL  '
      if(msys.eq.7)write(lo,*)
     1'                          CUBIC'
      if(msys.eq.8)write(lo,*)
     1'                        RHOMBOHEDRAL  '
       write(lo,*)' '
!--stampa informazione generale
!      write(lo,*)' ntotai,ntota,noconsid',ntotai,ntota,nonconsid
      write(lo,*)
     1 'Total number of independent reflections :   ',ntotai+nonconsid
      write(lo,*)
     1 'Total number of reflections considered:     ',ntota
      write(lo,*)
     1 'Total number of reflections greater than 3s:',
     1 ntota-nonacc
      write(lo,*)'< fo >Total :    ' ,tfo
      if(tfosfo.gt.0) write(lo,*)'< fo/sfo >Total :',tfosfo
      write(lo,*)' '
!--
      do i=1,13
        do j=1,8
           riga=scond(i,j)
           call xnoteq(riga)
           scond(i,j)=riga
        enddo
      enddo
!
      write(lo,*)'               SYSTEMATIC ABSENCE EXCEPTIONS'
      write(lo,*)'  '
      write(lo,*) '  Note: Symbol # means not equal  '
      if(tfosfo.eq.0)write(lo,*) '        foT  means <fo>Total  '
      if(tfosfo.gt.0)then
         write(lo,11)
      else
         write(lo,13)
      endif
!
      i13=numclass(msys)
      if(icomple.eq.1)i13=13
      do i=1,i13
         ij=numcond(i)
         if(ij.gt.0)write(lo,'(2x,a,i6)')stab(i),ncont(i)
         if(ncont(i).gt.0)then
            if(ij.gt.0)then
               do j=1,ij
                 nt=nint(tab(i,j,1))
                 ntg=nint(tab(i,j,2))
                 fomed=tab(i,j,3)
                 sfomed=tab(i,j,5)
                 ijj=tab(i,j,6)
!                 write(lo,*)'i,j,tab(i,j,6),symope(ijj),tab(i,j,5)'
!     1           ,i,j,tab(i,j,6),symope(ijj),tab(i,j,5)
                 if(tab(i,j,4).lt.0.)ijj=42
                 if(tfosfo.gt.0)then
                    write(lo,10)
     1              scond(i,j),nt,ntg,fomed,sfomed,symope(ijj)
!     1              ,tab(i,j,4)
                 endif
               enddo
            endif
         endif
      enddo
      write(lo,*)'  '
      write(lo,*)'  '
10    format(17x,a,i6,i6,1x,2f7.1,1x,a,f3.0)
11    format(/,'    Refl.','  Total','  Condition  ',4x
     1  ,'  N.Refl. ','N.(>3s) '
     1 ,'<fo>',' <fo/s> ',' Sym. Op.   ',/,'    Type','   Number' )
13    format(/,'    Refl.','  Total','    Condition',4x
     1  ,'  N.Refl. ','  '
     1 ,'<fo>',' <fo>/foT ',' Sym. Op.   ',/,'    Type','   Number' )
12    format(18x,a,i5,2x,2f7.1,1x,a,f3.0)
      return
      end
!
!code for anaclass
      subroutine anaclass(nclass)
      USE General
      USE Laue
!
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/dummyret/tab2ret(13,8,6),tabret(13,8,6),tabnewret(13,8)
      common/dummyyy/valmedio(13),loo
!
!   tab(i,j,1) no. of total refl. belonging to the j cond. of the i class
!   tab(-,-,2) no. of refl. with (fo.gt.nsig*sfo) belonging to the i,j class
!   tab(-,-,3) <fo> of this class
!   tab(-,-,4) <sfo> of this class
!   tab(-,-,5) =1 there are no exceptions.(l'operatore puo esistere)
!   tab(-,-,5) =-1 l'operatore non puo' esistere
!-- tab(nclass,j,5) = 1 no reflection with the j-condition (sym.op. present)
!-- tab(nclass,j,5) =-1 j-condition no verified
!-- set numero di cond. per ogni classe.
      i1=1
      if(msys.ge.4)i1=2
      numcond(1)=i1
      numcond(2)=i1
      numcond(3)=i1
      numcond(4)=i1+3
      numcond(5)=i1+3
      numcond(6)=i1+3
      numcond(7)=i1+3
      if(msys.eq.5)then
         numcond(1)=2
         numcond(8)=1
         numcond(9)=0
         numcond(10)=2
      endif
      if(msys.eq.6)then
         numcond(1)=4
         numcond(7)=7
         numcond(8)=0
         numcond(9)=5
         numcond(10)=3  
      endif
      if(msys.eq.7)then
         numcond(1)=2
         numcond(2)=2
         numcond(3)=2
         numcond(7)=5
         numcond(8)=0
         numcond(9)=0
         numcond(10)=5
         numcond(11)=0
         numcond(12)=5
         numcond(13)=5
      endif
      if(msys.eq.8)then
         numcond(8)=0
         numcond(9)=0
         numcond(11)=1
         numcond(10)=1
         numcond(12)=1
         numcond(13)=1
      endif
      if(wclass(nclass).gt.0)
     1   foclass(nclass)=foclass(nclass)/wclass(nclass)
      ttfo=foclass(nclass)
      if(ttfo.le.0.)ttfo=tfo
!           write(lo,*)'nclass,j,tab(nclass,j,5),tab2(nclass,j,5)
!     1    ,tabnew(nclass,j)'
      ij=numcond(nclass)
      do j=1,ij
         if(neutro.ne.2) then    !11mag11
           if(nEsure(nclass,j).gt.0)
     1     Esure(nclass,j)=Esure(nclass,j)/nEsure(nclass,j)    !27mar08
         endif
!
!--22feb11         tabnew(nclass,j)=1.
         tabnew(nclass,j)=0.5 !se mancano i rifl. la prob. deve essere 0.5
         tabnewret(nclass,j)=1.
         nt=nint(tab(nclass,j,1))
         nt2=nint(tab2(nclass,j,1))
         if(nt.gt.0)tab(nclass,j,2)=tab(nclass,j,2)/nt
         if(nt.gt.0)tab(nclass,j,3)=tab(nclass,j,3)/nt
         if(nt.gt.0)tab(nclass,j,4)=tab(nclass,j,4)/nt
!
         if(tab(nclass,j,4).gt.0)then
          tab(nclass,j,5)=tab(nclass,j,3)/tab(nclass,j,4)
          if(neutro.eq.2)tab(nclass,j,5)=tab(nclass,j,2)/tab(nclass,j,4)
         endif
!
         if(nt2.gt.0)tab2(nclass,j,2)=tab2(nclass,j,2)/nt2
         if(nt2.gt.0)tab2(nclass,j,3)=tab2(nclass,j,3)/nt2
         if(nt2.gt.0)tab2(nclass,j,4)=tab2(nclass,j,4)/nt2
         if(tab2(nclass,j,4).gt.0)
     1       tab2(nclass,j,5)=tab2(nclass,j,3)/tab2(nclass,j,4)
!--determina gli Esure per elettroni
         if(neutro.eq.2) then
            Esure(nclass,j)=0.
            nEsure(nclass,j)=0
            e2next=0.6*sqrt(tab2(nclass,j,2))
            if(e2next.lt.0.00001)cycle
            do ii=1,nrefl
             if(valEsure(nclass,j,ii).ge.e2next)then
                Esure(nclass,j)=Esure(nclass,j)+valEsure(nclass,j,ii)
                nEsure(nclass,j)=nEsure(nclass,j)+1
!             write(lo,'(a,3i4,f8.3,i5)')
!     1        'ii,nclass,j,valEsure(nclass,j,ii),nEsure(nclass,j) ',
!     1        ii,nclass,j,valEsure(nclass,j,ii),nEsure(nclass,j)
             endif   
            enddo
            if(nEsure(nclass,j).gt.0)
     1      Esure(nclass,j)=Esure(nclass,j)/nEsure(nclass,j)    !27mar08
!             write(lo,'(a,a,2i4,3f8.3,i4)')
!     1       'nclass,j,tab2(nclass,j,2),e2next,',
!     1       'Esure(nclass,j),nEsure(nclass,j)',        
!     1       nclass,j,tab2(nclass,j,2),e2next,
!     1       Esure(nclass,j),nEsure(nclass,j)        
         endif     
!-- analizza i riflessi singoli  
         ntr=nint(tabret(nclass,j,1))
         nt2r=nint(tab2ret(nclass,j,1))
!         write(lo,*)'ntr,nt2r',ntr,nt2r
         if(ntr.le.0)then
            tabret(nclass,j,2)=0.
            tabret(nclass,j,3)=0.
            tabret(nclass,j,4)=0.
            tabret(nclass,j,5)=0.
         else
            tabret(nclass,j,2)=tabret(nclass,j,2)/ntr
            tabret(nclass,j,3)=tabret(nclass,j,3)/ntr
            tabret(nclass,j,4)=tabret(nclass,j,4)/ntr
!
            if(tabret(nclass,j,4).gt.0)
     1      tabret(nclass,j,5)=tabret(nclass,j,3)/tabret(nclass,j,4)
            if(tabret(nclass,j,5).lt.0.10)
     1            tabret(nclass,j,5)=0.10
         endif
         if(nt2r.le.0)then
               tab2ret(nclass,j,2)=0.
               tab2ret(nclass,j,3)=0.
               tab2ret(nclass,j,4)=0.
               tab2ret(nclass,j,5)=0.
         else
               tab2ret(nclass,j,2)=tab2ret(nclass,j,2)/nt2r
               tab2ret(nclass,j,3)=tab2ret(nclass,j,3)/nt2r
               tab2ret(nclass,j,4)=tab2ret(nclass,j,4)/nt2r
               if(tab2ret(nclass,j,4).gt.0)
     1         tab2ret(nclass,j,5)=
     1         tab2ret(nclass,j,3)/tab2ret(nclass,j,4)
               if(tab2ret(nclass,j,5).lt.0.10)
     1            tab2ret(nclass,j,5)=0.10
         endif
!            endif
!
!-- calcola prob= <e2w>est/<e2w>n.est  per 1<nclass<13
         e2wtotal=tab2(nclass,j,5)
         if(e2wtotal.gt.0)tabnew(nclass,j)=tab(nclass,j,5)/e2wtotal
!           write(lo,*)'nclass,j,tab(nclass,j,5),tab2(nclass,j,5)
!     1    ,tabnew(nclass,j)'
!       write(lo,'(2i5,3f8.3)')
!     1    ,nclass,j,tab(nclass,j,5),tab2(nclass,j,5),tabnew(nclass,j)
         e2wtotalr=tab2ret(nclass,j,5)
         if(e2wtotalr.gt.0)
     1    tabnewret(nclass,j)=tabret(nclass,j,5)/e2wtotalr
      enddo
      return
      end
!
!code for numclass
      function numclass(m)
      USE General
!
      numclass=7
      if(m.eq.5)numclass=10
      if(m.eq.6)numclass=10
      if(m.gt.6)numclass=13
      return
      end
!                                                             
!code for msyss
      subroutine msyss  
      USE General
      USE Laue
!
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa
!     
      if(msys0.ne.-1)then
         msyss1=msys 
      else
         msyss1=9
      endif
!-- set la stampa completa  
      if(icomple.eq.1)then
         msyss1=9
         if(msys.eq.0)msys0=-1
      endif
!-- set numero di cond. per ogni classe.
      i1=1
      if(msyss1.ge.4)i1=2
      numcond(1)=i1
      numcond(2)=i1
      numcond(3)=i1
      numcond(4)=i1+3
      numcond(5)=i1+3
      numcond(6)=i1+3
      numcond(7)=i1+3
      if(msyss1.eq.5)then
         numcond(1)=2
         numcond(8)=1
         numcond(9)=0
         numcond(10)=2
      endif
      if(msyss1.eq.6)then
         numcond(1)=4
         numcond(7)=7
         numcond(8)=0
         numcond(9)=5
         numcond(10)=3
      endif
      if(msyss1.eq.7)then
         numcond(1)=4
         numcond(2)=4
         numcond(3)=4
         numcond(7)=5
         numcond(8)=0
         numcond(9)=0
         numcond(10)=5
         numcond(11)=0
         numcond(12)=5
         numcond(13)=5
      endif
      if(msyss1.eq.8)then
         numcond(8)=0
         numcond(9)=0
         numcond(11)=1
         numcond(10)=1
         numcond(12)=1
         numcond(13)=1
      endif
      if(msyss1.eq.9)then
         numcond(1)=4
         numcond(2)=4
         numcond(3)=4
         numcond(7)=7
         numcond(8)=1
         numcond(9)=5
         numcond(10)=5
         numcond(11)=1
         numcond(12)=5
         numcond(13)=5
      endif
!-- setta le stampe per stampas
          tab(:,:,6)=42
      mm=0
      if(msys.eq.4.or.msys.eq.5.or.msys.eq.7)mm=1
      tab(7,1,6)=36
      tab(7,2,6)=34
      tab(7,3,6)=35
      tab(7,4,6)=37
      tab(7,5,6)=38
      tab(7,6,6)=39
      tab(7,7,6)=40
      tab(7,8,6)=41
      if(msys.le.4)then 
         tab(7,6,6)=42
         tab(7,7,6)=42
         tab(7,8,6)=42
      endif
      if(msys.eq.1.or.mm.eq.1)then    
              tab(3,1,6)=1
              tab(4,1,6)=14
              tab(4,2,6)=15
              tab(4,4,6)=16
              if(msys.ne.1)tab(4,5,6)=17
      endif        
      if(msys.eq.2.or.mm.eq.1)then      
              tab(2,1,6)=4
              tab(5,1,6)=18
              tab(5,2,6)=20
              tab(5,4,6)=21
              if(msys.ne.2)tab(5,5,6)=22
      endif        
      if(msys.eq.3.or.mm.eq.1)then      
              tab(1,1,6)=7
              tab(6,1,6)=23
              tab(6,2,6)=24
              tab(6,4,6)=26 
              if(msys.ne.3)tab(6,5,6)=27
      endif        
      if(msys.eq.5.or.msys.eq.7)then
              tab(1,1,6)=8
              tab(1,2,6)=9
              tab(8,1,6)=43
              tab(9,1,6)=32
              tab(10,1,6)=32
              tab(10,2,6)=29
              if(msys.eq.7)then
                  tab(2,1,6)=5
                  tab(2,2,6)=6
                  tab(3,1,6)=2
                  tab(3,2,6)=3
                  tab(12,1,6)=31
                  tab(12,2,6)=29
                  tab(13,1,6)=30
                  tab(13,2,6)=29
              endif
      endif        
      if(msys.eq.6.or.msys.eq.8)then
           tab(1,1,6)=10
           tab(1,3,6)=12
           tab(1,4,6)=11
           tab(9,1,6)=46
           tab(9,3,6)=47
           tab(9,5,6)=48
           if(msys.eq.8)then
              tab(10,1,6)=32
              tab(12,1,6)=31
              tab(13,1,6)=30
           endif
      endif
      return
      end
!
!code for spacgr
      subroutine spacgr(imer)  
      USE General
      USE Symmetry
      USE Molcom
      USE Laue
!
!
      character*20 symbs, lauelcl1     
      common/dumm3/indla,jsol,numsol,ilegen
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,fattover 
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/fordata0/ nsymbo
      common/fordata/ symbs(2000,2),fmerit(2000,2),numerosy(2000,2)
     1,lauelcl1(2000,2)
      common /pseudoappl/iapplpse(74),iappl,perctab(13,8)
      dimension  ielim(13)
      character head*5, simbolo16*16
!
!--controlla le classi mancanti.
      if(msys.le.4)then
      if(ncont(6)==0.or.ncont(5)==0.or.ncont(4)==0.or.
     1   ncont(3)==0.or.ncont(2)==0.or.ncont(1)==0)then 
           write(lo,'(a)')' Warning; subset(s) of reflection absent: '
           if (ncont(3)==0) write(lo,'(a)') '  h 0 0' 
           if (ncont(2)==0) write(lo,'(a)') '  0 k 0' 
           if (ncont(1)==0) write(lo,'(a)') '  0 0 l' 
           if (ncont(4)==0) write(lo,'(a)') '  0 k l' 
           if (ncont(5)==0) write(lo,'(a)') '  h 0 l' 
           if (ncont(6)==0) write(lo,'(a)') '  h k 0' 
           write(lo,'(a)')
     1     ' The probabilities of the symmetry operators',
     1     ' related will be put equal to 0.5'
!
           if (jscreen > 0) then
               write(jgrap,'(a)')
     *               ' Warning; subset(s) of reflection absent:'
               if (ncont(3)==0) write(jgrap,'(a)') '  h 0 0' 
               if (ncont(2)==0) write(jgrap,'(a)') '  0 k 0' 
               if (ncont(1)==0) write(jgrap,'(a)') '  0 0 l' 
               if (ncont(4)==0) write(jgrap,'(a)') '  0 k l' 
               if (ncont(5)==0) write(jgrap,'(a)') '  h 0 l' 
               if (ncont(6)==0) write(jgrap,'(a)') '  h k 0' 
               write(jgrap,'(a)')
     1         ' The probabilities of the symmetry operators',
     1         ' related will be put equal to 0.5'
           endif
!
      endif 
      endif 
!-- elimina le condizioni di una classe superiore se i riflessi appartengono
!-- soltanto a una classe inferiore
      do i=4,13
         ielim(i)=0
      enddo
!
      if(ncont( 4).eq.ncont(1).or.ncont( 4).eq.ncont(2))ielim( 4)=1
      if(ncont( 5).eq.ncont(1).or.ncont( 5).eq.ncont(3))ielim( 5)=1
      if(ncont( 6).eq.ncont(2).or.ncont( 6).eq.ncont(3))ielim( 6)=1
      if(ncont( 9).eq.ncont(1).or.ncont( 9).eq.ncont(6))ielim( 9)=1
      if(ncont(10).eq.ncont(1).or.ncont(10).eq.ncont(6)
     1                        .or.ncont(10).eq.ncont(8))ielim(10)=1
      if(ncont(12).eq.ncont(2).or.ncont(12).eq.ncont(5))ielim(12)=1
      if(ncont(13).eq.ncont(3).or.ncont(13).eq.ncont(4))ielim(13)=1
!
      call stampas(imer, lo)
!
      if (jscreen > 0) then
          call stampas(imer, jgrap)
      endif
!
      write(lo,'(a)') ' '
      write(lo,'(a)')' '
!--  definisce itabsy(msys,inda,indx)
      do k=1,8
         do i=1,8
            do j=1,200
               itabsy(k,i,j) = 15
            enddo
         enddo
      enddo
! mono-a
      itabsy(1,1,  1)=  1
      itabsy(1,1, 17)=  2
      itabsy(1,1,  6)=  3
      itabsy(1,1, 20)=  4
      itabsy(1,1,  8)=  5
      itabsy(1,1, 21)=  6
      itabsy(1,1, 10)=  7
      itabsy(1,1, 22)=  8
      itabsy(1,4,  1)=  9
      itabsy(1,4, 10)= 10
      itabsy(1,3,  1)= 11
      itabsy(1,3,  6)= 12
      itabsy(1,5,  1)= 13
      itabsy(1,5,  8)= 14
! mono-b
      itabsy(2,1,  2)= 15
      itabsy(2,1, 18)= 16
      itabsy(2,1,  4)= 17
      itabsy(2,1, 23)= 18
      itabsy(2,1,  9)= 19
      itabsy(2,1, 24)= 20
      itabsy(2,1, 11)= 21
      itabsy(2,1, 25)= 22
      itabsy(2,4,  2)= 23
      itabsy(2,4,  9)= 24
      itabsy(2,2,  2)= 25
      itabsy(2,2, 11)= 26
      itabsy(2,5,  2)= 27
      itabsy(2,5,  4)= 28
! mono-c
      itabsy(3,1,  3)= 29
      itabsy(3,1, 19)= 30
      itabsy(3,1,  5)= 31
      itabsy(3,1, 26)= 32
      itabsy(3,1,  7)= 33
      itabsy(3,1, 27)= 34
      itabsy(3,1, 12)= 35
      itabsy(3,1, 28)= 36
      itabsy(3,3,  3)= 37
      itabsy(3,3, 12)= 38
      itabsy(3,2,  3)= 39
      itabsy(3,2,  5)= 40
      itabsy(3,5,  3)= 41
      itabsy(3,5,  7)= 42
! orto
      itabsy(4,1, 29)= 43
      itabsy(4,1, 32)= 44
      itabsy(4,1, 31)= 45
      itabsy(4,1, 35)= 46
      itabsy(4,1, 30)= 47
      itabsy(4,1, 34)= 48
      itabsy(4,1, 33)= 49
      itabsy(4,1, 36)= 50
      itabsy(4,1, 38)= 51
      itabsy(4,1, 40)= 52
      itabsy(4,1, 45)= 53
      itabsy(4,1, 37)= 54
      itabsy(4,1, 64)= 55
      itabsy(4,1, 65)= 56
      itabsy(4,1, 66)= 57
      itabsy(4,1, 42)= 58
      itabsy(4,1, 67)= 59
      itabsy(4,1, 68)= 60
      itabsy(4,1, 69)= 61
      itabsy(4,1, 44)= 62
      itabsy(4,1, 70)= 63
      itabsy(4,1, 71)= 64
      itabsy(4,1, 72)= 65
      itabsy(4,1, 39)= 66
      itabsy(4,1, 55)= 67
      itabsy(4,1, 56)= 68
      itabsy(4,1, 57)= 69
      itabsy(4,1, 46)= 70
      itabsy(4,1, 73)= 71
      itabsy(4,1, 74)= 72
      itabsy(4,1, 75)= 73
      itabsy(4,1, 47)= 74
      itabsy(4,1, 76)= 75
      itabsy(4,1, 77)= 76
      itabsy(4,1, 78)= 77
      itabsy(4,1, 48)= 78
      itabsy(4,1, 79)= 79
      itabsy(4,1, 80)= 80
      itabsy(4,1, 81)= 81
      itabsy(4,1, 41)= 82
      itabsy(4,1, 58)= 83
      itabsy(4,1, 59)= 84
      itabsy(4,1, 60)= 85
      itabsy(4,1, 49)= 86
      itabsy(4,1, 82)= 87
      itabsy(4,1, 83)= 88
      itabsy(4,1, 84)= 89
      itabsy(4,1, 50)= 90
      itabsy(4,1, 85)= 91
      itabsy(4,1, 86)= 92
      itabsy(4,1, 87)= 93
      itabsy(4,1, 51)= 94
      itabsy(4,1, 88)= 95
      itabsy(4,1, 89)= 96
      itabsy(4,1, 90)= 97
      itabsy(4,1, 43)= 98
      itabsy(4,1, 61)= 99
      itabsy(4,1, 62)=100
      itabsy(4,1, 63)=101
      itabsy(4,1, 52)=102
      itabsy(4,1, 91)=103
      itabsy(4,1, 92)=104
      itabsy(4,1, 93)=105
      itabsy(4,1, 53)=106
      itabsy(4,1, 94)=107
      itabsy(4,1, 95)=108
      itabsy(4,1, 96)=109
      itabsy(4,1, 54)=110
      itabsy(4,1, 97)=111
      itabsy(4,1, 98)=112
      itabsy(4,1, 99)=113
      itabsy(4,4, 29)=114
      itabsy(4,4, 32)=115
      itabsy(4,4,102)=116
      itabsy(4,4, 42)=117
      itabsy(4,4,110)=118
      itabsy(4,4, 41)=119
      itabsy(4,4,109)=120
      itabsy(4,4, 50)=121
      itabsy(4,4,111)=122
      itabsy(4,3, 29)=123
      itabsy(4,3, 31)=124
      itabsy(4,3, 40)=125
      itabsy(4,3,101)=126
      itabsy(4,3,107)=127
      itabsy(4,3, 39)=128
      itabsy(4,3, 56)=129
      itabsy(4,3,106)=130
      itabsy(4,3,108)=131
      itabsy(4,2, 29)=132
      itabsy(4,2, 30)=133
      itabsy(4,2, 38)=134
      itabsy(4,2, 37)=135
      itabsy(4,2, 64)=136
      itabsy(4,2,100)=137
      itabsy(4,2,104)=138
      itabsy(4,2,103)=139
      itabsy(4,2,105)=140
      itabsy(4,5, 29)=141
      itabsy(4,5,102)=142
      itabsy(4,5,101)=143
      itabsy(4,5, 68)=144
      itabsy(4,5,100)=145
      itabsy(4,5, 58)=146
      itabsy(4,5, 46)=147
      itabsy(4,5, 76)=148
      itabsy(4,6, 29)=149
      itabsy(4,6,120)=150
      itabsy(4,6,121)=151
      itabsy(4,6,122)=152
      itabsy(4,6,123)=153
!  tetra
      itabsy(5,1, 29)=154
      itabsy(5,1, 31)=155
      itabsy(5,1,114)=156
      itabsy(5,1,147)=157
      itabsy(5,1,113)=158
      itabsy(5,1,146)=159
      itabsy(5,1,145)=160
      itabsy(5,1,144)=161
      itabsy(5,1,143)=162
      itabsy(5,1,142)=163
      itabsy(5,1, 42)=164
      itabsy(5,1,141)=165
      itabsy(5,1, 44)=166
      itabsy(5,1,140)=167
      itabsy(5,1, 43)=168
      itabsy(5,1,117)=169
      itabsy(5,1,139)=170
      itabsy(5,1,138)=171
      itabsy(5,1,137)=172
      itabsy(5,1, 53)=173
      itabsy(5,1,136)=174
      itabsy(5,1, 54)=175
      itabsy(5,1,135)=176
      itabsy(5,5, 29)=177
      itabsy(5,5,113)=178
      itabsy(5,5,119)=179
      itabsy(5,5, 42)=180
      itabsy(5,5,125)=181
      itabsy(5,5,118)=182
      itabsy(5,5,124)=183
      itabsy(5,5,126)=184
! trig
      itabsy(6,1, 29)=185
      itabsy(6,1,127)=186
      itabsy(6,1,145)=187
      itabsy(6,1, 42)=188
      itabsy(6,7,131)=189
      itabsy(6,7,133)=190
      itabsy(6,7,132)=191
      itabsy(6,7,134)=192
! rhomb
      itabsy(8,7,148)=193
      itabsy(8,7,149)=194
! hexa
      itabsy(6,1,130)=195
      itabsy(6,1,129)=196
      itabsy(6,1,128)=197
      itabsy(6,1,141)=198
! cubic
      itabsy(7,1, 29)=199
      itabsy(7,1, 30)=200
      itabsy(7,1,114)=201
      itabsy(7,1,113)=202
      itabsy(7,1, 45)=203
      itabsy(7,1,154)=204
      itabsy(7,1, 43)=205
      itabsy(7,1, 63)=206
      itabsy(7,5, 29)=207
      itabsy(7,5,113)=208
      itabsy(7,5,119)=209
      itabsy(7,5,154)=210
      itabsy(7,5,153)=211
      itabsy(7,6, 29)=212
      itabsy(7,6,113)=213
      itabsy(7,6,152)=214
      itabsy(7,6,150)=215
      itabsy(7,6,151)=216
! triclinic
      itabsy(9,1, 1)=217
!
!-- Per ogni msys, legge da expo2005.egr il numero di unita 
!-- assimmetriche degli SG appartenenti ad ogni extinction 
!-- group (nasun(100,20). Per monoc e ortor., definisce lo stesso valori per
!-- i gruppi centrosim. (icsy(200)) e non centrosim. (incsy(200)) 
!      call readasun
!
      numsol=0
      do i=1,30
         isolu(i)=0
         lsolu(i)=0
         nsolu(i)='           '
      enddo      
       
!--  applica le pseudotraslazioni.
      if(iappl.eq.1)call applipseudo   !19feb11
!--
      if (msys.eq.8) call msys8(imer)
      if (msys.eq.7) call msys7(imer)
      if (msys.eq.6) call msys6(imer)
      if (msys.eq.5) call msys5(imer)
      if (msys.eq.4) call msys4
      if (msys.eq.3) call msys3
      if (msys.eq.2) call msys2
      if (msys.eq.1) call msys1
      if (msys.eq.0) then
      msys=9
      nume=1
      nindlacl(1)=12
      nindla(1)=1
      nindexx(1)=155
      nsymbo=1
      symbs(1,1)=lasymb(1)//exsymb(29)
*     fmersg(1)=1.00
*     fmersg(2)=101.00
      fmerit(1,1)=1.00
      fmerit(2,1)=101.00
      numerosy(1,1)=itabsy(9,1,1)
*     fmerit(1,1)=fmersg(2)
      endif

!           write(lo,'(a)')'fine refana '
!           write(lo,'(2x,a20,f6.3,2i15)')
!     *           symbs(nsymbo,1),
!     1           fmerit(nsymbo,1)
!     1           ,numerosy(nsymbo,1)


!
!ivan      write(lo,*)' ****************************************'
!ivan      write(lo,*)'  For more details look at stat.spg file'
!ivan      write(lo,*)' ****************************************'
!
      return
      end
!
!code for ilegend
      subroutine ilegend(ilegen)
      USE General
      write(lo,"(/,a,/,a,/,a,/,a,/,a,/,a,/,a)")
     1 '  Legend:',
     1 '    Crystal System',
     1 '    Extintion Symbol consistent with the given data set',
     1 '     Possible Space Group(s)',
     1 '     Space Group for the standard setting',
     1 '     New cell in agreement to the standard setting',
     1 '     Transformation Matrix to apply to the indicies'
       ilegen=1   
      return
      end
!
!code for matrmo
      subroutine matrmo(inum)
      USE General
      USE Laue
      character*31 mat6(10),stringa*16
!
      common/dumm3/indla,indexx,numsol,ilegen
      dimension   acell(6),a(3),b(3)  
!
      data mat6(1)/'1 0 0  0 1 0  0 0 1  0. 0. 0.  '/ 
      data mat6(2)/'0 0 1  0 1 0  -1 0 -1  0. 0. 0.'/ 
      data mat6(3)/'-1 0 -1  0 1 0  1 0 0  0. 0. 0.'/ 
      data mat6(4)/'0 -1 -1  1 0 0  0 0 1  0. 0. 0.'/ 
      data mat6(5)/'0 1 0  1 0 0  0 -1 -1  0. 0. 0.'/ 
      data mat6(6)/'0 0 1  1 0 0  0 1 0  0. 0. 0.  '/ 
      data mat6(7)/'-1 -1 0  0 0 1  0 1 0  0. 0. 0.'/ 
      data mat6(8)/'1 0 0  0 0 1 -1 -1  0  0. 0. 0.'/ 
      data mat6(9)/'0 1 0  0 0 1  1 0 0  0. 0. 0.  '/ 
      data mat6(10)/'0 0 1  0 -1 0  1 0 0  0. 0. 0.'/ 
!
      aax=cell(1 ) 
      bax=cell(2 ) 
      cax=cell(3 )
      alp=cell(4 )
      bet=cell(5 )
      gam=cell(6 )
!        write(lo,*)'aax,bax,cax,alp,bet,gam'
!        write(lo,'(3f10.3,3f10.2)')aax,bax,cax,alp,bet,gam
      i=inum
      ij=lsolu(i)
      ik=isolu(i)
!      write(lo,*)'i,ij,ik',i,ij,ik
      if(ij.le.1)then
         write(lo,*)'    '
      else
         if(ij.eq.2)then
            acell(1)=cax
            acell(2)=bax
            acell(3)=aax
            acell(4)=90.
            acell(5)=bet 
            acell(6)=90.
!      write(lo,*)' Cell '
!      write(lo,'(a,3f10.3,3f10.2)')'    New cell',acell
            if(ik.eq.13)then
              stringa='P 2/c'
            else if(ik.eq.14)then
              stringa='P 21/c'
            else
              ca=irdgs(ik,stringa)
              call xmaius(stringa)
            endif
!        write(lo,*)'ik,stringa  ',ik,stringa
!
            write(lo,'(a,a)')'     Standard Space Group  ',stringa
            write(lo,'(a,3f10.3,3f10.2)')'     New Cell',acell
            write(lo,*)'    Transformation Matrix  ',mat6(ij)
            write(lo,*)'    '
!
            acell(1)=cax
            acell(2)=bax
            a(1)=-1.
            a(2)=0.
            a(3)=-1.
            b(1)=0.
            b(2)=0.
            b(3)=1.
            acell(3)=axsom(a)
            acell(5)=angdeg(a,b)
         else if(ij.eq.3)then
            acell(1)=cax
            acell(2)=bax
            acell(3)=aax
            acell(4)=90.
            acell(5)=bet 
            acell(6)=90.
            if(ik.eq.13)then
              stringa='P 2/c'
            else if(ik.eq.14)then
              stringa='P 21/c'
            else
              ca=irdgs(ik,stringa)
              call xmaius(stringa)
            endif
!
            write(lo,'(a,a)')'     Standard Space Group  ',stringa
            write(lo,'(a,3f10.3,3f10.2)')'     New Cell',acell
            write(lo,*)'    Transformation Matrix  ',mat6(ij)
            write(lo,*)'    '
!
            a(1)=-1
            a(2)=0
            a(3)=-1
            b(1)=1
            b(2)=0
            b(3)=0
            acell(1)=axsom(a)
            acell(2)=bax
            acell(3)=cax
            acell(5)=angdeg(a,b)
         else if(ij.eq.4)then
            a(1)=0
            a(2)=-1
            a(3)=-1
            b(1)=0
            b(2)=0
            b(3)=1
            acell(1)=axsom(a)
            acell(2)=aax
            acell(3)=cax
            acell(5)=angdeg(a,b)
         else if(ij.eq.5)then
            a(1)=0
            a(2)=-1
            a(3)=-1
            b(1)=0
            b(2)=1
            b(3)=0
            acell(1)=bax
            acell(2)=aax
            acell(3)=axsom(a)
            acell(5)=angdeg(a,b)
         else if(ij.eq.6)then
            acell(1)=cax
            acell(2)=aax
            acell(3)=bax
            acell(5)=alp
         else if(ij.eq.7)then
            a(1)=-1
            a(2)=-1
            a(3)=0
            b(1)=0
            b(2)=1
            b(3)=0
            acell(1)=axsom(a)
            acell(2)=cax
            acell(3)=bax
            acell(5)=angdeg(a,b)
         else if(ij.eq.8)then
            a(1)=-1
            a(2)=-1
            a(3)=0
            b(1)=1
            b(2)=0
            b(3)=0
            acell(1)=aax
            acell(2)=cax
            acell(3)=axsom(a)
            acell(5)=angdeg(a,b)
         else if(ij.eq.9)then
            acell(1)=bax
            acell(2)=cax
            acell(3)=aax
            acell(5)=gam
         endif
         acell(4)=90.
         acell(6)=90.
         ik=isolu(i)
         if(ik.eq.13)then
            stringa='P 2/c'
         else if(ik.eq.14)then
            stringa='P 21/c'
         else
            ca=irdgs(ik,stringa)
            call xmaius(stringa)
         endif
!        write(lo,*)'ik,stringa  ',ik,stringa
!
         write(lo,'(a,a)')'     Standard Space Group  ',stringa
         write(lo,'(a,3f10.3,3f10.2)')'     New Cell',acell
         write(lo,*)'    Transformation Matrix  ',mat6(ij)
         write(lo,*)'    '
!
      endif
      return
      end
!
!code for axsom
      function axsom(d)
      USE General
      USE BuildModule
      USE Laue
!
      dimension d(3)
!      write(lo,*)'axsom d(3),g(9)',d,(g(j),j=1,9)
        distt=gdist(1)*d(1)*d(1)
     1       +gdist(5)*d(2)*d(2)
     2       +gdist(9)*d(3)*d(3)
     3       +gdist(2)*d(1)*d(2)*2.0
     4       +gdist(3)*d(1)*d(3)*2.0
     5       +gdist(6)*d(2)*d(3)*2.0
      axsom=sqrt(distt)
!      write(lo,*)'d,axsom ',d,axsom
      return
      end
!
!code for angdeg
      function angdeg(d1,d2)
      USE General
      USE Laue
!
      dimension d1(3),d2(3)
!      write(lo,*)'angdeg:d1,d2 ',d1,d2
      call ang(d1,d2,angle)
       a=axsom(d1)
       b=axsom(d2)
      deno=a*b
!      write(lo,*)'angdeg:d1,d2,a,b,deno,angle ',d1,d2,a,b,deno,angle
      if(deno.gt.1.0e-35) goto 302
      deno=1.0e-5
302   angle=angle/deno
      if(angle.gt.1.and.angle.le.1.1)angle=1.0
      if(angle.lt.-1.and.angle.ge.-1.1)angle=-1.0
      angdeg=acos(angle)*rtod
!      write(lo,*)'angdeg:d1,d2,a,b,deno,angdeg ',d1,d2,a,b,deno,angdeg
      return
      end
!
!code for matror
      subroutine matror
      USE General
      USE Laue
!
      character*30 mat6(6),stringa*16
!
      common/dumm3/indla,indexx,numsol,ilegen
      dimension   acell(6)  
! 
      data mat6(1)/'1 0 0  0 1 0  0 0 1  0. 0. 0.'/ 
      data mat6(2)/'0 1 0  1 0 0  0 0 -1  0. 0. 0.'/ 
      data mat6(3)/'0 1 0  0 0 1  1 0 0  0. 0. 0.'/ 
      data mat6(4)/'0 0 1  0 1 0  -1 0 0  0. 0. 0.'/ 
      data mat6(5)/'0 0 1  1 0 0  0 1 0  0. 0. 0.'/ 
      data mat6(6)/'1 0 0  0 0 1  0 -1 0  0. 0. 0.'/ 
      do i =1,numsol
      ij=lsolu(i)
        if(ij.le.1)then
        write(lo,*)'    '
        else
        call newcell(acell,ij)
!        write(lo,*)' Cell '
!        write(lo,'(3f10.3,3f10.2)')acell
        ik=isolu(i)
        ca=irdgs(ik,stringa)
        call xmaius(stringa)
!
!       write(lo,*)'    Standard Space Group  ',stringa
       write(lo,'(a,a)')'     Standard Space Group  ',stringa
       write(lo,'(a,3f10.3,3f10.2)')'     New Cell',acell
       write(lo,*)'    Transformation Matrix  ',mat6(ij)
       write(lo,*)'    '
!
        endif
      enddo
      return
      end
!
!code for newcell 
      subroutine newcell(acell,ij)
      USE General
      USE Laue
!
      common/dumm3/indla,indexx,numsol,ilegen
      dimension   acell(6)
!
!      mat6(1)/'1 0 0  0 1 0  0 0 1  0. 0. 0.'/ 
!      mat6(2)/'0 1 0  1 0 0  0 0 -1  0. 0. 0.'/ 
!      mat6(3)/'0 1 0  0 0 1  1 0 0  0. 0. 0.'/ 
!      mat6(4)/'0 0 1  0 1 0  -1 0 0  0. 0. 0.'/ 
!      mat6(5)/'0 0 1  1 0 0  0 1 0  0. 0. 0.'/ 
!      mat6(6)/'1 0 0  0 0 1  0 -1 0  0. 0. 0.'/ 
      aax=cell(1) 
      bax=cell(2) 
      cax=cell(3)
      alp=cell(4) 
      bet=cell(5) 
      gam=cell(6) 
      acell(4)=90.
      acell(5)=90.
      acell(6)=90.
!      if(msys.eq.1)acell(5)=alp
!      if(msys.eq.2)acell(5)=bet
!      if(msys.eq.3)acell(5)=gam
      if(ij.eq.1.or.ij.eq.6)acell(1)=aax
      if(ij.eq.2.or.ij.eq.3)acell(1)=bax
      if(ij.eq.4.or.ij.eq.5)acell(1)=cax
      if(ij.eq.1.or.ij.eq.4)acell(2)=bax
      if(ij.eq.2.or.ij.eq.5)acell(2)=aax
      if(ij.eq.3.or.ij.eq.6)acell(2)=cax
      if(ij.eq.1.or.ij.eq.2)acell(3)=cax
      if(ij.eq.3.or.ij.eq.4)acell(3)=aax
      if(ij.eq.5.or.ij.eq.6)acell(3)=bax
      return
      end 
!
!code for sortyb
      subroutine sortyb(sto,idim,lind,numb,minc,jump)
!--general sorting routine
!
!  sto : array to be used
!--lind :first address in the list
!--numb :number of elements in the list
!--minc :number of words per element
!--jump :function of the relative address(jaddress) of the variable
!  to be sort   (0.ge.jaddress.le.minc)
!  jump>0 increasing sorting ( jaddress=jump )
!  jump<0 decreasing sorting ( jaddress=iabs(jump)-1 )
!
      dimension  sto(idim)
!
      if (numb.le.1) then
          return
      endif
      jsign=1
      if(jump.lt.0)then
      jump=iabs(jump)-1
      jsign=-1
      endif
      if(numb.eq.1)return
      ja=2
2010  continue
      jb=numb/ja
      if(jb.le.0)jb=1
      jc=numb-jb
 2040 continue
      jd=0
      m =lind
      do  i=1,jc
      mk =m +jb*minc
      stt=(sto(m +jump)-sto(mk +jump))*jsign
          if(stt.gt.0)then
          mm=m
          mmk=mk
            do  je=1,minc
            xjf=sto(mm)
            sto(mm)=sto(mmk)
            sto(mmk)=xjf
            mm=mm+1
            mmk=mmk+1
            enddo
          jd=1
          endif
          m =m +minc
      enddo
      if(jd.gt.0)go to 2040
      if(jb.le.1)return
         if(jb.gt.1)then
         ja=ja*2
         go to 2010
         endif
      return
      end
!
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!
!code for pcorr21
      function pcorr21(i1,i2,prob)
      USE General
      USE Laue
!-- corregge gli assi quando ci sono pochi riflessi forti(esure)
      pcorr21=prob
!      nes=nint(tab(i1,i2,1))
      nes=nEsure(i1,i2)       !8apr2008
      if(nes.eq.0)return      !22nov10
      if(neutro.eq.2.and.nes.gt.4)then
      iotto=-8
      pcorr21=10**iotto
      return
      endif
            if(nes.le.4)then
            pcorr21=0.5
            ax=(4.-nes)/8.     
              if(prob.lt.0.5)then
              px=prob*exp(ax)
              axx=exp(ax)
              if(px.lt.0.5)pcorr21=px
              else          
              axx=exp(-ax)
              px=prob*exp(-ax)
              if(px.ge.0.5)pcorr21=px
              endif
            endif
      if(neutro.ne.2.and.pcorr21.lt.0.10)pcorr21=0.10
!        if(pcorr21.gt.0.90)pcorr21=0.90
       return
       end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



!
!code for applcorEsure 
      function applcorEsure(i1,i2,probori,problatt)
      USE General
      USE Laue
      common/dummyinp/indipen(13,8),indipen2(13,8),nEsu(13,8)
     1,numr(13,8,2)
!
      applcorEsure=probori
!      nn=nEsure(i1,i2)
      nn=nEsu(i1,i2)
!      if(nn.gt.0.20*tab(i1,i2,1))then
      if(neutro.eq.2.and.nn.ge.5)then
         iotto=-8
         applcorEsure=10**iotto
         return
      endif
      if(nn.gt.0)then
         nnn=nn
         if(neutro.ne.2.and.nn.gt.3)nnn=nn+1
         if(neutro.eq.2.and.nn.ge.2)nnn=nn+2
!
         fattcorr=0.5**nnn
!         if(Esure(i1,i2).ge.foclass(i1)) !26apr11
         if(neutro.eq.2.or.Esure(i1,i2).ge.foclass(i1)) !27apr11
     1    applcorEsure=probori*fattcorr  !7apr2008
      else if(problatt.gt.0.and.nn.eq.0)then
           if((probori-problatt).gt.0.0)then
               applcorEsure=0.5+(probori-problatt)      
           else
               applcorEsure=0.5+0.5*(probori-problatt)      
           endif
           if(applcorEsure.gt.probori)applcorEsure=probori
      endif
      if(applcorEsure.lt.0.1.and.neutro.ne.2)applcorEsure=0.1
      if(applcorEsure.gt.1.)applcorEsure=1.0
      return
      end
!
!code for corrprob
      subroutine corrprob(p1,p2,i1,j1,i2,j2)    
!
      USE General
      USE Laue
!
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
!
      dp=abs(p1-p2)
      if(p1.ge.p2.or.dp.lt.0.05)then
!      write(lo,*)'corrp p1,p2,i1,j1,i2,j2',p1,p2,i1,j1,i2,j2
      nd=tab(i2,j2,1)-tab(i1,j1,1)
      if(nd.le.0)nd=1000
      deltaemed=
     1(tab(i2,j2,2)*tab(i2,j2,1)-tab(i1,j1,2)*tab(i1,j1,1))/nd 
      if(deltaemed.lt.0.01.and.deltaemed.lt.tab2(i2,j2,2)) p1=p1-p2**2
      if(neutro.ne.2.and.p1.lt.0.1)p1=0.1
!      write(lo,*)'corrp dp,nd,deltaemed,p1',dp,nd,deltaemed,p1
      endif
      return
      end
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!code for sort_fmerit
      subroutine sort_fmerit(kprint)
!      
      USE General, only: lo, neutro, knw
      USE Laue
!      USE PseudoStuff
!
      character*20 symbs, lauelcl1     
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/dummyyy/valmedio(13),loo
      common/dumm3/indla,indexx,numsol,ilegen
      common/fordata0/ nsymbo
      common/fordata/ symbs(2000,2),fmerit(2000,2),numerosy(2000,2)
     1,lauelcl1(2000,2)
      common/dummfm/fmer1,knm
      common/dummyret/tab2ret(13,8,6),tabret(13,8,6),tabnewret(13,8)
      common /pseudoappl/iapplpse(74),iappl,perctab(13,8)
      common/probLaEle/numsysEle,RintSys(9,6),ProbSys(9,7),kfin,indprobs
     1,corrfattProb(9),ProbLsav(5),nomonoclino
!
      if(kprint.gt.1)call stampa_fmerit
         jpse=iappl+1
         do kpse=1,jpse
            fmersg(1:nume)=fmerit(1:nume,kpse)
            idim=2000
            lind=1
            minc=2
            jump=-1
            numes=nume/2
            call sortyb(fmersg,idim,lind,numes,minc,jump)
            fmerit(1:nume,kpse)=fmersg(1:nume)
         enddo
         jfin=nume-2
         do ii=1,jfin,2
           numenew=1+ii/2
           if(fmerit(ii,1).le.0.000099.and.fmerit(ii,jpse).le.0.000099
     1      .and. numenew.ge.60)exit
         enddo
         do kpse=1,jpse
           do ii=1,jfin,2
             i=nint(fmerit(ii+1,kpse))/100
             mm=nint(fmerit(ii+1,kpse))-i*100
             mmsys=mm/10
             jmer=mm-mmsys*10
             if(neutro.eq.2)msysori=probsys(mmsys,6)
             inda =nindla(i)
             indx =nindexx(i)
             indal=nindlacl(i)
             if(neutro.ne.2)then
               symbs(i,1)=lasymb(inda)//exsymb(indx)
               numerosy(i,1)=itabsy(mmsys,inda,indx)
!                write(lo,'(2x,a20,f6.3,2i15)')
!     *           symbs(nsymbo,icalcpseud+1),
!     1           fmerit(nsymbo,icalcpseud+1)
             else
               symbs(i,kpse)=lasymb(inda)//exsymb(indx)
               numerosy(i,kpse)=itabsy(msysori,inda,indx)
               lauelcl1(i,kpse)=lauecl(indal)
               ProbLaue=(ProbSys(mmsys,jmer))**0.5
               xx=ProbSys(mmsys,7) 
               fff= (fmerit(ii,kpse)/ProbSys(mmsys,jmer))**(1/xx) !Extintion Prob.  
!               nord=nord+1
!                 write(lo,'(i5,3x,a12,3x,a20,4f10.3,5i5)')nord,
!     1           lauecl(indal),symbs(i,icalcpseud+1)
!     1           ,fmerit(i,kpse),fff,ProbLaue,ProbSys(mmsys,7)
!!     1          ,numerosy(i,icalcpseud+1),mmsys,inda,indx,indal
             endif 
           enddo
         enddo
      if(kprint.gt.0)call stampa_fmerit
      return
      end    
!
!code for stampa_fmerit
      subroutine stampa_fmerit
!      
      USE General, only: lo, neutro, knw
      USE Laue
!      USE PseudoStuff
!
      character*20 symbs, lauelcl1, lal1, sy1, lal2, sy2     
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/dummyyy/valmedio(13),loo
      common/dumm3/indla,indexx,numsol,ilegen
      common/fordata0/ nsymbo
      common/fordata/ symbs(2000,2),fmerit(2000,2),numerosy(2000,2)
     1,lauelcl1(2000,2)
      common/dummfm/fmer1,knm
      common/dummyret/tab2ret(13,8,6),tabret(13,8,6),tabnewret(13,8)
      common /pseudoappl/iapplpse(74),iappl,perctab(13,8)
      common/probLaEle/numsysEle,RintSys(9,6),ProbSys(9,7),kfin,indprobs
     1,corrfattProb(9),ProbLsav(5),nomonoclino
!
! stampa
             if(neutro.ne.2)
     *           write(lo,'(a)')' Extinction Group    Fig.Mer' 
         nord=0
           do ii=1,nume-2,2
             i1=nint(fmerit(ii+1,1))/100
             i2=nint(fmerit(ii+1,2))/100
             if(neutro.ne.2)then
             if(fmerit(ii,1).lt.0.0005) exit
                write(lo,'(2x,a20,f6.3,2i15)')
     *           symbs(i1,1),fmerit(ii,1)
             else
                 nord=nord+1
                 lal1=' '
                 lal2=' '
                 sy1=' '
                 sy2=' '
                 if( i1 > 0 ) lal1=lauelcl1(i1,1)
                 if( i2 > 0 ) lal2=lauelcl1(i2,1)
                 if( i1 > 0 ) sy1=symbs(i1,1)
                 if( i2 > 0 ) sy2=symbs(i2,1)
                 if(iappl.eq.0.or.i2.eq.0) then
                  write(lo,'(i5,2(3x,a12,3x,a20,f10.3,5x))')nord,
     1             lal1,sy1,fmerit(ii,1)
                 else
                   write(lo,'(i5,2(3x,a12,3x,a20,f10.3,5x))')nord,
     1             lal1,sy1,fmerit(ii,1),lal2,sy2,fmerit(ii,2)
                 endif
             endif 
           enddo
       return
       end    
!
!code for msys1       !monocl. //a  
      subroutine msys1
      USE General, only: lo, Neutro, knw
      USE Laue
!      USE PseudoStuff
!
      character*20 symbs, lauelcl1     
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/dummyyy/valmedio(13),loo
      common/dumm3/indla,indexx,numsol,ilegen
      common/fordata0/ nsymbo
      common/fordata/ symbs(2000,2),fmerit(2000,2),numerosy(2000,2)
     1,lauelcl1(2000,2)
      common/dummfm/fmer1,knm
      common/refanaprint/natv,volcel,apeso,bpeso
      common/dummyret/tab2ret(13,8,6),tabret(13,8,6),tabnewret(13,8)
!      common /pseudotras/ nkk,mpseud(12,74),numps(74),perctab(13,8)
!     *                    ,perce(74),jpseud(74)
      common /pseudoappl/iapplpse(74),iappl,perctab(13,8)
      character*80 apeso,bpeso
!
      common/probLaEle/numsysEle,RintSys(9,6),ProbSys(9,7),kfin,indprobs
     1,corrfattProb(9),ProbLsav(5),nomonoclino
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!
      
      kprint=0
      icalcpseud=0
      indecl=13
      
!-- applica le limitazione del F ortorombico
      fattorto=1.0
      if(neutro.eq.2.and.nomonoclino.eq.1) fattorto=0.5
      !
!-hkl      
      sa  =tabnew(7,2) 
      sb  =tabnew(7,3) 
      sc  =tabnew(7,1) 
      si  =tabnew(7,4)
!      if(neutro.ne.2)then 
      if(sa.ge.0.9)sa=0.9
      if(sb.ge.0.9)sb=0.9
      if(sc.ge.0.9)sc=0.9
      if(si.ge.0.9)si=0.9
!      endif
!
      pa=1-sa
      pb=1-sb
      pc=1-sc
      pi=1-si
!
      p0a=pa
      p0b=pb
      p0c=pc
      p0i=pi
!
      pa= applcorEsure(7,2,p0a,0.0)*fattorto
      pb= applcorEsure(7,3,p0b,0.0)*fattorto
      pc= applcorEsure(7,1,p0c,0.0)*fattorto
      pi= applcorEsure(7,4,p0i,0.0)*fattorto
!
      pp=1-amax1(pa,pc,pi)
      if(neutro.ne.2.and.pp.lt.0.1)pp=0.1  
      if(pp.gt.1.)pp=1.
!-h00
      s21=tab(3,1,5) 
      if(s21.lt.0.1)s21=0.1
      if(s21.ge.0.9)s21=0.9
      if(neutro.eq.2)s21=tabnew(3,1) 
      if(s21.ge.0.9)s21=0.9
      if(ncont(3).eq.0)s21=0.5
      if(s21.ge.0.6)then
           if(tab2(3,1,5).gt.3.5*s21)s21=0.50
           if(tab2(3,1,5).gt.4.0*s21)s21=0.40
      endif
      p21=1-s21
      p21=pcorr21(3,1,p21)
      p021=p21
      p21= applcorEsure(3,1,p21,0.)
      if(ncont(3)==0.and.neutro==2)p21=0.5
!
      sb11=tabnew(4,1)
      sc11=tabnew(4,2)
      sbc11=tabnew(4,3)
      sn11=tabnew(4,4)
      if(sb11.ge.0.9)sb11=0.9
      if(sc11.ge.0.9)sc11=0.9
      if(sbc11.ge.0.9)sbc11=0.9
      if(sn11.ge.0.9)sn11=0.9
      if(neutro.ne.2)then
      if(sb11.lt.0.1)sb11=0.1
      if(sc11.lt.0.1)sc11=0.1
      if(sbc11.lt.0.1)sbc11=0.1
      if(sn11.lt.0.1)sn11=0.1
      endif
!
      pb11=1-sb11
      pb11ori=pb11
      p0=p0b
      pb11= applcorEsure(4,1,pb11,p0)
!
      pc11=1-sc11 
      pc11ori=pc11
      p0=p0c
      pc11= applcorEsure(4,2,pc11,p0)
!
      pbc11=1-sbc11 
      pbc11ori=pbc11
      p0=0.
      pbc11= applcorEsure(4,3,pbc11,p0)
!
      pn11=1-sn11 
      pn11ori=pn11
      p0=p0i
      pn11= applcorEsure(4,4,pn11,p0)
!
!-- setta a 0.5 la prob. per gli elementi di classi mancanti
      if(neutro==2)then
           if(ncont(3)==0.or.tab2(3,1,1)==0)p21 =0.5
           if(ncont(4)==0.or.tab2(4,1,1)==0)pb11 =0.5
           if(ncont(4)==0.or.tab2(4,2,1)==0)pc11 =0.5
           if(ncont(4)==0.or.tab2(4,3,1)==0)pbc11=0.5
           if(ncont(4)==0.or.tab2(4,4,1)==0)pn11 =0.5
      endif
!
      pm11= 1-amax1(pb11,pc11,pn11)
      if(neutro.ne.2.and.pm11.lt.0.1)pm11=0.1
      pcm11= 1-pn11
      if(neutro.ne.2.and.pcm11.lt.0.1)pcm11=0.1
      pbm11= 1-pb11
      if(neutro.ne.2.and.pbm11.lt.0.1)pbm11=0.1
      pim11= 1-pc11
      if(neutro.ne.2.and.pim11.lt.0.1)pim11=0.1
      p2=1.-p21
      if(neutro.ne.2.and.p2.lt.0.1)p2=0.1
!
      if(kprint.eq.1)then
      write(lo,'(a,2f8.3)')'sa    pa    ',sa,pa
      write(lo,'(a,2f8.3)')'sb    pb    ',sb,pb
      write(lo,'(a,2f8.3)')'sc    pc    ',sc,pc
      write(lo,'(a,2f8.3)')'si    pi    ',si,pi
      write(lo,'(a,2f8.3)')'   pp    ',pp
      write(lo,'(a,2f8.3)')'sb11  pb11  ',sb11,pb11
      write(lo,'(a,2f8.3)')'sc11  pc11  ',sc11,pc11
      write(lo,'(a,2f8.3)')'sbc11  pbc11  ',sbc11,pbc11
      write(lo,'(a,2f8.3)')'sn11  pn11  ',sn11,pn11
      write(lo,'(a,2f8.3)')'  pm11  ',pm11
      write(lo,'(a,2f8.3)')'s21   p21   ',s21,p21
      write(lo,'(a,2f8.3)')'  p2    ',p2
      write(lo,'(a)')'pcm11=1-pn1,pc1m1=1-p1n1,pi1m1=1-p1c1   '
      write(lo,'(a,3f8.3)')'pbm11 pcm11 pim11 ',pbm11,pcm11,pim11
      endif
!
1000  continue
!
!----------------------------------------------------------------------
!-- nel secondo passaggio applica le pseudot.
!
      if(icalcpseud.eq.1)then
      pa=pa*perctab(7,2)
      pb=pb*perctab(7,3)
      pc=pc*perctab(7,1)
      pi=pi*perctab(7,4)
      pp=1-amax1(pa,pc,pi)
      pb11=pb11*perctab(4,1)
      pc11=pc11*perctab(4,2)
      pn11=pn11*perctab(4,4)
      pbc11=pbc11*perctab(4,3)
      p21=p21*perctab(3,1)
!-- setta a 0.5 la prob. per gli elementi di classi mancanti
      if(neutro==2)then
           if(ncont(3)==0.or.tab2(3,1,1)==0)p21 =0.5
           if(ncont(4)==0.or.tab2(4,1,1)==0)pb11 =0.5
           if(ncont(4)==0.or.tab2(4,2,1)==0)pc11 =0.5
           if(ncont(4)==0.or.tab2(4,3,1)==0)pbc11=0.5
           if(ncont(4)==0.or.tab2(4,4,1)==0)pn11 =0.5
      endif
!
      pm11= 1-amax1(pb11,pc11,pn11)
      pcm11= 1-pn11
      pbm11= 1-pb11
      pim11= 1-pc11
      p2=1.-p21
      if(neutro.ne.2)then
      if(pm11.lt.0.1)pm11=0.1
      if(pcm11.lt.0.1)pcm11=0.1
      if(pbm11.lt.0.1)pbm11=0.1
      if(pim11.lt.0.1)pim11=0.1
      if(p2.lt.0.1)p2=0.1
      endif
!
      if(kprint.eq.1)then
      write(lo,*) 'dopo applicata la pseudot. '
      write(lo,'(a,6f6.3)')'pa,pb,pc,pi,pp         ',
     1  pa,pb,pc,pi,pp
      write(lo,'(a,2f8.3)')'sb11  pb11  ',sb11,pb11
      write(lo,'(a,2f8.3)')'sc11  pc11  ',sc11,pc11
      write(lo,'(a,2f8.3)')'sbc11  pbc11  ',sbc11,pbc11
      write(lo,'(a,2f8.3)')'sn11  pn11  ',sn11,pn11
      write(lo,'(a,2f8.3)')' pm11  ',pm11
      write(lo,'(a,2f8.3)')'s21   p21   ',s21,p21
      write(lo,'(a,2f8.3)')'   p2    ',p2
      endif
      endif


!----------------------------------------------------------------------
!         nume=1
         num0=nume
                     indla=1
                     indexx=1
         fmersg(nume)=ProbLa*pp*p2*pm11
         fmer1=0.
         knm=0
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=17
         fmersg(nume)=ProbLa*pp*p21*pm11
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=6
         fmersg(nume)=ProbLa*pp*p2*pb11 
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=20
         fmersg(nume)=ProbLa*pp*p21*pb11
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=8
         fmersg(nume)=ProbLa*pp*p2*pc11
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=21
         fmersg(nume)=ProbLa*pp*p21*pc11
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=10
         fmersg(nume)=ProbLa*pp*p2*pn11
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=22
         fmersg(nume)=ProbLa*pp*p21*pn11
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
!----------------------------------------------------------------------
!--ripristina  gli originali
!      pa=pasav
!      pb=pbsav
!      pc=pcsav
!      pi=pisav
!      pp=ppsav
!      p1a1=p1a1sav
!      p1c1=p1c1sav
!      p1n1=p1n1sav
!      p1ac1=p1ac1sav
!      p21=p21sav
!      p2=p2sav
!----------------------------------------------------------------------
                     indla=4
                     indexx=1
!         fmersg(nume)=pc*p21*pb11
         fmersg(nume)=ProbLa*pc*p21*pb11
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=4
                     indexx=10
!         fmersg(nume)=pc*p21*pbc11
         fmersg(nume)=ProbLa*pc*p21*pbc11
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=3
                     indexx=1
!         fmersg(nume)=pb*p21*pc11
         fmersg(nume)=ProbLa*pb*p21*pc11
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=3
                     indexx=6
!         fmersg(nume)=pb*p21*pbc11 
         fmersg(nume)=ProbLa*pb*p21*pbc11 
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                    indla=5
                    indexx=1
!         fmersg(nume)=pi*p21*pn11
         fmersg(nume)=ProbLa*pi*p21*pn11
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=5
                     indexx=8
!         fmersg(nume)=pi*p21*p1a1
         fmersg(nume)=ProbLa*pi*p21*pbc11
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
!
      if(knm.gt.0)fmersg(1)=1-fmer1/knm 
!
      mm=msys
      if(neutro.eq.2)mm=indprobs
      xx=Probsys(mm,7)
      if (knw > 0) write(lo,*)'mm,xx ',mm,xx
      do i=num0+1,nume,2
          if(fmersg(i-1).lt.0.)fmersg(i-1)=0.
          if(neutro.eq.2)then  !28apr11
             fmersg(i-1)=ProbLa*(fmersg(i-1)/ProbLa)**xx
          endif
          fmersg(i)=i/2*100+mm*10+1
          nindlacl(i/2)=indecl
      enddo
      fmerit(num0:nume,icalcpseud+1)=fmersg(num0:nume)
!
      if(numsysEle==kfin.and.icalcpseud.eq.iappl)then
         do kpse=1,iappl+1
           do ii=1,nume-2,2
             i=nint(fmerit(ii+1,kpse))/100
             mm=nint(fmerit(ii+1,kpse))-i*100
             mmsys=mm/10
             jmer=mm-mmsys*10
             if(neutro.eq.2)msysori=probsys(mmsys,6)
             inda =nindla(i)
             indx =nindexx(i)
             indal=nindlacl(i)
             if(neutro.ne.2)then
               symbs(i,1)=lasymb(inda)//exsymb(indx)
               numerosy(i,1)=itabsy(mmsys,inda,indx)
             else
               symbs(i,kpse)=lasymb(inda)//exsymb(indx)
               numerosy(i,kpse)=itabsy(msysori,inda,indx)
               lauelcl1(i,kpse)=lauecl(indal)
               ProbLaue=(ProbSys(mmsys,jmer))**0.5
               xx=ProbSys(mmsys,7) 
               fff= (fmerit(ii,kpse)/ProbSys(mmsys,jmer))**(1/xx) !Extintion Prob.  
             endif 
           enddo
         enddo
         if(kprint.eq.1)call stampa_fmerit
         call sort_fmerit(kprint)
      else 
         if(icalcpseud.eq.0)then
           if(iappl.eq.0)return
           icalcpseud=1
           nume=num0
           if(kprint.eq.1)then
             write(lo,'(a)')' ******************************* '
             write(lo,'(a)')' Correction by Pseudotranslation '
             write(lo,'(a)')' ******************************* '
           endif
         go to 1000
         endif
      endif
      return    
      end
!
!code for msys2               !monocl.//b
      subroutine msys2
      USE General, only: lo, neutro, knw
      USE Laue
!      USE PseudoStuff
!
      character*20 symbs, lauelcl1     
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/dummyyy/valmedio(13),loo
      common/dumm3/indla,indexx,numsol,ilegen
      common/fordata0/ nsymbo
      common/fordata/ symbs(2000,2),fmerit(2000,2),numerosy(2000,2)
     1,lauelcl1(2000,2)
      common/dummfm/fmer1,knm
      common/refanaprint/natv,volcel,apeso,bpeso
      common/dummyret/tab2ret(13,8,6),tabret(13,8,6),tabnewret(13,8)
!      common /pseudotras/ nkk,mpseud(12,74),numps(74),perctab(13,8)
!     *                    ,perce(74),jpseud(74)
      common /pseudoappl/iapplpse(74),iappl,perctab(13,8)
      character*80 apeso,bpeso
!
      common/probLaEle/numsysEle,RintSys(9,6),ProbSys(9,7),kfin,indprobs
     1,corrfattProb(9),ProbLsav(5),nomonoclino
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!
      kprint=0
      icalcpseud=0
      indecl=10
!-- applica le limitazione del F ortorombico
      fattorto=1.0
      if(neutro.eq.2.and.nomonoclino.eq.1) fattorto=0.5
!
!-hkl
      sa  =tabnew(7,2) 
      sb  =tabnew(7,3) 
      sc  =tabnew(7,1) 
      si  =tabnew(7,4) 
      if(sa.ge.0.9)sa=0.9
      if(sb.ge.0.9)sb=0.9
      if(sc.ge.0.9)sc=0.9
      if(si.ge.0.9)si=0.9
!
      pa=1-sa
      pb=1-sb
      pc=1-sc
      pi=1-si
!
      p0a=pa
      p0b=pb
      p0c=pc
      p0i=pi
!
      pa= applcorEsure(7,2,p0a,0.0)*fattorto
      pb= applcorEsure(7,3,p0b,0.0)*fattorto
      pc= applcorEsure(7,1,p0c,0.0)*fattorto
      pi= applcorEsure(7,4,p0i,0.0)*fattorto
      if(neutro.ne.2)then
      if(pa.lt.0.1)pa=0.1
      if(pb.lt.0.1)pb=0.1
      if(pc.lt.0.1)pc=0.1
      if(pi.lt.0.1)pi=0.1
      endif
!
      pp=1-amax1(pa,pc,pi)
      if(neutro.ne.2.and.pp.lt.0.1)pp=0.1
      if(pp.gt.1.)pp=1.
!-0k0      
      s21=tab(2,1,5) 
      if(s21.lt.0.)s21=0.
      if(s21.ge.0.9)s21=0.9
      if(neutro.eq.2)s21 =tabnew(2,1)
      if(s21.ge.0.9)s21=0.9
      if(s21.ge.0.6)then
           if(tab2(2,1,5).gt.3.5*s21)s21=0.50
           if(tab2(2,1,5).gt.4.0*s21)s21=0.40
      endif
      p21=1-s21
      if(neutro.ne.2.and.p21.lt.0.1)p21=0.1
      p21=pcorr21(2,1,p21)     !8apr2008
      p021=p21
      p21= applcorEsure(2,1,p21,0.)
      if(neutro.ne.2.and.p21.lt.0.1)p21=0.1
!-h0l
      s1a1=tabnew(5,1)
      s1c1=tabnew(5,2)
      s1ac1=tabnew(5,3)
      s1n1=tabnew(5,4)
!      if(neutro.ne.2)then
      if(s1a1.ge.0.9)s1a1=0.9
      if(s1c1.ge.0.9)s1c1=0.9
      if(s1ac1.ge.0.9)s1ac1=0.9
      if(s1n1.ge.0.9)s1n1=0.9
!      endif
!
      p1a1=1-s1a1
      p1a1ori=p1a1
      p0=p0c
      p1a1= applcorEsure(5,1,p1a1,p0)
!
      p1c1=1-s1c1
      p1c1ori=p1c1
      p0=p0a
      p1c1= applcorEsure(5,2,p1c1,p0)
      p1n1=1-s1n1 
      p1n1ori=p1n1
      p0=p0i
      p1n1= applcorEsure(5,4,p1n1,p0)
!
      p1ac1=1-s1ac1 
      p1ac1ori=p1ac1
      p1ac1=applcorEsure(5,3,p1ac1,0.0)  
      if(neutro.ne.2)then
      if(p1a1.le.0.1)p1a1=0.1
      if(p1c1.lt.0.1)p1c1=0.1
      if(p1n1.lt.0.1)p1n1=0.1
      if(p1ac1.le.0.1)p1ac1=0.1
      endif
!
!-- setta a 0.5 la prob. per gli elementi di classi mancanti
      if(neutro==2)then
         if(ncont(2)==0.or.tab2(2,1,1)==0)p21=0.5
         if(ncont(5)==0.or.tab2(5,1,1)==0)p1a1=0.5
         if(ncont(5)==0.or.tab2(5,2,1)==0)p1c1=0.5
         if(ncont(5)==0.or.tab2(5,3,1)==0)p1ac1=0.5
         if(ncont(5)==0.or.tab2(5,4,1)==0)p1n1=0.5
      endif
!
      p1m1= 1-amax1(p1a1,p1c1,p1n1)
      if(neutro.ne.2.and.p1m1.lt.0.1)p1m1=0.1
      pa1m1= 1-p1n1
      if(neutro.ne.2.and.pa1m1.lt.0.1)pa1m1=0.1
      pc1m1= 1-p1n1
      if(neutro.ne.2.and.pc1m1.lt.0.1)pc1m1=0.1
      pi1m1= 1-p1a1
      if(neutro.ne.2.and.pi1m1.lt.0.1)pi1m1=0.1
      p2=1.-p21
      if(neutro.ne.2.and.p2.lt.0.1)p2=0.1
!
      if(kprint.eq.1)then
      write(lo,'(a,3f8.3)')'sa p0a pa    ',sa,p0a,pa
      write(lo,'(a,3f8.3)')'sb p0b pb    ',sb,p0b,pb
      write(lo,'(a,3f8.3)')'sc p0c pc    ',sc,p0c,pc
      write(lo,'(a,3f8.3)')'si p0i pi    ',si,p0i,pi
!     write(lo,'(a,2f8.3)')'sp    pp    ',sp,ppp
      write(lo,'(a,3f8.3)')'s1a1 pori p1a1  ',s1a1,p1a1ori,p1a1
      write(lo,'(a,3f8.3)')'s1c1 pori p1c1  ',s1c1,p1c1ori,p1c1
      write(lo,'(a,3f8.3)')'s1ac1 pori p1ac1  ',s1ac1,p1ac1ori,p1ac1
      write(lo,'(a,3f8.3)')'s1n1 pori p1n1  ',s1n1,p1n1ori,p1n1
      write(lo,'(a,2f8.3)')'  p1m1  ',p1m1
      write(lo,'(a,3f8.3)')'s21 p021  p21   ',s21,p021,p21
      write(lo,'(a,2f8.3)')'  p2    ',p2
      write(lo,'(a)')'pa1m1=1-p1n1,pc1m1=1-p1n1,pi1m1=1-p1a1   '
      write(lo,'(a,3f8.3)')'pa1m1 pc1m1 pi1m1 ',pa1m1,pc1m1,pi1m1
      endif
!
1000  continue
!
!----------------------------------------------------------------------
!-- nel secondo passaggio applica le pseudot.
!
      if(icalcpseud.eq.1)then
      pa=pa*perctab(7,2)
      pb=pb*perctab(7,3)
      pc=pc*perctab(7,1)
      pi=pi*perctab(7,4)
      if(neutro.ne.2)then
      if(pa.lt.0.1)pa=0.1
      if(pb.lt.0.1)pb=0.1
      if(pc.lt.0.1)pc=0.1
      if(pi.lt.0.1)pi=0.1
      endif
      pp=1-amax1(pa,pc,pi)
      p1a1=p1a1*perctab(5,1)
      p1c1=p1c1*perctab(5,2)
      p1n1=p1n1*perctab(5,4)
      p1ac1=p1ac1*perctab(5,3)
      p21=p21*perctab(2,1)
      if(neutro.ne.2)then
      if(pp.lt.0.1)pp=0.1
      if(p21.lt.0.1)p21=0.1
      if(p1a1.lt.0.1)p1a1=0.1
      if(p1c1.lt.0.1)p1c1=0.1
      if(p1n1.lt.0.1)p1n1=0.1
      if(p1ac1.lt.0.1)p1ac1=0.1
      endif
!-- setta a 0.5 la prob. per gli elementi di classi mancanti
      if(neutro==2)then
         if(ncont(2)==0.or.tab2(2,1,1)==0)p21=0.5
         if(ncont(5)==0)then
           p1a1=0.5;    p1c1=0.5;    p1n1=0.5;    p1ac1=0.5
         else 
           if(tab2(5,1,1)==0)p1a1=0.5
           if(tab2(5,2,1)==0)p1c1=0.5
           if(tab2(5,3,1)==0)p1ac1=0.5
           if(tab2(5,4,1)==0)p1n1=0.5
         endif
      endif
      p2=1-p21
      p1m1= 1-amax1(p1a1,p1c1,p1n1)   

!
      if(kprint.eq.1)then
      write(lo,*) 'dopo applicata la pseudot. '
      write(lo,'(a,6f6.3)')'pa,pb,pc,pi,pp         ',
     1  pa,pb,pc,pi,pp
      write(lo,'(a,2f8.3)')'s1a1  p1a1  ',s1a1,p1a1
      write(lo,'(a,2f8.3)')'s1c1  p1c1  ',s1c1,p1c1
      write(lo,'(a,2f8.3)')'s1ac1  p1ac1  ',s1ac1,p1ac1
      write(lo,'(a,2f8.3)')'s1n1  p1n1  ',s1n1,p1n1
      write(lo,'(a,2f8.3)')'p1m1  ',p1m1
      write(lo,'(a,2f8.3)')'s21   p21   ',s21,p21
      write(lo,'(a,2f8.3)')'p2    ',p2
      write(lo,'(a)')'pa1m1=1-p1n1,pc1m1=1-p1n1,pi1m1=1-p1a1   '
      write(lo,'(a,3f8.3)')'pa1m1 pc1m1 pi1m1 ',pa1m1,pc1m1,pi1m1
      endif
      endif


!----------------------------------------------------------------------
!         nume=1
          num0=nume
                     indla=1
                     indexx=2
         fmersg(nume)=ProbLa*pp*p2*p1m1
         fmer1=0.
         knm=0
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=18
         fmersg(nume)=ProbLa*pp*p21*p1m1
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=4
         fmersg(nume)=ProbLa*pp*p2*p1a1 
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=23
         fmersg(nume)=ProbLa*pp*p21*p1a1
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=9
         fmersg(nume)=ProbLa*pp*p2*p1c1
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=24
         fmersg(nume)=ProbLa*pp*p21*p1c1
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=11
         fmersg(nume)=ProbLa*pp*p2*p1n1
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=25
         fmersg(nume)=ProbLa*pp*p21*p1n1
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
!----------------------------------------------------------------------
!--ripristina  gli originali
!      pa=pasav
!      pb=pbsav
!      pc=pcsav
!      pi=pisav
!      pp=ppsav
!      p1a1=p1a1sav
!      p1c1=p1c1sav
!      p1n1=p1n1sav
!      p1ac1=p1ac1sav
!      p21=p21sav
!      p2=p2sav
!----------------------------------------------------------------------
                     indla=4
                     indexx=2
!         fmersg(nume)=pc*p21*p1a1
         fmersg(nume)=ProbLa*pc*p21*p1a1
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=4
                     indexx=9
!         fmersg(nume)=pc*p21*p1ac1
         fmersg(nume)=ProbLa*pc*p21*p1ac1
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=2
                     indexx=2
!         fmersg(nume)=pa*p21*p1c1
         fmersg(nume)=ProbLa*pa*p21*p1c1
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=2
                     indexx=11
!         fmersg(nume)=pa*p21*p1ac1 
         fmersg(nume)=ProbLa*pa*p21*p1ac1 
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                    indla=5
                    indexx=2
!         fmersg(nume)=pi*p21*p1n1
         fmersg(nume)=ProbLa*pi*p21*p1n1
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=5
                     indexx=4
!         fmersg(nume)=pi*p21*p1ac1
         fmersg(nume)=ProbLa*pi*p21*p1ac1
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
!
!22ott         if(kfin.ne.numsysEle)return
      if(knm.gt.0)fmersg(1)=1-fmer1/knm
!
!
      mm=msys
      if(neutro.eq.2)mm=indprobs
      xx=Probsys(mm,7)
      if (knw > 0) write(lo,*)'mm,xx ',mm,xx
      do i=num0+1,nume,2
          if(fmersg(i-1).lt.0.)fmersg(i-1)=0.
          if(neutro.eq.2)then  !28apr11
             fmersg(i-1)=ProbLa*(fmersg(i-1)/ProbLa)**xx
          endif
          fmersg(i)=i/2*100+mm*10+1
          nindlacl(i/2)=indecl
      enddo
      fmerit(num0:nume,icalcpseud+1)=fmersg(num0:nume)
!
      if(numsysEle==kfin.and.icalcpseud.eq.iappl)then
         do kpse=1,iappl+1
           do ii=1,nume-2,2
             i=nint(fmerit(ii+1,kpse))/100
             mm=nint(fmerit(ii+1,kpse))-i*100
             mmsys=mm/10
             jmer=mm-mmsys*10
             if(neutro.eq.2)msysori=probsys(mmsys,6)
             inda =nindla(i)
             indx =nindexx(i)
             indal=nindlacl(i)
             if(neutro.ne.2)then
               symbs(i,1)=lasymb(inda)//exsymb(indx)
               numerosy(i,1)=itabsy(mmsys,inda,indx)
             else
               symbs(i,kpse)=lasymb(inda)//exsymb(indx)
               numerosy(i,kpse)=itabsy(msysori,inda,indx)
               lauelcl1(i,kpse)=lauecl(indal)
               ProbLaue=(ProbSys(mmsys,jmer))**0.5
               xx=ProbSys(mmsys,7) 
               fff= (fmerit(ii,kpse)/ProbSys(mmsys,jmer))**(1/xx) !Extintion Prob.  
             endif 
           enddo
         enddo
! stampa
         if(kprint.eq.1)call stampa_fmerit
!         write(lo,*) ' chiama sort_fmerit'
         call sort_fmerit(kprint)
!      nume=nume*2+1
      else 
         if(icalcpseud.eq.0)then
           if(iappl.eq.0)return
           icalcpseud=1
           nume=num0
           if(kprint.eq.1)then
             write(lo,'(a)')' ******************************* '
             write(lo,'(a)')' Correction by Pseudotranslation '
             write(lo,'(a)')' ******************************* '
           endif
         go to 1000
         endif
      endif
      return
      end
!
!code for msys3             !monoc.//c
      subroutine msys3
      USE General, only: lo, neutro, knw
      USE Laue
!      USE PseudoStuff
!
      character*20 symbs, lauelcl1     
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/dummyyy/valmedio(13),loo
      common/dumm3/indla,indexx,numsol,ilegen
      common/fordata0/ nsymbo
      common/fordata/ symbs(2000,2),fmerit(2000,2),numerosy(2000,2)
     1,lauelcl1(2000,2)
      common/dummfm/fmer1,knm
      common/refanaprint/natv,volcel,apeso,bpeso
      common/dummyret/tab2ret(13,8,6),tabret(13,8,6),tabnewret(13,8)
!      common /pseudotras/ nkk,mpseud(12,74),numps(74),perctab(13,8)
!     *                    ,perce(74),jpseud(74)
      common /pseudoappl/iapplpse(74),iappl,perctab(13,8)
      character*80 apeso,bpeso
!
      common/probLaEle/numsysEle,RintSys(9,6),ProbSys(9,7),kfin,indprobs
     1,corrfattProb(9),ProbLsav(5),nomonoclino
!
!
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!
      kprint=0
      icalcpseud=0
      indecl=14
!
!-- applica le limitazione del F ortorombico
      fattorto=1.0
      if(neutro.eq.2.and.nomonoclino.eq.1) fattorto=0.5
!
!-hkl
      sa  =tabnew(7,2) 
      sb  =tabnew(7,3) 
      sc  =tabnew(7,1) 
      si  =tabnew(7,4) 
!      if(neutro.ne.2)then
      if(sa.ge.0.9)sa=0.9
      if(sb.ge.0.9)sb=0.9
      if(sc.ge.0.9)sc=0.9
      if(si.ge.0.9)si=0.9
!      endif
!
      pa=1-sa
      pb=1-sb
      pc=1-sc
      pi=1-si
!
      p0a=pa
      p0b=pb
      p0c=pc
      p0i=pi
!
      pa= applcorEsure(7,2,p0a,0.0)*fattorto
      pb= applcorEsure(7,3,p0b,0.0)*fattorto
      pc= applcorEsure(7,1,p0c,0.0)*fattorto
      pi= applcorEsure(7,4,p0i,0.0)*fattorto
!
      pp=1-amax1(sa,sc,si)
      if(neutro.ne.2.and.pp.lt.0.1)pp=0.1
!-00l      
         s21=tabnew(1,1) 
         if(s21.lt.0.1)s21=0.1
         if(neutro.eq.2)s21 =tabnew(1,1)
         if(s21.ge.0.9)s21=0.9
         if(s21.ge.0.6)then
           if(tab2(1,1,5).gt.3.5*s21)s21=0.50
           if(tab2(1,1,5).gt.4.0*s21)s21=0.40
         endif
         p21=1-s21
         p021=p21
         p21=pcorr21(1,1,p21)
         p21= applcorEsure(1,1,p21,0.0)
!
!-hk0      
      s11a=tabnew(6,1)
      s11b=tabnew(6,2)
      s11ab=tabnew(6,3)
      s11n=tabnew(6,4)
!      if(neutro.ne.2)then
      if(s11a.ge.0.9)s11a=0.9
      if(s11b.ge.0.9)s11b=0.9
      if(s11ab.ge.0.9)s11ab=0.9
      if(s11n.ge.0.9)s11n=0.9
!      endif
!
      p11a=1-s11a
      p11aori=p11a
      p0=p0a
      p11a= applcorEsure(6,1,p11a,p0)
!
      p11b=1-s11b 
      p11bori=p11b
      p0=p0b
      p11b= applcorEsure(6,2,p11b,p0)
!
      p11ab=1-s11ab 
      p11abori=p11ab
      p0=0.0
      p11ab= applcorEsure(6,3,p11ab,p0)
!
      p11n=1-s11n 
      p11nori=p11n
      p0=p0i
      p11n= applcorEsure(6,4,p11n,p0)
      if(neutro.ne.2)then
      if(p11a.lt.0.1)p11a=0.1
      if(p11b.lt.0.1)p11b=0.1
      if(p11ab.lt.0.1)p11ab=0.1
      if(p11n.lt.0.1)p11n=0.1
      endif
!      
!-- setta a 0.5 la prob. per gli elementi di classi mancanti
      if(neutro==2)then
           if(ncont(1)==0.or.tab2(1,1,1)==0)p21=0.5
           if(ncont(6)==0.or.tab2(6,1,1)==0)p11a =0.5
           if(ncont(6)==0.or.tab2(6,2,1)==0)p11b =0.5
           if(ncont(6)==0.or.tab2(6,3,1)==0)p11ab=0.5
           if(ncont(6)==0.or.tab2(6,4,1)==0)p11n =0.5
      endif
!
      p11m= 1-amax1(p11b,p11a,p11n)
      pa11m= 1-p11n
      pc11m= 1-p11n
      pi11m= 1-p11a
      p2=1.-p21
      if(neutro.ne.2)then
      if(pa11m.lt.0.1)pa11m=0.1
      if(p11m.lt.0.1)p11m=0.1
      if(pc11m.lt.0.1)pc11m=0.1
      if(pi11m.lt.0.1)pi11m=0.1
      if(p2.lt.0.1)p2=0.1
      endif
!
      if(kprint.eq.1)then
      write(lo,'(a,2f8.3)')'sa    pa    ',sa,pa
      write(lo,'(a,2f8.3)')'sb    pb    ',sb,pb
      write(lo,'(a,2f8.3)')'sc    pc    ',sc,pc
      write(lo,'(a,2f8.3)')'si    pi    ',si,pi
      write(lo,'(a,2f8.3)')'    pp    ',pp
      write(lo,'(a,2f8.3)')'s11a  p11a  ',s11a,p11a
      write(lo,'(a,2f8.3)')'s11b  p11b  ',s11b,p11b
      write(lo,'(a,2f8.3)')'s11ab  p11ab  ',s11ab,p11ab
      write(lo,'(a,2f8.3)')'s11n  p11n  ',s11n,p11n
      write(lo,'(a,2f8.3)')'  p11m  ',p11m
      write(lo,'(a,2f8.3)')'s21   p21   ',s21,p21
      write(lo,'(a,2f8.3)')'  p2    ',p2
      endif
!
1000  continue
!
!----------------------------------------------------------------------
!-- nel secondo passaggio applica le pseudot.
!
      if(icalcpseud.eq.1)then
      pa=pa*perctab(7,2)
      pb=pb*perctab(7,3)
      pi=pi*perctab(7,4)
      if(neutro.ne.2)then
      if(pa.lt.0.1)pa=0.1
      if(pb.lt.0.1)pb=0.1
      if(pi.lt.0.1)pi=0.1
      endif
      pp=1-amax1(pa,pb,pi)
      p11a=p11a*perctab(6,1)
      p11b=p11b*perctab(6,2)
      p11n=p11n*perctab(6,4)
      p11ab=p11ab*perctab(6,3)
      p21=p21*perctab(2,1)
!
!-- setta a 0.5 la prob. per gli elementi di classi mancanti
      if(neutro==2)then
           if(ncont(1)==0.or.tab2(1,1,1)==0)p21=0.5
           if(ncont(6)==0.or.tab2(6,1,1)==0)p11a =0.5
           if(ncont(6)==0.or.tab2(6,2,1)==0)p11b =0.5
           if(ncont(6)==0.or.tab2(6,3,1)==0)p11ab=0.5
           if(ncont(6)==0.or.tab2(6,4,1)==0)p11n =0.5
      endif
!
!
      p11m= 1-amax1(p11b,p11a,p11n)
      pa11m= 1-p11n
      pc11m= 1-p11n
      pi11m= 1-p11a
      p2=1.-p21
      if(neutro.ne.2)then
      if(pp.lt.0.1)pp=0.1
      if(p2.lt.0.1)p2=0.1
      if(p11m.lt.0.1)p11m=0.1
      if(pa11m.lt.0.1)pa11m=0.1
      if(pc11m.lt.0.1)pc11m=0.1
      if(pi11m.lt.0.1)pi11m=0.1
      endif
!
      if(kprint.eq.1)then
      write(lo,*) 'dopo applicata la pseudot. '
      write(lo,'(a,6f6.3)')'pa,pb,pc,pi,pp         ',
     1  pa,pb,pc,pi,pp
      write(lo,'(a,2f8.3)')'s11a  p11a  ',s11a,p11a
      write(lo,'(a,2f8.3)')'s11b  p11b  ',s11b,p11b
      write(lo,'(a,2f8.3)')'s11ab  p11ab  ',s11ab,p11ab
      write(lo,'(a,2f8.3)')'s11n  p11n  ',s11n,p11n
      write(lo,'(a,2f8.3)')'  p11m  ',p11m
      write(lo,'(a,2f8.3)')'s21   p21   ',s21,p21
      write(lo,'(a,2f8.3)')' p2    ',p2
      endif
      endif


!----------------------------------------------------------------------
          num0=nume
                     indla=1
                     indexx=3
         fmersg(nume)=ProbLa*pp*p2*p11m
         fmer1=0.
         knm=0
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=19
         fmersg(nume)=ProbLa*pp*p21*p11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=5
         fmersg(nume)=ProbLa*pp*p2*p11a 
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=26
         fmersg(nume)=ProbLa*pp*p21*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=7
         fmersg(nume)=ProbLa*pp*p2*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=27
         fmersg(nume)=ProbLa*pp*p21*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=12
         fmersg(nume)=ProbLa*pp*p2*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=1
                     indexx=28
         fmersg(nume)=ProbLa*pp*p21*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
!
                     indla=3
                     indexx=3
!         fmersg(nume)=pb*p21*pc11a
         fmersg(nume)=ProbLa*pb*p21*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=3
                     indexx=12
!         fmersg(nume)=pc*p21*p1c1
         fmersg(nume)=ProbLa*pb*p21*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=2
                     indexx=3
!         fmersg(nume)=pa*p21*pa11m1
         fmersg(nume)=ProbLa*pa*p21*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=2
                     indexx=5
!         fmersg(nume)=pa*p21*pa1m1 
         fmersg(nume)=ProbLa*pa*p21*p11ab 
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                    indla=5
                    indexx=3
!         fmersg(nume)=pi*p21*pi1m
         fmersg(nume)=ProbLa*pi*p21*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
                     indla=5
                     indexx=7
!         fmersg(nume)=pi*p21*p1a1
         fmersg(nume)=ProbLa*pi*p21*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!         write(lo,'(10x,a,a,2f9.3,i6)')lasymb(indla),exsymb(indexx)
!     1       ,fmersg(nume),prob(nume),nume
         nume=nume+2
!
         if(knm.gt.0)fmersg(1)=1-fmer1/knm
!
      mm=msys
      if(neutro.eq.2)mm=indprobs
      xx=Probsys(mm,7)
      if (knw > 0) write(lo,*)'mm,xx ',mm,xx
      do i=num0+1,nume,2
          if(fmersg(i-1).lt.0.)fmersg(i-1)=0.
          if(neutro.eq.2)then  !28apr11
             fmersg(i-1)=ProbLa*(fmersg(i-1)/ProbLa)**xx
          endif
          fmersg(i)=i/2*100+mm*10+1
          nindlacl(i/2)=indecl
      enddo
      fmerit(num0:nume,icalcpseud+1)=fmersg(num0:nume)
!
      if(numsysEle==kfin.and.icalcpseud.eq.iappl)then
         do kpse=1,iappl+1
           do ii=1,nume-2,2
             i=nint(fmerit(ii+1,kpse))/100
             mm=nint(fmerit(ii+1,kpse))-i*100
             mmsys=mm/10
             jmer=mm-mmsys*10
             if(neutro.eq.2)msysori=probsys(mmsys,6)
             inda =nindla(i)
             indx =nindexx(i)
             indal=nindlacl(i)
             if(neutro.ne.2)then
               symbs(i,1)=lasymb(inda)//exsymb(indx)
               numerosy(i,1)=itabsy(mmsys,inda,indx)
             else
               symbs(i,kpse)=lasymb(inda)//exsymb(indx)
               numerosy(i,kpse)=itabsy(msysori,inda,indx)
               lauelcl1(i,kpse)=lauecl(indal)
               ProbLaue=(ProbSys(mmsys,jmer))**0.5
               xx=ProbSys(mmsys,7) 
               fff= (fmerit(ii,kpse)/ProbSys(mmsys,jmer))**(1/xx) !Extintion Prob.  
             endif 
           enddo
         enddo
         if(kprint.eq.1)call stampa_fmerit
         call sort_fmerit(kprint)
      else 
         if(icalcpseud.eq.0)then
           if(iappl.eq.0)return
           icalcpseud=1
           nume=num0
           if(kprint.eq.1)then
             write(lo,'(a)')' ******************************* '
             write(lo,'(a)')' Correction by Pseudotranslation '
             write(lo,'(a)')' ******************************* '
           endif
         go to 1000
         endif
      endif
      return
      end
!
!code for msys4
      subroutine msys4
      USE General, only: lo, neutro, knw
      USE Laue
!      USE PseudoStuff
!
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/dummyyy/valmedio(13),loo
      common/dumm3/indla,indexx,numsol,ilegen
      character*20 symbs, lauelcl1     
      common/fordata0/ nsymbo
      common/fordata/ symbs(2000,2),fmerit(2000,2),numerosy(2000,2)
     1,lauelcl1(2000,2)
      common/dummfm/fmer1,knm
      common/refanaprint/natv,volcel,apeso,bpeso
!      common /pseudotras/ nkk,mpseud(12,74),numps(74),perctab(13,8)
!     *                    ,perce(74),jpseud(74)
      common /pseudoappl/iapplpse(74),iappl,perctab(13,8)
      character*80 apeso,bpeso
!
      common/probLaEle/numsysEle,RintSys(9,6),ProbSys(9,7),kfin,indprobs
     1,corrfattProb(9),ProbLsav(5),nomonoclino
!
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!
      kprint=0   ! 0=non stampa,1=stampa solo la tab. finale, 2=tutto
      icalcpseud=0
      indecl=11
!--lattice
      sa  =tabnew(7,2) 
      sb  =tabnew(7,3) 
      sc  =tabnew(7,1) 
      si  =tabnew(7,4) 
      sf  =tabnew(7,5) 
!      if(neutro.ne.2)then
      if(sa.gt.0.9)sa=0.9
      if(sb.gt.0.9)sb=0.9
      if(sc.gt.0.9)sc=0.9
      if(si.gt.0.9)si=0.9
      if(sf.gt.0.9)sf=0.9
!      endif
!
      pa0=1-sa
      p0a=pa0
      pa0=applcorEsure(7,2,pa0,0.)
!
      pb0=1-sb
      p0b=pb0
      pb0=applcorEsure(7,3,pb0,0.)
!
      pc0=1-sc
      p0c=pc0
      pc0=applcorEsure(7,1,pc0,0.)
!
      pi=1-si
      p0i=pi
      pi=applcorEsure(7,4,pi,0.)
      pi0=pi
!
      pf0=1-sf
      p0f=pf0
      pf0=applcorEsure(7,5,pf0,0.)
!
      pa=pa0*(1-pb0)*(1-pc0)
      pb=pb0*(1-pa0)*(1-pc0)
      pc=pc0*(1-pa0)*(1-pb0)
      pf=pf0+pa*pb*pc
      if(pa0.le.0.35.or.pb0.le.0.35.or.pc0.le.0.35)
     1 pf=amin1(pa0,pb0,pc0)
      pp=1-amax1(pa,pb,pc,pi,pf)
      if(neutro.ne.2)then
      if(pa.lt.0.1)pa=0.1
      if(pb.lt.0.1)pb=0.1
      if(pc.lt.0.1)pc=0.1
      if(pi.lt.0.1)pi=0.1
      if(pf.lt.0.1)pf=0.1
      if(pp.lt.0.1)pp=0.1
      pp1=p0c
      pp2=p0a
      pp3=p0b
      pp4=p0i
      pp5=p0f
      else
      pp1=pc0
      pp2=pa0
      pp3=pb0
      pp4=pi0
      pp5=pf0
      endif
!-- controllo sui i monoclini   
      nomonoclino=0
      if(neutro.eq.2.and.pf.ge.0.8) nomonoclino=1   
!--assi
! 00l
      s112=tab(1,1,5)                        !l#2n
      if(s112.lt.0.1)s112=0.1
      if(neutro.eq.2)s112=tabnew(1,1)             
      if(s112.gt.0.9)s112=0.9
      if(s112.ge.0.6)then
               if(tab2(1,1,5).gt.3.5*s112)s112=0.50
               if(tab2(1,1,5).gt.4.0*s112)s112=0.40
      endif
      p112=1-s112
      p112=pcorr21(1,1,p112)    !8apr2008
      p112ori=p112
      p112=applcorEsure(1,1,p112,0.)
!-0k0
      s121=tab(2,1,5)
      if(s121.lt.0.1)s121=0.1
      if(neutro.eq.2)s121=tabnew(2,1)
      if(s121.gt.0.9)s121=0.9
      if(s121.ge.0.6)then
            if(tab2(2,1,5).gt.3.5*s121)s121=0.50
            if(tab2(2,1,5).gt.4.0*s121)s121=0.40
      endif
      p121=1-s121
      p121ori=p121
      p121=pcorr21(2,1,p121)       !8apr2008
      p121ori=p121
      p121=applcorEsure(2,1,p121,0.)
! h00
      s211=tab(3,1,5) 
      if(s211.lt.0.1)s211=0.1
      if(neutro.eq.2)s211=tabnew(3,1)
      if(s211.gt.0.9)s211=0.9
      if(s211.ge.0.6)then
            if(tab2(3,1,5).gt.3.5*s211)s211=0.50
            if(tab2(3,1,5).gt.4.0*s211)s211=0.40
      endif
      p211=1-s211
      p211=pcorr21(3,1,p211)      !8apr2008
      p211ori=p211
      p211=applcorEsure(3,1,p211,0.)
!
!      write(lo,*)'s211,s121,s112 ',s211,s121,s112
!      write(lo,*)'s11a,s11b,s11n ',s11a,s11b,s11n
!      write(lo,*)'s1a1,s1c1,s1n1 ',s1a1,s1c1,s1n1
!      write(lo,*)'sb11,sc11,sn11 ',sb11,sc11,sn11
!      write(lo,*)'  s211 ,s121 ,s112  ',s211,s121,s112
!      write(lo,*)' prima di pcorr p211 ,p121 ,p112  ',p211,p121,p112
!      write(lo,*)' dopo pcorr     p211 ,p121 ,p112  ',p211,p121,p112
!

      s114=tab(1,2,5) 
      if(neutro.eq.2)s114=tabnew(1,2)
      if(s114.gt.0.9)s114=0.9
      if(s114.ge.0.6)then
            if(tab2(1,2,5).gt.3.5*s114)s114=0.50
            if(tab2(1,2,5).gt.4.0*s114)s114=0.40
      endif
      p114=1.-s114
!
      s141=tab(2,2,5)
      if(neutro.eq.2)s141=tabnew(2,2)
      if(s141.gt.0.9)s141=0.9
      if(s141.ge.0.6)then
            if(tab2(2,2,5).gt.3.5*s141)s141=0.50
            if(tab2(2,2,5).gt.4.0*s141)s141=0.40
      endif
      p141=1-s141
!
      s411=tab(3,2,5)
      if(neutro.eq.2)s411=tabnew(3,2)
      if(s411.gt.0.9)s411=0.9
      if(s411.ge.0.6)then
           if(tab2(3,2,5).gt.3.5*s411)s411=0.50
           if(tab2(3,2,5).gt.4.0*s411)s411=0.40
      endif
      p411=1-s411
!
      p114=pcorr21(1,2,p114)
      p141=pcorr21(2,2,p141)
      p411=pcorr21(3,2,p411)
      p114=applcorEsure(1,2,p114,0.)
      p141=applcorEsure(2,2,p141,0.)
      p411=applcorEsure(3,2,p411,0.)
      if(neutro.ne.2)then
      if(p114.lt.0.1)p114=0.1
      if(p141.lt.0.1)p141=0.1
      if(p411.lt.0.1)p411=0.1
      endif

!
!--piani
!-- normali ad a
      sb11=tabnew(4,1) 
      if(sb11.gt.0.9)sb11=0.9
      pb11=1-sb11
      pb11ori=pb11
      p0=0
      p0=amax1(pp5,pp1)
      pb11 =applcorEsure(4,1,pb11,p0)
!
      sc11=tabnew(4,2) 
      if(sc11.gt.0.9)sc11=0.9
      pc11=1-sc11
      pc11ori=pc11
      p0=0
      p0=amax1(pp5,pp3)
      pc11 =applcorEsure(4,2,pc11,p0)
!
      sn11=tabnew(4,4) 
      if(sn11.gt.0.9)sn11=0.9
      pn11=1-sn11
      pn11ori=pn11
      p0=0
      p0=amax1(pp5,pp4,pp2)
      pn11 =applcorEsure(4,4,pn11,p0)   
!
      sd11=tabnew(4,5) 
      if(sd11.gt.0.9)sd11=0.9
      pd11=1-sd11
      pd11ori=pd11
      pd11 =applcorEsure(4,5,pd11,0.0)
!
      sbc11=tabnew(4,3) 
      if(sbc11.gt.0.9)sbc11=0.9
      pbc11=1-sbc11
      pbc11ori=pbc11
      pbc11=applcorEsure(4,3,pbc11,0.0)
      if(neutro.ne.2)then
      if(pc11.lt.0.1)pc11=0.1
      if(pb11.lt.0.1)pb11=0.1
      if(pn11.lt.0.1)pn11=0.1
      if(pd11.lt.0.1)pd11=0.1
      if(pbc11.lt.0.1)pbc11=0.1
      endif
!
!--normali a b
!
      s1a1=tabnew(5,1) 
      if(s1a1.gt.0.9)s1a1=0.9
      p1a1=1-s1a1
      p1a1ori=p1a1
      p0=0
      p0=amax1(pp5,pp1)
      p1a1= applcorEsure(5,1,p1a1,p0)
!
      s1c1=tabnew(5,2)
      if(s1c1.gt.0.9)s1c1=0.9
      p1c1=1-s1c1
      p1c1ori=p1c1
      p0=0
      p0=amax1(pp5,pp2)
      p1c1 =applcorEsure(5,2,p1c1,p0)
!
      s1n1=tabnew(5,4) 
      if(s1n1.gt.0.9)s1n1=0.9
      p1n1=1-s1n1
      p1n1ori=p1n1
      p0=0
      p0=amax1(pp5,pp4,pp3)
      p1n1 =applcorEsure(5,4,p1n1,p0)
!
      s1d1=tabnew(5,5) 
      if(s1d1.gt.0.9)s1d1=0.9
      p1d1=1-s1d1
      p1d1ori=p1d1
      p1d1 =applcorEsure(5,5,p1d1,0.0)
!
      s1ac1=tabnew(5,3) 
      if(s1ac1.gt.0.9)s1ac1=0.9
      p1ac1=1-s1ac1
      p1ac1ori=p1ac1
      p1ac1=applcorEsure(5,3,p1ac1,0.0)
      if(neutro.ne.2)then
      if(p1a1.lt.0.1)p1a1=0.1
      if(p1c1.lt.0.1)p1c1=0.1
      if(p1n1.lt.0.1)p1n1=0.1
      if(p1d1.lt.0.1)p1d1=0.1
      if(p1ac1.lt.0.1)p1ac1=0.1
      endif
!
!-- normali a c
      s11a=tabnew(6,1) 
      if(s11a.gt.0.9)s11a=0.9
      p11a=1-s11a
      p11aori=p11a
      p0=0
      p0=amax1(pp5,pp3)
      p11a =applcorEsure(6,1,p11a,p0)
!
      s11b=tabnew(6,2) 
      if(s11b.gt.0.9)s11b=0.9
      p11b=1-s11b
      p11bori=p11b
      p0=0
      p0=amax1(pp5,pp2)
      p11b =applcorEsure(6,2,p11b,p0)
!
      s11n=tabnew(6,4) 
      if(s11n.gt.0.9)s11n=0.9
      p11n=1-s11n
      p11nori=p11n
      p0=0
      p0=amax1(pp5,pp4,pp1)
      p11n =applcorEsure(6,4,p11n,p0)
!
      s11d=tabnew(6,5) 
      if(s11d.gt.0.9)s11d=0.9
      p11d=1-s11d
      p11dori=p11d
      p11d =applcorEsure(6,5,p11d,0.0)
!
      s11ab=tabnew(6,3) 
      if(s11ab.gt.0.9)s11ab=0.9
      p11ab=1-s11ab
      p11abori=p11ab
      p11ab=applcorEsure(6,3,p11ab,0.0)
      if(neutro.ne.2)then
      if(p11a.lt.0.1)p11a=0.1
      if(p11b.lt.0.1)p11b=0.1
      if(p11n.lt.0.1)p11n=0.1
      if(p11d.lt.0.1)p11d=0.1
      if(p11ab.lt.0.1)p11ab=0.1
      endif
!-- setta a 0.5 la prob. per gli elementi di classi mancanti
      if(neutro==2)then
         if(ncont(1)==0.or.tab2(1,1,1)==0)p112 =0.5
         if(ncont(1)==0.or.tab2(1,2,1)==0)p114 =0.5
         if(ncont(2)==0.or.tab2(2,1,1)==0)p121 =0.5
         if(ncont(2)==0.or.tab2(2,2,1)==0)p141 =0.5
         if(ncont(3)==0.or.tab2(3,1,1)==0)p211 =0.5
         if(ncont(3)==0.or.tab2(3,2,1)==0)p411 =0.5
         if(ncont(4)==0.or.tab2(4,1,1)==0)pb11 =0.5
         if(ncont(4)==0.or.tab2(4,2,1)==0)pc11 =0.5
         if(ncont(4)==0.or.tab2(4,3,1)==0)pbc11=0.5
         if(ncont(4)==0.or.tab2(4,4,1)==0)pn11 =0.5
         if(ncont(4)==0.or.tab2(4,5,1)==0)pd11 =0.5
         if(ncont(5)==0.or.tab2(5,1,1)==0)p1a1 =0.5
         if(ncont(5)==0.or.tab2(5,2,1)==0)p1c1 =0.5
         if(ncont(5)==0.or.tab2(5,3,1)==0)p1ac1=0.5
         if(ncont(5)==0.or.tab2(5,4,1)==0)p1n1 =0.5
         if(ncont(5)==0.or.tab2(5,5,1)==0)p1d1 =0.5
         if(ncont(6)==0.or.tab2(6,1,1)==0)p11a =0.5
         if(ncont(6)==0.or.tab2(6,2,1)==0)p11b =0.5
         if(ncont(6)==0.or.tab2(6,3,1)==0)p11ab=0.5
         if(ncont(6)==0.or.tab2(6,4,1)==0)p11n =0.5
         if(ncont(6)==0.or.tab2(6,5,1)==0)p11d =0.5
      endif
!
!
      p21x=p211
      p21y=p121
      p21z=p112
      if(neutro.ne.2)then
      if(p21x.lt.0.1)p21x=0.1
      if(p21y.lt.0.1)p21y=0.1
      if(p21z.lt.0.1)p21z=0.1
      endif
      p2x=1-p21x
      p2y=1-p21y
      p2z=1-p21z
      if(neutro.ne.2)then
      if(p2x.lt.0.1)p2x=0.1
      if(p2y.lt.0.1)p2y=0.1
      if(p2z.lt.0.1)p2z=0.1
      endif
!
      p4x=p411
      p4y=p141
      p4z=p114
      if(neutro.ne.2)then
      if(p4x.lt.0.1)p4x=0.1
      if(p4y.lt.0.1)p4y=0.1
      if(p4z.lt.0.1)p4z=0.1
      endif
!
      pP11m= 1-amax1(p11a,p11b,p11n)
      pP1m1= 1-amax1(p1a1,p1c1,p1n1)
      pPm11= 1-amax1(pb11,pc11,pn11)
      if(neutro.ne.2)then
      if(pP11m.lt.0.1)pP11m=0.1
      if(pP1m1.lt.0.1)pP1m1=0.1
      if(pPm11.lt.0.1)pPm11=0.1
      endif
!  
      if(kprint.gt.1)then
      write(lo,'(a)')'  Lattice'
      write(lo,'(a,6f6.3)')'p0a,p0b,p0c,p0i,p0f        ',
     1  p0a,p0b,p0c,p0i,p0f 
      write(lo,'(a,5f6.3)')'pa0,pb0,pc0,pi0,pf0        ',
     1  pa0,pb0,pc0,pi0,pf0  
      write(lo,'(a,6f6.3)')'pa,pb,pc,pi,pf,pp         ',
     1  pa,pb,pc,pi,pf,pp 
      write(lo,'(a)')'  Piani'
      write(lo,'(a,5f6.3)')'orig. pb11,pc11,pn11,pd11,pbc11 ',
     1  pb11ori,pc11ori,pn11ori,pd11ori,pbc11ori
      write(lo,'(a,5f6.3)')'corr. pb11,pc11,pn11,pd11,pbc11 ',
     1  pb11,pc11,pn11,pd11,pbc11 
      write(lo,'(a,5f6.3)')'orig. p1a1,p1c1,p1n1,p1d1,p1ac1 ',
     1  p1a1ori,p1c1ori,p1n1ori,p1d1ori,p1ac1ori
      write(lo,'(a,5f6.3)')'corr. p1a1,p1c1,p1n1,p1d1,p1ac1 ',
     1  p1a1,p1c1,p1n1,p1d1,p1ac1 
      write(lo,'(a,5f6.3)')'orig. p11a,p11b,p11n,p11d,p11ab ',
     1  p11aori,p11bori,p11nori,p11dori,p11abori
      write(lo,'(a,5f6.3)')'corr. p11a,p11b,p11n,p11d,p11ab ',
     1  p11a,p11b,p11n,p11d,p11ab 
      write(lo,'(a)')'  Assi'
      write(lo,'(a,5f6.3)')'p21x,p21y,p21z ',
     1  p21x,p21y,p21z
      write(lo,'(a,5f6.3)')'p2x ,p2y ,p2z  ',
     1  p2x,p2y,p2z
      write(lo,'(a,5f6.3)')'p4x ,p4y ,p4z  ',
     1  p4x,p4y,p4z
      write(lo,'(a,5f6.3)')' i 3 m per P: pPm11,p1Pm1,pP11m ',
     1  pPm11,pP1m1,pP11m 
!       write(lo ,'(a)')' Esure      ',
!     1'1       2       3       4       5       6      7      8'
!       write(lo,'(a)')'nEsure      ',
!     1'1       2       3       4       5       6      7      8'
!       do kk=1,13
!       write(lo,'(i6,8f8.2)')kk,(Esure(kk,kkk),kkk=1,8)
!       write(lo,'(i6,8i8)')kk,(nEsure(kk,kkk),kkk=1,8)
!       enddo
      endif
!
!--salva i valori originali
      ppsav=pp
      pasav=pa
      pbsav=pb
      pcsav=pc
      pisav=pi
      pfsav=pf
      pb11sav=pb11
      pc11sav=pc11
      pn11sav=pn11
      pd11sav=pd11
      pbc11sav=pbc11
      p1a1sav=p1a1
      p1c1sav=p1c1
      p1n1sav=p1n1
      p1d1sav=p1d1
      p1ac1sav=p1ac1
      p11asav=p11a
      p11bsav=p11b
      p11nsav=p11n
      p11dsav=p11d
      p11absav=p11ab
      p21xsav=p21x
      p21ysav=p21y
      p21zsav=p21z
      p2xsav=p2x
      p2ysav=p2y
      p2zsav=p2z
      p4xsav=p4x
      p4ysav=p4y
      p4zsav=p4z
      pP11msav= pP11m
      pP1m1sav= pP1m1
      pPm11sav= pPm11
1000  continue
!
!----------------------------------------------------------------------
!-- nel secondo passaggio applica le pseudot.
!
      if(icalcpseud.eq.1)then
      pa=pa*perctab(7,2)
      pb=pb*perctab(7,3)
      pc=pc*perctab(7,1)
      pi=pi*perctab(7,4)
      pf=pf*perctab(7,5)
!
      pb11=pb11*perctab(4,1)
      pc11=pc11*perctab(4,2)
      pn11=pn11*perctab(4,4)
      pd11=pd11*perctab(4,5)
      pbc11=pbc11*perctab(4,3)
!
      p1a1=p1a1*perctab(5,1)
      p1c1=p1c1*perctab(5,2)
      p1n1=p1n1*perctab(5,4)
      p1d1=p1d1*perctab(5,5)
      p1ac1=p1ac1*perctab(5,3)
!
      p11a=p11a*perctab(6,1)
      p11b=p11b*perctab(6,2)
      p11n=p11n*perctab(6,4)
      p11d=p11d*perctab(6,5)
      p11ab=p11ab*perctab(6,3)
!
      p21x=p21x*perctab(3,1)
      p21y=p21y*perctab(2,1)
      p21z=p21z*perctab(1,1)
      p4x=p4x*perctab(3,2)
      p4y=p4y*perctab(2,2)
      p4z=p4z*perctab(1,2)
      if(neutro.ne.2)then
      if(pa.lt.0.1)pa=0.1
      if(pb.lt.0.1)pb=0.1
      if(pc.lt.0.1)pc=0.1
      if(pi.lt.0.1)pi=0.1
      if(pf.lt.0.1)pf=0.1
      if(pb11.lt.0.1)pb11=0.1
      if(pc11.lt.0.1)pc11=0.1
      if(pn11.lt.0.1)pn11=0.1
      if(pd11.lt.0.1)pd11=0.1
      if(pbc11.lt.0.1)pbc11=0.1
      if(p1a1.lt.0.1)p1a1=0.1
      if(p1c1.lt.0.1)p1c1=0.1
      if(p1n1.lt.0.1)p1n1=0.1
      if(p1d1.lt.0.1)p1d1=0.1
      if(p1ac1.lt.0.1)p1ac1=0.1
      if(p11a.lt.0.1)p11a=0.1
      if(p11b.lt.0.1)p11b=0.1
      if(p11n.lt.0.1)p11n=0.1
      if(p11d.lt.0.1)p11d=0.1
      if(p11ab.lt.0.1)p11ab=0.1
      if(p21x.lt.0.1)p21x=0.1
      if(p21y.lt.0.1)p21y=0.1
      if(p21z.lt.0.1)p21z=0.1
      if(p4x.lt.0.1)p4x=0.1
      if(p4y.lt.0.1)p4y=0.1
      if(p4z.lt.0.1)p4z=0.1
      endif
!-- setta a 0.5 la prob. per gli elementi di classi mancanti
      if(neutro==2)then
         if(ncont(1)==0.or.tab2(1,1,1)==0)p21z =0.5
         if(ncont(1)==0.or.tab2(1,2,1)==0)p4z  =0.5
         if(ncont(2)==0.or.tab2(2,1,1)==0)p21y =0.5
         if(ncont(2)==0.or.tab2(2,2,1)==0)p4y  =0.5
         if(ncont(3)==0.or.tab2(3,1,1)==0)p21x =0.5
         if(ncont(3)==0.or.tab2(3,2,1)==0)p4x  =0.5
         if(ncont(4)==0.or.tab2(4,1,1)==0)pb11 =0.5
         if(ncont(4)==0.or.tab2(4,2,1)==0)pc11 =0.5
         if(ncont(4)==0.or.tab2(4,3,1)==0)pbc11=0.5
         if(ncont(4)==0.or.tab2(4,4,1)==0)pn11 =0.5
         if(ncont(4)==0.or.tab2(4,5,1)==0)pd11 =0.5
         if(ncont(5)==0.or.tab2(5,1,1)==0)p1a1 =0.5
         if(ncont(5)==0.or.tab2(5,2,1)==0)p1c1 =0.5
         if(ncont(5)==0.or.tab2(5,3,1)==0)p1ac1=0.5
         if(ncont(5)==0.or.tab2(5,4,1)==0)p1n1 =0.5
         if(ncont(5)==0.or.tab2(5,5,1)==0)p1d1 =0.5
         if(ncont(6)==0.or.tab2(6,1,1)==0)p11a =0.5
         if(ncont(6)==0.or.tab2(6,2,1)==0)p11b =0.5
         if(ncont(6)==0.or.tab2(6,3,1)==0)p11ab=0.5
         if(ncont(6)==0.or.tab2(6,4,1)==0)p11n =0.5
         if(ncont(6)==0.or.tab2(6,5,1)==0)p11d =0.5
      endif
!
!
      p2x=1-p21x
      p2y=1-p21y
      p2z=1-p21z
      if(neutro.ne.2)then
      if(p2x.lt.0.1)p2x=0.1
      if(p2y.lt.0.1)p2y=0.1
      if(p2z.lt.0.1)p2z=0.1
      endif
!
      pP11m= 1-amax1(p11a,p11b,p11n)
      pP1m1= 1-amax1(p1a1,p1c1,p1n1)
      pPm11= 1-amax1(pb11,pc11,pn11)
      if(pP11m.lt.0.1)pP11m=0.1
      if(pP1m1.lt.0.1)pP1m1=0.1
      if(pPm11.lt.0.1)pPm11=0.1
!  
      pp=1-amax1(pa,pb,pc,pi,pf)
      if(pp.lt.0.1)pp=0.1
!
      if(kprint.gt.1)then
      write(lo,*) 'dopo applicata la pseudot. '
      write(lo,'(a,6f6.3)')'pa,pb,pc,pi,pf,pp         ',
     1  pa,pb,pc,pi,pf,pp 
      write(lo,'(a,5f6.3)')'pb11,pc11,pn11,pd11,pbc11 ',
     1  pb11,pc11,pn11,pd11,pbc11 
      write(lo,'(a,5f6.3)')'p1a1,p1c1,p1n1,p1d1,p1ac1 ',
     1  p1a1,p1c1,p1n1,p1d1,p1ac1 
      write(lo,'(a,5f6.3)')'p11a,p11b,p11n,p11d,p11ab ',
     1  p11a,p11b,p11n,p11d,p11ab 
      write(lo,'(a,5f6.3)')'p21x,p21y,p21z ',
     1  p21x,p21y,p21z
      write(lo,'(a,5f6.3)')'p2x ,p2y ,p2z  ',
     1  p2x,p2y,p2z
      write(lo,'(a,5f6.3)')'p4x ,p4y ,p4z  ',
     1  p4x,p4y,p4z
      write(lo,'(a,5f6.3)')' i 3 m per P: pP11m,pP1m1,pPm11 ',
     1  pP11m,pP1m1,pPm11 
      endif
!----------------------------------------------------------------------
      endif
!  
!         nume=1
         num0=nume

                     indla=1
                     indexx=29
         fmersg(nume)=ProbLa*pp *p2x*pPm11 *p2y*pP1m1 *p2z*pP11m
         knm=0
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=32
         fmersg(nume)=ProbLa*pp *p2x*pPm11 *p2y*pP1m1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=31
         fmersg(nume)=ProbLa*pp *p2x*pPm11 *p21y*pP1m1 *p2z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=35
         fmersg(nume)=ProbLa*pp *p2x*pPm11 *p21y*pP1m1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=30
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p2y*pP1m1 *p2z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=34
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p2y*pP1m1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=33
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p21y*pP1m1 *p2z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=36
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p21y*pP1m1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
!
                     indla=1
                     indexx=38
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p2y*pP1m1 *p2z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=40
         fmersg(nume)=ProbLa*pp *p2x*pPm11 *p21y*pP1m1 *p2z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=45
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p21y*pP1m1 *p2z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=37
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p2y*p1a1 *p2z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=64
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p2y*p1a1 *p2z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=65
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p21y*p1a1 *p2z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=66
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p21y*p1a1 *p2z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=42
         fmersg(nume)=ProbLa*pp *p2x*pPm11 *p2y*p1c1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=67
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p2y*p1c1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=68
         fmersg(nume)=ProbLa*pp *p2x*pPm11 *p21y*p1c1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=69
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p21y*p1c1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=44
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p2y*p1n1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=70
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p2y*p1n1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=71
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p21y*p1n1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=72
         fmersg(nume)=ProbLa*pp *p21x*pPm11 *p21y*p1n1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=39
         fmersg(nume)=ProbLa*pp *p2x*pb11 *p21y*pP1m1 *p2z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=55
         fmersg(nume)=ProbLa*pp *p21x*pb11 *p21y*pP1m1 *p2z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=56
         fmersg(nume)=ProbLa*pp *p2x*pb11 *p21y*pP1m1 *p2z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=57
         fmersg(nume)=ProbLa*pp *p21x*pb11 *p21y*pP1m1 *p2z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=46
         fmersg(nume)=ProbLa*pp *p21x*pb11 *p21y*p1a1 *p2z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=73
         fmersg(nume)=ProbLa*pp *p21x*pb11 *p21y*p1a1 *p2z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=74
         fmersg(nume)=ProbLa*pp *p21x*pb11 *p21y*p1a1 *p2z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=75
         fmersg(nume)=ProbLa*pp *p21x*pb11 *p21y*p1a1 *p2z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=47
         fmersg(nume)=ProbLa*pp *p2x*pb11 *p21y*p1c1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=76
         fmersg(nume)=ProbLa*pp *p21x*pb11 *p21y*p1c1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=77
         fmersg(nume)=ProbLa*pp *p2x*pb11 *p21y*p1c1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=78
         fmersg(nume)=ProbLa*pp *p21x*pb11 *p21y*p1c1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=48
         fmersg(nume)=ProbLa*pp *p21x*pb11 *p21y*p1n1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=79
         fmersg(nume)=ProbLa*pp *p21x*pb11 *p21y*p1n1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=80
         fmersg(nume)=ProbLa*pp *p21x*pb11 *p21y*p1n1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=81
         fmersg(nume)=ProbLa*pp *p21x*pb11 *p21y*p1n1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=41
         fmersg(nume)=ProbLa*pp *p2x*pc11 *p2y*pP1m1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=58
         fmersg(nume)=ProbLa*pp *p21x*pc11 *p2y*pP1m1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=59
         fmersg(nume)=ProbLa*pp *p2x*pc11 *p21y*pP1m1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=60
         fmersg(nume)=ProbLa*pp *p21x*pc11 *p21y*pP1m1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=49
         fmersg(nume)=ProbLa*pp *p21x*pc11 *p2y*p1a1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=82
         fmersg(nume)=ProbLa*pp *p21x*pc11 *p2y*p1a1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=83
         fmersg(nume)=ProbLa*pp *p21x*pc11 *p21y*p1a1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=84
         fmersg(nume)=ProbLa*pp *p21x*pc11 *p21y*p1a1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=50
         fmersg(nume)=ProbLa*pp *p2x*pc11 *p2y*p1c1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=85
         fmersg(nume)=ProbLa*pp *p21x*pc11 *p2y*p1c1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=86
         fmersg(nume)=ProbLa*pp *p2x*pc11 *p21y*p1c1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=87
         fmersg(nume)=ProbLa*pp *p21x*pc11 *p21y*p1c1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=51
         fmersg(nume)=ProbLa*pp *p21x*pc11 *p2y*p1n1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=88
         fmersg(nume)=ProbLa*pp *p21x*pc11 *p2y*p1n1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=89
         fmersg(nume)=ProbLa*pp *p21x*pc11 *p21y*p1n1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=90
         fmersg(nume)=ProbLa*pp *p21x*pc11 *p21y*p1n1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=43
         fmersg(nume)=ProbLa*pp *p2x*pn11 *p21y*pP1m1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=61
         fmersg(nume)=ProbLa*pp *p21x*pn11 *p21y*pP1m1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=62
         fmersg(nume)=ProbLa*pp *p2x*pn11 *p21y*pP1m1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=63
         fmersg(nume)=ProbLa*pp *p21x*pn11 *p21y*pP1m1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=52
         fmersg(nume)=ProbLa*pp *p21x*pn11 *p21y*p1a1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=91
         fmersg(nume)=ProbLa*pp *p21x*pn11 *p21y*p1a1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=92
          fmersg(nume)=ProbLa*pp *p21x*pn11 *p21y*p1a1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=93
         fmersg(nume)=ProbLa*pp *p21x*pn11 *p21y*p1a1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=53
         fmersg(nume)=ProbLa*pp *p2x*pn11 *p21y*p1c1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=94
         fmersg(nume)=ProbLa*pp *p21x*pn11 *p21y*p1c1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=95
         fmersg(nume)=ProbLa*pp *p2x*pn11 *p21y*p1c1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=96
         fmersg(nume)=ProbLa*pp *p21x*pn11 *p21y*p1c1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=54
         fmersg(nume)=ProbLa*pp *p21x*pn11 *p21y*p1n1 *p21z*pP11m
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=97
         fmersg(nume)=ProbLa*pp *p21x*pn11 *p21y*p1n1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=98
         fmersg(nume)=ProbLa*pp *p21x*pn11 *p21y*p1n1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=1
                     indexx=99
         fmersg(nume)=ProbLa*pp *p21x*pn11 *p21y*p1n1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
!
!-- C lattice
                     indla=4
                     indexx=29
         fmersg(nume)=ProbLa*pc *p21x*pb11 *p21y*p1a1 *p2z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=4
                     indexx=32
         fmersg(nume)=ProbLa*pc *p21x*pb11 *p21y*p1a1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=4
                     indexx=102
         fmersg(nume)=ProbLa*pc *p21x*pb11 *p21y*p1a1 *p2z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=4
                     indexx=42
         fmersg(nume)=ProbLa*pc *p21x*pb11 *p21y*p1ac1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=4
                     indexx=110
         fmersg(nume)=ProbLa*pc *p21x*pb11 *p21y*p1ac1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=4
                     indexx=41
         fmersg(nume)=ProbLa*pc *p21x*pbc11 *p21y*p1a1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=4
                     indexx=109
         fmersg(nume)=ProbLa*pc *p21x*pbc11 *p21y*p1a1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=4
                     indexx=50
         fmersg(nume)=ProbLa*pc *p21x*pbc11 *p21y*p1ac1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=4
                     indexx=111
         fmersg(nume)=ProbLa*pc *p21x*pbc11 *p21y*p1ac1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!-- B lattice
         nume=nume+2
                     indla=3
                     indexx=29
         fmersg(nume)=ProbLa*pb *p21x*pc11 *p2y*p1n1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=3
                     indexx=31
         fmersg(nume)=ProbLa*pb *p21x*pc11 *p21y*p1n1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=3
                     indexx=40
         fmersg(nume)=ProbLa*pb *p21x*pc11 *p21y*p1n1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=3
                     indexx=101
         fmersg(nume)=ProbLa*pb *p21x*pc11 *p2y*p1ac1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=3
                     indexx=107
         fmersg(nume)=ProbLa*pb *p21x*pc11 *p21y*p1ac1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=3
                     indexx=39
         fmersg(nume)=ProbLa*pb *p21x*pbc11 *p21y*p1n1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=3
                     indexx=56
         fmersg(nume)=ProbLa*pb *p21x*pbc11 *p21y*p1n1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=3
                     indexx=106
         fmersg(nume)=ProbLa*pb *p21x*pbc11 *p21y*p1ac1 *p21z*p11a
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=3
                     indexx=108
         fmersg(nume)=ProbLa*pb *p21x*pbc11 *p21y*p1ac1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
!-- A lattice
                     indla=2
                     indexx=29
         fmersg(nume)=ProbLa*pa *p2x*pn11 *p21y*p1c1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=2
                     indexx=30
         fmersg(nume)=ProbLa*pa *p21x*pn11 *p21y*p1c1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=2
                     indexx=38
         fmersg(nume)=ProbLa*pa *p21x*pn11 *p21y*p1c1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=2
                     indexx=37
         fmersg(nume)=ProbLa*pa *p21x*pn11 *p21y*p1ac1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=2
                     indexx=64
         fmersg(nume)=ProbLa*pa *p21x*pn11 *p21y*p1ac1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=2
                     indexx=100
         fmersg(nume)=ProbLa*pa *p2x*pbc11 *p21y*p1c1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=2
                     indexx=104
         fmersg(nume)=ProbLa*pa *p21x*pbc11 *p21y*p1c1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=2
                     indexx=103
         fmersg(nume)=ProbLa*pa *p21x*pbc11 *p21y*p1ac1 *p21z*p11b
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=2
                     indexx=105
         fmersg(nume)=ProbLa*pa *p21x*pbc11 *p21y*p1ac1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!-- I lattice
         nume=nume+2
                     indla=5
                     indexx=29
         fmersg(nume)=ProbLa*pi *p21x*pn11 *p21y*p1n1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=5
                     indexx=102
         fmersg(nume)=ProbLa*pi *p21x*pn11 *p21y*p1n1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=5
                     indexx=101
         fmersg(nume)=ProbLa*pi *p21x*pn11 *p21y*p1ac1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=5
                     indexx=68
         fmersg(nume)=ProbLa*pi *p21x*pn11 *p21y*p1ac1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=5
                     indexx=100
         fmersg(nume)=ProbLa*pi *p21x*pbc11 *p21y*p1n1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=5
                     indexx=58
         fmersg(nume)=ProbLa*pi *p21x*pbc11 *p21y*p1n1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=5
                     indexx=46
         fmersg(nume)=ProbLa*pi *p21x*pbc11 *p21y*p1ac1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=5
                     indexx=76
         fmersg(nume)=ProbLa*pi *p21x*pbc11 *p21y*p1ac1 *p21z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
!-- F lattice
         nume=nume+2
                     indla=6
                     indexx=29
         fmersg(nume)=ProbLa*pf *p21x*pn11 *p21y*p1n1 *p21z*p11n
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=6
                     indexx=120
         fmersg(nume)=ProbLa*pf *p4x*pbc11 *p4y*p1d1 *p4z*p11d
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=6
                     indexx=121
         fmersg(nume)=ProbLa*pf *p4x*pd11 *p4y*p1ac1 *p4z*p11d
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=6
                     indexx=122
         fmersg(nume)=ProbLa*pf *p4x*pd11 *p4y*p1d1 *p4z*p11ab
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
                     indla=6
                     indexx=123
         fmersg(nume)=ProbLa*pf *p4x*pd11 *p4y*p1d1 *p4z*p11d
         nindla(nume/2+1)=indla
         nindexx(nume/2+1)=indexx
         nume=nume+2
!
      mm=msys
      if(neutro.eq.2)mm=indprobs
      xx=Probsys(mm,7)
      do i=num0+1,nume,2
          if(fmersg(i-1).lt.0.)fmersg(i-1)=0.
          if(neutro.eq.2)then  !28apr11
            fmersg(i-1)=ProbLa*(fmersg(i-1)/ProbLa)**xx
          endif
          fmersg(i)=i/2.*100+mm*10+1
          nindlacl(i/2)=indecl
      enddo
      fmerit(num0:nume,icalcpseud+1)=fmersg(num0:nume)
!
      if(numsysEle==kfin.and.icalcpseud.eq.iappl)then
         do kpse=1,iappl+1
           do ii=1,nume-2,2
             i=nint(fmerit(ii+1,kpse))/100
             mm=nint(fmerit(ii+1,kpse))-i*100
             mmsys=mm/10
             jmer=mm-mmsys*10
             if(neutro.eq.2)msysori=probsys(mmsys,6)
             inda =nindla(i)
             indx =nindexx(i)
             indal=nindlacl(i)
             if(neutro.ne.2)then
               symbs(i,1)=lasymb(inda)//exsymb(indx)
               numerosy(i,1)=itabsy(mmsys,inda,indx)
             else
               symbs(i,kpse)=lasymb(inda)//exsymb(indx)
               numerosy(i,kpse)=itabsy(msysori,inda,indx)
               lauelcl1(i,kpse)=lauecl(indal)
               ProbLaue=(ProbSys(mmsys,jmer))**0.5
               xx=ProbSys(mmsys,7) 
               fff= (fmerit(ii,kpse)/ProbSys(mmsys,jmer))**(1/xx) !Extintion Prob.  
             endif 
           enddo
         enddo
         if(neutro.eq.2.and.kprint.gt.0)call stampa_fmerit
         call sort_fmerit(kprint)
!          write(lo,*)' dopo sort_fmerit'
      else 
         if(icalcpseud.eq.0)then
           if(iappl.eq.0)return
           icalcpseud=1
           nume=num0
           if(kprint.gt.1)then
             write(lo,'(a)')' ******************************* '
             write(lo,'(a)')' Correction by Pseudotranslation '
             write(lo,'(a)')' ******************************* '
           endif
         go to 1000
         endif
      endif
      return    
      end
!
!code for msys5
      subroutine msys5(imer)
      USE General, only: lo, neutro, knw
      USE Laue
!      USE PseudoStuff
!
      character*20 symbs, lauelcl1     
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/dummyyy/valmedio(13),loo
      common/dumm3/indla,indexx,numsol,ilegen
      common/fordata0/ nsymbo
      common/fordata/ symbs(2000,2),fmerit(2000,2),numerosy(2000,2)
     1,lauelcl1(2000,2)
      common/dummfm/fmer1,knm
      common/dummyret/tab2ret(13,8,6),tabret(13,8,6),tabnewret(13,8)
!      common /pseudotras/ nkk,mpseud(12,74),numps(74),perctab(13,8)
!     *                    ,perce(74),jpseud(74)
      common /pseudoappl/iapplpse(74),iappl,perctab(13,8)
!
      common/probLaEle/numsysEle,RintSys(9,6),ProbSys(9,7),kfin,indprobs
     1,corrfattProb(9),ProbLsav(5),nomonoclino
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!--ci sono tutte le classi presenti??
!      Jcompleto=1
!      if(ncont(10)==0.or.ncont(8)==0.or.ncont(7)==0.or.
!     1   ncont(6)==0.or.ncont(4)==0.or.ncont(2)==0.or.
!     1   ncont(1)==0)then
!         Jcompleto=0
!         if(imer.eq.nclassla)write(lo,*)
!     1    "Extinction Groups Probability for Tetragonal Laue Classes ",
!     1    " can't be calculated (missing reflection class)"
!         return    
!       endif    
!
      kprint=1   
      icalcpseud=0
      indecl=imer
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!Tetragonale,calcolo delle probabilita' .      Subroutine msys5
!lungo c:p4z=Prob del 4 ; p4211=p211;p4111=Prob del 41
!lungo a: p2x=Prob del 2     ; p121=Prob del 21;
!lungo diag.:  p2d=Prob del 2; p112=Prob del 21;
!                       Laue  Latt    asse c     asse a      diag.                     
!P---     fmersg(nume)=ProbLa* pp  *p4z*pm11   *p2x*p1m1   *p2d*p11m 
!P-21-    fmersg(nume)=ProbLa* pp  *p4z*pm11   *p121*p1m1  *p2d*p11m 
!P42--    fmersg(nume)=ProbLa* pp  *p4211*pm11 *p2x*p1m1   *p2d*p11m 
!P42 21-  fmersg(nume)=ProbLa* pp  *p4211*pm11 *p121*p1m1  *p2d*p11m 
!P41--    fmersg(nume)=ProbLa* pp  *p4111*pm11 *p2x*p1m1   *p2d*p11m 
!P41 21-  fmersg(nume)=ProbLa* pp  *p4111*pm11 *p121*p1m1  *p2d*p11m 
!P--c     fmersg(nume)=ProbLa* pp  *p4211*pm11 *p2x*p1m1   *p2d*p11c 
!P-21c    fmersg(nume)=ProbLa* pp  *p4211*pm11 *p121*p1m1  *p2d*p11c 
!P-b-     fmersg(nume)=ProbLa* pp  *p4z*pm11   *p121*p1b1  *p2d*p11m 
!P-bc     fmersg(nume)=ProbLa* pp *p4211*pm11  *p121*p1b1  *p2d*p11c 
!P-c-     fmersg(nume)=ProbLa* pp *p4211*pm11  *p2x*p1c1   *p2d*p11m 
!P-cc     fmersg(nume)=ProbLa* pp *p4211*pm11  *p2x*p1c1   *p2d*p11c 
!P-n-     fmersg(nume)=ProbLa* pp *p4211*pm11  *p121*p1n1  *p2d*p11m 
!P-nc     fmersg(nume)=ProbLa* pp *p4211*pm11  *p121*p1n1  *p2d*p11c 
!Pn--     fmersg(nume)=ProbLa* pp *p4z*pn11    *p121*p1m1  *p2d*p11m 
!P42/n--  fmersg(nume)=ProbLa* pp *p4211*pn11  *p121*p1m1  *p2d*p11m 
!Pn-c     fmersg(nume)=ProbLa* pp *p4211*pn11  *p121*p1m1  *p2d*p11c 
!Pnb-     fmersg(nume)=ProbLa* pp *p4z*pn11    *p121*p1b1  *p2d*p11m 
!Pnbc     fmersg(nume)=ProbLa* pp *p4211*pn11  *p121*p1b1  *p2d*p11c 
!Pnc-     fmersg(nume)=ProbLa* pp *p4211*pn11  *p121*p1c1  *p2d*p11m 
!Pncc     fmersg(nume)=ProbLa* pp *p4211*pn11  *p121*p1c1  *p2d*p11c 
!Pnn-     fmersg(nume)=ProbLa* pp *p4211*pn11  *p121*p1n1  *p2d*p11m 
!Pnnc     fmersg(nume)=ProbLa* pp *p4211*pn11  *p121*p1n1  *p2d*p11c 
!I---     fmersg(nume)=ProbLa* pi *p4211*pn11  *p121*p1n1  *p2d*p11c 
!I41--    fmersg(nume)=ProbLa* pi *p4111*pn11  *p121*p1n1  *p2d*p11c 
!I--d     fmersg(nume)=ProbLa* pi *p4111*pn11  *p121*p1n1  *p112*p11d 
!I-c-     fmersg(nume)=ProbLa* pi *p4211*pn11  *p121*p1bc1 *p2d*p11c 
!I-cd     fmersg(nume)=ProbLa* pi *p4111*pn11  *p121*p1bc1 *p112*p11d 
!I41/a--  fmersg(nume)=ProbLa* pi *p4111*pa11  *p121*p1n1  *p2d*p11c 
!Ia-d     fmersg(nume)=ProbLa* pi *p4111*pa11  *p121*p1n1  *p112*p11d 
!Iacd     fmersg(nume)=ProbLa* pi *p4111*pa11  *p121*p1bc1 *p112*p11d 
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!-hkl     
      si   =tabnew(7,4)
      if(si.gt.0.9)si=0.9
      if(neutro.ne.2.and.si.lt.0.1)si=0.1
      pi=1-si
      p0i=pi
      pi=applcorEsure(7,4,pi,0.)     !23nov10
!
      pp=1-pi
      if(neutro.ne.2.and.pp.lt.0.1)pp=0.1

!
!-00l
      s211 =tab(1,1,5) 
      if(s211.lt.0.1)s211=0.1
      if(neutro.eq.2)s211 =tabnew(1,1) 
      if(s211.gt.0.9)s211=0.9
      if(s211.ge.0.6)then
            if(tab2(1,1,5).gt.3.5*s211)s211=0.50
            if(tab2(1,1,5).gt.4.0*s211)s211=0.40
      endif
      p211=1-s211
      p4211=pcorr21(1,1,p211)
      p4211=applcorEsure(1,1,p4211,0.)
!
      s411 =tab(1,2,5) 
      if(s411.lt.0.1)s411=0.1
      if(neutro.eq.2)s411 =tabnew(1,2) 
      if(s411.gt.0.9)s411=0.9
      if(s411.ge.0.6)then
            if(tab2(1,2,5).gt.3.5*s411)s411=0.50
            if(tab2(1,2,5).gt.4.0*s411)s411=0.40
      endif
      p411=1-s411
      p4111=pcorr21(1,2,p411)
      p4111=applcorEsure(1,2,p4111,0.)
      call corrprob(p4211,p4111,1,1,1,2)
!-0k0 = h00
      keh=2
      if(ncont(2)==0)keh=3
      s121 =tab(keh,1,5) 
      if(s121.lt.0.1)s121=0.1
      if(neutro.eq.2)s121 =tabnew(keh,1) 
      if(s121.gt.0.9)s121=0.9
      if(s121.ge.0.6)then
            if(tab2(keh,1,5).gt.3.5*s121)s121=0.50
            if(tab2(keh,1,5).gt.4.0*s121)s121=0.40
      endif
      p121=1-s121
      p121=pcorr21(keh,1,p121)
      p121=applcorEsure(keh,1,p121,0.)
!
!-hh0
      s112 =tab(8,1,5)
      if(s112.lt.0.1)s112=0.1
      if(neutro.eq.2)s112 =tabnew(8,1)
      if(s112.gt.0.9)s112=0.9
      if(s112.ge.0.6)then
            if(tab2(8,1,5).gt.3.5*s112)s112=0.50
            if(tab2(8,1,5).gt.4.0*s112)s112=0.40
      endif
      p112=1-s112
      p112=pcorr21(8,1,p112)
!
!-hk0
      sa11 =tabnew(6,3) 
      sn11 =tabnew(6,4)
      if(sn11.gt.0.9)sn11=0.9
      if(sa11.gt.0.9)sa11=0.9
      if(neutro.ne.2)then 
      if(sn11.lt.0.1)sn11=0.1
      if(sa11.lt.0.1)sa11=0.1
      endif
!
      pa11=1-sa11
      pa11=applcorEsure(6,3,pa11,0.)
      pn11=1-sn11
      pn11ori=pn11
      pn11=applcorEsure(6,4,pn11,p0i)


!-0kl
      s1b1 =tabnew(4,1) 
      s1c1 =tabnew(4,2) 
      s1bc1=tabnew(4,3) 
      s1n1 =tabnew(4,4)
      if(s1b1.gt.0.9)s1b1=0.9
      if(s1c1.gt.0.9)s1c1=0.9
      if(s1bc1.gt.0.9)s1bc1=0.9
      if(s1n1.gt.0.9)s1n1=0.9
      if(neutro.ne.2)then 
      if(s1b1.lt.0.1)s1b1=0.1
      if(s1c1.lt.0.1)s1c1=0.1
      if(s1bc1.lt.0.1)s1bc1=0.1
      if(s1n1.lt.0.1)s1n1=0.1
      endif
!
      p1b1=1-s1b1
      p1b1=applcorEsure(4,1,p1b1,0.)
      p1c1=1-s1c1
      p1c1=applcorEsure(4,2,p1c1,0.)
      p1bc1=1-s1bc1
      p1bc1=applcorEsure(4,3,p1bc1,0.)
      p1n1=1-s1n1
      p1n1ori=p1n1
      p1n1=applcorEsure(4,4,p1n1,p0i)
!-hhl
      s11c =tabnew(10,1) 
      s11d =tabnew(10,2)
      if(s11c.gt.0.9)s11c=0.9
      if(s11d.gt.0.9)s11d=0.9
      if(neutro.ne.2)then 
      if(s11c.lt.0.1)s11c=0.1
      if(s11d.lt.0.1)s11d=0.1
      endif
!
      p11c=1-s11c
      p11c=applcorEsure(10,1,p11c,p0i)
!
      p11d=1-s11d
      p11d=applcorEsure(10,2,p11d,0.)

!-- setta a 0.5 la prob. per gli elementi di classi mancanti
      if(neutro==2)then
         if(ncont(  1)==0.or.tab2(  1,1,1)==0)p211 =0.5
         if(ncont(  1)==0.or.tab2(  1,1,1)==0)p4211=0.5
         if(ncont(  1)==0.or.tab2(  1,2,1)==0)p4111=0.5
         if(ncont(keh)==0.or.tab2(keh,1,1)==0)p121 =0.5
         if(ncont(  8)==0.or.tab2(  8,1,1)==0)p112 =0.5
         if(ncont(  6)==0.or.tab2(  6,3,1)==0)pa11 =0.5
         if(ncont(  6)==0.or.tab2(  6,4,1)==0)pn11 =0.5
         if(ncont(  4)==0.or.tab2(  4,1,1)==0)p1b1 =0.5
         if(ncont(  4)==0.or.tab2(  4,2,1)==0)p1c1 =0.5
         if(ncont(  4)==0.or.tab2(  4,3,1)==0)p1bc1=0.5
         if(ncont(  4)==0.or.tab2(  4,4,1)==0)p1n1 =0.5
         if(ncont( 10)==0.or.tab2( 10,1,1)==0)p11c =0.5
         if(ncont( 10)==0.or.tab2( 10,2,1)==0)p11d =0.5
      endif
!
!
         pm11=1-pn11
         if(neutro.ne.2.and.pm11.lt.0.1)pm11=0.1
         p1m1=1-amax1(p1b1,p1c1,p1n1)
         if(neutro.ne.2.and.p1m1.lt.0.1)p1m1=0.1
         p11m=1-p11c
         if(neutro.ne.2.and.p11m.lt.0.1)p11m=0.1
!
         p4z=1-amax1(p4211,p4111)
         if(neutro.ne.2.and.p4z.lt.0.1)p4z=0.1
         p21x=p121
         p2x=1-p121
         if(neutro.ne.2.and.p2x.lt.0.1)p2x=0.1
         p2d=1-p112
         if(neutro.ne.2.and.p2d.lt.0.1)p2d=0.1

!
      if(kprint.eq.1)then
      write(lo,'(a,5f6.3)')'pp,p0i,pi ',pp,p0i,pi
      write(lo,*)''
      write(lo,'(a,5f6.3)')'p4211,p4111,p4z ',p4211,p4111,p4z
      write(lo,'(a,5f6.3)')'p121,p2x        ',p121,p2x
      write(lo,'(a,5f6.3)')'p112,p2d        ',p112,p2d
      write(lo,*)''
      write(lo,'(a,5f6.3)')'pa11,pn11ori,pn11,pm11            '
     1,pa11,pn11ori,pn11,pm11
      write(lo,'(a,6f6.3)')'p1b1,p1c1,p1bc1,p1n1ori,p1n1,p1m1 ',
     1 p1b1,p1c1,p1bc1,p1n1ori,p1n1,p1m1 
      write(lo,'(a,5f6.3)')'p11c,p11d,p11m                    ',
     1 p11c,p11d,p11m
!       write(lo ,'(a)')' Esure      ',
!     1'1       2       3       4       5       6      7      8'
!       write(lo,'(a)')'nEsure      ',
!     1'1       2       3       4       5       6      7      8'
!       do kk=1,13
!       write(lo,'(i6,8f8.2)')kk,(Esure(kk,kkk),kkk=1,8)
!       write(lo,'(i6,8i8)')kk,(nEsure(kk,kkk),kkk=1,8)
!       enddo
       endif
!
!-------------------------------------------------------
1000  continue
!-------------------------------------------------------
!-- nel secondo passaggio applica le pseudot.
!
      if(icalcpseud.eq.1)then
         pi=pi*perctab(7,4)
         if(neutro.ne.2.and.pi.lt.0.1)pi=0.1
         pp=1-pi
         if(neutro.ne.2.and.pp.lt.0.1)pp=0.1
!
         pa11=pa11*perctab(6,3)
         pn11=pn11*perctab(6,4)
         p1b1=p1b1*perctab(4,1)
         p1c1=p1c1*perctab(4,2)
         p1bc1=p1bc1*perctab(4,3)
         p1n1=p1n1*perctab(4,4)
         if(neutro.ne.2)then
         if(pa11.lt.0.1)pa11=0.1
         if(pn11.lt.0.1)pn11=0.1
         if(p1b1.lt.0.1)p1b1=0.1
         if(p1c1.lt.0.1)p1c1=0.1
         if(p1bc1.lt.0.1)p1bc1=0.1
         if(p1n1.lt.0.1)p1n1=0.1
         endif
!
         p11c=p11c*perctab(10,1)
         p11d=p11d*perctab(10,2)
         if(neutro.ne.2)then
         if(p11c.lt.0.1)p11c=0.1
         if(p11d.lt.0.1)p11d=0.1
         endif
!
         p4111=p4111*perctab(1,2)
         p4211=p4211*perctab(1,1)
         p121=p121*perctab(2,1)
         p112=p112*perctab(8,1)
         if(neutro.ne.2)then
         if(p121.lt.0.1)p121=0.1
         if(p4111.lt.0.1)p4111=0.1
         if(p4211.lt.0.1)p4211=0.1
         if(p112.lt.0.1)p112=0.1
         endif
!
!-- setta a 0.5 la prob. per gli elementi di classi mancanti
      if(neutro==2)then
         if(ncont(  1)==0.or.tab2(  1,1,1)==0)p211 =0.5
         if(ncont(  1)==0.or.tab2(  1,1,1)==0)p4211=0.5
         if(ncont(  1)==0.or.tab2(  1,2,1)==0)p4111=0.5
         if(ncont(keh)==0.or.tab2(keh,1,1)==0)p121 =0.5
         if(ncont(  8)==0.or.tab2(  8,1,1)==0)p112 =0.5
         if(ncont(  4)==0.or.tab2(  4,1,1)==0)p1b1 =0.5
         if(ncont(  6)==0.or.tab2(  6,3,1)==0)pa11 =0.5
         if(ncont(  6)==0.or.tab2(  6,4,1)==0)pn11 =0.5
         if(ncont(  4)==0.or.tab2(  4,2,1)==0)p1c1 =0.5
         if(ncont(  4)==0.or.tab2(  4,3,1)==0)p1bc1=0.5
         if(ncont(  4)==0.or.tab2(  4,4,1)==0)p1n1 =0.5
         if(ncont( 10)==0.or.tab2( 10,1,1)==0)p11c =0.5
         if(ncont( 10)==0.or.tab2( 10,2,1)==0)p11d =0.5
      endif
!
         pm11=1-pn11
         if(neutro.ne.2.and.pm11.lt.0.1)pm11=0.1
         p1m1=1-amax1(p1b1,p1c1,p1n1)
         if(neutro.ne.2.and.p1m1.lt.0.1)p1m1=0.1
         p11m=1-p11c
         if(neutro.ne.2.and.p11m.lt.0.1)p11m=0.1
!
         p4z=1-amax1(p4211,p4111)
         if(neutro.ne.2.and.p4z.lt.0.1)p4z=0.1
         p2x=1-p121
         if(neutro.ne.2.and.p2x.lt.0.1)p2x=0.1
         p2d=1-p112
         if(neutro.ne.2.and.p2d.lt.0.1)p2d=0.1

      if(kprint.eq.1)then
      write(lo,*) 'dopo applicata la pseudot. '
      write(lo,'(a,5f6.3)')'pp,pi ',pp,pi
      write(lo,'(a,5f6.3)')'p4211,p4111,p4z ',p4211,p4111,p4z
      write(lo,'(a,5f6.3)')'p121,p2x ',p121,p2x
      write(lo,'(a,5f6.3)')'p112,p2d ',p112,p2d
      write(lo,'(a,5f6.3)')'pa11,pn11,pm11 ',pa11,pn11,pm11
      write(lo,'(a,5f6.3)')'p1b1,p1c1,p1bc1,p1n1,p1m1 ',
     1 p1b1,p1c1,p1bc1,p1n1,p1m1 
      write(lo,'(a,5f6.3)')'p11c,p11d,p11m ',
     1 p11c,p11d,p11m
      endif
!
      endif
!-------------------------------------------------------
!
!
!         nume=1
!         nume2=1
         num0=nume
         nume2=1+nume/2
                     indla=1
                     indexx=29
         fmersg(nume)=ProbLa*pp *p4z*pm11 *p2x*p1m1 *p2d*p11m 
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
!         write(lo,*)'nume,nume2,fmersg(nume),fmersg(nume+1),nindla(nume2)',
!     1   ',nindexx(nume2)',
!     1   nume,nume2,fmersg(nume),fmersg(nume+1),nindla(nume2)
!     1   ,nindexx(nume2)
         nume=nume+2
         nume2=nume2+1
!imer              if(imer.ne.1)then
                     indla=1
                     indexx=31
         fmersg(nume)=ProbLa*pp  *p4z*pm11  *p121*p1m1  *p2d*p11m 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer              endif
                     indla=1
                     indexx=114
         fmersg(nume)=ProbLa*pp  *p4211*pm11  *p2x*p1m1 *p2d*p11m 
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer              if(imer.ne.1)then
                     indla=1
                     indexx=147
         fmersg(nume)=ProbLa*pp  *p4211*pm11  *p121*p1m1  *p2d*p11m 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer              endif
                     indla=1
                     indexx=113
         fmersg(nume)=ProbLa*pp  *p4111*pm11  *p2x*p1m1  *p2d*p11m 
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer              if(imer.ne.1)then
                     indla=1
                     indexx=146
         fmersg(nume)=ProbLa*pp  *p4111*pm11  *p121*p1m1 *p2d*p11m 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=145
         fmersg(nume)=ProbLa*pp  *p4211*pm11  *p2x*p1m1  *p2d*p11c 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=144
         fmersg(nume)=ProbLa*pp  *p4211*pm11  *p121*p1m1  *p2d*p11c 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=143
         fmersg(nume)=ProbLa*pp  *p4z*pm11  *p121*p1b1  *p2d*p11m 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=142
         fmersg(nume)=ProbLa*pp *p4211*pm11 *p121*p1b1 *p2d*p11c 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=42
         fmersg(nume)=ProbLa*pp *p4211*pm11 *p2x*p1c1 *p2d*p11m 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=141
         fmersg(nume)=ProbLa*pp *p4211*pm11 *p2x*p1c1 *p2d*p11c 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=44
         fmersg(nume)=ProbLa*pp *p4211*pm11 *p121*p1n1 *p2d*p11m 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=140
         fmersg(nume)=ProbLa*pp *p4211*pm11 *p121*p1n1 *p2d*p11c 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer              endif
                     indla=1
                     indexx=43
         fmersg(nume)=ProbLa*pp *p4z*pn11 *p121*p1m1 *p2d*p11m 
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer              if(imer.ne.2)then
                     indla=1
                     indexx=117
         fmersg(nume)=ProbLa*pp *p4211*pn11 *p121*p1m1 *p2d*p11m 
         if(imer.eq.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer              endif
                     indla=1
                     indexx=139
!imer              if(imer.ne.1)then
         fmersg(nume)=ProbLa*pp *p4211*pn11 *p121*p1m1 *p2d*p11c 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=138
         fmersg(nume)=ProbLa*pp *p4z*pn11 *p121*p1b1 *p2d*p11m 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=137
         fmersg(nume)=ProbLa*pp *p4211*pn11 *p121*p1b1 *p2d*p11c 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=53
         fmersg(nume)=ProbLa*pp *p4211*pn11 *p121*p1c1 *p2d*p11m 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=136
         fmersg(nume)=ProbLa*pp *p4211*pn11 *p121*p1c1 *p2d*p11c 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=54
         fmersg(nume)=ProbLa*pp *p4211*pn11 *p121*p1n1 *p2d*p11m 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=135
         fmersg(nume)=ProbLa*pp *p4211*pn11 *p121*p1n1 *p2d*p11c 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer              endif
!-------------------------------------------------------
!
                     indla=5
                     indexx=29
         fmersg(nume)=ProbLa*pi *p4211*pn11 *p121*p1n1 *p2d*p11c 
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=5
                     indexx=113
         fmersg(nume)=ProbLa*pi *p4111*pn11 *p121*p1n1 *p2d*p11c 
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=5
                     indexx=119
!imer              if(imer.ne.1)then
         fmersg(nume)=ProbLa*pi *p4111*pn11 *p121*p1n1 *p112*p11d 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=5
                     indexx=42
         fmersg(nume)=ProbLa*pi *p4211*pn11 *p121*p1bc1 *p2d*p11c 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
!         write(lo,*)'nume,nume2,fmersg(nume),fmersg(nume+1),nindla(nume2)'
!     1   ,',nindexx(nume2)',
!     1   nume,nume2,fmersg(nume),fmersg(nume+1),nindla(nume2)
!     1   ,nindexx(nume2)
         nume=nume+2
         nume2=nume2+1
                     indla=5
                     indexx=125
         fmersg(nume)=ProbLa*pi *p4111*pn11 *p121*p1bc1 *p112*p11d 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer              endif
!imer              if(imer.ne.2)then
                     indla=5
                     indexx=118
         fmersg(nume)=ProbLa*pi *p4111*pa11 *p121*p1n1 *p2d*p11c 
         if(imer.eq.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer              endif
!imer              if(imer.ne.1)then
                     indla=5
                     indexx=124
         fmersg(nume)=ProbLa*pi *p4111*pa11 *p121*p1n1 *p112*p11d 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=5
                     indexx=126
         fmersg(nume)=ProbLa*pi *p4111*pa11 *p121*p1bc1 *p112*p11d 
         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
!imer              endif
!         write(lo,*)'nume,nume2 ',nume,nume2 
!         write(lo,*)'nume2 nindla()',nume2,(nindla(i),i=1,nume2) 
!         write(lo,*)'nume2 nindexx()',nume2,(nindexx(i),i=1,nume2) 
!
!
      mm=msys
      if(neutro.eq.2)mm=indprobs
      xx=Probsys(mm,7)
      if (knw > 0) write(lo,*)'mm,xx ',mm,xx
      do i=num0+1,nume,2
          if(fmersg(i-1).lt.0.)fmersg(i-1)=0.
          if(neutro.eq.2)then  !28apr11
             fmersg(i-1)=ProbLa*(fmersg(i-1)/ProbLa)**xx
          endif
          fmersg(i)=i/2*100+mm*10+1
          nindlacl(i/2)=indecl
      enddo
      fmerit(num0:nume,icalcpseud+1)=fmersg(num0:nume)
!
      if(numsysEle==kfin.and.icalcpseud.eq.iappl)then
         do kpse=1,iappl+1
           do ii=1,nume-2,2
             i=nint(fmerit(ii+1,kpse))/100
             mm=nint(fmerit(ii+1,kpse))-i*100
             mmsys=mm/10
             jmer=mm-mmsys*10
             if(neutro.eq.2)msysori=probsys(mmsys,6)
             inda =nindla(i)
             indx =nindexx(i)
             indal=nindlacl(i)
             if(neutro.ne.2)then
               symbs(i,1)=lasymb(inda)//exsymb(indx)
               numerosy(i,1)=itabsy(mmsys,inda,indx)
             else
               symbs(i,kpse)=lasymb(inda)//exsymb(indx)
               numerosy(i,kpse)=itabsy(msysori,inda,indx)
               lauelcl1(i,kpse)=lauecl(indal)
               ProbLaue=(ProbSys(mmsys,jmer))**0.5
               xx=ProbSys(mmsys,7) 
               fff= (fmerit(ii,kpse)/ProbSys(mmsys,jmer))**(1/xx) !Extintion Prob.  
             endif 
           enddo
         enddo
         if(kprint.eq.1)call stampa_fmerit
         call sort_fmerit(kprint)
      else 
         if(icalcpseud.eq.0)then
           if(iappl.eq.0)return
           icalcpseud=1
           nume=num0
           if(kprint.eq.1)then
             write(lo,'(a)')' ******************************* '
             write(lo,'(a)')' Correction by Pseudotranslation '
             write(lo,'(a)')' ******************************* '
           endif
         go to 1000
         endif
      endif
      return
      end
!
!code for msys6
      subroutine msys6(imer)
      USE General, only: lo, neutro, knw
      USE Laue
!      USE PseudoStuff
!
      character*20 symbs, lauelcl1     
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/dummyyy/valmedio(13),loo
      common/dumm3/indla,indexx,numsol,ilegen
      common/fordata0/ nsymbo
      common/fordata/ symbs(2000,2),fmerit(2000,2),numerosy(2000,2)
     1,lauelcl1(2000,2)
!      common /pseudotras/ nkk,mpseud(12,74),numps(74),perctab(13,8)
!     *                    ,perce(74),jpseud(74)
      common /pseudoappl/iapplpse(74),iappl,perctab(13,8)
      common/dummyret/tab2ret(13,8,6),tabret(13,8,6),tabnewret(13,8)
      common/dummfm/fmer1,knm
!
      common/probLaEle/numsysEle,RintSys(9,6),ProbSys(9,7),kfin,indprobs
     1,corrfattProb(9),ProbLsav(5),nomonoclino
!
!--ci sono tutte le classi presenti??
!      Jcompleto=1
!      if(ncont(10)==0.or.ncont(9)==0.or.ncont(7)==0.or.
!     1   ncont(1)==0)then
!         Jcompleto=0
!         if(imer.eq.nclassla)write(lo,*)
!     1    "Extinction Groups Probability for Hexagonal Laue Classes ",
!     1    " can't be calculated (missing reflection class)"
!         return    
!       endif    
!
      icalcpseud=0
      kprint=1
      kprint=0
      indecl=imer+2
!
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!Esagonale,calcolo delle probabilita' .      Subroutine msys6
!lungo l'asse(00l)  :p3111=Prob.del 31 ;p6311=Prob. del 63;
!                    p6111=Prob.del 61; p3c=Prob. del 3 
!
!piano diag.(h,-h,l):p1m1=Prob del m; p1c1=Prob del c;
!                    p92=Prob per (h+l#3n)
!                    p93=Prob per diverso da (l=2n,h+l=3n);
!                    p94=Prob per -h+l#3n
!                    p95=Prob.per diverso da l=2n,-h+l=3n)
!
!piano diag (hhl)   :p11m: prob. del m; p11c=Prob per (l#2n);
!                    p103=Prob (l#3n) 
!         fmersg(nume)=ProbLa*pp*p3c*p1m1*p11m       !P---
!         fmersg(nume)=ProbLa*pp*p3111*p1m1*p11m     !P31--     
!         fmersg(nume)=ProbLa*pp*p6311*p1m1*p11m     !P63--  
!         fmersg(nume)=ProbLa*pp*p3111*p1m1*p11m     !P62--  
!         fmersg(nume)=ProbLa*pp*p6111*p1m1*p11m     !P61--  
!         fmersg(nume)=ProbLa*pp*p6311*p1m1*p11c     !P--c  
!         fmersg(nume)=ProbLa*pp*p6311*p1c1*p11m     !P-c-  
!         fmersg(nume)=ProbLa*pp*p6311*p1c1*p11c     !P-cc  
!         fmersg(nume)=ProbLa*pro*p3111*p92*p103     !R(obv)--  
!         fmersg(nume)=ProbLa*pro*p6111*p93*p103     !R(obv)-c 
!         fmersg(nume)=ProbLa*prr*p3111*p94*p103     !R(rev)--
!         fmersg(nume)=ProbLa*prr*p6111*p95*p103     !R(rev)-c
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
!
!
      sro=tabnew(7,6)
      srr=tabnew(7,7)
      if(sro.gt.1.)sro=1.0
      if(srr.gt.1.)srr=1.0
      if(sro.gt.0.9)sro=0.9
      if(srr.gt.0.9)srr=0.9
      if(neutro.ne.2)then
      if(sro.lt.0.1)sro=0.1
      if(srr.lt.0.1)srr=0.1
      endif
      pro=1-sro
      proori=pro
      pro=applcorEsure(7,6,pro,0.)
      prr=1-srr
      prrori=prr
      prr=applcorEsure(7,6,prr,0.)
      pp=1-amax1(pro,prr)
      if(neutro.ne.2.and.pp.lt.0.1)pp=0.1
!-000l
      s3111=tab(1,3,5)              
      if(s3111.lt.0.1)s3111=0.1
      if(neutro.eq.2)s3111=tabnew(1,3)             !l#3n
      if(s3111.gt.0.9)s3111=0.9
      if(s3111.ge.0.6)then
            if(tab2(1,3,5).gt.3.5*s3111)s3111=0.50    !tab2 i non estinti
            if(tab2(1,3,5).gt.4.0*s3111)s3111=0.40
      endif
!
      s6111=tab(1,4,5)                
      if(s6111.lt.0.1)s6111=0.1
      if(neutro.eq.2)s6111=tabnew(1,4)             !l#6n
      if(s6111.gt.0.9)s6111=0.9
      if(s6111.ge.0.6)then
         if(tab2(1,4,5).gt.3.5*s6111)s6111=0.50
         if(tab2(1,4,5).gt.4.0*s6111)s6111=0.40
      endif
!
      s6311=tab(1,1,5) 
      if(s6311.lt.0.1)s6311=0.1
      if(neutro.eq.2)s6311=tabnew(1,1)             !l#2n
      if(s6311.gt.0.9)s6311=0.9
      if(s6311.ge.0.6)then
            if(tab2(1,1,5).gt.3.5*s6311)s6311=0.50
            if(tab2(1,1,5).gt.4.0*s6311)s6311=0.40
      endif
      p3111=1-s3111
      p6111=1-s6111
      p6311=1-s6311
         p3111=pcorr21(1,3,p3111)
         p6111=pcorr21(1,4,p6111)
         p6311=pcorr21(1,1,p6311)
      p3111ori=p3111
      p6111ori=p6111
      p6311ori=p6311
         p3111=applcorEsure(1,3,p3111,0.)
         p6111=applcorEsure(1,4,p6111,0.)
         p6311=applcorEsure(1,1,p6311,0.)
!
      call corrprob(p6311,p6111,1,1,1,4)
      call corrprob(p3111,p6111,1,3,1,4)
!
      s1c1=tabnew(9,1)             !(h,-h,l), l#2n 
      if(s1c1.gt.0.9)s1c1=0.9
      if(neutro.ne.2.and.s1c1.lt.0.1)s1c1=0.1
      p1c1=1-s1c1
      p1c1ori=p1c1
      p1c1=applcorEsure(9,1,p1c1,0.)
!
      s11c=tabnew(10,1)            !(h,h,l), l#2n
      if(s11c.gt.0.9)s11c=0.9
      if(neutro.ne.2.and.s11c.lt.0.1)s11c=0.1
      p11c=1-s11c
      p11cori=p11c
      p11c=applcorEsure(10,1,p11c,0.)
!
      s92=tabnew(9,2)              !(h,-h,l), h+l#3n  
      if(s92.gt.0.9)s92=0.9
      if(neutro.ne.2.and.s92.lt.0.1)s92=0.1
!
      s93=tabnew(9,3)              !(h,-h,l), diverso da (l=2n,h+l=3n) 
      if(s93.gt.0.9)s93=0.9
      if(neutro.ne.2.and.s93.lt.0.1)s93=0.1
!
      s94=tabnew(9,4)              !(h,-h,l),-h+l#3n 
      if(s94.gt.0.9)s94=0.9
      if(neutro.ne.2.and.s94.lt.0.1)s94=0.1
!
      s95=tabnew(9,5)               !(h,-h,l), diverso da (l=2n,-h+l=3n)
      if(s95.gt.0.9)s95=0.9
      if(neutro.ne.2.and.s95.lt.0.1)s95=0.1
!
      s103=tabnew(10,3)              !(h,h,l), l#3n             
      if(s103.gt.0.9)s103=0.9
      if(neutro.ne.2.and.s103.lt.0.1)s103=0.1
      p92=1-s92
      p93=1-s93
      p94=1-s94
      p95=1-s95
      p103=1-s103
      p92ori=p92
      p93ori=p93
      p94ori=p94
      p95ori=p95
      p103ori=p103
         p92=applcorEsure(9,2,p92,0.)
         p93=applcorEsure(9,3,p93,0.)
         p94=applcorEsure(9,4,p94,0.)
         p95=applcorEsure(9,5,p95,0.)
         p103=applcorEsure(10,3,p103,0.)
!
!-- setta a 0.5 la prob. per gli elementi di classi mancanti
      if(neutro==2)then
         if(ncont( 1)==0.or.tab2( 1,3,1)==0)p3111 =0.5
         if(ncont( 1)==0.or.tab2( 1,4,1)==0)p6111 =0.5
         if(ncont( 1)==0.or.tab2( 1,1,1)==0)p6311 =0.5
         if(ncont( 6)==0.or.tab2( 6,3,1)==0)pa11=0.5
         if(ncont( 6)==0.or.tab2( 6,4,1)==0)pn11=0.5
         if(ncont( 9)==0.or.tab2( 9,1,1)==0)p1c1  =0.5
         if(ncont( 9)==0.or.tab2( 9,2,1)==0)p92   =0.5
         if(ncont( 9)==0.or.tab2( 9,3,1)==0)p93   =0.5
         if(ncont( 9)==0.or.tab2( 9,4,1)==0)p94   =0.5
         if(ncont( 9)==0.or.tab2( 9,5,1)==0)p95   =0.5
         if(ncont(10)==0.or.tab2(10,1,1)==0)p11c  =0.5
         if(ncont(10)==0.or.tab2(10,3,1)==0)p103  =0.5
      endif
!
      p3c=1-amax1(p3111,p6111,p6311)    !asse 3 
      p11m=1-p11c
      p1m1=1-p1c1
      if(neutro.ne.2)then
      if(p3c.lt.0.1)p3c=0.1
      if(p11m.lt.0.1)p11m=0.1
      if(p1m1.lt.0.1)p1m1=0.1
      endif
!
      if(kprint.eq.1)then
      write(lo,*)'ori:  pro,prr   ',proori,prrori
      write(lo,*)'corr: pro,prr,pp',pro,prr,pp
      write(lo,*)'ori :p3111,p6111,p6311    ',
     1 p3111ori,p6111ori,p6311ori
      write(lo,*)'corr: p3111,p6111,p6311,p3c',
     1 p3111,p6111,p6311,p3c
      write(lo,*)'ori :p1c1,p11c          ',
     1 p1c1ori,p11cori
      write(lo,*)'corr:p1c1,p1m1,p11c,p11m',
     1 p1c1,p1m1,p11c,p11m
      write(lo,*)'ori :p92,p93,p94,p95,p103'
     1,p92ori,p93ori,p94ori,p95ori,p103ori
      write(lo,*)'corr:p92,p93,p94,p95,p103',p92,p93,p94,p95,p103
      endif
!
1000  continue
!
!----------------------------------------------------------------------
!-- nel secondo passaggio applica le pseudot.
!
      if(icalcpseud.eq.1)then
      pro=pro*perctab(7,6)
      if(neutro.ne.2.and.pro.lt.0.1)pro=0.1
      prr=prr*perctab(7,7)
      if(neutro.ne.2.and.prr.lt.0.1)prr=0.1
      pp=1-amax1(pro,prr)
      if(neutro.ne.2.and.pp.lt.0.1)pp=0.1
      p3111=p3111*perctab(1,3)
      if(neutro.ne.2.and.p3111.lt.0.1)p3111=0.1
      p6111=p6111*perctab(1,4)
      if(neutro.ne.2.and.p6111.lt.0.1)p6111=0.1
      p6311=p6311*perctab(1,1)
      if(neutro.ne.2.and.p6311.lt.0.1)p6311=0.1
      p1c1=p1c1*perctab(9,1)
      if(neutro.ne.2.and.p1c1.lt.0.1)p1c1=0.1
      p11c=p11c*perctab(10,1)
      if(neutro.ne.2.and.p11c.lt.0.1)p11c=0.1
      p92=p92*perctab(9,2)
      if(neutro.ne.2.and.p92.lt.0.1)p92=0.1
      p93=p93*perctab(9,3)
      if(neutro.ne.2.and.p93.lt.0.1)p93=0.1
      p94=p94*perctab(9,4)
      if(neutro.ne.2.and.p94.lt.0.1)p94=0.1
      p95=p95*perctab(9,5)
      if(neutro.ne.2.and.p95.lt.0.1)p95=0.1
      p103=p103*perctab(10,3)
      if(neutro.ne.2.and.p103.lt.0.1)p103=0.1
!
!-- setta a 0.5 la prob. per gli elementi di classi mancanti
      if(neutro==2)then
         if(ncont( 1)==0.or.tab2( 1,3,1)==0)p3111 =0.5
         if(ncont( 1)==0.or.tab2( 1,4,1)==0)p6111 =0.5
         if(ncont( 1)==0.or.tab2( 1,1,1)==0)p6311 =0.5
         if(ncont( 6)==0.or.tab2( 6,3,1)==0)pa11=0.5
         if(ncont( 6)==0.or.tab2( 6,4,1)==0)pn11=0.5
         if(ncont( 9)==0.or.tab2( 9,1,1)==0)p1c1  =0.5
         if(ncont( 9)==0.or.tab2( 9,2,1)==0)p92   =0.5
         if(ncont( 9)==0.or.tab2( 9,3,1)==0)p93   =0.5
         if(ncont( 9)==0.or.tab2( 9,4,1)==0)p94   =0.5
         if(ncont( 9)==0.or.tab2( 9,5,1)==0)p95   =0.5
         if(ncont(10)==0.or.tab2(10,1,1)==0)p11c  =0.5
         if(ncont(10)==0.or.tab2(10,3,1)==0)p103  =0.5
      endif
!
      p3c=1-amax1(p3111,p6111,p6311)    !asse 3 
      if(neutro.ne.2.and.p3c.lt.0.1)p3c=0.1
      p11m=1-p11c
      if(neutro.ne.2.and.p11m.lt.0.1)p11m=0.1
      p1m1=1-p1c1
      if(neutro.ne.2.and.p1m1.lt.0.1)p1m1=0.1
!
      if(kprint.eq.1)then
      write(lo,*) 'dopo applicata la pseudot. '
      write(lo,*)'p3111,p6111,p6311,p3c,p1c1,p1m1,p11c,p11m',
     1 p3111,p6111,p6311,p3c,p1c1,p1m1,p11c,p11m
      write(lo,*)'p92,p93,p94,p95,p103',p92,p93,p94,p95,p103
      write(lo,*)'pp,pro,prr',pp,pro,prr
      endif
!
      endif
!      write(lo,*)'nume ',nume
!
!         nume=1
!         nume2=1
!
         num0=nume
         nume2=1+nume/2
                     indla=1
                     indexx=29 
         fmersg(nume)=ProbLa*pp*p3c*p1m1*p11m        !P---
         fmer1=0.
         knm=0
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1   
                     indexx=127
         fmersg(nume)=ProbLa*pp*p3111*p1m1*p11m     !P31--
         if(imer.gt.3)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=130
         fmersg(nume)=ProbLa*pp*p6311*p1m1*p11m     !P63--  
         if(imer.le.3)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=129
         fmersg(nume)=ProbLa*pp*p3111*p1m1*p11m     !P62--  
         if(imer.le.3)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=128
         fmersg(nume)=ProbLa*pp*p6111*p1m1*p11m     !P61--  
         if(imer.le.3)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=145
         fmersg(nume)=ProbLa*pp*p6311*p1m1*p11c     !P--c 
         if(imer.ne.3.and.imer.ne.5)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=42
         fmersg(nume)=ProbLa*pp*p6311*p1c1*p11m     !P-c- 
         if(imer.ne.2.and.imer.ne.5)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=141
         fmersg(nume)=ProbLa*pp*p6311*p1c1*p11c     !P-cc  

         if(imer.ne.5)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=7
                     indexx=131
         fmersg(nume)=ProbLa*pro*p3111*p92*p103     !R(obv)--
         if(imer.gt.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=7
                     indexx=133
         fmersg(nume)=ProbLa*pro*p6111*p93*p103     !R(obv)-c
         if(imer.ne.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=7
                     indexx=132
         fmersg(nume)=ProbLa*prr*p3111*p94*p103     !R(rev)--
         if(imer.gt.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=7
                     indexx=134
         fmersg(nume)=ProbLa*prr*p6111*p95*p103     !R(rev)-c
         if(imer.ne.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
!
      mm=msys
      if(neutro.eq.2)mm=indprobs
      xx=Probsys(mm,7)
      if (knw > 0) write(lo,*)'mm,xx ',mm,xx
      do i=num0+1,nume,2
          if(fmersg(i-1).lt.0.)fmersg(i-1)=0.
          if(neutro.eq.2)then  !28apr11
             fmersg(i-1)=ProbLa*(fmersg(i-1)/ProbLa)**xx
          endif
          fmersg(i)=i/2*100+mm*10+1
          nindlacl(i/2)=indecl
      enddo
      fmerit(num0:nume,icalcpseud+1)=fmersg(num0:nume)
!
      if(numsysEle==kfin.and.icalcpseud.eq.iappl)then
         do kpse=1,iappl+1
           do ii=1,nume-2,2
             i=nint(fmerit(ii+1,kpse))/100
             mm=nint(fmerit(ii+1,kpse))-i*100
             mmsys=mm/10
             jmer=mm-mmsys*10
             if(neutro.eq.2)msysori=probsys(mmsys,6)
             inda =nindla(i)
             indx =nindexx(i)
             indal=nindlacl(i)
             if(neutro.ne.2)then
               symbs(i,1)=lasymb(inda)//exsymb(indx)
               numerosy(i,1)=itabsy(mmsys,inda,indx)
             else
               symbs(i,kpse)=lasymb(inda)//exsymb(indx)
               numerosy(i,kpse)=itabsy(msysori,inda,indx)
               lauelcl1(i,kpse)=lauecl(indal)
               ProbLaue=(ProbSys(mmsys,jmer))**0.5
               xx=ProbSys(mmsys,7) 
               fff= (fmerit(ii,kpse)/ProbSys(mmsys,jmer))**(1/xx) !Extintion Prob.  
             endif 
           enddo
         enddo
         if(kprint.eq.1)call stampa_fmerit
         call sort_fmerit(kprint)
      else 
         if(icalcpseud.eq.0)then
           if(iappl.eq.0)return
           icalcpseud=1
           nume=num0
           if(kprint.eq.1)then
             write(lo,'(a)')' ******************************* '
             write(lo,'(a)')' Correction by Pseudotranslation '
             write(lo,'(a)')' ******************************* '
           endif
         go to 1000
         endif
      endif
      return
      end
!
!code for msys7
      subroutine msys7(imer)
      USE General, only: lo, neutro, knw
      USE Laue
!      USE PseudoStuff
!
      character*20 symbs, lauelcl1     
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/dummyyy/valmedio(13),loo
      common/dumm3/indla,indexx,numsol,ilegen
      common/fordata0/ nsymbo
      common/fordata/ symbs(2000,2),fmerit(2000,2),numerosy(2000,2)
     1,lauelcl1(2000,2)
!      common /pseudotras/ nkk,mpseud(12,74),numps(74),perctab(13,8)
!     *                    ,perce(74),jpseud(74)
      common /pseudoappl/iapplpse(74),iappl,perctab(13,8)
      common/dummyret/tab2ret(13,8,6),tabret(13,8,6),tabnewret(13,8)
      common/dummfm/fmer1,knm
!
      common/probLaEle/numsysEle,RintSys(9,6),ProbSys(9,7),kfin,indprobs
     1,corrfattProb(9),ProbLsav(5),nomonoclino
!
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!-- controlla che i 3 assi siano stati raccolti,altrimenti sceglie uno raccolto!!
      i1=ncont(1)
      i2=ncont(2)
      i3=ncont(3)
      kh=1
      if(i1.eq.0)then
      kh=2
      if(i2.eq.0)kh=3
!      if(i3.eq.0.and.keh.eq.3)keh=0
      endif
!--ci sono tutte le classi presenti??
!      Jcompleto=1
!      if(ncont(10)==0.or.ncont(7)==0.or.ncont(4)==0.or.
!     1   ncont(ii)==0)then
!         Jcompleto=0
!         if(imer.eq.nclassla)write(lo,*)
!     1    "Extinction Groups Probability for Cubic Laue Classes ",
!     1    " can't be calculated (missing reflection class)"
!         return    
!       endif    
!
!Cubico,calcolo delle probabilita .      Subroutine msys7
!lungo l'asse(00l) :p411=Prob.del m ;p11=Prob.per (l#2n);p12=Prob.per (l#4n); 
!
!diag faccia (0kl) :p11m=Prob del m; p41=Prob per (k#2n);p43=Prob per (k#2n,l#2n)
!                  p44=Prob per (k+l#2n);p45=Prob per (k#2n,l#2n,k+l#4n);
!diag corpo (hhl)  :p11m: prob. del m; p101=Prob per (l#2n); p102=Prob (l#2n, 2h+l#4n);
!                   p104=Prob (h+l=2n); p105=Prob (h#2n,l#2n)
!
!  P---     fmersg(nume)=ProbLa *pp *p411*pm11 *p11m
!  P21--    fmersg(nume)=ProbLa *pp *p11 *pm11 *p11m
!  P42--    fmersg(nume)=ProbLa *pp *p11 *pm11 *p11m
!  P41--    fmersg(nume)=ProbLa *pp *p12 *pm11 *p11m
!  P--n     fmersg(nume)=ProbLa *pp *p11 *pm11 *p101
!  Pa--     fmersg(nume)=ProbLa *pp *p11 *p41  *p11m
!  Ia--     fmersg(nume)=ProbLa *pi *p11 *p43  *p101
!  Pn--     fmersg(nume)=ProbLa *pp *p11 *p44  *p11m
!  I---     fmersg(nume)=ProbLa *pi *p11 *p44  *p101
!  Pn-n     fmersg(nume)=ProbLa *pp *p11 *p44  *p101
!  I41--    fmersg(nume)=ProbLa *pi *p12 *p44  *p101
!  I--d     fmersg(nume)=ProbLa *pi *p12 *p44  *p102
!  Ia-d     fmersg(nume)=ProbLa *pi *p12 *p43  *p102
!  F41--    fmersg(nume)=ProbLa *pf *p12 *p43  *p104
!  F--c     fmersg(nume)=ProbLa *pf *p11 *p43  *p105
!  Fd-c     fmersg(nume)=ProbLa *pf *p12 *p45  *p105
!  F---     fmersg(nume)=ProbLa *pf *p11 *p43  *p104
!  Fd--     fmersg(nume)=ProbLa *pf *p12 *p45  *p104
!
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!
      icalcpseud=0
      kprint=1
      kprint=0
      indecl=imer+7
!
!--lattice
      si   =tabnew(7,4)
      sf   =tabnew(7,5)
      if(si.gt.0.9)si=0.9
      if(sf.gt.0.9)sf=0.9
      if(neutro.ne.2)then
      if(si.lt.0.1)si=0.1
      if(sf.lt.0.1)sf=0.1
      endif
      pi=1-si
      pi0=pi
      pi=applcorEsure(7,4,pi,0.)
      pf=1-sf
      pf0=pf
      pf=applcorEsure(7,5,pf,0.)
      pp4=pi0
      pp5=pf0
      pp=1-amax1(pi,pf)
      if(neutro.ne.2.and.pp.lt.0.1)pp=0.1
!      
!--asse
      s11=tab(kh,1,5) 
      if(s11.lt.0.1)s11=0.1
      if(neutro.eq.2)s11 =tabnew(kh,1)              !00l l=2n
      if(s11.gt.0.9)s11=0.9
      if(s11.ge.0.6)then
           if(tab2(kh,1,5).gt.3.5*s11)s11=0.50
           if(tab2(kh,1,5).gt.4.0*s11)s11=0.40
      endif
      p11=1-s11
      p11=pcorr21(kh,1,p11)
      p11ori=p11
      p11=applcorEsure(kh,1,p11,0.)
!
      s12=tab(kh,2,5) 
      if(s12.lt.0.1)s12=0.1
      if(neutro.eq.2)s12 =tabnew(kh,2)              !00l l=4n
      if(s12.gt.0.9)s12=0.9
      if(s12.ge.0.6)then
            if(tab2(kh,2,5).gt.3.5*s12)s12=0.50
            if(tab2(kh,2,5).gt.4.0*s12)s12=0.40
      endif
! 
      if(s12.gt.1.0)s12=1.0
      p12=1-s12
      p12=pcorr21(kh,2,p12)
      p12ori=p12
      p12=applcorEsure(kh,2,p12,0.)
!
!
!-- diag. faccia
      p41 =1-tabnew(4,1)          !0kl k=2n
      if(p41.lt.0.)p41=0.0 
      if(neutro.ne.2.and.p41.lt.0.1)p41=0.1
      p41ori=p41
      p41=applcorEsure(4,1,p41,pp5)
!
      p43 =1-tabnew(4,3)          !0kl k=2n,l=2n
      if(p43.lt.0.)p43=0.0 
      if(neutro.ne.2.and.p43.lt.0.1)p43=0.1
      p43ori=p43
      p43=applcorEsure(4,3,p43,0.)
!
      p44 =1-tabnew(4,4)          !0kl k+l=2n
      if(p44.lt.0.)p44=0.0 
      if(neutro.ne.2.and.p44.lt.0.1)p44=0.1
      p44ori=p44
      p0=amax1(pp4,pp5)
      p44=applcorEsure(4,4,p44,p0)
!
      p45 =1-tabnew(4,5)            !0kl k=2n,l=2n, k+l=4n
      if(p45.lt.0.)p45=0.0 
      if(neutro.ne.2.and.p45.lt.0.1)p45=0.1
      p45ori=p45
      p45=pcorr21(4,5,p45)
      p45=applcorEsure(4,5,p45,0.)
!
!--diag. corpo
        p101 =1-tabnew(10,1)           !hhl  l=2n
        if(p101.lt.0.)p101=0.0 
        if(neutro.ne.2.and.p101.lt.0.1)p101=0.1
        p101ori=p101
        p101=applcorEsure(10,1,p101,pp4)
!      
        p102 =1-tabnew(10,2)           !hhl  l=2n, 2h+l=4n
        if(p102.lt.0.)p102=0.0 
        if(neutro.ne.2.and.p102.lt.0.1)p102=0.1         
        p102ori=p102
        p102=applcorEsure(10,2,p102,0.)
!
      p104 =1-tabnew(10,4)            !hhl  h+l=2n
      if(p104.lt.0.)p104=0.0 
      if(neutro.ne.2.and.p104.lt.0.1)p104=0.1
      p104ori=p104
      p104=applcorEsure(10,4,p104,pp5)
!
      p105 =1-tabnew(10,5)             !hhl  h=2n,l=2n
      if(p105.lt.0.)p105=0.0 
      if(neutro.ne.2.and.p105.lt.0.1)p105=0.1
      p105ori=p105
      p105=applcorEsure(10,5,p105,0.)
!
!-- setta a 0.5 la prob. per gli elementi di classi mancanti
      if(neutro==2)then
         if(ncont(kh)==0.or.tab2(kh,1,1)==0)p11 =0.5
         if(ncont(kh)==0.or.tab2(kh,2,1)==0)p12 =0.5
         if(ncont( 4)==0.or.tab2( 4,1,1)==0)p41 =0.5
         if(ncont( 4)==0.or.tab2( 4,3,1)==0)p43 =0.5
         if(ncont( 4)==0.or.tab2( 4,4,1)==0)p44 =0.5
         if(ncont( 4)==0.or.tab2( 4,5,1)==0)p45 =0.5
         if(ncont( 9)==0.or.tab2( 9,2,1)==0)p92 =0.5
         if(ncont( 9)==0.or.tab2( 9,3,1)==0)p93 =0.5
         if(ncont( 9)==0.or.tab2( 9,4,1)==0)p94 =0.5
         if(ncont( 9)==0.or.tab2( 9,5,1)==0)p95 =0.5
         if(ncont(10)==0.or.tab2(10,1,1)==0)p101=0.5
         if(ncont(10)==0.or.tab2(10,2,1)==0)p102=0.5
         if(ncont(10)==0.or.tab2(10,4,1)==0)p104=0.5
         if(ncont(10)==0.or.tab2(10,5,1)==0)p105=0.5
      endif
!
      p411=1-amax1(p11,p12)    !asse 4
      if(neutro.ne.2.and.p411.lt.0.1)p411=0.1
      pm11=1-amax1(p44,p41)
      if(neutro.ne.2.and.pm11.lt.0.1)pm11=0.1
      p11m =1-p101
      if(neutro.ne.2.and.p11m.lt.0.1)p11m=0.1
!
!
      if(kprint.eq.1)then
      write(lo,'(a,6f12.3)')'ori: pi,pf    ',pi0,pf0
      write(lo,'(a,6f12.3)')'corr:pi,pf,pp ',pi,pf,pp
      write(lo,*)' ' 
      write(lo,*)'      p11_(asse42),p12_(asse41,43),p411_(asse4) '
      write(lo,'(a,f12.3,f16.3,f10.3)')'ori  ',p11ori,p12ori
      write(lo,'(a,f12.3,f16.3,f10.3)')'corr ',p11,p12,p411
      write(lo,*)' ' 
      write(lo,*)'    p41_glideb,p43_glidebc,p44_gliden,p45_glided,pm11'
      write(lo,'(a,4f11.3)')'ori ',p41ori,p43ori,p44ori,p45ori
      write(lo,'(a,4f11.3,f6.3)')'corr',p41,p43,p44,p45,pm11
      write(lo,*)' ' 
      write(lo,*)
     1'piano hhl p101_glidec,p102_glided,p104_gliden,p105_glidecd, p11m'
      write(lo,'(a,4f12.3)')'ori      ',p101ori,p102ori,p104ori,p105ori
      write(lo,'(a,4f12.3,f9.3)')'corr     ',p101,p102,p104,p105,p11m
      endif
1000  continue
!
!----------------------------------------------------------------------
!-- nel secondo passaggio applica le pseudot.
!
      if(icalcpseud.eq.1)then
      pi=pi*perctab(7,4)
      if(neutro.ne.2.and.pi.lt.0.1)pi=0.1
      pf=pf*perctab(7,5)
      if(neutro.ne.2.and.pf.lt.0.1)pf=0.1
      pp=1-amax1(pi,pf)
      if(neutro.ne.2.and.pp.lt.0.1)pp=0.1
      p11=p11*perctab(1,1)
      if(neutro.ne.2.and.p11.lt.0.1)p11=0.1
      p12=p12*perctab(1,2)
      if(neutro.ne.2.and.p12.lt.0.1)p12=0.1
      p41=p41*perctab(4,1)
      if(neutro.ne.2.and.p41.lt.0.1)p41=0.1
      p44=p44*perctab(4,4)      !27gen11 Manca il n
      if(neutro.ne.2.and.p44.lt.0.1)p44=0.1     !27gen11 Manca il n
      p45=p45*perctab(4,5)
      if(neutro.ne.2.and.p45.lt.0.1)p45=0.1
      p101=p101*perctab(10,1)
      if(neutro.ne.2.and.p101.lt.0.1)p101=0.1
      p102=p102*perctab(10,2)
      if(neutro.ne.2.and.p102.lt.0.1)p102=0.1
      p104=p104*perctab(10,4)
      if(neutro.ne.2.and.p104.lt.0.1)p104=0.1
      p105=p105*perctab(10,5)
      if(neutro.ne.2.and.p105.lt.0.1)p105=0.1
      pp=1-amax1(pi,pf)
      if(neutro.ne.2.and.pp.lt.0.1)pp=0.1
!
!-- setta a 0.5 la prob. per gli elementi di classi mancanti
      if(neutro==2)then
         if(ncont( 1)==0.or.tab2( 1,1,1)==0)p11 =0.5
         if(ncont( 1)==0.or.tab2( 1,2,1)==0)p12 =0.5
         if(ncont( 4)==0.or.tab2( 4,1,1)==0)p41 =0.5
         if(ncont( 4)==0.or.tab2( 4,3,1)==0)p42 =0.5
         if(ncont( 4)==0.or.tab2( 4,4,1)==0)p44 =0.5
         if(ncont( 9)==0.or.tab2( 9,2,1)==0)p92 =0.5
         if(ncont( 9)==0.or.tab2( 9,3,1)==0)p93 =0.5
         if(ncont( 9)==0.or.tab2( 9,4,1)==0)p94 =0.5
         if(ncont( 9)==0.or.tab2( 9,5,1)==0)p95 =0.5
         if(ncont(10)==0.or.tab2(10,1,1)==0)p101=0.5
         if(ncont(10)==0.or.tab2(10,2,1)==0)p102=0.5
         if(ncont(10)==0.or.tab2(10,4,1)==0)p104=0.5
         if(ncont(10)==0.or.tab2(10,5,1)==0)p105=0.5
      endif
!
      p411=1-amax1(p11,p12)    !asse 4
      if(neutro.ne.2.and.p411.lt.0.1)p411=0.1
      pm11=1-amax1(p44,p41)
      if(neutro.ne.2.and.pm11.lt.0.1)pm11=0.1
      p11m =1-p101
      if(neutro.ne.2.and.p11m.lt.0.1)p11m=0.1
!
      if(kprint.eq.1)then
      write(lo,*) 'dopo applicata la pseudot. '
      write(lo,*)'p11,p12,p411',p11,p12,p411
      write(lo,*)'p41,p43,p44,p45,pm11',p41,p43,p44,p45,pm11
      write(lo,*)'p101,p11m,p102,p104,p105',p101,p11m,p102,p104,p105
      write(lo,*)'pi,pf,pp ',pi,pf,pp
      endif
!      
      endif
!
      if(pp.lt.0.1)pp=0.1
!         nume=1
!         nume2=1
         num0=nume
         nume2=1+nume/2
!
                     indla=1
                     indexx=29
         fmersg(nume)=ProbLa*pp*p411*pm11*p11m   !P---
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=30
         fmersg(nume)=ProbLa*pp*p11*pm11*p11m    !P21--
         if(imer.ne.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=114
         fmersg(nume)=ProbLa*pp*p11*pm11*p11m    !P42--
         if(imer.ne.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indec l
         nume=nume+2
         nume2=nume2+1
!imer              if(imer.ne.1)then
                     indla=1
                     indexx=113
         fmersg(nume)=ProbLa*pp*p12*pm11*p11m   !P41--
         if(imer.ne.2)fmersg(nume)=0.
!         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=1
                     indexx=45
         fmersg(nume)=ProbLa*pp*p11*pm11*p101    !P--n
         if(imer.ne.2)fmersg(nume)=0.
!         if(imer.eq.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer         endif
!imer         if(imer.ne.2)then
                     indla=1
                     indexx=154
         fmersg(nume)=ProbLa*pp*p11*p41*p11m   !Pa--
         if(imer.ne.1)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=5
                     indexx=154
         fmersg(nume)=ProbLa*pi*p11*p43*p101   !Ia---
         if(imer.ne.1)fmersg(nume)=0.
!         if(imer.eq.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer         endif
                     indla=1
                     indexx=43
         fmersg(nume)=ProbLa*pp*p11 *p44 *p11m   !Pn--
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=5
                     indexx=29
         fmersg(nume)=ProbLa*pi*p11*p44*p101   !I---
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer         if(imer.ne.1)then
                     indla=1
                     indexx=63
         fmersg(nume)=ProbLa*pp*p11*p44*p101   !Pn-n
         if(imer.ne.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=5
                     indexx=113
         fmersg(nume)=ProbLa*pi*p12*p44*p101   !I41--
         if(imer.ne.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=5
                     indexx=119
         fmersg(nume)=ProbLa*pi*p12*p44*p102   !I--d
         if(imer.ne.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=5
                     indexx=153
         fmersg(nume)=ProbLa*pi*p12*p43*p102   !Ia-d
         if(imer.ne.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=6
                     indexx=113
         fmersg(nume)=ProbLa*pf*p12*p43*p104   !F41--
         if(imer.ne.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=6
                     indexx=152
         fmersg(nume)=ProbLa*pf*p11*p43*p105   !F--c
         if(imer.ne.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=6
                     indexx=151
         fmersg(nume)=ProbLa*pf*p12*p45*p105   !Fd-c
         if(imer.ne.2)fmersg(nume)=0.
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer         endif
                     indla=6
                     indexx=29
         fmersg(nume)=ProbLa*pf*p11*p43*p104    !F---
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
                     indla=6
                     indexx=150
         fmersg(nume)=ProbLa*pf*p12*p45*p104   !Fd--
         fmersg(nume+1)=nume2 
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
!
!        write(lo,*)'num0,nume,nume2 ',num0,nume,nume2
!        write(lo,'(a,10f8.6)')'fmersg(i) '
!        write(lo,'(5(f9.4,f9.0))')(fmersg(i),i=1,nume)
!
      mm=msys
      if(neutro.eq.2)mm=indprobs
      xx=Probsys(mm,7)
      if (knw > 0) write(lo,*)'mm,xx ',mm,xx
      do i=num0+1,nume,2
          if(fmersg(i-1).lt.0.)fmersg(i-1)=0.
          if(neutro.eq.2)then  !28apr11
             fmersg(i-1)=ProbLa*(fmersg(i-1)/ProbLa)**xx
          endif
          fmersg(i)=i/2*100+mm*10+1
          nindlacl(i/2)=indecl
      enddo
      fmerit(num0:nume,icalcpseud+1)=fmersg(num0:nume)
!
      if(numsysEle==kfin.and.icalcpseud.eq.iappl)then
         do kpse=1,iappl+1
           do ii=1,nume-2,2
             i=nint(fmerit(ii+1,kpse))/100
             mm=nint(fmerit(ii+1,kpse))-i*100
             mmsys=mm/10
             jmer=mm-mmsys*10
             if(neutro.eq.2)msysori=probsys(mmsys,6)
             inda =nindla(i)
             indx =nindexx(i)
             indal=nindlacl(i)
             if(neutro.ne.2)then
               symbs(i,1)=lasymb(inda)//exsymb(indx)
               numerosy(i,1)=itabsy(mmsys,inda,indx)
             else
               symbs(i,kpse)=lasymb(inda)//exsymb(indx)
               numerosy(i,kpse)=itabsy(msysori,inda,indx)
               lauelcl1(i,kpse)=lauecl(indal)
               ProbLaue=(ProbSys(mmsys,jmer))**0.5
               xx=ProbSys(mmsys,7) 
               fff= (fmerit(ii,kpse)/ProbSys(mmsys,jmer))**(1/xx) !Extintion Prob.  
             endif 
           enddo
         enddo
         if(kprint.eq.1)call stampa_fmerit
         call sort_fmerit(kprint)
      else 
         if(icalcpseud.eq.0)then
           if(iappl.eq.0)return
           icalcpseud=1
           nume=num0
           if(kprint.eq.1)then
             write(lo,'(a)')' ******************************* '
             write(lo,'(a)')' Correction by Pseudotranslation '
             write(lo,'(a)')' ******************************* '
           endif
         go to 1000
         endif
      endif
      return
      end
!
!code for msys8
      subroutine msys8(imer)
      USE General, only: lo, neutro, knw
      USE Laue
!      USE PseudoStuff
!
      character*20 symbs, lauelcl1     
      common/dummyy/tab2(13,8,6),ntabte(13,8),ntabte2(13,8),nconteo(13)
      common/dummz/kverb,coefsig,nonacc,toller,ntota,icomple,msys0
     1            ,nonconsid,ntotai,tollercentr,ProbLa 
      common/dummyyy/valmedio(13),loo
      common/dumm3/indla,indexx,numsol,ilegen
      common/fordata0/ nsymbo
      common/fordata/ symbs(2000,2),fmerit(2000,2),numerosy(2000,2)
     1,lauelcl1(2000,2)
!      common /pseudotras/ nkk,mpseud(12,74),numps(74),perctab(13,8)
!     *                    ,perce(74),jpseud(74)
      common /pseudoappl/iapplpse(74),iappl,perctab(13,8)
      common/dummyret/tab2ret(13,8,6),tabret(13,8,6),tabnewret(13,8)
      common/dummfm/fmer1,knm
!
      common/probLaEle/numsysEle,RintSys(9,6),ProbSys(9,7),kfin,indprobs
     1,corrfattProb(9),ProbLsav(5),nomonoclino
!
!--ci sono tutte le classi presenti??
!      Jcompleto=1
!      if(ncont(11)==0)then
!         Jcompleto=0
!         if(imer.eq.nclassla)write(lo,*)
!     1   "Extinction Groups Probability for Rhombohedral Laue Class ",
!     1   " can't be calculated (missing reflection class)"
!         return    
!       endif    
!
      kprint=0
      icalcpseud=0
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!
      s21=tab(11,1,5)
      if(s21.lt.0.1)s21=0.1
      if(s21.ge.0.9)s21=0.9
      if(neutro.eq.2)s21=tabnew(11,1)
         if(s21.ge.0.6)then
         if(tab2(11,1,5).gt.3.5*s21)s21=0.50
         if(tab2(11,1,5).gt.4.0*s21)s21=0.40
         endif
      p21=1-s21
      p21=pcorr21(11,1,p21)
      p21=applcorEsure(11,1,p21,0.)
!
      sc=tabnew(10,1)
      pc=1-sc
      pc=applcorEsure(10,1,pc,0.)
      pm=1-pc
      if(neutro.ne.2.and.pm.lt.0.1)pm=0.1
      p2=1-p21
      if(neutro.ne.2.and.p2.lt.0.1)p2=0.1
1000  continue
!
!----------------------------------------------------------------------
!-- nel secondo passaggio applica le pseudot.
!
!      if(icalcpseud.eq.1)then
!      p21=p21*
!      pc=pc*
!      p2=p2*
!      endif
!
!         nume=1
!         nume2=1
         num0=nume
         indecl=imer+2
!imer         if(imer.ne.4)then
                     indla=7
                     indexx=148
         fmersg(nume)=ProbLa*p2*pm
         fmer1=0.
         knm=0
!              if(imer.eq.4)fmersg(nume)=0.
         fmersg(nume+1)=nume2
         nindla(nume2)=indla
         nindexx(nume2)=indexx
         nindlacl(nume2)=indecl
         nume=nume+2
         nume2=nume2+1
!imer                  if(imer.ne.1)then
                     indla=7
                     indexx=149
             fmersg(nume)=ProbLa*p21*pc
!                  if(imer.eq.1)fmersg(nume)=0.
!                  if(imer.eq.4)fmersg(nume)=0.
             fmersg(nume+1)=nume2
            nindla(nume2)=indla
            nindexx(nume2)=indexx
            nindlacl(nume2)=indecl
!imer                 endif
!imer              endif
           nume=nume+2
*Gianluca  if (knm > 0) then
*Gianluca      fmersg(1) = 1-fmer1 / knm
*Gianluca  endif
!
!
      mm=msys
      if(neutro.eq.2)mm=indprobs
      xx=Probsys(mm,7)
      if (knw > 0) write(lo,*)'mm,xx ',mm,xx
      do i=num0+1,nume,2
          if(fmersg(i-1).lt.0.)fmersg(i-1)=0.
          if(neutro.eq.2)then  !28apr11
             fmersg(i-1)=ProbLa*(fmersg(i-1)/ProbLa)**xx
          endif
          fmersg(i)=i/2*100+mm*10+1
          nindlacl(i/2)=indecl
      enddo
      fmerit(num0:nume,icalcpseud+1)=fmersg(num0:nume)
!
      if(numsysEle==kfin.and.icalcpseud.eq.iappl)then
         do kpse=1,iappl+1
           do ii=1,nume-2,2
             i=nint(fmerit(ii+1,kpse))/100
             mm=nint(fmerit(ii+1,kpse))-i*100
             mmsys=mm/10
             jmer=mm-mmsys*10
             if(neutro.eq.2)msysori=probsys(mmsys,6)
             inda =nindla(i)
             indx =nindexx(i)
             indal=nindlacl(i)
             if(neutro.ne.2)then
               symbs(i,1)=lasymb(inda)//exsymb(indx)
               numerosy(i,1)=itabsy(mmsys,inda,indx)
             else
               symbs(i,kpse)=lasymb(inda)//exsymb(indx)
               numerosy(i,kpse)=itabsy(msysori,inda,indx)
               lauelcl1(i,kpse)=lauecl(indal)
               ProbLaue=(ProbSys(mmsys,jmer))**0.5
               xx=ProbSys(mmsys,7) 
               fff= (fmerit(ii,kpse)/ProbSys(mmsys,jmer))**(1/xx) !Extintion Prob.  
             endif 
           enddo
         enddo
         if(kprint.eq.1)call stampa_fmerit
         call sort_fmerit(kprint)
      else 
         if(icalcpseud.eq.0)then
           if(iappl.eq.0)return
           icalcpseud=1
           nume=num0
           if(kprint.eq.1)then
             write(lo,'(a)')' ******************************* '
             write(lo,'(a)')' Correction by Pseudotranslation '
             write(lo,'(a)')' ******************************* '
           endif
         go to 1000
         endif
      endif
      return
      end
!
!      
!
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!
!code for irdgs
      function irdgs(ngsx,strin1)
!--function to read the space group symbol
!  ngsx   = number of space group
!  strin1 = space group symbol
!
      USE General
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!--
      character*16 strin1,strin2,idol
      dimension buf(60)
      integer sei(6)
!--
      idol='$$$$'
      ncau=42
!
!--open the file with the s.g. information
      itype=2
      iform=1
      jop=jopen(ncau,iasun,itype,iform,ierr)
      if (jop.ge.0)then
1001  continue
!
!--find the space group
40    continue
!     read(unit=ncau,fmt=1010,end=900) strin2,jump,ngs,(buf(j),j=1,60)
!1010  format(a10,2i5,6f5.1,1x,6f2.0,1x,20(3f3.0,2f5.1))
1016  format(a120)
      read(unit=ncau,fmt=1016,end=900) buffer_ctrl_M
      call filtra(buffer_ctrl_M)
!     read(buffer_ctrl_M,fmt=1010) strin2,jump,ngs,(buf(j),j=1,60)
!1010 format(a10,2i5,6f5.1,1x,6f2.0,1x,20(3f3.0,2f5.1))
      read(buffer_ctrl_M,fmt=1010) strin2,jump,ngs,
     *    (buf(j),j=1,6),
     *    (sei(j),j=1,6),
     *    (buf(j),j=13,60)
      buf(7:12) = sei(1:6)
1010  format(a12,i3,i5,
     *       6f5.1,1x,
     *       6i2,1x,
     *       20(3f3.0,2f5.1))
      if(ngs.eq.ngsx) goto 50
      if(index(idol,strin2).ne.0) goto 900
      go to 40
50    continue
      irdgs=ngs
      strin1=strin2
      close(unit=ncau)
      return
!
!--error messages
900   continue
      if(istat2.ne.0) write(ncwu,1011)
1011  format(2x,'string not found')
910   continue
      irdgs=0
      lvet=0
920   continue
      close(unit=ncau)
      return
      endif
9000  continue
      if(istat2.ne.0) write(ncwu,1012)
1012  format(2x,'**error on open file asunit.dat')
      irdgs=0
      lvet=0
      close(unit=ncau)
      return
      end
!
!code for equindi
      subroutine  equindi(hkl,mm,hkleMat)
      USE General
      USE Symmetry
!-- compute symmetry equivalent reflections
      integer hkl(3),hkleMat(48,3),hkleq(3)
!
      mm=1
      do  k=1,nsym
         do  i=1,3
            hkleq(i)=0
            do  j=1,3
              hkleq(i)=hkleq(i)+hkl(j)*kmat(k,j,i)
            enddo
         enddo
         if(mm.gt.1)then
            do ij=1,mm-1
               ikk=1
               do ik=1,2
!                 if(ik.eq.2)ikk=-1
                  if(ikk*hkleq(1).eq.hkleMat(ij,1).and.
     1            ikk*hkleq(2).eq.hkleMat(ij,2).and.
     1            ikk*hkleq(3).eq.hkleMat(ij,3))exit
                  if(ikk*hkleq(1).eq.-hkleMat(ij,1).and.
     1            ikk*hkleq(2).eq.-hkleMat(ij,2).and.
     1            ikk*hkleq(3).eq.-hkleMat(ij,3))exit
               enddo
            enddo
         endif
         hkleMat(mm,1)=hkleq(1)
         hkleMat(mm,2)=hkleq(2)
         hkleMat(mm,3)=hkleq(3)
         mm=mm+1
      enddo
      mm=mm-1
!      do i=1,mm
!      write(lo,*)'i,hkleMat',i,(hkleMat(i,ii),ii=1,3)
!      enddo
      return
      end
!-----------------------------------------------------------------------
!code for InitLaue
      subroutine InitLaue
      USE Laue
!
!      data stabb( 1)/'refl. type 0  0  l'/
!      data stabb( 2)/'refl. type 0  k  0'/
!      data stabb( 3)/'refl. type h  0  0'/
!      data stabb( 4)/'refl. type 0  k  l'/
!      data stabb( 5)/'refl. type h  0  l'/
!      data stabb( 6)/'refl. type h  k  0'/
!      data stabb( 7)/'refl. type h  k  l'/
!      data stabb( 8)/'refl. type h  h  0'/
!      data stabb( 9)/'refl. type h -h  l'/
!      data stabb(10)/'refl. type h  h  l'/
!      data stabb(11)/'refl. type h  h  h'/
!      data stabb(12)/'refl. type h  k  h'/
!      data stabb(13)/'refl. type h  k  k'/
!
      stab( 1) = ' 0  0  l'
      stab( 2) = ' 0  k  0'
      stab( 3) = ' h  0  0'
      stab( 4) = ' 0  k  l'
      stab( 5) = ' h  0  l'
      stab( 6) = ' h  k  0'
      stab( 7) = ' h  k  l'
      stab( 8) = ' h  h  0'
      stab( 9) = ' h -h  l'
      stab(10) = ' h  h  l'
      stab(11) = ' h  h  h'
      stab(12) = ' h  k  h'
      stab(13) = ' h  k  k'
!-- 0  0  l                                      
      scond(1,1) = 'l=2n              ' 
      scond(1,2) = 'l=4n              ' 
      scond(1,3) = 'l=3n              ' 
      scond(1,4) = 'l=6n              ' 
      scond(1,5) = '                  ' 
      scond(1,6) = '                  ' 
      scond(1,7) = '                  ' 
      scond(1,8) = '                  ' 
!-- 0  k  0                                  
      scond(2,1) = 'k=2n              ' 
      scond(2,2) = 'k=4n              ' 
      scond(2,3) = '                  ' 
      scond(2,4) = '                  ' 
      scond(2,5) = '                  ' 
      scond(2,6) = '                  ' 
      scond(2,7) = '                  ' 
      scond(2,8) = '                  ' 
!-- h  0  0                                   
      scond(3,1) = 'h=2n              ' 
      scond(3,2) = 'h=4n              ' 
      scond(3,3) = '                  ' 
      scond(3,4) = '                  ' 
      scond(3,5) = '                  ' 
      scond(3,6) = '                  ' 
      scond(3,7) = '                  ' 
      scond(3,8) = '                  ' 
!-- 0  k  l                                   
      scond(4,1) = 'k=2n              ' 
      scond(4,2) = 'l=2n              ' 
      scond(4,3) = 'k=2n,l=2n         ' 
      scond(4,4) = 'k+l=2n            ' 
      scond(4,5) = 'k=2n,l=2n,k+l=4n  ' 
      scond(4,6) = '                  ' 
      scond(4,7) = '                  ' 
      scond(4,8) = '                  ' 
!-- h  0  l                                 
      scond(5,1) = 'h=2n              ' 
      scond(5,2) = 'l=2n              ' 
      scond(5,3) = 'h=2n,l=2n         ' 
      scond(5,4) = 'h+l=2n            ' 
      scond(5,5) = 'h=2n,l=2n,h+l=4n  ' 
      scond(5,6) = '                  ' 
      scond(5,7) = '                  ' 
      scond(5,8) = '                  ' 
!-- h  k  0                                 
      scond(6,1) = 'h=2n              ' 
      scond(6,2) = 'k=2n              ' 
      scond(6,3) = 'h=2n,k=2n         ' 
      scond(6,4) = 'h+k=2n            ' 
      scond(6,5) = 'h=2n,k=2n,h+k=4n  ' 
      scond(6,6) = '                  ' 
      scond(6,7) = '                  ' 
      scond(6,8) = '                  ' 
!-- h  k  l                                 
      scond(7,1) = 'h+k=2n            ' 
      scond(7,2) = 'k+l=2n            ' 
      scond(7,3) = 'h+l=2n            ' 
      scond(7,4) = 'h+k+l=2n          ' 
      scond(7,5) = '(h+k,k+l,h+l)=2n  ' 
      scond(7,6) = '-h+k+l=3n         ' 
      scond(7,7) = 'h-k+l=3n          ' 
      scond(7,8) = 'h-k=3n            ' 
!-- h  h  0                                   
      scond(8,1) = 'h=2n              ' 
      scond(8,2) = '                  ' 
      scond(8,3) = '                  ' 
      scond(8,4) = '                  ' 
      scond(8,5) = '                  ' 
      scond(8,6) = '                  ' 
      scond(8,7) = '                  ' 
      scond(8,8) = '                  ' 
!-- h -h  l                                 
      scond(9,1) = 'l=2n              ' 
      scond(9,2) = 'h+l=3n            ' 
      scond(9,3) = 'l=2n,h+l=3n       ' 
      scond(9,4) = '-h+l=3n           ' 
      scond(9,5) = 'l=2n,-h+l=3n      ' 
      scond(9,6) = '                  ' 
      scond(9,7) = '                  ' 
      scond(9,8) = '                  ' 
!-- h  h  l                                  
      scond(10,1) = 'l=2n              ' 
      scond(10,2) = 'l=2n,2h+l=4n      ' 
      scond(10,3) = 'l=3n              ' 
      scond(10,4) = 'h+l=2n            ' 
      scond(10,5) = 'h=2n,l=2n         ' 
      scond(10,6) = '                  ' 
      scond(10,7) = '                  ' 
      scond(10,8) = '                  ' 
!-- h  h  h                                  
      scond(11,1) = 'h=2n              ' 
      scond(11,2) = '                  ' 
      scond(11,3) = '                  ' 
      scond(11,4) = '                  ' 
      scond(11,5) = '                  ' 
      scond(11,6) = '                  ' 
      scond(11,7) = '                  ' 
      scond(11,8) = '                  ' 
!-- h  k  h                                  
      scond(12,1) = 'k=2n              ' 
      scond(12,2) = 'k=2n,2h+k=4n      ' 
      scond(12,3) = 'k=3n              ' 
      scond(12,4) = 'h+k=2n            ' 
      scond(12,5) = 'h=2n,k=2n         ' 
      scond(12,6) = '                  ' 
      scond(12,7) = '                  ' 
      scond(12,8) = '                  ' 
!-- h  k  k                                  
      scond(13,1) = 'h=2n              ' 
      scond(13,2) = 'h=2n,2k+h=4n      ' 
      scond(13,3) = 'h=3n              ' 
      scond(13,4) = 'h+k=2n            ' 
      scond(13,5) = 'h=2n,k=2n         ' 
      scond(13,6) = '                  ' 
      scond(13,7) = '                  ' 
      scond(13,8) = '                  ' 
!
      symope(1 ) = '  21 _ _          ' 
      symope(2 ) = '  42 _ _          ' 
      symope(3 ) = '  41,43 - -       ' 
      symope(4 ) = '  _ 21 _          ' 
      symope(5 ) = '  _ 42 _          ' 
      symope(6 ) = '  _ 41,43 _       ' 
      symope(7 ) = '  _ _ 21          ' 
      symope(8 ) = '  _ _ 42          ' 
      symope(9 ) = '  _ _ 41,43       ' 
      symope(10) = '  _ _ 63          ' 
      symope(11) = '  _ _ 61,65       ' 
      symope(12) = '  _ _ 31,32,62,64 ' 
!
      symope(13) = '  a _ _           ' 
      symope(14) = '  b _ _           ' 
      symope(15) = '  c _ _           ' 
      symope(16) = '  n _ _           ' 
      symope(17) = '  d _ _           ' 
      symope(18) = '  _ a _           ' 
      symope(19) = '  _ b _           ' 
      symope(20) = '  _ c _           ' 
      symope(21) = '  _ n _           ' 
      symope(22) = '  _ d _           ' 
      symope(23) = '  _ _ a           ' 
      symope(24) = '  _ _ b           ' 
      symope(25) = '  _ _ c           ' 
      symope(26) = '  _ _ n           ' 
      symope(27) = '  _ _ d           ' 
      symope(28) = '   c              ' 
      symope(29) = '   d              ' 
      symope(30) = '   a,n            ' 
      symope(31) = '   b,n            ' 
      symope(32) = '   c,n            ' 
!
      symope(33) = '  Primitive       ' 
      symope(34) = '  A lattice       ' 
      symope(35) = '  B lattice       ' 
      symope(36) = '  C lattice       ' 
      symope(37) = '  I lattice       ' 
      symope(38) = '  F lattice       ' 
      symope(39) = '  R (obv.) lattice' 
      symope(40) = '  R (rev.) lattice' 
      symope(41) = '  H lattice       ' 
      symope(42) = '  ______          ' 
      symope(43) = '  _ _ a,b         ' 
      symope(44) = '                  ' 
      symope(45) = '                  ' 
      symope(46) = '  P _ c           ' 
      symope(47) = '  R (obv.) _ c    ' 
      symope(48) = '  R (rev.) _ c    ' 
! 
      lasymb(1 ) = ' P ' 
      lasymb(2 ) = ' A ' 
      lasymb(3 ) = ' B ' 
      lasymb(4 ) = ' C ' 
      lasymb(5 ) = ' I ' 
      lasymb(6 ) = ' F ' 
      lasymb(7 ) = ' R ' 
      lasymb(8 ) = ' H ' 
!
      lauecl(1 ) = ' 4/m        '
      lauecl(2 ) = ' 4/m m m    '
      lauecl(3 ) = ' -3         '
      lauecl(4 ) = ' -3 m 1     '
      lauecl(5 ) = ' -3 1 m     '
      lauecl(6 ) = ' 6/m        '
      lauecl(7 ) = ' 6/m m m    '
      lauecl(8 ) = ' m -3       '
      lauecl(9 ) = ' m -3 m     '
      lauecl(10) = ' 1 2/m 1    '
!     lauecl(11) = ' 2/m 2/m 2/m'
      lauecl(11) = ' m m m      '
      lauecl(12) = ' -1         '
      lauecl(13) = ' 2/m 1 1    '
      lauecl(14) = ' 1 1 2/m    '
!
      exsymb(1 ) = '_ 1 1       ' 
      exsymb(2 ) = '1 _ 1       ' 
      exsymb(3 ) = '1 1 _       ' 
      exsymb(4 ) = '1 a 1       ' 
      exsymb(5 ) = '1 1 a       ' 
      exsymb(6 ) = 'b 1 1       ' 
      exsymb(7 ) = '1 1 b       ' 
      exsymb(8 ) = 'c 1 1       ' 
      exsymb(9 ) = '1 c 1       ' 
      exsymb(10) = 'n 1 1       ' 
      exsymb(11) = '1 n 1       ' 
      exsymb(12) = '1 1 n       ' 
      exsymb(13) = '_ d d       ' 
      exsymb(14) = 'd _ d       ' 
      exsymb(15) = 'd d _       ' 
      exsymb(16) = 'd d d       ' 
      exsymb(17) = '21 1 1      ' 
      exsymb(18) = '1 21 1      ' 
      exsymb(19) = '1 1 21      ' 
      exsymb(20) = '21/b 1 1    ' 
      exsymb(21) = '21/c 1 1    ' 
      exsymb(22) = '21/n 1 1    ' 
      exsymb(23) = '1 21/a 1    ' 
      exsymb(24) = '1 21/c 1    ' 
      exsymb(25) = '1 21/n 1    ' 
      exsymb(26) = '1 1 21/a    ' 
      exsymb(27) = '1 1 21/b    ' 
      exsymb(28) = '1 1 21/n    ' 
      exsymb(29) = '_ _ _       ' 
      exsymb(30) = '21 _ _      ' 
      exsymb(31) = '_ 21 _      ' 
      exsymb(32) = '_ _ 21      ' 
      exsymb(33) = '21 21 _     ' 
      exsymb(34) = '21 _ 21     ' 
      exsymb(35) = '_ 21 21     ' 
      exsymb(36) = '21 21 21    ' 
      exsymb(37) = '_ a _       ' 
      exsymb(38) = '_ _ a       ' 
      exsymb(39) = 'b _ _       ' 
      exsymb(40) = '_ _ b       ' 
      exsymb(41) = 'c _ _       ' 
      exsymb(42) = '_ c _       ' 
      exsymb(43) = 'n _ _       ' 
      exsymb(44) = '_ n _       ' 
      exsymb(45) = '_ _ n       ' 
      exsymb(46) = 'b a _       ' 
      exsymb(47) = 'b c _       ' 
      exsymb(48) = 'b n _       ' 
      exsymb(49) = 'c a _       ' 
      exsymb(50) = 'c c _       ' 
      exsymb(51) = 'c n _       ' 
      exsymb(52) = 'n a _       ' 
      exsymb(53) = 'n c _       ' 
      exsymb(54) = 'n n _       ' 
      exsymb(55) = 'b _ a       ' 
      exsymb(56) = 'b _ b       ' 
      exsymb(57) = 'b _ n       ' 
      exsymb(58) = 'c _ a       ' 
      exsymb(59) = 'c _ b       ' 
      exsymb(60) = 'c _ n       ' 
      exsymb(61) = 'n _ a       ' 
      exsymb(62) = 'n _ b       ' 
      exsymb(63) = 'n _ n       ' 
      exsymb(64) = '_ a a       ' 
      exsymb(65) = '_ a b       ' 
      exsymb(66) = '_ a n       ' 
      exsymb(67) = '_ c a       ' 
      exsymb(68) = '_ c b       ' 
      exsymb(69) = '_ c n       ' 
      exsymb(70) = '_ n a       ' 
      exsymb(71) = '_ n b       ' 
      exsymb(72) = '_ n n       ' 
      exsymb(73) = 'b a a       ' 
      exsymb(74) = 'b a b       ' 
      exsymb(75) = 'b a n       ' 
      exsymb(76) = 'b c a       ' 
      exsymb(77) = 'b c b       ' 
      exsymb(78) = 'b c n       ' 
      exsymb(79) = 'b n a       ' 
      exsymb(80) = 'b n b       ' 
      exsymb(81) = 'b n n       ' 
      exsymb(82) = 'c a a       ' 
      exsymb(83) = 'c a b       ' 
      exsymb(84) = 'c a n       ' 
      exsymb(85) = 'c c a       ' 
      exsymb(86) = 'c c b       ' 
      exsymb(87) = 'c c n       ' 
      exsymb(88) = 'c n a       ' 
      exsymb(89) = 'c n b       ' 
      exsymb(90) = 'c n n       ' 
      exsymb(91) = 'n a a       ' 
      exsymb(92) = 'n a b       ' 
      exsymb(93) = 'n a n       ' 
      exsymb(94) = 'n c a       ' 
      exsymb(95) = 'n c b       ' 
      exsymb(96) = 'n c n       ' 
      exsymb(97) = 'n n a       ' 
      exsymb(98) = 'n n b       ' 
      exsymb(99) = 'n n n       ' 
      exsymb(100) = '(bc) _ _   ' 
      exsymb(101) = '_ (ac) _   ' 
      exsymb(102) = '_ _ (ab)   ' 
      exsymb(103) = '(bc) a _   ' 
      exsymb(104) = '(bc) _ a   ' 
      exsymb(105) = '(bc) a a   ' 
      exsymb(106) = 'b (ac) _   ' 
      exsymb(107) = '_ (ac) b   ' 
      exsymb(108) = 'b (ac) b   ' 
      exsymb(109) = 'c _ (ab)   ' 
      exsymb(110) = '_ c (ab)   ' 
      exsymb(111) = 'c c (ab)   ' 
      exsymb(112) = '_ 21 _     ' 
      exsymb(113) = '41 _ _     ' 
      exsymb(114) = '42 _ _     ' 
      exsymb(115) = '41 21 c    ' 
      exsymb(116) = '42 21 c    ' 
      exsymb(117) = '42/n _ _   ' 
      exsymb(118) = '41/a _ _   ' 
      exsymb(119) = '_ _ d      ' 
      exsymb(120) = '_ d d      ' 
      exsymb(121) = 'd _ d      ' 
      exsymb(122) = 'd d _      ' 
      exsymb(123) = 'd d d      ' 
      exsymb(124) = 'a _ d      ' 
      exsymb(125) = '_ c d      ' 
      exsymb(126) = 'a c d      ' 
      exsymb(127) = '31 _ _     ' 
      exsymb(128) = '61 _ _     ' 
      exsymb(129) = '62 _ _     ' 
      exsymb(130) = '63 _ _     ' 
      exsymb(131) = '(obv) _ _  ' 
      exsymb(132) = '(rev) _ _  ' 
      exsymb(133) = '(obv) _ c  ' 
      exsymb(134) = '(rev) _ c  ' 
      exsymb(135) = 'n n c       ' 
      exsymb(136) = 'n c c       ' 
      exsymb(137) = 'n b c       ' 
      exsymb(138) = 'n b _      ' 
      exsymb(139) = 'n _ c       ' 
      exsymb(140) = '_ n c       ' 
      exsymb(141) = '_ c c       ' 
      exsymb(142) = '_ b c       ' 
      exsymb(143) = '_ b _      ' 
      exsymb(144) = '_ 21 c      ' 
      exsymb(145) = '_ _ c       ' 
      exsymb(146) = '41 21 _    ' 
      exsymb(147) = '42 21 _    ' 
      exsymb(148) = '_  _       ' 
      exsymb(149) = '_  c        ' 
      exsymb(150) = 'd  _ _     ' 
      exsymb(151) = 'd  _ c      ' 
      exsymb(152) = '_  _ c      ' 
      exsymb(153) = 'a  _ d     ' 
      exsymb(154) = 'a  _ _     ' 
      exsymb(155) = '1          ' 
!
!      epsmed(msys,nclassla,nclassrif) epsilon medio in ogni classe dei gruppi di laue 
!      epsmed(8,5,27)
      epsmed(:,:,:)=1.
! msys=1: monoc. a   
      epsmed(1,1,1:3)  =1.6667; epsmed(1,1,6)    =1.6667    
! msys=2: monoc. b   
      epsmed(2,1,1:3)  =1.6667; epsmed(2,1,5)    =1.6667    
! msys=3: monoc. c   
      epsmed(3,1,1:3)  =1.6667; epsmed(3,1,4)    =1.6667   
! msys=4: ortor.   
      epsmed(4,1,1:3)  =2.8000; epsmed(4,1,4:6)  =2.6667    
! msys=5: tetrag. nclass=1 4/m   
      epsmed(5,1,1)    =3.3333; epsmed(5,1,2:4)  =1.3333    
      epsmed(5,1,7:8)  =1.3333   
! msys=5: tetrag. nclass=2 4/mmm   
      epsmed(5,2,1)    =5.6000; epsmed(5,2,2:3)  =2.4000    
      epsmed(5,2,4)    =1.2000; epsmed(5,2,5:6)  =1.6000    
      epsmed(5,2,7:8)  =2.4000; epsmed(5,2,23:24)=1.6000    
! msys=6: hexag. nclass=1   3  
      epsmed(6,1,1)    =3.0000;     
! msys=6: hexag. nclass=2   31m  
      epsmed(6,2,1)    =5.0000; epsmed(6,2,2:3)  =1.6667    
      epsmed(6,2,7:8)  =1.6667; epsmed(6,2,13:14)=1.6667    
      epsmed(6,2,23)   =1.6667; epsmed(6,2,25:26)=1.6667     
! msys=6: hexag. nclass=3   3m1  
      epsmed(6,3,1)    =5.0000; epsmed(6,3,2:3)  =1.6667    
      epsmed(6,3,5:8)  =1.6667; epsmed(6,3,13:14)=1.6667    
      epsmed(6,3,24)   =1.6667;      
! msys=6: hexag. nclass=4   6/m  
      epsmed(6,4,1)    =5.0000; epsmed(6,4,2:4)  =1.6667    
      epsmed(6,4,7:8)  =1.6667; epsmed(6,4,13:14)=1.6667    
! msys=6: hexag. nclass=5   6/mmm  
      epsmed(6,5,1)    =8.4000; epsmed(6,5,2:3)  =2.8000      
      epsmed(6,5,4:6)  =1.6000; epsmed(6,5,7:8)  =2.8000    
      epsmed(6,5,13:14)=2.8000; epsmed(6,5,23:26)=1.6000     
! msys=7: cubico nclass=1   m3  
      epsmed(7,1,1:3)  =3.0000; epsmed(7,1,4:12) =1.5000      
      epsmed(7,1,15:18)=3.0000;       
! msys=7: cubico nclass=2   m3m  
      epsmed(7,2,1:3)  =5.3333; epsmed(7,2,4:6)  =1.3333      
      epsmed(7,2,7:12) =2.6667; epsmed(7,2,15:18)=5.0000
      epsmed(7,2,19:24)=1.6667      
! msys=8: rhomb. nclass=1   3  
      epsmed(8,1,15)   =3.0000      
! msys=8: rhomb. nclass=2   3m  
      epsmed(8,2,1:3)  =1.6667; epsmed(8,2,7:12) =1.6667      
      epsmed(8,2,15)   =5.0000; epsmed(8,2,16:19)=1.6667      
      epsmed(8,2,21)   =1.6667; epsmed(8,2,23)   =1.6667
      return
      end
!
!-----------------------------------------------------------------------
! ----------------------------------------------------------------------
! 
!                   CELLANA
!
! ----------------------------------------------------------------------
!----------------------------------------------------------------------
!-- ricerca della cella triclina ridotta per il metodo di Buerger e 
!-- della sua simmetria superiore
!
!code for cellana 
      subroutine cellana 
      USE General
      USE Symmetry
      dimension epi(3,3),acel(6),ictot(3,3),ica(3,3),fctot(3,3)
      character*40 ititl
      dimension ec(3,3)
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
      common/cellanew/ cnew(6),volcnew,errcnew(6),cnewtrasf(3,3)
     1 ,lattcell,msyscell
!
!     jlatt=0  p
!     jlatt=1  a
!     jlatt=2  b
!     jlatt=3  c
!     jlatt=4  f
!     jlatt=5  i
!     jlatt=6  r
!     errac  (1:3)   errori sugli assi
!     errac  (4:6)   errori sugli angoli (degrees)
!     erras2(3,3)   errore sulla metrica (aa(3,3))
!     erraa(3,3)   errore . sqrt(aa(3,3))
!-----i11=-1/1 tipo I/II
!-----i12=0,1,2,3 codice assi uguali: nessuno,a=b,b=c,tutti
!
      i11=-1
      i12=0
      jlatt=latt-1
      if(latt.eq.5)jlatt=5
      if(latt.eq.6)jlatt=4
      kpri=1      !codice stampa cella primitiva ridotta :0=no 1=si
!      if(jlatt.gt.0)kpri=1
      ititl='Bravais lattice determination'
!      write(ncvu,'(//,1x,a)') ititl
!      write(lo,51)ac
!      write(lo,*) 'latt,jlatt',latt,jlatt 
!51    format(' Input cell :',/,1x,3f10.3,1x,3f10.2)
!      write(lo,'(1x,3f10.3,1x,3f10.2)')errac
!
!      write(lo,'(a,6f7.3)')'errcell ',errcell(1:6)
      cnew=0.
      errcnew=0.
      cnewtrasf=0.
!      write(lo,*) 'latt,jlatt,msys ' ,latt,jlatt,msys
      ac(1:6)=cell(1:6)
      errac(1:6)=errcell(1:6)
      iferrcell=1
      if(errcell(1).le.0.)iferrcell=0
      do i=1,6
         if(iferrcell.eq.0)errac(i)=ac(i)/1000
      enddo
      call anasyst(msys,1)
      ac0(1:6)=ac(1:6)
      ntest=-1
      ntent=0
      ec=0.
      totmat=0.
      do i=1,3
         ec(i,i)=1.
         totmat(i,i)=1.
      enddo
      call calmet(ac,errac,aa,erras2)
      aa0=aa
      erras20=erras2
      write(lo,*) ' '

!
!      write(lo,*)' dopo calmet aa  '
!      call prtm(aa,lo)
!      write(lo,*)' erras2'
!      call prtm(erras2,lo)
!
      if(jlatt.gt.0) call primi
!	call testmatic(ep)
!
!---test main condition
  1   continue
!      write(lo,*)'   dopo 1 aa '
!      call prce(aa,vol,lo)
!      write(lo,*)'   dopo 1 ep '
!      call prtm(ep,lo)
      ntent=ntent+1
!
!      write(lo,'(a,i3)') ' ntent =',ntent
      if(ntent.ge.20)then 
         write(lo,'(a)')' too many retry!!! solution aborted...'
         return
      endif
!
!      write(lo,*)' test main condition '
!
      call subr1
!	call testmatic(totmat)
!------------
      ec=0
      ec(1,1)=1
      ec(2,2)=1
      ec(3,3)=1
!
!-- tab.intern. b*c.le.0.5*b*b; a*c.le.0.5*a*a; a*b.le.0.5*a*a (2a)
!
!      write(lo,*)'b*c.le.0.5*b*b;a*c.le.0.5*a*a;a*b.le.0.5*a*a (2a)'
      i111=-i11
!
      err=sqrt(0.25*erras2(2,2)+erras2(2,3))
      x=aa(2,2)*.5-aa(2,3)*i111
      if(abs(x).gt.err.and.x.lt.0)then
               do   k=1,3
                   totmat(3,k)=totmat(3,k)+i11*totmat(2,k)
                   ec(3,k)=ec(3,k)+i11*ec(2,k)
               enddo
!	write(lo,*)' bc.le.0.5*bb... aa(2,3),aa(2,2)err',aa(2,3),aa(2,2),err
               call applicamat(ec)
!	         call testmatic(totmat)
               go to 1
      endif
      err=sqrt(0.25*erras2(1,1)+erras2(1,3))
      x=aa(1,1)*.5-aa(1,3)*i111
      if(abs(x).gt.err.and.x.lt.0)then
               do   k=1,3
                   totmat(3,k)=totmat(3,k)+i11*totmat(1,k)
                   ec(3,k)=ec(3,k)+i11*ec(1,k)
               enddo
!	write(lo,*)' ac.le.0.5*aa....,aa(1,3),aa(1,1),err',aa(1,3),aa(1,1),err
               call applicamat(ec)
!	         call testmatic(totmat)
               go to 1
      endif
      err=sqrt(0.25*erras2(1,1)+erras2(1,2))
      x=aa(1,1)*.5-aa(1,2)*i111
      if(abs(x).gt.err.and.x.lt.0)then
               do   k=1,3
                   totmat(2,k)=totmat(2,k)+i11*totmat(1,k)
                   ec(2,k)=ec(2,k)+i11*ec(1,k)
               enddo
!	write(lo,*)'ab.le.0.5*aa....,aa(1,2),aa(1,1),err',aa(1,2),aa(1,1),err
               call applicamat(ec)
!	         call testmatic(totmat)
               go to 1
        endif
!
        ec=0
        ec(1,1)=1
        ec(2,2)=1
        ec(3,3)=1
        if(i11.gt.0)then
!		   write(lo,*)' /b*c/+/a*c/+/a*b/.le.0.5*(a*a+b*b)' 
!-- tab.intern. /b*c/+/a*c/+/a*b/.le.0.5*(a*a+b*b)
             err=sqrt(erras2(2,3)+erras2(1,3)+erras2(1,2)+
     1           (0.25*(erras2(1,1))+erras2(2,2)))
             a1=abs(aa(2,3))
             a2=abs(aa(1,3))
             a3=abs(aa(1,2))
             a4=(a1+a2+a3)
             a5=(aa(1,1)+aa(2,2))*.5-a4
             if(a5.le.0.and.abs(a5).gt.err)then
                   ec=0
                   ec(1,1)=1
                   ec(2,2)=1
                   ec(3,3)=1
                   do k=1,3
                      totmat(3,k)=totmat(1,k)+totmat(2,k)+totmat(3,k)
                      ec(3,k)=ec(1,k)+ec(2,k)+ec(3,k)
                   enddo
!	write(lo,*)'  /b*c/+/a*c/+/a*b/.le.0.5*(a*a+b*b)'
                   call applicamat(ec)
!	             call testmatic(totmat)
                   go to 1
             endif
      endif
!
!----test special conditions
!      write(lo,'(a)') ' test special conditions'
!
      m=0
      if(i12.gt.0)m=i3a(i12)
      if(m.gt.0.and.i12.gt.0)then
         go to 1
      endif
!
      m=i3b(idum)
      if (m.gt.0)then
          go to 1
      endif
!
      m=0
      if(i11.gt.0)m=i3c(idum)
      if(m.gt.0)then
         go to 1
      endif
!
      ntest=ntest+1
!
      if(kpri.eq.1)then
        write(lo,8225)
8225    format(22x,'***   Cell parameters analysis   ***')
        write(lo,'(//,1x,a)') ititl
        write(lo,8230) ac(1:6)
        write(lo,8234) volac  
8230    format(/,' Primitive Reduced Cell (Niggli Cell):',/,
     *  5x,'    a =',f8.3,5x,'    b =',f8.3,5x,'    c =',f8.3,/,
     2  5x,'alpha =',f8.3,5x,' beta =',f8.3,5x,'gamma =',f8.3)
8234    format(5x,'Cell volume =',f13.2)
        write(lo,*)'            '
        write(lo,*)'Transformation Matrix ',
     1  'from the Input Cell to the Niggli Cell'
        call  prtm(totmat,lo)
      endif
!	call testmatic(totmat)
!
      call brava(iferrcell,kpri)
!	call testmatic(totmat)
      if (kpri.eq.1)then
          write(lo,8235)
      endif
8235  format(/,78('+'))
!
      return
      end
!
!code for calmet
      subroutine calmet(f,errf,xmet,errmet)
      USE General
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
      dimension f(6),errf(6),xmet(3,3),errmet(3,3)
!
!     creazione della metrica  e degli errori 
!
      do i=1,3
         f(i+3)=f(i+3)*dtr
         errf(i+3)=errf(i+3)*dtr
         xmet(i,i)=f(i)*f(i)
         errmet(i,i)=2*f(i)*errf(i)
      enddo
      rad90=90*dtr
      ca=0.0
      cb=0.0
      cc=0.0
      sa=1.0
      sb=1.0
      sc=1.0
      if(abs(f(4)-rad90).gt.errf(4))then
         ca=cos(f(4))
         sa=sin(f(4))
      endif
      if(abs(f(5)-rad90).gt.errf(5))then
         cb=cos(f(5))
         sb=sin(f(5))
      endif
      if(abs(f(6)-rad90).gt.errf(6))then
         cc=cos(f(6))
         sc=sin(f(6))
      endif
      xmet(1,2)=f(1)*f(2)*cc
      xmet(2,1)=xmet(1,2)
      errmet(1,2)=
     1abs(f(2)*cc*errf(1)+f(1)*cc*errf(2)-f(1)*f(2)*sc*errf(6))
      errmet(2,1)=errmet(1,2)
      xmet(1,3)=f(1)*f(3)*cb
      xmet(3,1)=xmet(1,3)
      errmet(1,3)=
     1abs(f(3)*cb*errf(1)+f(1)*cb*errf(3)-f(1)*f(3)*sb*errf(5))
      errmet(3,1)=errmet(1,3)
      xmet(2,3)=f(2)*f(3)*ca
      xmet(3,2)=xmet(2,3)
      errmet(2,3)=
     1abs(f(3)*ca*errf(2)+f(2)*ca*errf(3)-f(2)*f(3)*sa*errf(4))
      errmet(3,2)=errmet(2,3)
      return
      end
!
!code for subr1
      subroutine subr1
!
      USE General
      dimension ec(3,3),ic(3,3),c(3),aab(3,3),nn(3),jcod(26)
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
      data jcod/1,10,2,3,2,10,1,10,1,1,2,2,-10,
     ,2,1,1,-3,10,3,10,3,3,-1,10,-2,10/
!
!      write(lo,*)' subr1 '
!-----sortizza gli assi a<b<c
!      write(lo,*)' sort assi '
      ic=0
      ic(1,1)=1
      ic(2,2)=1
      ic(3,3)=1
      do i=1,3
         c(i)=aa(i,i)
      enddo
      j=minas(1,2)
      l1=minas(j,3)
      if(l1.eq.1)l2=minas(2,3)
      if(l1.eq.2)l2=minas(1,3)
      if(l1.eq.3)l2=minas(1,2)
      l3=6-l1-l2
!
      ec(1,1:3)=ic(l1,1:3)
      ec(2,1:3)=ic(l2,1:3)
      ec(3,1:3)=ic(l3,1:3)
!
      call applicamat(ec)
!
      aab=0.
      aab(1,1:3)=totmat(l1,1:3)
      aab(2,1:3)=totmat(l2,1:3)
      aab(3,1:3)=totmat(l3,1:3)
!
      totmat=aab
!	call testmatic(totmat)
!      write(lo,*)' sort assi totmat'
!      call prtm(totmat,lo)
!-----scambio del segno degli assi
!      write(lo,*)'jcod',jcod
!      write(lo,*)' scambia segno '
      ec=0
      do i=1,3
         ec(i,i)=1
      enddo
      c(1)=ac(6)
      c(2)=ac(4)
      c(3)=ac(5)
      do i=1,3
         err=errac(i+3)
         nn(i)=0
         d=c(i)-90.
         if(abs(d).le.err)cycle
         nn(i)=2
         if(d.lt.0)nn(i)=1
      enddo
      i=9*nn(1)+3*nn(2)+nn(3)
      i11=1
      if(i.ne.0)then
         i11=isign(1,jcod(i))
         n=iabs(jcod(i))
*        write(lo,*)'i,i11,n ',i,i11,n
         if(n.le.3)then
            ec(n,1:3)=-ec(n,1:3)
            totmat(n,1:3)=-totmat(n,1:3)
         endif
      endif
      call applicamat(ec)
!	call testmatic(totmat)
!      write(lo,*)' controllo destrorsa'
!-----controllo se destrorsa
      ec=0
      do i=1,3
         ec(i,i)=1
      enddo
      vm=det3x3(aa)
!      write(lo,*)'vm',vm
      if(vm.le.0) then
         do i=1,3
            do j=1,3
               ec(i,j)=-ec(i,j)
               totmat(i,j)=-totmat(i,j)
            enddo
         enddo
      endif
      call applicamat(ec)
!	call testmatic(totmat)
!
!
!-----definizione di i12 (assi uguali) a=b i12=1;b=c i12=2;a=b=c i12=3;no cond. i12=0
      c(1)=ac(1)
      c(2)=ac(2)
      c(3)=ac(3)
      i12=0
      do i=1,2
         err=sqrt(errac(i)**2+errac(i)**2)
         xb=abs(c(i)-c(i+1))
         if(xb-err.le.0) i12=i12+i
!         write(lo,*)'i,c,err,i12',i,c,err
      enddo
!      write(lo,'(a,2i3)')'subr1  i11 ,i12 ',i11,i12
!      write(lo,*)'fine subr1 '
      return
      end
!
!code for i3a
      function i3a(idum)
!
      USE General
!-- tab.intern. if(a*a.eq.b*b) then abs(b*c).le.abs(a*c)
!--       .and. if(c*c.eq.b*b) then abs(a*c).le.abs(a*b)
!
!
      dimension b(3),c(3),bb(3),ib(3),cerr(3),ec(3,3)
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
!
!      write(lo,*)'i3a '
      ec=0
      do i=1,3
         ec(i,i)=1
      enddo
      i3a=0
      if(i12.eq.1)then
  1      continue
         l=3
         n=3
         k=2
         m=1
      else if(i12.eq.2)then
         k=1
         m=1
         l=3
         n=2
      endif
      if(i12.lt.3)then
       err=0.
       if(erras2(k,l)+erras2(m,n).gt.0)err=sqrt(erras2(k,l)+erras2(m,n))
       x=abs(aa(k,l))-abs(aa(m,n))
!      write(lo,100)i3a,i12,n,x,err
100    format(1x,'i3a =', 3i3,2f10.3)
       if(x.le.err)return
       do i=1,3
          b(i)=totmat(i12,i)
          totmat(i12,i)=totmat(i12+1,i)
          totmat(i12+1,i)=b(i)
          b(i)=ec(i12,i)
          ec(i12,i)=ec(i12+1,i)
          ec(i12+1,i)=b(i)
	 enddo
	 ec=-1*ec
	 totmat=-1*totmat
       i3a=1
	 call applicamat(ec)
!	 call testmatic(totmat)
!      write(lo,100)i3a,i12,n,x,err
       return
	else if(i12.eq.3)then
       c(1)=abs(aa(2,3))
       c(2)=abs(aa(1,3))
       c(3)=abs(aa(1,2))
       cerr(1)=erras2(2,3)
       cerr(2)=erras2(1,3)
       cerr(3)=erras2(1,2)
!      write(lo,'(3f10.3)')c
!      write(lo,'(3f10.3)')cerr
  9    continue
       m=0
       do i=1,2
         err=sqrt(cerr(i)+cerr(i+1))
         cc=c(i)-c(i+1)
!        write(lo,*)'i,err,cc ',i,err,cc 
         if(cc.gt.err)then
            i3a=1
            do j=1,3
               b(j)=totmat(i,j)
               totmat(i,j)=totmat(i+1,j)
               totmat(i+1,j)=b(j)
               b(j)=ec(i,j)
               ec(i,j)=ec(i+1,j)
               ec(i+1,j)=b(j)
	      enddo
            bbb=c(i)
            c(i)=c(i+1)
            c(i+1)=bbb
            m=1
	   endif
	 enddo
       if(m.gt.0)go to 9
      endif
!              
      ec=-1*ec
	totmat=-1*totmat
	call applicamat(ec)
!	call testmatic(totmat)
      return
      end
!
!code for i3b
      function i3b(idum)
!
      USE General
!-- tab.intern. Type I:if(b*c.eq.0.5*b*b) then a*b.le.2*a*c
!--       .            if(a*c.eq.0.5*a*a) then a*b.le.2*b*c
!--       .            if(a*b.eq.0.5*a*a) then a*c.le.2*b*c
!--             Type II:if(b*c.eq.0.5*b*b) then a*b=0
!--       .             if(a*c.eq.0.5*a*a) then a*b=0
!--       .             if(a*b.eq.0.5*a*a) then a*c=0
!
!
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
      dimension ec(3,3)
!
!      write(lo,*)'i3b '
!      call prtm(aa,lo)
!      call prtm(erras2,lo)
      ec=0
      do i=1,3
         ec(i,i)=1
      enddo
      i3b=0
      if(i11.le.0)then
         err1=sqrt(erras2(2,3)+.25*erras2(2,2))
         a1=abs(abs(aa(2,3))-aa(2,2)*.5)
         err2=sqrt(erras2(1,3)+.25*erras2(1,1))
         a2=abs(abs(aa(1,3))-aa(1,1)*.5)
         err3=sqrt(erras2(1,2)+.25*erras2(1,1))
         a3=abs(abs(aa(1,2))-aa(1,1)*.5)
         dgen=0.
         errgen=0.
         if(a1-err1.le.0)then
!            write(lo,*)'2,3,,2,2,i11,err1,a1',i11,err1,a1
            dgen=aa(1,2)-aa(1,3)*2
            errgen=sqrt(erras2(1,2)+4*erras2(1,3))
            k=3
            m=1
            l=2
         else if(a2-err2.le.0)then
!            write(lo,*)'1,3,,1,1,i11,err2,a2',i11,err2,a2
            dgen=aa(1,2)-aa(2,3)*2
            errgen=sqrt(erras2(1,2)+4*erras2(2,3))
            k=3
            m=2
            l=1
         else if(a3-err3.le.0)then
!           write(lo,*)'1,2,,1,1,i11,err3,a3',i11,err3,a3
            dgen=aa(1,3)-aa(2,3)*2
            errgen=sqrt(erras2(1,3)+4*erras2(2,3))
            k=2
            m=3
            l=1
         endif
!
      else if(i11.gt.0)then
         err1=sqrt(erras2(2,3)+.25*erras2(2,2))
         a1=abs(abs(aa(2,3))-aa(2,2)*.5)
         err2=sqrt(erras2(1,3)+.25*erras2(1,1))
         a2=abs(abs(aa(1,3))-aa(1,1)*.5)
         err3=sqrt(erras2(1,2)+.25*erras2(1,1))
         a3=abs(abs(aa(1,2))-aa(1,1)*.5)
         dgen=0.
         errgen=0.
         if(a1-err1.le.0)then
!             write(lo,*)'2,3,,2,2,i11,err3,a1',i11,err3,a1
             dgen=abs(aa(1,2))
             errgen=erraa(1,2)
             k=3
             l=2
             m=1
         else if(a2-err2.le.0)then
!             write(lo,*)'1,2,,3,3,i11,err2,a2',i11,err2,a2
             dgen=abs(aa(1,2))
             errgen=erraa(1,2)
             k=3
             m=2
             l=1
         else if(a3-err3.le.0)then
!             write(lo,*)'1,2,,1,1,i11,err3,a3',i11,err3,a3
             dgen=abs(aa(1,3))
             errgen=erraa(1,3)
             k=2
             m=3
             l=1
         endif
      endif
!     write(lo,*)'dgen,errgen',dgen,errgen
      if(dgen-errgen.gt.0.)then
!             write(lo,*)'i3b,i11,k,l,m',i11,k,l,m
              i3b=1
              do ii=1,3
                 totmat(k,ii)=totmat(l,ii)+totmat(k,ii)*i11
                 totmat(k,ii)=-totmat(k,ii)
                 totmat(l,ii)=-totmat(l,ii)
                 totmat(m,ii)=totmat(m,ii)*i11
                 ec(k,ii)=ec(l,ii)+ec(k,ii)*i11
                 ec( k,ii)=-ec(k,ii)
                 ec(l,ii)=-ec(l,ii)
                 ec(m,ii)=ec(m,ii)*i11
              enddo
      endif
      call applicamat(ec)
!	call testmatic(totmat)
      return
      end
!
!code for i3c
      function i3c(idum)
!
      USE General
!-- tab.intern.:if(/b*c/+/a*c/+/a*b/.eq.0.5*(a*a+b*b) 
!--             then a*a.le.2*(/a*c/+/a*b/)
!
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
      dimension ec(3,3)
!
!      write(lo,*)'i3c '
      i3c=0
      ec=0
      do i=1,3
         ec(i,i)=1
      enddo
      abb=0.
      err=0
      do i=1,2
         do j=2,3
            if(i-j.ge.0) cycle
            err=err+erras2(i,j)
            abb=abb+abs(aa(i,j))
         enddo
      enddo
      b=abs(abb-0.5*(aa(1,1)+aa(2,2)))
      err=err+0.25*(erras2(1,1)+erras2(2,2))
      err=sqrt(err)
      if(b-err.gt.0)return
      err=sqrt(erras2(1,1)+4*(erras2(1,3)+erras2(1,2)))
      b=2*(abs(aa(1,3))+abs(aa(1,2)))-aa(1,1)
      if(abs(b).le.err.or.b.ge.err)return
      if((abs(b)-err).lt.err/100)return
      i3c=1
      do k=1,3
         totmat(3,k)=totmat(1,k)+totmat(2,k)+totmat(3,k)
         ec(3,k)=ec(1,k)+ec(2,k)+ec(3,k)
      enddo
      ec=-1*ec
      totmat=-1*totmat
      call applicamat(ec)
!	call testmatic(totmat)
      return
      end
!
!code for det3x3
      function det3x3(g)
!--determinant of a (3*3) matrix
!
      dimension g(3,3)
!
      det3x3=g(1,1)*g(2,2)*g(3,3)
     4      -g(1,1)*g(2,3)*g(3,2)
     5      -g(1,2)*g(2,1)*g(3,3)
     1      +g(1,2)*g(2,3)*g(3,1)
     2      +g(1,3)*g(2,1)*g(3,2)
     3      -g(1,3)*g(2,2)*g(3,1)

      return
      end
!
!code for prce
      subroutine prce(bb,vv,nx)
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
      dimension fff(6),bb(3,3)
!
      call calcel(bb,fff,vv)
      write(nx,2)fff,vv
 2    format(1x,3f10.3,/,1x,3f10.2,/,1x,'Vol = ',f8.2)
      return
      end
!
!code for calcel
      subroutine calcel(bb,f,vol)
      USE General
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
      dimension f(6),bb(3,3),errf(6),errbb(3,3)
!
      do i=1,3
         f(i)=sqrt(bb(i,i))
*        errf(i)=sqrt(errbb(i,i))
      enddo
      b=sqrt(bb(2,2)*bb(3,3))
      f(4)=acos(bb(2,3)/b)/dtr
      b=sqrt(bb(1,1)*bb(3,3))
      f(5)=acos(bb(1,3)/b)/dtr
      b=sqrt(bb(1,1)*bb(2,2))
      f(6)=acos(bb(1,2)/b)/dtr
!
      vol=sqrt(det3x3(bb))
      return
      end
!
!code for calcelerr
      subroutine calcelerr(bb,fxf,vol,errbb,errfxf,iferrcell)
      USE General
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
      dimension fxf(6),bb(3,3),errfxf(6),errbb(3,3)
!
      do i=1,3
         fxf(i)=sqrt(bb(i,i))
!        errfxf(i)=sqrt(errbb(i,i))
         if(iferrcell.eq.1)errfxf(i)=abs(errac(1)*totmat(i,1))
     1     +abs(errac(2)*totmat(i,2))+abs(errac(3)*totmat(i,3))
      enddo
      vol=sqrt(det3x3(bb))
!
      b=sqrt(bb(2,2)*bb(3,3))
      eff=acos(bb(2,3)/b)
      ca=cos(eff)
      sa=sin(eff)
      fxf(4)=eff/dtr
      b=sqrt(bb(1,1)*bb(3,3))
      eff=acos(bb(1,3)/b)
      cb=cos(eff)
      sb=sin(eff)
      fxf(5)=acos(bb(1,3)/b)/dtr
      b=sqrt(bb(1,1)*bb(2,2))
      eff=acos(bb(1,2)/b)
      cc=cos(eff)
      sc=sin(eff)
      fxf(6)=acos(bb(1,2)/b)/dtr
!
      if(iferrcell.eq.0)return
      errfxf(6)=abs(errbb(1,2)-
     1(fxf(2)*cc*errfxf(1)+fxf(1)*cc*errfxf(2))/fxf(1)*fxf(2)*sc)
!
      errfxf(5)=abs(errbb(1,3)-
     1(fxf(3)*cb*errfxf(1)+fxf(1)*cb*errfxf(2))/fxf(1)*fxf(3)*sb)
!
      errfxf(4)=abs(errbb(2,3)-
     1(fxf(3)*ca*errfxf(2)+fxf(2)*ca*errfxf(3))/fxf(2)*fxf(3)*sa)
!
      return
      end
!
!code for prtm
      subroutine prtm(c,nx)
      dimension c(3,3)
      do i=1,3
         write(nx,'(10x,3f10.4)') (c(i,j),j=1,3)
      enddo
      return
      end
!
!code for iprtm
      subroutine iprtm(ii,nx)
      dimension ii(3,3)
      do  i=1,3
         write(nx,'(10x,3i5)')(ii(i,j),j=1,3)
      enddo
      return
      end
!
!code for primi
      subroutine primi
      USE General
!     trasforma non primitiva in primitiva 
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
      dimension ep(3,3)
!
!     jlatt=  1,2,3,4,5,6/  a,b,c,f,i,r
!
      if(jlatt.eq.1)then
      write(lo,*)'Input Cell Type A ' 
!      k=minas(2,3)
!      ep(k,2)=0.5
!      ep(k,3)=0.5
!      ept(2,k)=0.5
!      ept(3,k)=0.5
      ep(1,1)=-1.
      ep(1,2)= 0.
      ep(1,3)= 0.
      ep(2,1)= 0.
      ep(2,2)=-0.5
      ep(2,3)= 0.5
      ep(3,1)= 0.
      ep(3,2)= 0.5
      ep(3,3)= 0.5
!
      else if(jlatt.eq.2)then
      write(lo,*)'Input Cell Type B ' 
!      k=minas(1,3)
!      ep(k,1)=0.5
!      ep(k,3)=0.5
      ep(1,1)=-0.5
      ep(1,2)= 0.
      ep(1,3)= 0.5
      ep(2,1)= 0.
      ep(2,2)=-1.
      ep(2,3)= 0.
      ep(3,1)= 0.5
      ep(3,2)= 0.
      ep(3,3)= 0.5
      else if(jlatt.eq.3)then
      write(lo,*)'Input Cell Type C ' 
!      k=minas(1,2)
!      ep(k,1)=0.5
!      ep(k,2)=0.5
!      ept(1,k)=0.5
!      ept(2,k)=0.5
      ep(1,1)= 0.5
      ep(1,2)= 0.5
      ep(1,3)= 0.
      ep(2,1)= 0.5
      ep(2,2)=-0.5
      ep(2,3)= 0.
      ep(3,1)= 0.
      ep(3,2)= 0.
      ep(3,3)=-1.
      else if(jlatt.eq.4)then
      write(lo,*)'Input Cell Type F ' 
!     do k=1,3
!     ep(k,k)=0.5
!	enddo
!     ep(1,2)=0.5
!     ep(2,3)=0.5
!     ep(3,1)=0.5
      ep=0.
      ep(1,2)=0.5
      ep(1,3)=0.5
      ep(2,1)=0.5
      ep(2,3)=0.5
      ep(3,1)=0.5
      ep(3,2)=0.5
      else if(jlatt.eq.5)then
      write(lo,*)'Input Cell Type I ' 
!      l=minas(1,2)
!      l=minas(l,3)
!      do k=1,3
!      ep(l,k)=0.5
!      ept(k,l)=0.5
!      enddo

      ep(1,1)=-0.5
      ep(1,2)= 0.5
      ep(1,3)= 0.5
      ep(2,1)= 0.5
      ep(2,2)=-0.5
      ep(2,3)= 0.5
      ep(3,1)= 0.5
      ep(3,2)= 0.5
      ep(3,3)=-0.5
!
      call  prtm(ep,lo)
      else if(jlatt.eq.6)then
      write(lo,*)'Input cell Type R '
      if(abs(aa(1,1)-aa(2,2)).lt.erraa(1,1).and.
     1   abs(aa(1,1)-aa(3,3)).lt.erraa(1,1).and. 
     1   abs(aa(1,2)-aa(1,3)).lt.erraa(1,2).and. 
     1   abs(aa(1,2)-aa(2,3)).lt.erraa(1,2))return 
!--Rh->Robv
      ep(1,1)= 2/3.
      ep(1,2)= 1/3.
      ep(1,3)= 1/3.
      ep(2,1)=-1/3.
      ep(2,2)= 1/3.
      ep(2,3)= 1/3.
      ep(3,1)=-1/3.
      ep(3,2)=-2/3.
      ep(3,3)= 1/3.
      call  prtm(ep,lo)
      endif
!	call testmatic(ep)
      totmat=ep
!      write(lo,*)'     primi---------------------------'
!      write(lo,*)' totmat'
!      call  prtm(totmat,lo)
      call applicamat(totmat)
!      write(lo,*)'fine primi---------------------------'
      return
      end
!
!code for TraspMat
      subroutine TraspMat(b, btras)
      dimension b(3,3), btras(3,3)
!
!
      do i = 1 , 3
         do j = 1 , 3
            btras(j,i)=b(i,j)
         enddo
      enddo
!
      return
      end
!
!code for NewMet
      subroutine NewMet(OldMet,B,xNewMet)
      common/com3/ erras2(3,3),errac(6),ac(6),ab(6),pgr,ncru,ncwu
      dimension xNewMet(3,3), OldMet(3,3), B(3,3),Bt(3,3)
      dimension ap(3,3)
!
! --- applica  la mat b alla metrica: New metrica=Btras*Met*B
!
      do i=1,3
         do j=1,3
            Bt(i,j)=B(j,i)
         enddo 
      enddo 
      call MoltMatMat(OldMet,Bt,ap)
!      write(lo,*)'NewMet ap=OldMet*B '
!      call prtm(ap,1,ncwu,ncwu,0,ncpu)
      call MoltMatMat(B,ap,xNewMet)
!      write(lo,*)'NewMet xNewMet=Bt*ap '
!      call prtm(xNewMet,1,ncwu,ncwu,0,ncpu)
!
      return
      end
!
!code for applicamat
      subroutine applicamat(ec)
      USE General, only : lo
!
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
      dimension ec(3,3)
      dimension xNewMet(3,3), OldMet(3,3)
!
      OldMet=aa
!	write(lo,*)'applicamat ec,Newaa,cell'
!      call prtm(aa,1,ncwu,ncwu,0,ncpu)
!      call prtm(ec,1,ncwu,ncwu,0,ncpu)
      call NewMet(OldMet,ec,xNewMet)
      aa=xNewMet
!--controllo degli angoli retti
      prob=3.
      if(aa(1,2).ne.0.and.abs(aa(1,2)).le.prob*erraa(1,2))aa(1,2)=0.0
      if(aa(1,3).ne.0.and.abs(aa(1,3)).le.prob*erraa(1,3))aa(1,3)=0.0
      if(aa(2,3).ne.0.and.abs(aa(2,3)).le.prob*erraa(2,3))aa(2,3)=0.0
!      call prtm(aa,lo)
!
      call calcel(aa,ac,volac)
!      call prce(aa,volac,lo)

      OldMet=erras2
      call NewMet(OldMet,ec,xNewMet)
      erras2=xNewMet
!
      do ii=1,3
         do ij=1,3
            erras2(ii,ij)=abs(erras2(ii,ij))
            erraa(ii,ij)=sqrt(erras2(ii,ij))
         enddo
      enddo
      return
      end
!
!code for testmatic
      subroutine testmatic(xc)
!
      USE General
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
      dimension ec(3,3),xc(3,3),adummy(3,3),aadummy(3,3),cellres(3,3)
      dimension xNewMet(3,3), OldMet(3,3),acdum(6),aares(3,3)
!
      ec=xc
      OldMet=aa0
!	write(lo,*)'testmatic ec='
      call prtm(ec,lo)
      write(lo,*)'aa0'
      call prtm(aa0,lo)
      call NewMet(OldMet,ec,xNewMet)
      aares=xNewMet
      write(lo,*)'aares '
      call prtm(aares,lo)
      write(lo,*)'aa '
      call prtm(aa,lo)
!
      call calcel(aares,cellres,vol)
!      nn=lo
      call prce(aares,vol,lo)
      write(lo,*)'fine testmatic '
      return
      end
!
!code for minas
      function minas(l,k)
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
!
      minas=l
      err=sqrt(erras2(k,k)+erras2(l,l))
      x=aa(l,l)-aa(k,k)
      if(x.gt.err)minas=k
!	write(lo,*)'minas: l,aa(l,l),k,aa(k,k) minas '
!	1,l,aa(l,l),k,aa(k,k),minas
      return
      end
!
!code for brava
      subroutine brava(iferrcell,kpri)
      USE General
!     verifica se la primitiva ridotta e' compatibile
!     con una simmetria superiore
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
      common/brav/x1,x2,x3,err1,err2,err3,epbrav(3,3),iffin
      common/cellanew/ cnew(6),volcnew,errcnew(6),cnewtrasf(3,3)
     1 ,lattcell,msyscell
      dimension ttras(3,3),it(3,3),tt(3,3),ttt(3,3)
!
      lattcell=0
      msyscell=-1
      igru=i12+1
!      write(lo,*)'brava 1 ac ',ac
!      write(lo,*)'aa '
!      call prtm(aa,lo)
!      write(lo,*)'erraa '
!      call prtm(erraa,lo)
!	write(lo,*)'brava igru',igru
!
      maggioresim=0
!
!--a=b=c
      if(igru.eq.4)then
            if(i11.eq.-1)then
      jx=1
!-- 1
      jfor=1
      x1=aa(1,1)/2
      x2=x1
      x3=x1
      err1=sqrt(erras2(2,3)+erras2(1,1)/4)
      err2=sqrt(erras2(1,3)+erras2(1,1)/4)
      err3=sqrt(erras2(1,2)+erras2(1,1)/4)
      if(jx.eq.1)jx=iconf3(jfor, 1,-1, 1,  1, 1,-1, -1, 1, 1)
!-- 2
      jfor=2
      x1= aa(2,3)
      x2=x1
      x3=x1
      err1=erraa(2,3)
      err2=sqrt(erras2(1,3)+erras2(2,3))
      err3=sqrt(erras2(1,2)+erras2(2,3))
!	write(lo,*)'jfor,x1,x2,x3,err1,err2,err3 ' 
!	1,jfor,x1,x2,x3,err1,err2,err3
        if(jx.eq.1)jx=iconf3(jfor, 1,-1, 0, -1, 0, 1, -1,-1,-1)
            else if(i11.eq.1)then
              jx=1
!-- 3
      jfor=3
      x1=0.
      x2=x1
      x3=x1
      err1=erraa(2,3)
      err1=erraa(1,3)
      err1=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 0,  0, 1, 0,  0, 0, 1)
      maggioresim=1
!-- 5
      jfor=4
      x1=-aa(1,1)/3.
      x2=x1
      x3=x1
      err1=sqrt(erras2(2,3)+erras2(1,1)/9)
      err2=sqrt(erras2(1,3)+erras2(1,1)/9)
      err3=sqrt(erras2(1,2)+erras2(1,1)/9)
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 1,  1, 1, 0,  0, 1, 1)
!-- 4
      jfor=2
      x1=aa(2,3)
      x2=x1
      x3=x1
      err1=erraa(2,3)
      err2=sqrt(erras2(2,3)+erras2(1,3))
      err3=sqrt(erras2(2,3)+erras2(1,2))
      if(jx.eq.1)jx=iconf3(jfor, 1,-1, 0, -1, 0, 1, -1,-1,-1)
!-- 6
      jfor=5
      x=2*abs(aa(2,3)+aa(1,3)+aa(1,2))-(aa(1,1)+aa(2,2))
      errx=sqrt(abs(erras2(2,3)+erras2(1,3)+erras2(1,2)
     1+erras2(1,1)+erras2(2,2)))
      if(abs(x).le.errx)then
      x1=aa(2,3)
      x2=x1
      x3=aa(1,2)
      err1=erraa(2,3)
      err2=sqrt(erras2(2,3)+erras2(1,3))
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 0, 1, 1,  1, 0, 1,  1, 1, 0)
      endif
!-- 7
      jfor=5
      x=2*abs(aa(2,3)+aa(1,3)+aa(1,2))-(aa(1,1)+aa(2,2))
      errx=sqrt(abs(erras2(2,3)+erras2(1,3)+erras2(1,2)
     1+erras2(1,1)+erras2(2,2)))
      if(abs(x).le.errx)then
!	if(2*abs(aa(2,3)+aa(1,3)+aa(1,2)).eq.aa(1,1)+aa(2,2))then
      x1=aa(2,3)
      x2=aa(1,3)
      x3=x1
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=sqrt(erras2(2,3)+erras2(1,2))
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 1,  1, 1, 0,  0, 1, 1)
      endif
!-- 8
      jfor=6
      x=2*abs(aa(2,3)+aa(1,3)+aa(1,2))-(aa(1,1)+aa(2,2))
      errx=sqrt(abs(erras2(2,3)+erras2(1,3)+erras2(1,2)
     1+erras2(1,1)+erras2(2,2)))
      if(abs(x).le.errx)then
!	if(2*abs(aa(2,3)+aa(1,3)+aa(1,2)).eq.aa(1,1)+aa(2,2))then
      x1=aa(2,3)
      x2=aa(1,3)
      x3=aa(1,2)
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor,-1,-1, 0, -1, 0,-1,  0,-1,-1)
      endif
            endif
!
!--a=b
!
      else if(igru.eq.2)then
!
!
!
            if(i11.eq.-1)then
               jx=1
!-- 9
      jfor=2
      x1=aa(1,1)/2
      x2=x1
      x3=x1
      err1=sqrt(erras2(2,3)+erras2(1,1)/4)
      err2=sqrt(erras2(1,3)+erras2(1,1)/4)
      err3=sqrt(erras2(1,2)+erras2(1,1)/4)
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 0, -1, 1, 0, -1,-1, 3)
!--10
      jfor=7
      x1=aa(2,3)
      x2=x1
      x3=aa(1,2)
      err1=erraa(2,3)
      err2=sqrt(erras2(2,3)+erras2(1,3))
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 1, 1, 0,  1,-1, 0,  0, 0,-1)
            else if(i11.eq.1)then
      jx=1
!--11
      jfor=8
      x1=0.
      x2=x1
      x3=x1
      err1=erraa(2,3)
      err2=sqrt(erras2(2,3)+erras2(1,3))
      err3=sqrt(erras2(2,3)+erras2(1,2))
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 0,  0, 1, 0,  0, 0, 1)
      maggioresim=1
!--12
      jfor=9
      x1=0.
      x2=x1
      x3=-aa(1,1)/2
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=sqrt(erras2(1,2)+erras2(1,1)/4)
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 0,  0, 1, 0,  0, 0, 1)
      maggioresim=1
!--13
      jfor=10
      x1=0.
      x2=x1
      x3=aa(1,2)
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 1, 1, 0, -1, 1, 0,  0, 0, 1)
!--15
      jfor=5
      x1=-aa(1,1)/2
      x2=x1
      x3=0.
      err1=sqrt(erras2(2,3)+erras2(1,1)/4)
      err2=sqrt(erras2(1,3)+erras2(1,1)/4)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 0,  0, 1, 0,  1, 1, 2)
!--16
      jfor=11
      x=2*abs(aa(2,3)+aa(1,3)+aa(1,2))-(aa(1,1)+aa(2,2))
      errx=sqrt(abs(erras2(2,3)+erras2(1,3)+erras2(1,2)
     1+erras2(1,1)+erras2(2,2)))
      if(abs(x).le.errx)then
!	if(2*abs(aa(2,3)+aa(1,3)+aa(1,2)).eq.aa(1,1)+aa(2,2))then
      x1=aa(2,3)
      x2=x1
      x3=aa(1,2)
      err1=erraa(2,3)
      err2=sqrt(erras2(1,3)+erras2(2,3))
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor,-1,-1, 0,  1,-1, 0,  1, 1, 2)
      endif
!--14
      jfor=7
      x1=aa(2,3)
      x2=x1
      x3=aa(1,2)
      err1=erraa(2,3)
      err2=sqrt(erras2(1,3)+erras2(2,3))
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 1, 1, 0, -1, 1, 0,  0, 0, 1)
!--17
      jfor=7
      x=2*abs(aa(2,3)+aa(1,3)+aa(1,2))-(aa(1,1)+aa(2,2))
      errx=sqrt(abs(erras2(2,3)+erras2(1,3)+erras2(1,2)
     1+erras2(1,1)+erras2(2,2)))
      if(abs(x).le.errx)then
!	if(2*abs(aa(2,3)+aa(1,3)+aa(1,2)).eq.aa(1,1)+aa(2,2))then
      x1=aa(2,3)
      x2=aa(1,3)
      x3=aa(1,2)
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 1,-1, 0,  1, 1, 0, -1, 0,-1)
      endif
            endif
!            
!            
!
!--b=c
!
      else if(igru.eq.3)then
!
!
!
            if(i11.eq.-1)then
      jx=1
!--18
      jfor=5
      x1=aa(1,1)/4
      x2=aa(1,1)/2
      x3=x2
      err1=sqrt(erras2(2,3)+erras2(1,1)/16)
      err2=sqrt(erras2(1,3)+erras2(1,1)/4)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 0,-1, 1,  1,-1,-1,  1, 0, 0)
!--19
      jfor=6
      x1=aa(2,3)
      x2=aa(1,1)/2
      x3=x2
      err1=erraa(2,3)
      err2=sqrt(erras2(1,3)+erras2(1,1)/4)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor,-1, 0, 0,  0,-1, 1, -1, 1, 1)
!--20
      jfor=7
      x1=aa(2,3)
      x2=aa(1,3)
      x3=x2
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=sqrt(erras2(1,2)+erras2(1,3))
      if(jx.eq.1)jx=iconf3(jfor, 0, 1, 1,  0, 1,-1, -1, 0, 0)
            else if(i11.eq.1)then
      jx=1
!--21
      jfor=8
      x1=0.
      x2=x1
      x3=x1
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 0, 1, 0,  0, 0, 1,  1, 0, 0)
!--22
      jfor=9
      x1=-aa(2,2)/2
      x2=0.
      x3=x2
      err1=sqrt(erras2(2,3)+erras2(2,2)/4)
      err2=erraa(1,3)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 0, 1, 0,  0, 0, 1,  1, 0, 0)
!--23
      jfor=10
      x1=aa(2,3)
      x2=0.
      x3=x2
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 0, 1, 1,  0,-1, 1,  1, 0, 0)
!--24
      jfor=2
      x=2*abs(aa(2,3)+aa(1,3)+aa(1,2))-(aa(1,1)+aa(2,2))
      errx=sqrt(abs(erras2(2,3)+erras2(1,3)+erras2(1,2)
     1+erras2(1,1)+erras2(2,2)))
!	 write(lo,*)'jx,x,errx ',jx,x,errx
!
      if(abs(x).le.errx)then
      x1=aa(2,3)
      x2=-aa(1,1)/3
      x3=x2
      err1=erraa(2,3)
      err2=sqrt(erras2(1,3)+erras2(1,1)/9)
      err3=sqrt(erras2(1,2)+erras2(1,1)/9)
      if(jx.eq.1)jx=iconf3(jfor, 1, 2, 1,  0,-1, 1,  1, 0, 0)
!	 write(lo,*)'jx,x1,x2,x3,err1,err2,err3 ',
!     1 jx,x1,x2,x3,err1,err2,err3 
      endif
!--25
      jfor=7
      x1=aa(2,3)
      x2=aa(1,3)
      x3=x2
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=sqrt(erras2(1,2)+erras2(1,3))
      if(jx.eq.1)jx=iconf3(jfor, 0, 1, 1,  0,-1, 1,  1, 0, 0)
            endif
!
!
!
!--a.ne.b.ne.c
!
      else if(igru.eq.1)then
!
!
!
            if(i11.eq.-1)then
      jx=1
!--26
      jfor=11
      x1=aa(1,1)/4
      x2=aa(1,1)/2
      x3=x2
      err1=sqrt(erras2(2,3)+erras2(1,1)/16)
      err2=sqrt(erras2(1,3)+erras2(1,1)/4)
      err3=sqrt(erras2(1,2)+erras2(1,1)/4)
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 0, -1, 2, 0, -1, 0, 2)
!--27
      jfor=7
      x1=aa(2,3)
      x2=aa(1,1)/2
      x3=x2
      err1=erraa(2,3)
      err2=sqrt(erras2(1,3)+erras2(1,1)/4)
      err3=sqrt(erras2(1,2)+erras2(1,1)/4)
      if(jx.eq.1)jx=iconf3(jfor,-1, 2, 0, -1, 0, 0,  0,-1, 1)
!--28
      jfor=7
      x1=aa(2,3)
      x2=aa(1,1)/2
      x3=2*aa(2,3)
      err1=erraa(2,3)
      err2=sqrt(erras2(1,3)+erras2(1,1)/4)
      err3=sqrt(erras2(1,2)+4*erras2(2,3))
      if(jx.eq.1)jx=iconf3(jfor,-1, 0, 0, -1, 0, 2,  0, 1, 0)
!--29
      jfor=7
      x1=aa(2,3)
      x2=2*aa(2,3)
      x3=aa(1,1)/2
      err1=erraa(2,3)
      err2=sqrt(erras2(1,3)+4*erras2(2,3))
      err3=sqrt(erras2(1,2)+erras2(1,1)/4)
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 0,  1,-2, 0,  0, 0,-1)
!--30
      jfor=7
      x1=aa(2,2)/2
      x2=aa(1,3)
      x3=2*aa(1,3)
      err1=sqrt(erras2(2,3)+erras2(2,2)/4)
      err2=erraa(1,3)
      err3=sqrt(erras2(1,2)+4*erras2(1,3))
      if(jx.eq.1)jx=iconf3(jfor, 0, 1, 0,  0, 1,-2, -1, 0, 0)
!--31
      jfor=12
      x1=aa(2,3)
      x2=aa(1,3)
      x3=aa(1,2)
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=erraa(1,2)
!      write(6,'(a,2f8.3)')'31 x1,err1 ',x1,err1
!      write(6,'(a,2f8.3)')'31 x2,err2 ',x2,err2
!      write(6,'(a,2f8.3)')'31 x3,err3 ',x3,err3
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 0,  0, 1, 0,  0, 0, 1)
      maggioresim=1
!      write(lo,*)'brava 31 jx ac ',jx,ac
            else if(i11.eq.1)then
      jx=1
!--32
      jfor=13
      x1=0.
      x2=x1
      x3=x1
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 0,  0, 1, 0,  0, 0, 1)
!--40
      jfor=10
      x1=-aa(2,2)/2
      x2=0.
      x3=x2
      err1=sqrt(erras2(2,3)+erras2(2,2)/4)
      err2=erraa(1,3)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 0,-1, 0,  0, 1, 2, -1, 0, 0)
!--35
      jfor=14
      x1=aa(2,3)
      x2=0.
      x3=x2
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 0,-1, 0, -1, 0, 0,  0, 0,-1)
!--36
      jfor=10
      x1=0.
      x2=-aa(1,1)/2
      x3=x1
      err1=erraa(2,3)
      err2=sqrt(erras2(1,3)+erras2(1,1)/4)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 0, -1, 0,-2,  0, 1, 0)
!--33
      jfor=14
      x1=0.
      x2=aa(1,3)
      x3=x1
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 0,  0, 1, 0,  0, 0, 1)
      maggioresim=1
!--38
      jfor=10
      x1=0.
      x2=x1
      x3=-aa(1,1)/2
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=sqrt(erras2(1,2)+erras2(1,1)/4)
      if(jx.eq.1)jx=iconf3(jfor,-1, 0, 0,  1, 2, 0,  0, 0,-1)
!--34
      jfor=14
      x1=0.
      x2=x1
      x3=aa(1,2)
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor,-1, 0, 0,  0, 0,-1,  0,-1, 0)
!--42
      jfor=6
      x1=-aa(2,2)/2
      x2=-aa(1,1)/2
      x3=0.
      err1=sqrt(erras2(2,3)+erras2(2,2)/4)
      err2=sqrt(erras2(1,3)+erras2(1,1)/4)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor,-1, 0, 0,  0,-1, 0,  1, 1, 2)
!--41
      jfor=7
      x1=-aa(2,2)/2
      x2=aa(1,3)
      x3=0.
      err1=sqrt(erras2(2,3)+erras2(2,2)/4)
      err2=erraa(1,3)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor,  0,-1,-2,  0,-1, 0, -1, 0, 0)
!--37
      jfor=7
      x1=aa(2,3)
      x2=-aa(1,1)/2
      x3=0.
      err1=erraa(2,3)
      err2=sqrt(erras2(1,3)+erras2(1,1)/4)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 2,  1, 0, 0,  0, 1, 0)
!--39
      jfor=7
      x1=aa(2,3)
      x2=0.
      x3=-aa(1,1)/2
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=sqrt(erras2(1,2)+erras2(1,1)/4)
!      write(6,'(a,2f8.3)')'39 x1,err1 ',x1,err1
!      write(6,'(a,2f8.3)')'39 x2,err2 ',x2,err2
!      write(6,'(a,2f8.3)')'39 x3,err3 ',x3,err3
      if(jx.eq.1)jx=iconf3(jfor,-1,-2, 0, -1, 0, 0,  0, 0,-1)
!--43
      jfor=7
      x=2*abs(aa(2,3)+aa(1,3)+aa(1,2))-(aa(1,1)+aa(2,2))
      errx=sqrt(abs(erras2(2,3)+erras2(1,3)+erras2(1,2)
     1+erras2(1,1)+erras2(2,2)))
!      write(6,'(a,2f8.3)')'43 1,x,errx ',x,errx
      if(abs(x).le.errx)then
      x=abs( 2*aa(2,3)+aa(1,2) )-aa(2,2) 
      errx=sqrt(abs(erras2(2,3)+erras2(1,2)+erras2(2,2)))
!      write(6,'(a,2f8.3)')'43 2,x,errx ',x,errx
      if(abs(x).le.errx)then
      x1=aa(2,3)
      x2=aa(1,3)
      x3=aa(1,2)
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor,-1, 0, 0, -1,-1,-2,  0,-1, 0)
      endif
      endif
!--44
      jfor=12
      x1=aa(2,3)
      x2=aa(1,3)
      x3=aa(1,2)
      err1=erraa(2,3)
      err2=erraa(1,3)
      err3=erraa(1,2)
      if(jx.eq.1)jx=iconf3(jfor, 1, 0, 0,  0, 1, 0,  0, 0, 1)
      maggioresim=1
            endif
!
!
!
      endif
500   continue
!      maggioresim=1
!      do i=1,6
!         if(abs(ac0(i)-ac(i)).gt.errac(i))maggioresim=0
!      enddo
!
      if(maggioresim.eq.0)then
!-- salva su cnew
      call calcelerr(aa,cnew,vol,erras2,errcnew,iferrcell)
!      cnew(1:6)=ac(1:6)
!      errcnew(1:6)=errac(1:6)
      cnewtrasf(1:3,1:3)=totmat(1:3,1:3)
!     
      write(lo,*)'    ' 
      write(lo,*)' Possible High Symmetry Cell: '
      if (iffin.eq.1) then
      write(lo,*)' Cubic   cF'
      msyscell=7
      lattcell=6
      else if(iffin.eq.2)then
      write(lo,*)' Rhombohedral   hR'
      msyscell=6
      lattcell=6
      else if(iffin.eq.3)then
       write(lo,*)' Cubic   cP'
      msyscell=7
      lattcell=0
      else if(iffin.eq.4)then
       write(lo,*)' Cubic   cI'
      msyscell=7
      lattcell=5
      else if(iffin.eq.5)then
       write(lo,*)' Tetragonal   tI'
      msyscell=5
      lattcell=5
      else if(iffin.eq.6)then
       write(lo,*)' Orthorhombic  oI'
      msyscell=4
      lattcell=5
      else if(iffin.eq.7)then
       write(lo,*)' Monoclinic   mC'
      msyscell=2
      lattcell=3
      else if(iffin.eq.8)then
       write(lo,*)' Tetragonal   tP'
      msyscell=5
      lattcell=0
      else if(iffin.eq.9)then
       write(lo,*)' Hexagonal   hP'
      msyscell=6
      lattcell=0
      else if(iffin.eq.10)then
      write(lo,*)' Orthorhombic   oC'
      msyscell=4
      lattcell=3
      else if(iffin.eq.11)then
      write(lo,*)' Orthorhombic   oF'
      msyscell=4
      lattcell=4
      else if(iffin.eq.12)then
      write(lo,*)' Triclinic   aP'
      msyscell=0
      lattcell=0
      else if(iffin.eq.13)then
      write(lo,*)' Orthorhombic   oP'
      msyscell=4
      lattcell=0
      else if(iffin.eq.14)then
      write(lo,*)' Monoclinic   mP'
      msyscell=2
      lattcell=0
      endif
3050  continue
      write(lo,8230) cnew(1:6)
      if(iferrcell.eq.1)write(lo,8232) errcnew(1:6)
      write(lo,8234) volac  
8230  format(/,5x,'    a =',f8.3,5x,'    b =',f8.3,5x,'    c =',f8.3,/,
     2 5x,'alpha =',f8.3,5x,' beta =',f8.3,5x,'gamma =',f8.3)
8232  format( 'Errors',/,
     * 5x,'    a =',f8.3,5x,'    b =',f8.3,5x,'    c =',f8.3,/,
     2 5x,'alpha =',f8.3,5x,' beta =',f8.3,5x,'gamma =',f8.3)
8234  format(5x,'Cell volume =',f13.2)
      write(lo,*)'            '
      write(lo,*)'     Transformation ',
     1'from the Input Cell to the High Symmetry Cell '
      write(lo,*)'       Transformation Matrix for Axes and Reflections'
      call  prtm(totmat,lo)
      callTraspMat(totmat, ttras)
      call inv3r(ttras,det,tt)
      write(lo,*)'       Transformation Matrix for Atomic Coordinates'
      call  prtm(tt,lo)
      write(lo,*)' '
      write(lo,*)' '
      else
      write(lo,*)' '
      write(lo,*) 'No possible Higher Symmetry Cells '
      endif
      return
      end
!
!code for icfin
      subroutine icfin(jl1,jl2,jl3,jl4,jl5,jl6,jl7,jl8,jl9)
      USE General
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
!mr      common/brav/x1,x2,x3,err1,err2,err3,epbrav(3,3)
      common/brav/x1,x2,x3,err1,err2,err3,epbrav(3,3),iffin
      dimension ict(3,3),at(3,3),x(3,3),ep(3,3)
!
!      write(lo,*)'jl1,jl2,jl3,jl4,jl5,jl6,jl7,jl8,jl9 ',
!	1jl1,jl2,jl3,jl4,jl5,jl6,jl7,jl8,jl9
!
      epbrav(1,1)=jl1
      epbrav(1,2)=jl2
      epbrav(1,3)=jl3
      epbrav(2,1)=jl4
      epbrav(2,2)=jl5
      epbrav(2,3)=jl6
      epbrav(3,1)=jl7
      epbrav(3,2)=jl8
      epbrav(3,3)=jl9
!
      call applicamat(epbrav)
      call MoltMatMat(epbrav,totmat,ep)
!     write(lo,*)'icfin ep=totmat*epbrav,totmat,epbrav,ep'
!     call  prtm(totmat,lo)
!     call  prtm(epbrav,lo)
!     call  prtm(ep,lo)
      do i=1,3
         totmat(i,1:3)=ep(i,1:3)
      enddo
!     write(lo,*)'2 totmat'
!     call  prtm(totmat,lo)
!     call testmatic(totmat)
      return
      end
!
!code for iconf
      function iconf(i,j,x,err)
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
!
!     iconf=-1    aa(i,j) < x
!     iconf= 1    aa(i,j) > x
!     iconf= 0    aa(i,j) = x
      iconf=1
      if(i.le.0)then
         y=x
      else
         ya=aa(i,j)
!         if(i11.gt.0)ya=abs(ya)
         y=ya-x
      endif
 12   continue
      iconf=0
!      write(6, '(a,3i5,4f8.2)')'iconf , i,j,aa(i,j),x,y,err',
!     1 iconf , i,j,aa(i,j),x,y,err
      if(abs(y).le.err)return
      iconf=1
      if(y.gt.0)return
      iconf=-1
      return
      end
!
!code for iconf3
!
      function iconf3(jform,j1,j2,j3,j4,j5,j6,j7,j8,j9)
      USE General
      common/commcell/ ac(6),volac,errac(6),ac0(6),aa(3,3),erras2(3,3)
     1,erraa(3,3),aa0(3,3),erras20(3,3),totmat(3,3)
     1,jlatt,i11,i12,maggioresim
      common/brav/x1,x2,x3,err1,err2,err3,epbrav(3,3),iffin
!
      iconf3=1
      i1=iconf(2,3,x1,err1)
      i2=iconf(1,3,x2,err2)
      i3=iconf(1,2,x3,err3)
      if(i1.eq.0.and.i2.eq.0.and.i3.eq.0)then
         iconf3=0
         call icfin(j1,j2,j3,j4,j5,j6,j7,j8,j9)
         iffin=jform
!	   write(lo,'(a,2i10,/,3(3i4,/))')'iconf3, iffin ',iconf3,iffin
      endif
      return
      end
!      
!-----------------------------------------------------------------------
!--routine da GEOM.f
!-----------------------------------------------------------------------
!
!code for pur
      subroutine pur(x1,x2,pd,x3)
!--punti di una retta
!
      dimension x1(*),x2(*),x3(*)
      idm = 3
      do i=1,idm
      x3(i) = x1(i)+(x2(i)-x1(i))*pd
      enddo
      return
      end
!
!code for bis
      subroutine bis(g,x1,x2,x3,x4)
!--point of  bisectrix
!
      dimension x1(*),x2(*),x3(*),x4(*),g(*)
      dimension x5(3),x6(3)
      call vlen(g,x2,x1,d2)
      call vlen(g,x3,x1,d3)
      pd2 = 1./d2
      pd3 = 1./d3
      call pur (x1,x2,pd2,x5)
      call pur(x1,x3,pd3,x6)
      x4(1) = 0.5*(x6(1)+x5(1))
      x4(2) = 0.5*(x6(2)+x5(2))
      x4(3) = 0.5*(x6(3)+x5(3))
      return
      end
!
!code for pnr
      subroutine pnr(x1,x2,x3,g,gr,pr)
!-----plane perpendicular to line
!
      dimension x1(*),x2(*),x3(*),g(*),gr(*)
      dimension p(4),pr(4)
      call vcmp(x1,x2,p)
      call mv(g,p,pr)
      call norm(p,pr)
      call ospr(x3,pr,b)
      pr(4) = b
      return
      end
