#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include "mrconfig.h"
#include "callbacks.h"
#include <gtkmrcomune.h>
#include <settings.h>
#include "aliasx.h"
#include "sir.h"
#include <glext.h>
#include <models.h>
#include <filtri.h>
// #define USE_PIE 1

namespace main_app {
       extern Application TheApp;
                   }

#define CIRCLE_RAD 100
#define CIRCLE_BOR  10
static const char *filexts[] = {"*.sir", "*.bin", "*.sav", "*.mdl",
                          "*.fra", "*.fil", "*.ins", "*.pdb",
                          "*.hkl", "*.prj", "*.mdl", "*.exe", "*.exe",
                          "*.cif", "*.fhz", "*.mop", "All files"};
typedef struct{ 
         nomefile file1, file2,file3, file4;
         int  n1, n2, n3, n4;
              } multistringa;

typedef struct {
                char stringa[1000];
                int  n1;
              } Megastringa;

//extern const char *FilesToImport;
extern "C" void set_style_(int *ps, int *which);
extern "C" void  putlab95_ (multistringa *inpfile, int *ier);
extern "C" void  importa_file_ (multistringa *inpfile, int *tipo);
extern "C" void  importa_file2_ (multistringa *inpfile);
extern "C" void  openjavviewer_();
extern "C" void  lanciajavs_(int *ifMappa, int *ifd);
extern "C" void  onopen_();
extern "C" void  cflush_();
extern "C" void  save_restore_mdl_(multistringa *inpfile, int *tipo);
extern "C" int   labtoatom_       (int *x, int *y, multistringa *ms);
extern "C" void  drawlabels_      ();
extern "C" void  get_allcom_      (str14 allcomm[]);
extern "C" void  cancellagruppo_  (multistringa *ms);
extern "C" void  aggiungigruppo_  (multistringa *ms);
extern "C" void  setgruppodefault_(multistringa *ms);
extern "C" void  copiagruppo_     (multistringa *ms, int *ier);
extern "C" void  drawgroups_      (int *ier, int *ambiente);
extern "C" void  drawonegroup_    (int *action, int *ngr, int *nCard, multistringa *ms);
extern "C" void  drawonerotamer_  (int *action, multistringa *ms);
extern "C" void  f_rotamers_      (int *nass, Megastringa *ms);
extern "C" void  f_rigidbody_     (int *nass, Megastringa *ms);
extern "C" void  getnewnw_        (int *nww);
extern "C" void  putnewnw_        (int *nww);
extern "C" void checkghostsforc_  (int *ier);

static GdkColor colorBlck =  Black;
//static GdkColor colorYellow =  Yellow;
//static GdkColor colorBlue =  Blue;
static GdkColor colorWhite =  White;
//static GdkColor colorRed =  Red;
//static GdkColor colorGreen =  Green;
extern GdkCursor *default_cursor, *wait_cursor;
extern gchar *Sigle[NUMSPECIES];
extern char *Specie[NUMSPECIES];
extern int  no[NUMSPECIES];
extern int   nSpec, nw[NUMSPECIES];
extern GdkColor BgColor;

extern "C" _Liste *liste;
extern "C" _Project *prj;
extern "C" _CContour *Contour;
extern "C" _PlotOpts *Options;
extern "C" _LSQinfo *clsqgtk;
extern "C" _Limfour *limits;
extern _Dialogo *dialogo;
extern "C" Tasti *tasti;
extern "C" _SWareRC *SWareRC;

extern int curSmiley, curSmileySav;
extern gboolean show_toolbar, can_drag, single_it, viewerOpened;
extern int Livcur, jscreen, altSaveP;
extern GtkWidget *finestre[6];
extern GdkWindow *outWindow, *outPix;
extern gboolean ifToolbar, ifMenubar, ifStatusbar;
extern const char *toolbarname[5];
extern signed char dash_list[];
extern GdkCursor *cross_cursor, *default_cursor,
          *drag1_cursor, *drag2_cursor;
extern int larSaveN;
extern gboolean statoinimb[6][150];
extern int altSaveP;
extern PangoFontDescription *fontdescP, *fontdescN, *fontdescU;
extern int ifContinueRot;
extern int Livcur;

static gboolean disegnarettangolo;
static int num_max_click = 0;
static int ok_clicked = 0;
static GtkWidget *CurrentToolBar = NULL;
static gpointer CurrentStringSelected;
static int npoints;
static int gsel_mode;
static gboolean def_vec = FALSE;
static gboolean start_drag = TRUE;
static const char *layers[] = {"A", "B", "C", "X", "Y", "Z"};
static GtkWidget *cont_dlg1 = NULL, *cont_dlg2 = NULL, *cont_dlg3 = NULL;
static int RadioSelected;
static GtkWidget *model_cont = NULL;
static int lcolor[5];
static int lval[5];
static int lvis[5];
static float limiti[3][2];
static float asy[2][3];
static float c_center[3];
static float c_delta[3];
static int Xiniz = -1;
static int Yiniz = -1;
static int Wrect, Hrect;
//static gboolean primavolta = TRUE;
static int cod_polyg;
static const char *altri[] = {"Ghost atoms", "Bonds", "Labels", "Cell edges",
                        "Restraints", "\0"};
extern int         nElemVett;
extern _matrice    ipixLab;
extern _matrice    ipix;
extern stringa     *It;
extern int         *ifLabelsVis;
extern int         *nzTot;
extern int         *SinglePlotStyle;
static _StyleType FrameStyle = {true, 1, NULL, GTK_SHADOW_ETCHED_IN, 2, 2, 8, 2};

bool ifSannel = false;
int ngrid[3];
guint entry_hnd = 0;
char old_name[20];
int if_std_lsq_restr = 0;     /* = 0 se provenienza standard,
                                 = 1 se provenienza LSQ,
                                 = 2 se provenienza Set Restraints 
                                 = 3 se provenienza  Geometric calculations 
                                 = 4 se provenienza  select to change P.S.  */
int ifOneAtom = 0;

int  CurrentLab;
gboolean movingLabel = FALSE;        /* sto spostando una label */
gboolean ifMoveLabels = FALSE;       /* sono nell'ambiente Move Labels */
gboolean ifMoveCube = FALSE;         /* sono nell'ambiente Fourier */
int ifContinueRot = 0;

void salva_stato_mb(GtkWidget *widget, gboolean stato_sav[]);
void manage_ok_restr (int from);
void manage_ok_geom(int from);
void manage_ok_ps(int from);
int  open_singlehydro (int wizard, int natom);
void seleziona(void);
void draw_cross(int ixx, int iyy, int col);
int open_polycol_dlg(int n, char *sites[], int pcolors[]);
void change_section(GtkWidget *widget,  gpointer data);
void draw_initial_pixmap();
void dashed_rectangle (int ix, int iy, int w, int h);
void quit_program (GtkWidget *widget, gpointer data);
void set_color_row(GtkWidget *pix, int iColor);
int getStructName(char *file1, char *file2);
void cDrawLabels();
void changeCube(int px, int py, int action);
gpointer linea_shaded (int x1, int y1, int x2, int y2,
                 double spessore, gpointer cont, GdkWindow *win, int iColor, GdkColor Colori[]);
gpointer linea_spessa (int x1, int y1, int x2, int y2,
                 int spessore, gpointer cont, GdkWindow *win, int iColor);
int c_carica(char *inpFile, char *inpDir, int tipo, float dista, int ifHyd);

GtkWidget *createSelectionM           (GtkWidget *parent, GtkWidget *parentbox,
                                       const char *title[], const char *id, int ncol, const char *col);
extern "C" void lanciajavsir_(int *flag);
extern "C" void mapvariance_(int *flag);
void set_normal_cursor();
void set_drag_cursor();
void populate_listgv(GtkTreeView *list, GList *values[],
                     int numlists, int ist, int iend);
void UpdateFrameColors (GtkWidget *win, GdkColor Palette[]);
gpointer get_action (const char *name);
void force_close_viewers();

/*-------------------------------------------------------------*/
/*         routines che chiamano il FORTRAN                    */
/*-------------------------------------------------------------*/

void load_recent_project (gpointer item, char *string)
{
     gchar *inpFile;
     gchar *outFile;
     gchar *cwd;
     const gchar *tipo = "bin";
     FILE *fp;
     gchar *testo = g_new0(char, MaxLenFilename);
   
     if(item)
        ScriviStringa(testo, MaxLenFilename, "%s", obj_get_label(item));
     else
        CopiaStringa(testo, MaxLenFilename, string);

     cwd = g_path_get_dirname(testo);
     if(dir_set_current(cwd))                // errore in change_directory
        (void) MessageDialog(finestre[0],  GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                      "Error in dir_set_current: %s", cwd);
     else
     {
        inpFile = g_path_get_basename(testo);

        outFile = g_new0(char, MaxLenFilename);
        CopiaStringa(outFile, MaxLenFilename, str_cut(inpFile, "."));
        AppendiStringa(outFile, MaxLenFilename, ".out");

        fp = fOpen(inpFile, "r");
        if(fp != NULL)
	{
           (void) fclose(fp);
           call_fortran(inpFile, outFile, tipo);
	}
        else
           (void) MessageDialog(finestre[0], GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                      "Error in open file: %s", inpFile);
     }
}

void c_no_more_crosses()
{
   no_more_crosses_();
}

void c_aggiornadisegno(void)
{
    gpointer context = getCurrentContext();
    if(context)
    {
       int ier;

       ier = ridisegna_();
       if(ier && !Contour->ifDrawContour)
          draw_initial_pixmap();        
    }
}

void c_savebinfile (GtkWidget *item,  gpointer data)
{
    int scelta;

/*  tipo = 1    ---> Save 
    tipo = 2    ---> Restore

    scelta = 1  ---> Project file
    scelta = 2  ---> Model
    scelta = 3  ---> Cancel     
*/ 
// 05/05/2015    int tipo = 1;
    
// 05/05/2015    scelta = save_restore_pm(tipo);
    scelta = 1;
    switch(scelta)
    {
    case 1:
       savebinfile_();
       break;
    case 2:
       if(liste->l[14])
          open_file(item, GINT_TO_POINTER(10));
       else
           (void) MessageDialog(gtk_widget_get_toplevel(item), GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                  "No model to save!!!");
       break;
    case 3:
       break;
    }
}

void c_restorebinfile (GtkWidget *item,  gpointer data)
{
    int scelta, ifFromGraphic=1, ier;
    GtkWidget *tb, *hbox;

/*  tipo = 1    ---> Save 
    tipo = 2    ---> Restore

    scelta = 1  ---> Project file
    scelta = 2  ---> Model
    scelta = 3  ---> Cancel     
*/ 
// 05/05/2015    int tipo = 2;
    
    if(prj->ifProject)         // c'è un file binario aperto
    {
// 05/05/2015       scelta = save_restore_pm(tipo);
       scelta = 1;
       switch(scelta)
       {
       case 1:
           restorebinfile_(&ifFromGraphic, &ier);
           tb = lookup_widget(finestre[0], toolbarname[Livcur]);
           hbox = get_widget(tb, "hbox");
           gtk_widget_set_sensitive(hbox, TRUE);
           abilitamb(finestre[0], MRmax(dialogo->QualeAbilita, 1));
           if(strstr(toolbarname[Livcur],"main"))
              abilitatb(tb, MRmax(dialogo->QualeAbilita, 1));
           can_drag = MRmax(dialogo->QualeAbilita - 1, 0);
           break;
       case 2:
           abilitamb(finestre[0], 0);
           open_file(item, GINT_TO_POINTER(3));
           abilitamb(finestre[0], 2);
           break;
       case 3:
           break;
       }
    }
    else
       open_file(item, GINT_TO_POINTER(2));

/* la seguente e' INDISPENSABILE */
    single_it = FALSE;
}

/*****************************************************************/
/*                       Style of ellipsoids                     */
/*****************************************************************/

static int EllipseStyle = 1;

void stile(GtkButton *button, gpointer tipo)
{
   EllipseStyle = GPOINTER_TO_INT(tipo);
   close_dlg(button, GINT_TO_POINTER(11));
   gtk_main_quit();
}
 
GtkWidget* create_ellisse ()
{

  GtkWidget *window;
  GtkWidget *box1;
  GtkWidget *box2;

  GtkWidget *separator;
  GtkWidget *buttona;
  GtkWidget *buttonb;
  GtkWidget *buttonc;
  GtkWidget *frame;
  GtkWidget *label;


  window = gtk_dialog_new ();
  gtk_container_set_border_width (GTK_CONTAINER (window), 7);
  gtk_window_set_title (GTK_WINDOW (window), "Select style");
  gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_MOUSE);

  box1 = gtk_dialog_get_content_area(GTK_DIALOG(window));

  frame = gtk_frame_new(NULL);
  gtk_widget_show (frame);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);
  gtk_box_pack_start (GTK_BOX (box1), frame, FALSE, FALSE, 4);

  label = LABEL_BOLD("Select the ellipsoid style", LABELCOLOR, 1.3f);
  gtk_widget_show (label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
  gtk_container_add(GTK_CONTAINER(frame), label);

  box2 = hbox_new (FALSE, 4);
  gtk_widget_show (box2);

  gtk_box_pack_start (GTK_BOX (box1), box2, TRUE, FALSE, 0);

  buttona = xpm_button("ellisse1.png");
  gtk_box_pack_start (GTK_BOX (box2), buttona, TRUE, FALSE, 0);

  separator = vseparator_new();
  gtk_widget_show (separator);
  gtk_box_pack_start (GTK_BOX (box2), separator, TRUE, FALSE, 0);

  buttonb = xpm_button("ellisse2.png");
  gtk_box_pack_start (GTK_BOX (box2), buttonb, TRUE, FALSE, 0);

  separator = vseparator_new();
  gtk_widget_show (separator);
  gtk_box_pack_start (GTK_BOX (box2), separator, TRUE, FALSE, 0);
  buttonc = xpm_button("ellisse3.png");
  gtk_box_pack_start (GTK_BOX (box2), buttonc, TRUE, FALSE, 0);
  
  separator = hseparator_new();
  gtk_widget_show (separator);
  gtk_box_pack_start (GTK_BOX (box1), separator, TRUE, FALSE, 0);
  (void) g_signal_connect (G_OBJECT(buttona), "clicked", 
               G_CALLBACK(stile), GINT_TO_POINTER(2));
  (void) g_signal_connect (G_OBJECT(buttonb), "clicked", 
               G_CALLBACK(stile), GINT_TO_POINTER(3));
  (void) g_signal_connect (G_OBJECT(buttonc), "clicked", 
               G_CALLBACK(stile), GINT_TO_POINTER(4));

  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return window;
}

int ellisse_style()
{
     GtkWidget *ellisse_dlg;

     ellisse_dlg = create_ellisse();
     gtk_widget_show(ellisse_dlg);
     finestra_modale_aperta2(ellisse_dlg);
     gdk_window_raise (gtk_widget_get_window(ellisse_dlg));
     gtk_main();
     return EllipseStyle;
}

void c_esporta (gpointer item,  gpointer data)
{
     int iCod, iAction;
     char nomefile[MaxLenFilename];
/*
     iCod =  1              shelx
     iCod =  2              crystals
     iCod =  3              Xtal
     iCod =  4              CCP_4
     iCod =  5              PDB
     iCod =  6              Caos
     iCod =  7              Postscript
     iCod =  8              HPGL
     iCod =  9              schakal
     iCod = 10              moldraw
     iCod = 11              xyz
     iCod = 12              PovRay
     iCod = 13              cif
   PostScript & HPGL
      iAction = 1    preview only
      iAction = 2    file only
      iAction = 3    preview & file
   C.I.F.
      iAction = 2    coordinates and reflection files
      iAction = 3    coordinates only
*/
     memset(nomefile, 0, sizeof(nomefile));
     iCod = GPOINTER_TO_INT(data);

     if( (iCod == 7) && 
         ((dialogo->iPlotType == 2) || (dialogo->iPlotType == 7)) )
     {
         (void) MessageDialog(finestre[0], GTK_MESSAGE_ERROR,
             GTK_BUTTONS_CLOSE, "Operation not supported for this plot style");
        return;
     }
     iAction = 3;
     if((iCod == 7) || (iCod == 8))
           iAction = preview_or_file(iCod-6);
     if(iCod == 12)
     {
         if (ifellipsoids_())
             iAction = ellisse_style();
     }
     if(iCod == 13)
     {
        if(liste->l[5])
           iAction = MessageDialog(finestre[0], GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO,
                  "Do you want also produce a\nreflection file in CIF format?");
        else
           iAction = GTK_RESPONSE_NO;
        if(iAction == GTK_RESPONSE_YES)
           iAction = 2;
        else
           iAction = 3;
     }   
     if(!liste->l[14] && (iCod != 3) && (iCod !=4))
     {
        (void) MessageDialog(finestre[0], GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
               "No structural model available to export");
        return;
     }
     if((iCod == 3) || (iCod ==4))
     {
        if(liste->l[16])
        {
           iAction = c_restart(NULL, GINT_TO_POINTER(iCod+3));
        }
        else
        {
           iAction = -1;
           (void) MessageDialog(finestre[0], GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                  "No phases available to export");
            return;
        }
     }

     if(iAction >= 0)
     {
       fortran_al_lavoro();
       esporta_(&iCod, &iAction, nomefile, sizeof(nomefile));
       fine_lavoro();
     }        
     if(iCod == 12)
     {
        int i;
        std::string filepov;
        struct stat s;
        gint status;

        status = stat(main_app::TheApp.PovrayP().c_str(), &s);
        if(status)
        {
            (void) MessageDialog(finestre[0], GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE,
                "To start PovRay, it has to be installed in %s, using the tool\n'Alien Programs' in 'Settings'"
                , MR_PACKAGE);
            return;
        }
        std::string msg;
        std::vector<std::string> args;
        args.push_back("-V");
        args.push_back("-GW");
        args.push_back("-GA");
        args.push_back("+P");
        args.push_back("+W800");
        args.push_back("+H600");
        args.push_back("+FN");
        filepov = nomefile;
        args.push_back("+I" + filepov);

        i = run_command(toUTF8(main_app::TheApp.PovrayP().c_str()), args, msg);

        if((i == -1) && !str_white(msg.c_str()))
            gtkext::dlg_errmsg(GTK_WINDOW(finestre[0]), msg);
     }
}

void sad_smiley()
{
    curSmileySav = curSmiley;
    curSmiley = 2;
    set_smiley(2);
}

void aggiorna_statusbar(void)
{
    if(Contour->sezione0 == Contour->sezioneN)
       print_mess(g_strdup_printf("Section %d of %d along %s;    %s = %.3f", 
        Contour->sezione0+1, ngrid[Contour->Layer-1],
        layers[Contour->Layer-1], layers[Contour->Layer+2], 
            (float)Contour->sezione0/(float)ngrid[Contour->Layer-1]));
    else
       print_mess(g_strdup_printf("Sections %d to %d of %d along %s;"
        "    %.3f < %s < %.3f", Contour->sezione0+1, Contour->sezioneN + 1, 
        ngrid[Contour->Layer-1],layers[Contour->Layer-1],
            (float)Contour->sezione0/(float)ngrid[Contour->Layer-1],
             layers[Contour->Layer+2],
            (float)Contour->sezioneN/(float)ngrid[Contour->Layer-1]));
}

void c_init_polygon (int int1)
{
   cod_polyg = int1;
   init_polygon_(&cod_polyg);
}

int c_finish_polygon (void)
{
   int ier;
   if(cod_polyg != 4)
      fortran_al_lavoro();
   finish_polygon_(&ier);
   if(cod_polyg != 4)
      fine_lavoro();
   return ier;
}

void c_show_all (GtkWidget *item,  gpointer data)
{
   c_init_polygon (4);
   (void) c_finish_polygon();
}

void stop_run              (gpointer item,  gpointer data)
{
     dialogo->ifBrekke = GPOINTER_TO_INT(data);
     obj_hide(item);
     gpointer but = get_object(finestre[0], "Stopping");
     obj_show(but);
}

void stop_rot              (gpointer item,  gpointer data)
{
     dialogo->ifBrekke = 1;
     ifContinueRot = 0;
     obj_hide(item);
     gpointer but = get_object(finestre[0], "RC");
     obj_show(but);
}

extern "C" void resetstop_()
{
     if(!jscreen)
     return;
     gpointer but = get_object(finestre[0], "Stopping");
     obj_hide(but);
     but = get_object(finestre[0], "Stop");
     obj_show(but);
}
void c_histograms (GtkWidget *wid,  gpointer data)
{
      histograms_();
}

void c_doallgraphs (GtkWidget *wid,  gpointer data)
{
      std::string filpng, dirn = SWareRC->WorkingDirectory;
      if(dirn.c_str()[dirn.length()-1] != G_DIR_SEPARATOR)
         dirn.append(G_DIR_SEPARATOR_S);
      filpng = dirn.c_str();
      filpng.append(str_cut(g_path_get_basename(main_app::TheApp.filebin), "."));
      filpng.append("_Foms.png");
      show_image(filpng.c_str(), "FOMs Statistics", finestre[0]);
}

void c_undelete (GtkWidget *item,  gpointer data)
{
     undelete_();
}

int complete_conn()
{
    GtkWidget *dlg, *radio, *vbox, *frame, *button;
    GSList *group = NULL;

    dlg = gtk_dialog_new();
    gtk_window_set_title (GTK_WINDOW (dlg), "ReGroup");
    gtk_container_set_border_width (GTK_CONTAINER (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), 8);

    frame = gtk_frame_new (NULL);
    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), frame, TRUE, TRUE, 0);
    vbox = vbox_new(FALSE, 2);
    gtk_container_add(GTK_CONTAINER(frame), vbox);

    radio = RADIO_BUTTON_WITH_LABEL(group, "Rebuild the connectivity", "blue");
    gtk_box_pack_start (GTK_BOX (vbox), radio, FALSE, FALSE, 6);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(dlg), "rebuild", radio); 

    radio = RADIO_BUTTON_WITH_LABEL(group, "Complete the connectivity", "blue");
    gtk_box_pack_start (GTK_BOX (vbox), radio, FALSE, FALSE, 6);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(dlg), "complete", radio); 

/*
    radio = RADIO_BUTTON_WITH_LABEL(group, "New procedure", "blue");
    gtk_box_pack_start (GTK_BOX (vbox), radio, FALSE, FALSE, 6);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
*/

    button = myimage_button("   _OK", "ok.png");
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_OK); 

    button = myimage_button("  _Cancel", "cancel.png");
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL); 
    gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
       GTK_BUTTONBOX_SPREAD);

    gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(finestre[0]));
    gtk_widget_show_all(dlg);
    finestra_modale_aperta2(dlg);
    int result = gtk_dialog_run(GTK_DIALOG(dlg));
    if(result == GTK_RESPONSE_OK)
    {
       GtkWidget *radio1 = get_widget(dlg, "complete");
       GtkWidget *radio2 = get_widget(dlg, "rebuild");
       if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radio1)))
          result = 1;
       else if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radio2)))
          result = 2;       
       else
          result = 3;       
    }
    else
         result = -1;
    gtk_widget_destroy(dlg);
    finestra_modale_chiusa2();
    return result;
}

void c_regroup (GtkWidget *item,  gpointer data)
{
  int flag = complete_conn();
  if(flag == -1)
     return;
  regroupv2_(&flag);
}

void c_sortbylabel (GtkWidget *item,  gpointer data)
{
  sortbylabel_();
}

void c_lsq (GtkWidget *item,  gpointer data)
{
   lsq_();
}

void c_reset_hbonds (GtkWidget *item,  gpointer data)
{
   reset_hbonds_();
}

int c_initcontour(int ngrid[], int flag)
{
   int i, j, ier;
   GtkWidget *tb, *hbox;

   for(i=0; i<3; i++)
       for(j=0; j<2; j++)
           limiti[i][j] = Contour->xyzlimCont[i][j];
   tb = lookup_widget(finestre[0], toolbarname[Livcur]);
   hbox = get_widget(tb, "hbox");
   gtk_widget_set_sensitive(hbox, FALSE);
   if(flag)
      abilitamb(finestre[0], 0);
   ier = 0;

   fortran_al_lavoro();
   initcontour_(ngrid, &ier);
   for(i=0; i<2; i++)
        for(j=0; j<3;j++)
            asy[i][j] = limits->xyzfou[i][j]/limits->xyzfou[3][j];

   fine_lavoro();

   gtk_widget_set_sensitive(hbox, TRUE);
   if(flag)
      abilitamb(finestre[0], dialogo->QualeAbilita);
   if(ier)
      return -1;
   aggiorna_statusbar();
   return 0;
}

void c_browserv2 (GtkWidget *wid,  gpointer data)
{
    int num;

    num = GPOINTER_TO_INT(data);
    browserv2_(&num);
}

void c_vista(int action, int valore)
{
      while(gtk_events_pending())
         (void) gtk_main_iteration();
      vista_(&action, &valore);
}

void view_options (GtkWidget *item,  gpointer data)
{
   GtkWidget *tb, *hbox;
   int action, int0 = 0;

   action = GPOINTER_TO_INT(data);
   if(!strstr(toolbarname[Livcur], "contour"))
      c_vista(action, int0);
   else
   {
      tb = lookup_widget(finestre[0], toolbarname[Livcur]);
      hbox = get_widget(tb, "hbox");
      gtk_widget_set_sensitive(hbox, FALSE);
      c_vista(action, int0);
      change_section(NULL, NULL);
      aggiorna_statusbar();
      gtk_widget_set_sensitive(hbox, TRUE);
   }
}

void on_speed_changed (GtkWidget *editable, gpointer user_data)
{
   dialogo->iRotSpeed = 
      spin_button_get_value_as_int(editable);
}

void on_sfrad_changed (GtkWidget *editable, gpointer user_data)
{
   dialogo->RaggioSfera = (float) spin_button_get_value(editable);
}

void move_rotate (GtkWidget *item,  gpointer data)
{
   int valore, action;
   action = GPOINTER_TO_INT(data);
/*
   GtkWidget *mother, *spin;


   mother = gtk_widget_get_parent(item);
   if(GTK_IS_TOOLBAR(mother))
   {
      spin = get_widget(mother, "spin");
      valore = spin_button_get_value_as_int(spin);
   }
   else
      valore = 1;
*/
   std::string nome;
   if(strstr(toolbarname[Livcur], "Rotate"))
      nome = "spinRotate";
   else
      nome = "spin";
   gpointer spin = get_object(finestre[0], nome.c_str());
   if(spin)
      valore = spin_button_get_value_as_int(GTK_WIDGET(spin));
   else
      valore = 1;

   if((ifContinueRot == 1) && (action <= 8))
      action +=30;
   if((((action % 10) == 7) || ((action % 10) == 8)) && !def_vec)
   {
      gdk_beep();
      (void) MessageDialog(gtk_widget_get_toplevel(item), GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
             "You must define vector before rotation");
   }
   else if(action <= 14)                  // Rotazione singola o traslazione
   {
      dialogo->iRotSpeed = 0;
      c_vista(action, valore);
   }
   else                                 // Rotazione continua
   {
      dialogo->ifBrekke = 1;
      valore = 1;
      spin = get_object(finestre[0], "speed");
      if (spin)
         dialogo->iRotSpeed = 
                 spin_button_get_value_as_int(GTK_WIDGET(spin));
      else
         dialogo->iRotSpeed = 10;
      c_vista(action, valore);
   }
}

void c_ThFacTooBig(GtkWidget *item, gpointer data)
{
    int zero = 0;
    thfactoobig_(&zero);
}

void c_enant(GtkWidget *item, gpointer data)
{
    enantiomorph_();
}

void elaborazione_in_corso()
{
   GtkWidget *drawingarea, *tb, *mb;

   drawingarea = lookup_widget(finestre[0], drawingareaname);
   tb = lookup_widget(finestre[0], "toolbar_main");
   mb = lookup_widget(finestre[0], menubarname);
   gtk_widget_set_sensitive(tb, FALSE);
   gtk_widget_set_sensitive(mb, FALSE);
   fortran_al_lavoro();
   gdk_window_set_cursor(gtk_widget_get_window(drawingarea),wait_cursor);
}

void fine_elaborazione()
{
   GtkWidget *drawingarea, *tb, *mb;

   drawingarea = lookup_widget(finestre[0], drawingareaname);
   tb = lookup_widget(finestre[0], "toolbar_main");
   mb = lookup_widget(finestre[0], menubarname);
   fine_lavoro();
   gdk_window_set_cursor(gtk_widget_get_window(drawingarea),default_cursor);
   gtk_widget_set_sensitive(tb, TRUE);
   gtk_widget_set_sensitive(mb, TRUE);
}

/*-------------------------------------------------------------*/
/*         routines chiamate dal FORTRAN                       */
/*-------------------------------------------------------------*/
extern "C" void ab_stop_run_(void)
{
   GtkWidget *tb;
 
   if(!jscreen)
     return;
   if(ifToolbar && show_toolbar)
   {  
      tb = get_widget(finestre[0], "toolbar_run"); 
      abilitatb(tb, 2);

      gpointer button = get_object(tb, "Stop");
      obj_set_sensitive(button, TRUE);
//      button = get_widget(tb, "Histogram");
//      gtk_widget_set_sensitive(button, TRUE);
   }
}

void destroy_dist_dlg(GtkButton *button, gpointer data)
{
    gtk_main_quit();
    gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
    finestra_modale_chiusa2();
}

extern "C" void cprintit_(char *title, int *nlines)
{
    GtkWidget *my_dlg, *text, *vbox, *cancel_b;
    int larg, i;
    GtkTextBuffer *buffer;
    char *buf;
    GtkTextIter iter;
    if(!jscreen)
      return;

    my_dlg = gtk_dialog_new ();
    gtk_window_set_title(GTK_WINDOW(my_dlg), title);
    gtk_window_move(GTK_WINDOW(my_dlg), 0,0);
    vbox = (gtk_dialog_get_content_area(GTK_DIALOG(my_dlg)));
    text = scrolled_text(vbox);
    widget_modify_font(text, fontdescN);
    set_bg_color(text, colorWhite);
    set_text_color(text, "blue");
    larg = 60 * larSaveN;
    gtk_widget_set_size_request(get_widget(text, "scrollwin"), larg, 200);
    gtk_text_view_set_editable(GTK_TEXT_VIEW(text), FALSE);
    buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (text));
    gtk_text_buffer_get_iter_at_offset (buffer, &iter, 0);
    for(i=0; i<*nlines; i++)
    {
        buf = g_strchomp(It[i]);
        gtk_text_buffer_insert_with_tags_by_name(buffer,
                                   &iter,
                                   buf, 
                                   (int) strlen(buf),
                                   MONOSPACE_FONT, NULL);
        gtk_text_buffer_insert(buffer,
                                   &iter,
                                   "\n", 
                                   1);
    }

    cancel_b = myimage_button("  _Cancel", "cancel.png");
    (void) g_signal_connect (G_OBJECT (cancel_b), "clicked",
                       G_CALLBACK (destroy_dist_dlg), NULL);
    gtk_dialog_add_action_widget(GTK_DIALOG(my_dlg), cancel_b, 1);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(cancel_b)), GTK_BUTTONBOX_SPREAD);

    (void) g_signal_connect_swapped(G_OBJECT(my_dlg), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(cancel_b));
  (void) g_signal_connect (G_OBJECT (my_dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);
    gtk_widget_show_all(my_dlg);
    finestra_modale_aperta2(my_dlg);
    gtk_main();
}
extern "C" void c_clessidra_on_off_(int *action)
{
   if(!jscreen)
     return;
    if(*action == 1)
       elaborazione_in_corso();
    else
       fine_elaborazione();
}

extern "C" void c_reset_plot_style_(int *iPlotStyle, int *ifLabels)
{
   if(!jscreen)
     return;

   gpointer tog_b = get_object(finestre[0], "LabTog");
   dialogo->iPlotType = *iPlotStyle;
   if(ifToolbar && show_toolbar)
      obj_set_active(tog_b, *ifLabels);
   main_app::TheApp.UpdatePS(dialogo->iPlotType);
}

extern "C" void mrdraggapol_(int xv1[], int yv1[], int xv2[], int yv2[],
                     int col1[], int *z)
{

   int np, new_color, old_color;
   gpointer context = getCurrentContext();
   gpointer outPix = getCurrentPix();

   if(!jscreen)
     return;
      old_color = 0;
      for (np=0;np<*z;np++)
      {
         new_color = col1[np];
         if ( new_color != old_color ) 
         {
           old_color = new_color;
           set_foreground( context, &main_app::TheApp.colorPalette[new_color]);
         }
         draw_line( outPix, context, xv1[np], yv1[np], xv2[np], yv2[np]);
      }

}

int curPosx, curPosy;
   
void DrawLabel(int xb, int yb, int fDel, char *string)
{
     GdkColor *fore;
     gpointer context = getCurrentContext();
     gpointer outPix = getCurrentPix();

     yb -= altSaveP;
     if(fDel)
        fore = ToGdkColor(main_app::TheApp.app_color[LABS]);
     else
        fore = ToGdkColor(main_app::TheApp.app_color[dialogo->jBackGround]);
     draw_string( outPix, fontdescP, context, xb, yb, string, fore, NULL);
     cflush_();
}  

int c_init_move_labels(void)
{
    int ier;

    can_drag = TRUE;
    ier = 0;
    elaborazione_in_corso();
    init_move_labels_(&ier);
    fine_elaborazione();
    return ier;        
}

void reset_lab_pos(GtkWidget *item, GtkWidget *widget)
{
  int i, xb, yb;
  GtkWidget *icon;

  for (i=0;i<dialogo->NatMol;i++)
  {
       if(ifLabelsVis[i] == 0)
       {
          xb = gMatrice(ipixLab, 0, i);
          yb = gMatrice(ipixLab, 1, i);
          DrawLabel(xb, yb, 1 ,It[i]);
          ifLabelsVis[i] = 1;
       }
  }
  icon = gtk_bin_get_child(GTK_BIN(widget));
  gtk_container_remove(GTK_CONTAINER(widget), icon);
  icon = get_widget(widget, "icon1");
  gtk_container_add(GTK_CONTAINER(widget), icon);
}

void stop_move_cube(int x, int y)
{
  ifMoveCube = FALSE;
  set_normal_cursor();
  changeCube(x,y,1);
  ridisegna_();
}

void stop_move_labels(int ifTrashcan)
{
     GtkWidget *drawarea;
     extern int altSaveP;
     GtkAllocation allocation;
     int xb, yb;

     drawarea = lookup_widget(finestre[0], drawingareaname);
     gtk_widget_get_allocation(drawarea, &allocation);
     can_drag = FALSE;
     if(CurrentLab >= 0)
     {
        if(!ifTrashcan)
        {
           if(curPosx <= 0)
              curPosx = 2;
           else if(curPosx >= allocation.width)
              curPosx = allocation.width - 
                 gtkext::text_width(fontdescP, It[CurrentLab]);
           if(curPosy <= 0)
              curPosy = altSaveP;
           else if(curPosy >= allocation.height)
              curPosy = allocation.height-altSaveP;
           DrawLabel(curPosx, curPosy, 1, It[CurrentLab]);
           pMatrice(ipixLab, 0, CurrentLab, curPosx);
           pMatrice(ipixLab, 1, CurrentLab, curPosy);
        }
        else
           ifLabelsVis[CurrentLab] = 0;
        xb = gMatrice(ipix, 0, CurrentLab);
        yb = gMatrice(ipix, 1, CurrentLab);
        draw_cross(xb, yb, dialogo->jBackGround);    /* cancella croce sull'atomo */
     }
     gdk_window_set_cursor(gtk_widget_get_window(drawarea),drag1_cursor);
}


void c_init_disegnarettangolo(GtkWidget *widget,  gpointer data)
{
     GtkWidget *tb, *mainwin;
     GtkWidget *drawingarea;

     drawingarea = lookup_widget(finestre[0], drawingareaname);
     mainwin = finestre[0];
     if(ifToolbar)
        tb = lookup_widget(mainwin, "toolbar_main");
     if(ifMenubar)
        abilitamb(mainwin, 0);
     if(ifToolbar)
        abilitatb(tb, 0);
     disegnarettangolo = TRUE;
     gdk_window_set_cursor(gtk_widget_get_window(drawingarea),cross_cursor);
}

void c_disegnarettangolo (int *x, int *y, int *butt)
{
     gpointer context = getCurrentContext();
     gpointer outPix = getCurrentPix();
     gpointer outWindow = getCurrentWindow();

     if (Xiniz < 0 )
     {
         Xiniz = *x;
         Yiniz = *y;
         setta_foreground(1-dialogo->jBackGround, context);
     }
     else
     {
         draw_drawable(outWindow, context, outPix, 0, 0);
         Wrect = *x - Xiniz + 1;
         Hrect = *y - Yiniz + 1;
         dashed_rectangle((int) MRmin(Xiniz, *x), (int) MRmin(Yiniz, *y),
            (int) MRabs(Wrect),(int) MRabs(Hrect));
     }
}

void c_stop_disegnarettangolo(void)
{
     GtkWidget *tb, *mainwin;
     GtkWidget *drawingarea;

     drawingarea = lookup_widget(finestre[0], drawingareaname);

     mainwin = finestre[0];
     if(ifToolbar)
        tb = lookup_widget(mainwin, "toolbar_main");
     if(ifMenubar)
        abilitamb(mainwin, 2);
     if(ifToolbar)
        abilitatb(tb, 2);

     disegnarettangolo = FALSE;
     gdk_window_set_cursor(gtk_widget_get_window(drawingarea),default_cursor);
     finish_disegnarettangolo_(&Xiniz, &Yiniz, &Wrect, &Hrect);
     Xiniz = -1;
     Yiniz = -1;
}

void c_stop_drag(void)
{
   int uno = 1;
   stopdragv2_(&uno);
}

gboolean trashcan (GtkWidget *widget, GdkEventButton *event, gpointer data)
{
      GtkWidget *icon, *menu, *item1;
      int action;

      start_drag = TRUE;
      action = GPOINTER_TO_INT(data);
      if(action)            /* button press */
      {
          movingLabel = FALSE;
          icon = get_widget(widget, "icon2");
          if(icon != gtk_bin_get_child(GTK_BIN(widget)))
             return TRUE;
          menu = gtk_menu_new ();
          item1 = gtk_menu_item_new_with_label 
                  ("Restore hidden labels");
          gtk_menu_shell_append (GTK_MENU_SHELL(menu), item1);
          gtk_widget_show (GTK_WIDGET (item1));
          g_signal_connect (G_OBJECT (item1), "activate",
                 G_CALLBACK (reset_lab_pos), widget);
          item1 = gtk_menu_item_new_with_label("Cancel");
          gtk_menu_shell_append (GTK_MENU_SHELL(menu), item1);

          gtk_widget_show (GTK_WIDGET (item1));

          gtk_menu_popup (GTK_MENU (menu), NULL, NULL, NULL, NULL,
                      event->button, event->time);

          return TRUE;
      }
      if(movingLabel)
      {
         stop_move_labels(1);
         icon = gtk_bin_get_child(GTK_BIN(widget));
         gtk_container_remove(GTK_CONTAINER(widget), icon);
         icon = get_widget(widget, "icon2");
         gtk_container_add(GTK_CONTAINER(widget), icon);
      }
      return TRUE;
}

gboolean button_release (GtkWidget *widget, GdkEventButton *ev, gpointer data)
{
  if((ev->y < 0) && ifMoveLabels)
  {
     GtkWidget *but = get_widget(finestre[0], "icon_cest");
     GtkAllocation allocation;
     gtk_widget_get_allocation(but, &allocation);
     GdkRectangle *rect = &allocation;
     gpointer reg = region_rectangle(rect);
     int yy = (int) ev->y + (int) rect->height + (int) rect->y;

     if(reg)
     {
        gboolean retval;
        if(point_in_region(reg, (int)ev->x, yy))
        {
           g_signal_emit_by_name(G_OBJECT(but), "button_release_event", 
              GINT_TO_POINTER(0), &retval);
           return TRUE;
        }
     }
     int xb = gMatrice(ipixLab, 0, CurrentLab);
     int yb = gMatrice(ipixLab, 1, CurrentLab);
     DrawLabel(xb, yb, 1 ,It[CurrentLab]);
     ifLabelsVis[CurrentLab] = 1;
     xb = gMatrice(ipix, 0, CurrentLab);
     yb = gMatrice(ipix, 1, CurrentLab);
     draw_cross(xb, yb, dialogo->jBackGround);    /* cancella croce sull'atomo */
     return TRUE;
  }

  if((!start_drag) || ifMoveLabels || ifMoveCube)
  {
      start_drag = TRUE;
      if(disegnarettangolo)
         c_stop_disegnarettangolo();
      else if(ifMoveLabels)
         stop_move_labels(0);
      else if(ifMoveCube)
         stop_move_cube((int) ev->x, (int) ev->y);
      else
         c_stop_drag();
      return TRUE;
  }
  return FALSE;
}

void stop_continue_rot(void)
{
     if(ifContinueRot)
     {
        ifContinueRot = 0;
        dialogo->ifBrekke = 1;
     }
}

gboolean button_scroll(GtkWidget *widget, GdkEventScroll  *event,
                       gpointer user_data)
{
  GdkScrollDirection dir = event->direction;
  int action, int0 = 0;
  if(dir == GDK_SCROLL_UP)
     action = 15;
  else
     action = 16;
  c_vista(action, int0);
  return TRUE;
}

gboolean button_move             (GtkWidget       *widget,
                                GdkEventMotion  *event,
                                gpointer         user_data)
{
  int ix, iy, butt, stato, uno;

  stato = (int) event->state;
  if(!stato)
     return TRUE;
  if(can_drag)
  {
     if(start_drag)
        start_drag = FALSE;
     ix   = (int) event->x;
     iy   = (int) event->y;

     uno = stato % 2;
     if ( (stato & GDK_BUTTON1_MASK) == GDK_BUTTON1_MASK )
           butt = uno * 10 + 1;
     else
           butt = uno * 10 + 2;

     if(disegnarettangolo)
        c_disegnarettangolo(&ix, &iy, &butt);
     else if(ifMoveLabels)
     {
        curPosx = ix;
        curPosy = iy;
     }
     else if(ifMoveCube)
     {
        int deltax = MRabs(ix -clsqgtk->ixCubo);
        int deltay = MRabs(iy -clsqgtk->iyCubo);
        if((deltax <= 2) && (deltay <= 2))
           return FALSE;
        changeCube(ix,iy,2);
     }
     else 
        rotbymousev2_(&ix, &iy, &butt);
  }
  return FALSE;
}

void c_init_becca_punti (int int1)
{
  int j = int1;
  init_becca_punti_(&j);
}

int c_becca_punti(int *x, int *y)
{
   int ier;

   becca_punti_(x, y, &ier);
   return ier;
}

int c_finish_becca_punti (void)
{
       int ier;

       finish_becca_punti_(&ier);
       return ier;
}

void c_finish_move_labels(void)
{
       ifMoveLabels = FALSE;
       finish_move_labels_();
}

void c_update_label_string(int serial, char *atomlabel)
{
   int l1;

   l1 = (int) strlen(atomlabel);
   updatelabelstring_(&serial, atomlabel, l1);
}

void c_find_atom(char *atomname)
{
   int l1;

   l1 = (int) strlen(atomname);
   findatom_(atomname, l1);
}

void entered2_text (GtkEditable *widget, char *string)
{
    char *text, riga[60];
    int xb, yb, dx;

//    if(CurrentLab < 0)
//       return;
    text = g_strdup_printf("%s", 
        gtk_editable_get_chars (GTK_EDITABLE(widget), 0, -1));
    if(strlen(text) > 0)
    {
      if(strstr(string, "Find") != NULL)
         c_find_atom(text);
      else if(strstr(string, "ReName") != NULL)
      {
         if(CurrentLab < 0)
            return;
         ScriviStringa(riga, sizeof(riga),
                    "Old name: %s          New name: %s", old_name, text);
         if(ifStatusbar)
             print_mess(riga);
         dx = gtkext::text_width(fontdescP, old_name);
         xb = gMatrice(ipix, 0, CurrentLab)-dx/2;
         yb = gMatrice(ipix, 1, CurrentLab)+altSaveP/4;
         DrawLabel(xb, yb, 0, old_name); 
         dx = gtkext::text_width(fontdescP, text);
         xb = gMatrice(ipix, 0, CurrentLab)-dx/2;
         DrawLabel(xb, yb, 1, text); 
         c_update_label_string(CurrentLab+1, text);
         ScriviStringa(old_name, sizeof(old_name), "%s", text);
         gtk_widget_set_sensitive(GTK_WIDGET(widget), FALSE);
      }
    }
}

void set_mycursor (GtkWidget *main_window, int maxpoints, int amb)
{
	GtkWidget  *draw;

	num_max_click = maxpoints;
    ok_clicked = amb;
	draw = lookup_widget(main_window, drawingareaname);
    if(ifMoveLabels)
          gdk_window_set_cursor(gtk_widget_get_window(draw), drag1_cursor);
    else
          gdk_window_set_cursor(gtk_widget_get_window(draw),cross_cursor);
    npoints = 0;
    if(amb == 3)
       gtk_main();
}

void pseudo_Sorcio(GtkWidget *main_window, int maxpoints, int amb)
{
    set_mycursor(main_window, maxpoints, amb);
}

int pcase(GtkWidget *tb, char *string)
{
   GtkWidget *labchild;
   GtkWidget *entry;
   GtkWidget *icon;
   GtkWidget *iconx;
   GtkWidget *main_window;
   char *icon_name;
   int i, ier = 0;

   if (strstr(string, "delete") || strstr(string, "Delete") ||
       strstr(string, "ReName") || strstr(string, "Change") ||
       strstr(string, "ReNumber") || strstr(string, "Bonds") ||
       strstr(string, "Sort") || strstr(string, "Move") ||
       strstr(string, "ReGroup") || strstr(string, "Complete") ||
       strstr(string, "Regularize") || strstr(string, "hedron") ||
       strstr(string, "Add Atom") || strstr(string, "Site") )
   {
/*                                       gianluca 19/04/2014
         checkghostsforc_(&ier);
         if(ier)
            return -1;
*/
   }
   ifMoveLabels = FALSE;
   main_window = lookup_widget(tb, windowname);

/* recupera il campo label */
   labchild = get_widget(tb, "labelG1");
   if(labchild == NULL)
      (void) printf("attenzione: labchild = NULL\n");
/*
codice per init_becca_punti = 1     Who
                            = 2     Delete Atoms
                            = 3     Relabel
                            = 4     Renumber
                            = 5     Add bonds
                            = 6     Del bonds
                            = 7     Move atoms
                            = 8     Complete
                            = 9     Regularize
                            = 10    Tetrahedron (II parte)
                            = 11    Add Atom
                            = 12    Distances / Sphere
                            = 13    Angles
                            = 14    Torsion Angles
                            = 15    Set restraints on distance
                            = 16    Set restraints on angles
                            = 17    Set restraints on plane
                            = 18    Delete restraints on distance
                            = 19    Delete restraints on angles
                            = 20    Delete restraints on plane
                            = 21    3-atoms Plane
                            = 22    2-atoms Vector
                            = 23    Mouse click in LSQ, restraints & 
                            = 24    Info in fourier
                            = 25    Single Hydrogen
                            = 26    Hydrogens Wizard
                            = 30    Add Polyhedra
                            = 31    Rename atoms
                            = 32    Add Hydrogen bonds
                            = 33    Delete Hydrogen bonds
                            = 34    Reset Hydrogen bonds
                            = 35    Accept Fourier Hydrogen
                            = 40    Move Labels
                            = 80    center for contour
                            = 110   Tetrahedron (I parte)
*/
     if(strstr(string, "Find") != 0)
     {
        set_label_text(labchild,
          "Enter the atom to locate", TBLABELCOLOR, 1.1f);
        entry = get_widget(tb, "entryG1");
        gtk_widget_set_sensitive(entry, TRUE);
        gtk_entry_set_text(GTK_ENTRY(entry), "");
        gtk_widget_show(entry);
        gtk_widget_hide(get_widget(tb, "Ok"));
        if(entry_hnd)
           g_signal_handler_disconnect(G_OBJECT(entry), entry_hnd);
        entry_hnd = g_signal_connect(G_OBJECT(entry), "activate", 
                    G_CALLBACK(entered2_text), string);
     }
     else if(strstr(string, "Who") != 0)
     {
        set_label_text(labchild,
          "Info on selected atoms: Click on Atoms ", TBLABELCOLOR, 1.1f);
        gtk_widget_hide(get_widget(tb, "Ok"));
        c_init_becca_punti(1);
//        pseudo_Sorcio(main_window, 1,0);
        pseudo_Sorcio(main_window, 1,1);
     }
     else if(strstr(string, "Delete Atoms") != 0)
     {
        set_label_text(labchild,
        "Delete atoms: Click on atoms to delete", TBLABELCOLOR, 1.1f);
        c_init_becca_punti(2);
        pseudo_Sorcio(main_window, 1,0);
     }
     else if(strstr(string, "ReName") != 0)
     {
        set_label_text(labchild,
        "Rename: Click on atom to rename and enter new name", TBLABELCOLOR, 1.1f);
        entry = get_widget(tb, "entryG1");
        gtk_widget_show(entry);
        gtk_widget_set_sensitive(entry, FALSE);
        gtk_widget_hide(get_widget(tb, "Ok"));
        if(entry_hnd)
           g_signal_handler_disconnect(G_OBJECT(entry), entry_hnd);
        entry_hnd = g_signal_connect(G_OBJECT(entry), "activate", 
                    G_CALLBACK(entered2_text), string);
        c_init_becca_punti(31);
        pseudo_Sorcio(main_window, 1,2);
     }
     else if(strstr(string, "Add Hydrogen Bond") != 0)
     {
        set_label_text(labchild,
        "Hydrogen Bonds: Click on couples of atoms", TBLABELCOLOR, 1.1f);
        gtk_widget_hide(get_widget(tb, "Ok"));
        c_init_becca_punti(32);
        pseudo_Sorcio(main_window, 2,1);
     }
     else if(strstr(string, "Delete Hydrogen Bond") != 0)
     {
        set_label_text(labchild,
        "Hydrogen Bonds: Click on couples of atoms", TBLABELCOLOR, 1.1f);
        gtk_widget_hide(get_widget(tb, "Ok"));
        c_init_becca_punti(33);
        pseudo_Sorcio(main_window, 2,1);
     }
     else if(strstr(string, "Change species") != 0)
     {
        set_label_text(labchild,
        "Change species: Click on atoms to change the atomic species", TBLABELCOLOR, 1.1f);
        c_init_becca_punti(3);
        pseudo_Sorcio(main_window, 1,0);
     }
     else if(strstr(string, "ReNumber") != 0)
     {
        set_label_text(labchild,
        "ReNumber: Click on atoms to renumber", TBLABELCOLOR, 1.1f);
        c_init_becca_punti(4);
        pseudo_Sorcio(main_window, 1,0);
     }
     else if(strstr(string, "Add Bonds") != 0)
     {
        set_label_text(labchild,
        "Add Bonds: Click on couples of atoms", TBLABELCOLOR, 1.1f);
        gtk_widget_hide(get_widget(tb, "Ok"));
        c_init_becca_punti(5);
        pseudo_Sorcio(main_window, 2,1);
     }
     else if(strstr(string, "Del Bonds") != 0)
     {
        set_label_text(labchild,
        "Delete Bonds: Click on couples of atoms", TBLABELCOLOR, 1.1f);
        gtk_widget_hide(get_widget(tb, "Ok"));
        c_init_becca_punti(6);
        pseudo_Sorcio(main_window, 2,1);
     }
     else if(strstr(string, "Move Atomsp2") != 0)
     {
        gtk_widget_show(get_widget(tb, "Close Polygon"));
        set_label_text(labchild,
        "Move Atoms: Select atom to minimize distances", TBLABELCOLOR, 1.1f);
        c_init_becca_punti(7);
        pseudo_Sorcio(main_window, 1,1);
     }
     else if(strstr(string, "Move Atoms") != 0)
     {
        gtk_widget_show(get_widget(tb, "Close Polygon"));
        gtk_widget_hide(get_widget(tb, "Ok"));
        set_label_text(labchild,
        "Enclose in a polygon the atoms to be moved", TBLABELCOLOR, 1.1f);
        c_init_polygon(7);
        pseudo_Sorcio(main_window, 1,0);
     }
     else if(strstr(string, "Complete") != 0)
     {
        set_label_text(labchild,
        "Complete: Click on 3, 4 or 5 atoms of the ring", TBLABELCOLOR, 1.1f);
        c_init_becca_punti(8);
        pseudo_Sorcio(main_window, 5,1);
     }
     else if(strstr(string, "Regularize") != 0)
     {
        set_label_text(labchild,
          "Regularize: Click on the 6 atoms of the ring", TBLABELCOLOR, 1.1f);
        gtk_widget_hide(get_widget(tb, "Ok"));
        c_init_becca_punti(9);
        pseudo_Sorcio(main_window, 6,1);
     }
     else if(strstr(string, "Tetrahedronp2") != 0)
     {
        set_label_text(labchild,
          "Now click on two vertices of the tetrahedron to complete", TBLABELCOLOR, 1.1f);
        c_init_becca_punti(10);
        pseudo_Sorcio(main_window, 2,0);
     }
     else if(strstr(string, "Octahedronp2") != 0)
     {
        set_label_text(labchild,
          "Now click on two adjacent vertices of the octahedron to complete", TBLABELCOLOR, 1.1f);
        c_init_becca_punti(210);
        pseudo_Sorcio(main_window, 2,0);
     }
     else if(strstr(string, "Tetrahedron") != 0)
     {
        set_label_text(labchild,
          "Tetrahedron: Click on central atom", TBLABELCOLOR, 1.1f);
        c_init_becca_punti(110);
        pseudo_Sorcio(main_window, 1,0);
     }
     else if(strstr(string, "Octahedron") != 0)
     {
        set_label_text(labchild,
          "Octahedron: Click on central atom", TBLABELCOLOR, 1.1f);
        c_init_becca_punti(110);
        pseudo_Sorcio(main_window, 1,0);
     }
     else if(strstr(string, "Add Atom") != 0)
     {
        set_label_text(labchild,
          "Add one atom:  Click on 3 atoms. New atom will be bonded to the first one", 
           TBLABELCOLOR, 1.1f);
        gtk_widget_hide(get_widget(tb, "Ok"));
        c_init_becca_punti(11);
        pseudo_Sorcio(main_window, 3,1);
     }
     else if(strstr(string, "Distances") != 0)
     {
        set_label_text(labchild,
          "Distances: Click on 2 atoms", TBLABELCOLOR, 1.1f);
        gtk_widget_hide(get_widget(tb, "Ok"));
        c_init_becca_punti(12);
        pseudo_Sorcio(main_window, 2,1);
     }
     else if(strstr(string, "Torsion Angles") != 0)
     {
        set_label_text(labchild,
          "Torsion angles: Click on 4 atoms", TBLABELCOLOR, 1.1f);
        gtk_widget_hide(get_widget(tb, "Ok"));
        c_init_becca_punti(14);
        pseudo_Sorcio(main_window, 4,1);
     }
     else if(strstr(string, "Angles") != 0)
     {
        set_label_text(labchild,
          "Angles: Click on 3 atoms", TBLABELCOLOR, 1.1f);
        gtk_widget_hide(get_widget(tb, "Ok"));
        c_init_becca_punti(13);
        pseudo_Sorcio(main_window, 3,1);
     }
     else if(strstr(string, "Sphere") != 0)
     {
        set_label_text(labchild,
          "Sphere: Click on atom(s). Radius of the sphere:", TBLABELCOLOR, 1.1f);
        gtk_widget_hide(get_widget(tb, "Ok"));
        gtk_widget_show(get_widget(tb, "spin"));
        dialogo->RaggioSfera = (float)
        spin_button_get_value(get_widget(tb, "spin"));
        c_init_becca_punti(12);
        pseudo_Sorcio(main_window, 1,1);
     }
     else if(strstr(string, "FourDist") != 0)
     {
        set_label_text(labchild,
          "Info on selected atoms: Click on Atoms ", TBLABELCOLOR, 1.1f);
        gtk_widget_hide(get_widget(tb, "Ok"));
        c_init_becca_punti(24);
        pseudo_Sorcio(main_window, 1,0);
     }
/* --- iQualePolyg = iCod = 1     to delete              */
/* ---                    = 2     to hide                */
/* ---                    = 3     to display             */
/* ---                    = 4     Show all            */
/* ---                    = 5     to change color        */
     else if(strstr(string, "delete") != 0)
     {
        gtk_widget_show(get_widget(tb, "Close Polygon"));
        gtk_widget_hide(get_widget(tb, "Ok"));
        set_label_text(labchild,
        "Enclose in a polygon the atoms to delete", TBLABELCOLOR, 1.1f);
        c_init_polygon(1);
        pseudo_Sorcio(main_window, 1,0);
     }
     else if(strstr(string, "hide") != 0)
     {
        gtk_widget_show(get_widget(tb, "Close Polygon"));
        gtk_widget_hide(get_widget(tb, "Ok"));
        set_label_text(labchild,
        "Enclose in a polygon the atoms to hide", TBLABELCOLOR, 1.1f);
        c_init_polygon(2);
        pseudo_Sorcio(main_window, 1,0);
     }
     else if(strstr(string, "display") != 0)
     {
        gtk_widget_show(get_widget(tb, "Close Polygon"));
        gtk_widget_hide(get_widget(tb, "Ok"));
        set_label_text(labchild,
        "Enclose in a polygon the atoms to display", TBLABELCOLOR, 1.1f);
        c_init_polygon(3);
        pseudo_Sorcio(main_window, 1,0);
     }
     else if(strstr(string, "change") != 0)
     {
        gtk_widget_show(get_widget(tb, "Close Polygon"));
        gtk_widget_hide(get_widget(tb, "Ok"));
        set_label_text(labchild,
        "Enclose in a polygon the atoms to assign a color", TBLABELCOLOR, 1.1f);
        c_init_polygon(5);
        pseudo_Sorcio(main_window, 1,0);
     }
     else if(strstr(string, "3-atoms Plane") != 0)
     {
        gtk_widget_show(get_widget(tb, "Close Polygon"));
        gtk_widget_hide(get_widget(tb, "Ok"));
        set_label_text(labchild,
        "Click on 3 atoms to define a plane", TBLABELCOLOR, 1.1f);
        c_init_becca_punti(21);
        pseudo_Sorcio(main_window, 3,1);
     }
    else if(strstr(string, "Single") != 0)
     {
        if(ifcarbons_xc_())
        {
           set_label_text(labchild,
           "Select one atom to add Hydrogen(s)", TBLABELCOLOR, 1.1f);
        gtk_widget_hide(get_widget(tb, "Ok"));
           c_init_becca_punti(25);
           pseudo_Sorcio(main_window, 1,1);
        }
     }
     else if(strstr(string, "Accept hydrogen") != 0)
     {
        set_label_text(labchild,
        "Accept hydrogen: Click on stars to accept", TBLABELCOLOR, 1.1f);
        c_init_becca_punti(35);
        pseudo_Sorcio(main_window, 1,0);
     }
     else if(strstr(string, "Move Labels") != 0)
     {
        ier = c_init_move_labels();
        if(!ier)
        {
           icon = get_widget(finestre[0], "icon_cest");
           icon_name = DuplicaStringa("icon1");
           for (i=0;i<dialogo->NatMol;i++)
           {
                if(ifLabelsVis[i] == 0)
                {
                  icon_name = DuplicaStringa("icon2");
                  break;
                }
           }
           iconx = gtk_bin_get_child(GTK_BIN(icon));
           gtk_container_remove(GTK_CONTAINER(icon), iconx);
           iconx = get_widget(icon, icon_name);
           gtk_container_add(GTK_CONTAINER(icon), iconx);
           gtk_widget_show(icon);
           set_label_text(labchild,
           "Drag Labels in the preferred position. Drag Labels in the safe to hide them."
           , TBLABELCOLOR, 1.1f);
           gtk_widget_hide(get_widget(tb, "Ok"));
           ifMoveLabels = TRUE;
           c_init_becca_punti(40);
           pseudo_Sorcio(main_window, 1,100);
        }
        else
           ier = MessageDialog(gtk_widget_get_toplevel(tb), GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE,
                 "No labels to move!");
     }
     else if(strstr(string, "tbg1lsq") != 0)
     {
        if(gsel_mode == 3)
           c_init_polygon(8);
        else
           c_init_becca_punti(23);
        pseudo_Sorcio(main_window, 1, 0);
     }
     else if(strstr(string, "OneAtom") != 0)
     {
        ifOneAtom = 1;
        set_label_text(labchild,
           "Select atom as center of contour box", TBLABELCOLOR, 1.1f);
        gtk_widget_show(get_widget(tb, "Ok"));
        c_init_becca_punti(80);
        pseudo_Sorcio(main_window, 1,0);
     }
     else if(strstr(string, "Site") != 0)
     {
        set_label_text(labchild,
          "Modify site: Click on Atom ", TBLABELCOLOR, 1.1f);
        gtk_widget_hide(get_widget(tb, "Ok"));
        c_init_becca_punti(41);
//        pseudo_Sorcio(main_window, 1,0);
        pseudo_Sorcio(main_window, 1,1);
     }     return ier;
}

void mostra_tbcur(int ier)
{
  if(ifToolbar && show_toolbar)
  {
     if(!ier)
     {
        if(strstr((const char *)CurrentStringSelected, "Atomsp2"))
        {
           nascondi_tb(CurrentToolBar);
           mostra_tbg1(CurrentToolBar, (gpointer) "Move Atoms");
        }
        else if(strstr((const char *)CurrentStringSelected, "Move Atoms"))
        {
            CurrentStringSelected = (gpointer) "Move Atomsp2";
            ier = pcase(CurrentToolBar, (char *)CurrentStringSelected);
        }
        else if(strstr((const char *)CurrentStringSelected, "Tetrahedronp2"))
        {
            nascondi_tb(CurrentToolBar);
            mostra_tbg1(CurrentToolBar, (gpointer) "Tetrahedron");
        }
        else if(strstr((const char *)CurrentStringSelected, "Tetrahedron"))
        {
            CurrentStringSelected = (gpointer) "Tetrahedronp2";
            ier = pcase(CurrentToolBar, (char *)CurrentStringSelected);
        }
        else if(strstr((const char *)CurrentStringSelected, "Octahedronp2"))
        {
            nascondi_tb(CurrentToolBar);
            mostra_tbg1(CurrentToolBar, (gpointer) "Octahedron");
        }
        else if(strstr((const char *)CurrentStringSelected, "Octahedron"))
        {
            CurrentStringSelected = (gpointer) "Octahedronp2";
            ier = pcase(CurrentToolBar, (char *)CurrentStringSelected);
        }
        else
            ier = pcase(CurrentToolBar, (char *)CurrentStringSelected);
     }
     else
         ier = pcase(CurrentToolBar, (char *)CurrentStringSelected);
   }
}

void mostra_tbdamenu(GtkWidget *item, gpointer data)
{
     std::string a((char *) data);
     size_t i = a.find("Menu");
     if(i == std::string::npos)
        i = a.size();
     char *newstr = g_strdup(a.substr(0, i).c_str());
     mostra_tb(item, (gpointer) newstr);
}

void mostra_tb(GtkWidget *item, gpointer data)
{
     GtkWidget *tb, *tbmain, *hbox, *mwin;
     gpointer widget;
     char *nome, *string;
     int hnd;
     
     string = (char *) data;
     nome = g_strdup_printf("toolbar_%s", string);
   if(ifToolbar && show_toolbar)
   {

/* prende la stringa e costruisce il nome della toolbar */

/* recupera la mainwindow e la toolbar */
//     mwin = lookup_widget(item, windowname);
     mwin = finestre[0];
     tb = lookup_widget(mwin, nome);

/* mostra la toolbar */     
     hbox = get_widget(tb, "hbox");
     if(strstr(nome, "Rotate") != NULL)
     {
        if(ifContinueRot == 0)
        {
           widget = get_object(mwin, "spinRotate");
           obj_set_visible(widget, TRUE);
           widget = get_object(mwin, "speed");
           obj_set_visible(widget, FALSE);
           widget = get_object(mwin, "Angle");
           obj_set_visible(widget, TRUE);
           widget = get_object(mwin, "Speed");
           obj_set_visible(widget, FALSE);
           widget = get_object(mwin, "RC");
           obj_set_visible(widget, TRUE);
           widget = get_object(mwin, "StopRot");
           obj_set_visible(widget, FALSE);
        }
        else
        {
           widget = get_object(mwin, "spinRotate");
           obj_set_visible(widget, FALSE);
           widget = get_object(mwin, "speed");
           obj_set_visible(widget, TRUE);
           widget = get_object(mwin, "Angle");
           obj_set_visible(widget, FALSE);
           widget = get_object(mwin, "Speed");
           obj_set_visible(widget, TRUE);
           widget = get_object(mwin, "RC");
           obj_set_visible(widget, FALSE);
           widget = get_object(mwin, "StopRot");
           obj_set_visible(widget, TRUE);
        }
     }
/*
     else if(strstr(nome, "View") != NULL)
     {
          widget = get_widget(tb, "togbg");
          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dialogo->jBackGround);
     }
*/
     else if(strstr(nome, "Modify") != NULL)
     {
/*                                       gianluca 19/04/2014
         int ier;
         checkghostsforc_(&ier);
         if(ier)
            return;
*/
          widget = get_object(mwin, "Sort");
          obj_set_sensitive(widget, !dialogo->ifCont);
          widget = get_object(mwin, "ReNumber");
          obj_set_sensitive(widget, !dialogo->ifCont);
          widget = get_object(mwin, "Add Atom");
          obj_set_sensitive(widget, !dialogo->ifCont);
          widget = get_object(mwin, "Move Atoms");
          obj_set_sensitive(widget, !dialogo->ifCont);
     }
     else if(strstr(nome, "four") != NULL)
     {
          widget = get_object(mwin, "LabTogF");
          hnd = get_int(widget, "hnd");
          g_signal_handler_block(G_OBJECT(widget), hnd);
          obj_set_active(widget, dialogo->ifLabels);
          g_signal_handler_unblock(G_OBJECT(widget), hnd);
     }
     else if(strstr(nome, "idro") != NULL)
     {
          widget = get_object(mwin, "LabTogH");
          hnd = get_int(widget, "hnd");
          g_signal_handler_block(G_OBJECT(widget), hnd);
          obj_set_active(widget, dialogo->ifLabels);
          g_signal_handler_unblock(G_OBJECT(widget), hnd);
     }
     else if(strstr(nome, "contour") != NULL)
     {
          if(c_initcontour(ngrid, 1) == -1)
             return;
          widget = get_object(mwin, "CellOnC");
          hnd = get_int(widget, "hnd");
          g_signal_handler_block(G_OBJECT(widget), hnd);
          obj_set_active(widget, dialogo->ifCell);
          g_signal_handler_unblock(G_OBJECT(widget), hnd);
          widget = get_object(mwin, "Grid On/Off");
          hnd = get_int(widget, "hnd");
          g_signal_handler_block(G_OBJECT(widget), hnd);
          obj_set_active(widget, Contour->ifGrid);
          g_signal_handler_unblock(G_OBJECT(widget), hnd);
     }

     gtk_widget_show(hbox);

/* nasconde quella precedente */
     if(!strstr(toolbarname[Livcur], "main")  || show_toolbar)
     {
         tbmain = lookup_widget(mwin, toolbarname[Livcur]);
         hbox = get_widget(tbmain, "hbox");
         gtk_widget_hide(hbox);
     }

/* disabilita il menubar e conserva lo stato nell'ultima riga*/
     if(ifMenubar)
     {
        if(Livcur == 0)
           salva_stato_mb(lookup_widget(mwin, "menubar"), statoinimb[5]);
        abilitamb(mwin, 0);
     }

/* mette il proprio nome nello stack */
     Livcur++;
     toolbarname[Livcur] = DuplicaStringa(nome);
     gdk_window_raise(gtk_widget_get_window(mwin));
   }
   g_free(nome);
}

void nascondi_tb(GtkWidget *mwin)
{
  GtkWidget  *tbmain, *hbox1;

  if(ifToolbar && show_toolbar)
  {
     if(strstr(toolbarname[Livcur], "run") == NULL)
        c_no_more_crosses(); 
     if(ifMoveLabels)
        c_finish_move_labels();
     tbmain = lookup_widget(mwin, toolbarname[Livcur]);
     hbox1 = get_widget(tbmain, "hbox");
     gtk_widget_hide(hbox1);
 
     if(Livcur > 0)
        Livcur--;
     if((!strstr(toolbarname[Livcur], "main")) || show_toolbar)
     {
         tbmain = lookup_widget(mwin, toolbarname[Livcur]);
         hbox1 = get_widget(tbmain, "hbox");
         gtk_widget_set_sensitive(hbox1, TRUE);
         gtk_widget_show(hbox1);
      }
      if(Livcur == 0)
         abilitamb(mwin, -3);

/* se non e' una toolbar di tipo g1 riabilita il drag */
     if(strcmp(toolbarname[Livcur], "toolbar_g1") != 0)
         can_drag = TRUE;

   }
}

void update_run_entry(GtkWidget *mwin, char* string)
{
     GtkWidget  *tbmain, *entry;

     if(jscreen && ifToolbar && show_toolbar)
     {
        tbmain = lookup_widget(mwin, toolbarname[Livcur]);
        const char *name;
        if(strstr(toolbarname[Livcur], "run2"))
           name = "entryRun2";
        else
           name = "entry";
        if(get_widget(tbmain, name) != NULL)
        {
            entry = get_widget(tbmain, name);
            if(GTK_IS_LABEL(entry))
                 gtk_label_set_text(GTK_LABEL(entry), toUTF8(string));
            else if(GTK_IS_STATUSBAR(entry))
                 (void) gtk_statusbar_push(GTK_STATUSBAR(entry), 1, toUTF8(string));
        }
     }
}

void mostra_tbg1(GtkWidget *item, gpointer data)
{
  GtkWidget *tb, *mwin, *tb_button;
  char *key;
  GtkWidget *icon;
  char  *string;
  int ier;
     
  if(ifToolbar && show_toolbar)
  {
     CurrentStringSelected  = data;

     string = (char *)data;
/* blocca il drag */
     can_drag = FALSE;
/* recupera la main window */
//     mwin = lookup_widget(item, windowname);
     mwin = finestre[0];

/* dalla tabella della mainw recupera la pixmap */
     key = g_strdup_printf("icon%s", string);
     if(get_widget(mwin, key))
     {
        icon = get_widget(mwin, key);
        g_object_ref(icon);
      }
      else
        icon = create_image("mouse.png");

/* la sistema nella toolbar        */
     tb = lookup_widget(mwin, "toolbar_g1");
     CurrentToolBar  = tb;
#ifdef USE_ACTIONS
     GtkUIManager *merge = (GtkUIManager *)get_object(finestre[0], "ui-manager");
     GtkWidget *icong1 = gtk_ui_manager_get_widget (merge, "/toolbar_g1/iconG1");
     GtkWidget *childpix = gtk_bin_get_child(GTK_BIN(icong1));
     gtk_container_remove(GTK_CONTAINER(icong1), childpix);
     gtk_container_add(GTK_CONTAINER(icong1), icon);
     gtk_widget_show(icon);
#else
     GtkWidget *veratb = get_widget(tb, "tb");

     GList *children = gtk_container_get_children(GTK_CONTAINER(veratb));
     GtkWidget *childpix = GTK_WIDGET((g_list_nth(children, 0))->data);
     GtkWidget *child1 = gtk_bin_get_child(GTK_BIN(childpix));
     gtk_container_remove(GTK_CONTAINER(childpix), child1);
     tb_button = icon;
     gtk_container_add(GTK_CONTAINER(childpix), tb_button);
     gtk_widget_show(tb_button);
#endif
     tb_button = get_widget(finestre[0], "icon_cest");
     gtk_widget_hide(tb_button);

/* salva i widget dei tasti ok e cancel nella mainwindow (serve a me) */
     g_object_set_data(G_OBJECT(mwin), "ok_mr", 
          get_widget(tb, "Ok"));
     g_object_set_data(G_OBJECT(mwin), "cancel_mr", 
          get_widget(tb, "BackG1"));
     g_object_set_data(G_OBJECT(get_object(tb, "Ok")), "item", string);

/* mostra il tasto Ok e nasconde il campo testo e il tasto Close Polygon */
     gtk_widget_hide(get_widget(tb, "Close Polygon"));
     gtk_widget_show(get_widget(tb, "Ok"));
     gtk_widget_hide(get_widget(tb, "entryG1"));
     gtk_widget_hide(get_widget(tb, "spinG1"));

/* i casi personali vanno gestiti al di fuori */
     ier =pcase(tb, string);
     if(!ier)
        mostra_tb(item, (gpointer) "g1");
   }
}


void set_normal(GtkWidget *main_window)
{
   GdkCursor *def_cursor;
   GtkWidget  *draw;

   num_max_click = 0;
   draw = lookup_widget(main_window, drawingareaname);
   def_cursor = (GdkCursor *)get_object(draw, "def_cursor");
   gdk_window_set_cursor(gtk_widget_get_window(draw),def_cursor);
   npoints = 0;
}

void cancel_tb_rotate (GtkWidget *item, gpointer data)
{
    GtkWidget *tb, *mwin;

    if(ifContinueRot == 0)
       cancel_tb (item, data);
    else
    {
        stop_continue_rot();
        mwin = lookup_widget(item, windowname);
        tb = lookup_widget(mwin, "toolbar_Rotate");

        gpointer widget = get_object(tb, "spinRotate");
        obj_show(widget);
        widget = get_object(tb, "speed");
        obj_hide(widget);
        widget = get_object(tb, "Angle");
        obj_show(widget);
        widget = get_object(tb, "Speed");
        obj_hide(widget);
        widget = get_object(tb, "RC");
        obj_show(widget);
        widget = get_object(tb, "StopRot");
        obj_hide(widget);

    }
}

void cancel_tb (GtkWidget *item, gpointer data)
{
    GtkWidget *main_window, *dlg;

    main_window = finestre[0];

    clear_status_bar();
    nascondi_tb(main_window);
    set_normal(main_window);
    if(if_std_lsq_restr)
    {
       if_std_lsq_restr = 0;
       dlg = get_widget(main_window, "win_dlg");
       gtk_widget_set_sensitive(dlg, TRUE);
       gtk_widget_show(dlg);
       gdk_window_raise(gtk_widget_get_window(dlg));
    }
    if(ifOneAtom)
    {
       ifOneAtom = 0;
       dlg = get_widget(main_window, "win_dlg");
       gtk_widget_show(dlg);
       gdk_window_raise(gtk_widget_get_window(dlg));
    }
}

void ok_tb1 (GtkWidget *item, gpointer data)
{
    GtkWidget *dlg, *wid;
    GtkWidget *main_window;
    char *string, num[4];
    int ier, i;

    string = (char *) get_object(item, "item");
    main_window = gtk_widget_get_toplevel(item);
    set_normal(main_window);
    ier = c_finish_becca_punti();
    if(ier)
    {
       switch(ier)
       {
       case 2:
            MessageDialog(main_window, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
               "At the least you should click on three atoms!");
            break;
       case 5:
            MessageDialog(main_window, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
               "No atoms selected!");
            break;
       case 8:
            MessageDialog(main_window, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
               "No atoms selected to minimize distances!");
            break;
       default:
            MessageDialog(main_window, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
               "Wrong operation required");
            c_no_more_crosses();
            break;
       }
       mostra_tbcur(1);
    }
    else
    {
        if(if_std_lsq_restr)
        {
           ier = 0;
/*
           nascondi_tb(main_window);
           dlg = get_widget(main_window, "win_dlg");
           gtk_widget_set_sensitive(dlg, TRUE);
           gtk_widget_show(dlg);
           gdk_window_raise(dlg->window);
*/
           switch(if_std_lsq_restr)
           {
//101010           case 1:
//101010              seleziona(); 
//101010              break;
           case 2:
              manage_ok_restr(0) ;
              break;
           case 3:
              manage_ok_geom(0);
              break;
           case 4:
              manage_ok_ps(0);
              break;
           }
           if(ier)
              mostra_tbcur(1);
           else
           {
              nascondi_tb(main_window);
              dlg = get_widget(main_window, "win_dlg");
              gtk_widget_set_sensitive(dlg, TRUE);
              gtk_widget_show(dlg);
              gdk_window_raise(gtk_widget_get_window(dlg));
              if_std_lsq_restr = 0;
           }
        }
        else if(strstr(string, "OneAtom"))
        {
           ifOneAtom = 0;
           nascondi_tb(main_window);
           dlg = get_widget(main_window, "win_dlg");
           gtk_widget_show(dlg);
           for(i=0; i<3;i++)
           {
               ScriviStringa(num, sizeof(num), "c%d", i);
               wid = get_widget(dlg, num);
               gtk_entry_set_text(GTK_ENTRY(wid), It[i]);
           }
           gdk_window_raise(gtk_widget_get_window(dlg));
        }
        else if(strstr(string, "Accept hydrogen"))
           nascondi_tb(main_window);
        else
       {
/* 020307
         if(strstr(string, "Site"))
          {
              nascondi_tb(main_window);
              return;
          }
*/
	         if(strstr(string, "Single"))
                 {
                    nascondi_tb(main_window);
		    open_singlehydro(0, dialogo->kptrc[0]);
                    return;
                 }
          mostra_tbcur(0);
       }
    }
}

void ok_tbselect (GtkWidget *item, gpointer data)
{
    int ier;
    GtkWidget *main_window, *dlg;

    main_window = gtk_widget_get_toplevel(item);
    ier = c_finish_polygon();
    set_normal(main_window);
    if(ier)
    {
       switch(ier)
       {
       case 6:
            MessageDialog(main_window, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
               "No polygon!");
            break;
       case 7:
            MessageDialog(main_window, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
               "No atoms in the polygon!");
            break;
       default:
            MessageDialog(main_window, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
               "Wrong operation required");
            c_no_more_crosses();
            break;
       }
       mostra_tbcur(1);
    }
    else if(if_std_lsq_restr)
    {
          nascondi_tb(main_window);
          dlg = get_widget(main_window, "win_dlg");
          gtk_widget_set_sensitive(dlg, TRUE);
          gtk_widget_show(dlg);
          gdk_window_raise(gtk_widget_get_window(dlg));
//101010          if(if_std_lsq_restr == 1)
//101010             seleziona(); 
//101010          else if(if_std_lsq_restr == 2)
          if(if_std_lsq_restr == 2)
             manage_ok_restr(1) ;
          else if(if_std_lsq_restr == 3)
             manage_ok_geom(1);
          else if(if_std_lsq_restr == 4)
             manage_ok_ps(1) ;
          if_std_lsq_restr = 0;
     }
     else
          mostra_tbcur(ier);
}

//void ok_tbfour (GtkWidget *item, GdkEventButton *event, gpointer data)
void ok_tbfour (GtkWidget *item, gpointer data)
{
    GtkWidget *main_window;
    int irisp;
    int np = 0;
    int ifIdro = GPOINTER_TO_INT(data);

    main_window = gtk_widget_get_toplevel(item);
    finishfourier_(&np);
    if(np > 0)
    {
       irisp = MessageDialog(main_window, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO,
              "%d new peaks not labelled. \nOK to discard them?", np);
       if(irisp == GTK_RESPONSE_YES)
       {
          np = -1;
          finishfourier_(&np);
          nascondi_tb(main_window);
          set_normal(main_window);
       }
       else
          return;
    }
    else
    {
       nascondi_tb(main_window);
       set_normal(main_window);
    }
    if(ifIdro)
       gtk_main_quit();
}

void ok_tbcontour (GtkWidget *item, gpointer data)
{
    GtkWidget *main_window;

    main_window = gtk_widget_get_toplevel(item);
    finishcontour_();
    nascondi_tb(main_window);
    set_normal(main_window);
    c_aggiornadisegno();
}

void define_vector (GtkWidget *item, gpointer data)
{

     dialogo->ifBrekke = 1;
     if(ifStatusbar)
        print_mess("Click on two atoms to define vector");

     c_init_becca_punti(22);
     pseudo_Sorcio(finestre[0], 2,200);
}

void mostra_tbg1lsq(GtkWidget *mwin, int sel_mode, int flag)
{
  GtkWidget *tb, *dlg;
  GtkWidget *icon;
  char  *label;
     
  if(ifToolbar && show_toolbar)
  {
     CurrentStringSelected = (gpointer) "tbg1lsq";
     gsel_mode = sel_mode;
     dlg = get_widget(mwin, "win_dlg");
     gtk_widget_set_sensitive(dlg, FALSE);
     gtk_widget_hide(dlg);

     if(sel_mode == 3)                              /* select by polygon */
     {
        icon = create_image("select.png");
        label = DuplicaStringa( "Enclose in a polygon the atoms to be selected");
     }
     else                                          /* select by click */
     {
        icon = create_image("selects.png");
        label = DuplicaStringa("Click on atom(s) to be selected");
     }

/* blocca il drag */
     can_drag = FALSE;

/* recupera toolbar e oggetti vari */
     tb = lookup_widget(mwin, "toolbar_g1");
     CurrentToolBar  = tb;
#ifdef USE_ACTIONS
     GtkUIManager *merge = (GtkUIManager *)get_object(finestre[0], "ui-manager");
     GtkWidget *icong1 = gtk_ui_manager_get_widget (merge, "/toolbar_g1/iconG1");
     GtkWidget *childpix = gtk_bin_get_child(GTK_BIN(icong1));
     gtk_container_remove(GTK_CONTAINER(icong1), childpix);
     gtk_container_add(GTK_CONTAINER(icong1), icon);
     gtk_widget_show(icon);
     GtkWidget *labelg1 = gtk_ui_manager_get_widget (merge, "/toolbar_g1/labelG1");
     GtkWidget *childlab = gtk_bin_get_child(GTK_BIN(labelg1));
     set_label_text(childlab, label, TBLABELCOLOR, 1.1f);
#else
     GtkWidget *veratb = get_widget(tb, "tb");
     GList     *children = gtk_container_get_children(GTK_CONTAINER(veratb));
     GtkWidget *childlab = gtk_bin_get_child(GTK_BIN((g_list_nth(children, 2))->data));
     GtkWidget *childpix = GTK_WIDGET((g_list_nth(children, 0))->data);
     GtkWidget *child1 = gtk_bin_get_child(GTK_BIN(childpix));
     gtk_container_remove(GTK_CONTAINER(childpix), child1);
     set_label_text(childlab, label, TBLABELCOLOR, 1.1f);
     GtkWidget *tb_button = icon;
     gtk_container_add(GTK_CONTAINER(childpix), tb_button);
     gtk_widget_show(tb_button);
#endif

     mostra_tb(mwin, (gpointer) "g1");

/* salva i widget dei tasti ok e cancel nella mainwindow (serve a me) */
     g_object_set_data(G_OBJECT(mwin), "ok_mr", get_widget(tb, "Ok"));
     g_object_set_data(G_OBJECT(mwin), "cancel_mr", get_widget(tb, "BackG1"));
     g_object_set_data(G_OBJECT(get_object(tb, "Ok")), "item",(gpointer) "LSQ");

/* mostra il tasto Ok e nasconde il campo testo e il tasto Close Polygon */
     gtk_widget_hide(get_widget(mwin, "icon_cest"));
     gtk_widget_hide(get_widget(mwin, "entryG1"));
     gtk_widget_hide(get_widget(mwin, "spinG1"));
     if(sel_mode == 3)                            /* select by polygon */
     {
        gtk_widget_show(get_widget(tb, "Close Polygon"));
        gtk_widget_hide(get_widget(tb, "Ok"));
        c_init_polygon(8);
     }
     else                                         /* select by click */
     {
        gtk_widget_hide(get_widget(tb, "Close Polygon"));
        gtk_widget_show(get_widget(tb, "Ok"));
        c_init_becca_punti(23);
     }
     if_std_lsq_restr = flag;
     pseudo_Sorcio(mwin, 1,0);

  }
}

                                                                             
gboolean button_press (GtkWidget *widget, GdkEventButton  *ev, gpointer data)
{
  int x, y, ier, xb, yb, dx;
  GtkWidget *okbutton;
  GtkWidget *main_window, *statusbar, *tb, *entry;

  main_window = gtk_widget_get_toplevel(widget);
  x = (int) ev->x;
  y = (int) ev->y;

  if(ifStatusbar)
     statusbar   = lookup_widget(main_window, statusbarname);

  ifMoveCube = FALSE;
  if(clsqgtk->ifCubo > 0)
  {
     GdkRectangle rect;
     rect.x = clsqgtk->ixCubo - 25;
     rect.y = clsqgtk->iyCubo - 25;
     rect.width = rect.height = 50;
     gpointer reg = region_rectangle(&rect);
     if(point_in_region(reg, x, y))
     {
        ifMoveCube = TRUE;
        set_drag_cursor();
     }
     region_destroy(reg);
  }
  if (num_max_click == 0)
     return FALSE;
  if(get_widget(main_window, "ok_mr") != NULL)
     okbutton = get_widget(main_window, "ok_mr");

  CurrentLab = -1;
  movingLabel = FALSE;
  if((ier = c_becca_punti(&x, &y)) >= 0)
  {
     if((ok_clicked != 100) && (ok_clicked != 2))
        draw_cross(x, y, 1 - dialogo->jBackGround);
     npoints++;
     if(npoints == num_max_click)
     {
       switch (ok_clicked)
       {
       case 0:
                               /* Who */
                               /* Delete */
                               /* Renumber */
                               /* Tetrahedron */
                               /* Select ... */
           if(gsel_mode > 10)
              gtk_button_clicked(GTK_BUTTON(okbutton));
           break;
       case 1:
                               /* Add bonds */
                               /* Del bonds */
                               /* Move atoms */
                               /* Complete */
                               /* Regularize */
                               /* Add Atom */
                               /* Distances */
                               /* Angles */
                               /* Torsion Angles */
                               /* 3-atoms Plane */
                               /* Single hydrogen */
                               /* Add Polyhedron */
           gtk_button_clicked(GTK_BUTTON(okbutton));
           break;
       case 2:                        /* Rename */
           gtk_button_clicked(GTK_BUTTON(okbutton));
           ScriviStringa(old_name, sizeof(old_name), "%s", It[0]);
           tb = lookup_widget(main_window, "toolbar_g1");
           entry = get_widget(tb, "entryG1");
           gtk_entry_set_text(GTK_ENTRY(entry), old_name);
           gtk_widget_set_sensitive(entry, TRUE);
           CurrentLab = ier - 1;
           if(!dialogo->ifLabels)
           {
              dx = gtkext::text_width(fontdescP, old_name);
              xb = gMatrice(ipix, 0, CurrentLab)-dx/2;
              yb = gMatrice(ipix, 1, CurrentLab)+altSaveP/4;
              DrawLabel(xb, yb, 1, old_name); 
           }
           break;
       case 3:                        /* Rigid body */
    	   set_normal(main_window);
           gtk_main_quit();
           break;
       case 100:                      /* Move Labels */
           gtk_button_clicked(GTK_BUTTON(okbutton));
           CurrentLab = ier - 1;
           movingLabel = TRUE;
           xb = gMatrice(ipixLab, 0, CurrentLab);
           yb = gMatrice(ipixLab, 1, CurrentLab);
           DrawLabel(xb, yb, 0 , It[CurrentLab]);
           curPosx = xb;
           curPosy = yb;
           xb = gMatrice(ipix, 0, CurrentLab);
           yb = gMatrice(ipix, 1, CurrentLab);
           draw_cross(xb, yb, LABS);    /* croce sull'atomo */
           gdk_window_set_cursor(gtk_widget_get_window(widget),drag2_cursor);
           break;
       case 200:                      /* Define vector for rotation */
  	   set_normal(main_window);
	   def_vec = TRUE;
           if(ifStatusbar)
              gtk_statusbar_pop (GTK_STATUSBAR(statusbar), 1);
/* chiamata a fortran per calcolo */
          ier = c_finish_becca_punti();
          break;
       }
     }
  }
  return FALSE;
}

void open_toolbox (gpointer ,  gpointer data)
{
    gpointer widget;

    ifContinueRot = 1;

    widget = get_object(finestre[0], "spinRotate");
    obj_hide(widget);
    widget = get_object(finestre[0], "speed");
    obj_show(widget);
    widget = get_object(finestre[0], "Angle");
    obj_hide(widget);
    widget = get_object(finestre[0], "Speed");
    obj_show(widget);
    widget = get_object(finestre[0], "RC");
    obj_hide(widget);
    widget = get_object(finestre[0], "StopRot");
    obj_show(widget);
}

extern "C" int c_runtoolbar_(int *action, char *string)

{
  GtkWidget *tb, *button, *mainwin;

  if(!jscreen)
     return 0;
  mainwin = finestre[0];
/*
  if(single_it)
     while(gtk_events_pending())
         (void) gtk_main_iteration();
*/

  switch(*action)
  {

  case 1:                /* ex 155 Open run toolbar */
       mostra_tb(mainwin, (gpointer) "run");
       tb = lookup_widget(mainwin, "toolbar_run");
       button = get_widget(tb, "Stop");
       if(button)
          gtk_widget_set_sensitive(button, FALSE);
//       button = get_widget(tb, "Histogram");
//       gtk_widget_set_sensitive(button, FALSE);
       break;

  case 2:                /* ex 156 Close run toolbar */
       nascondi_tb(mainwin);
       break;

  case 3:                /* ex 157 Update entry in run toolbar */
       update_run_entry(mainwin, string);
       break;

  }
  while(gtk_events_pending())
       (void) gtk_main_iteration();
  return 0;
}

extern "C" void c_open_toolbar_(char *string)
{
   if(!jscreen)
     return;
    mostra_tb(finestre[0], string);
}

extern "C" void c_nasconditoolbar_(int *iflag)
{
  int iftoolbar = *iflag;
  GtkWidget *hb, *mb;
  if(!jscreen)
     return;
  hb = get_widget(get_widget(finestre[0], "toolbar_main"), "hbox");
  mb = lookup_widget(finestre[0], "menubar");
  if(iftoolbar)
  {
     if(Livcur == 0)
        gtk_widget_show(hb);
     gtk_widget_show(mb);
     show_toolbar = TRUE;
  }
  else
  {
     gtk_widget_hide(hb);
     gtk_widget_hide(mb);
     show_toolbar = FALSE;
  }
}

int tipoMappa(int *quale, int *ifMappa)
{
      GtkWidget *radiofn;
      GtkWidget *window1 = gtk_dialog_new ();
      if(*ifMappa)
         gtk_window_set_title (GTK_WINDOW (window1), "Best Model");
      else
         gtk_window_set_title (GTK_WINDOW (window1), "Map Viewer");
      gtk_container_set_border_width (GTK_CONTAINER (window1), 10);

      GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(window1));
      gtk_container_set_border_width (GTK_CONTAINER (vbox1), 4);
      GtkWidget *hbox1 = hbox_new (FALSE, 10);
      g_object_set_data (G_OBJECT (window1), "hbox1", hbox1);
      gtk_widget_show (hbox1);
      gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);
      gtk_container_set_border_width (GTK_CONTAINER (hbox1), 6);

      GtkWidget *icon = create_image("viewmap.png");
      gtk_widget_show (icon);
#ifdef IN_GTK3
      center_image(icon);
      GtkWidget *align = gtk_frame_new(NULL);
      gtk_frame_set_shadow_type(GTK_FRAME(align), GTK_SHADOW_NONE);
#else
      GtkWidget *align = gtk_alignment_new(0, 0.5, 0, 0);
#endif
      gtk_container_add(GTK_CONTAINER(align), icon);
      gtk_box_pack_start (GTK_BOX (hbox1), align, TRUE, TRUE, 0);
      GSList *group = NULL;
      GtkWidget *frame = FRAME_NEW ("Map type", FRAMECOLOR);
      gtk_widget_show (frame);
      GtkWidget *vbox2 = vbox_new (FALSE, 0);
      gtk_widget_show (vbox2);
      gtk_container_add (GTK_CONTAINER (frame), vbox2);

      if(*ifMappa)
      {
         radiofn = RADIO_BUTTON_WITH_LABEL (group, "No map", NULL);
         group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiofn));
         gtk_widget_show (radiofn);
         gtk_box_pack_start (GTK_BOX (vbox2), radiofn, TRUE, TRUE, 1);
      }
      GtkWidget *radiof = RADIO_BUTTON_WITH_LABEL (group, "Observed", NULL);
      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiof));
      gtk_widget_show (radiof);
      gtk_box_pack_start (GTK_BOX (vbox2), radiof, TRUE, TRUE, 1);
      radiof = RADIO_BUTTON_WITH_LABEL (group, "Fobs - Fcalc", NULL);
      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiof));
      gtk_box_pack_start (GTK_BOX (vbox2), radiof, TRUE, TRUE, 1);
      gtk_widget_show (radiof);
      gtk_box_pack_start (GTK_BOX (hbox1), frame, TRUE, TRUE, 0);

      GtkWidget *button1 = OK_button();
      gtk_dialog_add_action_widget (GTK_DIALOG (window1), button1, GTK_RESPONSE_OK);
      GtkWidget *button2 = CANCEL_button();
      gtk_dialog_add_action_widget (GTK_DIALOG (window1), button2, GTK_RESPONSE_CANCEL);
      gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(button1)), GTK_BUTTONBOX_SPREAD);

      gtk_window_set_transient_for(GTK_WINDOW(window1), GTK_WINDOW(finestre[0]));
      gtk_widget_show_all(window1);
      int result = gtk_dialog_run(GTK_DIALOG(window1));
      *quale = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radiof));
      if(*ifMappa)
         *ifMappa = !gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radiofn));
      gtk_widget_destroy(window1);
      return result;
}

int tipoVariance(int *quale)
{
      GtkWidget *window1 = gtk_dialog_new ();
      gtk_window_set_title (GTK_WINDOW (window1), "MapVariance");
      gtk_container_set_border_width (GTK_CONTAINER (window1), 10);

      GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(window1));
      gtk_container_set_border_width (GTK_CONTAINER (vbox1), 4);
      GtkWidget *hbox1 = hbox_new (FALSE, 10);
      g_object_set_data (G_OBJECT (window1), "hbox1", hbox1);
      gtk_widget_show (hbox1);
      gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);
      gtk_container_set_border_width (GTK_CONTAINER (hbox1), 6);

      GtkWidget *icon = create_image("viewmap.png");
      gtk_widget_show (icon);
#ifdef IN_GTK3
      center_image(icon);
      GtkWidget *align = gtk_frame_new(NULL);
      gtk_frame_set_shadow_type(GTK_FRAME(align), GTK_SHADOW_NONE);
#else
      GtkWidget *align = gtk_alignment_new(0, 0.5, 0, 0);
#endif
      gtk_box_pack_start (GTK_BOX (hbox1), align, TRUE, TRUE, 0);
      gtk_container_add(GTK_CONTAINER(align), icon);
      GSList *group = NULL;
      GtkWidget *frame = FRAME_NEW ("Map type", FRAMECOLOR);
      gtk_widget_show (frame);
      GtkWidget *vbox2 = vbox_new (FALSE, 0);
      gtk_widget_show (vbox2);
      gtk_container_add (GTK_CONTAINER (frame), vbox2);

      GtkWidget *radiof = RADIO_BUTTON_WITH_LABEL (group, "Variance", NULL);
      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiof));
      gtk_widget_show (radiof);
      gtk_box_pack_start (GTK_BOX (vbox2), radiof, TRUE, TRUE, 1);
      radiof = RADIO_BUTTON_WITH_LABEL (group, "Map/Variance", NULL);
      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiof));
      gtk_box_pack_start (GTK_BOX (vbox2), radiof, TRUE, TRUE, 1);
      gtk_widget_show (radiof);
      gtk_box_pack_start (GTK_BOX (hbox1), frame, TRUE, TRUE, 0);

      GtkWidget *button1 = OK_button();
      gtk_dialog_add_action_widget (GTK_DIALOG (window1), button1, GTK_RESPONSE_OK);
      GtkWidget *button2 = CANCEL_button();
      gtk_dialog_add_action_widget (GTK_DIALOG (window1), button2, GTK_RESPONSE_CANCEL);
      gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(button1)), GTK_BUTTONBOX_SPREAD);

      gtk_widget_show_all(window1);
      int result = gtk_dialog_run(GTK_DIALOG(window1));
      *quale = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radiof)) + 1;
      gtk_widget_destroy(window1);
      return result;
}

void c_newbestmodel(GtkButton *button, gpointer data)
{
  GtkWidget *tb;
  GtkWidget *drawingarea = lookup_widget(finestre[0], drawingareaname);

//  dialogo->ifMadEnv = 0;    Gianluca 08/07/2010
  int which, ifMappa=1;
  int result = tipoMappa(&which, &ifMappa);
  if(result != GTK_RESPONSE_OK)
     return;

  gdk_window_set_cursor(gtk_widget_get_window(drawingarea),wait_cursor);
  bestmodel_(&which, &ifMappa);
  gdk_window_set_cursor(gtk_widget_get_window(drawingarea),default_cursor);

  tb = lookup_widget(finestre[0], "toolbar_main");

  if(dialogo->QualeAbilita)
  {
      if(ifMenubar)
         abilitamb(finestre[0], dialogo->QualeAbilita);
      if(ifToolbar)
         abilitatb(tb, dialogo->QualeAbilita);
      can_drag = MRmax(dialogo->QualeAbilita - 1, 0);
  }
  else
  {
      if(ifMenubar)
         abilitamb(finestre[0], -1);
      if(ifToolbar)
         abilitatb(finestre[0], -1);
      can_drag = FALSE;
      draw_initial_pixmap();
  }
}

extern "C" void c_proc_over_(int *show_gui)
{
    if(!jscreen)
       return;
    fine_lavoro();
    
//  24/03/2015 No tasti
    return;
//
    GtkWidget *hb = get_widget(finestre[0], "hboxsotto");
    gtk_widget_hide(hb);
    hb = get_widget(finestre[0], "gui_button");
    if(*show_gui)
       gtk_widget_show(hb);
    else
       gtk_widget_hide(hb);
    hb = get_widget(finestre[0], "close_box");
    gtk_widget_show(hb);
}

/**********************************************/
/*               Toggle Buttons               */
/**********************************************/

void init_toggles(GtkWidget *tb, gpointer data)
{
   gpointer widget;

   widget = get_object(finestre[0], "CellOn");
   obj_set_active(widget, dialogo->ifCell);
   widget = get_object(finestre[0], "LabTog");
   obj_set_active(widget, dialogo->ifLabels);
   widget = get_object(finestre[0], "SymmOn");
   obj_set_active(widget, dialogo->ifCont);
   widget = get_object(finestre[0], "togbg");
   obj_set_active(widget, main_app::TheApp.Background);
//   widget = lookup_widget(finestre[0], "DrawGrOn");
//   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dialogo->ifDrawGroups);
}

void init_toggles2()
{
   gpointer widget;

   widget = get_object(finestre[0], "CellOn");
   obj_set_active(widget, dialogo->ifCell, true);
   widget = get_object(finestre[0], "LabTog");
   obj_set_active(widget, dialogo->ifLabels, true);
   widget = get_object(finestre[0], "SymmOn");
   obj_set_active(widget, dialogo->ifCont, true);
   widget = get_object(finestre[0], "DrawGrOn");
   obj_set_active(widget, dialogo->ifDrawGroups, true);
   widget = get_object(finestre[0], "GrOn");
   obj_set_active(widget, dialogo->ifDrawGroups, true);
//   widget = get_widget(lookup_widget(finestre[0], menubarname), "BackBone On/Off");
//   GtkWidget *button = get_widget(widget, "button");
//   gtk_widget_hide(get_widget(button, "icon1"));
//   gtk_widget_show(get_widget(button, "icon0"));
}

void aggiornatasto(const char *nome, gboolean stato)
{
    gpointer tasto;

   if(ifToolbar && show_toolbar)
   {
      tasto = get_object(finestre[0], nome);
      if(obj_get_visible(tasto))
         obj_set_active(tasto, stato);
   }
}

void aggiornatasto2(const char *nome, gboolean stato)
{
   gpointer tasto;

   if(ifToolbar && show_toolbar)
   {
      tasto = get_object(finestre[0], nome);
      if(obj_get_visible(tasto))
         obj_set_active(tasto, stato, true);
   }
}

void change_bg(const char *nome, int val, int flag)
{
   main_app::TheApp.UpdateBG(val);
   c_aggiornadisegno();
   if(flag)
      aggiornatasto(nome, val);
}

void toggle_bg(gpointer widget,  gpointer data)
{
   dialogo->jBackGround = obj_get_active(widget);
   dialogo->icoWire = 1 - dialogo->jBackGround;
   change_bg((char *)data, dialogo->jBackGround, 0);
}

void change_label(const char *nome, int val, int flag)
{
   main_app::TheApp.UpdateLabel(val);
   c_aggiornadisegno();
   if(flag)
      aggiornatasto(nome, val);
}

void toggle_label(gpointer widget,  gpointer data)
{
   gpointer move_button;

   dialogo->ifLabels = obj_get_active(widget);
   change_label((char *)data, dialogo->ifLabels, 0);
   move_button = get_object(finestre[0], "Move Labels");
   obj_show(move_button);
   obj_set_sensitive(move_button, dialogo->ifLabels);
}

void change_cell(const char *nome, int val, int flag)
{
   c_aggiornadisegno();
   if(flag)
      aggiornatasto(nome, val);
}

int change_symm(char *nome, int val, int flag)
{
   int ier = 0;
   elaborazione_in_corso();
   fortran_al_lavoro();
   symmonoff_(&ier);
   fine_lavoro();
   c_aggiornadisegno();
   fine_elaborazione();
   return ier;
}

void toggle_cell(gpointer wid,  char *string)
{
   int val;

   val = obj_get_active(wid);
   dialogo->ifCell = val;
   change_cell(string, val, 0);
}

void toggle_symm(gpointer wid,  char *string)
{
   int val;

   val = obj_get_active(wid);
   dialogo->ifCont = val;
   if( change_symm(string, val, 0) < 0 )
   {
       int hnd = get_int(wid, "hnd");
       g_signal_handler_block(G_OBJECT(wid), hnd);
       obj_set_active(wid, dialogo->ifCont);
       g_signal_handler_unblock(G_OBJECT(wid), hnd);
   }
}

void toggle_grid(gpointer widget,  gpointer data)
{
   Contour->ifGrid = obj_get_active(widget);
   c_aggiornadisegno();
}

void UpdateColors(int iflag)
{
  if(iflag)
     main_app::TheApp.WritePalette();
  tihocambiatoicolori_(&iflag);
  c_aggiornadisegno();
}

/**********************************************/
/*               K E Y S                      */
/**********************************************/

gboolean key_pressed_sir (GtkWidget *widget, GdkEventKey *event, gpointer data)
{
    int icode,  iadd, int1;
    guint stato;

    if(viewerOpened)
       return FALSE;
    tasti->ifFkey = 0;
    tasti->ifCtrl = 0;
    tasti->ifShift = 0;
    tasti->tasto_premuto = event->keyval;
    stato = event->state;
    if ( (stato & GDK_CONTROL_MASK) == GDK_CONTROL_MASK )
          tasti->ifCtrl =  1;
    else if ( (stato & GDK_SHIFT_MASK) == GDK_SHIFT_MASK )
         tasti->ifShift =  1;

    int1 = 1;
    iadd = 0;
    if (tasti->ifShift)
        iadd = 30;

    switch(tasti->tasto_premuto)
    {
    case KeyLeft :
    case KeyKpLeft :
         if(tasti->ifCtrl || tasti->ifShift)
            icode = 3 + iadd;
         else
            icode = 9;
         break;
    case KeyRight :
    case KeyKpRight :
         if(tasti->ifCtrl || tasti->ifShift)
            icode = 4 + iadd;
         else
            icode = 10;
         break;
    case KeyDown :
    case KeyKpDown :
         if(tasti->ifCtrl || tasti->ifShift)
            icode = 2 + iadd;
         else
            icode = 11;
         break;
    case KeyUp :
    case KeyKpUp :
         if(tasti->ifCtrl || tasti->ifShift)
            icode = 1 + iadd;
         else
            icode = 12;
         break;
    case KeyPageDown:
    case KeyKpPageDown:
         if(tasti->ifCtrl || tasti->ifShift)
            icode = 5 + iadd;
         else
            icode = 13;
         break;
    case KeyPageUp:
    case KeyKpPageUp:
         if(tasti->ifCtrl || tasti->ifShift)
            icode = 6 + iadd;
         else
            icode = 14;
         break;
    case Keyminus:
    case KeyKpsubtract:
         icode = 7 + iadd;
         if(!def_vec)
            return FALSE;
         break;
    case Keyplus:
    case KeyKpadd:
         icode = 8 + iadd;
         if(!def_vec)
            return FALSE;
         break;
    case KeyHome:
    case KeyKpHome:
         icode = 17;
         break;
    case KeyEnd:
    case KeyKpEnd:
         stop_continue_rot();
         dialogo->iRotSpeed = 10;
         return TRUE;
         break;
    case Key0:
    case KeyKp0:
    case Key1:
    case KeyKp1:
    case Key2:
    case KeyKp2:
    case Key3:
    case KeyKp3:
    case Key4:
    case KeyKp4:
    case Key5:
    case KeyKp5:
    case Key6:
    case KeyKp6:
    case Key7:
    case KeyKp7:
    case Key8:
    case KeyKp8:
    case Key9:
    case KeyKp9:
         if(ifContinueRot)
         {
            dialogo->iRotSpeed = (tasti->tasto_premuto)%16 + 1;
            return TRUE;
         }
         else
            return FALSE;
         break;
    case KeyQ:
    case Keyq:
        if(tasti->ifCtrl)
           exit_confirm (NULL, "forced");
        return TRUE;
        break;
    case KeyP:
    case Keyp:
        if(tasti->ifCtrl)
        {
           if(!(liste->l[14]) || Contour->ifDrawContour)
              return FALSE;
           open_cplotstyle_dlg (NULL, (gpointer) " ");
           return TRUE;
        }
        return FALSE;
        break;
    case KeyL:
    case Keyl:
        if(tasti->ifCtrl)
        {
           dialogo->ifLabels = !(dialogo->ifLabels);
           change_label("LabTog", dialogo->ifLabels, 1);
           change_label("LabTogF", dialogo->ifLabels, 1);
           change_label("LabTogH", dialogo->ifLabels, 1);
           return TRUE;
        }
        return FALSE;
        break;
    case KeyB:
    case Keyb:
        if(tasti->ifCtrl)
        {
           dialogo->jBackGround = !dialogo->jBackGround;
           dialogo->icoWire = 1 - dialogo->jBackGround;
           change_bg("togbg", dialogo->jBackGround, 1);
           return TRUE;
        }
        return FALSE;
        break;
    case KeyE:
    case Keye:
        if(tasti->ifCtrl)
        {
           dialogo->ifCell = !dialogo->ifCell;
           change_cell("CellOn", dialogo->ifCell,1);
           change_cell("CellOnC", dialogo->ifCell,1);
           return TRUE;
        }
        return FALSE;
        break;
    case KeyH:
    case Keyh:
        if(tasti->ifCtrl)
        {
           PrintScreen(NULL, GINT_TO_POINTER(1));
           return TRUE;
        }
        return FALSE;
        break;
    default:
         return FALSE;
    }
    if((icode >= 31) && (icode <= 38))
    {
         ifContinueRot = 1;
         dialogo->ifBrekke = 0;
         dialogo->iRotSpeed = 10;
         if(show_toolbar && (strstr(toolbarname[Livcur], "Rotate") != NULL))
            open_toolbox(NULL, (gpointer) " ");
    }
    if(!(liste->l[14]))
       return FALSE;
    c_vista(icode, int1);
    return TRUE;
}


/**********************************************/
/*         C o n t o u r                      */
/**********************************************/

static int atoms_required = 0;

void c_finish_levels(void)
{
   finish_levels_(lvis, lval, lcolor);
}

void change_colors_combo (GtkToggleButton *button, gpointer data)
{
   GtkWidget *wid;
   int i, j;
   char num[6];

   i = gtk_toggle_button_get_active(button);
   for(j=0;j<5;j++)
   {
       if(i)
          lcolor[j] = 4 + j + N_OBJS+NUM_COLORS;
       else
          lcolor[j] = 15 - j + N_OBJS+NUM_COLORS;
       ScriviStringa (num, sizeof(num), "col%d", j);
       wid = lookup_widget(GTK_WIDGET(button), num);
       set_color_row(wid, lcolor[j]);
  }
}

void close_cont_dlg1 (GtkButton *button, gpointer data)
{
   GtkWidget *wid;
   GtkAdjustment *adj;
   int ifOk;
   int i;
   char num[6];

   ifOk = GPOINTER_TO_INT(data);
   if(ifOk)
   {
      for (i=0; i<5; i++)
      {
           ScriviStringa (num, sizeof(num), "cb%d", i);
           wid = lookup_widget(GTK_WIDGET(button), num);
           lvis[i] = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wid));
           ScriviStringa (num, sizeof(num), "sc%d", i);
           wid = lookup_widget(GTK_WIDGET(button), num);
           adj = gtk_range_get_adjustment ((GtkRange *)wid);
           lval[i] = (int) gtk_adjustment_get_value(adj);
           ScriviStringa (num, sizeof(num), "col%d", i);
           wid = lookup_widget(GTK_WIDGET(button), num);
           lcolor[i] = get_int(wid, "colore");
//         printf("lev %d check %d val %d col %d\n", i+1, lvis[i], lval[i], lcolor[i]);
      }
      wid = lookup_widget(GTK_WIDGET(button), "bg");
      i = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wid));
      if(i != dialogo->jBackGround)
      {
         dialogo->jBackGround = i;
         change_bg("togbg", dialogo->jBackGround, 1);
      }
      c_finish_levels();
   }
   if(ifOk <= 1)
      close_dlg(button, GINT_TO_POINTER(1));
}

void close_cont_dlg2 (GtkButton *button, gpointer data)
{
   int ifOk, i, j, ier, iAction;
   GtkWidget *wid, *tb, *hbox;
   char num[10];
   float newval;

   ifOk = GPOINTER_TO_INT(data);
   ier = 0;
   if(!ifOk)
   {
      close_dlg(button, GINT_TO_POINTER(1));
      return;
   }
   for(i=1; i<=4; i++)
   {
       ScriviStringa(num, sizeof(num), "radio%d", i);
       wid = lookup_widget(GTK_WIDGET(button), num);
       if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wid)))
       {
            iAction = i;
            break;
       }
   }
   ifOk = 0;
   switch(iAction)
   {
   case 4:
      for (j=0; j<3; j++)
      {
           ScriviStringa (num, sizeof(num), "c%d", j);
           wid = lookup_widget(GTK_WIDGET(button), num);
           CopiaStringa(num, sizeof(num), 
                         gtk_editable_get_chars(GTK_EDITABLE(wid), 0, -1));
           errno = 0;
           newval = (float) atof(num);
           if (newval != c_center[j]) 
           {
               c_center[j] = newval;
               ifOk = 1;
           }
           if(errno)
              ier = -1;

           ScriviStringa (num, sizeof(num), "d%d", j);
           wid = lookup_widget(GTK_WIDGET(button), num);
           CopiaStringa(num, sizeof(num), 
                         gtk_editable_get_chars(GTK_EDITABLE(wid), 0, -1));
           errno = 0;
           newval = (float) atof(num);
           if (newval != c_delta[j]) 
           {
               c_delta[j] = newval;
               ifOk = 1;
           }
           if(errno)
              ier = -1;
      }
      break;

   case 2:
      for (j=0; j<3; j++)
      {
           ScriviStringa (num, sizeof(num), "nc%d", j);
           wid = lookup_widget(GTK_WIDGET(button), num);
           i = spin_button_get_value_as_int(wid);
           if(i != Contour->numCell[0][j])
           {
              Contour->numCell[0][j] = i;
              ifOk = 1;
           }
           ScriviStringa (num, sizeof(num), "sc%d", j);
           wid = lookup_widget(GTK_WIDGET(button), num);
           i = spin_button_get_value_as_int(wid);
           if(i != Contour->numCell[1][j])
           {
              Contour->numCell[1][j] = i;
              ifOk = 1;
           }
      }
      break;
   default:
//       ifOk = 1;
      break;
   }
   if(!ier)
   {
      if(iAction != RadioSelected)
         ifOk = 1;
      close_dlg(button, GINT_TO_POINTER(1));
      if(ifOk)
      {
         for (i=0; i<3; i++)
         {
            Contour->centerCont[i] = c_center[i];
            Contour->deltaCont[i] = c_delta[i];
         }
         Contour->WhichLimit = iAction;
         tb = lookup_widget(finestre[0], toolbarname[Livcur]);
         hbox = get_widget(tb, "hbox");
         gtk_widget_set_sensitive(hbox, FALSE);
         finish_limits_();
         aggiorna_statusbar();
         gtk_widget_set_sensitive(hbox, TRUE);
      }

   }
}

void close_cont_dlg3 (GtkButton *button, gpointer data)
{
   int ifOk;
   GtkWidget *wid;

   ifOk = GPOINTER_TO_INT(data);
   if(ifOk)
   {
      wid = lookup_widget(GTK_WIDGET(button), "radio1");
      if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wid)))  // One section
      {
         wid = lookup_widget(GTK_WIDGET(button), "section");
         Contour->sezione0 = spin_button_get_value_as_int(
                  wid) - 1;
         Contour->sezioneN = Contour->sezione0;
      }
      else                                                      // More than
      {
         wid = lookup_widget(GTK_WIDGET(button), "section0");
         Contour->sezione0 = spin_button_get_value_as_int(
                  wid) - 1;
         wid = lookup_widget(GTK_WIDGET(button), "sectionN");
         Contour->sezioneN = spin_button_get_value_as_int(
                  wid) - 1;
      }
       leggisezioni_();
       c_aggiornadisegno();
   }
   aggiorna_statusbar();
   close_dlg(button, GINT_TO_POINTER(1));
}

GtkWidget *create_cont_dlg1(void)
{
    GtkWidget *window, *icon2;
    GtkWidget *vbox, *wid1, *wid2, *table, *wid;
    int i, j;
    char num[5];

    window = gtk_dialog_new();
    gtk_window_set_title(GTK_WINDOW(window), "Set contour levels");
    vbox = (gtk_dialog_get_content_area(GTK_DIALOG(window)));
    gtk_container_set_border_width(GTK_CONTAINER(vbox), 10);

    table = table_new(5, 3, FALSE);
    gtk_widget_show(table);
    table_set_row_spacings(table, 0);
    table_set_col_spacings(table, 0);
    gtk_box_pack_start(GTK_BOX(vbox), table, TRUE, TRUE, 4);
    for(j=0; j<3; j++)
    {
        for(i=0; i<5; i++)
        {
            wid = gtk_frame_new(NULL);
            table_attach(table, wid, j, j+1, i, i+1, TRUE);
            gtk_widget_show(wid);
            switch (j)
            {
            case 0:
               ScriviStringa (num, sizeof(num), " %d ", i+1);
               wid1 = LABEL_NEW(num, LABELCOLOR);
               gtk_widget_show(wid1);
               break;
            case 1:
               ScriviStringa (num, sizeof(num), "cb%d", i);
               wid1 = gtk_check_button_new();
               g_object_set_data(G_OBJECT(window), num, wid1);
               gtk_widget_show(wid1);
               break;
            case 2:
               wid1 = hbox_new(FALSE, 0);
               gtk_widget_show(wid1);
               wid2 = hscale_new(GTK_ADJUSTMENT(adj_new (
                       10, 10, 200, 0, 10)));
               gtk_scale_set_digits(GTK_SCALE(wid2), 0);
               ScriviStringa (num, sizeof(num), "sc%d", i);
               g_object_set_data(G_OBJECT(window), num, wid2);
               gtk_box_pack_start (GTK_BOX (wid1), wid2, TRUE,TRUE, 0);
               gtk_widget_set_size_request(wid2, 120, -1);
               gtk_widget_show(wid2);
               lcolor[i] = i+4+N_OBJS+NUM_COLORS;
               wid2 = create_combo_colors (wid1, lcolor[i]);
               ScriviStringa (num, sizeof(num), "col%d", i);
               g_object_set_data(G_OBJECT(window), num, wid2);
               gtk_widget_show(wid2);
               break;
            }
            gtk_container_add(GTK_CONTAINER(wid), wid1);
        } 
    } 

    wid1 = hbox_new(TRUE, 2);
    gtk_container_set_border_width(GTK_CONTAINER(wid1), 8);
    gtk_box_pack_start(GTK_BOX(vbox), wid1, FALSE, TRUE, 4);
    gtk_widget_show(wid1);

    wid2 = LABEL_BOLD("Background setting", LABELCOLOR, 1.2f);
    gtk_box_pack_start(GTK_BOX(wid1), wid2, FALSE, TRUE, 0);
    gtk_widget_show(wid2);

    icon2 = create_image("bbackgoff.png");
    wid2 = mr_toggle_button_new_with_pixmap(icon2, dialogo->jBackGround);
    gtk_box_pack_start (GTK_BOX (wid1), wid2, FALSE, FALSE, 0);
    g_object_set_data(G_OBJECT(window), "bg", wid2);
    (void) g_signal_connect (G_OBJECT (wid2), "clicked",
                      G_CALLBACK(change_colors_combo), NULL);
    gtk_widget_show(wid2);
  
    wid1 = OK_button();
    gtk_dialog_add_action_widget(GTK_DIALOG (window), wid1, 1);
    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(close_cont_dlg1), GINT_TO_POINTER(1));

    wid1 = APPLY_button();
    gtk_dialog_add_action_widget(GTK_DIALOG (window), wid1, 2);
    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(close_cont_dlg1), GINT_TO_POINTER(2));

    wid1 = CANCEL_button();
    gtk_dialog_add_action_widget(GTK_DIALOG (window), wid1, 3);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(wid1)), GTK_BUTTONBOX_SPREAD);

    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(close_cont_dlg1), GINT_TO_POINTER(0));
    (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
         G_CALLBACK(gtk_button_clicked), G_OBJECT(wid1));
   (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

    return window;
}

void attiva_entries2 (GtkToggleButton *button, gpointer data)
{
    GtkWidget *entry;
    int iattiva;

    iattiva = GPOINTER_TO_INT(data);
    
    if(gtk_toggle_button_get_active(button))
    {
       entry = lookup_widget(GTK_WIDGET(button), "more1");
       gtk_widget_set_sensitive(entry, iattiva);
       entry = lookup_widget(GTK_WIDGET(button), "more2");
       gtk_widget_set_sensitive(entry, iattiva);
       entry = lookup_widget(GTK_WIDGET(button), "one");
       gtk_widget_set_sensitive(entry, !iattiva);
    } 
    aggiorna_statusbar();
}

void scegli_atomo(GtkButton *button, GtkWidget *dlg)
{
    GtkWidget *wid;
    int i;
    char num[4];

    if(Contour->ifModel)
    {
       gtk_widget_hide(dlg);
       g_object_set_data(G_OBJECT(finestre[0]), "win_dlg", dlg);
       
       for(i=0; i<3;i++)
       {
           ScriviStringa(num, sizeof(num), "c%d", i);
           wid = get_widget(dlg, num);
           ScriviStringa(It[i], sizeof(num), "%s", 
                   gtk_editable_get_chars(GTK_EDITABLE(wid), 0, -1));
       }
       mostra_tbg1(NULL, (gpointer) "OneAtom");
    }
    else
       (void) MessageDialog(dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
              "Sorry. No atoms visible.");
}

void user_box(GtkWidget *frame, GtkWidget *window)
{
    GtkWidget *table, *wid2, *wid1;
    int j;
    char num[10];

    table = table_new(6, 3, FALSE);
    table_set_row_spacings(table, 4);
    table_set_col_spacings(table, 4);
    gtk_widget_show(table);
    gtk_container_add (GTK_CONTAINER (frame), table);
    gtk_container_set_border_width(GTK_CONTAINER(table), 2);

    wid2 = LABEL_BOLD("Dimensions of the box (Ang.)", LABELCOLOR, 1.2f);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0., 0.5);
    table_attach(table, wid2, 0, 3, 0, 1, TRUE);

    wid2 = LABEL_NEW("Lx", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 0, 1, 1, 2, TRUE);

    wid2 = LABEL_NEW("Ly", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 1, 2, 1, 2, TRUE);

    wid2 = LABEL_NEW("Lz", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 2, 3, 1, 2, TRUE);

    wid2 = LABEL_BOLD("Type center coordinates of the box", LABELCOLOR, 1.2f);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0., 0.5);
    table_attach(table, wid2, 0, 3, 3, 4, TRUE);

    wid2 = LABEL_BOLD("or select atom as center", LABELCOLOR, 1.2f);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0., 0.5);
    table_attach(table, wid2, 0, 2, 5, 6, TRUE);

    wid2 = xpm_button("mouse.png");
    gtk_widget_show(wid2);
    table_attach(table, wid2, 2, 3, 5, 6);
    (void) g_signal_connect(G_OBJECT(wid2), "clicked", 
          G_CALLBACK(scegli_atomo), window);

    for(j=0; j<3; j++)
    {
        wid1 = gtk_entry_new();
        set_width_chars (GTK_ENTRY(wid1), 10);
        gtk_widget_show(wid1);
        table_attach(table, wid1, j, j+1, 2, 3, TRUE);
        ScriviStringa(num, sizeof(num), "d%d", j);
        g_object_set_data(G_OBJECT(window), num, wid1);
        wid1 = gtk_entry_new();
        set_width_chars (GTK_ENTRY(wid1), 10);
        gtk_widget_show(wid1);
        table_attach(table, wid1, j, j+1, 4, 5, TRUE);
        ScriviStringa(num, sizeof(num), "c%d", j);
        g_object_set_data(G_OBJECT(window), num, wid1);
    }
}

void complete_cell(GtkWidget *frame, GtkWidget *window)
{
    GtkWidget *table, *wid2, *wid1;
    int j;
    char num[10];

    table = table_new(6, 3, FALSE);
    table_set_row_spacings(table, 4);
    table_set_col_spacings(table, 4);
    gtk_widget_show(table);
    gtk_container_add (GTK_CONTAINER (frame), table);
    gtk_container_set_border_width(GTK_CONTAINER(table), 2);

    wid2 = LABEL_BOLD("Number of cells:", LABELCOLOR, 1.2f);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0., 0.5);
    table_attach(table, wid2, 0, 3, 0, 1, TRUE);


    wid2 = LABEL_NEW("along x", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 0, 1, 1, 2, TRUE);

    wid2 = LABEL_NEW("along y", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 1, 2, 1, 2, TRUE);

    wid2 = LABEL_NEW("along z", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 2, 3, 1, 2, TRUE);

    wid2 = LABEL_NEW("along x", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 0, 1, 4, 5, TRUE);

    wid2 = LABEL_NEW("along y", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 1, 2, 4, 5, TRUE);

    wid2 = LABEL_NEW("along z", LABELCOLOR);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0.5, 0.5);
    table_attach(table, wid2, 2, 3, 4, 5, TRUE);

    wid2 = LABEL_BOLD("Starting point", LABELCOLOR,1.2f);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0., 0.5);
    table_attach(table, wid2, 0, 3, 3, 4, TRUE);

    for(j=0; j<3; j++)
    {
        wid1 = spin_button_new(GTK_ADJUSTMENT(
                 adj_new (1.f, 1.f,3.f,1.f,1.f)),1,0);
        set_width_chars (GTK_ENTRY(wid1), 8);
        gtk_widget_show(wid1);
        table_attach(table, wid1, j, j+1, 2, 3, TRUE);
        ScriviStringa(num, sizeof(num), "nc%d", j);
        g_object_set_data(G_OBJECT(window), num, wid1);
        wid1 = spin_button_new(GTK_ADJUSTMENT(
                 adj_new (0.f, -2.f,2.f,1.f,1.f)),1,0);
        set_width_chars (GTK_ENTRY(wid1), 8);
        gtk_widget_show(wid1);
        table_attach(table, wid1, j, j+1, 5, 6, TRUE);
        ScriviStringa(num, sizeof(num), "sc%d", j);
        g_object_set_data(G_OBJECT(window), num, wid1);
    }
}

GtkWidget *create_cont_dlg2(void)
{
    GtkWidget *window, *frame, *frame1;
    GtkWidget *vbox, *wid1, *wid2, *wid, *radio;
    GSList *group = NULL;

    window = gtk_dialog_new();
    gtk_window_set_title(GTK_WINDOW(window), "Set limits");
    vbox = (gtk_dialog_get_content_area(GTK_DIALOG(window)));
    gtk_container_set_border_width(GTK_CONTAINER(vbox), 10);
    
    wid1 = FRAME_NEW("Limits", FRAMECOLOR);
    gtk_widget_show(wid1);
    gtk_box_pack_start(GTK_BOX (vbox), wid1, TRUE, TRUE, 0);
    gtk_container_set_border_width(GTK_CONTAINER(wid1), 2);

    wid = vbox_new(FALSE, 0);
    gtk_widget_show(wid);
    gtk_container_add(GTK_CONTAINER (wid1), wid);

    wid2 = LABEL_BOLD("Select part of the map", LABELCOLOR, 1.2f);
    gtk_widget_show(wid2);
    set_alignment(wid2, 0., 0.5);
    gtk_box_pack_start (GTK_BOX (wid), wid2, FALSE, FALSE, 0);

    frame = FRAME_NEW("Box", FRAMECOLOR);

    frame1 = FRAME_NEW("Cells", FRAMECOLOR);

    radio = RADIO_BUTTON_WITH_LABEL (group, "Asymmetric unit", LABELCOLOR);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(window), "radio1", radio);
    gtk_widget_show(radio);
    gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);

    radio = RADIO_BUTTON_WITH_LABEL (group, "Complete unit cell", LABELCOLOR);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(window), "radio2", radio);
    gtk_widget_show(radio);
    gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);
    (void) g_signal_connect (G_OBJECT (radio), "toggled",
                       G_CALLBACK(on_cb_show),frame1);

    radio = RADIO_BUTTON_WITH_LABEL (group, "Box around model", LABELCOLOR);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(window), "radio3", radio);
    gtk_widget_show(radio);
    gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);

    radio = RADIO_BUTTON_WITH_LABEL (group, "User defined box", LABELCOLOR);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(window), "radio4", radio);
    gtk_widget_show(radio);
    gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);
    (void) g_signal_connect (G_OBJECT (radio), "toggled",
                       (GCallback)on_cb_show,frame);

    gtk_box_pack_start (GTK_BOX (wid), frame, FALSE, FALSE, 0);
    g_object_set_data(G_OBJECT(window), "user_box", frame);
    gtk_container_set_border_width(GTK_CONTAINER(wid), 2);
    user_box(frame, window);

    gtk_box_pack_start (GTK_BOX (wid), frame1, FALSE, FALSE, 0);
    g_object_set_data(G_OBJECT(window), "complete_cell", frame1);
    gtk_container_set_border_width(GTK_CONTAINER(wid), 2);
    complete_cell(frame1, window);

    wid1 = myimage_button("   _OK", "ok.png");
    gtk_dialog_add_action_widget(GTK_DIALOG (window), wid1, 1);
    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(close_cont_dlg2), GINT_TO_POINTER(1));

    wid1 = myimage_button("  _Cancel", "cancel.png");
    gtk_dialog_add_action_widget(GTK_DIALOG (window), wid1, 2);
    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(close_cont_dlg2), GINT_TO_POINTER(0));
    (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(wid1));
  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(wid1)), GTK_BUTTONBOX_SPREAD);

    return window;
}

GtkWidget *create_cont_dlg3(void)
{
    GtkWidget *window;
    GtkWidget *vbox, *wid1, *wid2, *wid, *radio, *wid3, *frame;
    GSList *group = NULL;

    window = gtk_dialog_new();
    gtk_window_set_title(GTK_WINDOW(window), "Select Section(s)");
    vbox = (gtk_dialog_get_content_area(GTK_DIALOG(window)));
    gtk_container_set_border_width(GTK_CONTAINER(vbox), 10);
    gtk_window_set_default_size(GTK_WINDOW(window), 230, 290);

    frame = gtk_frame_new(NULL);
    gtk_widget_show(frame);
    gtk_box_pack_start(GTK_BOX (vbox), frame, TRUE, TRUE, 10);
 
    wid = vbox_new(FALSE, 0);
    gtk_widget_show(wid);
#ifdef IN_GTK3
    gtk_container_add(GTK_CONTAINER(frame), wid);
    gtk_widget_set_vexpand(wid, TRUE);
    gtk_widget_set_hexpand(wid, TRUE);
    g_object_set(G_OBJECT(wid), "valign", GTK_ALIGN_CENTER, NULL);
#else
    wid1 = gtk_alignment_new(0.5, 0.5, 1, 1);
    gtk_widget_show(wid1);
    gtk_container_add(GTK_CONTAINER(frame), wid1);
    gtk_container_set_border_width(GTK_CONTAINER(wid1), 10);
    gtk_container_add(GTK_CONTAINER(wid1), wid);
#endif

    radio = RADIO_BUTTON_WITH_LABEL (group, "Only one section", LABELCOLOR);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(window), "radio1", radio);
    gtk_widget_show(radio);
    gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);
    (void) g_signal_connect (G_OBJECT (radio), "toggled",
                       (GCallback)attiva_entries2, GINT_TO_POINTER(0));

    wid1 = hbox_new(FALSE, 0);
    gtk_widget_show(wid1);
    gtk_box_pack_start (GTK_BOX (wid), wid1, FALSE, FALSE, 0);
    g_object_set_data(G_OBJECT(window), "one", wid1);

    wid2 = spin_button_new( GTK_ADJUSTMENT(
                    adj_new ((float)Contour->sezione0+1.f, 1.f, 
                    (float)ngrid[Contour->Layer-1], 1.f, 1.f)),1,0);
    gtk_box_pack_end (GTK_BOX (wid1), wid2, FALSE, FALSE, 0);
    gtk_widget_show(wid2);
    g_object_set_data(G_OBJECT(window), "section", wid2);

    wid  = LABEL_NEW("Section #", LABELCOLOR);
    gtk_box_pack_end (GTK_BOX (wid1), wid, FALSE, FALSE, 10);
    gtk_widget_show(wid);

    frame = gtk_frame_new(NULL);
    gtk_widget_show(frame);
    gtk_box_pack_start(GTK_BOX (vbox), frame, TRUE, TRUE, 10);

    wid = vbox_new(FALSE, 0);
    gtk_widget_show(wid);

#ifdef IN_GTK3
    gtk_container_add(GTK_CONTAINER(frame), wid);
    gtk_widget_set_vexpand(wid, TRUE);
    gtk_widget_set_hexpand(wid, TRUE);
    g_object_set(G_OBJECT(wid), "valign", GTK_ALIGN_CENTER, NULL);
#else
    wid1 = gtk_alignment_new(0.5, 0.5, 1, 1);
    gtk_widget_show(wid1);
    gtk_container_add(GTK_CONTAINER(frame), wid1);
    gtk_container_set_border_width(GTK_CONTAINER(wid1), 10);
    gtk_container_add(GTK_CONTAINER(wid1), wid);
#endif

    radio = RADIO_BUTTON_WITH_LABEL (group, "More than one", LABELCOLOR);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(window), "radio2", radio);
    gtk_widget_show(radio);
    gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);
    (void) g_signal_connect (G_OBJECT (radio), "toggled",
                       (GCallback)attiva_entries2, GINT_TO_POINTER(1));

    wid1 = hbox_new(FALSE, 0);
    gtk_widget_show(wid1);
    gtk_box_pack_start (GTK_BOX (wid), wid1, FALSE, FALSE, 0);
    g_object_set_data(G_OBJECT(window), "more1", wid1);

    wid2 = spin_button_new(GTK_ADJUSTMENT(
                    adj_new ((float)Contour->sezione0+1.f, 1.f, 
                    (float)ngrid[Contour->Layer-1], 1.f, 1.f)),1,0);
    gtk_box_pack_end (GTK_BOX (wid1), wid2, FALSE, FALSE, 0);
    gtk_widget_show(wid2);
    g_object_set_data(G_OBJECT(window), "section0", wid2);

    wid3  = LABEL_NEW("Starting Section", LABELCOLOR);
    gtk_box_pack_end (GTK_BOX (wid1), wid3, FALSE, FALSE, 10);
    gtk_widget_show(wid3);

    wid1 = hbox_new(FALSE, 0);
    gtk_widget_show(wid1);
    gtk_box_pack_start (GTK_BOX (wid), wid1, FALSE, FALSE, 0);
    g_object_set_data(G_OBJECT(window), "more2", wid1);

    wid2 = spin_button_new(GTK_ADJUSTMENT(
                    adj_new ((float)Contour->sezioneN+1.f, 1.f, 
                    (float)ngrid[Contour->Layer-1], 1.f, 1.f)),1,0);
    gtk_box_pack_end (GTK_BOX (wid1), wid2, FALSE, FALSE, 0);
    gtk_widget_show(wid2);
    g_object_set_data(G_OBJECT(window), "sectionN", wid2);

    wid3  = LABEL_NEW("Ending Section", LABELCOLOR);
    gtk_box_pack_end (GTK_BOX (wid1), wid3, FALSE, FALSE, 10);
    gtk_widget_show(wid3);

    wid1 = myimage_button("   _OK", "ok.png");
    gtk_dialog_add_action_widget(GTK_DIALOG (window), wid1, 1);
    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(close_cont_dlg3), GINT_TO_POINTER(1));

    wid1 = myimage_button("  _Cancel", "cancel.png");
    gtk_dialog_add_action_widget(GTK_DIALOG (window), wid1, 2);
    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(close_cont_dlg3), GINT_TO_POINTER(0));
    (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(wid1));
  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(wid1)), GTK_BUTTONBOX_SPREAD);

    wid = lookup_widget(window, "radio2");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(wid), TRUE);

    return window;
}

void change_section(GtkWidget *widget,  gpointer data)
{
   GtkWidget *tb;
   int quanto;

    if(widget)
    {
       quanto = GPOINTER_TO_INT(data) - 1;
       Contour->sezione0 += quanto;
       Contour->sezioneN += quanto;
       if(Contour->sezione0 > (ngrid[Contour->Layer-1]-1))
          Contour->sezione0 = 0;
       else if(Contour->sezione0 < 0)
          Contour->sezione0 = ngrid[Contour->Layer-1]-1;
       if(Contour->sezioneN > (ngrid[Contour->Layer-1]-1))
          Contour->sezioneN = 0;
       else if(Contour->sezioneN < 0)
          Contour->sezioneN = ngrid[Contour->Layer-1]-1;
   }
    else
    {
       Contour->sezione0 = 0;
       Contour->sezioneN = Contour->sezione0;
    }
    
    if(widget)
    {    
       tb = lookup_widget(finestre[0], toolbarname[Livcur]);
       abilitatb(tb, 0);
       leggisezioni_();
       aggiorna_statusbar();
       c_aggiornadisegno();
       abilitatb(tb, 2);
    }
}

void open_cont_dlg(GtkWidget *item, gpointer data)
{
    GtkWidget *wid;
    GObject *adj;
    char num[10];
    int quale;
    float smin, smax;
    int  i, j;
    
    smin = 0;
    smax = (float)Contour->massimoMappa;

    quale = GPOINTER_TO_INT(data);
    if(quale == 1)
    {
      if(!cont_dlg1)
         cont_dlg1 = create_cont_dlg1();
      wid = lookup_widget(cont_dlg1, "bg");
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(wid), dialogo->jBackGround);
      for(i=0; i<5; i++)
      {
          lval[i] = (int) Contour->Soglie[3*i+2];
          if(Contour->LevelCol[i] > (N_OBJS + NUM_COLORS))
             lcolor[i] = Contour->LevelCol[i];
          else
             lcolor[i] = i+4+N_OBJS+NUM_COLORS;
          lvis[i] = Contour->ifLevel[i];
          ScriviStringa (num, sizeof(num), "sc%d", i);
          wid = lookup_widget(GTK_WIDGET(cont_dlg1), num);
          adj = adj_new((float)lval[i], smin, smax, 0, 10);
          gtk_range_set_adjustment ((GtkRange *)wid, (GtkAdjustment*) adj);
          ScriviStringa (num, sizeof(num), "cb%d", i);
          wid = lookup_widget(GTK_WIDGET(cont_dlg1), num);
          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(wid), lvis[i]);
          ScriviStringa (num, sizeof(num), "col%d", i);
          wid = lookup_widget(GTK_WIDGET(cont_dlg1), num);
          set_color_row(wid, lcolor[i]);
      }
      gtk_widget_show(cont_dlg1);
      finestra_modale_aperta2(cont_dlg1);
    }
    else if(quale == 2)
    {
      if(!cont_dlg2)
         cont_dlg2 = create_cont_dlg2();
      for(j=0; j<3; j++)
      {
           c_center[j] = Contour->centerCont[j];
           c_delta[j] = Contour->deltaCont[j];
           ScriviStringa (num, sizeof(num), "c%d", j);
           wid = lookup_widget(cont_dlg2, num);
           gtk_entry_set_text(GTK_ENTRY(wid),g_strdup_printf("%5.2f",c_center[j]));
           ScriviStringa (num, sizeof(num), "d%d", j);
           wid = lookup_widget(cont_dlg2, num);
           gtk_entry_set_text(GTK_ENTRY(wid),g_strdup_printf("%5.2f",c_delta[j]));
           ScriviStringa (num, sizeof(num), "nc%d", j);
           wid = lookup_widget(cont_dlg2, num);
           spin_button_set_value(wid, (float)Contour->numCell[0][j]);
           ScriviStringa (num, sizeof(num), "sc%d", j);
           wid = lookup_widget(cont_dlg2, num);
           spin_button_set_value(wid, (float)Contour->numCell[1][j]);
      }
      ScriviStringa (num, sizeof(num), "radio%d", Contour->WhichLimit);
      wid = lookup_widget(cont_dlg2, num);
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(wid), TRUE);
      RadioSelected = Contour->WhichLimit;

      gtk_widget_show(cont_dlg2);
      finestra_modale_aperta2(cont_dlg2);
    }
    else if(quale == 3)
    {
      if(!cont_dlg3)
         cont_dlg3 = create_cont_dlg3();
      wid = lookup_widget(cont_dlg3, "section");
      spin_button_set_value(wid, (float)Contour->sezione0 + 1.f);
      wid = lookup_widget(cont_dlg3, "section0");
      spin_button_set_value(wid, (float)Contour->sezione0 + 1.f);
      wid = lookup_widget(cont_dlg3, "sectionN");
      spin_button_set_value(wid, (float)Contour->sezioneN + 1.f);
      gtk_widget_show(cont_dlg3);
      finestra_modale_aperta2(cont_dlg3);
    }

}

void close_model_cont(GtkButton *button, gpointer data)
{
    int ifOk, i;
    char num[3];
    GtkWidget *wid, *tb, *hbox;

    ifOk = GPOINTER_TO_INT(data);
    if(ifOk)
    {
       Contour->ifModel = atoms_required;
       if(atoms_required)
       {
          for(i=0; i<5; i++)
          {
             ScriviStringa(num, sizeof(num), "%d", i);
             wid = lookup_widget(GTK_WIDGET(button), num);
             if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wid)))
                Contour->ifModel += i;
          }
          wid = lookup_widget(GTK_WIDGET(button), "Labels");
          dialogo->ifLabels = 
             gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wid));
          main_app::TheApp.IfLabels = dialogo->ifLabels;
       }
       
       tb = lookup_widget(finestre[0], toolbarname[Livcur]);
       hbox = get_widget(tb, "hbox");
       gtk_widget_set_sensitive(hbox, FALSE);
       c_aggiornadisegno();
       gtk_widget_set_sensitive(hbox, TRUE);
       
    }
    close_dlg(button, GINT_TO_POINTER(1));
}

void radio_cont(GtkButton *button, gpointer data)
{
    int qual;
    GtkWidget *widget;

    qual = GPOINTER_TO_INT(data);
    widget = lookup_widget(GTK_WIDGET(button), "plotstyle");
    atoms_required = qual;
    gtk_widget_set_sensitive(widget, qual);
}

GtkWidget *create_model_cont()
{
    GtkWidget *window;
    GtkWidget *vbox, *wid1, *wid, *radio, *frame, *table;
    GSList *group = NULL, *group1 = NULL;

    window = gtk_dialog_new();
    gtk_window_set_title(GTK_WINDOW(window), "Model & Plot Style");
    vbox = (gtk_dialog_get_content_area(GTK_DIALOG(window)));
    gtk_container_set_border_width(GTK_CONTAINER(vbox), 10);
//  gtk_window_set_default_size(GTK_WINDOW(window), 230, 290);

    frame = FRAME_NEW("Model", FRAMECOLOR);
    gtk_widget_show(frame);
    gtk_box_pack_start(GTK_BOX (vbox), frame, TRUE, TRUE, 10);
 
    wid = vbox_new(FALSE, 0);
    gtk_widget_show(wid);
    gtk_container_add(GTK_CONTAINER(frame), wid);
 
    radio = RADIO_BUTTON_WITH_LABEL(group, "Draw all atoms in the cell", LABELCOLOR);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(window), "All", radio);
    gtk_widget_show(radio);
    gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);
    (void) g_signal_connect (G_OBJECT (radio), "toggled",
                       (GCallback)radio_cont,GINT_TO_POINTER(1));

    radio = RADIO_BUTTON_WITH_LABEL(group, 
           "Draw only atoms related to section(s)", LABELCOLOR);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(window), "Sect", radio);
    gtk_widget_show(radio);
    gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);
    (void) g_signal_connect (G_OBJECT (radio), "toggled",
                       (GCallback)radio_cont,GINT_TO_POINTER(11));
    radio = RADIO_BUTTON_WITH_LABEL(group, "No atoms", LABELCOLOR);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(window), "None", radio);
    gtk_widget_show(radio);
    gtk_box_pack_start (GTK_BOX (wid), radio, FALSE, FALSE, 0);
    (void) g_signal_connect (G_OBJECT (radio), "toggled",
                       (GCallback)radio_cont,GINT_TO_POINTER(0));

    frame = FRAME_NEW("Plot Style", FRAMECOLOR);
    gtk_widget_show(frame);
    g_object_set_data(G_OBJECT(window), "plotstyle", frame);
    gtk_box_pack_start(GTK_BOX (vbox), frame, TRUE, TRUE, 10);

    table = table_new(3, 2, TRUE);
    gtk_widget_show(table);
    gtk_container_add(GTK_CONTAINER(frame), table);

    radio = RADIO_BUTTON_WITH_LABEL (group1, "Sticks", LABELCOLOR);
    group1 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(window), "0", radio);
    gtk_widget_show(radio);
    table_attach (table, radio, 0, 1, 0, 1, TRUE);

    radio = RADIO_BUTTON_WITH_LABEL (group1, "Simple", LABELCOLOR);
    group1 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(window), "1", radio);
    gtk_widget_show(radio);
    table_attach (table, radio, 1, 2, 0, 1, TRUE);

    radio = RADIO_BUTTON_WITH_LABEL (group1, "Bubbles", LABELCOLOR);
    group1 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(window), "2", radio);
    gtk_widget_show(radio);
    table_attach (table, radio, 0, 1, 1, 2, TRUE);

    radio = RADIO_BUTTON_WITH_LABEL (group1, "Shaded", LABELCOLOR);
    group1 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(window), "3", radio);
    gtk_widget_show(radio);
    table_attach (table, radio, 1, 2, 1, 2, TRUE);

    radio = RADIO_BUTTON_WITH_LABEL (group1, "Ellipsoids", LABELCOLOR);
    group1 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(window), "4", radio);
    gtk_widget_show(radio);
    table_attach (table, radio, 0, 1, 2, 3, TRUE);

    radio = CHECK_BUTTON_WITH_LABEL ("Labels", LABELCOLOR);
    g_object_set_data(G_OBJECT(window), "Labels", radio);
    gtk_widget_show(radio);
    table_attach (table, radio, 1, 2, 2, 3, TRUE);

    wid1 = myimage_button("   _OK", "ok.png");
    gtk_dialog_add_action_widget(GTK_DIALOG (window), wid1, 1);
    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(close_model_cont), GINT_TO_POINTER(1));

    wid1 = myimage_button("  _Cancel", "cancel.png");
    gtk_dialog_add_action_widget(GTK_DIALOG (window), wid1, 2);
    (void) g_signal_connect (G_OBJECT (wid1), "clicked",
                      G_CALLBACK(close_model_cont), GINT_TO_POINTER(0));
    (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(wid1));
  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);
     gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(wid1)), GTK_BUTTONBOX_SPREAD);

    return window;
}

void open_model_cont(GtkWidget *widget,  gpointer data)
{
    GtkWidget *button;

    if(model_cont == NULL)
    {
       model_cont = create_model_cont();
       button = lookup_widget(model_cont, "None");
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
    }
    
    button = lookup_widget(model_cont, "Labels");
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), dialogo->ifLabels);
    gtk_widget_show(model_cont);
    finestra_modale_aperta2(model_cont);
}


/**********************************************/
/*         N e w   s c r 2                    */
/**********************************************/
extern "C"
{
typedef struct {
                 int icomq[2][200];
                 int maxcom;
                 int ipcom;
                 int ipdir;
                 int icomat;
               } _comdir;

extern _comdir  comdir_;
_comdir *comdir = &comdir_;
};

GdkPixbuf *pixvuoto, *pixhand;

gboolean void_func(GtkWidget *widget, GdkEvent *event,
                      gpointer user_data)
{
  return TRUE;
}

void riempi_listacom(GtkWidget *lista)
{
  int i;
  char It_str[80];
  str14 allcom[80];
  GtkTextIter iter, iter2;
  GtkTextBuffer *tb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(lista));

  get_allcom_(allcom);
  gtk_text_buffer_get_iter_at_offset (tb, &iter, 0);
  gtk_text_buffer_get_bounds (tb, &iter, &iter2);
  gtk_text_buffer_delete (tb, &iter, &iter2);
  for(i=0; i< comdir->ipcom; i++)
  {
      int j = comdir->icomq[0][i];
	  if (j != 10)
      {
          ScriviStringa(It_str, sizeof(It_str), "%s", allcom[j-1]);
          It_str[0] = MRtoupper(It_str[0]);

          gtk_text_buffer_insert_pixbuf (tb, &iter, pixvuoto);

          gtk_text_buffer_insert_with_tags_by_name(tb,
                                   &iter,
                                   g_strstrip(It_str), 
                                   -1,
                                   "yellow_foreground",
                                   "wide_margins",
                                   "font_p",
                                   NULL);
          gtk_text_buffer_insert_with_tags_by_name(tb,
                                   &iter,
                                   "\n", 
                                   -1,
                                   "yellow_foreground",
                                   "wide_margins",
                                   "font_p",
                                   NULL);
      }
  }
}

#ifdef USE_PIE
static gboolean draw_pie(GtkWidget *preview,
			  gpointer obj,
			  gpointer user_data)
{
  int curT = get_int(preview, "curT");
  int totT = get_int(preview, "totT");

  gpointer context = get_context(gtk_widget_get_window(preview));
  if(curT > 0)
     set_foreground(context, &colorYellow);
  else
     set_foreground(context, &BgColor);
  draw_circle( gtk_widget_get_window(preview), context, TRUE,
                     CIRCLE_BOR, CIRCLE_BOR, CIRCLE_RAD);

  double step = -360.0 / (double) totT;

  double h = step * (double) (curT-1);

  if(curT > 1)
  {
     set_foreground(context, &BgColor);
     draw_sector( gtk_widget_get_window(preview), context, TRUE, CIRCLE_BOR, 
            CIRCLE_BOR, CIRCLE_RAD, 90, (int) h);
  }

  if(curT)
  {
     set_foreground(context, &colorBlue);
     draw_sector( gtk_widget_get_window(preview), context, TRUE, CIRCLE_BOR, 
            CIRCLE_BOR, CIRCLE_RAD, (int) h+90, (int) step);
  }
  
  set_foreground(context, &colorBlck);
  draw_circle( gtk_widget_get_window(preview), context, FALSE, CIRCLE_BOR, 
            CIRCLE_BOR, CIRCLE_RAD);
  free_context(context);
  return TRUE;
}
#endif

#if 0
void set_widget_color_integral (GtkWidget *widget, GdkColor colore)
{                                      
#if GTK_MAJOR_VERSION < 3
  for(int i=GTK_STATE_NORMAL; i<=GTK_STATE_INSENSITIVE; i++)
      gtk_widget_modify_base(widget, (GtkStateType) i, &colore);
#else
  float *col = ToColor3f(&colore);
  const GdkRGBA color = {col[0], col[1], col[2], 1.0}; 
  g_free(col);
  for(int i=GTK_STATE_FLAG_NORMAL; i<=GTK_STATE_FLAG_FOCUSED; i++)
      gtk_widget_override_background_color(widget, (GtkStateFlags) i, &color);
#endif
}                                      
#endif

GtkWidget *create_listacom(char *title, int ifVLD)
{
  GtkWidget *box1, *box2, *box, *dum;
  GtkWidget *lista, *label, *preview;

  box1 = lookup_widget(finestre[0], "box_scr");
 
  box = gtk_frame_new(NULL); 
  g_object_ref(box);
  gtk_box_pack_start(GTK_BOX(box1), box, FALSE, FALSE, 4);
  box2 = vbox_new(FALSE, 4);
  gtk_container_add(GTK_CONTAINER(box), box2);
  gtk_widget_show(box2);

/*
  box2 = vbox_new(FALSE, 4);
  gtk_widget_ref(box2);
  gtk_box_pack_start(GTK_BOX(box1), box2, FALSE, FALSE, 4);
*/

  label = label_boxed(toUTF8(title));
  g_object_set_data(G_OBJECT(finestre[0]), "intestazione", label);
  gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 4);
  gtk_widget_show(label);
  widget_modify_font(get_widget(label, "label"), fontdescP);

#ifdef USE_PIE
  lista = scrolled_text_new(box2);
#else
  GtkWidget *box3 = vbox_new(FALSE, 4);
  lista = scrolled_text_new(box3);
#endif
  g_object_set_data(G_OBJECT(finestre[0]), "listacom", lista);
  //set_widget_color_integral(lista, BgColor);
  set_widget_color(lista, BgColor);

  pixvuoto    = create_pixbuf("vuoto.png");
  pixhand     = create_pixbuf("corrente.png");

#ifdef USE_PIE
#ifdef IN_GTK3
  dum = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, FALSE, FALSE);
#else
  dum = gtk_alignment_new(0.5f, 0.5f, 0, 0);
#endif
  gtk_box_pack_start(GTK_BOX(box2), dum, FALSE, FALSE, 4);
#else
#ifdef IN_GTK3
  dum = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_FILL, FALSE, TRUE);
#else
  dum = gtk_alignment_new(0.5f, 0, 0, 1);
#endif
  gtk_box_pack_start(GTK_BOX(box2), dum, TRUE, TRUE, 4);
#endif
  gtk_container_set_border_width(GTK_CONTAINER(dum), 10);
  gtk_widget_show(dum);
  
#ifdef USE_PIE
  preview = gtk_drawing_area_new();
  gtk_widget_set_size_request(preview, CIRCLE_RAD+2*CIRCLE_BOR, 
                                       CIRCLE_RAD+2*CIRCLE_BOR);
#else
  preview = gtk_progress_bar_new();
  progress_bar_set_orientation(preview, BOTTOM_TO_TOP);
  gtk_widget_set_name(preview, "myprogress");
#if GTK_MAJOR_VERSION < 3
  GtkStyle *style = gtk_style_new ();
  gdk_color_parse ("#008050", &style->bg[GTK_STATE_PRELIGHT]);
  gtk_widget_set_style (preview, style);
  g_object_unref (style);
#endif
#endif
  gtk_widget_show(preview);
  gtk_container_add(GTK_CONTAINER(dum), preview);
  g_object_set_data(G_OBJECT(finestre[0]), "phase_preview", preview);

#ifdef USE_PIE
  g_signal_connect (G_OBJECT (preview), DRAW_EVENT,
                      G_CALLBACK (draw_pie), NULL);
#elif defined(IN_GTK3)
  gtk_widget_set_vexpand(preview, TRUE);
#endif
  if(ifVLD)
     label = label_boxed("Block #00:\nPhasing\n00 of 100 Trials");
  else
     label = label_boxed("Block #00:\nPhasing\n00 of 100 Trials");
  g_object_set_data(G_OBJECT(finestre[0]), "dati_trial", label);
  gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 4);
  widget_modify_font(get_widget(label, "label"), fontdescP);

  return box;
}

static GtkWidget *my_box=NULL;

extern "C" void c_scr_ (int *action, int *ic1, int *ic2, int *ic3, int *ic4,
                            int *ifVLD, char *title)
{
  GtkWidget *lista, *frame;
  GtkTextBuffer *tb;
  char *line, *tmpstr;
  GtkTextIter iter1, iter2;
  int i, curTrial, totTrials, blocco;//, primap;
  static const char *stringa1[] = {"Block", "Trial"};
  static const char *stringa2[] = {"Phasing", "Cycle"};

  if(jscreen)
  {
     int iVLD = (*ifVLD==0)?0:1;
     if(single_it)
        while(gtk_events_pending())
            (void) gtk_main_iteration();

     switch (*action)
     {
      case 0:
           if(my_box == NULL)
              my_box = create_listacom(title, *ifVLD);
           else if((gtk_widget_get_parent(my_box)) == NULL)
           {
              GList *children;

              frame = lookup_widget(finestre[0], "box_scr");
              children = gtk_container_get_children(GTK_CONTAINER(frame));
              i = g_list_length(children);
              if(i > 1)
                 gtk_container_remove(GTK_CONTAINER(frame), 
                   (GtkWidget *) g_list_nth_data(children, 0));
              gtk_box_pack_start(GTK_BOX(frame), my_box, FALSE, FALSE, 4);
           }
           frame = lookup_widget(finestre[0], "intestazione");
           label_boxed_set_text(frame, title);
           frame = lookup_widget(finestre[0], "listacom");
           if(frame == NULL)
           {
              g_print("Non dovrei essere qui!!\n");
              return;
           }
           riempi_listacom(frame);
           gtk_widget_show(frame);
           frame = lookup_widget(finestre[0], "dati_trial");
           gtk_widget_hide(frame);
           frame = lookup_widget(finestre[0], "phase_preview");
           gtk_widget_hide(frame);
           gtk_widget_show(my_box);
           break;
            
      case -1:
           if(gtk_widget_get_parent(my_box) != NULL)
           {
              frame = lookup_widget(finestre[0], "box_scr");
              gtk_container_remove(GTK_CONTAINER(frame), my_box);
           }
           break;
            
      case -2:
           //primap = (*icomat) % 1000000;
           blocco = *ic3;     //(*icomat) / 1000000;
           curTrial = *ic1;   // primap % 1000;
           totTrials = *ic2;  //primap / 1000;
           
           frame = lookup_widget(finestre[0], "dati_trial");
           if(blocco == 0)
           {
              if(curTrial)
              {
                 tmpstr =
                 g_strdup_printf("%s\n%d of %d",
                 stringa2[iVLD], curTrial, totTrials);
                 label_boxed_set_text(frame, tmpstr);
                 g_free(tmpstr);
              }
              else
                 label_boxed_set_text(frame,"\n");
           }
           else
           {
              if(curTrial)
              {
                 tmpstr =
                 g_strdup_printf("%s #%d of %d\n%s\n%d of %d",
                 stringa1[iVLD], blocco, *ic4, stringa2[iVLD], curTrial, totTrials);
                 label_boxed_set_text(frame, tmpstr);
                 g_free(tmpstr);
              }
              else
              {
                 tmpstr =
                 g_strdup_printf("%s #%d of %d\n", stringa1[iVLD], blocco, *ic4);
                 label_boxed_set_text(frame, tmpstr);
                 g_free(tmpstr);
              }
           }
           gtk_widget_show(frame);
           frame = lookup_widget(finestre[0], "phase_preview");
#ifdef USE_PIE
           g_object_set_data(G_OBJECT(frame), "curT", 
                GINT_TO_POINTER(curTrial));
           g_object_set_data(G_OBJECT(frame), "totT", 
                GINT_TO_POINTER(totTrials));
           gtk_widget_hide(frame);
#else
           gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(frame),
                (double) curTrial/ (double) totTrials);
#endif
           gtk_widget_show(frame);
#ifdef USE_PIE
           GtkAllocation allocation;
           gtk_widget_get_allocation(frame, &allocation);
           gdk_window_invalidate_rect(gtk_widget_get_window(frame), 
              (GdkRectangle *)(&allocation), FALSE);
#endif
           break;

      case -3:
           frame = lookup_widget(finestre[0], "phase_preview");
#ifdef USE_PIE
           g_object_set_data(G_OBJECT(frame), "curT", 
                GINT_TO_POINTER(-1));
           g_object_set_data(G_OBJECT(frame), "totT", 
                GINT_TO_POINTER(0));
#endif
           gtk_widget_hide(frame);
           frame = lookup_widget(finestre[0], "dati_trial");
           gtk_widget_hide(frame);
           break;
            
      default:
           lista = lookup_widget(finestre[0], "listacom");
           if(lista == NULL)
           {
              g_print("Non dovrei essere qui!!\n");
              return;
           }
           tb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(lista));
           
           i = *action -1;

           gtk_text_buffer_get_iter_at_offset (tb, &iter2, 0);
           gtk_text_buffer_get_iter_at_line_offset (tb, &iter1, i, 0);
           gtk_text_buffer_remove_tag_by_name (tb, "yellow_foreground", &iter1, &iter2);
           gtk_text_buffer_apply_tag_by_name (tb, "gray_foreground", &iter2, &iter1);
           gtk_text_buffer_get_iter_at_line_offset (tb, &iter1, i, 0);
           if(i >= 1)
           {
              gtk_text_buffer_get_iter_at_line_offset (tb, &iter2, i-1, 0);
              line = gtk_text_buffer_get_text (tb, &iter2, &iter1, TRUE);
              gtk_text_buffer_delete (tb, &iter2, &iter1);
              gtk_text_buffer_insert_pixbuf (tb, &iter2, pixhand);
              gtk_text_buffer_insert_with_tags_by_name (tb, &iter2, line, -1,
               "gray_foreground",NULL);
//              gtk_text_buffer_insert_with_tags_by_name (tb, &iter2, "\n", 1,
//               "font_p",NULL);
             g_free(line);
           }
           gtk_text_buffer_get_iter_at_line_offset (tb, &iter1, i, 0);
           gtk_text_buffer_get_iter_at_line_offset (tb, &iter2, i+1, 0);
           gtk_text_buffer_delete(tb, &iter1, &iter2);
           gtk_text_buffer_insert_pixbuf (tb, &iter1, pixvuoto);
           gtk_text_buffer_insert_with_tags_by_name (tb, &iter1, title, -1,
            "blue_foreground",NULL);
           gtk_text_buffer_insert_with_tags_by_name (tb, &iter1, "\n", -1,
            "blue_foreground",NULL);
           gtk_text_buffer_get_bounds (tb, &iter1, &iter2);
           gtk_text_buffer_apply_tag_by_name (tb, "wide_margins", &iter2, &iter1);
           gtk_text_buffer_apply_tag_by_name (tb, "font_p", &iter1, &iter2);
           break;
      }
  }
}
/************************ s c r m a d ***************************************/
                                                                                
/*
//static GtkWidget *box_mad=NULL;
                                                                                
GtkWidget *create_listamad(char *title)
{
  GtkWidget *box1, *box2, *lista, *label;
  GtkTextBuffer *text;
  GtkTextIter iter;

  box1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(box1), "Log Window");
  box2 = vbox_new(FALSE, 4);
  gtk_container_add(GTK_CONTAINER(box1), box2);
  set_icon(box1, program_ico);
  label = label_boxed_big(title);
  gtk_label_set_line_wrap(GTK_LABEL(get_widget(label, "label")), TRUE);
  gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 4);
  widget_modify_font(get_widget(label, "label"), fontdescP);
  lista = scrolled_text_new(box2);
  g_object_set_data(G_OBJECT(finestre[0]), "listamad", lista);
  gtk_widget_set_size_request(lista, main_app::TheApp.Kscrx/2, 400);
  //set_widget_color_integral(lista, BgColor);
  set_widget_color(lista, BgColor);

  text = gtk_text_view_get_buffer (GTK_TEXT_VIEW (lista));
  gtk_text_buffer_get_iter_at_offset (text, &iter, 0);
  gtk_text_buffer_create_mark (text, "log_mark", &iter, FALSE);
  gtk_text_view_set_editable(GTK_TEXT_VIEW (lista), FALSE);

  g_signal_connect(G_OBJECT(box1), "delete_event", G_CALLBACK(true_cb), NULL);

  return box1;
}

void c_bestmodel(GtkButton *button, gpointer data)
{
  GtkWidget *tb;

  dialogo->ifMadEnv = 0;
  bestmodel_();
  gtk_main_quit();
  if(box_mad)
      gtk_widget_hide(box_mad);
  tb = lookup_widget(finestre[0], "toolbar_main");

  if(dialogo->QualeAbilita)
  {
      if(ifMenubar)
         abilitamb(finestre[0], dialogo->QualeAbilita);
      if(ifToolbar)
         abilitatb(tb, dialogo->QualeAbilita);
      can_drag = MRmax(dialogo->QualeAbilita - 1, 0);
  }
  else
  {
      if(ifMenubar)
         abilitamb(finestre[0], -1);
      if(ifToolbar)
         abilitatb(finestre[0], -1);
      can_drag = FALSE;
      draw_initial_pixmap();
  }

//  c_aggiornadisegno();
}
*/

void call_fortran(char *inpFile, char *outFile, const char *tipo)
{
   char *nom;
   int n1, n2, n3, n4, ier = 0;
   GtkWidget *tb, *mainwin;

   mainwin = finestre[0];
   force_close_viewers();
   if(ifMenubar)
      abilitamb(mainwin, 0);
   if(ifToolbar && show_toolbar)
   {
      tb = lookup_widget(mainwin, "toolbar_main");
      abilitatb(tb, 0);
   }
   can_drag = FALSE;

   nom  =  g_new0(char, strlen(inpFile) + 1);
   char *tmp = str_cut(inpFile, ".");
   CopiaStringa(nom, strlen(inpFile) + 1, tmp);
   g_free(tmp);
   tmp = g_path_get_basename(inpFile);
   char *tmp1 = str_cut(tmp, ".");
   getStructName(inpFile, main_app::TheApp.filebin);
   CopiaStringa(main_app::TheApp.filesir, MaxLenFilename, tmp1);
   g_free(tmp);
   g_free(tmp1);
   AppendiStringa(main_app::TheApp.filesir, MaxLenFilename, ".sir");
   AppendiStringa(main_app::TheApp.filebin, MaxLenFilename, ".bin");
   tmp = g_path_get_basename(outFile);
   CopiaStringa(main_app::TheApp.fileout, MaxLenFilename, tmp);
   g_free(tmp);
   if(jscreen)
      fortran_al_lavoro();
   multistringa ms;
   CopiaStringa(ms.file1, MaxLenFilename, fromUTF8(inpFile).c_str());
   CopiaStringa(ms.file2, MaxLenFilename, fromUTF8(outFile).c_str());
   CopiaStringa(ms.file3, MaxLenFilename, fromUTF8(nom).c_str());
   CopiaStringa(ms.file4, MaxLenFilename, tipo);
   n1    = (int) strlen(ms.file1);
   n2    = (int) strlen(ms.file2);
   n3    = (int) strlen(ms.file3);
   n4    = (int) strlen(tipo);
   ms.n1 = n1;
   ms.n2 = n2;
   ms.n3 = n3;
   ms.n4 = n4;
   putlab95_(&ms, &ier);
//   putlab95old_(inpFile, outFile, nom, tipo,
//                      &n1,&n2, &n3, &n4, &ier, n1,n2,n3,n4);

   if(jscreen)
   {
      CopiaStringa(main_app::TheApp.filebin, MaxLenFilename, nom);
      AppendiStringa(main_app::TheApp.filebin, MaxLenFilename, ".bin");
      fine_lavoro();
      if(ier < 0)
         set_smiley(2);
      if((Livcur != 0) && show_toolbar && ifToolbar)
         nascondi_tb(mainwin);
      if(dialogo->QualeAbilita)
      {
          if(ifMenubar)
             abilitamb(mainwin, dialogo->QualeAbilita);
          if(ifToolbar)
             abilitatb(tb, dialogo->QualeAbilita);
          can_drag = MRmax(dialogo->QualeAbilita - 1, 0);
      }
      else
      {
          if(ifMenubar)
             abilitamb(mainwin, -1);
          if(ifToolbar)
             abilitatb(tb, -1);
          can_drag = FALSE;
          if(!dialogo->ifMadEnv)
              draw_initial_pixmap();
      }
//301110
      if(ifSannel)
      {
         c_globalopt(NULL, NULL);
         ifSannel = false;
      }
//end 301110
   g_free(nom);
   }
   else
   {
      if(!ier)
         exitsir2006_(&ier);
      main_app::TheApp.AppError = ier;
   }
}

void call_fortran_bis(char *inpFile1, char *dir1, int tipo)
{
//chiamata solo per save/restore model
   char *inpFile = DuplicaStringa(fromUTF8(inpFile1).c_str());
   char *dir = DuplicaStringa(fromUTF8(dir1).c_str());
   int  n1   = (int) strlen(inpFile);
   int  n2   = (int) strlen(dir);

   multistringa ms;
   CopiaStringa(ms.file1, MaxLenFilename, inpFile);
   CopiaStringa(ms.file2, MaxLenFilename, dir);
   ms.n1 = n1;
   ms.n2 = n2;

   char *filtemp = str_cut(inpFile, ".");

   CopiaStringa(main_app::TheApp.filesir, MaxLenFilename, g_path_get_basename(filtemp));
   AppendiStringa(main_app::TheApp.filesir, MaxLenFilename, ".sir");
   save_restore_mdl_(&ms, &tipo);
}

/*
void oldcall_fortran_bis(char *inpFile1, char *dir1, int tipo)
{
//chiamata solo per save/restore model
   int l1, l2;

   char *inpFile = DuplicaStringa(fromUTF8(inpFile1));
   char *dir = DuplicaStringa(fromUTF8(dir1));
   l1    = (int) strlen(inpFile);
   l2    = (int) strlen(dir);
   char *filtemp = str_cut(inpFile, ".");

   CopiaStringa(main_app::TheApp.filesir, MaxLenFilename, g_path_get_basename(filtemp));
   AppendiStringa(main_app::TheApp.filesir, MaxLenFilename, ".sir");
   save_restore_mdlold_(inpFile, dir, &tipo, l1, l2);
}
*/

int exit_confirm(GtkWidget *dumw, const char* str)
{
    char *messaggio, *title;
    int irisp, ier=0;

    title = g_strdup_printf("%s Exit", MR_PACKAGE);
    messaggio = g_strdup_printf("\nDo you really want\nstop the program?\n");
//    set_smiley(2);
    irisp = MessageDialog(title, finestre[0], GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO,
            messaggio);
    g_free(title);
    g_free(messaggio);
    if(irisp == GTK_RESPONSE_YES)
    {
       stop_continue_rot();
       int x, y;
       gtk_window_get_position(GTK_WINDOW(finestre[0]), &x, &y);
       main_app::TheApp.UpdatePosition(x, y);

       bool kill = false;
       if(strstr(str, "forced") != NULL)
       {
          GtkWidget *tb1 = lookup_widget(finestre[0], "close_box");
          if((!show_toolbar || !strstr(toolbarname[Livcur], "main")) && 
              !gtk_widget_get_visible(tb1))
               kill = true;
          if(kill)
          {
              Contour->ifDrawContour = 0;
              programstopped_();
              quit_program(NULL, GINT_TO_POINTER(1));
          }
       }
       exitsir2006_(&ier);
       main_app::TheApp.AppError = ier;
       if(ier == 0)
       {
       if(gtk_main_level())
          gtk_main_quit();
       }
    }
    return irisp;
}

extern "C"   void c_sadface_()
{
   if(!jscreen)
     return;
    sad_smiley();
}

gboolean close_mainwin (GtkWidget *widget, GdkEventAny *event, gpointer data)
{
    exit_confirm(widget, (char *) data);
    return TRUE;
}

void tog_viewer(GtkWidget *wid, char *string)
{
   extern GtkWidget *viewer_window ;

   if(viewer_window != NULL)
   {
        gtk_widget_show(viewer_window);
        gdk_window_raise(gtk_widget_get_window(viewer_window));
   }
}

void c_importa(char *inpFile, char *dir, int tipo)
{
   int l1, l2;
   GtkWidget *tb, *mainwin;

   l1    = (int) strlen(inpFile);
   l2    = (int) strlen(dir);
   getStructName(inpFile, main_app::TheApp.filebin);
   CopiaStringa(main_app::TheApp.filesir, MaxLenFilename, str_cut(g_path_get_basename(inpFile), "."));
   AppendiStringa(main_app::TheApp.filesir, MaxLenFilename, ".sir");
   AppendiStringa(main_app::TheApp.filebin, MaxLenFilename, ".bin");
   if(jscreen)
      fortran_al_lavoro();
   multistringa ms;
   CopiaStringa(ms.file1, MaxLenFilename, fromUTF8(inpFile).c_str());
   CopiaStringa(ms.file2, MaxLenFilename, fromUTF8(dir).c_str());
   ms.n1 = l1;
   ms.n2 = l2;
   importa_file_(&ms, &tipo);

//   importa_fileold_((char *) fromUTF8(inpFile), (char *) fromUTF8(dir), &tipo, l1, l2);
   if(jscreen)
   {                                       // GIANLUCA
      fine_lavoro();
      mainwin = finestre[0];

      if(ifMenubar)
         abilitamb(mainwin, 0);
      if(ifToolbar && show_toolbar)
      {
         tb = lookup_widget(mainwin, "toolbar_main");
         abilitatb(tb, 0);
         if(Livcur != 0)
            nascondi_tb(mainwin);
      }
      if(ifMenubar)
         abilitamb(mainwin, dialogo->QualeAbilita);
      if(ifToolbar)
         abilitatb(tb,  dialogo->QualeAbilita);
      can_drag =  MRmax(0, dialogo->QualeAbilita - 1);
      if(!can_drag)
         draw_initial_pixmap();
      if(tipo < 0)
         sad_smiley();
   }
}
void c_importa2(char *inpFile, char *dir)
{
   int l1    = (int) strlen(inpFile);
   int l2    = (int) strlen(dir);
   if(jscreen)
      fortran_al_lavoro();
   multistringa ms;
   CopiaStringa(ms.file1, MaxLenFilename, fromUTF8(inpFile).c_str());
   CopiaStringa(ms.file2, MaxLenFilename, fromUTF8(dir).c_str());
   ms.n1 = l1;
   ms.n2 = l2;
   importa_file2_(&ms);

//   importa_file_(inpFile, dir, &tipo, l1, l2);
   if(jscreen)
      fine_lavoro();
}


void  update_name(const gchar *wFather, const gchar *wChild, gchar *stringdata)
{
  GtkWidget *widget;
  GtkWidget *entry;

  if(wFather != NULL)
  {
      widget = lookup_widget(finestre[0], wFather);
      entry = lookup_widget(widget, wChild);
  }
   else
      entry = lookup_widget(finestre[0], wChild);

  if (GTK_IS_ENTRY(G_OBJECT(entry)))
      gtk_entry_set_text (GTK_ENTRY(entry), 
           str_cut(g_path_get_basename(stringdata), "_sir."));
  else if (GTK_IS_LABEL(G_OBJECT(entry)))
      gtk_label_set_text (GTK_LABEL(entry), 
           str_cut(g_path_get_basename(stringdata), "_sir."));
}

void  update_filename(const gchar *wFather, const gchar *wChild, gchar *stringdata)
{
  GtkWidget *widget;
  GtkWidget *entry;

  if(wFather != NULL)
  {
      widget = get_widget(finestre[0], wFather);
      if(widget)
         entry = get_widget(widget, wChild);
  }
   else
      entry = get_widget(finestre[0], wChild);

  if(entry)
  {
      if (GTK_IS_ENTRY(G_OBJECT(entry)))
          gtk_entry_set_text (GTK_ENTRY(entry), stringdata);
      else if (GTK_IS_LABEL(G_OBJECT(entry)))
          gtk_label_set_text (GTK_LABEL(entry), stringdata);
  }
}

int open_file (GtkWidget *item,  gpointer data)
{
   int tipo;
   gtkext::FilselItem it;
   int ifHyd;
   char riga[MAX_LEN], *back_file;
   float distlim;

   if(item != NULL)
       (void) dir_set_current(SWareRC->WorkingDirectory);
   tipo          = GPOINTER_TO_INT(data);
   it.fileinp    = g_new0(gchar, MaxLenFilename);
   it.fileout    = g_new0(gchar, MaxLenFilename);
   it.cwd        = g_new0(gchar, MaxLenFilename);
   if (tipo < (int) (sizeof(filexts)/sizeof(filexts[0])))
      it.filter  = g_strdup_printf("%s", filexts[tipo]);
   else if ((tipo - 20)  < (int) (sizeof(filexts)/sizeof(filexts[0])))
      it.filter  = g_strdup_printf("%s", filexts[tipo-20]);
   else
      it.filter  = NULL;
   it.title      = NULL;
   it.label      = NULL;
   it.ifDirOnly  = FALSE;
   it.ifMultiple = FALSE;
   it.ifPreview  = FALSE;
   it.ifSave     = FALSE;
   it.exitCode   = 0;
   it.fd         = fontdescU;
   it.ifEditable = FALSE;
   it.ifExe      = FALSE;
   it.nofilter   = FALSE;
   it.ifOutput   = FALSE;
   it.AllFiles   = TRUE;
   it.ifAlpha    = FALSE;
   it.window     = finestre[0];

   char *tmp1, *tmp2, *tmp3;

   switch(tipo)
   {
   case 0: 
        if(it.filter)
           g_free(it.filter);
        it.title      = g_strdup_printf("Load %s input file", PK);
        it.label      = g_strdup_printf("%s _Input Filename", PK);
        it.ifEditable = TRUE;
        it.ifExe      = TRUE;
        it.ifOutput   = TRUE;
        tmp1 = g_path_get_basename(main_app::TheApp.filesir);
        tmp2 = g_path_get_dirname(main_app::TheApp.filesir);
        tmp3 = g_path_get_basename(main_app::TheApp.fileout);
        CopiaStringa(it.fileinp, MaxLenFilename, tmp1);
        CopiaStringa(it.cwd, MaxLenFilename, tmp2);
        CopiaStringa(it.fileout, MaxLenFilename, tmp3);
        it.filter     = g_strdup(
              "Sir input file (*.sir)@Shelx input file (*.ins)");
        g_free(tmp1);
        g_free(tmp2);
        g_free(tmp3);
        break;
   case 1:                        /* Load .bin file */
        it.title      = g_strdup_printf("Load old project");
        it.label      = g_strdup_printf("%s _Binary Filename", PK);
        it.ifOutput   = TRUE;
        tmp1 = g_path_get_basename(main_app::TheApp.filebin);
        tmp2 = g_path_get_dirname(main_app::TheApp.filebin);
        tmp3 = g_path_get_basename(main_app::TheApp.fileout);
        CopiaStringa(it.fileinp, MaxLenFilename, tmp1);
        CopiaStringa(it.cwd, MaxLenFilename, tmp2);
        CopiaStringa(it.fileout, MaxLenFilename, tmp3);
        g_free(tmp1);
        g_free(tmp2);
        g_free(tmp3);
        break;
   case 2:                        /* Restore .sav file */
        it.title      = g_strdup_printf("Restore binary file");
        it.label      = g_strdup_printf("_Backup filename");
        it.ifOutput   = TRUE;
        break;
   case 3:                        /* Restore model */
        it.title      = g_strdup_printf("Restore Model");
        it.label      = g_strdup_printf("_Backup filename");
        break;
   case 4:                        /* Import sir fragment */
        it.title      = g_strdup_printf("Import a fragment in Sir format");
        it.label      = g_strdup_printf("_Fragment filename");
        it.ifEditable = TRUE;
        break;
   case 5:                        /* Import caos fragment */
        it.title      = g_strdup_printf("Import a fragment in Caos format");
        it.label      = g_strdup_printf("_Fragment filename");
        break;
   case 6:                        /* Import shelx file */
        if(it.filter)
           g_free(it.filter);
        it.title      = g_strdup_printf("Import a Shelx file");
        it.label      = g_strdup_printf("_Shelx filename");
        it.filter     = g_strdup("*.ins,*.res");
        break;
   case 7:                        /* Import pdb fragment */
        if(it.filter)
           g_free(it.filter);
        it.title      = g_strdup_printf("Import a PDB file");
        it.label      = g_strdup_printf("_PDB filename");
        it.filter     = g_strdup("*.pdb,*.ent");
        break;
   case 8:                        /* Reflections file */
        it.window     = get_widget(finestre[0], "new_project_dlg");
        it.title      = g_strdup_printf("Select reflections file");
        it.label      = g_strdup_printf("%s _Reflections filename", PK);
        it.ifPreview  = TRUE;
        break;
   case 9:                        /* Old new project file */
        it.window     = get_widget(finestre[0], "new_project_dlg");
        it.nofilter   = TRUE;
        it.title      = g_strdup_printf("Select structure name");
        it.label      = g_strdup_printf("_Structure name");
        break;
   case 10:                       /* Save model */
        it.title      = g_strdup_printf("Save Model");
        it.label      = g_strdup_printf("_Backup filename");
//        it.fileinp    = str_cut(main_app::TheApp.filebin, ".");
        tmp2 = str_cut(main_app::TheApp.filebin, ".");
        CopiaStringa(it.fileinp, MaxLenFilename, tmp2);
        AppendiStringa(it.fileinp, MaxLenFilename, ".mdl");
        tmp1 = g_path_get_dirname(main_app::TheApp.filebin);
        CopiaStringa(it.cwd, MaxLenFilename, tmp1);
        it.ifSave     = TRUE;
        g_free(tmp1);
        g_free(tmp2);
        break;
   case 11:                       /* Internet Browser */
        if(it.filter)
           g_free(it.filter);
        it.title      = g_strdup_printf("Select executable for internet browser");
        it.label      = g_strdup_printf("_Browser filename");
#ifndef _WIN32
        it.filter     = DuplicaStringa("*.*");
#endif
        break;
   case 12:                       /* PovRay */
        if(it.filter)
           g_free(it.filter);
        it.title      = g_strdup_printf("Select executable for PovRay");
        it.label      = g_strdup_printf("_PovRay filename");
#ifndef _WIN32
        it.filter     = DuplicaStringa("*.*");
#endif
        break;
   case 13:                        /* Import CIF file */
        it.title      = g_strdup_printf("Import structure information in CIF format");
        it.label      = g_strdup_printf("_CIF filename");
        break;
   case 14:                        /* Import z-matrix fragment */
        it.title      = g_strdup_printf("Import a fragment in Z-Matrix format");
        it.label      = g_strdup_printf("_Z-Matrix filename");
        break;
   case 15:                        /* Import z-matrix fragment (ACD) */
        it.title      = g_strdup_printf("Import a fragment in Z-Matrix format (ACD)");
        it.label      = g_strdup_printf("_Z-Matrix filename (ACD)");
        break;
   case 24:                        /* Compare sir fragment */
   case 25:                        /* Compare caos fragment */
   case 26:                        /* Compare shelx file */
   case 27:                        /* Compare pdb fragment */
   case 33:                        /* Compare CIF file */
   case 34:                        /* Compare z-matrix fragment */
   case 35:                        /* Compare z-matrix fragment (ACD) */
        it.title      = g_strdup_printf("Compare atoms");
        it.label      = g_strdup_printf("Model filename");
        break;
   case 40:                        /* Fragment files ( ) */
        if(it.filter)
           g_free(it.filter);
        it.window     = get_widget(finestre[0], "new_project_dlg");
        it.filter     = g_strdup_printf("%s", "*.mol,*.mop,*.mol2,*.ml2,*.cif,*.pdb,*.fhz,*.fra,*.xyz,*.ins,*.res");
        it.title      = g_strdup_printf("Import Fragment");
        it.label      = g_strdup_printf("Fragment filename");
        break;
   case 101:                       /* Open examples dir */
        if(it.filter)
           g_free(it.filter);
        it.title      = g_strdup_printf("Load %s input file", PK);
        it.label      = g_strdup_printf("%s _Input Filename", PK);
        it.ifEditable = TRUE;
        it.ifExe      = TRUE;
        it.ifOutput   = TRUE;
//        it.filter     = DuplicaStringa("*.sir");
        it.filter     = g_strdup(
              "Sir input file (*.sir)@Shelx input file (*.ins)");
        std::string ex_dir = g_get_home_dir();
        ex_dir.append(G_DIR_SEPARATOR_S);
        ex_dir.append("share");
        ex_dir.append(G_DIR_SEPARATOR_S);
        ex_dir.append(PACKAGE);
        ex_dir.append(G_DIR_SEPARATOR_S);
        ex_dir.append("examples");
//        ex_dir.append(VERSION);
        ex_dir.append(G_DIR_SEPARATOR_S);
        ex_dir.append(EX_DIR);
        (void) dir_set_current(ex_dir.c_str());
        CopiaStringa(it.cwd, MaxLenFilename, ex_dir.c_str());
        break;
   }
   gtkext::file_open(&it);
   if((tipo == 11) || (tipo == 12))
       (void) dir_set_current(SWareRC->WorkingDirectory);
   if(it.exitCode > 0)
   {
      switch(tipo)
      {
      case 0: 
      case 101: 
           CopiaStringa(SWareRC->WorkingDirectory, MaxLenFilename, it.cwd);
           (void) dir_set_current(SWareRC->WorkingDirectory);
           call_fortran(it.fileinp, it.fileout, "sir");
           break;
      case 1: 
           CopiaStringa(SWareRC->WorkingDirectory, MaxLenFilename, it.cwd);
           (void) dir_set_current(SWareRC->WorkingDirectory);
           call_fortran(it.fileinp, it.fileout, "bin");
           break;
      case 2: 
           CopiaStringa(SWareRC->WorkingDirectory, MaxLenFilename, it.cwd);
           (void) dir_set_current(SWareRC->WorkingDirectory);
           back_file = DuplicaStringa(it.fileinp);
           CopiaStringa(it.fileinp, MaxLenFilename, str_cut(back_file, "."));
           AppendiStringa(it.fileinp, MaxLenFilename, ".bin");
           mr_CopyFile(back_file, it.fileinp);
           call_fortran(it.fileinp, it.fileout, "bin");
           break;
      case 3: 
           CopiaStringa(SWareRC->WorkingDirectory, MaxLenFilename, it.cwd);
           (void) dir_set_current(SWareRC->WorkingDirectory);
           call_fortran_bis(it.fileinp, it.cwd, 2);
           break;
      case 4: 
      case 5: 
      case 6: 
      case 7: 
           CopiaStringa(SWareRC->WorkingDirectory, MaxLenFilename, it.cwd);
           (void) dir_set_current(SWareRC->WorkingDirectory);
           c_importa(it.fileinp, it.cwd, tipo+16);
           break;
      case 8: 
           (void) dir_set_current(SWareRC->WorkingDirectory);
           ScriviStringa(riga, sizeof(riga), "%s%s", it.cwd, it.fileinp);
           update_filename("new_project_dlg","rpc_file",riga);
          break;
      case 9: 
           CopiaStringa(SWareRC->WorkingDirectory, MaxLenFilename, it.cwd);
           (void) dir_set_current(SWareRC->WorkingDirectory);
           ScriviStringa(riga, sizeof(riga), "%s%s", it.cwd, it.fileinp);
           update_filename("new_project_dlg","structfile",riga);
           update_name("new_project_dlg","structnam", riga);
           break;
      case 10: 
           (void) dir_set_current(SWareRC->WorkingDirectory);
           call_fortran_bis(it.fileinp, it.cwd, 1);
           break;
      case 11: 
           ScriviStringa(riga, sizeof(riga), "%s%s", it.cwd, it.fileinp);
           update_filename("alien_dlg","ib",riga);
           break;
      case 12: 
           ScriviStringa(riga, sizeof(riga), "%s%s", it.cwd, it.fileinp);
           update_filename("alien_dlg","povray",riga);
           break;
      case 13: 
      case 14: 
      case 15: 
           CopiaStringa(SWareRC->WorkingDirectory, MaxLenFilename, it.cwd);
           (void) dir_set_current(SWareRC->WorkingDirectory);
           c_importa(it.fileinp, it.cwd, tipo+11);
           break;
      case 24:
      case 25:
      case 26:
      case 27:
           (void) dir_set_current(SWareRC->WorkingDirectory);
           distlim = (float) spin_button_get_value(get_widget(item, "spindist"));
           ifHyd = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(get_widget(item, "ifHyd")));
           it.exitCode = c_carica(it.fileinp, it.cwd, tipo-4, distlim, ifHyd);
           break;
      case 33: 
      case 34: 
      case 35: 
           (void) dir_set_current(SWareRC->WorkingDirectory);
           distlim = (float) spin_button_get_value(get_widget(item, "spindist"));
           ifHyd = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(get_widget(item, "ifHyd")));
           it.exitCode = c_carica(it.fileinp, it.cwd, tipo-9, distlim, ifHyd);
           break;
      case 40:
           (void) dir_set_current(SWareRC->WorkingDirectory);
           ScriviStringa(riga, MaxLenFilename, "%s%s", it.cwd, it.fileinp);
           update_filename("new_project_dlg","frag_file",riga);
           break;
      }

   }
//prova
   g_free(it.cwd);
   g_free(it.fileinp);
   g_free(it.fileout);
   g_free(it.filter);
   g_free(it.title);
   g_free(it.label);
//
   return (it.exitCode);
}

void c_save_as(char *inpFile, char *dir)
{
   int l1, l2;

   l1    = (int) strlen(inpFile);
   l2    = (int) strlen(dir);
   save_as_(inpFile, dir, l1, l2);
}


typedef char stringa4[5];

extern "C" int msite_(char *atomo, stringa4 Lspecie[], float occs[], int *NumSpecie)
{
    GtkWidget *my_dlg, *vbox, *box, *cancel_b, *ok_b, *label, *frame, *align;
    int iExitCode, i, iOK;
    float occtot;
    size_t sznome = 6;
    if(!jscreen)
     return 0;
    char *title = g_new0(char, 40), *nome = g_new0(char, sznome);

    my_dlg = gtk_dialog_new ();
    ScriviStringa(title, 40, "Atom %s", atomo);
    gtk_window_set_title(GTK_WINDOW(my_dlg), title);
    gtk_window_move(GTK_WINDOW(my_dlg), 0,0);
    vbox = (gtk_dialog_get_content_area(GTK_DIALOG(my_dlg)));
    frame = gtk_frame_new (NULL);
    gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 0);
    gtk_widget_show(frame);
    gtk_container_set_border_width(GTK_CONTAINER(frame), 12);
    label = LABEL_BOLD("The sum of occupancies must be\nless or equal than 1.0", "blue", 1.2f);
    gtk_container_add(GTK_CONTAINER(frame), label);
    gtk_widget_show(label);
 
#ifdef IN_GTK3
    align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, FALSE, FALSE);
#else
    align = gtk_alignment_new(0.5, 0.5, 0, 0);
#endif
    gtk_widget_show(align);
    gtk_box_pack_start(GTK_BOX(vbox), align, TRUE, TRUE, 8);
    box = table_new(6, 2, FALSE);
    gtk_widget_show(box);
    gtk_container_add(GTK_CONTAINER(align), box);
    gtk_container_set_border_width(GTK_CONTAINER(box), 12);
    table_set_row_spacings(box, 8);
    table_set_col_spacings(box, 30);
    label = LABEL_NEW("Species", "blue");
    gtk_widget_show(label);
    table_attach(box, label, 0, 1, 0, 1);
    label = LABEL_NEW("Occupancy", "blue");
    gtk_widget_show(label);
    table_attach(box, label, 1, 2, 0, 1);

    for(i=0; i<5; i++)
    {
        label = ENTRY_NEW();
        gtk_widget_set_size_request(label, 60, 20);
        if(i == 0)
        {
           gtk_editable_set_editable(GTK_EDITABLE(label), FALSE);
//           gtk_widget_set_sensitive(label, FALSE);
        }
        gtk_widget_show(label);
        table_attach(box, label, 0, 1, i+1, i+2);
        ScriviStringa(nome, sznome, "at%d", i);
        g_object_set_data(G_OBJECT(my_dlg), nome, label);
        label = ENTRY_NEW();
        gtk_widget_set_size_request(label, 70, 20);
        gtk_widget_show(label);
        table_attach(box, label, 1, 2, i+1, i+2);
        ScriviStringa(nome, sznome, "occ%d", i);
        g_object_set_data(G_OBJECT(my_dlg), nome, label);
    }

    ok_b = myimage_button("   _OK", "ok.png");
    gtk_widget_show(ok_b);
    gtk_dialog_add_action_widget(GTK_DIALOG(my_dlg), ok_b, 1);
    cancel_b = myimage_button("  _Cancel", "cancel.png");
    gtk_widget_show(cancel_b);
    gtk_dialog_add_action_widget(GTK_DIALOG(my_dlg), cancel_b, 0);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(ok_b)), GTK_BUTTONBOX_SPREAD);
    finestra_modale_aperta2(my_dlg);
    gtk_window_set_transient_for(GTK_WINDOW(my_dlg), GTK_WINDOW(finestre[0]));
    iOK = 0;
   
    for(i=0; i<(*NumSpecie); i++)
    {
        ScriviStringa(nome, sznome, "at%d", i);
        label = get_widget(my_dlg, nome);
        gtk_entry_set_text(GTK_ENTRY(label), Lspecie[i]);
        ScriviStringa(nome, sznome, "occ%d", i);
        label = get_widget(my_dlg, nome);
        gtk_entry_set_text(GTK_ENTRY(label), g_strdup_printf("%f",occs[i]));
    }
    gtk_widget_grab_focus (ok_b);

    while(!iOK)
    {
        iExitCode = gtk_dialog_run(GTK_DIALOG(my_dlg));
        iOK = 1;
        switch(iExitCode)
        {
        case 1:
             occtot = 0;
             for(i=0; i<5; i++)
             {
                 ScriviStringa(nome, sznome, "at%d", i);
                 label = get_widget(my_dlg, nome);
                 CopiaStringa(Lspecie[i], sizeof(stringa4), gtk_editable_get_chars(GTK_EDITABLE(label), 0, -1));
                 ScriviStringa(nome, sznome, "occ%d", i);
                 label = get_widget(my_dlg, nome);
                 occs[i] = (float)atof(gtk_editable_get_chars(GTK_EDITABLE(label), 0, -1));
                 if(strlen(g_strstrip(Lspecie[i])) > 0)
                 {
                    bool foundspec = false;
                    int j;
                    for(j=0; j<nSpec; j++)
                    {
                        if(g_ascii_strcasecmp(g_strstrip(Lspecie[i]), Sigle[j]) == 0)
                        {
                           foundspec = true;
                           break;
                        } 
                    }
                    if(!foundspec)
                    {
                       iOK = 0;
                       (void) MessageDialog(my_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                              "Species %s not in unit cell content", Lspecie[i]);
                    }
                    if(occs[i] > 1)
                    {
                       iOK = 0;
                       (void) MessageDialog(my_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                              "Occupancy must be less or equal than 1");
                    }
                    else if(occs[i] <= 0)
                    {
                       iOK = 0;
                       (void) MessageDialog(my_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                              "Occupancy must be greather than 0");
                    }
                    else
                        occtot += occs[i];
                 }
                 else if(occs[i])
                 {
                       iOK = 0;
                       (void) MessageDialog(my_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                              "A species must be specified");
                 }
             }
             if(occtot > 1)
             {
                iOK = 0;
                (void) MessageDialog(my_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                       "Total occupancy must be less than 1");
             }
        case 0:
             if(iOK)
                gtk_widget_destroy(my_dlg);
             break;
        default:
             iExitCode = 0;
        }
    }
    finestra_modale_chiusa2();
    return iExitCode;
}

  void appendPng(std::ofstream &of, const std::string &fn)
  {
       std::string basefn = g_path_get_basename(fn.c_str());
       if(g_file_test(fn.c_str(), G_FILE_TEST_EXISTS))
       {
          of << "<p align=\"center\">"
             << "<font size=\"2\" style=\"font-family: courier new,courier,monospace;\"> "
             << std::endl
             << "<u><b>Image File: "<< fn << "</b></u></p>"
             << std::endl
             << "<img border=\"0\" src=\"" << basefn
             << "\" >" << std::endl;
       }
  }

void createHtml(int ifPng, int ifBody, const char *inp_suff, const char *out_suff)
{
      char *structname = g_new0(char, 80);
      std::string htmlFile, filnam, filpng, dirn = SWareRC->WorkingDirectory;
      CopiaStringa(structname, 80, str_cut(g_path_get_basename(main_app::TheApp.filebin), "."));
      if(dirn.c_str()[dirn.length()-1] != G_DIR_SEPARATOR)
         dirn.append(G_DIR_SEPARATOR_S);
      htmlFile = dirn.c_str();
      htmlFile.append(structname);
      htmlFile.append(out_suff);
      filpng = dirn.c_str();
      filpng.append(structname);
      filpng.append("_fPlot.png");
      filnam = dirn.c_str();
      filnam.append(structname);
      filnam.append(inp_suff);
      std::ofstream of(fromUTF8(htmlFile).c_str());
      
      if( !of || !of.is_open() )
      {
        return;
      }

                                 /*   header     */
      of << "<html>" << std::endl;
      of << "<head>" << std::endl;
      of << "<meta http-equiv=\"Content-Language\" content=\"en-us\">" << std::endl;
      of << "<meta name=\"GENERATOR\" content=\"" MR_PACKAGE "\">" << std::endl;
      of << "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=windows-1252\">" << std::endl;
      of << "<title>" << structname << "</title>" << std::endl;
      of << "</head>" << std::endl;
      of << "<body>" << std::endl;
      of << "<a name=\"home\"></a>" << std::endl;

                                 /*  body */
      if(ifBody)
      {
         of << "<p align=\"left\"><font size=\"5\" style=\"font-family: times new roman,times,serif;\"";
         of << "color=\"#FF0000\"><b>Summary for " << structname << "</b></font></p>";
         of << " <hr color=\"#000080\" size=\"1\">";
         of << "<pre>" << std::endl;
      }

      std::ifstream inf(fromUTF8(filnam).c_str());
      std::string line;
      if( inf && inf.is_open())
      {
         while( !inf.eof() )
         {
            std::getline(inf, line);
            of << line << std::endl;
         }
         inf.close();
      }
      if(ifPng)
         appendPng(of, fromUTF8(filpng).c_str());
                                 /*   end */
      of << "</font>" << std::endl;
      of << "</pre>" << std::endl;
      of << "</body>" << std::endl;
      of << "</html>" << std::endl;
      of.close();
      URLOpen(htmlFile, main_app::TheApp.InternetBrowser(), finestre[0]);
}

void TransformModel(GtkWidget *item, gpointer data)
{
    GtkWidget *dlg, *label, *vbox, *frame, *button, *table, *table2, *entry;
    int i, j;
    char name[10];
    float R[3][3], T[3];

    dlg = gtk_dialog_new();
    gtk_window_set_title (GTK_WINDOW (dlg), "Transform Model");

    frame = gtk_frame_new (NULL);
//    gtk_box_pack_start (GTK_BOX (GTK_DIALOG(dlg)->vbox), frame, FALSE, FALSE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (frame), 12);
    vbox = vbox_new(FALSE, 2);
    gtk_container_add(GTK_CONTAINER(frame), vbox);
    gtk_container_set_border_width (GTK_CONTAINER (vbox), 4);

    label = LABEL_BOLD("Transform the X coordinates of the model to obtain", "blue", 1.2f);
    gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);
    label = LABEL_BOLD("X' = RX + T", "blue", 1.3f);
    gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 4);
    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), frame, TRUE, TRUE, 0);

#ifdef IN_GTK3
    frame = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, FALSE, FALSE);
#else
    frame = gtk_alignment_new(0.5f, 0.5f, 0, 0);
#endif
    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), frame, FALSE, FALSE, 0);
    table = table_new(3, 4, FALSE);
    gtk_container_add(GTK_CONTAINER(frame), table);
//    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), table, FALSE, FALSE, 0);
    table_set_row_spacings(table, 8);
    table_set_col_spacings(table, 8);
    gtk_container_set_border_width (GTK_CONTAINER (table), 12);
    label = LABEL_BOLD("R =", "red", 1.5);
    table_attach(table, label, 0, 1, 1, 2, TRUE);
    label = LABEL_BOLD("T =", "red", 1.5);
    table_attach(table, label, 2, 3, 1, 2, TRUE);

    table2 = table_new (3, 3, FALSE);
    gtk_widget_show (table2);
    gtk_container_set_border_width (GTK_CONTAINER (table2), 0);
    table_attach(table, table2, 1, 2, 0, 3, TRUE);
    table_set_row_spacings (table2, 8);
    table_set_col_spacings (table2, 4);

    for(i=0; i<3;i++)
    {
     for(j=0;j<3;j++)
     {
         entry = gtk_entry_new ();
//         gtk_widget_set_size_request(entry, 70, 20);
         set_width_chars (GTK_ENTRY(entry), 4);
         gtk_widget_show (entry);
         ScriviStringa(name, sizeof(name), "R%d%d", i, j);
         g_object_set_data(G_OBJECT(dlg), name, entry);
         table_attach (table2, entry, j, j+1, i, i+1, TRUE);
         if(i == j)
            gtk_entry_set_text (GTK_ENTRY(entry), "1");
         else
            gtk_entry_set_text (GTK_ENTRY(entry), "0");
         g_signal_connect (G_OBJECT(entry), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);
     }
    }

    table2 = table_new (3, 1, FALSE);
    gtk_widget_show (table2);
    gtk_container_set_border_width (GTK_CONTAINER (table2), 0);
    table_attach(table, table2, 3, 4, 0, 3, TRUE);
    table_set_row_spacings (table2, 8);
    table_set_col_spacings (table2, 4);

    for(i=0; i<3;i++)
    {
         entry = gtk_entry_new ();
//         gtk_widget_set_size_request(entry, 70, 20);
         set_width_chars (GTK_ENTRY(entry), 4);
         gtk_widget_show (entry);
         ScriviStringa(name, sizeof(name), "T%d", i);
         g_object_set_data(G_OBJECT(dlg), name, entry);
         table_attach (table2, entry, 0, 1, i, i+1, TRUE);
         gtk_entry_set_text (GTK_ENTRY(entry), "0");
         g_signal_connect (G_OBJECT(entry), "focus_in_event",
                   G_CALLBACK (on_entry_focus_in_event), NULL);
    }

    button = myimage_button("   _OK", "ok.png");
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_OK); 

    button = myimage_button("  _Cancel", "cancel.png");
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL); 
    gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(button)), GTK_BUTTONBOX_SPREAD);

    gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(finestre[0]));
    gtk_widget_show_all(dlg);
    int result = gtk_dialog_run(GTK_DIALOG(dlg));
    if(result == GTK_RESPONSE_OK)
    {
       for(i=0; i<3;i++)
       {
           for(j=0;j<3;j++)
           {
               ScriviStringa(name, sizeof(name), "R%d%d", i, j);
               entry = get_widget(dlg, name);
               R[j][i] = (float) atof(gtk_entry_get_text(GTK_ENTRY(entry)));
           }
           ScriviStringa(name, sizeof(name), "T%d", i);
           entry = get_widget(dlg, name);
           T[i] = (float) atof(gtk_entry_get_text(GTK_ENTRY(entry)));
       }
           trasforma_modello_(R, T);
    }
    gtk_widget_destroy(dlg);
}



// DUMMIES

void SettaGruppoDefault(const char *nome)
{
    multistringa ms;
    CopiaStringa(ms.file1, MaxLenFilename, nome);
    ms.n1 = (int) strlen(nome);
    setgruppodefault_(&ms);
}

extern "C" void put_coords_(float localvet[], int ilocalvet[], int *n1, int *n2)
{
}

/*******************************************************************************************/
/*                             R i g i d   B o d y                                         */
/*******************************************************************************************/
#if 0
GList *Gruppi = NULL;
static GtkWidget *RigidBody_dlg = NULL;
std::vector<std::string> labAt;
std::vector<int> ifRotam;
typedef std::vector<int> _legami;
_legami **AtBonds;

typedef struct  {
                   int x;
                   int y;
                   float z;
                   int r;
                } _atomo;
#define MAX_ATOMS_RESID 15
int nResid, CurrentResid, CurrentAtom;
char ResidName[20];
_atomo **gCoords;
int    **iord;
int    **associato;
int    **SpecAtomResid;
char  ***ResidAtoms;
int   ***Legami;
int     *nLegami;
int     *SeqNum;
int     *nAtomsResid;
char   **ShortName;
MyRegion ***BondReg;
//                      n.atomo              n. residuo  label   

float *coords;
int *conn;
int NumResids;
int MaxAtomsInResids;
std::vector<int> set1, set2;
int sizeResidAtoms = 10;
int sizeShortName = 5;

void AllocaGruppi(int Action)
{
   int i, j;

   if(MaxAtomsInResids <= 0)
      return;
   if(Action)
   {
       gCoords       = g_new0(_atomo*, MaxAtomsInResids);
       iord          = g_new0(int*, MaxAtomsInResids);
       associato     = g_new0(int*, MaxAtomsInResids);
       SpecAtomResid = g_new0(int*, MaxAtomsInResids);
       AtBonds       = g_new0(_legami*, MaxAtomsInResids);
       ResidAtoms    = g_new0(char**, MaxAtomsInResids);
       Legami        = g_new0(int**, 2*MaxAtomsInResids);
       BondReg       = g_new0(MyRegion**, 2*MaxAtomsInResids);
       for(i=0; i<MaxAtomsInResids; i++)
       {
           gCoords[i]       = g_new0(_atomo, NumResids);
           iord[i]          = g_new0(int, NumResids);
           associato[i]     = g_new0(int, NumResids);
           SpecAtomResid[i] = g_new0(int, NumResids);
           AtBonds[i]       = g_new0(_legami, NumResids);
           ResidAtoms[i]    = g_new0(char *, NumResids);
           for(j=0; j<NumResids; j++)
               ResidAtoms[i][j] = g_new0(char, sizeResidAtoms);
           Legami[i]                  = g_new0(int*, NumResids);
           Legami[i+MaxAtomsInResids] = g_new0(int*, NumResids);
           BondReg[i]                 = g_new0(MyRegion*, NumResids);
           BondReg[i+MaxAtomsInResids]= g_new0(MyRegion*, NumResids);
           for(j=0; j<NumResids; j++)
           {
               Legami[i][j]                  = g_new0(int, 3);
               Legami[i+MaxAtomsInResids][j] = g_new0(int, 3);
           }
       }
       nLegami          = g_new0(int, NumResids);
       SeqNum           = g_new0(int, NumResids);
       nAtomsResid      = g_new0(int, NumResids);
       ShortName        = g_new0(char*, NumResids);
       for(j=0; j<NumResids; j++)
           ShortName[j] = g_new0(char, 5);
    }
    else
    {
       for(i=0; i<MaxAtomsInResids; i++)
       {
           g_free(gCoords[i]);
           g_free(iord[i]);
           g_free(associato[i]);
           g_free(SpecAtomResid[i]);
           g_free(AtBonds[i]);
           for(j=0; j<NumResids; j++)
               g_free(ResidAtoms[i][j]);
           g_free(ResidAtoms[i]);
           for(j=0; j<NumResids; j++)
           {
               g_free(Legami[i][j]);
               g_free(Legami[i+MaxAtomsInResids][j]);
               if(BondReg[i][j])
                  region_destroy(BondReg[i][j]);
               if(BondReg[i+MaxAtomsInResids][j])
                  region_destroy(BondReg[i+MaxAtomsInResids][j]);
           }
           g_free(Legami[i]);
           g_free(Legami[i+MaxAtomsInResids]);
           g_free(BondReg[i]);
           g_free(BondReg[i+MaxAtomsInResids]);
       }
       g_free(nLegami);
       g_free(BondReg);
       g_free(SeqNum);
       g_free(nAtomsResid);
       for(j=0; j<NumResids; j++)
           g_free(ShortName[j]);
       g_free(ShortName);
       g_free(gCoords);
       g_free(iord);
       g_free(associato);
       g_free(SpecAtomResid);
       g_free(AtBonds);
       g_free(ResidAtoms);
       g_free(Legami);
    }
}

extern "C" void put_coords_(float localvet[], int ilocalvet[], int *n1, int *n2)
{
       if(!jscreen)
         return;
       if(Gruppi)
          AllocaGruppi(0);

       NumResids        = *n1;
       MaxAtomsInResids = *n2;
       coords           = localvet;
       conn             = ilocalvet;
       Gruppi           = NULL;
}
     
float ResidCoords(int i, int j, int k)
{
      return coords[i+j*NumResids+k*3*NumResids];
}

int ResidConn(int i, int j, int k)
{
     return conn[i+j*NumResids+k*2*NumResids];
}

std::vector<float> zcoord;
std::vector<int> zord;

bool mygreater ( int elem1, int elem2 )
{
   return (zcoord.at(elem1) < zcoord.at(elem2));
}

void sort_coord()
{   
    int i, j;

    for(j=0; j<NumResids; j++)
    {
        zcoord.clear();
        zord.clear();
        for(i=0; i<nAtomsResid[j]; i++)
        {
            zcoord.push_back(gCoords[i][j].z);
            zord.push_back(i);
        }
        sort(zord.begin(), zord.end(), mygreater );
        for(i=0; i<nAtomsResid[j]; i++)
            iord[i][j] = zord.at(i);             
    }
}

int find_spec(char *spec)
{
    int j;
    for(j=0; j<nSpec; j++)
    {
        if(g_ascii_strcasecmp(g_strstrip(spec), g_strstrip(Sigle[j])) == 0)
           return (j+N_OBJS+1);
    }
    return GHOST;
}

GList *getInfo(const char *filename, int details, int drawsize)
{
    int i, k;
    FILE *fp;
    char rigar[MAX_LEN];
    char *spec=g_new0(char, 6);
    GList *gruppi = NULL;
    int bordo = (int)(drawsize*0.14), wid = drawsize -2*bordo;

//  Allocazioni
//    if(details)
       if(Gruppi)
          AllocaGruppi(0);
       AllocaGruppi(1);

    fp = fOpen(filename, "r");
    if(fp == NULL)

    {
       (void) MessageDialog(NULL, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
              "Error in open file: %s", filename);
       return NULL;
    }
    if(fgets(rigar, MAX_LEN, fp))
    {
       char *tmp = g_strdup(filtranl(rigar).c_str());
       gruppi = g_list_append(gruppi, DuplicaStringa(g_strstrip(tmp)));
       g_free(tmp);
    }
    if(fgets(rigar, MAX_LEN, fp) != NULL)
       nResid = 0;
    nResid = 0;
    while(fgets(rigar, MAX_LEN, fp))
    {
       int n = *(int *)( get_nth_field(rigar, " ", 2, 'i')); 
//       if(details)
       {
          CopiaStringa(ShortName[nResid], sizeShortName, (char *) ( get_nth_field(rigar, " ", 1, 's')));
          nAtomsResid[nResid] = n;
       }
//       else
       if(!details)
          gruppi = g_list_append(gruppi, (char *) ( get_nth_field(rigar, " ", 1, 's')));
       for(i=0; i<n; i++)
       {
           if(fgets(rigar, MAX_LEN, fp))
           {
              CopiaStringa(ResidAtoms[i][nResid], sizeResidAtoms, (char *) ( get_nth_field(rigar, " ", 2, 's')));
              CopiaStringa(spec, 6, (char *) ( get_nth_field(rigar, " ", 3, 's')));
              SpecAtomResid[i][nResid] = find_spec(spec);
              gCoords[i][nResid].x = bordo + (int) (wid * ResidCoords(nResid, 0, i));
              gCoords[i][nResid].y = bordo + (int) (wid * (1 - ResidCoords(nResid, 1, i))); 
              gCoords[i][nResid].z = ResidCoords(nResid, i, 2); 
              gCoords[i][nResid].r = (int) (drawsize/30); 
           }
       }
       
       nResid++;
       if(fgets(rigar, MAX_LEN, fp))
       {
          char *tmp = g_strdup(filtranl(rigar).c_str());
          gruppi = g_list_append(gruppi, DuplicaStringa(g_strstrip(tmp)));
          g_free(tmp);
       }
    }
    fclose(fp);
//    if(!details)
//       return gruppi;
    sort_coord();
    for(i=0; i<nResid; i++)
    {
        for(k=0; k<MaxAtomsInResids; k++)
            AtBonds[k][i].clear();
        k = 0;
        while(true)
        {
             if(ResidConn(i, 0, k) && ResidConn(i, 1, k) && (k < (2*MaxAtomsInResids)))
             {
                Legami[k][i][0] = ResidConn(i, 0, k) - 1;
                Legami[k][i][1] = ResidConn(i, 1, k) - 1;
                Legami[k][i][2] = 1;
                AtBonds[ResidConn(i, 0, k) - 1][i].push_back(ResidConn(i, 1, k) - 1);
                AtBonds[ResidConn(i, 1, k) - 1][i].push_back(ResidConn(i, 0, k) - 1);
                k++;
             }
             else
                break;
        }
        nLegami[i] = k;
    }
    return gruppi;
}

static void draw_flag(GdkWindow *window, int iat, GdkColor *colore)
{
      GdkPoint pflag[5];
      gpointer context = get_context(window);
      int ixx = gCoords[iat][CurrentResid].x;
      int iyy = gCoords[iat][CurrentResid].y; 
      int ir  = gCoords[iat][CurrentResid].r; 

      pflag[0].x = ixx;
      pflag[0].y = iyy - 3*ir;
      pflag[1].x = pflag[0].x + 2;
      pflag[1].y = pflag[0].y;
      pflag[2].x = pflag[0].x + 9;
      pflag[2].y = pflag[0].y + 5;
      pflag[3].x = pflag[0].x + 2;
      pflag[3].y = pflag[0].y + 10;
      pflag[4].x = pflag[0].x;
      pflag[4].y = pflag[0].y + 16;
          
      set_foreground( context,  colore);
      draw_polygon( window, context, TRUE, pflag, 5 );
      set_foreground( context, colore );
      draw_polygon( window, context, FALSE, pflag, 5 );
}

static void paint(GtkWidget *window, int idialog)
{
    int i, j, k, ir, ileg, ileg1, ixx, iyy, ixx1, iyy1, icol;
    GdkColor *colore;
    GtkWidget *drawable = get_widget(window, "drawarea");
    gpointer context = get_context( gtk_widget_get_window(drawable) );
    GtkAllocation allocation;
    gtk_widget_get_allocation(drawable, &allocation);
    PangoFontDescription *font_desc = DefaultFont();

    draw_rectangle (gtk_widget_get_window(drawable), context, TRUE, 0, 0,
          (int) allocation.width,(int)allocation.height);
    
    if(CurrentResid < 0)
    {
       if(idialog == 0)
          set_label_text(get_widget(window, "inte"), 
            "Select a group from the list on the left\nto create it.\n"
            "Select a group from the list below\n(right-click) to delete/modify it", "blue",  1.2f);
       else
          set_label_text(get_widget(window, "inte"), " ",  "blue",  1.2f);
       return;
    }
    else 
    {
       std::string testo = ResidName;
       if(gtk_widget_get_sensitive(window)&& (idialog == 0))
           testo.append("\nSelect a group from the list on the right\nto delete/modify it");
       if(idialog == 1)
       {
           testo.append(g_strdup_printf(" %d",SeqNum[CurrentResid]));
           testo.append("\nSelect a bond to define a rotamer");
       }
       else if(idialog == -1)
       {
           for(i=0; i<nAtomsResid[CurrentResid]; i++)
           {
               if(i)
                  testo.append(", ");
               testo.append(ResidAtoms[i][CurrentResid]);
           }
       }
//       if(idialog >= 0)
       set_label_text(get_widget(window, "inte"), (char *)testo.c_str(), "blue",  1.2f);
    }

    if(idialog < 0)
    {
        for(k=0; k<nLegami[CurrentResid]; k++)
        {
            ileg  = Legami[k][CurrentResid][0];
            ileg1 = Legami[k][CurrentResid][1];
            ixx  = gCoords[ileg][CurrentResid].x;
            iyy  = gCoords[ileg][CurrentResid].y;
            ixx1 = gCoords[ileg1][CurrentResid].x;
            iyy1 = gCoords[ileg1][CurrentResid].y;
            icol = (dialogo->color_YELLOW) % 16;
            set_foreground( context, &main_app::TheApp.colorPalette[icol] );
            draw_line( gtk_widget_get_window(drawable), context, ixx, iyy, ixx1, iyy1);
            BondReg[k][CurrentResid] = (MyRegion *)
               linea_spessa (ixx, iyy, ixx1, iyy1, 1, context, gtk_widget_get_window(drawable), icol);
        }
    }
    for(j=0; j<nAtomsResid[CurrentResid]; j++)
    {
        i = iord[j][CurrentResid];
        ixx = gCoords[i][CurrentResid].x;
        iyy = gCoords[i][CurrentResid].y; 
        ir  = gCoords[i][CurrentResid].r; 

        if(idialog >= 0)
        {
           for(k=0; k<nLegami[CurrentResid]; k++)
           {
               if(Legami[k][CurrentResid][2] == -1)                  //  bond already drawn
                  continue;
               if(Legami[k][CurrentResid][0] == i)
               {
                  ileg = Legami[k][CurrentResid][1];
                  ixx1 = gCoords[ileg][CurrentResid].x;
                  iyy1 = gCoords[ileg][CurrentResid].y;
               }
               else
                  continue;

               icol = (dialogo->color_GREEN) % 16;
               if(idialog < 0)
                  icol = (dialogo->color_YELLOW) % 16;
               if(idialog > 0)
               {
                  if(ifRotam[k] == 1)
                     icol = (dialogo->color_LIGHTMAGENTA) % 16;
                  else if(ifRotam[k] == -1)
                     icol = (dialogo->color_YELLOW) % 16;
               }
               BondReg[k][CurrentResid] = (MyRegion *)
                    linea_shaded (ixx, iyy, ixx1, iyy1, 4., context, gtk_widget_get_window(drawable), icol, main_app::TheApp.colorPalette);
               Legami[k][CurrentResid][2] = -1;
           }
        }
        set_foreground( context, &main_app::TheApp.colorPalette[0] );
        int ir1 = (int) ((double)ir*3);
        draw_circle( gtk_widget_get_window(drawable), context, TRUE,
                     ixx-(int)(1.5*ir), iyy-(int)(1.5*ir), ir1);
        palla_sfumata_java (ixx, iyy, ir, SpecAtomResid[i][CurrentResid],
                     4, context, gtk_widget_get_window(drawable), main_app::TheApp.colorPalette);
    }
    if(idialog < 0)
       return;

    for(i=0; i<nAtomsResid[CurrentResid]; i++)                       // draw labels
    {
        ixx = gCoords[i][CurrentResid].x;
        iyy = gCoords[i][CurrentResid].y; 
        ir  = gCoords[i][CurrentResid].r; 
        if(idialog == 0)
        {
           draw_string( gtk_widget_get_window(drawable), font_desc, context, 
                    ixx+ir, iyy, ResidAtoms[i][CurrentResid], &colorWhite, NULL);
           if (associato[i][CurrentResid] > 0)                              // draw flag
             colore = &colorGreen;
           else if (associato[i][CurrentResid] < 0)
             colore = &colorRed;
           if (associato[i][CurrentResid])
             draw_flag(gtk_widget_get_window(drawable), i, colore);
           else if(i == CurrentAtom)
             draw_flag(gtk_widget_get_window(drawable), i, &colorYellow);
        }
        else if(idialog == 1)
        {
           GdkColor *colore;
           if(find(set1.begin(), set1.end(), i) != set1.end())
              colore = &colorRed;
           else if(find(set2.begin(), set2.end(), i) != set1.end())
              colore = &colorGreen;
           else
              colore = &colorWhite;
           draw_string( gtk_widget_get_window(drawable), font_desc, context, 
                    ixx+ir, iyy, (char *)labAt.at(i).c_str(), colore, NULL);
        }
    }
    for(j=0; j<nAtomsResid[CurrentResid]; j++)                       // reset Legami for next paint
    {
        for(k=0; k<nLegami[CurrentResid]; k++)
            Legami[k][CurrentResid][2] = 1;
    }
}

void unselect_buttons(GtkWidget *container)
{
       int i;
       GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(container));
       GList *buttons = gtk_container_get_children (GTK_CONTAINER(container));
       for (i=0; i<(int)g_list_length(buttons); i++)
       {
            gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(g_list_nth_data(buttons, i)), FALSE);
            std::string nome = "listn";
            nome.append(g_strdup_printf("%d", i));
            clear_list(get_widget(dlg, (char *)nome.c_str()));
            nome = "framelist";
            nome.append(g_strdup_printf("%d", i));
            if(i != 0)
               gtk_widget_hide(get_widget(dlg, (char *)nome.c_str()));
            else
               gtk_widget_show(get_widget(dlg, (char *)nome.c_str()));
       }
}

void scelto_gruppo(GtkToggleButton *button, GtkWidget *container)
{
    if(gtk_toggle_button_get_active(button))
    {
       int i, j;
       GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
       GList *buttons = gtk_container_get_children (GTK_CONTAINER(container));

       if(gtk_widget_get_sensitive(get_widget(dlg, "apply")))
       {
           int irisp = MessageDialog(dlg, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO, 
              "The last group has not been saved. \nDo you want reject it?");
           if((irisp == GTK_RESPONSE_NO) || (irisp == GTK_RESPONSE_DELETE_EVENT))
           {
              gtk_toggle_button_set_active(button, FALSE);
              return;
           }
       }

       memset(ifLabelsVis, 0, nElemVett*sizeof(int));
       c_no_more_crosses();

       for (i=0; i<(int)g_list_length(buttons); i++)
       {
            std::string nome = "framelist";
            nome.append(g_strdup_printf("%d", i));
            if(GTK_WIDGET(g_list_nth_data(buttons, i)) != GTK_WIDGET(button))
            {
                gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(g_list_nth_data(buttons, i)), FALSE);
                gtk_widget_hide(get_widget(dlg, (char *)nome.c_str()));
            }
            else
            {
                CurrentResid = i;
                for(j=0; j<nAtomsResid[CurrentResid]; j++)
                    associato[j][CurrentResid] = 0;
                gtk_widget_show_all(get_widget(dlg, (char *)nome.c_str()));
                nome = "listn";
                nome.append(g_strdup_printf("%d", i));
                clear_list(get_widget(dlg, (char *)nome.c_str()));
                ScriviStringa(ResidName, sizeof(ResidName), "%s", (char *)gtk_button_get_label(GTK_BUTTON(button)));
                SeqNum[CurrentResid]++;
            }
       }
       paint(dlg, 0);
       gtk_dialog_response(GTK_DIALOG(dlg), 100);
    }
}

int reorder ( const int *elem1, const int *elem2 , GArray *posizioni)
{
   return (g_array_index(posizioni, int, *elem1) - g_array_index(posizioni, int, *elem2));
}

void add_line_uniq(GtkWidget *list, gpointer line)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list)); 
    list_store = GTK_LIST_STORE(model);
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);

    if(CurrentResid < 0)
       return;
    int num1 = *((int *) get_nth_field((char *)line, " ", 2, 'i'));
    while (valid)
    {
       gchar *riga, *resid;
       int num;
       gtk_tree_model_get (model, &iter, 0, &riga, -1);
       num = *((int *) get_nth_field(riga, " ", 2, 'i'));
       resid = (char *) get_nth_field(riga, " ", 1, 's');
       if((num == num1) && (strcmp(resid, ResidName) == 0))
//       if((num == SeqNum[CurrentResid]) && (strcmp(resid, ResidName) == 0))
       {
          gtk_list_store_set (list_store, &iter, 0, line,-1);
          return;
       }
       valid = gtk_tree_model_iter_next (model, &iter);
    }
    gtk_list_store_append (list_store, &iter);
    gtk_list_store_set (list_store, &iter, 0, line,-1);
}

void add_line_to_listA(GtkWidget *list, gpointer line)
{
    GArray *posizioni, *indici;
    GtkListStore *list_store;
    GtkTreeIter iter;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list)); 
    list_store = GTK_LIST_STORE(model);
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    int i=0;
    posizioni = g_array_new(FALSE, FALSE, sizeof(int));
    indici = g_array_new(FALSE, FALSE, sizeof(int));

    while (valid)
    {
       int num_ass;
       gtk_tree_model_get (model, &iter, 1, &num_ass, -1);
       g_array_append_val(posizioni, num_ass);
       g_array_append_val(indici, i);
       i++;
       if(num_ass == CurrentAtom)
       {
          gtk_list_store_set (list_store, &iter, 0, line, 1, CurrentAtom,-1);
          return;
       }
       valid = gtk_tree_model_iter_next (model, &iter);
    }
    gtk_list_store_append (list_store, &iter);
    gtk_list_store_set (list_store, &iter, 0, line, 1, CurrentAtom,-1);
    g_array_append_val(posizioni, CurrentAtom);
    g_array_append_val(indici, i);
    int npos = i+1;
    int *new_ind = g_new0(int, npos);
    for(i=0; i<npos; i++)
        new_ind[i] = g_array_index(posizioni, int, i);
    g_array_sort_with_data(indici, (GCompareDataFunc) reorder, posizioni);
    for(i=0; i<npos; i++)
        new_ind[i] = g_array_index(indici, int, i);
    gtk_list_store_reorder (list_store, new_ind);
}

void skip_atom(GtkWidget *item, gpointer data)
{
    npoints++;
    CopiaStringa(It[0], 60, "Skip");
    CopiaStringa(It[1], 60, "-1");
    set_normal(finestre[0]);
    gtk_main_quit(); 
}

static void AssociaAtomo(GtkWidget *widget)
{
    GtkWidget *dlg = gtk_widget_get_toplevel(widget);

    if((CurrentResid < 0) || (CurrentAtom < 0))
       return;
    associato[CurrentAtom][CurrentResid] = 0;
    gtk_widget_set_sensitive(get_widget(RigidBody_dlg, "action_area"), FALSE);
    draw_flag(gtk_widget_get_window(widget), CurrentAtom, &colorYellow);
    pseudo_Sorcio(finestre[0], 1, 3);
    if(CurrentResid != -1)
    {
       std::string linea = ResidAtoms[CurrentAtom][CurrentResid];
       std::string nome = "listn";
       nome.append(g_strdup_printf("%d", CurrentResid));
       linea.append(" - ");
       linea.append(It[0]);
       associato[CurrentAtom][CurrentResid] = atoi(It[1]);
       add_line_to_listA(get_widget(dlg, (char *) nome.c_str()), (gpointer) linea.c_str());
    }
    paint(dlg, 0);
    cDrawLabels();
 }

static void AssociaSingoloAtomo(GtkWidget *dlg)
{
    gtk_window_set_modal(GTK_WINDOW(dlg), FALSE);
    gtk_widget_set_sensitive(dlg, FALSE);
    gdk_window_raise(gtk_widget_get_window(finestre[0]));
    c_init_becca_punti(50);
    if(!strstr(toolbarname[Livcur], "RigidBody"))
        mostra_tb(NULL, (gpointer) "RigidBody");
    AssociaAtomo(dlg);
    if(strstr(toolbarname[Livcur], "RigidBody"))
    {
       clear_status_bar();
       nascondi_tb(finestre[0]);
       set_normal(finestre[0]);
       c_no_more_crosses();
    }
    gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
    gtk_widget_set_sensitive(get_widget(dlg, "action_area"), TRUE);
    gtk_widget_set_sensitive(get_widget(dlg, "apply"), (CurrentResid != -1));
    gtk_widget_set_sensitive(dlg, TRUE);
}

int isAtom (int x, int y)
{
    int i;

    if(CurrentResid < 0)
       return -1;
    for(i=0; i<nAtomsResid[CurrentResid]; i++)
    {
        int dist2 = (x - gCoords[i][CurrentResid].x) * (x - gCoords[i][CurrentResid].x) +
                    (y - gCoords[i][CurrentResid].y) * (y - gCoords[i][CurrentResid].y) ;
        if (dist2 <= (gCoords[i][CurrentResid].r * gCoords[i][CurrentResid].r))
            return i;
    }
    return -1;
}

static gboolean click_cb (GtkWidget *widget, GdkEventButton  *ev, gpointer data)
{
  int x, y;
  GtkWidget *dlg = gtk_widget_get_toplevel(widget);

  x = (int) ev->x;
  y = (int) ev->y;
  if ((CurrentAtom = isAtom(x, y)) != -1)
      AssociaSingoloAtomo(dlg);
  return TRUE;
}

static gboolean on_expose  (GtkWidget *widget, gpointer ob, gpointer data)
{
   GtkWidget *dlg = gtk_widget_get_toplevel(widget);
   paint(dlg, GPOINTER_TO_INT(data));
   return TRUE;
}

void copia_lista(GtkWidget *dlg, std::stringstream &str)
{
    std::string nome = "listn";
    if(CurrentResid < 0)
       return;
    nome.append(g_strdup_printf("%d", CurrentResid));
    GtkWidget *list = get_widget(dlg, (char *)nome.c_str());
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
    GtkTreeIter iter; 
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);

    while (valid)
    {
       char *line;
       std::string lstri;
       gtk_tree_model_get (model, &iter, 0, &line, -1);
       lstri = line;
       int indi = (int) lstri.find(" - ", 0);
       str << " " << lstri.substr(indi+3,strlen(line)-indi-3);
       g_free(line);
       valid = gtk_tree_model_iter_next (model, &iter);
    }
}

void DrawOneGroup(int *action, int *ngr, int *nCard, char *line)
{
     multistringa ms;
     CopiaStringa(ms.file1, MaxLenFilename, line);
     ms.n1 = (int) strlen(line);
     drawonegroup_(action, ngr, nCard, &ms);
}

void DrawOneRotamer(int *action, char *line)
{
     multistringa ms;
     CopiaStringa(ms.file1, MaxLenFilename, line);
     ms.n1 = (int) strlen(line);
     drawonerotamer_(action, &ms);
}

int get_residnum_from_name(GtkWidget *dlg)
{
   int i;
   GtkWidget *container = get_widget(dlg, "vbox_buttons");
   GList *buttons = gtk_container_get_children (GTK_CONTAINER(container));
   for (i=0; i<(int)g_list_length(buttons); i++)
   {
        GtkWidget *button = GTK_WIDGET(g_list_nth_data(buttons, i));
        if(strcmp(ResidName, gtk_button_get_label(GTK_BUTTON(button))) == 0)
           return i;
   }
   return -1;
}

static void delete_assoc (GtkWidget *item, gpointer data)
{
// cancella l'associazione selezionata (un solo atomo, che sara' identificato come 'Skip')
   int num_ass;
   GtkWidget *list = (GtkWidget *) data;

   GtkTreePath *path;
   GtkTreeModel *model = gtk_tree_view_get_model (GTK_TREE_VIEW(list));
   GtkTreeIter iter;
   GList *rowsel=NULL;

   if(CurrentResid < 0)
      return;
   rowsel = get_selections(list);
   if(rowsel)
   {
      path = (GtkTreePath *) g_list_nth_data (rowsel, 0);
      gtk_tree_model_get_iter (model, &iter, path);
      gtk_tree_model_get (model, &iter, 1, &num_ass, -1);
//      gtk_list_store_remove (GTK_LIST_STORE(model), &iter);
      std::string linea = ResidAtoms[num_ass][CurrentResid];
      linea.append(" - Skip");
      gtk_list_store_set (GTK_LIST_STORE(model), &iter, 0, linea.c_str(),-1);
      g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL); 
      g_list_free (rowsel); 
      associato[num_ass][CurrentResid] = -1;
      paint(gtk_widget_get_toplevel(list), 0);
      gtk_widget_set_sensitive(get_widget(gtk_widget_get_toplevel(list), "apply"), TRUE);
   }
}

int LabToAtom(std::stringstream &lab)
{
    int x, y, iatom;
    multistringa ms;
    CopiaStringa(ms.file1, MaxLenFilename, lab.str().c_str());
    ms.n1 = (int) strlen(lab.str().c_str());
    iatom = labtoatom_(&x, &y, &ms);
    return iatom;
}

static void modify_assoc (GtkWidget *item, gpointer data)
{
// modifica l'associazione selezionata (un solo atomo)
   int num_ass;
   GtkWidget *list = (GtkWidget *) data;

   GtkTreePath *path;
   GtkTreeModel *model = gtk_tree_view_get_model (GTK_TREE_VIEW(list));
   GtkTreeIter iter;
   GList *rowsel=NULL;
   rowsel = get_selections(list);
   if(rowsel)
   {
      path = (GtkTreePath *) g_list_nth_data (rowsel, 0);
      gtk_tree_model_get_iter (model, &iter, path);
      gtk_tree_model_get (model, &iter, 1, &num_ass, -1);
      CurrentAtom = num_ass;
      g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL); 
      g_list_free (rowsel); 
      AssociaSingoloAtomo(gtk_widget_get_toplevel(list));
   }
}

static void delete_resid_assoc (GtkWidget *item, gpointer data)
{
using namespace std;
// cancella un gruppo
   GtkWidget *list = (GtkWidget *) data;
   if(dialogo->ifDrawGroups)
   {
      gchar *line = get_selected_row(list);
      GtkWidget *dlg = gtk_widget_get_toplevel(list);
      CopiaStringa(ResidName, sizeof(ResidName), (char *) get_nth_field(line, " ", 1, 's'));
      int nResid = get_residnum_from_name(dlg);
      if(nResid != -1)
      {
         int i;
         std::stringstream line1;
         int action = 0;
         int ngr = nResid + 1;
         int nCard = nAtomsResid[nResid];
         for(i=0; i<nAtomsResid[nResid]; i++)
//260209             line1 << std::setw(8) << setiosflags(std::ios::left) 
             line1 << std::setw(LAB_LEN) << setiosflags(std::ios::left) 
                   << (char *)(get_nth_field(line, " ", i+3, 's')); 
         DrawOneGroup(&action, &ngr, &nCard, (char *)line1.str().c_str());
      }
   }
   remove_selection(list);
}

void modify_resid_assoc (GtkWidget *item, gpointer data)
{
using namespace std;
// modifica le associazioni all'interno del gruppo selezionato
   GtkWidget *list = (GtkWidget *) data;
   GtkWidget *dlg = gtk_widget_get_toplevel(list);
   int i;
   gchar *line = get_selected_row(list);
   CopiaStringa(ResidName, sizeof(ResidName), (char *) get_nth_field(line, " ", 1, 's'));
   CurrentResid = get_residnum_from_name(dlg);
   if(CurrentResid == -1)
      return;
   SeqNum[CurrentResid] = *((int *) get_nth_field(line, " ", 2, 'i'));
   char *nome = g_strdup_printf("listn%d", CurrentResid);
   for(i=0; i<nAtomsResid[CurrentResid]; i++)
   {
       std::string riga_ass = ResidAtoms[i][CurrentResid];
       std::stringstream labn;
       int iatom;
//260209       labn << std::setw(8) << setiosflags(std::ios::left) << (char *)(get_nth_field(line, " ", i+3, 's')); 
       labn << std::setw(LAB_LEN) << setiosflags(std::ios::left) << (char *)(get_nth_field(line, " ", i+3, 's')); 
       riga_ass.append(" - ");
       CurrentAtom = i;
       if(labn.str().find("Skip") == std::string::npos)   //-1)
       {
          iatom = MRmax(0, LabToAtom(labn));
          if(iatom > 0)
             ifLabelsVis[iatom-1] = 1;
          else
          {
              MessageDialog(dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CANCEL, 
                  g_strdup_printf("Atom %s not existent!", labn.str().c_str()));
              labn.str("Skip");
          }
       }
       else
          iatom = -1;
       associato[i][CurrentResid] = iatom;
       riga_ass.append(g_strstrip((char *)labn.str().c_str()));
       add_line_to_listA(get_widget(dlg, nome),(gpointer) riga_ass.c_str());
   }
   cDrawLabels();
   gtk_widget_hide(get_widget(dlg, "framelist0"));
   nome = g_strdup_printf("framelist%d", CurrentResid);
   gtk_widget_show_all(get_widget(dlg, nome));
   paint(dlg, 0);
}

static void do_popup (GtkWidget *list, guint32 timestamp, GCallback cb_delete, GCallback cb_modify)
{
  GtkWidget *menu;
  GtkWidget *mi;
  
  menu = gtk_menu_new ();

  mi = gtk_menu_item_new_with_mnemonic ("_Delete");
  widget_modify_font(gtk_bin_get_child(GTK_BIN(mi)), fontdescU);

  g_signal_connect (mi, "activate", cb_delete, list);
  
  gtk_menu_shell_append (GTK_MENU_SHELL (menu), mi);
  gtk_widget_show_all (mi);

  mi = gtk_menu_item_new_with_mnemonic ("_Modify");
  widget_modify_font(gtk_bin_get_child(GTK_BIN(mi)), fontdescU);

  g_signal_connect (mi, "activate", cb_modify, list);
  
  gtk_menu_shell_append (GTK_MENU_SHELL (menu), mi);
  gtk_widget_show_all (mi);

  gtk_menu_popup (GTK_MENU (menu), NULL, NULL,
                  NULL, list,
                  3, timestamp);
}

static void do_popup (GtkWidget *list, guint32 timestamp, GCallback cb_delete)
{
  GtkWidget *menu;
  GtkWidget *mi;
  
  menu = gtk_menu_new ();

  mi = gtk_menu_item_new_with_mnemonic ("_Delete");
  widget_modify_font(gtk_bin_get_child(GTK_BIN(mi)), fontdescU);

  g_signal_connect (mi, "activate", cb_delete, list);
  
  gtk_menu_shell_append (GTK_MENU_SHELL (menu), mi);
  gtk_widget_show_all (mi);

  gtk_menu_popup (GTK_MENU (menu), NULL, NULL,
                  NULL, list,
                  3, timestamp);
}

void reset_all(GtkWidget *dlg)
{
    int i;
    unselect_buttons(get_widget(dlg, "vbox_buttons"));
    for(i=0; i<nAtomsResid[CurrentResid]; i++)
        associato[i][CurrentResid] = 0;
    CurrentResid = -1;
    gtk_widget_set_sensitive(get_widget(dlg, "apply"), FALSE);
    paint(dlg, 0);
    memset(ifLabelsVis, 0, nElemVett*sizeof(int));
    c_no_more_crosses();
}

static gboolean open_popup (GtkWidget *list, GdkEventButton *event,
	                               gpointer data)
{
  gtk_widget_grab_focus (list);
  
  if (event->button == 3 &&
      event->type == GDK_BUTTON_PRESS)
    {
      do_popup (list, event->time, G_CALLBACK(delete_assoc), G_CALLBACK(modify_assoc));
      return TRUE;
    }

  return FALSE;
}

static gboolean open_popup2 (GtkWidget *list, GdkEventButton *event,
	                               gpointer data)
{
  gtk_widget_grab_focus (list);
  
  if (event->button == 3 &&
      event->type == GDK_BUTTON_PRESS)
    {
      if(CurrentResid != -1)
      {
           GtkWidget *dlg = gtk_widget_get_toplevel(list);
           int irisp = MessageDialog(dlg, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO, 
               "Do you want discard the previous changes?");
           if((irisp == GTK_RESPONSE_NO) || (irisp == GTK_RESPONSE_DELETE_EVENT))
              return FALSE;
           reset_all(dlg);
      }
      do_popup (list, event->time, G_CALLBACK(delete_resid_assoc), G_CALLBACK(modify_resid_assoc));
      return TRUE;
    }

  return FALSE;
}

int leggi_lista(GtkWidget *dlg, std::string &str)
{
    GtkWidget *list = get_widget(dlg, "associazioni");
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
    GtkTreeIter iter; 
    int i, nrows = 0;
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    while (valid)
    {
       char *line;
       gtk_tree_model_get (model, &iter, 0, &line, -1);
       CopiaStringa(ResidName, sizeof(ResidName), (char *) get_nth_field(line, " ", 1, 's'));
       int residnum = get_residnum_from_name(dlg);
       int serial = *((int *)get_nth_field(line, " ", 2, 'i'));
       str.append(g_ascii_strdown(ShortName[residnum], strlen(ShortName[residnum])));
       str.append(g_strdup_printf(" %d %d\n", serial, nAtomsResid[residnum]));
       for (i=0; i<nAtomsResid[residnum]; i++)
       {
            str.append(" ");
            str.append((char *) get_nth_field(line, " ", 3+i, 's'));
       }
       str.append("\n");
       g_free(line);
       valid = gtk_tree_model_iter_next (model, &iter);
       nrows++;
    }
    return nrows;
}

GtkWidget *createMSelection(GtkWidget *parent, GtkWidget *parentbox,
                            const char *title, const char *id, int formato, const char *col)
{  
  GtkWidget *scrollwin, *dirsel, *label;
  GtkWidget *frame;
  GtkListStore *store;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;
  int i;

  frame = gtk_frame_new(NULL);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
  if(parentbox)
  {
     if (GTK_IS_BOX(G_OBJECT(parentbox)))
         gtk_box_pack_start (GTK_BOX (parentbox), frame, TRUE, TRUE, 0);
     else if (GTK_IS_CONTAINER(G_OBJECT(parentbox)))
         gtk_container_add(GTK_CONTAINER(parentbox), frame);
  }
  gtk_widget_show (frame);
  scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_add(GTK_CONTAINER(frame), scrollwin);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                   GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrollwin);
  dirsel = gtk_tree_view_new();
  g_object_set_data(G_OBJECT(dirsel), "frame", frame);
  g_object_set_data(G_OBJECT(dirsel), "scrollwin", scrollwin);
  g_object_set_data(G_OBJECT(dirsel), "formato", GINT_TO_POINTER(0));
  if(formato == 0)
     (void) g_signal_connect (dirsel, "button_press_event",
		           G_CALLBACK (open_popup),  NULL);

  if(formato == 0)
     store = gtk_list_store_new (2, G_TYPE_STRING, G_TYPE_INT);
  else
     store = gtk_list_store_new (3, G_TYPE_STRING, G_TYPE_INT, G_TYPE_INT);
  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes (title,
            renderer, "markup", 0, NULL);
  gtk_tree_view_column_set_clickable(column, FALSE);
  gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
  if(title)
  {
     label = LABEL_NEW(title, col);
     gtk_widget_show (label);
     gtk_tree_view_column_set_widget(column, label);
  }
  for(i=0; i<=formato; i++)
  {
      renderer = gtk_cell_renderer_text_new ();
      column = gtk_tree_view_column_new_with_attributes ("num",
            renderer, "text", i+1, NULL);
      gtk_tree_view_column_set_clickable(column, FALSE);
      gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column); 
      gtk_tree_view_column_set_visible(column, FALSE);
  }

  gtk_tree_view_set_model(GTK_TREE_VIEW(dirsel), GTK_TREE_MODEL (store));
  g_object_set_data(G_OBJECT (parent), id, dirsel);
  gtk_widget_show (dirsel);
  gtk_container_add (GTK_CONTAINER (scrollwin), dirsel);
  if(title)
      g_object_set_data(G_OBJECT(dirsel), "titolo", label);
  else
      gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(dirsel), FALSE);

  return dirsel;
}

void fill_list1(char *line, GtkWidget *list)
{
  GtkWidget *dlg = gtk_widget_get_toplevel(list);
  int residnum;

  CopiaStringa(ResidName, sizeof(ResidName), (char *) get_nth_field(line, " ", 1, 's'));
  residnum = get_residnum_from_name(dlg);
  if(residnum == -1)
  {
      MessageDialog(dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                   "Wrong group name! %s", ResidName);
      return;
  }
  CurrentResid = residnum;
  add_line_uniq(list, (gpointer) line);
  SeqNum[residnum] = MRmax(SeqNum[residnum], *((int *) get_nth_field(line, " ", 2, 'i')));
  CurrentResid = -1;
}

GtkWidget *create_RigidBody()
{
    GtkWidget *dlg, *button, *hbox, *vbox, *scrollwin, *frame;
    GtkWidget *draw, *lista, *align, *label;
 
    dlg = gtk_dialog_new();
    gtk_window_set_title (GTK_WINDOW (dlg), "Rigid Body");
    gtk_container_set_border_width (GTK_CONTAINER (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), 8);
#ifndef NODELETABLE_PROP
    gtk_window_set_deletable(GTK_WINDOW(dlg), FALSE);
#endif
    hbox = hbox_new(FALSE, 0);
    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), hbox, TRUE, TRUE, 0);
    gtk_widget_show(hbox);
    scrollwin = gtk_scrolled_window_new( NULL, NULL);
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                  GTK_POLICY_NEVER, 
                                  GTK_POLICY_ALWAYS);
    vbox = vbox_new(FALSE, 0);
    add_to_scrollwin(scrollwin, vbox);
    gtk_box_pack_start (GTK_BOX (hbox), scrollwin, FALSE, TRUE, 0);
    g_object_set_data(G_OBJECT(dlg), "vbox_buttons", vbox);
    gtk_widget_show_all(scrollwin);

    vbox = vbox_new(FALSE, 0);
    gtk_box_pack_start (GTK_BOX (hbox), vbox, TRUE, TRUE, 0);
    label = gtk_label_new(NULL);
    gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 10);
    gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
    set_alignment(label, 0.5f, 0.5f);
    g_object_set_data(G_OBJECT(dlg), "inte", label);
    frame = gtk_frame_new (NULL);
    gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 10);
#ifdef IN_GTK3
    align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, FALSE, FALSE);
#else
    align = gtk_alignment_new(0.5, 0.5, 0, 0);
#endif
    gtk_container_add(GTK_CONTAINER(frame), align);
    draw = gtk_drawing_area_new();
    gtk_container_add(GTK_CONTAINER(align), draw);
    gtk_widget_set_size_request(draw, 250, 250);
    set_widget_color(draw, main_app::TheApp.colorPalette[0]);
    g_object_set_data(G_OBJECT(dlg), "drawarea", draw);
    gtk_widget_show_all(vbox);

    vbox = vbox_new(FALSE, 0);
    gtk_box_pack_start (GTK_BOX (hbox), vbox, TRUE, TRUE, 0);
    gtk_widget_show(vbox);
    g_object_set_data(G_OBJECT(dlg), "vbox_ass", vbox);

    frame = gtk_frame_new (NULL);
    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), frame, TRUE, TRUE, 0);
    lista = createSelection(dlg, frame, NULL, "associazioni", 0, NULL);
    set_widget_fontN(lista);
    gtk_widget_show_all(frame);
    (void) g_signal_connect (lista, "button_press_event",
		           G_CALLBACK (open_popup2),  NULL);

    button = HELP_button();
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_HELP); 
    g_object_set_data(G_OBJECT(dlg), "help", button);
    button = OK_button();
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_OK); 
    g_object_set_data(G_OBJECT(dlg), "ok", button);
    button = myimage_button ("_Accept", "apply.png");
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_APPLY); 
    g_object_set_data(G_OBJECT(dlg), "apply", button);
    button = CANCEL_button();
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL); 
    GtkWidget *act_area = gtk_widget_get_parent(button);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(act_area), GTK_BUTTONBOX_SPREAD);
    g_object_set_data(G_OBJECT(dlg), "action_area", act_area);

    (void) g_signal_connect (G_OBJECT (draw), DRAW_EVENT,
                      G_CALLBACK (on_expose), GINT_TO_POINTER(0));
    (void) g_signal_connect (G_OBJECT (draw), "button_press_event",
                      G_CALLBACK (click_cb), NULL);
    gtk_widget_set_events(draw, GDK_BUTTON_PRESS_MASK);
    (void) g_signal_connect (G_OBJECT (dlg), "delete_event",
                      G_CALLBACK (true_cb), NULL);

    gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(finestre[0]));
    return dlg;
}

void cancel_gruppi (GtkWidget *item, gpointer data)
{
    GtkWidget *main_window;

    main_window = gtk_widget_get_toplevel(item);

    clear_status_bar();
    nascondi_tb(main_window);
    set_normal(main_window);
    gtk_main_quit();
    c_no_more_crosses();
    reset_all(RigidBody_dlg);
    gtk_widget_set_sensitive(get_widget(RigidBody_dlg, "action_area"), TRUE);
    gtk_window_set_modal(GTK_WINDOW(RigidBody_dlg), TRUE);
}

void create_buttons_and_ass(GtkWidget *dlg, GList *gruppi)
{
    GtkWidget *vbox, *frame, *lista, *button, *child;
    int i, nchildren;
    GList *buttons = NULL;

    int n = g_list_length(gruppi);
    vbox = get_widget(dlg, "vbox_buttons");
    buttons = gtk_container_get_children (GTK_CONTAINER(vbox));  
    if(buttons)
    {
       nchildren = g_list_length(buttons);
       for(i=0; i<nchildren; i++)
       {
           child= GTK_WIDGET((g_list_nth(buttons, i))->data);
           gtk_container_remove(GTK_CONTAINER(vbox), child);
       }
       g_list_free(buttons);
    }
    for(i=1; i<n; i++)
    {
        button = TOGGLE_BUTTON_WITH_LABEL((char *)g_list_nth_data(gruppi, i));
        gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, TRUE, 0);
        g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(scelto_gruppo), vbox);
    }
    gtk_widget_show_all(vbox);

    vbox = get_widget(dlg, "vbox_ass");
    buttons = gtk_container_get_children (GTK_CONTAINER(vbox));
    if(buttons)
    {
       nchildren = g_list_length(buttons);
       for(i=0; i<nchildren; i++)
       {
           child= GTK_WIDGET((g_list_nth(buttons, i))->data);
           gtk_container_remove(GTK_CONTAINER(vbox), child);
       }
       g_list_free(buttons);
    }

    for(i=0; i<n; i++)
    {
       std::string nome = "framelist";
       nome.append(g_strdup_printf("%d", i));
       frame = gtk_frame_new (NULL);
       gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
       g_object_set_data(G_OBJECT(dlg), nome.c_str(), frame);
       nome = "listn";
       nome.append(g_strdup_printf("%d", i));
       lista = createMSelection(dlg, frame, NULL, (char *)nome.c_str(), 0, NULL);
       gtk_widget_show_all(lista);
       if(i == 0)
          gtk_widget_show(frame);
    }
}

void RigidBody(GtkWidget *item, gpointer data)
{
    int i, result, ngruppi, displacement = 0;
    bool completa = false;
    std::string line;

    ngruppi = ngruppidef_(&displacement);
    if(ngruppi == -2)
       return;
    memset(ifLabelsVis, 0, nElemVett*sizeof(int));
    gtk_widget_set_sensitive(get_widget(finestre[0], menubarname), FALSE);
    gtk_widget_set_sensitive(get_widget(finestre[0], "toolbar_main"), FALSE);
 
    can_drag = FALSE;
    CurrentResid = -1;

    if(RigidBody_dlg == NULL)
       RigidBody_dlg = create_RigidBody();
//    New
//    if(Gruppi == NULL)
    {
       Gruppi = getInfo(main_app::TheApp.GroupsFile().c_str(), 1, 250);
       if(Gruppi == NULL)
          return;
    }
    create_buttons_and_ass(RigidBody_dlg, Gruppi);

    for(i=0; i<NumResids; i++)
        SeqNum[i] = 0;
    unselect_buttons(get_widget(RigidBody_dlg, "vbox_buttons"));
    clear_list(get_widget(RigidBody_dlg, "associazioni"));
    gtk_widget_set_sensitive(get_widget(RigidBody_dlg, "apply"), FALSE);
    c_no_more_crosses();
   
    if(ngruppi > 0)
    {
       int k = 0;
       for(i=1; i<=ngruppi; i++)
       {
           line.clear();
           while(strstr(It[k], "&") != 0)
           {
                line.append(filtra(It[k], "&"));
                k++;
           }
           line.append(It[k]);
           k++;
           fill_list1((char *)line.c_str(), get_widget(RigidBody_dlg, "associazioni"));
           while(strstr(It[k], "#Rota") != 0)
           {
                k += 2;
                while(strstr(It[k], "&") != 0)
                      k++;
                k++;
           }
       }
    }

    gtk_window_set_transient_for(GTK_WINDOW(RigidBody_dlg), GTK_WINDOW(finestre[0]));
    setSmiley(finestre[0], "smil5.gif");
    result = gtk_dialog_run(GTK_DIALOG(RigidBody_dlg));
    while((result != GTK_RESPONSE_CANCEL))// && (result != GTK_RESPONSE_DELETE_EVENT))
    {
//         completa = false;
         if(result != GTK_RESPONSE_DELETE_EVENT)
         {
         if(result == GTK_RESPONSE_HELP)
            open_htm("Refine.html#groups");
         else if(result == 100)
         {
            gtk_window_set_modal(GTK_WINDOW(RigidBody_dlg), FALSE);
            gtk_widget_set_sensitive(RigidBody_dlg, FALSE);
            gdk_window_raise(gtk_widget_get_window(finestre[0]));
            if(!strstr(toolbarname[Livcur], "RigidBody"))
               mostra_tb(NULL, (gpointer) "RigidBody");
            c_init_becca_punti(50);
            int ResidCur = CurrentResid;
            for(i=0; i<nAtomsResid[ResidCur]; i++)
            {
                CurrentAtom = i;
                AssociaAtomo(get_widget(RigidBody_dlg, "drawarea"));
                if(CurrentResid == -1)
                {
                   SeqNum[ResidCur]--;
                   break;
                }
            }
            if(strstr(toolbarname[Livcur], "RigidBody"))
            {
               clear_status_bar();
               nascondi_tb(finestre[0]);
               set_normal(finestre[0]);
               c_no_more_crosses();
//               cDrawLabels();
            }
            gtk_window_set_modal(GTK_WINDOW(RigidBody_dlg), TRUE);
            gtk_widget_set_sensitive(get_widget(RigidBody_dlg, "action_area"), TRUE);
            gtk_widget_set_sensitive(get_widget(RigidBody_dlg, "apply"), (CurrentResid != -1));
            gtk_widget_set_sensitive(RigidBody_dlg, TRUE);
         }
         else
         {
            if((result == GTK_RESPONSE_OK) && (CurrentResid == -1))
                break;
            if(CurrentResid == -1)
            {
               completa = false;
               gtk_widget_set_sensitive(get_widget(RigidBody_dlg, "apply"), FALSE);
            }
            else
            {
               completa = true;
               for(i=0; i<nAtomsResid[CurrentResid]; i++)
               {
                   if(associato[i][CurrentResid] == 0)
                      completa = false;
               }
            }
            if(!completa)
               MessageDialog(RigidBody_dlg, GTK_MESSAGE_WARNING, GTK_BUTTONS_CANCEL,
                    "You must complete associations!");
            else
            {
               std::stringstream line;
               line << ResidName << " " << SeqNum[CurrentResid];
               copia_lista(RigidBody_dlg, line);
               add_line_uniq(get_widget(RigidBody_dlg, "associazioni"), (gpointer) line.str().c_str());
               if(dialogo->ifDrawGroups)
               {
                  std::stringstream line1;
                  int action = 1;
                  int ngr = CurrentResid + 1;
                  int nCard = nAtomsResid[CurrentResid];
                  copia_lista(RigidBody_dlg, line1);
                  DrawOneGroup(&action, &ngr, &nCard, (char *)line1.str().c_str());
               }
               reset_all(RigidBody_dlg);
            }
            if((result == GTK_RESPONSE_OK) && completa)
               break;
         }
         }
         setSmiley(finestre[0], "smil5.gif");
         result = gtk_dialog_run(GTK_DIALOG(RigidBody_dlg));
    }
    gtk_widget_hide(RigidBody_dlg);
    can_drag = TRUE;

    std::string line1;
    int nass;
    if(result == GTK_RESPONSE_OK)
       nass = leggi_lista(RigidBody_dlg, line1);
    else
    {
       line1.append(" ");
       nass = -1;
    }
     
    Megastringa ms;
    CopiaStringa(ms.stringa, sizeof(ms.stringa), line1.c_str());
    ms.n1 = (int) strlen(line1.c_str());
    f_rigidbody_(&nass, &ms);
    gtk_widget_set_sensitive(get_widget(finestre[0], menubarname), TRUE);
    gtk_widget_set_sensitive(get_widget(finestre[0], "toolbar_main"), TRUE);
    if(strstr(toolbarname[Livcur], "RigidBody"))
    {
       clear_status_bar();
       nascondi_tb(finestre[0]);
       set_normal(finestre[0]);
    }
    c_no_more_crosses();
    resetSmiley(finestre[0]);
//    memset(ifLabelsVis, 1, nElemVett*sizeof(int));
}
/*******************************************************************************************/
/*                                  R o t a m e r s                                        */
/*******************************************************************************************/

char CurGroup[25];
int  CurGroupN;
static GtkWidget *Rotamers_dlg = NULL;

static gboolean clickRot_cb (GtkWidget *widget, GdkEventButton  *ev, gpointer data)
{
  int x, y, i;
  GtkWidget *dlg = gtk_widget_get_toplevel(widget);

  if(CurrentResid == -1)
     return FALSE;
  for(i=0; i<nLegami[CurrentResid]; i++)
  {
      x = (int) ev->x;
      y = (int) ev->y;
      if(point_in_region(BondReg[i][CurrentResid], x, y))
         select_row(get_widget(dlg, "bonds"), i);
  }
  return TRUE;
}

bool coppie(char *a1, char *a2, char *b1, char *b2)
{
     if((strcmp(a1, b1) == 0) && (strcmp(a2, b2) == 0))
         return true;
     if((strcmp(a1, b2) == 0) && (strcmp(a2, b1) == 0))
         return true;
     return false;
}

void reset_allRot(GtkWidget *dlg)
{
   set_label_text(get_widget(dlg, "selbond"), "Selected bond: ", "blue", 1.2f, 0);
   gtk_widget_set_sensitive(get_widget(dlg, "framebonds"), FALSE);
   gtk_widget_set_sensitive(get_widget(dlg, "apply"), FALSE);
   set_label_text(get_widget(dlg, "A"), "Set A:", "red",  0.99f, 0);
   set_label_text(get_widget(dlg, "B"), "Set B:", "#00A000",  0.99f, 0);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dlg, "TogA")), TRUE);
   unselect_all(GTK_TREE_VIEW(get_widget(dlg, "bonds")));
   set1.clear();
   set2.clear();
}

void add_line_to_listB(GtkWidget *list, const gchar *line, int num1, int num2)
{
    GtkListStore *list_store;
    GtkTreeIter iter;

    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    gtk_list_store_append (list_store, &iter);
    gtk_list_store_set (list_store, &iter, 0, line, 1, num1, 2, num2, -1);
}

void check_rotam(int ngroup, GtkWidget *dlg)
{
    int ibond, irot, nrot;
    GtkWidget *listarot, *listabonds;
    GtkTreeModel *model;
    GtkTreeIter iter;
    std::string nome = "listn";
    char *line = g_new0(char, 25);
    char *line1 = g_new0(char, 25);
    char *at1 = g_new0(char, 10);
    char *at2 = g_new0(char, 10);
    char *at3 = g_new0(char, 10);
    char *at4 = g_new0(char, 10);
    gboolean valid;

    nome.append(g_strdup_printf("%d",ngroup));
    listarot = get_widget(dlg, (char *) nome.c_str());
    nrot = n_children(listarot);    
    listabonds = get_widget(dlg, "bonds");
    model = gtk_tree_view_get_model(GTK_TREE_VIEW(listabonds));
    valid = gtk_tree_model_get_iter_first (model, &iter);
    ibond = 0;
    while (valid)
    {
        gtk_tree_model_get (model, &iter, 0, &line, -1);
        CopiaStringa(at1, 10, g_strstrip((char *) get_nth_field(line, " ", 1, 's')));
        CopiaStringa(at2, 10, g_strstrip((char *) get_nth_field(line, " ", 3, 's')));
        for(irot=0; irot<nrot; irot++)
        {
            CopiaStringan(line1, 25, (char *) get_nth_row(listarot, irot, 0), 24);
            line1[24] = '\0';
            CopiaStringa(at3, 10, g_strstrip((char *) get_nth_field(line1, " ", 3, 's')));
            CopiaStringa(at4, 10, g_strstrip((char *) get_nth_field(line1, " ", 5, 's')));
            if(coppie(at1, at2, at3, at4))
               ifRotam.at(ibond) = 1;
        }
        valid = gtk_tree_model_iter_next (model, &iter);
        ibond++;
    }
    g_free(line);
    g_free(line1);
    g_free(at1);
    g_free(at2);
    g_free(at3);
    g_free(at4);
}

void mostra_gruppo(GtkToggleButton *button, GtkWidget *container)
{
    if(gtk_toggle_button_get_active(button))
    {
       int i, n, hnd;
       GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
       GList *buttons = gtk_container_get_children (GTK_CONTAINER(container));


       if(gtk_widget_get_sensitive(get_widget(dlg, "apply")))
       {
           int irisp = MessageDialog(dlg, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO, 
              "The last group has not been saved. \nDo you want reject it?");
           if((irisp == GTK_RESPONSE_NO) || (irisp == GTK_RESPONSE_DELETE_EVENT))
           {
              gtk_toggle_button_set_active(button, FALSE);
              return;
           }
       }

       reset_allRot(dlg);

       for (n=0; n<(int)g_list_length(buttons); n++)
       {
            std::string nome = "framelist";
            nome.append(g_strdup_printf("%d", n));
            GtkWidget *other = GTK_WIDGET(g_list_nth_data(buttons, n));
            if(other != GTK_WIDGET(button))
            {
                hnd = get_int(other, "hnd");
                g_signal_handler_block(G_OBJECT(other), hnd);
                gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(other), FALSE);
                g_signal_handler_unblock(G_OBJECT(other), hnd);
                gtk_widget_hide(get_widget(dlg, (char *) nome.c_str()));
            }
            else
            {
                gchar *line = g_strdup_printf("%s", gtk_widget_get_name(GTK_WIDGET(button)));
                CopiaStringa(ResidName, sizeof(ResidName), (char *) get_nth_field(line, " ", 1, 's'));
                CurrentResid = get_residnum_from_name(dlg);
                if(CurrentResid != -1)
                {
                SeqNum[CurrentResid] = *((int *) get_nth_field(line, " ", 2, 'i'));
                ScriviStringa(CurGroup, sizeof(CurGroup), "%s %d", ResidName, SeqNum[CurrentResid]);
                CurGroupN = n;
                clear_list(get_widget(dlg, "bonds"));
                labAt.clear();
                for(i=0; i<nAtomsResid[CurrentResid]; i++)
                    labAt.push_back((char *)get_nth_field(line, " ", i+3, 's'));
                ifRotam.clear();
                for(i=0; i<nLegami[CurrentResid]; i++)
                {
                    std::stringstream labn;
                    ifRotam.push_back(0);
                    labn << labAt.at(Legami[i][CurrentResid][0]) 
                         << " - " << labAt.at(Legami[i][CurrentResid][1]);
                    add_line_to_listB(get_widget(dlg, "bonds"),labn.str().c_str(),
                           Legami[i][CurrentResid][0], Legami[i][CurrentResid][1] );
                }
                check_rotam(n, dlg);
                cDrawLabels();
                paint(dlg, 1);
                g_free(line);
                }
                gtk_widget_show_all(get_widget(dlg, (char *)nome.c_str()));
            }
       }
    }
}

void find_set(int iAtom, int otherAtom, std::vector<int> &side, std::vector<int> &otherside)
{
    unsigned int i;
    std::vector<int>::iterator result;
    
    if( AtBonds[iAtom][CurrentResid].empty() )
        return;
    int iAtom2;
    for(i=0; i< AtBonds[iAtom][CurrentResid].size(); i++)
    {
        iAtom2 = AtBonds[iAtom][CurrentResid].at(i);
        if( (iAtom2 == iAtom) || (iAtom2 == otherAtom) )
           continue;
        result = find( otherside.begin(), otherside.end(), iAtom2);
        if (result != otherside.end() )         // anello
        {
           side.clear();
           return;
        }
        result = find( side.begin(), side.end(), iAtom2);
        if( result == side.end() )
        {
            side.push_back( iAtom2 );
            find_set( iAtom2 , otherAtom, side,  otherside);
        }
    }
}

void selected_rotamer(GtkTreeSelection *selec, GtkWidget *lista)
{
    if(get_selected_row(lista) == NULL)
       return;
    GtkWidget *dlg = gtk_widget_get_toplevel(lista);
    int ibond;
    GtkWidget  *listabonds;
    GtkTreeModel *model;
    GtkTreeIter iter;
    char *line = g_new0(char, 25);
    char *at1 = g_new0(char, 10);
    char *at2 = g_new0(char, 10);
    char *at3 = g_new0(char, 10);
    char *at4 = g_new0(char, 10);
    gboolean valid;
    char *angle = g_new0(char, 20);
    char *esd = g_new0(char, 20);
    int i, n_in_set;
    std::string set;

    listabonds = get_widget(dlg, "bonds");
    std::string line1 = (char *) get_selected_row(lista);
    model = gtk_tree_view_get_model(GTK_TREE_VIEW(listabonds));
    valid = gtk_tree_model_get_iter_first (model, &iter);
    ibond = 0;
    CopiaStringa(at3, 10, g_strstrip((char *) get_nth_field((char *)line1.c_str(), " ", 3, 's')));
    CopiaStringa(at4, 10, g_strstrip((char *) get_nth_field((char *)line1.c_str(), " ", 5, 's')));
    CopiaStringa(angle, 20, g_strstrip((char *) get_nth_field((char *)line1.c_str(), " ", 6, 's')));
    CopiaStringa(esd, 20, g_strstrip((char *) get_nth_field((char *)line1.c_str(), " ", 7, 's')));
    n_in_set = *((int *) get_nth_field((char *)line1.c_str(), " ", 8, 'i'));
    for(i=0; i<n_in_set; i++)
    {
        if(i)
           set.append( " " );
        set.append( g_strstrip((char *) get_nth_field((char *)line1.c_str(), " ", 9+i, 's')));
    }
    while (valid)
    {
        gtk_tree_model_get (model, &iter, 0, &line, -1);
        CopiaStringa(at1, 10, g_strstrip((char *) get_nth_field(line, " ", 1, 's')));
        CopiaStringa(at2, 10, g_strstrip((char *) get_nth_field(line, " ", 3, 's')));
        if(coppie(at1, at2, at3, at4))
        {
           ifRotam.at(ibond) = 1;
           break;
        }
        valid = gtk_tree_model_iter_next (model, &iter);
        ibond++;
    }
    select_row(listabonds, ibond);
    gtk_entry_set_text(GTK_ENTRY(get_widget(dlg, "angle")), angle);
    gtk_entry_set_text(GTK_ENTRY(get_widget(dlg, "sigma")), esd);    
    line1 = gtk_label_get_text(GTK_LABEL(get_widget(dlg, "A")));
    int ipos = (int) line1.find(": ");
    if(set.compare(line1.substr(ipos+2)) == 0)
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dlg, "TogA")), TRUE);
    else
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dlg, "TogB")), TRUE);

    g_free(line);
    g_free(at1);
    g_free(at2);
    g_free(at3);
    g_free(at4);
}

void selected_bond(GtkTreeSelection *select, GtkWidget *lista)
{
    GtkWidget *dlg = gtk_widget_get_toplevel(lista);
    unsigned int i;
    int ind;
    int nbond = get_selected_row_num(lista);
    
    if(nbond == -1)
       return;

    if(gtk_widget_get_sensitive(get_widget(dlg, "apply")))
    {
       float angle = (float) atof(gtk_entry_get_text(GTK_ENTRY(get_widget(dlg, "angle"))));
       if(MRabs(angle) > 1e-6)
       {
          int irisp = MessageDialog(dlg, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO,
              "The last rotamer has not been saved. \nDo you want reject it?");
          if((irisp == GTK_RESPONSE_NO) || (irisp == GTK_RESPONSE_DELETE_EVENT))
              return;
       }
    }

    for(i=0; i<ifRotam.size(); i++)
    {
        if(ifRotam[i] == -1)
           ifRotam[i] = 0;
    }
    std::string testo = "Selected bond: ";
    testo.append(get_selected_row(lista));
    set_label_text(get_widget(dlg, "selbond"), (char *)testo.c_str(), "blue",  1.2f, 0);
    ifRotam[nbond] = -1;

    int at1 = GPOINTER_TO_INT(get_selected_row_col(lista, 1));
    int at2 = GPOINTER_TO_INT(get_selected_row_col(lista, 2));
    set1.clear();
    set2.clear();
    set1.push_back(at1);
    set2.push_back(at2);
    find_set(at1, at2, set1, set2);
    find_set(at2, at1, set2, set1);

    if( (set1.size() > 0) && (set2.size() > 0) )
    {
        testo.clear();
        testo.append("Set A: ");
        for(i=1; i<set1.size(); i++)
        {
            ind = set1.at(i);
            testo.append(g_strdup_printf("%s ", labAt.at(ind).c_str()));
        }
        set_label_text(get_widget(dlg, "A"), (char *)testo.c_str(), "red",  0.99f, 0);
        testo.clear();
        testo.append("Set B: ");
        for(i=1; i<set2.size(); i++)
        {
            ind = set2.at(i);
            testo.append(g_strdup_printf("%s ", labAt.at(ind).c_str()));
        }
        set_label_text(get_widget(dlg, "B"), (char *)testo.c_str(), "#00A000",  0.99f, 0);
        gtk_widget_set_sensitive(get_widget(dlg, "apply"), TRUE);
        gtk_widget_set_sensitive(get_widget(dlg, "framebonds"), TRUE);
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget(dlg, "TogA")), TRUE);
        gtk_entry_set_text(GTK_ENTRY(get_widget(dlg, "angle")), "0");
    }
    else
    {
        reset_allRot(dlg);
        ifRotam[nbond] = 0;
    }
    paint(dlg, 1);
}

GtkWidget *create_Rotamers()
{
    GtkWidget *dlg, *button, *hbox, *vbox, *frame, *scrollwin;
    GtkWidget *draw, *lista, *align, *label, *radio;
    GSList *group = NULL;
    int hnd;
 
    dlg = gtk_dialog_new();
    gtk_window_set_title (GTK_WINDOW (dlg), "Rotamers");
    gtk_container_set_border_width (GTK_CONTAINER (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), 8);
    hbox = hbox_new(FALSE, 0);
    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), hbox, TRUE, TRUE, 0);
    gtk_widget_show(hbox);

    scrollwin = gtk_scrolled_window_new( NULL, NULL);
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                  GTK_POLICY_NEVER, 
                                  GTK_POLICY_ALWAYS);
    vbox = vbox_new(FALSE, 0);
    add_to_scrollwin(scrollwin, vbox);
    gtk_box_pack_start (GTK_BOX (hbox), scrollwin, FALSE, TRUE, 0);
    g_object_set_data(G_OBJECT(dlg), "vbox_gruppi", vbox);
    gtk_widget_show_all(scrollwin);

    vbox = vbox_new(FALSE, 0);
    gtk_box_pack_start (GTK_BOX (hbox), vbox, FALSE, FALSE, 0);
    g_object_set_data(G_OBJECT(dlg), "vbox_buttons", vbox);

    vbox = vbox_new(FALSE, 0);
    gtk_box_pack_start (GTK_BOX (hbox), vbox, TRUE, TRUE, 0);
    label = gtk_label_new(NULL);
    gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 10);
    gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
    set_alignment(label, 0.5f, 0.5f);
    g_object_set_data(G_OBJECT(dlg), "inte", label);
    frame = gtk_frame_new (NULL);
    gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 10);
#ifdef IN_GTK3
    align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, FALSE, FALSE);
#else
    align = gtk_alignment_new(0.5, 0.5, 0, 0);
#endif
    gtk_container_add(GTK_CONTAINER(frame), align);
    draw = gtk_drawing_area_new();
    gtk_container_add(GTK_CONTAINER(align), draw);
    gtk_widget_set_size_request(draw, 250, 250);
    set_widget_color(draw, main_app::TheApp.colorPalette[0]);
    g_object_set_data(G_OBJECT(dlg), "drawarea", draw);
    gtk_widget_show_all(vbox);

    vbox = vbox_new(FALSE, 0);
    gtk_box_pack_start (GTK_BOX (hbox), vbox, TRUE, TRUE, 0);
    gtk_widget_show(vbox);
    g_object_set_data(G_OBJECT(dlg), "vbox_bonds", vbox);
    lista = createMSelection(dlg, vbox, "List of bonds", "bonds", 1, "blue");
    set_widget_fontN(lista);
    gtk_widget_show_all(vbox);
    hnd = g_signal_connect (gtk_tree_view_get_selection(GTK_TREE_VIEW(lista)), "changed",
		           G_CALLBACK (selected_bond),  lista);
    g_object_set_data(G_OBJECT(lista), "hnd", GINT_TO_POINTER(hnd));

    vbox = vbox_new(FALSE, 0);
    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), vbox, TRUE, TRUE, 0);
    gtk_widget_show(vbox);
    g_object_set_data(G_OBJECT(dlg), "vbox_rot", vbox);

    frame = gtk_frame_new(NULL);
    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), frame, TRUE, TRUE, 0);
    g_object_set_data(G_OBJECT(dlg), "framebonds", frame); 
    vbox = vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(frame), vbox);
    label = LABEL_BOLD("Selected bond: ", "blue", 1.2f, 0);
    gtk_frame_set_label_widget(GTK_FRAME(frame), label);
    g_object_set_data(G_OBJECT(dlg), "selbond", label); 
    radio = RADIO_BUTTON_WITH_LABEL(group, "Set A:", "red");
    gtk_box_pack_start (GTK_BOX (vbox), radio, FALSE, FALSE, 6);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(dlg), "A", gtk_bin_get_child(GTK_BIN(radio))); 
    g_object_set_data(G_OBJECT(dlg), "TogA", radio); 
    radio = RADIO_BUTTON_WITH_LABEL(group, "Set B:", "#00A000");
    gtk_box_pack_start (GTK_BOX (vbox), radio, FALSE, FALSE, 6);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(dlg), "B", gtk_bin_get_child(GTK_BIN(radio))); 
    g_object_set_data(G_OBJECT(dlg), "TogB", radio); 
    hbox = hbox_new(FALSE, 0);
    gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 6);
    label = LABEL_WITH_ENTRY("Angle", "blue");
    gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 6);
    g_object_set_data(G_OBJECT(dlg), "angle", get_widget(label, "entry")); 
    label = LABEL_WITH_ENTRY("ESD", "blue");
    gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 6);
    g_object_set_data(G_OBJECT(dlg), "sigma", get_widget(label, "entry")); 
    gtk_editable_set_editable(GTK_EDITABLE(get_widget(label, "entry")), FALSE);
    gtk_widget_set_sensitive(get_widget(label, "entry"), FALSE);
    gtk_widget_show_all(frame);
    gtk_widget_set_sensitive(frame, FALSE);

    button = myimage_button("   _OK", "ok.png");
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_OK); 
    g_object_set_data(G_OBJECT(dlg), "ok", button);
    button = myimage_button ("_Accept", "apply.png");
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_APPLY); 
    g_object_set_data(G_OBJECT(dlg), "apply", button);
    button = myimage_button("  _Cancel", "cancel.png");
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL); 
    gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)), 
        GTK_BUTTONBOX_SPREAD);
    (void) g_signal_connect (G_OBJECT (draw), DRAW_EVENT,
                      G_CALLBACK (on_expose), GINT_TO_POINTER(1));
    (void) g_signal_connect (G_OBJECT (draw), "button_press_event",
                      G_CALLBACK (clickRot_cb), NULL);
    gtk_widget_set_events(draw, GDK_BUTTON_PRESS_MASK);

    return dlg;
}

void create_buttons(GtkWidget *dlg, int toshow, GList *gruppi)
{
    GtkWidget *vbox, *button, *child;
    int i, nchildren, hnd;
    GList *buttons = NULL;

    int n = g_list_length(gruppi);
    if(toshow)
       vbox = get_widget(dlg, "vbox_gruppi");
    else
       vbox = get_widget(dlg, "vbox_buttons");
    buttons = gtk_container_get_children (GTK_CONTAINER(vbox));  
    if(buttons)
    {
       nchildren = g_list_length(buttons);
       for(i=0; i<nchildren; i++)
       {
           child= GTK_WIDGET((g_list_nth(buttons, i))->data);
           gtk_container_remove(GTK_CONTAINER(vbox), child);
       }
       g_list_free(buttons);
    }
    for(i=1-toshow; i<n; i++)
    {
        char *labelstring = g_new0(char, 25);
        if(toshow)
        {
           CopiaStringa(labelstring, 25, (char *) get_nth_field((char *) g_list_nth_data(gruppi, i), " ", 1, 's'));
           AppendiStringa(labelstring, 25, (char *) get_nth_field((char *) g_list_nth_data(gruppi, i), " ", 2, 's'));
        }
        else
           CopiaStringa(labelstring, 25, (char *) g_list_nth_data(gruppi, i));
        button = TOGGLE_BUTTON_WITH_LABEL((char *)labelstring);
        gtk_widget_set_name(button, g_strstrip((char *) g_list_nth_data(gruppi, i)));
        gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 0);
        if(toshow)
        {
           hnd = g_signal_connect(G_OBJECT(button), "toggled", G_CALLBACK(mostra_gruppo), vbox);
           g_object_set_data(G_OBJECT(button), "hnd", GINT_TO_POINTER(hnd));
        }
    }
    if(toshow)
       gtk_widget_show_all(vbox);
}

int nleg_from_coppia(char *coppia, GtkWidget *dlg)
{
    int ibond, cercato = -1;
    GtkWidget *listabonds;
    GtkTreeModel *model;
    GtkTreeIter iter;
    char *line = g_new0(char, 25);
    char *at1 = g_new0(char, 10);
    char *at2 = g_new0(char, 10);
    char *at3 = g_new0(char, 10);
    char *at4 = g_new0(char, 10);
    gboolean valid;

    listabonds = get_widget(dlg, "bonds");
    model = gtk_tree_view_get_model(GTK_TREE_VIEW(listabonds));
    valid = gtk_tree_model_get_iter_first (model, &iter);
    ibond = 0;
    CopiaStringa(at3, 10, g_strstrip((char *) get_nth_field(coppia, "-", 1, 's')));
    CopiaStringa(at4, 10, g_strstrip((char *) get_nth_field(coppia, "-", 2, 's')));
    
    while (valid)
    {
        gtk_tree_model_get (model, &iter, 0, &line, -1);
        CopiaStringa(at1, 10, g_strstrip((char *) get_nth_field(line, " ", 1, 's')));
        CopiaStringa(at2, 10, g_strstrip((char *) get_nth_field(line, " ", 3, 's')));
        if(coppie(at1, at2, at3, at4))
        {
               cercato = ibond;
               break;
        }
        valid = gtk_tree_model_iter_next (model, &iter);
        ibond++;
    }
    g_free(line);
    g_free(at1);
    g_free(at2);
    g_free(at3);
    g_free(at4);
    return cercato;
}

static void delete_rot (GtkWidget *item, gpointer data)
{
// cancella un rotamero
   GtkWidget *list = (GtkWidget *) data;
   GtkWidget *dlg = gtk_widget_get_toplevel(list);
   gchar *line = get_selected_row(list);
   int action = 0;

   std::string line1 = (char *) get_nth_field(line, " ", 3, 's');
   line1.append((char *) get_nth_field(line, " ", 4, 's'));
   line1.append((char *) get_nth_field(line, " ", 5, 's'));
   DrawOneRotamer(&action, (char *)line1.c_str());

   int ibond = nleg_from_coppia((char *) line1.c_str(), dlg);
   remove_selection(list);
   ifRotam.at(ibond) = 0;
   reset_allRot(dlg);
   paint(dlg, 1);    

}

static gboolean open_popupRot (GtkWidget *list, GdkEventButton *event,
	                               gpointer data)
{
  gtk_widget_grab_focus (list);
  
  if (event->button == 3 &&
      event->type == GDK_BUTTON_PRESS)
    {
      do_popup (list, event->time, G_CALLBACK(delete_rot));
      return TRUE;
    }

  return FALSE;
}

void create_rotamers_list(GtkWidget *dlg, int n)
{
    GtkWidget *vbox, *frame, *lista, *child;
    int i, nchildren;
    GList *buttons = NULL;
    vbox = get_widget(dlg, "vbox_rot");
    buttons = gtk_container_get_children (GTK_CONTAINER(vbox));
    if(buttons)
    {
       nchildren = g_list_length(buttons);
       for(i=0; i<nchildren; i++)
       {
           child = GTK_WIDGET((g_list_nth(buttons, i))->data);
           gtk_container_remove(GTK_CONTAINER(vbox), child);
       }
       g_list_free(buttons);
    }
                                                                                                           
    for(i=0; i<n; i++)
    {
       std::string nome = "framelist";
       nome.append(g_strdup_printf("%d", i));
       frame = gtk_frame_new (NULL);
       gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
       g_object_set_data(G_OBJECT(dlg), nome.c_str(), frame);
       nome = "listn";
       nome.append(g_strdup_printf("%d", i));
       lista = createSelection(dlg, frame, NULL, (char *)nome.c_str(), 0, NULL);
       set_widget_fontN(lista);
       (void) g_signal_connect (gtk_tree_view_get_selection(GTK_TREE_VIEW(lista)), "changed",
  		           G_CALLBACK (selected_rotamer),  lista);
       (void) g_signal_connect (lista, "button_press_event",
		           G_CALLBACK (open_popupRot),  NULL);
       gtk_widget_show_all(lista);
       if(i == 0)
          gtk_widget_show(frame);
    }
}

void unselect_rots(GtkWidget *container)
{
       int i;
       GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(container));
       GList *buttons = gtk_container_get_children (GTK_CONTAINER(container));
       for (i=0; i<(int)g_list_length(buttons); i++)
       {
            std::string nome = "framelist";
            nome.append(g_strdup_printf("%d", i));
            gtk_widget_hide(get_widget(dlg, (char *)nome.c_str()));
       }
}
                                                                                                           
void convert_line_to_fort(char *line, GtkWidget *dlg, std::string &str)
{
     int i, resid;

     CopiaStringa(ResidName, sizeof(ResidName), g_strstrip((char *)get_nth_field((char *)line, " ", 1, 's')));
     resid = get_residnum_from_name(dlg);
     if(resid != -1)
        str.append(g_strstrip(ShortName[resid]));
     str.append(" ");
     str.append(g_strstrip((char *)get_nth_field((char *)line, " ", 2, 's')));
     str.append(" # ");
     str.append(g_strstrip((char *)get_nth_field((char *)line, " ", 3, 's')));
     str.append(" ");
     str.append(g_strstrip((char *)get_nth_field((char *)line, " ", 5, 's')));
     str.append(" ");
     str.append(g_strstrip((char *)get_nth_field((char *)line, " ", 6, 's')));
     str.append(" ");
     str.append(g_strstrip((char *)get_nth_field((char *)line, " ", 7, 's')));
     str.append(" # ");
     str.append(g_strstrip((char *)get_nth_field((char *)line, " ", 8, 's')));
     str.append(" # ");
     int num = *((int *) get_nth_field((char *)line, " ", 8, 'i'));
     for(i=0; i<num; i++)
     {
         str.append(g_strstrip((char *)get_nth_field((char *)line, " ", 9+i, 's')));
         str.append(" ");
    }
    str.append("\n");
}

int leggi_liste_rot(GtkWidget *dlg, std::string &str, int nrot)
{
    int i, resid, nrows = 0;
    GtkWidget *list;
    char *nome;

    for(i=0; i<nrot; i++)
    {
        nome = g_strdup_printf("listn%d", i);
        list = get_widget(dlg, nome);
        GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
        GtkTreeIter iter; 
        gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
        if(!valid)
        {
           GList *buttons = gtk_container_get_children(GTK_CONTAINER(get_widget(dlg, "vbox_gruppi")));
           GtkWidget *button = (GtkWidget *) g_list_nth_data(buttons, i);
           CopiaStringa(ResidName, sizeof(ResidName), 
              g_strstrip((char *) get_nth_field((char *)gtk_widget_get_name(button), " ", 1, 's')));
           resid = get_residnum_from_name(dlg);
           if(resid != -1)
               str.append(g_strstrip(ShortName[resid]));
            str.append(" ");
            str.append(g_strstrip((char *)get_nth_field((char *)gtk_widget_get_name(button), " ", 2, 's')));
            str.append("\n");
            nrows++;
        }
        while (valid)
        {
            char *line;
            gtk_tree_model_get (model, &iter, 0, &line, -1);
            convert_line_to_fort(line, dlg, str);
            g_free(line);
            valid = gtk_tree_model_iter_next (model, &iter);
            nrows++;
         }
    }
    return nrows;
}

void add_line_rot_uniq(GtkWidget *list, gpointer line)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list)); 
    list_store = GTK_LIST_STORE(model);
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    char *at1 = g_new0(char, 10);
    char *at2 = g_new0(char, 10);
    char *at3 = g_new0(char, 10);
    char *at4 = g_new0(char, 10);

    CopiaStringa(at1,  10, g_strstrip((char *) get_nth_field((char *)line, " ", 3, 's')));
    CopiaStringa(at2,  10, g_strstrip((char *) get_nth_field((char *)line, " ", 5, 's')));
    while (valid)
    {
       gchar *riga;
       gtk_tree_model_get (model, &iter, 0, &riga, -1);
       CopiaStringa(at3, 10, g_strstrip((char *) get_nth_field(riga, " ", 3, 's')));
       CopiaStringa(at4, 10, g_strstrip((char *) get_nth_field(riga, " ", 5, 's')));
       if(coppie(at1, at2, at3, at4))
       {
          gtk_list_store_set (list_store, &iter, 0, line,-1);
          return;
       }
       valid = gtk_tree_model_iter_next (model, &iter);
    }
    gtk_list_store_append (list_store, &iter);
    gtk_list_store_set (list_store, &iter, 0, line,-1);
}

void Rotamers(GtkWidget *item, gpointer data)
{
    int i, result, ngruppi, displacement = 0;
    int action, nrots;
    std::string line;
    char *strf;

    ngruppi = ngruppidef_(&displacement);

    if(ngruppi <= 0)
    {
       MessageDialog(finestre[0], GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                        "No Rigid Groups defined!");
       return;
    }

    obj_set_active(get_object(finestre[0], "DrawGrOn"), TRUE);
    CurrentResid = -1;
    CurGroupN = -1;
    memset(CurGroup, 0, 25*sizeof(char));
    can_drag = FALSE;
    set1.clear();
    set2.clear();

    if(Rotamers_dlg == NULL)
       Rotamers_dlg = create_Rotamers();

//    if(Gruppi == NULL)
    {
       Gruppi = getInfo(main_app::TheApp.GroupsFile().c_str(), 1, 250);
       if(Gruppi == NULL)
          return;
    }
    create_buttons(Rotamers_dlg, 0, Gruppi);

    clear_list(get_widget(Rotamers_dlg, "bonds"));
    gtk_label_set_text(GTK_LABEL(get_widget(Rotamers_dlg, "inte")), " ");
    set_label_text(get_widget(Rotamers_dlg, "selbond"), "Selected bond: ", "blue", 1.2f, 0);
    gtk_widget_set_sensitive(get_widget(Rotamers_dlg, "framebonds"), FALSE);
    gtk_widget_set_sensitive(get_widget(Rotamers_dlg, "apply"), FALSE);
    set_label_text(get_widget(Rotamers_dlg, "A"), "Set A:", "red",  0.99f, 0);
    set_label_text(get_widget(Rotamers_dlg, "B"), "Set B:", "#00A000",  0.99f, 0);
   
    if(ngruppi > 0)
    {
       int k = 0;
       GList *gruppidef = NULL;
       GList *rotdef = NULL;
       create_rotamers_list(Rotamers_dlg, ngruppi);
       for(i=1; i<=ngruppi; i++)
       {
           std::string name;
           line.clear();
           name = (char *) get_nth_field(It[k], " ", 1, 's');
           name.append(" ");
           name.append( (char *) get_nth_field(It[k], " ", 2, 's'));
           while(strstr(It[k], "&") != 0)
           {
                line.append(filtra(It[k], "&"));
                k++;
           }
           line.append(It[k]);
           k++;
           gruppidef = g_list_append(gruppidef, DuplicaStringa(line.c_str())); 
           line.clear();
           line = name;
           line.append(" ");
           std::string nome = "listn";
           nome.append(g_strdup_printf("%d", i-1));
           if(strstr(It[k], "#Rota") != 0)
           {
                int nrotameri = *((int *) get_nth_field(It[k], " ", 2, 'i'));
                int j;
                k++;
                clear_list(get_widget(Rotamers_dlg, (char *)nome.c_str()));
                for(j=0; j<nrotameri; j++)
                {
                    line.append(It[k]);
                    line.append(" ");
                    k++;
                    while(strstr(It[k], "&") != 0)
                    {
                          line.append(filtra(It[k], "&"));
                          k++;
                    }
                    line.append(It[k]);
                    k++;
                    add_line_rot_uniq(get_widget(Rotamers_dlg, (char *)nome.c_str()), 
                                     (gpointer) line.c_str());
                    rotdef = g_list_append(rotdef, DuplicaStringa(line.c_str()));
                }
           }
       }
       create_buttons(Rotamers_dlg, 1, gruppidef);
       g_list_free(gruppidef);
       unselect_rots(get_widget(Rotamers_dlg, "vbox_rot"));
    }

    gtk_window_set_transient_for(GTK_WINDOW(Rotamers_dlg), GTK_WINDOW(finestre[0]));
    gtk_widget_set_sensitive(finestre[0], FALSE);
    setSmiley(finestre[0], "smil5.gif");
    bool irun = true;
    while(irun)
    {
          GtkWidget *label;
          float angle, esd;
          std::string line, testo;
          int ipos, nrotam, nbond;
          result = gtk_dialog_run(GTK_DIALOG(Rotamers_dlg));
          switch (result)
          {
          case GTK_RESPONSE_OK:
               irun = false;
          case GTK_RESPONSE_APPLY:
               label = get_widget(Rotamers_dlg, "angle");
               angle = (float) atof(gtk_entry_get_text(GTK_ENTRY(label)));

               if(MRabs(angle) < 1e-6)
               {
                  if(gtk_widget_get_sensitive(get_widget(Rotamers_dlg, "apply")))
                  {
                     irun = true;
                     MessageDialog(Rotamers_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
                        "You should specify a value for angle!");
                  }
               }
               else
               {
                  if(gtk_widget_get_sensitive(get_widget(Rotamers_dlg, "apply")))
                  {
                     testo = CurGroup;
                     testo.append(" ");
                     label = get_widget(Rotamers_dlg, "sigma");
                     esd = (float) atof(gtk_entry_get_text(GTK_ENTRY(label)));
                     label = get_widget(Rotamers_dlg, "selbond");
                     line = gtk_label_get_text(GTK_LABEL(label));
                     ipos = (int) line.find(": ");
                     testo.append(line.substr(ipos+2));
                     strf = g_strdup_printf("%s", line.substr(ipos+2).c_str());
                     testo.append(g_strdup_printf(" %f ", angle));
                     testo.append(g_strdup_printf(" %f ", esd));
                     line.clear();
                     label = get_widget(Rotamers_dlg, "TogA");
                     if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(label)))
                        label = get_widget(Rotamers_dlg, "A");
                     else
                        label = get_widget(Rotamers_dlg, "B");
                     line = gtk_label_get_text(GTK_LABEL(label));
                     ipos = (int) line.find(": ");
                     nrotam = num_fields(line.substr(ipos+2).c_str(), " ");
                     testo.append(g_strdup_printf(" %d ", nrotam));
                     testo.append(line.substr(ipos+2));
                     line = "listn";
                     line.append(g_strdup_printf("%d", CurGroupN));
                     add_line_rot_uniq(get_widget(Rotamers_dlg, (char *)line.c_str()), (gpointer)testo.c_str());
                     nbond = get_selected_row_num(get_widget(Rotamers_dlg, "bonds"));
                     if(nbond != -1)
                     {
                        ifRotam.at(nbond) = 1;
                        paint(Rotamers_dlg, 1);
                     }
                  }
                  if(result == GTK_RESPONSE_APPLY)
                  {
                     action = 1;
                     DrawOneRotamer(&action, strf);
                     reset_allRot(Rotamers_dlg);
                  }
               }
               if(result == GTK_RESPONSE_OK)
               {
                     line.clear();
                     nrots = leggi_liste_rot(Rotamers_dlg, line, ngruppi); 
                     Megastringa ms;
                     CopiaStringa(ms.stringa, sizeof(ms.stringa), line.c_str());
                     ms.n1 = (int) strlen(line.c_str());
                     f_rotamers_(&nrots, &ms);
               }
               break;
          case GTK_RESPONSE_CANCEL:
          case GTK_RESPONSE_DELETE_EVENT:
               line.clear();
               nrots = leggi_liste_rot(Rotamers_dlg, line, ngruppi); 
               action = 0;
               for (i=0; i<nrots; i++)
               { 
                  strf = g_strdup_printf("%s", (char *)get_nth_field((char *) line.c_str(),
                            "\n", i+1, 's'));
                  if(strstr(strf, "#"))
                  {
                     testo.clear();
                     testo.append(g_strdup_printf("%s - %s", 
                          (char *)get_nth_field(strf, " ", 4, 's'),
                          (char *)get_nth_field(strf, " ", 5, 's')));
                     DrawOneRotamer(&action, (char *) testo.c_str());
                  }
                  g_free(strf);
               }
               irun = false;
               break;
          }
    }
    gtk_widget_hide(Rotamers_dlg);
    resetSmiley(finestre[0]);
    gtk_widget_set_sensitive(finestre[0], TRUE);
    can_drag = TRUE;
}

/*******************************************************************************************/
/*                        G r o u p   M a n a g e r                                        */
/*******************************************************************************************/

static GtkWidget *GroupMgr_dlg = NULL;

static const char *tt_s = "STRING";
static GtkTargetEntry target_table[] = {{ g_strdup(tt_s), 0, 0 }} ;
static guint n_targets = sizeof(target_table) / sizeof(target_table[0]);

gchar *get_selected_file(GtkWidget *list)
{
   GtkTreePath *path;
   GList *rowsel=NULL;
   gchar *riga = g_new0(char, 200);
   PixText *info;
                                                                                
   rowsel = get_selections(list);
   if(rowsel)
   {
      path = (GtkTreePath *) g_list_nth_data (rowsel, 0);
      info = (PixText *) get_selection_from_path(GTK_TREE_VIEW(list), path);
      ScriviStringa(riga, 200, "%s", info->text);
      g_list_foreach (rowsel, (GFunc)gtk_tree_path_free, NULL);
      g_list_free (rowsel);
   }
   return riga;
}

static void  show_groups (GtkTreeSelection *selec, GtkWidget *dlg)
{
    char *nome=NULL;
    GList *gruppi = NULL, *gruppi2[2];
    int ngruppi, displacement = 0;
    int i;                                                                                                                    
    for(i=0; i<2; i++)
        gruppi2[i] = NULL;
    gtk_widget_set_sensitive(get_widget(dlg, "setdefault"), FALSE);
    gtk_widget_set_sensitive(get_widget(dlg, "addgrp"), FALSE);
    if(row_selected(selec) == -1)
       return;
    nome  = g_build_filename(main_app::TheApp.ConfDir().c_str(), 
           get_selected_file(get_widget(dlg, "groupfiles")), NULL);
    multistringa ms;
    CopiaStringa(ms.file1, MaxLenFilename, nome);
    ms.n1 = (int) strlen(nome);
    setgruppodefault_(&ms);
    ngruppi = ngruppidef_(&displacement);

    if(ngruppi == -2)
       return;

    gruppi = getInfo(nome, 0, 150);
    for(i=1; i< (int) g_list_length(gruppi)-1; i+=2)
    {
        gruppi2[0]  = g_list_append(gruppi2[0], g_list_nth_data(gruppi, i));
        gruppi2[1]  = g_list_append(gruppi2[1], g_list_nth_data(gruppi, i+1));
    }
    populate_listgv(GTK_TREE_VIEW(get_widget(dlg, "groups")), gruppi2, 2, 0, -1);
    gtk_entry_set_text(GTK_ENTRY(get_widget(dlg, "title")), (char *) g_list_nth_data(gruppi, 0));
    gtk_widget_set_sensitive(get_widget(dlg, "setdefault"), TRUE);
    gtk_widget_set_sensitive(get_widget(dlg, "addgrp"), liste->l[14]);
    g_list_free(gruppi);
    g_list_free(gruppi2[0]);
    g_list_free(gruppi2[1]);
}

static void  selected_group (GtkTreeSelection *selec, GtkWidget *dlg)
{
    int nsel;
    gtk_widget_set_sensitive(get_widget(dlg, "delgrp"), FALSE);
    if((nsel = row_selected(selec)) < 0)
       return;
    gtk_widget_set_sensitive(get_widget(dlg, "delgrp"), TRUE);
    CurrentResid = nsel;
    paint(dlg, -1);
}

static void DisplayMessage(GtkWidget *dlg, const char *msg)
{
    GtkWidget *entry = get_widget(dlg, "error");
    gtk_label_set_text(GTK_LABEL(entry), msg);
    gtk_widget_show_all(get_widget(entry, "parent"));
}

static void new_group_file_entry(GtkWidget *window)
{
  GtkWidget *dialog;
  GtkWidget *hbox;
  GtkWidget *hbox1;
  GtkWidget *stock;
  GtkWidget *table;
  GtkWidget *local_entry1;
  GtkWidget *local_entry2;
  GtkWidget *label;
  GtkWidget *button;
  gint response;
  FILE *fp;
  gboolean ok = false;

  dialog = gtk_dialog_new();
  gtk_window_set_title (GTK_WINDOW (dialog), "New Groups File");

  hbox = hbox_new (FALSE, 8);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 8);
  gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG (dialog))), hbox, FALSE, FALSE, 0);

  stock = create_image ("questiondialog.png");
  gtk_box_pack_start (GTK_BOX (hbox), stock, FALSE, FALSE, 0);

  table = table_new (2, 2, FALSE);
  table_set_row_spacings (table, 4);
  table_set_col_spacings (table, 4);
  gtk_box_pack_start (GTK_BOX (hbox), table, TRUE, TRUE, 0);
  label = gtk_label_new_with_mnemonic ("_Filename");
  table_attach (table, label, 0, 1, 0, 1, TRUE);
  local_entry1 = gtk_entry_new ();
  table_attach (table, local_entry1, 1, 2, 0, 1, TRUE);
  gtk_label_set_mnemonic_widget (GTK_LABEL (label), local_entry1);

  label = gtk_label_new_with_mnemonic ("_Header");
  table_attach (table, label, 0, 1, 1, 2, TRUE);

  local_entry2 = gtk_entry_new ();
  table_attach (table, local_entry2, 1, 2, 1, 2, TRUE);
  gtk_label_set_mnemonic_widget (GTK_LABEL (label), local_entry2);
  
  hbox1 = hbox_new (FALSE, 8);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 8);
  gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG (dialog))), hbox1, FALSE, FALSE, 0);

  stock = create_image("error.png");
  gtk_box_pack_start (GTK_BOX (hbox1), stock, FALSE, FALSE, 0);

  label = LABEL_NEW (" ", "red");
  gtk_box_pack_start (GTK_BOX (hbox1), label, FALSE, FALSE, 0);
  g_object_set_data(G_OBJECT(dialog), "error", label);
  g_object_set_data(G_OBJECT(label), "parent", hbox1);

  button = myimage_button("_OK", "ok.png");
  gtk_dialog_add_action_widget (GTK_DIALOG(dialog), button, GTK_RESPONSE_OK);
  button = myimage_button("_Cancel", "cancel.png");
  gtk_dialog_add_action_widget (GTK_DIALOG(dialog), button, GTK_RESPONSE_CANCEL);
  gtk_window_set_transient_for(GTK_WINDOW(dialog), GTK_WINDOW(window));

  gtk_widget_show_all (hbox);
  
  while(!ok)
  {
      response = gtk_dialog_run (GTK_DIALOG (dialog));

      if ((response == GTK_RESPONSE_CANCEL) || (response == GTK_RESPONSE_DELETE_EVENT))
         ok = true;
      else if (response == GTK_RESPONSE_OK)
      {
          char *filename = NULL;
          char *ent = g_new0(char, MaxLenFilename);
          CopiaStringa(ent, MaxLenFilename, gtk_entry_get_text (GTK_ENTRY (local_entry1)));
          if(!str_white(ent))
          {
             if(!strstr(ent, GREXT))
                AppendiStringa(ent, MaxLenFilename, GREXT);
             filename = g_build_filename(main_app::TheApp.ConfDir().c_str(), ent, NULL);
             
             if (g_file_test (filename, G_FILE_TEST_EXISTS))
                 DisplayMessage(dialog, g_strdup_printf("File %s already exists!", filename));
             else
             {
                 if(!str_white(gtk_entry_get_text (GTK_ENTRY (local_entry2))))
                 {
                     fp = fOpen(filename, "w");
                     if(fp)
                     {
                        fprintf(fp, "%s\n", gtk_entry_get_text (GTK_ENTRY (local_entry2)));
                        fprintf(fp, "Z-matrix\n");
                        fclose(fp);
                        gtkext::riempi_listNew(get_widget(window, "groupfiles"));
                        ok = true;
                     }
                     else
                         DisplayMessage(dialog, g_strdup_printf("Open error: file %s ", filename));
                  }
                  else
                     DisplayMessage(dialog, "You should specify a title!");
             }
          }
          else
             DisplayMessage(dialog, "You should specify a filename!");
      }
  }

  gtk_widget_destroy (dialog);
}

static void NewGroupFile(GtkButton *button, GtkWidget *dlg)
{
    GtkWidget *list = get_widget(dlg, "groupfiles");
    gtk_window_set_modal(GTK_WINDOW(dlg), FALSE);
    gtk_widget_set_sensitive(dlg, FALSE);

    new_group_file_entry(dlg);

    gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
    gtk_widget_set_sensitive(dlg, TRUE);
    gtkext::check_default(list, main_app::TheApp.GroupsFile().c_str());
}

static void SetDefaultGroupFile(GtkButton *button, GtkWidget *dlg)
{
    GtkWidget *list = get_widget(dlg, "groupfiles");
    char *nome = NULL;

    if(row_selected(gtk_tree_view_get_selection(GTK_TREE_VIEW(list))) == -1)
       return;
    nome  = g_build_filename(main_app::TheApp.ConfDir().c_str(), get_selected_file(list), NULL);
    gtkext::change_default(list);
    main_app::TheApp.UpdateGrf(nome);
    multistringa ms;
    CopiaStringa(ms.file1, MaxLenFilename, nome);
    ms.n1 = (int) strlen(nome);
    setgruppodefault_(&ms);
}

static void DeleteGroup(GtkButton *button, GtkWidget *dlg)
{
    GtkWidget *list = get_widget(dlg, "groups");
    GtkTreeSelection *selec = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
    char *gruppo = get_selected_row(list);
    char *grfile = get_selected_file(get_widget(dlg, "groupfiles"));
    if((gruppo != NULL) && (grfile != NULL))
    {
        multistringa ms;
        CopiaStringa(ms.file1, MaxLenFilename, grfile);
        ms.n1 = (int) strlen(grfile);
        CopiaStringa(ms.file2, MaxLenFilename, gruppo);
        ms.n2 = (int) strlen(gruppo);
        cancellagruppo_(&ms);
    }
    show_groups(selec, dlg);
}

static void restore_images(GtkWidget *list)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    PixText *info;
    gpointer data;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
    GtkWidget *dlg = gtk_widget_get_toplevel(list);

    list_store = GTK_LIST_STORE(model);
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    while (valid)
    {
       gtk_tree_model_get (model, &iter, 0, &data, -1);
       info = (PixText *) data;
       if( info->icon == gtkext::get_pixbuf(dlg,'O'))
          info->icon = gtkext::get_pixbuf(dlg,'C');
       else if( info->icon == gtkext::get_pixbuf(dlg,'A'))
          info->icon = gtkext::get_pixbuf(dlg,'D');
       gtk_list_store_set (list_store, &iter, 0, (gpointer) info,-1);
       valid = gtk_tree_model_iter_next (model, &iter);
    }
}

static void new_group_entry(GtkWidget *window)
{
  GtkWidget *dialog;
  GtkWidget *hbox;
  GtkWidget *hbox1;
  GtkWidget *stock;
  GtkWidget *table;
  GtkWidget *local_entry1;
  GtkWidget *local_entry2;
  GtkWidget *label;
  GtkWidget *button;
  gint response;
  gboolean ok = false;
  char *grname = g_new0(char, 22);

  dialog = gtk_dialog_new();
  gtk_window_set_title (GTK_WINDOW (dialog), "Add Group");

  hbox = hbox_new (FALSE, 8);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 8);
  gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG (dialog))), hbox, FALSE, FALSE, 0);

  stock = create_image ("questiondialog.png");
  gtk_box_pack_start (GTK_BOX (hbox), stock, FALSE, FALSE, 0);

  table = table_new (2, 2, FALSE);
  table_set_row_spacings (table, 4);
  table_set_col_spacings (table, 4);
  gtk_box_pack_start (GTK_BOX (hbox), table, TRUE, TRUE, 0);
  label = gtk_label_new_with_mnemonic ("_Group Name");
  table_attach (table, label, 0, 1, 0, 1, TRUE);
  local_entry1 = gtk_entry_new ();
  table_attach (table, local_entry1, 1, 2, 0, 1, TRUE);
  gtk_label_set_mnemonic_widget (GTK_LABEL (label), local_entry1);

  label = gtk_label_new_with_mnemonic ("_Code (max 4 chars)");
  table_attach (table, label, 0, 1, 1, 2, TRUE);

  local_entry2 = gtk_entry_new ();
  table_attach (table, local_entry2, 1, 2, 1, 2, TRUE);
  gtk_label_set_mnemonic_widget (GTK_LABEL (label), local_entry2);
  gtk_entry_set_max_length(GTK_ENTRY(local_entry2), 4);
  
  hbox1 = hbox_new (FALSE, 8);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 8);
  gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG (dialog))), hbox1, FALSE, FALSE, 0);

  stock = create_image("error.png");
  gtk_box_pack_start (GTK_BOX (hbox1), stock, FALSE, FALSE, 0);

  label = LABEL_NEW (" ", "red");
  gtk_box_pack_start (GTK_BOX (hbox1), label, FALSE, FALSE, 0);
  g_object_set_data(G_OBJECT(dialog), "error", label);
  g_object_set_data(G_OBJECT(label), "parent", hbox1);

  button = myimage_button("_OK", "ok.png");
  gtk_dialog_add_action_widget (GTK_DIALOG(dialog), button, GTK_RESPONSE_OK);
  button = myimage_button("_Cancel", "cancel.png");
  gtk_dialog_add_action_widget (GTK_DIALOG(dialog), button, GTK_RESPONSE_CANCEL);
  gtk_window_set_transient_for(GTK_WINDOW(dialog), GTK_WINDOW(window));

  gtk_widget_show_all (hbox);
  
  while(!ok)
  {
      response = gtk_dialog_run (GTK_DIALOG (dialog));

      if ((response == GTK_RESPONSE_CANCEL) || (response == GTK_RESPONSE_DELETE_EVENT))
         ok = true;
      else if (response == GTK_RESPONSE_OK)
      {
          char *ent = g_new0(char, MaxLenFilename);
          CopiaStringa(ent, MaxLenFilename, gtk_entry_get_text (GTK_ENTRY (local_entry1)));
          if(!str_white(ent))
          {
             if(find_elem_in_list(get_widget(window, "groups"), ent, 1))
                 DisplayMessage(dialog, g_strdup_printf("Group %s already exists!", ent));
             else
             {
                 CopiaStringa(grname, 22, ent);
                 CopiaStringa(ent, MaxLenFilename, gtk_entry_get_text (GTK_ENTRY (local_entry2)));
                 if(!str_white(ent))
                 {
                     if(find_elem_in_list(get_widget(window, "groups"), ent, 0))
                        DisplayMessage(dialog, g_strdup_printf("Code %s already exists!", ent));
                     else
                     {
                         char *grfile = get_selected_file(get_widget(window, "groupfiles"));
                         multistringa ms;
                         CopiaStringa(ms.file1, MaxLenFilename, grfile);
                         ms.n1 = (int) strlen(grfile);
                         CopiaStringa(ms.file2, MaxLenFilename, grname);
                         ms.n2 = (int) strlen(grname);
                         CopiaStringa(ms.file3, MaxLenFilename, ent);
                         ms.n3 = (int) strlen(ent);
                         aggiungigruppo_(&ms);
                         ok = TRUE;
                     }
                 }
                 else
                    DisplayMessage(dialog, "You should specify a code!");
             }
          }
          else
             DisplayMessage(dialog, "You should specify a group name!");
      }
  }

  gtk_widget_destroy (dialog);
}

static void AddGroup(GtkButton *button, GtkWidget *dlg)
{
    GtkWidget *list = get_widget(dlg, "groupfiles");
    GtkTreeSelection *selec = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
    gtk_window_set_modal(GTK_WINDOW(dlg), FALSE);
    gtk_widget_set_sensitive(dlg, FALSE);

    new_group_entry(dlg);

    gtk_window_set_modal(GTK_WINDOW(dlg), TRUE);
    gtk_widget_set_sensitive(dlg, TRUE);
    show_groups(selec, dlg);
}

static gboolean DNDMotionCB(GtkWidget *widget, GdkDragContext *dc,
                            gint x, gint y, guint time, gpointer data)
{
        GtkTreeViewColumn *column;
        GtkTreePath *path;
        GdkDragAction suggested_action = (GdkDragAction) 0;
        GtkWidget *dlg = gtk_widget_get_toplevel(widget);

        if((widget == NULL) || (dc == NULL))
           return FALSE;
        if(!gtk_tree_view_get_path_at_pos(GTK_TREE_VIEW(widget), x, y, &path, &column, NULL, NULL))
        {
           gdk_drag_status(dc, suggested_action, time);
           return FALSE;
        }
        GtkTreeModel *model = gtk_tree_view_get_model (GTK_TREE_VIEW(widget));
        GtkTreeIter iter;
        gpointer ddata;

        gtk_tree_model_get_iter (model, &iter, path);
        gtk_tree_model_get (model, &iter, 0, &ddata, -1);
        char *dest_file =  ((PixText *)ddata)->text;
        char *src_file = get_selected_file(widget);
        if(strcmp(src_file, dest_file) == 0)
        {
           gdk_drag_status(dc, suggested_action, time);
           return FALSE;
        }
        restore_images(widget);
        if(((PixText *)ddata)->icon == gtkext::get_pixbuf(dlg,'C') )
            ((PixText *)ddata)->icon = gtkext::get_pixbuf(dlg,'O');
        else if(((PixText *)ddata)->icon == gtkext::get_pixbuf(dlg,'D') )
            ((PixText *)ddata)->icon = gtkext::get_pixbuf(dlg,'A');
        gtk_list_store_set (GTK_LIST_STORE(model), &iter, 0, ddata, -1);
        return TRUE;
}

static gboolean DNDDropCB(GtkWidget *widget, GdkDragContext *dc,
                            gint x, gint y, guint time, gpointer data)
{
        GtkTreeViewColumn *column;
        GtkTreePath *path;
        GtkWidget *dlg = gtk_widget_get_toplevel(widget);

        if((widget == NULL) || (dc == NULL))
           return FALSE;
        if(!gtk_tree_view_get_path_at_pos(GTK_TREE_VIEW(widget), x, y, &path, &column, NULL, NULL))
           return FALSE;
        GtkTreeModel *model = gtk_tree_view_get_model (GTK_TREE_VIEW(widget));
        GtkTreeIter iter;
        gpointer ddata;
                                                                                                         
        gtk_tree_model_get_iter (model, &iter, path);
        gtk_tree_model_get (model, &iter, 0, &ddata, -1);
        if(((PixText *)ddata)->icon == gtkext::get_pixbuf(dlg,'O') )
            ((PixText *)ddata)->icon = gtkext::get_pixbuf(dlg,'C');
        else if(((PixText *)ddata)->icon == gtkext::get_pixbuf(dlg,'A') )
            ((PixText *)ddata)->icon = gtkext::get_pixbuf(dlg,'D');
        gtk_list_store_set (GTK_LIST_STORE(model), &iter, 0, ddata, -1);
        return TRUE;
}

static void  DNDLeaveCB(GtkWidget *widget, GdkDragContext *dc, guint time, gpointer data)
{
        if((widget == NULL) || (dc == NULL))
           return;
        restore_images(widget);
}

static void DNDDataGetCB  (GtkWidget *widget, GdkDragContext *dc,
                       GtkSelectionData   *selection_data,
                       guint info, guint time, gpointer data)
{
    char *groupcode;
    if((widget == NULL) || (dc == NULL))
       return;
    if((groupcode = (char *)get_selected_row_col(widget, 0)) == NULL)
       return;

    gtk_selection_data_set_text (selection_data,
                            groupcode, (int) strlen(groupcode));
}

static void DNDDataReceivedCB( GtkWidget *widget, GdkDragContext *dc,
        gint x, gint y, GtkSelectionData *selection_data,
        guint info, guint t, gpointer data)
{
        GtkTreePath *path;
        GtkTreeViewColumn *column;

        if((widget == NULL) || (dc == NULL))
           return;
        if(selection_data == NULL)
           return;
//        if(selection_data->length < 0)
//           return;
        if(!gtk_tree_view_get_path_at_pos(GTK_TREE_VIEW(widget), x, y, &path, &column, NULL, NULL))
           return;

        GtkTreeModel *model = gtk_tree_view_get_model (GTK_TREE_VIEW(widget));
        GtkTreeIter iter;
        gpointer ddata;

        gtk_tree_model_get_iter (model, &iter, path);
        gtk_tree_model_get (model, &iter, 0, &ddata, -1);
        char *dest_file =  ((PixText *)ddata)->text;
        char *src_file = get_selected_file(widget);
        if(strcmp(src_file, dest_file) == 0)
           return;
        char *gruppo = (char *)gtk_selection_data_get_text(selection_data);
        int ier = 0;
        multistringa ms;
        CopiaStringa(ms.file1, MaxLenFilename, src_file);
        ms.n1 = (int) strlen(src_file);
        CopiaStringa(ms.file2, MaxLenFilename, dest_file);
        ms.n2 = (int) strlen(dest_file);
        CopiaStringa(ms.file3, MaxLenFilename, gruppo);
        ms.n3 = (int) strlen(gruppo);
       copiagruppo_(&ms, &ier);
       if(ier)
          MessageDialog(gtk_widget_get_toplevel(widget), GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, 
              "Group %s already stored in \n%s file !!!", gruppo, dest_file);
}

static void DNDBeginCB(GtkWidget *widget, GdkDragContext *dc, gpointer data)
{
    char *groupcode = (char *) get_selected_row_col(widget, 0);

    if(dc == NULL)
       return;

    GdkPixbuf *dest = pix_from_file_and_text("file.png", groupcode,
             fontdescU, 1, 12, &colorRed, widget);
    GdkPixbuf *dest1 = gdk_pixbuf_add_alpha(dest, TRUE, 0, 0, 0);
    if(dest1 != NULL)
    {
        gtk_drag_source_set_icon_pixbuf(widget, dest1);
        g_object_unref(G_OBJECT(dest));
    }
}

GtkWidget *create_groupmgr()
{
    GtkWidget *dlg, *align, *button, *hbox, *hpaned, *vbox, *frame, *lista;
    GtkWidget *label, *draw;
    const char *titles[] = { "Code    ","Group Name  "};
 
    dlg = gtk_dialog_new();
    gtk_window_set_title (GTK_WINDOW (dlg), "Group Manager");
    gtk_widget_set_size_request(dlg, 680, 350);
    gtk_container_set_border_width (GTK_CONTAINER (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), 8);
    hpaned = hbox_new(FALSE, 0);
    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), hpaned, TRUE, TRUE, 0);
    gtk_widget_show(hpaned);
    gtk_container_set_border_width (GTK_CONTAINER (hpaned), 8);
    
    frame = FRAME_BOLD ("Rigid body filename", "blue", 1.1f);
    gtk_frame_set_shadow_type (GTK_FRAME(frame), GTK_SHADOW_IN);
    gtk_box_pack_start (GTK_BOX (hpaned), frame, TRUE, TRUE, 0);
    gtk_widget_show(frame);
    vbox = vbox_new(FALSE, 0);
    gtk_container_set_border_width(GTK_CONTAINER(vbox), 8);
    gtk_container_add (GTK_CONTAINER (frame), vbox);
#ifdef IN_GTK3
    frame = new_alignment(GTK_ALIGN_FILL, GTK_ALIGN_FILL, TRUE, TRUE);
#else
    frame = gtk_alignment_new(0, 0, 1, 1);
#endif
    gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
    lista = createSelection(dlg, frame, NULL, "groupfiles", 3, NULL);
    set_widget_fontN(lista);
    g_object_set_data(G_OBJECT(lista), "filtro", (gpointer) GREXT);
    g_signal_connect(G_OBJECT(gtk_tree_view_get_selection (GTK_TREE_VIEW (lista))),
        "changed", G_CALLBACK(show_groups), dlg);
    gtk_drag_dest_set (lista, GTK_DEST_DEFAULT_ALL, target_table, n_targets,
                       (GdkDragAction) GDK_ACTION_COPY );
    g_signal_connect (lista, "drag_data_received", G_CALLBACK( DNDDataReceivedCB), NULL);

    g_signal_connect (lista, "drag_leave", G_CALLBACK (DNDLeaveCB), NULL);
                                                                                                        
    g_signal_connect (lista, "drag_motion", G_CALLBACK (DNDMotionCB), dlg);
                                                                                                        
    g_signal_connect (lista, "drag_drop", G_CALLBACK (DNDDropCB), dlg);

#ifdef IN_GTK3
    align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_END, FALSE, FALSE);
#else
    align = gtk_alignment_new(0.5f, 1.f, 0, 0);
#endif
    gtk_box_pack_end (GTK_BOX (vbox), align, FALSE, FALSE, 0);
    hbox = hbox_new(TRUE, 0);
    gtk_container_add(GTK_CONTAINER(align), hbox);
    button = myimage_button("   _New File", "new.png");
    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 4);
    g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(NewGroupFile), dlg);
    button = myimage_button("   _Set Default", "setdefault.png");
    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 4);
    g_object_set_data(G_OBJECT(dlg), "setdefault", button);
    g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(SetDefaultGroupFile), dlg);
    gtk_widget_set_sensitive(button, FALSE);
    gtk_widget_show_all(vbox);

    frame = FRAME_BOLD ("Content", "blue", 1.1f);
    gtk_frame_set_shadow_type (GTK_FRAME(frame), GTK_SHADOW_IN);
    gtk_box_pack_start (GTK_BOX (hpaned), frame, TRUE, TRUE, 0);
    gtk_widget_show(frame);
    vbox = vbox_new(FALSE, 0);
    gtk_container_add (GTK_CONTAINER (frame), vbox);
    gtk_container_set_border_width(GTK_CONTAINER(vbox), 8);
    label = LABEL_NEW("Group File Header", "blue");
    gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 4);
    gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
    set_alignment(label, 0.,0.);
    label = gtk_entry_new();
    gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 4);
    g_object_set_data(G_OBJECT(dlg), "title", label);
    gtk_editable_set_editable(GTK_EDITABLE(label), FALSE);

    frame = FRAME_NEW("Groups", "blue");
    gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 4);
    lista = createSelectionM(dlg, frame, titles, "groups", 2, "blue");
    g_object_set_data(G_OBJECT(lista), "formato", GINT_TO_POINTER(4));
    set_widget_fontN(lista);
    g_signal_connect(G_OBJECT(gtk_tree_view_get_selection (GTK_TREE_VIEW (lista))),
        "changed", G_CALLBACK(selected_group), dlg);
    gtk_drag_source_set (lista, GDK_BUTTON1_MASK,
                       target_table, n_targets,
                       (GdkDragAction) GDK_ACTION_COPY );
    g_signal_connect (lista, "drag_data_get",
                    G_CALLBACK (DNDDataGetCB), NULL);
    g_signal_connect (lista, "drag_begin",
                    G_CALLBACK(DNDBeginCB), dlg);

#ifdef IN_GTK3
    align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_END, FALSE, FALSE);
#else
    align = gtk_alignment_new(0.5f, 1.f, 0, 0);
#endif
    gtk_box_pack_end (GTK_BOX (vbox), align, FALSE, FALSE, 0);
    hbox = hbox_new(TRUE, 0);
    gtk_container_add(GTK_CONTAINER(align), hbox);
    button = myimage_button("_Add group", "addgrp.png");
    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 4);
    g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(AddGroup), dlg);
    g_object_set_data(G_OBJECT(dlg), "addgrp", button);
    gtk_widget_set_sensitive(button, FALSE);
    button = myimage_button("_Delete group", "delgrp.png");
    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 4);
    g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(DeleteGroup), dlg);
    g_object_set_data(G_OBJECT(dlg), "delgrp", button);
    gtk_widget_set_sensitive(button, FALSE);
    gtk_widget_show_all(vbox);

    frame = FRAME_BOLD ("Preview", "blue", 1.1f);
    gtk_frame_set_shadow_type (GTK_FRAME(frame), GTK_SHADOW_IN);
    gtk_box_pack_start (GTK_BOX (hpaned), frame, TRUE, TRUE, 0);
    gtk_widget_show(frame);
    vbox = vbox_new(FALSE, 0);
    gtk_container_add (GTK_CONTAINER (frame), vbox);
    gtk_container_set_border_width(GTK_CONTAINER(vbox), 8);
    label = gtk_label_new(NULL);
    gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 10);
    gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);
    set_alignment(label, 0.5f, 0);
    g_object_set_data(G_OBJECT(dlg), "inte", label);
    gtk_widget_set_size_request(label, 150, 70);
    gtk_label_set_line_wrap(GTK_LABEL(label), TRUE);
    frame = gtk_frame_new (NULL);
    gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
#ifdef IN_GTK3
    align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, FALSE, FALSE);
#else
    align = gtk_alignment_new(0.5, 0.5, 0, 0);
#endif
    gtk_container_add(GTK_CONTAINER(frame), align);
    draw = gtk_drawing_area_new();
    gtk_container_add(GTK_CONTAINER(align), draw);
    gtk_widget_set_size_request(draw, 150, 150);
    set_widget_color(draw, main_app::TheApp.colorPalette[0]);
    g_object_set_data(G_OBJECT(dlg), "drawarea", draw);
    gtk_widget_show_all(vbox);
    (void) g_signal_connect (G_OBJECT (draw), DRAW_EVENT,
                      G_CALLBACK (on_expose), GINT_TO_POINTER(-1));

    button = HELP_button();
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_HELP);

    button = myimage_button("_Exit", "stop.png");
    gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL);
    return dlg;    
}

void open_groupmgr(GtkWidget *item, gpointer data)
{
    GtkWidget *lista;
    int ngruppi, displacement = 0;

    ngruppi = ngruppidef_(&displacement);
    if(ngruppi == -2)
       return;

    (void) dir_set_current(main_app::TheApp.ConfDir().c_str());

    can_drag = FALSE;
    CurrentResid = -1;
    if(GroupMgr_dlg == NULL)
       GroupMgr_dlg = create_groupmgr();

    lista = get_widget(GroupMgr_dlg, "groupfiles");
    gtk_widget_show_all(GroupMgr_dlg);
    gtkext::riempi_listNew(lista);
    gtkext::check_default(lista, main_app::TheApp.GroupsFile().c_str());
    gtk_window_set_transient_for(GTK_WINDOW(GroupMgr_dlg), GTK_WINDOW(finestre[0]));
    setSmiley(finestre[0], "smil5.gif");
    gtk_widget_set_sensitive(finestre[0], FALSE);
    gtk_widget_set_sensitive(get_widget(GroupMgr_dlg, "addgrp"), liste->l[14]);

    int result = GTK_RESPONSE_OK;
    while(result != GTK_RESPONSE_CANCEL)
    {
        result = gtk_dialog_run(GTK_DIALOG(GroupMgr_dlg));
        if(result == GTK_RESPONSE_HELP)  
           open_htm("Refine.html#manager");
    }
    gtk_widget_hide(GroupMgr_dlg);
    resetSmiley(finestre[0]);
    gtk_widget_set_sensitive(finestre[0], TRUE);
}

void toggle_drawgr(GtkWidget *item, gpointer data)
{
   int ier = 0;
   int ambiente = GPOINTER_TO_INT(data);

   drawgroups_(&ier, &ambiente);
   aggiornatasto2("DrawGrOn", dialogo->ifDrawGroups);
   aggiornatasto2("GrOn", dialogo->ifDrawGroups);
}
#endif

void ChangeFonts(gpointer gp)
{
   Settings *info = (Settings *) gp;
   switch(info->whichFont)
   {
   case 0:
        main_app::TheApp.SetFont('P', info->fontname);
        set_font('P');
        break;
   case 1:
        main_app::TheApp.SetFont('N', info->fontname);
        set_font('N');
        break;
   case 2:
        main_app::TheApp.SetFont('U', info->fontname);
        set_font('U');
        break;
   }
}

#ifdef COLORSET
void ChangeColors(gpointer gp)
{
   Settings *info = (Settings *) gp;
   int i, j;

   for(j=0; j<16; j++)
       main_app::TheApp.pal_colors[j] = info->BaseColors[j];
   for(i=0; i<N_OBJS; i++)
   {
       float *c = ToColor3f(&(info->colori[i]));
       main_app::TheApp.putfCol(i, c);
   }
   for(i=0; i<nSpec; i++)
   {
       float *c = ToColor3f(&(info->colori[i+N_OBJS]));
       main_app::TheApp.putfCol(no[i]+N_OBJS-1, c);
   }

   i = 2;
   UpdateColors(i);
}

void Disegna(gpointer data1, gpointer data2, gpointer data3)
{ 
    GtkWidget *drawable = (GtkWidget *) data1;
    Settings *info = (Settings *) data3;
    GdkPoint punti[3] = { {70, 81}, {63, 126}, {118, 70}};
    GdkWindow *gdkwindow = gtk_widget_get_window(drawable);
    if(gdkwindow)
    {
        PangoFontDescription *font_desc = DefaultFont();
           // draw cell 
        set_foreground(data2, &info->colori[info->indcolor[CELLC]]);

        draw_line(gdkwindow, data2, 70,  3,  70,  40);
        draw_line(gdkwindow, data2, 70, 40,   3,  97);
        draw_line(gdkwindow, data2, 70, 40, 214, 172);

           // draw bonds 

        (void) draw_bonds (166, 57, 73, 84,5., data2, 
                 gdkwindow, info->indcolor[BONDS], info->colori);
        (void) draw_bonds (73, 84, 51, 180, 5., data2, 
                 gdkwindow, info->indcolor[BONDS], info->colori);

           // draw atoms 

        int ispec = 0;
        palla_sfumata_java (166, 57, 15, info->indcolor[ispec+N_OBJS],
                         4, data2, gdkwindow, info->colori, 1);
        ispec++;
        if(ispec >= nSpec)
           ispec--;
        palla_sfumata_java (73, 84, 15, info->indcolor[ispec+N_OBJS],
                         4, data2, gdkwindow, info->colori, 1);
        ispec++;
        if(ispec >= nSpec)
           ispec--;
        palla_sfumata_java (51, 180, 15, info->indcolor[ispec+N_OBJS],
                         4, data2, gdkwindow, info->colori, 1);

           // draw ghosts 

        palla_sfumata_java (141, 142, 8, info->indcolor[GHOST], 2, data2,
                       gdkwindow, info->colori, 1);
        setta_foreground(info->indcolor[0], data2);
        draw_circle(gdkwindow, data2, TRUE, 138, 139, 6);

           // draw labels 

        draw_string( gdkwindow, font_desc, data2,
                    185, 57, "At12", &info->colori[info->indcolor[LABS]], NULL);
        draw_string( gdkwindow, font_desc, data2,
                     24, 84, "At13", &info->colori[info->indcolor[LABS]], NULL);
        draw_string( gdkwindow, font_desc, data2,
                     81, 180, "At10", &info->colori[info->indcolor[LABS]], NULL);
        draw_string( gdkwindow, font_desc, data2,
                    160, 142, "Q1", &info->colori[info->indcolor[LABS]], NULL);

           // draw restraints 

        set_foreground(data2, &info->colori[info->indcolor[RESTR]]);
        draw_polygon( gdkwindow, data2, FALSE, punti, 3);
    }
}
#endif

void open_fcolors(GtkWidget *item, gpointer data)
{
   _SettingsInfo info;
   int i;

   info.pkgnam       = DuplicaStringa(MR_PACKAGE);
   info.AppFont      = DuplicaStringa(main_app::TheApp.FontU().c_str());
   info.PropFont     = DuplicaStringa(main_app::TheApp.FontP().c_str());
   info.FixedFont    = DuplicaStringa(main_app::TheApp.FontN().c_str());
   info.bg           = dialogo->jBackGround;
   info.cbFonts      = ChangeFonts;
#ifdef COLORSET
   info.cbColors     = ChangeColors;
   info.cbDraw       = Disegna;
#endif
   info.nSpec        = 0;  //nSpec;
   info.maxspecies   = NUMSPECIES;
   memset(info.nat, 0, NUMSPECIES*sizeof(int));
   for(i=0; i< nSpec; i++)
       info.nat[i] = no[i];
   memset(info.indcolor, 0, 50*sizeof(int));
   for(i=0; i<N_OBJS + nSpec; i++)
       info.indcolor[i] = i;
   
   for(i=0; i<num_el(altri)+2; i++)
   {
       float *c = main_app::TheApp.getfCol(i);
       GdkColor *c1 = ToGdkColor(c);
       info.colorb[i] =*c1;
   }
   for(i=0; i<nSpec; i++)
   {
       float *c = main_app::TheApp.getfCol(no[i]+N_OBJS-1);
       GdkColor *c1 = ToGdkColor(c);
       info.colorb[i+N_OBJS] =*c1;
   }
   info.oggetti.clear();

   _Oggetti ogg;
   for(i=0; i<num_el(altri); i++)
   {
       ogg.label = altri[i];
       ogg.indc = i + 2;
       info.oggetti.push_back(ogg);
   }
   for(i=0; i<nSpec; i++)
   {
       ogg.label = Specie[i];
       ogg.indc = i + N_OBJS;
       info.oggetti.push_back(ogg);
   }

   open_settings_notebook(finestre[0], &info, main_app::TheApp.pal_colors);
}

#ifdef COLORSET
static GtkWidget *pkC = NULL;
static GtkWidget *polycol_dlg = NULL;
static int polycol[10];
static int ind_poly = -1;
static int ind_atom = -1;
static int nSites;

void peek_col (GtkToggleButton *button, gpointer data) 
{   
    int ipos;
    GtkWidget *frame, *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));

    frame = (GtkWidget *) data;
    if(gtk_toggle_button_get_active(button))
    {
       ToggleButtons(dlg, get_int(GTK_WIDGET(button), "id"));
       gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_IN);
       ipos = get_int(GTK_WIDGET(button),"id");
       frame = get_widget(GTK_WIDGET(button), "father");
       g_object_set_data(G_OBJECT(frame), "scelta", GINT_TO_POINTER(ipos)); 
    }
}

void peek_polycol (GtkToggleButton *button, gpointer data) 
{   
    GtkWidget *frame, *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
    int ipos;

    frame = (GtkWidget *) data;
    if(gtk_toggle_button_get_active(button))
    {
       ToggleButtons(dlg, get_int(GTK_WIDGET(button), "id"));
       gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_IN);
       ipos = get_int(GTK_WIDGET(button),"id");
       frame = get_widget(GTK_WIDGET(button), "father");
       g_object_set_data(G_OBJECT(frame), "scelta", GINT_TO_POINTER(ipos)); 
       if(ind_poly >= 0)
          polycol[ind_poly] = ipos;
    }
}

static void  pc_select (GtkTreeSelection *list, gpointer data)
{
   GtkToggleButton *togbut;
   char num[3];
   int row;

/* row indica il numero d'ordine nella lista                 */

   row = row_selected(list);
   if(row != -1)
   {
      if(row < nSites)       // selezionato un sito
      {
         ind_poly = row;
         ScriviStringa(num, sizeof(num), "%d", polycol[ind_poly]);
         ind_atom = -1;
      }
      togbut = GTK_TOGGLE_BUTTON(get_widget(polycol_dlg, num));
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(togbut), TRUE);
   }
}



GtkWidget *create_peek_color_dialog(int type)
{
  GtkWidget *window, *frame ,*button, *box, *gtklist;
  GtkTreeSelection *selec;

  window = gtk_dialog_new ();
 
  gtk_window_set_position (GTK_WINDOW(window), GTK_WIN_POS_CENTER_ON_PARENT);
  gtk_window_set_title (GTK_WINDOW (window), "Select new color");
  gtk_container_set_border_width (GTK_CONTAINER (window), 4);
 
  if(type == 0)
  {
     box = gtk_dialog_get_content_area(GTK_DIALOG(window));
     frame = create_frame_colors(window, G_CALLBACK(peek_col));
  }
  else if(type == 1)
  {
     box = hbox_new(TRUE, 0);
     gtk_widget_show(box);
     gtk_container_add(GTK_CONTAINER( gtk_dialog_get_content_area(GTK_DIALOG(window))), box);
     frame = create_frame_colors(window, G_CALLBACK(peek_polycol));
  }

  gtk_widget_show(frame);
  gtk_container_add(GTK_CONTAINER(box), frame);
  g_object_set_data(G_OBJECT(window), "framecolors", frame); 

  if(type == 1)
  {
     frame = gtk_frame_new ("Objects");
     gtk_container_set_border_width(GTK_CONTAINER(frame), 4);
     gtk_widget_show (frame);
     gtk_container_add (GTK_CONTAINER (box), frame);
     gtklist = createSelection(window, frame, NULL, "lista", 0, "red");
     set_selection_mode(gtklist, GTK_SELECTION_SINGLE);
     selec = gtk_tree_view_get_selection(GTK_TREE_VIEW(gtklist));
    (void) g_signal_connect(G_OBJECT(selec), "changed", 
                      G_CALLBACK(pc_select), NULL);

  }


  button = myimage_button("   _OK", "ok.png");
  gtk_dialog_add_action_widget(GTK_DIALOG(window), button, GTK_RESPONSE_OK);

  if(type == 0)
  {
     button = myimage_button("  _Reset", "reset.png");
     gtk_dialog_add_action_widget(GTK_DIALOG(window), button, 100);
  }

  button = myimage_button("  _Cancel", "cancel.png");
  gtk_dialog_add_action_widget(GTK_DIALOG(window), button, GTK_RESPONSE_CANCEL);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)), 
        GTK_BUTTONBOX_SPREAD);

  return window;
}

void open_peek_color_dialog(int *icolor)
{
   int result, scelta;

   pkC = NULL;
   if(pkC == NULL)
      pkC = create_peek_color_dialog(0);

   GtkWidget *frame = get_widget(pkC, "framecolors");
   g_object_set_data(G_OBJECT(frame), "scelta", GINT_TO_POINTER(-1)); 
   UpdateFrameColors(pkC, main_app::TheApp.colorPalette);
   ToggleButtons(pkC, -1);
   setSmiley(finestre[0], "smil5.gif");
   gtk_widget_set_sensitive(finestre[0], FALSE);
   result = gtk_dialog_run(GTK_DIALOG(pkC));
   gtk_widget_hide(pkC);
   gtk_widget_set_sensitive(finestre[0], TRUE);
   switch (result)
   {
   case GTK_RESPONSE_CANCEL:
   case GTK_RESPONSE_DELETE_EVENT:
   default:
       scelta = -1;
       break;
   case 100:
       scelta = -2;
       break;
   case GTK_RESPONSE_OK:
       scelta = get_int(frame, "scelta") + N_OBJS + NUM_COLORS; //N_ELEMENTS;
       break;
   }
   *icolor = scelta;
   resetSmiley(finestre[0]);
}

extern "C" void c_peek_color_(int *ncol, int *ifreset)
{
   if(!jscreen)
     return;
   *ifreset = 0;
   open_peek_color_dialog(ncol);
   if(*ncol == -2)                             /* Reset Color */
        *ifreset = 1;
}

int open_polycol_dlg(int nsites, char *sites[], int pcolors[])
{
   int i, result, scelta;
   GtkWidget *gtklist;
 
   for(i=0; i<10; i++)
       polycol[i] = pcolors[i];
   polycol_dlg = NULL;
   if(polycol_dlg == NULL)
      polycol_dlg = create_peek_color_dialog(1);
   gtklist = get_widget(polycol_dlg, "lista");
   nSites = nsites;
   populate_list(GTK_TREE_VIEW(gtklist), sites, nSites, 1);
   ind_poly = 0;
   GtkWidget *frame = get_widget(polycol_dlg, "framecolors");
   g_object_set_data(G_OBJECT(frame), "scelta", GINT_TO_POINTER(-1)); 
   ToggleButtons(polycol_dlg, -1);
   UpdateFrameColors(polycol_dlg, main_app::TheApp.colorPalette);
   setSmiley(finestre[0], "smil5.gif");
   result = gtk_dialog_run(GTK_DIALOG(polycol_dlg));
   gtk_widget_hide(polycol_dlg);
   switch(result)
   {
   case GTK_RESPONSE_CANCEL:
   case GTK_RESPONSE_DELETE_EVENT:
   default:
       scelta = -1;
       break;
   case GTK_RESPONSE_OK:
       scelta = get_int(frame, "scelta") + N_OBJS + NUM_COLORS; //N_ELEMENTS;
       break;
   }
   resetSmiley(finestre[0]);

   if(scelta != -1)
   {
       for(i=0; i<10; i++)
           pcolors[i] = polycol[i];
       i = 0;
       UpdateColors( i);
       return 0;
   }
   return 1;
}
#endif

extern "C" void c_peek_color_(int *ncol, int *ifreset)
{
}

static void fixed_toggled(GtkCellRendererToggle *cell, gchar *path_str, gpointer data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreeIter  iter;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
  gboolean fixed;
                                                                                
  gtk_tree_model_get_iter (model, &iter, path);
  gtk_tree_model_get (model, &iter, 1, &fixed, -1);
                                                                                
  fixed ^= 1;
  gtk_list_store_set (GTK_LIST_STORE (model), &iter, 1, fixed, -1);
  gtk_tree_path_free (path);
}

GtkWidget *createHideShow()
{
    GtkWidget *dialog, *button, *frame, *scrollwin, *hbox, *radio, *list;
    GtkListStore *store;
    GtkCellRenderer *renderer;
    GtkTreeViewColumn *column;
    GSList *group = NULL;

    dialog = gtk_dialog_new();
    gtk_window_set_title (GTK_WINDOW (dialog), "HIDE/SHOW Species");
    gtk_container_set_border_width (GTK_CONTAINER (dialog), 4);
    gtk_widget_set_size_request(dialog, 250, 350);
 
    frame = gtk_frame_new(NULL);
    gtk_box_pack_start(GTK_BOX(gtk_dialog_get_content_area(GTK_DIALOG(dialog))), frame, FALSE, FALSE, 2);
    hbox = hbox_new(TRUE, 0);
    gtk_container_add(GTK_CONTAINER(frame), hbox);
    gtk_container_set_border_width (GTK_CONTAINER (hbox), 4);

    radio = RADIO_BUTTON_WITH_LABEL(group, "Hide", "blue");
    gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 6);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(dialog), "hide", radio); 
    radio = RADIO_BUTTON_WITH_LABEL(group, "Show", "blue");
    gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 6);
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    g_object_set_data(G_OBJECT(dialog), "show", radio); 

    frame = gtk_frame_new(NULL);
    gtk_box_pack_start(GTK_BOX(gtk_dialog_get_content_area(GTK_DIALOG(dialog))), frame, TRUE, TRUE, 2);
    scrollwin = gtk_scrolled_window_new (NULL, NULL);
    gtk_container_add(GTK_CONTAINER(frame), scrollwin);
                                                                                                        
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                   GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
    list = gtk_tree_view_new();
    g_object_set_data(G_OBJECT(list), "frame", frame);
    g_object_set_data(G_OBJECT(list), "scrollwin", scrollwin);
    g_object_set_data(G_OBJECT(list), "formato", GINT_TO_POINTER(2));
    g_object_set_data(G_OBJECT(dialog), "specie", list);

    store = gtk_list_store_new (2, G_TYPE_STRING, G_TYPE_BOOLEAN);
    renderer = gtk_cell_renderer_text_new ();
    column = gtk_tree_view_column_new_with_attributes ("Species",
            renderer, "text", 0, NULL);
    gtk_tree_view_column_set_clickable(column, FALSE);
    gtk_tree_view_column_set_sizing (GTK_TREE_VIEW_COLUMN (column),
                                   GTK_TREE_VIEW_COLUMN_FIXED);
    gtk_tree_view_column_set_fixed_width(GTK_TREE_VIEW_COLUMN(column), 140);
    gtk_tree_view_append_column (GTK_TREE_VIEW(list), column);

    renderer = gtk_cell_renderer_toggle_new ();
    g_signal_connect (renderer, "toggled", G_CALLBACK (fixed_toggled),
          GTK_TREE_MODEL(store));
    column = gtk_tree_view_column_new_with_attributes (" ",
            renderer, "active", 1, NULL);
    gtk_tree_view_column_set_clickable(column, FALSE);
    gtk_tree_view_column_set_sizing (GTK_TREE_VIEW_COLUMN (column),
                                   GTK_TREE_VIEW_COLUMN_FIXED);
    gtk_tree_view_column_set_fixed_width(GTK_TREE_VIEW_COLUMN(column), 50);
    gtk_tree_view_append_column (GTK_TREE_VIEW(list), column);
    gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(list), FALSE);
    gtk_container_add (GTK_CONTAINER (scrollwin), list);
    gtk_tree_view_set_model(GTK_TREE_VIEW(list), GTK_TREE_MODEL (store));

    button = myimage_button("   _OK", "ok.png");
    gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button, GTK_RESPONSE_OK); 

    button = myimage_button("  _Cancel", "cancel.png");
    gtk_dialog_add_action_widget(GTK_DIALOG(dialog), button, GTK_RESPONSE_CANCEL); 
    gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)), 
        GTK_BUTTONBOX_SPREAD);
    gtk_widget_show_all(dialog);
                                                                                                        
    return dialog;
}

void HideShowSpecies(GtkWidget *item, gpointer data)
{
   int i, result, to_show;
   int *sel_spec = g_new0(int, NUMSPECIES);
   GtkWidget *dlg = createHideShow();
   GtkWidget *gtklist = get_widget(dlg, "specie");
   GtkTreeModel *model = gtk_tree_view_get_model (GTK_TREE_VIEW(gtklist));
   GtkTreeIter iter;

   populate_list(GTK_TREE_VIEW(gtklist), Specie, nSpec, 0);
   gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(finestre[0]));
   finestra_modale_aperta2(dlg);
   result = gtk_dialog_run(GTK_DIALOG(dlg));
   if(result == GTK_RESPONSE_OK)
   {
      to_show = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(get_widget(dlg, "show")));
      gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
      i = 0;
      while (valid)
      {
           gtk_tree_model_get (model, &iter, 1, &sel_spec[i], -1);              
           i++;
           valid = gtk_tree_model_iter_next (model, &iter);
      }
      hideshowspecies_(&to_show, sel_spec);
   }
   gtk_widget_destroy(dlg);
   finestra_modale_chiusa2();
}

void view_coordinates(GtkButton *button, GtkWidget *dlg)
{
   
//   gtk_widget_hide(dlg);
   view_coord_();
//   gtk_widget_show(dlg);
}

void compare_atoms(GtkWidget *item, gpointer data)
{
   GtkWidget *dlg, *hbox, *frame, *label, *button, *radio, *table, *check, *spin;
   int i, TipoDiModello, ier = 0;
   float distlim;

   static const char *Tipi[] = {"C.I._F. (*.cif)",  "S_helx File (*.ins)", "_PDB (*.pdb)", "_Sir File(*.fra)"};
   int Tipo[] = {33, 26, 27, 24};
   int nc = 2;
   int numtipi = sizeof(Tipi)/sizeof(Tipi[0]);
   GSList *group = NULL;
   std::stringstream nome;

   dlg = gtk_dialog_new();
   gtk_container_set_border_width (GTK_CONTAINER (dlg), 6);
   gtk_window_set_title (GTK_WINDOW (dlg), "Load model to compare");

   frame = gtk_frame_new (NULL);
   gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), frame, FALSE, FALSE, 10);
   gtk_container_set_border_width (GTK_CONTAINER (frame), 4);

   if(dialogo->ModelToCompare == 0)
   {
      label = LABEL_NEW("No model loaded", "red");
      gtk_container_add(GTK_CONTAINER(frame), label);
      set_alignment(label, 0.5, 0.5);
   }
   else
   {
      hbox = hbox_new(FALSE, 0);
      gtk_container_add(GTK_CONTAINER(frame), hbox);
      label = LABEL_NEW("Model already loaded", MyBLUE);
      set_alignment(label, 0., 0.5);
      gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);
      button =  myimage_button(" View coordinates", "preview22.png");
      gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 10);
      g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(view_coordinates), dlg);
      check = CHECK_BUTTON_WITH_LABEL ("Change model", MyBLUE);
      gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 10);
      g_object_set_data(G_OBJECT(dlg), "chmodel", check);
   }

   getdistance_(&distlim);
   frame = gtk_frame_new (NULL);
   gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), frame, TRUE, TRUE, 10);
   gtk_container_set_border_width (GTK_CONTAINER (frame), 4);
   std::string labelstr = g_strdup_printf("Distance limit (&#x%x;): ", gdk_keyval_to_unicode(Aring));
   label = SPIN_WITH_LABEL(labelstr.c_str(), MyBLUE, 1e-6, 2., distlim, 0.01, 3);
   gtk_container_add(GTK_CONTAINER(frame), label);
   spin = get_widget(label, "spin");
   g_object_set_data(G_OBJECT(dlg), "spindist", spin);

   frame = gtk_frame_new (NULL);
   gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), frame, TRUE, TRUE, 10);
   gtk_container_set_border_width (GTK_CONTAINER (frame), 4);
   gtk_widget_set_sensitive(frame, (dialogo->ModelToCompare == 0));
   if(dialogo->ModelToCompare)
      g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_attiva), frame);

   table = table_new(nc+1, nc, FALSE);
   gtk_container_add(GTK_CONTAINER(frame), table);
   gtk_container_set_border_width (GTK_CONTAINER (table), 8);
//   table_set_row_spacing(table, nc-1, 15);

   for(i=0; i<numtipi; i++)
   {
       nome.str("");
       nome << "radio" << i;
       radio = RADIO_BUTTON_WITH_LABEL(group, Tipi[i], MyBLUE);
       table_attach (table, radio, i%nc, i%nc+1, i/nc, i/nc +1, TRUE);
       group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
       g_object_set_data(G_OBJECT(dlg), nome.str().c_str(), radio);
   }

   check = CHECK_BUTTON_WITH_LABEL("Include hydrogens", MyBLUE);
   g_object_set_data(G_OBJECT(dlg), "ifHyd", check);
   table_attach (table, check, 0, 1, nc, nc +1, TRUE);

   button = myimage_button("   _OK", "ok.png");
   gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_OK);

   button = myimage_button("  _Cancel", "cancel.png");
   gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL);
   gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(finestre[0]));
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)), 
        GTK_BUTTONBOX_SPREAD);

   gtk_widget_show_all(dlg);
   int result = GTK_RESPONSE_NONE;
   while ( result == GTK_RESPONSE_NONE )
   {
         result = gtk_dialog_run(GTK_DIALOG(dlg));
         if(result == GTK_RESPONSE_CANCEL)
         {
            gtk_widget_destroy(dlg);
            return;
         }
         else if(result == GTK_RESPONSE_OK)
         {
            if( (dialogo->ModelToCompare == 0) || 
                  gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(get_widget(dlg, "chmodel"))) )
            {
               for(i=0; i<numtipi; i++)
               {
                   nome.str("");
                   nome << "radio" << i;
                   radio = get_widget(dlg, nome.str().c_str());
                   if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radio)))
                   {
                         TipoDiModello = Tipo[i];
                         break;
                   }
               }
               gtk_widget_hide(dlg);
               ier = open_file(dlg, GINT_TO_POINTER(TipoDiModello));
            }
            distlim = (float) spin_button_get_value(spin);
            if(ier == 0)
            {
               gtk_widget_destroy(dlg);
               elaborazione_in_corso();
               compareatoms_(&distlim);
               fine_elaborazione();
//             dialogo->ModelToCompare = 1;
            }
            else
            {
               gtk_widget_show(dlg);
               result = GTK_RESPONSE_NONE;
            }
         }
   }
}

//void c_supplementary(GtkWidget *item, gpointer data)
//{
//   int ier;

//   supplementary_(&ier);
//   if(!ier)
//      createHtml(0, 0, "_supplementary.txt", "_supplementary.htm");
//}

namespace compareAtoms {
static int ifViewMod = 0, ifDrawLabels = 0;
}

int c_carica(char *inpFile1, char *inpDir1, int tipo, float dista, int ifHyd)
{
    char *inpFile = DuplicaStringa(fromUTF8(inpFile1).c_str());
    char *inpDir = DuplicaStringa(fromUTF8(inpDir1).c_str());
    int idum  = (int) strlen(inpFile);
    int idum1 = (int) strlen(inpDir);
    int typ = tipo;
    int ier = 0;
    carica_(inpFile, inpDir, &typ, &ier, &dista, &ifHyd, idum, idum1);
    return ier;
}

void on_button_click (GtkWidget *button, gpointer data)
{
   using namespace gtkext;
      gint response = GPOINTER_TO_INT(data);
      GtkWidget *window = gtk_widget_get_toplevel(button);
      GtkTextBuffer *tb = (GtkTextBuffer *) get_object(window, "buffer");
      GtkTextIter i1, i2;
      char *filename, *filter;
      std::string fn;

      switch(response)
      {
      case GTK_RESPONSE_NONE:
      case GTK_RESPONSE_DELETE_EVENT:
      case EXIT:
           chiusacompare_();
           gtk_widget_destroy(window);
           finestra_modale_chiusa2();
           break;
     case SAVEAS:
           gtk_text_buffer_get_bounds(tb, &i1, &i2);
           filter = get_string(window, "filter");
           fn = dlg_select_file(window, fn, eSELECT_TO_WRITE, filter);
           filename = g_new0(char, MaxLenFilename);
           CopiaStringa(filename, MaxLenFilename, fn.c_str());
           if(!fn.empty())
           {
              gchar *buffer = gtk_text_iter_get_text (&i1, &i2);
              if(g_file_test(fn.c_str(), G_FILE_TEST_EXISTS) && !mr_access(filename, 'w'))
                 gtkext::dlg_errmsg(GTK_WINDOW(window), "The file '%s' is READ_ONLY!", filename);
              else
              { 
                 FILE *fp = fOpen(filename, "w");
                 if(fp)
                 {
                    (void) fputs(buffer, fp);
                    (void) fclose(fp);
                 }
                 g_free(buffer);
              }
           }
           break;
      case PRINT:
           filename = get_string(window, "filename");
           if(strlen(filename))
              PrintFile(window, filename);
           break;
      default:
           break;
      }
}

void load_file_special( const char *filename, GtkWidget *dlg)
{
   FILE *infile = NULL;
   PangoFontDescription *desc = get_fontN (MONOSPACE_FONT, 1);

   if(filename && strlen(filename))
      infile = fOpen(filename, "r");
   GtkTreeViewColumn *column = gtk_tree_view_get_column(
        GTK_TREE_VIEW(get_widget(dlg, "listacoppie")), 0);
   gtk_tree_view_column_set_sizing (column, GTK_TREE_VIEW_COLUMN_AUTOSIZE);
  
   if (infile) 
   {
       char buffer[1024], *str;
       std::string intest;
       bool isInte = true, printInte = false;
       widget_modify_font(get_widget(dlg, "listacoppie"), desc);

       while((str = fgets(buffer, 1024, infile)) != NULL)
       {
              if (strstr(str, "----") != NULL)
              {
                 isInte = false;
                 printInte = true;
                 GtkWidget *label = LABEL_NEW(g_strchomp(str), MyBLUE);
                 widget_modify_font(label, desc);
                 gtk_widget_show (label);
                 column = gtk_tree_view_get_column(
                     GTK_TREE_VIEW(get_widget(dlg, "listacoppie")), 0);
                 gtk_tree_view_column_set_widget(column, label);
              }
              if (isInte)
              {
                 intest.append(g_strchomp(str));
                 intest.append("\n");
              }
              else if (printInte)
              {
                  gtk_label_set_text(GTK_LABEL(get_widget(dlg, "intestazione")), intest.c_str());
                  printInte = false;
              }
              else
                  add_line_to_list(get_widget(dlg, "listacoppie"), (gpointer) g_strchomp(str));
       }
       (void) fclose (infile);
    }
}

void couple_selected(GtkTreeSelection  *sele, GtkWidget *data)
{
     GtkTreeView *tree_view;

     tree_view = gtk_tree_selection_get_tree_view(sele);
     if(get_selection_mode(GTK_WIDGET(tree_view)) == GTK_SELECTION_MULTIPLE)
        return;
     char *riga = DuplicaStringa(get_selected_row(data));
//     g_print("selected %s\n", riga);
     pallealcentro_(riga, (int) strlen(riga));
}    

void tog_labmod(GtkToggleButton *button, GtkWidget *dlg)
{
using namespace compareAtoms;
    ifViewMod = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(get_widget(dlg, "viewmodel")));
    if (ifViewMod)
        ifDrawLabels = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(get_widget(dlg, "drawlabels")));
    else
        ifDrawLabels = 0;
    settoggles_(&ifViewMod, &ifDrawLabels);
}

extern "C" void chiudicompare_()
{
   if(!jscreen)
     return;
    GtkWidget *window = get_widget(finestre[0], "compare_w");
    if(GTK_IS_WIDGET(window))
       gtk_widget_destroy(window);

}

GtkWidget *create_compare_w (const char *filename, const char *filter, int flags, const char *title) 
{
using namespace gtkext;
using namespace compareAtoms;
  GtkWidget *text, *dialog, *frame, *hbox, *label, *image, *vbox, *check;
  GtkWidget *button_quit, *button_saveas, *button_print, *list, *check2, *align;
  GtkTextBuffer *text_buffer;
  GdkPixbuf *icon_pixbuf;
  PangoFontDescription *desc = get_fontN (MONOSPACE_FONT, 1);
//  GdkColor colore;

//  gdk_color_parse("#0000BB", &colore);

  dialog = gtk_dialog_new();
  gtk_widget_set_size_request(dialog, -1, 650);
  g_object_set_data(G_OBJECT(dialog), "filename", (gpointer) filename);
  g_object_set_data(G_OBJECT(dialog), "filter", (gpointer) filter);
  if(title)
     gtk_window_set_title(GTK_WINDOW(dialog), toUTF8(title));
  else
     gtk_window_set_title(GTK_WINDOW(dialog), "Editor");
  

  icon_pixbuf = create_pixbuf ("compare.png");
  if (icon_pixbuf)
  {
      gtk_window_set_icon (GTK_WINDOW (dialog), icon_pixbuf);
      g_object_unref (G_OBJECT(icon_pixbuf));
  }

  frame = gtk_frame_new(NULL);
  gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dialog))), frame, FALSE, FALSE, 0);
  hbox = hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER (frame), hbox);

  button_quit = image_button("quit32.png");
  gtk_box_pack_start (GTK_BOX (hbox), button_quit, FALSE, FALSE, 0);
  set_tip(button_quit, "Quit");
  g_signal_connect((gpointer) button_quit, "clicked", G_CALLBACK(on_button_click), GINT_TO_POINTER(EXIT));

  button_saveas = image_button("filesaveas32.png");
  gtk_box_pack_start (GTK_BOX (hbox), button_saveas, FALSE, FALSE, 0);
  set_tip(button_saveas, "Save File");
  g_signal_connect((gpointer) button_saveas, "clicked", G_CALLBACK(on_button_click), GINT_TO_POINTER(SAVEAS));

  button_print = image_button("fileprint32.png");
  gtk_box_pack_start (GTK_BOX (hbox), button_print, FALSE, FALSE, 0);
  set_tip(button_print, "Print File");
  g_signal_connect((gpointer) button_print, "clicked", G_CALLBACK(on_button_click), GINT_TO_POINTER(PRINT));

  frame = NEW_FRAME("Results");
  gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dialog))), frame, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
  align = get_widget(frame, "align");
   
//  align = gtk_frame_new(NULL);
//  gtk_widget_show (align);
//  gtk_container_set_border_width (GTK_CONTAINER (align), 6);
//  gtk_frame_set_shadow_type(GTK_FRAME(align), GTK_SHADOW_NONE);
//  gtk_container_add(GTK_CONTAINER (frame), align);

  label = gtk_label_new("");
  gtk_widget_show (label);
  gtk_container_add(GTK_CONTAINER (align), label);
  set_alignment(label, 0., 0.5);
  widget_modify_font(label, desc);
//  set_label_color(label, colore);
  
  g_object_set_data(G_OBJECT(dialog), "intestazione", label);

  frame = NEW_FRAME("Model");
  gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dialog))), frame, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);

  hbox = hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), hbox);

  check2 = CHECK_BUTTON_WITH_LABEL ("Display model", MyBLUE);
  g_object_set_data(G_OBJECT(dialog), "viewmodel", check2);
  gtk_box_pack_start (GTK_BOX (hbox), check2, FALSE, FALSE, 10);
  g_signal_connect(G_OBJECT(check2), "toggled", G_CALLBACK(tog_labmod), dialog);
  check = CHECK_BUTTON_WITH_LABEL ("Display labels", MyBLUE);
  g_object_set_data(G_OBJECT(dialog), "drawlabels", check);
  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 80);
  g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(tog_labmod), dialog);
  g_signal_connect(G_OBJECT(check2), "toggled", G_CALLBACK(on_cb_attiva), check);

  gtk_widget_set_sensitive(check, ifViewMod);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check2), ifViewMod);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), ifDrawLabels);

  frame = NEW_FRAME("Matches", &FrameStyle);
  gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dialog))), frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
   
  vbox = vbox_new(FALSE, 0);
  gtk_widget_show (vbox);
  gtk_container_add(GTK_CONTAINER (get_widget(frame, "align")), vbox);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, FALSE, FALSE);
#else
  align = gtk_alignment_new(0.5, 0.5, 0., 0.);
#endif
  gtk_box_pack_start(GTK_BOX (vbox), align, FALSE, FALSE, 10);

  hbox = hbox_new(FALSE, 0);
  gtk_widget_show (hbox);
  gtk_container_add(GTK_CONTAINER(align), hbox);

  image = create_image("idea.png");
  gtk_widget_show (image);
  gtk_box_pack_start(GTK_BOX (hbox), image, FALSE, FALSE, 10);

  label = LABEL_BOLD("Select a row to center the plot", "red", 1.2f);
  gtk_widget_show (label);
  gtk_box_pack_start(GTK_BOX (hbox), label, TRUE, TRUE, 30);
  set_alignment(label, 0., 0.5);
  
  list = createSelection(dialog, vbox, "titolo", "listacoppie", 0, MyBLUE);
  gtk_widget_show (list);
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  (void) g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (couple_selected), list);

  text = gtk_text_view_new ();
  g_object_set_data(G_OBJECT(dialog), "testo", text);

  text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (text));
  gtk_text_view_set_right_margin  (GTK_TEXT_VIEW(text), 4);
  gtk_text_view_set_left_margin  (GTK_TEXT_VIEW(text), 4);
  g_object_set_data(G_OBJECT(dialog), "buffer", text_buffer);

  if(flags & IFREADONLY)
     gtk_text_view_set_editable(GTK_TEXT_VIEW(text), FALSE);
  else
     gtk_text_view_set_editable(GTK_TEXT_VIEW(text), TRUE);
//  gtk_container_add(GTK_CONTAINER(scrollwin), text);

   if(filename)
   {
      (void) load_file_into_buffer(filename, text_buffer, flags | IFPROP);
      load_file_special(filename, dialog);
   }

   (void) g_signal_connect_swapped(G_OBJECT(dialog), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button_quit));
   (void) g_signal_connect (G_OBJECT (dialog), "delete_event",
                      G_CALLBACK(true_cb), NULL);
  return dialog;
}

void compare_w(GtkWindow *winmain, const char *filnam, const char *filter, int flags, 
           const char *title)
{
      GtkWidget *window;

      gchar *filename = g_new0(char, MaxLenFilename);
      if(filnam)
         CopiaStringa(filename, MaxLenFilename, filnam);

      window = get_widget(GTK_WIDGET(winmain), "compare_w");
      if(GTK_IS_WIDGET(window))
         gtk_widget_destroy(window);
      window = create_compare_w(filename, filter, flags, title);
      g_object_set_data(G_OBJECT(winmain), "compare_w", window);
      gtk_window_set_transient_for(GTK_WINDOW(window), GTK_WINDOW(finestre[0]));
      finestra_modale_aperta2(window);
      gtk_widget_show_all(window);
      gdk_window_raise (gtk_widget_get_window(window));
}
extern "C" void passacontrollo_();
void open_terminal (GtkWidget *item, gpointer data)
{
      gtk_widget_hide(finestre[0]);
      while(gtk_events_pending())
         (void) gtk_main_iteration();
#ifndef _WIN32
     int i = isatty(STDIN_FILENO);
     if(!i)
     {
        gtk_widget_show(finestre[0]);
        std::string msg = "Feature available only when Sir runs in a terminal";
        gtkext::dlg_errmsg(GTK_WINDOW(finestre[0]), msg);
        return;
     }
#endif
      passacontrollo_();
      gtk_widget_show(finestre[0]);
      gdk_window_raise (gtk_widget_get_window(finestre[0]));
}

extern "C" void cbasename_(char *filenam, char *basenam)
{
      CopiaStringa(basenam, 256, g_path_get_basename(filenam));
}

void call_jav(GtkWidget *, gpointer )
{
      int which, ifMappa=0;
      int result = tipoMappa(&which, &ifMappa);
      if(result == GTK_RESPONSE_OK)
         lanciajavsir_(&which);
}

void map_variance(GtkWidget *, gpointer )
{
      int which;
      int result = tipoVariance(&which);
      if(result == GTK_RESPONSE_OK)
         mapvariance_(&which);
}

void skip_or_stop              (GtkWidget *item,  gpointer data)
{
     dialogo->ifBrekke = GPOINTER_TO_INT(data);
}

void call_javs (GtkWidget *,  gpointer )
{
#if 0
     //dialogo->ifBrekke = GPOINTER_TO_INT(data);
      int ifMappa = 0;
      int javplotStyle = 0;
      switch(dialogo->iPlotType)
      {
      case 1:
           javplotStyle = WIRES;
           break;
      case 2:
           javplotStyle = RODS;
           break;
      case 3:
           javplotStyle = SIMPLE;
           break;
      case 4:
      case 5:
      case 6:
           javplotStyle = STICK_AND_BALLS;
           break;
      case 7:
           javplotStyle = VANDERWAALS;
           break;
      case 8:
           javplotStyle = ELLIPSOIDS;
           break;
      }
      javplotStyle++;
      int which = 1;
      set_style_(&javplotStyle, &which);
#endif
      //lanciajavs_(&ifMappa, &ifMappa);
      openjavviewer_();
}

void nuovoviewer(GtkWidget *item, gpointer data)
{
    onopen_();
}

extern "C" void aprisannelwin_()
{
    ifSannel = true;
}

extern "C" void aprisannelwinfortran_()
{
   if(!jscreen)
     return;
    c_globalopt(NULL, NULL);
}


namespace GLextmr{
                   extern Model *ModelInfo;
                   extern "C" float getxyz_(int *i, int *j);
//                   extern "C" int   getcatena_(int *i);
//                   extern "C" int   getnumresiduo_(int *i);
                   extern "C" void  getlab_(int *i, char *string, int l);
                   extern "C" int   getz_(int *i);

extern "C" void secondarystructureinfo_(int *nats, int *nSec, char *sec)
{
using namespace gtkext;

  int i, j, k=0;

  if(*nats == 0)
     return;

  //fprintf(stderr, "SecondaryStructureInfo\n");
  ModelInfo = g_new0(Model, 1);
  ModelInfo[k].created = true;
  ModelInfo[k].isPDB = 1;
  ModelInfo[k].nats = *nats;
  ModelInfo[k].nats_au = *nats;
  ModelInfo[k].atm = g_new0(jav_atom_type, ModelInfo[k].nats);
  ModelInfo[k].iEqui = g_new0(int, ModelInfo[k].nats);
  ModelInfo[k].atm_au = g_new0(jav_atom_type, ModelInfo[k].nats);
  ModelInfo[k].Secondary = g_new0(char, ModelInfo[k].nats);
  ModelInfo[k].nChains = 0;
  ModelInfo[k].Bmin = 1.e10;
  ModelInfo[k].Bmax = -1.e10;
  for(i=1; i<=ModelInfo[k].nats; i++)
  {
      for(int l=0; l<MAX_LABLEN; l++)
          ModelInfo[k].atm[i-1].lab[l] = '\0';
      ModelInfo[k].atm[i-1].deleted = false;
      getlab_(&i, ModelInfo[k].atm[i-1].lab, MAX_LABLEN);
      ModelInfo[k].atm[i-1].numResiduo = 0;
      ModelInfo[k].atm[i-1].Z = getz_(&i);
      ModelInfo[k].iEqui[i-1] = i-1;
/*
      ModelInfo[k].atm[i-1].numResiduo = (getnumresiduo_(&i) - 1 );
      int kch = getcatena_(&i);
      if( (kch >= 'A') && (kch <='Z') )
          ModelInfo[k].atm[i-1].catena = kch - 'A';
      else if( (kch >= 'a') && (kch <='z') )
          ModelInfo[k].atm[i-1].catena = kch - 'a';
      else
          ModelInfo[k].atm[i-1].catena = 0;
*/
      ModelInfo[k].atm[i-1].catena = 0;
      ModelInfo[k].atm[i-1].catseq = 0;
      for(j=1; j<=3; j++)
          ModelInfo[k].atm[i-1].xyz[j-1] = getxyz_(&i, &j);
      ModelInfo[k].Secondary[i-1] = ' ';
      memcpy(&(ModelInfo[k].atm_au[i-1]), &(ModelInfo[k].atm[i-1]), sizeof(ModelInfo[k].atm[i-1]));
  }
  for(int i=0; i<*nats; i++)
      sec[i] = ' ';
  std::string msg;
  ModelInfo[k].GetEquivs();
  if(!ModelInfo[k].PreparaTabelle(msg))
  {
     g_print("%s\n", msg.c_str());
     return;
  }
  int nsec = 0;
  for(int i=0; i<*nats; i++)
  {
      sec[i] = ModelInfo[k].Secondary[i];
      if(ModelInfo[k].Secondary[i] != ' ')
         nsec++;
  }
  *nSec = nsec;
  ModelInfo[k].freeModel();
  //fprintf(stderr, "Esco da SecondaryStructureInfo\n");
}
}

// Per new project
extern "C" void  newproject_gene_ (int *ier, multistringa *ms);

int c_newproject_gene(char *wdir, char *nome, char *title)
{
   int ier;
   multistringa ms;

   ms.n1 = (int) strlen(wdir); 
   ms.n2 = (int) strlen(nome);
   ms.n3 = (int) strlen(title);
   CopiaStringa(ms.file1, MaxLenFilename, wdir);
   CopiaStringa(ms.file2, MaxLenFilename, nome);
   CopiaStringa(ms.file3, MaxLenFilename, title);

   newproject_gene_(&ier, &ms);
   return ier;
}

/*****************************************************************/
/*       U P D A T E   C E L L   C O N T E N T                   */
/*****************************************************************/
static GtkWidget *modifycont_dlg = NULL;

void fill_modifycont_dlg(int newCont[])
{
   GtkWidget *entry;
   char num[5];
   int i;

   for(i=0; i<3*nSpec;i++)
   {
       ScriviStringa(num, sizeof(num), "%d", i);
       entry = lookup_widget(modifycont_dlg, num);
       gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
       if(nw[i/3])
       {
          switch(i%3)
          {
          case 0:
             gtk_entry_set_text(GTK_ENTRY(entry), Sigle[i/3]);
             break;
          case 1:
             gtk_entry_set_text(GTK_ENTRY(entry), g_strdup_printf("%d", 
                             nw[i/3]));
             break;
          case 2:
             gtk_entry_set_text(GTK_ENTRY(entry), g_strdup_printf("%d", 
                             newCont[i/3]));
             break;
          }
       }
  }
}

void get_modified(int newCont[])
{
   GtkWidget *entry;
   char num[5];
   int i;

   for(i=2; i<3*nSpec;i+=3)
   {
       ScriviStringa(num, sizeof(num), "%d", i);
       entry = lookup_widget(modifycont_dlg, num);
       newCont[i/3] = atoi(gtk_entry_get_text(GTK_ENTRY(entry)));
   }
}

GtkWidget *create_modifycellc (void)
{
  GtkWidget *window1;
  GtkWidget *vbox;
  GtkWidget *table;
  GtkWidget *label;
  GtkWidget *entry;
  GtkWidget *button;
  int i;
  char num[5];

  window1 = gtk_dialog_new ();
  g_object_set_data (G_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), "Update Cell Content");
  gtk_window_set_position (GTK_WINDOW(window1), GTK_WIN_POS_MOUSE);
  gtk_container_set_border_width(GTK_CONTAINER(window1), 10);
  gtk_widget_set_size_request (window1, -1, 250);

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(window1));

  GtkWidget *scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_box_pack_start (GTK_BOX (vbox), scrollwin, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                   GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  gtk_widget_show (scrollwin);

  table = table_new (nSpec+1, 3, FALSE);
  gtk_widget_show (table);
  add_to_scrollwin(scrollwin, table);
  gtk_container_set_border_width(GTK_CONTAINER(table), 5);
  table_set_col_spacings(table, 12);
  table_set_row_spacings(table, 6);

  label = LABEL_BOLD("Atomic\nspecies", LABELCOLOR, 1.2f);
  gtk_widget_show (label);
  set_alignment(label, 0.5, 0.);
  gtk_label_set_justify (GTK_LABEL(label), GTK_JUSTIFY_CENTER);
  table_attach(table, label, 0, 1, 0, 1, TRUE);

  label = LABEL_BOLD("Declared\nCell Content", LABELCOLOR, 1.2f);
  gtk_widget_show (label);
  set_alignment(label, 0.5, 0.);
  gtk_label_set_justify (GTK_LABEL(label), GTK_JUSTIFY_CENTER);
  table_attach(table, label, 1, 2, 0, 1, TRUE);

  label = LABEL_BOLD("Actual\nCell Content", LABELCOLOR, 1.2f);
  gtk_widget_show (label);
  set_alignment(label, 0.5, 0.);
  gtk_label_set_justify (GTK_LABEL(label), GTK_JUSTIFY_CENTER);
  table_attach(table, label, 2, 3, 0, 1, TRUE);

  for(i=0; i<3*nSpec; i++)
  {
      ScriviStringa(num, sizeof(num), "%d", i);
      entry = gtk_entry_new();
      g_object_set_data (G_OBJECT (window1), num, entry);
      gtk_widget_set_size_request(entry, 90, 24);
      gtk_widget_show (entry);
      if((i%3) == 2)
      {
         int hnd =  g_signal_connect(G_OBJECT(entry), "insert-text",
                    G_CALLBACK(check_numeric), NULL);
         g_object_set_data(G_OBJECT(entry), "hnd", GINT_TO_POINTER(hnd));
      }
      else
      {
         gtk_widget_set_sensitive(entry, FALSE);
         set_widget_color(entry, colorBlck);
      }
      table_attach(table, entry, i%3, i%3+1, i/3+1, i/3+2, TRUE);
  }

  button = OK_button();
  gtk_widget_show (button);
  gtk_dialog_add_action_widget(GTK_DIALOG(window1), button, GTK_RESPONSE_OK);

  button = CANCEL_button();
  gtk_widget_show (button);
  gtk_dialog_add_action_widget(GTK_DIALOG(window1), button, GTK_RESPONSE_CANCEL);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)), 
        GTK_BUTTONBOX_SPREAD);
  return window1;

}

extern "C" int c_updatecellcontent_ (int newCont[])
{
  int ifModi = 0;
   if(!jscreen)
     return 0;
  if(modifycont_dlg == NULL)
     modifycont_dlg = create_modifycellc();
  
  getnewnw_(nw);
  fill_modifycont_dlg(newCont);
  int result = gtk_dialog_run(GTK_DIALOG(modifycont_dlg));
  if(result == GTK_RESPONSE_OK)
  {
     get_modified(newCont);
     ifModi = 1;
     for(int i=0; i<nSpec; i++)
         nw[i] = newCont[i];
     putnewnw_(nw);
  }
  gtk_widget_hide(modifycont_dlg);
  return ifModi;
}

/*********************************************************/
/*                B e s t   T r i a l s                  */
/*********************************************************/

typedef struct {
                  nomefile f1;
                  int      n1;
               } _Stringa;

extern "C"
{
    void migliorierre_(int *act, int *n, int *rcol,float *fcol,_Stringa *strcol);
    int  getnbestmodels_();

    void showtrial_(int *ntr);
}

static void load_best_r(GtkButton *button, gpointer data)
{
using namespace gtkext;
   GtkWidget *list = (GtkWidget *) data;
   GtkTreeSelection *sel = gtk_tree_view_get_selection (GTK_TREE_VIEW (list));
   int scelta = row_selected(sel) + 1;
   if(scelta <= 0)
   {
      dlg_errmsg(GTK_WINDOW(gtk_widget_get_toplevel(GTK_WIDGET(button))), 
        "No trials selected.");
      return;
   }
   gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
   best_r_(&scelta);
}

static void on_cancel(GtkButton *button, gpointer data)
{
   gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}

void riempi_listaBestT(GtkWidget *lista, int nrow, int ntcol[],
                             float rfcol[], std::vector<std::string> fil,
                             std::vector<std::string> spg) //_Stringa *strcol)
{
  int i;
  char *rigacom[4] = {g_new0(char, MaxLenFilename),
                      g_new0(char, MaxLenFilename),
                      g_new0(char, MaxLenFilename),
                      g_new0(char, MaxLenFilename)};

  clear_list(lista);
  for(i=0; i<nrow; i++)
  {
     ScriviStringa(rigacom[0], MaxLenFilename, "%6d", ntcol[i]);
     ScriviStringa(rigacom[1], MaxLenFilename, "%12.2f%%", rfcol[i]);
//     ScriviStringa(rigacom[2], MaxLenFilename, "%s", strcol[i].f1, i+1);
     ScriviStringa(rigacom[2], MaxLenFilename, "%s", fil.at(i).c_str());
     if(!spg.empty())
        ScriviStringa(rigacom[3], MaxLenFilename, "%s", spg.at(i).c_str());
     add_line_to_listM(lista, rigacom);
  }
  select_row(lista, 0);
}

static void  on_select_trial (GtkTreeSelection *selec, gpointer data)
{
   int sel, pos;
   GtkTreeModel *model;
   GtkTreeIter iter;

   sel = gtk_tree_selection_get_selected (selec, &model, &iter);
   pos = 0;
   if(sel)
      pos = row_selected(selec) + 1;

   if(pos > 0)
      showtrial_(&pos);
}

GtkWidget *crea_finestra_best_r(int nBestR, int ntcol[], float rfcol[], _Stringa *strcol)
{
using namespace std;
     GtkWidget *dlg;
     GtkWidget *list, *vbox, *button1, *button2;
     static const char *colonne[] = {"Trial", "R Factor", "Exported file name",
         "Spacegroup"};
     vector<string> filnam;
     vector<string> spg;
     for(int i=0; i<nBestR; i++)
     {
         string strtemp =  strcol[i].f1;
         string::size_type i1 = strtemp.find(";");
         if(i1 != string::npos)
         {
            filnam.push_back(strtemp.substr(0, i1));
            spg.push_back(strtemp.substr(i1+1, string::npos));
         }
         else
            filnam.push_back(strtemp);
     }
     dlg = gtk_dialog_new ();
     gtk_window_set_title (GTK_WINDOW (dlg), "Best trials");
     gtk_container_set_border_width (GTK_CONTAINER (dlg), 10);
     gtk_widget_set_size_request(dlg, 400, 350);

     vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
     if(!spg.empty())
        list = createSelectionM(dlg, vbox, colonne, "listaBestT",
          sizeof(colonne)/sizeof(colonne[0]), "blue");
     else
        list = createSelectionM(dlg, vbox, colonne, "listaBestT",
          sizeof(colonne)/sizeof(colonne[0])-1, "blue");
     set_selection_mode(list, GTK_SELECTION_SINGLE);
     riempi_listaBestT(list, nBestR, ntcol,rfcol,filnam, spg);//strcol);
     g_signal_connect(G_OBJECT(gtk_tree_view_get_selection (GTK_TREE_VIEW (list))),
        "changed", G_CALLBACK(on_select_trial), NULL);

     button1 = myimage_button("   _Load ", "opensir.png");
     gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button1, GTK_RESPONSE_OK);
     
     button2 = CANCEL_button();
     gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button2, GTK_RESPONSE_CANCEL);

     g_signal_connect((gpointer) button1, "clicked", 
        G_CALLBACK(load_best_r),  (gpointer) list);
     g_signal_connect((gpointer) button2, "clicked", 
        G_CALLBACK(on_cancel),  NULL);
     g_signal_connect_swapped(G_OBJECT(dlg), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button2));
     g_signal_connect (G_OBJECT (dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);

     return dlg;
}

void apri_finestra_best_r(int nBestR, int ntcol[], float rfcol[], _Stringa strcol[])
{
     GtkWidget *dlg = crea_finestra_best_r(nBestR, ntcol, rfcol, strcol);
#ifndef _WIN32
     gtk_window_set_transient_for(GTK_WINDOW(dlg), GTK_WINDOW(finestre[0]));
#endif
     gtk_widget_show_all(dlg);
     gdk_window_raise(gtk_widget_get_window(dlg));
     GtkWidget *list = get_widget(dlg, "listaBestT");
     unselect_all(GTK_TREE_VIEW(list));
     select_row(list,0);
}

void c_best_r(GtkWidget *item, gpointer data)
{
    int nBestR = getnbestmodels_();
//050711    if(nBestR == 0)
    if(nBestR <= 1)
    {
       best_r_(&nBestR);
       return;
    }
    int   *ntcol = g_new0(int, nBestR);
    float *rfcol = g_new0(float, nBestR);
    _Stringa *strcol = g_new0(_Stringa, nBestR);

    int action = 5;
    int trial = 0;
    migliorierre_(&action, &trial, ntcol, rfcol, strcol);
    apri_finestra_best_r(nBestR,ntcol,rfcol,strcol);
}

int on_openFile (const char *title=NULL)
{
using namespace gtkext;
   FilselItem it;

//   if(item != NULL)
//       (void) dir_set_current(cSWareRC->WorkingDirectory);
   it.fileinp    = g_new0(gchar, MaxLenFilename);
   it.fileout    = g_new0(gchar, MaxLenFilename);
   it.cwd        = g_new0(gchar, MaxLenFilename);
   it.ifDirOnly  = FALSE;
   it.ifMultiple = FALSE;
   it.ifPreview  = FALSE;
   it.ifSave     = FALSE;
   it.exitCode   = 0;
   it.fd         = fontdescU;
   it.window     = finestre[0];
   it.ifEditable = FALSE;
   it.ifExe      = FALSE;
   it.nofilter   = FALSE;
   it.ifOutput   = FALSE;
   it.AllFiles   = FALSE;
   it.filter     = g_strdup(FilesToImport);
   if(title)
      it.title      = g_strdup(title);
   else
      it.title      = g_strdup("Import fragment");

   gtkext::file_open(&it);
   if(it.exitCode > 0)
      c_importa2(it.fileinp, it.cwd);
// {
//      int tipo;
//      tipo          = 0;
//      c_importa(it.fileinp, it.cwd, tipo);
// }
   return (it.exitCode);
}

extern "C" int open_file_selector_(char *title)
{
   int result = on_openFile(title);
   return result;
}

