!-----------------------------------------------------------------------
      MODULE VarianceMod
           integer :: npSav(3)
           real, allocatable :: xmap_sav(:,:,:)!(0:np(1)-1,0:np(2)-1,0:np(3)-1)
           real, allocatable :: xmap_var(:,:,:)!(0:np(1)-1,0:np(2)-1,0:np(3)-1)
           real, allocatable :: AH(:,:)
      END MODULE VarianceMod
!-----------------------------------------------------------------------
      subroutine MapVariance(tipo)
      USE Mappa
      USE Molcom, only : jscreen
      USE VarianceMod
!
      implicit none
      integer :: tipo
      logical :: test, show
!
!-- tipo = 1 Mappa Varianza          (xmap_var)
!--      = 2 Mappa / sqrt(varianza)  (xmap)
!
      test = .false.
      show = .true.
      if (jscreen == 0) then
          show = .false.
      endif
      call InitMapVariance()
!
      call conv_var_light(test)
!
      if (tipo == 1) then
          xmap(:,:,:) = xmap_var(:,:,:)
      endif
      if (show) then
          call LanciaJavs(1, 0)
      endif
!
      call FinishMapVariance()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine InitMapVariance()
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE VarianceMod
      USE ShellSIGMAA
!
      implicit none
      integer :: ier, ksubr, i, multi, hkl(3)
      real    :: besinv, eps
!
      call AllocaRiflessi(2)
      call AllocaRiflessi(1)
      ier = 0
      ksubr = 2
      call LeggiRiflessi(ier, ksubr)
      do i=1, nrefl
         hkl(1:3) = khl(1:3, i)
         call cmult2002(hkl, eps, multi)
         epsv(i) = eps
      enddo
!
      allocate(argBess(1:nrefl), stat = ier)
!
!-- Calcola fase e pesi dal modello in memoria
!
      call CalcolaFasiPesi
!
      do i=1, nrefl
         argBess(i) = besinv(wt(i))
      enddo
      allocate (AH(nsymtot,nreflDim), stat = ier)
!
      ihmxSav(:) = ihmx(:)
      npSav(:) = np(:)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine FinishMapVariance()
      USE General
      USE Mappa
      USE VarianceMod
!
      implicit none
      integer :: ier
!
      ihmx(:) = ihmxSav(:)
      np(:) = npSav(:)
      deallocate (AH, xmap_sav, xmap_var, stat = ier)
      call AllocaMappa(2)
!
      return
      end
!--------------------------------------------------------------------
      subroutine CalcolaFasiPesi
      USE General
      USE Riflessi
      USE Atomi
!
      implicit none
      integer :: iref, mode, ifBreak, iCoeff
      real    :: scalan
!
      nzsav(:) = nz(:)
      nz(:) = iabs(nz(:)) / nzConst
      iref = 0
      mode = 1
      scalan = 0.0
      ifBreak = 0
      iCoeff = 0
      call sftryyyc(iref, mode, nrefl, scalan, ifBreak, iCoeff)
      fcvet(:) = work1(:)
      nz(:) = nzsav(:)
!
      return
      end
!--------------------------------------------------------------------
      subroutine conv_var_light(test)

      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Riflessi!, only :sigmav, fcoef, fovet, wt
      USE PhaseModule
      USE VarianceMod
 
      implicit none
      integer :: ier, i, npunt, ipher, izero, jpatt 
      real    :: fo, fo2, ccost, denmin, denmax, avden, stden, lim_mappa
      logical :: test
      character (len=80)  :: tirang
      character (len=200) :: strTemp

     
!-------------------------------------------------------------------
!calcolo TH2 + TD
!--------------------------------------------------------
   
      sigmav = 0.0
      call space_hRsRq2(1)
      call TH2_FFT(AH) 
      if (test) then
          call maxmin3d(denmin,denmax,avden,stden,npunt,0)
          write(6,'(a,4g15.8)') 'TH2 min max media st  ',
     &                  denmin,denmax,avden,stden
      endif
*     strTemp = 'TH2_FFT.map'
*     call CCP4MAPOUT(jpatt,xmap,np,strTemp)
      allocate(xmap_sav(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat=ier)
      allocate(xmap_var(0:np(1)-1,0:np(2)-1,0:np(3)-1) , stat=ier)
      xmap_sav = xmap
      
      call TD_FFT() 
      if (test) then
          call maxmin3d(denmin,denmax,avden,stden,npunt,0)
          write(6,'(a,4g15.8)') 'TD min max media st  ',
     &              denmin,denmax,avden,stden
      endif

      xmap_var = xmap_sav + xmap

      xenve = - xmap
      if (test) then
          strTemp = 'TD_FFT.map'
          call CCP4MAPOUT(jpatt,xenve,np,strTemp)
      endif
            
      xmap_var = xmap_sav + xmap
      xmap = xmap_var
      if (test) then
          strTemp = 'TH2+TD_FFT.map'
          call CCP4MAPOUT(jpatt,xmap,np,strTemp)
      endif

!-------------------------------------------------------------------
!contributo della varianza dipendente dalla mappa e non dal punto
!-------------------------------------------------------------------
!siccome sto lavorando con gli E tolgo l'errore sperimentale sugli F
      ccost = 0.0
      do i=1, nreflDim
         if (khl(1,i) >=0 )then
             fo = evet(i) ! evet(i)*wt(i)!fovet(i)
             if (khl(1,i) == 0) fo = fo * 0.25
             fo2 = fo**2
             ccost = ccost + 
     *              ((2./(volume**2))*
     *              ((1.0-(wt(i)**2))*fo2)*mult(i))
           
         endif
      enddo
      write(6,*)"TH1=",ccost
!-------------------------------------------------------------------
!    TH+TD
!-------------------------------------------------------------------
      xmap_var = xmap_var + ccost!/2.
      xmap = xmap_var
      if (test) then
          call maxmin3d(denmin,denmax,avden,stden,npunt,0)
          write(6,'(a,4g15.8)') 'TH+TD min max media st  ',
     &                  denmin,denmax,avden,stden
      endif
!----------------------------------------------------------------
!fourier osservata
!------------------------------------------------------------------
c      call Trasla_Origine(nrefl)
      fcoef(:) = evet(:)*wt(:)!fovet(:) * wt(:)
      jpatt = 0
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                FORTH, BACK)
      if (test) then
          strTemp = 'OBSERVED.map'
          call CCP4MAPOUT(jpatt,xmap,np,strTemp)
      endif

      xmap_sav=xmap!/volume!salvo la mappa originale e la scrivo
      lim_mappa=minval(abs(xmap_sav))/10

      xmap_var(:,:,:)=max(xmap_var(:,:,:),lim_mappa)! per non far divergere il rapporto
      xmap(:,:,:)=xmap_var(:,:,:)
      if (test) then
          call maxmin3d(denmin,denmax,avden,stden,npunt,0)
          write(6,'(a,4g15.8)') 'VARIANZA min max media st  ',
     &                  denmin,denmax,avden,stden
          strTemp = 'VARIANZA.map'
          call CCP4MAPOUT(jpatt,xmap,np,strTemp)
      endif

!--calcolo S/N--------------------------------
      xmap(:,:,:) = xmap_sav(:,:,:) / sqrt(xmap_var(:,:,:))
      if (test) then
          strTemp = 'SigNoise.map'
          call CCP4MAPOUT(jpatt,xmap,np,strTemp)
      endif
!
      return
      end
!--------------------------------------------------------------------
      subroutine TH2_FFT(AH)
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c 
      USE Mappa
      USE Param, only: scale1, f000

      implicit none
      integer:: j, s, l, k1, k2, ii, indr, jj
      real   :: aver, tt, term, term1, arg
      real   :: AH(nsymtot,nreflDim), vet2(3),rho
      integer:: iHcan(3)
      integer :: idelt, jcode, isgnn, id1, ireje
      integer :: jpatt

      AH(:,:) = 0.0
c
      do j=1,nreflDim
         do s = 1, nsym
            tt = 0.0
            do l = 1, 3
               tt = tt + float(khl(l,j)) * tmat(s,l)
            enddo
            AH(s,j) = - twopi*tt 
          enddo
      enddo
      fcvetc(:)=0.0
      fcvets(:)=0.0
      do k2=1,nsymtot
         do k1=1,nsymtot 
            if(k2==k1)cycle
            do j=1,nrefl
               do ii=1,3
                  vet2(ii)= khl(1,j)*(kmat(k1,1,ii)-kmat(k2,1,ii))+
     &                      khl(2,j)*(kmat(k1,2,ii)-kmat(k2,2,ii))+
     &                      khl(3,j)*(kmat(k1,3,ii)-kmat(k2,3,ii))
               enddo
               call controllo_indici_interi(vet2,iHcan)
               call geneq(0, iHcan(1), iHcan(2), iHcan(3), 
     *              idelt, jcode, isgnn, id1, rho, ireje)
               if(id1==0)cycle
               indr = iHcan(1)*ifat1C + iHcan(2)*ifat2C + iHcan(3)
               if (indr>0.and.indr <= ifatxC) then
                 jj = superind(indr)
                 if (jj > 0) then
                    arg=AH(k1,j)-AH(k2,j)
                    term1=evet(j)**2!(evet(j)*wt(j))**2!fovet(j)**2
                    term=term1*(1.0-(wt(j)**2))!+sigmav(j)**2
                    fcvetc(jj)=fcvetc(jj)+term*cos(arg)
                    fcvets(jj)=fcvets(jj)+term*sin(arg)
                endif
              endif
            enddo
          enddo
      enddo
c      f000=sum(fcvetc)
c      scale1=sum(fcvets)
      call MakeMapMR2(jpatt, xmap, FORTH, BACK)
      xmap = (2 * xmap)/(volume**2)
      return
      end

!-----------------------------------------------------------------------
      subroutine TD_FFT()
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c 
      USE Mappa
      USE ShellSIGMAA
      USE VarianceMod

      implicit none
      integer :: j, s, l, s2, s1, jj, indr, ii
      real    :: tt, aver, term, term1, D2, arg
      real    :: vet2(3), rho !faze,
      integer :: iHcan(3),icont,i,indlmin
      integer :: hmax1,hmax2,hmax3,indk,indl,indh
      integer :: idelt, jcode, isgnn, id1, ireje
c      real    :: modAH(nRifDimC)
      integer :: jpatt!, iphAH(nRifDimC)
      
      AH(:,:) = 0.0
c
      do j=1,nreflDim
         do s = 1, nsym
            tt = 0.0
            do l = 1, 3
               tt = tt + float(khl(l,j)) * tmat(s,l)
            enddo
            AH(s,j) = - twopi*tt
          enddo
      enddo
      fcvetc(:)=0.0
      fcvets(:)=0.0

      do s2=1,nsym
         do s1=1,nsym
            do j=1,nreflDim
               do ii=1,3
                  vet2(ii)= khl(1,j)*(kmat(s1,1,ii)+kmat(s2,1,ii))+
     &                      khl(2,j)*(kmat(s1,2,ii)+kmat(s2,2,ii))+
     &                      khl(3,j)*(kmat(s1,3,ii)+kmat(s2,3,ii))
               enddo
               call controllo_indici_interi(vet2,iHcan)
               call geneq(0, iHcan(1), iHcan(2), iHcan(3), 
     *              idelt, jcode, isgnn, id1, rho, ireje)
               if(id1==0)cycle
               indr = iHcan(1)*ifat1C + iHcan(2)*ifat2C + iHcan(3)
               if (indr>0.and.indr <= ifatxC) then
                 jj = superind(indr)
                 if (jj > 0) then
                    term1=evet(j)**2!(evet(j)*wt(j))**2!fovet(j)**2
                    if(icent==0)then
                       arg=2.* iphaz(j)*dtor + AH(s2,j) + AH(s1,j)  
                       if(wt(j)/argBess(j)>0.1.and.argBess(j)/=0)then
                          D2 = 1.0 - (2 * wt(j)/argBess(j))
                       else
                          D2=0.0
                       endif
                       term=term1*((wt(j)**2)-D2)
                    else
                       arg= AH(s2,j) + AH(s1,j)
                       term=term1*(1-(wt(j)**2))
                    endif
                    fcvetc(jj)=fcvetc(jj)+term*cos(arg)
                    fcvets(jj)=fcvets(jj)+term*sin(arg)
                endif
              endif
            enddo
          enddo
      enddo
c      f000=sum(fcvetc)
c      scale1=sum(fcvets)
      jpatt = 0 
      call MakeMapMR2(jpatt, xmap, FORTH, BACK) 
c      call MakeMapMR(xmap, xmapC, FORTH, BACK, np, FFTW_ESTIMATE)
      if(icent==0)xmap=-xmap
      xmap =  (2 * xmap)/(volume**2)
      return
      end
!-----------------------------------------------------------------------
      subroutine space_hRsRq2(iAction)
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c 

      implicit none
      integer :: iAction
      integer :: k1, k2, j, ii, indh, indk, indl, indr,icount
      integer :: hmax1, hmax2, hmax3, indkmin, indlmin, nrr
      real    :: vet2(3), rho1, rho, rhof, eps1, vet3(3)
      integer :: iHcan(3),iHcan3(3),hklmax(3),hklmm(3),hkl(3)
      integer :: idelt, jcode, isgnn, id1, ireje, nsym2

      nrr=0  
      hklmax(1:3)=-99999.0
      hklmm(1:3)=-99999.0
      nsym2=nsym
      if(icent.gt.0)nsym2=nsym*2
      do k2=1,nsym2
         do k1=1,nsym2 
            do j=1,nreflDim
               do ii=1,3
c                 if(iAction==1)then
                     vet2(ii)= khl(1,j)*(kmat(k1,1,ii)-kmat(k2,1,ii))+
     &                         khl(2,j)*(kmat(k1,2,ii)-kmat(k2,2,ii))+
     &                         khl(3,j)*(kmat(k1,3,ii)-kmat(k2,3,ii))
c                 elseif(iAction==2)then
                     vet3(ii)= khl(1,j)*(kmat(k1,1,ii)+kmat(k2,1,ii))+
     &                         khl(2,j)*(kmat(k1,2,ii)+kmat(k2,2,ii))+
     &                         khl(3,j)*(kmat(k1,3,ii)+kmat(k2,3,ii))
  
c                 endif 
               enddo
               
               call controllo_indici_interi(vet2,iHcan3)
               call controllo_indici_interi(vet3,iHcan)
               call geneq(0, iHcan(1), iHcan(2), iHcan(3), 
     *              idelt, jcode, isgnn, id1, rho, ireje)
               if(id1==0)cycle
               nrr=nrr+1 
               if(abs(iHcan(1))>hklmax(1)) hklmax(1)=abs(iHcan(1))
               if(abs(iHcan(2))>hklmax(2)) hklmax(2)=abs(iHcan(2))
               if(abs(iHcan(3))>hklmax(3)) hklmax(3)=abs(iHcan(3))
               if(abs(iHcan3(1))>hklmm(1)) hklmm(1)=abs(iHcan3(1))
               if(abs(iHcan3(2))>hklmm(2)) hklmm(2)=abs(iHcan3(2))
               if(abs(iHcan3(3))>hklmm(3)) hklmm(3)=abs(iHcan3(3))

            enddo
         enddo
      enddo
      if(hklmax(1)<hklmm(1) .or. hklmax(3)<hklmm(3) .or. 
     *   hklmax(3)<hklmm(3))then
         write(6,*)"Attenzione non funziona più lo spazioHsHq"
         stop
      endif
      call AllocaRiflessi_c(2)
 
      ihmx(:)= hklmax(:) 
      nRifDimC=nrr
      write(6,*)"nReflDimC=",nrr
      call AllocaRiflessi_c(1)
      nrr=0 
      icount=0 
      do k2=1,nsym2
         do k1=1,nsym2 
            do j=1,nrefl
               do ii=1,3
c                  if(iAction==1)then
c                     vet2(ii)= khl(1,j)*(kmat(k1,1,ii)-kmat(k2,1,ii))+
c     &                         khl(2,j)*(kmat(k1,2,ii)-kmat(k2,2,ii))+
c     &                         khl(3,j)*(kmat(k1,3,ii)-kmat(k2,3,ii))
c                  elseif(iAction==2)then
                     vet2(ii)= khl(1,j)*(kmat(k1,1,ii)+kmat(k2,1,ii))+
     &                         khl(2,j)*(kmat(k1,2,ii)+kmat(k2,2,ii))+
     &                         khl(3,j)*(kmat(k1,3,ii)+kmat(k2,3,ii))
  
c                  endif 
               enddo
               call controllo_indici_interi(vet2,hkl)
               call geneq(0, hkl(1), hkl(2), hkl(3), 
     *              idelt, jcode, isgnn, id1, rho, ireje)
               if(id1==0)cycle
               nrr = nrr + 1
               indr = hkl(1) * ifat1C + hkl(2) * ifat2C + hkl(3)
               if (indr>0.and.indr <= ifatxC) then
                   superind(indr) = nrr
                   khlc(1:3,nrr) = hkl(1:3)
c                   write(6,*)indr,hkl(1:3)
               else
                   icount=icount+1
c                   write(6,*)icount,indr,hkl(1:3)
               endif

            enddo
         enddo
      enddo
      ifRemo = 2
      call AllocaMappa(2)
      call CheckGrid()
      call AllocaMappa(1)
      return
      end
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
      subroutine StatisticaR(numb)
      USE General
      USE Riflessi
      dimension rhr(10),nhr(10),stl(10),rsv(10),den(10)
      character*2 star
!
      sumfo = 0.0
      sumfc = 0.0
      do i=1,numb
         sumfo = sumfo + fovet(i)
         sumfc = sumfc + fcvet(i)
         worko(i) = fovet(i)
      enddo
      scalan = sumfc/sumfo
      sumdf = 0.0
      sumfo = 0.0
!
      nShells = 10
      rhom = sqrt(rhomax)
      rr0 = float(nShells) / rhom
!
      rhr = 0.0
      stl = 0.0
      rsv = 0.0
      den = 0.0
      nhr = 0
!
      do i=1,numb
         rhos=sqrt(rhov(i))
c-- n stores range of rho
         n=min0(int(1.0+rr0*rhos),nShells)
         fo = fovet(i) * scalan
         df = fo - fcvet(i)
         absdf = abs(df)
         sumfo = sumfo + fo
         sumdf = sumdf + absdf
         rhr(n) = rhr(n) + absdf
         den(n) = den(n) + fo
         nhr(n) = nhr(n) + 1
      enddo
      erre = sumdf / sumfo
      rfac = 100.0 * erre
      if (knw > 0) write(lo,*) 'ERRE TOTALE = ',rfac
      do i=1,nShells
         if (nhr(i).gt.0.0) then
             rhr(i) = rhr(i) / den(i)
         else
             rhr(i) = 0.0
         endif
      enddo
      rr0 = 1.0 / rr0
      do i=1,nShells
         stl(i) = rr0 * float(i)
         rsv(i) = 0.5 / stl(i)
         rhr(i) = rhr(i) * 100.0
      enddo
      write(lo,330)
     * (stl(j),j=1, 5),(rsv(j),j=1, 5),(rhr(j),j=1, 5),(nhr(j),j=1, 5),
     * (stl(j),j=6,10),(rsv(j),j=6,10),(rhr(j),j=6,10),(nhr(j),j=6,10)
  330 format(/,22x,'***     Statistic on Residual    ***',/,20x,
     1 'Distribution of  R% vs sin(theta)/lambda',//,
     2 2(' sinth/lambda',3x,5f10.4,/,
     3   ' ',4x,'Resol.  ',3x,5f10.2,/,
     3   ' ',4x,' R%     ',3x,5f10.2,/,
     3   ' ',4x,'number  ',3x, 5i10,//))
!
      fo2max = -9999
      do i=1,numb
         fo2 = fovet(i) * fovet(i)
         if (fo2.gt.fo2max) then
             fo2max = fo2
         endif
      enddo
      rhr = 0.0
      stl = 0.0
      rsv = 0.0
      den = 0.0
      nhr = 0
      rr0 = float(nShells) / fo2max
!
      do i=1,numb
         rhos=fovet(i) * fovet(i)
c-- n stores range of rho
         n=min0(int(1.0+rr0*rhos),nShells)
         fo = fovet(i) * scalan
         df = fo - fcvet(i)
         absdf = abs(df)
         rhr(n) = rhr(n) + absdf
         den(n) = den(n) + fo
         nhr(n) = nhr(n) + 1
      enddo
      do i=1,nShells
         if (nhr(i).gt.0.0) then
             rhr(i) = rhr(i) / den(i)
         else
             rhr(i) = 0.0
         endif
      enddo
!
      rr0 = 1.0 / rr0
      do i=1,nShells
         stl(i) = rr0 * float(i)
         rhr(i) = rhr(i) * 100.0
      enddo
      write(lo,340)
     * (stl(j),j=1, 5),                (rhr(j),j=1, 5),(nhr(j),j=1, 5),
     * (stl(j),j=6,10),                (rhr(j),j=6,10),(nhr(j),j=6,10)
!
      if (knw == 9) then
          call sortall(-1, worko, numb)
          ncond = nint(float(numb) * 0.7)
          sogliaFo = worko(ncond)
          n30 = 0
          sumfo30 = 0.0
          sumdf30 = 0.0
          sumsf30 = 0.0
          n70 = 0
          sumfo70 = 0.0
          sumdf70 = 0.0
          sumsf70 = 0.0
          sumfT = 0.0
          sumdT = 0.0
          do i=1,numb
             fo = fovet(i) * scalan
             df = fo - fcvet(i)
             absdf = abs(df)
             if (fovet(i) < sogliaFo) then
                 n30 = n30 + 1
                 sumfo30 = sumfo30 + fo
                 sumdf30 = sumdf30 + absdf
                 sumsf30 = sumsf30 + df
                 star = ' *'
             else
                 n70 = n70 + 1
                 sumfo70 = sumfo70 + fo
                 sumdf70 = sumdf70 + absdf
                 sumsf70 = sumsf70 + df
                 star = '  '
             endif
             sumfT = sumfT + fo
             sumdT = sumdT + absdf
             write(6,345) i, fovet(i)*scalan, fcvet(i), star
          enddo
          erre30a = 100.0 * sumdf30 / sumfo30
          erre30s = 100.0 * sumsf30 / sumfo30
          erre70a = 100.0 * sumdf70 / sumfo70
          erre70s = 100.0 * sumsf70 / sumfo70
          erreT   = 100.0 * sumdt / sumfT
          write(lo,350) n30, numb, erre30a, erre30s, 
     *                  n70, numb, erre70a, erre70s, erreT
      endif
!
      return
  340 format(/,22x,'***     Statistic on Residual    ***',/,' ',26x,
     1 'Distribution of  R% vs F**2             ',//,
     2 2(' F**2     ',3x,5f14.1,/,
     3   '  R%      ',3x,5f14.2,/,
     3   ' number   ',3x, 5i14,//))
  345 format(i5,1h),2f10.2,a)
  350 format(/,' Using ',i5,' small reflections over ',i5,
     *         ' |R%| =',f8.2,', R% =',f8.2,/,
     *         ' Using ',i5,' large reflections over ',i5,
     *         ' |R%| =',f8.2,', R% =',f8.2,/,
     *         ' Using all reflections |R%| =',f8.2)
!
      end
!-----------------------------------------------------------------------
      subroutine Calcola_Fom_Shelx()
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Mappa
c
c
c-dedi  -- per girare in continuo con la strategia per il singolo trial
c
      do i=1,numbLSQ
         fcoef(i) = evet(i)
      enddo
      do i=1,nrefl
         tmpwt(i) = wt(i)
c        if (i.gt.numbLSQ) then
c            tmpwt(i) = 0.0
c        endif
      enddo

      if (kmad /= 0) then
          invflag = 1
          percMap = 0.035
      else
          invflag = 2        ! ATTENZIONE MAPPA POSITIVA
      endif
      fcoef(:) = fcoef(:) * wt(:)
      jpatt = 0
      call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap,
     *                FORTH, BACK)
c
c --  iwork2 = nuova fase dopo inversione (per non sporcare iphaz)
c
      call InvMap(khl,mkang,iwork2,fcvet,nrefl)
      chope = 2.0
      iAll = -1  ! riscalamento Ec con HM
!     iAll =  1
      call CalcolaPesi(nrefl,nrefl,chope,iAll)
c
Calcola il Peso wt = 1 / (0.04 + sigma(Eo) ** 2)
!     go to 999
      call CalcolaPesi_Shelx()
c
c--- fcvet = Ecal, wt = nuovo peso , iwork2 = nuova fase

 999  continue
      call Fom_CC_Shelx(CC)
      CC_Shelx = CC
!     FOMs(1,4) = CC

      do i=1,nrefl
         wt(i) = tmpwt(i)
      enddo
!
      return
      end
c-----------------------------------------------------------------------
      subroutine Fom_CC_Shelx(CC)
      USE General
      USE Riflessi
      USE PhaseModule
c
c---- calcola il CC tra Eo**2 e wt**2 
c

      sumWT        = 0.0
      sumWTEo2Ec2  = 0.0
      sumWTEo2     = 0.0
      sumWTEc2     = 0.0
      sumWTEo4     = 0.0
      sumWTEc4     = 0.0


c
      do i=1,nrefl
c
             WTTval  = wt(i)
             Eo2 = evet(i)**2
             Eo4 = evet(i)**4
             Ec2 = fcvet(i)**2
             Ec4 = fcvet(i)**4
c
             sumWT       = sumWT + WTTval 
             sumWTEo2Ec2 = sumWTEo2Ec2 + WTTval * Eo2 * Ec2
             sumWTEo2    = sumWTEo2    + WTTval * Eo2
             sumWTEc2    = sumWTEc2    + WTTval       * Ec2
             sumWTEo4    = sumWTEo4    + WTTval * Eo4
             sumWTEc4    = sumWTEc4    + WTTval       * Ec4
c
      enddo
c
      umer  = (sumWTEo2Ec2 * sumWT) - (sumWTEo2 * sumWTEc2)
      den   = ((sumWTEo4 * sumWT) - (sumWTEo2 **2)) *
     *        ((sumWTEc4 * sumWT) - (sumWTEc2 **2)) 
      den   =  sqrt(den)

      if (den.eq.0.0) then
          CC = 0.0
      else
          CC = umer / den
      endif
c

      return
      end
c-----------------------------------------------------------------------
      subroutine CalcolaPesi_Shelx()

      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE MadModule
c
      dimension na(8)
c-- calculate wilson (giw) and debye (gis) scattering factors
c
      do i=1,nk
         na(i) = nw(i)
      enddo
c
      do i=1,560
         t      = 0.01 * float(i-1)
         tt     = t * t
         gis(i) = 0.0
         giw(i) = 0.0
         do j=1,nk
            fz = ScattFact60(j, tt)
**          fz = cl(j)
**          do jj=1,4
**             bst = bs(jj,j) * tt
**             if (bst.le.60.) then
**                 fz = fz + al(jj,j) * exp(-bst)
**             endif
**          enddo
!pgMAD
            if (kmad.ne.0) then
              do ii=1,nAnom
                if (kAnom(ii).eq.nalf(j)) then
                  arg = fz + fPrimoSecondo(ii,nWaveAct,1)
                  arg = arg * arg + fPrimoSecondo(ii,nWaveAct,2) ** 2
                  fz = sqrt(arg)
                  exit
                end if
              end do
            endif
!pgMAD
            gis(i) = gis(i) + fz * fz * float(na(j))
            fnw    = float(nw(j))
            giw(i) = giw(i) + fz * fz * fnw
         enddo
      enddo
c
c--trasformo sigmaFo in sigmaEo
c
      do i=1,nrefl
         rho = rhov(i)
         eps=epsv(i)
         sigma=sigmav(i)
         sigma2= sigma * sigma

         sinth=100.0*sqrt(rho)
         ind=max0(2,int(sinth+1.5))
         frac=sinth-float(ind-1)
         bf=0.5*(giw(ind+1)-giw(ind-1))
         af=bf+giw(ind-1)-giw(ind)
         form=af*frac*frac+bf*frac+giw(ind)
         denor=form*eps
         ed = sigma2/denor

         sigma2Eo = sc*ed*exp(2.*bt*rho)
         wt(i) = 1. / (0.04 + sigma2Eo)
      enddo

      return
      end
!-------------------------------------------------------------------------------
      subroutine ScriviMappaXtal(nByte,iunit,xmap_coef,
     *                           xmap_div,ierr)
      USE General
      USE Mappa
      USE PhaseModule
!
!  DA ELIMINARE
!
c
      common /header/ amin, amax, amean, arms, nsymbt
c
!   NORN = 2 for XY sections
! The output map file is binary and contains NSYM + 2 header records 
! followed by the map.  If NORN = 0, the map is written such that each 
! record contains NX density values (one row along x), with NZ 
! consecutive records constituting each section of constant y, i.e. y is 
! slowest varying. If NORN = 1, the positions of x and y are 
! interchanged. If NORN = 2, the positions of y and z are interchanged. 
! All map values are integers scaled as described below.  When NORN=0 
! the map file is suitable for input to programs PSRCH for locating 
! peaks, to MAPINV for modification followed by inversion, to MAPVIEW 
! for interactive contouring and display, to GMAP for conversion to
! TOM/O or CHAIN formats and for creation of skeletons, or to CTOUR to
! create hard copies of contoured plots. If NORN is nonzero the only
! recourse is to print the map within this program.
        
      nrec = 0
      nrow = np(1)
      ncol = np(2)
      npla = np(3)
      do i=0,npla-1
         do j=0,ncol-1
            write(iunit,iostat=ier,err=1000) 
     *            nint( xmap(0:nrow-1, j, i) * xmap_coef )
         enddo
      enddo
!
      return
!
 1000 write(Msg, 1100) ier,iunit
 1100 format(' ScriviMappaXtal: write Error ',i3,' on unit ',i5)
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      ierr = -1
      return
c
      end
!-----------------------------------------------------------------------
      subroutine VaiInP1()
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseStuff
      USE Mappa
      USE Atomi
      USE PhaseModule
!
      integer i1(3), i2(3), i3(3)
      dimension vet2(3), delta(3)
      integer, allocatable :: superind (:)
      integer, allocatable :: phir (:)
!
      call CheshireTra()
      numb = numbLSQ
      ifat1 = (2 * ihmx(3) + 1) * (2 * ihmx(2) + 1)
      ifat2 = (2 * ihmx(3) + 1)
      ifatx = ihmx(1) * ifat1 + ihmx(2) * ifat2 + ihmx(3)
      allocate (superind(1:ifatx), stat = ierr)
      allocate (phir(1:numb*nsym), stat = ierr)
      iphazo(1:numb) = iphaz(1:numb)
      wto(1:numb) = wt(1:numb)
      phir(:) = 0
      iphaz(1:numb) = 0
      superind(1:ifatx) = 0
!
      n = 0
      do i=1, numb
         worko(i) = dtor * iphazo(i)
         i1(1:3) = khl(1:3,i)
         do j=1,nsym
            tt=1000.0
            do l=1,3
               tt=tt+float(i1(l))*tmat(j,l)
               i2(l) = 0
c
               do k=1,3
                  i2(l) = i2(l) + i1(k) * kmat(j,k,l)
               enddo
c
            enddo
            n = n + 1
            phir(n) = iphazo(i) - 360 * tt
            call controlla_indici(i2,i3)
            indr = i3(1)*ifat1 + i3(2)*ifat2 + i3(3)
            if (indr > 0) then
                superind(indr) = i
            else
               gianluca = 1
            endif
         enddo
      enddo

!
      do i=1, numb
         do k2=1, nsym - 1
            n2 = k2 + (i -1) * nsym
            n1 = n2
            do k1=k2+1, nsym
               n1 = n1 + 1
               tt = 0
               do k=1,3
                  vet2(k) = khl(1,i)*(kmat(k1,1,k)-kmat(k2,1,k))
     &                    + khl(2,i)*(kmat(k1,2,k)-kmat(k2,2,k))
     &                    + khl(3,i)*(kmat(k1,3,k)-kmat(k2,3,k))
                  tt = tt + khl(k,i)*(tmat(k1,k)-tmat(k2,k))
               enddo
               call controllo_indici_interi(vet2, i3)
!
!-- seleziono i riflessi H
!
               indr = i3(1)*ifat1 + i3(2)*ifat2 + i3(3)
               if (indr > 0 .and. indr <= ifatx) then
                   kk = superind(indr)
                   if (kk > 0) then
!
!--calcolo i coefficienti
!
                       arg = - (phir(n1) - phir(n2) + 360*tt)
                       term = fovet(i) ** 2
                       iphaz(kk) = 0.0
                       arg = dtor*arg
                       fcoef(kk) = term * cos(arg)
                       tmpwt(kk) = term * abs( sin(arg) )
                       wt(kk) = 1.0
                       numbPhased = numbPhased + 1
                   endif
               endif
            enddo
         enddo
      enddo
!
      alim=nGridv(1)*nGridv(2)*nGridv(3)  
      lattSav = latt
      nsymSav = nsym
      ihalfSav = ihalf
      nsymTav = nsymTot
      latt = 1 ! evita di considerare la centratura
      nsym = 1 ! lavora in P1
      nsymTot = 1
      fcoef(:) = fcoef(:) * wt(:)
      jpatt = 0
      call MakeMap(fcoef, iphaz, numb, jpatt, xmap,
     *                FORTH, BACK)
      xenve = xmap
      do i=1, numb
         fcoef(i) = tmpwt(i) * wt(i)
      enddo
      call MakeMap(fcoef, iphaz, numb, jpatt, xmap,
     *                FORTH, BACK)
      xmap = xenve - xmap
      if (nGridv(1) == 1) then
          xmap(1:np(1)-1,0:np(2)-1,0:np(3)-1) = 0.0
      elseif (nGridv(2) == 1) then
          xmap(0:np(1)-1,1:np(2)-1,0:np(3)-1) = 0.0
      elseif (nGridv(3) == 1) then
          xmap(0:np(1)-1,0:np(2)-1,1:np(3)-1) = 0.0
      endif
      nats=0
      xyzs(:,:)=0.0
      krecy=0
      ihalf=0  ! per fare il peak search su tutta la cella
      term=alim/10.0
      aperc(1)=max(50.0,term)
      call Search99(-1,ier,nreflDim)
      nRis = 0
      do i = 1 , nats
c        write(6,*) 'picco trovato ',i,xyzs(1:3,i),xyzs(4,i)
         delta(1) = side( xyzs(1,i) )
         delta(2) = side( xyzs(2,i) )
         delta(3) = side( xyzs(3,i) )
         if (inCheshire(delta) == 1) then
            if (jsys == 6 .and. i > 1) then
                 diff = abs( delta(1) - side( xyzs(1,i-1) ))
                if (abs( diff - 0.5 ) < 0.01) then
                    diff = abs( delta(2) - side( xyzs(2,i-1) ))
                    if (abs( diff - 0.5 ) < 0.01) then
                        diff = abs( delta(3) - side( xyzs(3,i-1) ))
                        if (abs( diff - 0.5 ) < 0.01) then
                            cycle
                        endif
                    endif
                endif
             endif
c
             nRis = nRis + 1
             if (nRis == 1) then
                 vet2(:) = delta(:)
             endif
             write(6,'(i5,3f10.4,f10.1)') nRis, delta, xyzs(4,i)
         endif
      enddo
      write(6,*) numbPhased, ' riflessi fasati'
      if (nRis == 0) then
         write(6,*) 'nessun picco trovato'
         delta(:) = 0
      else
         delta(:) = vet2(:)
      endif
      delta(1:3) = - delta(1:3)
      do i=1,numbLSQ
         faze = worko(i) - twopi *
     *       (khl(1,i)*delta(1) + khl(2,i)*delta(2) + khl(3,i)*delta(3))
         work2(i) = faze
         iphz = nint(faze*rtod)+360000
         iphaz(i) = mod(iphz, 360)
         fcoef(i) = evet(i)
*        write(6,11) i,khl(1:3,i), iphazo(i),iphaz(i),worko(i)
11       format(i6,1h),3i4,5x,2i5,f9.3)
      enddo
      ifExamin = 1
      izero = 0
      ifmin = 11
      call examin(-333,mkang,khl,ipub,iphaz,numb,izero,wt,ifmin)
!
      latt = lattSav
      nsym = nsymSav
      nsymTot = nsymTav
      ihalf = ihalfSav

      deallocate (superind, stat = ierr)
      deallocate (phir, stat=ierr)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine TornainSG_old(ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE TestStuff
      USE Mappa
      USE PhaseModule
c--
c
      common /cent/ tl(3,4),fs(3,3,24),mlat
      common /centsav/ tlsav(12),fsSav(216)
      common/passainp1com/numbLSQ_Sav,numbInv_Sav,
     &               nreflDim_Sav,nrefl_Sav,ifExamin_Sav,
     &               icent_Sav,pts_Sav
!
      call AllocaTestStuff(2)

      write(6,*) ' TORNA IN SG'
      ifP1Pat = 0
      ifReduced = 0
      call AllocaTestStuff(1)  ! ripristina ifFloatOrigin e FT

      call AllocaRiflessi(2)
*     call AllocaRiflessiSIGMAA(2)
      call InitSigmaA(2)
!
      ifExamin = ifExamin_Sav
      icent    = icent_Sav
      nsym     = nsymTrue
      pts      = pts_Sav
      totop    = pts * float( ( icent + 1 ) * nsym )
      nsymTot  = nsym*(icent+1)*pts
c
      mlat =  pts
      k = 0
      do i=1,3
         do j=1,4
            k = k + 1
            tl(i,j) = tlSav(k)
         enddo
      enddo
      k = 0
      do i=1,3
         do j=1,3
            do l=1,24
               k = k + 1
               fs(i,j,l) = fsSav(k)
            enddo
         enddo
      enddo
c
      jspini = -1
      call xspinb
      numbLSQ = numbLSQ_Sav
      numbInv = numbInv_Sav
      nreflDim = nreflDim_Sav
      nrefl = nrefl_Sav
      nstr = nstrSav
!
      call AllocaRiflessi(1)
*     call AllocaRiflessiSIGMAA(1)
      ksubr = 3
      call LeggiRiflessi(ier,ksubr)
      call InitSigmaA(1)
!
      return

      call NewInv(iphaz,fcvet,numbLSQ,np(1),np(2),np(3), BACK)
      iAll = 1
      chope = 0.5
      call CalcolaPesi(numbLSQ,numbLSQ,chope,iAll)

      izero = 0
      ifmin = 1
      call examin(-555,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,ifmin)

   
      return
      end
!-----------------------------------------------------------------------
      subroutine SFC_PDB(ier)
      USE General
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Mappa
!
!-- compute SFC from *.PDB
!
      character*256 knwfile
     
!
      FraFilePath = '/server/public/proteins/pdb/'
      kpath = Lung(FraFilePath)
      k=index(fname(1),'.bin')
      knwfile = FraFilePath(1:kpath)//fname(1)(1:k)//'pdb'

      import = kQualeFormato(knwfile)
      itipo=2
      iform=1
      if (jopen(jhost,knwfile,itipo,iform,ios).lt.0) then
          ier = -1
          knw = 0
          Msg = 'Coordinate file: '// knwfile(1:Lung(knwfile))//
     *                            ' not found'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          return
      endif
      ScSav = sc
      sc = 1
      call ManagePDBSir(0, 1, 1, 0, 0, ier)
      close(jhost)
!
      sc = ScSav
      if (ier < 0) then
          write(lo,*) 'Error Reading Coordinates'
          knw = 0
          return
      endif
      call toflush()
!
      nzsav(1:nats) = nz(1:nats)
      nz(1:nats) = nz(1:nats) / nzConst
!     bfac(1:nats) = 10.0
      aaa = sum(bfac(1:nats))
      bbb = aaa / float(nats)
      
      iref  = 0
      mode  = 1
      numb = nrefl  ! sino alla risoluzione reale
!     numb = nreflDim  ! sino alla risoluzione generata
      ifBreak = 0
      iCoeff = 2
      call sftryyyc(iref,mode,numb,scalan,ifBreak,iCoeff)
      RSir = erre * 100.0
      nz(1:nats) = nzsav(1:nats)
!
      write(lo,10) RSir, bbb
!
!     fcoef(1:nrefl) = fcvet(1:nrefl)  !Fcal
      fcoef(1:nrefl) = work1(1:nrefl)  !Ecalc
      wt(:) = 1

      luset = 12345
      izero = 0
      ifmin = 1
      call examin(luset,mkang,khl,ipub,iphaz,numb,izero,wt,ifmin)

      fcoef(:) = fcoef(:) * wt(:)
      jpatt = 0
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                FORTH, BACK)
!
!     percmap = 0.7
!     invflag = 1
      percmap = 1
      invflag = 0
      call ModificaMappa()

      aperc(1) = nats
      iflagPKS = 0
      mode = -1
      krecy = 0
      nnuu = numb
      call pksrch_New(mode, iflagPKS, nnuu,ier)

      kdst = 1
      call to_coord_sir(kdst, numb)
!
      invflag = 0
      call InvMap(khl,mkang,iphaz,fcvet,numb)
      luset = 67890
      izero = 0
      ifmin = 1
      call examin(luset,mkang,khl,ipub,iphaz,numb,izero,wt,ifmin)

      call toflush()
!
      return
   10 format(' *** R Factor = ',f6.2,'% ***   Bmedio =',f8.2)
      end
!-----------------------------------------------------------------------
      subroutine calc_dist_stat()
      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
!
      common /matr/rm(3,3),rmi(3,3)
c
      dimension x1(3),rrv(3)
      dimension distri(3,501),dista(501)
c           
      a = cell(1)
      b = cell(2)
      c = cell(3)
      alfa = cell(4)
      beta = cell(5)
      gam  = cell(6)
      call Orto_new(a,b,c,alfa,beta,gam)
      do i = 1, nats
         x1(1:3)=xyzs(1:3,i)
         call MoltMatVec(rm, x1, rrv)
         xyzSk(1:3,i) = rrv(1:3)
      end do
c
      nsymPatt=nsym*2*pts
      natsMR = nats
      distmaxPdb=-9999                
      distri(:,:) = 0.0

      step1 = 0.1
      step2 = step1 / 2.

      do i = 1, 501
         ii = i-1
         dista(i) =  (ii * step1)
      enddo
c
      indice:do j1=1, natsMR-1
        ciclo:   do j2=j1+1,natsMR

          dist = 0
          do i=1,3
             dist = dist + (xyzSk(i,j1)-xyzSk(i,j2))**2
           end do
           dist = sqrt(dist)
           if (dist < 5.0) then
               do ii = 2,501  
                  jj = ii - 1
                  if (dist >= dista(jj) .and. dist < dista(ii)) then
                      distri(1,jj)=distri(1,jj) + 1.
                      distri(2,jj)=distri(2,jj) + dist
                      distri(3,jj)=dista(jj)  + step2
                  endif
               enddo
           endif
         
        end do ciclo
      end do indice   
      do ii = 2,501 
         jj = ii - 1 
         dd = distri(1,jj)/natsMR
         write(55,20) jj,distri(3,jj),distri(1,jj),dd
      enddo
  20       format (i5,3f15.3)
c
!          call cstop ('9999')


      return 
      end
!---------------------------------------------------------------------
      subroutine CombinePhase(numb,correl, ifBreak)
      USE General
      USE Symmetry
      USE Riflessi
      USE Molcom
      USE RemoModule
      USE PhaseModule


      write(lo,*)'prima:',sum(worko(:))/count(worko(:)>0.0)
      write(lo,*)'dopo:',sum(wt(:))/count(wt(:)>0.0)
      sclawt=sum(wt(:))/count(wt(:)>0.)/sum(worko(:))/count(worko(:)>0.)
!
c
c--vario linearmente il contributo delle fasi Patterson
c
!     x=indiceMacro
!     x1=1
!     x2= nMacro
!     y1=1.0
!     y2=0.1
!     call varlinear(x,x1,x2,y,y1,y2)
!     pold=y
      pold = 0.90/ (1.0+Iterazione)
      pnew = 1. - pold
!
      do j=1, numb
          wti = worko(j)
          wtj = wt(j)
          if (wti > 0.001 .and. wtj > 0.001) then

              if (mkang(j) == 1) then
                  g_in = besinv(wti)
                  g_cu = besinv(wtj)
              else
                  g_in = atanhILM(wti)
                  g_cu = atanhILM(wtj)
              endif
              tannum = pold*g_in * sin( dtor * iphazo(j) ) +
     *                 pnew*g_cu * sin( dtor * iphaz(j) )
              tanden = pold*g_in * cos( dtor * iphazo(j) ) +
     *                 pnew*g_cu * cos( dtor * iphaz(j) )
              iphaz(j) = nint(mod(rtod*atan2(tannum,tanden)+
     *                                3600.,360.))
              arg = sqrt( tannum * tannum + tanden * tanden )
              wt(j) = bes(arg)
          endif
      enddo
!
      if (knw == 1) then
           call toflush()
      endif
!
      if (knw.eq.1) then
          kstp = 1
          write(lo,*) 'COMBINA FASI'
          call Calcola_CC_Mappa(numbLSQ,correl,kstp,2)
      endif
!
      return
      end
!------------------------------------------------------------------------------
      subroutine CalcolaE(ifTest)
      USE General
      USE Symmetry
      USE Atomi
      USE Riflessi
      USE PhaseModule
      USE HistoStuff
      USE Mappa
!
      if (knw == 1) then
          call AllocaTestStuff(1)
      endif
      if (.not.allocated(fcvetv)) then
          allocate(fcvetv(1:nreflDim), stat = ier)
          if (ier < 0) return
      endif
!
      write(6,*)
      if (ifTest < 0) then
          write(6,*) 'E calcolati con Resolution Bias'
      elseif (ifTest > 0) then
          write(6,*) 'E calcolati dal modello pubblicato'
      else
          write(6,*) 'E calcolati dalla Patterson osservata'
      endif
      write(6,*)
      if (ifTest < 0) then
          call InitFour(0,ier)
          natsSav = 2 * MaxAtoms
          call AllocaAtomi(2)
          nats = natsSav
          call AllocaAtomi(-1)
c
c-- calcolo della jtable
c
          call seminv(ier)
c
c--preparo la funzione di correzione
c
          numbMax = nrefl
          call IndagaMappaPat(numbMax,ier) ! modelPat
          iorig=0
          do i=1,nsym
            do j=1,3
              if(tmat(i,j)>0.0) iorig=1
            enddo
          enddo
!
          call Switch_to_Patterson_Group
!
          fcoef(:) = evet(:) ** 2
          wt(:) = 1.0
!
          fcoef(:) = fcoef(:) * wt(:)
          jpatt = 1
          call MakeMap(fcoef, iphaz, numbMax, jpatt, xmap,
     *                FORTH, BACK)
!
          call CorreggiMappaPat(numbMax,iorig,ier) ! modelPat
          invflag = 0
          percMap = 0
          call InvMap(khl, mkang, iphaz, fcvet, nreflDim)
          fcvet(:) = sqrt(fcvet(:))
          fcvetv(1:nrefl) = evet(1:nrefl)
          fcvetv(nrefl+1:nreflDim) = fcvet(nrefl+1:nreflDim)
          call E2F()
!
!-- porta gli E estrapolati a <E**2> = 1.0
!
          aww = 0.0
          tot = 0.0
          do i=nrefl+1, nreflDim
             tmul = float(mult(i))
             aww = aww + tmul
             if (fcvetv(i) > 3.0) write(6,*) 'FCVETV',fcvetv(i)
             tot = tot + tmul * fcvetv(i)**2
          enddo
          tot = tot / aww
          scala = 1.0/tot
*         fcvetv(nrefl+1:nreflDim)=fcvetv(nrefl+1:nreflDim)*sqrt(scala)
!
          call Switch_from_Patterson_Group
!
      elseif (ifTest == 0) then
!
          numb = nreflDim
          fcoef(:) = evet(:) ** 2
*         fcoef(:) = fovet(:) ** 2
          wt(:) = 1.0
          fcoef(nrefl+1:nreflDim) = 1
       nkkk = 1
       do kkkk =1, nkkk
          call Switch_to_Patterson_Group
          fcoef(:) = fcoef(:) * wt(:)
          jpatt = 1
          call MakeMap(fcoef, iphaz, numb, jpatt, xmap,
     *                FORTH, BACK)
          call Switch_from_Patterson_Group
          numb = nreflDim
          invflag = 2
*         if (kkkk == nkkk) invflag = 0
          percMap = 0
          call InvMap(khl, mkang, iphaz, fcvet, numb)
!
*         call F2ENew1() ! riempie fcvetv
*         fcvet(1:nrefl) = evet(1:nrefl)
*         fcvet(nrefl+1:nreflDim) = fcvetv(nrefl+1:nreflDim)
*         go to 1
!
          fcvet(:) = sqrt(fcvet(:))

          call AllocaHistoStuff(1)
          kk = -1
          call InitHistMatchTheo(kk)

!
!--applico l'HM rispetto alle curve teoriche degli E
!
          numberToUse=nreflTot
!          
          icont=0
          do i=1,numberToUse ! default
            icont=icont+1
            vetmatchin(icont)=fcvet(i)  ! default
!           write(99,'(i8,4f15.2)') i,sqrt(rhov(i)),evet(i),fcvet(i),wt(i)
          enddo
          call HistMatchTheo(icont)
          icont=0
          do i=1,numberToUse ! default
            fcvetv(i)=vetmatchin(i)
!           write(101,'(i8,4f15.2)') i,sqrt(rhov(i)),evet(i),fcvetv(i),wt(i)
          enddo
          aww = 0.0
          tot = 0.0
          do i=nrefl+1, nreflDim
             tmul = float(mult(i))
             aww = aww + tmul
             tot = tot + tmul * fcvetv(i)**2
          enddo
          tot = tot / aww
          scala = 1.0/tot
*         fcvetv(nrefl+1:nreflDim)=fcvetv(nrefl+1:nreflDim)*sqrt(scala)
          fcoef(1:nrefl) = evet(1:nrefl) ** 2
          fcoef(nrefl+1:nreflDim) = fcvetv(nrefl+1:nreflDim) ** 2
          wt(:) = 1
      enddo
          go to 1
          fcvet(1:nrefl) = evet(1:nrefl)
          fcvet(nrefl+1:nreflDim) = fcvetv(nrefl+1:nreflDim)
          call sigmaAA(fcvet,nreflDim)
          fcvetv(nrefl+1:nreflDim) = fcvet(nrefl+1:nreflDim)

    1     continue
!
      else
!
          call F2ENew1() ! riempie fcvetv
!
      endif
!
      n8 = 0
      n12 = 0
      do i=nrefl+1, nrefltot
         evet(i) = fcvetv(i)
         if (evet(i) > 0.8) then
             n8 = n8 + 1
             if (evet(i) > 1.2) then
                 n12 = n12 + 1
             endif
         endif
      enddo
!
      deallocate (fcvetv, stat = ierr)
      write(6,*) 'n8,n12',n8,n12
!
      call AllocaHistoStuff(2)
!
      return
      end
!---------------------------------------------------------------------
!     subroutines per ELICA
!---------------------------------------------------------------------
      subroutine Switch_to_Patterson_Group
      USE Symmetry
!
!-- switch to the Patterson Space Group
!
      icent = 1
      tmat(:,:) = 0.
      call musym()
      nsymTot = nsym * ( icent + 1 ) * pts
!
      return
      end
!---------------------------------------------------------------------
      subroutine Switch_from_Patterson_Group
      USE Symmetry
!
!-- restore the original Space Group
!
      implicit none
      integer :: ier, k, i, j
!
      ier = 0
      call CreaSymmetryInfo(ier)
!
      return
      end
!---------------------------------------------------------------------
      Subroutine CombinazioniSemplici(CombiS, N, NR, K)
!
!   Ritorna, nella matrice CombiS(Cnk(N, K), K) con N >= K e K > 0,
!   le combinazioni semplici di N oggetti della classe K:
!
      Integer   N, K, R, NR, C, P, CombiS(NR,K)

      ! Scrivo la prima riga:
      Do C = 1, K
         CombiS(1, C) = C
      end do

      ! Righe rimanenti:
      do R = 2, NR

         P = K
         Do While (CombiS(R - 1, P) >= N - K + P)
            P = P - 1
         enddo

         do C = 1, P - 1
            CombiS(R, C) = CombiS(R - 1, C)
         end do

         CombiS(R, P) = CombiS(R - 1, P) + 1

         do C = P + 1, K
            CombiS(R, C) = CombiS(R, C - 1) + 1
         end do

      end do
!      do i=1, NR
!         write(6,'(i3,1h),10i5)') i, CombiS(i,1:K)
!      end do

      return
      end
!-----------------------------------------------------------------------
      Integer Function Cnk(N, K)
!
!   Ritorna il numero delle combinazioni semplici
!   di N oggetti presi a gruppi di K. Se K = 0 e',
!   per definizione, Cnk(N, 0) = 1:
!
      Integer   Prodotto

      Cnk = Prodotto(N, N - K + 1) / Prodotto(K, -1)
!
      return
      end
!---------------------------------------------------------------
      Subroutine DisposizioniSemplici(DispoS, N, NR, K)

!      Ritorna, nella matrice DispoS(Dnk(N, K), K) con N >= K
!      e K > 0, le disposizioni semplici di N oggetti della classe K.
!      Se K = N calcola le permutazioni di N oggetti.

       Integer*4 R, NR, C, cr, P, DispoS(NR,K)
       Integer*4 NG1, DG1, NG2, DG2 !Numero e dimensioni dei sottogruppi


       DG2 = NR
       do C = 1 , K
          R = 1
          NG1 = NR / DG2
          DG1 = DG2
          NG2 = N - C + 1
          DG2 = DG1 / NG2
          do L = 1, NG1
             P = 1
             do J = 1 , NG2
                if (P > N)  P = 1
   88           do cr = 1 , C - 1
                   if (P == DispoS(R, cr)) then
                       P = P + 1
                       goto 88
                   endif
                enddo
                do I = 1 , DG2
                   DispoS(R, C) = P
                   R = R + 1
                enddo
                P = P + 1
             enddo
          enddo
       enddo
       return
      end
!-----------------------------------------------------------------------
      subroutine Stima_E
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseStuff
      USE PhaseModule
      USE VLDmod_1
      dimension evet_form1(200000), evet_form2(200000)
c===============================================================
      if (.NOT. ALLOCATED(SigmaN))
     *     ALLOCATE (SigmaN(1:nrefl), stat = ier3)
      if (.NOT. ALLOCATED(es))
     *     ALLOCATE (es(1:nrefl), stat = ier2)

      evet_form1(1:200000) = 0.0
      evet_form2(1:200000) = 0.0
      do ll= 1,nstr
         k=iordeTang(ll)
         jcris=0
         ist = 4
         li=limref(1,k)*ist+1
         ls=limref(1,k+1)*ist
         ii = 0
         if (li.le.ls) then
             enne = limref(1,k+1) - limref(1,k)
             do jj= li,ls,ist
                ira = iabs(iph(jj))
                ila = iabs(iph(jj+1))
                evet_form1(k) =  evet_form1(k) +
     *                           evet(ira)**2 * evet(ila)**2
                evet_form2(k) =  evet_form2(k) +
     *                       (evet(ira)**2 - 1.0) * (evet(ila)**2 - 1.0)
                ii = ii + 1
*               if (k == 272) then
*                   write(6,1) ii, evet_form1(k), evet_form2(k),
*    *                         evet(ira), evet(ila)
*   1 format(i5,4f10.4)
*               endif
*               if (ll == 1) then
*                  write(lo,'(3i5,3f8.3,2f12.5)') k,ira,ila,evet(k),
*    *                   evet(ira),evet(ila),evet_form1(k),evet_form2(k)
*               end if
             enddo
         endif
         evet_form1(k) = (1./enne) * evet_form1(k)
         evet_form2(k) = 1.0 + (1./enne) * evet_form2(k)
      enddo


      evet_form1(1:nstr) = sqrt(evet_form1(1:nstr))
      evet_form2(1:nstr) = sqrt(evet_form2(1:nstr))

*     do i=1,nstr
*        write(6,2) i, evet_form1(i),evet_form2(i)
*   2    format(i5,2f8.3)
*     enddo
! calcolo residuo per evet_form1
      call Calcola_SigmaN_es

      work1(1:nstr) = evet_form1(1:nstr) * SigmaN(1:nstr)
      sumfo = sum(fovet(1:nstr))
      sumfc = sum(work1(1:nstr))
      scala = sumfo / sumfc
      anum = sum(abs(fovet(1:nstr)-scala*work1(1:nstr)))
      aden = sum(fovet(1:nstr))
      rfac_form1 = 100.*anum/aden

! calcolo residuo per evet_form2

      work1(1:nstr) = evet_form2(1:nstr) * SigmaN(1:nstr)
      sumfo = sum(fovet(1:nstr))
      sumfc = sum(work1(1:nstr))
      scala = sumfo / sumfc
      anum = sum(abs(fovet(1:nstr)-scala*work1(1:nstr)))
      aden = sum(fovet(1:nstr))
      rfac_form2 = 100.*anum/aden

      write(lo,'(a,f8.2,a,f8.2)') ' Form1. R% =',rfac_form1,
     *                            ' Form2. R% =',rfac_form2

      stop
!
      return
      end
!--------------------------------------------------------------------
      subroutine StatErre_perShellExtra()
c
c--confronta gli F obs (work1) con gli F calc (work2)
c
      USE General
      USE Symmetry
      USE Riflessi
      USE TestStuff
      USE RenorArrays
!
      integer nrf(101), reflres(10)
      real fosum(10), fcsum(10), dfsum(10), scalares(10)
      real minmaxres(2,10)
!
      numb = nrefl
      sumfc = sum(fcvet(:))
      if (sumfc < 0.001 .and. knw > 0) then
          write(lo,*) ' Subroutine StatErre_perShell: 
     *     *** Fcalc not available! ***'
          return
      endif

      write(lo,11) 

      numint = interv
!
      work1(1:numb) = fovet(1:numb)
      call sortall(-1,work1,numb)
      nn1 = percRefl * numb
      if (nn1 <= 0) then   ! se numb < 100 ... (strutture micro, ...)
          nn1 = 1
      endif
      sogliaFo = work1(nn1)
!     sogliaSg = 10.
!     sogliaRs = 10.


      erref = 0.0
      sca = 1.0
      sumdf=0.0
      sumfo=0.0
      sumfc=0.0
      do i=1,numb
!?!      if(wt(j)==0) cycle
         sumfo = sumfo + fovet(i) 
         sumfc = sumfc + fcvet(i) 
      enddo
      sca = sumfo / sumfc
      do i=1,numb
         work1(i) = fovet(i)
         work2(i) = sca * fcvet(i)
         sumdf=sumdf+abs( work1(i)-work2(i) )
      enddo
      erref = (sumdf/sumfo) * 100
      write(lo,*) ' Subr. StatErre_perShell: Rf%', erref, ' su ',numb,
     * ' riflessi'
!
!--calcola gli RF in intervalli di F osservato
!
      exmax = sogliaFo
      exmin = minval(work1(1:numb))
      eint=(exmax-exmin)/float(numint)
!
      write(lo,101)
!
      sumdfcum=0.0
      sumfocum=0.0
      erecum=0.0
      nrf(:) =  0

      sumdf=0.0
      ere=0.0
      elim2=exmax
      sumfo=0.0
      sumdf=0.0
      numnn=0
      do k=1,numb
         if (work1(k).lt.elim2) cycle
         numnn=numnn+1
         sumdf=sumdf+abs( work1(k)-work2(k) )
         sumfo=sumfo+work1(k)
         sumdfcum=sumdfcum+abs( work1(k)-work2(k) )
         sumfocum=sumfocum+work1(k)
      enddo
      nrf(1)=numnn
      if(sumfo.gt.0.0) ere=(sumdf/sumfo)*100.0
      if(sumfocum.gt.0.0) erecum=(sumdfcum/sumfocum)*100.0
      write(lo,12) elim2,ere,erecum,numnn,nrf(1)

      do j=1,numint
        sumdf=0.0
        ere=0.0
        elim1=exmax-(j-1)*eint
        elim2=elim1-eint
        if(elim2 < 0.001) elim2=-0.0001
        sumfo=0.0
        sumdf=0.0
        numnn= 0
        do k=1,numb
          if(work1(k).lt.elim1.and.work1(k).ge.elim2) then
            numnn=numnn+1
            sumdf=sumdf+abs( work1(k)-work2(k) )
            sumfo=sumfo+work1(k)
            sumdfcum=sumdfcum+abs( work1(k)-work2(k) )
            sumfocum=sumfocum+work1(k)
          endif
        enddo
          nrf(j+1)=numnn+nrf(j)
        if(numnn.eq.0) cycle 
        if(sumfo.gt.0.0) ere=(sumdf/sumfo)*100.0
        if(sumfocum.gt.0.0) erecum=(sumdfcum/sumfocum)*100.0
        if(elim2 < 0.001) elim2=0.0
        write(lo,13) elim1,elim2,ere,erecum,numnn,nrf(j+1)
      enddo

!
!--calcola gli RF in intervalli di Fo/sigmaFo
!
      do j=1,numb
         worko(j)=fovet(j)/sigmav(j)
      enddo
      exmax = sogliaSg
      exmin = minval(worko(1:numb))
      eint=(exmax-exmin)/float(numint)

      write(lo,102)

      sumdfcum=0.0
      sumfocum=0.0
      erecum=0.0
      nrf(:) =  0

      sumdf=0.0
      ere=0.0
      elim2=exmax
      sumfo=0.0
      sumdf=0.0
      numnn=0
      do k=1,numb
         if (fovet(k) < 0.001) then
             sig = 0.0
         else
             sig=fovet(k)/sigmav(k)
         endif
         if (sig.lt.elim2) cycle
         numnn=numnn+1
         sumdf=sumdf+abs( work1(k)-work2(k) )
         sumfo=sumfo+work1(k)
         sumdfcum=sumdfcum+abs( work1(k)-work2(k) )
         sumfocum=sumfocum+work1(k)
      enddo
      nrf(1)=numnn
      if(sumfo.gt.0.0) ere=(sumdf/sumfo)*100.0
      if(sumfocum.gt.0.0) erecum=(sumdfcum/sumfocum)*100.0
      write(lo,12) elim2,ere,erecum,numnn,nrf(1)

      do j=1,numint
        sumdf=0.0
        ere=0.0
        elim1=exmax-(j-1)*eint
        elim2=elim1-eint
        if(elim2 < 0.001) elim2=-0.0001
        sumfo=0.0
        sumdf=0.0
        numnn= 0
        do k=1,numb
           if (fovet(k) < 0.001) then
               sig = 0.0
           else
               sig=fovet(k)/sigmav(k)
           endif
           if(sig.lt.elim1.and.sig.ge.elim2) then
              numnn=numnn+1
              sumdf=sumdf+abs( work1(k)-work2(k) )
              sumfo=sumfo+work1(k)
              sumdfcum=sumdfcum+abs( work1(k)-work2(k) )
              sumfocum=sumfocum+work1(k)
           endif
        enddo
        nrf(j+1)=numnn+nrf(j)
        if(numnn.eq.0) cycle
        if(sumfo.gt.0.0) ere=(sumdf/sumfo)*100.0
        if(sumfocum.gt.0.0) erecum=(sumdfcum/sumfocum)*100.0
        if(elim2 < 0.001) elim2=0.0
        write(lo,13) elim1,elim2,ere,erecum,numnn,nrf(j+1)
      enddo

!
!--calcola gli RF in intervalli di risoluzione
!

      exmax = sogliaRs
      exmin = resm
      eint=(exmax-exmin)/float(numint)

      write(lo,103)

      sumdfcum=0.0
      sumfocum=0.0
      erecum=0.0
      nrf(:) =  0

      sumdf=0.0
      ere=0.0
      elim2=exmax
      sumfo=0.0
      sumdf=0.0
      numnn=0
      do k=1,numb
         ris=0.5/sqrt(rhov(k))
         if (ris.lt.elim2) cycle
         numnn=numnn+1
         sumdf=sumdf+abs( work1(k)-work2(k) )
         sumfo=sumfo+work1(k)
         sumdfcum=sumdfcum+abs( work1(k)-work2(k) )
         sumfocum=sumfocum+work1(k)
      enddo
      nrf(1)=numnn
      if(sumfo.gt.0.0) ere=(sumdf/sumfo)*100.0
      if(sumfocum.gt.0.0) erecum=(sumdfcum/sumfocum)*100.0
      write(lo,12) elim2,ere,erecum,numnn,nrf(1)

      elim1 = exmax + eint
      numint = 100
      do j=1,numint
        sumdf=0.0
        ere=0.0
*       elim1=exmax-(j-1)*eint
        if (elim2 < 2.0) then
            eintt = 0.1
            elim1 = elim2
            elim2 = elim1 - 0.1
        else
            eintt = eint
            elim1=elim1 - eint
            elim2=elim1-eint
        endif
*       if(elim2 < 0.001) elim2=-0.0001
        if(elim2 < 0.001) exit
        sumfo=0.0
        sumdf=0.0
        numnn= 0
        do k=1,numb
           ris=0.5/sqrt(rhov(k))
           if(ris.lt.elim1.and.ris.ge.elim2) then
              numnn=numnn+1
              sumdf=sumdf+abs( work1(k)-work2(k) )
              sumfo=sumfo+work1(k)
              sumdfcum=sumdfcum+abs( work1(k)-work2(k) )
              sumfocum=sumfocum+work1(k)
           endif
        enddo
        nrf(j+1)=numnn+nrf(j)
        if(numnn.eq.0) cycle
        if(sumfo.gt.0.0) ere=(sumdf/sumfo)*100.0
        if(sumfocum.gt.0.0) erecum=(sumdfcum/sumfocum)*100.0
        if(elim2 < 0.001) elim2=0.0
        write(lo,13) elim1,elim2,ere,erecum,numnn,nrf(j+1)
      enddo
!
*     if (neutro == 2) then
          fosum(:) = 0.0
          fcsum(:) = 0.0
          dfsum(:) = 0.0
          reflres(:) = 0
          scalares(:) = 0.0
          minmaxres(1,:) =  9999
          minmaxres(2,:) = -9999
          NShell = 5
          nreflSHL = numb
          call AllocaRenorArrays(1)
          nreflSHL = numb
          RES(1:nreflSHL) = 0.5 / sqrt(rhov(1:nreflSHL))
          call Ren_shells()
          do i=1, numb
             j = RES_TAG(i)
*            write(6,22) i,j,khl(1:3,i),fovet(i),fcvet(i)
*  22        format(i5,")",i2," HKL",3i4,2f10.4)
             fosum(j) = fosum(j) + fovet(i)
             fcsum(j) = fcsum(j) + fcvet(i)
             reflres(j) = reflres(j) + 1
             r = RES(i)
             if (r < minmaxres(1,j)) then
                 minmaxres(1,j) = r
             endif
             if (r > minmaxres(2,j)) then
                 minmaxres(2,j) = r
             endif
          enddo
          do i=1, NShell
             scalares(i) = fcsum(i) / fosum(i)
          enddo
          sumdf = 0.0
          sumfo = 0.0
          sumfc = 0.0
          do i=1, numb
             j = RES_TAG(i)
             sumfo = sumfo + scalares(j) * fovet(i)
             sumfc = sumfc + fcvet(i)
          enddo
          ovscale = sumfc / sumfo
          sumdf = 0.0
          sumfo = 0.0
          fosum(:) = 0.0
          dfsum(:) = 0.0
          totnum = 0.0
          totden = 0.0
          numtot = 0
          do i=1, numb
             j = RES_TAG(i)
             fo = scalares(j) * fovet(i) * ovscale
             sumfo = sumfo + fo
             sumdf = sumdf + abs(fcvet(i) - fo)
             fosum(j) = fosum(j) + fo
             dfsum(j) = dfsum(j) + abs(fcvet(i) - fo)
             totnum = totnum + abs(fcvet(i) - fo)
             totden = totden + fo 
             numtot = numtot + 1
          enddo
          erreres = 100.0 * sumdf/sumfo
          write(6,200) erreres
          do i=1, NShell
             rfac = 100.0 * dfsum(i) / fosum(i)
             write(6,210) i, minmaxres(1,i), minmaxres(2,i),
     *                    reflres(i),fosum(i),fcsum(i),scalares(i),rfac
             fosum(j) = fosum(j) + fovet(i)
             fcsum(j) = fcsum(j) + fcvet(i)
             reflres(j) = reflres(j) + 1
          enddo
          rfac = 100.0 * totnum / totden
          write(6,220) numtot,rfac
          call AllocaRenorArrays(2)
*     endif
!
!-- Statistiche per Fc
!

      numint = interv

      work1(1:numb) = fcvet(1:numb)
      call sortall(-1,work1,numb)
      nn1 = percRefl * numb
      if (nn1 <= 0) then   ! se numb < 100 ... (strutture micro, ...)
          nn1 = 1
      endif
      sogliaFo = work1(nn1)

      erref = 0.0
      sca = 1.0
      sumdf=0.0
      sumfo=0.0
      sumfc=0.0
      do i=1,numb
         sumfo = sumfo + fovet(i) 
         sumfc = sumfc + fcvet(i) 
      enddo
      sca = sumfo / sumfc
      do i=1,numb
         work1(i) = fovet(i)
         work2(i) = sca * fcvet(i)
         sumdf=sumdf+abs( work1(i)-work2(i) )
      enddo
      erref = (sumdf/sumfo) * 100
      write(lo,*) ' Subr. StatErre_perShell: Rf%', erref, ' su ',numb,
     * ' riflessi'
!
!--calcola gli RF in intervalli di F calcolato
!
      exmax = sogliaFo
      exmin = minval(work1(1:numb))
      eint=(exmax-exmin)/float(numint)
!
      write(lo,105)
!
      sumdfcum=0.0
      sumfocum=0.0
      erecum=0.0
      nrf(:) =  0

      sumdf=0.0
      ere=0.0
      elim2=exmax
      sumfo=0.0
      sumdf=0.0
      numnn=0
      do k=1,numb
         if (work1(k).lt.elim2) cycle
         numnn=numnn+1
         sumdf=sumdf+abs( work1(k)-work2(k) )
         sumfo=sumfo+work1(k)
         sumdfcum=sumdfcum+abs( work1(k)-work2(k) )
         sumfocum=sumfocum+work1(k)
      enddo
      nrf(1)=numnn
      if(sumfo.gt.0.0) ere=(sumdf/sumfo)*100.0
      if(sumfocum.gt.0.0) erecum=(sumdfcum/sumfocum)*100.0
      write(lo,12) elim2,ere,erecum,numnn,nrf(1)

      do j=1,numint
        sumdf=0.0
        ere=0.0
        elim1=exmax-(j-1)*eint
        elim2=elim1-eint
        if(elim2 < 0.001) elim2=-0.0001
        sumfo=0.0
        sumdf=0.0
        numnn= 0
        do k=1,numb
          if(work1(k).lt.elim1.and.work1(k).ge.elim2) then
            numnn=numnn+1
            sumdf=sumdf+abs( work1(k)-work2(k) )
            sumfo=sumfo+work1(k)
            sumdfcum=sumdfcum+abs( work1(k)-work2(k) )
            sumfocum=sumfocum+work1(k)
          endif
        enddo
          nrf(j+1)=numnn+nrf(j)
        if(numnn.eq.0) cycle 
        if(sumfo.gt.0.0) ere=(sumdf/sumfo)*100.0
        if(sumfocum.gt.0.0) erecum=(sumdfcum/sumfocum)*100.0
        if(elim2 < 0.001) elim2=0.0
        write(lo,13) elim1,elim2,ere,erecum,numnn,nrf(j+1)
      enddo
!
   11 format(/,'      ---  STATISTICHE  su  Rf %  ---')
c  12 format('    up  to',3f10.3,2i10)
   12 format('  inf.  to',3f10.3,2i10)
   13 format(4f10.3,2i10)
  101 format(/,' --- Rf % - Distribuzione in f.ne di Fobs ---',/,
     * '     Fmax      Fmin      |R_F|   R_F cum.      NR     NR cum.')
  102 format(/,' --- Rf % - Distribuzione in f.ne di Fo/sigmaFo ---',/,
     * '     Smax      Smin      |R_F|   R_F cum.      NR     NR cum.')
  103 format(/,' --- Rf % - Distribuzione in f.ne di Risoluzione ---',/,
     * '     Rmin      Rmax      |R_F|   R_F cum.      NR     NR cum.') 
  105 format(/,' --- Rf % - Distribuzione in f.ne di Fcal ---',/,
     * '     Fmax      Fmin      |R_F|   R_F cum.      NR     NR cum.')
  200 format(/,' Resolution based scale: R% = ', f8.2,/,
     * '          Shell    Number        sum(Fo)        sum(Fc)     '
     * ,'Scale    R%')
  210 format(i5,')',2f6.2,i7,2f15.3,f10.3,f8.2)
  220 format('            All   ',i7,40x,f8.2)
!
      return
      end
!--------------------------------------------------------------------
      subroutine AllocaStimaModulo(iAction)
      USE General
      USE InvarStuff
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      implicit none
      integer :: iAction, ierv(10), ierr
!
      call AllocaIsr(iAction)
!
      ierv(:) = 0
      ierr = 0
      if (iAction == 1) then
          if (.not. allocated(itab)) then
              allocate(itab(1:itabmx),  stat = ierv(1))
              allocate(itabH(1:itabmx), stat = ierv(2))
              allocate(itabK(1:itabmx), stat = ierv(3))
              allocate(itabL(1:itabmx), stat = ierv(4))
          endif
!
          ierr = sum(iabs(ierv))
          if (ierr /= 0) then
              write(lo,*) 'AllocaStimaModulo Allocation error '
              write(lo,*) 'Errors ',ierv
              call cstop(' ')
          endif
          itab  = 0
          itabH = 0
          itabK = 0
          itabL = 0
      else
          ierr = 0
          if (allocated(itab)) then
              deallocate(itab, itabH, itabK, itabL, stat = ierr)
          endif
          if (ierr /= 0) then
              write(*,*) 'AllocaStimaModulo DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
!--------------------------------------------------------------------
      subroutine StimaModuloOsservati()
!
!--calculate triplets to estimate extrapolated reflections
!
      USE General
      USE Symmetry
      USE Riflessi
      USE InvarStuff
      USE VLDmod_1
!
      implicit none
      integer :: ier, i, ii, i0, i1, j, j1, jh1, jl1, jl2, jk, jk1, jk2
      integer :: jn, jnk, jl, in, in3, ins, ns2, ns3
      integer :: l, l1, l3, nivet, isra, inn1, il, ksubr
      integer :: ifObserved, ntripExtra
      integer :: k, ipu, indr, indrr, imeno1, isgn, ih3, ih31, ih32
      integer :: ill(3), ivet(48), iniz1, ifin1, iniz2, ifin2
      real    :: e1Val, e2Val, e3Val, g, form1, form2, arg1, arg2, aw
      real    :: sommaO1, sommaO2, sommaC1, sommaC2, sommaD1, sommaD2
      real    :: scala1, scala2, rfac1, rfac2, rfac3, rfac4
!
!*******************************************************************
!--description of some important settings
!
!  h1 = h2 + h3
!  i  h1 code
!  j  h2 code
! in  h3 code
!     ipsi0 = 0   ->  sigma2
!     ipsi0 = 1   ->  psi-zero or psi-e
!
!*******************************************************************
!
      if (.NOT. ALLOCATED(SigmaN))
     *     ALLOCATE (SigmaN(1:nrefl), stat = ier)
      if (.NOT. ALLOCATED(es))
     *     ALLOCATE (es(1:nrefl), stat = ier)
!
      ifObserved = 0
      ntripExtra = 0
      ksubr = 2
      call LeggiRiflessi(ier,ksubr)
!
!-- allocate work area
!
      itabmx = nrefl * nsym
      ifat1 = (2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2 = (2*ihmx(3)+1)
      ifatx = ihmx(1) * ifat1 + ihmx(2) * ifat2 + ihmx(3)
      call AllocaStimaModulo(1)
!
!--clear the areas
      jh1 = 0
      itab(:) = 0
      isr(:) = 0
c--create the list
      ipu = 0
      do j=1,nreflDim
         ipu = (j-1) * nsym
         do i=1,nsym
            do i1=1,3
               ill(i1) = 0
               do j1=1,3
                  ill(i1) = ill(i1) + khl(j1,j) * kmat(i,j1,i1)
               enddo
            enddo
            indr  = ill(1) * ifat1 + ill(2) * ifat2 + ill(3)
            indrr = indr
            if (i /= 1) then
                imeno1 = i - 1
                do i1=1,imeno1
                   if (indr == ivet(i1)) indrr = 0
                enddo
            endif
            ipu = ipu + 1
            ivet(i) = indrr
            itab(ipu)=indrr
            itabK(ipu) = ill(2)
            itabL(ipu) = ill(3)
            isgn = isign(1,indr)
            indr = iabs(indr)
            if (isr(indr) == 0) isr(indr) = (j*100+i) * isgn
         enddo
      enddo
!
      if (ifObserved == 0) then
          iniz1 = 1
          ifin1 = nstr - 1
          ifin1 = nstr
      else
          iniz1 = nrefl + 1
          ifin1 = nreflDim - 1
      endif
!
!-- calculate sigma 2: first loop
!
      do i = iniz1, ifin1
         aw    = 0.0
         form1 = 0.0
         form2 = 0.0
         e1Val = evet(i)
         if (ifObserved == 0) then
             inn1 = (i-1) * nsym + 1
             jk1 = itabK(inn1)
             jl1 = itabL(inn1)
             il = i
         else
             jh1 = khl(1,i)
             jk1 = khl(2,i)
             jl1 = khl(3,i)
             il = i
         endif
!
!--second loop
!
         if (ifObserved == 0) then
             ins = (i-1) * nsym + 1
             ih31 = itab(ins)
         else
             ih31 = jh1 * ifat1 + jk1 * ifat2 + jl1
         endif
         iniz2 = il + 1
         iniz2 = iniz1
         ifin2 = ifin1
         do j = iniz2, ifin2
            if (i == j) cycle
            e2Val = evet(j)
            ivet(:) = 0
            i0 = 0
            jn = (j-1) * nsym
            do k = 1, nsym
               jnk = jn + k
               if (itab(jnk) == 0) cycle
               jk2 = itabK(jnk)
               jl2 = itabL(jnk)
               Tre: do l = 1, 3, 2
                  l1 = l - 2
                  ih32 = itab(jnk)
                  ih3  = ih31 + ih32 * l1
                  l3 = 1
                  if (ih3 < 0) then
                      l3  = -1
                      ih3 = -ih3
                  elseif (ih3 == 0) then
                      cycle Tre
                  endif
                  if (ih3 > ifatx) cycle Tre
                  if (isr(ih3) == 0) cycle Tre
                  jk = iabs(jk1 + jk2 * l1)
                  if (jk > ihmx(2)) cycle Tre
                  jl = iabs(jl1 + jl2 * l1)
                  if (jl > ihmx(3)) cycle Tre
                  if (isr(ih3) < 0) l3 = -l3
                  isra = isr(ih3)
                  isra = iabs(isra)
                  in = isra / 100
                  if (in == i .or. in <= j) cycle Tre
                  if (in > ifin2+1) cycle Tre
                  if (i0 > 0) then
                      do ii = 1, i0
                         if (in == ivet(ii)) cycle Tre
                      enddo
                  endif
                  i0 = i0 + 1
                  ivet(i0) = in
                  in3 = isra - in * 100
!
!  phi(t)=phi(h1)-phi(h2)-phi(h3)+shift(fase)
!  i codici sono per  h1 = h2 + h3
!  cod(h2)= -l1 * j
!  cod(h3)=  l3 * in
!
                  e3Val = evet(in)
*     write(6,10) i,jh1,jk1,jl1,e1Val,j,k,jk2,jl2,e2Val,l,in,e3Val
*  10 format(i5,')',3i4,f8.2,2i5,')',2i4,f8.2,2i5,f8.2)
                  aw = aw + 1
                  form1 = form1 + e2Val**2 * e3Val**2
                  form2 = form2 + (e2Val**2-1.0) * (e3Val**2-1.0)
*                 if (i == 272) then
*                     write(6,1) nint(aw),form1,form2,
*    *                         e2Val, e3Val
*   1 format(i5,4f10.4)
*                 endif
                  ntripExtra = ntripExtra + 1
               enddo Tre
            enddo
         enddo
!
!-- Applica formule
!
         if (aw > 0.1) then
             arg1 = form1 / aw
             work1(i) = sqrt(arg1)
             arg2 = 1.0 + form2 / aw
             work2(i) = sqrt(arg2)
         else
             work1(i) = 0.0
             work2(i) = 0.0
         endif
!
      enddo
*     do i=1,nstr
*        write(6,2) i, work1(i),work2(i)
*   2    format(i5,2f8.3)
*     enddo
!
      call AllocaStimaModulo(2)
!
!-- Statistiche
!
      if (ifObserved == 0) then
          iniz1 = 1
          ifin1 = nstr
      else
          iniz1 = nrefl + 1
          ifin1 = nreflDim
      endif
!

      sommaO1 = 0.0
      sommaC1 = 0.0
      sommaC2 = 0.0
      do i = iniz1, ifin1
         sommaO1 = sommaO1 + evet(i)
         sommaC1 = sommaC1 + work1(i)
         sommaC2 = sommaC2 + work2(i)
      enddo
      scala1 = sommaC1 / sommaO1
      scala2 = sommaC2 / sommaO1
      sommaO1 = 0.0
      sommaO2 = 0.0
      sommaD1 = 0.0
      sommaD2 = 0.0
      do i = iniz1, ifin1
         sommaO1 = sommaO1 + scala1 * evet(i)
         sommaO2 = sommaO2 + scala2 * evet(i)
         sommaD1 = sommaD1 + abs( work1(i) - scala1 * evet(i) )
         sommaD2 = sommaD2 + abs( work2(i) - scala2 * evet(i) )
      enddo
      rfac1 = 100.0 * sommaD1 / sommaO1
      rfac2 = 100.0 * sommaD2 / sommaO2

      call Calcola_SigmaN_es

      k = ifin1 - iniz1 + 1

      work1(1:k) = work1(1:k) * SigmaN(1:k)
      sommaO1 = sum(fovet(1:k))
      sommaC1 = sum(work1(1:k))
      scala1 = sommaO1 / sommaC1
      sommaD1 = sum(abs(fovet(1:k)-scala1*work1(1:k)))
      sommaO1 = sum(fovet(1:k))
      rfac3 = 100.0 * sommaD1 / sommaO1

      work2(1:k) = work2(1:k) * SigmaN(1:k)
      sommaO1 = sum(fovet(1:k))
      sommaC1 = sum(work2(1:k))
      scala1 = sommaO1 / sommaC1
      sommaD1 = sum(abs(fovet(1:k)-scala1*work2(1:k)))
      sommaO1 = sum(fovet(1:k))
      rfac4 = 100.0 * sommaD1 / sommaO1
      write(lo,100) ntripExtra, k, rfac1, rfac2, rfac3, rfac4
!
      deallocate(SigmaN, es, stat = ier)
!
      return
  100 format(i8,' triplets on ',i7,' reflections R1 = ',f6.2,'%',
     *       ' R2 = ',f6.2,'%',' R3 = ',f6.2,'%',' R4 = ',f6.2,'%')
      end
!--------------------------------------------------------------------
      subroutine StimaModuloEstrapolati(mode)
!
!--calculate triplets to estimate extrapolated reflections
!
      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiNew
      USE InvarStuff
      USE VLDmod_1
!
      implicit none
      integer :: ier, i, ii, i0, i1, j, j1, jh1, jl1, jl2, jk, jk1, jk2
      integer :: jn, jnk, jl, in, in3, ins, ns2, ns3
      integer :: l, l1, l3, nivet, isra, inn1, il, ksubr
      integer :: ntripExtra, mode
      integer :: k, ipu, indr, indrr, imeno1, isgn, ih3, ih31, ih32
      integer :: ill(3), ivet(48), iniz1, ifin1, iniz2, ifin2
      real    :: e1Val, e2Val, e3Val, g, form1, form2, arg1, arg2, aw
      real    :: sommaO1, sommaO2, sommaC1, sommaC2, sommaD1, sommaD2
      real    :: scala1, scala2, rfac1, rfac2, rfac3, rfac4, scSav
      real    :: fo, rho, eps, multi, ff0, sinth, frac, bf, af, form
      real    :: denor, ed, esq
      integer :: ind
!
!-- mode = 1  in %data
!-- mode = 2  else
!-- 
!*******************************************************************
!--description of some important settings
!
!  h1 = h2 + h3
!  i  h1 code
!  j  h2 code
! in  h3 code
!     ipsi0 = 0   ->  sigma2
!     ipsi0 = 1   ->  psi-zero or psi-e
!
!*******************************************************************
!
!
      ntripExtra = 0
      if (mode == 1) then
          ksubr = 2
          call LeggiRiflessi(ier,ksubr)
      else
          fcvet(1:nreflDim) = refl%fc(1:nreflDim)
      endif
!
!-- Normalize Fcalc of extrapolated reflections
!
      go to 11

      iniz1 = 1
      ifin1 = nreflDim
      do i=iniz1, nreflDim
         fo = fcvet(i)
         rho = rhov(i)
         eps=epsv(i)
         multi=mult(i)
         ff0   = fo * fo / pts
         sinth=100.0*sqrt(rho)
         ind=max0(2,int(sinth+1.5))
         frac=sinth-float(ind-1)
         bf=0.5*(giw(ind+1)-giw(ind-1))
         af=bf+giw(ind-1)-giw(ind)
         form=af*frac*frac+bf*frac+giw(ind)
         denor=form*eps
         ed = ff0/denor
         esq=ed*exp(2.*bt*rho)
c           write(687,'(i10,4f15.8)') i,fovet(i),evet(i),sqrt(esq),
c    &                  0.5/sqrt(rho)
         fcvetv(i)=sqrt(esq)
      enddo

      go to 1
   11 continue

      iniz1 = nrefl + 1
      ifin1 = nreflDim
      fovet(iniz1:ifin1) = fcvet(iniz1:ifin1)
      scSav = sc
      sc = 1
      call F2E()
      sc = scSav

    1 continue

      evet(iniz1:ifin1) = fcvetv(iniz1:ifin1)
      ecvet(iniz1:ifin1) = fcvetv(iniz1:ifin1)**2
      scala1 = sum(ecvet(iniz1:ifin1)) / float(ifin1 - iniz1 + 1)
      write(6,'(a,f9.3)') 'Estrapolati: <E**2> =', scala1
      ecvet(iniz1:ifin1) = ecvet(iniz1:ifin1) / scala1
      ecvet(iniz1:ifin1) = sqrt(ecvet(iniz1:ifin1))
      scala1 = sum(ecvet(iniz1:ifin1)**2) / float(ifin1 - iniz1 + 1)
      write(6,'(a,f9.3)') 'Estrapolati: <E**2> =', scala1
      return
!
      if (.NOT. ALLOCATED(SigmaN))
     *     ALLOCATE (SigmaN(1:nreflDim), stat = ier)
      if (.NOT. ALLOCATED(es))
     *     ALLOCATE (es(1:nreflDim), stat = ier)
!
!-- allocate work area
!
      itabmx = nrefl * nsym
      ifat1 = (2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2 = (2*ihmx(3)+1)
      ifatx = ihmx(1) * ifat1 + ihmx(2) * ifat2 + ihmx(3)
      call AllocaStimaModulo(1)
!
!--clear the areas
      jh1 = 0
      itab(:) = 0
      isr(:) = 0
c--create the list
      ipu = 0
      do j=1,nrefl
         ipu = (j-1) * nsym
         do i=1,nsym
            do i1=1,3
               ill(i1) = 0
               do j1=1,3
                  ill(i1) = ill(i1) + khl(j1,j) * kmat(i,j1,i1)
               enddo
            enddo
            indr  = ill(1) * ifat1 + ill(2) * ifat2 + ill(3)
            indrr = indr
            if (i /= 1) then
                imeno1 = i - 1
                do i1=1,imeno1
                   if (indr == ivet(i1)) indrr = 0
                enddo
            endif
            ipu = ipu + 1
            ivet(i) = indrr
            itab(ipu)=indrr
            itabK(ipu) = ill(2)
            itabL(ipu) = ill(3)
            isgn = isign(1,indr)
            indr = iabs(indr)
            if (isr(indr) == 0) isr(indr) = (j*100+i) * isgn
         enddo
      enddo
!
      iniz1 = nrefl + 1
      ifin1 = nreflDim
      iniz2 = 1
      ifin2 = nrefl
      
!
!-- calculate sigma 2: first loop
!
      do i = iniz1, ifin1
         aw    = 0.0
         form1 = 0.0
         form2 = 0.0
         e1Val = evet(i)
         jh1 = khl(1,i)
         jk1 = khl(2,i)
         jl1 = khl(3,i)
         il = i
         ih31 = jh1 * ifat1 + jk1 * ifat2 + jl1
!
!--second loop
!
         do j = iniz2, ifin2
            e2Val = evet(j)
            ivet(:) = 0
            i0 = 0
            jn = (j-1) * nsym
            do k = 1, nsym
               jnk = jn + k
               if (itab(jnk) == 0) cycle
               jk2 = itabK(jnk)
               jl2 = itabL(jnk)
               Tre: do l = 1, 3, 2
                  l1 = l - 2
                  ih32 = itab(jnk)
                  ih3  = ih31 + ih32 * l1
                  l3 = 1
                  if (ih3 < 0) then
                      l3  = -1
                      ih3 = -ih3
                  elseif (ih3 == 0) then
                      cycle Tre
                  endif
                  if (ih3 > ifatx) cycle Tre
                  if (isr(ih3) == 0) cycle Tre
                  jk = iabs(jk1 + jk2 * l1)
                  if (jk > ihmx(2)) cycle Tre
                  jl = iabs(jl1 + jl2 * l1)
                  if (jl > ihmx(3)) cycle Tre
                  if (isr(ih3) < 0) l3 = -l3
                  isra = isr(ih3)
                  isra = iabs(isra)
                  in = isra / 100
                  if (in <= j) cycle Tre
                  if (i0 > 0) then
                      do ii = 1, i0
                         if (in == ivet(ii)) cycle Tre
                      enddo
                  endif
                  i0 = i0 + 1
                  ivet(i0) = in
                  in3 = isra - in * 100
                  e3Val = evet(in)
!
*     write(6,10) i,jh1,jk1,jl1,e1Val,j,k,jk2,jl2,e2Val,l,in,e3Val
*  10 format(i5,')',3i4,f8.2,2i5,')',2i4,f8.2,2i5,f8.2)
                  aw = aw + 1
                  form1 = form1 + e2Val**2 * e3Val**2
                  form2 = form2 + (e2Val**2-1.0) * (e3Val**2-1.0)
*                 if (i == 272) then
*                     write(6,1) nint(aw),form1,form2,
*    *                         e2Val, e3Val
*   1 format(i5,4f10.4)
*                 endif
                  ntripExtra = ntripExtra + 1
               enddo Tre
            enddo
         enddo
!
!-- Applica formule
!
         if (aw > 0.1) then
             arg1 = form1 / aw
             work1(i) = sqrt(arg1)
             arg2 = 1.0 + form2 / aw
             work2(i) = sqrt(arg2)
         else
             work1(i) = 0.0
             work2(i) = 0.0
         endif
!
      enddo
*     do i=1,nstr
*        write(6,2) i, work1(i),work2(i)
*   2    format(i5,2f8.3)
*     enddo
!
      call AllocaStimaModulo(2)
!
!-- Statistiche
!
      iniz1 = nrefl + 1
      ifin1 = nreflDim
!

      sommaO1 = 0.0
      sommaC1 = 0.0
      sommaC2 = 0.0
      do i = iniz1, ifin1
         sommaO1 = sommaO1 + evet(i)
         sommaC1 = sommaC1 + work1(i)
         sommaC2 = sommaC2 + work2(i)
      enddo
      scala1 = sommaC1 / sommaO1
      scala2 = sommaC2 / sommaO1
      sommaO1 = 0.0
      sommaO2 = 0.0
      sommaD1 = 0.0
      sommaD2 = 0.0
      do i = iniz1, ifin1
         sommaO1 = sommaO1 + scala1 * evet(i)
         sommaO2 = sommaO2 + scala2 * evet(i)
         sommaD1 = sommaD1 + abs( work1(i) - scala1 * evet(i) )
         sommaD2 = sommaD2 + abs( work2(i) - scala2 * evet(i) )
      enddo
      rfac1 = 100.0 * sommaD1 / sommaO1
      rfac2 = 100.0 * sommaD2 / sommaO2

      call Calcola_SigmaN_es

      k = ifin1 - iniz1 + 1

      work1(1:k) = work1(1:k) * SigmaN(1:k)
      sommaO1 = sum(fovet(1:k))
      sommaC1 = sum(work1(1:k))
      scala1 = sommaO1 / sommaC1
      sommaD1 = sum(abs(fovet(1:k)-scala1*work1(1:k)))
      sommaO1 = sum(fovet(1:k))
      rfac3 = 100.0 * sommaD1 / sommaO1

      work2(1:k) = work2(1:k) * SigmaN(1:k)
      sommaO1 = sum(fovet(1:k))
      sommaC1 = sum(work2(1:k))
      scala1 = sommaO1 / sommaC1
      sommaD1 = sum(abs(fovet(1:k)-scala1*work2(1:k)))
      sommaO1 = sum(fovet(1:k))
      rfac4 = 100.0 * sommaD1 / sommaO1
      write(lo,100) ntripExtra, k, rfac1, rfac2, rfac3, rfac4
!
      deallocate(SigmaN, es, stat = ier)
!
      return
  100 format(i10,' triplets on ',i7,' reflections R1 = ',f6.2,'%',
     *       ' R2 = ',f6.2,'%',' R3 = ',f6.2,'%',' R4 = ',f6.2,'%')
      end
!--------------------------------------------------------------------
      subroutine StimaModuloTuttiOsservati()
!
!--calculate triplets to estimate extrapolated reflections
!
      USE General
      USE Symmetry
      USE Riflessi
      USE InvarStuff
      USE VLDmod_1
!
      implicit none
      integer :: ier, i, ii, i0, i1, j, j1, jh1, jl1, jl2, jk, jk1, jk2
      integer :: jn, jnk, jl, in, in3, ins, ns2, ns3
      integer :: l, l1, l3, nivet, isra, inn1, il, ksubr
      integer :: ifObserved, ntripExtra
      integer :: k, ipu, indr, indrr, imeno1, isgn, ih3, ih31, ih32
      integer :: ill(3), ivet(48), iniz1, ifin1, iniz2, ifin2
      real    :: e1Val, e2Val, e3Val, g, form1, form2, arg1, arg2, aw
      real    :: sommaO1, sommaO2, sommaC1, sommaC2, sommaD1, sommaD2
      real    :: scala1, scala2, rfac1, rfac2, rfac3, rfac4
!
!*******************************************************************
!--description of some important settings
!
!  h1 = h2 + h3
!  i  h1 code
!  j  h2 code
! in  h3 code
!     ipsi0 = 0   ->  sigma2
!     ipsi0 = 1   ->  psi-zero or psi-e
!
!*******************************************************************
!
      if (.NOT. ALLOCATED(SigmaN))
     *     ALLOCATE (SigmaN(1:nrefl), stat = ier)
      if (.NOT. ALLOCATED(es))
     *     ALLOCATE (es(1:nrefl), stat = ier)
!
      ifObserved = 0
      ntripExtra = 0
      ksubr = 2
      call LeggiRiflessi(ier,ksubr)
!
!-- allocate work area
!
      itabmx = nrefl * nsym
      ifat1 = (2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2 = (2*ihmx(3)+1)
      ifatx = ihmx(1) * ifat1 + ihmx(2) * ifat2 + ihmx(3)
      call AllocaStimaModulo(1)
!
!--clear the areas
      jh1 = 0
      itab(:) = 0
      isr(:) = 0
c--create the list
      ipu = 0
      do j=1,nrefl
         ipu = (j-1) * nsym
         do i=1,nsym
            do i1=1,3
               ill(i1) = 0
               do j1=1,3
                  ill(i1) = ill(i1) + khl(j1,j) * kmat(i,j1,i1)
               enddo
            enddo
            indr  = ill(1) * ifat1 + ill(2) * ifat2 + ill(3)
            indrr = indr
            if (i /= 1) then
                imeno1 = i - 1
                do i1=1,imeno1
                   if (indr == ivet(i1)) indrr = 0
                enddo
            endif
            ipu = ipu + 1
            ivet(i) = indrr
            itab(ipu)=indrr
            itabK(ipu) = ill(2)
            itabL(ipu) = ill(3)
            isgn = isign(1,indr)
            indr = iabs(indr)
            if (isr(indr) == 0) isr(indr) = (j*100+i) * isgn
         enddo
      enddo
!
      iniz1 = 1
      ifin1 = nrefl
      iniz2 = 1
      ifin2 = nstr
!
!-- calculate sigma 2: first loop
!
      do i = iniz1, ifin1
         if (i == 2135) then
             aw = 0.0
         endif
         aw    = 0.0
         form1 = 0.0
         form2 = 0.0
         e1Val = evet(i)
         jh1 = khl(1,i)
         jk1 = khl(2,i)
         jl1 = khl(3,i)
         il = i
         ih31 = jh1 * ifat1 + jk1 * ifat2 + jl1
!
!--second loop
!
         do j = iniz2, ifin2
            if (i == j) cycle
            e2Val = evet(j)
            ivet(:) = 0
            i0 = 0
            jn = (j-1) * nsym
            do k = 1, nsym
               jnk = jn + k
               if (itab(jnk) == 0) cycle
               jk2 = itabK(jnk)
               jl2 = itabL(jnk)
!
!--third loop
!
               Tre: do l = 1, 3, 2
                  l1 = l - 2
                  ih32 = itab(jnk)
                  ih3  = ih31 + ih32 * l1
                  l3 = 1
                  if (ih3 < 0) then
                      l3  = -1
                      ih3 = -ih3
                  elseif (ih3 == 0) then
                      cycle Tre
                  endif
                  if (ih3 > ifatx) cycle Tre
                  if (isr(ih3) == 0) cycle Tre
                  jk = iabs(jk1 + jk2 * l1)
                  if (jk > ihmx(2)) cycle Tre
                  jl = iabs(jl1 + jl2 * l1)
                  if (jl > ihmx(3)) cycle Tre
                  if (isr(ih3) < 0) l3 = -l3
                  isra = isr(ih3)
                  isra = iabs(isra)
                  in = isra / 100
                  if (in == i .or. in <= j) cycle Tre
                  if (in > ifin2) cycle Tre    ! NEW
                  if (i0 > 0) then
                      do ii = 1, i0
                         if (in == ivet(ii)) cycle Tre
                      enddo
                  endif
                  i0 = i0 + 1
                  ivet(i0) = in
                  in3 = isra - in * 100
!
!  phi(t)=phi(h1)-phi(h2)-phi(h3)+shift(fase)
!  i codici sono per  h1 = h2 + h3
!  cod(h2)= -l1 * j
!  cod(h3)=  l3 * in
!
                  e3Val = evet(in)
*     write(6,10) i,jh1,jk1,jl1,e1Val,j,k,jk2,jl2,e2Val,l,in,e3Val
*  10 format(i5,')',3i4,f8.2,2i5,')',2i4,f8.2,2i5,f8.2)
                  aw = aw + 1
                  form1 = form1 + e2Val**2 * e3Val**2
                  form2 = form2 + (e2Val**2-1.0) * (e3Val**2-1.0)
*                 if (i == 272) then
*                     write(6,1) nint(aw),form1,form2,
*    *                         e2Val, e3Val
*   1 format(i5,4f10.4)
*                 endif
                  ntripExtra = ntripExtra + 1
               enddo Tre
            enddo
         enddo
!
!-- Applica formule
!
         if (aw > 0.1) then
             arg1 = form1 / aw
             work1(i) = sqrt(arg1)
             arg2 = 1.0 + form2 / aw
             fcoef(i) = arg2 * aw
             if (fcoef(i) < 0.0) fcoef(i) = 0.0
             work2(i) = sqrt(arg2)
         else
             work1(i) = 0.0
             work2(i) = 0.0
         endif
!
      enddo
*     do i=1,nstr
*        write(6,2) i, work1(i),work2(i)
*   2    format(i5,2f8.3)
*     enddo
!
      call AllocaStimaModulo(2)
!
!-- Statistiche
!
      iniz1 = 1
      ifin1 = nrefl
!

      sommaO1 = 0.0
      sommaC1 = 0.0
      sommaC2 = 0.0
      do i = iniz1, ifin1
         sommaO1 = sommaO1 + evet(i)
         sommaC1 = sommaC1 + work1(i)
         sommaC2 = sommaC2 + work2(i)
      enddo
      scala1 = sommaC1 / sommaO1
      scala2 = sommaC2 / sommaO1
      sommaO1 = 0.0
      sommaO2 = 0.0
      sommaD1 = 0.0
      sommaD2 = 0.0
      do i = iniz1, ifin1
         sommaO1 = sommaO1 + scala1 * evet(i)
         sommaO2 = sommaO2 + scala2 * evet(i)
         sommaD1 = sommaD1 + abs( work1(i) - scala1 * evet(i) )
         sommaD2 = sommaD2 + abs( work2(i) - scala2 * evet(i) )
      enddo
      rfac1 = 100.0 * sommaD1 / sommaO1
      rfac2 = 100.0 * sommaD2 / sommaO2

      call Calcola_SigmaN_es

      k = ifin1 - iniz1 + 1

      Dluz(:) = work2(:)
      work1(1:k) = work1(1:k) * SigmaN(1:k)
      sommaO1 = sum(fovet(1:k))
      sommaC1 = sum(work1(1:k))
      scala1 = sommaO1 / sommaC1
      sommaD1 = sum(abs(fovet(1:k)-scala1*work1(1:k)))
      sommaO1 = sum(fovet(1:k))
      rfac3 = 100.0 * sommaD1 / sommaO1
      write(6,*) '====================================================='
      write(6,*) '==================    Formula 1   ==================='
      write(6,*) '====================================================='
      fcvet(:) = work1(:)
      call StatErre_perShellExtra()

      work2(:) = Dluz(:)
      work2(1:k) = work2(1:k) * SigmaN(1:k)
      sommaO1 = sum(fovet(1:k))
      sommaC1 = sum(work2(1:k))
      scala1 = sommaO1 / sommaC1
      sommaD1 = sum(abs(fovet(1:k)-scala1*work2(1:k)))
      sommaO1 = sum(fovet(1:k))
      rfac4 = 100.0 * sommaD1 / sommaO1
      write(6,*) '====================================================='
      write(6,*) '==================    Formula 2   ==================='
      write(6,*) '====================================================='
      fcvet(:) = work2(:)
      call StatErre_perShellExtra()
      write(lo,100) ntripExtra, k, rfac1, rfac2, rfac3, rfac4
      
!
      deallocate(SigmaN, es, stat = ier)
!

      scala1 = float(nrefl) / sum(fcoef(:))
      fcoef(:) = scala1 * fcoef(:)
      scala2 = sum(fcoef(:)) / float(nrefl)
      write(6,*) 'SCALA2', scala2
!
      return
  100 format(i8,' triplets on ',i7,' reflections R1 = ',f6.2,'%',
     *       ' R2 = ',f6.2,'%',' R3 = ',f6.2,'%',' R4 = ',f6.2,'%')
      end
!--------------------------------------------------------------------
!     prova per uso HM su mappe con maschera per atomi pesanti
!-----------------------------------------------------------------------
      subroutine PostDSR_HM_Flex(numb,correl, ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE MappaCont
      USE Param
      USE PhaseModule
!
      common /misc/ ttt(3,3), dxmax(3), ishift(3,19)

!
      if (knw == 1) write(6,*) 'POSTDSR_HM_FLEX '

      finalfomIter = FinalFom
      coeFFom = CCEoEc(1) / fomold(1)
      coeFFomIter = coeFFom
!
      ifPostDSR = 1
      ifBreak = 0
!
      correl   = 0.0
      correMR = 0.0
      ier = 0
      jpatt = 0
      chope = 0.5
!
      nMacroTotSav = nMacroTot
      nBlockEDMSav = nBlockEDM
      nBlockEDM = 1
      nMacroTot = 3 
      nMicro = 5
      if (ResEff>1.50) then
          nMacroTot = 1 
          nMicro = 5 
      endif


          nMacroTot = 1   !15 
          nMicro = 3 


      nMacro = nMacroTot / nBlockEDM
      nMacroAppl = 0
!
      if (knw ==1. and. ifOUT == 1) write (lo,11) 
      call CPUTime0('inizio PostDSR')

!
      call ControllaAtomiPesanti(NumPeso)
      aperc(1) = NumPeso   ! opp. NumPes (un po' di più)
      write(6,*) 'Num. HA =',NumPeso, aperc(1), NumPes
      call readhist
!
      ifExpandedSav = ifExpanded
      if (ifExpanded>0) then ! occhio
         ifExpanded = 0
         ihmx=ihmxSav
         rhomax = maxval(rhov(1:nrefl))
      endif
!
      Macro: do indiceMacro=1,nMacro
         nMacroAppl = nMacroAppl + 1

         call Applica_HM_Flex()

         chope=2.0
         numbDyn = numbLSQ
!
!--elimino i riflessi tra numbLSQ+1 : nerfl
!
         do i = 1,nrefl
            if (i<=numbLSQ) then
               wt(i) = min(1.0,wt(i))
            else
               wt(i) = 0.0
            endif
         enddo

        if (indiceMacro == 1 .and. ifExamin /= 0) then
            ifmin = 0 ! 10
            luset = 555
            izero = 0
            call examin(luset,mkang,khl,ipub,iphaz,nrefl,izero,
     *                    wt,ifmin)
            write (lo,113) erore, erorepes, isumal
         endif
!
!-- statistiche
!
         kverbo_sav = kverbo
         kverbo = 1
         if (nsym == 1.and.icent == 0) kverbo = 0
            if (kverbo.gt.0) then
                luset = nMacroAppl*1000+888
                izero = 0
                ifmin = 1
                call examin(luset,mkang,khl,ipub,iphaz,nrefl,izero,
     *                      wt,ifmin)
            endif
         kverbo = kverbo_sav
!
!-- statistiche
!

      if (ifEnve.eq.1) then
          jpatt = 0
          RenveDyn = CalcolaRaggioEnve(jpatt)
          RenveDyn = RenveDyn
          if (knw > 0) then
              write(6,*) 'RAGGIO ENVELOPE =',RenveDyn
          endif
          call Long_Env_New(numbLSQ,jpatt)
          EnvePronta = 1
      endif

         if (knw == 1) then
             call toflush()
         endif

         Micro: do indiceMicro = 1,nMicro
!--
            percMap = 0.05
            percMap_EC = percMap
            invflag = 1
c           if (ResEff>1.50) invflag = 2!liberato2009
!           
            call Inverti_HM_Flex(correl,ifBreak, ier)

            if (ier < 0) return
            if (ifBreak == 1) return
!
             if (knw == 1) then
                 kstp = 1
                 iesCC=1
                 if(iesCC==1)  then
                   call Calcola_CC_Mappa(numbLSQ,correl,kstp,2)
                 endif
             endif
            call Barra()
         enddo Micro
!
         if (knw == 1) then
             call toflush()
         endif
!
         if (knw == 1) then
             kstp = 1
             write(lo,15) numbrun,Iterazione,nMacroAppl,
     *                    CCEoEc,FOMs(2,4),correl
         elseif (kverbo /= 0) then
             write(lo,16) numbrun,Iterazione,nMacroAppl,
     *                    CCEoEc,FOMs(2,4)
         endif
!
         if (knw == 1) then
             call toflush()
         endif
      enddo Macro
!
!--  Calcolo FinalFom in PostDSR 
!
!

      call Calcola_FinalFom(0)
      coeFFom = CCEoEc(1) / fomold(1)
      FinalF = FinalFom
      FinalFom = FinalFom_DSR * coeFFom
!
c     if (FinalFom > stopFinalFom) then
c         kWstop = 1
c         write(6,'(a)') 'PostDSR HM_Flex kWstop=1'
c     endif

c     if (finalfomIter > FinalFom) then
      if (coeFFomIter > coeFFom) then
          kWstop3 = 1
      endif
      if (knw == 1) then
          write (6,*) 'POST_HM_Flex #',
     *                 Iterazione,coeFFomIter,coeFFom,kWstop3 
      endif

      finalfomIter = FinalFom
      finalfomIter = coeFFom


!
      if (knw == 1) then
          write(lo,115) numbrun,Iterazione,CCEoEc,FOMs(2,4),correl
      endif
!
      if (knw == 1) then
          call toflush()
          if (ifExamin == 1 .and. ifTime == 0) then
              luset = 999
              izero = 0
              ifmin = 0 ! 10
!             ifmin = 10
              call examin(luset,mkang,khl,ipub,iphaz,numbDyn,izero,wt,
     *                    ifmin)
          endif
      endif
!
      if (knw == 1) then
          write (lo,118) Iterazione, erore, erorepes, isumal,
     *                   correl, FinalFom, coeFFom
      endif
!
      ifExpanded = ifExpandedSav
      if (ifExpanded>0) then ! occhio
         ihmx=ihmxExt
         rhomax = maxval(rhov(1:nrefltot))
      endif
!
      if (knw == 1) then
          call toflush()
      endif
!
      nBlockEDM = nBlockEDMSav
      nMacroTot = nMacroTotSav
      ifPostDSR = 0
      coeFFom = 1.0
!
cdedi - Calcolo fasi e pesi per tutti nrefl  prima di memorizzarli su lista 17
      iStampa = knw
!
      call CPUTime('fine PostDSR_HM_Flex', iStampa)
      return

   11 format(/,5x,' POSTDSR  MODULE ',/)
   15 format(' Trial',i6,2i4,'  POSTDSR FOMs =',3f7.3, 
     *                       '  POSTDSR CC_MAP =',f7.3)
   16 format(' Trial',i6,2i4,'  POSTDSR FOMs =',3f7.3)
  113 format(10x,'Starting POSTDSR - Mean Phase Error ',f6.2,
     *'  (',f6.2,')  over',i8,' reflections')
  115 format(/,' Trial',i6,'   Iteration #',i4,
     *       ' FOMs =',3f7.3,' CC(MAP) =',f7.3)
  118 format(' End POSTDSR  ',i4,' - MPE ',f6.2,
     *'  (',f6.2,') over',i8,' refl.',' CC = ', f6.3,' FFom = '
     *     ,2f6.3,/)
  119 format(' End POSTDSR',i4,' FFom = ',f6.3,i4,/)

      end
!------------------------------------------------------------------------------
      subroutine Inverti_HM_Flex(correl,ifBreak, ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE Param
      USE RemoModule
      USE PhaseModule
!
      common /misc/ ttt(3,3), dxmax(3), ishift(3,19)
!
      character tirang * 11
      character ttirang * 80
      real shi(4), segni_mio(nreflDim)
!
      cicloEDM = cicloEDM + 1

      chope = 2.0
      numberToUse = nrefl
      numberToInv = nrefl
      numbDyn = nrefl
!

      fcoef(1:numberToUse) = evet(1:numberToUse) *
     *                       wt(1:numberToUse)
      jpatt = 0 
      call MakeMap(fcoef, iphaz, numberToUse, jpatt, xmap,
     *                FORTH, BACK)
!
      if (ifNegativePeaks == 1) then
          EnvePronta = 0
      endif
      isogiter = 3!liberato2009
      if (EnvePronta.gt.0.5) then
          iflat = 1
          Xflip = 0
          call flatmapOld(xmap,xenve,iflat,Xflip)
      endif
   
      percMap=0.025 + 0.025 * indiceMicro
      invflag = 1

      if (knw == 1) then
          write(6,*) 'INVERTI_HM_FLEX = ', indiceMacro, indiceMicro,
     *                  invflag, percMap, percMap_n
      endif
      call InvMap(khl,mkang,iphaz,fcvet,numberToInv)
!
!-- selezione dei pesi
!
      call Weights_Calculation_NEW(numbDyn,numberToUse,chope,
     *                             correl,ifBreak)
      if (ifBreak == 1) return
!
         kverbo_sav = kverbo
         kverbo = 1
         if (nsym == 1.and.icent == 0) kverbo = 0

      if (indiceMicro.eq.nMicro.or.kverbo.ne.0) then
!
!--statistiche
!
          if (ifExamin.ne.0 .or. ifTime == 0) then 
              if (kverbo.eq.0) then
                  ifmin = 0
              else
                  ifmin = 11
              endif
              nuset = nMacroAppl*1000+666
              izero = 0
              ifin = nrefl
              call examin(nuset,mkang,khl,ipub,iphaz,ifin,izero,
     *                    wt,ifmin)
!             tirang = 'EDM - OBSER'
!             ipher = 1
!             call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
!    *                    ipub,iphaz,wt,10,0.0,ipher)

              jwork1(:) = iphaz(:)
              shi(:) = shiftexam(1:4)
              call ShiftPhases(jwork1,shi,izero,nrefl)
              ttirang = 'WT OBS.'
              izero1 = 1
              segni_mio = 0.0
              call ParamDistribution(ttirang,2,wt,khl,nrefl,izero1,
     *        ipub,jwork1,shi,wt,segni_mio,10,1.0)


              if (kverbo.eq.0) then
                    write (lo,101) nMacroAppl, erore, erorepes, isumal
              endif
          endif
!
      endif  ! if (indiceMicro.eq.nMicro)

         kverbo = kverbo_sav
!
!--fine statistiche
!
      call DoSingleIteration()
!
      return
   11 format('ENVELOPE APPLICATO',f7.3)
  101 format(' Supercycle HM_Flex n.',i4,' - Mean Phase Error ',f6.2,
     *       '  (',f6.2,')  over',i8,' reflections')
      end
!------------------------------------------------------------------------------
      subroutine Applica_HM_Flex()
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE Atomi
      USE Param
      USE RemoModule
      USE PhaseModule
!
      common/maphistograms/ vresl(50),vrmin(50),vrmax(50),vrave(50),
     +                   vrstd(50),hdata(200,50),nresl,nhist
!
      character tirang * 11
      character ttirang * 80
      character strMaps * 50
      real shi(4), segni_mio(nreflDim)
!
      real :: xH(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      real :: xHA(0:np(1)-1,0:np(2)-1,0:np(3)-1)
!
c     wt(:) = 1.0
c     wt(nrefl+1:) = 0.0
c     iphaz = ipub
!
      ier = 0 
      nuset = 1000
      izero = 0
      call examin(nuset,mkang,khl,ipub,iphaz,nrefl,izero,wt,1)
      jwork1(:) = iphaz(:)
      shi(:) = shiftexam(1:4)
      call ShiftPhases(jwork1,shi,izero,nrefl)
!     tirang = 'EDM - OBSER'
!     ipher = 1
!     call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
!    *                    ipub,iphaz,wt,10,0.0,ipher)
       ttirang = 'WT OBS.'
       izero1 = 1
       segni_mio = 0.0
       call ParamDistribution(ttirang,2,wt,khl,nrefl,izero1,
     *         ipub,jwork1,shi,wt,segni_mio,10,1.0)

!
      call Trasla_Origine(nrefl)
!
      fcoef(1:nrefl) = evet(1:nrefl) *
     *                       wt(1:nrefl)
      jpatt = 0 
      call MakeMap(fcoef, iphaz, nreflTot, jpatt, xmap,
     *                FORTH, BACK)
!
! ----  creo maschera per atomi pesanti e li elimino dalla mappa
!
      kverbo_sav = kverbo
      kverbo = 1
!
      iflagPKS = 0
      mode = -1
      nnuu = nrefl
      krecy = 0
      call pksrch_New(mode, iflagPKS, nnuu,ier)
      if (ier /= 0) then
          return
      endif
      nats = aperc(1)
!
      fcoef(1:nrefl) = fovet(1:nrefl) *
     *                       wt(1:nrefl)
      jpatt = 0 
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                FORTH, BACK)


      iprin = 1
      if (iprin == 1) then
          nnuu = 10 + indiceMacro
          call Write_CCP4_Map(xmap, nnuu)
      endif

! 
!- calcolo envelope
!
      jpatt = 0
      RenveDyn = CalcolaRaggioEnve(jpatt)
      RenveDyn = RenveDyn
      if (knw > 0) then
          write(6,*) 'RAGGIO HM_Flex =',RenveDyn
      endif
      call Long_Env_New(numbLSQ,jpatt)

      if (kverbo==1) then
        strMaps='Mappa di partenza'
        call rhostats(xmap,xenve,strMaps)
        write(6,*) strMaps
        call maxmin_dedi(np(1),np(2),np(3),xmap)
        rapden = denmax/stden
        write(6,110) denmax, denmin, avden, stden, rapden
      endif

      iflat = 1
      Xflip = 0
      call flatmapOld(xmap,xenve,iflat,Xflip)

      if (kverbo==1) then
          strMaps='Mappa dopo envelope'
          call rhostats(xmap,xenve,strMaps)
          write(6,*) strMaps
          call maxmin_dedi(np(1),np(2),np(3),xmap)
          rapden = denmax/stden
          write(6,110) denmax, denmin, avden, stden, rapden
      endif
!
      radius_elim = 2.5
      iAction = 1
      call elimHA_DSR(radius_elim,xH,xHA,iAction)

      if (kverbo==1) then
        strMaps='Mappa dopo eliminazione HA'
        call rhostats(xH,xenve,strMaps)
        write(6,*) strMaps
        call maxmin_dedi(np(1),np(2),np(3),xH)
        rapden = denmax/stden
        write(6,110) denmax, denmin, avden, stden, rapden
      endif
      denmax_old = denmax
      
      call HM_Flex(xH,xenve)

      if (kverbo==1) then
        strMaps='Mappa dopo HM '
        call rhostats(xH,xenve,strMaps)
        write(6,*) strMaps
        call maxmin_dedi(np(1),np(2),np(3),xH)
        rapden = denmax/stden
        write(6,110) denmax, denmin, avden, stden, rapden
      endif
      denmax_new = denmax
      
      percMap = 0.05
      invflag = 1 

c     percMap=0.025 + 0.025 * indiceMacro
c     invflag = 1
      if (knw == 1) then
          write(6,*) 'INVERTI_HM = ', indiceMacro, indiceMicro,invflag,
     +                                 percMap
      endif
      call InvMap(khl,mkang,iphaz,fcvet,nrefl)


      wt(:) = 1.0
      nuset = 2000
      izero = 0
      call examin(nuset,mkang,khl,ipub,iphaz,nrefl,izero,wt,1)
      wt(:) = 0.0

!
!-- calcolo dei pesi
!

      nreflDimSav=nreflDim
      nreflDim=nrefl

      iesfast = 0
c     jflag = 1    !!!  Fo=1, E=-1  <Eo2Ep2>
      jflag = 2    !!!  Fo=2, E=-2  R(Fo,Fc)
c     jflag = -2    !!!  Fo=3, E=-3  <(Eo2-Ec2)>
      call PresigmaA(jflag, 0)
!
!--elimino i riflessi tra numbLSQ+1 : nerfl
!
      do i = 1,nrefl
         if (i<=numbLSQ) then
            wt(i) = min(1.0,wt(i))
         else
            wt(i) = 0.0
         endif
      enddo
      wt(nrefl+1:) = 0.0
      waveare2 = sum(wt(1:nrefl))/float(nrefl)
      if (knw > 0) then
          write(6,*) '<wt_procHM> =', waveare2
      endif

      nreflDim=nreflDimSav
!
      if (nsym == 1.and.icent == 0) kverbo = 0
      if (indiceMicro.eq.nMicro.or.kverbo.ne.0) then
!
!--statistiche
!
          if (ifExamin.ne.0 .or. ifTime == 0) then 
              if (kverbo.eq.0) then
                  ifmin = 0
              else
                  ifmin = 11
              endif
              nuset = nMacroAppl*1000+777
              izero = 0
              ifin = nrefl
              call examin(nuset,mkang,khl,ipub,iphaz,ifin,izero,
     *                    wt,ifmin)
!             tirang = 'EDM - OBSER'
!             ipher = 1
!             call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
!    *                    ipub,iphaz,wt,10,0.0,ipher)


              jwork1(:) = iphaz(:)
              shi(:) = shiftexam(1:4)
              call ShiftPhases(jwork1,shi,izero,nrefl)
              ttirang = 'WT OBS.'
              izero1 = 1
              segni_mio = 0.0
              call ParamDistribution(ttirang,2,wt,khl,nrefl,izero1,
     *        ipub,jwork1,shi,wt,segni_mio,10,1.0)


              if (kverbo.eq.0) then
                    write (lo,101) nMacroAppl, erore, erorepes, isumal
              endif
          endif
!
      endif  ! if (indiceMicro.eq.nMicro)

         kverbo = kverbo_sav
!
!--fine statistiche
!
      call DoSingleIteration()
!
      return
  101 format(' HM_FLEX n.',i4,' - Mean Phase Error ',f6.2,
     *       '  (',f6.2,')  over',i8,' reflections')
  110 format ('Denmax, Denmin, Avden, St_dev, Rapden =',5f15.2)
      end
!-----------------------------------------------------------------------
      subroutine elimHA_DSR(radius,xH,xHA,iAction)
!
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE PhaseModule
      USE Param
      dimension xs(3),xs1(3)
      dimension xs2(3),xs3(3),xss(3)
      integer sidepp
      real xH(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      real xHA(0:np(1)-1,0:np(2)-1,0:np(3)-1)

!
      if (iAction == 1) then
          xH(:,:,:)  = xmap(:,:,:)   ! mappa con HA eliminati
          xHA(:,:,:) = 0.0           ! mappa soli HA

          write(lo,*)'  ***************************************'
          write(lo,*)'  *    Heavy atom residue elimination    *'
          write(lo,*)'  ***************************************'
      endif

      denel=0.0
      npunti=0

      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)
c

      do iat = 1,nats

         do i=1,3
            xs1(i) = side(xyzs(i,iat))
         enddo

c        write(6,*) 'Atom #',iat, xs1(1:3), xyzs(4,iat)

      do kk1=1,ncentr
         do kk2=1,icent+1
            coef=1.0
            if(kk2==2) coef=-1.0
            do kk3=1,nsym
               call xequi(xs1,kk3,coef,xs,kk1)
               do ii=1,3
                  xs(ii)=side(xs(ii))
               enddo
               iszu=nint(xs(3)*np(3)+radius*deltz)
               iszl=nint(xs(3)*np(3)-radius*deltz)
               isyu=nint(xs(2)*np(2)+radius*delty)
               isyl=nint(xs(2)*np(2)-radius*delty)
               isxu=nint(xs(1)*np(1)+radius*deltx)
               isxl=nint(xs(1)*np(1)-radius*deltx)
c
               do iz = iszl, iszu
                 do iy = isyl, isyu
                   do ix = isxl, isxu
                     a1=ix/deltx-xs(1)*cell(1)
                     a2=iy/delty-xs(2)*cell(2)
                     a3=iz/deltz-xs(3)*cell(3)
                     ray2=a1**2 + a2**2 + a3**2 +
     &                    2.*a1*a2*cg + 2.*a1*a3*cb + 2.*a2*a3*ca
                     ray=sqrt(ray2)
                     if(ray>radius) cycle
                     ih = sidepp(ix,np(1))
                     ik = sidepp(iy,np(2))
                     il = sidepp(iz,np(3))
c                    write(6,*) 'Punti griglia #',ih,ik,il
                     if (iAction == 1) then
                         xx = xmap(ih,ik,il)
                         npunti=npunti+1
                         denel=denel+xx
                         xHA(ih,ik,il) = xx
                     endif
                     xH(ih,ik,il) = 0.0
                   enddo
                 enddo
               enddo
 
          enddo
        enddo
      enddo  ! fine loop sulla centratura

      enddo  ! fine loop sugli atomi
 
      if (iAction == 1) then
          write(lo,1000) radius,npunti,denel, 
     *                                 denel/(volume*float(npunti))
      endif
 1000 format('   Radius of the sfere .................',f9.3,/,
     +       '   Number of grid point changed.........',i5,f15.2/,
     +       '   Average density eliminated ..........',f9.3,/)

      return
      end
!------------------------------------------------------------------------------
      subroutine UsaEliche(inizTrial, ifinTrial, ier)
      USE General
      USE Riflessi
      USE Atomi
      USE RemoModule
      USE PhaseModule
!
      implicit none
      integer :: ier, nRefi, ifDiff, ncy, scrivi, inizTrial, ifinTrial
      integer :: nuset, i, j, k, kk, kStripTask1, Lung
      integer :: itype, iform, jop, jopen, ifGoOn, ifBreak
      real    :: corre, a, fomNoWind
      character*10 reje
!
      inizTrial = 1
      ifinTrial = 1
      ier = 0
      numbModels = 1
      call AllocaModelRemo(0)
      FichierOut = 'cramb_elica.pdb'
      call LoadPDB(ier)
!
!-- move coordinates
!
      k = index(fname(1),'.bin')
      kk = kStripTask1(k) - 1
      FichierOut = fname(1)(1:kk) // '_copy_refmac.pdb'
      itype = 0
      iform = 1
      jop=jopen(jhost, FichierOut, itype, iform, ier)
      do i=1, natsInModel(WhichModel)
         do j=1, 3
            a = j
            model(WhichModel)%atoms(j,i,1) =
     *                      model(WhichModel)%atoms(j,i,1) + 0.1 * a
         enddo
      enddo
      Titolo = FichierOut(1:Lung(FichierOut))
      call outPDB(jhost, 0, 1, 0, 1)
      close(jhost)
!
      nRefi = 5
      nRefi = 1
      ifDiff = 0
      scrivi = 1
      ncy    = 1
      call UseRefmac(FichierOut, nRefi, ifDiff, ncy, scrivi, ier)
      numbrun = 1
!
!-- translates phases
!
      nrfac = 1
      krfac = 1
      jBlock = 1
      nSetsFineDSR = 1
      BackPh(1:8000) =  iphaz(1:8000)
      BackWT(1:8000) =  wt(1:8000)
      call Relax(ier, fomNoWind, ifGoOn, ifBreak)
      FOMs(1,4) = fomNoWind
      absfom = 0.0
      coms   = 0.0
      nundet = 0
      nuset = numbrun
      call fomsp(nuset, reje)
      corre = 0.0
      call ManageEarlyFom(FOMs(1,4), corre, erore)
      ncy    = 1
      call PutGetInitialPhases(1, ncy, figMer, wt, iphaz)
!
      return
      end
!------------------------------------------------------------------------------
      subroutine LoadPDB(ier)
      USE General
      USE Atomi
      USE RemoModule
!
      implicit none
      integer :: jop, jopen, istat, iform, ier
      integer :: i, j, k, l
      integer :: ifHet
      character (len=4) :: SpeciesTmp(18), a4
!
      ifHet = 0
      cardDiret = nome(1:lnome) // '_refmac0.pdb'
      istat = 2
      iform = 1
      jop = jopen(jhost, FichierOut, istat, iform, ier)
!
      call ManagePDBSir(0, 0, 0, 0, 1, ier)
      if (ier < 0) then
          return
      endif
      close(jhost)
!
      SpeciesTmp(1:18) = Species(1:18)
      call RestoreLists123(3)   ! modificato dalla lettura del PDB
!
      do i=1, natsInModel(WhichModel)
         k = model(WhichModel)%specie(i,1) / nzConst
         a4 = SpeciesTmp(k)
         do j=1, nk
            if (a4 == Species(j)) then
                k = j
                exit
            endif
         enddo
         model(WhichModel)%specie(i,1) = k * nzConst
      enddo
!
      call GetModel
!
      return
      end
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!-----------------------------------------------------------------------
!     MODULE PhMod
!          integer :: nAu, nkPh
!          integer, allocatable :: Pderiv_v(:)
!          real,    allocatable :: Rderiv_1(:)
!          integer, allocatable :: Ptota(:), Pub_target(:)
!          integer, allocatable :: Ftarget(:)
!          real,    allocatable :: Wtota(:), Rtarget(:)
!          integer, allocatable :: ancora(:)
!          integer, allocatable :: Pfinal(:)
!          real   , allocatable :: Wfinal(:)
!          real   , allocatable :: Usin(:), Ucos(:)
!          real   , allocatable :: Rderiv_0(:)
!          real   , allocatable :: Pesi_MR(:)
!          integer, allocatable :: Fasi_MR(:)
!          real   , allocatable :: Fcvet_MR(:)
!          real   , allocatable :: Pesi_Sav(:)
!          integer, allocatable :: Fasi_Sav(:)
!          real   , allocatable :: MappaSomma(:,:,:)
!          integer, allocatable :: RifPh(:)
!          real   , allocatable :: RifWt(:)
!          integer, allocatable :: Estinti(:)
!          integer              :: ancella
!          integer              :: ancellaMax
!          integer              :: BigCycles
!          integer              :: nBigCycles =   1
!          integer              :: nMicro_PHA, nMicro_PHA2
!          integer              :: nDer
!          integer              :: nVR = 1
!          integer              :: npMix(3)
!          real                 :: VettRisultati(50)
!          real                 :: VettFom(50)
!          real                 :: tabOrigin(320,3)
!          real                 :: RatioModelTarget = 1.0
!          integer              :: nOrigPHA
!          logical              :: mista
!          logical              :: ModificaNp = .true.
!          logical              :: AddRis = .true.
!          logical              :: AssiFixed = .true. ! .true.
!          logical              :: calcFC = .false. ! .true.
!     ENDMODULE PhMod
!-----------------------------------------------------------------------
!      MODULE MtzMod
!           integer              :: MTZOUT, NSYMTZ, NSYMP, NSPGR
!           integer              :: MaxLab = 200
!           integer              :: MaxSym = 192
!           real                 :: RSYM(4,4,192)
!!
!           character (len= 1)   :: Col1, Col2, Col3, Col4, Col5, Col6
!           character (len=10)   :: SPGRNAM, PGNAM
!           character (len=20)   :: CrystalName, ProjectName, DataSetName
!           character (len=30)   :: LabCol1, LabCol2, LabCol3, LabCol4, 
!     *                             LabCol5, LabCol6, HLA, HLB, HLC, HLD
!!
!!-- ASU
!!
!           integer              :: NSPGRP_MASTER, NLAUE_MASTER
!           integer              :: NSYMP_MASTER, NSYM_MASTER
!           character (len=10)   :: NAMSPG_MASTER, PGNAME_MASTER
!           character (len= 1)   :: LATTYP_MASTER
!           real                 :: RSYMT_MASTER, RSYM_MASTER
!           real                 :: ha, hb, hc, hd, peso
!!
!           COMMON /ATSYM/  RSYM_MASTER(4,4,192), RSYMT_MASTER(4,4,192),
!     +                     NSYM_MASTER, NSYMP_MASTER, NSPGRP_MASTER, 
!     +                     NLAUE_MASTER
!           COMMON /ATSYM_CHAR/ NAMSPG_MASTER, PGNAME_MASTER, 
!     *                     LATTYP_MASTER
!      real, allocatable         :: hkl(:,:)
!!
!      ENDMODULE MtzMod
!-----------------------------------------------------------------------
      subroutine Trasla_Origine_PHA(riferimento, fasi, peso)
      USE General
      USE Symmetry
      USE TestStuff
      USE Riflessi
      USE PhaseModule
      USE PhMod
!
      implicit none
      integer :: riferimento(nrefl), fasi(nrefl)
      integer :: i, k, knwSav, ifPhantomSav, ier
      real    :: peso(nrefl), delta, phih, phihr, xyzmaxSav(3)
!
      ifPhantomSav = ifPhantom
      ifPhantom    = 0
      knwSav = knw
      knw = 1
*     write(6,*) 'Trasla_Origine_PHA'
*     do i=1, nrefl
*     write(6,*)i,Pub_target(i),riferimento(i),fasi(i),RifWt(i), peso(i)
*     enddo
!
      if (knwSav == 1) then
          k = 1
      else
          k = 0
      endif
      call examin(0,mkang,khl, Pub_target,riferimento,nrefl,0,RifWt,k)
      call examin(333,mkang,khl,riferimento,fasi,nrefl,0,peso,k)
      do i=1,nrefl
         phih = fasi(i)*dtor
         delta = khl(1,i)*shiftexam(1)+khl(2,i)*shiftexam(2)
     *                          +khl(3,i)*shiftexam(3)
         phihr = shiftexam(4) * phih - 2.0 * pi * delta
         fasi(i) = nint(phihr*rtod)+360000
         fasi(i) = mod(fasi(i),360)
      enddo
      call examin(444,mkang,khl,riferimento,fasi,nrefl,0,peso,k)
!
      knw = knwSav
      ifPhantom = ifPhantomSav
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Phantom(ier, fromPhasing)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE PhMod
      USE TestStuff
      USE MapTest
      USE Param
      USE Tutto, only : wt11
      USE RemoModule, only : ifFreeLunchMR
!
      implicit none
      integer :: ier, ipher, ifm, i, j, iyStart, zero, uno, kkk, nkkk
      integer :: numbLSQSav, num_cs, num_ncs, tipo, fromPhasing
      real    :: bes, erre0, correl
      real    :: vettoreRis(10), OldFom
      logical :: Traslazioni
      character (len=11) :: tirang
!
      zero = 0
      uno = 1
      ier = 0
      ifPhantom = 1
      call RoutineHeader('Phantom')
!
      write(lo, 210) v_m, v_p, v_s
!
      if (numbGen > 0) then
         ifFreeLunchMR = 1
      else
         ifFreeLunchMR = 0
      endif
!
      call Phantom0(ier, fromPhasing)
      if (ier /= 0) then
          return
      endif

!
      sogFinalFom = 4.00
      sogFinalFom = 44.00
!

*     knw = 0

      call Phantom_nab()

*     knw = 1


      call FinalPhantom(ier)
!
      return
  210 format (' Matthews coefficient  =',f12.2,/,
     *        ' Protein fraction      =',f12.2,/,
     *        ' Solvent fraction      =',f12.2,/)
      end
!-----------------------------------------------------------------------
      subroutine Phantom_nab()
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Molcom
      USE PhMod
      USE TestStuff
      USE Mappa
      USE MapTest
      USE Param
      USE Tutto, only : wt11
      USE CowMod
!
      implicit none
      integer :: ipher, ifm, i, j, ier, jpatt, ii
      real    :: vettoreRis(10), correl, pm
      character (len=11) :: tirang
!
*     TSinCos(:,:) = 0
!
      if (FichierOut(1:1) /= ' ') then
          call WriteMTZ_Refmac(0, ier)
          call ContaResidui
      endif
!
      Ftarget(1:nrefl) = fovet(1:nrefl)
      RifPh(1:nrefl) = Fasi_MR(1:nrefl)
!
      if (knw == 1) then
         call examin(1,mkang,khl,Pub_target,Fasi_Sav,nrefl,0,Pesi_Sav,1)
         tirang = 'FASI V-FL  '
         ipher = 1
         call pherrdisNew(tirang, Pesi_Sav, khl, mkang, nrefl, 0,
     *                   Pub_target, Fasi_Sav, Pesi_Sav, 20, 0.0, ipher)
      endif
!
      nBigCycles = 2
      call GeneraTraslazioni
      ancellaMax = nOrigPHA
      if (jscreen > 0) then
          write(Msg,40) nBigCycles, ancellaMax
          call OneBlankOnly(Msg)
          call TestoGR(Msg, -1, 2, 3)
          Msg = '... starting PhD ... '
          call TestoGR(Msg, -1, 2, 3)
      endif


*     knw = 0

      do BigCycles=1, nBigCycles
         nDer = 0
         ancora(1:nrefl) = 0
         do ancella=1, ancellaMax
            nDer = nDer + 1
            call PrintStepInfo()
            call StepT()
         enddo
*     knw = 1
         call FinalStepT(correl)
         if (FichierOut(1:1) /= ' ') then
             call ApplicaRefmac
         endif
!
!
         iphaz(1:nrefl) = Pfinal(1:nrefl)
         wt(1:nrefl) = Wfinal(1:nrefl)
         if (knw == 1) then
             ifm = 1
             call examin(9999,mkang,khl, ipub, iphaz, nrefl, 0, wt, ifm)
         endif
!
         if (LowRes == 1) then
             AddRis = .true.
             jumpVLD = 1
             call Cicla_VLD(1, -5, 0, vettoreRis)   !      Procedura VLD
             jumpVLD = 0
             call FillVett_PHA(erore) ! FL  20gennaio2017
             if (knw == 1) then
                 write(6,10) erore, erorepes, isumal
             endif
             call LastTangent
         endif
!
         Pfinal(1:nrefl) = iphaz(1:nrefl)
         Fasi_MR(1:nrefl) = iphaz(1:nrefl)
         Pesi_MR(1:nrefl) = wt(1:nrefl)
         Fasi_Sav(1:nrefl) = iphaz(1:nrefl)
         Pesi_Sav(1:nrefl) = wt(1:nrefl)
!
!-- ricalcolo FC
!
          if (ifMadData == 1) then     ! gianluca correzione 1 giugno 2017
              fcoef(1:nrefl) = Ftarget(1:nrefl) * Pesi_MR(1:nrefl)
              jpatt = 0
              call MakeMap(fcoef, Fasi_MR, nrefl, jpatt, xmap,
     *                     FORTH, BACK)
              ii = invflag
              pm = percMap
              percMap = 0.5
              invflag = 1
              call InvMap(khl,mkang,jwork1,fcvet,nrefl)
              wt(1:nrefl) = Pesi_MR(1:nrefl)
              Fcvet_MR(1:nrefl) = fcvet(1:nrefl)
              invflag = ii
              percMap = pm
              ifMadData = 0
          endif

      enddo
      if (LowRes == 0) then
          AddRis = .true.
          call FillVett_PHA(erore)
      endif
!
      return
   10 format(/,' Free Lunch ends - Mean Phase Error',f6.2,' (',f6.2,
     *       ')  over ',i7,' reflections',/)
   40 format(i3,' cycles and ',i3,' ancils will be used')
      end
!-----------------------------------------------------------------------
      subroutine ContaResidui
      USE General
      USE Symmetry
      USE Groups
      USE PhMod
!
      implicit none
      integer :: jop, jopen, ier, oldRes, nRes, n, na, nb, i, Lung
      real    :: ratio1, ratio2
!
      jop = jopen(jrel, FichierOut, 0, 1, ier)
      oldRes = -9999
      nRes = 0
      na   = 0
      do
         read(jrel,'(a)',end=100) Inte
         if (Inte(1:4) /= 'ATOM') cycle
         read(Inte,10) n
         na = na + 1
         if (n /= oldRes) then
             nRes = nRes + 1
             oldRes = n
         endif
      enddo
  100 close (jrel)
      nb = 0
      do i=1, nk
         if (no(i) /= 1) then
             nb = nb + nw(i)
         endif
      enddo
      nb = nb / totop
      if (knw == 1) then
          write(6,*) 'RESIDUI NEL MODELLO ',nRes
          write(6,*) 'nResid, nAcid, nResTot, nResidStored'
          write(6,*)  nResid, nAcid, nResTot, nResidStored 
          endif
      n = nResidStored + nAcid
      ratio1 = float(nRes) / float(n)
      ratio2 = float(na) / float(nb)
      write(lo,20) FichierOut(1:Lung(FichierOut))
      write(lo,30) nRes, na, n, nb, ratio1, ratio2
!
      RatioModelTarget = ratio2
      if (RatioModelTarget < 1.6) then
          call ModificaFasiRemo
      endif
      return
   10 format(22x,i4,a1)
   20 format(' Model from ',a,' file')
   30 format(/,'        Residues    Atoms',/,
     *         ' Model  ',i6,4x,i6,/,
     *         ' Target ',i6,4x,i6,/,
     *         ' Ratio  ',f6.2,4x,f6.2,/)
      end
!-----------------------------------------------------------------------
      subroutine ModificaFasiRemo
      USE General
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE Param
      USE PhMod
!
      implicit none
      integer :: ipher, jpatt, nRefi, ifDiff, NREFMAC, ier, Phi, i
      integer :: ifBreak
      real    :: PHI1, PHI2, T, B
      character (len=11) :: tirang
!
      cardDiret = nome(1:lnome) // '_PerRefmac.mtz'
      i = knw
      call WriteMTZ_Express(i, 0, cardDiret, ier)
!
      if (knw == 1) then
          call examin(1,mkang,khl,Pub_target,iphaz,nrefl,0,wt,1)
          ipher = 1
          tirang = 'Step 0     '
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                     Pub_target, iphaz, wt, 20, 0.0, ipher)
      endif
!
      nRefi = 0
      ifDiff = 0
      NREFMAC = 0
      call UseRefmac(FichierOut, nRefi, ifDiff, NREFMAC, 0, ier)
      Fcvet_MR(1:nrefl) = fcvet(1:nrefl)
      call Normalize(1, fcvet, worko)
      do i=1, nrefl
         fcoef(i) = ( 2.0 * evet(i) - worko(i) ) ! * wt(i)
      enddo
      jpatt = 0
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH,BACK)

      jwork1(1:nrefl) = iphaz(1:nrefl)

      nRefi = 0
      ifDiff = 1
      NREFMAC = 0
      call UseRefmac(FichierOut, nRefi, ifDiff, NREFMAC, 0, ier)
      iphaz(1:nrefl) = jwork1(1:nrefl)
      fcoef(1:nrefl) = fovet(1:nrefl)               + fcvet(1:nrefl)
      jpatt = 0
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH,BACK)
!
      percMap = 0.10
      invflag = 1
      call InvMap(khl,mkang,jwork1,worko,nrefl)
      wt(1:nrefl) = tmpwt(1:nrefl)
      if (knw == 1) then
          call examin(3,mkang,khl,Pub_target,jwork1,nrefl,0,wt,1)
          ipher = 1
          tirang = 'Step 2     '
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                     Pub_target, jwork1, wt, 20, 0.0, ipher)
          call examin(31,mkang,khl,Pub_target,iphaz,nrefl,0,wt,1)
          call examin(32,mkang,khl,Pub_target,jwork1,nrefl,0,wt,1)
      endif
      do i=1, nrefl
         PHI1 = float(iphaz(i)) * dtor
         PHI2 = float(jwork1(i)) * dtor
         T = sin(PHI1) + sin(PHI2)
         B = cos(PHI1) + cos(PHI2)
         Phi = nint(3600 + atan2(T, B) * rtod)
         iphaz(i) = Phi
      enddo
      if (knw == 1) then
          call examin(4,mkang,khl,Pub_target,iphaz,nrefl,0,wt,1)
      endif
      Fasi_MR(1:nrefl) = iphaz(1:nrefl)
      Fasi_Sav(1:nrefl) = iphaz(1:nrefl)
!
      nVR = nVR - 1
      AddRis = .true.
      call FillVett_PHA(erore)
      AddRis = .false.
!
      return
      end
!-----------------------------------------------------------------------
      subroutine FinalStepT(correl)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE Param
      USE PhMod
      USE MapTest
      USE TestStuff, only : ifFloatOrigin
      USE Tutto, only : wt11
      USE RemoModule, only : ifFreeLunchMR
      USE HistoStuff
      USE CowMod
!
      implicit none
      integer :: i, j, k, ifBreak, ifm, ipher, nMicro_SOMMA, jpatt
      integer :: numberToUse, ier, iFL
      integer :: numbRileggi, ifAborted, kk, nera, nerb, nerc
      real    :: correl, chope, div, w, vettoreRis(10), Q, R, bes, arg
      real    :: era, erb, erc, er2, er3
      character (len=11) :: tirang
!
      invflag = 1
      percMap = 0.05
      if (.not.allocated(wt11)) then
          allocate(wt11(1:nrefl), stat = ier)
      endif

      ipub(1:nrefl) = Pub_target(1:nrefl)
      div = ancellaMax
      chope = 0.25
!
      xmapApp = MappaSomma / div
!
      xmap(:,:,:) = xmapApp(:,:,:)

      if (LowRes == 0) then
          nMicro_SOMMA = 10
          do indiceMicro = 1, nMicro_SOMMA
             numbrun = indiceMicro
             if (indiceMicro > 1) then
                 fcoef(1:nrefl) = Rtarget(1:nrefl) * wt(1:nrefl)
                 jpatt = 0
                 call MakeMap(fcoef, iphaz, nrefl,jpatt,xmap,FORTH,BACK)
             endif

             call ModificaMappa()

             call NewInvCuda(iphaz, fcvet, nrefl, np(1), np(2), np(3),
     *                          BACK, xmap)
             wt(1:nrefl) = 1
             call Normalize(2, fcvet, fcvet)
             call Weights_Calculation_NEW(nrefl,nrefl,chope, correl,
     *                                    ifBreak)
!
             if (indiceMicro > 1) then
                 do i=1, nrefl
                    w = wt(i)
                    if (w < 0.10) w = 0.10
                    wt(i) = 0.7 * w ** 0.5
                 enddo
             endif
             if (knw == 1) then
                 ifm = 0
                 call examin(7,mkang,khl,Pub_target,iphaz,nrefl,0,wt,0)
             endif
             if (indiceMicro <= 2) then
                 if (indiceMicro == 1) then
!
                     er2 = erore
                     AddRis = .false.
                     call FillVett_PHA(erore)
*                    call TangenteT(er3)
!
                 endif
                 tirang = 'SOMMA      '
                 write(tirang(7:8),'(i2)') indiceMicro
                 ipher = 1
                 call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                            Pub_target, iphaz, wt, 20, 0.0, ipher)
             endif
          enddo
!
          AddRis = .true.
          call FillVett_PHA(erore)
          AddRis = .false.
          call FillVett_PHA(0.0)
          call FillVett_PHA(erore)
          AddRis = .false.
!
      else
          call NewInvCuda(iphaz, fcvet, nrefl, np(1), np(2), np(3),
     *                    BACK, xmap)
          wt(1:nrefl) = 1
          call Normalize(2, fcvet, fcvet)
          numberToUse = nrefl
          call Weights_Calculation_NEW(nrefl,numberToUse,chope, correl,
     *                                    ifBreak)
!
          if (knw == 1) then
              call examin(7,mkang,khl,Pub_target,iphaz,nrefl,0,wt,1)
              tirang = 'SOMMA COW 0'
              ipher = 1
              call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                         Pub_target, iphaz, wt, 20, 0.0, ipher)
          endif
          er2 = erore
          erc = erore
          nerc = isumal

          if (BigCycles >= 2) then ! nuova procedura
!
!-- NUOVA FEATURE: ai riflessi non stimati viene assegnata la fase MR
!
              if (knw == 1) then
                  call examin(765,mkang,khl,Pub_target,Fasi_MR,nrefl,0,
     *                        Pesi_MR,1)
              endif
              wto(1:nrefl) = 0
              do i=1, nrefl
                 if (wt(i) > 0.0) cycle
                 if (Pesi_MR(i) > 0) then
                     iphaz(i) = Fasi_MR(i)
                     wt(i) = Pesi_MR(i)
                     wto(i) = Pesi_MR(i)
                 endif
              enddo
              if (knw == 1) then
                 call examin(7,mkang,khl,Pub_target,iphaz,nrefl,0,wto,1)
                  erb = erore
                  nerb = isumal
                  tirang = 'SOMMA ADDED'
                  ipher = 1
                  call pherrdisNew(tirang, wto, khl, mkang, nrefl, 0,
     *                           Pub_target, iphaz, wto, 20, 0.0, ipher)
                  call examin(7,mkang,khl,Pub_target,iphaz,nrefl,0,wt,1)
                  erc = erore
                  nerc = isumal
                  tirang = 'SOMMA CO 00'
                  ipher = 1
                  call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                           Pub_target, iphaz, wt, 20, 0.0, ipher)
              endif
!
!-- NUOVA FEATURE: FINE
!

          endif
          AddRis = .true.
          call FillVett_PHA(erore) ! Sum 0  20gennaio2017
          AddRis = .false.
          wto(1:nrefl) = 0
          do i=1, nrefl
             if (ancora(i) > 0) then
                 wto(i) = wt(i)
             else
                 wto(i) = 0
             endif
          enddo
          if (knw == 1) then
              call examin(8,mkang,khl,Pub_target,iphaz,nrefl,0,wto,1)
          endif
          era = erore
          nera = isumal
          wto(1:nrefl) = 0
          do i=1, nrefl
             if (ancora(i) == 0) then
                 wto(i) = wt(i)
             else
                 wto(i) = 0
             endif
          enddo
          if (knw == 1) then
              call examin(9,mkang,khl,Pub_target,iphaz,nrefl,0,wto,1)
          endif
          if (BigCycles == 1) then ! vechio standard 
              erb = erore
              nerb = isumal
          endif

          if (knw == 1) then
              write(6,55) era, nera, erb, nerb, erc, nerc
          endif
*         call TangenteT(er3)
          ifPhantom = -5
          call Cicla_LOW(1)
          ifPhantom = 1
          if (knw == 1) then
              ifm = 0
              call examin(7,mkang,khl,Pub_target,iphaz,nrefl,0,wt,1)
              tirang = 'SOMMA COW n'
              ipher = 1
              call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                         Pub_target, iphaz, wt, 20, 0.0, ipher)
          endif
!
          AddRis = .true.
          call FillVett_PHA(erore) ! Sum N  20gennaio2017
      endif
!
      Wfinal(1:nrefl) = Pesi_MR(1:nrefl)
      Pfinal(1:nrefl) = iphaz(1:nrefl)
!
      MappaSomma(:,:,:) = 0
      if (allocated(wt11)) then
          deallocate(wt11, stat = ier)
      endif
!
      return
   55 format('STATS','  S',3(f8.2,i8))
      end
!-----------------------------------------------------------------------
      subroutine ApplicaRefmac
      USE General
      USE Riflessi
      USE PhaseModule, only : erore, erorepes, LowRes, jumpVLD
      USE ArpWarp
      USE PhMod
!
      implicit none
      integer :: nRefi, ifDiff, ier, NREFMAC, k, Lung, nAtoms, ifAll
      integer :: Macro, nMacroRef, nBatch, nVolte, nVolteMax, previous
      integer :: MaxBatch, ndPhi, i, ipher
      real    :: R, Rfree, vecchioValore, RFree0, RFreen, DeltaRFree
      real    :: erreUsed, dPhi, dPhiSog, dif, RFreeRef
      real    :: vettoreRis(10)
      character (len= 5)  :: a5
      character (len= 80) :: Stringa
      logical :: UsaRfree
      real, allocatable    :: FasiPrecedenti(:)
      real, allocatable    :: PesiPrecedenti(:)
      character (len=11) :: tirang
!
      ier = 0
      iphaz(1:nrefl) = Pfinal(1:nrefl)
      wt(1:nrefl)    = Wfinal(1:nrefl)

!
!-- modifica pesi
!
      do i=1, nrefl
         if (wt(i) > 0) then
             if (wt(i) < 0.10) wt(i) = 0.10
             wt(i) = sqrt(wt(i))
         endif
*        iphaz(i) = Pub_target(i)
      enddo
      if (knw == 1) then
          call examin(1, mkang, khl, Pub_target, iphaz, nrefl,0, wt, 1)
          ipher = 1 ;  tirang = 'PER REFMAC '
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                     Pub_target, iphaz, wt, 20, 0.0, ipher)
      endif
!
      write(lo,140)
      ifDiff = 0
      nRefi = 10
      FasiPerRefmac = 0
      i = knw
      cardDiret = nome(1:lnome) // '_PerRefmac.mtz'
      call WriteMTZ_Express(i, 0, cardDiret, ier)
      write(6,130) FichierOut(1:Lung(FichierOut))
!
      nRefi = 2
      write(lo,120) nRefi
!
      ndPhi = 0
      dPhi = 99
      dPhiSog = 3.0
      allocate (FasiPrecedenti(1:nrefl), stat = ier)
      allocate (PesiPrecedenti(1:nrefl), stat = ier)
      FasiPrecedenti(:) = 0
      PesiPrecedenti(:) = 0
!
      if (knw == 0) then
          write(lo,10)
      else
          write(lo,15)
      endif
      UsaRfree = .true.
      UsaRfree = .false.
!
      NREFMAC = 0
      if (nRefi == 0) then
          vecchioValore = -9999
      else
          vecchioValore = 9999
      endif
      nVolteMax = 2
      nMacroRef = 2
      nMacroRef = 1
      tutto: do Macro=1, nMacroRef
         if (Macro == 1) then
             nVolteMax = 2
             MaxBatch = 30
             MaxBatch = 1
         else
             nVolteMax = 1
             MaxBatch = 30
             write(6,*)
             nRefi = 10
             FasiPerRefmac = -1
             write(lo,100) nRefi
         endif
*        MaxBatch = 1
         nVolte = 0
         do nBatch=1, MaxBatch ! 30
            NREFMAC = NREFMAC + nRefi
            call UseRefmac(FichierOut, nRefi, ifDiff, NREFMAC, 0, ier)
            if (UsaRfree) then
                erreUsed = RfreAW
            else
                erreUsed = RfacAW
            endif
!
            if (ndPhi == 0) then
                a5 = '     '
            else
                dPhi = 0
                ndPhi = 0
                do i=1, nrefl
                   if (wt(i) > 0.0 .and. PesiPrecedenti(i) > 0.0) then
                       dif = iphaz(i) - FasiPrecedenti(i)
                       dif = cos(dif * dtor)
                       dif = acos(dif) * rtod
                       if (dif > 180.0) dif = 360.0 - dif
                       dPhi = dPhi + dif
                       ndPhi = ndPhi + 1
                   endif
                enddo
                if (ndPhi > 0) dPhi = dPhi / float(ndPhi)
                write(a5,'(f5.2)') dPhi
            endif
            FasiPrecedenti(1:nrefl) = iphaz(1:nrefl)
            PesiPrecedenti(1:nrefl) = wt(1:nrefl)
            ndPhi = 1
            if (knw == 0) then
                write(lo,20) NREFMAC, RfacAW, RfreAW, a5
            else
                write(lo,20) NREFMAC, RfacAW, RfreAW, a5,
     *                       erore, erorepes, erreUsed
            endif
!
            FichierOut = nome(1:lnome) // '_refmac0.pdb'
            cardDiret  = nome(1:lnome) // '_refmac.pdb'
            if (Macro == 3 .and. nBatch == 1) then !(nBatch == 1 .or. nBatch == 3)) then
                ifAll = 0
                call DelHOH(cardDiret, FichierOut, nBatch, ifAll)
                vecchioValore = 9999
                erreUsed      = 9998
            else
                call cCopyFile(cardDiret, FichierOut)
            endif
            if (erreUsed > vecchioValore) then
                nVolte = nVolte + 1
                if (nVolte == nVolteMax) then
                    exit
                else
                    erreUsed = vecchioValore
                endif
            endif
            vecchioValore = erreUsed
            if (Macro == 1 .and.  nBatch == 1) then
               RFree0 = erreUsed
               RFreeRef =  RfreAW
            endif
!
            if (dPhi < dPhiSog) then
                if (knw == 1) then
                    write(6,70) 'D(phi): EXIT IF ',dPhi, dPhiSog
                endif
                exit tutto
            endif
            if (mod(NREFMAC,50) == 0) then
                if (RfreAW > RFreeRef) then
                    if (knw == 1) then
                        write(6,50) 'Rfree: EXIT IF ',RfreAW, RFreeRef
                    endif
                    exit tutto
                else
                    RFreeRef = RfreAW
                endif
            endif
!
         enddo
!
         vecchioValore = 9999
      enddo tutto
!
      RFreen = erreUsed 
      DeltaRFree = ( RFree0 - RFreen)/ RFreen
      if (knw == 1) then
          write(6,30) 'NREFMAC',NREFMAC, DeltaRFree
          write(lo,40) NREFMAC, RfacAW, RfreAW, erore, erorepes
          write(lo,45) NREFMAC, RfacAW, erore
          write(6,60) erore, NREFMAC
      endif
!
      AddRis = .true.
      call FillVett_PHA(erore)
      AddRis = .false.
!
      if (knw == 1) then
          call examin(2, mkang, khl, Pub_target, iphaz, nrefl,0, wt, 1)
          ipher = 1 ;  tirang = 'DOPO REFMAC'
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                     Pub_target, iphaz, wt, 20, 0.0, ipher)
      endif

      write(lo,140)
!
      if (LowRes == 0) then
          call Cicla_PHA
      else
          ifPhantom = -5
          call Cicla_VLD(1,-5, 1, vettoreRis)
      endif
      AddRis = .true.
      call FillVett_PHA(erore)
!
      Pfinal(1:nrefl) = iphaz(1:nrefl)
      Wfinal(1:nrefl) = wt(1:nrefl)
!
      deallocate (FasiPrecedenti, PesiPrecedenti, stat = ier)
!
      return
   10 format(/,' Cycles  R factor',3x,'R free',3x,'D(phi)')
   15 format(/,' Cycles  R factor',3x,'R free',3x,'D(phi)',
     *      3x,'MPE     wMPE       R test')
   20 format(2x,i3,3x,f8.4,2x,f8.4,3x,a5,2f8.2,5x,f8.4)
   30 format(2x,a,i5,'   Delta(Rfree) =',f9.4)
   35 format(2x,'BMOD   ',2f8.2)
   36 format(2x,'ADDW   ',2f8.2)
   37 format(2x,'DELH   ',2f8.2)
   40 format(2x,'After ',i3,' Refmac cycles: ',f8.4,2x,f8.4,2f8.2)
   45 format(2x,'REFMAC ',i3,' ; ',f8.4,' ; ',f8.2,' ; ')
   50 format(a,f8.4,' >',f8.4)
   60 format('MPEREFMAC ',f8.2,' ;',/,'NCICLI ',i3,' ;')
   70 format(a,f8.2,' <',f8.2)
  100 format(/,' Starting Refmac: batches of ',i2,' cycles')
  110 format(/,' Remo phases are recomputed using Refmac')
  120 format(/,' Starting Phases-Driven Refmac: batches of ',i2,
     *         ' cycles')
  130 format(' Using model ',a)
  140 format(/,78('+'),/)
      end
!-----------------------------------------------------------------------
      subroutine TangenteT(er3)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE PhMod
      USE TestStuff
!
      implicit none
      integer :: i, Phi
      real    :: er3, arg1, arg2, Q, T, bes
!
      do i=1, nrefl
         arg1 = float(PTota(i)) * dtor
         arg2 = float(iphaz(i)) * dtor
         Q = Wtota(i) * sin(arg1) + wt(i) * sin(arg2)
         T = Wtota(i) * cos(arg1) + wt(i) * cos(arg2)
         Phi = nint(3600 + atan2(Q, T) * rtod)
         Ptota(i) = mod(Phi, 360)
         arg1 = sqrt(Q*Q+T*T)
         Wtota(i) = bes(arg1)
      enddo
      call examin(1111, mkang, khl, Pub_target, Ptota, nrefl, 0,Wtota,1)
      er3 = erore
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GeneraTraslazioni
      USE General
      USE Symmetry
      USE PhaseModule
      USE PhMod
!
      implicit none
      integer :: i, j, k, l, n, ix, numbRandom, numb, iyStart, ktl
      integer :: iniz, ifin, nFloat, nFixed, nnumb, nTot, ifinC, noP1
      real    :: yfl, centra(3)
      logical :: ifNotFloating
!
      if (nsym == 1 .and. icent == 0) then
          noP1 = 1
      else
          noP1 = 3
      endif
      numbRandom = 8
      numb = numbRandom / 4
      iyStart = 67543
      iyrand = iyStart
      ifNotFloating = .true.
      nFloat = 0
      write(lo,*) 
      write(lo,*) 'Allowed origin translations: ',
     *            '(256 or 128 indicates a floating direction)'
      do i=1, nOrigRoxi
         write(6,10) i, tabo(i,1:3)
         if (tabo(i,1) > 127 .or. tabo(i,2) > 127 .or. 
     *       tabo(i,3) > 127) then
             nFloat = nFloat + 1
         endif
      enddo
      if (nFloat == 0) then
          AssiFixed = .true.
      else
          AssiFixed = .false.
      endif
      nFixed = nOrigRoxi - nFloat
      numb = 8 - nFixed
      if (nFloat > 0) then
          numb = nint(float(numb) / float(nFloat))
      endif

      nnumb = numb
      nTot = nFixed + nFloat*numb
      if (nFloat > 0) then
!         nTot = numb   ! TEST
      endif
      if (nTot < 8) then
          ifinC = ncentr
      else
          ifinC = 1
      endif
!
      iniz = 2
      ifin = nOrigRoxi
      do i=1, 3
         if (tabo(1,i) > 127) then
             iniz = 1
         endif
      enddo
      
      write(lo,*) 
      write(lo,*) 'Following translations will be used in PhD:'
      IYsolve = iyrand
      ix = iyrand
      n = 0
      do k=1, ifinC  ! ncentr ! 1
         if (k> 1) then
             iniz = 1
         endif
         ktl = (k-1)*3
         do l=1, 3
            centra(l) = centrt(latt, ktl+l)
         enddo
         do i=iniz, ifin
*           do j=1, 3
            do j=1, noP1
               if (tabo(i,j) > 127) then
                   ifNotFloating = .false.
                   do l=1, numb
                      call SirRandom(ix, iyrand, yfl)
                      ix = iyrand
                      n = n + 1
                      tabOrigin(n,1:3) = tabo(i,1:3) + centra(1:3)
                      if (noP1 == 3) then
                          tabOrigin(n,j) = yfl
                      else
                          tabOrigin(n,1:3) = yfl
                      endif
                   enddo
               endif
            enddo
            if (ifNotFloating) then
                n = n + 1
                tabOrigin(n,1:3) = tabo(i,1:3) + centra(1:3)
            endif
         enddo
      enddo
      write(lo,*) 

      if (n == 0) then
          call cstop('Nessun derivato possibile')
      endif
      nOrigPHA = n
      do i=1, nOrigPHA
         write(6,10) i, tabOrigin(i,1:3)
      enddo
      VettRisultati(1) = nOrigPHA
!
      iyStart = 67543
      iyrand = iyStart
!
      return
   10 format(i3,1h), 3f10.4)
      end
!-----------------------------------------------------------------------
      subroutine Calcola_FinalFom_PHA(init)
      USE General
      USE PhaseModule
!
      implicit none
      integer :: ipr, init
      real    :: numFom, denomFom
      real    :: dumpFFom0, dumpFFom
      real    :: FFom_1, FFom_2
!
      ipr = knw 
!
!--nuovo calcolo di FinalFom
!
      call Calcola_FOM_Lib(1)
!
      numFom = CCEoEc(1)*CCEoEc(2)*FOMs(2,4) 
      denomFom = fomold(1)*fomold(2)*fomold(3)
      FFom_1 = numFom / denomFom

      dumpFFom0 = CCEoEc(1)

      if (CCEoEc(1) > 0.00001) then
          dumpFFom = sqrt(CCEoEc(1))
      else
          dumpFFom = 0.001
      endif 

!     FFom_2 = FFom_1 *  dumpFFom0
      FFom_2 = FFom_1 *  dumpFFom
!     
      if (ipr == 1) then
          if (init == 1) then
              write(6, 50) figuracce(2,1:3)
              write(6,100) CCEoEc(1:2),FOMs(2,4)
              write(6,200) fomold(1:3)
              write(6,300) numFom, denomFom, CCEoEc(1)
              write(6,400) FFom_1, FFom_2, dumpFFom
          else 
              write(6, 5) figuracce(2,1:3)
              write(6,10) CCEoEc(1:2),FOMs(2,4)
              write(6,20) fomold(1:3)
              write(6,30) numFom, denomFom, CCEoEc(1)
              write(6,40) FFom_1, FFom_2, dumpFFom 
          endif
      endif
!
      FinalFom = FFom_2
      if (knw == 1) write(6,*) 'FINALFOM', FinalFom
!

  5   format(' Current numRAT, denomRAT, RAT_cur   ',3f10.5)
 10   format(' Current CCall_cur, CClarge_cur, RAT_cur   ',3f10.5)
 20   format(' Current CCall_ini, CClarge_ini, RAT_ini   ',3f10.5)
 30   format(' Current numFOM, denomFOM, CC  ',3f10.5)
 40   format(' Current FFom1, FFom2, dumpFFom',3f10.5)


  50  format(' Random numRAT, denomRAT, RAT_cur   ',3f10.5)
 100  format(' Random CCall_cur, CClarge_cur, RAT_cur   ',3f10.5)
 200  format(' Random CCall_ini, CClarge_ini, RAT_ini   ',3f10.5)
 300  format(' Random numFOM, denomFOM, CC  ',3f10.5)
 400  format(' Random FFom1, FFom2, dumpFFom',3f10.5)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine FillVett_PHA(erore)
      USE General
      USE Riflessi, only : fcvet
      USE PhMod
      USE PhaseModule, only : FinalFom
      USE Tutto, only : wt11
!
      implicit none
      integer :: ier
      real    :: erore
      logical :: allocato
!
      if (AddRis) then
          allocato = .false.
          if (.not.allocated(wt11)) then
             allocate(wt11(nreflDim), stat=ier)
             allocato = .true.
          endif
          Usin(1:nrefl) = fcvet(1:nrefl)
          call Calcola_FinalFom_PHA(0)
          fcvet(1:nrefl) = Usin(1:nrefl)
          nVR = nVR + 1
          VettRisultati(nVR) = erore
          if (knw == 1) write(6,10) nVR, erore, nint(erore)
          VettFom(nVR) = FinalFom
          if (allocato) then
              deallocate(wt11, stat = ier)
          endif
      endif
!
      return
   10 format('FillVett_PHA nVR = ',i2,f8.2,i5)
      end
!-----------------------------------------------------------------------
      subroutine FinalPhantom(ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE Param
      USE PhaseStuff
      USE RfacMatrixModule
      USE PhMod
      USE Tutto, only : wt11
      USE ArpWarp
      USE TestStuff, only : ifFloatOrigin
      USE Grafici
!
      implicit none
      integer :: MSetsFineDSR, doRicicla, ier, nset, iAction, ipher
      integer :: ifFromGraphic, ifBreak, nono, ifPeak, kdsrReq
      integer :: i, l, jpatt, npunt, irisp, stampaInfo
      real    :: vettoreRis(10), delta, arg, correl
      character (len= 6) :: a6
      character (len=11) :: tirang
      character (len=16) :: gruppoSp
!
!-- modifica finale dei pesi
!
*     knw = 1
      do i=1, nrefl
         if (wt(i) > 0) then
             if (wt(i) < 0.05) then
                 wt(i) = 0.05
             endif
             wt(i) = sqrt(wt(i))
         endif
      enddo

      if (jEnan == 0) then
          ier = 0
          nset = 1
          MSetsFineDSR = nset
          iAction = 1
          call ManageFinalPhases(iAction, nrefl, nset)
          iposFineDSR(:) = 1
          call UpdateFinalPhases(cfom, iposFineDSR, nset)
          figMer(:) = 1
          call PutGetFinalPhases(1, nset, figMer)
          call LookForEnantiomorph
      endif

      if (knw == 1) then
          call examin(999, mkang, khl,  Pub_target, iphaz, nrefl,
     *                        0, wt, 1)
          ipher = 1
          tirang = 'END PHANTOX'
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                     Pub_target, iphaz, wt, 20, 0.0, ipher)
!
          write(6,65) nint(VettRisultati(1)), VettRisultati(2:nVR)
      endif
      
      if (knw == 1) then
          write(gruppoSp,'(16a1)') nSpaceG(1:16)
          call lcase(gruppoSp)
          call ucase(gruppoSp(1:1))
          write(6,67) nint(VettRisultati(2:nVR))
      endif

      call AllocaPhantom(2)
      if (allocated(wt11)) then
          deallocate(wt11, stat = ier)
      endif
      if (LowRes == 1) then
          call AllocaRiflessiCow(2)
          deallocate(MappaSomma, stat = ier)
      endif
!
      ier = 0
      nset = 1
      MSetsFineDSR = nset
      iAction = 1
      call ManageFinalPhases(iAction, nrefl, nset)
      iposFineDSR(:) = 1
      call UpdateFinalPhases(cfom, iposFineDSR, nset)
      figMer(:) = 1
      call PutGetFinalPhases(1, nset, figMer)
      if (ier == 0) then
!
!-- Calcolo mappa vera per coeff. correlazione
!
          if (knw == 1) then
              fcoef(1:nrefl)  = fovet(1:numbLSQ)
              jpatt = 0
              call MakeMap(fcoef, ipub, nrefl, jpatt, xmap,
     *                     FORTH, BACK)
              call Scrivi_Mappa_Vera(2)
              call Calcola_CC_Mappa(nrefl,correl,1,2)
              cardDiret = nome(1:lnome) // '_PhDfin.mtz'
              jwork1(1:nrefl) = iphaz(1:nrefl)
              call Trasla_Origine(nrefl)
              call WriteMTZ_Express(1, 0, cardDiret, ier)
              fcoef(1:nrefl) = fovet(1:nrefl) * wt(1:nrefl)
              jpatt = 0 
              f000 = 0
              call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                     FORTH, BACK)
              call maxmin3d(denmin,denmax,avden,stden,npunt,0)
              write(6,*) 'Mappa 2 ',denmin,denmax,avden,stden 
              call Write_CCP4_Map(xmap, 2)
              iphaz(1:nrefl) = jwork1(1:nrefl)
          endif
      endif
      stampaInfo = knw
      call MTZfiles(MSetsFineDSR, 0, stampaInfo)
      ifPhantom = 1
      if (knw == 1) then
          if (nVR > 4) then
              write(a6,'(i6)') nint(VettRisultati(nVR))
          else
              a6 = ' '
          endif
      endif
      ifPDBfiles = 0
      if (ifAmb > 0) then
          doRicicla = 1
          call Ricicla(vettoreRis, doRicicla, 1, ier)
          if (knw == 1) then
              write(6,*) 'coverage,RfacAW, RfreAW, RfacAWi, RfreAWi'
              write(6,*)  coverage,RfacAW, RfreAW, RfacAWi, RfreAWi 
              write(6,80) VettRisultati(1),   ! risoluzione
     *                    nint(VettRisultati(2)), ! MPE MR
     *                    nint(VettRisultati(3)), ! MPE COW
     *                    nint(VettRisultati(4)), ! MPE VLD_FL
     *                    a6,                     ! MPE finale
     *                    nint(coverage),         ! Coverage
     *                    nint(vettoreRis(4)),    ! MPE Refmac
     *                    RfacAW,                 ! R Refmac
     *                    RfreAW                  ! R-free Refmac
*         else
*             write(6,80) VettRisultati(1),   ! risoluzione
*    *                    nint(VettRisultati(2)), ! MPE MR
*    *                    nint(VettRisultati(3)), ! MPE COW
*    *                    nint(VettRisultati(4)), ! MPE VLD_FL
*    *                    a6                  ! MPE finale
          endif
      endif
!
      i = 5
      call ProcOver(i, irisp)
!
      call CPUTime(' ', 0)
      headersGR(2) = Inte
      HistoOK(:) = 0
      call ManageGraph(0, 0)
      call zflush
      call DoSingleIteration()
      call zflush
      call DoSingleIteration()

      return
!nVR   60 format('RISULTATI ',f6.3,50(' |',f6.2))
   65 format('RISULTATI ','|',i1,'|',f6.2,50(' |',f6.2))
   66 format('INTE ',';',a,';',i1,';',i4,50(' ;',i4))
   67 format('INTE ','|',i4,50(' |',i4))
   70 format('RISULTATI ',  6x,50(' |',f6.2))
   80 format('TAB ;',f6.2,3(' ; ',i6),' ; ',a6,' ; ',i6,'%',
     *       ' ; ',i6,2(' ; ',f7.3))
   
      end
!-----------------------------------------------------------------------
      subroutine StepT()
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE PhaseModule ! , only : LowRes, erore, erorepes, isumal
      USE PhMod
      USE Tutto, only : wt11
      USE TestStuff, only : ifFloatOrigin
      USE RemoModule, only : ifFreeLunchMR
      USE CowMod
!
      implicit none
      integer :: jpatt, Phi, i, l, ipher, shi
      integer :: j, nExt, nToUse, ifFl
      real    :: vettoreRis(10), a, b, sqr2, delta, Rd, PhiRad, Fdh, FdM
      real    :: bes, cos_pi_delta, arg, w, soglia, y
      logical :: preso
      character (len= 5) :: floatCh
      character (len=11) :: tirang
!
*     knw = 0
      mista = .false.
      sqr2 = sqrt(2.0)

      if (numbGen > 0) then
         ifFreeLunchMR = 1
      else
         ifFreeLunchMR = 0
      endif
!
      call Normalize(1, Fcvet_MR, Rderiv_1)
!
      fcvet(1:nrefl) = Fcvet_MR(1:nrefl)
      wt(1:nrefl) = Pesi_MR(1:nrefl)
      if (knw == 1) then
          write(lo,11) tabOrigin(ancella,1:3)
      endif
      if (knw == 1) then
          write(6,*) '<PhiTarget-Fasi_MR>'
          call examin(10, mkang, khl, Pub_target, Fasi_MR,nrefl,0,wt,1)
          ipher = 1
          tirang = 'Fasi iniz. '
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                     Pub_target, Fasi_MR, wt, 20, 0.0, ipher)
      endif
!
      nExt = 0
      do i=1, nrefl
         delta = 0.0
         do l=1,3
            delta = delta + float(khl(l,i)) * tabOrigin(ancella,l)
         enddo
         shi = nint(pi * delta * rtod)
         shi = mod(shi+3600, 360)
!-- fasi derivato vero
         PhiRad = Pub_target(i) * dtor
         PhiRad = PhiRad + pi * delta
         Phi = nint(PhiRad * rtod) + 3600
         Phi = mod(Phi, 360)
         Phi = Phi 
   20 format(3i4, 4f8.4,3i6)
         Pderiv_v(i) = Phi
!-- fasi derivato modello
         PhiRad = Fasi_MR(i) * dtor
         PhiRad = PhiRad + pi * delta
         Phi = nint(PhiRad * rtod) + 3600
         Phi = mod(Phi, 360)
         iphaz(i) = Phi 
!-- modulo derivato vero
         cos_pi_delta = abs( cos(pi*delta) )
         Rd = sqr2 * Rtarget(i) * cos_pi_delta
         Fdh = 2.0 * Ftarget(i) * cos_pi_delta
         fovet(i) = Fdh
!-- modulo derivato modello
         Rd = sqr2 * Rderiv_1(i) * cos_pi_delta
         Rderiv_1(i) = Rd
         FdM = 2.0 * Fcvet_MR(i) * cos_pi_delta
!-- riflessi estinti
         Estinti(i) = 0
         if (cos_pi_delta < 0.001) then
             fovet(i) = 0
             fovet(i) = Ftarget(i)  ! NEW
             Estinti(i) = 1
             nExt = nExt + 1
         endif
   19 continue
      enddo
      wt(1:nrefl) = Pesi_MR(1:nrefl)
      ipub(1:nrefl) = Pderiv_v(1:nrefl)
      tmpwt(1:nrefl) = wt(1:nrefl)
      if (knw == 1) then
          write(6,*) '<PhidVero(5)-PhiTarget>'
          call examin(11, mkang, khl,Pderiv_v,Pub_target, nrefl,0,wt,1)
          write(6,*) '<PhidVero(5)-Phid(6)>'
          call examin(12, mkang, khl,Pderiv_v,iphaz, nrefl,0,wt,1)
      endif

      if (nExt > 0) then
          jwork1(1:nrefl) = mkang(1:nrefl)
          mkang(1:nrefl) = 1
      endif
      if (knw == 1) then
          write(6,*) 'Fasi modificate per il derivato:'
          call examin(11, mkang, khl, Pub_target, iphaz,nrefl,0,wt,1)
      endif
      AddRis = .false.
      if (LowRes == 0) then
          call Cicla_PHA
      else
          call Cicla_LOW(1)
          ifPhantom = 1
      endif

      if (knw == 1) then
          write(6,10) erore, erorepes, isumal
      endif
!
      if (nExt > 0) then
          mkang(1:nrefl) = jwork1(1:nrefl)
      endif
      call Indietro(nExt, 1)
!
      if (knw == 1) then
          write(6,*) 'Prima del primo riciclo'
          call examin(11, mkang, khl, Pub_target, iphaz, nrefl,0,wt,1)
      endif
      fovet(1:nrefl) = Ftarget(1:nrefl)
      fcvet(1:nrefl) = Fcvet_MR(1:nrefl)
      ipub(1:nrefl) = Pub_target(1:nrefl)
      if (LowRes == 0) then
          call Cicla_PHA
      else
          if (BigCycles == 200) then
              jumpVLD = 1
          endif
          call Cicla_VLD(1,-5, 1, vettoreRis)   ! 2611 Procedura VLD
          jumpVLD = 0
      endif

      call Trasla_Origine_PHA(RifPh, iphaz, wt)
!
      if (knw == 1) then
          call examin(1, mkang, khl, Pderiv_v, iphaz, nrefl,0,wt,1)
          ipher = 1
          tirang = 'Fasi Mappa '
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                     Pderiv_v, iphaz, wt, 20, 0.0, ipher)
          call examin(1, mkang, khl, Pub_target, iphaz, nrefl,0,wt,1)
          ipher = 1
          tirang = 'Fasi MappaV'
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                     Pub_target, iphaz, wt, 20, 0.0, ipher)
      endif
!
      y = 1.0
      worko(1:nrefl) = fcvet(1:nrefl)
      call Normalize(1, worko, fcvet)
!
      do i=1, nrefl
         delta = 0.0
         do l=1,3
            delta = delta + float(khl(l,i)) * tabOrigin(ancella,l)
         enddo
*
         arg = pi * delta
         tmpwt(i) = 2.0 * Rtarget(i) * ( 2.0*abs(cos(arg))-1)
         tmpwt(i) = abs(tmpwt(i))
      enddo
      if (knw == 1) then
          ipher = 1
          tirang = 'LAST WT    '
          call pherrdisNew(tirang, tmpwt, khl, mkang, nrefl, 0,
     *                     Pub_target, iphaz, wt, 20, 0.0, ipher)
      endif
!
!-- NSELECT*NORIG= y* NRIFL
!
      y = 1.5
      nToUse = y * float(nrefl) / ancellaMax 
      do i=1, nrefl
         jwork1(i) = i
         work1(i) = tmpwt(i)
      enddo
      call sort3_big(work1, jwork1, worko, nrefl)
      if (AssiFixed) then
          y = 0.6
      elseif (ancellaMax == 1) then
          y = 0.6
      elseif (ancellaMax == 2) then
          y = 0.5
      elseif (ancellaMax == 3) then
          y = 0.4
      elseif (ancellaMax >= 4) then
          y = 0.3
      endif
      y = y + 0.4
      nToUse = y * float(nrefl)
      soglia = worko(nToUse)
      if (knw == 1) write(6,*) 'NSELECT, perc', nToUse, y

      wto(1:nrefl) = wt(1:nrefl)
      if (BigCycles >= 2) then ! nuova procedura

          do i=1, nrefl
             if (tmpwt(i) < soglia) then
                 wt(i) = 0 ! .3 * wt(i)
             endif
          enddo
      endif
      j = 0

!

!
! X TANGENTE/SUM0
!
      do i=1, nrefl
         if (wt(i) > 0.0) then
             arg = float(iphaz(i)) * dtor
             w = wt(i)
             ancora(i) = ancora(i) + 1
         endif
      enddo
!
      if (knw == 1) then
          if (AssiFixed) then
              floatCh = '     '
          else
              floatCh = 'float'
          endif
          call examin(1, mkang, khl, Pub_target, iphaz, nrefl,0,wt,1)
          write(6,55) nDer, erore, isumal, y, nrefl, floatCh ! j
          ipher = 1
          tirang = 'X Sum0     '
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                     Pub_target, iphaz, wt, 20, 0.0, ipher)
      endif

      mista = .true.
      if (mista) then
          fcoef(1:nrefl) = Rtarget(1:nrefl)  * wt(1:nrefl)
      else
          fcoef(1:nrefl) = Rderiv_1(1:nrefl) * wt(1:nrefl)
      endif
!
      jpatt = 0
      FORTH = 0
      BACK = 0
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH,BACK)
!
      MappaSomma(:,:,:) = MappaSomma(:,:,:) + xmap(:,:,:)
!
      fovet(1:nrefl) = Ftarget(1:nrefl)
      fcvet(1:nrefl) = Fcvet_MR(1:nrefl)
!
*     call cstop('fine test')
      return
   10 format(/,' Free Lunch ends - Mean Phase Error',f6.2,' (',f6.2,
     *       ')  over ',i7,' reflections',/)
   11 format(/,'Translation applied: ',3f10.3)
   55 format('STATS',i3,f8.2,i8,'  perc:',f5.1,'  su ',i8,2x,a5)
      end
!-----------------------------------------------------------------------
      subroutine Indietro(nExt, step)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE PhMod
!
      implicit none
      integer :: i, l, Phi, nExt, step, nq
      real    :: delta, PhiRad, errExt
!
      do i=1, nrefl
         delta = 0.0
         do l=1, 3
            delta = delta + float(khl(l,i)) * tabOrigin(ancella,l)
         enddo
!-- fasi target (??)
         PhiRad = iphaz(i) * dtor
         PhiRad = PhiRad - pi * delta
         Phi = nint(PhiRad * rtod) + 3600
         Phi = mod(Phi, 360)
         iphaz(i) = Phi
      enddo
      if (nExt > 0 .and. knw == 1) then
          tmpwt(1:nrefl) = wt(1:nrefl) * Estinti(1:nrefl)
          if (step == 1) then
          call examin(8880,mkang,khl,Pub_target,Fasi_MR,nrefl,0,tmpwt,1)
          endif
          errExt = erore
          call examin(8881,mkang,khl,Pub_target,iphaz,  nrefl,0,tmpwt,1)
          write(6,10) errExt, erore, isumal, nrefl
      endif

      return
   10 format( 'ESTINTI MPE(MR)',f7.2,'  MPE(Ext)',f7.2,2i7)
      end
!-----------------------------------------------------------------------
      subroutine Cicla_PHA
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE MapTest
      USE Param
      USE PhMod
      USE TestStuff, only : ifFloatOrigin
!
      implicit none
      integer :: jpatt
!
      fcoef(1:nrefl) = Rtarget(1:nrefl)
      jpatt = 0
      call MakeMap(fcoef, Pderiv_v, nrefl, jpatt, xmap, FORTH, BACK)
      xmapDif(:,:,:) = xmap(:,:,:)
!
      invflag = 1
      percMap = 0.025
      percMap = 0.05
      percMap = 0.08
      percMap_n = 0.010
      nMicro_PHA2 = 1
      do indiceMicro = 1, nMicro_PHA2
!
         if (mista) then
             fcoef(1:nrefl) = Rtarget(1:nrefl) * wt(1:nrefl)
         else
             fcoef(1:nrefl) = Rderiv_0(1:nrefl) * wt(1:nrefl)
         endif
!
         jpatt = 0
         call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH, BACK)
!
         xmapApp = xmap
      enddo
!
      xmap(:,:,:) = xmapApp(:,:,:)
      if (knw == 1) then
          call examin(333, mkang, khl, Pub_target, iphaz, nrefl, 0,wt,1)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Cicla_LOW(backToMR)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE MapTest
      USE Param
      USE PhMod
!
      implicit none
      integer :: i, ipher, jpatt, backToMR, npSav(3)
      integer :: nfree, numBox
      character (len=11) :: tirang
!
      if (knw == 1) then
          call examin(3,mkang, khl, Pub_target, iphaz, nrefl, 0, wt, 0)
          write(6,10) erore, erorepes, isumal
      endif
      numbGenSav = numbGen
      npSav(1:3) = np(1:3)
      if (ifMixEdm == 0) then
          nfree = 0 ; numBox = 0
          wtd(1:nrefl) = wt(1:nrefl)
          iphad(1:nrefl) = iphaz(1:nrefl)
          call AllocaMapTest(2)
          numbGen = 0

          call PreCicla_LOW(npSav)

          call EDMdritan(nfree, numBox)

          call PostCicla_LOW(npSav)
!
          if (knw == 1) then
              call examin(3,mkang, khl, Pub_target, iphaz, nrefl,
     *                    0, wt, 1)
              tirang = 'WT STEP 2B '
              ipher = 1
              call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                         Pub_target, iphaz, wt, 20, 0.0, ipher)
          endif
          fcoef(1:nrefl) = Rtarget(1:nrefl) * Pesi_MR(1:nrefl)
          jpatt = 0
          call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH, BACK)
!
      else
          call MixEdm(0)
      endif
!
      numbGen = numbGenSav
*MIX* call cstop('fine test')
!
      return
   10 format(/,'Starting Cicla_LOW - MPE = ',f6.2,' (',f6.2,') using ',
     *       i6,' reflections',/)
      end
!-----------------------------------------------------------------------
      subroutine MixEdm(ModificaPesi)
      USE General
      USE Riflessi
      USE PhMod
      USE Mappa
!
!-- sostituisce la chiamata a EDMdritan 
!
      implicit none
      integer :: stampaInfo, ifAsuCCP4, ier, ModificaPesi, i, kstp
      integer :: temp_np(3)
      real    :: corre, corr
!
      go to 1

      temp_np(1:3) = np(1:3)
      np(1:3) = npMix(1:3)
      kstp = 0
      call Calcola_CC_Mappa(nrefl,corre,kstp,2)
      corr = corre
      np(1:3) = temp_np(1:3)

    1 continue
!
      stampaInfo = 0
      ifAsuCCP4 = 1
      ier = 0
      cardDiret = nome(1:lnome) // '_CadInp.mtz'
      call WriteMTZ_Express(stampaInfo, ifAsuCCP4, cardDiret, ier)
      if (ifMixEdm == 1) then
          call dm_density_modification
      elseif (ifMixEdm == 2) then
          call phenix_density_modification
      else
          call cstop('Error in MixEd')
      endif
      if (ModificaPesi == 99) then
          do i=1, nrefl
             wt(i) = sqrt(wt(i))
          enddo
      endif

      return


      temp_np(1:3) = np(1:3)
      np(1:3) = npMix(1:3)
      kstp = 0
      call Calcola_CC_Mappa(nrefl,corre,kstp,2)
      np(1:3) = temp_np(1:3)
      write(6,10) corr, corre
!
      return
   10 format('Map correlation before and after RESOLVE ',2f8.3)
      end
!-------------------------------------------------------------------------
      subroutine ManageFL
      USE General
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE Param
      USE PhMod
      USE CowMod
!
      implicit none
      integer :: ipher, jpatt
      real    :: f000Sav
      character (len=11) :: tirang
!
      nreflDim = ntotSav
      nreflTot = nreflDim
      numbGen = numbGenSav
      call AllocaHistoStuff(1)
!
!-- Free Lunch
!
      if (knw == 1) then
          call examin(111,mkang,khl,ipub,iphaz,nrefl,0,wt,1)
          tirang = 'FL START   '
          ipher = 1
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                     Pub_target, iphaz, wt, 20, 0.0, ipher)
      endif
      f000    = 0
      f000Sav = f000
      call ResettaPesi(1)
      LoadedWt = 0
      ifDEDM = 1
      iphazo(:) = iphaz(:)
      worko(:) = fcvet(:)
      wto(:) = wt(:)
      ifExpanded = 1
      call FreeLunchCow(VettRisultati, f000Sav)
      if (knw == 1) then
          call examin(111,mkang,khl,ipub,iphaz,nrefl,0,wt,1)
          tirang = 'FASI FL-VLD'
          ipher = 1
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                     Pub_target, iphaz, wt, 20, 0.0, ipher)
          write (lo,217) erore, erorepes, isumal
      endif
!
      Fasi_MR(1:nrefl) = iphaz(1:nrefl)
      Pesi_MR(1:nrefl) = wt(1:nrefl)
      fcoef(1:nrefl) = fovet(1:nrefl) * Pesi_MR(1:nrefl)
      jpatt = 0
      call MakeMap(fcoef, Fasi_MR, nrefl, jpatt, xmap,
     *             FORTH, BACK)
      percMap = 0.5
      invflag = 1
      call InvMap(khl,mkang,jwork1,fcvet,nrefl)
      wt(1:nrefl) = Pesi_MR(1:nrefl)
      Fcvet_MR(1:nrefl) = fcvet(1:nrefl)
      return
  217 format(10x,'FREELUNCH ENDS   - Mean Phase Error ',f6.2,
     *       '  (',f6.2,')  over',i8,' reflections')
      end
!-------------------------------------------------------------------------

      subroutine Cicla_VLD(Cicli, fermati, statistiche, vettoreRis)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE MapTest
      USE Param
      USE PhMod
      USE Tutto, only : wt11
      USE RemoModule, only : ifFreeLunchMR
!
      implicit none
      integer :: jpatt, ier, numbLSQSav, npSav(3), j, Cicli, LowResSav
      integer :: fermati, statistiche
      real    :: vettoreRis(10)
      character (len=11) :: tirang
!
      npSav(1:3) = np(1:3)
!
      do j=1, Cicli

         ifRemo = 1
         if (allocated(wtd)) then
             call AllocaRiflessiCow(2)
         endif
         if (LowRes == 1) then
             if (allocated(wt11)) then
                 deallocate(wt11, stat = ier)
             endif
         endif
         if (allocated(xmodel)) then
             call AllocaMapTest(2)
         endif
         Usin(1:nrefl) = sigmav(1:nrefl)
!!!      ifPhantom = -4
         if (fermati /= 0) then
             ifPhantom = fermati
         endif
         numbLSQSav = numbLSQ

*        LowResSav = LowRes
*        LowRes = 1
*        ifFreeLunchMR = 1
         call DoRemoDsr(vettoreRis)
         ifPhantom = 1
*        LowRes = LowResSav

         numbLSQ = numbLSQSav
         sigmav(1:nrefl) = Usin(1:nrefl)
         if (allocated(xmodel)) then
             call AllocaMapTest(2)
         endif
         if (.not.allocated(wtd)) then
             call AllocaRiflessiCow(1)
         endif
         if (LowRes == 1) then
             if (.not.allocated(wt11)) then
                 allocate(wt11(nreflDim), stat=ier)
             endif
         endif

      enddo
!
      evet(1:nrefl) = Rtarget(1:nrefl)
!
      ifRemo = 0
      call AllocaMappa(2)
      np(1:3) = npSav(1:3)
      call AllocaMappa(1)
      call AllocaMapTest(1)

      if (knw == 1) then
          call examin(7654,mkang,khl,Pub_target,iphaz,nrefl,0,wt     ,1)
          call examin(7655,mkang,khl,Pub_target,iphaz,nrefl,0,Pesi_MR,1)
      endif
!

      fcoef(1:nrefl) = Rtarget(1:nrefl) * Pesi_MR(1:nrefl)
*     fcoef(1:nrefl) = Rtarget(1:nrefl) * wt(1:nrefl)
      jpatt = 0
      FORTH = 0
      BACK = 0
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH,BACK)
*     jumpVLD = 0
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PreCicla_LOW(npSav)
      USE General
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE Param
      USE PhMod
!
      implicit none
      integer :: i, ix, iy, iAction, volta, ier, npSav(3)
      real    :: yfl, flag, den
!
      Usin(1:nrefl) = sigmav(1:nrefl)
!
      ifRemo = 1
      ifDsrVLD = 0
      volta = 1
      call InitGiw()
      call InitEnvCow(volta)
      ifRFree = nint(sum(rfree1))
      if (ifRFree == 0) then
          iy = 67543
          ix = iy
          do i=1, nrefl
             call randu1(ix,iy,yfl)
             flag = real(int(yfl*20.0)+1)
             ix = iy
             rfree1(i) = nint(flag) - 1
          enddo
      endif
!
      v_m  = 0.0
      f000 = 0.0
      den = 0.0                     !mr 040606
      do i=1, nk
         if (no(i) > 16) cycle
         f000 = f000 + float( nw(i) * no(i) )
         if (no(i) > 1) then
             den = den + float( nw(i) * nw(i) * no(i) )
             v_m = v_m + 14.0 * float( nw(i) )
         endif
      enddo
*---- Matthews' number
      v_m = volume / v_m
*---- Percent of Protein
*-----  protein density=1.23 (from CCP4 1.34)
      v_p = 1.34 / v_m
      f000 = volume*(0.32*(1.0-v_p)+0.43*v_p)
!
      ihism = 0
      if (ifHeavyAtom) then
          ihism = 0    ! TEST ABI 13 febbraio 2017
      else
          ihism = 1
      endif
      ifreem = 0
      call CalcScale
      if (volta == 1) then
          sigmav(1:nrefl)=sqrt(ScaleDM)*sigmav(1:nrefl)
      endif
      if (ihism.gt.0) f000=volume*(0.32*(1.0-v_p)+0.43*v_p)
!
      if (ModificaNp) then
          iAction = 0
          call AllocaMappa(iAction)
          iAction = 1
          call AllocaMappa(iAction)
          allocate (xmapApp(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat=ier)
      else
          iAction = 2
          call AllocaMapTest(iAction)
          np(1:3) = npSav(1:3)
          iAction = 1
          call AllocaMapTest(iAction)
      endif
      exposigma = 1
      ifVLD = 0
      if (volta == 1) then
          iphad(:)   = iphaz(:)
          wtd(:)     = wt(:)
          iphi2_o(:) = iphaz(:)
          wtt_o(:)   = wt(:)
      endif
!
*     ihism = 1
*     ifDEDM = 1
*     ifDsrVLD = 1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PostCicla_LOW(npSav)
      USE General
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE Param
      USE PhMod
!
      implicit none
      integer :: iAction, npSav(3)
!
      sigmav(1:nrefl) = Usin(1:nrefl)
!
      ifRemo = 0
      ifDsrVLD = 0
      if (ModificaNp) then
          iAction = 0
          call AllocaMappa(iAction)
          rhomax = maxval(rhov(1:nrefl))
          call CheckGrid()
          np(1:3) = npSav(1:3)
          iAction = 1
          call AllocaMappa(iAction)
          iAction = 2
          call AllocaMapTest(iAction)
          iAction = 1
          call AllocaMapTest(iAction)
      endif
      f000 = 0
      cicloMut = cicloMut + 1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LastTangent
      USE General
      USE Symmetry
      USE Riflessi
      USE PhMod
      USE TestStuff
      USE PhaseModule
!
      implicit none
      integer :: i, j, ipher, nwizm1, nden, nsip1, jj
      real    :: Q, R, arg1, arg2, bes, besinv, bes1, bes2, bes3
      logical :: preso
      character (len=11) :: tirang
!
      if (knw == 1) then
         call examin(1, mkang, khl,  Pub_target, iphaz,nrefl,0,wt,1)
         tirang = 'FASI FL    '
         ipher = 1
         call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                    Pub_target, iphaz, wt, 20, 0.0, ipher)
         call examin(1,mkang,khl,Pub_target,Fasi_Sav,nrefl,0,Pesi_Sav,1)
         call examin(2, mkang, khl, Pub_target, iphaz, nrefl,0,wt,1)
         write(tirang,'(a9,i2)') 'WT HM 0  '
         ipher = 1
         call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                    Pub_target, iphaz, wt, 20, 0.0, ipher)
      endif
!
!-- HM
!
      nwizm1 = 25  ! proteins  -  da provare con routine generalizzata
      nden   =  nstr / 10
      nsip1  = nrefl / nden
      nsip1  = min(nsip1,498)
      call HistogramMatch(wt,Pesi_Sav,nrefl,nsip1,nwizm1,1)
      if (knw == 1) then
          call examin(1, mkang, khl, Pub_target,Fasi_Sav,nrefl,0,
     *                Pesi_Sav,1)
          call examin(2, mkang, khl, Pub_target, iphaz, nrefl,0,wt,1)
          write(tirang,'(a9,i2)') 'WT HM 1  '
          ipher = 1
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                     Pub_target, iphaz, wt, 20, 0.0, ipher)
      endif
!
      Wtota(:) = 0
      Ptota(:) = 0
      tmpwt(:) = 0
      j = 0
      jj = 0
      do i=1, nrefl
         preso = .false.
         if (Pesi_Sav(i) > 0.0 .and. wt(i) > 0.0) then
             preso = .true.
             arg1 = float(Fasi_Sav(i)) * dtor
             arg2 = float(iphaz(i)) * dtor
             bes1 = Pesi_Sav(i) ! * 0.6
             bes2 = wt(i)       ! * 1.4
             Q = bes1 * sin(arg1) + bes2 * sin(arg2)
             R = bes1 * cos(arg1) + bes2 * cos(arg2)
         endif
         if (mkang(i) /= 1 .and. Fasi_Sav(i) /= iphaz(i)) then
             jj = jj + 1
             preso = .false.
         endif
         if (preso) then
             Ptota(i) = nint(3600 + atan2(Q, R) * rtod)
             Ptota(i) = mod(Ptota(i), 360)
             arg1 = sqrt(Q*Q + R*R)
             Wtota(i) = bes(arg1)
             if (Wtota(i) > 0) then
                 if (mkang(i) /= 1 .and. Fasi_Sav(i) == iphaz(i)) then
                     tmpwt(i) = 1
                 endif
             endif
         endif
      enddo
!
      if (knw == 1) write(6,*) 'JJ',jj
      iphaz(1:nrefl) = Ptota(1:nrefl)
      wt(1:nrefl) = Wtota(1:nrefl)
      if (knw == 1) then
          call examin(33, mkang, khl, Pub_target, iphaz,nrefl,0,tmpwt,1)
          call examin(3, mkang, khl, Pub_target, iphaz, nrefl,0,wt,1)
          write(tirang,'(a9,i2)') 'LAST TANG'
          ipher = 1
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                     Pub_target, iphaz, wt, 20, 0.0, ipher)
      endif
!
      AddRis = .true.
      call FillVett_PHA(erore)
      AddRis = .false.
!
      Pfinal(1:nrefl) = iphaz(1:nrefl)
      Wfinal(1:nrefl) = wt(1:nrefl)

      do i=1, nrefl
         if (wt(i) > 0.0) then
             arg1 = float(iphaz(i)) * dtor
*            TSinCos(1,i) = TSinCos(1,i) + sin(arg1)
*            TSinCos(2,i) = TSinCos(2,i) + cos(arg1)
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PrintStepInfo()
      USE General
      USE Molcom
      USE PhMod
!
      implicit none
!
      if (knw == 1) then
          write(lo,10) ancella, BigCycles, nDer
*     else
*        if (ancella == 1) then
*            write(lo,20) 
*        endif
*            write(lo,30) BigCycles, ancella, tabOrigin(ancella,1:3)
      endif
      if (jscreen > 0) then
          write(Inte,40) BigCycles, nBigCycles, ancella, ancellaMax
          call OneBlankOnly(Inte)
          Msg = '        ' // Inte
          call SameLine(Msg, -1, 3)
          write(Inte,'(a,i3,a,i2)') 'Processing ancil #', ancella, 
     *                              ' in cycle #',BigCycles
          call scrper(Inte,0,-1)
          call zflush
          call DoSingleIteration()
      endif
!
      return
   10 format('XXXX  ANCIL ', i3,' CYCLE ',i3,
     *       ' XXXX Derivative ',i3,/,45('*'))
   20 format(/,78('+'),//,
     *         '   Cycle Ancil  Translation applied',/)
   30 format(2i6,3f8.3)
   40 format('Cycle',i2,'/',i2,5x,' Ancil',i3,'/',i3)
      end
!-----------------------------------------------------------------------
      subroutine Phantom0(ier, fromPhasing)
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE Molcom
      USE Grafici
      USE PhMod
      USE PhaseModule
      USE Param
      USE Tutto, only : wt11
      USE RemoModule, only: resol1, numbModels
      USE TestStuff, only: ifFloatOrigin
      USE CowMod
!
      implicit none
      integer :: ier, i, j, k, ksubr, ifBreak, jpatt, kkk, Lung,ipher
      integer :: Phi, npunt, icod, npunti, ifResetLab, kridisegna
      integer :: fromPhasing
      real    :: anatSav, scf, eroreSav, correl
      real    :: vettoreRis(10)
      real    :: arg1, arg2, Q, T
      character (len=256) :: MTZfileSav
      character (len=11) :: tirang
      real    :: deltaPhiCow
*     real    :: denmin, denmax, avden, stden
      common /deltaPhiCowtan/ deltaPhiCow
!
      ifFloatOrigin = sum( vpol(1:3) )
!
      deltaPhiCow = 0
      numbModels = 2
      ier = 0
!nVR  VettRisultati(1) = ResEff
!nVR  VettRisultati(1) = resol1
*
      ksubr = 3
      call LeggiRiflessi(ier,ksubr)
!
      ifExamin = 1
!
      v_m = volume / v_m
      v_p = 1.34 / v_m
      f000 = volume*(0.32*(1.0-v_p)+0.43*v_p)
      f000 = 0
!
      if (ResEff < ResSogLow) then
          LowRes = 0
      else
          LowRes = 1
      endif
!
      if (jscreen > 0) then
          call sirdate(Inte,icod)
          headersGR(1) = Inte(1:icod)  //
     *                 '      Phantom Derivative procedure' //
     *                 ' starts on: '//nome(1:lnome)
          WhichFom = 2
          ifTang = 0
          call AllocaGrafici(2, 0, ifTang)
          jBlocksPh(1,1) = 10
          npunti = sum(jBlocksPh(1,:))
          call WhiteBoard
          if (jscreen > 0) then
              kLarg = kscrx
              kAlt  = kscry
              stepGR = 1.5 * FntPixHeight / float(kAlt)
              stepGR0 = 1.0
          endif
          ifResetLab = 0
          call AllocaGrafici(1, npunti, ifTang)
          HistoOK(:) = 0
          k = kridisegna(kscrx, kscry, ifResetLab)
          Msg = "<big><b>Phantom Derivative procedure</b></big>"
          call TestoGR(Msg, color_RED, 2, 3)
          call zflush
          call DoSingleIteration()
      endif

!
      call AllocaAtomi(2)
      anatSav = anat
      anat = anat * 2.0
      call AllocaAtomi(1)
      anat = anatSav
!
      do i=1, nrefl
         vettoreSigma(i) = i
      enddo
!
      kkk = 0
!
      sogResEff=1.59
      ifPatt = 1
      call CheckGrid()
      call InitSigmaA(1)
      ksubr = 1
      call LeggiRiflessi(ier,ksubr)
      scf = sqrt(sc)
      fovet(1:nrefl) = scf * fovet(1:nrefl)
      sigmav(1:nrefl) = scf * sigmav(1:nrefl)
      numbLSQ = nrefl
      call AllocaMappa(1)
      allocate(wt11(nreflDim), stat=ier)
      if (knw == 1) then
          call AllocaTestStuff(1)
          ifBreak = 0
          ier = 0
          call MakeMapsForCorr(ifBreak, ier)
      endif
*     call Calcola_FOM_Lib(1)
!
!-- Calcolo mappa vera per coeff. correlazione
!
      if (knw == 1) then
          npMix(1:3) = np(1:3)
          iphaz(1:numbLSQ)  = ipub(1:numbLSQ)
          wt(1:numbLSQ)     = 1.0
          fcoef(1:numbLSQ)  = fovet(1:numbLSQ) * wt(1:numbLSQ)
          jpatt = 0
          call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap,
     *                 FORTH, BACK)
          call Scrivi_Mappa_Vera(2)
      endif
!
*     knw = 0

      call InitFinalFom()
*     iesfom = 0
!
!
      if (fromPhasing == 0) then
          call dirPhantom(ier)
      endif
!
      nDer = ancellaMax * nBigCycles
      call AllocaPhantom(1)
      Ptota = -1
      Wtota = 0
      Rtarget(1:nrefl) = evet(1:nrefl)
      Pub_target(1:nrefl) = ipub(1:nrefl)
!
      write(lo,100) MTZfile(1:Lung(MTZfile))
      call GetMTZ_PHA(1, ier)
      k = count(wt(1:nrefl) > 0.0)
      if (ifMadData == 0) then
          write(Inte,120) k, nrefl
      else
          write(Inte,130) k, nrefl
      endif
      call OneBlankOnly(Inte)
      write(lo,'(a,/)') Inte(1:Lung(Inte))
      if (jscreen > 0) then
          call TestoGR(Inte, -1, 2, 3)
          call zflush
          call DoSingleIteration()
      endif
!
!-- dedi
!
*     call Trasla_Origine(nrefl)
*     cardDiret = nome(1:lnome) // 'traslato.mtz'
*     call WriteMTZ_Express(1, 0, cardDiret, ier)
*     STOP
!
      if (ier /= 0) then
          return
      endif
      if (knw == 1) write(6,110) erore
      AddRis = .true.
      call FillVett_PHA(erore)
      if (ier /= 0) then
          return
      endif

      MTZfile = MTZfileSav
      iphaz(1:nrefl)  = Pfinal(1:nrefl)
      wt(1:nrefl)     = Wfinal(1:nrefl)
      fcvet(1:nrefl)  = usin(1:nrefl)
!
      if (.not.allocated(xmapApp)) then
          allocate (xmapApp(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat=ier)
      endif
      allocate (MappaSomma(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat=ier)
      MappaSomma(:,:,:) = 0.0
      call AllocaRiflessiCow(1)
      
      eroreSav = erore

!
!-- EDM Cowtan sulle fasi MR
!

      Ptota(1:nrefl) = iphaz(1:nrefl)
      Wtota(1:nrefl) = wt(1:nrefl)


      ModificaNp = .true.
      cicloMut = 1
      call Cicla_LOW(0)
      AddRis = .true.
      call FillVett_PHA(erore)
!
      if (ier == 0 .and. knw == 1) then
          call Calcola_CC_Mappa(nrefl,correl,1,2)
          cardDiret = nome(1:lnome) // '_DMout.mtz'
          jwork1(1:nrefl) = iphaz(1:nrefl)
          call Trasla_Origine(nrefl)
          call WriteMTZ_Express(1, 0, cardDiret, ier)
          fcoef(1:nrefl) = fovet(1:nrefl) * wt(1:nrefl)
          jpatt = 0 
          f000 = 0
          call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                 FORTH, BACK)
          call maxmin3d(denmin,denmax,avden,stden,npunt,0)
          write(6,*) 'Mappa 1 ',denmin,denmax,avden,stden 
          call Write_CCP4_Map(xmap, 1)
          iphaz(1:nrefl) = jwork1(1:nrefl)
      endif
!
      if (knw == 1) then
          call examin(333, mkang, khl,  Pub_target, iphaz, nrefl,
     *                0, wt, 1)
          call examin(336, mkang, khl,  Pub_target, Fasi_MR,
     *                    nrefl, 0, Pesi_MR, 1)
          tmpwt(1:nrefl) = wt(1:nrefl)
          do i=1, nrefl
             if (Pesi_MR(i) > 0.0) then
                 tmpwt(i) = 0.0
             endif
          enddo
          call examin(337, mkang, khl,  Pub_target, iphaz, nrefl,
     *                0, tmpwt, 1)
          tirang = 'FASI NEW   '
          ipher = 1
          call pherrdisNew(tirang, tmpwt, khl, mkang, nrefl, 0,
     *                 Pub_target, iphaz, tmpwt, 20, 0.0, ipher)
!
          do i=1, nrefl
             if (mkang(i) == 1) then
                 tmpwt(i) = 0
             endif
          enddo
          call examin(338, mkang, khl,  Pub_target, iphaz, nrefl,
     *                0, tmpwt, 1)
          tirang = 'FASI NEW CS'
          ipher = 1
          call pherrdisNew(tirang, tmpwt, khl, mkang, nrefl, 0,
     *                     Pub_target, iphaz, tmpwt, 20, 0.0, ipher)
      endif
!

      if (LowRes == 1 .and. ifMadData == 1) then
          ntotSav = nreflDim
          numbGenSav = numbGen
          allocate (distrPesi(nrefl), stat = ier)
          call Calcola_v_p
          if (deltaPhiCow < 60) then
              call UpdateMAD()
              iphaz(1:nrefl) = Fasi_MR(1:nrefl)
              wt(1:nrefl) = Pesi_MR(1:nrefl)
          else
              iphaz(1:nrefl) = Ptota(1:nrefl)
              wt(1:nrefl) = Wtota(1:nrefl)
          endif
          call ManageFL
      endif
      MappaSomma(:,:,:) = 0.0

!
!-- VLD-FreeLunch sulle fasi MR
!
      iphaz(1:nrefl) = Fasi_MR(1:nrefl)
      wt(1:nrefl)    = Pesi_MR(1:nrefl)
      fcvet(1:nrefl) = Fcvet_MR(1:nrefl)
      if (FichierOut(1:1) == ' ') then
          AddRis = .false.
          call Cicla_VLD(1, 0, 0, vettoreRis)   !      Procedura VLD

          if (knw == 1) then
              call examin(334, mkang, khl,  Pub_target, iphaz,nrefl,
     *                    0, wt, 1)
          endif
!
      else
          erore = eroreSav
      endif
      AddRis = .true.
      call FillVett_PHA(erore)

      Fasi_MR(1:nrefl) = iphaz(1:nrefl)
      Pesi_MR(1:nrefl) = wt(1:nrefl)
      if (knw == 1) then
          call examin(335, mkang, khl,  Pub_target, Fasi_MR,nrefl,
     *                0, Pesi_MR, 1)
      endif

      Fasi_Sav(1:nrefl) = iphaz(1:nrefl)
      Pesi_Sav(1:nrefl) = wt(1:nrefl)

!
!-- per utilizzare le fasi da Cowtan/VLD-FreeLunch come fasi iniziali
!
      Fasi_MR(1:nrefl) = iphaz(1:nrefl)
      Pfinal(1:nrefl) = iphaz(1:nrefl)
      Wfinal(1:nrefl) = wt(1:nrefl)
!
      if (knw == 1) then
          call examin(336, mkang, khl,  Pub_target, Fasi_MR,nrefl,
     *                0, Pesi_MR, 1)
      endif
      RifPh(1:nrefl) = Fasi_MR(1:nrefl)
      RifWt(1:nrefl) = Pesi_MR(1:nrefl)
!
      return
  100 format(/,' Starting phases from ',a,' file',/)
  110 format('REMO ',f7.2)
  120 format(' Phased reflections ',i10,' over ',i10,
     *       ' from MTZ file')
  130 format(' SAD/MAD phased reflections ',i10,' over ',i10,
     *       ' from MTZ file')
      end
!-----------------------------------------------------------------------
      subroutine dirPhantom(ier)
      USE General
      USE PhMod
      USE Direttive
      USE PhaseModule
!
      implicit none
      integer :: ier, ic, icmax, ldiret, Lung, lenp, lend, ind, ind1
      integer :: iopt, iv, nExitCode, k, kk
      character (len=  8) :: a8
      character (len=256) :: fileh
!
      if (no(nk) > 60) then
          ifHeavyAtom = .true.
      else
          ifHeavyAtom = .false.
      endif
      jEnan = 0
      ifMadData = 0
      FichierOut = ' '
      ifMTZlab   = 0
      MTZfile = ' '
      ic = 0
      icmax = icomq(icomat,2)
c
      do while (ic.lt.icmax.and.ier.eq.0)
         ic = ic + 1
         ipdir=ipdir+1
         cardDiret=card(ipdir)
         cardImage=cardDiret
         ldiret = Lung(cardImage)
         call cutst(cardDiret,lenp,direttiva,lend)
         call lcase(direttiva)
         if (direttiva(1:4).eq.'fcal') then
             calcFC = .true.
         elseif (direttiva(1:4).eq.'heav') then
             ifHeavyAtom = .true.
         elseif (direttiva(1:4).eq.'dm  ') then
             ifMixEdm = 1
         elseif (direttiva(1:4).eq.'phen') then
             ifMixEdm = 2
         elseif (direttiva(1:3).eq.'jen') then
             jEnan = 1
         elseif (direttiva(1:4).eq.'mode') then
!
!-- check for blanks in the reflection file name
!
             call CheckBlanks(fileh, lend)
!
             if (lend > 0) then
                 FichierOut = fileh(1:lend)
                 kk = index(FichierOut, '$STRUCTURE')
                 if (kk > 0) then
                     Msg = FichierOut(1:kk-1)
     *                     // nome(1:lnome)
     *                     // FichierOut(kk+10:)
                     k = Lung(Msg)
                     FichierOut = Msg(1:k)
                 endif
             endif
         elseif (direttiva(1:3).eq.'mad') then
             ifMadData = 1
             calcFC = .true.
         elseif (direttiva(1:3).eq.'lab') then
             Lab_Ch(:) = ' '
             k = 0
             lenp = 1
             do while (lenp > 0)
                call cutst(cardDiret,lenp,direttiva,lend)
                k = k + 1
                Lab_Ch(k) = direttiva
             enddo
             if (k < 5) then
                 ier = -10
             else
                 ifMTZlab = 1
                 nMTZlab  = k
             endif
         elseif (direttiva(1:4).eq.'mtz ') then
!
!-- check for blanks in the reflection file name
!
             call CheckBlanks(fileh, lend)
!
             if (lend > 0) then
                 ReflFileName = fileh(1:lend)
                 kk = index(ReflFileName, '$STRUCTURE') 
                 if (kk > 0) then
                     Msg = ReflFileName(1:kk-1)
     *                     // nome(1:lnome) 
     *                     // ReflFileName(kk+10:)
                     k = Lung(Msg)
                     ReflFileName = Msg(1:k)
                 endif
                 fileh   = ReflFileName
                 MTZfile = ReflFileName
                 ifMTZ   = 1
                 ind = index(ReflFileName,char(47),.TRUE.)
                 ind1 = index(ReflFileName,char(92),.TRUE.)
                 ind = max(ind,ind1)
                 if ( (ind + ind1) > 0 ) then
                     ReflFilePath = ReflFileName(1:ind)
                 endif
             else
                 ier = -10
             endif
         else
             ier = -20
         endif
      enddo
!
      if (ier == -10) then
          write(Msg,6100) cardImage(1:ldiret)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
      if (ier == -20) then
          write(Msg,6200) cardImage(1:ldiret)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
!
      if (ifHeavyAtom ) then 
          write(a8,'(a)') Species(nk)
          call lcase(a8)
          call ucase(a8(1:1))
          write(Inte,100) a8
          call OneBlankOnly(Inte)
          write(lo,'(a)') Inte(1:Lung(Inte))
      endif
!
      return
  100 format(' Heavy atom ',a,' presence used actively')
 6100 format(' Error in directive : ',a)
 6200 format(' Wrong directive in PHANTOM modulus:   ',a)
      end
!-----------------------------------------------------------------------
      subroutine GetMTZ_PHA(ModificaWT, ier)
      USE General
      USE Riflessi
      USE Mappa
      USE PhMod
      USE PhaseModule
!
      implicit none
      integer :: ier, iAction, lix1, lix2, knwSav, ipher, uno, i, jpatt
      integer :: ModificaWT
      real    :: celltemp(13), argbes, bes, besinv

      character (len=11) :: tirang
!
      uno = 1
      ier  = 0
      lix1 = 1
      lix2 = 1
      if (ifMTZlab == 0) then
          Lab_Ch(1) = 'H'
          Lab_Ch(2) = 'K'
          Lab_Ch(3) = 'L'
          Lab_Ch(4) = 'F'
          Lab_Ch(5) = 'SIGF'
          Lab_Ch(6) = 'PHIC' ! fase
          Lab_Ch(7) = 'FOM'  ! peso
          Lab_Ch(8) = 'FC'   ! fc
*         Lab_Ch(7) = 'WT_EDM'  ! peso   ! da MAD
*         Lab_Ch(6) = 'PHI_EDM' ! fase   ! da MAD
*         Lab_Ch(8) = 'HLA_EDM'   ! fc   ! da MAD
          ifMTZlab = 1
      endif
      knwSav = knw
      do iAction =1, 2
         call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
         if (ier /= 0) then
             return
         endif
      enddo
      knw = 0
      call LeggiMTZPhase(ier)
      if (ier /= 0) then
          return
      endif
!
      iAction = 3
      call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
      if (ier /= 0) then
          return
      endif
!
      knw = knwSav
!
!-- modifica pesi MR
!
      if (ModificaWT == 1) then
          do i=1, nrefl
             argbes = wt(i)
             argbes = 1.5 * besinv(argbes) 
             wt(i) = bes(argbes)
             if (wt(i) < 0.0) wt(i) = 0.0
          enddo
      endif

      Pfinal(1:nrefl)  = iphaz(1:nrefl)
      Wfinal(1:nrefl)  = wt(1:nrefl)
      Fasi_MR(1:nrefl) = iphaz(1:nrefl)
      Pesi_MR(1:nrefl) = wt(1:nrefl)
      if (knw == 1) then
          call examin(333, mkang, khl,  Pub_target, Pfinal, nrefl,
     *                0, Wfinal, 1)
          tirang = 'FASI INIZ. '
          ipher = 1
          call pherrdisNew(tirang, Wfinal, khl, mkang, nrefl, 0,
     *                     Pub_target, Pfinal, Wfinal, 20, 0.0, ipher)
!
          AddRis = .true.
          call FillVett_PHA(erore)
      endif
!
      worko(1:nrefl) = fcvet(1:nrefl)
      if (calcFC) then
          calcFC = .false.
          fcoef(1:nrefl) = fovet(1:nrefl) * Pesi_MR(1:nrefl)
          jpatt = 0 
          call MakeMap(fcoef, Fasi_MR, nrefl, jpatt, xmap,
     *                 FORTH, BACK)
          percMap = 0.5
          invflag = 1
          call InvMap(khl,mkang,jwork1,fcvet,nrefl)
          wt(1:nrefl) = Pesi_MR(1:nrefl)
          Fcvet_MR(1:nrefl) = fcvet(1:nrefl)
      else
          fcvet(1:nrefl) = worko(1:nrefl)
          Fcvet_MR(1:nrefl) = fcvet(1:nrefl)
      endif
!nVR
      nVR = nVR -1
!nVR
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaPhantom(iAction)
      USE General
      USE PhMod
!
      implicit none
      integer :: ier(80), iAction, ierr
!
      ier(:) = 0
      if (iAction == 1) then
          allocate (Pderiv_v(nrefl), stat = ier( 4))
          allocate (Rderiv_1(nrefl), stat = ier( 8))
          allocate (Ptota(nrefl), stat = ier(10))
          allocate (Wtota(nrefl), stat = ier(11))
          allocate (Pub_target(nrefl), stat = ier(12))
          allocate (Rtarget(nrefl), stat = ier(13))
          allocate (ancora(nrefl), stat = ier(40))
          allocate (Pfinal(nrefl), stat = ier(41))
          allocate (Wfinal(nrefl), stat = ier(42))
          allocate (Usin(nrefl), stat = ier(50))
          allocate (Ucos(nrefl), stat = ier(51))
          allocate (Rderiv_0(nrefl), stat = ier(52))
          allocate (Pesi_MR(nrefl), stat = ier(53))
          allocate (Fasi_MR(nrefl), stat = ier(54))
          allocate (Fcvet_MR(nrefl), stat = ier(55))
          allocate (Pesi_Sav(nrefl), stat = ier(56))
          allocate (Fasi_Sav(nrefl), stat = ier(57))
*         allocate (TSinCos(2,nrefl), stat = ier(58))
          allocate (RifPh(nrefl), stat = ier(60))
          allocate (RifWt(nrefl), stat = ier(61))
          allocate (Ftarget(nrefl), stat = ier(67))
          allocate (Estinti(nrefl), stat = ier(68))
          ierr = sum(iabs( ier(:) ))
          if (ierr /= 0) then
              write(lo,*) 'AllocaPhantom Allocation error'
              call cstop(' ')
          endif
          Pfinal(:) = 0
          Wfinal(:) = 0
          Usin(:) = 0
          Ucos(:) = 0
          Pesi_Sav(:) = 0
          Fasi_Sav(:) = 0
*         TSinCos(:,:) = 0
          RifPh(:) = 0
          RifWt(:) = 0
      else
          deallocate (ancora,
     *                Pderiv_v,
     *                Rderiv_1,
     *                Ptota, Wtota,
     *                Pfinal, Wfinal,
     *                Pub_target, Rtarget, Pesi_Sav, Fasi_Sav,
     *                Usin, Ucos, ! TSinCos, 
     *                Rderiv_0, Pesi_MR, Fasi_MR, Fcvet_MR, 
     *                RifPh, RifWt, 
     *                Ftarget, 
     *                Estinti, stat = ierr)
          if (ierr /= 0) then
              write(lo,*) 'AllocaPhantom deAllocation error'
              call cstop(' ')
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Normalize(iAction, Faux, Raux)
      USE General
      USE Symmetry
      USE Riflessi
!
      implicit none
      integer :: iAction, i, j, k
      real    :: Faux(nreflDim), Raux(nreflDim), e, costante, somma
      real    :: rho, eps, sumfff, sig, spts, ScattFact, den
!
      if (iAction == 1) then
          spts = sqrt(pts)
          do j=1, nrefl
             i = vettoreSigma(j)
             if (i == 0) cycle
             rho = rhov(i)
             eps = epsv(i)
             sumfff = 0.0
             do k=1, nk
                ff(k) = ScattFact(k, rho)
                sumfff = sumfff + nw(k) * (ff(k)**2)
             enddo
             sig = sqrt( exp(-2.0*bt*rho) * sumfff )
             den = eps * sig
             Raux(i) = Faux(i) / (den * spts)
          enddo
      endif
!
      somma = 0
      do i=1, nrefl
         somma = somma + Raux(i) ** 2 
      enddo
      costante = float(nrefl) / somma
      do i=1, nrefl
         e = costante * Raux(i) **2 
         Raux(i) = sqrt(e)
         if (Raux(i) > 5) then
             Raux(i) = 5
         endif
      enddo
!!!!!
      return
      somma = 0
      do i=1, nrefl
         somma = somma + Raux(i) ** 2 
      enddo
      write(6,*) ' <E^2> = ', somma /float(nreflDim)
!
      return
      end
!------------------------------------------------------------------------------
      subroutine phenix_density_modification
      USE General
      USE Param, only : v_s
      USE Riflessi
!
      implicit none
      integer :: k, Lung, ier, lcard
      integer :: itype, iform, jop, jopen
      character (len=20) :: solv
!
      cardImage = nome(1:lnome) // '_' // 'phenix_edm.sh'
      lcard = Lung(cardImage)
      itype = 0
      iform = 1
      jop = jopen(jhost,cardImage(1:lcard),itype,iform,ier)
      cardDiret = 'phenix.density_modification '
      write(Inte,10) v_s
      call NoBlanks(Inte, k)
      Msg = nome(1:lnome) // '_pdir output_mtz=' // nome(1:lnome) 
     *   // '_phenix.mtz'

      cardDiret = 'phenix.density_modification '
     *         // MTZfile(1:Lung(MTZfile)) // ' '
**   *         // 'phib_labels=SKIP' // ' '
     *         // Inte(1:k) ! // ' mask_type=wang'
     *         // ' temp_dir=' // Msg(1:Lung(Msg))
     *         // ' hl_in_output_mtz=True'
     *         // ' > ' // nome(1:lnome) // '_' // 'phenix.log'
      write(jhost,'(a)') '#!/bin/sh'
      write(jhost,'(a)') cardDiret(1:Lung(cardDiret))
      close(jhost)
      lcard = Lung(cardImage)
      cardImage(lcard+1:lcard+1) = char(0)
      call MakeExec(cardImage)
      Buffer1 = cardImage
      call Lanciash(Buffer1)
      cardDiret = MTZfile
!
*     numbGenSav = numbGen
      numbGen    = 0
      MTZfile = nome(1:lnome) // '_phenix.mtz'
      ifMTZlab = 0
      worko(1:nrefl) = fcvet(1:nrefl)
      tmpwt(1:nrefl) = wt(1:nrefl)
      call GetMTZ_PHENIX(ier)
      fcvet(1:nrefl) = worko(1:nrefl)
      wt(1:nrefl) = tmpwt(1:nrefl)
      numbGen    = numbGenSav
      MTZfile = cardDiret
      ifMTZlab = 0
!
      return
   10 format('solvent_content=',f4.1)
      end
!-----------------------------------------------------------------------
      subroutine parrot_density_modification
      USE General
      USE Param, only : v_s
!
      implicit none
      integer :: Lung, lcard, itype, iform, jop, jopen, ier
!
      cardImage = nome(1:lnome) // '_' // 'parrot.sh'
      lcard = Lung(cardImage)
      itype = 0
      iform = 1
      jop = jopen(jhost,cardImage(1:lcard),itype,iform,ier)
      write(jhost,100)
      write(jhost,110) nome(1:lnome) // '.seq'
      write(jhost,120) MTZfile(1:Lung(MTZfile))
      write(jhost,130)
      write(jhost,140)
      write(jhost,150)
      write(jhost,160) nome(1:lnome) // '_parrot.mtz'
      write(jhost,170)
      write(jhost,180)
      write(jhost,190)
      write(jhost,200)
      write(jhost,210)
      write(jhost,220)
      write(jhost,230) nome(1:lnome) // '_parrot.log'
      close(jhost)
      lcard = Lung(cardImage)
      cardImage(lcard+1:lcard+1) = char(0)
      call MakeExec(cardImage)
      Buffer1 = cardImage
      call Lanciash(Buffer1)
      cardDiret = MTZfile
!
      numbGenSav = numbGen
      numbGen    = 0
      ifMTZlab = 0
      MTZfile = nome(1:lnome) // '_parrot.mtz'
      call GetMTZ_PARROT(ier)
      numbGen    = numbGenSav
      MTZfile = cardDiret
!
  100 format('cparrot \')
  110 format('-seqin-wrk ',a,' \')
  120 format('-mtzin-wrk ',a,' \')
  130 format('-colin-wrk-fo F,SIGF \')
  140 format('-colin-wrk-phifom PHIC,FOM \')
  150 format('-colin-wrk-free FreeR_flag \')
  160 format('-mtzout ',a,' \')
  170 format('-colout parrot \')
  180 format('-solvent-flatten \')
  190 format('-histogram-match \')
  200 format('-ncs-average \')
  210 format('-anisotropy-correction \')
  220 format('-resolution 1.0 \')
  230 format(' > ',a)

      return
      end
!-----------------------------------------------------------------------
      subroutine dm_density_modification
      USE General
      USE Param, only : v_s
!
      implicit none
      integer :: Lung, lcard, itype, iform, jop, jopen, ier
!
      Inte = nome(1:lnome) // '_' // 'dm.inp'
      lcard = Lung(Inte)
      itype = 0
      iform = 1
      jop = jopen(jhost,Inte(1:lcard),itype,iform,ier)
      write(jhost,200) v_s
      write(jhost,210)
      write(jhost,220)
      write(jhost,230)
      write(jhost,240)
      write(jhost,250)
      close(jhost)
      cardImage = nome(1:lnome) // '_' // 'dm.sh'
      lcard = Lung(cardImage)
      itype = 0
      iform = 1
      jop = jopen(jhost,cardImage(1:lcard),itype,iform,ier)
      write(jhost,'(a)') '#!/bin/sh'
      Msg = 'dm HKLIN '// MTZfile(1:Lung(MTZfile)) // ' ' //
     *      'HKLOUT ' // nome(1:lnome) // '_dm.mtz' // ' < ' //
     *      Inte(1:Lung(Inte)) // ' > ' // nome(1:lnome) // '_dm.log'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      close (jhost)
      lcard = Lung(cardImage)
      cardImage(lcard+1:lcard+1) = char(0)
      call MakeExec(cardImage)
      Buffer1 = cardImage
      call Lanciash(Buffer1)
      cardDiret = MTZfile
!
*     numbGenSav = numbGen
      numbGen    = 0
      ifMTZlab = 0
      MTZfile = nome(1:lnome) // '_dm.mtz'
      call GetMTZ_DM(ier)
*     numbGen    = numbGenSav
      MTZfile = cardDiret

!
  200 format('SOLC ',f5.2)
  210 format('MODE SOLV HIST MULT')
* 210 format('MODE SOLV NOHIST   ')
  220 format('NCYCLE AUTO')
  230 format('SCHEME ALL')
  240 format('LABIN FP=F SIGFP=SIGF PHIO=PHIC FOMO=FOM ' 
     *       'HLA=HLA HLB=HLB HLC=HLC HLD=HLD')
  250 format('LABOUT PHIDM=PHI1 FOMDM=W1')

      return
      end
!-----------------------------------------------------------------------
      subroutine GetMTZ_PHENIX(ier)
      USE General
      USE Riflessi
      USE PhMod
      USE PhaseModule
      USE Mappa
      USE Param
!
      implicit none
      integer :: ier, iAction, lix1, lix2, knwSav, ipher, uno, i, ifBr
      integer :: jpatt
      real    :: celltemp(13), argbes, bes, besinv, correl, chope
!
      character (len=11) :: tirang
!
      uno = 1
      ier  = 0
      lix1 = 1
      lix2 = 1
      if (ifMTZlab == 0) then
          Lab_Ch(1) = 'H'
          Lab_Ch(2) = 'K'
          Lab_Ch(3) = 'L'
          Lab_Ch(4) = 'FP'
          Lab_Ch(5) = 'SIGFP'
          Lab_Ch(7) = 'FOM'  ! peso
          Lab_Ch(6) = 'PHWT' ! fase
          Lab_Ch(8) = 'FWT'   ! fc pesato, forse
      endif
      knwSav = knw
      ifMTZlab = 1
      do iAction =1, 2
         call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
         if (ier /= 0) then
             return
         endif
      enddo
      knw = 0
      call LeggiMTZPhase(ier)
      if (ier /= 0) then
          return
      endif
!
      iAction = 3
      call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
      if (ier /= 0) then
          return
      endif
!
      knw = knwSav

      call examin(333, mkang, khl,  Pub_target, iphaz, nrefl,
     *            0, wt, 1)
      tirang = 'FASI PHENIX'
      ipher = 1
      call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                 Pub_target, iphaz, wt, 20, 0.0, ipher)
      write(6,'(a,f7.2,i5)') 'PHENIX ',erore, nint(erore)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetMTZ_PARROT(ier)
      USE General
      USE Riflessi
      USE PhMod
      USE PhaseModule
      USE Mappa
      USE Param
!
      implicit none
      integer :: ier, iAction, lix1, lix2, knwSav, ipher, uno, i, ifBr
      integer :: jpatt
      real    :: celltemp(13), argbes, bes, besinv, correl, chope
!
      character (len=11) :: tirang
!
      uno = 1
      ier  = 0
      lix1 = 1
      lix2 = 1
      if (ifMTZlab == 0) then
          Lab_Ch(1) = 'H'
          Lab_Ch(2) = 'K'
          Lab_Ch(3) = 'L'
          Lab_Ch(4) = 'F'
          Lab_Ch(5) = 'SIGF'
          Lab_Ch(7) = 'FOM'  ! peso
          Lab_Ch(6) = 'parrot.F_phi.phi' ! fase
          Lab_Ch(8) = 'parrot.F_phi.F'   ! fc pesato, forse
      endif
      knwSav = knw
      ifMTZlab = 1
      do iAction =1, 2
         call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
         if (ier /= 0) then
             return
         endif
      enddo
      knw = 0
      call LeggiMTZPhase(ier)
      if (ier /= 0) then
          return
      endif
!
      iAction = 3
      call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
      if (ier /= 0) then
          return
      endif
!
      knw = knwSav

      call examin(333, mkang, khl,  Pub_target, iphaz, nrefl,
     *            0, wt, 1)
      tirang = 'FASI PARROT'
      ipher = 1
      call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                 Pub_target, iphaz, wt, 20, 0.0, ipher)
      write(6,'(a,f7.2)') 'PARROT ',erore
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetMTZ_DM(ier)
      USE General
      USE Riflessi
      USE PhMod
      USE PhaseModule
      USE Mappa
      USE Param
!
      implicit none
      integer :: ier, iAction, lix1, lix2, knwSav, ipher, uno, i, ifBr
      integer :: jpatt
      real    :: celltemp(13), argbes, bes, besinv, correl, chope
!
      character (len=11) :: tirang
!
      uno = 1
      ier  = 0
      lix1 = 1
      lix2 = 1
      if (ifMTZlab == 0) then
          Lab_Ch(1) = 'H'
          Lab_Ch(2) = 'K'
          Lab_Ch(3) = 'L'
          Lab_Ch(4) = 'F'
          Lab_Ch(5) = 'SIGF'
          Lab_Ch(7) = 'W1'  ! peso
          Lab_Ch(6) = 'PHI1' ! fase
          Lab_Ch(8) = 'FC'   ! fc
      endif
      knwSav = knw
      ifMTZlab = 1
      do iAction =1, 2
         call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
         if (ier /= 0) then
             return
         endif
      enddo
      knw = 0
      call LeggiMTZPhase(ier)
      if (ier /= 0) then
          return
      endif
!
      iAction = 3
      call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
      if (ier /= 0) then
          return
      endif
!
      knw = knwSav

      call examin(333, mkang, khl,  Pub_target, iphaz, nrefl,
     *            0, wt, 1)
      tirang = 'FASI DM    '
      ipher = 1
      call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                 Pub_target, iphaz, wt, 20, 0.0, ipher)
      write(6,'(a,f7.2,i5)') 'DM     ',erore, nint(erore)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine UpdateMAD()
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE MapTest
      USE Param
      USE PhMod
      USE TestStuff, only : ifFloatOrigin
!
      implicit none
      integer :: i, j, n, Phi, ipher, ii, kk, jj, nCicli, jpatt, ier
      integer :: numb_cs, numb_ncs, k
      real    :: soglia, arg1, arg2, Q, T
      real    :: vettoreRis(10)
      character (len=11) :: tirang
!
!     Siano n le fasi MAD iniziali.
!     Il SET A è costituito dagli n riflessi a peso più alto.
!     con le fasi e i pesi da inversione (Cowtan).
!     Si utilizza la tangente tra le fasi MAD e le fasi da inversione 
!     complementari rispetto a SET A. Questo è il SET A+
!     Il SET B è dato dalla somma di A e di A+
!
      numb_cs = 0
      numb_ncs = 0
      do i=1, nrefl
         if (mkang(i) == 1) then
             numb_ncs = numb_ncs + 1
         else
             numb_cs = numb_cs + 1
         endif
      enddo
      if (knw == 1) then
          write(6,*)
          write(6,*) '-------------------------------------------------'
          write(6,*) '             Procedura SET A  SET B '
          write(6,*) '        Numero NCS, CS', numb_ncs, numb_cs
          write(6,*) '-------------------------------------------------'
          write(6,*)
*     else
*         write(lo,10)
      endif
      ii = ksize
      jj = LowRes
      kk = numbGen
      nstr = count(Pesi_MR(1:nrefl) > 0.0)

      nCicli = 3
      do j=1, nCicli

*        do i=1, nrefl
*           if (mkang(i) /= 1 .and. wt(i) > 0.5) then
*               wt(i) = wt(i) ** 0.7
*           endif
*        enddo

         tmpwt(1:nrefl) = wt(1:nrefl)
         wto(1:nrefl) = wt(1:nrefl)
         n = nstr
         do i=1, nrefl
            jwork1(i) = i
            work1(i) = wt(i)
         enddo
         call sort3_big(work1, jwork1, worko, nrefl)
         soglia = worko(n)
         do i=1, nrefl
            if (wt(i) < soglia) then
                wto(i) = 0
            endif
         enddo
         if (knw == 1) then
             i = 200
             call examin(i,mkang,khl,Pub_target,iphaz,nrefl,0,wto,1)
             tirang = 'SET A      '
             ipher = 1
             call pherrdisNew(tirang, wto, khl, mkang, nrefl, 0,
     *                        Pub_target, iphaz, wto, 20, 0.0,ipher)
         endif

         worko(1:nrefl) = 0
         do i=1, nrefl
            if (.not.Pesi_MR(i) > 0 .and. mkang(i) /= 1) then
                worko(i) = wt(i)
            endif
         enddo
         if (knw == 1) then
             i = 201
             call examin(i,mkang,khl,Pub_target,iphaz,nrefl,0,worko,1)
             tirang = 'SET NO A CS'
             ipher = 1
             call pherrdisNew(tirang, worko, khl, mkang, nrefl, 0,
     *                        Pub_target, iphaz, worko, 20, 0.0,ipher)
         endif
!

         worko(1:nrefl) = 0
         do i=1, nrefl
            if (Pesi_MR(i) > 0.0 .and. wto(i) < 0.001) then
                arg1 = float(Fasi_MR(i)) * dtor
                arg2 = float(iphaz(i)) * dtor
                Q = 2.0*Pesi_MR(i) * sin(arg1) + 1.0*tmpwt(i)*sin(arg2)
                T = 2.0*Pesi_MR(i) * cos(arg1) + 1.0*tmpwt(i)*cos(arg2)
                Phi = nint(3600 + atan2(Q, T) * rtod)
                iphaz(i) = mod(Phi, 360)
                arg1 = sqrt(Q*Q+T*T) / 3.0
                wto(i) = arg1
                worko(i) = arg1
            endif
         enddo
         if (knw == 1) then
             i = 202
             call examin(i,mkang,khl,Pub_target,iphaz,nrefl,0,worko,1)
             tirang = 'SET A +    '
             ipher = 1
             call pherrdisNew(tirang, worko, khl, mkang, nrefl, 0,
     *                        Pub_target, iphaz, worko, 20, 0.0,ipher)
             i = 202
             call examin(i,mkang,khl,Pub_target,iphaz,nrefl,0,wto,1)
             tirang = 'SET B      '
             ipher = 1
             call pherrdisNew(tirang, wto, khl, mkang, nrefl, 0,
     *                        Pub_target, iphaz, wto, 20, 0.0,ipher)
         endif
!


         wt(1:nrefl) = wto(1:nrefl)

         if (j < nCicli) then
             ModificaNp = .true.
             cicloMut = 1
             call Cicla_LOW(0)
         endif

      enddo

      ksize = ii
      numbGen = kk
      LowRes = jj
      Fasi_MR(1:nrefl) = iphaz(1:nrefl)
      Pesi_MR(1:nrefl) = wt(1:nrefl)
      Fasi_Sav(1:nrefl) = iphaz(1:nrefl)
      Pesi_Sav(1:nrefl) = wt(1:nrefl)
      Pfinal(1:nrefl) = iphaz(1:nrefl)
      Wfinal(1:nrefl) = wt(1:nrefl)
      if (knw == 1) then
          call examin(8888, mkang, khl, ipub, iphaz, nrefl, 0, wt, 1)
          tirang = 'Estendi FIN'
          ipher = 1
          call pherrdisNew(tirang, wt, khl, mkang, nrefl, 0,
     *                     ipub, iphaz, wt, 20, 0.0, ipher)
      endif
!
      fcoef(1:nrefl) = fovet(1:nrefl) * Pesi_MR(1:nrefl)
      jpatt = 0 
      call MakeMap(fcoef, Fasi_MR, nrefl, jpatt, xmap,
     *             FORTH, BACK)
      percMap = 0.5
      invflag = 1
      call InvMap(khl,mkang,jwork1,fcvet,nrefl)
      wt(1:nrefl) = Pesi_MR(1:nrefl)
      Fcvet_MR(1:nrefl) = fcvet(1:nrefl)
!
      return
   10 format(/,'Extending MAD/SAD phases ...',/)
      end
!-----------------------------------------------------------------------
      subroutine Calcola_v_p
      USE General
      USE PhaseModule
      USE Param
!
      implicit none
      integer :: i
      real    :: den
!
      v_m  = 0.0
      den = 0.0                     !mr 040606
      do i=1, nk
         if (no(i) > 16) cycle
         if (no(i) > 1) then
             den = den + float( nw(i) * nw(i) * no(i) )
             v_m = v_m + 14.0 * float( nw(i) )
         endif
      enddo
*---- Matthews' number
      v_m = volume / v_m
*---- Percent of Protein
*-----  protein density=1.23 (from CCP4 1.34)
      v_p = 1.34 / v_m
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Abi2PhD
      USE General
      USE Riflessi
      USE PhMod
      USE PhaseModule
      USE Mappa
      USE Param
!
      implicit none
      integer :: Lung, ier, fromPhasing
      logical :: Esiste
!
      if (knw == 1) then
          write(6,*) 'subr Abi2PhD'
          write(lo,*) MTZfile(1:Lung(MTZfile))
      endif
      inquire (file=MTZfile,  exist = Esiste)
      if (.not.Esiste) then
          write(lo,10) MTZfile(1:Lung(MTZfile))
          ier = -1
          return
      endif
!
      call AllocaMappa(2)
!
      ifInvar = 0
      InfoOK(15) = 0
      ifPhantom = 1
      jEnan = 1
      ifHeavyAtom = .true.
      calcFC = .true.
      FichierOut = ' '
!
      ier = 0
      fromPhasing = 1
      call Phantom(ier, fromPhasing)
!
      return
   10 format(/,'  **************** ERROR ****************',
     *       /,' Phantom Derivative procedure cannot start',
     *       /,' MTZ file ',a,' not found',/)
      end
!-----------------------------------------------------------------------
      subroutine MR2PhD
      USE General
      USE Riflessi
      USE PhMod
      USE PhaseModule
      USE Mappa
      USE Param
!
      implicit none
      integer :: Lung, ier, fromPhasing
      logical :: Esiste
!
      if (knw == 1) then
          write(6,*) 'subr MR2PhD'
          write(lo,*) MTZfile(1:Lung(MTZfile))
          write(lo,*) FichierOut(1:Lung(FichierOut))
      endif
      inquire (file=MTZfile,  exist = Esiste)
      if (.not.Esiste) then
          write(lo,10) MTZfile(1:Lung(MTZfile))
          ier = -1
          return
      endif
      inquire (file=FichierOut,  exist = Esiste)
      if (.not.Esiste) then
          write(lo,20) FichierOut(1:Lung(FichierOut))
      endif
!
      call AllocaMappa(2)
!
      ifInvar = 0
      InfoOK(15) = 0
      ifPhantom = 1
      jEnan = 1
!
      ifMTZlab = 1
      if (knw == 1) then
          write(6,*) Lab_Ch(1:14)(1:5)
      endif
      Lab_Ch(1:5) = Lab_Col(1:5)
      Lab_Ch(6) = Lab_Col(8)
      Lab_Ch(7) = Lab_Col(9)
      Lab_Ch(8) = Lab_Col(7)
      if (knw == 1) then
          write(6,*) 'LABELS'
          write(6,*) Lab_Ch(1:8)(1:5)
      endif
!
      ier = 0
      fromPhasing = 1
      call Phantom(ier, fromPhasing)
!
      return
   10 format(/,'  **************** ERROR ****************',
     *       /,' Phantom Derivative procedure cannot start',
     *       /,' MTZ file ',a,' not found',/)
   20 format(/,'  *************** WARNING ***************',
     *       /,' Phantom Derivative procedure will start',
     *       /,' without model: PDB file ',a,' not found',/)
      end
!-----------------------------------------------------------------------
