!-----------------------------------------------------------------------
!  La direttiva tipo (cioe' con i valori di default) e'
!
!  vld 300 20 1
!
!  dove 300 = numero di cicli per seed (trial/modello) (variabile n_cicli)
!        20 = numero di seeds (trials/modelli) (variabile n_Maxrun)
!         1 = numero di seed da cui iniziare la sequenza dei trials  
!             (variabile n_abi_model); questo significa che se hai gia' 
!             fatto 20  trials e non hai trovato la soluzione , si puo' 
!             ripartire dandogli 21  come n_abi_model
!-----------------------------------------------------------------------
      subroutine Block_VLD(ier, iPlotTypeSWRC, ifFromGraphic, ifBreak)
      USE General
      USE Symmetry
      USE Riflessi
      USE HistoStuff
      USE Atomi
      USE Molcom
      USE Html
      USE PhaseModule
      USE Mappa
      USE VLDmod
      USE TestModel, only : naatoms
c     USE Tutto, only : wt11
!
      integer :: doRicicla
      real    :: VettRisultati(10)
!
      if (ifMDM == 1) then
         call cpu_time(tiniz)
      end if

      if (.not.allocated(rvetVLD)) then
          allocate (rvetVLD(1:max0(n_abi_model,n_Maxrun)), stat = ier)
      endif
c     allocate(wt11(nrefl), stat=ier)
      rvetVLD(:) = -1
      correBestVLD = -99.99
      erre = 9999
      naatoms = 0
!
      if (jscreen > 0 .and. ifMadEnv == 0) then
          call AbilitaSkipeStop()
      endif
!     
      call fomspinit
!
!-- Envelope
!
      RenveStart = 8.0
      RenveDyn   = RenveStart
      EnvePronta = 0
      ifEnve = 0
!
      ifIbrida = 0
      Tau = 1.0
      Omega = 2.0    
      

      WhichBlock = 0
      nuset = 0
      numbrun = 0
      numbrunTot = 0
      MaxRunTot = 0
      jCountRun = 0
      jBlock = 1
      WhichBlock = jBlock
      if (ifMDM == 1) then
         MaxRun_MDM = jBlocksPh(1,jBlock)
         MaxRunTot = MaxRunTot + MaxRun_MDM
      else
         MaxRun = jBlocksPh(1,jBlock)
         MaxRunTot = MaxRunTot + MaxRun
      end if

      if (jrest.ne.2) then
          jRfac = 0
      endif
      MaxToStore = min0(jBlocksPh(2,jBlock),500)
      if (jBlock == 1 .and. ifMDM == 1) then
          if (MaxToStore > 1 .or. nBlocksPh > 1) then
              if (ifMadEnv == 0) then
                  iAction = -1
                  npunti = sum(jBlocksPh(1,:))
                  call DataForGraph(iAction, npunti)
              endif
          endif
      endif
      nRfac    = 0
      WhichFom = 2
      SetsStored=0
      nsxx = MaxRun
      nfom0  = 0
      nfoml  = 0
      nSetStored = 0
      lungs = MaxToStore
      call ManageInitialPhases(1, nstr, lungs)
!
      call AllocaFasiPesiFcVLD(1)
!
      ierrP  = 0

      WhichFom = 3

      btOld = bt    ! salvo il B di Wilson
      
      if (ifMDM == 0) Then
         call SviluppaRandom_VLD(ifBreak, ier)
      else
         call SviluppaRandom_MDM(ifBreak, ier)
      end if   

      call WriteFinal(lo, 0)
      call ManagePhasesDSR(2,corre,0)
!
!-- Final interpretation
!
      if (ifMDM == 1) then
         call cpu_time(tfin)
         if (knw == 1) then
             write(lo,'(a,f8.1)') 'Tempo x MDM ',tfin-tiniz
         endif
      end if

      if (InfoOK(15).eq.1) then
          call FinalInterpretation
          nolsq = -1
      endif
!
      bt = btOld

      if (ifBreak == 1) then
          return
      endif
      if (ier < 0) then
          return
      endif
!
      call AbInfo(2)
      if (Lung(HTMLstr) > 0) then
          call AbInfo(3)
          HTMLstr = ' '
          call AbInfo(3)
      endif         
!
      if (kWstop.eq.1) then
         if (nolsq == 0) then
         endif
         call AbInfo(2)
         if (Lung(HTMLstr) > 0) then
             HTMLstr = ' '
             call AbInfo(3)
         endif
      endif
      if (WhichBlock == 0) then
          jBlock = nBlocksPh
      else
          jBlock = WhichBlock
      endif
!
      iPlotType = iPlotTypeSWRC
      if (InfoOK(15).eq.1) then
!
          if (ifAutomatic == 0) then
              call ThFacTooBig(2)
          end if
!
          interp = 1
          call lastplot(rfac)
          if (nolsq /= 0) then
              call LastSFC(1, ier)
          endif
      endif
!
      call DoAllGraphs()
!
      call AllocaPhaseStuff(2)
!
      if (nolsq == 0) then
          if (nSetsFineDSR > 0) then
              call Cancella( 5)
              call Cancella(12)
              call Cancella(22)
              call scrper(' ', 0, -1)
!
              numbGen = numbGenSav
              if (ifFreeLunch > 0) then
                  if (LowRes==1.and.numbGen > 0) then
                     ihmx(:) = ihmxExt(:)
                     rhomax = maxval(rhov(1:nreflTot))
                     call FreeLunch()
                  endif
              endif
              ksize = ksize_vero
*             call MTZfiles(nSetsFineDSR, 0, 1)
              write(Msg,70) nSetsFineDSR
              call PrintMess(Msg)
              if (ifMadEnv == 0) then
                  Inte = 'Final Stage'
                  call MsgWinErr(Inte, Msg, INFO_WINDOW, nExitCode)
              else
                  k = index(Msg, 'MTZ')
                  Msg(1:k-1) = ' '
                  call shift(Msg, k)
                  call TestoGR(Msg, -1, 2, 3)
                  write(Msg,75) fomBest
                  call TestoGR(Msg, -1, 2, 3)
              endif
          endif
      endif
!
      call StoreCorrectPhases
!
      if (ifAmb /= 0) then
          call StampaMtzPdb
          doRicicla = 0
          call Ricicla(VettRisultati, doRicicla, 1, ier)
      endif
!
      if (InfoOK(15) == 1) then
          QualeAbilita = 2
      elseif (InfoOK(17) == 1) then
          if (ifSkeleton == 0) then
              QualeAbilita = 1
          else
              QualeAbilita = 2
          endif
      endif
!
      call AllocaFasiPesiFcVLD(2)
!
      return
   70 format(i3,' set of phases available. ')
   75 format('Best Final FOM value: ',f8.3)
      end
!-----------------------------------------------------------------------
      subroutine SviluppaRandom_MDM(ifBreak, ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Param
      USE PhaseModule
      USE Grafici, only : NewPoint
      USE TestModel
      USE Mappa
      USE ShellSIGMAA
      USE RemoModule , only: use_E
      USE MappaPatterson , only: xmapSav
      USE Molcom, only : jscreen, QualeAbilita, color_LIGHTRED,
     *                   color_GREEN, ifMadEnv, ifBrekke
      USE Html

      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      USE Tutto
      USE RelaxMod, only : BestFomChe
      USE RfacMatrixModule
!
!psi-e
      common/dirpse/npse      
      
      dimension sh_save(4),sh_phiq_save(4)
      integer :: AggiornaFasi        !rst  , ripetibilita
      character * 1,iast
      character*11 tirang
      character *80 line      
            
      dimension Eo2Ec2Med(50)
      dimension Eo2Ec2Med_old(50)
!
      real    :: rFac
!
!rst      if (ifDebug == 0) then
!rst          ripetibilita = 0
!rst      else
!rst          ripetibilita = 1
!rst      endif
      somma_fFOM2 = 0.0
      n_seeds_rec = 0
      AggiornaFasi = 0
      nreflSav = nrefl
      
      call AllocaVLD 
            
      stopFinalFom = 0.3
      stopFinalFom2 = 3.0

!!!!!!!!!!!!            stopFinalFom2 = 9.0    !!! prova DEDI 
      
      nrefl = nreflSav

      ifTiDeviFermare = 0

!      ksigma_pg = ksigma
      ksigma_pg = 0 ! per non utilizzare gli eventuali valori di sigmav

      line = 'the MDM procedure starts '
      lline = Lung(line)
      call scrend(line,lline)
      if (knw /= 0) then
          write(lo,'(/,a,/)') line(1:lline)
      endif
      line = ' '
      
      if (no(1) == 1) then 
          jlig = 2
      else
          jlig = 1
      endif
      
      naatoms_max = 0
      numero_cicli_max = 0
      numbrun_max = 0
      
      fcoef(1:nrefl) = evet(1:nrefl)     
      jpatt = 0
      krecy = 0
      mode = -1
      MaxRun_MDM = n_Maxrun + n_abi_model -1
          
      amedia_n_EDM =  0.0
      ifExamin = 1                   !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ifExaminSav = ifExamin
!      ifExamin = 0                   !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      time_tot_edm = 0
      num_tot_edm = 0
      time_tot_dlsq = 0
      num_tot_dlsq = 0
      time_tot_raffi = 0
      time_tot_postdsr = 0
      num_tot_raffi = 0
      rfac_edm_min = 9999.
      num_model_edm_min = 0
      
      call Calcola_SigmaN_es
      
      if (ripetibilita == 1) then
!ripetibilità
          if (n_abi_model == 1) then
             L = index(fname(1),'.bin') - 1
             ReflFileName = fname(1)(1:L)//'.rst'
             itype = 0
             len_rec = 20
             jop = kopen(98, ReflFileName, len_rec, itype, ier)
             if (ier < 0) then
                return
             end if
             n_seeds_rec = 0
          else
             L = index(fname(1),'.bin') - 1
             ReflFileName = fname(1)(1:L)//'.rst'
             itype = 2
             len_rec = 20
             jop = kopen(98, ReflFileName, len_rec, itype, ier)
             if (ier < 0) then
                return
             end if
!!!!!!!!!!!!!!!!!!!!!         
             if (ier == 29) then
                itype = 0
                len_rec = 20
                jop = kopen(98, ReflFileName, len_rec, itype, ier)
                n_seeds_rec = 0  
                go to 33221   
             end if
!!!!!!!!!!!!!!!!!!!!!         
             read (98,rec = 1) n_seeds_rec
             if (n_seeds_rec + 1 < n_abi_model) then
                write (lo,'(//,a,//)')
     *         'You asked for a trial greater than those stored',
     *         ' in the file '// ReflFileName
             else
                read(98, rec = n_abi_model) n_seed_req, rfac_init_edm,
     *                                      somma_fFOM2
                if (kverbo_pg == 1) then
                    write(lo,'(a,i5,2f20.15)') ' kopen r ',n_seed_req, 
     *                                     rfac_init_edm, somma_fFOM2
                endif
             end if
          end if
      endif

33221 continue      
! Find the first seed to generate random phases
      if (itria > 0) then
          n_abi_model = itria
          MaxRun_MDM = itria
      endif
      do i=1, n_abi_model - 1
         call RandomPhases_VLD
      end do
         
      n_EDM_save = n_EDM
!
!-- inizializza i grafici
!
*     if (ksize <= 3) then
*        call RWind(0)
*     else
*        call RWindMainWindow(0)
*     end if
!
!-- inizializza la figura di merito
!
      call InitFinalFomVLD   !gl
      
      numsog = 20  ! soglia dinamica di FFOM
      if (n_abi_model == 1) then
        rfac_init_edm = 0.0
      end if
      nSeedDLSQ = 0
      nSeedRelax = 0
      nSeedSogRelax = 0
      nSeedMigliora = 0
      
      perc_cammino_Rat = 0.0001
                        
      if (ripetibilita == 1) then
!ripetibilità
          if (n_seeds_rec == 0) then                 
              somma_fFOM2 = 0.0
          end if
      endif
      fFOM2_max = -9999.
      somma_fFOM2_2 = 0.0
      erreBestVLD = 9999


! Esplora tutti i models (seeds.... trials .....)
! a partire dal trial n_abi_model (default = 1)
      do numbrun = n_abi_model, MaxRun_MDM

          NewPoint = .true.

          if (nBlocksPh > 1) then
!!            inumC = numbrun + MaxRun_MDM*1000 + jBlock*1000000       !mr
              inumC = jBlock
          else
!!            inumC = numbrun + MaxRun_MDM*1000                    !mr
              inumC = 0
          endif
          if (ifMadEnv == 0) then
!!            call c_scr2(-2, inumC, ' ')     !mr
              call c_scr2(-2,numbrun,MaxRun_MDM,inumC,MaxRun_MDM,' ')  !mr
          endif
          if (numbrun - nSeedDLSQ > 10) then
             if (ksize_vero <= 3) then
                stopFinalFom2 = stopFinalFom2 * 0.9
                nSeedDLSQ = numbrun
             end if
          end if
          if (numbrun - nSeedSogRelax > 10) then
             perc_cammino_Rat = perc_cammino_Rat / 2.
             nSeedSogRelax = numbrun
          end if
          if (numbrun > 1) then
            line = 'change random model        '
            write(line(21:24),'(i4)') numbrun
            lline = lung(line)
            call scrend(line, lline)
            if (knw /= 0) then
                write(lo,'(/,a,/)') line(1:lline)
            endif
            line = ' '
         end if
                   
*        if (ifMadEnv == 0) then
*            inumC = numbrun*1000000
*            call c_scr2(-2, inumC, ' ')                       !mr
*        endif
!
         nsetVLD = numbrun
         stopFinalFom = 0.30
         stopFinalFom = 1.30
         stopFFsog = 0.4  ! soglia dinamica di FFOM
         num_ffom = 0     ! soglia dinamica di FFOM
         sumef = 0.0      ! soglia dinamica di FFOM
        
*        if (ksize <= 3) then
*           call RWind(1)
*        else
*           call RWindMainWindow(1)
*        end if

         iperc = 0
         numbrunTot = numbrun
         nCycleVLD = 0
*TEST*   erreBestVLD = 9999
         rfac_edm = 9999.
         rfac_init = 0.0
         rfac_10EDM = 0.0
         Rat_VLD = 0
         numbDyn = nrefl
         nstr = nstrSav
         amed_Dl = 0.0
         nats = natm
         somma_rfac = 0.0
         n_rfac = 0
         iphaz(1:nrefl) = 0
         wt(1:nrefl) = 0
         
! genera un set di fasi random per tutti i riflessi
         if (knw == 1) then
             write(lo,'(a,i4,a,i11,/)')
     *             ' The random seed generator for Model n. ',
     *             numbrun,' is', iyrand
         endif
     
         call RandomPhases_VLD

!  i cicli devono essere sostituiti dai trials richiesti
!         npercBarra  = 100
!         npercBarra  = n_cicli
!         iperc0      = n_cicli / npercBarra
!         iperc       = iperc0
!         jpercBarra  = 0
!         call scrper('Running MDM procedure ',0,0)
!                 
         ifStoredPhases = 0
         fomBestVLD = -9999
!         do numero_cicli = 1, n_cicli
            numero_cicli = 1
            ifScriviCicloVLD = 1
            n_EDM = n_EDM_save
!            if (numero_cicli == iperc) then
!               jpercBarra = jpercBarra + 1
!               iperc = iperc + iperc0
!               call scrper(' ',jpercBarra,npercBarra)
!            endif

!            if (ifMadEnv == 0) then
!                inumC = numero_cicli + n_cicli*1000 + numbrun*1000000
!                call c_scr2(-2, inumC, ' ')
!            endif
            
*           call Messaggi_VLD

            if (knw /= 0 .and. kverbo_pg == 1) then
               write(lo,51) numbrun
   51          format(' Trial =',i5,/)
            end if
   

!    mappa iniziale osservata con fasi random
            iphazo(1:nrefl) = iphaz(1:nrefl)
            Wt_save(1:nrefl) = wt(1:nrefl)  
            fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
!piero
            call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,FORTH,BACK)
            Rat_VLD = 0.0001
            sigmaA_1 = 0.0001
            FinalFom = 0.0001
            FinalFom2 = 0.0001
            corre_VLD = 0.0001
*           if (ksize > 3) then
*                  call PlotFinalFomVLD(1)
*           end if

!formula20
            if (ifForm20 == 1) then            
                call MDM_SB_init(iyseed)
! soglia per cfom dopo edm
                stopFFF = 1.7 !large
                stopFFF3 = 3.0 !small
            end if


            if (ifForm20 == 0) then            

!            do jjcris = 1, 10
            FinalFom2 = -9999
            FinalFom2 = 0.01
            call MDM_start
            fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
            fcoef(nstr+1:nrefl) = 0.0
            call MakeMap(fcoef, iphaz, nstr, jpatt, xmap,FORTH,BACK)
!!!!!!!!!!!               numero_cicli = 2
               
!  calcolo dei cicli EDM 

            percp = 0.025
!            n_EDM = 6
            call EDM_Cycles_VLD(percp, 0, 0)
!            end do !jjcris
            else
               do jjcris = 1,6
                   
                  write (lo,'(/,a,i5,/)') ' Tangente N. =', jjcris
                  FinalFom2 = -9999
                  FinalFom2 = 0.01
                  call MDM_SB(iyseed,jjcris)
                  fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
                  fcoef(nstr+1:nrefl) = 0.0
                call MakeMap(fcoef, iphaz, nstr, jpatt, xmap,FORTH,BACK)
!psie                  
!psie                  if  (jjcris > 1) then
!psie!                     nrefl_psie = nstr + nstr / 3
!psie                     nrefl_psie = nstr + npse
!psie                     call weitan_psie(numbrun, nstr, nrefl_psie)
!psie                     fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
!psie                     fcoef(nrefl_psie+1:nrefl) = 0.0
!psie                     call MakeMap(fcoef, iphaz, nrefl_psie, 
!psie     *                            jpatt, xmap,FORTH,BACK)
!psie                  else
!psie                     fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
!psie                     fcoef(nstr+1:nrefl) = 0.0
!psie                call MakeMap(fcoef, iphaz, nstr, jpatt, xmap,FORTH,BACK)
!!!!!!!!!!!               numero_cicli = 2
!psie                  end if
             
               
!  calcolo dei cicli EDM 

               percp = 0.025
!               if (ksize_vero < 3) then
                 n_edm = 8
                 numero_edm_finale = 8
!               else
!                 n_edm = 12
!                 numero_edm_finale = 12
!               end if
444            call EDM_Cycles_VLD(percp, 0, 0)
               
               
!               if (jjcris == 1) then
!                   
!                  wq1_1(1:nrefl) = Dluz(1:nrefl)
!                  
!               call Prova_a_Raffinare(corre_VLD)           ! il ciclo e' degno di "attenzione" !!!!
!               
!!               if (ksize > 3) then
!!                   call scrper('Running MDM procedure ',0,0)
!!                   call scrper(' ',jpercBarra,npercBarra)
!!               endif 
!               
!                  Dluz(1:nrefl) =  wq1_1(1:nrefl)              
!               
!               if (kWstop == 1) then
!                   if (ksize < 3) then
!                       RfacMatrix(3,numbrun,jBlock) = BestFomChe
!                   endif
!                   call DeAllocaVLD
!                   AggiornaFasi = 1
!                   call SalvaFasi(1, FinalFom2, corre_VLD, AggiornaFasi)
!                   return
!               end if
!               end if
               
!large      
               if (ksize_vero >= 4) then
! calcolo cfom dopo edm e controllo con soglie        
                 call CalcFFomVLD(2, corre_VLD)
                 write(lo,'(a,2f12.5)')
     *              ' FinalFom, stopFFF =',
     *                FinalFom,stopFFF
     
corig            if (FinalFom > 3.0) then
                 if (FinalFom > stopFinalFom2) then
                   exit
                 end if
     
               if (FinalFom > stopFFF) then
                    stopFFF = FinalFom
                    go to 444
                 end if
               else
 !small + medie                 
                 call CalcFFomVLD(2, corre_VLD)
                 write (lo,'(a,2f12.5)') ' FinalFom =',
     *                FinalFom, stopFFF3
                 
                 if (ksize_vero <= 2) then
                    ifFA = 0 
                    if (jjcris == 1) then
                      ifFA = 1
                    elseif (FinalFom > 1.2 * stopFFF3) then
                      ifFA = 1
                    end if
                    if (ifFA == 1) then
                       stopFFF3 = FinalFom 
                       wq1_1(1:nrefl) = Dluz(1:nrefl)
                       call Prova_a_Raffinare(corre_VLD)           ! il ciclo e' degno di "attenzione" !!!!
                       Dluz(1:nrefl) =  wq1_1(1:nrefl)              
                       if (kWstop == 1) then
                          if (ksize < 3) then
                          RfacMatrix(3,numbrun,jBlock) = BestFomChe
                          endif
                          call DeAllocaVLD
                          AggiornaFasi = 1
                   call SalvaFasi(1, FinalFom2, corre_VLD, AggiornaFasi)
                          return
                       else
                          cycle  
                       end if
                    end if
                 end if
                
 !solo MNQ                
 !                if (jjcris <=5) then                   
 !                if (FinalFom > 3.0) then 
 !                    RfacMatrix(3,numbrun,jBlock) = FinalFom
 !                    ifLsqVLD = 1
 !                    call Prova_DLSQ(naatoms_max, corre_VLD)      ! il ciclo e' degno di "attenzione" !!!!
 !                    if (kWstop == 1) then
 !                  call SalvaFasi(1,FinalFom2, corre_VLD, AggiornaFasi)
 !                       call DeAllocaVLD
 !                       return
 !                    else
 !                       cycle
 !                    end if
!                   
!!!!!!!!!!!                   exit
 !                  end if
 !                end if
! calcolo cfom dopo edm e controllo con soglie  
                 
               end if
               end do !jjcris
               jjcris = 0
               numero_edm_finale = 30
            end if  
!-------------------------------------------------------------------------------
      
            if (kverbo_pg /= 0 .and. ifTime == 0) then
                write(lo,'(i5,a,4f10.5,2i5)') numbrun,
     *            '  SA, perc_cammino_SA, Rat_VLD, FOMS(2,4)=',
     *            sigmaA_1,perc_cammino_Rat,Rat_VLD,FOMS(2,4),
     *            ksize,ksize_vero
            end if
            
            if (ksize > 3) then
              
                call CalcFFomVLD(1, corre_VLD)
                call SalvaFasi(1, FinalFom2, corre_VLD, 0)

                if (ifTime == 0 .and. kverbo_pg == 1) then
                   write(6,*) 'FinalFom, stopFinalFom',
     *                           FinalFom,stopFinalFom
                endif
                  
                if ((ksize_vero  <= 3 .and. FinalFom > stopFinalFom).or.
     *               ksize_vero > 3) then

!    Blocco ulteriore di cicli  EDM per medie-grandi trovata la possibile soluzione
 
                    call MiglioraFasi(AggiornaFasi, numsog, stopFFsog,
     *                        sumef, num_ffom, ifLsqVLD, corre_VLD)
                    if (kWstop == 1 .and. 
     *                 (ifLsqVLD == 1 .or. ksize_vero > 3)) then
!ripetibilità
                        somma_fFOM2 = somma_fFOM2 + FinalFom2
                        if (ripetibilita == 1) then
                            write(98,rec = numbrun + 1) numbrun, 
     *                           rfac_init_edm, somma_fFOM2 
                            if (kverbo_pg == 1) then
                               write(lo,'(a,i5,2f20.15)') ' kopen w ',
     *                           numbrun,rfac_init_edm, somma_fFOM2
                            end if             
                            if (numbrun > n_seeds_rec) then
                               write(98,rec = 1) numbrun
                            end if
                        endif
     
                        ifExamin = 1
                        ifTime = 0
                        izero = 0
                        ifmin = 1
                        nbru = 8888
                        call examin(nbru,mkang,khl,ipub,iphaz,nrefl,
     *                              izero,wt,ifmin)
                        nTrialsVLD = numbrun
!
                        call SolutionFound(1, ifBreak)
!
                        if (nolsq == 0) then
                           call Cancella(15)
                        endif
!
                        call SalvaFasi(1, FinalFom2, corre_VLD, 1)
                        call EndTrialVLD
                        return
                    end if
                end if !per medie finalfom > stopfinalfom
            else  ! if (ksize >3)
                call ScriviCicloVLD(numero_cicli, numbrun,
     *               eFom_MDM, Rat_VLD, perc_cammino_control)
            endif  ! ksize >3
            
            ifProvaVLD = 0
            
            if (FinalFom2 > fFOM2_max) then
               fFOM2_max = FinalFom2
            endif
            somma_fFOM2 = somma_fFOM2 + FinalFom2
              
            if (ripetibilita == 1) then
!ripetibilità
                write(98,rec = numbrun + 1) numbrun, rfac_init_edm,
     *                              somma_fFOM2             
                if (kverbo_pg == 1) then
                    write(lo,'(a,i5,2f20.15)') ' kopen w ',numbrun, 
     *                                  rfac_init_edm, somma_fFOM2
                endif
                if (numbrun > n_seeds_rec) then
                    write(98,rec = 1) numbrun
                end if
            endif
            somma_fFOM2_2 = somma_fFOM2_2 + FinalFom2 ** 2
            if (n_seeds_rec > 0) then
               fFOM2_med = somma_fFOM2 / numbrun
            else
               fFOM2_med = somma_fFOM2 / (numbrun-n_abi_model+1)
            end if
            if (ksize_vero <= 3 ) then
               ifProvaVLD = 1
            else
               if (numbrun <= 2 .or. FinalFom2 > fFOM2_med) then
                   ifProvaVLD = 1
               end if
            end if   
            dev_st = 0.0
            if (numbrun > 2) then
               dev_st = sqrt((numbrun*somma_fFOM2_2-somma_fFOM2**2)/
     *                           (numbrun*numbrun))
            endif
             if (ifTime == 0 .and. kverbo_pg == 1) then
              write(lo,'(a,i6,4f20.5)')' Valori per fFOM2 = ',numbrun,
     *                   FinalFom2,fFOM2_med,dev_st,fFOM2_max
             end if
            if (ifProvaVLD == 1) then

               nSeedSogRelax = numbrun
               
               call Prova_a_Raffinare(corre_VLD)           ! il ciclo e' degno di "attenzione" !!!!
               if (ksize > 3) then
                   call scrper('Running MDM procedure ',0,0)
                   call scrper(' ',jpercBarra,npercBarra)
               endif
               if (kWstop == 1) then
                   if (ksize < 3) then
                       RfacMatrix(3,numbrun,jBlock) = BestFomChe
                   endif
                   call DeAllocaVLD
                   AggiornaFasi = 1
                   call SalvaFasi(1, FinalFom2, corre_VLD, AggiornaFasi)
                   return
               end if
            end if

!!!!            if (numero_cicli == n_cicli) go to 4444
!!!!            if (numero_cicli == n_cicli) exit

!!!!            call DEDM_VLD(rfac, ifBreak)
             
            go to 4444
            
            if (ifBreak > 0) then
                call DeAllocaVLD
                return
            endif
         
            call Tangente_VLD
         
            if (knw > 0 .and. ifExamin == 1 .and. ifTime == 0) then
!pg201213               call VLD_Statistics
            end if
            go to 4444    !small come medium
            
            if (ifIbrida /= 0 .and. ksize_vero < 3) then
            
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! calcolo della mappa con pesi e fasi ottenuti dalla tangente (60% Gq)
! modifica e inversione al 2.5%
! richiamo della SigmaA e relativo calcolo di m
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
               jpatt = 0
               fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
               call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,FORTH,BACK)
         
               npunti=np(1)*np(2)*np(3)
               percp = 0.025
               percn=0.00
               npts1=npunti*percp ! punti positivi
               npts2 = 0
               call denhist(0,xmap,xenve,npts1,npts2)
c
c--inverto la mappa
c
               knw_save = knw
               knw = 0
               call ChangeAndInvMap_VLD(xmap,xenve,1,0.0,1,1,ier)
               knw = knw_save 
               work1(1:nrefl) = fcvet(1:nrefl)
               nwizm1=25
               nsip1=150 
               call HistogramMatch(work1,work1,nrefl,nsip1,nwizm1,4) 
               fcvet(1:nrefl) = work1(1:nrefl)
         
               call Calcola_SigmaA(Ratt)               
               
               do i=1, nrefl
                  if (Dluz(i)>0.97) Dluz(i)=0.97
                  if (Dluz(i)<0.20) Dluz(i)=0.20
               end do
               do i=1,nrefl
                  X=(2.*Dluz(i)*evet(i)*fcvet(i))/(es(i) - Dluz(i)**2)
                  pesMod(i) = bes(X)
               end do
         
               wt(1:nrefl) = pesmod(1:nrefl)
               sog_wt = 0.20
               do i=1, nrefl
                  if (wt(i) < sog_wt) then
                     wt(i) = 0.0
                  end if
               end do
!                                                                            !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            end if
 
 4444       continue    

            if (ksize < 3) then
                RfacMatrix(3,numbrun,jBlock) = BestFomChe   ! da verificare?
            endif

            call Messaggi_VLD
            
!
!-- manage BREAK button
!
            if (ifBreak == 0) then
                ifBreak = ifBreakFun()
                if (ifBreak == 1) then
                   exit
                endif
            endif
   
                
!         end do  ! numero_cicli = 1, n_cicli
!
!-- ha finito i conti sul trial corrente
!
         RfacMatrix(4,numbrun,1) = erre * 100.0
         if (numbrun <= 2 .or. numbrun == MaxRun_MDM) then
            call EndTrialVLD
         end if
         if (ifExamin == 1 .and. knw == 1) then
            write(lo,4533) naatoms_max, numero_cicli_max,
     *                     numbrun_max
         end if
         if (kWstop == 1) then
             numero_cicli = cicloBestVLD
             corre_VLD = correBestVLD
             call DeAllocaVLD
             AggiornaFasi = 1
             call SalvaFasi(1, FinalFom2, corre_VLD, AggiornaFasi)
             exit
         endif

         if (ifBreak == 1) then
             exit
         endif
     
      enddo  ! numbrun = n_abi_model, MaxRun_MDM

      if (ifBreak == 1) then
          n_abi_model = n_abi_model - 1
          numbrunTot = 0
          ifBrekke = 0
      endif

      go to 1234   ! eventualmente eliminare il blocco che segue

      if (knw /= 0) then
          write(lo,*) ' Numero totale di cicli EDM =',
     *                amedia_n_EDM
          write(lo,4533) naatoms_max, numero_cicli_max,
     *                numbrun_max
          write(lo,*) 'Tempo x edm, n. di cicli edm)',
     *                time_tot_edm, num_tot_edm
          write(lo,*) 'Tempo x raffinamenti, n. di raff.',
     *                time_tot_raffi, num_tot_raffi
          write(lo,'(a,f7.3,a,i4,a,i4)') ' Rfactor minimo = ',
     *      rfac_edm_min, ' in  ciclo=',num_rfac_edm_min, '/',
     *      num_model_edm_min 
      endif

 1234 continue

      line = ' '
      nz(:) = nzsav(:)
      kWstop = 0
      ifExamin = ifExaminSav
      call DeAllocaVLD
      return

 4533 format(//,' Maximum of matches founds:  ',i5,
     *    ' in cycle N.:  ',i5,'    of Trial N.:',i3) 
      end
!-----------------------------------------------------------------------
      subroutine AllocaVLD
      USE General
      USE Mappa
      USE VLDmod_1
      USE VLDmod_2
      USE MappaPatterson , only: xmapSav
           
      if (.NOT. ALLOCATED(Ep))
     *     ALLOCATE (Ep(1:nrefl), stat = ier1)
      if (.NOT. ALLOCATED(Eq))
     *     ALLOCATE (Eq(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(Epp))
     *     ALLOCATE (Epp(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(Eqp))
     *     ALLOCATE (Eqp(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(Eqp_ist))
     *     ALLOCATE (Eqp_ist(1:nrefl), stat = ier2)

      if (.NOT. ALLOCATED(Eq_s))
     *     ALLOCATE (Eq_s(1:nrefl), stat = ier2)

      if (.NOT. ALLOCATED(es))
     *     ALLOCATE (es(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(EqVero))
     *     ALLOCATE (EqVero(1:nrefl), stat = ier2)     
      if (.NOT. ALLOCATED(ArgGq))
     *     ALLOCATE (ArgGq(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(sgq))
     *     ALLOCATE (sgq(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(wq))
     *     ALLOCATE (wq(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(wq1_1))
     *     ALLOCATE (wq1_1(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(wq1_2))
     *     ALLOCATE (wq1_2(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(wq1_3))
     *     ALLOCATE (wq1_3(1:nrefl), stat = ier2)

      if (.NOT. ALLOCATED(wq1_a))
     *     ALLOCATE (wq1_a(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(wq1_b))
     *     ALLOCATE (wq1_b(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(wq1_c))
     *     ALLOCATE (wq1_c(1:nrefl), stat = ier2)

      if (.NOT. ALLOCATED(wq2))
     *     ALLOCATE (wq2(1:nrefl), stat = ier2)

      if (.NOT. ALLOCATED(wq2_a))
     *     ALLOCATE (wq2_a(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(wq2_b))
     *     ALLOCATE (wq2_b(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(wq2_c))
     *     ALLOCATE (wq2_c(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(wq2_d))
     *     ALLOCATE (wq2_d(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(wq2_e))
     *     ALLOCATE (wq2_e(1:nrefl), stat = ier2)

      if (.NOT. ALLOCATED(wq3))
     *     ALLOCATE (wq3(1:nrefl), stat = ier2)
      if (.NOT. ALLOCATED(wq4))
     *     ALLOCATE (wq4(1:nrefl), stat = ier2)

      if (.NOT. ALLOCATED(PHIp))
     *     ALLOCATE (PHIp(1:nrefl), stat = ier3)
      if (.NOT. ALLOCATED(PHIq))
     *     ALLOCATE (PHIq(1:nrefl), stat = ier4)

      if (.NOT. ALLOCATED(PHIq_s))
     *     ALLOCATE (PHIq_s(1:nrefl), stat = ier4)

      if (.NOT. ALLOCATED(PHIqp))
     *     ALLOCATE (PHIqp(1:nrefl), stat = ier4)
      if (.NOT. ALLOCATED(PHIqVero))
     *     ALLOCATE (PHIqVero(1:nrefl), stat = ier4)     
      if (.NOT. ALLOCATED(WT_save))
     *     ALLOCATE (WT_save(1:nrefl), stat = ier5)
      if (.NOT. ALLOCATED(WT_save_m))
     *     ALLOCATE (WT_save_m(1:nrefl), stat = ier5)
      if (.NOT. ALLOCATED(EossEcal))
     *     ALLOCATE (EossEcal(1:nrefl), stat = ier10)
      if (.NOT. ALLOCATED(dijs))
     *     ALLOCATE (dijs(1:nrefl), stat = ier10)
      if (.NOT. ALLOCATED(PHIp_diff))
     *     ALLOCATE (PHIp_diff(1:nrefl), stat = ier3)
      if (.NOT. ALLOCATED(SigmaN))
     *     ALLOCATE (SigmaN(1:nrefl), stat = ier3)
      if (.NOT. ALLOCATED(ichange_sym))
     *     ALLOCATE (ichange_sym(1:nrefl), stat = ier3)
           if (.NOT. ALLOCATED(jorde))
     *     ALLOCATE (jorde(1:nrefl), stat = ier3)
      if (.NOT. ALLOCATED(caso))
     *     ALLOCATE (caso(1:nrefl), stat = ier3)
      if (.NOT. ALLOCATED(caso_ac))
     *     ALLOCATE (caso_ac(1:nrefl), stat = ier3)
      if (.NOT. ALLOCATED(xmapSav))
     *     ALLOCATE (xmapSav(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat=ier3)
      if (.NOT. ALLOCATED(work22))
     *     ALLOCATE (work22(1:nrefl), stat = ier9)
      if (.NOT. ALLOCATED(work1_res))
     *     ALLOCATE (work1_res(1:nrefl), stat = ier9)
      if (.NOT. ALLOCATED(WT_save_res))
     *     ALLOCATE (WT_save_res(1:nrefl), stat = ier9)
      if (.NOT. ALLOCATED(iphaz_res))
     *     ALLOCATE (iphaz_res(1:nrefl), stat = ier9)
      if (.NOT. ALLOCATED(WT_work3))
     *     ALLOCATE (WT_work3(1:nrefl), stat = ier8)
      if (.NOT. ALLOCATED(WT_work4))
     *     ALLOCATE (WT_work4(1:nrefl), stat = ier9)
      if (.NOT. ALLOCATED(WT_work5))
     *     ALLOCATE (WT_work5(1:nrefl), stat = ier9)
      if (.NOT. ALLOCATED(xmapSav_VLD))
     *     ALLOCATE (xmapSav_VLD(0:np(1)-1,0:np(2)-1,0:np(3)-1),
     *                      stat = ierr)

      return
      end      
c ------------------------------------------------------------------
      subroutine DeAllocaVLD
      USE VLDmod_1
      USE VLDmod_2
      USE MappaPatterson , only: xmapSav
!
      implicit none
      integer :: ier
!
      if (ALLOCATED(SigmaN)) then
          deallocate (SigmaN, es,
     *    Ep,       Eq,          Eqp,  Eqp_ist, Epp,
     *    EqVero,   ArgGq,       sgq,  wq,      WT_save,
     *    EossEcal, xmapSav_VLD, work22,
     *    WT_work3, WT_work4,    WT_work5,
     *    PHIp,     PHIp_diff,   PHIq, PHIq_s,  PHIqp,
     *    PHIqVero, ichange_sym, caso, stat = ier)
      endif
      if (ALLOCATED(xmapSav)) then
          deallocate (xmapSav, stat =ier)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Calcola_SigmaN_es
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE VLDmod_1

      
      do i=1,nrefl
         rho = rhov(i)
         eps = epsv(i)
         sumfff = 0.0
         do ij=1,nk
            ff(ij) = ScattFact(ij, rho)
            sumfff=sumfff+nw(ij)*(ff(ij)**2)
         enddo
         coef = 1.0
         sig = sqrt( exp(-2.0*bt*rho) * sumfff )
         den = coef  * eps      * sig
         SigmaN(i) = den * sqrt(pts)

         if (ksigma_pg > 0) then
             es(i) = 1 + (sigmav(i))**2 / SigmaN(i)**2
             if (es(i) < 1.05) es(i) = 1.05       !!! 26/08 ore 13:00
         else
             if (ifMDM == 0) then
                es(i) = 1.05
             else
                es(i) = 1.00
             end if
         end if
      end do
      return
      end
!-----------------------------------------------------------------------
      subroutine EDM_Cycles_VLD(percp, ifImprove, ifDopoRelax)

      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Atomi
      USE Mappa
      USE ShellSIGMAA
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3

      integer :: jpercBarraSav, npercBarraSav
      real    :: SigmaA_media_EDM (30),Residuo_EDM(30)
      
      real    :: Eo2Ec2Med(50)
      real    :: Eo2Ec2Med_old(50)
      
      if (ifImprove == 1) then
          jpercBarraSav = jpercBarra
          npercBarraSav = npercBarra
          call scrper('Improving phases ',0,0)
          npercBarra  = n_EDM
          iperc0      = n_EDM / npercBarra
          iperc       = iperc0
          jpercBarra  = 0
      endif

      call CPU_TIME(t0_edm)
      
      ier = 0
      numero_edm = 1
      
      if (ifMDM == 0) then 
         numero_edm_finale = 26
      else
!formula20
          if (ifForm20 /= 1) then
             numero_edm_finale = 30
          end if
!         numero_edm_finale = 6
      end if
!
      if (ifPatt /= 0) then 
         numero_edm_finale = 3
      endif
!
      faiEDM : do while (numero_edm <= n_EDM)
      
         if (kverbo_pg > 0) then
!             write(lo,'(a,f10.5)') ' Percentuale di inversione =',percp
         endif
        
         if (ifImprove == 1) then
             if (numero_edm == iperc) then
                jpercBarra = jpercBarra + 1
                iperc = iperc + iperc0
                call scrper(' ',jpercBarra,npercBarra)
             endif
         endif

         amedia_n_EDM = amedia_n_EDM + 1
                 
         npunti=np(1)*np(2)*np(3)

         percn=0.00

         npts1=npunti*percp ! punti positivi
         npts2 = 0
             
         call denhist(0,xmap,xenve,npts1,npts2)
c
c--inverto la mappa
c
         knw_save = knw
         knw = 0
         if (npts2 == 0) then
            call ChangeAndInvMap_VLD(xmap,xenve,1,0.0,1,1,ier)
         end if 
         knw = knw_save 
         
         work1(1:nrefl) = fcvet(1:nrefl)
         nwizm1=25
         nsip1=150
         
! controllo su ipercentrosimmetricità  
         
         if (ifForm20 == 1) then
            if (ksize_vero < 3 .and. ifHypercentr == 0) then
               call HistogramMatch(work1,work1,nrefl,nsip1,nwizm1,4) 
            else
                call HistogramMatch(work1,evet,nrefl,nsip1,nwizm1,1) 
            endif
         else
            if (ksize_vero < 3) then
               call HistogramMatch(work1,work1,nrefl,nsip1,nwizm1,4) 
            else
                call HistogramMatch(work1,evet,nrefl,nsip1,nwizm1,1) 
            endif
         end if

         fcvet(1:nrefl) = work1(1:nrefl)

                    
!!!!  calcolo Fcalc a partire da Ecalc proveniente da inversione mappa
         do i=1,nrefl
            work1(i) = work1(i) * SigmaN(i)
         end do

!  salvataggio in work22 di Fc per il calcolo del residuo su pochi riflessi        
         work22(1:nrefl) = work1(1:nrefl)           

!    calcolo Residuo tra fo e fc che vengono dall'inversione della mappa
 
         sumfo = sum(fovet(1:nrefl))
         sumfc = sum(work1(1:nrefl))
         scala = sumfo / sumfc
         anum = sum(abs(fovet(1:nrefl)-scala*work1(1:nrefl)))
         aden = sum(fovet(1:nrefl))
         rfac_edm = 100.*anum/aden

         Residuo_EDM(numero_EDM) = rfac_edm
         
         if (rfac_edm < rfac_edm_min) then
             rfac_edm_min = rfac_edm
             num_rfac_edm_min = numero_cicli
             num_model_edm_min = numbrun
         end if 
          
         if (ifMDM == 1) then
            if (numero_edm ==1 ) then
               if (rfac_edm > rfac_init_edm) then            
                 rfac_init_edm = rfac_edm                   
               end if                                        
            end if
         else
            if (mod(numero_cicli,n_cb) == 2 .and. numero_edm ==1 ) then
               rfac_init_edm = rfac_edm
            end if
         end if
         
!=============================================================================         
!        riscalamento sigmaA in EDM come da trattamento sigmaa.doc del 1/2/2010

         Ratt = ( rfac_init_edm - rfac_edm ) / ( rfac_init_edm - 30.)
         if (Ratt < 0.1) Ratt = 0.1
         
         if (neutro == 0) then
!  calcolo teorico della sigmaA e del peso m
             call Calcola_SigmaA(Ratt)
                     
             sigmaA_1 = (amed_Dl - sigmaA_init) / (1.0 - sigmaA_init)
             if (sigmaA_1 < 0.1) sigmaA_1 = 0.1
         
             amedia_teorica = sigmaA_1 * (Ratt ** 0.3)
!
!     controllo punto n.5 da Martina12.doc
! 
             if (numero_edm == n_EDM) then
                amedia_teorica_10EDM = amedia_teorica
                rfac_10EDM = rfac_edm
             end if

             fattore = amedia_teorica / amed_Dl_orig
         
             if (fattore > 1.0) then
                fattore = 1.0
             end if
         
             do i=1, nrefl
                Dluz(i) = Dluz(i)* fattore
                if (Dluz(i)>0.97) Dluz(i)=0.97
                if (Dluz(i)<0.2) Dluz(i)=0.2
             end do
        
             amed_Dl= sum(Dluz(1:nrefl))/nrefl
             SigmaA_media_EDM(numero_edm)= amed_Dl
             if (knw /= 0 .and. kverbo_pg == 1) then
                 write(lo,'(a,a,3e25.15)')
     *            ' <sigmaATeorica>, <SigmaAorig>,',
     *            '<SigmaArisc>', amedia_teorica, amed_Dl_orig, amed_Dl
             end if
         
             do i=1,nrefl
                X = (2. * Dluz(i) * evet(i)*fcvet(i))/(es(i)-Dluz(i)**2)
                pesMod(i) = bes(X)
             end do
         
             ammin = minval(pesMod(1:nrefl))
             ammax = maxval(pesMod(1:nrefl))
             amed_m = sum(pesMod(1:nrefl))/nrefl
             ammin1 = minval(Dluz(1:nrefl))
             ammax1 = maxval(Dluz(1:nrefl))
             amed_Dl= sum(Dluz(1:nrefl))/nrefl
             amed_evet = sum(evet(1:nrefl))/nrefl
             amed_fcvet = sum(fcvet(1:nrefl))/nrefl
         
             if (knw /= 0 .and. kverbo_pg == 1) then
                write(lo,'(i5,a,3e25.15)') numero_edm,
     *             ' EDM: min, max, med(m) = ',ammin,ammax,amed_m
                write(lo,'(i5,a,5e25.15,i7)') numero_edm,
     *          ' EDM : min, max, med(sigmaa) ,resid= ',
     *           ammin1,ammax1,amed_Dl,rfac_edm
                
             write(lo,'( a,e25.15,a,e25.15)')' Media Eobs= ',amed_evet,
     *                   ' Media Ecal= ',amed_fcvet
             end if 
          
!  fine calcolo teorico della sigmaA e del peso m
         else
             do i=1,nrefl
                X = 2.0 * evet(i) * fcvet(i) ! wt Sim like per elettroni
                pesMod(i) = bes(X)
             end do
         endif
                    
         wt(1:nrefl) = pesmod(1:nrefl)
         
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!         work1(1:nrefl) = wt(1:nrefl)
!         ncond = nrefl
!         call sortall(-1,work1,ncond)
!         ncond = nstr + numero_edm * nstr
!         ncond = min(ncond,4*nstr)
!         sog_wwtt=work1(ncond)

           
!=======================================================================

! elimina i riflessi piu' bassi .... se richiesto!!!!!           
C -- Istruzioni originali PG -- elimino riflessi con peso < 0.2
         if (sog_ref < 100. .and. numero_edm  < n_EDM_save) then
            nin = (sog_ref * nrefl) /100.
            do i=nin+1, nrefl
                wt(i) = 0.0
            end do
         end if 
           
         if (ksize_vero >= 4) then
             sog_wt = 0.00
         else
             sog_wt = 0.20
         endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
!        sog_wt = max(sog_wt,sog_wwtt)
       
 !        if (numero_edm == 5)then
 !        do i =1,nrefl
 !            if (wt(i) < sog_wt) then
 !                write(lo,'(i5,5f12.5)') i, evet(i), fcvet(i),
 !    *                     es(i),dluz(i),wt(i)
 !            end if
 !        end do
 !        end if

         do i=1, nrefl
            if (wt(i) < sog_wt) then
               wt(i) = 0.0
            end if
         end do

!===================================================================================           
         fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
         
         jpatt = 0 
         call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                FORTH, BACK)

         if (kverbo_pg > 0) then
             call Stampe_MPE_RES(sog_wt)
         endif
         
         if(numero_edm == numero_edm_finale) then
            exit faiEDM
         end if
         
         if (ifMDM == 1) then
!!!!!   incremento numero cicli edm su controllo fFOM
         
            if (ifDopoRelax == 1 .and. numero_edm == n_EDM) then
               amo = 1.3  
               if (n_EDM > 10) then
                  amo = 1.12
               end if
               FinalFom_save = FinalFom
               call CalcFFomVLD(2, corre_VLD)
               if (FinalFom / FinalFom_save < amo) then
                  if (knw == 1 .and. kverbo_pg == 1) then
                      write(lo,'(a,4f12.5)')
     *              ' FinalFom, Corre, stopFinalFom2, FinalFom2==',
     *                FinalFom,corre_VLD,stopFinalFom2,FinalFom2
                  endif 
                  exit faiEDM
               end if
            end if
         end if
           
                
         if (numero_edm == n_EDM) then
            if (SigmaA_media_EDM (n_EDM) > SigmaA_media_EDM (n_EDM-1)
     *         .and. Residuo_EDM(n_EDM) < Residuo_EDM(n_EDM-1))then
               if (abs(SigmaA_media_EDM (n_EDM)- 
     *            SigmaA_media_EDM (n_EDM-1))+ abs(Residuo_EDM(n_EDM) 
     *            - Residuo_EDM(n_EDM-1))>0.1)then
                     n_EDM = n_EDM + 4
                     numero_edm = numero_edm + 1
               else
                  if (ifMDM == 1) then
!!!!!   incremento numeo cicli edm su controllo fFOM
                     if (FinalFom2 > 2.0 .and. ksize_vero > 3) then
                        n_EDM = n_EDM + 4
                        numero_edm = numero_edm + 1
                     else
                        exit faiEDM
                     end if
                  else
                     exit faiEDM
                  end if
               end if      
            else
!!!!!   incremento numeo cicli edm su controllo fFOM
               if (ifMDM == 1) then
                  if (FinalFom2 > 2.0 .and. ksize_vero > 3) then
                     n_EDM = n_EDM + 4
                     numero_edm = numero_edm + 1
                  else
                     exit faiEDM
                  end if
               else
                  exit faiEDM
               end if
            end if
         else
            numero_edm = numero_edm + 1
         end if
      end do faiEDM
      
      ifTimeSav = ifTime
      if(ifTime == 1) then
          ifTime = 0
      end if
      if (ifExamin == 1) then
c         if (kverbo_pg > 0) then
              izero = 0
              ifmin = 1
              nbru = 4422
             call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
c         endif
      end if
      ifTime = ifTimeSav
       
      Rat_VLD = Ratt

      call CPU_TIME(t1_edm)
      time_tot_edm = time_tot_edm + (t1_edm - t0_edm)
      num_tot_edm = num_tot_edm + numero_edm

      if (ifImprove == 1) then
          jpercBarra = jpercBarraSav
          npercBarra = npercBarraSav
          if (ifMDM == 0) then
              call scrper('Running VLD procedure ',0,0)
          else
              call scrper('Running MDM procedure ',0,0)
          endif
          call scrper(' ',jpercBarra,npercBarra)
      endif
!
      return
      end
c ------------------------------------------------------------------
      subroutine Prova_a_Raffinare(corre_VLD)
      
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE MappaPatterson , only: xmapSav
      USE TestModel
      USE Html
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      USE Tutto
      USE Molcom, only : color_LIGHTRED, color_GREEN, jscreen
      
      character *80 line      
      integer :: AggiornaFasi
      
      if (kWstop == 1 .and. ifTiDeviFermare == 0) then
          write(lo,'(a,2i5)') ' kWstop, ifTidevifermare=',
     *      kWstop, ifTidevifermare
          stop 3355
      end if
!pg201213      
!      if (knw > 0) then
!          write(6,*) 'AFFINA ciclo ', numero_cicli
!      endif

      AggiornaFasi = 0
       
      xmapSav_VLD(:,:,:) = xmap(:,:,:)
      WT_work4(1:nrefl) = fcvet(1:nrefl)      
      WT_work3(1:nrefl) = wt(1:nrefl)
      WT_work5(1:nrefl) = iphaz(1:nrefl)
      
      ier = 0
      ifBreak = 0
      kverbo_pg_sav = kverbo_pg
      ifExaminSav = ifExamin
      if (kWstop == 0) then
         call CPU_TIME(t0_raffi)

         if (sigmaA_1 > perc_cammino_control) then
             perc_cammino_Rat = sigmaA_1
         end if
         krecySave = krecy
         ifExamin = 1
         
         if (kverbo_pg /= 0 .and. ifRelax == 1) then
!pg201213             
          write(lo,'(/,a,i6,f8.4,/)')' Start of RELAX procedure',numbrun
            if (ifMDM == 0) then
!pg201213                
!               write(lo,'(a,i5,a,i4,2(a,f8.3),/)')
!     *           ' Trial =',numbrun,
!     *           '  Cycle=', numero_cicli, ' FOM =',Rat_VLD,
!     *           '  FOM MAX =', perc_cammino_control
               if (ksize <= 3) then
                  if (knw == 1) then
                      write(lo,66) numero_cicli, numbrun,
     *                        Rat_VLD, perc_cammino_control
                  else
                      write(lo,67) numero_cicli, numbrun, Rat_VLD
                  endif

               endif
            else
               write(lo,'(a,i5,a,f8.3,/)')
     *           ' Trial =',numbrun,' FOM =',Rat_VLD
            end if
         end if
 
         nrfac = numbrun
         ifRelaxTrial = 0
         
         if (ifMDM == 1) then
            kSavMDM = ksize
            ksize = ksize_vero
         end if

         call RAFFI_VLD(ifGoOn, ifBreak)
         
         if (ifMDM == 1) then
            ksize = kSavMDM
            if (kwstop == 0) then
               sommfF = sommfF + FinalFom
               sommfF2 = sommfF2 + FinalFom ** 2
               nRelax = nRelax + 1
               fFom_med = sommfF / nRelax
               dev_st = 0.0
               if (nRelax > 2) then
                  dev_st = sqrt((nRelax*sommfF2-sommfF**2)/
     *                    (nRelax*nRelax))
!pg27012014
               if (knw /= 0) then
                   write(lo,'(/,a,4f7.4,/)') 
     *                   'finalFom, fFom_med + 2*dev_st:',
     *                    finalFom, fFom_med+2*dev_st,fFom_med,dev_st
               end if
                  if (finalFom < p_fFom) then
                     kwstop = 0
                     
                     
             xmap(:,:,:) = xmapSav_VLD(:,:,:)
             fcvet(1:nrefl) = WT_work4(1:nrefl)
             wt(1:nrefl)= WT_work3(1:nrefl)
             iphaz(1:nrefl) = WT_work5(1:nrefl)

                     return
                  end if
                  p_fFom = fFom_med + 2*dev_st
               end if
            end if
         end if
         if (FinalFom > stopFinalFom) then
             if (ksize > 3) then
!
                 write(Msg,55)
                 call ScriviCicloVLD(numero_cicli, numbrun, 
     *                FinalFom2, Rat_VLD, perc_cammino_control)
!pg27012014                 
!                 write(lo,"(12x,a)") Msg(1:Lung(Msg))
                 if (kwstop == 1) then
                    write(lo,'(11x,a)')' Final FOM provided by RELAX ind
     *icates a candidate solution'
                 else
                     write(lo,'(11x,a)')' RELAX procedure fault'
                 end if
             endif
             if (ksize > 3 .and. jscreen > 0) then
                 call OneBlankOnly(Msg)
                 call TestoGR(Msg, color_LIGHTRED, 2, 3)
             endif
!pg27012014
         else
             if (ksize > 3) then
                 write(lo,'(11x,a)') ' No candidate solution'
             end if
         endif
         
         if (ifBreak == 1) then
             kWstop = 1
         endif
         
         if (naatoms > naatoms_max) then 
            naatoms_max = naatoms
            numero_cicli_max = numero_cicli
            numbrun_max = numbrun           
         end if
         
         krecy = krecySave
         ifExamin = 1            !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

         if (kWstop == 0) then
             xmap(:,:,:) = xmapSav_VLD(:,:,:)
             fcvet(1:nrefl) = WT_work4(1:nrefl)
             wt(1:nrefl)= WT_work3(1:nrefl)
             iphaz(1:nrefl) = WT_work5(1:nrefl)
         endif
! Calcola il tempo totale x raffinamento e num. tot. di raff.            
         call CPU_TIME(t1_raffi)
         time_tot_raffi = time_tot_raffi + (t1_raffi - t0_raffi)
         num_tot_raffi = num_tot_raffi + 1
      endif

      ifTime_sav = ifTime

      if (kWstop == 0) then
          return
      end if
      
      if (ksize > 3) then
         if (ifTiDeviFermare == 0) then

            fcoef (1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
            jpatt = 0
            call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                   FORTH, BACK)
     
!    Blocco ulteriore di cicli  EDM per medie-grandi trovata la possibile soluzione

!pg201213
!            n_EDM_sav = n_EDM
!            n_EDM =18
            call MiglioraFasi_2(AggiornaFasi, kverbo_pg_sav,ifExaminSav,
     *                          ifTime_sav, corre_VLD) 
!            n_EDM = n_EDM_sav
            fomNoWind = FinalFom2
            if (kWstop == 0) then
               return
            end if

         end if
      end if
      if (ksize_vero == 3) then
         ncicla = 1
         kWstop = 0
         ifRelaxSav = ifRelax
         ifRelax = 0
         nolsq = -1
         ifBreak = 0

         call ClessidraOnOff(1)
         Msg = 'Starting automatic Diagonal Least Squares ...'
         call TestoGR(Msg, color_GREEN, 2, 3)
         write(lo,'(12x,a)') Msg(1:Lung(Msg))
         call scrper(Msg, 0, 0)
         kSavMDM = ksize
         ksize = ksize_vero
         call dlsq(ier, ncicla, erreNoWind, fomNoWind,
     *             0, ifBreak)
         if (ifMDM == 1) then
            nSeedDLSQ = numbrun
         end if
         AggiornaFasi = 1
         ksize = kSavMDM

         write(Msg,100) erre*100
         call OneBlankOnly(Msg)
         call TestoGR(Msg, color_GREEN, 2, 3)
         call ClessidraOnOff(2)
         
         if (erre > RSoglia/100.0) then
            xmap(:,:,:) = xmapSav_VLD(:,:,:)
            fcvet(1:nrefl) = WT_work4(1:nrefl)
            wt(1:nrefl)= WT_work3(1:nrefl)
            iphaz(1:nrefl) = WT_work5(1:nrefl)
            kWstop = 0
            kverbo_pg = kverbo_pg_sav
            ifExamin = ifExaminSav
            ifTime = ifTime_sav
            ifTiDeviFermare = 0
            ifRelax = ifRelaxSav
            ksize = 4
            nolsq = 0
            return
         end if
         
         kWstop = 1
         call SalvaFasi(1, FinalFom2, corre_VLD, AggiornaFasi)
      end if
           
      ifExamin = 1
      ifTime = 0
      izero = 0
      ifmin = 1
      nbru = 8888
      call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,
     *            ifmin)
*     call examin(nbru,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,
*    *            ifmin)
*     izero = numbLSQ
*     call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,
*    *            ifmin)

      nTrialsVLD = numbrun
!
      call SolutionFound(1, ifBreak)
!
      if (nolsq == 0) then
         call Cancella(15)
      endif
!
      call SalvaFasi(1, FinalFom2, corre_VLD, 1)
      call EndTrialVLD
!
      return
!pg201213
   55 format('Final FOM indicates a candidate solution.')
   66 format(/,' Cycle ',i4,' Trial ',i4,
     *       '  SaFOM',f7.3,'  Threshold',f7.3)
   67 format(/,' Cycle ',i4,' Trial ',i4,'  SaFOM',f7.3)
   68 format(/,' Cycle ',i4,' Trial ',i4,'  fFOM',f7.3,
!    *       '  SaFOM',f13.10,'  Threshold',f13.10)
     *       '  SaFOM',f7.3,'  Threshold',f7.3)
  100 format('Final R value is ',f8.2,'%')
      end
!-----------------------------------------------------------------------
      subroutine Prova_DLSQ(naatoms_max, corre_VLD)
      
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE MappaPatterson , only: xmapSav
      USE TestModel
      USE Html
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      USE Molcom, only : color_LIGHTRED, color_GREEN, jscreen
      
      character *80 line      
      
!pg05052014
      integer :: AggiornaFasi
      real :: corre_VLD

      xmapSav_VLD(:,:,:) = xmap(:,:,:)
      WT_work4(1:nrefl) = fcvet(1:nrefl)      
      WT_work3(1:nrefl) = wt(1:nrefl)
      WT_work5(1:nrefl) = iphaz(1:nrefl)
      
      fomNoWind = 0.0
      ier = 0
      ifBreak = 0
      kverbo_pg_sav = kverbo_pg
      ifExaminSav = ifExamin

      ifTime_sav = ifTime
      ncicla = 1
      ifRelaxSav = ifRelax
      ifRelax = 0
      kWstop = 0
      if (ksize_vero == 3) then
        ksize = 3
      end if
      nolsq = -1
      ifBreak = 0

      call ClessidraOnOff(1)
      Msg = 'Starting automatic Diagonal Least Squares ...'
      call TestoGR(Msg, color_GREEN, 2, 3)
      write(lo,'(12x,a)') Msg(1:Lung(Msg))
      call scrper(Msg, 0, 0)
      call dlsq(ier,ncicla,erreNoWind, fomNoWind, 0,ifBreak)
      

      if (ifMDM == 1) then       
         nSeedDLSQ = numbrun
      end if
      
      if (ksize_vero == 3) then
          ksize = 4
      end if

!differenza  importante????    
!!!!!!!!!!!      ksize = 4

      write(Msg,100) erre*100
      call OneBlankOnly(Msg)
      call TestoGR(Msg, color_GREEN, 2, 3)
      call ClessidraOnOff(2)
      
      if (erre > RSoglia/100.0) then
         xmap(:,:,:) = xmapSav_VLD(:,:,:)
         fcvet(1:nrefl) = WT_work4(1:nrefl)
         wt(1:nrefl)= WT_work3(1:nrefl)
         iphaz(1:nrefl) = WT_work5(1:nrefl)
         kWstop = 0
         kverbo_pg = kverbo_pg_sav
         ifExamin = ifExaminSav
         ifTime = ifTime_sav
         ifTiDeviFermare = 0
         ifRelax = ifRelaxSav
         if (ksize_vero == 3) then
            ksize = 4
         end if
!         nolsq = 0
         if (ksize_vero <= 2) then
             nolsq = -1
         else
             nolsq = 0
         end if
         return
      end if
      
!pg05052014      
      AggiornaFasi = 1
      call SalvaFasi(1, FinalFom2, corre_VLD, AggiornaFasi)

      ifRelax = ifRelaxSav
      kWstop = 1
      ifExamin = 1
C     ifTime = 0
      izero = 0
      ifmin = 1
      nbru = 8888
      call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
      nTrialsVLD = numbrun
!
      if (ksize_vero <= 3) then
          call SolutionFound(1, ifBreak)
      endif
!
      if (nolsq == 0) then
         call Cancella(15)
      endif
!
      call EndTrialVLD
!

      return
  100 format('Final R value is ',f8.2,'%')
      end
!-----------------------------------------------------------------------
      subroutine Calcola_EqVero
      USE General
      USE Riflessi
      USE PhaseModule
      USE VLDmod
      USE VLDmod_2
      
!pg201213
      return

      if (ifTime == 1 .or. ifExamin == 0) return      
      
      if (ifExamin == 1) then
         amed_Ep = sum(Ep(1:nrefl)**2)/nrefl
         if (kverbo_pg > 0) write(lo,440) amed_Ep
  440    format(//,' <Ep**2> =',f10.3)
         amed_Epp = sum(Epp(1:nrefl)**2)/nrefl
         if (kverbo_pg > 0) write(lo,441) amed_Epp
  441    format(//,' <Epp**2> =',f10.3)
      
         izero = 0
         ifmin = 1
         nbru = 4444
         if (kverbo_pg > 0) then
             write(lo,'(a)') ' errore di PHIp rispetto a iPUB'
             call examin(nbru,mkang,khl,ipub,PHIp,nrefl,izero,wt,ifmin)
         endif
      end if
! calcolo della mappa RHOq_ideale come:
!          EqVero*exp(i PHIqVero) = Eoss*exp(i ipub) - Ep*exp(i PHIp) 

      do i = 1, nrefl
         jh = khl(1,i)
         jk = khl(2,i)
         jl = khl(3,i)
         shiftp = jh*shiftexam(1)+jk*shiftexam(2)+jl*shiftexam(3)
         shiftp = 360.* shiftp + ipub(i)
         if (shiftexam(4) < 0) then
             shiftp = -shiftp
         end if
         shiftp = amod(shiftp+36000.,360.)
         ishiftp = shiftp
         if (ishiftp == 0) ishiftp = 360
         if (ifIbrida == 0) then
            A = evet(i)*sin(dtor*ishiftp)- Epp(i)*sin(dtor*PHIp(i))
            B = evet(i)*cos(dtor*ishiftp)- Epp(i)*cos(dtor*PHIp(i))
            EqVero(i) = sqrt(A*A + B*B)
         else
         A =Tau*evet(i)*sin(dtor*ishiftp)-Omega*Epp(i)*sin(dtor*PHIp(i))
         B =Tau*evet(i)*cos(dtor*ishiftp)-Omega*Epp(i)*cos(dtor*PHIp(i))
            wwq = Tau**2 + Omega**2 - 2.*(Tau*Omega*Dluz(i))         
            EqVero(i) = sqrt((A*A + B*B) / wwq)
         end if
         PHIqVero(i) = mod(nint(atan2(A, B)*rtod + 3600),360)
         
!         goto 11234

         if(mkang(i).ne.1) then
            iphi=PHIqVero(i)
            idv = 15*mod(mkang(i)-1,12)
            id1 = iabs(idv-iphi)
            id2 = iabs(idv+180-iphi)
            id1=min0(id1,360-id1)
            id2=min0(id2,360-id2)
            if(id1.lt.id2) then
               iphi=idv
            else
               iphi=idv+180
            endif
            iphi=mod(iphi,360)
            if (iphi == 0) iphi = 360
            PHIqVero(i) = iphi
         end if
!11234    continue
      end do
      
      EqVero_medio = sum(EqVero(1:nrefl)**2)/float(nrefl)
      do i =1,nrefl
         eqqq = EqVero(i)
         EqVero(i) = sqrt(EqVero(i)**2 / EqVero_medio)
!      write(lo,'(4i5,2f7.3,i5)')i,khl(1:3,i),eqqq, EqVero(i),PHIqVero(i)
      end do
!      EqVero(1:nrefl) = sqrt(EqVero(1:nrefl)**2 / EqVero_medio)
      EqVero_medio = sum(EqVero(1:nrefl)**2)/float(nrefl)
      
      return
      end
c ------------------------------------------------------------------
      subroutine MDM_start
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE TestModel
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
     
      if (knw /= 0. and. kverbo == 1)  then
         write(lo,'(/,a)') 'INIZIO PROCEDURA MDM '
      end if
                  
!  inversione della mappa
      jpatt = 0   
      npunti=np(1)*np(2)*np(3)
      percp = 0.010
      percn=0.00
      npts1=npunti*percp ! punti positivi
      npts2 = 0
      call denhist(0,xmap,xenve,npts1,npts2)
c
c--inverto la mappa
c
      knw_save = knw
      knw = 0
      call ChangeAndInvMap_VLD(xmap,xenve,1,0.0,1,1,ier)     
      knw = knw_save
      
      work1(1:nrefl) = fcvet(1:nrefl)
      nwizm1=25
      nsip1=150 
      if (ksize_vero < 3) then
          call HistogramMatch(work1,work1,nrefl,nsip1,nwizm1,4) 
      else
          call HistogramMatch(work1,evet,nrefl,nsip1,nwizm1,1) 
      endif
      fcvet(1:nrefl)= work1(1:nrefl)
      
      do i=1,nrefl
         work1(i) = fcvet(i) *SigmaN(i)
      end do

! calcolo residuo tra fovet e fcvet per riscalamento  sigmaA

      sumfo = sum(fovet(1:nrefl))
      sumfc = sum(work1(1:nrefl))
      scala = sumfo / sumfc
      anum = sum(abs(fovet(1:nrefl)-scala*work1(1:nrefl)))
      aden = sum(fovet(1:nrefl))
      rfac = 100.*anum/aden
    
      sumfo = sum(fovet(1:nstr))
      sumfc = sum(work1(1:nstr))
      scala = sumfo / sumfc
      anum = sum(abs(fovet(1:nstr)-scala*work1(1:nstr)))
      aden = sum(fovet(1:nstr))
      rfac_nstr = 100.*anum/aden
      
      if (knw == 1) then
          write(lo,'(a,f12.6,a,f12.6)')' R%(nrefl) =',rfac,
     *                                 ' R%(nstr) =',rfac_nstr
      endif

      if (neutro == 0) then
          call Calcola_SigmaA(Rat_VLD)     
          SigmaA_init = amed_Dl
      else
          SigmaA_init = 0.0
      endif
     
      if (knw /= 0 .and. kverbo_pg == 1) then
       write(lo,'(a,e25.15)') ' <SigmaAorig>,', amed_Dl
      end if
      
      maxrun = 1
      call Tangent(iniztrial,ifintrial)
      
      return
      end
c ------------------------------------------------------------------
      subroutine MDM_SB_init(iyseed)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE TestModel
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      
      character*11 tirang
      character*10 reje
      character*20 cara
      character*80 line 
         
      if (knw /= 0. and. kverbo == 1)  then
         write(lo,'(/,a)') 'INIZIO PROCEDURA MDM_SB '
      end if
                  
!  inversione della mappa
      jpatt = 0   
      npunti=np(1)*np(2)*np(3)
      percp = 0.010
      percn=0.00
      npts1=npunti*percp ! punti positivi
      npts2 = 0
      call denhist(0,xmap,xenve,npts1,npts2)
c
c--inverto la mappa
c
      knw_save = knw
      knw = 0
      call ChangeAndInvMap_VLD(xmap,xenve,1,0.0,1,1,ier)     
      knw = knw_save
      
      work1(1:nrefl) = fcvet(1:nrefl)
      nwizm1=25
      nsip1=150 
      if (ksize_vero < 3) then
          call HistogramMatch(work1,work1,nrefl,nsip1,nwizm1,4) 
      else
          call HistogramMatch(work1,evet,nrefl,nsip1,nwizm1,1) 
      endif
      fcvet(1:nrefl)= work1(1:nrefl)
      
      do i=1,nrefl
         work1(i) = fcvet(i) *SigmaN(i)
      end do

! calcolo residuo tra fovet e fcvet per riscalamento  sigmaA

      sumfo = sum(fovet(1:nrefl))
      sumfc = sum(work1(1:nrefl))
      scala = sumfo / sumfc
      anum = sum(abs(fovet(1:nrefl)-scala*work1(1:nrefl)))
      aden = sum(fovet(1:nrefl))
      rfac = 100.*anum/aden
    
      sumfo = sum(fovet(1:nstr))
      sumfc = sum(work1(1:nstr))
      scala = sumfo / sumfc
      anum = sum(abs(fovet(1:nstr)-scala*work1(1:nstr)))
      aden = sum(fovet(1:nstr))
      rfac_nstr = 100.*anum/aden
      
      write(lo,'(a,f12.6,a,f12.6)')' R%(nrefl) =',rfac,
     *                             ' R%(nstr) =',rfac_nstr
      call Calcola_SigmaA(Rat_VLD)     
     
      SigmaA_init = amed_Dl
      if (knw /= 0 .and. kverbo_pg == 1) then
       write(lo,'(a,e25.15)') ' <SigmaAorig>,', amed_Dl
      end if
      
      call FindSeed_VLD(numbrun)
      iyseed = iyrand
      sigm = s3s2
      call RandomPhases_VLD
      wt(nstr+1:) = 0.0
      izero = 0
      ifmin = 1
      call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
      return
      end
c ------------------------------------------------------------------
      subroutine MDM_SB(iyseed,jjcris)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE TestModel
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      
      character*11 tirang
      character*10 reje
      character*20 cara
      character*80 line
      
      kverbo = 1
       
      wt(nstr+1:) = 0.0
      
      irefin(:) = 0.
      do i=1,nstr
                BackPh(i) = iphaz(i)*10000 + wt(i) * 1000
      end do
      if (jjcris == 1) then
         call weitan_MDM(numbrun, nstr)
      else
!         call weitan_MDM_SB(numbrun, nstr, jjcris)
         call weitan_trip_SB(numbrun, nstr, jjcris)
      end if

      nwtgt0 = 0
      do i=1,nstr
         if (wt(i).gt.0.00001) nwtgt0 = nwtgt0 + 1
      enddo

      if (nwtgt0.lt.5) then
          do i = 1,nstr
             wt1000 = mod(BackPh(i),10000.)
             BackPh(i) = BackPh(i) - wt1000
             iphaz(i) = nint(BackPh(i) / 10000)
             wt(i) = wt1000 / 1000
          enddo
      else
          if (ifRescale.eq.1) then
              do i = 1,nstr
                 if (wt(i).lt.0.000001) then
                     alphaVet(i) = 0.0
                 endif
              enddo
              nperc = nstr*0.1
              WtRef = 0.3
              call RiscalAlfa(nstr,nperc,WtRef)
          endif
      endif
      if (ifExamin.ne.0) then
          izero = 0
          ifmin = 0
          ifmin = 1
          nnrefl = nrefl
!p&c          
          ifTimeSav = ifTime
          if(ifTime == 1 .and. ifMDM == 1) then
              ifTime = 0
          end if
          call examin(numbrun,mkang,khl,ipub,iphaz,nnrefl,izero,
     *                         wt,ifmin)
          ifTime = ifTimeSav

              write (lo,31)  numbrun,erore, erorepes, isumal,iyseed
          er_tang   = erore
          erp_tang  = erorepes
          isum_tang = isumal
      endif
!psie      
!psie      call weitan_estendi(numbrun, nstr)
      
      call Calcola_FOM_Early(corre)
         nuset = numbrun
         call fomsp(nuset, reje)
         stampa( 7) = FOMs(1,1)
         stampa(11) = FOMs(1,2)
         stampa(12) = FOMs(1,3)
         stampa(13) = FOMs(1,4)
         stampa(14) = corre 
         if (knw.gt.0) then
             if (kverbo /= 0) then
                 write(lo,50) 
     *                (stampa(i),i=3,5),(stampa(i),i=8,10),
     *                (stampa(i),i=11,14),reje(1:Lung(reje))
             endif
         end if
 !-- eFOMs
         eFom = FOMs(1,4)
         call ManageEarlyFom(eFom, corre, er_tang)
         
         call salvafasi(1,eFom,corre,0)
      kverbo = 0
                                                  
      return
   31 format(/,' Trial #',i6,' - Mean Phase Error ',f6.2,
     *'  (',f6.2,')  over',i8,' reflections  SEED =',i12)      
   50 format(' FOMs',4f7.3,1x,2f6.2,4f7.3,2x,a)
      end
           
c ------------------------------------------------------------------
      subroutine DEDM_MDM(rfac, ifBreak)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE TestModel
      USE Molcom, only : jscreen, ifMadEnv
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      character*1 asterics
      
!piero
! iphaz_res contiene le fasi random iniziali

      iphaz_res(1:nrefl) = iphaz(1:nrefl)
          
      if (knw /= 0. and. kverbo == 1)  then
         write(lo,'(/,a)') 'INIZIO PROCEDURA DEDM '
      end if
                  
!  inversione della mappa e calcolo dei fattori normalizzati Ep, Epp e PHIp
      jpatt = 0   
      npunti=np(1)*np(2)*np(3)
      if (numero_cicli == 1) then
         percp = 0.010
      else
         percp = 0.025
      end if
      percn=0.00
      npts1=npunti*percp ! punti positivi
      npts2 = 0
      call denhist(0,xmap,xenve,npts1,npts2)
c
c--inverto la mappa
c
      knw_save = knw
      knw = 0
      call ChangeAndInvMap_VLD(xmap,xenve,1,0.0,1,1,ier)     
      knw = knw_save
      
      work1(1:nrefl) = fcvet(1:nrefl)
      nwizm1=25
      nsip1=150 
      if (ksize_vero < 3) then
          call HistogramMatch(work1,work1,nrefl,nsip1,nwizm1,4) 
      else
          call HistogramMatch(work1,evet,nrefl,nsip1,nwizm1,1) 
      endif
      fcvet(1:nrefl)= work1(1:nrefl)
                
      SigmaPN = 1.0    ! SigmaP/SigmaN
      do i=1,nrefl
! in Epp memorizzo fc/sqrt(SigmaN)
         Epp(i) = work1(i)
! in Ep memorizzo fc/sqrt(SigmaP)
         if (ifIbrida == 0) then      
           Ep(i) = work1(i) / SigmaPN
         else
           Ep(i) = work1(i)
         end if
         work1(i) = fcvet(i) *SigmaN(i)
      end do

! calcolo residuo tra fovet e fcvet per riscalamento  sigmaA

      sumfo = sum(fovet(1:nrefl))
      sumfc = sum(work1(1:nrefl))
      scala = sumfo / sumfc
      anum = sum(abs(fovet(1:nrefl)-scala*work1(1:nrefl)))
      aden = sum(fovet(1:nrefl))
      rfac = 100.*anum/aden
    
      work1(1:nstr) = Ep(1:nstr) * SigmaN(1:nstr)
      sumfo = sum(fovet(1:nstr))
      sumfc = sum(work1(1:nstr))
      scala = sumfo / sumfc
      anum = sum(abs(fovet(1:nstr)-scala*work1(1:nstr)))
      aden = sum(fovet(1:nstr))
      rfac_nstr = 100.*anum/aden
      
      write(lo,'(a,f12.6,a,f12.6)')' R%(nrefl) =',rfac,
     *                             ' R%(nstr) =',rfac_nstr
 
      iphaz(1:nrefl) = iphaz_res(1:nrefl)

      if (numero_cicli > 1  ) then
         rfac_init = rfac_init_edm
      end if
      
      call ri_Calcola_SigmaA
      
      if (ifMDM == 1) then
         maxrun = 1
         call tangent(iniztrial,ifintrial)
         return
      end if
       

      nume_inv = 0
      do i=1,nrefl
         X = (2. * Dluz(i) * evet(i) * Ep(i)) / (es(i) - Dluz(i)**2)
         pesMod(i) = bes(X)
! mR - Rp
         if (ifIbrida == 0) then
            fcoef(i) = pesMod(i)* evet(i) - Ep(i)
         else
            fcoef(i) = Tau * pesMod(i)* evet(i) - Omega * Ep(i)
         endif
         
         wt(i) = pesMod(i)
         
         ArgGq(i) = fcoef(i)
         
         PHIq(i) = PHIp(i)
         if (fcoef(i) < 0) then
            nume_inv = nume_inv + 1
            PHIq(i) = PHIp(i) + 180
            PHIq(i) = mod(PHIq(i),360)
            if (PHIq(i) == 0) PHIq(i) = 360
            fcoef(i) = -fcoef(i)
         end if
      end do
      pesMod_med = sum(pesMod(1:nrefl))/nrefl

!   Inserimento statistiche di PHIq   rispetto a PHIqvero prima della Fourier differenza   18/12/2009
      if (knw > 0 .and. ifExamin == 1 .and. ifTime == 0) then
          if (kverbo_pg > 0) then
              izero = 0
              ifmin = 1
              nbru = 4450
              write(lo,'(/,a)')
     *    ' M.P.E. PHIq rispetto a PHIqVero prima di fourier differenza'
              call examin(nbru,mkang,khl,PHIqVero,PHIq,nrefl,izero,wt,
     *                    ifmin)  
          endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!        
          
          rmag = 100.*count(ArgGq(1:nrefl) > 0.0) / nrefl 
          if (kverbo_pg > 0) then
              write(lo,'(/,a,f6.1,a,i7,/)') 'perc di ArgGq > 0.0 =',
     *                                   rmag,'   numinv =',nume_inv
          endif
      end if
!-----------
      amed_Dl= sum(Dluz(1:nrefl))/nrefl
      if(knw /= 0 .and. kverbo_pg == 1) then
         ammin = minval(pesMod(1:nrefl))
         ammax = maxval(pesMod(1:nrefl))  
         amed_m = sum(pesMod(1:nrefl))/nrefl
         ammin1 = minval(Dluz(1:nrefl))
         ammax1 = maxval(Dluz(1:nrefl))  
         write(lo,'(/,a,11x,3e25.15)')' DEDM: min, max, med(m) = ',
     *      ammin,ammax,amed_m
         write(lo,'(/,a,a,4e25.15,/)')' DEDM: min, max,med(sigmaa)',
     *      ',Resid = ', ammin1, ammax1, amed_Dl, rfac
      end if

      call DEDM_Recycle
      
      return
      end
c ------------------------------------------------------------------
      subroutine DEDM_Recycle
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Param
      USE PhaseModule
      USE Mappa
      USE ShellSIGMAA
      USE MappaPatterson , only: xmapSav
      USE Molcom, only : jscreen, QualeAbilita

      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3

      jpatt = 0
      PHIq_s(1:nrefl) = PHIq(1:nrefl)
      Wt_save(1:nrefl) = wt(1:nrefl)
      if (IfIbrida == 0) then
         nucy = 2
      else
         nucy = 1
      end if
      
      amin_xmap = 99999.
      amax_xmap = -99999.
      asomma_xmap = 0
         
      do kj = 1,nucy   
         call MakeMap(fcoef, PHIq_s, nrefl, jpatt, xmap, FORTH, BACK)

!  modifica della RHOq in RHOq' e sua inversione

         npunti=np(1)*np(2)*np(3)
         if (IfIbrida == 0) then
            percp = 0.04
            percn = 0.04
         else
!            percn = 0.06
            percp = 0.04
            percn = 0.06
         end if
         npts1=npunti*percp ! punti positivi
         npts2=npunti*percn ! punti negativi

         call denhist(0,xmap,xenve,npts1,npts2)
c
c--inverto la mappa
c
         knw_save = knw 
         knw = 0
         
         ifInv = 1
            
         call ChangeAndInvMap_VLD(xmap,xenve,7,0.0,1,ifInv,ier)
         knw = knw_save
     
         PHIqp(1:nrefl) = iphaz(1:nrefl)
         
!         goto 12345
         
         do i=1,nrefl 
            if(mkang(i).ne.1) then
               iphi=PHIqp(i)
               idv = 15*mod(mkang(i)-1,12)
               id1 = iabs(idv-iphi)
               id2 = iabs(idv+180-iphi)
               id1=min0(id1,360-id1)
               id2=min0(id2,360-id2)
               if(id1.lt.id2) then
                  iphi=idv
               else
                  iphi=idv+180
               endif
               iphi=mod(iphi,360)
               if (iphi == 0) iphi = 360
               PHIqp(i) = iphi
            end if
            if (PHIqp(i) == 0) PHIqp(i) = 360
         end do
!12345 continue         

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!             
!   Inserimento statistiche di PHIqp  rispetto a PHIqvero dopo inversione                18/12/2009
       if (nsym == 1 .and. icent == 0) then
       else
         if(knw > 0 .and. ifExamin == 1 .and. ifTime == 0) then
            if (kverbo_pg > 0) then
                izero = 0
                ifmin = 1
                nbru = 4450
!pg201213                write(lo,'(/,a)')
!    *          ' M.P.E. PHIqp rispetto a PHIqVero dopo inversione'
!               call examin(nbru,mkang,khl,PHIqVero,PHIqp,nrefl,izero,
!    *                      Wt_save, ifmin)
            endif
        end if       
       end if       
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!             
!
!-- Histogram Matching
!
         work1(1:nrefl) = fcvet(1:nrefl)
         nwizm1=25
         nsip1=150 
         if (ksize_vero < 3) then
             call HistogramMatch(work1,work1,nrefl,nsip1,nwizm1,4) 
         else
             call HistogramMatch(work1,evet,nrefl,nsip1,nwizm1,1) 
         endif
         Eqp_ist(1:nrefl) = work1(1:nrefl)
         amed_Eqp_ist = sum(Eqp_ist(1:nrefl)**2)/nrefl
!     
!!!!!!!! modifica delle fasi centrosimmetriche come da e-mail del 24/01/10
!

         if (ifIbrida == 0) then
            call Geom_Constraints
         end if
         
         go to 999
         
         if (ifIbrida /= 0) then
             Eqp(1:nrefl) = 0.0
             if (nsym > 1 .or. icent == 1) then
                call Geom_Constraints_Ibrida_cs(amed_Eqp_ist)
             end if
             
             if (icent == 0) then
                call Geom_Constraints_Ibrida_ncs(amed_Eqp_ist)
             end if
             do i=1,nrefl
!!!!                work1(i) = Eqp(i)
!                if (mkang(i) /= 1) then
!!!!                   work1(i) = Eqp(i) / sqrt(Tau**2 + Omega**2  
!!!!     *              - 2.*(Tau*Omega*Dluz(i)))
                work1(i) = Eqp(i) 
!                else
!                   if (Eqp(i) /= 0.0) then
!                      work1(i) = Eqp(i)
!                   end if
!                end if
             end do
         end if 
999      continue        
         if (ifTime == 0 )then
            sumfo = sum(Eqvero(1:nrefl))
            sumfc = sum(work1(1:nrefl))
            scala = sumfo / sumfc
            anum = sum(abs(Eqvero(1:nrefl)-scala*work1(1:nrefl)))
            aden = sum(Eqvero(1:nrefl))
            rfac_Eq = 100.*anum/aden
        
            if (kverbo_pg > 0) then
!pg201213                write(lo,'(//,a,2f12.7,//,4(/,a,i5))')
!     *          ' Residuo tra Eqvero ed Eqp dopo constraints =', rfac_Eq
            endif
         end if
         do i=1,nrefl
            if (ifIbrida == 0) then
               Eqp(i) = work1(i) * sqrt(2.*(1.-Dluz(i)))   !!!01-12
            else
               Eqp(i) = work1(i) * sqrt(Tau**2 + Omega**2 - 
     *                  2.*(Tau*Omega*Dluz(i)))
            end if
         end do
                 
!         if (ifIbrida /= 0) then
!               call Geom_Constraints_Ibrida(amed_Eqp_ist)
!         end if

!         if (ifIbrida /= 0) then
!            work1(1:nrefl) = Eqp(1:nrefl)
!            nwizm1=25
!            nsip1=150 
!            if (ksize_vero < 3) then
!               call HistogramMatch(work1,work1,nrefl,nsip1,nwizm1,4) 
!            else
!               call HistogramMatch(work1,evet,nrefl,nsip1,nwizm1,1)
!            endif
!            Eqp(1:nrefl) =  work1(1:nrefl)
!         end if
                    
         if (ifIbrida == 0) then
            do i=1,nrefl
               if(Eqp(i) > 3.3) Eqp(i) = 3.3
            end do
         end if
         
calcolo R% tra RqVero ed Rqprimo
         if (ifTime == 0 )then
            sumfo = sum(Eqvero(1:nrefl))
            sumfc = sum(Eqp(1:nrefl))
            scala = sumfo / sumfc
            anum = sum(abs(Eqvero(1:nrefl)-scala*Eqp(1:nrefl)))
            aden = sum(Eqvero(1:nrefl))
            rfac_Eq = 100.*anum/aden
        
            if (kverbo_pg > 0) then
!pg201213                write(lo,'(//,a,2f12.7,//,4(/,a,i5))')
!     *          ' Residuo tra Eqvero ed Eqp dopo constraints =', rfac_Eq
            endif
         end if
         
!pg201213
         if (kverbo_pg == 1 .and. ifTime == 0) then
            amed_Eqp = sum(Eqp(1:nrefl)**2)/nrefl
            if (knw == 1) then
!pg201213                write(lo,460) amed_Eqp
            endif
  460       format(//,' <Eqp**2> =',f10.3)
         end if
         
         do i=1,nrefl
            if(work1(i) > 3.3) work1(i) = 3.3
         end do
        
         if (kj < nucy) then
            PHIq_s(1:nrefl) = PHIqp(1:nrefl)

!  salto della prima versione di DEDM + TANG

            goto 8877

            Eq_s(1:nrefl) = Eqp(1:nrefl)   ! va dimensionato !!!
            do i=1,nrefl
               Qsin = Ep(i)  * sin(dtor * PHIp(i)) +      !19/11
!     *                Eqp(i) * sin(dtor * PHIqp(i))
     *                Eq_s(i) * sin(dtor * PHIq_s(i))
               Qcos = Ep(i)  * cos(dtor * PHIp(i)) +
!     *                Eqp(i) * cos(dtor * PHIqp(i))!
     *                Eq_s(i) * cos(dtor * PHIq_s(i))!
!               Qarg = 2*evet(i) * sqrt(Qsin**2 + Qcos**2)   ! ??????? serve per il peso?
               iphaz(i) = nint(3600 + atan2(Qsin, Qcos) * rtod)
               iphaz(i) = mod(iphaz(i), 360)
            end do
            PHIq_s(1:nrefl) = iphaz(1:nrefl)
         else
            PHIq_s(1:nrefl) = PHIqp(1:nrefl)
!            do i=1,nrefl
!               Qsin = Eq_s(i)  * sin(dtor * PHIq_s(i)) +      !19/11
!!     *                Eqp(i) * sin(dtor * PHIqp(i))
!     *                Ep(i) * sin(dtor * PHIp(i))
!               Qcos = Eq_s(i)  * cos(dtor * PHIq_s(i)) +
!!     *                Eqp(i) * cos(dtor * PHIqp(i))!
!     *                Ep(i) * cos(dtor * PHIp(i))!
!!               Qarg = 2*evet(i) * sqrt(Qsin**2 + Qcos**2)   ! ??????? serve per il peso?
!               iphaz(i) = nint(3600 + atan2(Qsin, Qcos) * rtod)
!               iphaz(i) = mod(iphaz(i), 360)
!            end do


         end if
 8877    continue
         wt(1:nrefl) = Wt_save(1:nrefl)
      end do      !nucy : numero di DEDM 
       
      return
      end
c ------------------------------------------------------------------
      subroutine Geom_Constraints
      USE General
      USE Symmetry
      USE Riflessi
      USE ShellSIGMAA
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      
      
      ichange_sym(1:nrefl) = 1
      caso(1:nrefl) = '  '
      ncon_1 = 0
      ncon_2a = 0
      ncon_2b = 0
      ncon_3a = 0
      ncon_3b = 0
      ncon_4 = 0
      do i=1,nrefl
         if (mkang(i) /=1 ) then
            wwq = sqrt(2*(1-Dluz(i)))
            if (evet(i) > Ep(i)) then                    !R > Rp
               if (PHIqp(i) == PHIp(i)) then             ! caso 1
                  work1(i) = (evet(i) - Ep(i)) / wwq
                  ichange_sym(i) = -1
                  caso(i) = ' 1'
                  ncon_1 = ncon_1 + 1
               else
!                  if (work1(i) > Ep(i) / wwq) then         !caso 2
                  if (work1(i) > 0.6 * Ep(i) / wwq) then  !caso 2
                     work1(i) = (evet(i) + Ep(i)) / wwq   
                     ncon_2a = ncon_2a + 1
                 else
                     PHIqp(i) = PHIq_s(i)                       
                     work1(i) = (evet(i) - Ep(i)) / wwq   
                     ncon_2b = ncon_2b + 1
                 end if
                  ichange_sym(i) = -1
                  caso(i) = ' 2'
               end if
            else 
               if (PHIqp(i) /= PHIp(i)) then                  !R < Rp
!                  if (work1(i) < Ep(i) / wwq) then            !caso 3
                  if (work1(i) < 0.6 * Ep(i) / wwq) then     !caso 3
                     work1(i) = (Ep(i) - evet(i)) / wwq  
                     ncon_3a = ncon_3a + 1
                  else
                     work1(i) = (evet(i) + Ep(i)) / wwq       
                     ncon_3b = ncon_3b + 1
                 end if
                  ichange_sym(i) = -1
                  caso(i) = ' 3'
               else
                  PHIqp(i) = PHIq_s(i)                        !caso 4
                  work1(i) = (Ep(i) - evet(i)) / wwq
                  ncon_4 = ncon_4 + 1
                 ichange_sym(i) = -1
                  caso(i) = ' 4'
               end if
            end if      
         end if
      end do
!     
!!!!!!!!!!!!    fine modifiche fasi centrosimmetriche come da e-mail del 3/1/2010
!
         
!      write(lo,'(a,6i5)')' GEOM =', ncon_1,ncon_2a,ncon_2b,ncon_3a,
!     *         ncon_3b,ncon_4

      return
      end
c ------------------------------------------------------------------
      subroutine Geom_Constraints_Ibrida_cs(amed_Eqp_ist)
      USE General
      USE Symmetry
      USE Riflessi
      USE ShellSIGMAA
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      USE PhaseModule, only : ifTime, ksize_vero
      character*1 aster
      dimension ffbo(nrefl)
      
      caso(1:nrefl) = '  '
      wq1_1(:) = 0.0
      wq1_2(:) = 0.0
      wq1_3(:) = 0.0
      wq2(:) = 0.0
      wq3(:) = 0.0
      wq4(:) = 0.0
      

! vincoli nel caso di riflessi c.s. (vedi e-mail del 1/7/2011)
      ncon1_1 = 0
      ncon1_2 = 0
      ncon1_3 = 0
      ncon2 = 0
      ncon3 = 0
      ncon4 = 0
      intestazione98 = 0
      intestazione99 = 0
      
!      tperc = 0.5
      j = 0
      do i=1,nrefl
         if (mkang(i) /= 1) then
            wwq = sqrt(Tau**2 + Omega**2  
     *                 - 2.*(Tau*Omega*Dluz(i)))          
            DeltaPhiq = (PHIqp(i) - PHIp(i)) * dtor 
            if (Tau*evet(i) <= Omega*Ep(i)) then
               if (abs(cos(DeltaPhiq) + 1.0) < 1.0e-6) then
                  j = j + 1
                  jorde(j) = j 
                  ffbo(j) = Eqp_ist(i)
              end if
            end if
         end if
      end do
      call sortall3(1,ffbo,1,j,jorde)
      soglia_eebo =  ffbo(nint(tperc *j))
          
      do i=1,nrefl
         if (mkang(i) /= 1) then
            wwq = sqrt(Tau**2 + Omega**2  
     *                 - 2.*(Tau*Omega*Dluz(i)))          
            DeltaPhiq = (PHIqp(i) - PHIp(i)) * dtor 
!Tau*R > Omega*Rp                           
            if (Tau*evet(i) > Omega*Ep(i)) then
               if (abs(cos(DeltaPhiq) - 1.0) < 1.0e-6) then 
                  Eqp(i) = (-Omega*Ep(i) + Tau*evet(i)) / wwq
                  ncon1_1 = ncon1_1 + 1
                  caso(i) ='11'
                  wq1_1(i) = 1.0
               else
               
                  eebo = 0.3 * (Tau*evet(i) + Omega*Ep(i))/wwq      !new
!                 eebo = 0.8 * (Omega*Ep(i))/wwq      !medium
                 if (Eqp_ist(i)> eebo) then      !new
             
               
                      Eqp(i) = (Omega*Ep(i) + Tau*evet(i)) / wwq
                      ncon1_2 = ncon1_2 + 1
                      caso(i) ='12'
                      wq1_2(i) = 1.0
                      
                  else      !new
                  
                     Eqp(i)= work1(i)     !new
                     ncon1_3 = ncon1_3 + 1
                     caso(i) ='13'
                     wq1_3(i) = 1.0
                 end if      !new
                  
                  
                  
               endif 
!Tau*R < Omega*Rp e cos(DELTA) = 1                 
            elseif (abs(cos(DeltaPhiq) - 1.0) < 1.0e-6) then  
               Eqp(i)= (Omega*Ep(i) - Tau*evet(i)) / wwq
               PHIqp(i) = PHIqp(i) + 180
               PHIqp(i) = mod(PHIqp(i),360)
               if (PHIqp(i) == 0) PHIqp(i) = 360
               ncon2 = ncon2 + 1
               caso(i) =' 2'
               wq2(i) = 1.0
!Tau*R < Omega*Rp e cos(DELTA) = - 1                 
            else
!small come medium            
!               if (ksize_vero < 3) then
!                  eebo = 0.3 *(Tau*evet(i)+Omega*Ep(i))     !small
!               else
                  eebo = 0.3 * (Tau*evet(i)+Omega*Ep(i))/wwq      !medium
!               eebo = soglia_eebo
!                  eebo = 0.9 * (abs(Tau*evet(i) + Omega*Ep(i)))/wwq      !medium
!                eebo = 0.8 * (Omega*Ep(i))/wwq      !medium
!               eebo = 0.5*(Omega*Ep(i))    !medium
!               end if
                     
               if (Eqp_ist(i)> eebo) then
                  Eqp(i)= (Omega*Ep(i) + Tau*evet(i)) / wwq
                  ncon3 = ncon3 + 1
                  caso(i) =' 3'
                  wq3(i) = 1.0
               else
                  Eqp(i)= (Omega*Ep(i) - Tau*evet(i)) / wwq 
                  ncon4 = ncon4 + 1
                  caso(i) =' 4'
                  wq4(i) = 1.0
               end if
            end if
         end if
!         if (mkang(i) == 1) then
!            DeltaPhiq = (PHIqp(i) - PHIp(i)) * dtor 
!            arg_rad = Tau**2*evet(i)**2 - Omega**2 * Ep(i)**2 *
!     *                   sin(DeltaPhiq)**2
!            primo = -Omega * Ep(i) * cos(DeltaPhiq)     
!            if (Tau*evet(i) > Omega*Ep(i)) then
!               if (intestazione98 == 0) then
!                  intestazione98 = 1
!                  write(98,'(a)')' Tau*R  Omega*Rp Delta   sinD    cosD 
!     *  argrad primo'
!               endif
!               write(98,2369) Tau*evet(i),Omega*Ep(i),
!     *  int(DeltaPhiq*rtod),sin(DeltaPhiq),cos(DeltaPhiq),arg_rad,primo 
!            else
!               if (intestazione99 == 0) then
!                  intestazione99 = 1
!                  write(99,'(a)')' Tau*R  Omega*Rp Delta   sinD    cosD 
!     *  argrad primo'
!               endif
!               write(99,2369) Tau*evet(i),Omega*Ep(i),
!     *  int(DeltaPhiq*rtod),sin(DeltaPhiq),cos(DeltaPhiq),arg_rad,primo 
!2369         format(2f8.2,i6,4f8.4) 
!            end if
!         end if
!            
           
      end do

      amed_Eqp = 0.0
      ifExamin = 1
      if(ifExamin == 1) then
         if (icent == 1) then
           amed_Eqp = sum(Eqp(1:nrefl)**2)/nrefl
           write(lo,460) amed_Eqp_ist,amed_Eqp
  460      format(//,' <Eqp_ist**2> <Eqp**2> =',2f10.3)
         end if

         write(lo,'(//,6(/,a,i5),a,i5,a,2f10.3)')
     *    ' caso Tau*R>Omega*Rp + cosDelta = 1 caso 1',ncon1_1,
     *    ' caso Tau*R>Omega*Rp + cosDelta = -1 grande caso 1',ncon1_2,
     *    ' caso Tau*R>Omega*Rp + cosDelta = -1 piccolo caso 1',ncon1_3,
     *    ' caso Tau*R<Omega*Rp + cosDelta = 1 caso 2',ncon2,
     *    ' caso Tau*R<OmegaRp + cosDelta = -1 grande caso 2',ncon3,
     *    ' caso Tau*R<OmegaRp + cosDelta = -1 piccolo caso 2 ',ncon4,
     *    '  ciclo',numero_cicli,' <Eqp_ist**2> <Eqp**2> =',
     *        amed_Eqp_ist,amed_Eqp

      
      end if
      
      ncon1tot = ncon1_1
      ncon2tot = ncon1_2
      ncon3tot = ncon1_3
      ncon4tot = ncon2
      ncon5tot = ncon3
      ncon6tot = ncon4

      if (knw /= 0) then
      
      ifTime_sav = ifTime
      ifTime = 0
      nOrigRoxi_sav = nOrigRoxi
      nOrigRoxi = 1
      izero = 0
      ifmin = 1
      nbru = 2310
      write(lo,'(/,a,a)')
     *' M.P.E. PHIq'' rispetto a PHIqvero caso Tau*R>Omega*Rp + cosD'
     *   ,'elta = 1 '
      call examin(nbru,mkang,khl,PHIqvero,PHIqp,nrefl,izero,wq1_1,ifmin)
      nOrigRoxi = nOrigRoxi_sav
      
      nOrigRoxi_sav = nOrigRoxi
      nOrigRoxi = 1
      izero = 0
      ifmin = 1
      nbru = 2311
      write(lo,'(/,a,a)')
     *' M.P.E. PHIq'' rispetto a PHIqvero caso Tau*R>Omega*Rp + cosD'
     *     ,'elta = - 1 '
      call examin(nbru,mkang,khl,PHIqvero,PHIqp,nrefl,izero,wq1_2,ifmin)
      nOrigRoxi = nOrigRoxi_sav
      
      nOrigRoxi_sav = nOrigRoxi
      nOrigRoxi = 1
      izero = 0
      ifmin = 1
      nbru = 2312
      write(lo,'(/,a,a)')
     *' M.P.E. PHIq'' rispetto a PHIqvero caso Tau*R>Omega*Rp + cosD'
     *     ,'elta = - 1 '
      call examin(nbru,mkang,khl,PHIqvero,PHIqp,nrefl,izero,wq1_3,ifmin)
      
      nOrigRoxi = nOrigRoxi_sav
      
      nOrigRoxi_sav = nOrigRoxi
      nOrigRoxi = 1
      izero = 0
      ifmin = 1
      nbru = 2313
      write(lo,'(/,a,a)')
     *' M.P.E. PHIq'' rispetto a PHIqvero caso Tau*R<Omega*Rp + cosD'
     *     ,'elta = 1 '
      call examin(nbru,mkang,khl,PHIqvero,PHIqp,nrefl,izero,wq2,ifmin)
      nOrigRoxi = nOrigRoxi_sav
      
      nOrigRoxi_sav = nOrigRoxi
      nOrigRoxi = 1
      izero = 0
      ifmin = 1
      nbru = 2314
      write(lo,'(/,a,a)')
     *' M.P.E. PHIq'' rispetto a PHIqvero caso Tau*R<Omega*Rp + cosD'
     *    ,'elta = - 1 grande  '
      call examin(nbru,mkang,khl,PHIqvero,PHIqp,nrefl,izero,wq3,ifmin)
      nOrigRoxi = nOrigRoxi_sav
      
      nOrigRoxi_sav = nOrigRoxi
      nOrigRoxi = 1
      izero = 0
      ifmin = 1
      nbru = 2315
      write(lo,'(/,a,a)')
     *' M.P.E. PHIq'' rispetto a PHIqvero caso Tau*R<Omega*Rp + cosD'
     *    ,'elta = - 1 piccolo  '
      call examin(nbru,mkang,khl,PHIqvero,PHIqp,nrefl,izero,wq4,ifmin)
      nOrigRoxi = nOrigRoxi_sav


!      write(lo,'(a)')'    h    k    l    R    Rp  Rq_ist  Rq'' Rqvero PH
!     *Iqv  PHIqp PHIp caso  wwq'  
      do i=1,nrefl
         wwq = sqrt(Tau**2 + Omega**2  
     *             - 2.*(Tau*Omega*Dluz(i)))          
      
         jh = khl(1,i)
         jk = khl(2,i)
         jl = khl(3,i)
 !        if(wq1_1(i)+wq1_2(i)+wq2(i)+wq3(i)+wq4(i) > 0) then
         if(wq4(i)> 0) then
             aster = ' '
             if (PHIqvero(i) /= PHIqp(i)) aster = '*'
!       write(lo,'(3i5,5f6.2,a,3i6,1x,a,a,f6.2)')jh,jk,jl,evet(i),Ep(i),
!     *   Eqp_ist(i),Eqp(i),Eqvero(i),aster,PHIqvero(i),PHIqp(i),PHIp(i),
!     *           caso(i),aster,wwq
         end if
      end do
      ifTime = ifTime_sav
      
      end if ! (knw /= 0)
      return
      end
c ------------------------------------------------------------------
      subroutine Geom_Constraints_Ibrida_ncs(amed_Eqp_ist)
      USE General
      USE Symmetry
      USE Riflessi
      USE ShellSIGMAA
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      USE PhaseModule, only : ifTime, ksize_vero
      character*1 aster
      integer Delta_Tan, Fi_qc_1, Fi_qc_2
      
      caso(1:nrefl) = '  '
      wq1_a(:) = 0.0
      wq1_b(:) = 0.0
      wq1_c(:) = 0.0
      wq2_a(:) = 0.0
      wq2_b(:) = 0.0
      wq2_c(:) = 0.0
      wq2_d(:) = 0.0
      wq2_e(:) = 0.0
      

      ncon1_a = 0
      ncon1_b = 0
      ncon1_c = 0
      ncon2_a = 0
      ncon2_b = 0
      ncon2_c = 0
      ncon2_d = 0
      ncon2_e = 0

      do i=1,nrefl
         if (mkang(i) == 1) then
            wwq = sqrt(Tau**2 + Omega**2  
     *                 - 2.*(Tau*Omega*Dluz(i)))     
            DeltaPhiq = (PHIqp(i) - PHIp(i)) * dtor 
            rad_arg = (Tau*evet(i))**2 - 
     *                 (Omega*Ep(i)*sin(DeltaPhiq))**2 
            
!Tau*R > Omega*Rp                           
            if (Tau*evet(i) > Omega*Ep(i)) then
               if (cos(DeltaPhiq) > 0.0) then
                  Eqp(i) = (-Omega*Ep(i)*cos(DeltaPhiq) + 
     *                       sqrt(rad_arg)) / wwq
                  ncon1_a = ncon1_a + 1
                  caso(i) ='1a'
                  wq1_a(i) = 1.0
               else
                 eebo = 0.8 * (Omega*Ep(i))/wwq      
!                 eebo = 0.3 * (Tau*evet(i) + Omega*Ep(i))/wwq      
                 if (Eqp_ist(i)> eebo) then      
                     Eqp(i) = (Omega*Ep(i)*cos(DeltaPhiq) + 
     *                       sqrt(rad_arg)) / wwq
                      ncon1_b = ncon1_b + 1
                      caso(i) ='1b'
                      wq1_b(i) = 1.0
                  else      
                      Eqp(i)= work1(i)
                      ncon1_c = ncon1_c + 1
                      caso(i) ='1c'
                      wq1_c(i) = 1.0
                  end if      
               endif
            end if
                
!Tau*R < Omega*Rp             
            if (Tau*evet(i) < Omega*Ep(i)) then
!Tau*R < Omega*Rp e Tau*R**2 < Omega*Rp*sin(Delta)**2
            if ((Tau*evet(i))**2 < (Omega*Ep(i)*sin(DeltaPhiq))**2) then
!Tau*R < Omega*Rp e Tau*R**2 < Omega*Rp*sin(Delta)**2 + cos(Delta)> 0.0
               if (cos(DeltaPhiq) > 0.0) then  
                  Eqp(i)= (Omega*Ep(i) - Tau*evet(i)) / wwq
                  PHIqp(i) = PHIqp(i) + 180
                  PHIqp(i) = mod(PHIqp(i),360)
                  if (PHIqp(i) == 0) PHIqp(i) = 360
                  ncon2_a = ncon2_a + 1
                  caso(i) ='2a'
                  wq2_a(i) = 1.0
               else
!Tau*R < Omega*Rp e Tau*R**2 < Omega*Rp*sin(Delta)**2 + cos(Delta)< 0.0
                  arg_asin = (Tau*evet(i)) / (Omega*Ep(i))
                  Delta_Tan = 180 - asin(arg_asin) * rtod
                  Fi_qc_1 = mod(Delta_Tan + PHIp(i) + 3600, 360)
                  Fi_qc_2 = mod(-Delta_Tan + PHIp(i) + 3600, 360)
                  D1 = abs(Fi_qc_1 - 180)
                  D2 = abs(Fi_qc_2 - 180)
                  if (D1 < D2) then
                     PHIqp(i) = Fi_qc_1
                  else
                     PHIqp(i) = Fi_qc_2
                  end if
 !!!!!!!!!!!!!!                 
                  Eqp(i)= (-Omega*Ep(i)*cos(DeltaPhiq)) / wwq           
                  ncon2_b = ncon2_b + 1
                  caso(i) ='2b'
                  wq2_b(i) = 1.0
               end if
            else
!Tau*R < Omega*Rp e Tau*R**2 > Omega*Rp*sin(Delta)**2 + cos(Delta)> 0.0
               if (cos(DeltaPhiq) > 0.0) then
                  Eqp(i)= (Omega*Ep(i) - Tau*evet(i)) / wwq
                  PHIqp(i) = PHIqp(i) + 180
                  PHIqp(i) = mod(PHIqp(i),360)
                  if (PHIqp(i) == 0) PHIqp(i) = 360
                  ncon2_c = ncon2_c + 1
                  caso(i) ='2c'
                  wq2_c(i) = 1.0
               else
!Tau*R < Omega*Rp e Tau*R**2 > Omega*Rp*sin(Delta)**2 + cos(Delta)< 0.0
                  eebo = 0.8 * (Omega*Ep(i))/wwq      
!                  eebo = 0.8 * (abs(Tau*evet(i) - Omega*Ep(i)))/wwq     
!                  eebo = 0.9 * (abs(Tau*evet(i) + Omega*Ep(i)))/wwq     
!                  eebo = 0.5*(Omega*Ep(i))    
                  if (Eqp_ist(i)> eebo) then      
                     Eqp(i) = (-Omega*Ep(i)*cos(DeltaPhiq) + 
     *                       sqrt(rad_arg)) / wwq
                     ncon2_d = ncon2_d + 1
                     caso(i) ='2d'
                     wq2_d(i) = 1.0
                  else
                     Eqp(i) = (-Omega*Ep(i)*cos(DeltaPhiq) - 
     *                       sqrt(rad_arg)) / wwq
                     ncon2_e = ncon2_e + 1
                     caso(i) ='2e'
                     wq2_e(i) = 1.0
                  end if
               end if
            end if
            end if
         end if
      end do

      ifExamin = 1
      if(ifExamin == 1) then
         amed_Eqp = sum(Eqp(1:nrefl)**2)/nrefl
         write(lo,460) amed_Eqp_ist,amed_Eqp
  460    format(//,' <Eqp_ist**2> <Eqp**2> =',2f10.3)
      
         write(lo,'(//,8(/,a,i5),a,i5,a,2f10.3)')
     *        ' caso Tau*R>Omega*Rp & cosDelta > 0 caso 1a',ncon1_a,
     *        ' caso Tau*R>Omega*Rp & cosDelta < 0 caso 1b',ncon1_b,
     *        ' caso Tau*R>Omega*Rp & cosDelta < 0 caso 1c',ncon1_c,
     *        ' caso Tau*R<Omega*Rp & cosDelta > 0 caso 2a',ncon2_a,
     *        ' caso Tau*R<Omega*Rp & cosDelta < 0 caso 2b',ncon2_b,
     *        ' caso Tau*R<Omega*Rp & cosDelta > 0 caso 2c',ncon2_c,
     *        ' caso Tau*R<Omega*Rp & cosDelta < 0 caso 2d',ncon2_d,
     *        ' caso Tau*R<Omega*Rp & cosDelta < 0 caso 2e',ncon2_e,
     *        '  ciclo',numero_cicli,' <Eqp_ist**2> <Eqp**2> =',
     *        amed_Eqp_ist,amed_Eqp

      
      end if
      
      ncon1tot_ncs = ncon1_a
      ncon2tot_ncs = ncon1_b
      ncon3tot_ncs = ncon1_c
      ncon4tot_ncs = ncon2_a
      ncon5tot_ncs = ncon2_b
      ncon6tot_ncs = ncon2_c
      ncon7tot_ncs = ncon2_d
      ncon8tot_ncs = ncon2_e
      
      if (knw /= 0) then
      
      ifTime_sav = ifTime
      ifTime = 0
      nOrigRoxi_sav = nOrigRoxi
      nOrigRoxi = 1
      izero = 0
      ifmin = 1
      nbru = 3310
      write(lo,'(/,a)')
     *'M.P.E. PHIq'' rispetto a PHIqvero: Tau*R>Omega*Rp + cosDelta > 0
     * 1a'
      call examin(nbru,mkang,khl,PHIqvero,PHIqp,nrefl,izero,wq1_a,ifmin)
      nOrigRoxi = nOrigRoxi_sav
      
      nOrigRoxi_sav = nOrigRoxi
      nOrigRoxi = 1
      izero = 0
      ifmin = 1
      nbru = 3311
      write(lo,'(/,a)')
     *'M.P.E. PHIq'' rispetto a PHIqvero: Tau*R>Omega*Rp + cosDelta < 0
     * 1b'
      call examin(nbru,mkang,khl,PHIqvero,PHIqp,nrefl,izero,wq1_b,ifmin)
      nOrigRoxi = nOrigRoxi_sav
      
      nOrigRoxi_sav = nOrigRoxi
      nOrigRoxi = 1
      izero = 0
      ifmin = 1
      nbru = 3312
      write(lo,'(/,a)')
     *'M.P.E. PHIq'' rispetto a PHIqvero: Tau*R>Omega*Rp + cosDelta < 0
     * 1c'
      call examin(nbru,mkang,khl,PHIqvero,PHIqp,nrefl,izero,wq1_c,ifmin)
      nOrigRoxi = nOrigRoxi_sav
      
      nOrigRoxi_sav = nOrigRoxi
      nOrigRoxi = 1
      izero = 0
      ifmin = 1
      nbru = 3313
      write(lo,'(/,a)')
     *'M.P.E. PHIq'' rispetto a PHIqvero: Tau*R<Omega*Rp + cosDelta > 0
     * 2a'
      call examin(nbru,mkang,khl,PHIqvero,PHIqp,nrefl,izero,wq2_a,ifmin)
      nOrigRoxi = nOrigRoxi_sav
      
      nOrigRoxi_sav = nOrigRoxi
      nOrigRoxi = 1
      izero = 0
      ifmin = 1
      nbru = 3314
      write(lo,'(/,a)')
     *'M.P.E. PHIq'' rispetto a PHIqvero: Tau*R<Omega*Rp + cosDelta < 0
     * 2b'
      call examin(nbru,mkang,khl,PHIqvero,PHIqp,nrefl,izero,wq2_b,ifmin)
      nOrigRoxi = nOrigRoxi_sav
      
      nOrigRoxi_sav = nOrigRoxi
      nOrigRoxi = 1
      izero = 0
      ifmin = 1
      nbru = 3315
      write(lo,'(/,a)')
     *'M.P.E. PHIq'' rispetto a PHIqvero: Tau*R<Omega*Rp + cosDelta > 0
     * 2c'
      call examin(nbru,mkang,khl,PHIqvero,PHIqp,nrefl,izero,wq2_c,ifmin)
      nOrigRoxi = nOrigRoxi_sav
      
      nOrigRoxi_sav = nOrigRoxi
      nOrigRoxi = 1
      izero = 0
      ifmin = 1
      nbru = 3316
      write(lo,'(/,a)')
     *'M.P.E. PHIq'' rispetto a PHIqvero: Tau*R<Omega*Rp + cosDelta < 0
     * 2d'
      call examin(nbru,mkang,khl,PHIqvero,PHIqp,nrefl,izero,wq2_d,ifmin)
      nOrigRoxi = nOrigRoxi_sav

      nOrigRoxi_sav = nOrigRoxi
      nOrigRoxi = 1
      izero = 0
      ifmin = 1
      nbru = 3317
      write(lo,'(/,a)')
     *'M.P.E. PHIq'' rispetto a PHIqvero: Tau*R<Omega*Rp + cosDelta < 0
     * 2e'
      call examin(nbru,mkang,khl,PHIqvero,PHIqp,nrefl,izero,wq2_e,ifmin)
      nOrigRoxi = nOrigRoxi_sav

!      write(lo,'(a)')'    h    k    l    R    Rp  Rq_ist  Rq''  PHIqv 
!     * PHIqp PHIp caso'  
!      do i=1,nrefl
!         jh = khl(1,i)
!         jk = khl(2,i)
!         jl = khl(3,i)
!!         if(wq1_1(i)+wq1_2(i)+wq2(i)+wq3(i)+wq4(i) > 0) then
!         if(wq1_2(i)> 0) then
!             aster = ' '
!             if (PHIqvero(i) /= PHIqp(i)) aster = '*'
!!             write(lo,'(3i5,4f6.2,a,3i6,1x,a,a)')jh,jk,jl,evet(i),Ep(i),
!!     *           Eqp_ist(i),Eqp(i),aster,PHIqvero(i),PHIqp(i),PHIp(i),
!!     *           caso(i),aster
!         end if
!      end do
      
      ifTime = ifTime_sav

      end if ! (knw /= 0)
      
      return
      end      
c ------------------------------------------------------------------
      subroutine ri_Calcola_SigmaA_MDM
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE ShellSIGMAA
      USE TestModel
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3

      dimension Eo2Ec2Med(50)
      dimension Eo2Ec2Med_old(50)

      Rat_VLD = ( rfac_init  - rfac_10EDM ) / ( rfac_init - 40.)
      
      call Calcola_SigmaA(Rat_VLD)     
     
      if ( numero_cicli == 1 ) then
         SigmaA_init = amed_Dl
      end if
      
! riscalamento della SigmaA in DEDM

      if ( (numero_cicli > 1 .and. ifMDM == 1) .or.
     *     (mod(numero_cicli, n_cb) /= 1 .and. ifMDM == 0)) then

         Rat_VLD = ( rfac_init  - rfac_10EDM ) / ( rfac_init - 40.)        

         if (Rat_VLD < 0.1) Rat_VLD = 0.1
         sigmaA_1 = (amed_Dl - sigmaA_init) / (0.97 - sigmaA_init)
         if (sigmaA_1 < 0.1) sigmaA_1 = 0.1

         amedia_teorica = sigmaA_1 * (Rat_VLD**0.3)
         if (amedia_teorica <0.2) amedia_teorica = 0.2

         if (ifMDM == 0) then
            n_cyc = mod(numero_cicli,2)
            if (n_cyc == 1 .and. numero_cicli > 2) then
               amedia_teorica = 0.6
            end if
         end if
      else
         amedia_teorica = 0.1
      end if
      
      fattore = amedia_teorica / amed_Dl_orig
      
      if (fattore > 1.0) then
         fattore = 1.0
      end if
      
      do i=1, nrefl
         Dluz(i) = Dluz(i)* fattore
         if (Dluz(i)>0.97) Dluz(i)=0.97
         if (ifMDM == 0) then
            if (Dluz(i)<0.2 .and. mod(numero_cicli,n_cb)/=1) then
               Dluz(i)=0.2
            end if
         else
            if (Dluz(i)<0.2 .and. numero_cicli > 1) then
               Dluz(i)=0.2
            end if
         end if
      end do

      amed_Dl= sum(Dluz(1:nrefl))/nrefl
      if (knw /= 0 .and. kverbo_pg == 1) then
       write(lo,'(a,a,3e25.15)') ' <sigmaATeorica>, <SigmaAorig>,',
     *    '<SigmaArisc>', amedia_teorica, amed_Dl_orig, amed_Dl
      end if
      
      if (ifMDM == 1) then
         if (numero_cicli == 1) then
            amed_Dl_orig_init = amed_Dl_orig
         end if
      end if
      
      tperc_min = 0.1
      tperc_max = 0.0
      amed_Dl_max = 0.80
      tperc = tperc_min + ((amed_Dl_orig-amed_Dl_orig_init)*
     *(abs(tperc_max - tperc_min)))/(amed_Dl_max - amed_Dl_orig_init)
     
!      write(lo,'(a,2f8.2)') ' <SigmaAorig>, Tperc = ',amed_Dl_orig,tperc
      
      do i=1,nrefl
         X = (2. * Dluz(i) * evet(i)*fcvet(i))/(es(i) - Dluz(i)**2)
         wt(i) = bes(X)        
!piero
         if (ifMDM == 1) then
            wt(i) = wt(i) * 0.5
         end if
      end do
      
      if (ifMDM == 1) then
         ammin = minval(wt(1:nrefl))
         ammax = maxval(wt(1:nrefl))
         amed_m = sum(wt(1:nrefl))/nrefl
         
         if (knw /= 0 .and. kverbo_pg == 1) then
            write(lo,'(a,3e25.15)') 
     *         ' min, max, med(m) = ',ammin,ammax,amed_m
         end if 
      
         WT_save_m(1:nrefl) = wt(1:nrefl)
      end if
       
! -----------------------
!in fcvet metto Ep per calcolo sigmaa
      fcvet(1:nrefl) = Ep(1:nrefl)
      
      do i = 1,nrefl
         if(mkang(i).ne.1) then
            iphi=iphaz(i)
            idv = 15*mod(mkang(i)-1,12)
            id1 = iabs(idv-iphi)
            id2 = iabs(idv+180-iphi)
            id1=min0(id1,360-id1)
            id2=min0(id2,360-id2)
            if(id1.lt.id2) then
               iphi=idv
            else
               iphi=idv+180
            endif
            iphi=mod(iphi,360)
            if (iphi == 0) iphi = 360
            iphaz(i) = iphi
         end if
      end do

! in PHIp le fasi delle parziale
      PHIp(1:nrefl) = iphaz(1:nrefl)
      
      if (ifExamin == 1 .and. knw /= 0 .and. ifMDM == 0) then
          call Calcola_EqVero
      end if

!  richiamo della sigmaa e calcolo della fourier differenza RHOq

      call Calcola_SigmaA(Rat_VLD)
      if (ifMDM == 1) then
         wt(1:nrefl) =  WT_save_m(1:nrefl)
      end if
      do i=1, nrefl
         Dluz(i) = Dluz(i)* fattore
         if (Dluz(i)>0.97) Dluz(i)=0.97
         if (ifMDM == 0) then
            if (Dluz(i)<0.2 .and. mod(numero_cicli,n_cb)/=1) then
               Dluz(i)=0.2
            end if
         else
            if (Dluz(i)<0.2 .and. numero_cicli > 1) then
               Dluz(i)=0.2
            end if
         end if
      end do
      
      amed_Dl= sum(Dluz(1:nrefl))/nrefl

      return
      end
c ------------------------------------------------------------------
      subroutine VLD_Statistics

      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Param
      USE PhaseModule
      USE TestModel
      USE Mappa
      USE ShellSIGMAA

      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      character*11 tirang

!
      if (kverbo_pg == 0) then
          return
      endif
!  nuove statistiche
      write(lo,'(/,a,/)') ' NUOVE STATISTICHE : '
      
      izero = 0
      ifmin = 1
      nbru = 4410
      write(lo,'(/,a)')' M.P.E. PHIq rispetto a IPUB'
      call examin(nbru,mkang,khl,ipub,PHIq,nrefl,izero,wq,ifmin)
      
      izero = 0
      ifmin = 1
      nbru = 4410
      write(lo,'(/,a)')' M.P.E. PHIq'' rispetto a IPUB'
      call examin(nbru,mkang,khl,ipub,PHIqp,nrefl,izero,wq,ifmin)
      
      write(lo,'(/,a,/)') ' VECCHIE STATISTICHE : '
      
      izero = 0
      ifmin = 1
      nbru = 4455
      write(lo,'(/,a)')' M.P.E. PHIq rispetto a PHIqVero'
      call examin(nbru,mkang,khl,PHIqVero,PHIq,nrefl,izero,wq,ifmin)
      
      izero = 0
      ifmin = 1
      nbru = 4455
      write(lo,'(/,a)')' M.P.E. PHIq'' rispetto a PHIqVero'
      call examin(nbru,mkang,khl,PHIqVero,PHIqp,nrefl,izero,wq,ifmin)
      
      izero = 0
      ifmin = 1
      nbru = 5555
      write(lo,'(/,a)')' M.P.E. PHI rispetto a iPUB'
      call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
         
      tirang = 'Q'
      ipher = 1
      call pherrdisNew_VLD(tirang,EossEcal,khl,mkang,nrefl,izero,
     *              ipub,iphaz,wt,20,0.0,ipher,soglia_PrCy,0)
!      if (Sog_PrCy > 9999. .and. numero_cicli == nPrCy) then
      if (abs(numero_cicli - nPrCy) < 3) then
         Sog_PrCy = soglia_PrCy
      end if
      nprcy = 13
!      if ((abs(numero_cicli - nPrCy) < 3 .and. numbrun == 2) .or.
!     *   (abs(numero_cicli - 159) < 3 .and. numbrun == 2)) then
!         write(lo,'(/,a,a)')
!     *  '      Q     Rq     R     Rp       m      Rp''  PHIp   Rq''_ist
!     * ' ,' Rq''  PHIq'' PHI pub   sigmaA'
!         do i= 1,nrefl
!           if (EossEcal(i) >= Sog_PrCy) then
!              jh = khl(1,i)
!              jk = khl(2,i)
!              jl = khl(3,i)
!              shiftp = jh*shiftexam(1)+jk*shiftexam(2)+jl*shiftexam(3)
!              shiftp = 360.* shiftp + ipub(i)
!              if (shiftexam(4) < 0) then
!                 shiftp = -shiftp
!              end if
!              shiftp = amod(shiftp+36000.,360.)
!              ishiftp = shiftp
!              if (ishiftp == 0) ishiftp = 360
!              
!              idiff = iabs(ishiftp-iphaz(i))
!              if (idiff > 180) then
!                 idiff = 360 - idiff
!              end if
!              
!              write(lo,'(f10.4,f6.2,f6.2,f6.2,2(f10.5,f6.2,i5),2i5,
!     *                   f10.5, i5,2x,a2)')
!     *    EossEcal(i),ArgGq(i),evet(i)*ichange_sym(i),Ep(i),pesMod(i),
!     *        Epp(i),PHIp(i), Eqp_ist(i),Eqp(i),PHIqp(i),iphaz(i),
!     *        ishiftp,Dluz(i),mkang(i),caso(i)
!     
!           end if
!         end do
!      end if
      tirang = ' stat WQ    '
      izero = 0
      ipher = 0
      call weightsdis(tirang,wt,khl,nrefl,izero,
     *                  ipub,iphaz,wt,10,0.0,ipher)

      return
      end
c ------------------------------------------------------------------
      subroutine RandomPhases_VLD
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
c
      iphaz(1:nrefl) = 0
      wt(1:nrefl) = 0.0
c routine definizione set di fasi mediante SirRandom
      IYsolve = iyrand
      if (kverbo.ne.0) then 
          write(lo,*) 'TRIAL =',numbrun
      endif
      ix=iyrand

      do i=1, nrefl
         if (ifMDM == 1) then
            if (i <= nstr) then
               k = iordetang(i)
            else
               k = i
            end if
         else
            k = i
         end if
         call SirRandom(ix,iyrand,yfl)
         ix=iyrand
!         iphaz(i) = nint(yfl*360.0)
         
!         goto 10
         
         iphi=nint(yfl*360.0)
         if (k==0) then
             k=0
         endif
         if(iabs(mkang(k)).ne.1) then
            idv = 15*mod(iabs(mkang(k))-1,12)
            id1 = iabs(idv-iphi)
            id2 = iabs(idv+180-iphi)
            id1=min0(id1,360-id1)
            id2=min0(id2,360-id2)
            if (id1.lt.id2) then
                iphi=idv
            else
                iphi=idv+180
            endif
         endif
         iphi=mod(iphi,360)
         if (iphi == 0) iphi = 360
         iphaz(k)=iphi
         
!   10  continue
   
         wt(k) = 1.0
      enddo
      
      call UpdateReflInfo
      
      return
      end
c-------------------------------------------------------------------
      subroutine FindSeed_VLD(itr)
      USE General
      USE PhaseModule

      iyrand=67543
      ix=iyrand
      do 10 ntri=1,itr-1
        do 20 i=1,nrefl
!         do 20 i=1,nstarttang
            call SirRandom(ix,iyrand,yfl)
            ix=iyrand
 20      continue
 10   continue
      call UpdateReflInfo
c
      return
      end

*-------------------------------------------------------------*
      subroutine ChangeAndInvMap_VLD(x,x1,jflagM,sogrho1,jflagE,ifInv,
     *                              ier)


      USE Riflessi
      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))

      common/puntic/npu1,npu2,npu3,npu4

 
*---- jflagM=0 Non modifica la densita'  ----*
*---- jflagM=1 Modifica la densita': troncare a " den_p "  ----*
*---- jflagM=11Modifica la densita': troncare  den_p pos e neg --*
*---- jflagM=2 Modifica la densita': troncare la parte negativa--*
*---- jflagM=7 Modifica la densita': troncare tra "den_s" e "den_p" (prende la parte piu' alta pos e piu' bassa neg)

!
!-- Envelope    gianluca 28/01/2011
!
*     if (EnvePronta > 0.5) then
*         call ApplicaEnveVLD
*     endif
!
      if (sogrho1.gt.0.0) then
          sog=avden+sogrho1*stden
      else
          sog=0.0
      endif
      npunti=np(1)*np(2)*np(3)

      n_p=0
      n_s=0
      npu1=0
      npu2=0
      npu3=0
      npu4=0

*---- Prima volta  fa la modifica
       call ChangeMapFlex_VLD(x,x1,sog,jflagM,jflagE)
       
      if (ifInv == 0) then
         return
      end if    

      if (knw > 0) then
       write(lo,*)'  ***************************************'
       write(lo,*)'  *          Inverse FFT Routine        *'
       write(lo,*)'  ***************************************'
      endif
      percT=float(n_p)/(float(npunti))
      perc=float(n_p)/(float(npunti)*v_p)
      if (perc.gt.1.0) perc=1.0

      if (knw > 0) then
        write(lo,'(" jflagM = ",i4)') jflagM

        write(lo,1000)den_p/volume,n_p,percT*100.0,perc*100.0,
     +             npu2,100.0*float(npu2)/float(n_p),
     +             npu3,100.0*float(npu3)/float(n_p),
     +             den_s/volume,n_s,100.*float(n_s)/(float(npunti)),
     *             100.*float(n_s)/(float(npunti)*v_p),
     *             sog/volume,npu1
      endif

 1000 format(/,'   Minimum Density level (pos)........ ',f8.3,/,
     +       '   Grid point .gt. Level ............. ',i8,2x,
     +                                       2(1x,f6.1,'%'),/,
     +       '     a) in the envelope .............. ',i8,3x,f6.1,1h%,/,
     +       '     b) out of the envelope .......... ',i8,3x,f6.1,1h%,/,
     *       '   Minimum Density level (neg)........ ',f8.3,/,
     +       '   Grid point .lt. Level ............. ',i8,2x,
     +                                       2(1x,f6.1,'%'),/,
     +       '   Cut-off density ................... ',f8.3,/,
     +       '   Cut-off points .................... ',i8,/)


!!gpu call NewInv(iphaz,fcvet,nreflTot,np(1),np(2),np(3),BACK)
      call NewInvCuda(iphaz,fcvet,nreflTot,np(1),np(2),np(3),BACK,x)
      if (knw > 0) then
       write(lo,*)'  ***************************************'
       write(lo,*)'  *      END Inverse FFT Routine        *'
       write(lo,*)'  ***************************************'
      endif

      return
      end
*------------------------------------------------------------------*
      subroutine ChangeMapFlex_VLD(x,x1,sog,jflagM,jflagE)

      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      common/puntic/npu1,npu2,npu3,npu4
      integer :: npu1,npu2,npu3,npu4

      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))
 
      SOGmin=0.32*volume
      SOGmax=2.0*volume
      nx=np(1)
      ny=np(2)
      nz=np(3)
      n_p=0
c     write(0,*) 'den_p',den_p

      do 150 i=1,nx
         do 100 j=1,ny
            do 50 k=1,nz
               xx=x(i,j,k)
               if (jflagE.gt.0) xx1=x1(i,j,k)/100.0
               if (sog.gt.0.0.and.x(i,j,k).gt.sog) then
                    x(j,i,k)=sog
                    npu1=npu1+1
               endif

               if (jflagM.eq.1) then
*----------------
!
!-- gianluca 22/01/2013
!
                  if (xx.lt.den_p.or.xx.le.0.0) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                     if (jflagE.gt.0) then
                         if (xx1.eq.1.0) then
                             npu2=npu2+1
                         elseif (xx1.eq.0.5) then
                             npu3=npu3+1
                         else
                             npu4=npu4+1
                         endif
                     endif
                  endif
*----------------
               elseif (jflagM.eq.11) then
                  if (abs(xx).lt.den_p) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                     if (jflagE.gt.0) then
                         if (xx1.eq.1.0) then
                             npu2=npu2+1
                         elseif (xx1.eq.0.5) then
                             npu3=npu3+1
                         else
                             npu4=npu4+1
                         endif
                     endif
                  endif
*----------------
               elseif (jflagM.eq.2) then
                  if ( xx.le.0.0 ) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                     if (jflagE.gt.0) then
                         if (xx1.gt.0.0.and.xx1.lt.2.0) then
                             if (xx1.eq.1.0) then
                                npu2=npu2+1
                             elseif (xx1.eq.0.5) then
                                npu3=npu3+1
                             else
                                npu4=npu4+1
                             endif 
                         endif
                     endif
                  endif
*----------------
               elseif (jflagM.eq.3) then
                  if ( xx.lt.den_s ) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                  endif
*----------------
               elseif (jflagM.eq.4) then
                  if ( xx.lt.SOGmin ) then
                     x(i,j,k)=SOGmin
                  elseif ( xx.gt.SOGmax ) then
                     x(i,j,k)=SOGmax
                     n_p=n_p+1
                  endif
*----------------
               elseif (jflagM.eq.5) then
                  if (xx1.eq.1.0) then
                     if (xx.lt.den_p) then
                        x(i,j,k)=0.0
                        n_s=n_s+1
                     else
                        n_p=n_p+1
                        npu2=npu2+1
                     endif
                  else
                     if (xx.lt.den_s) then
                         x(i,j,k)=0.0
                         n_s=n_s+1
                     else
                        n_p=n_p+1
                        npu3=npu3+1
                     endif
                  endif
*----------------
               elseif (jflagM.eq.7) then
                     if (xx.gt.den_n.and.xx.lt.den_p) then
                        x(i,j,k)=0.0
                     else
                        if (xx < den_n) n_s=n_s+1
                        if (xx > den_p) n_p=n_p+1
                        if (jflagE.gt.0) then
                           if (xx1.eq.1.0) then
                              npu2=npu2+1
                           elseif (xx1.eq.0.5) then
                              npu3=npu3+1
                           else
                              npu4=npu4+1
                           endif
                        endif
                     endif
*----------------
               else
                  n_p=n_p+1
                  if (jflagE.gt.0) then
                     if (xx1.eq.1.0) then
                        npu2=npu2+1
                     elseif (xx1.eq.0.5) then
                        npu3=npu3+1
                     else
                        npu4=npu4+1
                     endif
                  endif
               endif
  50        continue
 100     continue
 150  continue
!
      return
      end
!-----------------------------------------------------------------------
      ! sigmaA routine
      ! Dritan : 28/06/2005
c--------------------------------------
      ! input:
      ! jsigma=1  <E2Ec2>
      ! jsigma=2  R(E2Ec2)
      ! jsigma=3  <E2-Ec2>
      ! jsigma=4  nel caso di FreeLunch (jsigma = -4)
      ! jsigma=5,6  nel caso di Fourier differenza
      ! jsigma< 0  Ec instead of Fc
      ! Fo ,sigFo,--> observed data
      ! rho --> (sinT/l)^2
      ! eps
      ! Fop2 & iphi2 wtt --> calculated data  (wtt can be also 1.0)
      ! iphi --> true phase
      ! iphi2o &  wto --> observed phase/weigth for combination (icombPh=1)
      ! nrefl1 --> number of reflection (observed)
      ! nrefSi --> number of reflection (incluse non-observed)
      ! ndim --> dimension for all the arrays
      ! output:
      ! wvar , m(pesMod) and D (Dluz)
      !
     
      subroutine sigmaA_VLD(fovet, evet, ecvet, mkang, sigmav, epsv,
!     *          rhov,ipub,iphaz,Eo2Ec2Med, Eo2Ec2Med_old, RES_TAG,Nbin,
     *          rhov,ipub,iphaz,Eo2Ec2Med, Eo2Ec2Med_old, 
     *          ifnoEE, nrefl1)
     

      USE General
      USE Symmetry
      USE ShellSIGMAA
      USE PhaseModule, only : numbrun
      USE VLDmod_3

      dimension fovet(nrefl1), evet(nrefl1), ecvet(nrefl1), 
     *  mkang(nrefl1), sigmav(nrefl1), epsv(nrefl1),
     *  rhov(nrefl1), ipub(nrefl1), iphaz(nrefl1)
      dimension Eo2Shell(50),Ec2Shell(50),scEo2Shell(50),scEc2Shell(50)
      dimension Eo2Ec2Med(50),eeShell(50),SIGnShell(50),numbShell(50)
      dimension Eo4Shell(50),Ec4Shell(50)
      dimension Eo6Shell(50),Ec6Shell(50)
      dimension Eo2Ec2Med_old(50)
      dimension Eo2Ec2Ave(50)
      dimension Eo2Ec2Med_noMNQ(50)
      dimension RES_abi(50),sintl_abi(50)
      dimension RES_abi_M(50),sintl_abi_M(50)
      dimension cosErrShell(50)

      dimension esse(50),smin(50),smax(50)
     
      real,     allocatable   :: ee(:),sigEobs(:)
      allocate(ee(nrefl1),sigEobs(nrefl1),  stat=ierr)
      
c--deb
      iprint = 0
      
      if (iprint==1) then
        write(lo,*)'================================='
        write(lo,*)'=  sigmaA  routine', nbin
        write(lo,*)'================================='
      endif
       
      sigAmed=0.0
      do i=1, nrefl1
         ee(i)=0.0
         sigEobs(i)=0.0
      enddo

      do i=1, Nbin
         Eo2Shell(i)=0.0
         Ec2Shell(i)=0.0
         Eo4Shell(i)=0.0
         Ec4Shell(i)=0.0         
         Eo6Shell(i)=0.0
         Ec6Shell(i)=0.0         
         Eo2Ec2Med(i)=0.0
         Eo2Ec2Med_old(i)=0.0
         eeShell(i)=0.0
         scEo2Shell(i)=1.0
         scEc2Shell(i)=1.0
         numbShell(i)=0.0
         SIGnShell(i)=0.0
         cosErrShell(i)=0.0       
      enddo

      if (iprint==1) then
       write(lo,*)'Nr riflessi obs:',nrefl1
       write(lo,*)'Nr riflessi con Ec >0:',count(ecvet(1:nrefl1) > 0.0)
       write(lo,*)'Nr riflessi con Eo >0:',count(evet(1:nrefl1) > 0.0)
      endif

!
      sumEo=sum(evet(1:nrefl1))
      sumEc=sum(Ecvet(1:nrefl1))
      scaleEoEc=sumEo/sumEc
   
      if (iprint==1) then
        write(lo,*)'scale(Eo,Ec):',scaleEoEc
      endif
      
! calcolo % riflessi con E > 2.5           !22/2/2010
      num_eobs= 0
      do i = 1, nrefl1
         if (evet(i) > 2.5) then
            num_eobs = num_eobs + 1
         end if
      end do
      perc_eobs = num_eobs / float(nrefl1) 
    
      do i=1,nrefl1
         ii=RES_TAG(i)
         eps=epsv(i)*pts
         wref=2.0
         if (mkang(i) > 1) wref=1.0
         numbShell(ii)=numbShell(ii) + wref                            
         SIGnShell(ii)=SIGnShell(ii) + wref*((fovet(i)**2)/eps)
      end do

      do i=1,Nbin
        SIGnShell(i)=SIGnShell(i)/numbShell(i)
      enddo                               
      sumDiff=0.0
      num_shell_1 = 0
      do i=1,nrefl1
       res_rif = sqrt(rhov(i))
       ii=RES_TAG(i)
c
       eps=epsv(i)*pts
       
       diffERR=(iphaz(i)-ipub(i)) * dtor
       diffERR=cos(diffERR)
       cosErrShell(ii)=cosErrShell(ii) + diffERR
       
       if (kmad /= 1) then
         sigEobs(i)=sigmav(i)/(sqrt(eps*SIGnShell(ii)))
       else
           sigEobs(i)=sigmav(i)  !   per MAD i sigma sono sigma(E)
       endif
       if(ifnoEE==1) then
              ee(i)=1.0 
       else
              ee(i)=1.0 + sigEobs(i)
       endif
       eeShell(ii)= eeShell(ii)+ee(i)
       Eo2Shell(ii)= Eo2Shell(ii)+evet(i)**2
       Ec2Shell(ii)= Ec2Shell(ii)+Ecvet(i)**2
       Eo4Shell(ii)= Eo4Shell(ii)+evet(i)**4
       Ec4Shell(ii)= Ec4Shell(ii)+Ecvet(i)**4
       Eo6Shell(ii)= Eo6Shell(ii)+evet(i)**6
       Ec6Shell(ii)= Ec6Shell(ii)+Ecvet(i)**6
       
       if (mkang(i) == 1 ) then                      !28-05-2010
         quaranta = (evet(i)**2)*(Ecvet(i)**2) 
       else
         quaranta = 0.5 * (evet(i)**2)*(Ecvet(i)**2)
       end if
       quaranta_old = (evet(i)**2)*(Ecvet(i)**2) 
       
       if (quaranta_old > 40.0) then                      !16/2/2010 controllo originale AB
           quaranta_old = 40.0
       end if
                
       Eo2Ec2Med(ii)=Eo2Ec2Med(ii) + quaranta
       Eo2Ec2Med_old(ii)=Eo2Ec2Med_old(ii) + quaranta_old
!       Eo2Ec2Med_old(ii)=Eo2Ec2Med_old(ii) + quaranta
       
      enddo

      if (iprint==1) then
          write(lo,'(a,e25.15)')'<Eo>',sum(evet(1:nrefl))/float(nrefl1)
          write(lo,'(a,e25.15)')'<Ec>',sum(Ecvet(1:nrefl))/float(nrefl1)
      write(lo,'(a,e25.15)')'<sigE>',sum(sigEobs(1:nrefl))/float(nrefl1)
      endif

! calc <Eo2>, <Ec2> <Eo2Ec2> for any shell
!      if (iprint == 1) then
!      write(lo,'(a)')' shell  <Eo2Ec2>     <Eo2>       <Ec2>       <Eo4>
!     *       <Ec4>       <Eo6>        <Ec6> numero rifl'
!      end if
      do i=1, Nbin
        numbShell1=count(RES_TAG(:) == i)
        Eo2Shell(i)=Eo2Shell(i)/float(numbShell1)
        Ec2Shell(i)=Ec2Shell(i)/float(numbShell1)
        Eo4Shell(i)=Eo4Shell(i)/float(numbShell1)
        Ec4Shell(i)=Ec4Shell(i)/float(numbShell1)
        Eo6Shell(i)=Eo6Shell(i)/float(numbShell1)
        Ec6Shell(i)=Ec6Shell(i)/float(numbShell1)
        Eo2Ec2Med(i)=Eo2Ec2Med(i)/float(numbShell1) 
        cosErrShell(i) = cosErrShell(i)/float(numbShell1)
        
        Eo2Ec2Ave(i)=Eo2Ec2Med(i)
                
        Eo2Ec2Med_old(i)=Eo2Ec2Med_old(i)/float(numbShell1)
        eeShell(i)=eeShell(i)/float(numbShell1)
        
!        if (iprint == 1) then
!          write(lo,'(i4,7f12.5,i6)') i,Eo2Ec2Med(i),
!     *    Eo2Shell(i),Ec2Shell(i),Eo4Shell(i),Ec4Shell(i),
!     *    Eo6Shell(i),Ec6Shell(i),numbShell1
!          write(lo,'(i4,3e35.25,i6)') i,Eo2Ec2Med_old(i),
!     *    Eo2Shell(i),Ec2Shell(i),numbShell1
!        end if
      enddo
      
!       if (iprint==1) then
!        write(lo,*)'<e>o',sum(eeShell(:))/float(Nbin)
!        write(lo,*)'<Eo2>o',sum(Eo2Shell(:))/float(Nbin)
!        write(lo,*)'<Ec2>o',sum(Ec2Shell(:))/float(Nbin)
!        write(lo,*)'<Eo2Ec2>o',sum(Eo2Ec2Med(:))/float(Nbin)
!      endif
!      if (iprint == 1) then     
!piero        write(lo,'(a)') ' shell   CCP4     form.1_noMNQ form.1_MNQ   <co
!piero     *sphi>     form.2      form.3'
!        write(lo,'(a)') ' shell     RES        sint/l          CCP4     
!     *form.1_noMNQ form.1_MNQ   <cosphi>     form.2      form.3'
!      end if
!scale <Eo2> , <Ec2>, <Eo2Ec2> and calc <sigmaA> for any shell
      
      do i=1,Nbin
        scEo2Shell(i)=Eo2Shell(i)/1.0
        scEc2Shell(i)=Ec2Shell(i)/1.0
        Eo2Shell(i)=Eo2Shell(i)/scEo2Shell(i)
        Ec2Shell(i)=Ec2Shell(i)/scEc2Shell(i)
        
        if (icent == 0) then
          Eo2Ec2Med(i)=Eo2Ec2Ave(i) - (scEo2Shell(i)*scEc2Shell(i))
        else
          Eo2Ec2Med(i)=Eo2Ec2Ave(i) - 0.5 *(scEo2Shell(i)*scEc2Shell(i))
        end if
                      
        Eo2Ec2Med_old(i)=Eo2Ec2Med_old(i)/(scEo2Shell(i)*scEc2Shell(i)) 
      enddo
      
      Eo2Ec2Med_noMNQ(1:Nbin) =  Eo2Ec2Med(1:Nbin)
      
      smin(:) = 9999.
      smax(:) = -9999.
      do i=1,Nbin
        do jcris=1,nrefl1
          ii=RES_TAG(jcris)
          if (i == ii) then
             if (rhov(jcris) < smin(i)) then
                smin(i) = rhov(jcris)
             end if
             if (rhov(jcris) > smax(i)) then
                smax(i) = rhov(jcris)
             end if
          end if
        end do
      end do
      
      do i=1,Nbin
         esse(i) = (smin(i)+smax(i))/2.
         sintl_abi(i) = sqrt(smin(i))
         sintl_abi_M(i) = sqrt(smax(i))
         RES_abi(i) = 0.5/sintl_abi(i)
         RES_abi_M(i) = 0.5/sintl_abi_M(i)
      end do
      
      ifMinQ = 0
      if (ifMinQ == 1) then
        p = sum(esse(1:Nbin)**2)
        q = sum(esse(1:Nbin))
        r = sum(Eo2Ec2Med(1:Nbin)*esse(1:Nbin))
        t = sum(Eo2Ec2Med(1:Nbin))
      
        a = (Nbin*r-t*q) / (Nbin*p-q**2)
        b = (p*t-r*q) / (Nbin*p-q**2)
      
        do i=1,Nbin
          Eo2Ec2Med(i) = a * esse(i) + b
        end do
      end if
      
      do ii=1,Nbin
       do i=1,Nbin
       dif=Eo2Ec2Med_old(i) - eeShell(i)
        if (dif < 0.01) then
          if (i == Nbin) then
            Eo2Ec2Med_old(i)=Eo2Ec2Med_old(i-1)
          elseif (i == 1) then
            Eo2Ec2Med_old(i)=Eo2Ec2Med_old(i+1)
          else
            Eo2Ec2Med_old(i)=0.5*(Eo2Ec2Med_old(i-1) + 
     *              Eo2Ec2Med_old(i+1))
          endif
        endif
       enddo
      enddo

      if (iprint == 1) then
         write(lo,'(a)') ' shell     RES        sint/l         sigmaA'  
     
         write(lo,'(i4,2f7.2,2f7.3,e35.25)')(i,RES_abi(i), RES_abi_M(i),
     *                        Sintl_abi(i),Sintl_abi_M(i),
     *                        Eo2Ec2Med_old(i),i=1,Nbin)
      end if
 
      return  
      end
!-----------------------------------------------------------------------
      subroutine Calcola_SigmaA(Ratt)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule, only : ksize_vero, LowRes, ifMDM
      USE ShellSIGMAA
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_3

      implicit none
      integer :: i, j
      real    :: Ratt, Eo2Ec2Med(50), Eo2Ec2Med_old(50), Dluzi
      real    :: aregr, bregr

      call PresigmaA_VLD(Eo2Ec2Med, Eo2Ec2Med_old, RES_TAG, Nbin)

      do i = 1, Nbin
         if (Eo2Ec2Med_old(i) > 1.99)then
            Eo2Ec2Med_old(i)= 1.99
         end if
      end do

! eventuale linearizzazione

      if (ifMDM == 0) then
         if (ksize_vero > 3) then
             if (ifDsrVLD == 0) then
                 call Linearizza_SA(Ratt,Eo2Ec2Med_old,aregr,bregr)
             else
                 if (LowRes == 0) then
                     if (knw == 1) then
                         write(lo,*)' NON APPLICO Linearizza_SA'
                    end if
                 else
                     call Linearizza_SA(Ratt,Eo2Ec2Med_old,aregr,bregr)
                 end if
             endif
         end if
      end if

      do i=1, nrefl
          j = RES_TAG(i)
          Dluzi = Eo2Ec2Med_old(j) - es(i)
          if (Dluzi < 0.0) Dluzi = 0.0
          Dluz(i) = sqrt(Dluzi)
          if (Dluz(i) > sog_sigmaA) Dluz(i)=sog_sigmaA
      end do

      amed_Dl = sum(Dluz(1:nrefl))/nrefl
      amed_Dl_orig = amed_Dl

      return
      end
!-----------------------------------------------------------------------
      subroutine PresigmaA_VLD(Eo2Ec2Med, Eo2Ec2Med_old,
     *                         RES_TAG, Nbin)
     
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE RuotaRiflessi
      USE RemoModule
      USE VLDmod_1 , only : ksigma_pg
      USE VLDmod

      dimension Eo2Ec2Med(50)
      dimension Eo2Ec2Med_old(50)
      
      integer RES_TAG(nrefl)
!
      iworkt(1:nrefl) = iphaz(1:nrefl)
      wt(1:nrefl) = 1.

      if (knw > 0) then
          call Trasla_Origine(nrefl)
      endif

canna
      if(use_E)then
         nreflsav = nrefl
         nrefl=nreflSelTra
      endif
canna  

!
!--non considero i valori di sigma nel calcolo della
!  sigmaA se questi non hanno significato fisico
!
      if(ksigma_pg<=0) ifnoEE=1
!
!-- pesMod contiene il nuovo peso Sim
!
      if (kmad /= 0) then
          iphaz_in(1:nreflDim) = iphaz(1:nreflDim)
          wt_in(1:nreflDim) = wt(1:nreflDim)
      endif
 
      call sigmaA_VLD(fovet, evet, fcvet, mkang, sigmav, epsv,rhov,
     *                      ipub, iphaz,
     *                      Eo2Ec2Med, Eo2Ec2Med_old,
     *                      ifnoEE, nrefl)
     
canna
      if(use_E) nrefl=nreflsav
canna
      if (ifPert == 0) then
          iphaz(1:nrefl) = iworkt(1:nrefl)
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine ControllaLabel
      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
!
!-- subroutine to re-label peaks according only to
!-- the relative peak height and to the cell content
!
!-- nw(i) = number of atoms of the i-th specie
!-- no(i) = Z of atom of the i-th specie
!
      
      nz(:) = nz(:)/nzConst
      
      k=0
      do i = 1, nats
         if (nz(i) > 0) then
            if (no(nz(i)) <= 8) then
               k = i
               exit
            end if
         end if
      end do
      
      if (k > 1) then
         do j=1, k-1
            if (nz(j) > 0) then
               rap_nz = float(no(nz(j)))/no(nz(k))
               if (xyzs(4,j)/xyzs(4,k) < 0.35 * rap_nz) then
                  nz(j) = nz(k)
               end if
            end if
         end do
      end if
             
      nz(:) = nz(:)* nzConst
      return
      end
!-----------------------------------------------------------------------
      subroutine pherrdisNew_VLD(tirang,dij,khl,mkang,nrif,ic,
     *                  ia,ib,c,nrang1,rmax1,ipher,soglia_PrCy,ifInv)
! --- (tirang,wt,khl,numbMax,izero,
!                       ipub,iphaz,tmpwt,10,0.0,ipher) 
      USE General
      USE PhaseModule
!
      dimension khl(3,nrif),mkang(nrif)
      dimension ia(nrif),ib(nrif),c(nrif),dij(nrif)
      dimension his(201),cumde(201),range(201),
     * disa1(201),disb1(201),disa2(201),disb2(201),
     * cumerr1(201),cumerr2(201),cumerp1(201),cumerp2(201),
     * csegni(201),cumse(201),cmed(201),ccmed(201)
      character tirang*11
      integer his, cumde, ierv(3)

      real,    allocatable :: dijs(:)
      integer, allocatable :: jorde(:), jorde1(:)

      if (ipher < 0 .or. ifExamin == 0) return    ! 27/7/2010 dedi - per uscire dalla subroutine
      if (ifTime == 1) return

      if (ipher.eq.0) then
          lll = -444
          ifmin = 10
          call examin(lll,mkang,khl,ia,ib,nrif,ic,c,ifmin)
      endif
      if (knw.eq.0) return 
      
      if (ipher == 1) return
      
      if (nrif.le.0) then
         write(lo,*) ' nrif = 0'
        return
      endif
c--
      ierv(:) = 0
      IF (.NOT. ALLOCATED(dijs))
     *    ALLOCATE (dijs(1:nreflDim),  stat = ierv(1))
      IF (.NOT. ALLOCATED(jorde))
     *    ALLOCATE (jorde(1:nreflDim), stat = ierv(2))
      IF (.NOT. ALLOCATED(jorde1))
     *    ALLOCATE (jorde1(1:nreflDim),stat = ierv(3))
      ierr = sum(iabs(ierv(:)))
      if (ierr.ne.0) then
          write(lo,*) 'PherrDisNew Allocation error'
          call cstop(' ')
      endif
      do i=1,nrif
         jorde(i) = i
      enddo
      nrang = 10
      if (nrang1.gt.0)   nrang = nrang1
      if (nrang1.gt.200) nrang = 200
      itot=0
      sumsegni=0.0
      sumdif1=0.0
      sumdisb1=0.0
      sumdif2=0.0
      sumdisb2=0.0
      sumc=0.0
      do i=1,201
         range(i)=0.0
         his(i)=0
         cumde(i)=0
         cumse(i)=0.0
         csegni(i)=0.0
         cmed(i)=0.0
         disa1(i)=0.0
         disb1(i)=0.0
         cumerr1(i)=0.0
         cumerp1(i)=0.0
         disa2(i)=0.0
         cumerr2(i)=0.0
         cumerp2(i)=0.0
         disb2(i)=0.0
         ccmed(i)=0.0
      enddo
      rmin=99999.
      rabs=99999.
      rmax=-99999.
      ii=0
      do i=1,nrif
         if (i.le.ic) cycle
         kk=jorde(i)
         if (kk.eq.0.or.kk.gt.nrif) write(lo,*)kk
         if (c(kk).le.0.0) cycle
         ii=ii+1
         dijs(ii)=dij(kk)
         jorde1(ii)=kk
         if (abs(dij(kk)).lt.rabs) rabs=abs(dij(kk))
         if (dij(kk).lt.rmin) rmin=dij(kk)
         if (dij(kk).gt.rmax) rmax=dij(kk)
      enddo
      numsort=ii
      if (rmax.eq.rmin) then
          write(lo,*) ' rmax = rmin '
          return
      endif
      call sortall3(1,dijs,1,numsort,jorde1)
      
      soglia_PrCy = dijs(numsort-100)
      
      if (rmin.lt.0.0) then
          rmax=amax1(rmax,abs(rmin))
          rmin=-1.0*rmax
      endif
      rmaxg=rmax
      rming=rmin
      if (rmax1.gt.0.0) then
          rmax=rmax1
          if (rmin.lt.0.0) rmin=-1.0*rmax
      endif

c--
      dev=rmax-rmin
      iaa=nint(dev)
      rang=float(nrang)
      if (iaa.gt.0) then
          dev=float(iaa)/rang
      else
          dev=dev/rang
      end if
      if (rmin.ge.0.0) then
          range(1)=float(int(10.*rmin))/10.
          do i=2,nrang
             range(i)=range(i-1)+dev
          enddo
      else
          range(1)=float(nint(10.*rmin))/10.
          nrangi=nint(rang/2.0)
          nrang=2*nrangi
          dev=rmax-rabs
          dev=dev/float(nrangi)
          do i=2,nrangi-1
             range(i)=range(i-1)+dev
          enddo
          range(nrangi)=-rabs
          range(nrangi+1)=rabs
          do i=nrangi+2,nrang
             range(i)=range(i-1)+dev
          enddo
      endif
c     range(1)=rmin
      range(1)=rming
      nrang=nrang+1
      range(nrang)=rmax
      range(nrang+1)=rmaxg
c--
10001 n=2
      do i=1,numsort
         k=jorde1(i)
         jh = khl(1,k)
         jk = khl(2,k)
         jl = khl(3,k)
         shiftp=jh*shiftexam(1)+jk*shiftexam(2)+jl*shiftexam(3)
         shiftp=360.* shiftp + ia(k)
         dif1=shiftp - ib(k)
         dif2=shiftp + ib(k)
         dif1=abs(amod(dif1,360.))
         if (dif1.gt.180.)dif1=360.-dif1
         dif2=abs(amod(dif2,360.))
         if (dif2.gt.180.)dif2=360.-dif2

   17    if (dijs(i).le.range(n)) then
             his(n)=his(n)+1
         else
             n=n+1
             if (n.gt.nrang) n=nrang+1
             goto 17
         endif
         disa1(n)=disa1(n)+dif1
         disa2(n)=disa2(n)+dif2
         disb1(n)=disb1(n)+dif1*c(k)
         disb2(n)=disb2(n)+dif2*c(k)
         cmed(n)=cmed(n)+c(k)
      enddo
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      do i=2, nrang
         if (his(i) > 0.2*numsort) then
            nrang = nrang + 1
            do j=nrang,i+1,-1
               range(j) = range(j-1)
            end do
            range(i) = (range(i-1)+range(i))/2
            his(:) = 0
            disa1(:) = 0.0
            disa2(:) = 0.0
            disb1(:) = 0.0
            disb2(:) = 0.0
            cmed(:) = 0.0
            goto 10001
         end if
      end do
*-----cumulative
      cumerp1(nrang+1)=disb1(nrang+1)
      cumerp2(nrang+1)=disb2(nrang+1)
      ccmed(nrang+1)=cmed(nrang+1)
      do i=1,nrang
         cumerp1(nrang+1-i)=cumerp1(nrang+2-i)+disb1(nrang+1-i)
         cumerp2(nrang+1-i)=cumerp2(nrang+2-i)+disb2(nrang+1-i)
         ccmed(nrang+1-i)=ccmed(nrang+2-i)+cmed(nrang+1-i)
      enddo
*-----
      do i=1,nrang+1
         if (his(i).gt.0) then
             itot=itot+his(i)
             sumdif1=sumdif1+disa1(i)
             sumdif2=sumdif2+disa2(i)
             sumdisb1=sumdisb1+disb1(i)
             sumdisb2=sumdisb2+disb2(i)
             sumc=sumc+cmed(i)
             sumsegni=sumsegni+csegni(i)
             disa1(i)=disa1(i)/float(his(i))
             disa2(i)=disa2(i)/float(his(i))
             disb1(i)=disb1(i)/cmed(i)
             disb2(i)=disb2(i)/cmed(i)
             csegni(i)=csegni(i)/float(his(i))
             csegni(i)=100.*csegni(i)
         else
             disa1(i)=0.0
             disa2(i)=0.0
             disb1(i)=0.0
             disb2(i)=0.0
             csegni(i)=0.0
             cmed(i)=0.0
         endif
      enddo
      if (itot.le.0) then
          write(lo,*) ' itot = 0'
          return
      endif
      tot=float(itot)
      segnim=100.*sumsegni/tot
      dif1m=sumdif1/tot
      dif2m=sumdif2/tot
      disb1m=sumdisb1/sumc
      disb2m=sumdisb2/sumc
c-----cumulative 
      cumde(nrang+1)  =his(nrang+1)
      cumse(nrang+1)  =float(his(nrang+1))*csegni(nrang+1)
      cumerr1(nrang+1)=float(his(nrang+1))*disa1(nrang+1)
      cumerr2(nrang+1)=float(his(nrang+1))*disa2(nrang+1)
      do i=1,nrang
         cumde(nrang+1-i)  =cumde(nrang+2-i)+his(nrang+1-i)
         cumse(nrang+1-i)  =cumse(nrang+2-i)+csegni(nrang+1-i)*
     *                      float(his(nrang+1-i))
         cumerr1(nrang+1-i)=cumerr1(nrang+2-i)+disa1(nrang+1-i)*
     *                      float(his(nrang+1-i))
         cumerr2(nrang+1-i)=cumerr2(nrang+2-i)+disa2(nrang+1-i)*
     *                      float(his(nrang+1-i))
      enddo

      if (knw.eq.1) write(lo,200) tirang
      if (knw.eq.0) write(lo,250) tirang
      if(ifInv == 1) then
         range(:) = -range(:)
      end if
      do i=2,nrang+1
         if (his(i).eq.0) cycle
         if (knw > 0)then
             if (shiftexam(4).gt.0.) then
                 write(lo,100) range(i-1),range(i),his(i),
     *                 disa1(i),disb1(i),cumde(i),
     *                 cumerr1(i)/float(cumde(i)),cumerp1(i)/ccmed(i)
             else
                 write(lo,100) range(i-1),range(i),his(i),
     *                 disa2(i),disb2(i),cumde(i),
     *                 cumerr2(i)/float(cumde(i)),cumerp2(i)/ccmed(i)
             endif
         else
             write(lo,150) range(i-1),range(i),his(i),cumde(i)
         endif
      enddo

      write(lo,"(24x,42('.'))")
      if (knw.gt.0) then
          if (shiftexam(4).gt.0.) then 
              write(lo,300)itot,dif1m,disb1m
         else
              write(lo,300)itot,dif2m,disb2m
          endif
      else
          write(lo,300)itot
      end if
  100 format(f10.4,'  - ',f10.4,i8,2f7.2,'  |',i8,2f7.2)
  150 format(f10.4,'  - ',f10.4,i8,'  |',i8)
  200 format(/,11x,a11,6x,' HIS',
     *      '  <err> <w-err>',' | ',
     *      '    CUM',
     *      '  <err> <w-err>')
  250 format(11x,a11,6x,'HIS',3x,'CUM')
  300 format(34x,i8,2f7.2,/)
c
      ipher = 0
      DEALLOCATE (dijs, jorde, jorde1, stat = ierr)
      if (ierr.ne.0) then
          write(*,*) 'PherrDisNew DeAllocation Error'
          call cstop(' ')
      endif
c
      return
      end
c------------------------------------------------------------------
      subroutine weightsdis_VLD(tirang,dij,khl,nrif,ic,
     *                      ia,ib,c,nrang1,rmax11,ipher)
! --- (tirang,wt,khl,numbMax,izero,
!                       ipub,iphaz,tmpwt,10,0.0,ipher)
      USE General
      USE PhaseModule
!
      dimension khl(3,nrif)
      dimension ia(nrif),ib(nrif),c(nrif),dij(nrif)
      dimension his(201),cumde(201),range(201),
     * disa1(201),disb1(201),disa2(201),disb2(201),
     * cumerr1(201),cumerr2(201),cumerp1(201),cumerp2(201),
     * csegni(201),cumse(201),cmed(201),ccmed(201)
      character tirang*11
      integer his,cumde,ierv(2)

      real, allocatable    :: dijs(:)
      integer, allocatable :: iorde1(:)

c--
      if (ipher.eq.0) return   ! ipher = 1 esegue la statistica
      if (knw.eq.0) return
      if (nrif.le.0) then
         write(lo,*) ' nrif = 0'
        return
      endif
c--
      ierv(:) = 0
      IF (.NOT. ALLOCATED(dijs))
     *    ALLOCATE (dijs(1:nreflDim),  stat = ierv(1))
      IF (.NOT. ALLOCATED(iorde1))
     *    ALLOCATE (iorde1(1:nreflDim),stat = ierv(2))
      ierr = sum(iabs(ierv(:)))
      if (ierr.ne.0) then
          write(lo,*) 'WeightsDis Allocation error'
          call cstop(' ')
      endif

      nrang=10
      rmax1=rmax11
      if (nrang1.gt.0) nrang=nrang1
      if (nrang1.gt.200) nrang = 200
      itot=0
      sumsegni=0.0
      sumdif1=0.0
      sumdisb1=0.0
      sumdif2=0.0
      sumdisb2=0.0
      sumc=0.0
      do i=1,201
         range(i)=0.0
         his(i)=0
         cumde(i)=0
         cumse(i)=0.0
         csegni(i)=0.0
         cmed(i)=0.0
         disa1(i)=0.0
         disb1(i)=0.0
         cumerr1(i)=0.0
         cumerp1(i)=0.0
         disa2(i)=0.0
         cumerr2(i)=0.0
         cumerp2(i)=0.0
         disb2(i)=0.0
         ccmed(i)=0.0
      enddo
      rmin=99999.
      rabs=99999.
      rmax=-99999.
      ii=0
      do 5 i=1,nrif
       if (i.le.ic) goto 5
       kk=i
       if (dij(kk) == 0.0) goto 5
       if (kk.eq.0.or.kk.gt.nrif) write(6,*)kk
!      if (c(kk).le.0.0.or.dij(kk).eq.0.0) goto 5
       ii=ii+1
       dijs(ii)=dij(kk)
       iorde1(ii)=kk
       if (abs(dij(kk)).lt.rabs) rabs=abs(dij(kk))
       if (dij(kk).lt.rmin) rmin=dij(kk)
       if (dij(kk).gt.rmax) rmax=dij(kk)
    5 continue
      numsort=ii
      if (rmax.eq.rmin) return 
      if (numsort.eq.0) return 
      call sortall3(1,dijs,1,numsort,iorde1)
      nsogrmax=nint(0.99*numsort)
      rmax1=dijs(nsogrmax)
      if (rmin.lt.0.0) then
          rmax=amax1(rmax,abs(rmin))
          rmin=-1.0*rmax
      endif
      rmaxg=rmax
      rming=rmin
      if (rmax1.gt.0.0) then
        rmax=rmax1
        if (rmin.lt.0.0)rmin=-1.0*rmax
      endif

c--
      dev=rmax-rmin
      iaa=nint(dev)
      rang=float(nrang)
      if (iaa.gt.0) then
          dev=float(iaa)/rang
      else
          dev=dev/rang
      end if
      if (rmin.ge.0.0) then
         range(1)=float(int(10.*rmin))/10.
         do 12 i=2,nrang
            range(i)=range(i-1)+dev
  12     continue
      else
         range(1)=float(nint(10.*rmin))/10.
         nrangi=nint(rang/2.0)
         nrang=2*nrangi
         dev=rmax-rabs
         dev=dev/float(nrangi)
         do 13 i=2,nrangi-1
            range(i)=range(i-1)+dev
  13     continue
         range(nrangi)=-rabs
         range(nrangi+1)=rabs
         do 14 i=nrangi+2,nrang
            range(i)=range(i-1)+dev
  14     continue
      endif
      range(1)=rming
      range(nrang)=rmaxg
c--
      n=2
      do 15 i=1,numsort
        k=iorde1(i)
        jh = khl(1,k)
        jk = khl(2,k)
        jl = khl(3,k)
        shift=jh*shiftexam(1)+jk*shiftexam(2)+jl*shiftexam(3)
        shift=360.* shift + ia(k)
        dif1=shift - shiftexam(4)*ib(k)
        dif2=shift + ib(k)
        dif1=abs(amod(dif1,360.))
        if (dif1.gt.180.)dif1=360.-dif1
        dif2=abs(amod(dif2,360.))
        if (dif2.gt.180.)dif2=360.-dif2

   17   if (dijs(i).le.range(n)) then
            his(n)=his(n)+1
        else
            n=n+1
            if (n.gt.nrang) n=nrang+1
            goto 17
        endif
       disa1(n)=disa1(n)+dif1
       disa2(n)=disa2(n)+dif2
       disb1(n)=disb1(n)+dif1*c(k)
       disb2(n)=disb2(n)+dif2*c(k)
       cmed(n)=cmed(n)+c(k)
   15 continue

      do i=1,nrang-1
        args=0.5*(range(i) + range(i+1))
        args=min(args,1.0)
        csegni(i)=rtod*acos(args)
        args=sum(range(i:nrang))
        args=args/float(nrang-i+1)
        args=min(args,1.0)
        cumse(i)  = rtod*acos(args)
      enddo

*-----cumulative
      cumerp1(nrang)=disb1(nrang)
      cumerp2(nrang)=disb2(nrang)
      ccmed(nrang)=cmed(nrang)
      do i=1,nrang-1
        cumerp1(nrang-i)=cumerp1(nrang+1-i)+disb1(nrang-i)
        cumerp2(nrang-i)=cumerp2(nrang+1-i)+disb2(nrang-i)
        ccmed(nrang-i)=ccmed(nrang+1-i)+cmed(nrang-i)
      enddo
*-----
      do 20 i=1,nrang
         if (his(i).gt.0) then
            itot=itot+his(i)
            sumdif1=sumdif1+disa1(i)
            sumdif2=sumdif2+disa2(i)
            sumdisb1=sumdisb1+disb1(i)
            sumdisb2=sumdisb2+disb2(i)
            sumc=sumc+cmed(i)
            sumsegni=sumsegni+csegni(i)
            disa1(i)=disa1(i)/float(his(i))
            disa2(i)=disa2(i)/float(his(i))
            disb1(i)=disb1(i)/cmed(i)
            disb2(i)=disb2(i)/cmed(i)
         else
            disa1(i)=0.0
            disa2(i)=0.0
            disb1(i)=0.0
            disb2(i)=0.0
            cmed(i)=0.0
         endif
   20 continue
      if (itot.le.0) return
      tot=float(itot)
      dif1m=sumdif1/tot
      dif2m=sumdif2/tot
      disb1m=sumdisb1/sumc
      disb2m=sumdisb2/sumc
c-----cumulative 
      cumde(nrang)  =his(nrang)
      cumerr1(nrang)=float(his(nrang))*disa1(nrang)
      cumerr2(nrang)=float(his(nrang))*disa2(nrang)
      do 25 i=1,nrang-1
        cumde(nrang-i)  =cumde(nrang+1-i)+his(nrang-i)
        cumerr1(nrang-i)=cumerr1(nrang+1-i)+disa1(nrang-i)*
     *                   float(his(nrang-i))
        cumerr2(nrang-i)=cumerr2(nrang+1-i)+disa2(nrang-i)*
     *                   float(his(nrang-i))
   25 continue

      if (knw.eq.1) write(lo,210)tirang
      if (knw.eq.0) write(lo,250)tirang
      do 30 i=2,nrang+1
      if (his(i).eq.0) go to 30
      if (knw.gt.0 )then
       csegni1=csegni(i-1)
       cumse1=cumse(i-1)
        write(lo,110) range(i-1),range(i),his(i),csegni1,
     *                disa1(i),disb1(i),
     *                cumde(i),cumse1,
     *                cumerr1(i)/float(cumde(i)),cumerp1(i)/ccmed(i)
      else
      write(lo,150) range(i-1),range(i),his(i),cumde(i)
      endif
   30 continue
      write(lo,"(24x,42('.'))")
      if (knw.gt.0) then
       write(lo,310)itot,cumse(1),dif1m,disb1m
      else
       write(lo,300)itot
      end if
  100 format(f10.4,'  - ',f10.4,i7,5f7.2,' |',i7,5f7.2)
  110 format(f10.4,'  - ',f10.4,i7,3f7.2,' |',i7,3f7.2)
  150 format(f10.4,'  - ',f10.4,i7,' |',i7)

  210 format(11x,a11,6x,'HIS',1x,'<err>c',
     *      '  <err> <w-err>','|',
     *      '   CUM',2x,'<err>c',
     *      '  <err> <w-err>')

  250 format(11x,a11,6x,'HIS',3x,'CUM')
  300 format(24x,i7,5f7.2,/)
  310 format(24x,i7,3f7.2,/)
c
      ipher = 0
      DEALLOCATE (dijs, iorde1, stat = ierr)
      if (ierr.ne.0) then
          write(*,*) 'WeightsDis DeAllocation Error'
          call cstop(' ')
      endif
c
      return
      end
!---------------------------------------------------------------------------------------
      subroutine RAFFI_VLD(ifGoOn, ifBreak)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom          
      USE PhaseModule
      USE PhaseStuff
      USE Mappa
      USE Grafici
      USE HistoStuff
      USE Html
      USE Param
      USE MadModule
      USE TestModel
      USE VLDmod
      USE VLDmod_3
      USE Tutto
!
      integer :: jpercBarraSav, npercBarraSav, AggiornaFasi
!
      if (ifOUT == 1) write(6,*) 'INGRANA'
      
       ifGoOn = 0
       ifBreak = 0
       iCoeff = 0
       mode = 1
       iref=0

       nundet = 0
       izero = 0
       ifmin = 0
       nbru = -2
       call examin(nbru,mkang,khl,ipub,iphaz,nstr,izero,
     *      wt,ifmin)
       if ( knw /= 0 .and. ifTime == 0) then
          write (lo,14)  erore, erorepes, isumal
       end if
       
       nbru = -2
       call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,
     *      wt,ifmin)
       if ( knw /= 0 .and. ifTime == 0) then
          write (lo,14)  erore, erorepes, isumal
       end if

      
       ksubr = 4
       call AggiornaFasiPesiNew(ksubr, wt, iphaz, fcvet)
 
       nundet = 0
       izero = 0
       ifmin = 0
       nbru = -2
       call examin(nbru,mkang,khl,ipub,iphaz,nstr,izero,
     *      wt,ifmin)
       if (knw /= 0 .and. ifTime == 0) then
          write (lo,14)  erore, erorepes, isumal
 14       format(9x,' Fragment - Mean Phase Error ',f7.2,
     *        '  (',f7.2,')  over',i8,' reflections')
       end if
          

       if (ifRelax.eq.1) then
           ncicla = 2
       else
           ncicla = 1
       endif
                     
       kWstop = 0
       
       erreNoWind = 0
       fomnowind = 0.0
       ier = 0
!
       call ScriviCicloVLD(numero_cicli, numbrun, 
     *          FinalFom2, Rat_VLD, perc_cammino_control)
       if (nolsq /= 0) then
           if (ksize_vero < 3 .or. neutro /= 0) then
               call CalcFFomVLD(0,0.0)
           endif
           call dlsq(ier,ncicla,erreNoWind, fomNoWind, 0,ifBreak)
           if (kWstop == 1) then
               AggiornaFasi = 1
               if (ksize < 3) then
                   FinalFom2 = FinalFom
               endif
               call SalvaFasi(1, FinalFom2, corre_VLD, AggiornaFasi)
               call ccorr_VLD(evet,fcvet,wt,nrefl, corre_VLD)
               correBestVLD = corre_VLD
           endif
       elseif (ifRelax == 1) then
*          call ScriviCicloVLD(numero_cicli, numbrun, 
*    *          FinalFom2, Rat_VLD, perc_cammino_control)
           numbR = min0(nreflDim,8000)
           BackPh(1:numbR) = iphaz(1:numbR)
           BackWt(1:numbR) = wt(1:numbR)
           ifBreak = 0
           ier = 0
           jpercBarraSav = jpercBarra
           npercBarraSav = npercBarra
           call Relax(ier, fomNoWind, ifGoOn, ifBreak)
           if (ifMDM == 1) then
              nSeedRelax = numbrun
           end if
           jpercBarra = jpercBarraSav
           npercBarra = npercBarraSav
       endif
       
       return
       end               
!-----------------------------------------------------------------------
      subroutine EndTrialVLD
      USE General
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE VLDmod
      USE VLDmod_3
      USE Molcom, only : color_GREEN
      USE TestModel, only : naatoms
      USE RfacMatrixModule
!
      implicit none
      integer :: ifRelaxTrial, izero, ifmin, nbru, ifTimeSav
      integer :: iref, mode, numb, ifBreak, iCoeff, im, iz, ifRelaxSav
      integer :: ier, ncicla, Lung, ksizeSav
      integer :: L, ii, jop, jopen, itype, iform, ierr, ifExaminSav
      real    :: corre, scalan, mpe, erreNoWind, fomNoWind, erreSav
      character (len= 8) :: errec
!
      
      ifTimeSav = ifTime
      ksizeSav = ksize
      ifRelaxSav = ifRelax
      nolsqSav = nolsq
      ifTime = 0
      mpe = 0.0
      if (ksize <= 3) then
          if (InfoOK(15) == 1) then                    ! piccole molecole
              if (kWstop == 0) then
!
!-- recover best model
!
                  call PutGetBackUpXyzs(2)
!
!-- compute corresponding phases
!
                  erreSav = errem
                  nzSav(1:nats) = nz(1:nats)
                  nz(1:nats) = iabs(nz(1:nats)) / nzConst
                  iref    = 0
                  mode    = 1
                  scalan  = 0
                  ifBreak = 0
                  iCoeff  = 2
                  call sftryyyc(iref, mode, nrefl,scalan,ifBreak,iCoeff)
                  nz(1:nats) = nzSav(1:nats)
                  erre = erreSav
              endif

          call SalvaFasi(2, 0.0, 0.0, 0)
          corre = 0.0
          FinalFom = erre
          call ManagePhasesDSR(1,corre,0)

          endif
      else                                         ! proteine
!
!-- per il futuro:
!    in caso di proteine non abbiamo un modello ma solo delle fasi
!    dovremo conservarci fasi/pesi ogni volta che la fFom risulta migliore
!    (equivalentemente al best model), arrivati in questa subr. dobbiamo
!    fare un restore in iphaz/wt di questa quantità e andare avanti
!
          
          call SalvaFasi(2, 0.0, 0.0, 0)
          corre = 0.0
          FinalFom = fomBestVLD
          call ManagePhasesDSR(1,corre,0)
!
          if (kWstop == 0 .and. ksize_vero == 3) then
!pg27012014
             if (ifMDM == 0) then
                write(lo,16) numero_cicli, numbrun
             end if
             ncicla = 1
             kWstop = 0
             ksize = 3 
             ifRelax = 0
             nolsq = -1
             ifBreak = 0
             call ClessidraOnOff(1)
             Msg = 'End of Trial: automatic Diagonal Least Squares ...'
             call TestoGR(Msg, color_GREEN, 2, 3)
             write(lo,'(12x,a)') Msg(1:Lung(Msg))
             call scrper(Msg, 0, 0)
             call dlsq(ier,ncicla,erreNoWind, fomNoWind, 0,ifBreak)
             if (ifMDM == 1) then
                nSeedDLSQ = numbrun  
             end if
             if (erre < erreBestVLD) then
                 erreBestVLD = erre
             endif
             if (erre < RSoglia/100.0) then
                 numero_cicli = cicloBestVLD
                 nTrialsVLD = numbrun
                 kWstop = 1
                 call SolutionFound(1, 0)
                 naatoms_max = naatoms
                 numero_cicli_max  = cicloBestVLD
                 numbrun_max = numbrun
             endif
             rvetVLD(numbrun) = erre * 100
             L = index(fname(1),'.bin') - 1
             write(Inte,80) fname(1)(1:L), numbrun,ExportExtension
             call NoBlanks(Inte, L)
! per non creare il file .res per ogni seed
!             itype = 0
!             iform = 1
!             jop=jopen(jhost, Inte, itype, iform, ierr)
!             if (ifExportShelx == 1) then
!                 call outShelx(0)
!             else
!                 call outPDB(jhost, numbrun, 1, 0)
!             endif
!             close(jhost)
*            write(Msg,100) erreBestVLD*100
             write(Msg,100) abs_erreBestVLD*100
             call OneBlankOnly(Msg)
             call TestoGR(Msg, color_GREEN, 2, 3)
             call ClessidraOnOff(2)
          endif
      endif
      if (knw == 1) then
          ifExaminSav = ifExamin
          ifExamin = 1
          iz = 0
          im = 0
          call examin(1, mkang, khl, ipub, iphaz, nrefl, iz, wt, im)
          mpe = erore
          ifExamin = ifExaminSav
      endif
!
      RfacMatrix(1,numbrun,1) = numbrun
      RfacMatrix(2,numbrun,1) = mpe
      RfacMatrix(3,numbrun,1) = fomBestVLD
      RfacMatrix(4,numbrun,1) = erreBestVLD * 100.0
      if (knw > 0) then
          if (erreBestVLD > 0.0 .and. erreBestVLD < 0.99) then
              write(errec,'(f7.2,"%")') erreBestVLD*100.0
          else
              errec = '  n.a.  '
          endif
          write(6,'(a,2i4,2x,a,f12.3,f12.2)') 
     *          'EndTrialVLD - trial - ciclo, R, fom, mpe  = ',
     *           numbrun, cicloBestVLD, errec, fomBestVLD, mpe
      endif
!
      ifTime = ifTimeSav
      ifRelax = ifRelaxSav
      nolsq = nolsqSav
      ksize = ksizeSav
!
      return
!pg27012014
   16 format(/,' Cycle ',i4,' Trial ',i4)
   80 format(a,2x,'_',i6,'.',a3)
  100 format('Final R value is ',f8.2,'%')
      end               
!-----------------------------------------------------------------------
      subroutine EndDSR_VLD
      USE General
      USE Riflessi
      USE PhaseModule
      USE VLDmod
!
      implicit none
      integer :: ifRelaxTrial, ifExaminSav, izero, ifmin, nbru
      real    :: corre
!
!     call Calcola_FOM_Lib(0)
!     FinalFom = FOMs(2,4) / sogFinalFom
!     call Calcola_FOM_Lib(1)
!     diffCC = CCEoEc(2)-fomold(2)
!     FinalFom0=CCEoEc(1)*FOMs(2,4)*diffCC/(fomold(1)*fomold(3))
!     FinalFom = FinalFom0 / sogFinalFom
      if (knw == 1) then
          ifExaminSav = ifExamin
          ifExamin = 1
          izero = 0
          ifmin = 1
          nbru = numbrun
          call examin(nbru,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,ifmin)
          if(ifOUT==1 .and. knw /= 0) then
          write(6,*) 'EndTrialVLD 1 ',erore, erorepes
          end if
          izero = 0
          call Calcola_CC_Mappa(numbLSQ, corre, izero, 2)
          if(ifOUT==1 .and. knw /= 0) then
          write(6,*) 'EndTrialVLD 2 ',erore, erorepes
          end if
          ifExamin = ifExaminSav
      endif
      if (ksize <= 2) then
          FinalFom = 0.0
      endif
      if (ksize > 3) then
          if (numbrun /= numbrunOld) then
              ifRelaxTrial = 0
              numbrunOld = numbrun
          else
              ifRelaxTrial = 1
          endif
          call EndDSR(corre, ifRelaxTrial)
      end if
!
      return
      end               
!-----------------------------------------------------------------------
      subroutine CreaEnveVLD(ifBreak, ier)
      USE General
      USE Riflessi
      USE PhaseModule
!
      implicit none
      integer :: jpatt, numbDyn, ifBreak, ier, ifExaminSav
      integer :: izero, ifmin, nbru
      real    :: chope, aSav, correl
!
      aSav = aperc(1)
      write(6,*) 'INIZIO ENVELOPE'
      ifExaminSav = ifExamin
      ifExamin = 1
      nMicro = 4
      MetaMicro = nMicro / 2
      chope = 0.5
      invflag = 1
      numbDyn = numbLSQ
      jpatt = 0
      call Long_Env_New(numbDyn, jpatt)
      EnvePronta = 1
      do indiceMicro=1, nMicro
         percMap = 0.025
         call Inverti_NEW(numbDyn, chope, correl, ifBreak, ier)
         izero = 0
         ifmin = 1
         nbru = 1000 + indiceMicro
         call examin(nbru,mkang,khl,ipub,iphaz,numbDyn,izero,wt,ifmin)
      enddo
!
      ifExamin = ifExaminSav
      aperc(1) = aSav
      write(6,*) 'FINE ENVELOPE'
!
      return
      end               
!-----------------------------------------------------------------------
      subroutine ApplicaEnveVLD
      USE General
      USE PhaseModule
      USE Param
      Use Mappa
!
      implicit none
!
      iflat = 1
      Xflip = 0
      call flatmapOld(xmap,xenve,iflat,Xflip)
      if (v_p > 0.59) then
          if (LowRes == 0) then
             if (Complet > 0.9) then
                 percMap = percMap * 2.
             else
                 percMap = percMap * 1.5
             endif
          else
             if (ResEff < sogResEff) then
                 percMap = percMap * 3.!ultima
             endif
          endif
      else
          if (ResEff < sogResEff) then
              if (is3s2 > 3000 .and. (ResEff-resm)/resm < 0.1) then
                  percMap=percMap*3.
              endif
              if (ksize==4 .and. iwei = =0 .and. 
     *            LowRes == 0 .and. is3s2 > 1500) then
                  percMap = percMap * 2.
              endif
          endif
      endif
      percMap = min(percMap,0.5)
      if (LowRes == 1 .and. no(nk) < 20) then
              percMap = min(percMap, 0.05)
      endif
      if (knw == 1) write(lo,11) percMap
!
      return
   11 format('ENVELOPE APPLICATO',f7.3)
      end               
!-----------------------------------------------------------------------
      subroutine InitFinalFomVLD       !gl
      USE General
      USE PhaseModule
      USE Mappa
      USE VLDmod
      USE Param, only: v_p
!
!--calcolo il valore di riferimento per la FinalFom
!
      implicit none
!
*     sogFinalFom = 2.7
      if (ksize < 4) then
          sogFinalFom = 2.0
      else
          if (LowRes == 0) then
              if (resm < 1.0 .and. v_p > 0.8) then
                  sogFinalFom = 2.0
              elseif (resm < 1.0 .and. v_p < 0.8) then
                  if (iwei==0) then
                      sogFinalFom = 2.7
                  else
                      sogFinalFom = 2.0
                  endif
              else
                  sogFinalFom = 1.4
                  if (ksize > 5) sogFinalFom = 1.9
              endif
          else
              if (no(nk) < 20) then
                  sogFinalFom = 1.00
                  if (is3s2 < 1400) sogFinalFom = 0.5
              else
                  if (resm < sogResEff) then
                      sogFinalFom = 2.0
                      if (no(nk) > 40) sogFinalFom = 1.0
                  else
                      sogFinalFom = 1.5
                      if (ksize == 4) sogFinalFom = 1.0
                  endif
              endif
          endif
          if (resm > sogResEff + 0.1) then
              sogFinalFom = sqrt(anat/1000.0)*min(1.5/ResEff,0.78)
              sogFinalFom = max(sogFinalFom,0.7)!liberato2009
          endif
          if (ksize == 7) then
               sogFinalFom = 4.0
               if (is3s2 < 3500 .and. no(nk) >= 20) sogFinalFom = 5.0
               if (LowRes == 1) then
                  sogFinalFom = 2.0
                  if (ResEff > sogResEff .or. Complet < 0.99) then
                     sogFinalFom =sqrt(anat/1000.0)*min(1.5/ResEff,0.78)
                  endif
               endif
          endif
      endif
!
      iyrandSav = iyrand
      iyrand = 67543
      call RandomPhases_VLD
      call Calcola_FOM_Lib(1)
      fomold(1)  = CCEoEc(1)
      fomold(2)  = CCEoEc(2)
      fomold(3)  = FOMs(2,4)
      if (knw == 1) write(6,*) 'FOMOLD',fomold

      figuracce(1,1) = FOMs(2,2)  !num Rat
      figuracce(1,2) = FOMs(2,3)  !denom Rat
      figuracce(1,3) = FOMs(2,4)  !RAT
      figuracce(1,4) = fig_CC(1)  !CC all
      figuracce(1,5) = fig_CC(10) !comb  = CC large + 3 * CC weak
      figuracce(1,6) = fig_CC(2)  !CC lage
      figuracce(1,7) = fig_CC(4)  !CC weak
      figuracce(1,8) = fig_CC(4) * 3 !cc weak * 3

      if (kverbo_pg > 0) then
          write(6,10) figuracce(1,1:3)
          write(6,20) figuracce(1,4:5)
          write(6,30) figuracce(1,6:8)
      endif


 10   format(' Initial numRAT,denomRAT,RAT   ',3f10.5)
 20   format(' Initial CCall ,Combined       ',2f10.5)
 30   format(' Initial CClarge,CCweak,3CCweak',3f10.5)

      stopFFom  = stopFinalFom

      iyrand = iyrandSav
      xmap(:,:,:) = 0.0
!
      return
      end
!-----------------------------------------------------------------------
      subroutine exportVLD
      USE General
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Mappa
      USE TestModel
      USE PhaseStuff
!
      implicit none
      integer :: ier, ksubr, nsetP, iniz, ifin, jlig, jpatt, mode
      integer :: k, ifmin, izero, nbru, iref, iCoeff, ifBreak, Lung
      real    :: scalan, rfac
      character (len=11) :: StringaErre
!
      ksubr = 3
      call LeggiRiflessi(ier, ksubr)
      call LoadFinalPhases(FomsFineDSR, iposFineDSR, nsetFinalPhases)
      nsetP = iposFineDSR(1)
      call PutGetFinalPhases(2, nsetP, figMer)
      if (knw > 0) then
          ifExamin = 1
C         ifTime   = 0
          izero    = 0
          ifmin    = 1
          nbru     = -8888
          call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
      endif
      fcoef (1:nrefl) = evet(1:nrefl)
      jpatt = 0
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH, BACK)
      krecy = 0
      mode = -1
      aperc(1) = float(natm)
      call Search99(mode, ier, nrefl)
      if (no(1) == 1) then 
          jlig = 2
      else
          jlig = 1
      endif
      nz(1:nats) = jlig * nzConst
      ifin = nats
      call label(ifin)
      iniz = 1
      ifin = nats
      call MakeLab(iniz, ifin)
      iref    = 0
      iCoeff  = 2
      ifBreak = 0
      scalan  = 1.0
      nzSav(1:nats) = nz(1:nats)
      nz(1:nats) = iabs(nz(1:nats) / nzConst)
      bfac(1:nats) = bt
      call sftryyyc(iref, mode, nrefl, scalan, ifBreak, iCoeff)
      nz(1:nats) = nzSav(1:nats)
      if (knw > 0) then
          call to_coord_sir(-1, nrefl)          !gianluca
          write(lo,80) nint(vett_test(1:3)),erore,vett_test(4)
      endif
!
      StringaErre = ' n.a.  '
      errem = erre
      rfac  = errem * 100.0
      if (rfac > 0.0) then
          if (errem > 9998) then
              StringaErre = ' n.a.  '
          else
              write(StringaErre,'(f10.2,1h%)') errem * 100.
          endif
          call shift(StringaErre, ifin)
          write(Inte,'(i10)') nrefl
          call shift(Inte, k)
          write(lo,34) StringaErre(1:ifin), Inte(1:k)
      endif
!
      return
   34 format(//,' Final R value is ',a,' using ',a,' reflections',/)
   80 format(i5,' atoms published,',i5,' used, ',i5,' found. MPE =',
     *      f8.3,' <dist> = ',f8.3)
      end               
!-----------------------------------------------------------------------
      subroutine CalcFFomVLD(iAction, corre_VLD)
      USE General
      USE Riflessi, only : evet, fcvet, wt, fc_burla, iphaz_burla,iphaz,
     *      wt_burla
      USE PhaseModule
      USE VLDmod
      USE VLDmod_2
      USE VLDmod_3
      USE MappaPatterson , only: xmapSav
      USE Mappa , only: xmap
!
      implicit none
      integer :: iAction
      real    :: corre_VLD, espo
!
!-- save the map
!
      xmapSav(:,:,:) = xmap(:,:,:)
      if (ifMDM == 1) then
         iphaz_burla(1:nrefl) = iphaz(1:nrefl)
         fc_burla(1:nrefl) = fcvet(1:nrefl)
         wt_burla(1:nrefl) = wt(1:nrefl)
      end if
      if (iAction /= 0) then
!
!-- Calcola correlazione
!
          call ccorr_VLD(evet,fcvet,wt,nrefl, corre_VLD)
      endif
!
!-- Compute Final Fom
!
      if (ksize <= 3 .and. (ifMDM == 1 .and. kSavMDM <= 3)) then
          call Calcola_FOM_Lib(0)
          FinalFom0 = FOMs(2,4)
          FinalFom = FinalFom0 / sogFinalFom
      else
          call Calcola_FOM_Lib(1)
          diffCC = CCEoEc(2)-fomold(2)
          if (numbrun <= 10) then
              espo = 0.5
          else
              espo = 0.333
          endif
          if (diffCC > 0.001) then
              diffCC = diffCC**espo
          else
              diffCC = 0.001
          endif
          FinalFom0=CCEoEc(1)*FOMs(2,4)*diffCC/(fomold(1)*fomold(3))
          FinalFom = FinalFom0 / sogFinalFom
          
!          write(lo,'(/,a,/)') ' OLD FOM VLD ='
!          write(lo,'(a,3f10.5,/)')' CCall,Comb,Rat iniziali =',
!     *           fomold(1),fomold(2),fomold(3)
          
!          write(lo,'(a,/,5f10.5,/)')' CCall*Rat*(Comb-Combini) / CCall
!     *ini*Ratini',
!     *    CCEoEc(1),FOMs(2,4),(CCEoEc(2)-fomold(2)),fomold(1),fomold(3)
          
          if (ifMDM == 1) then
          
!          write(lo,'(/,a,/)') ' NEW FOM VLD ='
!          write(lo,'(a,3f10.5,/)')' CCall,Comb,Rat iniziali =',
!     *           fomold(1),fomold(2),fomold(3)

              FinalFom=CCEoEc(1)*FOMs(2,4)*CCEoEc(2)/       !!3rapporti
     *                  (fomold(1)*fomold(3)*fomold(2))    !!3rapporti
            
!          write(lo,'(a,/,6f10.5,/)')' CCall*Rat*CClarge/Callini*CClargei
!     *ni*Ratini',CCEoEc(1),FOMs(2,4),CCEoEc(2),
!     *     fomold(1),fomold(2),fomold(3)
          end if


          figuracce(2, 9) = CCEoEc(1)*FOMs(2,4)
          figuracce(2,10) = fomold(1)*fomold(3)
          figuracce(2,11) = diffCC
          figuracce(2,12) = FinalFom0
          figuracce(2,13) = FinalFom
          figuracce(2,14) = sogFinalFom

          if (knw /=0 .and. kverbo_pg > 0) then
             if (ifMDM == 1) then
                write(lo,'(a,3f12.5)')
     *          '  RATcur, RATini, rap',
     *          FOMs(2,4), fomold(3), FOMs(2,4)/fomold(3)
                write(lo,'(a,3f12.5)')
     *          '  CC(all)cur, CC(all)ini, rap ',
     *          CCEoEc(1), fomold(1), CCEoEc(1)/fomold(1) 
                write(lo,'(a,3f12.5)')
     *          '  CC(large)cur, CC(large)ini, rap ', 
     *          CCEoEc(2), fomold(2), CCEoEc(2)/fomold(2)
             else
 !               write(6,100) numbrun,numero_cicli,ntraslas
 !               write(6,10) figuracce(2,1:3)
 !               write(6,20) figuracce(2,4:5)
 !               write(6,30) figuracce(2,6:8)
 !               write(6,40) figuracce(2,9:11)
 !               write(6,50) figuracce(2,12:14)
             endif
          endif

      endif
!
      if (iAction /= 0) then
          FinalFom2 = FinalFom * corre_VLD
          if (ifMDM == 0) then
              call PlotFinalFomVLD(iAction)
          else
              call PlotFinalFomMDM(iAction)
          endif
      endif
!
!-- restore the map
!
      xmap(:,:,:) = xmapSav(:,:,:)
      if (ifMDM == 1) then
         fcvet(1:nrefl) = fc_burla(1:nrefl)
         wt(1:nrefl) = wt_burla(1:nrefl)
         iphaz(1:nrefl) = iphaz_burla(1:nrefl)
      end if
!
 10   format(' Current numRAT, denomRAT, RAT   ',3f10.5)
 20   format(' Current CCall , Combined        ',2f10.5)
 30   format(' Current CClarge, CCweak, 3CCweak',3f10.5)
 40   format(' Current numFFom,denomFFom,diffCC',3f10.5)
 50   format(' Current FFom0, FFom, sogFFom    ',3f10.5)
 100  format(' Current Trial, Ciclo, Relax > 0 ',3i5)

      return
      end
!-----------------------------------------------------------------------
      subroutine PlotFinalFomVLD(iAction)
      USE General
      USE VLDmod, only : WhichVldPlot
!
      implicit none
      integer :: iAction
!
      if (iAction > 0 .and. ksize > 3) then
          if (iAction == 1) then
*             WhichVldPlot = 1
*             call RWindMainWindow(2)
*             WhichVldPlot = 2
              WhichVldPlot = 2
              call RWindMainWindow(2)
          else
*             WhichVldPlot = 1
*             call RWindMainWindow(3)
*             WhichVldPlot = 2
              WhichVldPlot = 2
              call RWindMainWindow(3)
              call RWindMainWindow(4)
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PlotFinalFomMDM(iAction)
      USE General
      USE VLDmod, only : WhichVldPlot
      USE PhaseModule
      USE Molcom, only : ifMadEnv
      USE VLDmod_3, only : FinalFom2
      USE Grafici
      USE RfacMatrixModule
!
      implicit none
      integer :: iAction, npunti, iAct
!
*     write(0,*) 'subroutine PlotFinalFomMDM(',iAction,')', FinalFom2
!
! ATTENZIONE con + di 500 trials muore nella seguente
!
      RfacMatrix(3,numbrun,1) = FinalFom2
      if (MaxToStore > 1 .or. ifMadEnv > 0) then
          if (ksize_vero > 3) then
*             if (iAction == 2) then
*                 lPlots(2) = lPlots(2) - 1
*             endif
              iAct = 3
              npunti = 1
              call DataForGraph(iAct, npunti)
              lastBox = 3
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SameLine(string, colore, box)
!
      USE Grafici
      USE Molcom

      implicit none
      integer :: Lung, colore, box
      character (len=*) :: string
!
      if (kscreen <= 0) return
      if (inBoxGr(box) > 0) then
          if (box == 3) then
              inBoxGr(box) = inBoxGr(box) - 1
              nLinesGR = nLinesGR -1
          else
              if (nLinesGRsaveBox(box) > 0) then
                  nLinesGR=nLinesGRsaveBox(box)
              else
                  nLinesGRsaveBox(box)=nLinesGR
              endif
          endif
      else
        nLinesGRsaveBox(box)=nLinesGR
      endif
!
      if (Lung(string) > 0) then
          call OneBlankOnly(string)
          call TestoGR(string, colore, 2, box)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Linearizza_SA_new(Ratto,Eo2Ec2Med,a,b)

      USE General
      USE Symmetry
      USE ShellSIGMAA
      USE Riflessi

      dimension Eo2Ec2Med(50)
      dimension smin(50), smax(50), esse(50), enne(50)
      dimension RES_abi(50),sintl_abi(50)
      dimension RES_abi_M(50),sintl_abi_M(50)
      
      smin(:) = 9999.
      smax(:) = -9999.
      do i=1,Nbin
        do jcris=1,nrefl
          ii=RES_TAG(jcris)
          if (i == ii) then
             if (sqrt(rhov(jcris)) < smin(i)) then
                smin(i) = sqrt(rhov(jcris))
             end if
             if (sqrt(rhov(jcris)) > smax(i)) then
                smax(i) = sqrt(rhov(jcris))
             end if
          end if
        end do
      end do
      
      do i=1,Nbin
         esse(i) = (smin(i)+smax(i))/2.
!         sintl_abi(i) = sqrt(smin(i))
!         sintl_abi_M(i) = sqrt(smax(i))
         sintl_abi(i) = smin(i)
         sintl_abi_M(i) = smax(i)
         RES_abi(i) = 0.5/sintl_abi(i)
         RES_abi_M(i) = 0.5/sintl_abi_M(i)
      end do
      
      ifMinQ = 1
      if (ifMinQ == 1) then
        p = sum(esse(3:Nbin)**2)
        q = sum(esse(3:Nbin))
        r = sum(Eo2Ec2Med(3:Nbin)*esse(3:Nbin))
        t = sum(Eo2Ec2Med(3:Nbin))
        Nbin3 = Nbin -2
        
!        amed = t / float(Nbin3)
        
        a = (Nbin3*r-t*q) / (Nbin3*p-q**2)
        b = (p*t-r*q) / (Nbin3*p-q**2)

        do i=1,Nbin
          Eo2Ec2Med(i) = a * esse(i) + b
          if ( a > 0.0) then
            if (Ratto <= 0.30) then
              Eo2Ec2Med(i) = a * esse(i) + b
            else
!           Eo2Ec2Med(i) = 0.5 * a * esse(i) + b
              Eo2Ec2Med(i) =  b
            endif
          endif
        end do

!         amed1 = sum(Eo2Ec2Med(3:Nbin))/ float(Nbin3)
!         do i=1,Nbin
!            Eo2Ec2Med(i) = Eo2Ec2Med(i)+abs(amed-amed1)
!         end do

      end if
      
!      amed_finale = sum(Eo2Ec2Med(1:Nbin))/ float(Nbin) 
      
!      if (Eo2Ec2Med(1) > 1.99) then
!          rapp = Eo2Ec2Med(1) - 1.99
!          do i=1,Nbin
!             Eo2Ec2Med(i) = Eo2Ec2Med(i) - rapp
!          end do
!!      elseif (Eo2Ec2Med(Nbin) < 1.05) then
!!          rapp = 1.05 - Eo2Ec2Med(Nbin)
!      elseif (Eo2Ec2Med(Nbin) < 1.05) then
!          rapp = 1.99 - Eo2Ec2Med(1) 
!          do i=1,Nbin
!             Eo2Ec2Med(i) = Eo2Ec2Med(i) + rapp
!          end do
!      end if
          
!      write(lo,'(/,a,5f6.3)') ' shell     RES        sint/l         Sigm
!     *aA   a    b',a,b,amed,amed1,amed_finale  

!      do i=1, Nbin
!          write(lo,'(i4,2f7.2,2f7.3,f12.5)')
!     *     i, RES_abi(i), RES_abi_M(i),
!     *     Sintl_abi(i), Sintl_abi_M(i),
!     *     Eo2Ec2Med(i)                   
!      end do
           
      return
      end
!-----------------------------------------------------------------------
      subroutine Linearizza_SA(Ratto,Eo2Ec2Med,a,b)

      USE General
      USE Symmetry
      USE ShellSIGMAA
      USE Riflessi

      dimension Eo2Ec2Med(50)
      dimension smin(50), smax(50), esse(50), enne(50)
      dimension RES_abi(50),sintl_abi(50)
      dimension RES_abi_M(50),sintl_abi_M(50)
      
      smin(:) = 9999.
      smax(:) = -9999.
      do i=1,Nbin
        do jcris=1,nrefl
          ii=RES_TAG(jcris)
          if (i == ii) then
             if (sqrt(rhov(jcris)) < smin(i)) then
                smin(i) = sqrt(rhov(jcris))
             end if
             if (sqrt(rhov(jcris)) > smax(i)) then
                smax(i) = sqrt(rhov(jcris))
             end if
          end if
        end do
      end do
      
      do i=1,Nbin
         esse(i) = (smin(i)+smax(i))/2.
!         sintl_abi(i) = sqrt(smin(i))
!         sintl_abi_M(i) = sqrt(smax(i))
         sintl_abi(i) = smin(i)
         sintl_abi_M(i) = smax(i)
         RES_abi(i) = 0.5/sintl_abi(i)
         RES_abi_M(i) = 0.5/sintl_abi_M(i)
      end do
      
      ifMinQ = 1
      if (ifMinQ == 1) then
        p = sum(esse(1:Nbin)**2)
        q = sum(esse(1:Nbin))
        r = sum(Eo2Ec2Med(1:Nbin)*esse(1:Nbin))
        t = sum(Eo2Ec2Med(1:Nbin))
      
        amed = t / float(Nbin)
        
        a = (Nbin*r-t*q) / (Nbin*p-q**2)
        b = (p*t-r*q) / (Nbin*p-q**2)
!        if (a < 0.5) a = 0.5

!        dif = 2.0
!        do while (dif>0.9)
           do i=1,Nbin
             Eo2Ec2Med(i) = a * esse(i) + b
             if ( a > 0.0) then
               if (Ratto <= 0.30) then
                 Eo2Ec2Med(i) = a * esse(i) + b
               else
!              Eo2Ec2Med(i) = 0.5 * a * esse(i) + b
                 Eo2Ec2Med(i) =  b
               endif
             endif
!             Eo2Ec2Med(i) = 0.25 * a * esse(i) + b
!             Eo2Ec2Med(i) =  b
!             Eo2Ec2Med(i) = 1.99
!!!!!             Eo2Ec2Med(i) = -a * esse(i) + b + 2. * abs(amed-b)
!             Eo2Ec2Med(i) = -a * esse(i) +  b
           end do
!           dif = Eo2Ec2Med(1)-Eo2Ec2Med(Nbin)
!           if (dif > 0.9) then
!              a = 0.9*a
!           end if
!        end do
         amed1 = sum(Eo2Ec2Med(1:Nbin))/ float(Nbin)
         do i=1,Nbin
            Eo2Ec2Med(i) = Eo2Ec2Med(i)+abs(amed-amed1)
         end do
      end if
      
!      amed_finale = sum(Eo2Ec2Med(1:Nbin))/ float(Nbin) 
      
!      if (Eo2Ec2Med(1) > 1.99) then
!          rapp = Eo2Ec2Med(1) - 1.99
!          do i=1,Nbin
!             Eo2Ec2Med(i) = Eo2Ec2Med(i) - rapp
!          end do
!!      elseif (Eo2Ec2Med(Nbin) < 1.05) then
!!          rapp = 1.05 - Eo2Ec2Med(Nbin)
!      elseif (Eo2Ec2Med(Nbin) < 1.05) then
!          rapp = 1.99 - Eo2Ec2Med(1) 
!          do i=1,Nbin
!             Eo2Ec2Med(i) = Eo2Ec2Med(i) + rapp
!          end do
!      end if
          
!      write(lo,'(/,a,5f6.3)') ' shell     RES        sint/l         Sigm
!     *aA   a    b',a,b,amed,amed1,amed_finale  

!      do i=1, Nbin
!          write(lo,'(i4,2f7.2,2f7.3,f12.5)')
!     *     i, RES_abi(i), RES_abi_M(i),
!     *     Sintl_abi(i), Sintl_abi_M(i),
!     *     Eo2Ec2Med(i)                   
!      end do
      
      
      return
      end
!-----------------------------------------------------------------------
      subroutine ccorr_VLD(x,y,wt,npunti, corre_VLD)

      dimension x(npunti), y(npunti),wt(npunti)
c
      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0
      npunti_1= 0
      do ix=1,npunti
       if (wt(ix) > 0.0) then
         npunti_1 =  npunti_1 + 1
         xx1 = x(ix)
         xx2 = y(ix)
         vmedt=vmedt + xx1
         vmedc=vmedc + xx2
         vmedtc=vmedtc + xx1 * xx2
         vmed2t=vmed2t + xx1 * xx1
         vmed2c=vmed2c + xx2 * xx2
       endif
      enddo
      vmedt=vmedt/float(npunti_1)
      vmedc=vmedc/float(npunti_1)
      vmedtc=vmedtc/float(npunti_1)
      vmed2t=vmed2t/float(npunti_1)
      vmed2c=vmed2c/float(npunti_1)

      rnum=vmedtc - (vmedt*vmedc)
      rden=sqrt(vmed2t-vmedt**2) * sqrt(vmed2c-vmedc**2)
      corre_VLD=rnum/rden
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CancellaUltimaLinea()
      USE Grafici
      USE Molcom, only : jscreen, ifMadEnv
!
      implicit none
      integer :: Box
!
      if (jscreen == 0 .or. ifMadEnv == 0) return
      Box = lastBox
      nLinesGR = nLinesGR - 1
      inBoxGR(Box) = inBoxGR(Box) - 1
      call TestoGR('  ', 0, 2, Box)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaFasiPesiFcVLD(iAction)
      USE General
      USE VLDmod
!
      implicit none
      integer :: iAction, i, ier
!
      if (iAction == 1) then
          allocate(FasiPesiFcVLD(3,nrefl), stat=ier)
      else
          deallocate (FasiPesiFcVLD, stat =ier)
      endif
!
      return
      end
!----------------------------------------------------------------------
      subroutine SalvaFasi(iAction, fom, corre_VLD, AggiornaFasi)
      USE General
      USE Riflessi
      USE VLDmod
      USE VLDmod_3
      USE PhaseModule, only : fomBest
!
!-- iAction      = 1   Save 
!--              = 2   Restore 
!-- AggiornaFasi = 1   Force phases update
!
      implicit none
      integer :: iAction, i, AggiornaFasi
      real    :: fom, corre_VLD
!
      if (iAction == 1) then
          if (fom > fomBestVLD .or. AggiornaFasi == 1) then
              fomBestVLD = fom
              if (fomBestVLD > fomBest) then
                  fomBest = fomBestVLD
              endif
*             write(6,'(a,2x,2f10.3)') 'SALVAFASI',fomBestVLD,fomBest
              do i=1, nrefl
                 FasiPesiFcVLD(1,i) = iphaz(i)
                 FasiPesiFcVLD(2,i) = wt(i)
                 FasiPesiFcVLD(3,i) = fcvet(i)
              enddo
              cicloBestVLD = numero_cicli
              correBestVLD = corre_VLD
          endif 
      else 
          do i=1, nrefl
             iphaz(i) = FasiPesiFcVLD(1,i)
             wt(i)    = FasiPesiFcVLD(2,i)
             fcvet(i) = FasiPesiFcVLD(3,i)
          enddo
      endif 
!
      return
      end
!----------------------------------------------------------------------
      subroutine ScriviCicloVLD(numero_cicli, numbrun, 
     *                          FinalFom, Rat_VLD, perc_cammino_control)
      USE General, only : lo, knw
      USE VLDmod, only : ifScriviCicloVLD
      USE Phasemodule, only : ifMDM
!
      if (ifScriviCicloVLD == 1) then
          if (ifMDM == 0) then
              if (knw == 1) then
                  write(lo,10) numero_cicli, numbrun, FinalFom,
     *                      Rat_VLD, perc_cammino_control
              else
*                 write(lo,15) numero_cicli, numbrun, FinalFom,
*    *                      Rat_VLD
!pg27012014
                  write(lo,16) numero_cicli, numbrun
                  if (numero_cicli > 1) then
                     write(lo,'(11x,a)')' EDM recycling'
                  end if
              endif
              ifScriviCicloVLD = 0
          else
              if (knw == 1) then
                  write(lo,20) numbrun, FinalFom,Rat_VLD
              else
!pg27012014
                  write(lo,22) numbrun     !, FinalFom
                  write(lo,'(11x,a)')' Tangent and EDM recycling'
              endif
              ifScriviCicloVLD = 0
          end if
      endif
!
      return
   10 format(/,' Cycle ',i4,' Trial ',i4,'  fFOM',f10.3,
     *       '  SaFOM',f13.10,'  Threshold',f13.10)
   15 format(/,' Cycle ',i4,' Trial ',i4,'  fFOM =',f10.3,
     *       '  SaFOM',f13.10)
   16 format(/,' Cycle ',i4,' Trial ',i4)
   20 format(/,' Trial ',i5,'  fFOM',f10.3,'  SaFOM',f13.10)
!pg27012014   22 format(/,' Trial ',i5,'  eFOM =',f10.3)
   22 format(/,' Trial ',i5)
      end
!----------------------------------------------------------------------
      subroutine MiglioraFasi(AggiornaFasi, numsog, stopFFsog,
     *                        sumef, num_ffom, ifLsqVLD, corre_VLD)

      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Param
      USE PhaseModule
      USE Mappa
      USE ShellSIGMAA
      USE MappaPatterson , only: xmapSav
      USE Molcom, only : jscreen, QualeAbilita, color_LIGHTRED,
     *                   color_GREEN, ifMadEnv
      USE RfacMatrixModule

      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      
      implicit none
      integer :: AggiornaFasi, Lung, ifTime_sav
      integer :: izero, ifmin, nbru, ncicla, ifBreak, ier, ifExaminSav
      integer :: num_ffom, numsog, ifLsqVLD
      real    :: percp, sigmaA_1_sav, Rat_VLD_sav
      real    :: erreNoWind, fomNoWind, sumef, stopFFsog
      real    :: corre_VLD
     
      real    :: FinalFomIniz
      integer :: nv, nvmax,ifdoo
!
      ifLsqVld = 0
      if (kverbo_pg == 1 .and. ifTime == 0) then
         write(lo,'(a,3i6)')' IFtidevi, kWstop, ifexamin',
     *                       iftidevifermare,kWstop,ifexamin
      end if
      write(Msg,55)
      call ScriviCicloVLD(numero_cicli, numbrun,
     *        FinalFom2, Rat_VLD, perc_cammino_control)
      write(lo,"(12x,a)") Msg(1:Lung(Msg))
      if (jscreen > 0) then
         write(Msg,55)
         call OneBlankOnly(Msg)
         call TestoGR(Msg, color_LIGHTRED, 2, 3)
      endif
      
! qui va inserito l'ulteriore blocco di cicli EDM per proteine !!!!!!
      if (ifTiDeviFermare == 0) then
!           xmapSav_VLD(:,:,:) = xmap(:,:,:)
!           WT_work4(1:nrefl) = fcvet(1:nrefl)      
!           WT_work3(1:nrefl) = wt(1:nrefl)
!           iphazo(1:nrefl) = iphaz(1:nrefl)
         nvmax = 1
         if (ifMDM == 1) nvmax = 2
         do nv=1,nvmax
            if (nv == 1) then
               FinalFomIniz = FinalFom
            end if
            ifTiDeviFermare = 1
            n_EDM = n_EDM_save
            percp = 0.045
            ifTime_sav = ifTime
C        ifTime = 0
            if (knw /= 0) then
               write(lo,'(/,a,2f7.3,/)')
     *             ' Altri cicli EDM ...', FinalFom, FinalFom2
            endif
         
            sigmaA_1_sav = sigmaA_1
            Rat_VLD_sav = Rat_VLD
         
            call EDM_Cycles_VLD(percp, 1, 0)
        
            sigmaA_1 = sigmaA_1_sav
            Rat_VLD = Rat_VLD_sav

            call CalcFFomVLD(2, corre_VLD)
!pg27012014            
!            write(lo,'(11x,a,f7.3)') 
!     *         ' Improved phases: Final Fom =',FinalFom2
            write(line_EDM,'(11x,a,f7.3)') 
     *         ' EDM recycling: Final Fom =',FinalFom2

            if (ifTime == 0 .and. kverbo_pg == 1) then
               write(6,*) 'FinalFom, stopFinalFom,FinalFom2',
     *               FinalFom,stopFinalFom,FinalFom2
            endif
                                 
            call SalvaFasi(1, FinalFom2, corre_VLD, AggiornaFasi)
  
            if (knw /= 0 .or. kverbo_pg == 1) then
               write(lo,'(a,5f12.5)')
     *         ' FinalFom,SFF, Corre, stopFinalFom2, FinalFom2 >=',
     *           FinalFom,stopFinalFom,corre_VLD,stopFinalFom2,FinalFom2
            endif
            if (ifMDM == 1) then
               if (FinalFom < 1.4 * FinalFomIniz) then
                  exit
               end if
            elseif (nv == 1) then
               if (knw == 1) then
                   write(lo,'(a,2f10.5)') 'FinalFomIniz, FinalFom:',
     *                                     FinalFomIniz, FinalFom
               endif
            end if
         end do
!pg27012014
         write(lo,'(a)') line_EDM
!        end if
         RfacMatrix(3,numbrun,jBlock) = FinalFom2
         if (FinalFom2 >= stopFinalFom2 .and. 
     *         ksize_vero == 3 .and. 
     *        (rfac_edm > 33. .or. ifMDM == 1)) then
            ifLsqVLD = 1
!pg05052014            
            call Prova_DLSQ(naatoms_max, corre_VLD)      ! il ciclo e' degno di "attenzione" !!!!
            if (kWstop == 1) then
               call SalvaFasi(1,FinalFom2, corre_VLD, AggiornaFasi)
               call DeAllocaVLD
               return
            elseif (ifMDM == 1) then
               stopFinalFom2 = FinalFom2      !<<<===========!piero solo
            end if
         end if

         ifdoo = 0
         if(ifMDM == 1) then
            if (FinalFom2 >= stopFinalFom2 .and. 
     *                    rfac_edm < 33. .and. ksize_vero > 3) then
                ifdoo = 1
            end if
         else
            if (FinalFom2 >= stopFinalFom2 .and. 
     *                       rfac_edm < 33.)    then
                ifdoo = 1
            end if
         end if
         if (ifdoo == 1) then
            ifTime = ifTime_sav
            kWstop = 1
         else
!            xmap(:,:,:) = xmapSav_VLD(:,:,:)
!            fcvet(1:nrefl) = WT_work4(1:nrefl)
!            wt(1:nrefl)= WT_work3(1:nrefl)
!            iphaz(1:nrefl) = iphazo(1:nrefl)

! calcolo della soglia dinamica di FFOM
 
            if (FinalFom > stopFinalFom) then
              stopFinalFom = FinalFom
              if (stopFinalFom > stopFFsog) then
                  if (num_ffom < numsog) then
                    num_ffom = num_ffom + 1
                    sumef = sumef + FinalFom
                    stopFinalFom = stopFFsog
                    FinalFom = stopFFsog
                  else
                    stopFinalFom = sumef / num_ffom
                    stopFFsog = stopFinalFom
                    num_ffom = 1
                    sumef = 0.0
                 end if   
                 if (ifTime == 0 .and. kverbo_pg == 1) then
                     write(lo,'(a,i4,3f7.3)') 'num_ffom',
     *                    num_ffom,FinalFom,stopFinalFom,
     *                    stopFFsog
                 endif
              end if
            end if    

            ifTiDeviFermare = 0
            kWstop = 0
*?*         ifExamin = ifExaminSav
            ifTime = ifTime_sav
            call CancellaUltimaLinea()
         end if
!!pg180511
      else
      
         write(lo,'(/,a,/)') ' ATTENZIONE: passo per else /endif non chi
     *aro'
      
         call  ccorr_VLD(evet,fcvet,wt,nrefl, corre_VLD)
         call SalvaFasi(1, FinalFom2, corre_VLD, AggiornaFasi)
!!pg170511
         if (knw /= 0) then
             write(lo,'(a,3f12.5)')
     *             ' FinalFom, Corre, FinalFom2>=',
     *               FinalFom,corre_VLD,FinalFom2
         endif
 !!pg170511
      end if  ! (ifTiDeviFermare == 0)
!!pg180511
*     RfacMatrix(3,numbrun,jBlock) = FinalFom
      if (kWstop == 1) then                      
         ifExamin = 1
         ifTime = 0
         izero = 0
         ifmin = 1
         nbru = 8888
         call examin(nbru,mkang,khl,ipub,iphaz,nrefl,
     *       izero,wt,ifmin)
         ifTime = ifTime_sav
         if (knw /= 0) then
            write(6,*) 'PROGRAM HAS TO STOP NOW'
         endif
         t0_raffi = 0.0
      endif  ! (kWstop == 1)
      
      return
   55 format('Final FOM indicates a candidate solution.')
      end
!----------------------------------------------------------------------
      subroutine MiglioraFasi_2(AggiornaFasi, kverbo_pg_sav,ifExaminSav,
     *                          ifTime_sav, corre_VLD) 
      USE General
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE RfacMatrixModule
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      
      implicit none
      integer :: AggiornaFasi, kverbo_pg_sav, ifExaminSav, ifTime_sav
      real :: percp, corre_VLD

      ifTiDeviFermare = 1
      n_EDM = n_EDM_save
      percp = 0.045
      kverbo_pg_sav = kverbo_pg
      if (knw > 0 .and. ifOUT == 1) then
          kverbo_pg = 1
      endif
      kWstop = 1
      if (knw /= 0) then
          write(lo,'(/,a,f7.3,/)') 
     *          ' Altri cicli EDM ....', FinalFom
      endif
      call EDM_Cycles_VLD(percp, 1, 1)

      call CalcFFomVLD(2, corre_VLD)
      
      if (ifMDM == 1) then
          Aggiornafasi = 1
      end if

      call SalvaFasi(1, FinalFom2, corre_VLD, AggiornaFasi)
      RfacMatrix(3,numbrun,jBlock) = FinalFom2
!pg27012014      
!      write(lo,'(11x,a,f7.3)') 
!     *   ' Improved phases: Final Fom =',FinalFom2
       write(lo,'(11x,a,f7.3)') ' EDM recycling: Final Fom =',FinalFom2

      if (knw == 1 .and. kverbo_pg == 1) then
          write(lo,'(a,4f12.5)')
     *          ' FinalFom, Corre, stopFinalFom2, FinalFom2=',
     *          FinalFom,corre_VLD,stopFinalFom2,FinalFom2
      endif
      kverbo_pg = kverbo_pg_sav

      if (ifTraslas == 1) then
          ifTiDeviFermare = 0
          kWstop = 0
          return
      endif 

      if (FinalFom2 < stopFinalFom2 .or. 
     * ((rfac_edm>33.0 .and. FinalFom2<1.5 .and. ksize_vero >= 3).and.
     *   ifMDM == 1)) then

         xmap(:,:,:) = xmapSav_VLD(:,:,:)
         fcvet(1:nrefl) = WT_work4(1:nrefl)
         wt(1:nrefl)= WT_work3(1:nrefl)
         iphaz(1:nrefl) = WT_work5(1:nrefl)
         kWstop = 0
         kverbo_pg = kverbo_pg_sav
         ifExamin = ifExaminSav
         ifTime = ifTime_sav
         ifTiDeviFermare = 0
         call CancellaUltimaLinea()
         return
      end if
!
      return
      end
!----------------------------------------------------------------------
      subroutine Tangente_VLD
      USE General
      USE Riflessi
      USE PhaseModule, only : ifExamin, ksize_vero, ifTime
      USE Symmetry, only : icent

      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      
      implicit none
      integer :: i, Nmag, idv, id1, id2, iphi
      real :: sca, perc_Nn, wq_med, Qsin, Qcos,Qarg, bes, soglia_sgq
      real :: wwq, soglia_prcy, amed_Eqp, etan
      integer :: ipher, izero, ncon2, ncon3, ncon4, jh, jk, jl, ncon1
      integer :: ncon5, ncon6, ncon1_ncs,ncon2_ncs,ncon3_ncs,ncon4_ncs
      integer :: ncon5_ncs,ncon6_ncs,ncon7_ncs,ncon8_ncs
      character*11 tirang
      character*1 aster
       
      sca = 1./0.9
      perc_Nn = 1.
      
      
      
!     do i=1, 100
!        write(lo,'(3e15.9)') evet(i),Eqp(i),ArgGq(i)
!     end do
!     stop 9876
      
      

      do while (perc_Nn > 0.25)
         sca = sca * 0.9                        
         Nmag = 0
         do i = 1,nrefl
            if (ifIbrida == 0) then
               sgq(i) = 2 * Eqp(i) * ArgGq(i) / (es(i) -1.)
            else  
               sgq(i) = 2 * Eqp(i) * ArgGq(i) / (Tau**2*(es(i) -1.))
            end if  
            sgq(i) = abs (sca * sgq(i))
            wq(i) = bes(abs(sgq(i)))
!            if (sgq(i) < 0.01) then
!               write(lo,'(9f12.5)') eqp(i),eqp_ist(i),pesmod(i),evet(i),
!     * ep(i),es(i),sgq(i),wq(i),sca
!            end if
            if (wq(i) >0.9) then                    
               Nmag = Nmag + 1                     
            end if 
         end do
         perc_Nn = float(Nmag)/nrefl
      end do
      wq_med = sum(wq(1:nrefl))/nrefl
!pg201213      
      if (knw /= 0 .and. kverbo_pg == 1 .and.ifTime == 0) then
!         write(lo,'(/,a,3e25.15,/)') '<wq>, <pesMod> = ',wq_med, 
!     *                        pesMod_med
      end if
!      goto 655
      if (ifIbrida /= 0) then
         do i=1,nrefl
            dijs(i) = sgq(i)
            jorde(i) = i
         end do
         call sortall3(1,dijs,1,nrefl,jorde)
 !           soglia_sgq =  dijs(0.3*nrefl)    !medie
         soglia_sgq =  dijs(nint(0.4 *nrefl))
         do i=1,nrefl
 !             if (sgq(i)<soglia_sgq .or. evet(i) < soglia_eminimo) then   !medie
            if (sgq(i)<soglia_sgq ) then
                 wq(i) = 0.0
            end if
         end do
      end if
655   continue
!calcolo di PHI con la formula della tangente da mR - Rp


      ncon1 = 0
      ncon2 = 0
      ncon3 = 0
      ncon4 = 0
      ncon5 = 0
      ncon6 = 0
      ncon1_ncs = 0
      ncon2_ncs = 0
      ncon3_ncs = 0
      ncon4_ncs = 0
      ncon5_ncs = 0
      ncon6_ncs = 0
      ncon7_ncs = 0
      ncon8_ncs = 0

      do i = 1,nrefl
         if (ifIbrida == 0) then
            Qsin = Ep(i)  * sin(dtor * PHIp(i)) +      !19/11
     *          Eqp(i) * sin(dtor * PHIqp(i))
            Qcos = Ep(i)  * cos(dtor * PHIp(i)) + 
     *          Eqp(i) * cos(dtor * PHIqp(i))
!               Qsin = Ep(i)  * sin(dtor * PHIp(i)) +      !19/11
!     *                Eqvero(i) * sin(dtor * PHIqvero(i))
!               Qcos = Ep(i)  * cos(dtor * PHIp(i)) + 
!     *                Eqvero(i) * cos(dtor * PHIqvero(i))
         else
            wwq = sqrt(Tau**2 + Omega**2 - 2.*(Tau*Omega*Dluz(i)))
            Qsin = Omega * Ep(i)  * sin(dtor * PHIp(i)) +      !19/11
     *          Eqp(i) * sin(dtor * PHIqp(i))
            Qcos = Omega * Ep(i)  * cos(dtor * PHIp(i)) +
     *          Eqp(i) * cos(dtor * PHIqp(i))
!               Qsin = Omega * Ep(i)  * sin(dtor * PHIp(i)) +      !19/11
!     *                wwq * Eqvero(i) * sin(dtor * PHIqvero(i))
!               Qcos = Omega * Ep(i)  * cos(dtor * PHIp(i)) + 
!     *                wwq * Eqvero(i) * cos(dtor * PHIqvero(i))
         end if
      
!               Qsin = Ep(i)  * sin(dtor * PHIp(i)) +      !19/11
!     *                Eqvero(i) * sin(dtor * PHIqvero(i))
!               Qcos = Ep(i)  * cos(dtor * PHIp(i)) + 
!     *                Eqvero(i) * cos(dtor * PHIqvero(i))
       
!               Qsin = Ep(i)  * sin(dtor * PHIp(i)) +      !19/11
!     *                Eqvero(i) * sin(dtor * PHIqp(i))
!               Qcos = Ep(i)  * cos(dtor * PHIp(i)) + 
!     *                Eqvero(i) * cos(dtor * PHIqp(i))
       
         Qarg = 2*evet(i) * sqrt(Qsin**2 + Qcos**2)
      
         iphaz(i) = nint(3600 + atan2(Qsin, Qcos) * rtod)
         iphaz(i) = mod(iphaz(i), 360)
                 
         if(mkang(i).ne.1) then
            iphi=iphaz(i)
            idv = 15*mod(mkang(i)-1,12)
            id1 = iabs(idv-iphi)
            id2 = iabs(idv+180-iphi)
            id1=min0(id1,360-id1)
            id2=min0(id2,360-id2)
            if(id1.lt.id2) then
               iphi=idv
            else
               iphi=idv+180
            endif
            iphi=mod(iphi,360)
            if (iphi == 0) iphi = 360
            iphaz(i) = iphi
         end if
         if (iphaz(i).eq.0) iphaz(i) = 360
         
 !           write(lo,'(4i5,3(f7.3,i5),i5)')i,khl(1:3,i),EqVero(i),
 !    *            PHIqVero(i),Ep(i),PHIp(i),Eqp(i),PHIqp(i),iphaz(i)
        
         if (ifIbrida == 0) then
            wt(i) = bes(Qarg)
         else
            if(wq(i) == 0.0) then
               
                 if (wq1_1(i) == 1.0) ncon1 = ncon1 + 1
                 if (wq1_2(i) == 1.0) ncon2 = ncon2 + 1
                 if (wq1_3(i) == 1.0) ncon3 = ncon3 + 1
                 if (wq2(i) == 1.0) ncon4 = ncon4 + 1
                 if (wq3(i) == 1.0) ncon5 = ncon5 + 1
                 if (wq4(i) == 1.0) ncon6 = ncon6 + 1
                 
                 if (wq1_a(i) == 1.0) ncon1_ncs = ncon1_ncs + 1
                 if (wq1_b(i) == 1.0) ncon2_ncs = ncon2_ncs + 1
                 if (wq1_c(i) == 1.0) ncon3_ncs = ncon3_ncs + 1
                 if (wq2_a(i) == 1.0) ncon4_ncs = ncon4_ncs + 1
                 if (wq2_b(i) == 1.0) ncon5_ncs = ncon5_ncs + 1
                 if (wq2_c(i) == 1.0) ncon6_ncs = ncon6_ncs + 1
                 if (wq2_d(i) == 1.0) ncon7_ncs = ncon7_ncs + 1
                 if (wq2_e(i) == 1.0) ncon8_ncs = ncon8_ncs + 1
               
 !               if (Ep(i) > 0.6) then
 !                  wt(i) = bes(Qarg)
 !                  iphaz(i) = PHIp(i)
 !               else
                 
                 wt(i) = 0.0
                 
 !               end if
            else
            
 !              if(wq1_1(i)+wq1_2(i)+wq1_3(i) > 0) then
 !                 wt(i) = 0.0
 !              else
                  wt(i) = bes(Qarg)
 !              end if
               
!small come medium               
!               if (wt(i) < 0.1 .and. ksize_vero < 3) then     !mail 22/07   !small
!                  wt(i) = 0.0
!               end if
               
            end if
            
!            if (wq4(i) > 0.0) then
!              jh = khl(1,i)
!              jk = khl(2,i)
!              jl = khl(3,i)
!              etan = sqrt(Qsin**2 + Qcos**2)
!        write(lo,'(3i5,3f6.2,2i6,3f6.2,i6)')jh,jk,jl,evet(i),Ep(i),
!     *   Eqp(i),PHIp(i),PHIqp(i),Qarg,wt(i),etan,iphaz(i)
!             end if
         end if
         
         if(ifExamin == 1) then
            EossEcal(i) = Qarg
            if (EossEcal(i) > 25.) EossEcal(i) = 25.
         end if
      end do
      
!      write(lo,'(/,a,6i6)') ' ntot1,ntot2,ntot3,ntot4,ntot5,ntot6 =',
!     * ncon1tot,ncon2tot,ncon3tot,ncon4tot,ncon5tot,ncon6tot
      
!      write(lo,'(a,6i6)') ' ncon1,ncon2,ncon3,ncon4,ncon5,ncon6 =',
!     *                      ncon1,ncon2,ncon3,ncon4,ncon5,ncon6
     
!      write(lo,'(/,a,8i6)') ' ntot1_ncs,ntot2_ncs,ntot3_ncs,ntot4_ncs,nt
!     *ot5_ncs,ntot6_ncs,ntot7_ncs,ntot8_ncs =',
!     * ncon1tot_ncs,ncon2tot_ncs,ncon3tot_ncs,ncon4tot_ncs,ncon5tot_ncs,
!     * ncon6tot_ncs,ncon7tot_ncs,ncon8tot_ncs
      
!      write(lo,'(a,8i6,/)') ' ncon1_ncs,ncon2_ncs,ncon3_ncs,ncon4_ncs,
!     *ncon5_ncs,ncon6_ncs,ncon7_ncs,ncon8_ncs =',
!     * ncon1_ncs,ncon2_ncs,ncon3_ncs,ncon4_ncs,ncon5_ncs,ncon6_ncs,
!     * ncon7_ncs,ncon8_ncs
     
      go to 999
      
      if (icent /= 0) then
         ncon2 = 0
         do i=1,nrefl
           wwq = sqrt(Tau**2 + Omega**2  
     *                 - 2.*(Tau*Omega*Dluz(i)))     
           EossEcal(i)= (-Tau*evet(i)+Omega* Ep(i))/wwq
            
           if( (mod(khl(1,i),2)==0) .and. (mod(khl(2,i),2)==0)
     *          .and. (mod(khl(3,i),2)==0)) then
     
                wq2(i) = wq2(i) * wt(i)
           else
                wq2(i) = 0.0
                

           end if
            
            if (wq2(i) /= 0.0)  ncon2 = ncon2+1 
         end do
      
         if (ncon2 > 10) then
         tirang = '2a'
         ipher = 0
         izero = 0
         call pherrdisNew_VLD(tirang,EossEcal,khl,mkang,nrefl,izero,
     *              ipub,iphaz,wq2,20,0.0,ipher,soglia_PrCy,0)
         end if
         
         ncon3 = 0
         
!        write(lo,'(/,a)')'    h    k    l    R    Rp  Rq_ist  Rq''  Rq_v
!     *    PHI   PHIp PHIqp PHIqv caso'  
                  
         do i=1,nrefl
            wwq = sqrt(Tau**2 + Omega**2  
     *                 - 2.*(Tau*Omega*Dluz(i)))     
!            EossEcal(i)=Eqp_ist(i)-(0.9*(Tau*evet(i)+Omega* Ep(i))/wwq)
            EossEcal(i)=Eqp_ist(i)-0.8*(Omega* Ep(i))/wwq
            
            if( (mod(khl(1,i),2)==0) .and. (mod(khl(2,i),2)==0)
     *          .and. (mod(khl(3,i),2)==0)) then
            
                wq3(i) = wq3(i) * wt(i)
            else
                wq3(i) = 0.0

            end if

            if (wq3(i) /= 0.0)  then 
               ncon3 = ncon3+1
                
               jh = khl(1,i)
               jk = khl(2,i)
               jl = khl(3,i)
               aster = ' '
!               if (PHIqvero(i) /= PHIqp(i)) aster = '*'
               if (ipub(i) /= PHIp(i)) aster = '*'
 !              write(lo,'(3i5,5f6.2,i6,a,3i6,1x,a,a)')jh,jk,jl,evet(i),
 !    *         Ep(i),Eqp_ist(i),Eqp(i),EqVero(i),ipub(i),aster,PHIp(i),
 !    *         PHIqp(i),PHIqvero(i),caso(i),aster
               
            end if
         end do
      
         if (ncon3 > 10) then
         tirang = '2b grande'
         ipher = 0
         izero = 0
         call pherrdisNew_VLD(tirang,EossEcal,khl,mkang,nrefl,izero,
     *              ipub,iphaz,wq3,20,0.0,ipher,soglia_PrCy,0)
         end if

     
         ncon4 = 0
         
!        write(lo,'(/,a)')'    h    k    l    R    Rp  Rq_ist  Rq''  Rq_v
!     *    PHI   PHIp PHIqp PHIqv caso'  
         
         do i=1,nrefl
            wwq = sqrt(Tau**2 + Omega**2  
     *                 - 2.*(Tau*Omega*Dluz(i)))     
!            EossEcal(i)=Eqp_ist(i)-(0.9*(Tau*evet(i)+Omega* Ep(i))/wwq)
            EossEcal(i)=Eqp_ist(i)- 0.8*(Omega* Ep(i))/wwq
            if( (mod(khl(1,i),2)==0) .and. (mod(khl(2,i),2)==0)
     *          .and. (mod(khl(3,i),2)==0)) then
            
               wq4(i) = wq4(i) * wt(i)
           else
               wq4(i) = 0.0
            end if

            if (wq4(i) /= 0.0) then 
               ncon4 = ncon4+1 
                
               jh = khl(1,i)
               jk = khl(2,i)
               jl = khl(3,i)
               aster = ' '
!               if (PHIqvero(i) /= PHIqp(i)) aster = '*'
               if (ipub(i) /= PHIp(i)) aster = '*'
!              write(lo,'(3i5,5f6.2,i6,a,3i6,1x,a,a)')jh,jk,jl,evet(i),
!     *         Ep(i),Eqp_ist(i),Eqp(i),EqVero(i),ipub(i),aster,PHIp(i),
!     *         PHIqp(i),PHIqvero(i),caso(i),aster
            end if
         end do
      
         if (ncon4 > 10) then
         tirang = '2b piccolo'
         ipher = 0
         izero = 0
         call pherrdisNew_VLD(tirang,EossEcal,khl,mkang,nrefl,izero,
     *              ipub,iphaz,wq4,20,0.0,ipher,soglia_PrCy,0)
         end if
      end if

 999  continue     
      return
      end
!----------------------------------------------------------------------
      subroutine Stampe_MPE_RES(sog_wt)

      USE General
      USE Riflessi
      USE PhaseModule
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      
      implicit none
      integer :: ifExaminSav, iftsv, i, j, izero, ifmin, nbru, ncond
      integer :: n_rfac, n_rfac1, ipher
      real    :: sog, sumfo, sumfc, scala, anum, aden, rfac_edm_new
      real    :: rfac_edm_new_fo, sog_wt
      character*11 tirang

      ifExaminSav = ifExamin
      ifExamin = 1
!p&c      iftsv = ifTime
!p&c      ifTime = 0

      iftsv = ifTime                         !p&c
      if (numero_edm == 1) then
         ifTime = 0
      end if
                        
      if (ifExamin == 1) then
          if (kverbo_pg > 0) then
              izero = 0
              ifmin = 1
              nbru = 4422
             call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
          endif
          
!          tirang = ' stat WT    '
!          izero = 0
!          ipher = 1
!          call weightsdis(tirang,wt,khl,nrefl,izero,
!     *                  ipub,iphaz,wt,10,0.0,ipher)
      end if
      
      go to 888

      WT_save(1:nrefl) = 0.0
      do i=1, nrefl
           if (0.5/sqrt(rhov(i)) > 1.0 .and. wt(i) >= sog_wt) then
              WT_save(i) = pesmod(i)
           end if
      end do
      izero = 0
      ifmin = 1
      nbru = 5522
      call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,WT_save,
     *            ifmin)
  
     
      WT_save(1:nrefl) = wt(1:nrefl)
      work1(1:nrefl) = wt(1:nrefl)
      ncond = numbLSQ
      call sortall(-1,work1,ncond)
      ncond = (ncond/3)+1
      sog=work1(ncond)
      do j=1,nrefl
         if (WT_save(j).lt.sog) WT_save(j)= 0.0
      enddo
       
      do i=1, nrefl
         if (0.5/sqrt(rhov(i))> 6.0) WT_save(i) = 0.0
      end do
      do i=1, nrefl
         if (0.5/sqrt(rhov(i))< 1.2) WT_save(i) = 0.0
      end do
                  
      izero = 0
      ifmin = 1
      nbru = 6622
      call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,WT_save,
     *           ifmin)
    
      sumfo = 0.0
      sumfc = 0.0
      do i=1, nrefl
          sumfo = sumfo + fovet(i)
          sumfc = sumfc + work22(i)
      end do 
      scala = sumfo / sumfc
      
      sumfo = 0.0
      sumfc = 0.0
      do i=1, nrefl
        if (WT_save(i) > 0.0) then
          sumfo = sumfo + fovet(i)
          sumfc = sumfc + work22(i)
        end if
      end do 
      scala = sumfo / sumfc
      anum = 0.0
      aden = 0.0
      n_rfac = 0
      do i=1,nrefl
         if (WT_save(i) > 0.0) then
           anum = anum + abs(fovet(i)-scala*work22(i))
           aden = aden + fovet(i)
           n_rfac = n_rfac + 1
         end if
      end do
      rfac_edm_new = 100.*anum/aden
      
! residuo "piccolo" calcolato su numbLSQ/3 riflesssi sortati su fovet

      WT_save(1:nrefl) = wt(1:nrefl)
      work1(1:nrefl) = fovet(1:nrefl)
      ncond = numbLSQ
      call sortall(-1,work1,ncond)
!     ncond = (ncond/2)+1
      ncond = (ncond/3)+1
      sog=work1(ncond)
      do j=1,nrefl
         if (fovet(j).lt.sog) WT_save(j)= 0.0
      enddo
             
      do i=1, nrefl
         if (0.5/sqrt(rhov(i))> 6.0) WT_save(i) = 0.0
      end do
      do i=1, nrefl
         if (0.5/sqrt(rhov(i))< 1.2) WT_save(i) = 0.0
      end do
                        
      izero = 0
      ifmin = 1
      nbru = 7722
      call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,WT_save,
     *                 ifmin)
      

    
      sumfo = 0.0
      sumfc = 0.0
      do i=1, nrefl
         if (WT_save(i) > 0.0) then
            sumfo = sumfo + fovet(i)
            sumfc = sumfc + work22(i)
         end if
      end do 
      scala = sumfo / sumfc
      anum = 0.0
      aden = 0.0
      n_rfac1 = 0
      do i=1,nrefl
         if (WT_save(i) > 0.0) then
            anum = anum + abs(fovet(i)-scala*work22(i))
            aden = aden + fovet(i)
            n_rfac1 = n_rfac1 + 1
         end if
       end do
       rfac_edm_new_fo = 100.*anum/aden
     
       if (kverbo_pg > 0) then
           write(lo,'(a,2(f12.5,i7))')' EDM: NUMBLSQ/3 e d>6.0 e d<1.2',
     *          rfac_edm_new, n_rfac, rfac_edm_new_fo, n_rfac1
       endif
    
888    continue
      
!      if (numbrun==4 .and. numero_cicli==6 .and. numero_edm==22) then
!         write(lo,'(a,i5,f12.3)')' Numero e soglia  =',ncond,sog
!         nconta_riflessi = 0
!         do i=1,nrefl
!            jh = khl(1,i)
!            jk = khl(2,i)
!            jl = khl(3,i)
!            if (WT_save(i) > 0.0)  then
!               nconta_riflessi = nconta_riflessi + 1
!               d_brag = 0.5/sqrt(rhov(i))
!               write(lo,'(4i5,5f12.3)')nconta_riflessi,jh,jk,jl,d_brag,
!     *             evet(i),fovet(i),work22(i),WT_save(i)
!            end if
!         end do
!         stop   
!      end if    
      ifExamin = ifExaminSav
      ifTime = iftsv
      
      return
      end
!----------------------------------------------------------------------
      subroutine Messaggi_VLD
      
      USE General
      USE Symmetry
      USE PhaseModule
      USE Molcom, only : jscreen, ifMadEnv, color_GREEN
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_3
       
      implicit none
      integer :: k1, k2, k3, Lung
      character (len=11) :: tirang 
      character (len=80) :: line
       
      if (jscreen > 0) then         
          if (ifMDM == 0) then
              write(tirang,"(i5,'/',i5)") numbrun, MaxRun
          else
              write(tirang,"(i5)") TrerreBestMDM
          endif
          call NoBlanks(tirang,k1)
          if (ifMadEnv == 0) then
              if (erreBestVLD > 100) then
                  Inte = 'n.a.'
              else
                  write(Inte,"(f8.2,'%')") erreBestVLD * 100.0
              endif
              call NoBlanks(Inte,k2)
              if (abs_erreBestVLD > 100) then
                  line = 'n.a.'
              else
                  write(line,"(f8.2,'%')") abs_erreBestVLD * 100.0
              endif
              call NoBlanks(line,k3)
              if (TotalScan > 0) then
                  write(line(k3+2:),'(a,16a1)') 'in ',nSpaceG(1:16)
                  call ucase(line(k3+5:k3+5))
                  k3 = Lung(line)
              endif
              if (ifMDM == 0) then
                  write(Msg,22) tirang(1:k1), Inte(1:k2), line(1:k3)
              else
                  write(Msg,24) tirang(1:k1), line(1:k3)
              endif
          else
              write(Inte,"(i5,'/',i5)") numero_cicli, n_cicli
              call NoBlanks(Inte,k2)
              write(Msg,23) tirang(1:k1), Inte(1:k2)
          endif
          if (ksize <= 3) then
              call RunToolBar(1,Msg)
          else
              if (ifMadEnv /= 0) then
                  if (ifMDM == 1) then
                      Msg = ' '
                  endif
                  call SameLine(Msg, color_GREEN, 2)
              else
                  if (TrerreBestMDM > 0) then
                      call RunToolBar(1,Msg)
                  endif
              endif
          endif
      endif
!
      return
   22     format('EDM on Fourier Difference Map   -   ',
     *           'Best R in trial ',a,' = ',a,'   -   ',
     *           'Best R in all trials = ',a)
   23     format('EDM on Fourier Difference Map - Trial ',a,
     *           ', cycle ',a)
   24     format('MDM Procedure   -   ',
     *           'Best R% in trial ',a,' = ',a)

      end
!----------------------------------------------------------------------      
      subroutine SolutionFound(iAction, ifBreak)
      USE General
      USE Atomi, only : nats
!pg05052014
      USE PhaseModule, only : erre, erore, ifMDM, ifVLD, numbrun,
     *        erore_best_MNQ, ksize_vero
      USE Dialogo, only : ModelToCompare
      USE TestModel
      USE VLDmod
      USE VLDmod_3
!
      implicit none
      integer :: iAction, ifBreak, Lung, lline, L
      character (len= 7) :: errec
      character (len=15) :: mpe
      character (len=8) :: mpee
      character (len=80) :: line
!
      if (iAction /= 0) then
          if (erre > 0.0 .and. erre < 0.99) then
              write(errec,'(f7.2)') erre*100.0
          else
              errec = '  n.a. '
          endif
          if (knw /= 0) then
             if (naatoms == 0 .and. nats > 0 
     *                        .and. ModelToCompare == 1) then
                 call to_coord_sir(0,nrefl)
             endif
             if (ifVLD == 1) then
                 write(lo,10) naatoms, numero_cicli, nTrialsVLD, 
     *                             errec, erore, correBestVLD
             elseif (ifMDM == 1) then
                write(lo,15) naatoms, nTrialsVLD, errec, erore,
     *                       correBestVLD
             end if
          elseif (kverbo_pg > 0) then
             if (ifVLD == 1) then
                 write(lo,20) numero_cicli, nTrialsVLD, errec,
     *                       correBestVLD
             elseif (ifMDM == 1) then
                write(lo,25) nTrialsVLD, errec, correBestVLD
             end if
          end if
      endif
      L = index(fname(1),'.bin') - 1
      if (ifBreak == 1) then
         call StoppedRun
         line = 'Program stopped '
      else
         write(line,'(1h ,a)') fname(1)(1:L) 
         if (iAction == 1 .and. ifDebug == 1) then 
             if (ifVLD == 1) then
                write(line(14:),41) numero_cicli, nTrialsVLD, errec
             elseif (ifMDM == 1) then
                write(line(14:),46) nTrialsVLD, errec
             end if
         endif
      endif
 
      if (iAction /= 0) then 
          lline = Lung(line)
          if (knw /= 0) then
              write(mpe,'(" - MPE =",f7.2)') erore
              if (ifMDM == 1 .or. ifVLD == 1) then
                  write(lo,30) line(1:lline), mpe
              endif
          endif
      endif
 
*     if (L > 15) L = 15
      L = 15
      if (iAction == 0) then 
          numero_cicli = 0
          nTrialsVLD   = 0
          errec        = ' '
          mpee         = ' '
          if (ifVLD /= 1) then
              write(line_VLD,42) nome(1:L),nTrialsVLD,errec,mpee
          else
             write(line_VLD,43) nome(1:L),numero_cicli,nTrialsVLD,
     *                    errec,mpee
          endif
      else
          if (knw /= 0) then
!pg05052014
              if (ksize_vero <= 3) then
                  if (erore_best_MNQ /= 0.00) then
                     write(mpee,'(f7.2)') erore_best_MNQ
                  else
                     mpee = '       '
                  end if   
              else
                  write(mpee,'(f7.2)') erore
              end if
          else
              mpee = '       '
          endif
          if (ifVLD /= 1) then
              write(line_VLD,42) nome(1:L),nTrialsVLD,errec,mpee
          else
             write(line_VLD,43) nome(1:L),numero_cicli,nTrialsVLD,
     *                    errec,mpee
          end if
          if (ifMDM == 1 .or. ifVLD == 1) then
            if (knw /= 0) then
              write(lo,'(a,4(f10.1,i6))') 'Tempo x edm, dlsq e raff ',
     *          time_tot_edm,num_tot_edm,
     *          time_tot_dlsq, num_tot_dlsq,
     *          time_tot_raffi, num_tot_raffi,
     *          time_tot_postdsr
        
              write(lo,'(a,f12.3,a,i4,a,i4)') ' Rfactor minimo = ',
     *          rfac_edm_min, ' in  ciclo=',num_rfac_edm_min, '/',
     *          num_model_edm_min 
            end if
          end if
      endif
!
      return
   10 format(//,i5,' matches found in cycle #',i4,
     * ' of Trial #',i3,' - R% =',a,' - MPE =',f7.2,' - CC = ',f8.3)
   15 format(//,i5,' matches found in Trial #',i5,
     * ' - R% =',a,' - MPE =',f7.2,' - CC = ',f8.3)
   20 format(//,' Final Cycle #',i4,'    of Trial #',i3,' - R% =',a,
     *          ' - CC = ',f8.3)
   25 format(//,' Trial #',i5,' - R% =',a,' - CC = ',f8.3)
   30 format(/,a,a,/)
   41 format(': solution found in cycle #',i4,
     * '  of Trial #',i3,' - R% =',a)
   42 format(a,' ; soluzione ;',i5,' ;',a,' ;',a' ;')
   43 format(a,' ; soluzione ;',i5,' ;',i5,' ;',a,' ;',a,' ;')
   46 format(': solution found in Trial #',i5,' - R% =',a)
      end      
!----------------------------------------------------------------------      
! le successive subroutines sono originali VLD SIR2011
!----------------------------------------------------------------------
      subroutine SviluppaRandom_VLD(ifBreak, ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Param
      USE PhaseModule
      USE TestModel
      USE Mappa
      USE ShellSIGMAA
      USE RemoModule , only: use_E
      USE MappaPatterson , only: xmapSav
      USE Molcom, only : jscreen, QualeAbilita, color_LIGHTRED,
     *                   color_GREEN, ifMadEnv, ifBrekke
      USE Html
      USE Grafici, only : NewPoint

      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
!
      dimension sh_save(4),sh_phiq_save(4)
      integer :: AggiornaFasi

      character * 1,iast
      character*11 tirang
      character *80 line      
      
      dimension Eo2Ec2Med(50)
      dimension Eo2Ec2Med_old(50)
!
      real    :: rFac
!
      AggiornaFasi = 0
      nreflSav = nrefl
      
      call AllocaVLD      

      if (ifRemo == 1) then
          PHIq(1:nrefl) = iphaz(1:nrefl)
          wq(1:nrefl)   = wt(1:nrefl)
          n_abi_model   = 1
          MaxRun        = 1
          n_Maxrun      = 1
          numbrun       = 1
          n_cicli       = 20
          n_cb          = 20
          n_EDM         = 10
          ksize_vero    = ksize
          kverbo_pg     = 1
          sog_sigmaA    = 0.97
          sog_ref       = 100.
          sogFinalFom   = 2.0
          call AllocaAtomi(1)
      endif

      stopFinalFom = 0.3
      stopFinalFom2 = 0.8
      
      nrefl = nreflSav

      ifTiDeviFermare = 0

!      ksigma_pg = ksigma
      ksigma_pg = 0 ! per non utilizzare gli eventuali valori di sigmav

      line = 'the VLD procedure starts '
      lline = Lung(line)
      call scrend(line,lline)
      if (knw /= 0) then
          write(lo,'(/,a,/)') line(1:lline)
      endif
      line = ' '
 
      if (no(1) == 1) then 
          jlig = 2
      else
          jlig = 1
      endif
      
      naatoms_max = 0
      numero_cicli_max = 0
      numbrun_max = 0
      
      fcoef(1:nrefl) = evet(1:nrefl)     !pgVLD290111
      jpatt = 0
      krecy = 0
      mode = -1
      MaxRun = n_Maxrun + n_abi_model -1
          
      amedia_n_EDM =  0.0
      ifExamin = 1                   !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ifExaminSav = ifExamin
!      ifExamin = 0                   !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      time_tot_edm = 0
      num_tot_edm = 0
      time_tot_raffi = 0
      num_tot_raffi = 0
      rfac_edm_min = 9999.
      num_model_edm_min = 0
      
      call Calcola_SigmaN_es
      
! Find the first seed to generate random phases
      do i=1, n_abi_model - 1
         call RandomPhases_VLD
      end do
         
      n_EDM_save = n_EDM
!
!-- inizializza i grafici
!
      if (ksize <= 3) then
         call RWind(0)
      else
         call RWindMainWindow(0)
         k = n_Maxrun
         call DataForGraph(5,k)
      end if
!
!-- inizializza la figura di merito
!
      call InitFinalFomVLD   !gl
      
      numsog = 20  ! soglia dinamica di FFOM
              
! Esplora tutti i models (seeds.... trials .....)
! a partire dal trial n_abi_model (default = 1)
      do numbrun = n_abi_model, MaxRun
      
          NewPoint = .true.

          if (numbrun > 1) then
            line = 'change random model        '
            write(line(21:23),'(i3)') numbrun
            lline = lung(line)
            call scrend(line, lline)
            if (knw /= 0) then
                write(lo,'(/,a,/)') line(1:lline)
            endif
            line = ' '
         end if
                   
         if (ifMadEnv == 0) then
             inumC = numbrun!!*1000000
!!           call c_scr2(-2, inumC, ' ')                       !mr
             call c_scr2(-2, 0, 0, inumC, 0, ' ')                 !mr
         endif
!
         nsetVLD = numbrun
         stopFinalFom = 0.3
         stopFFsog = 0.4  ! soglia dinamica di FFOM
         num_ffom = 0     ! soglia dinamica di FFOM
         sumef = 0.0      ! soglia dinamica di FFOM
        
         perc_cammino_Rat = 0.20
         if (ksize <= 3) then
            call RWind(1)
         else
            call RWindMainWindow(1)
         end if

         iperc = 0
         numbrunTot = numbrun
         nCycleVLD = 0
         erreBestVLD = 9999
         rfac_edm = 9999.
         rfac_init = 0.0
         rfac_10EDM = 0.0
         Rat_VLD = 0
         numbDyn = nrefl
         nstr = nstrSav
         amed_Dl = 0.0
         nats = natm
         somma_rfac = 0.0
         n_rfac = 0
         iphaz(1:nrefl) = 0
         wt(1:nrefl) = 0
         
! genera un set di fasi random per tutti i riflessi
         if (knw == 1) then
             write(lo,'(a,i4,a,i11,/)')
     *             ' The random seed generator for Model n. ',
     *             numbrun,' is', iyrand
         endif
     
         call RandomPhases_VLD
         
         if (ifRemo == 1) then
             iphaz(1:nrefl) = PHIq(1:nrefl)
             wt(1:nrefl)    = wq(1:nrefl)
         endif
!
         npercBarra  = 100
         npercBarra  = n_cicli
         iperc0      = n_cicli / npercBarra
         iperc       = iperc0
         jpercBarra  = 0
         call scrper('Running VLD procedure ',0,0)
!                 
         ifStoredPhases = 0
         fomBestVLD = -9999
         eFom_MDM = 0
         do numero_cicli = 1, n_cicli
            ifScriviCicloVLD = 1
            n_EDM = n_EDM_save
            if (numero_cicli == iperc) then
               jpercBarra = jpercBarra + 1
               iperc = iperc + iperc0
               call scrper(' ',jpercBarra,npercBarra)
            endif

            if (ifMadEnv == 0) then
                inumC = numero_cicli + n_cicli*1000 + numbrun*1000000
!!              call c_scr2(-2, inumC, ' ')
                call c_scr2(-2,numero_cicli,n_cicli,numbrun,MaxRun,' ')
            endif
            

*           call ScriviCicloVLD(numero_cicli, numbrun,
*    *               eFom_MDM, Rat_VLD, perc_cammino_control)
            call Messaggi_VLD

            if (knw /= 0 .and. kverbo_pg == 1) then
               write(lo,51) numero_cicli,numbrun
!pg201213               
   51          format(/,' Ciclo =',i4,'/',i3,/)
            end if
   

!    mappa iniziale osservata con fasi random
            iphazo(1:nrefl) = iphaz(1:nrefl)
            Wt_save(1:nrefl) = wt(1:nrefl)  
            fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
            call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,FORTH,BACK)
!   plot per il ciclo n. 1
            if (numero_cicli == 1) then
               Rat_VLD = 0.0001
               sigmaA_1 = 0.0001
               FinalFom = 0.0001
               FinalFom2 = 0.0001
               if (ksize > 3) then
                   call PlotFinalFomVLD(1)
               end if
            end if
     
            FinalFom2 = -9999

            if (numero_cicli > 1) then 
! eventuale calcolo del modello dopo la DEDM precedente
!pg201213         
!               if (ifTime == 0 .and. knw > 0 .and.  kverbo_pg == 1) then
!                  nats_sav = nats          
!                  aperc(1) = nats
!                  call Model_post_DEDM(jlig)
!                  nats = nats_sav          
!                  aperc(1) = nats
!               endif
!  calcolo dei gamma cicli EDM 
               percp = 0.025
               call EDM_Cycles_VLD(percp, 0, 0)
            end if   
!-------------------------------------------------------------------------------
      
            if (kverbo_pg /= 0) then
!pg201213                
               write(lo,'(/,i2,i4,a,3f15.10,2i5)') numbrun,numero_cicli,
     *               '  SA, perc_cammino_SA, Rat_VLD=',
     *                sigmaA_1,perc_cammino_Rat,Rat_VLD,ksize,ksize_vero
            end if
              
            if (ksize > 3) then
               if (numero_cicli > 1 .or. numbrun > n_abi_model) then
                  call CalcFFomVLD(1, corre_VLD)
                  call SalvaFasi(1, FinalFom2, corre_VLD, 0)

                  if (ifTime == 0 .and. kverbo_pg == 1) then
                     write(6,*) 'FinalFom, stopFinalFom',
     *                           FinalFom,stopFinalFom
                  endif   

                  if (FinalFom > stopFinalFom) then
                  
!    Blocco ulteriore di cicli  EDM per medie-grandi trovata la possibile soluzione
             
                     call MiglioraFasi(AggiornaFasi, numsog, stopFFsog,
     *                            sumef, num_ffom, ifLsqVLD, corre_VLD)
                     if (kWstop == 1 .and. ifLsqVLD == 1) then    ! 11/11/11
                         return
                     end if
                     
                  endif
                  
               endif 
            endif

            perc_cammino_control = perc_cammino_Rat
            
            zero_qualcosa = 1.00
            soglia = zero_qualcosa * perc_cammino_control
            
            if (sigmaA_1 > Rat_VLD) then
                sigmaA_1 = Rat_VLD
            end if

!pg201213
!            if (sigmaA_1 > soglia .or. kWstop == 1) then
            if (sigmaA_1 > soglia .or. kWstop == 1 .or.
     *          (numero_cicli <= 3 .and. ksize_vero <= 3)) then
               call Prova_a_Raffinare(corre_VLD)           ! il ciclo e' degno di "attenzione" !!!!
               if (ksize > 3) then
                   call scrper('Running VLD procedure ',0,0)
                   call scrper(' ',jpercBarra,npercBarra)
               endif
               if (kWstop == 1) then
                   call DeAllocaVLD
                   AggiornaFasi = 1
                   call SalvaFasi(1, FinalFom2, corre_VLD, AggiornaFasi)
                   return
               end if
            end if
      
            call DEDM_VLD(rfac, ifBreak)
            
            if (ifBreak > 0) then
                call DeAllocaVLD
                return
            endif
         
            call Tangente_VLD
         
            if (knw > 0 .and. ifExamin == 1 .and. ifTime == 0) then
!pg201213               call VLD_Statistics
            end if
!
!-- manage BREAK button
!
            if (ifBreak == 0) then
                ifBreak = ifBreakFun()
                if (ifBreak == 1) then
                   exit
                endif
            endif
   
                
         end do  ! numero_cicli = 1, n_cicli
!
!-- ha finito i conti sul trial corrente
!
         if (numero_cicli > n_cicli) then
             numero_cicli = n_cicli
             cicloBestVLD = numero_cicli
         endif
         call EndTrialVLD
         if (ifExamin == 1 .and. knw == 1) then
            write(lo,4533) naatoms_max, numero_cicli_max,
     *                     numbrun_max
         end if
         if (kWstop == 1) then
             numero_cicli = cicloBestVLD
             corre_VLD = correBestVLD
             call DeAllocaVLD
             AggiornaFasi = 1
             call SalvaFasi(1, FinalFom2, corre_VLD, AggiornaFasi)
             exit
         endif

         if (ifBreak == 1) then
             exit
         endif
     
      enddo  ! numbrun = n_abi_model, MaxRun

      if (ifBreak == 1) then
          n_abi_model = n_abi_model - 1
          numbrunTot = 0
          ifBrekke = 0
      endif

      go to 1234   ! eventualmente eliminare il blocco che segue

      if (knw /= 0) then
          write(lo,*) ' Numero totale di cicli EDM =',
     *                amedia_n_EDM
          write(lo,4533) naatoms_max, numero_cicli_max,
     *                numbrun_max
          write(lo,*) 'Tempo x edm, n. di cicli edm)',
     *                time_tot_edm, num_tot_edm
          write(lo,*) 'Tempo x raffinamenti, n. di raff.',
     *                time_tot_raffi, num_tot_raffi
          write(lo,'(a,f7.3,a,i4,a,i4)') ' Rfactor minimo = ',
     *      rfac_edm_min, ' in  ciclo=',num_rfac_edm_min, '/',
     *      num_model_edm_min 
      endif

 1234 continue

      line = ' '
      nz(:) = nzsav(:)
      kWstop = 0
      ifExamin = ifExaminSav
      call DeAllocaVLD
      return

 4533 format(//,' Maximum of matches founds:  ',i5,
     *    ' in cycle N.:  ',i5,'    of Trial N.:',i3) 
      end
c ------------------------------------------------------------------
      subroutine Model_post_DEDM(jlig)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE TestModel
      USE PhaseModule
      USE VLDmod
      USE VLDmod_3
      
      integer :: numb
      mode = -1
      
      numb = nrefl                   ! gianluca 13/09/2011
      call Search99(mode,ier, numb)  ! gianluca 13/09/2011
      
      ifOccVar = 0     ! =0 : occ = 1    
                       ! =1 : occ = rapporto fra altezza dei picchi
      if (ifOccVar == 0) then
          nono = jlig     ! tutti specie leggera
      else
          nono = nk       ! tutti specie pesante  
      end if
      nz(1:nats) = nono * nzConst
      nzsav(:) = nz(:)
      bfac(:) = bt
      if (ifTuttiCarboni == 0) then
         call label(nats)
         call muovi
         if (ifContrLab == 1) then
            call ControllaLabel
         end if
      end if
      iniz = 1
      ifin = nats
      call MakeLab(iniz,ifin)
      
      if (numero_cicli > 1 .and. knw /= 0 .and.ifExamin==1) then
         write(lo,'(a,/)')
     *          ' MODELLO ALLA FINE DELLA DEDM PRECEDENTE'
      end if
      
      do i =1,nats
         write(lo,3322) alab(i),xyzs(1:5,i),nz(i)
      end do
 3322 format(a8,5f8.3,i8)
      
      nz(:) = iabs(nz(:)) / nzConst
      
      erore = 99.99
      if (kverbo == 1) then
          call to_coord_sir(1,nrefl)          !pgVLD
      elseif (ifExamin == 1) then
          call to_coord_sir(0,nrefl)          !gianluca
          write(lo,80) nint(vett_test(1:3)),erore,vett_test(4)
      endif
      if (naatoms_max < naatoms) then
         naatoms_max = naatoms
         numero_cicli_max = numero_cicli
         numbrun_max = numbrun           
      end if

   80 format(i5,' atoms published,',i5,' used, ',i5,' found. MPE =',
     *      f8.3,' <dist> = ',f8.3)
      return
      end  
c ------------------------------------------------------------------
      subroutine DEDM_VLD(rfac, ifBreak)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE TestModel
      USE Molcom, only : jscreen, ifMadEnv
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3
      
      if (knw /= 0. and. kverbo == 1)  then
         write(lo,'(/,a)') 'INIZIO PROCEDURA DEDM '
      end if
            
!  inversione della mappa e calcolo dei fattori normalizzati Ep, Epp e PHIp
      jpatt = 0   
      npunti=np(1)*np(2)*np(3)
      percp=0.01
      percn=0.00
      npts1=npunti*percp ! punti positivi
      npts2 = 0
      call denhist(0,xmap,xenve,npts1,npts2)
c
c--inverto la mappa
c
      knw_save = knw
      knw = 0
      call ChangeAndInvMap_VLD(xmap,xenve,1,0.0,1,1,ier)     
      knw = knw_save
 
      work1(1:nrefl) = fcvet(1:nrefl)
      nwizm1=25
      nsip1=150 
      if (ksize_vero < 3) then
          call HistogramMatch(work1,work1,nrefl,nsip1,nwizm1,4) 
      else
          call HistogramMatch(work1,evet,nrefl,nsip1,nwizm1,1) 
      endif
      fcvet(1:nrefl)= work1(1:nrefl)          
       
      SigmaPN = 0.97    ! SigmaP/SigmaN
      do i=1,nrefl
! in Epp memorizzo fc/sqrt(SigmaN)
         Epp(i) = work1(i)
! in Ep memorizzo fc/sqrt(SigmaP)     
         Ep(i) = work1(i) / SigmaPN
         work1(i) = fcvet(i) *SigmaN(i)
      end do

! calcolo residuo tra fovet e fcvet per riscalamento  sigmaA

      sumfo = sum(fovet(1:nrefl))
      sumfc = sum(work1(1:nrefl))
      scala = sumfo / sumfc
      anum = sum(abs(fovet(1:nrefl)-scala*work1(1:nrefl)))
      aden = sum(fovet(1:nrefl))
      rfac = 100.*anum/aden
      
      if (ifDsrVLD >0) then
          if (ifPrimaEDMg) then
              rfac_init = rfac
              rfac_10EDM = rfac
              write(lo,*) 'Riniz = ', rfac_init
          else

c             rfac_init = rfac_init_edm  !dedi 02/04/13

              rfac_10EDM = rfac
              if (knw == 1) then
                  write(lo,*) 'Riniz e Rattuale ', rfac_init,rfac_10EDM
              endif
          endif
      else
        if (numero_cicli > 1  ) then
            rfac_init = rfac_init_edm
        end if    
      endif
            
c     if (ifDsrVLD > 0 .and. LowRes == 0) then
      if (ifDsrVLD > 0) then
          fcvet(1:nrefl) = Ep(1:nrefl)
          PHIp(1:nrefl) = iphaz(1:nrefl)

          if (nsym == 1 .and. icent == 0) then
          else
            if (knw > 0 .and. ifExamin == 1 .and. ifTime == 0) then
                wt(1:nrefl) = 1.0
                call Calcola_EqVero
            end if
          end if

          call Calcola_SigmaA(Rat_VLD)
          a = sum(Dluz(1:nrefl))/float(nrefl)
          if (knw > 0 .and. kverbo_pg > 0) then
              write(6,*) '<sigmaA>',a
          endif
          if (a < sigmaAmed) then
              b = sigmaAmed / a
              do i=1, nrefl
                 c = b * Dluz(i)
                 if (c < 1.0) then
                     Dluz(i) = c
                 endif
              enddo
              a = sum(Dluz(1:nrefl))/float(nrefl)
              if (knw > 0.and. kverbo_pg > 0) then
                  write(6,*) '<sigmaA>',a
              endif
          endif
      else
          call ri_Calcola_SigmaA
!pg201213          
          if (knw > 0.and. kverbo_pg > 0 .and. ifTime == 0) then
              write(6,*) '<sigmaA>',sum(Dluz(1:nrefl))/float(nrefl)
          endif
      endif

      nume_inv = 0
      do i=1,nrefl
         X = (2. * Dluz(i) * evet(i) * Ep(i)) / (es(i) - Dluz(i)**2)
         pesMod(i) = bes(X)
! mR - Rp

         fcoef(i) = pesMod(i)* evet(i) - Ep(i)

         wt(i) = pesMod(i)
         
         ArgGq(i) = fcoef(i)
         
         PHIq(i) = PHIp(i)
         if (fcoef(i) < 0) then
            nume_inv = nume_inv + 1
            PHIq(i) = PHIp(i) + 180
            PHIq(i) = mod(PHIq(i),360)
            if (PHIq(i) == 0) PHIq(i) = 360
            fcoef(i) = -fcoef(i)
         end if
      end do
      pesMod_med = sum(pesMod(1:nrefl))/nrefl

!   Inserimento statistiche di PHIq   rispetto a PHIqvero prima della Fourier differenza   18/12/2009
      if (knw > 0 .and. ifExamin == 1 .and. ifTime == 1000) then  !pg201213
          if (kverbo_pg > 0) then
              izero = 0
              ifmin = 1
              nbru = 4450
              write(lo,'(/,a)')
     *    ' M.P.E. PHIq rispetto a PHIqVero prima di fourier differenza'
              call examin(nbru,mkang,khl,PHIqVero,PHIq,nrefl,izero,wt,
     *                    ifmin)   
          endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!        
          
         rmag = 100.*count(ArgGq(1:nrefl) > 0.0) / nrefl 
         if (kverbo_pg > 0) then
             write(lo,'(/,a,f6.1,a,i7,/)') 'perc di ArgGq > 0.0 =',rmag,
     *          '   numinv =',nume_inv
         endif
      end if
!-----------
      amed_Dl= sum(Dluz(1:nrefl))/nrefl
!pg201213      
      if(knw /= 0 .and. kverbo_pg == 1 .and. ifTime == 0) then
         ammin = minval(pesMod(1:nrefl))
         ammax = maxval(pesMod(1:nrefl))  
         amed_m = sum(pesMod(1:nrefl))/nrefl
         ammin1 = minval(Dluz(1:nrefl))
         ammax1 = maxval(Dluz(1:nrefl))  
         write(lo,'(/,a,11x,3e25.15)')' DEDM: min, max, med(m) = ',
     *      ammin,ammax,amed_m
         write(lo,'(/,a,a,4e25.15,/)')' DEDM: min, max,med(sigmaa)',
     *      ',Resid = ', ammin1, ammax1, amed_Dl, rfac
      end if

      call DEDM_Recycle
      
      return
      end
c ------------------------------------------------------------------
      subroutine ri_Calcola_SigmaA
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE ShellSIGMAA
      USE TestModel
      USE VLDmod
      USE VLDmod_1
      USE VLDmod_2
      USE VLDmod_3

      dimension Eo2Ec2Med(50)
      dimension Eo2Ec2Med_old(50)

      Rat_VLD = ( rfac_init  - rfac_10EDM ) / ( rfac_init - 40.)

      call Calcola_SigmaA(Rat_VLD)

      if ( numero_cicli == 1 ) then
         SigmaA_init = amed_Dl
      end if
! riscalamento della SigmaA in DEDM

      if ( mod(numero_cicli, n_cb) /= 1 ) then
         Rat_VLD = ( rfac_init  - rfac_10EDM ) / ( rfac_init - 40.)
         if (Rat_VLD < 0.1) Rat_VLD = 0.1
         sigmaA_1 = (amed_Dl - sigmaA_init) / (0.97 - sigmaA_init)
         if (sigmaA_1 < 0.1) sigmaA_1 = 0.1

         amedia_teorica = sigmaA_1 * (Rat_VLD**0.3)
         if (amedia_teorica <0.2) amedia_teorica = 0.2
         n_cyc = mod(numero_cicli,2)
         if (n_cyc == 1 .and. numero_cicli > 2) then
            amedia_teorica = 0.6
         end if
      else
         amedia_teorica = 0.1
      end if
      
      fattore = amedia_teorica / amed_Dl_orig
      
      if (fattore > 1.0) then
         fattore = 1.0
      end if
      
      if (ifRemo == 1) then
         fattore = 1.0
      end if

      do i=1, nrefl
         Dluz(i) = Dluz(i)* fattore
         if (Dluz(i)>0.97) Dluz(i)=0.97
         if (Dluz(i)<0.2 .and. mod(numero_cicli,n_cb)/=1) then
            Dluz(i)=0.2
         end if
      end do

      amed_Dl= sum(Dluz(1:nrefl))/nrefl
!pg201213      
      if (knw /= 0 .and. kverbo_pg == 1 .and. ifTime == 0) then
       write(lo,'(a,a,3e25.15)') ' <sigmaATeorica>, <SigmaAorig>,',
     *    '<SigmaArisc>', amedia_teorica, amed_Dl_orig, amed_Dl
      end if 
            
      do i=1,nrefl
         X = (2. * Dluz(i) * evet(i)*fcvet(i))/(es(i) - Dluz(i)**2)
         wt(i) = bes(X)
      end do 
! -----------------------
!in fcvet metto Ep per calcolo sigmaa
      fcvet(1:nrefl) = Ep(1:nrefl)
      
!      goto 12345

      do i = 1,nrefl
         if(mkang(i).ne.1) then
            iphi=iphaz(i)
            idv = 15*mod(mkang(i)-1,12)
            id1 = iabs(idv-iphi)
            id2 = iabs(idv+180-iphi)
            id1=min0(id1,360-id1)
            id2=min0(id2,360-id2)
            if(id1.lt.id2) then
               iphi=idv
            else
               iphi=idv+180
            endif
            iphi=mod(iphi,360)
            if (iphi == 0) iphi = 360
            iphaz(i) = iphi
         end if
      end do
!12345 continue

! in PHIp le fasi delle parziale
      PHIp(1:nrefl) = iphaz(1:nrefl)
      
      if (ifExamin == 1 .and. knw /= 0) then
          call Calcola_EqVero
      end if

!  richiamo della sigmaa e calcolo della fourier differenza RHOq

      call Calcola_SigmaA(Rat_VLD)
          
      do i=1, nrefl
         Dluz(i) = Dluz(i)* fattore
         if (Dluz(i)>0.97) Dluz(i)=0.97
         if (Dluz(i)<0.2 .and. mod(numero_cicli,n_cb)/=1) then
            Dluz(i)=0.2
         end if
      end do
      
      amed_Dl= sum(Dluz(1:nrefl))/nrefl

      return
      end
!-----------------------------------------------------------------------
      subroutine InitFinalFom_PROT()
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE Param
      USE PhaseModule
      USE VLDmod

!
!--calcolo il valore di riferimento per la FinalFom
!
      fomold(:)  = 0.0
      iyrandSav = iyrand
      iyrand = 67543
      call RandomPhases_VLD
      call Calcola_FOM_Lib(1)

      fomold(1)  = CCEoEc(1)
      fomold(2)  = CCEoEc(2)
      fomold(3)  = FOMs(2,4)

      numrat_first = FOMs(2,2)

      if (knw == 1) write(6,*) 'FOMOLD',fomold(1:3)

      figuracce(1,1) = FOMs(2,2)  !num Rat
      figuracce(1,2) = FOMs(2,3)  !denom Rat
      figuracce(1,3) = FOMs(2,4)  !RAT
      figuracce(1,4) = fig_CC(1)  !CC all
      figuracce(1,5) = fig_CC(10) !comb  = CC large + 3 * CC weak
      figuracce(1,6) = fig_CC(2)  !CC lage
      figuracce(1,7) = fig_CC(4)  !CC weak
      figuracce(1,8) = fig_CC(4) * 3 !cc weak * 3

      if (knw == 1) then
          write(6,10) figuracce(1,1:3)
          write(6,20) figuracce(2,4), figuracce(2,6)
      endif

! calcolo fasi e pesi random per FFom casuale di confronto

c         if (ksize <= 3) then

c             sogFinalFom = 2.0
c             stopFinalFom = 1.0
c             FFomStopPGM = 99.9

c         else

                  sogFinalFom = 1.0
                  sogFFomRif = 1.9
                  stopFinalFom = 3.0 
    
c         endif
! - per non bloccare il PGM in base alla FFom di default
         if (ffomReq /= -99) then
             FFomStopPGM = ffom
         else
             FFomStopPGM = stopFinalFom
         endif


      FFomRif   = sogFFomRif
      stopFFom  = stopFinalFom

      xmap(:,:,:) = 0.0
      iyrand = iyrandSav
      iphaz = 0.0
      wt = 0.0
      call UpdateReflInfo

 10   format(' Initial numRAT,denomRAT,RAT   ',3f10.5)
 20   format(' Initial CCall , CClarge        ',2f10.5)

!
      return
      end
!-------------------------------------------------------------------------------
      subroutine Run_DSR(ifBreak, correl, ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE RemoModule
      USE PhaseModule
      USE VLDmod
      USE Mappa

!
      nMacroTot = 15
      nBlockEDM = 5
!
      erreSav = erre
! 
      ier = 0
      iesFom = 0 
!
      f000 = 0.0
      waveare = 0.0
      exposigma = 2.0
      cicloEDM = 0
      Iterazione = 0
!
      FinalFom = 0.0
      sogFFomRif = FFomRif 

      if (ksize > 3) then
          stopFinalFom = stopFFom
      endif
!
!
!-- Envelope
!
      RenveStart = 8.0
      RenveDyn   = RenveStart
      EnvePronta = 0
      ifEnve = 0
      if (ksize > 3) then
          ifEnve = 1
      endif
!
      nMacroAppl = 0
      esalta = esaltaPatt
!
!--EDM - iterations

      nIterazioni = 1
      if (knw > 0) write(6,*)  'nIterazioni = ',nIterazioni

      do Iterazione = 1,nIterazioni
          call CalcolaBarra()
          nbarra = iabs(nbarra)
          nMacroAppl = 0
          RenveDyn = RenveStart
          if (ksize > 3) then
              ifDrsVLD = 1
          endif
!
c         call Scegli_DSR(ifBreak,correl,ier)   ! per scegliere il DSR in base al size
!
          call DirectSpaceRefinement_PROT(correl,ifBreak, ier)
!
          if (ifBreak == 1) then
              return
          endif
      enddo
!
      write(lo,15) numbrun, FinalFom ! FOMs(2,4)
 15   format(11x,' Trial',i6,3x,'End of DSR  -  Final FOM =',f7.3)
!
      erre = erreSav
!
      return
      end
!-------------------------------------------------------------------------------
      subroutine DirectSpaceRefinement_PROT(correl,ifBreak, ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE Mappa
      USE MapTest
      USE MappaCont
      USE Param
      USE PhaseModule
!
      USE HistoStuff
      USE Skeleton
      USE VLDmod
!
!-- nBlockEDM = total number of EDM blocks
!-- nMacroTot = total number of macro cycles
!-- nMicro    = number of micro cycles per macro cycle
!-- nMacro    = number of macro cycles per EDM block
!
      common /anna1/ scale2,sigma_rif,cicloHafr,iesHM,nCB
      common /anna2/ ipr
      common /misc/ ttt(3,3), dxmax(3), ishift(3,19)
      integer cicliFour, iesEnve
      integer uset
      real xs(3)
      character*8  a8
      logical ifPrimaVolta

      ifPrimaVolta = .true.
      ifExpa = 0

      if (knw == 1) then
          write(6,*) 'DSR_PROT ITERAZIONE ',Iterazione
      endif
      call CPUTime0('inizio Iterazione')

!Modifico il numero di riflessi di partenza per la Patterson

      nstr_orig = nstr
      ns   = 0.15 * numbLSQ 
      nstr = max(nstr,ns)
      numb = nstr
!
      ifDEDM = 0
!
      correl   = 0.0
      correMR = 0.0
      ier = 0
      jpatt = 0
      mode = 0
      krecy = 0
      chope = 0.5
      icode = 0
      ipr = 0
!
      iniz = 1
      EnvePronta = 0
      RenveDyn = 0.0
!
      nMacro = nMacroTot / nBlockEDM
      nMicro = 5
      if(iheavy==1) nMicro = 7

      MetaMicro = nMicro / 2 + 1
      nMacroAppl = 0
      nmeno=0
      nMicroNeg_ini =  nMicro-2
      nMicroNeg_fin =  nMicro-nmeno
      nMicroNeg = (nMicroNeg_fin-nMicroNeg_ini)+1

      nbarra = nMacroTot * (nMicro+nMicroNeg)
      call Barra
!
      nCB = 0
      Blocchi: do indiceBlocchi=1,nBlockEDM
         numbDyn = numbLSQ
         if (ifExamin /= 0) then
             write(lo,11)
             if (indiceBlocchi == 1) then
                 if (ifRemo == 0) then
                     ifmin = 0 ! 10
                 else
                     ifmin = 10
                 endif
                 luset = 555
                 izero = 0
                 call examin(luset,mkang,khl,ipub,iphaz,nreflDim,izero,
     *                    wt,ifmin)
                 write(lo,112) erore, erorepes, isumal
             endif
         endif

         if(ifExpanded>0) then
            x  = Iterazione
            x1 = 1
            x2 = 3 
            y1 = 0.5
            y2 = 1.0
            call varlinear(x,x1,x2,y,y1,y2)
            chopeiniz=y
         else
            chopeiniz=0.5
         endif
!
!
!!!!   if (ifReduced == 0) then

!!!!      if (Iterazione == 1 .and. mod(indiceBlocchi,2) == 0) then
!!!!          call Hafr_VLD_new(numbLSQ,ifBreak,ier)
!!!!          if (ifBreak == 1) return
!!!!      else
!!!!          call PattVLD(ifPrimaVolta)
!!!!          call PattVLD(ifPrimaVolta)
!!!!      endif

!!!!   endif

!

         Macro: do indiceMacro=1,nMacro

            nMacroAppl = nMacroAppl + 1
            chope = chopeiniz + nMacroAppl * 0.1
            if (chope.gt.2.0) chope = 2.0

!
!--memorizzo le fasi e i pesi dei riflessi estrapolati
!

            if (numbGen > 0) then
                   call Expand2006(chope,expTerm)
            endif
!
            if (kverbo.gt.0) then
                luset = nMacroAppl*1000+777
                izero = 0
                ifmin = 1
                call examin(luset,mkang,khl,ipub,iphaz,nstr,izero,
     *                      wt,ifmin)
            endif
!
!--selezione dei riflessi osservati  
!
            if (ifExpanded == 0) then
                wt(numbDyn+1:) = 0.0
            endif
!
!           ncond1 = nstr
            ncond1 = nstr * 1.5  !2


          ifin = numbLSQ
          work1(1:ifin) = wt(1:ifin)
          call sortall(-1,work1,ifin)
          sog = work1(ncond1)
          do i=1,ifin
             if (wt(i).lt.sog) then
                wt(i) = 0.0
             endif
          enddo

!
!--elimino i riflessi tra numbLSQ+1 : nerfl
!
         wt(numbLSQ+1:nrefl) = 0.0
!
!--selezione dei riflessi estrapolati
!
         if(ifExpanded>0) then
           work1(1:numbGen) = wt(nrefl+Added+1:nreflTot)
           call sortall(-1,work1,numbGen)
           ncond1 = ncond1*float(numbGen)/float(nrefl)
           sog=work1(ncond1)
           icont=0
           do i=nrefl+Added+1,nreflTot
              if (wt(i).lt.sog) then
                  wt(i) = 0.0
              else
                  icont=icont+1
              endif
           enddo
!          write(6,*) 'soglia',icont1,icont,float(icont1)/float(icont)
         endif

!-- statistiche
!
         kverbo_sav = kverbo
         kverbo = 1
         if (nsym == 1.and.icent == 0) kverbo = 0
            if (kverbo.gt.0) then
                uset = nMacroAppl*1000+888
                izero = 0
                if (ifRemo == 1) then
                    ifmin = 11
                else
                    ifmin = 1
                endif
                call examin(uset,mkang,khl,ipub,iphaz,numbLSQ,izero,
     *                      wt,ifmin)
                som = -99.9
                som = sum(wt(numbLSQ+1:nrefl))
                if (som > 0.001) then
                izero = numbLSQ
                call examin(uset,mkang,khl,ipub,iphaz,nrefl,izero,
     *                      wt,ifmin)
                endif
                izero = 0
                call examin(uset,mkang,khl,ipub,iphaz,nrefl,izero,
     *                      wt,ifmin)
                if (Added > 0) then
                izero = nrefl
                call examin(uset,mkang,khl,ipub,iphaz,nrefl+Added,izero,
     *                      wt,ifmin)
                endif
                if (numbGen > 0) then
                izero = nrefl+Added
                call examin(uset,mkang,khl,ipub,iphaz,nreflDim,izero,
     *                      wt,ifmin)
                endif
            endif
         kverbo = kverbo_sav
!enve
            if (knw == 1) then
                call toflush()
            endif
!enve
            iesnegmap = 0
            Micro: do indiceMicro = 1,nMicro
               percMap_n = 0.0
               percMap = 0.020 + Iterazione * 0.005
               percMap = min(percMap, 0.05)
               invflag = 1
            
               if (LowRes == 0) then
                   call Inverti_HIGH(numbDyn,chope,correl,ifBreak,ier)
               else
                   call Inverti_LOW(numbDyn,chope,correl,ifBreak,ier)
               endif

               if (ier < 0) return
               if (ifBreak == 1) return

               if (knw == 1) then
                   kstp = 0
                   if(kverbo==1) then
                      iesCC = 1
                   else
                      iesCC = 1
                      if (jsys == 1 .and. indiceMicro /= nMicro) then
                          iesCC = 0
                      endif 
                   endif
                   if (iesCC==1. and. ifReduced == 0)  then
                       correl_all = correl  
                       call Calcola_CC_Mappa(numbLSQ,correl,kstp,2)
                       write(lo,99) cicloEDM,correl,correl_all
                   endif
               endif

               call Barra()

            enddo Micro
!
            if (knw == 1) then
                call toflush()
            endif
!
!-- Mappa Negativa
!
            if (iheavy == 0) iesnegmap = 1

            if (iesnegmap == 1) then
!pg20012014
                 if (knw == 1) write(lo,*) ' MAPPA NEGATIVA'

                MicroNeg: do indiceMicro = nMicroNeg_ini, nMicroNeg_fin
                   percMap = 0.035
                   percMap_n = 0.015
                   invflag   = 3

                   if (LowRes == 0) then
                     call Inverti_HIGH(numbDyn,chope,correl,ifBreak,ier)
                   else
                     call Inverti_LOW(numbDyn,chope,correl,ifBreak,ier)
                   endif


                   if (ier < 0) return
                   if (ifBreak == 1) return
                   if (knw == 1) then
                       kstp = 0
                       if(kverbo==1) then
                          iesCC = 1
                       else
                         iesCC = 1
                         if (jsys == 1 .and. indiceMicro /= nMicro) then
                             iesCC = 0
                         endif

                       endif
                       if (iesCC==1. and. ifReduced == 0)  then
                       correl_all = correl
                       call Calcola_CC_Mappa(numbLSQ,correl,kstp,2)
                       write(lo,99) cicloEDM,correl,correl_all
                       endif
                   endif
                   call Barra()

                enddo MicroNeg
            endif
!
!-- Fine Mappa Negativa
!
            if (knw == 1. and. ifOUT == 1) then
                kstp = 1
!pg20012014
!                write(lo,15) numbrun,Iterazione,nMacroAppl,correl
            elseif (kverbo /= 0) then
                write(lo,16) numbrun,Iterazione,nMacroAppl
            endif
!
            iesEnve = 0 
!
            if (ifEnve.eq.1) then

                if (LowRes == 0) then
                    nMacro1=3
                    if (mod(nMacroAppl,nMacro1)==2.and.
     *                  nMacroAppl/=nMacroTot) then
                       iesEnve = 1
                    endif
                else
                    nMacro1=6
                    if ((LowRes==1.and.no(nk)>20).or.ksize==4) nMacro1=3
                    if(ksize > 4 .and. ResEff>sogResEff) nMacro1=1
                    if (mod(nMacroAppl,nMacro1)==0.or.
     *                  nMacroAppl==(nMacroTot-1)) then
                        iesEnve = 1
                    endif
                endif

                 if (iesEnve == 1) then
                    RenveDyn = CalcolaRaggioEnve(jpatt)
                    if (knw>0) then
                        write(6,*) 'RAGGIO ENVELOPE =',RenveDyn
                    endif
                    jpatt = 0
                    call Long_Env_New(numbDyn,jpatt)
                    EnvePronta = 1
                else
                    EnvePronta = 0
                endif
            endif
            if (EnvePronta < 0.5) RenveDyn = 0.0
!
!-- fine enve
!
            if (knw == 1) then
                call toflush()
            endif
!

         enddo Macro
!
      enddo Blocchi
!
      nstr = nstr_orig
!
!--nuovo calcolo di FinalFom
!
         call Calcola_FinalFom(0)
         call Calcola_FinalFom2(0)
!
         if (knw > 0) then
             write (lo,'(a,3f8.2)')
     *             'FinalFoms',FinalFom0,FinalFom,figuracce(2,14)
         else
             if (kverbo > 0) then
                 write (lo,120) FinalFom, Iterazione
             endif
         endif

!
        if (FinalFom > stopFinalFom) then
             kWstop  = 1
             if (knw == 1) write(6,'(a)') 'kWstop=1'
        endif

         if (ifOUT == 1) then
             write(lo,115) numbrun,Iterazione,FinalFom,sogFinalFom,
     *                                                    correl
             call toflush()
         endif

!
      if(knw>0 .and. ifExamin.ne.0) then
          luset = 999
          izero = 0
          ifmin = 0 ! 10
!         ifmin = 10
          call examin(luset,mkang,khl,ipub,iphaz,numbDyn,izero,wt,ifmin)

          write(lo,118) Iterazione,erore, erorepes, isumal,
     *                                    correl, FinalFom
      else
           write(lo,119) Iterazione,FinalFom
      endif
!
      if (knw == 1) then
          call toflush()
      endif

      iAct = knw
      call CPUTime('fine Iterazione', iAct)
!
      return

   11 format(/,5x,' EDM  MODULE (Electron-Density Modification)',/)
   15 format(' Trial',i6,2i4,'  EDM CC_MAP =',f7.3)
   16 format(' Trial',i6,2i4)
   99 format(5x,'CICLO EDM = ',i8,8x,'CORR_70% = ',
     *                            f8.3,6x,'CORR_ALL = ',f8.3,6x)
  112 format(10x,'Entering - Mean Phase Error ',f6.2,
     *       '  (',f6.2,')  over',i8,' reflections')
  115 format(/,' Trial',i6,'   Iteration #',i4,
     *       ' FOMs =',2f7.3,' CC (MAP) =',f7.3)
  118 format(' End Iteration',i4,' - MPE ',f6.2,
     *'  (',f6.2,') over',i8,' refl.',' CC = ', f6.3,' FFom = '
     *     , f6.3,i4,/)
  119 format(11x,' End Iteration',i4,' Final Fom = ',f6.3)
  120 format(11x,' Final Fom =',f8.3,' DSR Iteration #',i3)
      end
!------------------------------------------------------------------------------
      subroutine pherrdisNew_PG(tirang,dij,khl,mkang,nrif,ic,
     *               ia,ib,c,nrang1,rmax1,ipher)
! --- (tirang,wt,khl,numbMax,izero,
!                       ipub,iphaz,tmpwt,10,0.0,ipher) 
      USE General
      USE Riflessi, only:evet,fcvet
      USE PhaseModule
      
      common /istog_pg/ stog_in(31), stog_if(31), n_istog(31),
     *                  nrang, num_osser
!
      dimension khl(3,nrif),mkang(nrif)
      dimension ia(nrif),ib(nrif),c(nrif),dij(nrif)
      dimension his(201),cumde(201),range(201),
     * disa1(201),disb1(201),disa2(201),disb2(201),
     * cumerr1(201),cumerr2(201),cumerp1(201),cumerp2(201),
     * csegni(201),cumse(201),cmed(201),ccmed(201)
      character tirang*11
      integer his, cumde, ierv(3)

      real,    allocatable :: dijs(:)
      integer, allocatable :: jorde(:), jorde1(:)
c--
      if (ipher < 0 .or. ifExamin == 0) return    ! 27/7/2010 dedi - per uscire dalla subroutine
      if (ifTime == 1) return
!
      if (ipher.eq.0) then
          lll = -444
          ifmin = 10
          call examin(lll,mkang,khl,ia,ib,nrif,ic,c,ifmin)
      endif
      if (knw.eq.0) return
      if (nrif.le.0) then
         write(lo,*) ' nrif = 0'
        return
      endif
c--
      ierv(:) = 0
      IF (.NOT. ALLOCATED(dijs))
     *    ALLOCATE (dijs(1:nreflDim),  stat = ierv(1))
      IF (.NOT. ALLOCATED(jorde))
     *    ALLOCATE (jorde(1:nreflDim), stat = ierv(2))
      IF (.NOT. ALLOCATED(jorde1))
     *    ALLOCATE (jorde1(1:nreflDim),stat = ierv(3))
      ierr = sum(iabs(ierv(:)))
      if (ierr.ne.0) then
          write(lo,*) 'PherrDisNew Allocation error'
          call cstop(' ')
      endif
      do i=1,nrif
         jorde(i) = i
      enddo
      nrang = 10
      if (nrang1.gt.0)   nrang = nrang1
      if (nrang1.gt.200) nrang = 200
      itot=0
      sumsegni=0.0
      sumdif1=0.0
      sumdisb1=0.0
      sumdif2=0.0
      sumdisb2=0.0
      sumc=0.0
      do i=1,201
         range(i)=0.0
         his(i)=0
         cumde(i)=0
         cumse(i)=0.0
         csegni(i)=0.0
         cmed(i)=0.0
         disa1(i)=0.0
         disb1(i)=0.0
         cumerr1(i)=0.0
         cumerp1(i)=0.0
         disa2(i)=0.0
         cumerr2(i)=0.0
         cumerp2(i)=0.0
         disb2(i)=0.0
         ccmed(i)=0.0
      enddo
      rmin=99999.
      rabs=99999.
      rmax=-99999.
      ii=0
      do i=1,nrif
         if (i.le.ic) cycle
         kk=jorde(i)
         if (kk.eq.0.or.kk.gt.nrif) write(lo,*)kk
         if (c(kk).le.0.0) cycle
         ii=ii+1
         dijs(ii)=dij(kk)
         jorde1(ii)=kk
         if (abs(dij(kk)).lt.rabs) rabs=abs(dij(kk))
         if (dij(kk).lt.rmin) rmin=dij(kk)
         if (dij(kk).gt.rmax) rmax=dij(kk)
      enddo
      numsort=ii
      if (rmax.eq.rmin) then
          write(lo,*) ' rmax = rmin '
          return
      endif
      call sortall3(1,dijs,1,numsort,jorde1)
      if (rmin.lt.0.0) then
          rmax=amax1(rmax,abs(rmin))
          rmin=-1.0*rmax
      endif
      rmaxg=rmax
      rming=rmin
      if (rmax1.gt.0.0) then
          rmax=rmax1
          if (rmin.lt.0.0) rmin=-1.0*rmax
      endif

c--
      dev=rmax-rmin
      iaa=nint(dev)
      rang=float(nrang)
      if (iaa.gt.0) then
          dev=float(iaa)/rang
      else
          dev=dev/rang
      end if
      if (rmin.ge.0.0) then
          range(1)=float(int(10.*rmin))/10.
          do i=2,nrang
             range(i)=range(i-1)+dev
          enddo
      else
          range(1)=float(nint(10.*rmin))/10.
          nrangi=nint(rang/2.0)
          nrang=2*nrangi
          dev=rmax-rabs
          dev=dev/float(nrangi)
          do i=2,nrangi-1
             range(i)=range(i-1)+dev
          enddo
          range(nrangi)=-rabs
          range(nrangi+1)=rabs
          do i=nrangi+2,nrang
             range(i)=range(i-1)+dev
          enddo
      endif
c     range(1)=rmin
      range(1)=rming
      nrang=nrang+1
      range(nrang)=rmax
      range(nrang+1)=rmaxg
      
!cris
      range(1) = 0.0
!      do i=2,11
      do i=2,nrang1 + 1
          range(i) = range(i-1) + 0.1
      end do
c--
      n=2
      do i=1,numsort
         k=jorde1(i)
         jh = khl(1,k)
         jk = khl(2,k)
         jl = khl(3,k)
         shiftp=jh*shiftexam(1)+jk*shiftexam(2)+jl*shiftexam(3)
         shiftp=360.* shiftp + ia(k)
         dif1=shiftp - ib(k)
         dif2=shiftp + ib(k)
         dif1=abs(amod(dif1,360.))
         if (dif1.gt.180.)dif1=360.-dif1
         dif2=abs(amod(dif2,360.))
         if (dif2.gt.180.)dif2=360.-dif2

   17    if (dijs(i).le.range(n)) then
             his(n)=his(n)+1
         else
             n=n+1
             if (n.gt.nrang) n=nrang+1
             goto 17
         endif
         
         if (Iterazione == 6 .and. cicloedm ==630) then
             differ = amin1(dif1,dif2)
             if (differ > 120) then
              if (mkang(k) > 1) then
             pha_ver = amod(shiftp+36000.,360.)
!         write(lo,'(a,i5,i8,i5,f8.0,i8,3f12.5)')'  >120 =',n,k,mkang(k),
!     *       pha_ver,ib(k),dij(k),evet(k),fcvet(k)
               end if
              end if
         end if
         
         disa1(n)=disa1(n)+dif1
         disa2(n)=disa2(n)+dif2
         disb1(n)=disb1(n)+dif1*c(k)
         disb2(n)=disb2(n)+dif2*c(k)
         cmed(n)=cmed(n)+c(k)
      enddo
*-----cumulative
      cumerp1(nrang+1)=disb1(nrang+1)
      cumerp2(nrang+1)=disb2(nrang+1)
      ccmed(nrang+1)=cmed(nrang+1)
      do i=1,nrang
         cumerp1(nrang+1-i)=cumerp1(nrang+2-i)+disb1(nrang+1-i)
         cumerp2(nrang+1-i)=cumerp2(nrang+2-i)+disb2(nrang+1-i)
         ccmed(nrang+1-i)=ccmed(nrang+2-i)+cmed(nrang+1-i)
      enddo
*-----
      do i=1,nrang+1
         if (his(i).gt.0) then
             itot=itot+his(i)
             sumdif1=sumdif1+disa1(i)
             sumdif2=sumdif2+disa2(i)
             sumdisb1=sumdisb1+disb1(i)
             sumdisb2=sumdisb2+disb2(i)
             sumc=sumc+cmed(i)
             sumsegni=sumsegni+csegni(i)
             disa1(i)=disa1(i)/float(his(i))
             disa2(i)=disa2(i)/float(his(i))
             disb1(i)=disb1(i)/cmed(i)
             disb2(i)=disb2(i)/cmed(i)
             csegni(i)=csegni(i)/float(his(i))
             csegni(i)=100.*csegni(i)
         else
             disa1(i)=0.0
             disa2(i)=0.0
             disb1(i)=0.0
             disb2(i)=0.0
             csegni(i)=0.0
             cmed(i)=0.0
         endif
      enddo
      if (itot.le.0) then
          write(lo,*) ' itot = 0'
          return
      endif
      tot=float(itot)
      segnim=100.*sumsegni/tot
      dif1m=sumdif1/tot
      dif2m=sumdif2/tot
      disb1m=sumdisb1/sumc
      disb2m=sumdisb2/sumc
c-----cumulative 
      cumde(nrang+1)  =his(nrang+1)
      cumse(nrang+1)  =float(his(nrang+1))*csegni(nrang+1)
      cumerr1(nrang+1)=float(his(nrang+1))*disa1(nrang+1)
      cumerr2(nrang+1)=float(his(nrang+1))*disa2(nrang+1)
      do i=1,nrang
         cumde(nrang+1-i)  =cumde(nrang+2-i)+his(nrang+1-i)
         cumse(nrang+1-i)  =cumse(nrang+2-i)+csegni(nrang+1-i)*
     *                      float(his(nrang+1-i))
         cumerr1(nrang+1-i)=cumerr1(nrang+2-i)+disa1(nrang+1-i)*
     *                      float(his(nrang+1-i))
         cumerr2(nrang+1-i)=cumerr2(nrang+2-i)+disa2(nrang+1-i)*
     *                      float(his(nrang+1-i))
      enddo

      if (knw.eq.1) write(lo,200) tirang
      if (knw.eq.0) write(lo,250) tirang
      do i=2,nrang+1
         if (his(i).eq.0) cycle
         if (knw > 0)then
             if (shiftexam(4).gt.0.) then
                 write(lo,100) range(i-1),range(i),his(i),
     *                 disa1(i),disb1(i),cumde(i),
     *                 cumerr1(i)/float(cumde(i)),cumerp1(i)/ccmed(i)
            else
                 write(lo,100) range(i-1),range(i),his(i),
     *                 disa2(i),disb2(i),cumde(i),
     *                 cumerr2(i)/float(cumde(i)),cumerp2(i)/ccmed(i)
             endif
         else
             write(lo,150) range(i-1),range(i),his(i),cumde(i)
         endif
      enddo

      num_osser = numsort
      do i=1,nrang+1
          stog_in(i) = range(i)
          stog_if(i) = range(i)
          n_istog(i) = his(i)
      end do

      write(lo,"(24x,42('.'))")
      if (knw.gt.0) then
          if (shiftexam(4).gt.0.) then 
              write(lo,300)itot,dif1m,disb1m
          else
              write(lo,300)itot,dif2m,disb2m
          endif
      else
          write(lo,300)itot
      end if
  100 format(f10.4,'  - ',f10.4,i8,2f7.2,'  |',i8,2f7.2)
  150 format(f10.4,'  - ',f10.4,i8,'  |',i8)
  200 format(/,11x,a11,6x,' HIS',
     *      '  <err> <w-err>',' | ',
     *      '    CUM',
     *      '  <err> <w-err>')
  250 format(11x,a11,6x,'HIS',3x,'CUM')
  300 format(34x,i8,2f7.2,/)
c
      ipher = 0
      DEALLOCATE (dijs, jorde, jorde1, stat = ierr)
      if (ierr.ne.0) then
          write(*,*) 'PherrDisNew DeAllocation Error'
          call cstop(' ')
      endif
c
      return
      end
!-----------------------------------------------------------------------
      subroutine pherrdisNew_PG_ex(tirang,dij,khl,mkang,nrif,ic,
     *                       ia,ib,c,nrang1,rmax1,ipher)
! --- (tirang,wt,khl,numbMax,izero,
!                       ipub,iphaz,tmpwt,10,0.0,ipher) 
      USE General
      USE PhaseModule
      
      common /istog_pg/ stog_in(31), stog_if(31), n_istog(31),
     *                  nrang_o, num_osser
!
      dimension khl(3,nrif),mkang(nrif)
      dimension ia(nrif),ib(nrif),c(nrif),dij(nrif)
      dimension his(201),cumde(201),range(201),
     * disa1(201),disb1(201),disa2(201),disb2(201),
     * cumerr1(201),cumerr2(201),cumerp1(201),cumerp2(201),
     * csegni(201),cumse(201),cmed(201),ccmed(201)
      character tirang*11
      integer his, cumde, ierv(3)

      real,    allocatable :: dijs(:)
      integer, allocatable :: jorde(:), jorde1(:)
c--
      if (ipher < 0 .or. ifExamin == 0) return    ! 27/7/2010 dedi - per uscire dalla subroutine
      if (ifTime == 1) return
!
      if (ipher.eq.0) then
          lll = -444
          ifmin = 10
          call examin(lll,mkang,khl,ia,ib,nrif,ic,c,ifmin)
      endif
      if (knw.eq.0) return
      if (nrif.le.0) then
         write(lo,*) ' nrif = 0'
        return
      endif
c--
      ierv(:) = 0
      IF (.NOT. ALLOCATED(dijs))
     *    ALLOCATE (dijs(1:nreflDim),  stat = ierv(1))
      IF (.NOT. ALLOCATED(jorde))
     *    ALLOCATE (jorde(1:nreflDim), stat = ierv(2))
      IF (.NOT. ALLOCATED(jorde1))
     *    ALLOCATE (jorde1(1:nreflDim),stat = ierv(3))
      ierr = sum(iabs(ierv(:)))
      if (ierr.ne.0) then
          write(lo,*) 'PherrDisNew Allocation error'
          call cstop(' ')
      endif
      do i=1,nrif
         jorde(i) = i
      enddo
      nrang = 10
      if (nrang1.gt.0)   nrang = nrang1
      if (nrang1.gt.200) nrang = 200
      itot=0
      sumsegni=0.0
      sumdif1=0.0
      sumdisb1=0.0
      sumdif2=0.0
      sumdisb2=0.0
      sumc=0.0
      do i=1,201
         range(i)=0.0
         his(i)=0
         cumde(i)=0
         cumse(i)=0.0
         csegni(i)=0.0
         cmed(i)=0.0
         disa1(i)=0.0
         disb1(i)=0.0
         cumerr1(i)=0.0
         cumerp1(i)=0.0
         disa2(i)=0.0
         cumerr2(i)=0.0
         cumerp2(i)=0.0
         disb2(i)=0.0
         ccmed(i)=0.0
      enddo
      rmin=99999.
      rabs=99999.
      rmax=-99999.
      ii=0
      do i=1,nrif
         if (i.le.ic) cycle
         kk=jorde(i)
         if (kk.eq.0.or.kk.gt.nrif) write(lo,*)kk
         if (c(kk).le.0.0) cycle
         ii=ii+1
         dijs(ii)=dij(kk)
         jorde1(ii)=kk
         if (abs(dij(kk)).lt.rabs) rabs=abs(dij(kk))
         if (dij(kk).lt.rmin) rmin=dij(kk)
         if (dij(kk).gt.rmax) rmax=dij(kk)
      enddo
      numsort=ii
      if (rmax.eq.rmin) then
          write(lo,*) ' rmax = rmin '
          return
      endif
      call sortall3(1,dijs,1,numsort,jorde1)
      if (rmin.lt.0.0) then
          rmax=amax1(rmax,abs(rmin))
          rmin=-1.0*rmax
      endif
      rmaxg=rmax
      rming=rmin
      if (rmax1.gt.0.0) then
          rmax=rmax1
          if (rmin.lt.0.0) rmin=-1.0*rmax
      endif

c--
      dev=rmax-rmin
      iaa=nint(dev)
      rang=float(nrang)
      if (iaa.gt.0) then
          dev=float(iaa)/rang
      else
          dev=dev/rang
      end if
      if (rmin.ge.0.0) then
          range(1)=float(int(10.*rmin))/10.
          do i=2,nrang
             range(i)=range(i-1)+dev
          enddo
      else
          range(1)=float(nint(10.*rmin))/10.
          nrangi=nint(rang/2.0)
          nrang=2*nrangi
          dev=rmax-rabs
          dev=dev/float(nrangi)
          do i=2,nrangi-1
             range(i)=range(i-1)+dev
          enddo
          range(nrangi)=-rabs
          range(nrangi+1)=rabs
          do i=nrangi+2,nrang
             range(i)=range(i-1)+dev
          enddo
      endif
c     range(1)=rmin
      range(1)=rming
      nrang=nrang+1
      range(nrang)=rmax
      range(nrang+1)=rmaxg
!cris
      range(1) = 0.0
!      do i=2,11
      do i=2,nrang1 + 1
          range(i) = range(i-1) + 0.1
      end do
c--
      n=2
      do i=1,numsort
         k=jorde1(i)
         jh = khl(1,k)
         jk = khl(2,k)
         jl = khl(3,k)
         shiftp=jh*shiftexam(1)+jk*shiftexam(2)+jl*shiftexam(3)
         shiftp=360.* shiftp + ia(k)
         dif1=shiftp - ib(k)
         dif2=shiftp + ib(k)
         dif1=abs(amod(dif1,360.))
         if (dif1.gt.180.)dif1=360.-dif1
         dif2=abs(amod(dif2,360.))
         if (dif2.gt.180.)dif2=360.-dif2
   17    if (dijs(i).le.range(n)) then
             his(n)=his(n)+1
             if (cicloEDM == 44 .and. n == 4) then
 !                write(lo,'(4i7,f8.5)') k,jh,jk,jl, dijs(i)
             end if 
         else
             n=n+1
             if (n.gt.nrang) n=nrang+1
             goto 17
         endif
         disa1(n)=disa1(n)+dif1
         disa2(n)=disa2(n)+dif2
         disb1(n)=disb1(n)+dif1*c(k)
         disb2(n)=disb2(n)+dif2*c(k)
         cmed(n)=cmed(n)+c(k)
      enddo
*-----cumulative
      cumerp1(nrang+1)=disb1(nrang+1)
      cumerp2(nrang+1)=disb2(nrang+1)
      ccmed(nrang+1)=cmed(nrang+1)
      do i=1,nrang
         cumerp1(nrang+1-i)=cumerp1(nrang+2-i)+disb1(nrang+1-i)
         cumerp2(nrang+1-i)=cumerp2(nrang+2-i)+disb2(nrang+1-i)
         ccmed(nrang+1-i)=ccmed(nrang+2-i)+cmed(nrang+1-i)
      enddo
*-----
      do i=1,nrang+1
         if (his(i).gt.0) then
             itot=itot+his(i)
             sumdif1=sumdif1+disa1(i)
             sumdif2=sumdif2+disa2(i)
             sumdisb1=sumdisb1+disb1(i)
             sumdisb2=sumdisb2+disb2(i)
             sumc=sumc+cmed(i)
             sumsegni=sumsegni+csegni(i)
             disa1(i)=disa1(i)/float(his(i))
             disa2(i)=disa2(i)/float(his(i))
             disb1(i)=disb1(i)/cmed(i)
             disb2(i)=disb2(i)/cmed(i)
             csegni(i)=csegni(i)/float(his(i))
             csegni(i)=100.*csegni(i)
         else
             disa1(i)=0.0
             disa2(i)=0.0
             disb1(i)=0.0
             disb2(i)=0.0
             csegni(i)=0.0
             cmed(i)=0.0
         endif
      enddo
      if (itot.le.0) then
          write(lo,*) ' itot = 0'
          return
      endif
      tot=float(itot)
      segnim=100.*sumsegni/tot
      dif1m=sumdif1/tot
      dif2m=sumdif2/tot
      disb1m=sumdisb1/sumc
      disb2m=sumdisb2/sumc
c-----cumulative 
      cumde(nrang+1)  =his(nrang+1)
      cumse(nrang+1)  =float(his(nrang+1))*csegni(nrang+1)
      cumerr1(nrang+1)=float(his(nrang+1))*disa1(nrang+1)
      cumerr2(nrang+1)=float(his(nrang+1))*disa2(nrang+1)
      do i=1,nrang
         cumde(nrang+1-i)  =cumde(nrang+2-i)+his(nrang+1-i)
         cumse(nrang+1-i)  =cumse(nrang+2-i)+csegni(nrang+1-i)*
     *                      float(his(nrang+1-i))
         cumerr1(nrang+1-i)=cumerr1(nrang+2-i)+disa1(nrang+1-i)*
     *                      float(his(nrang+1-i))
         cumerr2(nrang+1-i)=cumerr2(nrang+2-i)+disa2(nrang+1-i)*
     *                      float(his(nrang+1-i))
      enddo

      if (knw.eq.1) write(lo,200) tirang
      if (knw.eq.0) write(lo,250) tirang
      do i=2,nrang+1
         if (his(i).eq.0) cycle
         if (knw > 0)then
             if (shiftexam(4).gt.0.) then
                 write(lo,100) range(i-1),range(i),his(i),
     *                 disa1(i),disb1(i),cumde(i),
     *                 cumerr1(i)/float(cumde(i)),cumerp1(i)/ccmed(i)
             else
                 write(lo,100) range(i-1),range(i),his(i),
     *                 disa2(i),disb2(i),cumde(i),
     *                 cumerr2(i)/float(cumde(i)),cumerp2(i)/ccmed(i)
             endif
         else
             write(lo,150) range(i-1),range(i),his(i),cumde(i)
         endif
      enddo

      write(lo,"(24x,42('.'))")
      if (knw.gt.0) then
          if (shiftexam(4).gt.0.) then 
              write(lo,300)itot,dif1m,disb1m
         else
              write(lo,300)itot,dif2m,disb2m
          endif
      else
          write(lo,300)itot
      end if
      
      n_aposto = 0
      do i=nrang_o,3,-1
          if(his(i) == 0) cycle
          if (his(i) <= n_istog(i)) then
              n_aposto = n_aposto + his(i)
              cycle
          end if
          n_aposto = n_aposto + n_istog(i)
          do j = n_aposto + 1, cumde(i)
              k = numsort - j
              if (k > 0) then
                  dij(jorde1(k)) = range(i-1) - 0.000001
                  his(i-1) = his(i-1) + 1
                  his(i) = his(i) - 1
              end if
          end do
!          write(lo,'(12i6)') i,(his(j),j=1,11)
      end do
      
      
      do i = 1, numsort - num_osser
          j = jorde1(i)
          dij(j) = 0.0
      end do
  100 format(f10.4,'  - ',f10.4,i8,2f7.2,'  |',i8,2f7.2)
  150 format(f10.4,'  - ',f10.4,i8,'  |',i8)
  200 format(/,11x,a11,6x,' HIS',
     *      '  <err> <w-err>',' | ',
     *      '    CUM',
     *      '  <err> <w-err>')
  250 format(11x,a11,6x,'HIS',3x,'CUM')
  300 format(34x,i8,2f7.2,/)
c
      ipher = 0
      DEALLOCATE (dijs, jorde, jorde1, stat = ierr)
      if (ierr.ne.0) then
          write(*,*) 'PherrDisNew DeAllocation Error'
          call cstop(' ')
      endif
c
      return
      end
