!----------------------------------------------------------------------
      subroutine SymmToString(i, string)
      USE General
      USE Symmetry
!
      character*(*) string
      character*2 tx(2,6,3), ll(2,3,2)
      integer iscont(3), t(48,3)
!
!-- initializations
!
      iscont = 1
      t      = 0
!--06nov08
      ik = i
      ksegn = 1
c      if (i.gt.nsym) then
c          ksegn = -1
c          i = i - nsym
c      endif
!
      do j=1,3
         if (tmat(i,j).gt.0.01) then
             t(i,j) = nint( tmat(i,j) * 24 )
         else
             t(i,j) = 0
         endif
      enddo

!
      do l=1,2
         do j=1,3
!--06nov08            nd =  kmat(i,j,1) + kmat(i,j,2)*3 + kmat(i,j,3)*4 + 5
            nd = ksegn*(kmat(i,j,1) + kmat(i,j,2)*3 + kmat(i,j,3)*4 )+ 5
            tx(1,j,l) = teb(1,nd)
            tx(2,j,l) = teb(2,nd)
            do k=1,2
               m = t(i,j)*2 + k
               ll(k,j,l) = ntex(m)
            enddo
         enddo
      enddo
      write(string,10) (tx(1,j,1),tx(2,j,1),ll(1,j,1),ll(2,j,1),j=1,3)
   10 format(2(4a2,','),4a2,4x)
      i=ik
!
      return
      end
! -----------------------------------------------------------------
      subroutine CentrToString(ii, string)
      USE General 
      USE Symmetry
!
      character*(*) string
!
!       write(lo,'(a,i4,2x,18f5.3,i4)')
!     1  'latt,centrt(latt,1:12) ',
!     1 latt,centrt(latt,1:12)
      iniz = 1
      do l=1, 3
         ind = centrt(latt,(ii-1)*3+l)*10.0
!       write(lo,'(a,3i4,2x,f5.3,i4)')
!     1  'latt,ii,l,centrt(latt,(ii-1)*3+l),ind ',
!     1 latt,ii,l,centrt(latt,(ii-1)*3+l),ind
         if (ind == 0) then
             string(iniz:iniz+9) = '   0    ,'
         elseif (ind == 3) then
             string(iniz:iniz+9) = '  1/3   ,'
         elseif (ind == 5) then
             string(iniz:iniz+9) = '  1/2   ,'
         elseif (ind == 6) then
             string(iniz:iniz+9) = '  2/3   ,'
         endif
         iniz = iniz + 9
      enddo
!      write(lo,'(a)')string
      string(27:27) = ' '
!
      return
      end
! -----------------------------------------------------------------
      subroutine ManageWho(j1)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
!
      integer abc(3), QualeSpecie(5), NumSpecie
      real x1(3), occs(5)
      character*5 Lspecie(5)
      character*16 LabbTmp
!
      It(:) = ' '
      Labb = Lab(j1)
      call StringiStringa(Labb, 8)
      l0 = Lung(Labb)
      numfrag= nfragm(j1)
      nn=0
!!10.10.08      if(numfrag.gt.nfrag_ini)nn=numfrag
      nn=numfrag     !!10.10.08    
      l1 = iEqui(j1)
      nz1 = nzTot(j1)
      if (ifCont == 0) then
          x1(1:3) = xyzs(1:3, j1)
      else
          x1(1:3) = xyztot(1:3, j1)
      endif

      NumSpecie = 0
      call GetSiteConditions(l1, NumSpecie, occs, Lspecie)

      It(1) = 
     *     'Label   Height    x         y         z       Occ.   B[iso]'
      if (Labb(1:1).ne.' ') then
c--          if (nOpEq(j1) == 11555 .and. nn == 0) then
          if (nOpEq(j1) == 1555 .and. nn == 0) then
              It(1) = 'Asymmetric atom:'
              It(2) = 'Label   Height    x       y       z'
     *              //'       Occ.   B[iso]'
              write(It(3),10) Labb(1:8), nint(xyzs(4,l1)),
     *                       (xyzs(kk,l1),kk=1,3), xyzs(5,l1),bfac(l1)
              nIt = 3
              if (NumSpecie > 0) then
                  do i=1, NumSpecie
                     nIt = nIt + 1
                     write(It(nIt),15) Lspecie(i), occs(i) 
                  enddo
              endif
          else
              It(1) = 'Label   Height    x       y       z'
     *              //'       Occ.   B[iso]'
              write(It(2),10) Labb(1:8), nint(xyzs(4,l1)),
     *                       x1, xyzs(5,l1),bfac(l1)
              nIt = 2
              if (NumSpecie > 0) then
                  do i=1, NumSpecie
                     nIt = nIt + 1
                     write(It(nIt),15) Lspecie(i), occs(i) 
                  enddo
              endif
              It(nIt+1) = ' '
              write(It(nIt+2),20)
              LabbTmp = Lab(l1)
              call StringiStringa(LabbTmp, 8)
              write(It(nIt+3),30) LabbTmp(1:8),(xyzs(kk,l1), kk=1,3)
              It(nIt+4) = ' '
              write(It(nIt+5),35)
c              ii = nOpEq(j1) / 10000
              ii = nOpEq(j1) / 1000
              It(nIt+6)=SymmStrings(ii)
c              call SymmToString(ii, It(8))
              write(It(nIt+6)(31:60),40) ii
              nIt = nIt + 6
c               jj = nOpEq(j1) - ii * 10000
c              ii = jj / 1000
c              if (ii > 0 .and. pts >1.1) then
c                  nIt = nIt + 1
c                  call CentrToString(ii, It(nIt))
c                  write(It(nIt)(31:60),60)
c              endif
              jj = nOpEq(j1) - ii  * 1000
              if (jj > 0) then
                  kk = 100
                  do i=1,3
                     ii = jj / kk
                     abc(i) = ii - 5
                     jj = jj - ii * kk
                     kk = kk / 10
                  enddo
                  nIt = nIt + 1
                  write(It(nIt),70) (abc(l),l=1,3)
                  write(It(nIt)(31:60),75)
              endif
!-- 9sett08
              if (nn > 0) then
                  nIt=nIt+3
                  if (nOpEqBaric(numfrag) /= 1555) then
                      write(It(nIt),36)
                      ii = nOpEqBaric(numfrag) / 1000
                      It(nIt+1)=SymmStrings(ii)
c                      call SymmToString(ii, It(nIt+1))
                      write(It(nIt+1)(31:60),40) ii
                      nIt = nIt +1
                      jj = nOpEqBaric(numfrag) - ii * 1000
c                      ii = jj / 1000
c                      if (ii > 0 .and. pts > 1.1) then
c                          nIt = nIt + 1
c                          call CentrToString(ii, It(nIt))
c                          write(It(nIt)(31:60),60)
c                      endif
c                      jj = jj - ii * 1000
                      if (jj > 0) then  
                          kk = 100
                          do i=1,3
                             ii = jj / kk
                             abc(i) = ii - 5
                             jj = jj - ii * kk
                             kk = kk / 10
                          enddo
                          nIt = nIt + 1
                          write(It(nIt),70) (abc(l),l=1,3)
                          write(It(nIt)(31:60),75)
                      endif
                  endif
              endif
          endif
      else
          It(1) = 'Peak    Height    x       y       z'
     *          //'       Occ. '
          write(It(2),10) Labb(1:8), nint(xyzs(4,l1)),
     *                   (xyzs(kk,l1), kk=1,3), xyzs(5,l1)
          nIt = 2
          if (NumSpecie > 0) then
              do i=1, NumSpecie
                 nIt = nIt + 1
                 write(It(nIt),15) Lspecie(i), occs(i) 
              enddo
          endif
      endif
      do i=1,nIt
         ii = Lung(It(i))
         It(i)(ii+1:ii+1) = char(0)
      enddo
      It(nIt+1) = char(0)
      write(Inte,100) Labb(1:l0)
      call PrintIt(Inte, nIt)
!
      return
   10 format(a,i4,2x,3f8.3,f8.3,f8.2)
   15 format(a4,34x,f8.3)
   20 format('Asymmetric coordinates:')
c   30 format(     14x,3f8.3,f8.3,f8.2)
   30 format(     4x,a,2x,3f8.3,f8.3,f8.2)
   35 format('Transformations applied:')
   40 format('Symmetry operator number ',i2)
   60 format('Lattice translations')
   70 format(i4,2('    ,',i4))
   75 format('Cell translations')
  100 format('Info on ',a)
   36 format('Transformations applied to the fragment:')
      end
! -----------------------------------------------------------------
!
code  for AtomTable 
      subroutine AtomTable()
!--lista gli atomi presenti nello schermo      
!
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
!
      integer :: NumSpecie, QualeSpecie(5)
      real    :: occs(5), cell_shift(3), x1(3), x2(3)
      character*4 Lspecie(5)
!      
      denom = 8.0 * PI * PI
      write(iscra,1050) nats
1050  format(/, ' Number of independent atom(s) :',i6/)
      if (neutro == 0) then
          write(iscra,1062)
      else
          write(iscra,1062)
      endif
      do i=1,NatMol
         j = iEqui(i)
         nzsav(j) = nz(j)
         ifDrawPs = 1
         if (nzTot(i).eq.1.and.ifHydro.eq.1) then
             if (ifDrHydr == 0) then
                 ifDrawPs = 0
             endif
         endif
*gl*     if (RS(i) < 0.0 .or. nz(j) == 0) then
         if (RS(i) < 0.0) then
             ifDrawPs = 0
         endif
         if (ifDrawPs == 1) then
             rMLU(i) = 1
*            iz=iabs(nz(j))/nzConst
*            kfrag=mod(nz(i),nzConst)
             iz = nzTot(i)
             if (iz.eq.0) iz=1
c--------------------------------------------------
c-- per l'atomo i-esimo:
c--
c-- (xyzs(n,j),n=1,5) = x,y,z,Altezza,occupanza
c-- bfac(j)           = fattore termico isotropo
c-- bij(n,j),n=1,6)   = fattore termico anisotropo
c-- Ell(1,1,j)        = ellissoidi termici
c-- Ell(1,2,j)	          "         "
c-- Ell(1,3,j)	          "         "
c-- Ell(2,2,j)	          "         "
c-- Ell(2,3,j)	          "         "
c-- Ell(3,3,j)	          "         "
c-- Lab(i)            = label
c-- serial(i)         = serial number
c---------------------------------------------------
             Labb = Lab(i)
             call lcase(Labb)
             call ucase(Labb(1:1))
             if (nzTot(i) /= 0) then
                 write(Lspecie(1),'(a4)') nalf(iz)
             else
                Lspecie(1) = 'q   '
             endif
             biso=abs(bfac(j))
             uiso = biso / denom
             nxyzs4 = nint(xyzs(4,j)*10.0)
!
!-- manage equivalent posistions
!
             x1(1:3) = xyzs(1:3,j)
             k = nOpEqBaric(i) / 1000 ! = n * 1000 + 555
*            k = nOpEq(i) / 1000 ! = n * 1000 + 555
             iexit = 0
             call xequiTot(k, x1, x2, iexit)
             k = nOpEqBaric(i) - k * 1000
             if (k /= 555) then
!
!-- manage cell translations
!
                 call GetCellTranslation(k, cell_shift)
                 x2(1:3) = x2(1:3) + cell_shift(1:3)
             endif
             write(iscra,1110) i, Labb, Lspecie(1), serial(j),
*gl* 1         xyzs(1:3,i), xyzs(5,j), biso, uiso , nxyzs4
     1         x2(1:3), xyzs(5,j), biso, uiso , nxyzs4
             a = sum(xyzs_dev(1:3,j))
             if (a > 0.0001) then
                 write(iscra,1111) xyzs_dev(1:3,j)
             endif
             Lspecie(:) = ' '
             QualeSpecie(:) = 0
             occs(:) = 0.0
             NumSpecie = 1
             Lspecie(1) = Species(iz)
             call ucase(Lspecie(1)(1:1))
             occs(1) = xyzs(5,j)
             call GetSiteConditions(j, NumSpecie, occs, Lspecie)
             if (NumSpecie > 1) then
                 do j=2, NumSpecie
                    write(iscra,1112) Lspecie(j), occs(j)
                 enddo
             endif
         endif    
      enddo
!
      return
 1061 format(5x, ' Name',10x,'  Type',' Serial',2x,' x',6x,
     1 ' y',6x,' z',5x,' Occ',4x,'B(iso)',4x,'U(iso)',4x,'Height',/)
 1062 format(5x, ' Name',10x,'  Type',' Serial',2x,' x',6x,
     1 ' y',6x,' z',5x,' Occ',4x,'B(iso)',4x,'U(iso)',2x,'Height*10',/)
 1110 format(i5,1x,a,' ',a4,i5,3f8.4,2f8.3,f10.5,i8)
 1111 format(5x,27x,3f8.4)
 1112 format(23x,a4,29x,f8.3)
      end
! -----------------------------------------------------------------
      subroutine GetCellTranslation(k, cell_shift)
!
      implicit none
      integer :: k, i, j
      real    :: cell_shift(3)
!
      j = k
      cell_shift(1:3) = 0
      i = j / 100
      cell_shift(1) = i - 5
      j = j - i * 100
      i = j / 10
      cell_shift(2) = i - 5
      j = j - i * 10
      cell_shift(3) = j - 5
!
      return
      end
! -----------------------------------------------------------------
      subroutine StampaModello()
      USE General
      USE TestModel
!
      implicit none
      integer i
      character*4 stringa4
!
      if (InfoOK(45) == 0) then
          call AllocaTestModel(1)
      endif
      write(iscra,100) ncoordPub
      write(iscra,200)
      do i=1, ncoordPub
         write(stringa4,'(a4)') nalf(nzPub(i))
         write(iscra,300) i, aLabPub(i), stringa4, coordPub(1:3,i),
     *                    coordPub(5,i), coordPub(4,i)
      enddo 
!
      return
  100 format(/, ' Number of atom(s) in the model:',i6/)
  200 format(5x, ' Name',10x,'  Type',3x,' x',6x,
     1 ' y',6x,' z',6x,' Occ',4x,'B(iso)',/)
  300 format(i5,1x,a,' ',a4,3f8.4,2f8.3)
      end
!-----------------------------------------------------------------------
      subroutine StampaOutput(ier)
      USE General
      character*256 line
!
*     l = Lung(fname(15))
*     if (l == 0) then
*         Msg = 'No output file at the moment, try later.'
*         call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
*         ier = -1
*         return
*     endif
      nLines = 0
      rewind lo
  100 continue
      read(lo,'(a)',end=200) line
      write(iscra,'(a)') line(1:Lung(line))
      nLines = nLines + 1
      go to 100
!
  200 continue
      close(lo)
      rewind iscra
!
      itype=0
      iform=1
      if (jopen(lo,fname(15),itype,iform,ier2).lt.0) go to 1000
      do 300 irec=1,nLines
         read(iscra,'(a)') line
         k = Lung(line)
         if (k.eq.0) k = 1
         write(lo,'(a)') line(1:k)
  300 continue
!
      return
!
 1000 continue
      write(Msg,1100) ier2,fname(15)(1:Lung(fname(15)))
 1100 format(' Open error #',i5,' on file:',a)
      call MsgWinErr('ERROR', Msg, SEVERE_ERR_WINDOW, nExitCode)
      return
      end
! ----------------------------------------------------------------------
      subroutine Histograms()
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
!
      character valore*8
!
      if (neutro == 0) then
          Inizio = 80
          zMax = maxval(no(1:nk))
      else
          Inizio = 2
          zMax = -1.0
      endif
      ixv(1) = Inizio
      iyv(1) = 0
!
      rMaxx = -999.
      rMaxB = -999.
      NatV=0
      do 10 i = 1, NatInd
         if (RS(i) .gt. -10.) then
            NatV = NatV + 1
            if (xyzs(4,i).gt.rMaxx) rMaxx = xyzs(4,i)
            if (bfac(i).gt.rMaxB) rMaxB = bfac(i)
         end if
   10 continue
      if (abs(rMaxx).le.0.0001) rMaxx = 1.
!
      if (zMax > rMaxx) rMaxx = zMax
!
      Larg = 18
      nBarre = NatV
      ix = Larg*nBarre + 100
      iy = -1
      Inte = 'Intensities Histograms'
      call OpenViewer(ixv(1), iyv(1), ix, iy, Inte)
!
   12 jxp = ixv(1) + 1
      jxpi = jxp
      jyp = iy - 5
      jypm = 10
      ini = 1
      nRig = 1
      Larg1 = .75 * Larg
      if (Larg .eq. Larg1) Larg1 = Larg - 1
      jxp = iVP(1) + 1
      jxpi = jxp
      ix1 = 1
      call Linea(ix1, jyp, ix, jyp,color_WHITE)
      if (neutro == 0) then
          do i=1,nk
             jypp =  jyp + nint ( abs(no(i) / rMaxx) * (jypm - jyp) )
             write(valore,"(i3,' ',a4)") no(i), Species(i)
             call ucase(valore(5:5))
             do nnpp = ix1, ix, 5
                ix2 = nnpp + 2
                call Linea (nnpp,jypp,ix2,jypp,color_WHITE)
             enddo
             call DrawLabel (ix1+10, jypp+5, valore, icoWire, 2)
             jcol = no(i) + N_OBJS
             call Rettangolo (ix1, jypp-8, ix1+8, jypp, jcol, jcol)
          enddo
      endif
      j = 1
      do i = 1, NatInd
         if (RS(i).le.-10.) cycle
         AltInPix = nint(abs((xyzs(4,i))/rMaxx) * (jypm - jyp ))
         if (AltInPix .gt. -1) AltInPix = 0.03 * (jypm-jyp)
         ixv(1) = jxp
         iyv(1) = jyp
         ixv(2) = jxp
         iyv(2) = jyp + AltInPix
         ixv(3) = jxp + Larg1
         iyv(3) = jyp + AltInPix
         ixv(4) = jxp + Larg1
         iyv(4) = jyp
         ixv(5) = ixv(1)
         iyv(5) = iyv(1)
!!mr
         ixv(1) = jxp
         iyv(1) = jyp + AltInPix
         ixv(2) = Larg1
         iyv(2) = -AltInPix
!!mr
         ico = iCol(i)
         Labb = aLab(i)
         write(Inte,"(a,' - Height =',f10.2)") Labb,xyzs(4,i)
         call OneBlankOnly(Inte)
         L = Lung(Inte)
         call RettangoloSpeciale(ico, j, Inte(1:L))
         jxp = jxp + Larg
         j = j + 1
      enddo
      call zflush
!
      iAction = 1
      call EndViewer(iAction)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine Viewer(xminn, yminn, xmaxx, ymaxx,lx,ly)
      USE Molcom
!
      common /viewerc/ XXYY(4),kviewer(4),x11sd(4),iWait
!
      if (kscreen.eq.0) return
!
      XXmin = xminn
      XXMax = xmaxx
      YYmin = yminn

!!!!!!!!!      YYmin = FntPixHeight

      YYMax = ymaxx
      dx=XXMax-XXMin
      dy=YYMax-YYMin
      x11scale(1)=float(lx)/dx
      x11scale(2)=float(ly)/dy
      x11disp(1)=-XXMin
      x11disp(2)=-YYMin

!
      return
      end
!-----------------------------------------------------------------------
      subroutine OpenViewer(ix1,iy1,ix2,iy2,String)
      USE General
      USE Molcom
!
!     common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,del,ks
      common /minmax/ XXmin,XXMax,YYmin,YYMax,iAdd
      common /viewerc/ XXYY(4),kviewer(4),x11sd(4),iWait
! ---
      character *(*) String
! ---
!
      if (kscreen.eq.0) return
!
      XXYY(1) = XXmin
      XXYY(2) = XXMax
      XXYY(3) = YYmin
      XXYY(4) = YYMax
      x11sd(1) = x11scale(1)
      x11sd(2) = x11scale(2)
      x11sd(3) = x11disp(1)
      x11sd(4) = x11disp(2)
      kviewer(1) = iVP(1)
      kviewer(2) = iVP(2)
      kviewer(3) = iVP(3)
      kviewer(4) = iVP(4)
! ---
      iVP(1) = ix1
      iVP(2) = iy1
      iVP(3) = ix2
      iVP(4) = iy2

      ix = ix2
      iy = iy2
      ind = 1
      call Visualizzatore(ind, ix, iy, String)
      iVP(4) = iy
      iy2 = iy
! ---
      return
      end
!-----------------------------------------------------------------------
      subroutine EndViewer(iAction)
      USE General
      USE Molcom
!
      common /minmax/ XXmin,XXMax,YYmin,YYMax,iAdd
      common /viewerc/ XXYY(4),kviewer(4),x11sd(4),iWait
!
      if (kscreen.eq.0) return
!
      XXmin = XXYY(1)
      XXMax = XXYY(2)
      YYmin = XXYY(3)
      YYMax = XXYY(4)
      x11scale(1) = x11sd(1)
      x11scale(2) = x11sd(2)
      x11disp(1)  = x11sd(3)
      x11disp(2)  = x11sd(4)
      iVP(1) = kviewer(1)
      iVP(2) = kviewer(2)
      iVP(3) = kviewer(3)
      iVP(4) = kviewer(4)
      if (iAction.eq.1) then
          ind = 3     
          call Visualizzatore(ind, ix, iy, ' ')
      endif
! ---
      return
      end
!-----------------------------------------------------------------------
      subroutine OpenPseudoViewer(ix1,iy1,ix2,iy2,String)
      USE General
      USE Molcom
!
!     common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,del,ks
      common /minmax/ XXmin,XXMax,YYmin,YYMax,iAdd
      common /viewerc/ XXYY(4),kviewer(4),x11sd(4),iWait
! ---
      character *(*) String
! ---
!
      if (kscreen.eq.0) return
!
      XXYY(1) = XXmin
      XXYY(2) = XXMax
      XXYY(3) = YYmin
      XXYY(4) = YYMax
      x11sd(1) = x11scale(1)
      x11sd(2) = x11scale(2)
      x11sd(3) = x11disp(1)
      x11sd(4) = x11disp(2)
      kviewer(1) = iVP(1)
      kviewer(2) = iVP(2)
      kviewer(3) = iVP(3)
      kviewer(4) = iVP(4)
! ---
      iVP(1) = ix1
      iVP(2) = iy1
      iVP(3) = ix2
      iVP(4) = iy2
      ix = ix2
      iy = iy2
      ind = 11
      call Visualizzatore(ind, ix, iy, String)

! ---
      return
      end
!-----------------------------------------------------------------------
      subroutine EndPseudoViewer(iAction)
      USE General
      USE Molcom
      USE MadModule
!
      common /minmax/ XXmin,XXMax,YYmin,YYMax,iAdd
      common /viewerc/ XXYY(4),kviewer(4),x11sd(4),iWait
!
      if (kscreen.eq.0) return
!
      XXmin = XXYY(1)
      XXMax = XXYY(2)
      YYmin = XXYY(3)
      YYMax = XXYY(4)
      x11scale(1) = x11sd(1)
      x11scale(2) = x11sd(2)
      x11disp(1)  = x11sd(3)
      x11disp(2)  = x11sd(4)
      iVP(1) = kviewer(1)
      iVP(2) = kviewer(2)
      iVP(3) = kviewer(3)
      iVP(4) = kviewer(4)
      if (iAction.eq.1) then
          ix = nWilsonPlots 
          iy = 0 
          ind = 33     
          call Visualizzatore(ind, ix, iy, ' ')
      endif
! ---
      return
      end
!-----------------------------------------------------------------------
      subroutine CloseViewer
      USE Molcom
      USE PhaseModule
!
      if (kscreen.eq.0) return
!
      ind = 5   
      call Visualizzatore(ind, ix, iy, ' ')
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DoAllGraphs()
      USE General
      USE Grafici
      USE Molcom
      USE PhaseModule
      USE RfacMatrixModule
!
! --- iAction = 1  Updates & displays histograms during the run
!             = 2  Display the histograms stored in binary file
! --- iFomR   = 1  Updates FOMs histogram 
!             = 2  Updates R    histogram 
!
!
      if (kmad /= 0) then
          ifViewer = .false.
      endif
      nRfac = 0
      lfw = InfoOK(34)
      if (lfw > 0) then
          call PutGetRfacMatrix(2)
      endif
      if (nRfac> 0) then
          fomrt(:,:) = 0.0
          fomrt(1:nRfac,5) = RfacMatrix(2,1:nRfac,1)
          MaxToStore = nRfac
          call AllocaGrafici(1, MaxToStore, ifTang)
          HistoOK(:) = 0
          call DataForGraph(-1, MaxToStore)
!         if (kmad == 0) then
              call DataForGraph(6, MaxToStore)
!         else
!             call DataForGraph(26, MaxToStore)
!         endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine ReGroupV2(jComplete)
      USE General
      USE Molcom
      USE Atomi
!
!-- jComplete = 1    complete a partial connectivity
!-- jComplete = 2    recompute connectivity
!-- jComplete = 3    avvisolati
!
      Message = 'Computing connectivity. Please wait...'
      call PrintMess(Message)
      jrest=0
      call ModCom(jrest)
      jscreenSav = jscreen
      jscreen = 1
      if (jComplete <= 2) then
          call ReGroup(jComplete)
      else
          call Compatta()
      endif
      jscreen = jscreenSav
      ifChangedXYZ = 1
      ifCont = 0
      call SoloInd(NatInd)
      call GetBonds(1)
!mr   ifCell = 0
      ifScale= 1
      if (jscreen > 0) then
          Message = '... done ! '
          call PrintMess(Message)
          call Disegna(ifScale)
          call ClearMessage
          call AggiornaJav()
      endif
! ---
      return
      end
c-----------------------------------------------------------------------
      subroutine SortByLabel()
      USE General
      USE Molcom
!
      jrests = 0
      ier = 0
      call UpdateCommonAndList5(ier)
      if (ier < 0) return
*gl*  call ModCom(jrests)
      call sortAtoms
      Message = 'Atom list has been sorted respect to '
     *   //'atomic species and serial number.'
      ier = 0
      call OpenWarning(Message)
      leggi = 1
      call toMolPlo3(leggi)
      call RotazTot
      call GetBonds(1)
      if (ifScale.ne.0) then
          call FindMinMax
      end if
      call Disegna(ifScale)
      call AggiornaJav()
! ---
      return
      end
!-----------------------------------------------------------------------
      subroutine sortAtoms
!
!--sort atoms with respect to species and serial number
!
      USE General
      USE Molcom
      USE Atomi
      USE RemoModule
!
      implicit none
      integer :: i, j, k, uno, due, nBonds, ifSingle, kplot, ierr
      logical :: ifAllocated
!
      uno = 1
      due = 2
      if (.not.allocated(model(due)%atoms)) then
          natsInModel(due)  = natsInModel(uno)
          BondsInModel(due) =  BondsInModel(uno)
          call AllocaModello(due, ierr)
          k = BondsInModel(due)
          allocate (Bonds(due)%Legami(3,k), stat = ierr)
          ifAllocated = .true.
      else
          ifAllocated = .false.
      endif
      call CopyModel(uno, due)
      do i=1, nats
         nzo(i) = i
         bSav(i) = nzTot(i) * 10000 + (10000 - serial(i))
      enddo
!
      call sort3 (bSav, nzo, nats)
!
      do i=1, nats
         j = nzo(i)
         model(uno)%atoms(:,i,1)      = model(due)%atoms(:,j,1)
         model(uno)%specie(i,1)       = model(due)%specie(j,1)
         model(uno)%th_fact(i,1)      = model(due)%th_fact(j,1)
         model(uno)%Label(i)          = model(due)%Label(j)
         model(uno)%serial(i)         = model(due)%serial(j)
         model(uno)%SinglePlotType(i) = model(due)%SinglePlotType(j)
         model(uno)%IsoAniso(i,1)     = model(due)%IsoAniso(j,1)
         model(uno)%bij(:,i,1)        = model(due)%bij(:,j,1)
         model(uno)%iSite(i)          = model(due)%iSite(j)
         model(uno)%SiteInfo(:,i)     = model(due)%SiteInfo(:,j)
         model(uno)%xyz_dev(:,i,1)    = model(due)%xyz_dev(:,j,1)
         model(uno)%occX_dev(:,i)     = model(due)%occX_dev(:,j)
         model(uno)%th_fact_dev(i,1)  = model(due)%th_fact_dev(j,1)
         model(uno)%occ_dev(i)        = model(due)%occ_dev(j)
         model(uno)%bij_dev(1:6,i,1)  = model(due)%bij_dev(1:6,j,1)
         model(uno)%GeomAtom(i)       = model(due)%GeomAtom(j)
      enddo
!
!-- connectivity
!
      do i=1, nats
         do j=1, nats
            if (nzo(j) == i) then
                nzsav(i) = j
                exit
            endif
         enddo
      enddo
!
      nBonds = BondsInModel(WhichModel)
      do i=1, nBonds
         do j=1, 2
            k = Bonds(due)%Legami(j,i)
            k = nzsav(k)
            Bonds(uno)%Legami(j,i) = k
         enddo
         Bonds(uno)%Legami(3,i) = Bonds(due)%Legami(3,i)
      end do
!
      call GetModel
      call PutGetXyzs(uno, uno)
      ifSingle = 0
      kplot    = iPlotType
      call MolPlo(kplot, ifSingle)
!
      if (ifAllocated) then
          call DeallocaModello(due, ierr)
          deallocate (Bonds(due)%Legami, stat = ierr)
      endif
!
      return
      end

!-----------------------------------------------------------------------
      subroutine NewAtomsV2(NumCase,dExp, iExitCode)        !mr
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
!
      dimension nur(10),dist(20),di(9),c(3),xn(3,3)
      dimension x1(3),r1(3)
      dimension xx(3, 5), xyn(3, 3), cn(3)
!
      call ResetLabelPos()
      do i=1,nptr
         nur(i) = kptr(i)
      enddo
      iExitCode = 0
      if (NumCase .le. 3) then
         MoreAtoms = 3
      elseif (NumCase .eq. 4 .or. NumCase .eq. 5) then
         MoreAtoms = 2
      else
         MoreAtoms = 1
      end if
      do 30 i=1, 6 - MoreAtoms
         do 10 k=1, 3
            x1(k) = xyzs(k,nur(i))
   10    continue
         call MoltMatVec(rm,x1,r1)
         do 20 k=1, 3
            xx(k, i) = r1(k)
   20    continue
   30 continue
      do 60 k=NatMol + NatSpi, NatMol + 1, -1
         do 55 kk=1, 3
            xyz(kk, k + MoreAtoms) = xyz(kk, k)
  55     continue
         RS(k + MoreAtoms) = RS(k)
         iCol(k + MoreAtoms) = iCol(k)
         Lab(k + MoreAtoms) = Lab(k)
         iEqui(k + MoreAtoms) = iEqui(k)
         rMLU(k + MoreAtoms) = rMLU(k)
  60  continue
! ---
      if(NumCase .eq. 1) then
         do 70 i=1, 3
            di(i) = 0
   70    continue
         do 100 i=1, NumLeg-nlp
            if (LE(3,i).gt.0) then
               do 90 j=1, 2
                  do 80 k=j+1, 3
                     if ((LE(1,i).eq.nur(j).and.LE(2,i).eq.nur(k)) .or.
     +                  (LE(1,i).eq.nur(k).and.LE(2,i).eq.nur(j))) then
                        di(j) = di(j)+1
                        di(k) = di(k)+1
                     end if
   80             continue
   90          continue
            end if
  100    continue
         ii = 0
         ij = 0
         jj = 0
         do 110 i=1, 3
            if (di(i).eq.1 .and. ii.ne.0) jj = i
            if (di(i).eq.1 .and. ii.eq.0) ii = i
            if (di(i).eq.2)               ij = i
  110    continue
         if (ii.eq.0.or.ij.eq.0.or.jj.eq.0) then
            iExitCode = 1
            return
         end if
         d1 = 0.
         d2 = 0.
         do 120 k=1, 3
            d1 = d1 + (xyz(k,nur(ij)) - xyz(k,nur(ii))) ** 2
            d2 = d2 + (xyz(k,nur(ij)) - xyz(k,nur(jj))) ** 2
  120    continue
         d1 = sqrt(d1)
         d2 = sqrt(d2)
         do 130 k=1, 3
            c(k)=xyz(k, nur(ii)) + xyz(k, nur(jj)) - xyz(k, nur(ij))
  130    continue
         d3 =0.
         do 140 k=1, 3
            d3 = d3 + ( xyz(k,nur(ij)) - c(k) ) ** 2
  140    continue
         d3 = sqrt(d3)
         do 150 k=1, 3
            xyz(k,NatMol+1)=c(k)+dExp/d1*(xyz(k,nur(ii))-xyz(k,nur(ij)))
            xyz(k,NatMol+2)=c(k)+dExp/d2*(xyz(k,nur(jj))-xyz(k,nur(ij)))
            xyz(k,NatMol+3)=c(k)+dExp/d3*(c(k) - xyz(k,nur(ij)))
            xn(k,1) = c(k) + dExp/d2 * (c(k) - xyz(k,nur(jj)))
            xn(k,2) = c(k) + dExp/d1 * (c(k) - xyz(k,nur(ii)))
            xn(k,3) = xyz(k, NatMol+1) + xyz(k, NatMol+2) - c(k)
            xyz(k,NatMol+1)=(xyz(k,NatMol+1)+xn(k,1))/2
            xyz(k,NatMol+2)=(xyz(k,NatMol+2)+xn(k,2))/2
            xyz(k,NatMol+3)=(xyz(k,NatMol+3)+xn(k,3))/2
  150    continue
         MoreBonds = 4
         do 160 k=1, 3
            cn(k)=xx(k, ii) + xx(k, jj) - xx(k, ij)
  160    continue
         do 170 k=1, 3
            xyn(k,1)=cn(k)+dExp/d1*(xx(k,ii)-xx(k,ij))
            xyn(k,2)=cn(k)+dExp/d2*(xx(k,jj)-xx(k,ij))
            xyn(k,3)=cn(k)+dExp/d3*(cn(k) - xx(k,ij))
            xn(k,1) = cn(k) + dExp/d2 * (cn(k) - xx(k,jj))
            xn(k,2) = cn(k) + dExp/d1 * (cn(k) - xx(k,ii))
            xn(k,3) = xyn(k,1) + xyn(k,2) - cn(k)
            xyn(k,1)=(xyn(k,1) + xn(k,1))/2
            xyn(k,2)=(xyn(k,2) + xn(k,2))/2
            xyn(k,3)=(xyn(k,3) + xn(k,3))/2
  170    continue
      elseif(NumCase .eq. 2) then
         do 180 i=1, 3
            di(i) = 0
  180    continue
         do 210 i=1, NumLeg-nlp
            if (LE(3,i).gt.0) then
               do 200 j=1, 2
                  do 190 k=j+1, 3
                     if ((LE(1,i).eq.nur(j).and.LE(2,i).eq.nur(k)) .or.
     +                  (LE(1,i).eq.nur(k).and.LE(2,i).eq.nur(j))) then
                        di(j) = di(j)+1
                        di(k) = di(k)+1
                     end if
  190             continue
  200          continue
            end if
  210    continue
         if (di(1).ne.0.or.di(2).ne.0.or.di(3).ne.0) then
            iExitCode = 1
            return
         end if
         do 220 k=1, 3
            c(k)=(xyz(k, nur(1)) + xyz(k, nur(3)) + xyz(k, nur(2)))/3.
  220    continue
         do 230 k=1, 3
            xyz(k, NatMol+1) = 2 * c(k) - xyz(k,nur(3))
            xyz(k, NatMol+2) = 2 * c(k) - xyz(k,nur(1))
            xyz(k, NatMol+3) = 2 * c(k) - xyz(k,nur(2))
  230    continue
         MoreBonds = 6
         do 240 k=1, 3
            cn(k) = ( xx(k, 1) + xx(k, 3) + xx(k, 2) ) / 3.
  240    continue
         do 250 k=1, 3
            xyn(k, 1) = 2 * cn(k) - xx(k, 3)
            xyn(k, 2) = 2 * cn(k) - xx(k, 1)
            xyn(k, 3) = 2 * cn(k) - xx(k, 2)
  250    continue
      elseif(NumCase .eq. 3) then
         do 260 i=1, 3
            di(i) = 0
  260    continue
         do 290 i=1, NumLeg-nlp
            if (LE(3,i).gt.0) then
               do 280 j=1, 2
                  do 270 k=j+1, 3
                     if ((LE(1,i).eq.nur(j).and.LE(2,i).eq.nur(k)) .or.
     +                  (LE(1,i).eq.nur(k).and.LE(2,i).eq.nur(j))) then
                        di(j) = di(j)+1
                        di(k) = di(k)+1
                     end if
  270             continue
  280          continue
            end if
  290    continue
         ii = 0
         ij = 0
         jj = 0
         do 300 i=1, 3
            if (di(i) .eq. 0) jj = i
            if (di(i) .eq. 1 .and. ii .ne.0 ) ij = i
            if (di(i) .eq. 1 .and. ii .eq.0 ) ii = i
  300    continue
         if (ii.eq.0.or.ij.eq.0.or.jj.eq.0) then
            iExitCode = 1
            return
         end if
         d1 = 0.
         d2 = 0.
         do 310 k=1, 3
            d1 = d1 + (xyz(k,nur(jj)) - xyz(k,nur(ii))) ** 2
            d2 = d2 + (xyz(k,nur(jj)) - xyz(k,nur(ij))) ** 2
  310    continue
         if(d1 .lt. d2) then
            idum = ii
            ii = ij
            ij = idum
         end if
         d1 = 0.
         do 320 k=1, 3
            d1 = d1 + (xyz(k,nur(ij)) - xyz(k,nur(ii))) ** 2
  320    continue
         d1 = sqrt(d1)
         do 330 k=1, 3
            c(k) =  ( xyz(k,nur(ii)) + xyz(k, nur(jj)) ) / 2
  330    continue
         do 340 k=1, 3
            xyz(k,NatMol+1)=c(k)+dExp/d1*(xyz(k,nur(ii))-xyz(k,nur(ij)))
            xyz(k,NatMol+2)=c(k)+dExp/d1*(xyz(k,nur(ij))-xyz(k,nur(ii)))
            xyz(k,NatMol+3) = c(k) + dExp/d1 * (c(k) - xyz(k, nur(ij)))
  340    continue
         MoreBonds = 5
         do 350 k=1, 3
            cn(k) =  ( xx(k, ii) + xx(k, jj) ) / 2.
  350    continue
         do 360 k=1, 3
            xyn(k,1) = cn(k) + dExp/d1 * (xx(k,ii) - xx(k,ij))
            xyn(k,2) = cn(k) + dExp/d1 * (xx(k,ij) - xx(k,ii))
            xyn(k,3) = cn(k) + dExp/d1 * (cn(k) - xx(k, ij))
  360    continue
      elseif(NumCase .eq. 4) then
         do 370 i=1, 4
            di(i) = 0
  370    continue
         do 400 i=1, NumLeg-nlp
            if (LE(3,i).gt.0) then
               do 390 j=1, 3
                  do 380 k=j+1, 4
                     if ((LE(1,i).eq.nur(j).and.LE(2,i).eq.nur(k)) .or.
     +                  (LE(1,i).eq.nur(k).and.LE(2,i).eq.nur(j))) then
                        di(j) = di(j)+1
                        di(k) = di(k)+1
                     end if
  380             continue
  390          continue
            end if
  400    continue
         ii = 0
         ij = 0
         ik = 0
         jj = 0
         do 410 i=1, 4
            if (di(i) .eq. 1 .and. ii.ne.0) jj = i
            if (di(i) .eq. 1 .and. ii.eq.0) ii = i
  410    continue
         if (ii.eq.0.or.jj.eq.0) then
            iExitCode = 1
            return
         end if
         ji = 0
         ki = 0
         do 420 i=1, 4
            if (i.ne.ii .and. i.ne.jj .and. ji.eq.0) ji = i
            if (i.ne.ii .and. i.ne.jj .and. i.ne.ji) ki = i
  420    continue
         if (ji.eq.0.or.ki.eq.0) then
            iExitCode = 1
            return
         end if
         do 430 i=1, NumLeg-nlp
            if (LE(3,i).gt.0) then
               if (LE(1,i).eq.nur(ii).and.LE(2,i).eq.nur(ji)) ij = ji
               if (LE(1,i).eq.nur(ii).and.LE(2,i).eq.nur(ki)) ij = ki
               if (LE(2,i).eq.nur(ii).and.LE(1,i).eq.nur(ji)) ij = ji
               if (LE(2,i).eq.nur(ii).and.LE(1,i).eq.nur(ki)) ij = ki
               if (LE(1,i).eq.nur(jj).and.LE(2,i).eq.nur(ji)) ik = ji
               if (LE(1,i).eq.nur(jj).and.LE(2,i).eq.nur(ki)) ik = ki
               if (LE(2,i).eq.nur(jj).and.LE(1,i).eq.nur(ji)) ik = ji
               if (LE(2,i).eq.nur(jj).and.LE(1,i).eq.nur(ki)) ik = ki
            end if
  430    continue
         if (ij.eq.0.or.ik.eq.0) then
            iExitCode = 1
            return
         end if
         do 440  k=1, 3
            c(k) =  ( xyz(k,nur(ii)) + xyz(k, nur(jj)) ) / 2
  440    continue
         d1 = 0
         d2 = 0
         do 450 k=1, 3
            d1 = d1 + ( c(k) - xyz(k,ij) ) ** 2
            d2 = d2 + ( c(k) - xyz(k,ik) ) ** 2
  450    continue
         d1 = sqrt(d1)
         d2 = sqrt(d2)
         do 460 k=1, 3
            xyz(k,NatMol+1) = c(k) +  (c(k) - xyz(k,nur(ij)))
            xyz(k,NatMol+2) = c(k) +  (c(k) - xyz(k,nur(ik)))
  460    continue
         MoreBonds = 3
         do 470  k=1, 3
            cn(k) =  ( xx(k, ii) + xx(k, jj) ) / 2
  470    continue
         do 480 k=1, 3
            xyn(k,1) = cn(k) +  (cn(k) - xx(k,ij))
            xyn(k,2) = cn(k) +  (cn(k) - xx(k,ik))
  480    continue
      elseif(NumCase .eq. 5) then
         do 490 i=1, 4
            di(i) = 0
  490    continue
         do 520 i=1, NumLeg-nlp
            if (LE(3,i).gt.0) then
               do 510 j=1, 3
                  do 500 k=j+1, 4
                     if ((LE(1,i).eq.nur(j).and.LE(2,i).eq.nur(k)) .or.
     +                  (LE(1,i).eq.nur(k).and.LE(2,i).eq.nur(j))) then
                        di(j) = di(j)+1
                        di(k) = di(k)+1
                     end if
  500             continue
  510          continue
            end if
  520    continue
         ii = 0
         jj = 0
         do 530 i=1, 4
            if (di(i) .eq. 2) ii = i
            if (di(i) .eq. 0) jj = i
  530    continue
         ij = 0
         do 540 i=1, 4
            if (i.ne.ii .and. i.ne.jj .and. ij.eq.0) ij = i
  540    continue
         ik = 0
         do 550 i=1, 4
            if (i.ne.ii .and. i.ne.jj .and. i.ne.ij) ik = i
  550    continue
         if (ii.eq.0.or.ij.eq.0.or.ik.eq.0.or.jj.eq.0) then
            iExitCode = 1
            return
         end if
         if (di(ij).ne.1.or.di(ik).ne.1) then
            iExitCode = 1
            return
         end if
         do 560  k=1, 3
            c(k) =  ( xyz(k,nur(ii)) + xyz(k, nur(jj)) ) / 2
  560    continue
         di(1) = 0.
         di(2) = 0.
         do 570 k=1, 3
            di(1) = di(1) + (xyz(k,nur(ii)) - xyz(k,nur(ij))) ** 2
            di(2) = di(2) + (xyz(k,nur(ii)) - xyz(k,nur(ik))) ** 2
  570    continue
         di(1) = sqrt(di(1))
         di(2) = sqrt(di(2))
         do 580 k=1, 3
           xyz(k,NatMol+1)=c(k)+dExp/di(1)*(xyz(k,nur(ij))-
     *                     xyz(k,nur(ii)))
           xn(k,1) = c(k) + (c(k) - xyz(k,nur(ik)))
           xyz(k,NatMol+1)=(xn(k,1) + xyz(k,NatMol+1)) / 2
           xyz(k,NatMol+2)=c(k)+dExp/di(2)*(xyz(k,nur(ik))-
     *                     xyz(k,nur(ii)))
           xn(k,2) = c(k) + (c(k) - xyz(k,nur(ij)))
           xyz(k,NatMol+2)=(xn(k,2) + xyz(k,NatMol+2)) / 2
  580    continue
         MoreBonds = 4
         do 590 k=1, 3
            cn(k) =  ( xx(k,ii) + xx(k, jj) ) / 2
  590    continue
         do 600 k=1, 3
            xyn(k,1) = cn(k) + dExp/di(1) * (xx(k,ij) -  xx(k,ii))
            xn(k,1)  = cn(k) + (cn(k) - xx(k,ik))
            xyn(k,1) = (xn(k,1) + xyn(k,1)) / 2
            xyn(k,2) = cn(k) + dExp/di(2) * (xx(k,ik) - xx(k,ii))
            xn(k,2)  =  cn(k) + (cn(k) - xx(k,ij))
            xyn(k,2) = (xn(k,2) + xyn(k,2)) / 2
  600    continue
      elseif(NumCase .eq. 6) then
         do 610 i=1, 5
            di(i) = 0
  610    continue
         do 640 i=1, NumLeg-nlp
            if (LE(3,i).gt.0) then
               do 630 j=1, 4
                  do 620 k=j+1, 5
                     if ((LE(1,i).eq.nur(j).and.LE(2,i).eq.nur(k)) .or.
     +                  (LE(1,i).eq.nur(k).and.LE(2,i).eq.nur(j))) then
                        di(j) = di(j)+1
                        di(k) = di(k)+1
                     end if
  620             continue
  630          continue
            end if
  640    continue
         ii = 0
         jj = 0
         do i=1, 5
            if (di(i) .eq. 1 .and. ii.ne.0) jj = i
            if (di(i) .eq. 1 .and. ii.eq.0) ii = i
         enddo
         if (ii.eq.0.or.jj.eq.0) then
            iExitCode = 1
            return
         end if
         ji = 0
         ki = 0
         kl = 0
         do i=1, 5
            dist(i) = 0
            if (i.ne.ii .and. i.ne.jj .and. ji.eq.0) ji = i
            if (i.ne.ii .and. i.ne.jj .and. i.ne.ji .and. kl.eq.0) kl=i
            if (i.ne.ii .and. i.ne.jj .and. i.ne.ji .and. i.ne.kl) ki=i
         enddo
         if (ji.eq.0.or.kl.eq.0.or.ki.eq.0) then
            iExitCode = 1
            return
         end if
         ij = 0
         ik = 0
         do i=1, NumLeg-nlp
            if (LE(3,i).gt.0) then
               if (LE(1,i).eq.nur(ii).and.LE(2,i).eq.nur(ji)) ij = ji
               if (LE(1,i).eq.nur(ii).and.LE(2,i).eq.nur(ki)) ij = ki
               if (LE(1,i).eq.nur(ii).and.LE(2,i).eq.nur(kl)) ij = kl
               if (LE(2,i).eq.nur(ii).and.LE(1,i).eq.nur(ji)) ij = ji
               if (LE(2,i).eq.nur(ii).and.LE(1,i).eq.nur(ki)) ij = ki
               if (LE(2,i).eq.nur(ii).and.LE(1,i).eq.nur(kl)) ij = kl
               if (LE(1,i).eq.nur(jj).and.LE(2,i).eq.nur(ji)) ik = ji
               if (LE(1,i).eq.nur(jj).and.LE(2,i).eq.nur(ki)) ik = ki
               if (LE(1,i).eq.nur(jj).and.LE(2,i).eq.nur(kl)) ik = kl
               if (LE(2,i).eq.nur(jj).and.LE(1,i).eq.nur(ji)) ik = ji
               if (LE(2,i).eq.nur(jj).and.LE(1,i).eq.nur(ki)) ik = ki
               if (LE(2,i).eq.nur(jj).and.LE(1,i).eq.nur(kl)) ik = kl
            end if
         enddo
         if (ij.eq.0.or.ik.eq.0) then
            iExitCode = 1
            return
         end if
         dist(ii) = 1
         dist(ij) = 1
         dist(ik) = 1
         dist(jj) = 1
         kk = 0
         do i=1, 5
            if (dist(i).eq.0) kk = i
         enddo
         if (kk.eq.0) then
            iExitCode = 1
            return
         end if
         do k=1, 3
            c(k) = xyz(k,nur(ii)) + xyz(k, nur(ik))
            c(k) = ( c(k) + xyz(k,nur(ij)) + xyz(k, nur(jj)) ) / 4
         enddo
         di(3) = 0
         do k=1, 3
            di(3) = di(3) + ( c(k) - xyz(k,kk) ) ** 2
         enddo
         di(3) = sqrt(di(3))
         do k=1, 3
            xyz(k,NatMol+1) = c(k) + c(k) - xyz(k,nur(kk))
         enddo
         MoreBonds = 2
         do k=1, 3
            cn(k) = xx(k,ii) + xx(k, ik)
            cn(k) = ( cn(k) + xx(k,ij) + xx(k, jj) ) / 4
         enddo
         do k=1, 3
            xyn(k, 1) = cn(k) + cn(k) - xx(k, kk)
         enddo
      end if
! ---
      do i=1, MoreAtoms
         do k=1, 3
            x1(k) = xyn(k, i)
         enddo
         call MoltMatVec(rmi, x1, r1)
         do k=1, 3
            xyzs(k, NatMol + i) = r1(k)
         enddo
      enddo
!
      call FillVetSpec()
!
*gl*  call xupd05a(ier)
!
      do i=NatMol + 1, NatMol + MoreAtoms
         lnz   = iabs(nz(nur(1))/nzConst)
         RS(i) = RS(nur(1))
         iCol(i) = iCol(nur(1))
         iEqui(i) = i
c         nOpEq(i) = 10000
         nOpEq(i) = 1555
         rMLU(i) = rMLU(nur(1))
         xyzs(4, i) = xyzs(4, nur(1))
         xyzs(5, i) = xyzs(5, nur(1))
         bfac(i) = bfac(nur(1))
         bSav(i) = bfac(nur(1))
         nz(i) = nz(nur(1))
         nzTot(i) = lnz
         SinglePlotType(i) = iPlotType
         call CreaEll(i)
         call CreaLab(i,-1,lnz,Labb)
         Lab(i) = Labb
         VetChanges(1) = xyzs(1,i)
         VetChanges(2) = xyzs(2,i)
         VetChanges(3) = xyzs(3,i)
         VetChanges(4) = xyzs(4,i)
         VetChanges(5) = xyzs(5,i)
         VetChanges(6) = bfac(i)
*        lnz = inz
         iAction = 1
*gl*     call xupd05(i,iAction,Labb,lnz,VetChanges)
         call ModModel(i,iAction,Labb,lnz,VetChanges)
      enddo
      natve=NatMol
      do i = 1, NumLeg
         if (LE(1, i) .gt. NatMol) LE(1, i) = LE(1, i) + MoreAtoms
         if (LE(2, i) .gt. NatMol) LE(2, i) = LE(2, i) + MoreAtoms
      enddo
      do i = NumLeg, NumLeg - nlp + 1, -1
         LE(1, i + MoreBonds) = LE(1, i)
         LE(2, i + MoreBonds) = LE(2, i)
         LE(3, i + MoreBonds) = LE(3, i)
      enddo
      NL = NumLeg - nlp
      if (NumCase.eq.1) then
         LE(1, NL+1) = nur(ii)
         LE(2, NL+1) = NatMol + 1
         LE(3, NL+1) = 1
         LE(1, NL+2) = nur(jj)
         LE(2, NL+2) = NatMol + 2
         LE(3, NL+2) = 1
         LE(1, NL+3) = NatMol + 1
         LE(2, NL+3) = NatMol + 3
         LE(3, NL+3) = 1
         LE(1, NL+4) = NatMol + 2
         LE(2, NL+4) = NatMol + 3
         LE(3, NL+4) = 1
      elseif (NumCase.eq.2) then
         LE(1, NL+1) = nur(1)
         LE(2, NL+1) = NatMol + 1
         LE(3, NL+1) = 1
         LE(1, NL+2) = nur(2)
         LE(2, NL+2) = NatMol + 1
         LE(3, NL+2) = 1
         LE(1, NL+3) = nur(2)
         LE(2, NL+3) = NatMol + 2
         LE(3, NL+3) = 1
         LE(1, NL+4) = nur(3)
         LE(2, NL+4) = NatMol + 2
         LE(3, NL+4) = 1
         LE(1, NL+5) = nur(3)
         LE(2, NL+5) = NatMol + 3
         LE(3, NL+5) = 1
         LE(1, NL+6) = nur(1)
         LE(2, NL+6) = NatMol + 3
         LE(3, NL+6) = 1
      elseif (NumCase.eq.3) then
         LE(1, NL+1) = nur(ii)
         LE(2, NL+1) = NatMol + 1
         LE(3, NL+1) = 1
         LE(1, NL+2) = NatMol + 1
         LE(2, NL+2) = NatMol + 3
         LE(3, NL+2) = 1
         LE(1, NL+3) = nur(jj)
         LE(2, NL+3) = NatMol + 3
         LE(3, NL+3) = 1
         LE(1, NL+4) = nur(jj)
         LE(2, NL+4) = NatMol + 2
         LE(3, NL+4) = 1
         LE(1, NL+5) = nur(ij)
         LE(2, NL+5) = NatMol + 2
         LE(3, NL+5) = 1
      elseif (NumCase.eq.4) then
         LE(1, NL+1) = nur(ii)
         LE(2, NL+1) = NatMol + 2
         LE(3, NL+1) = 1
         LE(1, NL+2) = NatMol + 1
         LE(2, NL+2) = NatMol + 2
         LE(3, NL+2) = 1
         LE(1, NL+3) = nur(jj)
         LE(2, NL+3) = NatMol + 1
         LE(3, NL+3) = 1
      elseif (NumCase.eq.5) then
         LE(1, NL+1) = nur(ij)
         LE(2, NL+1) = NatMol + 1
         LE(3, NL+1) = 1
         LE(1, NL+2) = nur(jj)
         LE(2, NL+2) = NatMol + 1
         LE(3, NL+2) = 1
         LE(1, NL+3) = nur(jj)
         LE(2, NL+3) = NatMol + 2
         LE(3, NL+3) = 1
         LE(1, NL+4) = nur(ik)
         LE(2, NL+4) = NatMol + 2
         LE(3, NL+4) = 1
      elseif (NumCase.eq.6) then
         LE(1, NL+1) = nur(ii)
         LE(2, NL+1) = NatMol + 1
         LE(3, NL+1) = 1
         LE(1, NL+2) = nur(jj)
         LE(2, NL+2) = NatMol + 1
         LE(3, NL+2) = 1
      end if
      NumLeg = NumLeg + MoreBonds
      do i = 1, NumLeg
         LE1(1, i) = LE(1, i)
         LE1(2, i) = LE(2, i)
         LE1(3, i) = LE(3, i)
      enddo
      NatMol = NatMol + MoreAtoms
      NatInd = NatMol
      nLegInd = NumLeg
      do K =  1 , NatMol + NatSpi
         iOrd(K) = K
      enddo
!
      call LEtoIconn
      iAction = 100
      j       =   0
      Labb    = ' '
      call ModModel(i,iAction,Labb,lnz,VetChanges)
      call GetModel
*gl*  call xupd05(i,iAction,Labb,lnz,VetChanges)
*gl*  iAction = 200
*gl*  j       =   0
*gl*  Labb    = ' '
*gl*  call xupd05(j,iAction,Labb,lnz,VetChanges)
*gl*  call xupd05z(0)
!
      call AggiornaJav
! ---
      return
      end
! -----------------------------------------------------------------
      subroutine FindAtom(NewLab)
      USE General
      USE Molcom
! ---
      character*(*) NewLab
      character*16 UCLab
! ---
      ier = 0
      UCLab = NewLab
      call NoBlanks(UCLab,L)
      if (L.le.0) then
          ier = -1
      else
          call lcase(UCLab)
          call Ucase(UCLab(1:1))
          if (ier.ge.0) then
              iFound = 0
              do nh=1, NatMol
                 Labb = Lab(nh)(1:Lung(Lab(nh)))
                 if (Labb.eq.UCLab) then
                     ixx = ipix(1, nh)
                     iyy = ipix(2, nh)
                     call Linea(ixx-6, iyy, ixx+6, iyy, icoWire)
                     call Linea(ixx, iyy-6, ixx, iyy+6, icoWire)
                     call zflush()                     !mr 2401
                     iFound = 1
                 endif
              enddo
              if (iFound .eq. 0) then
                  LNN = Lung(NewLab)
                  Msg  = 'Atom '//NewLab(1:LNN)//' does not exist !!!'
                  Inte = 'Finding Atoms'
                  call MsgWinErr(Inte, Msg, WARN_WINDOW, nExitC)
              end if
          endif
      endif
! ---
      return
      end
! -----------------------------------------------------------------
      subroutine best_r(itrial)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE RfacMatrixModule
      USE PhaseInterface
      integer             ::itrial
!
      if (itrial > 0) then
          iAction = 6
          call MiglioriErre(iAction, itrial)
      else
          call PutGetBackUpXyzs(2)
      endif
      if (InfoOK(32) == 1) then
          call Cancella(5)
          erre = errem
          rfac = erre * 100.0
          write(Msg,100) rfac, numbrun
  100     format(' R = ',f6.2,'%   Trial',i5)
          call PrintMess(Msg)
!	    call scrper(Msg, 0, -1)
          write(lo,200) rfac, numbrun
  200     format(//,'Best R trial restored',/,
     *              ' R = ',f6.2,'%   Trial',i5)
          kblock(:) = 0
          kact=5
          call build(kact, 2)
          if (itrial == 0) then
              BTot(1,1) = 101
          endif
          call PutModel
          interp = 1
          call PutGetXyzs(1, interp)
          call ComputePhasesBestR
          ifSingle = 0
          kplot    = iPlotType
          call MolPlo(kplot, ifSingle)
      else
          Msg = 'Sorry ! No data previously saved'
          call OpenWarning(Msg)
      endif
! ---
      return
      end
! -----------------------------------------------------------------
      subroutine ComputePhasesBestR
      USE General
      USE Riflessi
      USE Atomi
!
      implicit none
      integer :: i, iref, mode, numb, ifBreak, iCoeff
      real    :: scalan
!
      do i=1, nats
         nzo(i) = nz(i)
         nz(i) = nz(i) / nzConst
      enddo
      do i=1, nrefl
         vettoreSigma(i) = i
      enddo
!
      iref = 0
      mode = 1
      numb = nrefl
      scalan = 0.0
      ifBreak = 0
      iCoeff = 0
      call sftryyyc(iref, mode, numb, scalan, ifBreak, iCoeff)
      fcvet(:) = work1(:)
!
      nz(1:nats) = nzo(1:nats)
!
      return
      end
! -----------------------------------------------------------------
      subroutine finishrestart(iAction, Valori, blocchi)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE Mappa
      USE MappaCont
      USE Seminvariants
      USE Param
      USE PhaseModule
*     USE RfacMatrixModule
      USE Direttive
      USE RemoModule
      USE VLDmod
      USE Grafici, only : headersGR
!
!-- iAction  = 1 Compute model for phases for the old trial = ntrialsC
!--          = 2 Restart computing phases for ntrialsC new trials
!--          = 3 Start Jav for trial ntrialsC
!--          = 4 Compute 2D contour   for trial ntrialsC
!--          = 5 Re-Compute phases for old trial = ntrialsC
!--          = 6 Export phases for trial = ntrialsC
!-- WhichLSQ = 1 Compute model only
!--          = 2 Fourier recycling only
!--          = 3 Automatic DLSQ
!
      dimension Valori(10)
      integer blocchi(20), WhichLSQ
      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
     *                  NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!psie      
!psie     *            NPsie,NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!
      dimension xv(3,8),x1(3),x2(3)
!
      ier = 0
      ifPatt = 0
      ntrialsC = nint(Valori(5)) / 100
      jrest = 0
      if (iAction == 1) then
          WhichLSQ = nint(valori(7))
          jrest = 2
          numbTrials = 1
          ntrialsF = nint(OldTRialsForDLSQ(ntrialsC,1))
          trialVett(1) = ntrialsF
          itria    = ntrialsF
          numbrun  = ntrialsF
          MaxRun   = 1
          numbTrials = 1
          write(lo,10) numbrun
          anat = Valori(6)
          ifFour = 1
          aperc(1) = anat
          nats = anat
          WhichModel = 1
          numbModels = 2
          ifVLD = 0
      elseif (iAction == 2) then
          jproc = 1
          jrest = 1
          MaxRun    = ntrialsC
          nBlocksPh = ntrialsC
          itria     = 0
          write(lo,20) nBlocksPh
          k = 0
          do i=1,nBlocksPh
             do j=1,2
                k = k + 1
                jBlocksPh(j,i) = blocchi(k)
             enddo
          enddo
          numbTrials = 0
          do i=1,nBlocksPh
              write(lo,30) i,(jBlocksPh(j,i),j=1,2)
              numbTrials = numbTrials + jBlocksPh(1,i)
          enddo
          write(lo,*) ' '
          k = nint(Valori(5))
          k = mod(k, 100)
          ifRelax = k - 3
          RSoglia = Valori(6)
      elseif (iAction == 3) then
          call LanciaJavSir(0)
          return
      elseif (iAction == 4) then
          numb = nreflDim
          if (nats == 0) then
              do i = 1 , 3
                 do j = 1 , 3
                    BTot(i, j) = 0
                 enddo
                 BTot(i, i) = 1
              enddo
              nMaxLeg = 9800
              call InitMolplo()
              xv(1, 1) = 1
              xv(2, 1) = 0
              xv(3, 1) = 0
              xv(1, 2) = 0
              xv(2, 2) = 1
              xv(3, 2) = 0
              xv(1, 3) = 0
              xv(2, 3) = 0
              xv(3, 3) = 1
              xv(1, 4) = 0
              xv(2, 4) = 0
              xv(3, 4) = 0
              xv(1, 5) = 1
              xv(2, 5) = 1
              xv(3, 5) = 0
              xv(1, 6) = 1
              xv(2, 6) = 0
              xv(3, 6) = 1
              xv(1, 7) = 0
              xv(2, 7) = 1
              xv(3, 7) = 1
              xv(1, 8) = 1
              xv(2, 8) = 1
              xv(3, 8) = 1
              do i=1, 8
                 iOrd(i) = i
                 Lab(i) = ' '
                 iCol(i) = color_CELL
                 RS(i) = 0.01
                 do j = 1, 3
                    x1(j) = xv(j, i)
                 enddo
                 call MoltMatVec(rm,x1,x2)
                 xyz(1,i) = x2(1)
                 xyz(2,i) = x2(2)
                 xyz(3,i) = x2(3)
                 NatSpi = 8
              enddo
          endif
!
          call AllocaMappa(2)
          call AllocaMappaCont(2)
          call AllocaContorno(2)
          call CheckGrid()
          call AllocaMappa(1)
          call AllocaMappaCont(1)
          call AllocaContorno(1)
          nset = iposFineDSR(ntrialsC)
!gl!      call snr17(nset,figMer)
          call PutGetFinalPhases(2, nset, figMer)
          fcoef(1:numb) = fovet(1:numb) * wt(1:numb)
          jpatt = 0
          call MakeMap(fcoef, iphaz, numb, jpatt, xmap,
     *                FORTH, BACK)
          ifAlreadyProduced = 1
!
          RhoNew = xmap
!
          nnx=np(1)
          nny=np(2)
          nnz=np(3)
          call maxminSir(nnx,nny,nnz,rhonew)
          massimoMappa = denmax
          massimoMappa = max0(massimoMappa, int(5*sigmaMappa))
          sigmaMappa = stden
!          write(0,*) 'massimoMappa',massimoMappa
          sigma3 = sigmaMappa / 3.0
          do i=1,15
             SoglieCont(i) = sigma3 * i
          enddo
          ngridCont = np
          call PreparaContour
*         call InitContour(ngrid)
          Msg = 'Starting contouring procedure'
          call PrintMess(Msg)
          return
       elseif (iAction == 5) then
!          write(0,*) 'Trial number ',ntrialsC
!          write(0,*) 'LSQ ',nint(Valori(7))
!          write(0,*) 'Procedure ',nint(Valori(8))
!          write(0,*) 'Relax ',nint(Valori(9))
          iyrand = 67543
          jproc = 1
          jrest = 2
          numbTrials = 1
          trialVett(1) = ntrialsC
          numbTrials   = 1
          MaxRun    = 1
          nBlocksPh = 1
          jBlocksPh(1,1) = 1
          jBlocksPh(2,1) = 1
          n_Maxrun = 1
          itria     = ntrialsC
          ntria     = 1
          ifRelax = 1
*         k = nint(Valori(5))        ! gianluca 21/04/2014
*         k = mod(k, 100)
*         ifRelax = k - 3
*         ifRelax = nint(Valori(9))
*         RSoglia = Valori(6)
          InfoOK(8) = 0
          WhichLSQ = nint(valori(7))
          if (WhichLSQ == 1) then
              nolsq = 1
          elseif (WhichLSQ == 2) then
              nolsq = 6
          else
              nolsq = -1
          endif
          ifMDM = 0
          ifVLD = 0
          ifTang  = 0
          ifPatt  = 0
          kWstop = 0
          nstr = nstr_data
          nPreviousTrials = 0
          InfoOK(15) = 0
! aggiunte 24/03/2015
          if (ksize >= 3) then
              call CPUTime0(' ')
              call CPUTime0(' ')
              headersGR(2) = ' '
          endif
!

          select case (nint(Valori(8)))

             case (1)
                n_EDM = 18
                ifMDM = 1

             case (2)
                ifTang = 1

             case (3)
                ifVLD = 1
                n_abi_model = nPreviousTrials + 1

             case (4)
                ifPatt = 1

          end select
          if (ifPatt == 1) then
              NQuaNeg = 0
              ifNewPsi0 = 0
              jproc = 0
          endif
          write(lo,10) ntrialsC

       elseif (iAction == 6) then
          itria = ntrialsC
          numb = nreflDim
          nset = iposFineDSR(ntrialsC)
!gl!      call snr17(nset,figMer)
          call PutGetFinalPhases(2, nset, figMer)
          fcoef(1:numb) = fovet(1:numb)
          if (resm < ResSogLow) then
              LowRes = 0
          else
              LowRes = 1
          endif
          ifPatt = 0
          call CheckGrid()
          return
      endif
!
      if (iAction == 2 .or. iAction == 5) then
          if (InfoOK(6) == 1) then
              call CheckGrid()
              nreflDim = nrefltot
              call AllocaRiflessi(1)
          endif
!
          jBlock  = 1
*gl*      if (InfoOK(34) == 0) then
              ifLi34 = InfoOK(34)
              if (ifLi34 > 0) then
                  call PutGetRfacMatrix(2)
              else
                  nRfac = 0
*                 RfacMatrix(:,:,:) = 0
*                 RfacMatrix(2,:,:) = -9999.9      !!!<<<
*                 RfacMatrix(3,:,:) = -9999.9      !!!<<<
              endif
*gl*      endif
!
          iAction = 99
          call AllocaBonds(iAction)
          numbModels = 2
          iAction = 0
          call AllocaBonds(iAction)
!
          iAction = 0
          call RunToolBar(iAction,' ')
          icomat = 1
          ipunt  = 1
          ipdir = 0
          call Inserisci(ipunt,'%end',ier)
          call Inserisci(ipunt,'%pha',ier)
!
          numbTrials = ntrialsC
          nBlocksPh = 1
          jBlocksPh(1,1) = 1
          jBlocksPh(2,1) = 1
          trialVett(1) = ntrialsC
          ntria = 1
          itria = ntrialsC
          ifTrial = 1
          ifPeak = 1
!
          ipcom = 2
          call scr2_sir
          ksubr = 3
          ifFromGraphic = 1
!!          ifViewer = .false.
          call CloseViewer()
          call Contan(ier, ksubr, ifFromGraphic)


                       call export(ier,ksubr) ! prova gianluca 25/03/2015


          call c_scr2(-1, 0, 0, 0, 0, ' ')
          call RunToolBar(-1,' ')
          return
      endif
      if (anat.lt.5) then
          anatLSQ = 7
      else
          anatLSQ = float(nint(anat * 1.2))
      endif
      ObsPar = float(numbLSQ) / ( 4.0 * anatLSQ )
      if (ObsPar < 5.0 . and. WhichLSQ == 3) then
          write(Msg,100) char(10), char(10), ObsPar, char(10)
          Inte = 'Warning'
          call MsgWinErr(Inte, Msg, QUEST_WINDOW_YES_NO,
     *                   nExitCode)
      else
         nExitCode = 1
      endif
      if (nExitCode == 1) then
          if (WhichLSQ == 1) then
              Msg = 'Computing Atomic Model'
          elseif (WhichLSQ == 2) then
              Msg = 'Starting Automatic Fourier Recycling'
          elseif (WhichLSQ == 3) then
              Msg = 'Starting Automatic Diagonal Least Squares'
          endif
          call PrintMess(Msg)
          call f_FortranAlLavoro(1)
          LowRes = 1
          if (resm < ResSogLow) then
              LowRes = 0
          else
              LowRes = 1
          endif
          call AllocaAtomi(2)
!         call AllocaAtomi(-1)
          call AllocaAtomi(1)
          call AllocaTestModel(1)
          call InitMolplo()
          ifFromGraphic = 1
          call InitFour(ifFromGraphic,ier)

          if (iAction == 1) then
              ifFour = 1
              aperc(1) = Valori(6)
              if (neutro == 2) aperc(1) = aperc(1) / 2.0
          endif

          if (WhichLSQ == 1) then
              jrecyc = 0
          elseif (WhichLSQ == 2) then
              jrecyc = 6
          endif
          if (knw > 0) then
              call AllocaTestStuff(1)
              if (ifReduced.eq.1) then
                  ifExamin = 2
              else
                  ifExamin = 1
              endif
          else
              ifExamin = 0
          endif
          ifTime = 0
          nset = iposFineDSR(ntrialsC)
!gl!      call snr17(nset,figMer)
          call PutGetFinalPhases(2, nset, figMer)
          if (knw == 1) then
              call Trasla_Origine(nreflDim)          
          endif
          izero = 0
          ifmin = 0
          call examin(5455,mkang,khl,ipub,iphaz,nreflDim,izero,wt,
     *                ifmin)
          call CheckGrid()
          call AllocaMappa(1)
          nrefB = numbLSQ
          kcicla = 1
          erreNoWind = 0
          fomNoWind = 0
          ifBreak = 0
          kWstop = 0
          nolsq = -1
          call dlsq(ier,kcicla,erreNoWind, fomNoWind, 1,
     *               ifBreak)
          if (ier < 0) then
              call f_FineLavoro(1)
              return
          endif

          if (WhichLSQ == 1) then
              nzsav(:) = nz(:)
              nz(:) = iabs(nz(:)) / nzConst
              iref = 0
              mode = 1
              numb = nrefB
              scalan = 0.0
              ifBreak = 0
              iCoeff = 0
              call sftryyyc(iref,mode,numb,scalan,ifBreak,iCoeff)
              fcvet(:) = work1(:)
              nz(:) = nzsav(:)
              rfac  = erre  * 100.0
              write(Msg,110) numbrun,rfac
              call PrintMess(Msg)
              errem = erre
              if (erreBest > erre) then
                  erreBest = erre * 100.0
              endif
!
!-- store in list 6 the last R value
!
              rflsq = errem * 100.0
!
          endif
!
          call PutModel
          WhichModel = 2
          call PutModel
          InfoOK(32) = 1
          WhichModel = 1
!
          call StatisticaErre
!
          call AggiornaFasiPesiNew(4,wt,iphaz,fcvet)
!
          QualeAbilita = 2
          call lastplot(rfac)
          call f_FineLavoro(1)
      endif
!
   10 format(///,' ',78('+'),//,
     *           ' Recomputing phases for trial no.',i5,//)
   20 format(///,' ',78('+'),//,
     *           'Restarting to develop ',i2,' new block(s)',/,
     *       15x,' Block     Trials    to explore')
   30 format(15x,i3,2i12)
   40 format('Computing skeleton for trial ',i5)
   45 format('Computed skeleton for trial ',i5)
   50 format('Computing model for trial ',i5)
  100 format('Do you want apply',a,'automatic diagonal LSQ?',a,
     *    'Ratio Obs-Params =',f12.2,a,'Too low value')
  110 format('Trial ',i5,'   R =',f7.2)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LanciaJavSir(ifDifference)
      USE General
      USE Riflessi
      USE Atomi
      USE Mappa
!
      implicit none
      integer    :: L, Lung, step, kk, knwSav, numb, nSetsMTZL, ier
      integer    :: izero, ifmin, nbru, jpatt, GiaFatta, ksubr
      integer    :: ifDifference, iAction
      real       :: sommaFo, bari(3), scala
!
!-- Check reflections
!
      if (nrefl > 0) then
          if (.not. allocated(khl)) then
              call AllocaRiflessi(1)
              kk = 4
              call LeggiRiflessi(ier, kk)
!
!-- Check phases
!
              kk = sum(iphaz(:))
              if (kk == 0 .or. ifDifference == 1) then
                  if (nats > 0) then
                      iAction = 1
                      ier = 0
                      call LastSFC(iAction, ier)
                      call AggiornaFC(fcvet, wt)
                  endif
                  if (nats == 0 .or .ier /= 0) then
                      Msg = 'No phases available'
                      call MsgWinErr('Starting Viewer:', Msg,
     *                                   ERR_WINDOW,kk)
                      return
                  endif
              endif
          endif
          if (ifDifference == 1) then
              if (nats > 0) then
                  iAction = 1
                  ier = 0
                  call LastSFC(iAction, ier)
                  call AggiornaFC(fcvet, wt)
              endif
          endif
      else
          Msg = 'Impossible to create the map: no reflections loaded.'
     *          // char(10) // 'Continue?'
          call MsgWinErr('Starting Viewer:',Msg,QUEST_WINDOW_YES_NO,kk)
          if (kk == 2) return
      endif
!
      kk = Lung(StructureName)
      if (sum(fovet(1:nrefl)) < 0.01) then
          ksubr = 4
          ier   = 0
          call LeggiRiflessi(ier, ksubr)
      endif
!
!-- Check on map
!
      if (.not.allocated(xmap)) then
          call CheckGrid()
          call AllocaMappa(1)
      endif
      if (ifDifference == 1) then
          scala = sum(fcvet(1:nrefl)) / sum(fovet(1:nrefl))
          fcoef(1:nrefl) = scala * fovet(1:nrefl) - fcvet(1:nrefl)
      else
          fcoef(1:nrefl) = fovet(1:nrefl)
      endif
      jpatt = 0
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH,BACK)
!
      call LanciaJavs(1, ifDifference)
      return
!
!-- CIF
!
      if (nats > 0) then
          cardDiret = StructureName(1:kk) // '_tmp.cif'
          call WriteSimpleCif(cardDiret, nats, nz, nzConst, 5, xyzs,
     *                        bfac, aLab, 1.0, bari)
          card(2) = cardDiret(1:Lung(cardDiret)) // char(0)
      else
          card(2) = ' ' // char(0)
      endif
!
!-- MTZ
!
      if (nrefl > 0) then
          sommaFo = sum(fovet(:))
          if (sommaFo < 0.001) then
              ksubr = 3
              call LeggiRiflessi(ier, ksubr)
          endif
          cardDiret = StructureName(1:kk) // '_tmp.mtz'
          knwSav = knw
          knw = 0
          step = -88
          numb = 1
          nSetsMTZL = 0
          call WriteMTZ(step, numb, nSetsMTZL, 1, ier)
          knw = knwSav
          if (knw > 0) then
              izero = 0
              ifmin = 1
              nbru = 666
             call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
          endif
          card(4) = cardDiret(1:Lung(cardDiret)) // char(0)
!
!-- Check on map
!
          if (.not.allocated(xmap)) then
              call CheckGrid()
              call AllocaMappa(1)
              fcoef(1:nrefl) = fovet(1:nrefl)
              jpatt = 0
              call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH,BACK)
          endif
!
!-- XYZ
!
          cardDiret = StructureName(1:kk) // '_tmp.xyz'
          GiaFatta = 0
          call WriteMapXYZ(GiaFatta, ifDifference)
          card(3) = cardDiret(1:Lung(cardDiret)) // char(0)
      else
          card(4) = ' ' // char(0)
      endif
      
!
!-- Start Jav
!
      if (nats > 0) then
          write(Msg,20) bari(1:3)         
          call NoBlanks(Msg, L)
      else
          Msg = ' '
          L = 1
      endif
      if (ifDifference == 0) then
          write(card(1),10) char(34),Titolo(1:Lung(Titolo)),char(34),
     *                  Msg(1:L)
      else
          write(card(1),15) char(34),Titolo(1:Lung(Titolo)),char(34),
     *                  Msg(1:L)
      endif
*     write(*,*) 'f:card(1)', card(1)(1:Lung(card(1)))
*     write(*,*) 'f:card(2)', card(2)(1:Lung(card(2)))
*     write(*,*) 'f:card(3)', card(3)(1:Lung(card(3)))
      direttiva = card(1)(1:Lung(card(1))) // ' ' //
     *            card(2)(1:Lung(card(2))) // ' ' //
     *            card(3)(1:Lung(card(3)))
      L = Lung(direttiva)
      write(*,'(a,a)') 'jav ',direttiva(1:L)
      L = Lung(card(1))
      card(1)(L+1:L+1) = char(0)
*     call startJav(card, 4)
      call startJav(card, 3)

!
      return
   10 format('-w -t=',a,'Jav: ',a,a,2x,a)
   15 format('-w -d -t=',a,'Jav: ',a,a,2x,a)
   20 format('-C=" ',f8.2,' , ',f8.2,' , ',f8.2,' "')
      end
!-----------------------------------------------------------------------
      subroutine GetSkeleton()
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
!
      character*80 fileh, line, dire
      dimension vet(40), ivet(40)
!
      k = index(fname(1),'.bin')
      fileh = fname(1)(1:k) // 'skl'
      itype=2
      iform=1
      if (jopen(jhost,fileh,itype,iform,ios).lt.0) then
          ier = -1
          write(6,*) 'Errore in apertura del PDB'
          call toflush()
          call cstop(' ')
      endif
      nats = 0
      nleg = 0
      do 
         read(jhost,'(a)',end = 10) line
         call shift(line,k1)
         call lcase(line)
         call cutst(line,lenp,dire,lend)
         if (dire(1:1) == '!' .or.  dire(1:1) == '>') then
             cycle
         endif
         if (dire(1:2) == 'sk') then
             iopt = 0
             call getnum(line, vet, ivet, iv, iopt)
             if (iopt == -1. or. iv /= 3) then
                 ier = -1
                 exit
             endif
             nats = nats + 1
             xyz(1:3,nats) = vet(1:3)
         elseif (dire(1:2) == 'co') then
             iopt = 0
             call getnum(line, vet, ivet, iv, iopt)
             if (iopt == -1. or. iv /= 2) then
                 ier = -1
                 exit
             endif
             nleg = nleg + 1
             LE(1:2,nleg) = ivet(1:2)
             LE(3,nleg) = 4
         else
             ier = -1
         endif
      enddo 
   10 close(jhost)
      call AllocaAtomi(2)
      call AllocaAtomi(-1)
      do i=1, nats
         xyzs(1:3,i) = xyz(1:3,i)
         xyzSk(1:3,i) = xyz(1:3,i)
         xyzs(4,i) = 100
         xyzs(5,i) = 1.0
         bfac(i) = 3.0
         nz(i) = nzConst
         SinglePlotType(i) = STICKS
      enddo
      iPlotType  = STICKS
      iconn(1) = nleg
      k = 1
      do i=1, nleg
         iconn(k+1:k+3) = LE(1:3,i)
         k = k + 3
      enddo
      k = nleg * 3 + 1
      iconnSk(1:k) = iconn(1:k)
      interp = 1
      call PutGetXyzs(1, interp)
      ifSkeleton= nats
      if (QualeAbilita /= 2) then
          QualeAbilita = 1
      endif
!
      call DrawSkeleton
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DrawSkeleton
      USE General
      USE Symmetry
      USE Molcom
      USE PhaseModule
!
      real :: B(3,3)
!
      BTot(1,1) = 101
      BTot11 = BTot(1,1)
      IfScale= 1
      leggi = 0
      call toMolPlo3(leggi)
      call LsPlane(NATV, 1)
!
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
!
      if (BTot11.lt.100.0) then
          call RotazTot
      else
          do i = 1 , 3
             do j = 1 , 3
                BTot(i, j) = 0
             enddo
             BTot(i, i) = 1
          enddo
          call FindOr(B, 1)
      end if
!
      call GetBonds(1)
      call Disegna(ifScale)

!
      return
      end
!-----------------------------------------------------------------------
      subroutine Skto15
      USE General
      USE Atomi
      USE Molcom
!
      character*8 tmpLab
!
      nats = ifSkeleton
      do i=1, nats
         xyzs(1:3,i) = xyzSk(1:3,i)
         xyzs(4,i) = 100
         xyzs(5,i) = 1.0
         bfac(i) = 3.0
         nz(i) = nzConst
         SinglePlotType(i) = STICKS
         write(tmpLab,10) i
         call NoBlanks(tmpLab,k)
         aLab(i) = tmpLab
      enddo
      nleg = iconnSk(1)
      k = nleg * 3 + 1
      iconn(1:k) = iconnSk(1:k)
      BTot(1,1) = 101
      interp = 1
      call PutGetXyzs(1, interp)
!
      return
   10 format('Sk',i6)
      end
!======================================================================
!
!  -------------------------- M O L P V 2 ---------------------------
!
!======================================================================
      subroutine ProduciMappa()
      USE General
      USE Riflessi
      USE Atomi
      USE Mappa
      USE Param
      USE PhaseModule
!
      call LoadReflInfo
      sumWt = 0.0
      numb    = nreflDim
      if (InfoOK(6).eq.1) then
          call CheckGrid()
          nreflDim = nrefltot
          call AllocaRiflessi(1)
          ksubr = 4
          call LeggiRiflessi(ier,ksubr)
          sumWt = sum(wt)
      endif
!
      if (sumWt < 1.0) then
          do i=1,nats
             nzo(i) = nz(i)
             nz(i)  = iabs(nz(i)) / nzConst
          enddo
          ifBreak = 0
          iCoeff  = 1
          mode    = 1
          iref    = 0
          call sftryyyc(iref,mode,numb,scalan,ifBreak,iCoeff)
          call AggiornaFasiPesiNew(4,wt,iphaz,fcvet)
      endif
!
!test iphaz = ipub
!test wt = 1
      call AllocaMappa(1)
      fcoef(1:numb) = fovet(1:numb) * wt(1:numb)
      jpatt = 0
      call MakeMap(fcoef, iphaz, numb, jpatt, xmap,
     *                FORTH, BACK)
!
      if (sumWt < 1.0) then
          nz(1:nats) = nzo(1:nats)
      endif
!
      return
      npx = np(1)
      npy = np(2)
      npz = np(3)
      call maxminSir(npx,npy,npz,xmap)
      call AllocaRiflessi(2)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine TrasformaContour()
      USE Contorno
      USE Molcom
!
      dimension x1(3), x2(3)
!
      do i=1, nPuntiCont + MorePoints
         do j=1,3
            x1(j) = xyz_tria(j,i)
         enddo
         call MoltMatVec(rm, x1, x2)
         do j=1,3
            xyz_tria(j,i) = x2(j)
         enddo
      end do
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PlotContour()
      USE General
      USE Molcom
      USE Contorno
      USE PhaseModule
!
      real tria(3,10)
      integer Code, TipoPlot
!
      if (nPuntiCont.lt.3) then
          Msg = 'Not enough points to contour. Check level values.'
          call MsgWinErr('Warning', Msg, WARN_WINDOW, nExitCode)
      else

          call NewPage()

!!mr
          call SetScaleMap()
!!mr
          nPoints = 2
          Code = 0
          do i=1, nPuntiCont-moreBox, 2
             do k=0,1
                kk = i + k
                do j=1,3
                   tria(j,k+1) = xyz_tria(j,kk)
                enddo
             enddo
             ic = xyz_tria(4,i)
             ic1 = mod(ic-1, 5) + 1
             if (ifLevel(ic1).eq.1) then
                 ic1 = LevelCol(ic1)
                 call PolyShape(Code, nPoints, tria, ic1)
             endif
          end do
      endif
!
      if (ifModel /= 0) then
          call SelectAtoms()
          do i=1, NatMol + NatSpi
             iOrd(i) = i
          enddo
          call AngToPix
          TipoPlot = mod(ifModel,10)
          ipltSav = iPlotType
          if (TipoPlot == 1) then
              iPlotType = STICKS
          elseif (TipoPlot == 2) then
              iPlotType = SIMPLE
          elseif (TipoPlot == 3) then
              iPlotType = BUBBLES
          elseif (TipoPlot == 4) then
              iPlotType = SHADING
          elseif (TipoPlot == 5) then
              iPlotType = ELLIPSOIDS
          endif
          ifSingle = 0
          call DisegnaAtomi(0,ifSingle)
          iPlotType = ipltSav
          if (ifLabels.ne.0) then
              call DrawLabels()
          endif
      endif
      if (ifGrid == 1) then
          call DrawGrid()
      endif
!
      if (ifCell.eq.1) then
          call DrawCellContour()
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SetScaleMap()
      USE Contorno
      USE Molcom
!
      morePointsB = morePoints  !pgMap
      if (ifCell == 0) then     !pgMap
         morePoints = 0         !pgMap
      end if                    !pgMap
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      bard = 0
! ---
! ---    trova il baricentro dei vertici dei triangoli
! ---
      do i = 1 , nPuntiCont + morePoints
         bard(1) = bard(1) + xyz_tria(1,i)
         bard(2) = bard(2) + xyz_tria(2,i)
         bard(3) = bard(3) + xyz_tria(3,i)
      enddo
!
      bard = bard / ( nPuntiCont + morePoints )
! ---
! ---     shift dei vertici dei triangoli: origine sul baricentro
! ---
      do i = 1 , nPuntiCont + morePointsB         !pgMap
          xyz_tria(1,i) = xyz_tria(1,i) - bard(1)
          xyz_tria(2,i) = xyz_tria(2,i) - bard(2)
          xyz_tria(3,i) = xyz_tria(3,i) - bard(3)
      enddo
!
      do JAT = 1 , nPuntiCont + morePoints
         if (xyz_tria(1,JAT) .LT. Rmin1) Rmin1 = xyz_tria(1,JAT)
         if (xyz_tria(1,JAT) .GT. RMAX1) RMAX1 = xyz_tria(1,JAT)
         if (xyz_tria(2,JAT) .LT. Rmin2) Rmin2 = xyz_tria(2,JAT)
         if (xyz_tria(2,JAT) .GT. RMAX2) RMAX2 = xyz_tria(2,JAT)
      enddo
      DeltX = (Rmin1 + RMAX1) / 2
      DeltY = (Rmin2 + RMAX2) / 2
      do JAT = 1 , nPuntiCont + morePointsB        !pgMap
         xyz_tria(1,JAT) = xyz_tria(1,JAT) - DeltX
         xyz_tria(2,JAT) = xyz_tria(2,JAT) - DeltY
      enddo
!
      if (NatMol > 0) then
          call SovrapponiAtomi()
      endif
!
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      iEnd = NatMol
      do JAT = 1 , nPuntiCont + morePoints
         if (xyz_tria(1,JAT) .LT. Rmin1) then
            Rmin1 = xyz_tria(1,JAT)
         end if
         if (xyz_tria(1,JAT) .GT. RMAX1) then
            RMAX1 = xyz_tria(1,JAT)
         end if
         if (xyz_tria(2,JAT) .LT. Rmin2) then
            Rmin2 = xyz_tria(2,JAT)
         end if
         if (xyz_tria(2,JAT) .GT. RMAX2) then
            RMAX2 = xyz_tria(2,JAT)
         end if
      enddo
!
      Lim1 = iVP(1)
      Lim2 = iVP(2)
      Lim3 = iVP(3)
      Lim4 = iVP(4)
      NPX = Lim3 - Lim1
      NPY = Lim4 - Lim2
      Ratio = float(NPX) / float(NPY)
!
      quanto = 20
      D1 = (RMAX1 - Rmin1) / quanto
      Rmin1 = Rmin1 - D1
      RMAX1 = RMAX1 + D1
      D2 = (RMAX2 - Rmin2) / quanto
      Rmin2 = Rmin2 - D2
      RMAX2 = RMAX2 + D2
      Dx = RMAX1 - Rmin1
      Dy = RMAX2 - Rmin2
!
      if (Dx.LE.Dy * Ratio) then
         DX1 = Dy * Ratio
         DEL = (DX1 - Dx) / 2
         Rmin1 = Rmin1 - DEL
         RMAX1 = RMAX1 + DEL
         Dx = DX1
      else
         DY1 = Dx / Ratio
         DEL = (DY1 - Dy) / 2
         Rmin2 = Rmin2 - DEL
         RMAX2 = RMAX2 + DEL
         Dy = DY1
      end if
      Xmin = Rmin1
      Ymin = Rmin2
      YMax = Rmin2 + Dy
      XMax = Rmin1 + Dx
      RMAX1 = XMax
      RMAX2 = YMax
      call Window (Xmin, Ymin, XMax, YMax, Ratio)
      DDX = (XMax - Xmin) / (Lim3 - Lim1)
      DDY = (YMax - Ymin) / (Lim4 - Lim2)
!
      if (ifCell == 0) then              !pgMap
         morePoints = morePointsB        !pgMap
      end if                             !pgMap

      return
      end
!-----------------------------------------------------------------------
      subroutine DrawCellContour()
      USE Atomi
      USE Contorno
      USE Molcom
      USE PhaseModule
!
      iC1 = color_CELL
      do j=1,12 + moreLines
         N1  = kSpiCont(j,1)
         N2  = kSpiCont(j,2)
         a = ( xyz_tria(1,N1) + x11disp(1) ) * x11scale(1)
         b = ( xyz_tria(2,N1) + x11disp(2) ) * x11scale(2)
         ix1 = nint(a)
         iy1 = iVP(4) - nint(b)
         a = ( xyz_tria(1,N2) + x11disp(1) ) * x11scale(1)
         b = ( xyz_tria(2,N2) + x11disp(2) ) * x11scale(2)
         ix2 = nint(a)
         iy2 = iVP(4) - nint(b)
         call Linea(ix1, iy1, ix2, iy2, iC1)
      enddo
!
      return
      end
! -----------------------------------------------------------------
      subroutine PolyShape(Code, nPoints, tria, ico)
      USE Molcom
!
      dimension tria(3,10), x1(3)
      integer Code
!
      iColor = ico
      RagMed = 0.0
      NatVis = 0
      do j = 1, nPoints
         do i = 1, 3
            x1(i)=tria(i,j)
         enddo
         a = ( x1(1) + x11disp(1) ) * x11scale(1)
         b = ( x1(2) + x11disp(2) ) * x11scale(2)
         ixv(j)=nint(a)
         iyv(j)=iVP(4) - nint(b)
      enddo
!
      select case(Code)

! Line

         case (0)         
            ind = 3
            call graphs(nPoints, ind, ' ', iColor, iColor)

! Triangle or Trapezoide

         case (1,2)         
            ind = 14
            call graphs(nPoints, ind, ' ', iColor, iColor)

! Triangle + Trapezoide

         case (3)           
            ind = 14
            call graphs(3, ind, ' ', iColor, iColor)
            do i=1,4
               ixv(i) = ixv(i+3)
               iyv(i) = iyv(i+3)
            enddo
            ind = 14
            call graphs(4, ind, ' ', iColor, iColor)

! Triangle + Triangle + Trapezoide

         case (4)           
            ind = 14
            call graphs(3, ind, ' ', iColor, iColor)
            do i=1,3
               ixv(i) = ixv(i+3)
               iyv(i) = iyv(i+3)
            enddo
            ind = 14
            call graphs(3, ind, ' ', iColor, iColor)
            do i=1,4
               ixv(i) = ixv(i+6)
               iyv(i) = iyv(i+6)
            enddo
            ind = 14
            call graphs(4, ind, ' ', iColor, iColor)

! Triangle + Line

         case (5)           
            ind = 14
            call graphs(3, ind, ' ', iColor, iColor)
            ixv(2) = ixv(4)
            iyv(2) = iyv(4)
            ind = 3
            call graphs(nPoints, ind, ' ', iColor, iColor)

! Triangle + Triangle + Line

         case (6)           
            ind = 14
            call graphs(3, ind, ' ', iColor, iColor)
            do i=1,3
               ixv(i) = ixv(i+3)
               iyv(i) = iyv(i+3)
            enddo
            ind = 14
            call graphs(3, ind, ' ', iColor, iColor)
            ixv(2) = ixv(7)
            iyv(2) = iyv(7)
            ind = 3
            call graphs(4, ind, ' ', iColor, iColor)

      end select
!
      return
      end
! ----------------------------------------------------------------------
      subroutine PreparaContour
!corr      USE General
!corr      USE Atomi
!corr      USE Molcom
!corr      USE Contorno
!corr      USE Mappa
!corr      USE MappaCont
!corr      USE Iso_Surfaces
!corr      USE PhaseModule
!
      implicit none
!
      real zlim(5)
      integer Step(3)
!
      call LeggiSezioni()
      call SetScaleMap()
      call PlotContour()
      call Sistemino
!
      return
      end
! ----------------------------------------------------------------------
      subroutine LeggiSezioni()
      USE General
      USE Contorno
      USE Molcom
      USE Mappa
      USE MappaCont
      USE Iso_Surfaces
      USE PhaseModule
!
      real limits(2,2)
      integer sezione, sezioni, ngrid2(2)
      real xvet(1000) ,yvet(1000)
      real,    allocatable :: dmap(:,:)
!
!     imap is the orientation section: 1 XY, 2 YZ, 3 ZX
      assex = xyzlimCont(2,1) - xyzlimCont(1,1)
      assey = xyzlimCont(2,2) - xyzlimCont(1,2)
      assez = xyzlimCont(2,3) - xyzlimCont(1,3)
      nPuntiCont = 0
      nLev = nLevels(1)
      if (Layer == 1) then
          stepx = 1.0 / float(ngridCont(2))
          stepy = 1.0 / float(ngridCont(3))
          stepz = 1.0 / float(ngridCont(1))
          iix = int( 0.5 + assey / stepx )
          iiy = int( 0.5 + assez / stepy )
          ii = int( xyzlimCont(1,2) / stepx )
          ax = float(ii) * stepx
          ii = int( xyzlimCont(1,3) / stepy )
          ay = float(ii) * stepy
          limits(1,1) = xyzlimCont(1,2)
          limits(1,2) = xyzlimCont(2,2)
          limits(2,1) = xyzlimCont(1,3)
          limits(2,2) = xyzlimCont(2,3)
          imap = 2
      elseif (Layer == 2) then
          stepx = 1.0 / float(ngridCont(3))
          stepy = 1.0 / float(ngridCont(1))
          stepz = 1.0 / float(ngridCont(2))
          iix = int(  0.5 + assez / stepx )
          iiy = int(  0.5 + assex / stepy )
          ii = int( xyzlimCont(1,3) / stepx )
          ax = float(ii) * stepx
          ii = int( xyzlimCont(1,1) / stepy )
          ay = float(ii) * stepy
          limits(1,1) = xyzlimCont(1,3)
          limits(1,2) = xyzlimCont(2,3)
          limits(2,1) = xyzlimCont(1,1)
          limits(2,2) = xyzlimCont(2,1)
          imap = 3
      elseif (Layer == 3) then
          stepx = assex / float(ngridCont(1))
          stepy = assey / float(ngridCont(2))
          stepz = 1.0 / float(ngridCont(3))
          iix = int(  0.5 + assex / stepx )
          iiy = int(  0.5 + assey / stepy )
          ii = int( xyzlimCont(1,1) / stepx )
          ax = float(ii) * stepx
          ii = int( xyzlimCont(1,2) / stepy )
          ay = float(ii) * stepy
          limits(1,1) = xyzlimCont(1,1)
          limits(1,2) = xyzlimCont(2,1)
          limits(2,1) = xyzlimCont(1,2)
          limits(2,2) = xyzlimCont(2,2)
          imap = 1
      endif
!
      ngrid2(1) = iix + 1
      ngrid2(2) = iiy + 1
!
      ilb = 1  !            ( 1,dimensione(dmap) )
      iub = ngrid2(1)
      jlb = 1
      jub = ngrid2(2)

      IF (.NOT. ALLOCATED(dmap)) then
          ALLOCATE (dmap(ilb:iub,jlb:jub), stat = ier)
      endif
      do i=1,ngrid2(1)
         xvet(i) = ax
         ax = ax + stepx
      enddo

      do i=1,ngrid2(2)
         yvet(i) = ay
         ay = ay + stepy
      enddo
!
      if (sezione0 <= sezioneN) then
          sezioni = sezioneN - sezione0 + 1
      else
          sezioni = (sezioneN+np(Layer)) - sezione0 + 1
      endif
      ier = 0
      do k=1,sezioni
         sezione = mod(sezione0+k-1,np(Layer))
         ksezione = sezione + 1
         call Load_Section(RhoNew, ngridCont, imap, ksezione,
     *                     limits, ngrid2, dmap)
         iniz = nPuntiCont + 1
         call PrintMess('Computing iso-lines ...')
         call Calculate_Contour2D(dmap,ilb,iub,jlb,jub,xvet,yvet,
     *         SoglieCont,nLev,nPuntiCont,xyz_tria,Max_Points,ier)
         ifin = nPuntiCont
         zeta = stepz * float(sezione)
         xyz_tria(4,iniz:ifin) = xyz_tria(3,iniz:ifin)
         if (Layer == 1) then
             xyz_tria(3,iniz:ifin) = xyz_tria(2,iniz:ifin)
             xyz_tria(2,iniz:ifin) = xyz_tria(1,iniz:ifin)
             xyz_tria(1,iniz:ifin) = zeta
         elseif (Layer == 2) then
             xyz_tria(3,iniz:ifin) = xyz_tria(1,iniz:ifin)
             xyz_tria(1,iniz:ifin) = xyz_tria(2,iniz:ifin)
             xyz_tria(2,iniz:ifin) = zeta
         elseif (Layer == 3) then
             xyz_tria(3,iniz:ifin) = zeta
         endif
         if (ier < 0) then
             Msg = 'Too many points: reduce limits !!!'
             call MsgWinErr('Warning', Msg, WARN_WINDOW, nExitCode)
             exit
         endif
      enddo
!
      IF (ALLOCATED(dmap))
     *    DEALLOCATE (dmap, stat = ier)
!
      call AddCellContour
!
      call TrasformaContour()
!
      if (ifOriented == 0) then
!	ifOriented = 1

      Layer3 = Layer + 3
      ifDrawContour = 0
      call ChePiano (Layer3)
      ifDrawContour = 1
      call RotMap(BTot)             !pg
!
!pieropg      Layer3 = Layer + 3
!pieropg      call ChePiano (Layer3)
!
      call SetScaleMap()

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine SovrapponiAtomi()
      USE General
      USE Molcom
      USE Contorno
!
      DeltX = xyz(1, NatMol + 4) - xyz_tria(1, NpuntiCont + 4)
      DeltY = xyz(2, NatMol + 4) - xyz_tria(2, NpuntiCont + 4)
      DeltZ = xyz(3, NatMol + 4) - xyz_tria(3, NpuntiCont + 4)
!
      do JAT = 1 , NatMol + NatSpi
         xyz(1,JAT) = xyz(1,JAT) - DeltX
         xyz(2,JAT) = xyz(2,JAT) - DeltY
         xyz(3,JAT) = xyz(3,JAT) - DeltZ
      enddo
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AddCellContour
      USE General
      USE Atomi
      USE Contorno
      USE Molcom
!
!                        3       [9]         7
!                       ......................
!                      .|                    .     
!                     . |                   ..     
!                 [8].  |                  . .     
!                   .   |[7]          [12].  .     
!                  .    |                .   .[6]  
!                 .     |    [11]       .    .     
!               6.......................8    .     
!                .      |              .     .     
!                .      |4       [4]   .     .     
!                .      +--------------.------ 2
!                .     /               .     .
!            [3] .    /            [10].    .
!                .   /                 .   .
!                .  / [1]              .  . [5]
!                . /                   . .
!                ./        [2]         ..
!                /......................
!               1                      5
!
!
      real CellEdges(2,3)
!
      call BuildBox
!
!  numCell(3,2)
      do i=1,3
         CellEdges (1,i) = numCell(i,2)
         CellEdges (2,i) = CellEdges (1,i) + numCell(i,1)
      enddo
!
      k = nPuntiCont
      xyz_tria(1, k + 1) = 1
      xyz_tria(2, k + 1) = 0
      xyz_tria(3, k + 1) = 0

      xyz_tria(1, k + 2) = 0
      xyz_tria(2, k + 2) = 1
      xyz_tria(3, k + 2) = 0

      xyz_tria(1, k + 3) = 0
      xyz_tria(2, k + 3) = 0
      xyz_tria(3, k + 3) = 1

      xyz_tria(1, k + 4) = 0
      xyz_tria(2, k + 4) = 0
      xyz_tria(3, k + 4) = 0

      xyz_tria(1, k + 5) = 1
      xyz_tria(2, k + 5) = 1
      xyz_tria(3, k + 5) = 0

      xyz_tria(1, k + 6) = 1
      xyz_tria(2, k + 6) = 0
      xyz_tria(3, k + 6) = 1

      xyz_tria(1, k + 7) = 0
      xyz_tria(2, k + 7) = 1
      xyz_tria(3, k + 7) = 1

      xyz_tria(1, k + 8) = 1
      xyz_tria(2, k + 8) = 1
      xyz_tria(3, k + 8) = 1
!
      kSpiCont( 1,1) = k + 1
      kSpiCont( 1,2) = k + 4
      kSpiCont( 2,1) = k + 1
      kSpiCont( 2,2) = k + 5
      kSpiCont( 3,1) = k + 1
      kSpiCont( 3,2) = k + 6
      kSpiCont( 4,1) = k + 2
      kSpiCont( 4,2) = k + 4
      kSpiCont( 5,1) = k + 2
      kSpiCont( 5,2) = k + 5
      kSpiCont( 6,1) = k + 2
      kSpiCont( 6,2) = k + 7
      kSpiCont( 7,1) = k + 3
      kSpiCont( 7,2) = k + 4
      kSpiCont( 8,1) = k + 3
      kSpiCont( 8,2) = k + 6
      kSpiCont( 9,1) = k + 3
      kSpiCont( 9,2) = k + 7
      kSpiCont(10,1) = k + 8
      kSpiCont(10,2) = k + 5
      kSpiCont(11,1) = k + 8
      kSpiCont(11,2) = k + 6
      kSpiCont(12,1) = k + 8
      kSpiCont(12,2) = k + 7
!
      n12 = 12
      n8 = k + 8
      do j=1,3
         jj1 = mod(j, 3) + 1
         jj2 = mod(j+1, 3) + 1
         jj3 = mod(4-j, 3) + 5
         if (xyzlimCont(1,j).lt.0.0) then
             xyz_tria(j,n8+1) = CellEdges(1,j)
             xyz_tria(j,n8+2) = CellEdges(1,j)
             xyz_tria(jj1,n8+1) = 0
             xyz_tria(jj1,n8+2) = 0
             xyz_tria(jj2,n8+1) = 0
             xyz_tria(jj2,n8+2) = 1
             kSpiCont(n12+1,1) = n8 + 1
             kSpiCont(n12+1,2) = k + 4
             kSpiCont(n12+2,1) = n8 + 2
             kSpiCont(n12+2,2) = k + jj2
             n8 = n8 + 2
             n12 = n12 + 2
             xyz_tria(j,n8+1) = CellEdges(1,j)
             xyz_tria(j,n8+2) = CellEdges(1,j)
             xyz_tria(jj1,n8+1) = 1
             xyz_tria(jj1,n8+2) = 1
             xyz_tria(jj2,n8+1) = 0
             xyz_tria(jj2,n8+2) = 1
             kSpiCont(n12+1,1) = n8 + 1
             kSpiCont(n12+1,2) = k + jj1
             kSpiCont(n12+2,1) = n8 + 2
             kSpiCont(n12+2,2) = k + 8 - j
             n8 = n8 + 2
             n12 = n12 + 2
         endif
         if (xyzlimCont(2,j).gt.1.0) then
             xyz_tria(j,n8+1) = CellEdges(2,j)
             xyz_tria(j,n8+2) = CellEdges(2,j)
             xyz_tria(jj1,n8+1) = 0
             xyz_tria(jj1,n8+2) = 0
             xyz_tria(jj2,n8+1) = 0
             xyz_tria(jj2,n8+2) = 1
             kSpiCont(n12+1,1) = n8 + 1
             kSpiCont(n12+1,2) = k + j
             kSpiCont(n12+2,1) = n8 + 2
             kSpiCont(n12+2,2) = k + 2 + jj2 + j
             n8 = n8 + 2
             n12 = n12 + 2
             xyz_tria(j,n8+1) = CellEdges(2,j)
             xyz_tria(j,n8+2) = CellEdges(2,j)
             xyz_tria(jj1,n8+1) = 1
             xyz_tria(jj1,n8+2) = 1
             xyz_tria(jj2,n8+1) = 0
             xyz_tria(jj2,n8+2) = 1
             kSpiCont(n12+1,1) = n8 + 1
             kSpiCont(n12+1,2) = k + jj3
             kSpiCont(n12+2,1) = n8 + 2
             kSpiCont(n12+2,2) = k + 8
             n8 = n8 + 2
             n12 = n12 + 2
         endif
      enddo
      morePoints = n8 - nPuntiCont
      moreLines  = n12 - 12
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DrawGrid()
      USE General
      USE Contorno
      USE Molcom
!
      integer lati(4)
!
      select case(Layer)
         case (1)
            lati(1)=4
            lati(2)=9
            lati(3)=7
            lati(4)=6
         case (2)
            lati(1)=1
            lati(2)=8
            lati(3)=7
            lati(4)=3
         case (3)
            lati(1)=1
            lati(2)=5
            lati(3)=4
            lati(4)=2
      end select
      iColoB = color_WHITE

      do k=0,1
         j=1+2*k
         N1 = kSpiCont(lati(j),1)
         N2 = kSpiCont(lati(j),2)
         N3 = kSpiCont(lati(j+1),1)
         N4 = kSpiCont(lati(j+1),2)
         x0 = xyz_tria(1,N1)
         y0 = xyz_tria(2,N1)
         x1 = xyz_tria(1,N2)
         y1 = xyz_tria(2,N2)
         x2 = xyz_tria(1,N3)
         y2 = xyz_tria(2,N3)
         x3 = xyz_tria(1,N4)
         y3 = xyz_tria(2,N4)

         dist = sqrt( (x1-x0)**2 ) / 10.0
         if (dist > 1.e-6) then
             emme = (y1-y0) / (x1-x0)
             if (x0 < x1) then
                 xp = x0
                 yp = y0
             else
                 xp = x1
                 yp = y1
             endif
             if (x2 < x3) then
                 xp1 = x2
                 yp1 = y2
             else
                 xp1 = x3
                 yp1 = y3
             endif
         else
             stepy = sqrt( (y1-y0)**2 ) / 10.0
             if (y0 < y1) then
                 xp = x0
                 yp = y0
             else
                 xp = x1
                 yp = y1
             endif
             if (y2 < y3) then
                 xp1 = x2
                 yp1 = y2
             else
                 xp1 = x3
                 yp1 = y3
             endif
         endif
         do ix=1,9
            x = ix
            if (dist > 1.e-6) then
                xn = xp + dist * x
                yn = emme * (xn-xp) +yp
            else
                xn = xp
                yn = stepy*x + yp
            endif
            a = ( xn + x11disp(1) ) * x11scale(1)
            b = ( yn + x11disp(2) ) * x11scale(2)
            ix1 = nint(a)
            iy1 = iVP(4) - nint(b)
            if (dist > 1.e-6) then
                xn1 = xp1 + dist * x
                yn1 = emme * (xn1-xp1) + yp1
            else
                xn1 = xp1
                yn1 = stepy*x + yp1 
            endif
            a = ( xn1 + x11disp(1) ) * x11scale(1)
            b = ( yn1 + x11disp(2) ) * x11scale(2)
            ix2 = nint(a)
            iy2 = iVP(4) - nint(b)
            call Linea_dash(ix1, iy1, ix2, iy2, iColoB)
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CalcolaCerchio(k, ill, xn, yn)
      USE General
      USE Molcom
!
      character*2 campo
!
      a = ( xn + x11disp(1) ) * x11scale(1)
      b = ( yn + x11disp(2) ) * x11scale(2)
      ix1 = nint(a)
      iy1 = iVP(4) - nint(b)
      iRad = 10
      iColor = color_WHITE
      IfFill = -1
      iFillColor = color_BLACK
      call Cerchio (ix1, iy1, iRad, iColor, IfFill, iFillColor)
      write(campo,'(i2)') ill
      if (k /= 0) then
          call DrawLabel (ix1+2*iRad, iy1, campo, iColor, 2)
      else
          call DrawLabel (ix1-2*iRad, iy1, campo, iColor, 2)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CalcolaCerchioAbs(ix1, iy1)
      USE General
      USE Molcom
!
      iRad = 10
      iColor = color_WHITE
      IfFill = -1
      iFillColor = color_BLACK
      call Cerchio (ix1, iy1, iRad, iColor, IfFill, iFillColor)
      call zflush
!
      return
      end
!-----------------------------------------------------------------------
      subroutine FindMinMaxCont()
      USE General
      USE Contorno
      USE Molcom
!
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      do i = 1 , nPuntiCont + 8
         if (xyz_tria(1,i) .LT. Rmin1) Rmin1 = xyz_tria(1,i)
         if (xyz_tria(1,i) .GT. RMAX1) RMAX1 = xyz_tria(1,i)
         if (xyz_tria(2,i) .LT. Rmin2) Rmin2 = xyz_tria(2,i)
         if (xyz_tria(2,i) .GT. RMAX2) RMAX2 = xyz_tria(2,i)
      enddo
      DeltX = (Rmin1 + RMAX1) / 2
      DeltY = (Rmin2 + RMAX2) / 2
      do i = 1 , nPuntiCont + morePoints !8
         xyz_tria(1,i) = xyz_tria(1,i) - DeltX
         xyz_tria(2,i) = xyz_tria(2,i) - DeltY
      enddo
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      do i = 1 , nPuntiCont + 8
         if (xyz_tria(1,i) .LT. Rmin1) then
            Rmin1 = xyz_tria(1,i)
         end if
         if (xyz_tria(1,i) .GT. RMAX1) then
            RMAX1 = xyz_tria(1,i)
         end if
         if (xyz_tria(2,i) .LT. Rmin2) then
            Rmin2 = xyz_tria(2,i)
         end if
         if (xyz_tria(2,i) .GT. RMAX2) then
            RMAX2 = xyz_tria(2,i)
         end if
      enddo
!
      return
      end
! -----------------------------------------------------------------
      subroutine finish_limits()
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Mappa
      USE MappaCont
      USE Iso_Surfaces
      USE PhaseModule
!
!-- WhichLimit = 1 Asymmetric unit
!              = 2 Complete unit cell
!              = 3 Box around model
!              = 4 User defined box
!-- WhichRes   = 1 Low Resolution
!              = 2 Standard Resolution
!              = 3 High Resolution
!
!
      if (WhichLimit == 1) then
          do i=1,3
             xyzlimCont(1,i) = xyzfou(i,1) / xyzfou(i,4)
             xyzlimCont(2,i) = xyzfou(i,2) / xyzfou(i,4)
             deltaCont(i)  = xyzlimCont(2,i) - xyzlimCont(1,i)
             centerCont(i) = xyzlimCont(1,i) + deltaCont(i) / 2.0
          enddo
      elseif (WhichLimit == 2) then
!  numCell(3,2)
          do i=1,3
             delta = 0.5 /cell(i)
             xyzlimCont(1,i) = numCell(i,2)
             xyzlimCont(2,i) = xyzlimCont(1,i) + numCell(i,1)
             deltaCont(i)  = xyzlimCont(2,i) - xyzlimCont(1,i)
             centerCont(i) = xyzlimCont(1,i) + deltaCont(i) / 2.0
          enddo
      elseif (WhichLimit == 3) then
          if (nats > 0) then
              do i=1,3
                 delta = 0.5 /cell(i)
                 xyzlimCont(1,i) = minval(xyzs(i,1:nats)) - delta
                 xyzlimCont(2,i) = maxval(xyzs(i,1:nats)) + delta
                 deltaCont(i)  = xyzlimCont(2,i) - xyzlimCont(1,i)
                 centerCont(i) = xyzlimCont(1,i) + deltaCont(i) / 2.0
              enddo
          else
              Msg = 'No atoms stored'
              call MsgWinErr('Warning', Msg, WARN_WINDOW, nExitCode)
          endif
      elseif (WhichLimit == 4) then
          do i=1,3
             deltaFract = 0.5 * deltaCont(i) / cell(i) 
             xyzlimCont(1,i) = centerCont(i) - deltaFract
             xyzlimCont(2,i) = centerCont(i) + deltaFract
             deltaCont(i)  = xyzlimCont(2,i) - xyzlimCont(1,i)
          enddo
      elseif (WhichLimit == 0) then
          write(0,*) 'Non dovevo essere qui(WhicLimit = 0)'
      endif
!
      RhoNew=xmap
      call PreparaContour
      call zflush
!
      return
      end
! -----------------------------------------------------------------
      subroutine BuildBox
      USE Contorno
      USE Molcom
!
!             1-5 ---------- 2-6
!              |              |       (1-2-3-4) z(c) + 
!              |       C      |       (5-6-7-8) z(c) - 
!              |              |
!             4-8 ---------- 3-7
!
!
      moreBox = 8
!
      k = nPuntiCont 
      xyz_tria(1,k+1) = centerCont(1) - deltaCont(1) / 2.0
      xyz_tria(1,k+2) = centerCont(1) + deltaCont(1) / 2.0
      xyz_tria(1,k+3) = centerCont(1) + deltaCont(1) / 2.0
      xyz_tria(1,k+4) = centerCont(1) - deltaCont(1) / 2.0
      xyz_tria(1,k+5) = centerCont(1) - deltaCont(1) / 2.0
      xyz_tria(1,k+6) = centerCont(1) + deltaCont(1) / 2.0
      xyz_tria(1,k+7) = centerCont(1) + deltaCont(1) / 2.0
      xyz_tria(1,k+8) = centerCont(1) - deltaCont(1) / 2.0
!
      xyz_tria(2,k+1) = centerCont(2) - deltaCont(2) / 2.0
      xyz_tria(2,k+2) = centerCont(2) - deltaCont(2) / 2.0
      xyz_tria(2,k+3) = centerCont(2) + deltaCont(2) / 2.0
      xyz_tria(2,k+4) = centerCont(2) + deltaCont(2) / 2.0
      xyz_tria(2,k+5) = centerCont(2) - deltaCont(2) / 2.0
      xyz_tria(2,k+6) = centerCont(2) - deltaCont(2) / 2.0
      xyz_tria(2,k+7) = centerCont(2) + deltaCont(2) / 2.0
      xyz_tria(2,k+8) = centerCont(2) + deltaCont(2) / 2.0
!
      xyz_tria(3,k+1) = centerCont(3) + deltaCont(3) / 2.0
      xyz_tria(3,k+2) = centerCont(3) + deltaCont(3) / 2.0
      xyz_tria(3,k+3) = centerCont(3) + deltaCont(3) / 2.0
      xyz_tria(3,k+4) = centerCont(3) + deltaCont(3) / 2.0
      xyz_tria(3,k+5) = centerCont(3) - deltaCont(3) / 2.0
      xyz_tria(3,k+6) = centerCont(3) - deltaCont(3) / 2.0
      xyz_tria(3,k+7) = centerCont(3) - deltaCont(3) / 2.0
      xyz_tria(3,k+8) = centerCont(3) - deltaCont(3) / 2.0
!
      ContBox(1:3,1) = xyz_tria(1:3,k+1)
      ContBox(1:3,2) = xyz_tria(1:3,k+7)
!
!
!             1-5 ---------- 2-6
!              |              |       (1-2-3-4) z(c) + 
!              |       C      |       (5-6-7-8) z(c) - 
!              |              |
!             4-8 ---------- 3-7
      lineBox( 1,1) = k+1
      lineBox( 1,2) = k+2
      lineBox( 2,1) = k+2
      lineBox( 2,2) = k+3
      lineBox( 3,1) = k+3
      lineBox( 3,2) = k+4
      lineBox( 4,1) = k+4
      lineBox( 4,2) = k+1
!
      lineBox( 5,1) = k+5
      lineBox( 5,2) = k+6
      lineBox( 6,1) = k+6
      lineBox( 6,2) = k+7
      lineBox( 7,1) = k+7
      lineBox( 7,2) = k+8
      lineBox( 8,1) = k+8
      lineBox( 8,2) = k+5
!             1-5 ---------- 2-6
!              |              |       (1-2-3-4) z(c) + 
!              |       C      |       (5-6-7-8) z(c) - 
!              |              |
!             4-8 ---------- 3-7
!
      lineBox( 9,1) = k+1
      lineBox( 9,2) = k+5
      lineBox(10,1) = k+2
      lineBox(10,2) = k+6
      lineBox(11,1) = k+3
      lineBox(11,2) = k+7
      lineBox(12,1) = k+4
      lineBox(12,2) = k+8
      nPuntiCont = nPuntiCont + moreBox
!
      return
      end
! -----------------------------------------------------------------
      subroutine DrawBox(iColor)
      USE Contorno
      USE Molcom
!
!             1-5 ---------- 2-6
!              |              |       (1-2-3-4) z(c) + 
!              |       C      |       (5-6-7-8) z(c) - 
!              |              |
!             4-8 ---------- 3-7
!
!
      do i=1,12
         i1 = lineBox(i,1) 
         i2 = lineBox(i,2) 
         x1 = xyz_tria(1,i1)
         y1 = xyz_tria(2,i1)
         x2 = xyz_tria(1,i2)
         y2 = xyz_tria(2,i2)
         call Linea0(x1, y1, x2, y2, iColor)
      enddo
!
      return
      end
! -----------------------------------------------------------------
!pg
      subroutine RotMap(B)
      USE Contorno
      USE Molcom
!
      dimension q(3), P(3), B(3, 3)
!
          do JAT = 1 , nPuntiCont + morePoints
             q(1) = xyz_tria(1,JAT)
             q(2) = xyz_tria(2,JAT)
             q(3) = xyz_tria(3,JAT)
             do i = 1 , 3
                P(i) = 0
                do j = 1 , 3
                   P(i) = P(i) + B(i, j) * q(j)
                enddo
             enddo
             xyz_tria(1,JAT) = P(1)
             xyz_tria(2,JAT) = P(2)
             xyz_tria(3,JAT) = P(3)
          enddo

      return
      end
!pg
!-----------------------------------------------------------------
      subroutine SelectAtoms()
      USE General
      USE Atomi
      USE Molcom
      USE Mappa
      USE Contorno
      USE Poliedri
      USE PhaseModule
!
      dimension xo(3),xn(3)
!
!-- show all
!
      do i = 1 , NatMol
         if (RS(i) .gt. -10.) then
             RS(i) = abs(RS(i))
         end if
      enddo
!
      if (ifModel /= 0) then
          if (WhichLimit == 3) then
              do i = nats + 1 , NatMol
                 if (RS(i) .gt. -10.) then
                     RS(i) = -abs(RS(i))
                 endif
              enddo
          endif
      endif
!
!-- Compute limits of the wafer (top-bottom)
!

      step = cell(Layer) / float( np(Layer) )
      step = 1.0 / float( np(Layer) )
      bot0 = xyz_tria(Layer,nPuntiCont + 4)
      bot0 = 0
!
!-- Hide all atoms external to the interval top-bottom
!
      sez0 = sezione0
      sezN = sezioneN
      if (sezione0 == sezioneN) then
          top = step * sez0 + bot0 + step / 2.0
          bot = step * sez0 + bot0 - step / 2.0
      else
          top = step * sezN + bot0 + step / 2.0
          bot = step * sez0 + bot0 - step / 2.0
      endif
      if (bot.lt.top) then
          do i = 1 , NatMol
             if (RS(i) .gt. -10.) then
                 xo(1:3) = xyzs(1:3,iEqui(i))
c                 call xequi(xo,nOpEq(i)/10000,1.0,xn,1)
                 js=nOpEq(i)/1000
                 ieqX=-1
                 call xequiTot(js, xo, xn,ieqX)
c                 if(ieqX.eq.1) cycle
                 if (xn(Layer).gt.1.0) xn(Layer) = xn(Layer) - 1.0
                 if (xn(Layer).lt.0.0) xn(Layer) = xn(Layer) + 1.0
                 if ((xn(Layer) > top).or.
     *               (xn(Layer) < bot)) then
                     RS(i) = -abs(RS(i))
                 endif
             endif
          enddo
      else
          com = bot
          bot = top
          top = com
          do i = 1 , NatMol
             if (RS(i) .gt. -10.) then
                 xo(1:3) = xyzs(1:3,iEqui(i))
c                 call xequi(xo,nOpEq(i)/10000,1.0,xn,1)
                 js=nOpEq(i)/1000
                 ieqX=-1
                 call xequiTot(js, xo, xn,ieqX)
c                 if(ieqX.eq.1) cycle
                 if ((xn(Layer) > top).or.
     *               (xn(Layer) < bot)) then
                     RS(i) = -abs(RS(i))
                 endif
             endif
          enddo
      endif
      if (WhichLimit /= 3) then
!
!-- Hide all atoms outside limits
!
! calcoliamo le coordinate dei vertici della scatola (frazionarie)
! le ortonormalizziamo e applichiamo la rotaztot
! li trattiamo come atomi e - in prima approssimazione li disegnamo
! con una routine a parte e poi passiamo a nascondere gli atomi 
!      
      k = nPuntiCont - moreBox
!             1-5 ---------- 2-6
!              |              |       (1-2-3-4) z(c) + 
!              |       C      |       (5-6-7-8) z(c) - 
!              |              |
!             4-8 ---------- 3-7
          x1 = xyz_tria(1,k+1) 
          x2 = xyz_tria(1,k+7)
          y1 = xyz_tria(2,k+1) 
          y2 = xyz_tria(2,k+7)
          z1 = xyz_tria(3,k+1) 
          z2 = xyz_tria(3,k+7)
!
          x1 = ContBox(1,1)
          y1 = ContBox(2,1)
          z1 = ContBox(3,1)
          x2 = ContBox(1,2)
          y2 = ContBox(2,2)
          z2 = ContBox(3,2)
!
          if (x1 > x2) then
              a  = x1
              x1 = x2
              x2 = a
          endif
          if (y1 > y2) then
              a  = y1
              y1 = y2
              y2 = a
          endif
          if (z1 > z2) then
              a  = z1
              z1 = z2
              z2 = a
          endif
          do i = 1 , NatMol
             if (RS(i) .gt. -10.) then
                 if (xyzTot(1,i) < x1 .or. xyzTot(1,i) > x2 .or.
     *               xyzTot(2,i) < y1 .or. xyzTot(2,i) > y2 .or.
     *               xyzTot(3,i) < z1 .or. xyzTot(3,i) > z2) then
                     RS(i) = -abs(RS(i))
                 end if
             end if
          enddo
      endif
      iColor = color_GREEN
      call DrawBox(iColor)
!
      return
      end
!-----------------------------------------------------------------
      subroutine DummyAtoms
      USE General
      USE Atomi
      USE Molcom
!
      dimension x1(3), x2(3), xv(5,8)
!
      InfoOK(15) = 1
      nMaxLeg = 9800
      do i=1,3
         do j=1,3
            BTot(i,j) = 0
         enddo
         BTot(i,i) = 1
      enddo
!
      xv(1, 1) = 1
      xv(2, 1) = 0
      xv(3, 1) = 0
      xv(1, 2) = 0
      xv(2, 2) = 1
      xv(3, 2) = 0
      xv(1, 3) = 0
      xv(2, 3) = 0
      xv(3, 3) = 1
      xv(1, 4) = 0
      xv(2, 4) = 0
      xv(3, 4) = 0
      xv(1, 5) = 1
      xv(2, 5) = 1
      xv(3, 5) = 0
      xv(1, 6) = 1
      xv(2, 6) = 0
      xv(3, 6) = 1
      xv(1, 7) = 0
      xv(2, 7) = 1
      xv(3, 7) = 1
      xv(1, 8) = 1
      xv(2, 8) = 1
      xv(3, 8) = 1
      do i = 1, 8
         iOrd(i) = i
         Lab(i) = ' '
         iCol(i) = color_CELL
         RS(i) = 0.01
         do j = 1, 3
            x1(j) = xv(j, i)
         enddo
         call MoltMatVec(rm,x1,x2)
         xyz(1,i) = x2(1)
         xyz(2,i) = x2(2)
         xyz(3,i) = x2(3)
      enddo
      NatMol = 8
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiSkeleton(iAction)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE Dialogo, only: ifPDBcoded
!
      integer iLabel(4)
      real, allocatable :: store(:)
!
!-- check if residues are stored in List 5 (ifPDBcoded)
!-- if yes:
!--     read c-alpha position
!--     consider these position as skeleton
!--     read hetam positions
!--     consider these positions as atoms
!--     compute connectivity for both groups
!
      
      ifQuit = 1
      if (jscreen == 0) then
          return
      endif
      if (iAction == 1) then
          lfw = InfoOK(5)
          if (lfw > 0) then
              call GetModel
              if (ifPDBcoded == 1) then
!          write(0,*) 'ifPDBcoded',ifPDBcoded
                  ifQuit = 0
              endif
          endif
          if (ifQuit == 1) then
              return
          endif
      endif
      if (ifSkeletonOn == 1) then
          ifSkeletonOn = 0
          call GetModel
          call InitMolplo()
          QualeAbilita = 2
          BTot(1,1) = 101
          interp = 1
          call PutGetXyzs(1, interp)
          ifSkeleton = 0
          nSkel = 0
          ifSingle = 0
          kplot    = 0
          call MolPlo(kplot, ifSingle)
          return
      endif
      ifSkeletonOn = 1

      if (.not.Allocated(xyzs)) then
          call AllocaAtomi(1)
          call InitMolplo()
          QualeAbilita = 2
      endif
      ier = 0
      if (iAction == 1) then
          call LeggiCalpha()
      endif
!
      NumLeg = iconnSk(1)

      L = nats * 7 + (NumLeg+1)*3
      allocate(store(1:L), stat=ier)


      natsSav = nats
      k = 0
      do i=1,nats
         do j=1,5
            k = k + 1
            store(k) = xyzSk(j,i)
         enddo
         store(k+1) = bfac(i)
         store(k+2) = serial(i)
         store(k+3) = nz(i)
         read(aLab(i),'(4a4)') iLabel(1:4)
         store(k+4) = iLabel(1)
         store(k+5) = iLabel(2)
         store(k+6) = iLabel(3)
         store(k+7) = iLabel(4)
         k = k + 7
      enddo
      do i=1,NumLeg * 3 + 1
         k = k + 1
         store(k) = iconnSk(i)
      enddo
!     call AllocaAtomi(2)
!
      nats = natsSav
!     call AllocaAtomi(-1)
      k = 0
      do i=1,nats
         do j=1,5
            k = k + 1
            xyzSk(j,i) = store(k) 
         enddo
         bfac(i) = store(k+1) 
         serial(i) = nint(store(k+2))
         nz(i)     = nint(store(k+3))
         iLabel(1) = nint(store(k+4))
         iLabel(2) = nint(store(k+5))
         iLabel(3) = nint(store(k+6))
         iLabel(4) = nint(store(k+7))
         write(aLab(i),'(4a4)') iLabel(1:4)
         k = k + 7
      enddo
      do i=1,NumLeg * 3 + 1
         k = k + 1
         iconnSk(i) = store(k) 
      enddo

      deallocate(store, stat=ier)

!
!      do i=1, nats
!         xyzs(1:3,i) = xyzSk(1:3,i)
!         xyzs(4,i) = 100
!         xyzs(5,i) = 1.0
!         bfac(i) = 3.0
!         nz(i) = nzConst
!         SinglePlotType(i) = STICKS
!      enddo
      iPlotType  = STICKS
      k = NumLeg * 3 + 1
!      iconn(1:k) = iconnSk(1:k)
      iC = 1
      do i=1, nk
         if (Species(i) == 'C ') then
             iC = i
             exit
         endif
      enddo
      natsOnly = nats - nSkel
      ifSkeleton = nats
      do i=1, nats
         xyzs(1:5,i) = xyzSk(1:5,i)
         if (i > natsOnly) then
             nz(i) = iC * nzConst
             SinglePlotType(i) = STICKS
         endif
      enddo
      nleg = iconnSk(1)
      k = nleg * 3 + 1
      iconn(1:k) = iconnSk(1:k)
      BTot(1,1) = 101
      interp = 1
      call PutGetXyzs(1, interp)
!
      ifSingle = 0
      kplot    = 0
      call MolPlo(kplot, ifSingle)

      return
      end
!-----------------------------------------------------------------------
      subroutine AutoCalcAngle(n1,n2,n3,Ang)
      USE Molcom
!
      integer   :: n1, n2, n3
      real      :: Ang
!
      nptr = 3
      kptr(1) = n1
      kptr(2) = n2
      kptr(3) = n3

      call CalcAngle(0, Ang)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiCalpha()
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE RemoModule
!
      real x1(3), x2(3), distBackBone(2)
      character AtName*4, tipo(2)*8, str*16
      integer hetam
!
      nCatene = 0
      distBackBone(1) = 4.0
      distBackBone(2) = 7.5
      iOrd(:) = 0   ! iOrd(i) = 1 -> CA;  iOrd(i) = 2 -> P
      tipo(1) = '  ATOM  '
      tipo(2) = '  HETATM'
      nSkel = 0
      nats  = 0
      m5 = l5
!
      iconn(1) = 0
!
!-- delete atoms connectivity and consider only 
!-- c-alpha connectivity  (gianluca 28/01/2008)
!
      iconn(1) = 0
!
      m5 = l5
      do i=1, natsInModel(WhichModel)
         AtName = model(WhichModel)%tipoAtomo(i,1)
         call ucase(AtName)
*        if (hetam == 0) then
             if (AtName(1:3) == 'CA ' .or. AtName(1:3) == 'P  ') then
                 nSkel = nSkel + 1
                 xyzSk(1:5,nSkel) = model(WhichModel)%atoms(1:5,i,1)
                 bfac(nSkel)      = model(WhichModel)%th_fact(i,1)
                 aLab(nSkel)=model(WhichModel)%Label(i)
                 if (AtName(1:3) == 'CA ') then
                     iOrd(nSkel) = 1
                 else
                     iOrd(nSkel) = 2
                 endif
!
                 nzTot(nSkel) = iOrd(nSkel)    ! gianluca 11/03/2009
!
!            write(88,*) i,tipo(hetam+1),AtName,nSkel,' ',aLab(nSkel)
*            endif
         endif
         if (nzSav(i) == 1) then
             nats = nats + 1
             serial(nats) =  model(WhichModel)%serial(i)
             nzSav(i) = nats
             ispec  = model(WhichModel)%specie(i,1)
             if (ispec  /= 0) then
                 do j=1,nk
                    if (ispec.eq.nalf(j)) then
                        itipo = j
                        nz(nats) = itipo * nzConst
                    endif
                 enddo
             else
                 nz(nats) = 9 * nzConst
             endif
             xyzs(1:5,nats) =  model(WhichModel)%atoms(1:5,i,1)
!
             bfac(nats) = model(WhichModel)%th_fact(i,1)
!
             isn = model(WhichModel)%serial(i)
             jSingleColor(nats)  = 0
             SinglePlotType(nats)=iPlotType
!
             aLab(nats)=model(WhichModel)%Label(i)
!            write(88,*) i,tipo(hetam+1),AtName,nats,' ',aLab(nats)
!
             IsoAniso(nats) = 2
             if (model(WhichModel)%bij(1,i,1).gt.0.000001) then
                 IsoAniso(nats) = 1
!--i termini fuori diagonale andrebbero divisi per 2.0, ma questo viene fatto
!  nella routine toMolPlo3(leggi) in molplocomune.f 
                 Ell(1,1,nats) = model(WhichModel)%bij(1,i,1)
                 Ell(1,2,nats) = model(WhichModel)%bij(2,i,1)  
                 Ell(2,1,nats) = model(WhichModel)%bij(2,i,1)  
                 Ell(1,3,nats) = model(WhichModel)%bij(3,i,1) 
                 Ell(3,1,nats) = model(WhichModel)%bij(3,i,1)  
                 Ell(2,2,nats) = model(WhichModel)%bij(4,i,1)
                 Ell(2,3,nats) = model(WhichModel)%bij(5,i,1)  
                 Ell(3,2,nats) = model(WhichModel)%bij(5,i,1) 
                 Ell(3,3,nats) = model(WhichModel)%bij(6,i,1)
!
!-- salvo b(ij)
!
                 bfac(nats) = model(WhichModel)%th_fact(i,1)
            endif
         endif
!
      enddo
!
!-- Update connectivity codes
!
      j = 1
      nleg = iconn(1)
      do i=1, nleg
!         write(88,*) i, iconn(j+1),iconn(j+2)
         iconn(j+1) = nzSav(iconn(j+1))
         iconn(j+2) = nzSav(iconn(j+2))
!        write(88,*) i, iconn(j+1),iconn(j+2)
         j = j + 3
      enddo
!
!-- Merge atoms & C-Alpha chain
!
      do i=1, nSkel
         xyzs(1:5,nats+i) =  xyzSk(1:5,i)
      end do
!
!-- C-Alpha connectivity
!
      do i=nats+1, nats+nSkel
         x1(1:3)=xyzs(1:3,i)
         call MoltMatVec(rm, x1, x2)
         xyz(1:3,i) = x2(1:3)
      end do
      iconnSk(:) = iconn(:)
      nleg = iconnSk(1)
      k = nleg * 3 + 1
      kk = 0
      do i=nats+1, nats+nSkel-1
         if (iOrd(i) /= iOrd(i+1)) cycle
         kk = kk + 1
         dist = 0.0
         do j=1,3
            dist = dist + (xyz(j,i)-xyz(j,i+1))**2
         end do
         dist = sqrt(dist)
         j = iOrd(i)
         if (dist < distBackBone(j)) then
             nleg = nleg + 1
             iconnSk(k+1) = i
             iconnSk(k+2) = i+1
             iconnSk(k+3) = 4
             k = k + 3
             if (kk >= 3) then
                 call AutoCalcAngle(i-1,i,i+1,Ang)
**               write(6,*) Ang
             endif
         endif
      enddo
      iconnSk(1) = nleg
      nCatene = 1
      iOK = 1
      ipivot = 1
      do while (iOK == 1)
         do i=1, nleg
            iOK = 0
            ii1 = 1 + (i-1) * 3 + 1
            ii2 = 1 + (i-1) * 3 + 2
            ii3 = 1 + (i-1) * 3 + 3
            i1 = iconnSk(ii1)
            i2 = iconnSk(ii2)
            i3 = iconnSk(ii3)
            if (i3 == 0) cycle
            if (i1 == ipivot .or. i2 == ipivot) then
               iCol(i1) = nCatene + N_OBJS
               iCol(i2) = nCatene + N_OBJS
               iconnSk(ii3) = 0
               iOK = 1
               if (i1 == ipivot) then
                   ipivot = i2
               else
                   ipivot = i1
               endif
               exit
            endif
         enddo
         if (iOK == 0) then
             nCatene = nCatene + 1
             ipivot = ipivot + 1
             if (nCatene >= 26) then
                 nCatene = 1
             endif
         endif
         iOK = 0
         do i=1, nleg
            i3 = 1 + (i-1) * 3 + 3
            i3 = iconnSk(i3)
            if (i3 /= 0) then
                iOK = 1
                exit
            endif
         enddo
      enddo
      do i=1, nleg
         i3 = 1 + (i-1) * 3 + 3
         iconnSk(i3) = 4
      enddo
      nats = nats + nSkel
!     j = 1
!     do i=1, iconnSk(1)
!        write(88,*) i, iconnSk(j+1),iconnSk(j+2)
!        j = j + 3
!     enddo
      do i=1, nats
         xyzSk(1:5,i)=xyzs(1:5,i)
      end do
!
      return
      end
! ----------------------------------------------------------------------
      subroutine DataForGraph(iflagInp,npunti)
      USE General
      USE Molcom
      USE Solutions
      USE TraslaSolution
      USE Riflessi
      USE GrexpoMod
      USE Grafici
      USE MadModule
      USE PhaseModule
      USE RfacMatrixModule
!
      real minx, maxx, miny, maxy
      integer checkColor(100)
      double precision rhoclu
      logical :: noWrite,plusModel
      integer :: ncount, maxcount
      common /util2/ noWrite, ncount, maxcount,plusModel

!per gestire il caso più monomeri per cui i grafici visualizzati sono solo 2        
      numbGR = 3  
      if(plusModel) numbGR = 2

c      checkColor(:)=0.
!
      if (jscreen == 0) return
!
      if (iflagInp <= 0) then
          iflag = iflagInp
      elseif (ifRemo > 0) then
          iflag = iflagInp + 10
      elseif(kmad > 0) then
          iflag = iflagInp + 20
      elseif(ifVLD > 0 .and. ifMDM == 0) then
          iflag = iflagInp + 30
      else
          iflag = iflagInp
      endif
!
      select case (iflag) 
          case (-1)
!
!-- inizializzazioni istogrammi
!
               call ManageGraph(-1, npunti)
!
          case (0)
!
!-- plot everything in any case
!
               call ManageGraph(0, npunti)
!
!========   AB INITIO CASE ========
!
          case (1)
!
               lPlots(1) = lPlots(1) + 1
               xpoints(lPlots(1),1) = RfacMatrix(2,kRfac,jBlock)
               minx = minval(xpoints(1:lPlots(1),1))
               maxx = maxval(xpoints(1:lPlots(1),1))
               i = minx
               minx = i
               i = maxx + 1
               maxx = i
               MinMaxGR(1,1) = minx
               MinMaxGR(2,1) = maxx
               colorGR(1:lPlots(1), 1) = color_LIGHTRED
               call ManageGraph(1, npunti)
!
          case (2)

               lPlots(1) = MaxToStore
               xpoints(1:MaxToStore,1) = 
     *                                 RfacMatrix(2,1:MaxToStore,jBlock)
               minx = minval(xpoints(1:lPlots(1),1))
               maxx = maxval(xpoints(1:lPlots(1),1))
               i = minx
               minx = i
               i = maxx + 1
               maxx = i
               MinMaxGR(1,1) = minx
               MinMaxGR(2,1) = maxx
               colorGR(1:lPlots(1), 1) = color_LIGHTRED
               call ManageGraph(1, npunti)
!
          case (3)
!
               if (ifTang == 1) then ! .or. ifMadEnv > 0) then
                   kk = 2
               else
                   kk = 1
               endif

               if (NewPoint) then
                   lPlots(kk) = lPlots(kk) + 1
                   NewPoint = .false.
               endif
               if (nolsq == 0) then
                   xpoints(lPlots(kk),kk) = RfacMatrix(3,kRfac,jBlock)
               else
                   xpoints(lPlots(kk),kk) = erre * 100
                   ypoints(lPlots(kk),kk) = FinalFom
                   k = nint( ypoints(lPlots(kk),kk) * 100.0)
                   ypoints(lPlots(kk),kk) = float(k) / 100.0
               endif
               minx = minval(xpoints(1:lPlots(kk),kk))
               maxx = maxval(xpoints(1:lPlots(kk),kk))
               if (minx > 0.0) then
                   i = minx
               else
                   i = minx - 1
               endif
               minx = i
               if (maxx > 0.0) then
                   i = maxx + 1
               else
                   i = maxx
               endif
               maxx = i
               MinMaxGR(1,kk) = minx
               MinMaxGR(2,kk) = maxx

               colorGR(1:lPlots(kk), kk) = color_LIGHTRED

               if (nolsq /= 0) then
                   miny = minval(ypoints(1:lPlots(kk),kk))
                   maxy = maxval(ypoints(1:lPlots(kk),kk))
                   miny = miny - 0.05
                   maxy = maxy + 0.05
                   MinMaxGR(3,kk) = miny
                   MinMaxGR(4,kk) = maxy

               endif
               call ManageGraph(kk, npunti)
!
          case (5)

               kLarg = kscrx
               kAlt  = kscry
               call gr_init(1, kLarg, kAlt) 
               call ManageGraph(0, npunti)
!
          case (6)

               npoints = nRfac
               lPlots(1) = npoints
               xpoints(1:npoints, 1) = RfacMatrix(2,1:npoints, 1)
               minx = minval(xpoints(1:lPlots(1),1))
               maxx = maxval(xpoints(1:lPlots(1),1))
               i = minx
               minx = i
               i = maxx + 1
               maxx = i
               MinMaxGR(1,1) = minx
               MinMaxGR(2,1) = maxx
               colorGR(1:lPlots(1), 1) = color_LIGHTRED
!
               k = 0
               do i=1, npoints
                  if (RfacMatrix(4, i, 1) < 100.0) then
                      k = k + 1
                      xpoints(k, 2) = RfacMatrix(4, i, 1)
                      ypoints(k, 2) = RfacMatrix(3, i, 1)
                      j = nint( ypoints(k,2) * 100.0)
                      ypoints(k,2) = float(j) / 100.0
                  endif
               enddo
               if (k == 0) then
                   k = npoints
                   xpoints(1:k, 2) = RfacMatrix(3, 1:k, 1)
                   nolsq = 0
               endif
               lPlots(2) = k
               minx = minval(xpoints(1:lPlots(2),2))
               maxx = maxval(xpoints(1:lPlots(2),2))
               i = minx
               minx = i
               i = maxx + 1
               maxx = i
               MinMaxGR(1,2) = minx
               MinMaxGR(2,2) = maxx
               if (nolsq /= 0) then
                   miny = minval(ypoints(1:lPlots(2),2))
                   maxy = maxval(ypoints(1:lPlots(2),2))
                   miny = miny - 0.05
                   maxy = maxy + 0.05
                   MinMaxGR(3,2) = miny
                   MinMaxGR(4,2) = maxy
               endif
               colorGR(1:lPlots(2), 2) = color_LIGHTRED
               HistoOK(:) = 1
               call ManageGraph(0, npunti)
!
!========   REMO CASE ========
!
          case (11)
!
               do i=1, npunti
                  xpoints(i,1)=i
                  kbo(1,i) = i
                  kbo(2,i) = solcan(i)%ipunt
                  ypoints(i,1)=solcan(iwork3(i))%RotFom
                   k = nint(ypoints(i,1) * 1000.0)
                   ypoints(i,1) = float(k) / 1000.0
               enddo
               lPlots(1) = npunti
               minx = 0.0
               maxx = nPointsGR + 1
               miny = minval(ypoints(1:lPlots(1),1))
               maxy = maxval(ypoints(1:lPlots(1),1))
               if (abs(maxy - miny) < 0.001) then
                   miny = miny - 0.05
                   maxy = maxy + 0.05
               endif
               MinMaxGR(1,1) = minx
               MinMaxGR(2,1) = maxx
               MinMaxGR(3,1) = miny
               MinMaxGR(4,1) = maxy
               colorGR(1:lPlots(1), 1) = color_LIGHTRED
               QualeTic(1) = CheckTic(maxx, 1)
               call ManageGraph(1, npunti)
!
          case (12)
!
!-- primo grafico(b): soluzioni selezionate dopo clustering
!
               lp1 = lPlots(1)
               do i=1, npunti
                  ipunt=solcan(i)%ipunt
                  do j=1,nPointsGR
                    if(ipunt==kbo(2,j)) then
                       xpoints(lp1+i,1)=kbo(1,j)
                       exit
                    endif
                  enddo
                  ypoints(lp1+i,1)=solcan(solcan(i)%ipunt)%TraFom
                  k = nint(ypoints(lp1+i,1) * 1000.0)
                  ypoints(lp1+i,1) = float(k) / 1000.0
               enddo
               lPlots(1) = lp1 + npunti
               minx = 0.0
               maxx = nPointsGR + 1
               miny = minval(ypoints(1:lPlots(1),1))
               maxy = maxval(ypoints(1:lPlots(1),1))
               if (abs(maxy - miny) < 0.001) then
                   miny = miny - 0.05
                   maxy = maxy + 0.05
               endif
               MinMaxGR(1,1) = minx
               MinMaxGR(2,1) = maxx
               MinMaxGR(3,1) = miny
               MinMaxGR(4,1) = maxy
               colorGR(lp1+1:lPlots(1), 1) = color_GREEN
               call ManageGraph(1, npunti)
!
          case (13)
!
!-- secondo grafico(a): soluzioni selezionate dopo traslazione
!
               do i=1, npunti
                  ii=TraAll(i)%ipunt
                  ipunt=TraAll(ii)%trial
                  do j=1,nPointsGR
                    if(ipunt==kbo(2,j)) then
                       xpoints(i,2)=kbo(1,j)
                       exit
                    endif
                  enddo
                  ypoints(i,2)=TraAll(ii)%TraFom
                  k = nint(ypoints(i,2) * 1000.0)
                  ypoints(i,2) = float(k) / 1000.0
               enddo
               lPlots(2) = npunti
               minx = 0.0
               maxx = nPointsGR + 1
               miny = minval(ypoints(1:lPlots(2),2))
               maxy = maxval(ypoints(1:lPlots(2),2))
               if (abs(maxy - miny) < 0.001) then
                   miny = miny - 0.05
                   maxy = maxy + 0.05
               endif
               MinMaxGR(1,2) = minx
               MinMaxGR(2,2) = maxx
               MinMaxGR(3,2) = miny
               MinMaxGR(4,2) = maxy
               colorGR(1:lPlots(2), 2) = color_LIGHTRED
               QualeTic(2) = CheckTic(maxx, 2)
               call ManageGraph(2, npunti)
!
          case (14)
!
!-- secondo grafico(b): soluzioni dopo ottimizzazione locale
!
               lp1 = lPlots(2)
               do i=1, npunti
                  ii=TraAll(i)%ipunt
                  ipunt=TraAll(ii)%trial
                  do j=1,nPointsGR
                    if(ipunt==kbo(2,j)) then
                       xpoints(lp1+i,2)=kbo(1,j)
                       exit
                    endif
                  enddo
                  ypoints(lp1+i,2)=TraAll(ii)%LocFom
                  k = nint(ypoints(lp1+i,2) * 1000.0)
                  ypoints(lp1+i,2) = float(k) / 1000.0
               enddo
               lPlots(2) = lp1 + npunti
               minx = 0.0
               maxx = nPointsGR + 1
               miny = minval(ypoints(1:lPlots(2),2))
               maxy = maxval(ypoints(1:lPlots(2),2))
              if (abs(maxy - miny) < 0.001) then
                   miny = miny - 0.05
                   maxy = maxy + 0.05
               endif
               MinMaxGR(1,2) = minx
               MinMaxGR(2,2) = maxx
               MinMaxGR(3,2) = miny
               MinMaxGR(4,2) = maxy
               colorGR(lp1+1:lPlots(2), 2) = color_GREEN
               call ManageGraph(2, npunti)
!
          case (15)
!
!-- terzo grafico:  ricerca di NCS
!
               nMaxSolutionsGR = kco(2)
               do i=1, npunti
                  lPlots(numbGR) = lPlots(numbGR) + 1
                  xpoints(lPlots(numbGR),numbGR)=kco(1)
                  checkColor(lPlots(numbGR))=1
                  k = nint(ra(i) * 1000.0)
                  ypoints(lPlots(numbGR),numbGR)= float(k) / 1000.0
               enddo
               minx = 0.0
               maxx = nMaxSolutionsGR + 1
               miny = minval(ypoints(1:lPlots(numbGR),numbGR))
               maxy = maxval(ypoints(1:lPlots(numbGR),numbGR))
               if (abs(maxy - miny) < 0.001) then
                   miny = miny - 0.05
                   maxy = maxy + 0.05
               endif
               MinMaxGR(1,numbGR) = minx
               MinMaxGR(2,numbGR) = maxx
               MinMaxGR(3,numbGR) = miny
               MinMaxGR(4,numbGR) = maxy
               do i=1, lPlots(numbGR)
                  if(checkColor(i)==1)
     *                  colorGR(i, numbGR) = color_LIGHTRED
                  if(checkColor(i)==0)
     *                  colorGR(i, numbGR) = color_GREEN

               enddo 
               QualeTic(numbGR) = CheckTic(maxx, numbGR)
               call ManageGraph(numbGR, npunti)
          case (18)
!
!-- terzo grafico:  improvement NCS
!
               lp1 = kco(2)!lPlots(4)
               nMaxSolutionsGR = kco(2)
c               do i=npunti-1, npunti
                  lPlots(numbGR) = lPlots(numbGR) + 1
                  xpoints(lPlots(numbGR),numbGR)=kco(1)
                  checkColor(lPlots(numbGR))=0
c                  xpoints(i+lp1,3)=kco(1)
c                  k = nint(ra(i+lp1) * 1000.0)
                  k = nint(ra(npunti+1) * 1000.0)
                  ypoints(lPlots(numbGR),numbGR)= float(k) / 1000.0
c                  ypoints(i+lp1,3)= float(k) / 1000.0
c               enddo
c               lPlots(3) = lp1 + npunti
               minx = 0.0
               maxx = nMaxSolutionsGR + 1
               miny = minval(ypoints(1:lPlots(numbGR),numbGR))
               maxy = maxval(ypoints(1:lPlots(numbGR),numbGR))
               if (abs(maxy - miny) < 0.001) then
                   miny = miny - 0.05
                   maxy = maxy + 0.05
               endif
c               write(6,*)'valori y',miny,maxy
               MinMaxGR(1,numbGR) = minx
               MinMaxGR(2,numbGR) = maxx
               MinMaxGR(3,numbGR) = miny
               MinMaxGR(4,numbGR) = maxy
               do i=1, lPlots(numbGR)
                  if(checkColor(i)==1)
     *                   colorGR(i,numbGR) = color_LIGHTRED
                  if(checkColor(i)==0)
     *                   colorGR(i, numbGR) = color_GREEN

               enddo 

c              colorGR(lp1 + 1:lPlots(3), 3) = color_GREEN
               QualeTic(numbGR) = CheckTic(maxx, numbGR)
               call ManageGraph(numbGR,1)
!
          case (16)

               kLarg = kscrx
               kAlt  = kscry
               sinistra = 0.5
               call gr_init(1, kLarg, kAlt) 
               call ManageGraph(0, npunti)
!
          case (17)
!
!-- secondo (e ultimo) grafico: caso di piu' modelli
!
               lp1 = lPlots(2)
               do i=1, npunti
                  xpoints(lp1+i,2)=i
                  ypoints(lp1+i,2)=finsolcan(i)%Fom
                  k = nint(ypoints(lp1+i,2) * 1000.0)
                  ypoints(lp1+i,2) = float(k) / 1000.0
               enddo
               lPlots(2) = lp1 + npunti
               minx = 0.0
               maxx = nPointsGR + 1
               miny = minval(ypoints(1:lPlots(2),2))
               maxy = maxval(ypoints(1:lPlots(2),2))
              if (abs(maxy - miny) < 0.001) then
                   miny = miny - 0.05
                   maxy = maxy + 0.05
               endif
               MinMaxGR(1,2) = minx
               MinMaxGR(2,2) = maxx
               MinMaxGR(3,2) = miny
               MinMaxGR(4,2) = maxy
               colorGR(lp1+1:lPlots(2), 2) = color_GREEN
               call ManageGraph(2, npunti)
!
!
!========   MAD CASE ========
!
          case (21)
!
               if (lPlots(1) < MaxToStore) then     !cricri
                   lPlots(1) = lPlots(1) + 1
               end if
               lPl1 = lPlots(1)
               iniz = 1
               if (kmad == 2) then
                  lPl1 = mod(lPl1-1, MaxToStore) + 1
                  iniz = (WhichDeriv -1) * MaxToStore + 1
               endif 
!pgMAD2112
             if (ifPatt == 0) then
                xpoints(iniz:iniz+lPl1-1,1) = fomrt(1:lPl1,5)
!cricri
                minx = minval(xpoints(1:lPlots(1),1))
                maxx = maxval(xpoints(1:lPlots(1),1))
                i = minx - 1
                minx = i
                i = maxx + 1
                maxx = i
                MinMaxGR(1,1) = minx
                MinMaxGR(2,1) = maxx

!                do i=1, lPlots(1)
!                   if (xpoints(i,1) > 0.99) then
!                      xpoints(i,1) = 0.99
!                   end if
!                end do
!                MinMaxGR(1,1) = 0.0
!                MinMaxGR(2,1) = 1.0
             else
                lp1 = lPlots(1)
                xpoints(iniz:iniz+lPl1-1,1) = 
     *                                RfacMatrix(2, 1:lPl1, jBlock)
                minx = minval(xpoints(1:lPlots(1),1))
                maxx = maxval(xpoints(1:lPlots(1),1))
                i = minx - 1
                minx = i
                i = maxx + 1
                maxx = i
                MinMaxGR(1,1) = minx
                MinMaxGR(2,1) = maxx
             end if
             call ManageGraph(1, npunti)
!
          case (22)
!
             if (kmad /= 2) then
                 lPlots(1) = MaxToStore
                 npunti = MaxToStore
                 xpoints(1:npunti, 1) = RfacMatrix(2, 1:npunti, jBlock)
             endif
             if (ifPatt == 0) then
!cricri
                minx = minval(xpoints(1:lPlots(1),1))
                maxx = maxval(xpoints(1:lPlots(1),1))
                i = minx - 1
                minx = i
                i = maxx + 1
                maxx = i
                MinMaxGR(1,1) = minx
                MinMaxGR(2,1) = maxx

!                do i=1, npunti
!                   if (xpoints(i,1) > 0.99) then
!                      xpoints(i,1) = 0.99
!                   end if
!                end do
!                MinMaxGR(1,1) = 0.0
!                MinMaxGR(2,1) = 1.0
             else
                minx = minval(xpoints(1:npunti,1))
                maxx = maxval(xpoints(1:npunti,1))
                i = minx - 1
                minx = i
                i = maxx + 1
                maxx = i
                MinMaxGR(1,1) = minx
                MinMaxGR(2,1) = maxx
             end if
!pgMAD2112
               call ManageGraph(1, npunti)
!
          case (23)
!
               lPlots(2) = lPlots(2) + 1
               xpoints(lPlots(2),2) = erre * 100
               ypoints(lPlots(2),2) = FinalFom
               k = nint( ypoints(lPlots(2),2) * 100.0)
               ypoints(lPlots(2),2) = float(k) / 100.0
               minx = minval(xpoints(1:lPlots(2),2))
               maxx = maxval(xpoints(1:lPlots(2),2))
               miny = minval(ypoints(1:lPlots(2),2))
               maxy = maxval(ypoints(1:lPlots(2),2))
               i = minx - 1
               minx = i
               i = maxx + 1
               maxx = i
               miny = miny - 0.05
               maxy = maxy + 0.05
               MinMaxGR(1,2) = minx
               MinMaxGR(2,2) = maxx
               MinMaxGR(3,2) = miny
               MinMaxGR(4,2) = maxy

               colorGR(1:lPlots(2), 2) = color_LIGHTRED

!                   lPl2 = lPlots(2)
!                   if (lPl2 < 4) then                           !!!!!!!!!!!!!!!!!!!!!!!!!
!                      colorGR(1:lPl2, 2) = color_LIGHTRED
!                   else
!                      rhoclu = (maxx-minx)/4
!                      call test03(xpoints(1:lPl2,2), ypoints(1:lPl2,2),
!     *                          lPl2, rhoclu, nClust(1:lPl2), nTotClust,
!     *                          ivBest(2), kverbo)
!                      if (nTotClust < 2) then
!                         colorGR(1:lPl2, 2) = color_LIGHTRED
!                      else
!                         do i=1, lPl2
!                            if (nClust(i) == 1) then
!                               ColorGR(i, 2) = color_LIGHTGREEN
!                            else
!                               ColorGR(i, 2) = color_LIGHTRED
!                            end if
!                         end do
!                      end if
!                   endif

               call ManageGraph(2, npunti)
!
               lPlots(3) = lPlots(3) + 1
               xpoints(lPlots(3),3) = erre * 100 / FinalFom
               
               ypoints(lPlots(3),3) = 0.0
               
               minx = minval(xpoints(1:lPlots(3),3))
               maxx = maxval(xpoints(1:lPlots(3),3))
               i = minx - 1
               minx = i
               i = maxx + 1
               maxx = i
               MinMaxGR(1,3) = minx
               MinMaxGR(2,3) = maxx
 
               call ManageGraph(3, npunti)
!
          case (25)

               kLarg = kscrx
               kAlt  = kscry
               sinistra = 0.5
               call gr_init(1, kLarg, kAlt) 
               call ManageGraph(0, npunti)
!
          case (26)

               HistoOK(:) = 1
!pgMAD0512               colorGR(:,:) = color_LIGHTRED
!
               lPlots(1) = npunti
               xpoints(1:npunti,1) = RfacMatrix(2,1:npunti,jBlock)
               minx = minval(xpoints(1:lPlots(1),1))
               maxx = maxval(xpoints(1:lPlots(1),1))
               i = minx
               minx = i
               i = maxx + 1
               maxx = i
               MinMaxGR(1,1) = minx
               MinMaxGR(2,1) = maxx
!
               k = 0
               do i=1, npunti
                  if (RfacMatrix(4, i, 1) < 100.0) then
                      k = k + 1
                      xpoints(k, 2) = RfacMatrix(4, i, 1)
                      ypoints(k, 2) = RfacMatrix(3, i, 1)
                      j = nint( ypoints(k,2) * 100.0)
                      ypoints(k,2) = float(j) / 100.0
                  endif
               enddo
               npunti = k
               lPlots(2) = npunti
               lPlots(3) = npunti
               if (npunti > 0) then
                   minx = minval(xpoints(1:lPlots(2),2))
                   maxx = maxval(xpoints(1:lPlots(2),2))
                   miny = minval(ypoints(1:lPlots(2),2))
                   maxy = maxval(ypoints(1:lPlots(2),2))
                   i = minx - 1
                   minx = i
                   i = maxx + 1
                   maxx = i
                   miny = miny - 0.05
                   maxy = maxy + 0.05
               else
                   minx = 0
                   maxx = 1
                   miny = 0
                   maxy = 1
               endif
cXXXXXXXXXX
               MinMaxGR(1,2) = minx
               MinMaxGR(2,2) = maxx
               MinMaxGR(3,2) = miny
               MinMaxGR(4,2) = maxy
!
               if (npunti > 0) then
                   do i=1, npunti
                      xpoints(i,3) = xpoints(i,2)  / ypoints(i,2)
                   enddo
                   minx = minval(xpoints(1:lPlots(3),3))
                   maxx = maxval(xpoints(1:lPlots(3),3))
                   i = minx - 1
                   minx = i
                   i = maxx + 1
                   maxx = i
               else
                   minx = 0
                   maxx = 1
                   miny = 0
                   maxy = 1
               endif
               MinMaxGR(1,3) = minx
               MinMaxGR(2,3) = maxx
!
               kLarg = kscrx
               kAlt  = kscry
               call gr_init(1, kLarg, kAlt) 
               call ManageGraph(0, npunti)
!
!========   VLD CASE ========
!
!
          case (31)

               call  RWindMainWindow(2)

          case (35)

               kLarg = kscrx
               kAlt  = kscry
               call gr_init(1, kLarg, kAlt) 
               call ManageGraph(0, npunti)

!
      end select
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ManageGraph(iAction, npoints)
      USE General
      USE Molcom      
      USE GrexpoMod
      USE Grafici
      USE VLDmod, only : WhichVldPlot
      USE PhaseModule, only : ifVLD, ifMDM
!
!
!-- iAction = -1  initialize graphic area
!--         =  0  plot all histograms
!--         =  n  plot histogram # n
!

      character stringx*50, stringy*50, top*100
      !
      if (iAction >= 0) then
          if (.not.allocated(MinMaxGR)) then
              if (.not. preRemo) then
                  return
              endif
          endif
      endif
      if (iAction < 0) then
          call InitGrafici(npoints)
!
          if (.not. ifViewer) then
              stepGR = 1.5 * FntPixHeight / float(kAlt)
              stepGR0 = 1.0
              stepGRi = stepGR0
              headGR(1,1) = 0.0
              headGR(2,1) = 1.0
              headGR(3,1) = 1.0
              headGR(4,1) = 1.0 - stepGR
              headGR(1,2) = 0.0
              headGR(2,2) = 1.0
              headGR(3,2) = 0.0
              headGR(4,2) = 0.0 + stepGR
          endif
!
!-- create and open viewer
!
          if (ifViewer) then
              ind = 1
              iot = 0
              Message = 'FOMs Statistics'
              call Visualizzatore(ind, kLarg, kAlt, Message)
          endif
!
          HistoBack = color_BRIGHTWHITE
          call gr_init(1, kLarg, kAlt) 
          call gr_setbackground(HistoBack)
!
!-- Text part
!
      if (.not. ifViewer .and. ifDrawGR) then
          call gr_frame(kLarg, kAlt, 0.0, 0.5, 0.0, 1.0,
     *                  color_BRIGHTWHITE, color_BRIGHTWHITE)
          call gr_area( 0.0, 0.5, 0.0, 1.0)
          call TestoGR(' ', -1, 2, 0)
      endif

!
          do i=1, nGraficiGR
             if (HistoOK(i) == 1) then
                 if (ifVLD == 1 .and. ifMDM == 0) then
                     WhichVldPlot = i
                 endif
                 call gr_frame(kLarg, kAlt,
     *                         xHistF(1,i), xHistF(2,i), 
     *                         yHistF(1,i), yHistF(2,i),
     *                         HistoBack, HistoBack)
                 call gr_area(xHisto(1,i), xHisto(2,i), 
     *                        yHisto(1,i), yHisto(2,i))
                 call gr_clear_area(xHisto(1,i), xHisto(2,i), 
     *                              yHisto(1,i), yHisto(2,i))
                 stringx = StringGR(i,1)
                 stringy = StringGR(i,2)
                 top     = LegendGR(i)
                 kk = tipoGraficiGR(i)
                 Tic = QualeTic(i)
                 call DoGraph(i, kk, stringx, stringy, top, Tic)
                 call zflush
             endif
          enddo
!
!-- close viewer
!
          if (ifViewer) then
              ind = 3
              iot = 0
              call Visualizzatore(ind, ix, iy, ' ')
          endif
      elseif (iAction == 0) then
!
!-- plot all histograms
!
          if (ifViewer) then
              ind = 4
              iot = 0
              call Visualizzatore(ind, ix, iy, ' ')
          endif
!
          call gr_setbackground(HistoBack)
!
!-- Text part
!
      if (.not. ifViewer .and. ifDrawGR) then
          call gr_frame(kLarg, kAlt, 0.0, 0.5, 0.0, 1.0,
     *                  color_BRIGHTWHITE, color_BRIGHTWHITE)
          call gr_area( 0.0, 0.5, 0.0, 1.0)
          call TestoGR(' ', -1, 2, 0)
      endif

          do i=1, nGraficiGR
             if (HistoOK(i) == 1) then
                 if (ifVLD == 1) then
                     WhichVldPlot = i
                 endif
                 call gr_frame(kLarg, kAlt,
     *                         xHistF(1,i), xHistF(2,i), 
     *                         yHistF(1,i), yHistF(2,i), 
     *                         HistoBack, HistoBack)
                 call gr_area(xHisto(1,i), xHisto(2,i), 
     *                        yHisto(1,i), yHisto(2,i))
                 call gr_clear_area(xHisto(1,i), xHisto(2,i), 
     *                              yHisto(1,i), yHisto(2,i))
                 kk = tipoGraficiGR(i)
                 stringx = StringGR(i,1)
                 stringy = StringGR(i,2)
                 top     = LegendGR(i)
                 Tic = QualeTic(i)
                 call DoGraph(i, kk, stringx, stringy, top, Tic)
             endif
          enddo
!
          call zflush
          if (ifViewer) then
              ind = 3
              iot = 0
              call Visualizzatore(ind, ix, iy, ' ')
          endif
!
      else
!
!-- plot iAction-th histogram
!
          if (ifViewer) then
              ind = 4
              iot = 0
              call Visualizzatore(ind, ix, iy, ' ')
          endif
          i = iAction
          HistoOK(i) = 1
          stringx = StringGR(i,1)
          stringy = StringGR(i,2)
          top     = LegendGR(i)
          call gr_frame(kLarg, kAlt,
     *                  xHistF(1,i), xHistF(2,i), 
     *                  yHistF(1,i), yHistF(2,i),
     *                  HistoBack, HistoBack)
          call gr_area(xHisto(1,i), xHisto(2,i), 
     *                 yHisto(1,i), yHisto(2,i))
          call gr_clear_area(xHisto(1,i), xHisto(2,i), 
     *                       yHisto(1,i), yHisto(2,i))
          kk = tipoGraficiGR(i)
          Tic = QualeTic(i)
          call DoGraph(i, kk, stringx, stringy, top, Tic)
          call zflush
          if (ifViewer) then
              ind = 3
              iot = 0
              call Visualizzatore(ind, ix, iy, ' ')
          endif
      endif
!
!-- Text part
!
!!      if (.not. ifViewer .and. ifDrawGR) then
!!          call gr_frame(kLarg, kAlt, 0.0, 0.5, 0.0, 1.0,
!!     *                  color_BRIGHTWHITE, color_BRIGHTWHITE)
!!          call gr_area( 0.0, 0.5, 0.0, 1.0)
!!          call TestoGR(' ', -1, 2, 0)
!!      endif
!!gianluca
          if (ifPlotGR) then
*             call MettiPixmap(NomePng, PlotGR_x, PlotGR_y)
*             call MettiPixmap('c8_preview.png',PlotGR_x, PlotGR_y)
              call PixmapOnWhiteBoard
          endif
!!gianluca
!
      call zflush
!!mr20/05/2014  call DoSingleIteration()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine TestoGR(stringa, colore, size, Box)
      USE General
      USE Molcom      
      USE GrexpoMod
      USE Grafici
!
      implicit none
      integer :: i, size, colore, Box, lstr, Lung, LenInPix, nbx, ifBox4
      real    :: xp, yp, xpbb, xpb, PixMax, fx, sini
      character(len=*) :: stringa
!
      if (jscreen == 0 .or. ifMadEnv == 0) return
!
      if (Box > 0) then
          lastBox = Box
      endif
      stepGR = 1.5 * FntPixHeight / float(kAlt)

      if (nLinesGR == 0) then
          sinistra = 0.5
      endif
      lstr = Lung(stringa)
      if (Box > 0) then
          inBoxGR(Box) = inBoxGR(Box) + 1
      endif
      stepGRi = stepGR0
      if (lstr == 1 .and. stringa(1:1) == '&') then
          nLinesGR = nLinesGR + 1
          cardGR(nLinesGR) = ' '
          WhichBoxGR(nLinesGR) = Box
          sizeLinesGR(nLinesGR) = size
          if (colore > 0) then
              colorLinesGR(nLinesGR) = colore
          else
              colorLinesGR(nLinesGR) = color_LIGHTBLUE
          endif
      elseif (lstr > 0) then
          nLinesGR = nLinesGR + 1
          call MarkUpGR(stringa, lstr)
          cardGR(nLinesGR) = ' '
          cardGR(nLinesGR) = stringa(1:lstr)
          WhichBoxGR(nLinesGR) = Box
          sizeLinesGR(nLinesGR) = size
          if (colore > 0) then
              colorLinesGR(nLinesGR) = colore
          else
              colorLinesGR(nLinesGR) = color_LIGHTBLUE
          endif
      endif
!
      if (.not. ifDrawGR) return
      call gr_area(0.0, 1.0, 0.0, 1.0)
      xp = 0.01
!
!-- header
!
      call gr_setcolor(color_RED)
      call gr_frame(kLarg, kAlt,
     *              headGR(1,1), headGR(2,1), 
     *              headGR(3,1), headGR(4,1),
     *              color_YELLOW, color_YELLOW)
      stepGRi = stepGRi - stepGR
      yp = stepGRi + stepGR / 5
      call gr_drawtext(xp,yp,0.0,headersGR(1),2)
!
!-- text
!
      stepGRi = stepGRi + stepGR / 2              ! gianluca 05/05/09
      if (nLinesGR > 0) then
          call gr_frame(kLarg, kAlt,
     *              0.0, sinistra, 
     *              headGR(4,1) - stepGR / 2, headGR(4,2) + stepGR / 2,
     *              color_BRIGHTWHITE, color_BRIGHTWHITE)
          call gr_setcolor(color_LIGHTBLUE)
          xpb = xp + stepGR
          xpb1 = xp + stepGR / 2
          ypb1 = stepGRi - stepGR / 2
          ypb2 = 0
          stepGRi = ypb1
          PixMax = -99
!
          do nbx=1, 5
             if (RightBox  > 0) then
                 if (nbx > RightBox .and. inBoxGR(nbx) >= 1) then
                     call gr_frame(kLarg, kAlt, 
     *                         xHistF(1,3)        , xHistF(2,3)        ,
     *                         yHistF(1,3)        , yHistF(2,3)        ,
     *                         color_BRIGHTWHITE, color_BRIGHTWHITE)
                 endif
             endif
!
             ifBox4 = 0
             do i=1, nLinesGR
                if (WhichBoxGR(i) /= nbx) cycle
                call gr_setcolor(colorLinesGR(i))
                stepGRi = stepGRi - stepGR *0.9
                if (nbx <= LeftBox .and. RightBox == 0) then
                    xpb = xp + stepGR
                    xpb1 = xp + stepGR / 2
                    yp  = stepGRi
                else
                    xpb = xHistF(1,3) + 1.5 * stepGR 
                    if (ifBox4 == 0) then
                        ifBox4 = 1
                        yp  = yHistF(2,3) - stepGR ! - 2*stepGR ! gianluca 05/05/09
                    else
                        yp  = yp - stepGR
                    endif
                endif

                if (index(cardGR(i),'<big>') > 0) then  ! gianluca 05/05/09
                    xpbb = xpb / 2                      ! gianluca 05/05/09
                else                                    ! gianluca 05/05/09
                    xpbb = xpb                          ! gianluca 05/05/09
                endif                                   ! gianluca 05/05/09
                call gr_drawtext(xpbb,yp,0.0,cardGR(i),
     *                           sizeLinesGR(i))
                fx = LenInPix(cardGR(i),sizeLinesGR(i))
                if (fx > PixMax) then
                    PixMax = fx
                    sini = xpb + PixMax / float(kLarg) + xpb - xpb1
                    if (sini > sinistra) sinistra = sini
                endif
             enddo
             if (inBoxGR(nbx) >= 1) then
                 if (nbx <= LeftBox .and. RightBox == 0) then
                     ypb2 = yp - stepGR / 2
                     xpb2 = xpb + PixMax / float(kLarg) + xpb - xpb1
                 endif
             endif

             ypb1 = ypb2 - stepGR / 3
             ypb2 = ypb1 - stepGR

          end do
!
          if (RightBox > 0) then
              if (inBoxGR(RightBox) == 0) then
                  call gr_frame(kLarg, kAlt, 
     *                     xHistF(1,3)+stepGR , xHistF(2,3)-stepGR , 
     *                     yHistF(1,3)+stepGR , yHistF(2,3)-stepGR , 
     *                     color_BRIGHTWHITE, color_BRIGHTWHITE)
              endif
          endif

          do i=1, nLinesGR
             if (WhichBoxGR(i) > 0) cycle
             call gr_setcolor(colorLinesGR(i))
             stepGRi = stepGRi - stepGR
             yp = stepGRi
             if (index(cardGR(i),'<big>') > 0) then  ! gianluca 05/05/09
                 xpbb = xp / 2                       ! gianluca 05/05/09
             else                                    ! gianluca 05/05/09
                 xpbb = xp                           ! gianluca 05/05/09
             endif                                   ! gianluca 05/05/09
             call gr_drawtext(xpbb,yp,0.0,cardGR(i),sizeLinesGR(i))
          enddo
      endif
!
!-- footer
!
      call gr_setcolor(color_RED)
      if (Lung(headersGR(2)) > 0) then
          call gr_frame(kLarg, kAlt,
     *                  headGR(1,2), headGR(2,2), 
     *                  headGR(3,2), headGR(4,2),
     *                  color_YELLOW, color_YELLOW)
          call CreaIsOver()
          yp = stepGR / 4
          call gr_drawtext(xp,yp,0.0,Msg, 2)
          fx = LenInPix(headersGR(2),2) * 1.1
          xp = 1.0 - fx / float(kscrx)
          call gr_drawtext(xp,yp,0.0,headersGR(2), 2)
      endif
!
      call zflush
!
      return
      end
!-----------------------------------------------------------------------
      subroutine MarkUpGR(stringa, lstr)
      USE General
      USE CaratteriSpeciali
!
!-- This routine manages the following MarkUps  
!          <span lang="A">A</span>              Angstrom symbol
!          <span lang="Greek">stringa</span>    Greek characters
!
!-- The following are managed directly by GTK
!          <b>text</b>          Bold 
!          <big>text</big>      Makes font relatively larger
!          <sub>text</sub>      Subscript 
!          <sup>text</sup>      Superscript 
!          <small>text</small>  Makes font relatively smaller
!          <tt>text</tt>        Monospace font 
!          <u>text</u>          Underline 
 
      character*(*) stringa
!
      cardDiret = ' '
      cardImage = stringa
      call lcase(cardImage)
      k1 = index(cardImage,'<span lang="a">')
      k2 = index(cardImage,'<span lang="greek">')
      if (k1 > 0) then
          do while (k1 > 0)
             call SpecialChar(SpecCode(59), Inte, InteL)
             cardDiret(1:k1-1) = stringa(1:k1-1)
             cardDiret(k1:k1+InteL-1) = Inte(1:InteL)
             cardDiret(k1+InteL:) = stringa(k1+23:)
             stringa = cardDiret
             cardImage = stringa
             call lcase(cardImage)
             k1 = index(cardImage,'<span lang=a>')
          enddo
      endif
      if (k2 > 0) then
          do while (k2 > 0)
             kn = index(cardImage,'</span>') - 1
             k3 = k2 + 19
             cardDiret(1:k2-1) = stringa(1:k2-1)
             do k = k3, kn
                kk = ichar(stringa(k:k))
                kk = kk - 64
                call SpecialChar(SpecCode(kk), Inte, InteL)
                cardDiret(k2:k2+InteL-1) = Inte(1:InteL)
                k2 = k2+InteL
             enddo
             cardDiret(k2:) = stringa(kn+8:)
             stringa = cardDiret
             cardImage = stringa
             call lcase(cardImage)
             k2 = index(cardImage,'<span lang="greek">')
          enddo
      endif
      lstr = Lung(stringa)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DoGraph(Quale, tipo, stringx, stringy, legenda, Tic)
      USE General
      USE Molcom      
      USE GREXPOMOD
      USE Grafici
!
!-- tipo = 1   Scatter plot (Markers)
!-- tipo = 2   Histogram
!-- tipo = 3   Arrows
!-- tipo = 4   VLD
!
      integer, intent(in) :: tipo
      integer, intent(in) :: Quale
      real, intent(in)    :: Tic
      real                :: minx, maxx, miny, maxy
      real                :: delta
      integer             :: i
      character(len=*)    :: stringx, stringy, legenda
!
      if (tipo == 4) then     ! VLD
          call RWindMainWindow(4)
      else
!
!-- Set viewport
!
          delta = -2

          minx = MinMaxGR(1,Quale) 
          maxx = MinMaxGR(2,Quale)
          miny = MinMaxGR(3,Quale) 
          maxy = MinMaxGR(4,Quale)
          if (tipo == 2) then     ! Histogram
              miny = 0
              k = lPlots(Quale)
              if (k > 0) then
                  maxy = maxval(gr_distrib(xpoints(1:k,Quale),
     *                          minx, maxx, 100))
              else
                  maxy = 1
              endif
          endif
          call gr_setwin(minx, maxx, miny, maxy)
!

!
!-- Axis
!
          call gr_setcolor(color_BLUE)
          if (tipo == 1) then    ! Scatter plot
              call gr_box_sir('ABILTS', Tic, 0, 'ABILT',delta,0,0, card)
          else                   ! Histogram
              call gr_box_sir('AILTS', Tic,  0, 'AILT', delta,0,0, card)
          endif
!
!-- Grids
!
!     call gr_setcolor(color_GRAY)
!     call gr_setlinestyle(2)
!     call gr_box('G',0.0,0,'G',0.0,0, 0, ' ')
!     call gr_setlinestyle(1)
!
!-- Line
!
!     call gr_setcolor(color_BLACK)
!     call gr_drawline(xpoints(:n),ypoint(:n))
!
          if (tipo == 1) then
!
!-- Scatter plot (Markers)
!
              call gr_setsize(2)
              k = lPlots(Quale)
              if (k > 0) then
                  do j=1, k
                     xxp = xpoints(j,Quale)
                     yyp = ypoints(j,Quale)
                     call gr_setcolor(colorGR(j, Quale))
                     call gr_draw1marker(xxp, yyp, 5)
                  enddo
              endif
          elseif (tipo == 2) then
!
!-- Histogram
!
              if (lPlots(Quale) > 0) then
                  k = lPlots(Quale)
!old              call gr_setcolor(color_LIGHTRED)
!old              call gr_sfs(1)
                  ifColor = 0
                  nbin = 100
                  i = 1
!old          call gr_hist(xpoints(1:k,Quale), nbin, i)
                  call gr_hist_sir(xpoints(1:k,Quale), nbin, i, ifColor,
     *                 color_LIGHTGREEN, color_LIGHTRED, ivBest(Quale))  !pgMAD1512
              endif
          elseif (tipo == 3) then
!
!-- Arrows
!
              call gr_setsize(2)
              k = lPlots(Quale)
              if (k > 0) then
                  do j=1, k
                     xxp = xpoints(j,Quale)
                     yyp = ypoints(j,Quale)
                     call gr_setcolor(colorGR(j, Quale))
                     call gr_drawarrow(xxp, yyp)
                  enddo
              endif
          endif
      endif
!
!-- Text
!
      call gr_setcolor(color_BLUE)
      call gr_reldrawtext('B',2.5,0.5,0.5,stringx,2)
      call gr_reldrawtext('L',1.5,0.5,0.5,stringy,2)
      if (Lung(legenda) > 0) then
          if (QualePgm == SIRPROTPGM) then
              call gr_reldrawtext('T', -0.01, 0.5, 0.5, legenda, 2)
          else
*             call gr_reldrawtext('T', -0.01, 0.5, 0.5, legenda, 1)
              call gr_reldrawtext('T', -0.01, 0.5, 0.5, legenda, 2)
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      real function CheckTic(maxx, Quale)
      USE Grafici
      real, intent(in)    :: maxx
      integer, intent(in) :: Quale
      real                :: Tic
      integer             :: i, xArea
      character(len=10)   :: numero
!
      write(numero,'(i10)') nint(maxx)
      call shift(numero,i)
      i = LenInPix2(numero,i, 2)
      i = i * maxx
      xArea = nint( (xHisto(2,Quale) - xHisto(1,Quale)) * float(kLarg))
      if (i > xArea) then
          Tic = 0.0
      else
          Tic = 1.0
      endif
      CheckTic = Tic
!
      return
      end
! ----------------------------------------------------------------------
      subroutine gr_frame(kLarg, kAlt, xminGR, xmaxGR, yminGR, ymaxGR,
     *                    ic1GR, ic2GR)
!
      USE Molcom
!
      ix1 = nint(kLarg * xminGR)
      ix2 = nint(kLarg * xmaxGR)
      iy1 = kAlt - nint(kAlt * yminGR)
      iy2 = kAlt - nint(kAlt * ymaxGR)
!     
      call Rettangolo (ix1, iy1, ix2, iy2, ic1GR, ic2GR)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine  gr_Poligono(xvet, yvet, iz, iColor, jFill)
      USE Molcom
!
      integer  xvet(iz), yvet(iz)
!
      ixv(1:iz) = xvet(1:iz)
      iyv(1:iz) = yvet(1:iz)
      call  Poligono(iz, iColor, jFill)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine RecoverTrialFromBin(ier)
      USE PhaseModule
      USE Dialogo
!
      ksubr = 3
      call LeggiRiflessi(ier,ksubr)
      if (ier < 0) return
      call CreaBestModel(numbrun, ier)
      if (ier < 0) return
      QualeAbilita = 2
      ifSingle = 0
      kplot    = 0
      call MolPlo(kplot, ifSingle)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RecoverTrial(ier)
      USE General
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Dialogo
!
      character stringa*8
      integer WhichBestSolution
!
      call RoutineHeader('Recovery')
!
      call dirrec(ier)
      if (ier < 0) return
      write(Msg,100) numbrun, FFfom
      call OneBlankOnly(Msg)
      call PrintMess(Msg)
      call f_FortranAlLavoro(1)
      call AllocaAtomi(1)
      LowRes = 1
      call InitMolplo()
      ifFromGraphic = 1
      call InitFour(ifFromGraphic,ier)
      jrecyc = 0
      if (knw > 0) then
          call AllocaTestStuff(1)
          ifExamin = 1
      else
          ifExamin = 0
      endif
      ifTime = 0
      if (knw == 1) then
          call Trasla_Origine(nreflDim)          
      endif
      izero = 0
      ifmin = 0
      call examin(5455,mkang,khl,ipub,iphaz,nreflDim,izero,wt,
     *            ifmin)
      call CheckGrid()
      call AllocaMappa(1)
!
      if (numbGen > 0) then
          numbLSQ = nreflDim
      endif
      fcoef(:) = evet(:)
*     write(6,*) 'STAMPA MAKEMAP'
*     do i=1,nrefl
*        write(6,112) i,khl(1:3,i),iphaz(i),evet(i),wt(i)
*     enddo
* 112 format(i6,1h),3i4,i8,2f10.3)
*     write(6,*) 'FINE STAMPA MAKEMAP'
!
      nrefB = numbLSQ
      kcicla = 1
      erreNoWind = 0
      fomNoWind = 0
      ifBreak = 0
      kWstop = 0
      nolsq = -1
      aperc(1) = anat
      call dlsq(ier,kcicla,erreNoWind, fomNoWind, 1, ifBreak)
      if (ier < 0) then
          call f_FineLavoro(1)
          return
      endif
      nne    = nats
      call label(nne)
      iniz   = 1
      ifin   = nats
      call MakeLab(iniz,ifin)
      call PutModel
!
      k = index(fname(1),'.bin')
      kk = kStripTask1(k)
      WhichBestSolution = numbrun
      write(stringa,"('_',i4)") WhichBestSolution
      call NoBlanks(stringa,k1)
      cardDiret = fname(1)(1:kk-1) // stringa(1:k1) // '.pdb'
      itype = 0
      iform = 1
      jop = jopen(jhost,cardDiret,itype,iform,ier)
      numbPDB = -1
      ifFast = 0
      ifREM = 0
      call outPDB(jhost, numbPDB, ifFast, ifREM, 0)
      close(jhost)
!
      if (knw == 1) then
          call to_coord_sir(1,numbLSQ)
      endif
!
      nzsav(:) = nz(:)
      nz(:) = iabs(nz(:)) / nzConst
      iref = 0
      mode = 1
      numb = nrefB
      scalan = 0.0
      ifBreak = 0
      iCoeff = 0
      call sftryyyc(iref,mode,numb,scalan,ifBreak,iCoeff)
*     fcvet(:) = work1(:)
      nz(:) = nzsav(:)
      rfac  = erre  * 100.0
      write(Msg,110) numbrun, rfac
      call OneBlankOnly(Msg)
      write(lo,"(/,' ',a)") Msg(1:Lung(Msg))
      call PrintMess(Msg)
      errem = erre
      if (kmad == 0) then
          call StatisticaErre
      endif
!
!-- store in list 6 the last R value
!
      rflsq = errem * 100.0
      QualeAbilita = 2
      ifSingle = 0
      kplot    = 0
      call MolPlo(kplot, ifSingle)
!
      return
  100 format('Set up model for trial #',i5,' Final FOM = ',f9.3)
  110 format('For recovered trial # ',i5,' R% = ',f9.2)
      end
!-----------------------------------------------------------------------
      subroutine dirrec(ier)
      USE General
      USE Riflessi
      USE PhaseModule
      USE DataModule
      USE Direttive
!
*gl*  common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
*gl*  common /dataCommon/ ifPlotSpots, bfacPDB, noSpaceGroup,
*gl* *                    ifContSuppl, wave
*gl*  dimension vet(40), ivet(40), celltemp(13)
      dimension celltemp(13)
      character fileh*256
!
!-- set default values
!
      ifRecovered = 1
      ier = 0
      ReflFilePath = ' '
      MTZfile = ' '
      Lab_Ch(:) = ' '
      numbrun = 0
      FFom = 0.0
      ifMTZlab = 0
      nMTZlab  = 0
      ifMTZ   = 0
!
      ic    = 0
      icmax = icomq(icomat,2)
c
      do while (ic.lt.icmax.and.ier.eq.0)
         ic = ic + 1
         ipdir=ipdir+1
         cardDiret=card(ipdir)
         cardImage=cardDiret
         ldiret = Lung(cardImage)
         call cutst(cardDiret,lenp,direttiva,lend)
         call lcase(direttiva)
         if (direttiva(1:3).eq.'mtz') then
!
!-- check for blanks in the reflection file name
!
             call CheckBlanks(fileh, lend)
!
             if (lend > 0) then
                 MTZfile = fileh(1:lend)
                 ifMTZ   = 1
                 ind = index(MTZfile,char(47),.TRUE.)
                 ind1 = index(MTZfile,char(92),.TRUE.)
                 ind = max(ind,ind1)
                 if ( (ind + ind1) > 0 ) then
                     ReflFilePath = MTZfile(1:ind)
                 endif
             else
                 ier = -10
             endif
         elseif (direttiva(1:3).eq.'lab') then
             Lab_Ch(:) = ' '
             k = 0
             lenp = 1
             do while (lenp > 0)
                call cutst(cardDiret,lenp,direttiva,lend)
                k = k + 1
                Lab_Ch(k) = direttiva
             enddo
             if (k < 5) then
                 ier = -10
             else
                 ifMTZlab = 1
                 nMTZlab  = k
             endif
         else
!-- directives with numeric parameters
             iopt=0
             call getnum(cardDiret,vet,ivet,iv,iopt)
             if (iopt.ne.-1) then
                 if (direttiva(1:3).eq.'tri') then
                     numbrun = ivet(1)
                     FFfom = vet(2)
                 else
                     ier = -20
                 endif
             else
                 ier = -20
             endif
         endif
      enddo
!
      if (ier == -10) then
          write(Msg,6100) cardImage(1:ldiret)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
      if (ier == -20) then
          write(Msg,6200) cardImage(1:ldiret)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
!
      ksubr = 3
      call LeggiRiflessi(ier,ksubr)
!
      write(Msg,100) numbrun, FFfom
      call OneBlankOnly(Msg)
      write(lo,"(' ',a,/)") Msg(1:Lung(Msg))
!
!-- MTZ
!
      if (ifMTZ == 1) then
          iAction = 1
          celltemp(:) = 0.0
          lix1 = 1
          lix2 = 1
          noSpaceGroup = 1
          call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
          if (ier < 0) return
          iAction = 2
          call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
          call WriteMTZCont()
          if (ier < 0) return
          call LeggiRecoveredMTZ(ier)
          iAction = 3
          call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
      endif
!
      if (knw == 1) then
          iAction = 1
          call AllocaTestStuff(iAction)
          ifExamin = 1
          izero = 0
          nbru = -333
          ifmin = 1
          call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
      else
          ifExamin = 0
      endif
!
      return
  100 format(' Recovering model from trial ',i8,' - FOM = ',f8.3)
 6100 format(' Error in directive : ',a)
 6200 format(' Wrong directive in RECOVERY modulus:   ',a)
      end
!-----------------------------------------------------------------------
      subroutine LeggiRecoveredMTZ(ier)
      USE General
      USE Riflessi
      USE PhaseModule
      USE IsrCom
!
      logical ifEof
!
      ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2=(2*ihmx(3)+1)
      ifatx=ihmx(1)*ifat1+ihmx(2)*ifat2+ihmx(3)
      allocate(isr(1:ifatx), stat = ier)
!
      do i=1,ifatx
         isr(i)=0
      enddo
!
      jump   = 0
      ifLine = 1
      nFoZero = 0
      nSyst = 0
!
      nr = 0
      do 
         call GetHklMTZRec(jump, kh, kk, kl, fase, peso, ifEof)
        
         if (ifEof) then
             exit
         endif
!
         if (jump == 1) then
             cycle
         endif
         call geneq(1, kh, kk, kl, idelt, jcod, isgnn, id1, rho, ireje)
         nr = nr + 1
         khl(1,nr) = kh
         khl(2,nr) = kk
         khl(3,nr) = kl
         ifase = fase
         ifase = ifase + idelt
         ifase = ifase * isgnn
         ifase = mod(ifase, 360)
         if (ifase.le.0) then
             ifase = ifase + 360
         endif
         work1(nr) = ifase
         work2(nr) = peso
         indr = kh * ifat1 + kk * ifat2 + kl
*        write(0,'(i5,2h) ,3i4,i8)') nr, kh, kk, kl, indr
         isr(indr) = nr
      enddo
!
*     go to 1
      do i=1, nrefl
         kh = khl(1,i)
         kk = khl(2,i)
         kl = khl(3,i)
         indr = kh * ifat1 + kk * ifat2 + kl
         j = isr(indr)
         iphaz(i) = nint(work1(j))
         wt(i)    = work2(j)
      enddo
 1    deallocate (isr, stat = ier)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetHklMTZRec(jump, kh, kk, kl, fase, peso, ifEof)
      USE General
!
      logical ifEof, is_a_NaN, IsItaNaN
!
      call lrrefl(MTZunit, resolution, MTZdata, ifEof)
      if (ifEof) then 
          return
      endif
      jump = 0
      kh    = MTZdata(MTZlookup(1))
      kk    = MTZdata(MTZlookup(2))
      kl    = MTZdata(MTZlookup(3))
      do j=4,5
         i = MTZlookup(j)
         is_a_NaN = IsItaNaN(MTZdata(i))
         if (is_a_NaN) then
            jump = 1
         end if
      enddo
      if (jump == 0) then
          if (knw == 1) then
              fase = MTZdata(MTZlookup(7))
              peso = MTZdata(MTZlookup(8))
          else
              fase = MTZdata(MTZlookup(6))
              peso = MTZdata(MTZlookup(7))
          endif
      else
          fase  = -999.99
          peso = -999.99
      end if
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CreaBestModel(iAction, ier)
      USE General
      USE Riflessi
      USE Atomi
      USE Mappa
      USE RemoModule
      USE PhaseModule
      USE PhaseInterface
      USE Molcom, only : ifFour, jscreen
!
!-- iAction = 0  create Best Model
!-- iAction = n  create Model using the n-th set of phases
!
      integer trial, WhichSet
      real n
      character stringa*8
!
      if (.not.allocated(xyzs)) then
          call AllocaAtomi(1)
      endif
      if (iAction == 0) then
          WhichSet = 1
      else
          WhichSet = iAction
      endif
      if (InfoOK(17) > 0) then
          call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                         nsetFinalPhases)
          if (nSetsFineDSR > 0 .and. ier == 0) then
              if (iAction == 0) then
                  nset = iposFineDSR(1)
                  call PutGetFinalPhases(2, nset, figMer)
                  trial = nint( figMer(1) )
                  fFom = figMer(3)
                  iFound = 1
              else
                  iFound = 0
                  do i=1, nSetsFineDSR
                     nset = iposFineDSR(i)
!gl!                 call snr17(nset,figMer)
                     call PutGetFinalPhases(2, nset, figMer)
                     trial = nint( figMer(1) )
                     fFom = figMer(3)
                     if (trial == iAction) then
                         iFound = 1
                         exit
                     endif
                  enddo
              endif
              if (iFound == 1) then
                  write(Msg,25) trial, fFom
                  write(lo,26) trial, fFom
                  call PrintMess(Msg)
                  write(Msg,'(a,i8)') 
     *                  'Computing Atomic Model for trial #', trial
                  call OneBlankOnly(Msg)
                  call PrintMess(Msg)
                  call f_FortranAlLavoro(1)
                  LowRes = 1
                  if (resm < ResSogLow) then
                      LowRes = 0
                  else
                      LowRes = 1
                  endif
                  call InitMolplo()
                  ifFromGraphic = 1
                  call InitFour(ifFromGraphic,ier)
                  jrecyc = 0
                  if (knw > 0) then
                      call AllocaTestStuff(1)
                      ifExamin = 1
                  else
                      ifExamin = 0
                  endif
                  ifTime = 0
                  if (knw == 1) then !  .and. ifVLD == 0) then
                      call Trasla_Origine(nreflDim)          
                  endif
                  izero = 0
                  ifmin = 0
                  call examin(5455,mkang,khl,ipub,iphaz,nreflDim,izero,
     *                        wt,ifmin)
                  call CheckGrid()
                  call AllocaMappa(1)
!
                  numbLSQ_sav = numbLSQ
                  if (numbGen > 0) then
                      numbLSQ = nreflDim
                  endif
!
                  nrefB = numbLSQ
                  numb  = numbLSQ
                  kcicla = 1
                  erreNoWind = 0
                  fomNoWind = 0
                  ifBreak = 0
                  kWstop = 0
                  nolsq = -1
                  fcoef(:) = evet(:) * wt(:)
                  jpatt = 0
                  call MakeMap(fcoef, iphaz, numb, jpatt, xmap,
     *                         FORTH, BACK)
                  aperc(1) = anat
                  ifFour = 1
                  mode = 0
                  call Search99(mode,ier,numb)
                  if (ier.lt.0) return
                  if (iverbo.eq.0) then
                      kact=2
                  else
                      kact=3
                  endif
                  ifRecovered = 0
                  xyzo(1:5,1:nats) = xyzs(1:5,1:nats)
                  call outpea(kact)
                  xyzs(1:5,1:nats) = xyzo(1:5,1:nats)
CNEW E-MAP
                  call scrper(' ',0,-1)
                  jump = 1
                  kcicla = 1
                  call stopr(kcicla, numb, jump)
*gl*                  go to 111
*gl*
*gl*                  call dlsq(ier,kcicla,erreNoWind, fomNoWind, 1,
*gl*     *                      ifBreak)
*gl*
*gl*  111             continue

                  if (ier < 0) then
                      call f_FineLavoro(1)
                      return
                  endif
!
                  if (jscreen == 0) then
                      if (no(1) == 1 .and. neutro == 0) then
                          jlig = 2
                      else
                          jlig = 1
                      endif
                      nz(1:nats) = jlig * nzConst
                      nne = nats
                      call label(nne)
                  endif
                  nzsav(:) = nz(:)
                  nz(:) = iabs(nz(:)) / nzConst
                  iref = 0
                  mode = 1
                  scalan = 0.0
                  ifBreak = 0
                  iCoeff = 0
                  call sftryyyc(iref,mode,nrefl,scalan,ifBreak,iCoeff)
                  call AggiornaFC(fcvet, wt)
                  bariVLD(:) = 0.0
                  n = 0
                  do i = 1, nats 
                     if (nz(i) /= 0) then
                         n = n + 1
                         bariVLD(1:3) = bariVLD(1:3) + xyzs(1:3, i)
                     endif
                  enddo
                  bariVLD(1:3) = bariVLD(1:3) / n
                  nz(:) = nzsav(:)
                  rfac  = erre  * 100.0
                  write(Msg,110) trial,rfac
*                 write(lo,120) rfac
                  if (ifVLD == 1) then
                      call MiglioriErre(1)
                  endif
                  call PrintMess(Msg)
                  errem = erre
                  if (kmad == 0) then
                      Call StatisticaErre
                  endif
!
!-- store in list 6 the last R value
!
                  rflsq = errem * 100.0
                  call UpdateReflInfo
!
!-- store in list 6 phases & weights
!
                  call LastSFC(0, ier)
!
                  call PutModel
!
                  k = index(fname(1),'.bin')
                  kk = kStripTask1(k)
                  WhichBestSolution = trial
                  numbrun = trial
                  write(stringa,"('_',i4)") WhichBestSolution
                  call NoBlanks(stringa,k1)
                  if (ifExportShelx >= 0) then
                      cardDiret = fname(1)(1:kk-1) // stringa(1:k1) //
     *                            '.' // ExportExtension
                  else
                      cardDiret = fname(1)(1:kk-1) // stringa(1:k1) //
     *                            '.pdb'
                  endif
                  FichierOut = cardDiret
                  itype = 0
                  iform = 1
                  jop = jopen(jhost,cardDiret,itype,iform,ier)
                  if (ifExportShelx <= 0) then
                      numbPDB = -1
                      ifFast = 0
                      ifREM = 0
                      call outPDB(jhost, numbPDB, ifFast, ifREM, 0)
                  else
                      call outShelx(0)
                  endif
                  close(jhost)
!
                  numbLSQ = numbLSQ_sav
              else
                  write(Msg,'(a,i8)') 
     *                 'No phases available for required trial', iAction
                  call OneBlankOnly(Msg)
                  call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
                  ier = -1
                  return
              endif
          endif
      else
          Msg = 'No phases available to create a structural model'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
!
!!      call LanciaJavPreview()
      call LanciaJavPreviewNew()
!
      interp = 1
      call PutGetXyzs(1, interp)
!TEST!iAct = 2
!TEST!call AllocaModelRemo(iAct)
!
      return
   25 format('Set up model for best trial #',i5,'. Final FOM = ',f9.3)
   26 format(/,' Set up model for best trial #',i5,
     *         '. Final FOM = ',f9.3)
  110 format(' Trial #',i6,
     *       ' Structure Factor Calculation results: R% =',f7.2)
  120 format(' Structure Factor Calculation results: R% =',f7.2)
      end
! ----------------------------------------------------------------------
      subroutine LeggiGroups()
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Groups
      USE ZMatrix
      USE Poliedri
      USE PhaseModule
      USE RemoModule, only : numbModels
!
      real cellSav(6), celltemp(6), x1(3), x2(3), B(3, 3), x11Sav(4)
      real BTotSav(3,3)
      integer iVPSav(4)
!
!      return
!
!
       BTotSav(:,:) = BTot(:,:)
      ier = 0
!
*     call star9
*     itipe=0
*     kop = kopen(jdir,'tmp_tmp_tmp.bin',nlenBin,itipe,ierr)
*     call xdwn(lfirst,lindex,10)
*     call setfi
*     call xlc
*     call xcsae
!
      cellSav(1:6) = cell(1:6)
      celltemp(1:3) = 1.0
      celltemp(4:6) = 90
*     celltemp(7:13) = 0.0
*     call frm01(celltemp)
*     call xfl01
      kDealloca = 0
      IF (.NOT. ALLOCATED(xyz)) then
          if (numbModels == 0) then
              numbModels = 1
          endif
          kDealloca = 1
          nats = 50
          call AllocaAtomi(-1)
          nMaxLeg = 9800
          color_CELL = 3
          ViewDist = 9.e33
      endif
      iVPSav(:) = iVP(:)
      NatMolSav = NatMol
      NATindSav = NATind
      NatSpiSav = NatSpi
      NumLegSav = NumLeg
      xyztot(1:3,1:NatMol+NatSpi) = xyz(1:3,1:NatMol+NatSpi)
      jdoppio(1:NatMol+NatSpi) = iOrd(1:NatMol+NatSpi)
      x11Sav(1:2) = x11scale(1:2)
      x11Sav(3:4) = x11disp(1:2)
      call OrtoGroups(celltemp)
      iVP(1) = 1
      iVP(2) = 1
      iVP(3) = 250
      iVP(4) = 250
      Lim1 = iVP(1)
      Lim2 = iVP(2)
      Lim3 = iVP(3)
      Lim4 = iVP(4)
      NPX = Lim3 - Lim1
      NPY = Lim4 - Lim2
      Ratio = float(NPX) / float(NPY)
      RaggioCov = 0.750
!
      do i=1, nResid
         nzm = ResidTable1(i,1)
         NatMol = nzm
         do j=1, NatMol+NatSpi
            iOrd(j)  = j
         enddo
         
         do j=1, NatMol
            xloc(1:3,j) = ResidTable2(i,1:3,j)
            nloc(1:3,j) = int(ResidTable2(i,4:6,j))
            iloc(j) = j
            xor(1:3) = 0.0
         enddo
!
         call zmatr_new(ier)
         do j=1, NatMol
            xyz(1:3, j) = xortolocal(1:3, j)
            iOrd(j) = j
         enddo
         distAmin = MaxVal(xloc(1,1:NatMol)) * 1.1
         ResidConn(i,1:2,:) = 0
         n = 0
         do j=1, NatMol-1
            do l=j+1, NatMol
               dist = 0.
               do k=1,3
                  dist = dist + (xyz(k,j)-xyz(k,l))**2
               enddo
               dist = sqrt(dist)
               if (dist < distAmin) then
                   n = n + 1
                   ResidConn(i,1,n) = j
                   ResidConn(i,2,n) = l
               endif
            enddo
         enddo
!
         if (kDealloca == 1) then
             nzTot(1:NatMol) = 2
             RS(1:NatMol) = RaggioCov / 3.0
             rMLu(1:NatMol) = 2 * RaggioCov
         endif
         NATind = NatMol
         Rmin1 = 99999.
         Rmin2 = 99999.
         RMAX1 = -99999.
         RMAX2 = -99999.
!
         do i1 = 1 , 3
            do j1 = 1 , 3
               BTot(i1, j1) = 0
            enddo
            BTot(i1, i1) = 1
         enddo
         iScelta = 1         
         call ChePiano (iScelta)
         IfSc = 0         
         x1(1) = minval(xyz(1,1:NatMol))
         x1(2) = minval(xyz(2,1:NatMol))
         x1(3) = minval(xyz(3,1:NatMol))
         do j=1, NatMol
            xyz(1:3,j) = xyz(1:3,j) - x1(1:3)
         enddo
         x1(1) = minval(xyz(1,1:NatMol))
         x1(2) = minval(xyz(2,1:NatMol))
         x1(3) = minval(xyz(3,1:NatMol))
         x1(1) = maxval(xyz(1,1:NatMol))
         x1(2) = maxval(xyz(2,1:NatMol))
         x1(3) = maxval(xyz(3,1:NatMol))
         div = maxval(x1(1:3))
         do j=1, NatMol
            ResidCoords(i, 1:3, j) = xyz(1:3,j) / div
         enddo
      enddo
      
      call PassaCoordsAndConn()
      if (kDealloca == 1) then
          call AllocaAtomi(2)
      endif
!
      cell(1:6) = cellSav(1:6)
      call OrtoGroups(cellSav)
      iVP(:) = iVPSav(:)
      Lim1 = iVP(1)
      Lim2 = iVP(2)
      Lim3 = iVP(3)
      Lim4 = iVP(4)
      NPX = Lim3 - Lim1
      NPY = Lim4 - Lim2
      Ratio = float(NPX) / float(NPY)
      x11scale(1:2) = x11Sav(1:2)
      x11disp(1:2)  = x11Sav(3:4) 
!
      if (kDealloca == 1) return
!
          BTot(:,:) = BTotSav(:,:)
          ifSingle = 0
          kplot    = iPlotType
          call MolPlo(kplot, ifSingle)

*gl*  NatMol = NatMolSav
*gl*  NATind = NATindSav
*gl*  NatSpi = NatSpiSav
*gl*  NumLeg = NumLegSav
*gl*  xyz(1:3,1:NatMol+NatSpi) = xyztot(1:3,1:NatMol+NatSpi)
*gl*  iOrd(1:NatMol+NatSpi) = jdoppio(1:NatMol+NatSpi)
*gl*  call FindMinMax
*gl*  BTot(:,:) = 0 ; BTot(1,1) = 1 ; BTot(2,2) = 1 ; BTot(3,3) = 1
*gl*  call Disegna(1)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine OrtoGroups(cella)
      USE General ! , only: pi
      USE Molcom
!
      implicit none
      real   :: cella(6), alf, bet, gam
!
*     common /pippo/ asta(3),alf,bet,gam,sas,sbs,sgs,alfs,bets,gams,v
!
      call Orto(cella)
      return
!
      alf = cella(4)
      bet = cella(5)
      gam = cella(6)
!
      alf=pi/180*alf
      bet=pi/180*bet
      gam=pi/180*gam
! ---------
! ---------  sgs =  coseno di gamma star
! ---------
      sas=(cos(bet)*cos(gam)-cos(alf))/(sin(bet)*sin(gam))
      sbs=(cos(alf)*cos(gam)-cos(bet))/(sin(alf)*sin(gam))
      sgs=(cos(alf)*cos(bet)-cos(gam))/(sin(alf)*sin(bet))
! ---------
! ---------  gams =  gamma star
! ---------

      if ( sas .gt.  1.0 ) sas = 1.0
      if ( sas .lt. -1.0 ) sas =-1.0
      alfs=acos(sas)
      if ( sbs .gt.  1.0 ) sbs = 1.0
      if ( sbs .lt. -1.0 ) sbs =-1.0
      bets=acos(sbs)
      if ( sgs .gt.  1.0 ) sgs = 1.0
      if ( sgs .lt. -1.0 ) sgs =-1.0
      gams=acos(sgs)
      volume =cella(1)*cella(2)*cella(3)
      volume =volume *sqrt(sin(alf)**2+sin(bet)**2+sin(gam)**2-2+
     *    2*cos(alf)*cos(bet)*cos(gam))
      asta(1)=cella(2)*cella(3)*sin(alf)/volume
      asta(2)=cella(1)*cella(3)*sin(bet)/volume
      asta(3)=cella(1)*cella(2)*sin(gam)/volume
!
      rmi(1,1)=1./cella(1)
      rmi(1,2)=0
      rmi(1,3)=0
      rmi(2,1)=-cos(gam)/(cella(1)*sin(gam))
      rmi(2,2)=1./(cella(2)*sin(gam))
      rmi(2,3)=0
      rmi(3,1)=asta(1)*cos(bets)
      rmi(3,2)=asta(2)*cos(alfs)
      rmi(3,3)=asta(3)
!
      rm(1,1)=cella(1)
      rm(1,2)=0
      rm(1,3)=0
      rm(2,1)=cella(2)*cos(gam)
      rm(2,2)=cella(2)*sin(gam)
      rm(2,3)=0
      rm(3,1)=cella(3)*cos(bet)
      rm(3,2)=-cella(3)*sin(bet)*cos(alfs)
      rm(3,3)=1./asta(3)
!
      rm(1,1)=cella(1)*sin(bet)
      rm(1,2)=-cella(2)*sin(alf)*cos(gams)
      rm(1,3)=0
      rm(2,1)=0
      rm(2,2)=cella(2)*sin(alf)*sin(gams)
      rm(2,3)=0
      rm(3,1)=cella(1)*cos(bet)
      rm(3,2)=cella(2)*cos(alf)
      rm(3,3)=cella(3)
!
      call InvRm
!
      return
      end
! ----------------------------------------------------------------------
      subroutine Compatta()
      USE General
      USE Atomi
!
      kaction = 5
      istamp  = 0  !1
      ncycle  = 5
      call avvisolati(kaction, istamp, ncycle)
!
!-- connect unlinked atoms
!
      kact = 5
      kblock(1:nats) = 1
      jComplete = 2
      call build(kact, jComplete)
!
!-- Update coordinates in list 5
!
*gl*  call xupd05a(ier)
      do i=1, nats
         Labb = aLab(i)
         lnz = iabs(nz(i)/nzConst)
         VetChanges(1) = xyzs(1,i)
         VetChanges(2) = xyzs(2,i)
         VetChanges(3) = xyzs(3,i)
         VetChanges(4) = xyzs(4,i)
         VetChanges(5) = xyzs(5,i)
         VetChanges(6) = bfac(i)
         iAction = 0
*gl*     call xupd05(i, iAction, Labb, lnz, VetChanges)
         call ModModel(i, iAction, Labb, lnz, VetChanges)
      enddo
      iAction = 100
      j       =   0
      Labb    = ' '
      call ModModel(i, iAction, Labb, lnz, VetChanges)
*gl*  call xupd05(i, iAction, Labb, lnz, VetChanges)
*gl*  iAction = 200
*gl*  j       =   0
*gl*  Labb    = ' '
*gl*  call xupd05(j, iAction, Labb, lnz, VetChanges)
*gl*  call xupd05z(0)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LanciaJavRemo(ifMap, ifDifference)
      USE General
      USE Riflessi
      USE Atomi
      USE RemoModule
!
      implicit none
      integer    :: Lung, L, kk, knwSav, numb, nSetsMTZL, ier
      integer    :: ifMap, ifDifference, GiaFatta, iAction, nc
!
!-- Start JAV
!
      L = Lung(cardDiret)

      if (ifMap == 1) then
          if (ifDifference == 0) then
              card(1) = '-a -b -s=ro -c=sp' // char(0)
          else     
              card(1) = '-a -b -d -s=ro -c=sp' // char(0)
          endif
      else     
          card(1) = '-a -b -s=ct -c=ss' // char(0)
      endif     
      card(2) = cardDiret(1:L) // char(0)
      nc = 2
      if (ifMap == 1) then
          nc = 3
          if (ifDifference == 0) then
              kk = index(MTZfile, slash, .TRUE.)
              if (kk > 0) then
                  card(3) = MTZfile(kk+1:Lung(MTZfile)) // char(0)
              else
                  card(3) = MTZfile(1:Lung(MTZfile)) // char(0)
              endif
          else
              L = Lung(StructureName)
              cardDiret = StructureName(1:L) // '_tmp.xyz'
              GiaFatta = 0
              call WriteMapXYZ(GiaFatta, ifDifference)
              card(3) = cardDiret(1:Lung(cardDiret)) // char(0)
          endif
      endif
      write(lo,30) nome(1:lnome)
      do kk=1, nc
         write(lo,40) card(kk)(1:Lung(card(kk)))
      enddo
      write(lo,*)
      call startJav(card, nc)
**    Jav direttiva
!
      return
   30 format(/,' Jav started on ',a,' with the following parameters:')
   40 format('    ',a)
      end
!-----------------------------------------------------------------------
      subroutine LanciaJavAbi(ifMap, ifDifference)
      USE General
      USE Riflessi
      USE Atomi
      USE RemoModule
      USE PhaseModule, only : ifVLD
      USE Dialogo, only : ifMadEnv
!
      implicit none
      integer    :: Lung, L, kk, knwSav, numb, nSetsMTZL, ier, ifCartoon
      integer    :: ifMap, ifDifference, GiaFatta, iAction, nc
!
!-- Start JAV
!
      if (Model_PDB == 1 .and. ifAmb /= 4) then
          ifCartoon = 1
      else
          ifCartoon = 0
      endif
      L = Lung(FichierOut)

      if (ifDifference == 0) then
          if (ifMap == 0 .and. ifCartoon == 1 ) then
              write(card(1),12) char(34), Titolo(1:Lung(Titolo)),
     *                          char(34), char(34), bariVLD, char(34)
          else
              write(card(1),10) char(34), Titolo(1:Lung(Titolo)),
     *                          char(34), char(34), bariVLD, char(34)
          endif
      else     
          write(card(1),15) char(34), Titolo(1:Lung(Titolo)),
     *                      char(34), char(34), bariVLD, char(34)
      endif     
      call OneBlankOnly(card(1))
      card(1) = card(1)(1:Lung(card(1))) // char(0)
      card(2) = FichierOut(1:L) // char(0)
      nc = 2
      if (ifMadEnv /= 0) then
          if (ifMap == 1) then
              nc = 3
              if (ifDifference == 0) then
                  kk = index(MTZfile, slash, .TRUE.)
                  if (kk > 0) then
                      card(3) = MTZfile(kk+1:Lung(MTZfile)) // char(0)
                  else
                      card(3) = MTZfile(1:Lung(MTZfile)) // char(0)
                  endif
              else
                  if (nats > 0) then
                      iAction = 1
                      ier = 0
                      nz(1:nats) = nz(1:nats) * nzConst
                      call LastSFC(iAction, ier)
                      call AggiornaFC(fcvet, wt)
                  endif
                  kk = Lung(StructureName)
                  cardDiret = StructureName(1:kk) // '_tmp.xyz'
                  GiaFatta = 0
                  call WriteMapXYZ(GiaFatta, ifDifference)
                  card(3) = cardDiret(1:Lung(cardDiret)) // char(0)
              endif
          endif
      endif
      write(lo,30) nome(1:lnome)
      do kk=1, nc
         write(lo,40) card(kk)(1:Lung(card(kk)))
      enddo
      write(lo,*)
      call startJav(card, nc)
!
      return
   10 format('-a -w -s=ro -c=sp -t=',a,'Jav: ',a,a,
     *       ' -C=',a,f8.2,',',f8.2,',',f8.2,a)
   12 format('-a -w -s=ct -c=ss -t=',a,'Jav: ',a,a,
     *       ' -C=',a,f8.2,',',f8.2,',',f8.2,a)
   15 format('-d -w -s=ro -c=sp -t=',a,'Jav: ',a,a,
     *       ' -C=',a,f8.2,',',f8.2,',',f8.2,a)
   30 format(/,' Jav started on ',a,' with the following parameters:')
   40 format('    ',a)
      end
!-----------------------------------------------------------------------
      subroutine LanciaJavPreview()
      USE General
      USE RemoModule
      USE Molcom, only : jscreen
!
      implicit none
      integer    :: Lung, L, kk, knwSav, numb, nSetsMTZL, ier, ifCartoon
      integer    :: GiaFatta, iAction, nc
!
      if (jscreen <= 0) then
          return
      endif
!
!-- Start JAV
!
      if (allocated(model)) then
          if (model(WhichModel)%PDB == 1 .and. ifAMB /= 4) then
              ifCartoon = 1
          else
              ifCartoon = 0
          endif
      else
          ifCartoon = 1
      endif
      L = Lung(FichierOut)

      write(lo,30) FichierOut(1:L)

c     kk = min0( index(FichierOut,'_'), index(FichierOut,'.')) - 1
      kk = index(FichierOut,'.') - 1

      if (ifCartoon == 1) then
          write(card(1),12) char(34), FichierOut(1:kk)//'.pdb',
     *                      char(34), char(34), bariVLD, char(34)
      else
          if (natsInModel(WhichModel) <= 100) then
              write(card(1),10) char(34), FichierOut(1:kk)//'.pdb',
     *                          char(34), char(34), bariVLD, char(34)
          else
              write(card(1),11) char(34), FichierOut(1:kk)//'.pdb',
     *                          char(34), char(34), bariVLD, char(34)
          endif
      endif
      call OneBlankOnly(card(1))
      card(1) = card(1)(1:Lung(card(1))) // char(0)
      card(2) = FichierOut(1:L) // char(0)
      nc = 2
!
      call startJav(card, nc)
!
      return
   10 format('-a -w -p -S=400,400 -s=sb -c=sp -t=',a,'Jav preview: ',
     *       a,a,' -C=',a,f8.2,',',f8.2,',',f8.2,a)
   11 format('-a -w -p -S=400,400 -s=wi -c=sp -t=',a,'Jav preview: ',
     *       a,a,' -C=',a,f8.2,',',f8.2,',',f8.2,a)
   12 format('-a -w -p -S=400,400 -s=ct -c=ss -t=',a,'Jav preview: ',
     *       a,a,' -C=',a,f8.2,',',f8.2,',',f8.2,a)
   30 format(/,' Jav preview of the file ',a,/)
      end
!-----------------------------------------------------------------------
      subroutine LanciaJavPreviewNew()
      USE General
      USE PhaseModule, only : ifVLD
      USE RemoModule
      USE Molcom, only : jscreen, kscry
      USE Grafici
      USE Atomi
      USE javinterface
      USE realloc
      USE ilmviewmod
      USE molpnew
      USE connect_mod
      USE atom_type_util
      USE unit_cell
!
      implicit none
      integer    :: Lung, L, Lpng, kk, ifCartoon, nAtoms, nb, i
      logical    :: Esiste
      type(atom_type), dimension(:), allocatable :: atom
      type(bond_type), dimension(:), allocatable :: legame
!
      if (jscreen <= 0) then
          return
      endif
!
      nAtoms = natsInModel(WhichModel)
      nb     = BondsInModel(WhichModel)
      if (nAtoms == 0) then
          return
      endif
      if (model(WhichModel)%PDB == 1 .and. ifAMB /= 4) then
          if (ifAmbEnan /= 4) then
              ifCartoon = 1
          else
              ifCartoon = 0
          endif
      else
          ifCartoon = 0
      endif
      NomePng = nome(1:lnome) // '_preview.png'
      Lpng =Lung(NomePng)
      NomePng(Lpng+1:Lpng+1) = char(0)
      call cRemoveFile(NomePng)
!
!-- Start JAV if:
!       ifCartoon = 1
!     or
!       ifCartoon = 0  and nAtoms < 1000
!
      if (ifCartoon == 1 .or. (ifCartoon == 0 .and. nAtoms < 1000)) then
          L = Lung(FichierOut)

c         kk = min0( index(FichierOut,'_'), index(FichierOut,'.')) - 1
          kk = index(FichierOut,'.') - 1

          if (ifCartoon == 1) then
              call setta_style(12)
              call jav_setta_colmode(8)
          else
              call jav_setta_colmode(1)
              if (nAtoms <= 100) then
                  call setta_style(5)
              else
                  call setta_style(1)
              endif
          endif
!
          if (ifRemo == 0) then
              if (ifVLD == 1) then
                  PlotGR_w = kscry /3
              else
                  PlotGR_w = kscry /2
              endif
          else
              PlotGR_w = 0.8 * float(kscry)
          endif
          PlotGR_h = PlotGR_w
          call map_set_centre(bariVLD) 
          call set_title('Jav preview: ' // FichierOut(1:kk) // char(0))
          call jav_setta_size(PlotGR_w, PlotGR_h)
!
          call jav_setta_preview(1, NomePng)
          call reallocate(atom, nAtoms, .false.)
          call fromModelToAtom(atom)
!
          if (nk == 0) then
              nk = Model(WhichModel)%nk
              nw(1:18) = Model(WhichModel)%nw(1:18)
              no(1:18) = Model(WhichModel)%no(1:18)
          endif
!
          if (nb /= 0) then
              call reallocate_legm(legame, nb, .FALSE.)
              do i=1, nb
                 legame(i)%n1 =   Bonds(WhichModel)%Legami(1,i)
                 legame(i)%n2 =   Bonds(WhichModel)%Legami(2,i)
                 legame(i)%dist = Bonds(WhichModel)%Legami(4,i)
              enddo
          else
              call create_connectivity(atom,legm=legame,
     *             cellt=set_cell_type(cell))
              nb = numbonds(legame)
          endif
! 
          call ilmview_open()
          call ilmview_load_bond_table()
          call ilmview_draw(atom,legame,kmodel=WhichModel)
      endif
!
      inquire (file=NomePng(1:Lpng),  exist = Esiste)
      if (Esiste) then
          ifPlotGR = .true.
      endif
!
      if (ifPlotGR) then
          call PixmapOnWhiteBoard
      endif
!
      call zflush()
      call DoSingleIteration()
!
      Inte = nome(1:lnome) // '_fPlot.png' // char(0)
      call CreaPng(Inte)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PixmapOnWhiteBoard
      USE General
      USE Grafici
      USE Molcom
!
      implicit none
      integer :: L, LenInPix, iColor
!
      if (ifRemo == 0) then
          Inte = 'Best model preview'
          L = LenInPix(Inte,3)
          PlotGR_x = kscrx/4 * 3
          PlotGR_y = kscry/4 * 3
          PlotGR_x = kscrx/2  + (kscrx / 2 - PlotGR_w) / 2
          PlotGR_y = kscry/2  + (kscry / 2 - PlotGR_h) / 2-FntPixHeight
      else
          Inte = RemoLegend
          L = LenInPix(Inte,3)
          PlotGR_x = (kscrx - PlotGR_w) / 2
          PlotGR_y = (kscry - PlotGR_h) / 2 - FntPixHeight
      endif
      iColor = color_LIGHTBLUE
      call MettiPixmap(NomePng, PlotGR_x, PlotGR_y)
      if (ifRemo == 0) then
          ixv(1) = kscrx / 2 + (kscrx / 2 - L) / 2
          iyv(1) = PlotGR_y - FntPixHeight             ! - 2 * FntPixHeight
      else
          ixv(1) = (kscrx - L) / 2
          iyv(1) = PlotGR_y - FntPixHeight             ! - 2 * FntPixHeight
      endif
      call DrawLabel(ixv(1), iyv(1), Inte, iColor, 3)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine OpenJavViewer()
!
      USE General
      USE cgeom
      USE RemoModule
      USE Molcom, only : jscreen, kscry
      USE Atomi
      USE javinterface
      USE proginterface          !!mr 02082015
      USE realloc
      USE ilmviewmod
      USE molpnew
      USE connect_mod
      USE atom_type_util
      USE unit_cell
!
      implicit none
      integer    :: Lung, L, Lpng, kk, ifCartoon, nAtoms, nb, i
      logical    :: Esiste
      type(atom_type), dimension(:), allocatable :: atom
      type(bond_type), dimension(:), allocatable :: legame
!
      if (jscreen <= 0) then
          return
      endif
!
      if (ifWasRemo == 1) then
          if (.not.allocated(natsInModel)) then
              MonomerInModel(:) = 1
              call LoadPDBfromAmb(0)
          endif
      endif
      nAtoms = natsInModel(WhichModel) ! * MonomerInModel(WhichModel)
      nb     = BondsInModel(WhichModel)
      if (nAtoms == 0) then
          return
      endif
      call reallocate(atom, nAtoms, .false.)
      call fromModelToAtom(atom)
!
      if (nk == 0) then
          nk = Model(WhichModel)%nk
          nw(1:18) = Model(WhichModel)%nw(1:18)
          no(1:18) = Model(WhichModel)%no(1:18)
      endif
      call nk_to_elem(celem)             !!mr 02082015
!
      if (nb /= 0) then
          call reallocate_legm(legame, nb, .FALSE.)
          do i=1, nb
             legame(i)%n1 =   Bonds(WhichModel)%Legami(1,i)
             legame(i)%n2 =   Bonds(WhichModel)%Legami(2,i)
!!mr         legame(i)%dist = Bonds(WhichModel)%Legami(4,i)
             legame(i)%dist = distanzaC(atom(legame(i)%n1)%xc,
     *        atom(legame(i)%n2)%xc, xgg)
             legame(i)%sigma = 0.3
             legame(i)%ord = 0
          enddo
      else
          call create_connectivity(atom,legm=legame,
     *         cellt=set_cell_type(cell))
          nb = numbonds(legame)
      endif
! 
      call ilmview_open(StructureName)
      call ilmview_load_bond_table()
      call ilmview_draw(atom,legame,kmodel=WhichModel)
!
      return
      end
!-----------------------------------------------------------------------
